/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ve=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/uri","vs/base/common/path","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/nls","vs/nls!vs/server/node/server.main","vs/base/common/network","vs/base/common/errors","vs/base/common/types","vs/platform/log/common/log","vs/base/common/async","vs/base/common/strings","vs/base/common/buffer","vs/platform/files/common/files","vs/base/common/arrays","vs/base/common/resources","vs/base/common/cancellation","vs/base/node/pfs","vs/base/common/objects","vs/platform/configuration/common/configuration","vs/platform/environment/common/environment","vs/platform/product/common/productService","vs/base/common/uuid","os","vs/base/common/process","vs/base/common/map","fs","vs/platform/extensionManagement/common/extensionManagement","vs/platform/telemetry/common/telemetry","vs/base/common/extpath","vs/platform/registry/common/platform","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/errorMessage","vs/platform/extensions/common/extensions","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/codicons","vs/base/common/marshalling","child_process","vs/base/parts/ipc/common/ipc","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/server/node/serverEnvironmentService","vs/base/common/iterator","vs/base/common/stream","vs/base/common/performance","vs/editor/common/core/range","vs/base/common/semver/semver","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/processes","vs/platform/environment/node/argv","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policy","vs/workbench/api/node/uriTransformer","vs/base/parts/ipc/node/ipc.net","vs/base/common/functional","vs/base/common/json","net","vs/base/common/mime","vs/base/common/severity","vs/base/common/glob","vs/base/common/uriIpc","vs/platform/extensions/common/extensionValidator","vs/platform/credentials/common/credentials","vs/platform/download/common/download","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/remote/common/remoteHosts","crypto","url","vs/platform/shell/node/shellEnv","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/base/common/decorators","path","vs/editor/common/core/position","vs/base/common/observableValue","vs/base/common/hash","vs/base/common/normalization","vs/base/common/htmlContent","vs/base/node/id","vs/base/node/powershell","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/common/environmentService","vs/platform/contextkey/common/contextkey","vs/platform/files/common/io","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/fileService","vs/platform/log/common/logIpc","vs/platform/log/node/spdlogLog","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/languagePacks/node/languagePacks","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/workspace/common/workspace","vs/server/node/extensionHostStatusService","vs/server/node/remoteLanguagePacks","vs/server/node/extensionsScannerService","vs/workbench/api/common/extHostTypes","vs/workbench/common/editor","vs/workbench/contrib/terminal/common/environmentVariable","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostTypeConverters","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/remote/common/remoteAgentService","vs/base/node/zip","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/server/node/extensionHostConnection","vs/base/common/amd","vs/base/common/assert","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/marked/marked","vs/base/common/skipList","vs/base/node/decoder","vs/base/node/languagePacks","vs/base/node/macAddress","vs/base/node/ports","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/console","vs/base/common/labels","vs/base/node/extpath","vs/base/parts/storage/common/storage","vs/editor/common/tokenizationRegistry","vs/editor/common/languages","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/server/node/serverEnvironmentService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsUtil","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/download/common/downloadIpc","vs/platform/editor/common/editor","vs/platform/encryption/node/encryptionMainService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/diagnostics/common/diagnostics","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/label/common/label","vs/platform/credentials/common/credentialsMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/markers/common/markers","vs/platform/credentials/node/credentialsMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/errorTelemetry","vs/platform/telemetry/common/remoteTelemetryChannel","vs/platform/diagnostics/node/diagnosticsService","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/common/serverTelemetryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/errorTelemetry","vs/platform/terminal/common/requestStore","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/storage/common/storage","vs/server/node/remoteExtensionManagement","vs/server/node/serverConnectionToken","cookie","vs/server/node/webClientServer","vs/workbench/api/common/extHostRpcService","vs/server/node/remoteFileSystemProviderServer","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/terminal/common/environmentVariableCollection","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/services/configuration/common/configuration","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostTestItem","vs/workbench/contrib/terminal/common/remoteTerminalChannel","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/services/extensions/common/extensionsUtil","vs/server/node/remoteAgentEnvironmentImpl","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostCommands","vs/workbench/services/remote/common/remoteFileSystemProviderClient","vs/platform/extensionManagement/node/extensionManagementUtil","zlib","vs/server/node/remoteExtensionHostAgentCli","vs/workbench/api/node/extHostCLIServer","vs/server/node/remoteTerminalChannel","vs/server/node/serverServices","vs/server/node/remoteExtensionHostAgentServer","perf_hooks","string_decoder","util","minimist","assert","graceful-fs","yauzl","yazl","http","vs/server/node/server.main"],we=function(oe){for(var e=[],I=0,t=oe.length;I<t;I++)e[I]=ve[oe[I]];return e};define(ve[129],we([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=void 0;class I{static get(){const v=new Map,P=new Map,k=new Map,w=new Map;function p(b,d){b.has(d.detail)||b.set(d.detail,-d.timestamp)}function D(b,d){const C=b.get(d.detail);!C||C>=0||b.set(d.detail,C+d.timestamp)}const T=oe.getStats().slice(0).sort((b,d)=>b.timestamp-d.timestamp);for(const b of T)switch(b.type){case 10:p(v,b);break;case 11:case 12:D(v,b);break;case 21:p(P,b);break;case 22:D(P,b);break;case 33:p(k,b);break;case 34:D(k,b);break;case 31:p(w,b);break;case 32:D(w,b);break}let R=0;k.forEach(b=>R+=b);function E(b){const d=[];return b.forEach((C,y)=>d.push([y,C])),d}return{amdLoad:E(v),amdInvoke:E(P),nodeRequire:E(k),nodeEval:E(w),nodeRequireTotal:R}}static toMarkdownTable(v,P){let k="";const w=[];return v.forEach((p,D)=>{w[D]=p.length}),P.forEach(p=>{p.forEach((D,T)=>{typeof D=="undefined"&&(D=p[T]="-");const R=D.toString().length;w[T]=Math.max(R,w[T])})}),v.forEach((p,D)=>{k+=`| ${p+" ".repeat(w[D]-p.toString().length)} `}),k+=`|
`,v.forEach((p,D)=>{k+=`| ${"-".repeat(w[D])} `}),k+=`|
`,P.forEach(p=>{p.forEach((D,T)=>{typeof D!="undefined"&&(k+=`| ${D+" ".repeat(w[T]-D.toString().length)} `)}),k+=`|
`}),k}}e.LoaderStats=I}),define(ve[130],we([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function I(t,v){if(!t)throw new Error(v?`Assertion failed (${v})`:"Assertion Failed")}e.ok=I}),define(ve[40],we([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function I(k){return k?k.replace(/\$\((.*?)\)/g,(w,p)=>` ${p} `).trim():""}e.getCodiconAriaLabel=I;class t{constructor(w,p,D){this.id=w,this.definition=p,this.description=D,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\f101"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function v(k,w){const p=["codicon","codicon-"+k];return w&&p.push("codicon-modifier-"+w),p}e.getClassNamesArray=v;var P;(function(k){k.iconNameSegment="[A-Za-z0-9]+",k.iconNameExpression="[A-Za-z0-9-]+",k.iconModifierExpression="~[A-Za-z]+",k.iconNameCharacter="[A-Za-z0-9~-]";const w=new RegExp(`^(${k.iconNameExpression})(${k.iconModifierExpression})?$`);function p(R){if(R instanceof t)return["codicon","codicon-"+R.id];const E=w.exec(R.id);if(!E)return p(t.error);const[,b,d]=E,C=["codicon","codicon-"+b];return d&&C.push("codicon-modifier-"+d.substr(1)),C}k.asClassNameArray=p;function D(R){return p(R).join(" ")}k.asClassName=D;function T(R){return"."+p(R).join(".")}k.asCSSSelector=T})(P=e.CSSIcon||(e.CSSIcon={}))}),define(ve[82],we([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function I(k){return(w,p,D)=>{let T=null,R=null;if(typeof D.value=="function"?(T="value",R=D.value):typeof D.get=="function"&&(T="get",R=D.get),!R)throw new Error("not supported");D[T]=k(R,p)}}e.createDecorator=I;function t(k,w,p){let D=null,T=null;if(typeof p.value=="function"?(D="value",T=p.value,T.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof p.get=="function"&&(D="get",T=p.get),!T)throw new Error("not supported");const R=`$memoize$${w}`;p[D]=function(...E){return this.hasOwnProperty(R)||Object.defineProperty(this,R,{configurable:!1,enumerable:!1,writable:!1,value:T.apply(this,E)}),this[R]}}e.memoize=t;function v(k,w,p){return I((D,T)=>{const R=`$debounce$${T}`,E=`$debounce$result$${T}`;return function(...b){this[E]||(this[E]=p?p():void 0),clearTimeout(this[R]),w&&(this[E]=w(this[E],...b),b=[this[E]]),this[R]=setTimeout(()=>{D.apply(this,b),this[E]=p?p():void 0},k)}})}e.debounce=v;function P(k,w,p){return I((D,T)=>{const R=`$throttle$timer$${T}`,E=`$throttle$result$${T}`,b=`$throttle$lastRun$${T}`,d=`$throttle$pending$${T}`;return function(...C){if(this[E]||(this[E]=p?p():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),w&&(this[E]=w(this[E],...C)),this[d])return;const y=this[b]+k;y<=Date.now()?(this[b]=Date.now(),D.apply(this,[this[E]]),this[E]=p?p():void 0):(this[d]=!0,this[R]=setTimeout(()=>{this[d]=!1,this[b]=Date.now(),D.apply(this,[this[E]]),this[E]=p?p():void 0},y-Date.now()))}})}e.throttle=P}),define(ve[11],we([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class I{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(i){setTimeout(()=>{throw i.stack?h.isErrorNoTelemetry(i)?new h(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.listeners.push(i),()=>{this._removeListener(i)}}emit(i){this.listeners.forEach(a=>{a(i)})}_removeListener(i){this.listeners.splice(this.listeners.indexOf(i),1)}setUnexpectedErrorHandler(i){this.unexpectedErrorHandler=i}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(i){this.unexpectedErrorHandler(i),this.emit(i)}onUnexpectedExternalError(i){this.unexpectedErrorHandler(i)}}e.ErrorHandler=I,e.errorHandler=new I;function t(f){e.errorHandler.setUnexpectedErrorHandler(f)}e.setUnexpectedErrorHandler=t;function v(f){p(f)||e.errorHandler.onUnexpectedError(f)}e.onUnexpectedError=v;function P(f){p(f)||e.errorHandler.onUnexpectedExternalError(f)}e.onUnexpectedExternalError=P;function k(f){if(f instanceof Error){const{name:i,message:a}=f,n=f.stacktrace||f.stack;return{$isError:!0,name:i,message:a,stack:n,noTelemetry:h.isErrorNoTelemetry(f)}}return f}e.transformErrorForSerialization=k;const w="Canceled";function p(f){return f instanceof D?!0:f instanceof Error&&f.name===w&&f.message===w}e.isCancellationError=p;class D extends Error{constructor(){super(w);this.name=this.message}}e.CancellationError=D;function T(){const f=new Error(w);return f.name=f.message,f}e.canceled=T;function R(f){return f?new Error(`Illegal argument: ${f}`):new Error("Illegal argument")}e.illegalArgument=R;function E(f){return f?new Error(`Illegal state: ${f}`):new Error("Illegal state")}e.illegalState=E;function b(f){return f?new Error(`readonly property '${f} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=b;function d(f){const i=new Error(`${f} has been disposed`);return i.name="DISPOSED",i}e.disposed=d;function C(f){return f?f.message?f.message:f.stack?f.stack.split(`
`)[0]:String(f):"Error"}e.getErrorMessage=C;class y extends Error{constructor(i){super("NotImplemented");i&&(this.message=i)}}e.NotImplementedError=y;class m extends Error{constructor(i){super("NotSupported");i&&(this.message=i)}}e.NotSupportedError=m;class g extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=g;class h extends Error{constructor(i){super(i);this.name="ErrorNoTelemetry"}static fromError(i){if(i instanceof h)return i;const a=new h;return a.message=i.message,a.stack=i.stack,a}static isErrorNoTelemetry(i){return i.name==="ErrorNoTelemetry"}}e.ErrorNoTelemetry=h;class l extends Error{constructor(i){super(i||"An unexpected bug occurred.");Object.setPrototypeOf(this,l.prototype);debugger}}e.BugIndicatingError=l}),define(ve[18],we([0,1,11]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function t(K,he=0){return K[K.length-(1+he)]}e.tail=t;function v(K){if(K.length===0)throw new Error("Invalid tail call");return[K.slice(0,K.length-1),K[K.length-1]]}e.tail2=v;function P(K,he,te=(le,de)=>le===de){if(K===he)return!0;if(!K||!he||K.length!==he.length)return!1;for(let le=0,de=K.length;le<de;le++)if(!te(K[le],he[le]))return!1;return!0}e.equals=P;function k(K,he,te){return w(K.length,le=>te(K[le],he))}e.binarySearch=k;function w(K,he){let te=0,le=K-1;for(;te<=le;){const de=(te+le)/2|0,Y=he(de);if(Y<0)te=de+1;else if(Y>0)le=de-1;else return de}return-(te+1)}e.binarySearch2=w;function p(K,he){let te=0,le=K.length;if(le===0)return 0;for(;te<le;){const de=Math.floor((te+le)/2);he(K[de])?le=de:te=de+1}return te}e.findFirstInSorted=p;function D(K,he,te){if(K=K|0,K>=he.length)throw new TypeError("invalid index");const le=he[Math.floor(he.length*Math.random())],de=[],Y=[],J=[];for(const H of he){const G=te(H,le);G<0?de.push(H):G>0?Y.push(H):J.push(H)}return K<de.length?D(K,de,te):K<de.length+J.length?J[0]:D(K-(de.length+J.length),Y,te)}e.quickSelect=D;function T(K,he){const te=[];let le;for(const de of K.slice(0).sort(he))!le||he(le[0],de)!==0?(le=[de],te.push(le)):le.push(de);return te}e.groupBy=T;function R(K,he,te){const le=[];function de(H,G,fe){if(G===0&&fe.length===0)return;const pe=le[le.length-1];pe&&pe.start+pe.deleteCount===H?(pe.deleteCount+=G,pe.toInsert.push(...fe)):le.push({start:H,deleteCount:G,toInsert:fe})}let Y=0,J=0;for(;;){if(Y===K.length){de(Y,0,he.slice(J));break}if(J===he.length){de(Y,K.length-Y,[]);break}const H=K[Y],G=he[J],fe=te(H,G);fe===0?(Y+=1,J+=1):fe<0?(de(Y,1,[]),Y+=1):fe>0&&(de(Y,0,[G]),J+=1)}return le}e.sortedDiff=R;function E(K,he,te){const le=R(K,he,te),de=[],Y=[];for(const J of le)de.push(...K.slice(J.start,J.start+J.deleteCount)),Y.push(...J.toInsert);return{removed:de,added:Y}}e.delta=E;function b(K,he,te){if(te===0)return[];const le=K.slice(0,te).sort(he);return C(K,he,le,te,K.length),le}e.top=b;function d(K,he,te,le,de){return te===0?Promise.resolve([]):new Promise((Y,J)=>{(async()=>{const H=K.length,G=K.slice(0,te).sort(he);for(let fe=te,pe=Math.min(te+le,H);fe<H;fe=pe,pe=Math.min(pe+le,H)){if(fe>te&&await new Promise(ke=>setTimeout(ke)),de&&de.isCancellationRequested)throw new I.CancellationError;C(K,he,G,fe,pe)}return G})().then(Y,J)})}e.topAsync=d;function C(K,he,te,le,de){for(const Y=te.length;le<de;le++){const J=K[le];if(he(J,te[Y-1])<0){te.pop();const H=p(te,G=>he(J,G)<0);te.splice(H,0,J)}}}function y(K){return K.filter(he=>!!he)}e.coalesce=y;function m(K){let he=0;for(let te=0;te<K.length;te++)K[te]&&(K[he]=K[te],he+=1);K.length=he}e.coalesceInPlace=m;function g(K,he,te){K.splice(te,0,K.splice(he,1)[0])}e.move=g;function h(K){return!Array.isArray(K)||K.length===0}e.isFalsyOrEmpty=h;function l(K){return Array.isArray(K)&&K.length>0}e.isNonEmptyArray=l;function f(K,he=te=>te){const te=new Set;return K.filter(le=>{const de=he(le);return te.has(de)?!1:(te.add(de),!0)})}e.distinct=f;function i(K){const he=new Set;return te=>{const le=K(te);return he.has(le)?!1:(he.add(le),!0)}}e.uniqueFilter=i;function a(K,he){const te=n(K,he);if(te!==-1)return K[te]}e.findLast=a;function n(K,he){for(let te=K.length-1;te>=0;te--){const le=K[te];if(he(le))return te}return-1}e.lastIndex=n;function o(K,he){return K.length>0?K[0]:he}e.firstOrDefault=o;function r(K,he){return K.length>0?K[K.length-1]:he}e.lastOrDefault=r;function s(K,he,te=(le,de)=>le===de){let le=0;for(let de=0,Y=Math.min(K.length,he.length);de<Y&&te(K[de],he[de]);de++)le++;return le}e.commonPrefixLength=s;function c(K){return[].concat(...K)}e.flatten=c;function u(K,he){let te=typeof he=="number"?K:0;typeof he=="number"?te=K:(te=0,he=K);const le=[];if(te<=he)for(let de=te;de<he;de++)le.push(de);else for(let de=te;de>he;de--)le.push(de);return le}e.range=u;function S(K,he,te){return K.reduce((le,de)=>(le[he(de)]=te?te(de):de,le),Object.create(null))}e.index=S;function A(K,he){return K.push(he),()=>M(K,he)}e.insert=A;function M(K,he){const te=K.indexOf(he);if(te>-1)return K.splice(te,1),he}e.remove=M;function $(K,he,te){const le=K.slice(0,he),de=K.slice(he);return le.concat(te,de)}e.arrayInsert=$;function Q(K,he){let te;if(typeof he=="number"){let le=he;te=()=>{const de=Math.sin(le++)*179426549;return de-Math.floor(de)}}else te=Math.random;for(let le=K.length-1;le>0;le-=1){const de=Math.floor(te()*(le+1)),Y=K[le];K[le]=K[de],K[de]=Y}}e.shuffle=Q;function _(K,he){const te=K.indexOf(he);te>-1&&(K.splice(te,1),K.unshift(he))}e.pushToStart=_;function q(K,he){const te=K.indexOf(he);te>-1&&(K.splice(te,1),K.push(he))}e.pushToEnd=q;function U(K,he){for(const te of he)K.push(te)}e.pushMany=U;function ne(K,he){return Array.isArray(K)?K.map(he):he(K)}e.mapArrayOrNot=ne;function Z(K){return Array.isArray(K)?K:[K]}e.asArray=Z;function F(K){return K[Math.floor(Math.random()*K.length)]}e.getRandomElement=F;function x(K,he){for(const te of K){const le=he(te);if(le!==void 0)return le}}e.mapFind=x;function z(K,he,te){const le=re(K,he),de=K.length,Y=te.length;K.length=de+Y;for(let J=de-1;J>=le;J--)K[J+Y]=K[J];for(let J=0;J<Y;J++)K[J+le]=te[J]}e.insertInto=z;function W(K,he,te,le){const de=re(K,he),Y=K.splice(de,te);return z(K,de,le),Y}e.splice=W;function re(K,he){return he<0?Math.max(he+K.length,0):Math.min(he,K.length)}var V;(function(K){function he(de){return de<0}K.isLessThan=he;function te(de){return de>0}K.isGreaterThan=te;function le(de){return de===0}K.isNeitherLessOrGreaterThan=le,K.greaterThan=1,K.lessThan=-1,K.neitherLessOrGreaterThan=0})(V=e.CompareResult||(e.CompareResult={}));function X(K,he){return(te,le)=>he(K(te),K(le))}e.compareBy=X;function ae(...K){return(he,te)=>{for(const le of K){const de=le(he,te);if(!V.isNeitherLessOrGreaterThan(de))return de}return V.neitherLessOrGreaterThan}}e.tieBreakComparators=ae;const ie=(K,he)=>K-he;e.numberComparator=ie;function O(K,he){if(K.length===0)return;let te=K[0];for(let le=1;le<K.length;le++){const de=K[le];he(de,te)>0&&(te=de)}return te}e.findMaxBy=O;function B(K,he){if(K.length===0)return;let te=K[0];for(let le=1;le<K.length;le++){const de=K[le];he(de,te)>=0&&(te=de)}return te}e.findLastMaxBy=B;function ee(K,he){return O(K,(te,le)=>-he(te,le))}e.findMinBy=ee;class ce{constructor(he){this.items=he,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(he){let te=this.firstIdx;for(;te<this.items.length&&he(this.items[te]);)te++;const le=te===this.firstIdx?null:this.items.slice(this.firstIdx,te);return this.firstIdx=te,le}takeFromEndWhile(he){let te=this.lastIdx;for(;te>=0&&he(this.items[te]);)te--;const le=te===this.lastIdx?null:this.items.slice(te+1,this.lastIdx+1);return this.lastIdx=te,le}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const he=this.items[this.firstIdx];return this.firstIdx++,he}removeLast(){const he=this.items[this.lastIdx];return this.lastIdx--,he}takeCount(he){const te=this.items.slice(this.firstIdx,this.firstIdx+he);return this.firstIdx+=he,te}}e.ArrayQueue=ce}),define(ve[64],we([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function I(t){const v=this;let P=!1,k;return function(){return P||(P=!0,k=t.apply(v,arguments)),k}}e.once=I}),define(ve[47],we([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var I;(function(t){function v(a){return a&&typeof a=="object"&&typeof a[Symbol.iterator]=="function"}t.is=v;const P=Object.freeze([]);function k(){return P}t.empty=k;function*w(a){yield a}t.single=w;function p(a){return a||P}t.from=p;function D(a){return!a||a[Symbol.iterator]().next().done===!0}t.isEmpty=D;function T(a){return a[Symbol.iterator]().next().value}t.first=T;function R(a,n){for(const o of a)if(n(o))return!0;return!1}t.some=R;function E(a,n){for(const o of a)if(n(o))return o}t.find=E;function*b(a,n){for(const o of a)n(o)&&(yield o)}t.filter=b;function*d(a,n){let o=0;for(const r of a)yield n(r,o++)}t.map=d;function*C(...a){for(const n of a)for(const o of n)yield o}t.concat=C;function*y(a){for(const n of a)for(const o of n)yield o}t.concatNested=y;function m(a,n,o){let r=o;for(const s of a)r=n(r,s);return r}t.reduce=m;function g(a,n){let o=0;for(const r of a)n(r,o++)}t.forEach=g;function*h(a,n,o=a.length){for(n<0&&(n+=a.length),o<0?o+=a.length:o>a.length&&(o=a.length);n<o;n++)yield a[n]}t.slice=h;function l(a,n=Number.POSITIVE_INFINITY){const o=[];if(n===0)return[o,a];const r=a[Symbol.iterator]();for(let s=0;s<n;s++){const c=r.next();if(c.done)return[o,t.empty()];o.push(c.value)}return[o,{[Symbol.iterator](){return r}}]}t.consume=l;function f(a){return l(a)[0]}t.collect=f;function i(a,n,o=(r,s)=>r===s){const r=a[Symbol.iterator](),s=n[Symbol.iterator]();for(;;){const c=r.next(),u=s.next();if(c.done!==u.done)return!1;if(c.done)return!0;if(!o(c.value,u.value))return!1}}t.equals=i})(I=e.Iterable||(e.Iterable={}))}),define(ve[65],we([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var I;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(I=e.ScanError||(e.ScanError={}));var t;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var v;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(v=e.ParseErrorCode||(e.ParseErrorCode={}));var P;(function(i){i.DEFAULT={allowTrailingComma:!0}})(P=e.ParseOptions||(e.ParseOptions={}));function k(i,a=!1){let n=0;const o=i.length;let r="",s=0,c=16,u=0;function S(U){let ne=0,Z=0;for(;ne<U;){const F=i.charCodeAt(n);if(F>=48&&F<=57)Z=Z*16+F-48;else if(F>=65&&F<=70)Z=Z*16+F-65+10;else if(F>=97&&F<=102)Z=Z*16+F-97+10;else break;n++,ne++}return ne<U&&(Z=-1),Z}function A(U){n=U,r="",s=0,c=16,u=0}function M(){const U=n;if(i.charCodeAt(n)===48)n++;else for(n++;n<i.length&&D(i.charCodeAt(n));)n++;if(n<i.length&&i.charCodeAt(n)===46)if(n++,n<i.length&&D(i.charCodeAt(n)))for(n++;n<i.length&&D(i.charCodeAt(n));)n++;else return u=3,i.substring(U,n);let ne=n;if(n<i.length&&(i.charCodeAt(n)===69||i.charCodeAt(n)===101))if(n++,(n<i.length&&i.charCodeAt(n)===43||i.charCodeAt(n)===45)&&n++,n<i.length&&D(i.charCodeAt(n))){for(n++;n<i.length&&D(i.charCodeAt(n));)n++;ne=n}else u=3;return i.substring(U,ne)}function $(){let U="",ne=n;for(;;){if(n>=o){U+=i.substring(ne,n),u=2;break}const Z=i.charCodeAt(n);if(Z===34){U+=i.substring(ne,n),n++;break}if(Z===92){if(U+=i.substring(ne,n),n++,n>=o){u=2;break}switch(i.charCodeAt(n++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:{const x=S(4);x>=0?U+=String.fromCharCode(x):u=4;break}default:u=5}ne=n;continue}if(Z>=0&&Z<=31)if(p(Z)){U+=i.substring(ne,n),u=2;break}else u=6;n++}return U}function Q(){if(r="",u=0,s=n,n>=o)return s=o,c=17;let U=i.charCodeAt(n);if(w(U)){do n++,r+=String.fromCharCode(U),U=i.charCodeAt(n);while(w(U));return c=15}if(p(U))return n++,r+=String.fromCharCode(U),U===13&&i.charCodeAt(n)===10&&(n++,r+=`
`),c=14;switch(U){case 123:return n++,c=1;case 125:return n++,c=2;case 91:return n++,c=3;case 93:return n++,c=4;case 58:return n++,c=6;case 44:return n++,c=5;case 34:return n++,r=$(),c=10;case 47:{const ne=n-1;if(i.charCodeAt(n+1)===47){for(n+=2;n<o&&!p(i.charCodeAt(n));)n++;return r=i.substring(ne,n),c=12}if(i.charCodeAt(n+1)===42){n+=2;const Z=o-1;let F=!1;for(;n<Z;){if(i.charCodeAt(n)===42&&i.charCodeAt(n+1)===47){n+=2,F=!0;break}n++}return F||(n++,u=1),r=i.substring(ne,n),c=13}return r+=String.fromCharCode(U),n++,c=16}case 45:if(r+=String.fromCharCode(U),n++,n===o||!D(i.charCodeAt(n)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=M(),c=11;default:for(;n<o&&_(U);)n++,U=i.charCodeAt(n);if(s!==n){switch(r=i.substring(s,n),r){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return r+=String.fromCharCode(U),n++,c=16}}function _(U){if(w(U)||p(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function q(){let U;do U=Q();while(U>=12&&U<=15);return U}return{setPosition:A,getPosition:()=>n,scan:a?q:Q,getToken:()=>c,getTokenValue:()=>r,getTokenOffset:()=>s,getTokenLength:()=>n-s,getTokenError:()=>u}}e.createScanner=k;function w(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function p(i){return i===10||i===13||i===8232||i===8233}function D(i){return i>=48&&i<=57}var T;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(T||(T={}));function R(i,a){const n=[],o=new Object;let r;const s={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function u(S,A,M,$){s.value=S,s.offset=A,s.length=M,s.type=$,s.colonOffset=void 0,r=s}try{h(i,{onObjectBegin:(S,A)=>{if(a<=S)throw o;r=void 0,c=a>S,n.push("")},onObjectProperty:(S,A,M)=>{if(a<A||(u(S,A,M,"property"),n[n.length-1]=S,a<=A+M))throw o},onObjectEnd:(S,A)=>{if(a<=S)throw o;r=void 0,n.pop()},onArrayBegin:(S,A)=>{if(a<=S)throw o;r=void 0,n.push(0)},onArrayEnd:(S,A)=>{if(a<=S)throw o;r=void 0,n.pop()},onLiteralValue:(S,A,M)=>{if(a<A||(u(S,A,M,f(S)),a<=A+M))throw o},onSeparator:(S,A,M)=>{if(a<=A)throw o;if(S===":"&&r&&r.type==="property")r.colonOffset=A,c=!1,r=void 0;else if(S===","){const $=n[n.length-1];typeof $=="number"?n[n.length-1]=$+1:(c=!0,n[n.length-1]=""),r=void 0}}})}catch(S){if(S!==o)throw S}return{path:n,previousNode:r,isAtPropertyKey:c,matches:S=>{let A=0;for(let M=0;A<S.length&&M<n.length;M++)if(S[A]===n[M]||S[A]==="*")A++;else if(S[A]!=="**")return!1;return A===S.length}}}e.getLocation=R;function E(i,a=[],n=P.DEFAULT){let o=null,r=[];const s=[];function c(S){Array.isArray(r)?r.push(S):o!==null&&(r[o]=S)}return h(i,{onObjectBegin:()=>{const S={};c(S),s.push(r),r=S,o=null},onObjectProperty:S=>{o=S},onObjectEnd:()=>{r=s.pop()},onArrayBegin:()=>{const S=[];c(S),s.push(r),r=S,o=null},onArrayEnd:()=>{r=s.pop()},onLiteralValue:c,onError:(S,A,M)=>{a.push({error:S,offset:A,length:M})}},n),r[0]}e.parse=E;function b(i,a=[],n=P.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(S){o.type==="property"&&(o.length=S-o.offset,o=o.parent)}function s(S){return o.children.push(S),S}h(i,{onObjectBegin:S=>{o=s({type:"object",offset:S,length:-1,parent:o,children:[]})},onObjectProperty:(S,A,M)=>{o=s({type:"property",offset:A,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:S,offset:A,length:M,parent:o})},onObjectEnd:(S,A)=>{o.length=S+A-o.offset,o=o.parent,r(S+A)},onArrayBegin:(S,A)=>{o=s({type:"array",offset:S,length:-1,parent:o,children:[]})},onArrayEnd:(S,A)=>{o.length=S+A-o.offset,o=o.parent,r(S+A)},onLiteralValue:(S,A,M)=>{s({type:f(S),offset:A,length:M,parent:o,value:S}),r(A+M)},onSeparator:(S,A,M)=>{o.type==="property"&&(S===":"?o.colonOffset=A:S===","&&r(A))},onError:(S,A,M)=>{a.push({error:S,offset:A,length:M})}},n);const u=o.children[0];return u&&delete u.parent,u}e.parseTree=b;function d(i,a){if(!i)return;let n=i;for(const o of a)if(typeof o=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let r=!1;for(const s of n.children)if(Array.isArray(s.children)&&s.children[0].value===o){n=s.children[1],r=!0;break}if(!r)return}else{const r=o;if(n.type!=="array"||r<0||!Array.isArray(n.children)||r>=n.children.length)return;n=n.children[r]}return n}e.findNodeAtLocation=d;function C(i){if(!i.parent||!i.parent.children)return[];const a=C(i.parent);if(i.parent.type==="property"){const n=i.parent.children[0].value;a.push(n)}else if(i.parent.type==="array"){const n=i.parent.children.indexOf(i);n!==-1&&a.push(n)}return a}e.getNodePath=C;function y(i){switch(i.type){case"array":return i.children.map(y);case"object":{const a=Object.create(null);for(const n of i.children){const o=n.children[1];o&&(a[n.children[0].value]=y(o))}return a}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=y;function m(i,a,n=!1){return a>=i.offset&&a<i.offset+i.length||n&&a===i.offset+i.length}e.contains=m;function g(i,a,n=!1){if(m(i,a,n)){const o=i.children;if(Array.isArray(o))for(let r=0;r<o.length&&o[r].offset<=a;r++){const s=g(o[r],a,n);if(s)return s}return i}}e.findNodeAtOffset=g;function h(i,a,n=P.DEFAULT){const o=k(i,!1);function r(ae){return ae?()=>ae(o.getTokenOffset(),o.getTokenLength()):()=>!0}function s(ae){return ae?ie=>ae(ie,o.getTokenOffset(),o.getTokenLength()):()=>!0}const c=r(a.onObjectBegin),u=s(a.onObjectProperty),S=r(a.onObjectEnd),A=r(a.onArrayBegin),M=r(a.onArrayEnd),$=s(a.onLiteralValue),Q=s(a.onSeparator),_=r(a.onComment),q=s(a.onError),U=n&&n.disallowComments,ne=n&&n.allowTrailingComma;function Z(){for(;;){const ae=o.scan();switch(o.getTokenError()){case 4:F(14);break;case 5:F(15);break;case 3:F(13);break;case 1:U||F(11);break;case 2:F(12);break;case 6:F(16);break}switch(ae){case 12:case 13:U?F(10):_();break;case 16:F(1);break;case 15:case 14:break;default:return ae}}}function F(ae,ie=[],O=[]){if(q(ae),ie.length+O.length>0){let B=o.getToken();for(;B!==17;){if(ie.indexOf(B)!==-1){Z();break}else if(O.indexOf(B)!==-1)break;B=Z()}}}function x(ae){const ie=o.getTokenValue();return ae?$(ie):u(ie),Z(),!0}function z(){switch(o.getToken()){case 11:{let ae=0;try{ae=JSON.parse(o.getTokenValue()),typeof ae!="number"&&(F(2),ae=0)}catch{F(2)}$(ae);break}case 7:$(null);break;case 8:$(!0);break;case 9:$(!1);break;default:return!1}return Z(),!0}function W(){return o.getToken()!==10?(F(3,[],[2,5]),!1):(x(!1),o.getToken()===6?(Q(":"),Z(),X()||F(4,[],[2,5])):F(5,[],[2,5]),!0)}function re(){c(),Z();let ae=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(ae||F(4,[],[]),Q(","),Z(),o.getToken()===2&&ne)break}else ae&&F(6,[],[]);W()||F(4,[],[2,5]),ae=!0}return S(),o.getToken()!==2?F(7,[2],[]):Z(),!0}function V(){A(),Z();let ae=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(ae||F(4,[],[]),Q(","),Z(),o.getToken()===4&&ne)break}else ae&&F(6,[],[]);X()||F(4,[],[4,5]),ae=!0}return M(),o.getToken()!==4?F(8,[4],[]):Z(),!0}function X(){switch(o.getToken()){case 3:return V();case 1:return re();case 10:return x(!0);default:return z()}}return Z(),o.getToken()===17?n.allowEmptyContent?!0:(F(4,[],[]),!1):X()?(o.getToken()!==17&&F(9,[],[]),!0):(F(4,[],[]),!1)}e.visit=h;function l(i,a){const n=k(i),o=[];let r,s=0,c;do switch(c=n.getPosition(),r=n.scan(),r){case 12:case 13:case 17:s!==c&&o.push(i.substring(s,c)),a!==void 0&&o.push(n.getTokenValue().replace(/[^\r\n]/g,a)),s=n.getPosition();break}while(r!==17);return o.join("")}e.stripComments=l;function f(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=f}),define(ve[131],we([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class I{constructor(v){this.executor=v,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(v){this._error=v}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(v){return new I(()=>v(this.getValue()))}}e.Lazy=I}),define(ve[2],we([0,1,64,47]),function(oe,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const v=!1;let P=null;function k(r){P=r}if(e.setDisposableTracker=k,v){const r="__is_disposable_tracked__";k(new class{trackDisposable(s){const c=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[r]||console.log(c)},3e3)}setParent(s,c){if(s&&s!==g.None)try{s[r]=!0}catch{}}markAsDisposed(s){if(s&&s!==g.None)try{s[r]=!0}catch{}}markAsSingleton(s){}})}function w(r){return P?.trackDisposable(r),r}function p(r){P?.markAsDisposed(r)}function D(r,s){P?.setParent(r,s)}function T(r,s){if(!!P)for(const c of r)P.setParent(c,s)}function R(r){return P?.markAsSingleton(r),r}e.markAsSingleton=R;class E extends Error{constructor(s){super(`Encountered errors while disposing of store. Errors: [${s.join(", ")}]`);this.errors=s}}e.MultiDisposeError=E;function b(r){return typeof r.dispose=="function"&&r.dispose.length===0}e.isDisposable=b;function d(r){if(t.Iterable.is(r)){const s=[];for(const c of r)if(c)try{c.dispose()}catch(u){s.push(u)}if(s.length===1)throw s[0];if(s.length>1)throw new E(s);return Array.isArray(r)?[]:r}else if(r)return r.dispose(),r}e.dispose=d;function C(...r){const s=y(()=>d(r));return T(r,s),s}e.combinedDisposable=C;function y(r){const s=w({dispose:(0,I.once)(()=>{p(s),r()})});return s}e.toDisposable=y;class m{constructor(){this._toDispose=new Set,this._isDisposed=!1,w(this)}dispose(){this._isDisposed||(p(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{d(this._toDispose.values())}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return D(s,this),this._isDisposed?m.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}e.DisposableStore=m,m.DISABLE_DISPOSED_WARNING=!1;class g{constructor(){this._store=new m,w(this),D(this._store,this)}dispose(){p(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}e.Disposable=g,g.None=Object.freeze({dispose(){}});class h{constructor(){this._isDisposed=!1,w(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){this._isDisposed||s===this._value||(this._value?.dispose(),s&&D(s,this),this._value=s)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,p(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const s=this._value;return this._value=void 0,s&&D(s,null),s}}e.MutableDisposable=h;class l{constructor(s){this._disposable=s,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=l;class f{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,w(this)}set(s){let c=s;return this.unset=()=>c=void 0,this.isset=()=>c!==void 0,this.dispose=()=>{c&&(c(),c=void 0,p(this))},this}}e.SafeDisposable=f;class i{constructor(){this.references=new Map}acquire(s,...c){let u=this.references.get(s);u||(u={counter:0,object:this.createReferencedObject(s,...c)},this.references.set(s,u));const{object:S}=u,A=(0,I.once)(()=>{--u.counter==0&&(this.destroyReferencedObject(s,u.object),this.references.delete(s))});return u.counter++,{object:S,dispose:A}}}e.ReferenceCollection=i;class a{constructor(s){this.referenceCollection=s}async acquire(s,...c){const u=this.referenceCollection.acquire(s,...c);try{return{object:await u.object,dispose:()=>u.dispose()}}catch(S){throw u.dispose(),S}}}e.AsyncReferenceCollection=a;class n{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=n;function o(r){const s=new m;try{r(s)}finally{s.dispose()}}e.disposeOnReturn=o}),define(ve[132],we([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class I{constructor(P){this.element=P,this.next=I.Undefined,this.prev=I.Undefined}}I.Undefined=new I(void 0);class t{constructor(){this._first=I.Undefined,this._last=I.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===I.Undefined}clear(){let P=this._first;for(;P!==I.Undefined;){const k=P.next;P.prev=I.Undefined,P.next=I.Undefined,P=k}this._first=I.Undefined,this._last=I.Undefined,this._size=0}unshift(P){return this._insert(P,!1)}push(P){return this._insert(P,!0)}_insert(P,k){const w=new I(P);if(this._first===I.Undefined)this._first=w,this._last=w;else if(k){const D=this._last;this._last=w,w.prev=D,D.next=w}else{const D=this._first;this._first=w,w.next=D,D.prev=w}this._size+=1;let p=!1;return()=>{p||(p=!0,this._remove(w))}}shift(){if(this._first!==I.Undefined){const P=this._first.element;return this._remove(this._first),P}}pop(){if(this._last!==I.Undefined){const P=this._last.element;return this._remove(this._last),P}}_remove(P){if(P.prev!==I.Undefined&&P.next!==I.Undefined){const k=P.prev;k.next=P.next,P.next.prev=k}else P.prev===I.Undefined&&P.next===I.Undefined?(this._first=I.Undefined,this._last=I.Undefined):P.next===I.Undefined?(this._last=this._last.prev,this._last.next=I.Undefined):P.prev===I.Undefined&&(this._first=this._first.next,this._first.prev=I.Undefined);this._size-=1}*[Symbol.iterator](){let P=this._first;for(;P!==I.Undefined;)yield P.element,P=P.next}}e.LinkedList=t}),function(oe,e){typeof exports=="object"&&typeof module!="undefined"?e(exports):typeof define=="function"&&define.amd?define(ve[133],we([1]),e):(oe=typeof globalThis!="undefined"?globalThis:oe||self,e(oe.marked={}))}(this,function(oe){"use strict";function e(te,le){for(var de=0;de<le.length;de++){var Y=le[de];Y.enumerable=Y.enumerable||!1,Y.configurable=!0,"value"in Y&&(Y.writable=!0),Object.defineProperty(te,Y.key,Y)}}function I(te,le,de){return le&&e(te.prototype,le),de&&e(te,de),Object.defineProperty(te,"prototype",{writable:!1}),te}function t(te,le){if(!!te){if(typeof te=="string")return v(te,le);var de=Object.prototype.toString.call(te).slice(8,-1);if(de==="Object"&&te.constructor&&(de=te.constructor.name),de==="Map"||de==="Set")return Array.from(te);if(de==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(de))return v(te,le)}}function v(te,le){(le==null||le>te.length)&&(le=te.length);for(var de=0,Y=new Array(le);de<le;de++)Y[de]=te[de];return Y}function P(te,le){var de=typeof Symbol!="undefined"&&te[Symbol.iterator]||te["@@iterator"];if(de)return(de=de.call(te)).next.bind(de);if(Array.isArray(te)||(de=t(te))||le&&te&&typeof te.length=="number"){de&&(te=de);var Y=0;return function(){return Y>=te.length?{done:!0}:{done:!1,value:te[Y++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function k(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}oe.defaults=k();function w(te){oe.defaults=te}var p=/[&<>"']/,D=/[&<>"']/g,T=/[<>"']|&(?!#?\w+;)/,R=/[<>"']|&(?!#?\w+;)/g,E={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},b=function(le){return E[le]};function d(te,le){if(le){if(p.test(te))return te.replace(D,b)}else if(T.test(te))return te.replace(R,b);return te}var C=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function y(te){return te.replace(C,function(le,de){return de=de.toLowerCase(),de==="colon"?":":de.charAt(0)==="#"?de.charAt(1)==="x"?String.fromCharCode(parseInt(de.substring(2),16)):String.fromCharCode(+de.substring(1)):""})}var m=/(^|[^\[])\^/g;function g(te,le){te=typeof te=="string"?te:te.source,le=le||"";var de={replace:function(J,H){return H=H.source||H,H=H.replace(m,"$1"),te=te.replace(J,H),de},getRegex:function(){return new RegExp(te,le)}};return de}var h=/[^\w:]/g,l=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function f(te,le,de){if(te){var Y;try{Y=decodeURIComponent(y(de)).replace(h,"").toLowerCase()}catch{return null}if(Y.indexOf("javascript:")===0||Y.indexOf("vbscript:")===0||Y.indexOf("data:")===0)return null}le&&!l.test(de)&&(de=r(le,de));try{de=encodeURI(de).replace(/%25/g,"%")}catch{return null}return de}var i={},a=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(te,le){i[" "+te]||(a.test(te)?i[" "+te]=te+"/":i[" "+te]=S(te,"/",!0)),te=i[" "+te];var de=te.indexOf(":")===-1;return le.substring(0,2)==="//"?de?le:te.replace(n,"$1")+le:le.charAt(0)==="/"?de?le:te.replace(o,"$1")+le:te+le}var s={exec:function(){}};function c(te){for(var le=1,de,Y;le<arguments.length;le++){de=arguments[le];for(Y in de)Object.prototype.hasOwnProperty.call(de,Y)&&(te[Y]=de[Y])}return te}function u(te,le){var de=te.replace(/\|/g,function(H,G,fe){for(var pe=!1,ke=G;--ke>=0&&fe[ke]==="\\";)pe=!pe;return pe?"|":" |"}),Y=de.split(/ \|/),J=0;if(Y[0].trim()||Y.shift(),Y.length>0&&!Y[Y.length-1].trim()&&Y.pop(),Y.length>le)Y.splice(le);else for(;Y.length<le;)Y.push("");for(;J<Y.length;J++)Y[J]=Y[J].trim().replace(/\\\|/g,"|");return Y}function S(te,le,de){var Y=te.length;if(Y===0)return"";for(var J=0;J<Y;){var H=te.charAt(Y-J-1);if(H===le&&!de)J++;else if(H!==le&&de)J++;else break}return te.slice(0,Y-J)}function A(te,le){if(te.indexOf(le[1])===-1)return-1;for(var de=te.length,Y=0,J=0;J<de;J++)if(te[J]==="\\")J++;else if(te[J]===le[0])Y++;else if(te[J]===le[1]&&(Y--,Y<0))return J;return-1}function M(te){te&&te.sanitize&&!te.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function $(te,le){if(le<1)return"";for(var de="";le>1;)le&1&&(de+=te),le>>=1,te+=te;return de+te}function Q(te,le,de,Y){var J=le.href,H=le.title?d(le.title):null,G=te[1].replace(/\\([\[\]])/g,"$1");if(te[0].charAt(0)!=="!"){Y.state.inLink=!0;var fe={type:"link",raw:de,href:J,title:H,text:G,tokens:Y.inlineTokens(G,[])};return Y.state.inLink=!1,fe}return{type:"image",raw:de,href:J,title:H,text:d(G)}}function _(te,le){var de=te.match(/^(\s+)(?:```)/);if(de===null)return le;var Y=de[1];return le.split(`
`).map(function(J){var H=J.match(/^\s+/);if(H===null)return J;var G=H[0];return G.length>=Y.length?J.slice(Y.length):J}).join(`
`)}var q=function(){function te(de){this.options=de||oe.defaults}var le=te.prototype;return le.space=function(Y){var J=this.rules.block.newline.exec(Y);if(J&&J[0].length>0)return{type:"space",raw:J[0]}},le.code=function(Y){var J=this.rules.block.code.exec(Y);if(J){var H=J[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:J[0],codeBlockStyle:"indented",text:this.options.pedantic?H:S(H,`
`)}}},le.fences=function(Y){var J=this.rules.block.fences.exec(Y);if(J){var H=J[0],G=_(H,J[3]||"");return{type:"code",raw:H,lang:J[2]?J[2].trim():J[2],text:G}}},le.heading=function(Y){var J=this.rules.block.heading.exec(Y);if(J){var H=J[2].trim();if(/#$/.test(H)){var G=S(H,"#");(this.options.pedantic||!G||/ $/.test(G))&&(H=G.trim())}var fe={type:"heading",raw:J[0],depth:J[1].length,text:H,tokens:[]};return this.lexer.inline(fe.text,fe.tokens),fe}},le.hr=function(Y){var J=this.rules.block.hr.exec(Y);if(J)return{type:"hr",raw:J[0]}},le.blockquote=function(Y){var J=this.rules.block.blockquote.exec(Y);if(J){var H=J[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:J[0],tokens:this.lexer.blockTokens(H,[]),text:H}}},le.list=function(Y){var J=this.rules.block.list.exec(Y);if(J){var H,G,fe,pe,ke,Te,Me,Be,ge,Se,ye,Oe,Ne=J[1].trim(),Je=Ne.length>1,$e={type:"list",raw:"",ordered:Je,start:Je?+Ne.slice(0,-1):"",loose:!1,items:[]};Ne=Je?"\\d{1,9}\\"+Ne.slice(-1):"\\"+Ne,this.options.pedantic&&(Ne=Je?Ne:"[*+-]");for(var He=new RegExp("^( {0,3}"+Ne+")((?:[	 ][^\\n]*)?(?:\\n|$))");Y&&(Oe=!1,!(!(J=He.exec(Y))||this.rules.block.hr.test(Y)));){if(H=J[0],Y=Y.substring(H.length),Be=J[2].split(`
`,1)[0],ge=Y.split(`
`,1)[0],this.options.pedantic?(pe=2,ye=Be.trimLeft()):(pe=J[2].search(/[^ ]/),pe=pe>4?1:pe,ye=Be.slice(pe),pe+=J[1].length),Te=!1,!Be&&/^ *$/.test(ge)&&(H+=ge+`
`,Y=Y.substring(ge.length+1),Oe=!0),!Oe)for(var We=new RegExp("^ {0,"+Math.min(3,pe-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),je=new RegExp("^ {0,"+Math.min(3,pe-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)");Y&&(Se=Y.split(`
`,1)[0],Be=Se,this.options.pedantic&&(Be=Be.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(We.test(Be)||je.test(Y)));){if(Be.search(/[^ ]/)>=pe||!Be.trim())ye+=`
`+Be.slice(pe);else if(!Te)ye+=`
`+Be;else break;!Te&&!Be.trim()&&(Te=!0),H+=Se+`
`,Y=Y.substring(Se.length+1)}$e.loose||(Me?$e.loose=!0:/\n *\n *$/.test(H)&&(Me=!0)),this.options.gfm&&(G=/^\[[ xX]\] /.exec(ye),G&&(fe=G[0]!=="[ ] ",ye=ye.replace(/^\[[ xX]\] +/,""))),$e.items.push({type:"list_item",raw:H,task:!!G,checked:fe,loose:!1,text:ye}),$e.raw+=H}$e.items[$e.items.length-1].raw=H.trimRight(),$e.items[$e.items.length-1].text=ye.trimRight(),$e.raw=$e.raw.trimRight();var Ge=$e.items.length;for(ke=0;ke<Ge;ke++){this.lexer.state.top=!1,$e.items[ke].tokens=this.lexer.blockTokens($e.items[ke].text,[]);var ue=$e.items[ke].tokens.filter(function(Pe){return Pe.type==="space"}),Ce=ue.every(function(Pe){for(var Ae=Pe.raw.split(""),Le=0,Ue=P(Ae),Ve;!(Ve=Ue()).done;){var Ke=Ve.value;if(Ke===`
`&&(Le+=1),Le>1)return!0}return!1});!$e.loose&&ue.length&&Ce&&($e.loose=!0,$e.items[ke].loose=!0)}return $e}},le.html=function(Y){var J=this.rules.block.html.exec(Y);if(J){var H={type:"html",raw:J[0],pre:!this.options.sanitizer&&(J[1]==="pre"||J[1]==="script"||J[1]==="style"),text:J[0]};return this.options.sanitize&&(H.type="paragraph",H.text=this.options.sanitizer?this.options.sanitizer(J[0]):d(J[0]),H.tokens=[],this.lexer.inline(H.text,H.tokens)),H}},le.def=function(Y){var J=this.rules.block.def.exec(Y);if(J){J[3]&&(J[3]=J[3].substring(1,J[3].length-1));var H=J[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:H,raw:J[0],href:J[2],title:J[3]}}},le.table=function(Y){var J=this.rules.block.table.exec(Y);if(J){var H={type:"table",header:u(J[1]).map(function(Me){return{text:Me}}),align:J[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:J[3]&&J[3].trim()?J[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(H.header.length===H.align.length){H.raw=J[0];var G=H.align.length,fe,pe,ke,Te;for(fe=0;fe<G;fe++)/^ *-+: *$/.test(H.align[fe])?H.align[fe]="right":/^ *:-+: *$/.test(H.align[fe])?H.align[fe]="center":/^ *:-+ *$/.test(H.align[fe])?H.align[fe]="left":H.align[fe]=null;for(G=H.rows.length,fe=0;fe<G;fe++)H.rows[fe]=u(H.rows[fe],H.header.length).map(function(Me){return{text:Me}});for(G=H.header.length,pe=0;pe<G;pe++)H.header[pe].tokens=[],this.lexer.inline(H.header[pe].text,H.header[pe].tokens);for(G=H.rows.length,pe=0;pe<G;pe++)for(Te=H.rows[pe],ke=0;ke<Te.length;ke++)Te[ke].tokens=[],this.lexer.inline(Te[ke].text,Te[ke].tokens);return H}}},le.lheading=function(Y){var J=this.rules.block.lheading.exec(Y);if(J){var H={type:"heading",raw:J[0],depth:J[2].charAt(0)==="="?1:2,text:J[1],tokens:[]};return this.lexer.inline(H.text,H.tokens),H}},le.paragraph=function(Y){var J=this.rules.block.paragraph.exec(Y);if(J){var H={type:"paragraph",raw:J[0],text:J[1].charAt(J[1].length-1)===`
`?J[1].slice(0,-1):J[1],tokens:[]};return this.lexer.inline(H.text,H.tokens),H}},le.text=function(Y){var J=this.rules.block.text.exec(Y);if(J){var H={type:"text",raw:J[0],text:J[0],tokens:[]};return this.lexer.inline(H.text,H.tokens),H}},le.escape=function(Y){var J=this.rules.inline.escape.exec(Y);if(J)return{type:"escape",raw:J[0],text:d(J[1])}},le.tag=function(Y){var J=this.rules.inline.tag.exec(Y);if(J)return!this.lexer.state.inLink&&/^<a /i.test(J[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(J[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(J[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(J[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:J[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(J[0]):d(J[0]):J[0]}},le.link=function(Y){var J=this.rules.inline.link.exec(Y);if(J){var H=J[2].trim();if(!this.options.pedantic&&/^</.test(H)){if(!/>$/.test(H))return;var G=S(H.slice(0,-1),"\\");if((H.length-G.length)%2==0)return}else{var fe=A(J[2],"()");if(fe>-1){var pe=J[0].indexOf("!")===0?5:4,ke=pe+J[1].length+fe;J[2]=J[2].substring(0,fe),J[0]=J[0].substring(0,ke).trim(),J[3]=""}}var Te=J[2],Me="";if(this.options.pedantic){var Be=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Te);Be&&(Te=Be[1],Me=Be[3])}else Me=J[3]?J[3].slice(1,-1):"";return Te=Te.trim(),/^</.test(Te)&&(this.options.pedantic&&!/>$/.test(H)?Te=Te.slice(1):Te=Te.slice(1,-1)),Q(J,{href:Te&&Te.replace(this.rules.inline._escapes,"$1"),title:Me&&Me.replace(this.rules.inline._escapes,"$1")},J[0],this.lexer)}},le.reflink=function(Y,J){var H;if((H=this.rules.inline.reflink.exec(Y))||(H=this.rules.inline.nolink.exec(Y))){var G=(H[2]||H[1]).replace(/\s+/g," ");if(G=J[G.toLowerCase()],!G||!G.href){var fe=H[0].charAt(0);return{type:"text",raw:fe,text:fe}}return Q(H,G,H[0],this.lexer)}},le.emStrong=function(Y,J,H){H===void 0&&(H="");var G=this.rules.inline.emStrong.lDelim.exec(Y);if(!!G&&!(G[3]&&H.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var fe=G[1]||G[2]||"";if(!fe||fe&&(H===""||this.rules.inline.punctuation.exec(H))){var pe=G[0].length-1,ke,Te,Me=pe,Be=0,ge=G[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ge.lastIndex=0,J=J.slice(-1*Y.length+pe);(G=ge.exec(J))!=null;)if(ke=G[1]||G[2]||G[3]||G[4]||G[5]||G[6],!!ke){if(Te=ke.length,G[3]||G[4]){Me+=Te;continue}else if((G[5]||G[6])&&pe%3&&!((pe+Te)%3)){Be+=Te;continue}if(Me-=Te,!(Me>0)){if(Te=Math.min(Te,Te+Me+Be),Math.min(pe,Te)%2){var Se=Y.slice(1,pe+G.index+Te);return{type:"em",raw:Y.slice(0,pe+G.index+Te+1),text:Se,tokens:this.lexer.inlineTokens(Se,[])}}var ye=Y.slice(2,pe+G.index+Te-1);return{type:"strong",raw:Y.slice(0,pe+G.index+Te+1),text:ye,tokens:this.lexer.inlineTokens(ye,[])}}}}}},le.codespan=function(Y){var J=this.rules.inline.code.exec(Y);if(J){var H=J[2].replace(/\n/g," "),G=/[^ ]/.test(H),fe=/^ /.test(H)&&/ $/.test(H);return G&&fe&&(H=H.substring(1,H.length-1)),H=d(H,!0),{type:"codespan",raw:J[0],text:H}}},le.br=function(Y){var J=this.rules.inline.br.exec(Y);if(J)return{type:"br",raw:J[0]}},le.del=function(Y){var J=this.rules.inline.del.exec(Y);if(J)return{type:"del",raw:J[0],text:J[2],tokens:this.lexer.inlineTokens(J[2],[])}},le.autolink=function(Y,J){var H=this.rules.inline.autolink.exec(Y);if(H){var G,fe;return H[2]==="@"?(G=d(this.options.mangle?J(H[1]):H[1]),fe="mailto:"+G):(G=d(H[1]),fe=G),{type:"link",raw:H[0],text:G,href:fe,tokens:[{type:"text",raw:G,text:G}]}}},le.url=function(Y,J){var H;if(H=this.rules.inline.url.exec(Y)){var G,fe;if(H[2]==="@")G=d(this.options.mangle?J(H[0]):H[0]),fe="mailto:"+G;else{var pe;do pe=H[0],H[0]=this.rules.inline._backpedal.exec(H[0])[0];while(pe!==H[0]);G=d(H[0]),H[1]==="www."?fe="http://"+G:fe=G}return{type:"link",raw:H[0],text:G,href:fe,tokens:[{type:"text",raw:G,text:G}]}}},le.inlineText=function(Y,J){var H=this.rules.inline.text.exec(Y);if(H){var G;return this.lexer.state.inRawBlock?G=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(H[0]):d(H[0]):H[0]:G=d(this.options.smartypants?J(H[0]):H[0]),{type:"text",raw:H[0],text:G}}},te}(),U={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:s,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};U._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,U._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,U.def=g(U.def).replace("label",U._label).replace("title",U._title).getRegex(),U.bullet=/(?:[*+-]|\d{1,9}[.)])/,U.listItemStart=g(/^( *)(bull) */).replace("bull",U.bullet).getRegex(),U.list=g(U.list).replace(/bull/g,U.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+U.def.source+")").getRegex(),U._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",U._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,U.html=g(U.html,"i").replace("comment",U._comment).replace("tag",U._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),U.paragraph=g(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.blockquote=g(U.blockquote).replace("paragraph",U.paragraph).getRegex(),U.normal=c({},U),U.gfm=c({},U.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),U.gfm.table=g(U.gfm.table).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.gfm.paragraph=g(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",U.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.pedantic=c({},U.normal,{html:g(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",U._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:s,paragraph:g(U.normal._paragraph).replace("hr",U.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",U.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ne={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:s,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:s,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ne._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ne.punctuation=g(ne.punctuation).replace(/punctuation/g,ne._punctuation).getRegex(),ne.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ne.escapedEmSt=/\\\*|\\_/g,ne._comment=g(U._comment).replace("(?:-->|$)","-->").getRegex(),ne.emStrong.lDelim=g(ne.emStrong.lDelim).replace(/punct/g,ne._punctuation).getRegex(),ne.emStrong.rDelimAst=g(ne.emStrong.rDelimAst,"g").replace(/punct/g,ne._punctuation).getRegex(),ne.emStrong.rDelimUnd=g(ne.emStrong.rDelimUnd,"g").replace(/punct/g,ne._punctuation).getRegex(),ne._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ne._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ne._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ne.autolink=g(ne.autolink).replace("scheme",ne._scheme).replace("email",ne._email).getRegex(),ne._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ne.tag=g(ne.tag).replace("comment",ne._comment).replace("attribute",ne._attribute).getRegex(),ne._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ne._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ne._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ne.link=g(ne.link).replace("label",ne._label).replace("href",ne._href).replace("title",ne._title).getRegex(),ne.reflink=g(ne.reflink).replace("label",ne._label).replace("ref",U._label).getRegex(),ne.nolink=g(ne.nolink).replace("ref",U._label).getRegex(),ne.reflinkSearch=g(ne.reflinkSearch,"g").replace("reflink",ne.reflink).replace("nolink",ne.nolink).getRegex(),ne.normal=c({},ne),ne.pedantic=c({},ne.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:g(/^!?\[(label)\]\((.*?)\)/).replace("label",ne._label).getRegex(),reflink:g(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ne._label).getRegex()}),ne.gfm=c({},ne.normal,{escape:g(ne.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),ne.gfm.url=g(ne.gfm.url,"i").replace("email",ne.gfm._extended_email).getRegex(),ne.breaks=c({},ne.gfm,{br:g(ne.br).replace("{2,}","*").getRegex(),text:g(ne.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function Z(te){return te.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function F(te){var le="",de,Y,J=te.length;for(de=0;de<J;de++)Y=te.charCodeAt(de),Math.random()>.5&&(Y="x"+Y.toString(16)),le+="&#"+Y+";";return le}var x=function(){function te(de){this.tokens=[],this.tokens.links=Object.create(null),this.options=de||oe.defaults,this.options.tokenizer=this.options.tokenizer||new q,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Y={block:U.normal,inline:ne.normal};this.options.pedantic?(Y.block=U.pedantic,Y.inline=ne.pedantic):this.options.gfm&&(Y.block=U.gfm,this.options.breaks?Y.inline=ne.breaks:Y.inline=ne.gfm),this.tokenizer.rules=Y}te.lex=function(Y,J){var H=new te(J);return H.lex(Y)},te.lexInline=function(Y,J){var H=new te(J);return H.inlineTokens(Y)};var le=te.prototype;return le.lex=function(Y){Y=Y.replace(/\r\n|\r/g,`
`),this.blockTokens(Y,this.tokens);for(var J;J=this.inlineQueue.shift();)this.inlineTokens(J.src,J.tokens);return this.tokens},le.blockTokens=function(Y,J){var H=this;J===void 0&&(J=[]),this.options.pedantic?Y=Y.replace(/\t/g,"    ").replace(/^ +$/gm,""):Y=Y.replace(/^( *)(\t+)/gm,function(Me,Be,ge){return Be+"    ".repeat(ge.length)});for(var G,fe,pe,ke;Y;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Me){return(G=Me.call({lexer:H},Y,J))?(Y=Y.substring(G.raw.length),J.push(G),!0):!1}))){if(G=this.tokenizer.space(Y)){Y=Y.substring(G.raw.length),G.raw.length===1&&J.length>0?J[J.length-1].raw+=`
`:J.push(G);continue}if(G=this.tokenizer.code(Y)){Y=Y.substring(G.raw.length),fe=J[J.length-1],fe&&(fe.type==="paragraph"||fe.type==="text")?(fe.raw+=`
`+G.raw,fe.text+=`
`+G.text,this.inlineQueue[this.inlineQueue.length-1].src=fe.text):J.push(G);continue}if(G=this.tokenizer.fences(Y)){Y=Y.substring(G.raw.length),J.push(G);continue}if(G=this.tokenizer.heading(Y)){Y=Y.substring(G.raw.length),J.push(G);continue}if(G=this.tokenizer.hr(Y)){Y=Y.substring(G.raw.length),J.push(G);continue}if(G=this.tokenizer.blockquote(Y)){Y=Y.substring(G.raw.length),J.push(G);continue}if(G=this.tokenizer.list(Y)){Y=Y.substring(G.raw.length),J.push(G);continue}if(G=this.tokenizer.html(Y)){Y=Y.substring(G.raw.length),J.push(G);continue}if(G=this.tokenizer.def(Y)){Y=Y.substring(G.raw.length),fe=J[J.length-1],fe&&(fe.type==="paragraph"||fe.type==="text")?(fe.raw+=`
`+G.raw,fe.text+=`
`+G.raw,this.inlineQueue[this.inlineQueue.length-1].src=fe.text):this.tokens.links[G.tag]||(this.tokens.links[G.tag]={href:G.href,title:G.title});continue}if(G=this.tokenizer.table(Y)){Y=Y.substring(G.raw.length),J.push(G);continue}if(G=this.tokenizer.lheading(Y)){Y=Y.substring(G.raw.length),J.push(G);continue}if(pe=Y,this.options.extensions&&this.options.extensions.startBlock&&function(){var Me=1/0,Be=Y.slice(1),ge=void 0;H.options.extensions.startBlock.forEach(function(Se){ge=Se.call({lexer:this},Be),typeof ge=="number"&&ge>=0&&(Me=Math.min(Me,ge))}),Me<1/0&&Me>=0&&(pe=Y.substring(0,Me+1))}(),this.state.top&&(G=this.tokenizer.paragraph(pe))){fe=J[J.length-1],ke&&fe.type==="paragraph"?(fe.raw+=`
`+G.raw,fe.text+=`
`+G.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=fe.text):J.push(G),ke=pe.length!==Y.length,Y=Y.substring(G.raw.length);continue}if(G=this.tokenizer.text(Y)){Y=Y.substring(G.raw.length),fe=J[J.length-1],fe&&fe.type==="text"?(fe.raw+=`
`+G.raw,fe.text+=`
`+G.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=fe.text):J.push(G);continue}if(Y){var Te="Infinite loop on byte: "+Y.charCodeAt(0);if(this.options.silent){console.error(Te);break}else throw new Error(Te)}}return this.state.top=!0,J},le.inline=function(Y,J){this.inlineQueue.push({src:Y,tokens:J})},le.inlineTokens=function(Y,J){var H=this;J===void 0&&(J=[]);var G,fe,pe,ke=Y,Te,Me,Be;if(this.tokens.links){var ge=Object.keys(this.tokens.links);if(ge.length>0)for(;(Te=this.tokenizer.rules.inline.reflinkSearch.exec(ke))!=null;)ge.includes(Te[0].slice(Te[0].lastIndexOf("[")+1,-1))&&(ke=ke.slice(0,Te.index)+"["+$("a",Te[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Te=this.tokenizer.rules.inline.blockSkip.exec(ke))!=null;)ke=ke.slice(0,Te.index)+"["+$("a",Te[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Te=this.tokenizer.rules.inline.escapedEmSt.exec(ke))!=null;)ke=ke.slice(0,Te.index)+"++"+ke.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Y;)if(Me||(Be=""),Me=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ye){return(G=ye.call({lexer:H},Y,J))?(Y=Y.substring(G.raw.length),J.push(G),!0):!1}))){if(G=this.tokenizer.escape(Y)){Y=Y.substring(G.raw.length),J.push(G);continue}if(G=this.tokenizer.tag(Y)){Y=Y.substring(G.raw.length),fe=J[J.length-1],fe&&G.type==="text"&&fe.type==="text"?(fe.raw+=G.raw,fe.text+=G.text):J.push(G);continue}if(G=this.tokenizer.link(Y)){Y=Y.substring(G.raw.length),J.push(G);continue}if(G=this.tokenizer.reflink(Y,this.tokens.links)){Y=Y.substring(G.raw.length),fe=J[J.length-1],fe&&G.type==="text"&&fe.type==="text"?(fe.raw+=G.raw,fe.text+=G.text):J.push(G);continue}if(G=this.tokenizer.emStrong(Y,ke,Be)){Y=Y.substring(G.raw.length),J.push(G);continue}if(G=this.tokenizer.codespan(Y)){Y=Y.substring(G.raw.length),J.push(G);continue}if(G=this.tokenizer.br(Y)){Y=Y.substring(G.raw.length),J.push(G);continue}if(G=this.tokenizer.del(Y)){Y=Y.substring(G.raw.length),J.push(G);continue}if(G=this.tokenizer.autolink(Y,F)){Y=Y.substring(G.raw.length),J.push(G);continue}if(!this.state.inLink&&(G=this.tokenizer.url(Y,F))){Y=Y.substring(G.raw.length),J.push(G);continue}if(pe=Y,this.options.extensions&&this.options.extensions.startInline&&function(){var ye=1/0,Oe=Y.slice(1),Ne=void 0;H.options.extensions.startInline.forEach(function(Je){Ne=Je.call({lexer:this},Oe),typeof Ne=="number"&&Ne>=0&&(ye=Math.min(ye,Ne))}),ye<1/0&&ye>=0&&(pe=Y.substring(0,ye+1))}(),G=this.tokenizer.inlineText(pe,Z)){Y=Y.substring(G.raw.length),G.raw.slice(-1)!=="_"&&(Be=G.raw.slice(-1)),Me=!0,fe=J[J.length-1],fe&&fe.type==="text"?(fe.raw+=G.raw,fe.text+=G.text):J.push(G);continue}if(Y){var Se="Infinite loop on byte: "+Y.charCodeAt(0);if(this.options.silent){console.error(Se);break}else throw new Error(Se)}}return J},I(te,null,[{key:"rules",get:function(){return{block:U,inline:ne}}}]),te}(),z=function(){function te(de){this.options=de||oe.defaults}var le=te.prototype;return le.code=function(Y,J,H){var G=(J||"").match(/\S*/)[0];if(this.options.highlight){var fe=this.options.highlight(Y,G);fe!=null&&fe!==Y&&(H=!0,Y=fe)}return Y=Y.replace(/\n$/,"")+`
`,G?'<pre><code class="'+this.options.langPrefix+d(G,!0)+'">'+(H?Y:d(Y,!0))+`</code></pre>
`:"<pre><code>"+(H?Y:d(Y,!0))+`</code></pre>
`},le.blockquote=function(Y){return`<blockquote>
`+Y+`</blockquote>
`},le.html=function(Y){return Y},le.heading=function(Y,J,H,G){if(this.options.headerIds){var fe=this.options.headerPrefix+G.slug(H);return"<h"+J+' id="'+fe+'">'+Y+"</h"+J+`>
`}return"<h"+J+">"+Y+"</h"+J+`>
`},le.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},le.list=function(Y,J,H){var G=J?"ol":"ul",fe=J&&H!==1?' start="'+H+'"':"";return"<"+G+fe+`>
`+Y+"</"+G+`>
`},le.listitem=function(Y){return"<li>"+Y+`</li>
`},le.checkbox=function(Y){return"<input "+(Y?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},le.paragraph=function(Y){return"<p>"+Y+`</p>
`},le.table=function(Y,J){return J&&(J="<tbody>"+J+"</tbody>"),`<table>
<thead>
`+Y+`</thead>
`+J+`</table>
`},le.tablerow=function(Y){return`<tr>
`+Y+`</tr>
`},le.tablecell=function(Y,J){var H=J.header?"th":"td",G=J.align?"<"+H+' align="'+J.align+'">':"<"+H+">";return G+Y+("</"+H+`>
`)},le.strong=function(Y){return"<strong>"+Y+"</strong>"},le.em=function(Y){return"<em>"+Y+"</em>"},le.codespan=function(Y){return"<code>"+Y+"</code>"},le.br=function(){return this.options.xhtml?"<br/>":"<br>"},le.del=function(Y){return"<del>"+Y+"</del>"},le.link=function(Y,J,H){if(Y=f(this.options.sanitize,this.options.baseUrl,Y),Y===null)return H;var G='<a href="'+d(Y)+'"';return J&&(G+=' title="'+J+'"'),G+=">"+H+"</a>",G},le.image=function(Y,J,H){if(Y=f(this.options.sanitize,this.options.baseUrl,Y),Y===null)return H;var G='<img src="'+Y+'" alt="'+H+'"';return J&&(G+=' title="'+J+'"'),G+=this.options.xhtml?"/>":">",G},le.text=function(Y){return Y},te}(),W=function(){function te(){}var le=te.prototype;return le.strong=function(Y){return Y},le.em=function(Y){return Y},le.codespan=function(Y){return Y},le.del=function(Y){return Y},le.html=function(Y){return Y},le.text=function(Y){return Y},le.link=function(Y,J,H){return""+H},le.image=function(Y,J,H){return""+H},le.br=function(){return""},te}(),re=function(){function te(){this.seen={}}var le=te.prototype;return le.serialize=function(Y){return Y.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},le.getNextSafeSlug=function(Y,J){var H=Y,G=0;if(this.seen.hasOwnProperty(H)){G=this.seen[Y];do G++,H=Y+"-"+G;while(this.seen.hasOwnProperty(H))}return J||(this.seen[Y]=G,this.seen[H]=0),H},le.slug=function(Y,J){J===void 0&&(J={});var H=this.serialize(Y);return this.getNextSafeSlug(H,J.dryrun)},te}(),V=function(){function te(de){this.options=de||oe.defaults,this.options.renderer=this.options.renderer||new z,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new W,this.slugger=new re}te.parse=function(Y,J){var H=new te(J);return H.parse(Y)},te.parseInline=function(Y,J){var H=new te(J);return H.parseInline(Y)};var le=te.prototype;return le.parse=function(Y,J){J===void 0&&(J=!0);var H="",G,fe,pe,ke,Te,Me,Be,ge,Se,ye,Oe,Ne,Je,$e,He,We,je,Ge,ue,Ce=Y.length;for(G=0;G<Ce;G++){if(ye=Y[G],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ye.type]&&(ue=this.options.extensions.renderers[ye.type].call({parser:this},ye),ue!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ye.type))){H+=ue||"";continue}switch(ye.type){case"space":continue;case"hr":{H+=this.renderer.hr();continue}case"heading":{H+=this.renderer.heading(this.parseInline(ye.tokens),ye.depth,y(this.parseInline(ye.tokens,this.textRenderer)),this.slugger);continue}case"code":{H+=this.renderer.code(ye.text,ye.lang,ye.escaped);continue}case"table":{for(ge="",Be="",ke=ye.header.length,fe=0;fe<ke;fe++)Be+=this.renderer.tablecell(this.parseInline(ye.header[fe].tokens),{header:!0,align:ye.align[fe]});for(ge+=this.renderer.tablerow(Be),Se="",ke=ye.rows.length,fe=0;fe<ke;fe++){for(Me=ye.rows[fe],Be="",Te=Me.length,pe=0;pe<Te;pe++)Be+=this.renderer.tablecell(this.parseInline(Me[pe].tokens),{header:!1,align:ye.align[pe]});Se+=this.renderer.tablerow(Be)}H+=this.renderer.table(ge,Se);continue}case"blockquote":{Se=this.parse(ye.tokens),H+=this.renderer.blockquote(Se);continue}case"list":{for(Oe=ye.ordered,Ne=ye.start,Je=ye.loose,ke=ye.items.length,Se="",fe=0;fe<ke;fe++)He=ye.items[fe],We=He.checked,je=He.task,$e="",He.task&&(Ge=this.renderer.checkbox(We),Je?He.tokens.length>0&&He.tokens[0].type==="paragraph"?(He.tokens[0].text=Ge+" "+He.tokens[0].text,He.tokens[0].tokens&&He.tokens[0].tokens.length>0&&He.tokens[0].tokens[0].type==="text"&&(He.tokens[0].tokens[0].text=Ge+" "+He.tokens[0].tokens[0].text)):He.tokens.unshift({type:"text",text:Ge}):$e+=Ge),$e+=this.parse(He.tokens,Je),Se+=this.renderer.listitem($e,je,We);H+=this.renderer.list(Se,Oe,Ne);continue}case"html":{H+=this.renderer.html(ye.text);continue}case"paragraph":{H+=this.renderer.paragraph(this.parseInline(ye.tokens));continue}case"text":{for(Se=ye.tokens?this.parseInline(ye.tokens):ye.text;G+1<Ce&&Y[G+1].type==="text";)ye=Y[++G],Se+=`
`+(ye.tokens?this.parseInline(ye.tokens):ye.text);H+=J?this.renderer.paragraph(Se):Se;continue}default:{var Pe='Token with "'+ye.type+'" type was not found.';if(this.options.silent){console.error(Pe);return}else throw new Error(Pe)}}}return H},le.parseInline=function(Y,J){J=J||this.renderer;var H="",G,fe,pe,ke=Y.length;for(G=0;G<ke;G++){if(fe=Y[G],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[fe.type]&&(pe=this.options.extensions.renderers[fe.type].call({parser:this},fe),pe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(fe.type))){H+=pe||"";continue}switch(fe.type){case"escape":{H+=J.text(fe.text);break}case"html":{H+=J.html(fe.text);break}case"link":{H+=J.link(fe.href,fe.title,this.parseInline(fe.tokens,J));break}case"image":{H+=J.image(fe.href,fe.title,fe.text);break}case"strong":{H+=J.strong(this.parseInline(fe.tokens,J));break}case"em":{H+=J.em(this.parseInline(fe.tokens,J));break}case"codespan":{H+=J.codespan(fe.text);break}case"br":{H+=J.br();break}case"del":{H+=J.del(this.parseInline(fe.tokens,J));break}case"text":{H+=J.text(fe.text);break}default:{var Te='Token with "'+fe.type+'" type was not found.';if(this.options.silent){console.error(Te);return}else throw new Error(Te)}}}return H},te}();function X(te,le,de){if(typeof te=="undefined"||te===null)throw new Error("marked(): input parameter is undefined or null");if(typeof te!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(te)+", string expected");if(typeof le=="function"&&(de=le,le=null),le=c({},X.defaults,le||{}),M(le),de){var Y=le.highlight,J;try{J=x.lex(te,le)}catch(pe){return de(pe)}var H=function(ke){var Te;if(!ke)try{le.walkTokens&&X.walkTokens(J,le.walkTokens),Te=V.parse(J,le)}catch(Me){ke=Me}return le.highlight=Y,ke?de(ke):de(null,Te)};if(!Y||Y.length<3||(delete le.highlight,!J.length))return H();var G=0;X.walkTokens(J,function(pe){pe.type==="code"&&(G++,setTimeout(function(){Y(pe.text,pe.lang,function(ke,Te){if(ke)return H(ke);Te!=null&&Te!==pe.text&&(pe.text=Te,pe.escaped=!0),G--,G===0&&H()})},0))}),G===0&&H();return}try{var fe=x.lex(te,le);return le.walkTokens&&X.walkTokens(fe,le.walkTokens),V.parse(fe,le)}catch(pe){if(pe.message+=`
Please report this to https://github.com/markedjs/marked.`,le.silent)return"<p>An error occurred:</p><pre>"+d(pe.message+"",!0)+"</pre>";throw pe}}X.options=X.setOptions=function(te){return c(X.defaults,te),w(X.defaults),X},X.getDefaults=k,X.defaults=oe.defaults,X.use=function(){for(var te=arguments.length,le=new Array(te),de=0;de<te;de++)le[de]=arguments[de];var Y=c.apply(void 0,[{}].concat(le)),J=X.defaults.extensions||{renderers:{},childTokens:{}},H;le.forEach(function(G){if(G.extensions&&(H=!0,G.extensions.forEach(function(pe){if(!pe.name)throw new Error("extension name required");if(pe.renderer){var ke=J.renderers?J.renderers[pe.name]:null;ke?J.renderers[pe.name]=function(){for(var Te=arguments.length,Me=new Array(Te),Be=0;Be<Te;Be++)Me[Be]=arguments[Be];var ge=pe.renderer.apply(this,Me);return ge===!1&&(ge=ke.apply(this,Me)),ge}:J.renderers[pe.name]=pe.renderer}if(pe.tokenizer){if(!pe.level||pe.level!=="block"&&pe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");J[pe.level]?J[pe.level].unshift(pe.tokenizer):J[pe.level]=[pe.tokenizer],pe.start&&(pe.level==="block"?J.startBlock?J.startBlock.push(pe.start):J.startBlock=[pe.start]:pe.level==="inline"&&(J.startInline?J.startInline.push(pe.start):J.startInline=[pe.start]))}pe.childTokens&&(J.childTokens[pe.name]=pe.childTokens)})),G.renderer&&function(){var pe=X.defaults.renderer||new z,ke=function(Be){var ge=pe[Be];pe[Be]=function(){for(var Se=arguments.length,ye=new Array(Se),Oe=0;Oe<Se;Oe++)ye[Oe]=arguments[Oe];var Ne=G.renderer[Be].apply(pe,ye);return Ne===!1&&(Ne=ge.apply(pe,ye)),Ne}};for(var Te in G.renderer)ke(Te);Y.renderer=pe}(),G.tokenizer&&function(){var pe=X.defaults.tokenizer||new q,ke=function(Be){var ge=pe[Be];pe[Be]=function(){for(var Se=arguments.length,ye=new Array(Se),Oe=0;Oe<Se;Oe++)ye[Oe]=arguments[Oe];var Ne=G.tokenizer[Be].apply(pe,ye);return Ne===!1&&(Ne=ge.apply(pe,ye)),Ne}};for(var Te in G.tokenizer)ke(Te);Y.tokenizer=pe}(),G.walkTokens){var fe=X.defaults.walkTokens;Y.walkTokens=function(pe){G.walkTokens.call(this,pe),fe&&fe.call(this,pe)}}H&&(Y.extensions=J),X.setOptions(Y)})},X.walkTokens=function(te,le){for(var de=function(){var G=J.value;switch(le.call(X,G),G.type){case"table":{for(var fe=P(G.header),pe;!(pe=fe()).done;){var ke=pe.value;X.walkTokens(ke.tokens,le)}for(var Te=P(G.rows),Me;!(Me=Te()).done;)for(var Be=Me.value,ge=P(Be),Se;!(Se=ge()).done;){var ye=Se.value;X.walkTokens(ye.tokens,le)}break}case"list":{X.walkTokens(G.items,le);break}default:X.defaults.extensions&&X.defaults.extensions.childTokens&&X.defaults.extensions.childTokens[G.type]?X.defaults.extensions.childTokens[G.type].forEach(function(Oe){X.walkTokens(G[Oe],le)}):G.tokens&&X.walkTokens(G.tokens,le)}},Y=P(te),J;!(J=Y()).done;)de()},X.parseInline=function(te,le){if(typeof te=="undefined"||te===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof te!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(te)+", string expected");le=c({},X.defaults,le||{}),M(le);try{var de=x.lexInline(te,le);return le.walkTokens&&X.walkTokens(de,le.walkTokens),V.parseInline(de,le)}catch(Y){if(Y.message+=`
Please report this to https://github.com/markedjs/marked.`,le.silent)return"<p>An error occurred:</p><pre>"+d(Y.message+"",!0)+"</pre>";throw Y}},X.Parser=V,X.parser=V.parse,X.Renderer=z,X.TextRenderer=W,X.Lexer=x,X.lexer=x.lex,X.Tokenizer=q,X.Slugger=re,X.parse=X;var ae=X.options,ie=X.setOptions,O=X.use,B=X.walkTokens,ee=X.parseInline,ce=X,K=V.parse,he=x.lex;oe.Lexer=x,oe.Parser=V,oe.Renderer=z,oe.Slugger=re,oe.TextRenderer=W,oe.Tokenizer=q,oe.getDefaults=k,oe.lexer=he,oe.marked=X,oe.options=ae,oe.parse=ce,oe.parseInline=ee,oe.parser=K,oe.setOptions=ie,oe.use=O,oe.walkTokens=B,Object.defineProperty(oe,"__esModule",{value:!0})}),function(){function oe(v){const P=[];typeof v=="number"&&P.push("code/timeOrigin",v);function k(p){P.push(p,Date.now())}function w(){const p=[];for(let D=0;D<P.length;D+=2)p.push({name:P[D],startTime:P[D+1]});return p}return{mark:k,getMarks:w}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?oe():{mark(v){performance.mark(v)},getMarks(){let v=performance.timeOrigin;typeof v!="number"&&(v=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const P=[{name:"code/timeOrigin",startTime:Math.round(v)}];for(const k of performance.getEntriesByType("mark"))P.push({name:k.name,startTime:Math.round(v+k.startTime)});return P}};if(typeof process=="object"){const v=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return oe(v)}else return console.trace("perf-util loaded in UNKNOWN environment"),oe()}function I(v){return v.MonacoPerformanceMarks||(v.MonacoPerformanceMarks=e()),v.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return I(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=I(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=I(t))}(),function(oe,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var I=e();for(var t in I)(typeof exports=="object"?exports:oe)[t]=I[t]}}(typeof self!="undefined"?self:this,function(){return function(oe){var e={};function I(t){if(e[t])return e[t].exports;var v=e[t]={i:t,l:!1,exports:{}};return oe[t].call(v.exports,v,v.exports,I),v.l=!0,v.exports}return I.m=oe,I.c=e,I.d=function(t,v,P){I.o(t,v)||Object.defineProperty(t,v,{enumerable:!0,get:P})},I.r=function(t){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},I.t=function(t,v){if(1&v&&(t=I(t)),8&v||4&v&&typeof t=="object"&&t&&t.__esModule)return t;var P=Object.create(null);if(I.r(P),Object.defineProperty(P,"default",{enumerable:!0,value:t}),2&v&&typeof t!="string")for(var k in t)I.d(P,k,function(w){return t[w]}.bind(null,k));return P},I.n=function(t){var v=t&&t.__esModule?function(){return t.default}:function(){return t};return I.d(v,"a",v),v},I.o=function(t,v){return Object.prototype.hasOwnProperty.call(t,v)},I.p="",I(I.s=0)}([function(oe,e,I){(function(t){var v;e=oe.exports=O,v=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var ge=Array.prototype.slice.call(arguments,0);ge.unshift("SEMVER"),console.log.apply(console,ge)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var P=256,k=Number.MAX_SAFE_INTEGER||9007199254740991,w=e.re=[],p=e.src=[],D=0,T=D++;p[T]="0|[1-9]\\d*";var R=D++;p[R]="[0-9]+";var E=D++;p[E]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var b=D++;p[b]="("+p[T]+")\\.("+p[T]+")\\.("+p[T]+")";var d=D++;p[d]="("+p[R]+")\\.("+p[R]+")\\.("+p[R]+")";var C=D++;p[C]="(?:"+p[T]+"|"+p[E]+")";var y=D++;p[y]="(?:"+p[R]+"|"+p[E]+")";var m=D++;p[m]="(?:-("+p[C]+"(?:\\."+p[C]+")*))";var g=D++;p[g]="(?:-?("+p[y]+"(?:\\."+p[y]+")*))";var h=D++;p[h]="[0-9A-Za-z-]+";var l=D++;p[l]="(?:\\+("+p[h]+"(?:\\."+p[h]+")*))";var f=D++,i="v?"+p[b]+p[m]+"?"+p[l]+"?";p[f]="^"+i+"$";var a="[v=\\s]*"+p[d]+p[g]+"?"+p[l]+"?",n=D++;p[n]="^"+a+"$";var o=D++;p[o]="((?:<|>)?=?)";var r=D++;p[r]=p[R]+"|x|X|\\*";var s=D++;p[s]=p[T]+"|x|X|\\*";var c=D++;p[c]="[v=\\s]*("+p[s]+")(?:\\.("+p[s]+")(?:\\.("+p[s]+")(?:"+p[m]+")?"+p[l]+"?)?)?";var u=D++;p[u]="[v=\\s]*("+p[r]+")(?:\\.("+p[r]+")(?:\\.("+p[r]+")(?:"+p[g]+")?"+p[l]+"?)?)?";var S=D++;p[S]="^"+p[o]+"\\s*"+p[c]+"$";var A=D++;p[A]="^"+p[o]+"\\s*"+p[u]+"$";var M=D++;p[M]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var $=D++;p[$]="(?:~>?)";var Q=D++;p[Q]="(\\s*)"+p[$]+"\\s+",w[Q]=new RegExp(p[Q],"g");var _=D++;p[_]="^"+p[$]+p[c]+"$";var q=D++;p[q]="^"+p[$]+p[u]+"$";var U=D++;p[U]="(?:\\^)";var ne=D++;p[ne]="(\\s*)"+p[U]+"\\s+",w[ne]=new RegExp(p[ne],"g");var Z=D++;p[Z]="^"+p[U]+p[c]+"$";var F=D++;p[F]="^"+p[U]+p[u]+"$";var x=D++;p[x]="^"+p[o]+"\\s*("+a+")$|^$";var z=D++;p[z]="^"+p[o]+"\\s*("+i+")$|^$";var W=D++;p[W]="(\\s*)"+p[o]+"\\s*("+a+"|"+p[c]+")",w[W]=new RegExp(p[W],"g");var re=D++;p[re]="^\\s*("+p[c]+")\\s+-\\s+("+p[c]+")\\s*$";var V=D++;p[V]="^\\s*("+p[u]+")\\s+-\\s+("+p[u]+")\\s*$";var X=D++;p[X]="(<|>)?=?\\s*\\*";for(var ae=0;ae<35;ae++)v(ae,p[ae]),w[ae]||(w[ae]=new RegExp(p[ae]));function ie(ge,Se){if(ge instanceof O)return ge;if(typeof ge!="string"||ge.length>P||!(Se?w[n]:w[f]).test(ge))return null;try{return new O(ge,Se)}catch{return null}}function O(ge,Se){if(ge instanceof O){if(ge.loose===Se)return ge;ge=ge.version}else if(typeof ge!="string")throw new TypeError("Invalid Version: "+ge);if(ge.length>P)throw new TypeError("version is longer than "+P+" characters");if(!(this instanceof O))return new O(ge,Se);v("SemVer",ge,Se),this.loose=Se;var ye=ge.trim().match(Se?w[n]:w[f]);if(!ye)throw new TypeError("Invalid Version: "+ge);if(this.raw=ge,this.major=+ye[1],this.minor=+ye[2],this.patch=+ye[3],this.major>k||this.major<0)throw new TypeError("Invalid major version");if(this.minor>k||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>k||this.patch<0)throw new TypeError("Invalid patch version");ye[4]?this.prerelease=ye[4].split(".").map(function(Oe){if(/^[0-9]+$/.test(Oe)){var Ne=+Oe;if(Ne>=0&&Ne<k)return Ne}return Oe}):this.prerelease=[],this.build=ye[5]?ye[5].split("."):[],this.format()}e.parse=ie,e.valid=function(ge,Se){var ye=ie(ge,Se);return ye?ye.version:null},e.clean=function(ge,Se){var ye=ie(ge.trim().replace(/^[=v]+/,""),Se);return ye?ye.version:null},e.SemVer=O,O.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},O.prototype.toString=function(){return this.version},O.prototype.compare=function(ge){return v("SemVer.compare",this.version,this.loose,ge),ge instanceof O||(ge=new O(ge,this.loose)),this.compareMain(ge)||this.comparePre(ge)},O.prototype.compareMain=function(ge){return ge instanceof O||(ge=new O(ge,this.loose)),ee(this.major,ge.major)||ee(this.minor,ge.minor)||ee(this.patch,ge.patch)},O.prototype.comparePre=function(ge){if(ge instanceof O||(ge=new O(ge,this.loose)),this.prerelease.length&&!ge.prerelease.length)return-1;if(!this.prerelease.length&&ge.prerelease.length)return 1;if(!this.prerelease.length&&!ge.prerelease.length)return 0;var Se=0;do{var ye=this.prerelease[Se],Oe=ge.prerelease[Se];if(v("prerelease compare",Se,ye,Oe),ye===void 0&&Oe===void 0)return 0;if(Oe===void 0)return 1;if(ye===void 0)return-1;if(ye!==Oe)return ee(ye,Oe)}while(++Se)},O.prototype.inc=function(ge,Se){switch(ge){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Se);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Se);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Se),this.inc("pre",Se);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Se),this.inc("pre",Se);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ye=this.prerelease.length;--ye>=0;)typeof this.prerelease[ye]=="number"&&(this.prerelease[ye]++,ye=-2);ye===-1&&this.prerelease.push(0)}Se&&(this.prerelease[0]===Se?isNaN(this.prerelease[1])&&(this.prerelease=[Se,0]):this.prerelease=[Se,0]);break;default:throw new Error("invalid increment argument: "+ge)}return this.format(),this.raw=this.version,this},e.inc=function(ge,Se,ye,Oe){typeof ye=="string"&&(Oe=ye,ye=void 0);try{return new O(ge,ye).inc(Se,Oe).version}catch{return null}},e.diff=function(ge,Se){if(te(ge,Se))return null;var ye=ie(ge),Oe=ie(Se);if(ye.prerelease.length||Oe.prerelease.length){for(var Ne in ye)if((Ne==="major"||Ne==="minor"||Ne==="patch")&&ye[Ne]!==Oe[Ne])return"pre"+Ne;return"prerelease"}for(var Ne in ye)if((Ne==="major"||Ne==="minor"||Ne==="patch")&&ye[Ne]!==Oe[Ne])return Ne},e.compareIdentifiers=ee;var B=/^[0-9]+$/;function ee(ge,Se){var ye=B.test(ge),Oe=B.test(Se);return ye&&Oe&&(ge=+ge,Se=+Se),ye&&!Oe?-1:Oe&&!ye?1:ge<Se?-1:ge>Se?1:0}function ce(ge,Se,ye){return new O(ge,ye).compare(new O(Se,ye))}function K(ge,Se,ye){return ce(ge,Se,ye)>0}function he(ge,Se,ye){return ce(ge,Se,ye)<0}function te(ge,Se,ye){return ce(ge,Se,ye)===0}function le(ge,Se,ye){return ce(ge,Se,ye)!==0}function de(ge,Se,ye){return ce(ge,Se,ye)>=0}function Y(ge,Se,ye){return ce(ge,Se,ye)<=0}function J(ge,Se,ye,Oe){var Ne;switch(Se){case"===":typeof ge=="object"&&(ge=ge.version),typeof ye=="object"&&(ye=ye.version),Ne=ge===ye;break;case"!==":typeof ge=="object"&&(ge=ge.version),typeof ye=="object"&&(ye=ye.version),Ne=ge!==ye;break;case"":case"=":case"==":Ne=te(ge,ye,Oe);break;case"!=":Ne=le(ge,ye,Oe);break;case">":Ne=K(ge,ye,Oe);break;case">=":Ne=de(ge,ye,Oe);break;case"<":Ne=he(ge,ye,Oe);break;case"<=":Ne=Y(ge,ye,Oe);break;default:throw new TypeError("Invalid operator: "+Se)}return Ne}function H(ge,Se){if(ge instanceof H){if(ge.loose===Se)return ge;ge=ge.value}if(!(this instanceof H))return new H(ge,Se);v("comparator",ge,Se),this.loose=Se,this.parse(ge),this.semver===G?this.value="":this.value=this.operator+this.semver.version,v("comp",this)}e.rcompareIdentifiers=function(ge,Se){return ee(Se,ge)},e.major=function(ge,Se){return new O(ge,Se).major},e.minor=function(ge,Se){return new O(ge,Se).minor},e.patch=function(ge,Se){return new O(ge,Se).patch},e.compare=ce,e.compareLoose=function(ge,Se){return ce(ge,Se,!0)},e.rcompare=function(ge,Se,ye){return ce(Se,ge,ye)},e.sort=function(ge,Se){return ge.sort(function(ye,Oe){return e.compare(ye,Oe,Se)})},e.rsort=function(ge,Se){return ge.sort(function(ye,Oe){return e.rcompare(ye,Oe,Se)})},e.gt=K,e.lt=he,e.eq=te,e.neq=le,e.gte=de,e.lte=Y,e.cmp=J,e.Comparator=H;var G={};function fe(ge,Se){if(ge instanceof fe)return ge.loose===Se?ge:new fe(ge.raw,Se);if(ge instanceof H)return new fe(ge.value,Se);if(!(this instanceof fe))return new fe(ge,Se);if(this.loose=Se,this.raw=ge,this.set=ge.split(/\s*\|\|\s*/).map(function(ye){return this.parseRange(ye.trim())},this).filter(function(ye){return ye.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ge);this.format()}function pe(ge){return!ge||ge.toLowerCase()==="x"||ge==="*"}function ke(ge,Se,ye,Oe,Ne,Je,$e,He,We,je,Ge,ue,Ce){return((Se=pe(ye)?"":pe(Oe)?">="+ye+".0.0":pe(Ne)?">="+ye+"."+Oe+".0":">="+Se)+" "+(He=pe(We)?"":pe(je)?"<"+(+We+1)+".0.0":pe(Ge)?"<"+We+"."+(+je+1)+".0":ue?"<="+We+"."+je+"."+Ge+"-"+ue:"<="+He)).trim()}function Te(ge,Se){for(var ye=0;ye<ge.length;ye++)if(!ge[ye].test(Se))return!1;if(Se.prerelease.length){for(ye=0;ye<ge.length;ye++)if(v(ge[ye].semver),ge[ye].semver!==G&&ge[ye].semver.prerelease.length>0){var Oe=ge[ye].semver;if(Oe.major===Se.major&&Oe.minor===Se.minor&&Oe.patch===Se.patch)return!0}return!1}return!0}function Me(ge,Se,ye){try{Se=new fe(Se,ye)}catch{return!1}return Se.test(ge)}function Be(ge,Se,ye,Oe){var Ne,Je,$e,He,We;switch(ge=new O(ge,Oe),Se=new fe(Se,Oe),ye){case">":Ne=K,Je=Y,$e=he,He=">",We=">=";break;case"<":Ne=he,Je=de,$e=K,He="<",We="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Me(ge,Se,Oe))return!1;for(var je=0;je<Se.set.length;++je){var Ge=Se.set[je],ue=null,Ce=null;if(Ge.forEach(function(Pe){Pe.semver===G&&(Pe=new H(">=0.0.0")),ue=ue||Pe,Ce=Ce||Pe,Ne(Pe.semver,ue.semver,Oe)?ue=Pe:$e(Pe.semver,Ce.semver,Oe)&&(Ce=Pe)}),ue.operator===He||ue.operator===We||(!Ce.operator||Ce.operator===He)&&Je(ge,Ce.semver)||Ce.operator===We&&$e(ge,Ce.semver))return!1}return!0}H.prototype.parse=function(ge){var Se=this.loose?w[x]:w[z],ye=ge.match(Se);if(!ye)throw new TypeError("Invalid comparator: "+ge);this.operator=ye[1],this.operator==="="&&(this.operator=""),ye[2]?this.semver=new O(ye[2],this.loose):this.semver=G},H.prototype.toString=function(){return this.value},H.prototype.test=function(ge){return v("Comparator.test",ge,this.loose),this.semver===G||(typeof ge=="string"&&(ge=new O(ge,this.loose)),J(ge,this.operator,this.semver,this.loose))},H.prototype.intersects=function(ge,Se){if(!(ge instanceof H))throw new TypeError("a Comparator is required");var ye;if(this.operator==="")return ye=new fe(ge.value,Se),Me(this.value,ye,Se);if(ge.operator==="")return ye=new fe(this.value,Se),Me(ge.semver,ye,Se);var Oe=!(this.operator!==">="&&this.operator!==">"||ge.operator!==">="&&ge.operator!==">"),Ne=!(this.operator!=="<="&&this.operator!=="<"||ge.operator!=="<="&&ge.operator!=="<"),Je=this.semver.version===ge.semver.version,$e=!(this.operator!==">="&&this.operator!=="<="||ge.operator!==">="&&ge.operator!=="<="),He=J(this.semver,"<",ge.semver,Se)&&(this.operator===">="||this.operator===">")&&(ge.operator==="<="||ge.operator==="<"),We=J(this.semver,">",ge.semver,Se)&&(this.operator==="<="||this.operator==="<")&&(ge.operator===">="||ge.operator===">");return Oe||Ne||Je&&$e||He||We},e.Range=fe,fe.prototype.format=function(){return this.range=this.set.map(function(ge){return ge.join(" ").trim()}).join("||").trim(),this.range},fe.prototype.toString=function(){return this.range},fe.prototype.parseRange=function(ge){var Se=this.loose;ge=ge.trim(),v("range",ge,Se);var ye=Se?w[V]:w[re];ge=ge.replace(ye,ke),v("hyphen replace",ge),ge=ge.replace(w[W],"$1$2$3"),v("comparator trim",ge,w[W]),ge=(ge=(ge=ge.replace(w[Q],"$1~")).replace(w[ne],"$1^")).split(/\s+/).join(" ");var Oe=Se?w[x]:w[z],Ne=ge.split(" ").map(function(Je){return function($e,He){return v("comp",$e),$e=function(We,je){return We.trim().split(/\s+/).map(function(Ge){return function(ue,Ce){v("caret",ue,Ce);var Pe=Ce?w[F]:w[Z];return ue.replace(Pe,function(Ae,Le,Ue,Ve,Ke){var et;return v("caret",ue,Ae,Le,Ue,Ve,Ke),pe(Le)?et="":pe(Ue)?et=">="+Le+".0.0 <"+(+Le+1)+".0.0":pe(Ve)?et=Le==="0"?">="+Le+"."+Ue+".0 <"+Le+"."+(+Ue+1)+".0":">="+Le+"."+Ue+".0 <"+(+Le+1)+".0.0":Ke?(v("replaceCaret pr",Ke),Ke.charAt(0)!=="-"&&(Ke="-"+Ke),et=Le==="0"?Ue==="0"?">="+Le+"."+Ue+"."+Ve+Ke+" <"+Le+"."+Ue+"."+(+Ve+1):">="+Le+"."+Ue+"."+Ve+Ke+" <"+Le+"."+(+Ue+1)+".0":">="+Le+"."+Ue+"."+Ve+Ke+" <"+(+Le+1)+".0.0"):(v("no pr"),et=Le==="0"?Ue==="0"?">="+Le+"."+Ue+"."+Ve+" <"+Le+"."+Ue+"."+(+Ve+1):">="+Le+"."+Ue+"."+Ve+" <"+Le+"."+(+Ue+1)+".0":">="+Le+"."+Ue+"."+Ve+" <"+(+Le+1)+".0.0"),v("caret return",et),et})}(Ge,je)}).join(" ")}($e,He),v("caret",$e),$e=function(We,je){return We.trim().split(/\s+/).map(function(Ge){return function(ue,Ce){var Pe=Ce?w[q]:w[_];return ue.replace(Pe,function(Ae,Le,Ue,Ve,Ke){var et;return v("tilde",ue,Ae,Le,Ue,Ve,Ke),pe(Le)?et="":pe(Ue)?et=">="+Le+".0.0 <"+(+Le+1)+".0.0":pe(Ve)?et=">="+Le+"."+Ue+".0 <"+Le+"."+(+Ue+1)+".0":Ke?(v("replaceTilde pr",Ke),Ke.charAt(0)!=="-"&&(Ke="-"+Ke),et=">="+Le+"."+Ue+"."+Ve+Ke+" <"+Le+"."+(+Ue+1)+".0"):et=">="+Le+"."+Ue+"."+Ve+" <"+Le+"."+(+Ue+1)+".0",v("tilde return",et),et})}(Ge,je)}).join(" ")}($e,He),v("tildes",$e),$e=function(We,je){return v("replaceXRanges",We,je),We.split(/\s+/).map(function(Ge){return function(ue,Ce){ue=ue.trim();var Pe=Ce?w[A]:w[S];return ue.replace(Pe,function(Ae,Le,Ue,Ve,Ke,et){v("xRange",ue,Ae,Le,Ue,Ve,Ke,et);var nt=pe(Ue),it=nt||pe(Ve),rt=it||pe(Ke);return Le==="="&&rt&&(Le=""),nt?Ae=Le===">"||Le==="<"?"<0.0.0":"*":Le&&rt?(it&&(Ve=0),rt&&(Ke=0),Le===">"?(Le=">=",it?(Ue=+Ue+1,Ve=0,Ke=0):rt&&(Ve=+Ve+1,Ke=0)):Le==="<="&&(Le="<",it?Ue=+Ue+1:Ve=+Ve+1),Ae=Le+Ue+"."+Ve+"."+Ke):it?Ae=">="+Ue+".0.0 <"+(+Ue+1)+".0.0":rt&&(Ae=">="+Ue+"."+Ve+".0 <"+Ue+"."+(+Ve+1)+".0"),v("xRange return",Ae),Ae})}(Ge,je)}).join(" ")}($e,He),v("xrange",$e),$e=function(We,je){return v("replaceStars",We,je),We.trim().replace(w[X],"")}($e,He),v("stars",$e),$e}(Je,Se)}).join(" ").split(/\s+/);return this.loose&&(Ne=Ne.filter(function(Je){return!!Je.match(Oe)})),Ne=Ne.map(function(Je){return new H(Je,Se)})},fe.prototype.intersects=function(ge,Se){if(!(ge instanceof fe))throw new TypeError("a Range is required");return this.set.some(function(ye){return ye.every(function(Oe){return ge.set.some(function(Ne){return Ne.every(function(Je){return Oe.intersects(Je,Se)})})})})},e.toComparators=function(ge,Se){return new fe(ge,Se).set.map(function(ye){return ye.map(function(Oe){return Oe.value}).join(" ").trim().split(" ")})},fe.prototype.test=function(ge){if(!ge)return!1;typeof ge=="string"&&(ge=new O(ge,this.loose));for(var Se=0;Se<this.set.length;Se++)if(Te(this.set[Se],ge))return!0;return!1},e.satisfies=Me,e.maxSatisfying=function(ge,Se,ye){var Oe=null,Ne=null;try{var Je=new fe(Se,ye)}catch{return null}return ge.forEach(function($e){Je.test($e)&&(Oe&&Ne.compare($e)!==-1||(Ne=new O(Oe=$e,ye)))}),Oe},e.minSatisfying=function(ge,Se,ye){var Oe=null,Ne=null;try{var Je=new fe(Se,ye)}catch{return null}return ge.forEach(function($e){Je.test($e)&&(Oe&&Ne.compare($e)!==1||(Ne=new O(Oe=$e,ye)))}),Oe},e.validRange=function(ge,Se){try{return new fe(ge,Se).range||"*"}catch{return null}},e.ltr=function(ge,Se,ye){return Be(ge,Se,"<",ye)},e.gtr=function(ge,Se,ye){return Be(ge,Se,">",ye)},e.outside=Be,e.prerelease=function(ge,Se){var ye=ie(ge,Se);return ye&&ye.prerelease.length?ye.prerelease:null},e.intersects=function(ge,Se,ye){return ge=new fe(ge,ye),Se=new fe(Se,ye),ge.intersects(Se)},e.coerce=function(ge){if(ge instanceof O)return ge;if(typeof ge!="string")return null;var Se=ge.match(w[M]);return Se==null?null:ie((Se[1]||"0")+"."+(Se[2]||"0")+"."+(Se[3]||"0"))}}).call(this,I(1))},function(oe,e){var I,t,v=oe.exports={};function P(){throw new Error("setTimeout has not been defined")}function k(){throw new Error("clearTimeout has not been defined")}function w(y){if(I===setTimeout)return setTimeout(y,0);if((I===P||!I)&&setTimeout)return I=setTimeout,setTimeout(y,0);try{return I(y,0)}catch{try{return I.call(null,y,0)}catch{return I.call(this,y,0)}}}(function(){try{I=typeof setTimeout=="function"?setTimeout:P}catch{I=P}try{t=typeof clearTimeout=="function"?clearTimeout:k}catch{t=k}})();var p,D=[],T=!1,R=-1;function E(){T&&p&&(T=!1,p.length?D=p.concat(D):R=-1,D.length&&b())}function b(){if(!T){var y=w(E);T=!0;for(var m=D.length;m;){for(p=D,D=[];++R<m;)p&&p[R].run();R=-1,m=D.length}p=null,T=!1,function(g){if(t===clearTimeout)return clearTimeout(g);if((t===k||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(g);try{t(g)}catch{try{return t.call(null,g)}catch{return t.call(this,g)}}}(y)}}function d(y,m){this.fun=y,this.array=m}function C(){}v.nextTick=function(y){var m=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)m[g-1]=arguments[g];D.push(new d(y,m)),D.length!==1||T||w(b)},d.prototype.run=function(){this.fun.apply(null,this.array)},v.title="browser",v.browser=!0,v.env={},v.argv=[],v.version="",v.versions={},v.on=C,v.addListener=C,v.once=C,v.off=C,v.removeListener=C,v.removeAllListeners=C,v.emit=C,v.prependListener=C,v.prependOnceListener=C,v.listeners=function(y){return[]},v.binding=function(y){throw new Error("process.binding is not supported")},v.cwd=function(){return"/"},v.chdir=function(y){throw new Error("process.chdir is not supported")},v.umask=function(){return 0}}])}),define(ve[134],we([0,1]),function(oe,e){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class t{constructor(w,p,D){this.level=w,this.key=p,this.value=D,this.forward=[]}}const v=void 0;class P{constructor(w,p=2**16){this.comparator=w,this[I]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(p)|0),this._header=new t(this._maxLevel,v,v)}get size(){return this._size}clear(){this._header=new t(this._maxLevel,v,v)}has(w){return Boolean(P._search(this,w,this.comparator))}get(w){return P._search(this,w,this.comparator)?.value}set(w,p){return P._insert(this,w,p,this.comparator)&&(this._size+=1),this}delete(w){const p=P._delete(this,w,this.comparator);return p&&(this._size-=1),p}forEach(w,p){let D=this._header.forward[0];for(;D;)w.call(p,D.value,D.key,this),D=D.forward[0]}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let w=this._header.forward[0];for(;w;)yield[w.key,w.value],w=w.forward[0]}*keys(){let w=this._header.forward[0];for(;w;)yield w.key,w=w.forward[0]}*values(){let w=this._header.forward[0];for(;w;)yield w.value,w=w.forward[0]}toString(){let w="[SkipList]:",p=this._header.forward[0];for(;p;)w+=`node(${p.key}, ${p.value}, lvl:${p.level})`,p=p.forward[0];return w}static _search(w,p,D){let T=w._header;for(let R=w._level-1;R>=0;R--)for(;T.forward[R]&&D(T.forward[R].key,p)<0;)T=T.forward[R];if(T=T.forward[0],T&&D(T.key,p)===0)return T}static _insert(w,p,D,T){const R=[];let E=w._header;for(let b=w._level-1;b>=0;b--){for(;E.forward[b]&&T(E.forward[b].key,p)<0;)E=E.forward[b];R[b]=E}if(E=E.forward[0],E&&T(E.key,p)===0)return E.value=D,!1;{const b=P._randomLevel(w);if(b>w._level){for(let d=w._level;d<b;d++)R[d]=w._header;w._level=b}E=new t(b,p,D);for(let d=0;d<b;d++)E.forward[d]=R[d].forward[d],R[d].forward[d]=E;return!0}}static _randomLevel(w,p=.5){let D=1;for(;Math.random()<p&&D<w._maxLevel;)D+=1;return D}static _delete(w,p,D){const T=[];let R=w._header;for(let E=w._level-1;E>=0;E--){for(;R.forward[E]&&D(R.forward[E].key,p)<0;)R=R.forward[E];T[E]=R}if(R=R.forward[0],!R||D(R.key,p)!==0)return!1;for(let E=0;E<w._level&&T[E].forward[E]===R;E++)T[E].forward[E]=R.forward[E];for(;w._level>0&&w._header.forward[w._level-1]===v;)w._level-=1;return!0}}e.SkipList=P}),define(ve[48],we([0,1,11,2]),function(oe,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function v(l){const f=l;return f?typeof f.read=="function":!1}e.isReadable=v;function P(l){const f=l;return f?[f.on,f.pause,f.resume,f.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=P;function k(l){const f=l;return f?P(f.stream)&&Array.isArray(f.buffer)&&typeof f.ended=="boolean":!1}e.isReadableBufferedStream=k;function w(l,f){return new p(l,f)}e.newWriteableStream=w;class p{constructor(f,i){this.reducer=f,this.options=i,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(f){if(!this.state.destroyed){if(this.state.flowing)this.emitData(f);else if(this.buffer.data.push(f),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(i=>this.pendingWritePromises.push(i))}}error(f){this.state.destroyed||(this.state.flowing?this.emitError(f):this.buffer.error.push(f))}end(f){this.state.destroyed||(typeof f!="undefined"&&this.write(f),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(f){this.listeners.data.slice(0).forEach(i=>i(f))}emitError(f){this.listeners.error.length===0?(0,I.onUnexpectedError)(f):this.listeners.error.slice(0).forEach(i=>i(f))}emitEnd(){this.listeners.end.slice(0).forEach(f=>f())}on(f,i){if(!this.state.destroyed)switch(f){case"data":this.listeners.data.push(i),this.resume();break;case"end":this.listeners.end.push(i),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(i),this.state.flowing&&this.flowErrors();break}}removeListener(f,i){if(this.state.destroyed)return;let a;switch(f){case"data":a=this.listeners.data;break;case"end":a=this.listeners.end;break;case"error":a=this.listeners.error;break}if(a){const n=a.indexOf(i);n>=0&&a.splice(n,1)}}flowData(){if(this.buffer.data.length>0){const f=this.reducer(this.buffer.data);this.emitData(f),this.buffer.data.length=0;const i=[...this.pendingWritePromises];this.pendingWritePromises.length=0,i.forEach(a=>a())}}flowErrors(){if(this.listeners.error.length>0){for(const f of this.buffer.error)this.emitError(f);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function D(l,f){const i=[];let a;for(;(a=l.read())!==null;)i.push(a);return f(i)}e.consumeReadable=D;function T(l,f,i){const a=[];let n;for(;(n=l.read())!==null&&a.length<i;)a.push(n);return n===null&&a.length>0?f(a):{read:()=>{if(a.length>0)return a.shift();if(typeof n!="undefined"){const o=n;return n=void 0,o}return l.read()}}}e.peekReadable=T;function R(l,f){return new Promise((i,a)=>{const n=[];E(l,{onData:o=>{f&&n.push(o)},onError:o=>{f?a(o):i(void 0)},onEnd:()=>{i(f?f(n):void 0)}})})}e.consumeStream=R;function E(l,f){let i=!1;return l.on("error",a=>{i||f.onError(a)}),l.on("end",()=>{i||f.onEnd()}),l.on("data",a=>{i||f.onData(a)}),(0,t.toDisposable)(()=>i=!0)}e.listenStream=E;function b(l,f){return new Promise((i,a)=>{const n=new t.DisposableStore,o=[],r=u=>{if(o.push(u),o.length>f)return n.dispose(),l.pause(),i({stream:l,buffer:o,ended:!1})},s=u=>a(u),c=()=>i({stream:l,buffer:o,ended:!0});n.add((0,t.toDisposable)(()=>l.removeListener("error",s))),l.on("error",s),n.add((0,t.toDisposable)(()=>l.removeListener("end",c))),l.on("end",c),n.add((0,t.toDisposable)(()=>l.removeListener("data",r))),l.on("data",r)})}e.peekStream=b;function d(l,f){const i=w(f);return i.end(l),i}e.toStream=d;function C(){const l=w(()=>{throw new Error("not supported")});return l.end(),l}e.emptyStream=C;function y(l){let f=!1;return{read:()=>f?null:(f=!0,l)}}e.toReadable=y;function m(l,f,i){const a=w(i);return E(l,{onData:n=>a.write(f.data(n)),onError:n=>a.error(f.error?f.error(n):n),onEnd:()=>a.end()}),a}e.transform=m;function g(l,f,i){let a=!1;return{read:()=>{const n=f.read();return a?n:(a=!0,n!==null?i([l,n]):l)}}}e.prefixedReadable=g;function h(l,f,i){let a=!1;const n=w(i);return E(f,{onData:o=>a?n.write(o):(a=!0,n.write(i([l,o]))),onError:o=>n.error(o),onEnd:()=>{a||(a=!0,n.write(l)),n.end()}}),n}e.prefixedStream=h}),define(ve[16],we([0,1,48]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer!="undefined";let v,P;class k{constructor(u){this.buffer=u,this.byteLength=this.buffer.byteLength}static alloc(u){return t?new k(Buffer.allocUnsafe(u)):new k(new Uint8Array(u))}static wrap(u){return t&&!Buffer.isBuffer(u)&&(u=Buffer.from(u.buffer,u.byteOffset,u.byteLength)),new k(u)}static fromString(u,S){return!(S?.dontUseNodeBuffer||!1)&&t?new k(Buffer.from(u)):(v||(v=new TextEncoder),new k(v.encode(u)))}static fromByteArray(u){const S=k.alloc(u.length);for(let A=0,M=u.length;A<M;A++)S.buffer[A]=u[A];return S}static concat(u,S){if(typeof S=="undefined"){S=0;for(let $=0,Q=u.length;$<Q;$++)S+=u[$].byteLength}const A=k.alloc(S);let M=0;for(let $=0,Q=u.length;$<Q;$++){const _=u[$];A.set(_,M),M+=_.byteLength}return A}clone(){const u=k.alloc(this.byteLength);return u.set(this),u}toString(){return t?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(u,S){return new k(this.buffer.subarray(u,S))}set(u,S){if(u instanceof k)this.buffer.set(u.buffer,S);else if(u instanceof Uint8Array)this.buffer.set(u,S);else if(u instanceof ArrayBuffer)this.buffer.set(new Uint8Array(u),S);else if(ArrayBuffer.isView(u))this.buffer.set(new Uint8Array(u.buffer,u.byteOffset,u.byteLength),S);else throw new Error("Unknown argument 'array'")}readUInt32BE(u){return D(this.buffer,u)}writeUInt32BE(u,S){T(this.buffer,u,S)}readUInt32LE(u){return R(this.buffer,u)}writeUInt32LE(u,S){E(this.buffer,u,S)}readUInt8(u){return b(this.buffer,u)}writeUInt8(u,S){d(this.buffer,u,S)}}e.VSBuffer=k;function w(c,u){return c[u+0]<<0>>>0|c[u+1]<<8>>>0}e.readUInt16LE=w;function p(c,u,S){c[S+0]=u&255,u=u>>>8,c[S+1]=u&255}e.writeUInt16LE=p;function D(c,u){return c[u]*2**24+c[u+1]*2**16+c[u+2]*2**8+c[u+3]}e.readUInt32BE=D;function T(c,u,S){c[S+3]=u,u=u>>>8,c[S+2]=u,u=u>>>8,c[S+1]=u,u=u>>>8,c[S]=u}e.writeUInt32BE=T;function R(c,u){return c[u+0]<<0>>>0|c[u+1]<<8>>>0|c[u+2]<<16>>>0|c[u+3]<<24>>>0}e.readUInt32LE=R;function E(c,u,S){c[S+0]=u&255,u=u>>>8,c[S+1]=u&255,u=u>>>8,c[S+2]=u&255,u=u>>>8,c[S+3]=u&255}e.writeUInt32LE=E;function b(c,u){return c[u]}e.readUInt8=b;function d(c,u,S){c[S]=u}e.writeUInt8=d;function C(c){return I.consumeReadable(c,u=>k.concat(u))}e.readableToBuffer=C;function y(c){return I.toReadable(c)}e.bufferToReadable=y;function m(c){return I.consumeStream(c,u=>k.concat(u))}e.streamToBuffer=m;async function g(c){return c.ended?k.concat(c.buffer):k.concat([...c.buffer,await m(c.stream)])}e.bufferedStreamToBuffer=g;function h(c){return I.toStream(c,u=>k.concat(u))}e.bufferToStream=h;function l(c){return I.transform(c,{data:u=>typeof u=="string"?k.fromString(u):k.wrap(u)},u=>k.concat(u))}e.streamToBufferReadableStream=l;function f(c){return I.newWriteableStream(u=>k.concat(u),c)}e.newWriteableBufferStream=f;function i(c,u){return I.prefixedReadable(c,u,S=>k.concat(S))}e.prefixedBufferReadable=i;function a(c,u){return I.prefixedStream(c,u,S=>k.concat(S))}e.prefixedBufferStream=a;function n(c){let u=0,S=0,A=0;const M=new Uint8Array(Math.floor(c.length/4*3)),$=_=>{switch(S){case 3:M[A++]=u|_,S=0;break;case 2:M[A++]=u|_>>>2,u=_<<6,S=3;break;case 1:M[A++]=u|_>>>4,u=_<<4,S=2;break;default:u=_<<2,S=1}};for(let _=0;_<c.length;_++){const q=c.charCodeAt(_);if(q>=65&&q<=90)$(q-65);else if(q>=97&&q<=122)$(q-97+26);else if(q>=48&&q<=57)$(q-48+52);else if(q===43||q===45)$(62);else if(q===47||q===95)$(63);else{if(q===61)break;throw new SyntaxError(`Unexpected base64 character ${c[_]}`)}}const Q=A;for(;S>0;)$(0);return k.wrap(M).slice(0,Q)}e.decodeBase64=n;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function s({buffer:c},u=!0,S=!1){const A=S?r:o;let M="";const $=c.byteLength%3;let Q=0;for(;Q<c.byteLength-$;Q+=3){const _=c[Q+0],q=c[Q+1],U=c[Q+2];M+=A[_>>>2],M+=A[(_<<4|q>>>4)&63],M+=A[(q<<2|U>>>6)&63],M+=A[U&63]}if($===1){const _=c[Q+0];M+=A[_>>>2],M+=A[_<<4&63],u&&(M+="==")}else if($===2){const _=c[Q+0],q=c[Q+1];M+=A[_>>>2],M+=A[(_<<4|q>>>4)&63],M+=A[q<<2&63],u&&(M+="=")}return M}e.encodeBase64=s}),define(ve[12],we([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function I(c){return Array.isArray(c)}e.isArray=I;function t(c){return typeof c=="string"}e.isString=t;function v(c){return Array.isArray(c)&&c.every(u=>t(u))}e.isStringArray=v;function P(c){return typeof c=="object"&&c!==null&&!Array.isArray(c)&&!(c instanceof RegExp)&&!(c instanceof Date)}e.isObject=P;function k(c){return typeof c=="object"&&(c instanceof Uint8Array||c instanceof Uint16Array||c instanceof Uint32Array||c instanceof Float32Array||c instanceof Float64Array||c instanceof Int8Array||c instanceof Int16Array||c instanceof Int32Array||c instanceof BigInt64Array||c instanceof BigUint64Array||c instanceof Uint8ClampedArray)}e.isTypedArray=k;function w(c){return typeof c=="number"&&!isNaN(c)}e.isNumber=w;function p(c){return!!c&&typeof c[Symbol.iterator]=="function"}e.isIterable=p;function D(c){return c===!0||c===!1}e.isBoolean=D;function T(c){return typeof c=="undefined"}e.isUndefined=T;function R(c){return!E(c)}e.isDefined=R;function E(c){return T(c)||c===null}e.isUndefinedOrNull=E;function b(c,u){if(!c)throw new Error(u?`Unexpected type, expected '${u}'`:"Unexpected type")}e.assertType=b;function d(c){if(E(c))throw new Error("Assertion Failed: argument is undefined or null");return c}e.assertIsDefined=d;function C(...c){const u=[];for(let S=0;S<c.length;S++){const A=c[S];if(E(A))throw new Error(`Assertion Failed: argument at index ${S} is undefined or null`);u.push(A)}return u}e.assertAllDefined=C;const y=Object.prototype.hasOwnProperty;function m(c){if(!P(c))return!1;for(const u in c)if(y.call(c,u))return!1;return!0}e.isEmptyObject=m;function g(c){return typeof c=="function"}e.isFunction=g;function h(...c){return c.length>0&&c.every(g)}e.areFunctions=h;function l(c,u){const S=Math.min(c.length,u.length);for(let A=0;A<S;A++)f(c[A],u[A])}e.validateConstraints=l;function f(c,u){if(t(u)){if(typeof c!==u)throw new Error(`argument does not match constraint: typeof ${u}`)}else if(g(u)){try{if(c instanceof u)return}catch{}if(!E(c)&&c.constructor===u||u.length===1&&u.call(void 0,c)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=f;function i(c){let u=[],S=Object.getPrototypeOf(c);for(;Object.prototype!==S;)u=u.concat(Object.getOwnPropertyNames(S)),S=Object.getPrototypeOf(S);return u}e.getAllPropertyNames=i;function a(c){const u=[];for(const S of i(c))typeof c[S]=="function"&&u.push(S);return u}e.getAllMethodNames=a;function n(c,u){const S=M=>function(){const $=Array.prototype.slice.call(arguments,0);return u(M,$)},A={};for(const M of c)A[M]=S(M);return A}e.createProxyObject=n;function o(c){return c===null?void 0:c}e.withNullAsUndefined=o;function r(c){return typeof c=="undefined"?null:c}e.withUndefinedAsNull=r;function s(c,u="Unreachable"){throw new Error(u)}e.assertNever=s}),define(ve[22],we([0,1,12]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const C=Array.isArray(d)?[]:{};return Object.keys(d).forEach(y=>{d[y]&&typeof d[y]=="object"?C[y]=t(d[y]):C[y]=d[y]}),C}e.deepClone=t;function v(d){if(!d||typeof d!="object")return d;const C=[d];for(;C.length>0;){const y=C.shift();Object.freeze(y);for(const m in y)if(P.call(y,m)){const g=y[m];typeof g=="object"&&!Object.isFrozen(g)&&!(0,I.isTypedArray)(g)&&C.push(g)}}return d}e.deepFreeze=v;const P=Object.prototype.hasOwnProperty;function k(d,C){return w(d,C,new Set)}e.cloneAndChange=k;function w(d,C,y){if((0,I.isUndefinedOrNull)(d))return d;const m=C(d);if(typeof m!="undefined")return m;if((0,I.isArray)(d)){const g=[];for(const h of d)g.push(w(h,C,y));return g}if((0,I.isObject)(d)){if(y.has(d))throw new Error("Cannot clone recursive data-structure");y.add(d);const g={};for(const h in d)P.call(d,h)&&(g[h]=w(d[h],C,y));return y.delete(d),g}return d}function p(d,C,y=!0){return(0,I.isObject)(d)?((0,I.isObject)(C)&&Object.keys(C).forEach(m=>{m in d?y&&((0,I.isObject)(d[m])&&(0,I.isObject)(C[m])?p(d[m],C[m],y):d[m]=C[m]):d[m]=C[m]}),d):C}e.mixin=p;function D(d,C){if(d===C)return!0;if(d==null||C===null||C===void 0||typeof d!=typeof C||typeof d!="object"||Array.isArray(d)!==Array.isArray(C))return!1;let y,m;if(Array.isArray(d)){if(d.length!==C.length)return!1;for(y=0;y<d.length;y++)if(!D(d[y],C[y]))return!1}else{const g=[];for(m in d)g.push(m);g.sort();const h=[];for(m in C)h.push(m);if(h.sort(),!D(g,h))return!1;for(y=0;y<g.length;y++)if(!D(d[g[y]],C[g[y]]))return!1}return!0}e.equals=D;function T(d){const C=new Set;return JSON.stringify(d,(y,m)=>{if((0,I.isObject)(m)||Array.isArray(m)){if(C.has(m))return"[Circular]";C.add(m)}return m})}e.safeStringify=T;function R(d,C){const y=Object.create(null);return!d||!C||Object.keys(C).forEach(g=>{const h=d[g],l=C[g];D(h,l)||(y[g]=l)}),y}e.distinct=R;function E(d,C){const y=C.toLowerCase(),m=Object.keys(d).find(g=>g.toLowerCase()===y);return m?d[m]:d[C]}e.getCaseInsensitive=E;function b(d,C){const y=Object.create(null);for(const[m,g]of Object.entries(d))C(m,g)&&(y[m]=g);return y}e.filter=b}),define(ve[26],we([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const I=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(v){return I.test(v)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let v;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?v=crypto.getRandomValues.bind(crypto):v=function(w){for(let p=0;p<w.length;p++)w[p]=Math.floor(Math.random()*256);return w};const P=new Uint8Array(16),k=[];for(let w=0;w<256;w++)k.push(w.toString(16).padStart(2,"0"));return function(){v(P),P[6]=P[6]&15|64,P[8]=P[8]&63|128;let p=0,D="";return D+=k[P[p++]],D+=k[P[p++]],D+=k[P[p++]],D+=k[P[p++]],D+="-",D+=k[P[p++]],D+=k[P[p++]],D+="-",D+=k[P[p++]],D+=k[P[p++]],D+="-",D+=k[P[p++]],D+=k[P[p++]],D+="-",D+=k[P[p++]],D+=k[P[p++]],D+=k[P[p++]],D+=k[P[p++]],D+=k[P[p++]],D+=k[P[p++]],D}}()}),define(ve[135],we([0,1,265]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class t{constructor(P="utf8"){this.stringDecoder=new I.StringDecoder(P),this.remaining=null}write(P){const k=[],w=this.remaining?this.remaining+this.stringDecoder.write(P):this.stringDecoder.write(P);if(w.length<1)return k;let p=0,D,T=p;for(;T<w.length;)if(D=w.charCodeAt(T),D===13||D===10){if(k.push(w.substring(p,T)),T++,T<w.length){const R=D;D=w.charCodeAt(T),(R===13&&D===10||R===10&&D===13)&&T++}p=T}else T++;return this.remaining=p<w.length?w.substr(p):null,k}end(){return this.remaining}}e.LineDecoder=t}),function(){"use strict";function oe(e,I,t,v){function P(d){return new Promise(C=>t.exists(d,C))}function k(d){return new Promise((C,y)=>{const m=new Date;t.utimes(d,m,m,g=>g?y(g):C())})}function w(d){return new Promise((C,y)=>t.mkdir(d,{recursive:!0},m=>m&&m.code!=="EEXIST"?y(m):C(d)))}function p(d){return new Promise((C,y)=>t.rm(d,{recursive:!0,force:!0,maxRetries:3},m=>m?y(m):C()))}function D(d){return new Promise((C,y)=>t.readFile(d,"utf8",(m,g)=>m?y(m):C(g)))}function T(d,C){return new Promise((y,m)=>t.writeFile(d,C,"utf8",g=>g?m(g):y()))}function R(d){const C=I.join(d,"languagepacks.json");try{return e(C)}catch{}}function E(d,C){try{for(;C;){if(d[C])return C;{const y=C.lastIndexOf("-");if(y>0)C=C.substring(0,y);else return}}}catch(y){console.error("Resolving language pack configuration failed.",y)}}function b(d,C,y,m){if(m==="pseudo")return Promise.resolve({locale:m,availableLanguages:{},pseudo:!0});if(process.env.VSCODE_DEV)return Promise.resolve({locale:m,availableLanguages:{}});if(m&&(m==="en"||m==="en-us"))return Promise.resolve({locale:m,availableLanguages:{}});const g=m;v.mark("code/willGenerateNls");const h=function(l){return v.mark("code/didGenerateNls"),Promise.resolve({locale:l,availableLanguages:{}})};try{if(!d)return h(g);const l=R(C);if(!l||(m=E(l,m),!m))return h(g);const f=l[m];let i;return!f||typeof f.hash!="string"||!f.translations||typeof(i=f.translations.vscode)!="string"?h(g):P(i).then(a=>{if(!a)return h(g);const n=f.hash+"."+m,o=I.join(C,"clp",n),r=I.join(o,d),s=I.join(o,"tcf.json"),c=I.join(o,"corrupted.info"),u={locale:g,availableLanguages:{"*":m},_languagePackId:n,_translationsConfigFile:s,_cacheRoot:o,_resolvedLanguagePackCoreLocation:r,_corruptedFile:c};return P(c).then(S=>{let A;return S?A=p(o):A=Promise.resolve(void 0),A.then(()=>P(r).then(M=>M?(k(r).catch(()=>{}),v.mark("code/didGenerateNls"),u):w(r).then(()=>Promise.all([D(y),D(i)])).then($=>{const Q=JSON.parse($[0]),_=JSON.parse($[1]).contents,q=Object.keys(Q.bundles),U=[];for(const ne of q){const Z=Q.bundles[ne],F=Object.create(null);for(const x of Z){const z=Q.keys[x],W=Q.messages[x],re=_[x];let V;if(re){V=[];for(let X=0;X<z.length;X++){const ae=z[X],ie=typeof ae=="string"?ae:ae.key;let O=re[ie];O===void 0&&(O=W[X]),V.push(O)}}else V=W;F[x]=V}U.push(T(I.join(r,ne.replace(/\//g,"!")+".nls.json"),JSON.stringify(F)))}return U.push(T(s,JSON.stringify(f.translations))),Promise.all(U)}).then(()=>(v.mark("code/didGenerateNls"),u)).catch($=>(console.error("Generating translation files failed.",$),h(m)))))})})}catch(l){return console.error("Generating translation files failed.",l),h(m)}}return{getNLSConfiguration:b}}if(typeof define=="function")define(ve[136],we([0,83,30,49]),function(e,I,t,v){return oe(e.__$__nodeRequire,I,t,v)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),I=require("fs"),t=require("../common/performance");module.exports=oe(require,e,I,t)}else throw new Error("Unknown context")}(),define(ve[137],we([0,1,27]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const t=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function v(k){const w=k.replace(/\-/g,":").toLowerCase();return!t.has(w)}function P(){const k=(0,I.networkInterfaces)();for(const w in k){const p=k[w];if(p){for(const{mac:D}of p)if(v(D))return D}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=P}),define(ve[138],we([0,1,66]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function t(w,p,D,T=1){let R=!1;return new Promise(E=>{const b=setTimeout(()=>{if(!R)return R=!0,E(0)},D);v(w,p,T,d=>{if(!R)return R=!0,clearTimeout(b),E(d)})})}e.findFreePort=t;function v(w,p,D,T){if(p===0)return T(0);const R=new I.Socket;R.once("connect",()=>(k(R),v(w+D,p-1,D,T))),R.once("data",()=>{}),R.once("error",E=>(k(R),E.code!=="ECONNREFUSED"?v(w+D,p-1,D,T):T(w))),R.connect(w,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function P(w,p,D){let T=!1,R,E=1;const b=I.createServer({pauseOnConnect:!0});function d(C,y){T||(T=!0,b.removeAllListeners(),b.close(),R&&clearTimeout(R),y(C))}return new Promise(C=>{R=setTimeout(()=>{d(0,C)},D),b.on("listening",()=>{d(w,C)}),b.on("error",y=>{y&&(y.code==="EADDRINUSE"||y.code==="EACCES")&&E<p?(w++,E++,b.listen(w,"127.0.0.1")):d(0,C)}),b.on("close",()=>{d(0,C)}),b.listen(w,"127.0.0.1")})}e.findFreePortFaster=P;function k(w){try{w.removeAllListeners("connect"),w.removeAllListeners("error"),w.end(),w.destroy(),w.unref()}catch(p){console.error(p)}}}),define(ve[84],we([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class I{constructor(v,P){this.lineNumber=v,this.column=P}with(v=this.lineNumber,P=this.column){return v===this.lineNumber&&P===this.column?this:new I(v,P)}delta(v=0,P=0){return this.with(this.lineNumber+v,this.column+P)}equals(v){return I.equals(this,v)}static equals(v,P){return!v&&!P?!0:!!v&&!!P&&v.lineNumber===P.lineNumber&&v.column===P.column}isBefore(v){return I.isBefore(this,v)}static isBefore(v,P){return v.lineNumber<P.lineNumber?!0:P.lineNumber<v.lineNumber?!1:v.column<P.column}isBeforeOrEqual(v){return I.isBeforeOrEqual(this,v)}static isBeforeOrEqual(v,P){return v.lineNumber<P.lineNumber?!0:P.lineNumber<v.lineNumber?!1:v.column<=P.column}static compare(v,P){const k=v.lineNumber|0,w=P.lineNumber|0;if(k===w){const p=v.column|0,D=P.column|0;return p-D}return k-w}clone(){return new I(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(v){return new I(v.lineNumber,v.column)}static isIPosition(v){return v&&typeof v.lineNumber=="number"&&typeof v.column=="number"}}e.Position=I}),define(ve[50],we([0,1,84]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class t{constructor(P,k,w,p){P>w||P===w&&k>p?(this.startLineNumber=w,this.startColumn=p,this.endLineNumber=P,this.endColumn=k):(this.startLineNumber=P,this.startColumn=k,this.endLineNumber=w,this.endColumn=p)}isEmpty(){return t.isEmpty(this)}static isEmpty(P){return P.startLineNumber===P.endLineNumber&&P.startColumn===P.endColumn}containsPosition(P){return t.containsPosition(this,P)}static containsPosition(P,k){return!(k.lineNumber<P.startLineNumber||k.lineNumber>P.endLineNumber||k.lineNumber===P.startLineNumber&&k.column<P.startColumn||k.lineNumber===P.endLineNumber&&k.column>P.endColumn)}static strictContainsPosition(P,k){return!(k.lineNumber<P.startLineNumber||k.lineNumber>P.endLineNumber||k.lineNumber===P.startLineNumber&&k.column<=P.startColumn||k.lineNumber===P.endLineNumber&&k.column>=P.endColumn)}containsRange(P){return t.containsRange(this,P)}static containsRange(P,k){return!(k.startLineNumber<P.startLineNumber||k.endLineNumber<P.startLineNumber||k.startLineNumber>P.endLineNumber||k.endLineNumber>P.endLineNumber||k.startLineNumber===P.startLineNumber&&k.startColumn<P.startColumn||k.endLineNumber===P.endLineNumber&&k.endColumn>P.endColumn)}strictContainsRange(P){return t.strictContainsRange(this,P)}static strictContainsRange(P,k){return!(k.startLineNumber<P.startLineNumber||k.endLineNumber<P.startLineNumber||k.startLineNumber>P.endLineNumber||k.endLineNumber>P.endLineNumber||k.startLineNumber===P.startLineNumber&&k.startColumn<=P.startColumn||k.endLineNumber===P.endLineNumber&&k.endColumn>=P.endColumn)}plusRange(P){return t.plusRange(this,P)}static plusRange(P,k){let w,p,D,T;return k.startLineNumber<P.startLineNumber?(w=k.startLineNumber,p=k.startColumn):k.startLineNumber===P.startLineNumber?(w=k.startLineNumber,p=Math.min(k.startColumn,P.startColumn)):(w=P.startLineNumber,p=P.startColumn),k.endLineNumber>P.endLineNumber?(D=k.endLineNumber,T=k.endColumn):k.endLineNumber===P.endLineNumber?(D=k.endLineNumber,T=Math.max(k.endColumn,P.endColumn)):(D=P.endLineNumber,T=P.endColumn),new t(w,p,D,T)}intersectRanges(P){return t.intersectRanges(this,P)}static intersectRanges(P,k){let w=P.startLineNumber,p=P.startColumn,D=P.endLineNumber,T=P.endColumn;const R=k.startLineNumber,E=k.startColumn,b=k.endLineNumber,d=k.endColumn;return w<R?(w=R,p=E):w===R&&(p=Math.max(p,E)),D>b?(D=b,T=d):D===b&&(T=Math.min(T,d)),w>D||w===D&&p>T?null:new t(w,p,D,T)}equalsRange(P){return t.equalsRange(this,P)}static equalsRange(P,k){return!!P&&!!k&&P.startLineNumber===k.startLineNumber&&P.startColumn===k.startColumn&&P.endLineNumber===k.endLineNumber&&P.endColumn===k.endColumn}getEndPosition(){return t.getEndPosition(this)}static getEndPosition(P){return new I.Position(P.endLineNumber,P.endColumn)}getStartPosition(){return t.getStartPosition(this)}static getStartPosition(P){return new I.Position(P.startLineNumber,P.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(P,k){return new t(this.startLineNumber,this.startColumn,P,k)}setStartPosition(P,k){return new t(P,k,this.endLineNumber,this.endColumn)}collapseToStart(){return t.collapseToStart(this)}static collapseToStart(P){return new t(P.startLineNumber,P.startColumn,P.startLineNumber,P.startColumn)}static fromPositions(P,k=P){return new t(P.lineNumber,P.column,k.lineNumber,k.column)}static lift(P){return P?new t(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn):null}static isIRange(P){return P&&typeof P.startLineNumber=="number"&&typeof P.startColumn=="number"&&typeof P.endLineNumber=="number"&&typeof P.endColumn=="number"}static areIntersectingOrTouching(P,k){return!(P.endLineNumber<k.startLineNumber||P.endLineNumber===k.startLineNumber&&P.endColumn<k.startColumn||k.endLineNumber<P.startLineNumber||k.endLineNumber===P.startLineNumber&&k.endColumn<P.startColumn)}static areIntersecting(P,k){return!(P.endLineNumber<k.startLineNumber||P.endLineNumber===k.startLineNumber&&P.endColumn<=k.startColumn||k.endLineNumber<P.startLineNumber||k.endLineNumber===P.startLineNumber&&k.endColumn<=P.startColumn)}static compareRangesUsingStarts(P,k){if(P&&k){const D=P.startLineNumber|0,T=k.startLineNumber|0;if(D===T){const R=P.startColumn|0,E=k.startColumn|0;if(R===E){const b=P.endLineNumber|0,d=k.endLineNumber|0;if(b===d){const C=P.endColumn|0,y=k.endColumn|0;return C-y}return b-d}return R-E}return D-T}return(P?1:0)-(k?1:0)}static compareRangesUsingEnds(P,k){return P.endLineNumber===k.endLineNumber?P.endColumn===k.endColumn?P.startLineNumber===k.startLineNumber?P.startColumn-k.startColumn:P.startLineNumber-k.startLineNumber:P.endColumn-k.endColumn:P.endLineNumber-k.endLineNumber}static spansMultipleLines(P){return P.endLineNumber>P.startLineNumber}toJSON(){return this}}e.Range=t}),define(ve[139],we([8,9]),function(oe,e){return oe.create("vs/base/common/date",e)}),define(ve[140],we([0,1,139]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,v=t*60,P=v*24,k=P*7,w=P*30,p=P*365;function D(R,E,b){typeof R!="number"&&(R=R.getTime());const d=Math.round((new Date().getTime()-R)/1e3);if(d<-30)return(0,I.localize)(0,null,D(new Date().getTime()+d*1e3,!1));if(d<30)return(0,I.localize)(1,null);let C;return d<t?(C=d,E?C===1?b?(0,I.localize)(2,null,C):(0,I.localize)(3,null,C):b?(0,I.localize)(4,null,C):(0,I.localize)(5,null,C):C===1?b?(0,I.localize)(6,null,C):(0,I.localize)(7,null,C):b?(0,I.localize)(8,null,C):(0,I.localize)(9,null,C)):d<v?(C=Math.floor(d/t),E?C===1?b?(0,I.localize)(10,null,C):(0,I.localize)(11,null,C):b?(0,I.localize)(12,null,C):(0,I.localize)(13,null,C):C===1?b?(0,I.localize)(14,null,C):(0,I.localize)(15,null,C):b?(0,I.localize)(16,null,C):(0,I.localize)(17,null,C)):d<P?(C=Math.floor(d/v),E?C===1?b?(0,I.localize)(18,null,C):(0,I.localize)(19,null,C):b?(0,I.localize)(20,null,C):(0,I.localize)(21,null,C):C===1?b?(0,I.localize)(22,null,C):(0,I.localize)(23,null,C):b?(0,I.localize)(24,null,C):(0,I.localize)(25,null,C)):d<k?(C=Math.floor(d/P),E?C===1?(0,I.localize)(26,null,C):(0,I.localize)(27,null,C):C===1?(0,I.localize)(28,null,C):(0,I.localize)(29,null,C)):d<w?(C=Math.floor(d/k),E?C===1?b?(0,I.localize)(30,null,C):(0,I.localize)(31,null,C):b?(0,I.localize)(32,null,C):(0,I.localize)(33,null,C):C===1?b?(0,I.localize)(34,null,C):(0,I.localize)(35,null,C):b?(0,I.localize)(36,null,C):(0,I.localize)(37,null,C)):d<p?(C=Math.floor(d/w),E?C===1?b?(0,I.localize)(38,null,C):(0,I.localize)(39,null,C):b?(0,I.localize)(40,null,C):(0,I.localize)(41,null,C):C===1?b?(0,I.localize)(42,null,C):(0,I.localize)(43,null,C):b?(0,I.localize)(44,null,C):(0,I.localize)(45,null,C)):(C=Math.floor(d/p),E?C===1?b?(0,I.localize)(46,null,C):(0,I.localize)(47,null,C):b?(0,I.localize)(48,null,C):(0,I.localize)(49,null,C):C===1?b?(0,I.localize)(50,null,C):(0,I.localize)(51,null,C):b?(0,I.localize)(52,null,C):(0,I.localize)(53,null,C))}e.fromNow=D;function T(R){return R.getFullYear()+"-"+String(R.getMonth()+1).padStart(2,"0")+"-"+String(R.getDate()).padStart(2,"0")+"T"+String(R.getHours()).padStart(2,"0")+":"+String(R.getMinutes()).padStart(2,"0")+":"+String(R.getSeconds()).padStart(2,"0")+"."+(R.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=T}),define(ve[141],we([8,9]),function(oe,e){return oe.create("vs/base/common/errorMessage",e)}),define(ve[37],we([0,1,18,12,141]),function(oe,e,I,t,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function P(R,E){return E&&(R.stack||R.stacktrace)?v.localize(0,null,w(R),k(R.stack)||k(R.stacktrace)):w(R)}function k(R){return Array.isArray(R)?R.join(`
`):R}function w(R){return typeof R.code=="string"&&typeof R.errno=="number"&&typeof R.syscall=="string"?v.localize(1,null,R.message):R.message||v.localize(2,null)}function p(R=null,E=!1){if(!R)return v.localize(3,null);if(Array.isArray(R)){const b=I.coalesce(R),d=p(b[0],E);return b.length>1?v.localize(4,null,d,b.length):d}if(t.isString(R))return R;if(R.detail){const b=R.detail;if(b.error)return P(b.error,E);if(b.exception)return P(b.exception,E)}return R.stack?P(R,E):R.message?R.message:v.localize(5,null)}e.toErrorMessage=p;function D(R){const E=R;return E instanceof Error&&Array.isArray(E.actions)}e.isErrorWithActions=D;function T(R,E){let b;return typeof R=="string"?b=new Error(R):b=R,b.actions=E,b}e.createErrorWithActions=T}),define(ve[142],we([8,9]),function(oe,e){return oe.create("vs/base/common/jsonErrorMessages",e)}),define(ve[143],we([0,1,142]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function t(v){switch(v){case 1:return(0,I.localize)(0,null);case 2:return(0,I.localize)(1,null);case 3:return(0,I.localize)(2,null);case 4:return(0,I.localize)(3,null);case 5:return(0,I.localize)(4,null);case 6:return(0,I.localize)(5,null);case 7:return(0,I.localize)(6,null);case 8:return(0,I.localize)(7,null);case 9:return(0,I.localize)(8,null);default:return""}}e.getParseErrorMessage=t}),define(ve[144],we([8,9]),function(oe,e){return oe.create("vs/base/common/platform",e)}),define(ve[3],we([0,1,144]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=void 0;const t="en";let v=!1,P=!1,k=!1,w=!1,p=!1,D=!1,T=!1,R=!1,E=!1,b,d=t,C,y;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let m;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?m=e.globals.vscode.process:typeof process!="undefined"&&(m=process);const g=typeof m?.versions?.electron=="string",h=g&&m?.type==="renderer";if(typeof navigator=="object"&&!h)y=navigator.userAgent,v=y.indexOf("Windows")>=0,P=y.indexOf("Macintosh")>=0,R=(y.indexOf("Macintosh")>=0||y.indexOf("iPad")>=0||y.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,k=y.indexOf("Linux")>=0,D=!0,b=I.getConfiguredDefaultLocale(I.localize(0,null))||t,d=b;else if(typeof m=="object"){v=m.platform==="win32",P=m.platform==="darwin",k=m.platform==="linux",w=k&&!!m.env.SNAP&&!!m.env.SNAP_REVISION,T=g,E=!!m.env.CI||!!m.env.BUILD_ARTIFACTSTAGINGDIRECTORY,b=t,d=t;const c=m.env.VSCODE_NLS_CONFIG;if(c)try{const u=JSON.parse(c),S=u.availableLanguages["*"];b=u.locale,d=S||t,C=u._translationsConfigFile}catch{}p=!0}else console.error("Unable to resolve platform.");var l;(function(c){c[c.Web=0]="Web",c[c.Mac=1]="Mac",c[c.Linux=2]="Linux",c[c.Windows=3]="Windows"})(l=e.Platform||(e.Platform={}));function f(c){switch(c){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=f;let i=0;P?i=1:v?i=3:k&&(i=2),e.isWindows=v,e.isMacintosh=P,e.isLinux=k,e.isLinuxSnap=w,e.isNative=p,e.isElectron=T,e.isWeb=D,e.isWebWorker=D&&typeof e.globals.importScripts=="function",e.isIOS=R,e.isCI=E,e.platform=i,e.userAgent=y,e.language=d;var a;(function(c){function u(){return e.language}c.value=u;function S(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}c.isDefaultVariant=S;function A(){return e.language==="en"}c.isDefault=A})(a=e.Language||(e.Language={})),e.locale=b,e.translationsConfigFile=C,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const c=[];e.globals.addEventListener("message",S=>{if(S.data&&S.data.vscodeScheduleAsyncWork)for(let A=0,M=c.length;A<M;A++){const $=c[A];if($.id===S.data.vscodeScheduleAsyncWork){c.splice(A,1),$.callback();return}}});let u=0;return S=>{const A=++u;c.push({id:A,callback:S}),e.globals.postMessage({vscodeScheduleAsyncWork:A},"*")}}return c=>setTimeout(c)})();var n;(function(c){c[c.Windows=1]="Windows",c[c.Macintosh=2]="Macintosh",c[c.Linux=3]="Linux"})(n=e.OperatingSystem||(e.OperatingSystem={})),e.OS=P||R?2:v?1:3;let o=!0,r=!1;function s(){if(!r){r=!0;const c=new Uint8Array(2);c[0]=1,c[1]=2,o=new Uint16Array(c.buffer)[0]===(2<<8)+1}return o}e.isLittleEndian=s,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ve[28],we([0,1,3]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof I.globals.vscode!="undefined"&&typeof I.globals.vscode.process!="undefined"){const v=I.globals.vscode.process;t={get platform(){return v.platform},get arch(){return v.arch},get env(){return v.env},cwd(){return v.cwd()}}}else typeof process!="undefined"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return I.isWindows?"win32":I.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(ve[5],we([0,1,28]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,v=97,P=90,k=122,w=46,p=47,D=92,T=58,R=63;class E extends Error{constructor(l,f,i){let a;typeof f=="string"&&f.indexOf("not ")===0?(a="must not be",f=f.replace(/^not /,"")):a="must be";const n=l.indexOf(".")!==-1?"property":"argument";let o=`The "${l}" ${n} ${a} of type ${f}`;o+=`. Received type ${typeof i}`;super(o);this.code="ERR_INVALID_ARG_TYPE"}}function b(h,l){if(typeof h!="string")throw new E(l,"string",h)}function d(h){return h===p||h===D}function C(h){return h===p}function y(h){return h>=t&&h<=P||h>=v&&h<=k}function m(h,l,f,i){let a="",n=0,o=-1,r=0,s=0;for(let c=0;c<=h.length;++c){if(c<h.length)s=h.charCodeAt(c);else{if(i(s))break;s=p}if(i(s)){if(!(o===c-1||r===1))if(r===2){if(a.length<2||n!==2||a.charCodeAt(a.length-1)!==w||a.charCodeAt(a.length-2)!==w){if(a.length>2){const u=a.lastIndexOf(f);u===-1?(a="",n=0):(a=a.slice(0,u),n=a.length-1-a.lastIndexOf(f)),o=c,r=0;continue}else if(a.length!==0){a="",n=0,o=c,r=0;continue}}l&&(a+=a.length>0?`${f}..`:"..",n=2)}else a.length>0?a+=`${f}${h.slice(o+1,c)}`:a=h.slice(o+1,c),n=c-o-1;o=c,r=0}else s===w&&r!==-1?++r:r=-1}return a}function g(h,l){if(l===null||typeof l!="object")throw new E("pathObject","Object",l);const f=l.dir||l.root,i=l.base||`${l.name||""}${l.ext||""}`;return f?f===l.root?`${f}${i}`:`${f}${h}${i}`:i}e.win32={resolve(...h){let l="",f="",i=!1;for(let a=h.length-1;a>=-1;a--){let n;if(a>=0){if(n=h[a],b(n,"path"),n.length===0)continue}else l.length===0?n=I.cwd():(n=I.env[`=${l}`]||I.cwd(),(n===void 0||n.slice(0,2).toLowerCase()!==l.toLowerCase()&&n.charCodeAt(2)===D)&&(n=`${l}\\`));const o=n.length;let r=0,s="",c=!1;const u=n.charCodeAt(0);if(o===1)d(u)&&(r=1,c=!0);else if(d(u))if(c=!0,d(n.charCodeAt(1))){let S=2,A=S;for(;S<o&&!d(n.charCodeAt(S));)S++;if(S<o&&S!==A){const M=n.slice(A,S);for(A=S;S<o&&d(n.charCodeAt(S));)S++;if(S<o&&S!==A){for(A=S;S<o&&!d(n.charCodeAt(S));)S++;(S===o||S!==A)&&(s=`\\\\${M}\\${n.slice(A,S)}`,r=S)}}}else r=1;else y(u)&&n.charCodeAt(1)===T&&(s=n.slice(0,2),r=2,o>2&&d(n.charCodeAt(2))&&(c=!0,r=3));if(s.length>0)if(l.length>0){if(s.toLowerCase()!==l.toLowerCase())continue}else l=s;if(i){if(l.length>0)break}else if(f=`${n.slice(r)}\\${f}`,i=c,c&&l.length>0)break}return f=m(f,!i,"\\",d),i?`${l}\\${f}`:`${l}${f}`||"."},normalize(h){b(h,"path");const l=h.length;if(l===0)return".";let f=0,i,a=!1;const n=h.charCodeAt(0);if(l===1)return C(n)?"\\":h;if(d(n))if(a=!0,d(h.charCodeAt(1))){let r=2,s=r;for(;r<l&&!d(h.charCodeAt(r));)r++;if(r<l&&r!==s){const c=h.slice(s,r);for(s=r;r<l&&d(h.charCodeAt(r));)r++;if(r<l&&r!==s){for(s=r;r<l&&!d(h.charCodeAt(r));)r++;if(r===l)return`\\\\${c}\\${h.slice(s)}\\`;r!==s&&(i=`\\\\${c}\\${h.slice(s,r)}`,f=r)}}}else f=1;else y(n)&&h.charCodeAt(1)===T&&(i=h.slice(0,2),f=2,l>2&&d(h.charCodeAt(2))&&(a=!0,f=3));let o=f<l?m(h.slice(f),!a,"\\",d):"";return o.length===0&&!a&&(o="."),o.length>0&&d(h.charCodeAt(l-1))&&(o+="\\"),i===void 0?a?`\\${o}`:o:a?`${i}\\${o}`:`${i}${o}`},isAbsolute(h){b(h,"path");const l=h.length;if(l===0)return!1;const f=h.charCodeAt(0);return d(f)||l>2&&y(f)&&h.charCodeAt(1)===T&&d(h.charCodeAt(2))},join(...h){if(h.length===0)return".";let l,f;for(let n=0;n<h.length;++n){const o=h[n];b(o,"path"),o.length>0&&(l===void 0?l=f=o:l+=`\\${o}`)}if(l===void 0)return".";let i=!0,a=0;if(typeof f=="string"&&d(f.charCodeAt(0))){++a;const n=f.length;n>1&&d(f.charCodeAt(1))&&(++a,n>2&&(d(f.charCodeAt(2))?++a:i=!1))}if(i){for(;a<l.length&&d(l.charCodeAt(a));)a++;a>=2&&(l=`\\${l.slice(a)}`)}return e.win32.normalize(l)},relative(h,l){if(b(h,"from"),b(l,"to"),h===l)return"";const f=e.win32.resolve(h),i=e.win32.resolve(l);if(f===i||(h=f.toLowerCase(),l=i.toLowerCase(),h===l))return"";let a=0;for(;a<h.length&&h.charCodeAt(a)===D;)a++;let n=h.length;for(;n-1>a&&h.charCodeAt(n-1)===D;)n--;const o=n-a;let r=0;for(;r<l.length&&l.charCodeAt(r)===D;)r++;let s=l.length;for(;s-1>r&&l.charCodeAt(s-1)===D;)s--;const c=s-r,u=o<c?o:c;let S=-1,A=0;for(;A<u;A++){const $=h.charCodeAt(a+A);if($!==l.charCodeAt(r+A))break;$===D&&(S=A)}if(A!==u){if(S===-1)return i}else{if(c>u){if(l.charCodeAt(r+A)===D)return i.slice(r+A+1);if(A===2)return i.slice(r+A)}o>u&&(h.charCodeAt(a+A)===D?S=A:A===2&&(S=3)),S===-1&&(S=0)}let M="";for(A=a+S+1;A<=n;++A)(A===n||h.charCodeAt(A)===D)&&(M+=M.length===0?"..":"\\..");return r+=S,M.length>0?`${M}${i.slice(r,s)}`:(i.charCodeAt(r)===D&&++r,i.slice(r,s))},toNamespacedPath(h){if(typeof h!="string")return h;if(h.length===0)return"";const l=e.win32.resolve(h);if(l.length<=2)return h;if(l.charCodeAt(0)===D){if(l.charCodeAt(1)===D){const f=l.charCodeAt(2);if(f!==R&&f!==w)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(y(l.charCodeAt(0))&&l.charCodeAt(1)===T&&l.charCodeAt(2)===D)return`\\\\?\\${l}`;return h},dirname(h){b(h,"path");const l=h.length;if(l===0)return".";let f=-1,i=0;const a=h.charCodeAt(0);if(l===1)return d(a)?h:".";if(d(a)){if(f=i=1,d(h.charCodeAt(1))){let r=2,s=r;for(;r<l&&!d(h.charCodeAt(r));)r++;if(r<l&&r!==s){for(s=r;r<l&&d(h.charCodeAt(r));)r++;if(r<l&&r!==s){for(s=r;r<l&&!d(h.charCodeAt(r));)r++;if(r===l)return h;r!==s&&(f=i=r+1)}}}}else y(a)&&h.charCodeAt(1)===T&&(f=l>2&&d(h.charCodeAt(2))?3:2,i=f);let n=-1,o=!0;for(let r=l-1;r>=i;--r)if(d(h.charCodeAt(r))){if(!o){n=r;break}}else o=!1;if(n===-1){if(f===-1)return".";n=f}return h.slice(0,n)},basename(h,l){l!==void 0&&b(l,"ext"),b(h,"path");let f=0,i=-1,a=!0,n;if(h.length>=2&&y(h.charCodeAt(0))&&h.charCodeAt(1)===T&&(f=2),l!==void 0&&l.length>0&&l.length<=h.length){if(l===h)return"";let o=l.length-1,r=-1;for(n=h.length-1;n>=f;--n){const s=h.charCodeAt(n);if(d(s)){if(!a){f=n+1;break}}else r===-1&&(a=!1,r=n+1),o>=0&&(s===l.charCodeAt(o)?--o==-1&&(i=n):(o=-1,i=r))}return f===i?i=r:i===-1&&(i=h.length),h.slice(f,i)}for(n=h.length-1;n>=f;--n)if(d(h.charCodeAt(n))){if(!a){f=n+1;break}}else i===-1&&(a=!1,i=n+1);return i===-1?"":h.slice(f,i)},extname(h){b(h,"path");let l=0,f=-1,i=0,a=-1,n=!0,o=0;h.length>=2&&h.charCodeAt(1)===T&&y(h.charCodeAt(0))&&(l=i=2);for(let r=h.length-1;r>=l;--r){const s=h.charCodeAt(r);if(d(s)){if(!n){i=r+1;break}continue}a===-1&&(n=!1,a=r+1),s===w?f===-1?f=r:o!==1&&(o=1):f!==-1&&(o=-1)}return f===-1||a===-1||o===0||o===1&&f===a-1&&f===i+1?"":h.slice(f,a)},format:g.bind(null,"\\"),parse(h){b(h,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return l;const f=h.length;let i=0,a=h.charCodeAt(0);if(f===1)return d(a)?(l.root=l.dir=h,l):(l.base=l.name=h,l);if(d(a)){if(i=1,d(h.charCodeAt(1))){let S=2,A=S;for(;S<f&&!d(h.charCodeAt(S));)S++;if(S<f&&S!==A){for(A=S;S<f&&d(h.charCodeAt(S));)S++;if(S<f&&S!==A){for(A=S;S<f&&!d(h.charCodeAt(S));)S++;S===f?i=S:S!==A&&(i=S+1)}}}}else if(y(a)&&h.charCodeAt(1)===T){if(f<=2)return l.root=l.dir=h,l;if(i=2,d(h.charCodeAt(2))){if(f===3)return l.root=l.dir=h,l;i=3}}i>0&&(l.root=h.slice(0,i));let n=-1,o=i,r=-1,s=!0,c=h.length-1,u=0;for(;c>=i;--c){if(a=h.charCodeAt(c),d(a)){if(!s){o=c+1;break}continue}r===-1&&(s=!1,r=c+1),a===w?n===-1?n=c:u!==1&&(u=1):n!==-1&&(u=-1)}return r!==-1&&(n===-1||u===0||u===1&&n===r-1&&n===o+1?l.base=l.name=h.slice(o,r):(l.name=h.slice(o,n),l.base=h.slice(o,r),l.ext=h.slice(n,r))),o>0&&o!==i?l.dir=h.slice(0,o-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...h){let l="",f=!1;for(let i=h.length-1;i>=-1&&!f;i--){const a=i>=0?h[i]:I.cwd();b(a,"path"),a.length!==0&&(l=`${a}/${l}`,f=a.charCodeAt(0)===p)}return l=m(l,!f,"/",C),f?`/${l}`:l.length>0?l:"."},normalize(h){if(b(h,"path"),h.length===0)return".";const l=h.charCodeAt(0)===p,f=h.charCodeAt(h.length-1)===p;return h=m(h,!l,"/",C),h.length===0?l?"/":f?"./":".":(f&&(h+="/"),l?`/${h}`:h)},isAbsolute(h){return b(h,"path"),h.length>0&&h.charCodeAt(0)===p},join(...h){if(h.length===0)return".";let l;for(let f=0;f<h.length;++f){const i=h[f];b(i,"path"),i.length>0&&(l===void 0?l=i:l+=`/${i}`)}return l===void 0?".":e.posix.normalize(l)},relative(h,l){if(b(h,"from"),b(l,"to"),h===l||(h=e.posix.resolve(h),l=e.posix.resolve(l),h===l))return"";const f=1,i=h.length,a=i-f,n=1,o=l.length-n,r=a<o?a:o;let s=-1,c=0;for(;c<r;c++){const S=h.charCodeAt(f+c);if(S!==l.charCodeAt(n+c))break;S===p&&(s=c)}if(c===r)if(o>r){if(l.charCodeAt(n+c)===p)return l.slice(n+c+1);if(c===0)return l.slice(n+c)}else a>r&&(h.charCodeAt(f+c)===p?s=c:c===0&&(s=0));let u="";for(c=f+s+1;c<=i;++c)(c===i||h.charCodeAt(c)===p)&&(u+=u.length===0?"..":"/..");return`${u}${l.slice(n+s)}`},toNamespacedPath(h){return h},dirname(h){if(b(h,"path"),h.length===0)return".";const l=h.charCodeAt(0)===p;let f=-1,i=!0;for(let a=h.length-1;a>=1;--a)if(h.charCodeAt(a)===p){if(!i){f=a;break}}else i=!1;return f===-1?l?"/":".":l&&f===1?"//":h.slice(0,f)},basename(h,l){l!==void 0&&b(l,"ext"),b(h,"path");let f=0,i=-1,a=!0,n;if(l!==void 0&&l.length>0&&l.length<=h.length){if(l===h)return"";let o=l.length-1,r=-1;for(n=h.length-1;n>=0;--n){const s=h.charCodeAt(n);if(s===p){if(!a){f=n+1;break}}else r===-1&&(a=!1,r=n+1),o>=0&&(s===l.charCodeAt(o)?--o==-1&&(i=n):(o=-1,i=r))}return f===i?i=r:i===-1&&(i=h.length),h.slice(f,i)}for(n=h.length-1;n>=0;--n)if(h.charCodeAt(n)===p){if(!a){f=n+1;break}}else i===-1&&(a=!1,i=n+1);return i===-1?"":h.slice(f,i)},extname(h){b(h,"path");let l=-1,f=0,i=-1,a=!0,n=0;for(let o=h.length-1;o>=0;--o){const r=h.charCodeAt(o);if(r===p){if(!a){f=o+1;break}continue}i===-1&&(a=!1,i=o+1),r===w?l===-1?l=o:n!==1&&(n=1):l!==-1&&(n=-1)}return l===-1||i===-1||n===0||n===1&&l===i-1&&l===f+1?"":h.slice(l,i)},format:g.bind(null,"/"),parse(h){b(h,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return l;const f=h.charCodeAt(0)===p;let i;f?(l.root="/",i=1):i=0;let a=-1,n=0,o=-1,r=!0,s=h.length-1,c=0;for(;s>=i;--s){const u=h.charCodeAt(s);if(u===p){if(!r){n=s+1;break}continue}o===-1&&(r=!1,o=s+1),u===w?a===-1?a=s:c!==1&&(c=1):a!==-1&&(c=-1)}if(o!==-1){const u=n===0&&f?1:n;a===-1||c===0||c===1&&a===o-1&&a===n+1?l.base=l.name=h.slice(u,o):(l.name=h.slice(u,a),l.base=h.slice(u,o),l.ext=h.slice(a,o))}return n>0?l.dir=h.slice(0,n-1):f&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=I.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=I.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=I.platform==="win32"?e.win32.join:e.posix.join,e.resolve=I.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=I.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=I.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=I.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=I.platform==="win32"?e.win32.extname:e.posix.extname,e.format=I.platform==="win32"?e.win32.format:e.posix.format,e.parse=I.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=I.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=I.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=I.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ve[67],we([0,1,5]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const t={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},v={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function P(T){const R=(0,I.extname)(T),E=t[R.toLowerCase()];return E!==void 0?E:k(T)}e.getMediaOrTextMime=P;function k(T){const R=(0,I.extname)(T);return v[R.toLowerCase()]}e.getMediaMime=k;function w(T){for(const R in v)if(v[R]===T)return R}e.getExtensionForMimeType=w;const p=/^(.+)\/(.+?)(;.+)?$/;function D(T,R){const E=p.exec(T);return E?`${E[1].toLowerCase()}/${E[2].toLowerCase()}${E[3]??""}`:R?void 0:T}e.normalizeMimeType=D}),define(ve[56],we([0,1,3]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(w){w[w.stdout=0]="stdout",w[w.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var v;(function(w){w[w.Success=0]="Success",w[w.Unknown=1]="Unknown",w[w.AccessDenied=2]="AccessDenied",w[w.ProcessNotFound=3]="ProcessNotFound"})(v=e.TerminateResponseCode||(e.TerminateResponseCode={}));function P(w,...p){const D=p.reduce((E,b)=>(E[b]=!0,E),{}),T=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(w).filter(E=>!D[E]).forEach(E=>{for(let b=0;b<T.length;b++)if(E.search(T[b])!==-1){delete w[E];break}})}e.sanitizeProcessEnvironment=P;function k(w){!w||(delete w.DEBUG,I.isMacintosh&&delete w.DYLD_LIBRARY_PATH,I.isLinux&&delete w.LD_PRELOAD)}e.removeDangerousEnvVariables=k}),define(ve[145],we([0,1,3]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=I.globals.performance&&typeof I.globals.performance.now=="function";class v{constructor(k){this._highResolution=t&&k,this._startTime=this._now(),this._stopTime=-1}static create(k=!0){return new v(k)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?I.globals.performance.now():Date.now()}}e.StopWatch=v}),define(ve[7],we([0,1,11,64,2,132,145]),function(oe,e,I,t,v,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;const w=!1,p=!1;var D;(function(s){s.None=()=>v.Disposable.None;function c(ie){if(p){const{onListenerDidAdd:O}=ie,B=d.create();let ee=0;ie.onListenerDidAdd=()=>{++ee==2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),B.print()),O?.()}}}function u(ie){return(O,B=null,ee)=>{let ce=!1,K;return K=ie(he=>{if(!ce)return K?K.dispose():ce=!0,O.call(B,he)},null,ee),ce&&K.dispose(),K}}s.once=u;function S(ie,O,B){return q((ee,ce=null,K)=>ie(he=>ee.call(ce,O(he)),null,K),B)}s.map=S;function A(ie,O,B){return q((ee,ce=null,K)=>ie(he=>{O(he),ee.call(ce,he)},null,K),B)}s.forEach=A;function M(ie,O,B){return q((ee,ce=null,K)=>ie(he=>O(he)&&ee.call(ce,he),null,K),B)}s.filter=M;function $(ie){return ie}s.signal=$;function Q(...ie){return(O,B=null,ee)=>(0,v.combinedDisposable)(...ie.map(ce=>ce(K=>O.call(B,K),null,ee)))}s.any=Q;function _(ie,O,B,ee){let ce=B;return S(ie,K=>(ce=O(ce,K),ce),ee)}s.reduce=_;function q(ie,O){let B;const ee={onFirstListenerAdd(){B=ie(ce.fire,ce)},onLastListenerRemove(){B?.dispose()}};O||c(ee);const ce=new y(ee);return O?.add(ce),ce.event}function U(ie,O,B=100,ee=!1,ce,K){let he,te,le,de=0;const Y={leakWarningThreshold:ce,onFirstListenerAdd(){he=ie(H=>{de++,te=O(te,H),ee&&!le&&(J.fire(te),te=void 0),clearTimeout(le),le=setTimeout(()=>{const G=te;te=void 0,le=void 0,(!ee||de>1)&&J.fire(G),de=0},B)})},onLastListenerRemove(){he.dispose()}};K||c(Y);const J=new y(Y);return K?.add(J),J.event}s.debounce=U;function ne(ie,O=(ee,ce)=>ee===ce,B){let ee=!0,ce;return M(ie,K=>{const he=ee||!O(K,ce);return ee=!1,ce=K,he},B)}s.latch=ne;function Z(ie,O,B){return[s.filter(ie,O,B),s.filter(ie,ee=>!O(ee),B)]}s.split=Z;function F(ie,O=!1,B=[]){let ee=B.slice(),ce=ie(te=>{ee?ee.push(te):he.fire(te)});const K=()=>{ee?.forEach(te=>he.fire(te)),ee=null},he=new y({onFirstListenerAdd(){ce||(ce=ie(te=>he.fire(te)))},onFirstListenerDidAdd(){ee&&(O?setTimeout(K):K())},onLastListenerRemove(){ce&&ce.dispose(),ce=null}});return he.event}s.buffer=F;class x{constructor(O){this.event=O,this.disposables=new v.DisposableStore}map(O){return new x(S(this.event,O,this.disposables))}forEach(O){return new x(A(this.event,O,this.disposables))}filter(O){return new x(M(this.event,O,this.disposables))}reduce(O,B){return new x(_(this.event,O,B,this.disposables))}latch(){return new x(ne(this.event,void 0,this.disposables))}debounce(O,B=100,ee=!1,ce){return new x(U(this.event,O,B,ee,ce,this.disposables))}on(O,B,ee){return this.event(O,B,ee)}once(O,B,ee){return u(this.event)(O,B,ee)}dispose(){this.disposables.dispose()}}function z(ie){return new x(ie)}s.chain=z;function W(ie,O,B=ee=>ee){const ee=(...te)=>he.fire(B(...te)),ce=()=>ie.on(O,ee),K=()=>ie.removeListener(O,ee),he=new y({onFirstListenerAdd:ce,onLastListenerRemove:K});return he.event}s.fromNodeEventEmitter=W;function re(ie,O,B=ee=>ee){const ee=(...te)=>he.fire(B(...te)),ce=()=>ie.addEventListener(O,ee),K=()=>ie.removeEventListener(O,ee),he=new y({onFirstListenerAdd:ce,onLastListenerRemove:K});return he.event}s.fromDOMEventEmitter=re;function V(ie){return new Promise(O=>u(ie)(O))}s.toPromise=V;function X(ie,O){return O(void 0),ie(B=>O(B))}s.runAndSubscribe=X;function ae(ie,O){let B=null;function ee(K){B?.dispose(),B=new v.DisposableStore,O(K,B)}ee(void 0);const ce=ie(K=>ee(K));return(0,v.toDisposable)(()=>{ce.dispose(),B?.dispose()})}s.runAndSubscribeWithStore=ae})(D=e.Event||(e.Event={}));class T{constructor(c){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${c}_${T._idPool++}`}start(c){this._stopWatch=new k.StopWatch(!0),this._listenerCount=c}stop(){if(this._stopWatch){const c=this._stopWatch.elapsed();this._elapsedOverall+=c,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${c.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}T._idPool=0;let R=-1;function E(s){const c=R;return R=s,{dispose(){R=c}}}e.setGlobalLeakWarningThreshold=E;class b{constructor(c,u=Math.random().toString(18).slice(2,5)){this.customThreshold=c,this.name=u,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(c,u){let S=R;if(typeof this.customThreshold=="number"&&(S=this.customThreshold),S<=0||u<S)return;this._stacks||(this._stacks=new Map);const A=this._stacks.get(c.value)||0;if(this._stacks.set(c.value,A+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=S*.5;let M,$=0;for(const[Q,_]of this._stacks)(!M||$<_)&&(M=Q,$=_);console.warn(`[${this.name}] potential listener LEAK detected, having ${u} listeners already. MOST frequent listener (${$}):`),console.warn(M)}return()=>{const M=this._stacks.get(c.value)||0;this._stacks.set(c.value,M-1)}}}class d{constructor(c){this.value=c}static create(){return new d(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class C{constructor(c,u,S){this.callback=c,this.callbackThis=u,this.stack=S,this.subscription=new v.SafeDisposable}invoke(c){this.callback.call(this.callbackThis,c)}}class y{constructor(c){this._disposed=!1,this._options=c,this._leakageMon=R>0?new b(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new T(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(w){const c=Array.from(this._listeners);queueMicrotask(()=>{for(const u of c)u.subscription.isset()&&(u.subscription.unset(),u.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(c,u,S)=>{this._listeners||(this._listeners=new P.LinkedList);const A=this._listeners.isEmpty();A&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let M,$;this._leakageMon&&this._listeners.size>=30&&($=d.create(),M=this._leakageMon.check($,this._listeners.size+1)),w&&($=$??d.create());const Q=new C(c,u,$),_=this._listeners.push(Q);A&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,c,u);const q=Q.subscription.set(()=>{M?.(),this._disposed||(_(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return S instanceof v.DisposableStore?S.add(q):Array.isArray(S)&&S.push(q),q}),this._event}fire(c){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new g);for(const u of this._listeners)this._deliveryQueue.push(this,u,c);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=y;class m{constructor(){this._queue=new P.LinkedList}get size(){return this._queue.size}push(c,u,S){this._queue.push(new h(c,u,S))}clear(c){const u=new P.LinkedList;for(const S of this._queue)S.emitter!==c&&u.push(S);this._queue=u}deliver(){for(;this._queue.size>0;){const c=this._queue.shift();try{c.listener.invoke(c.event)}catch(u){(0,I.onUnexpectedError)(u)}}}}e.EventDeliveryQueue=m;class g extends m{clear(c){this._queue.clear()}}class h{constructor(c,u,S){this.emitter=c,this.listener=u,this.event=S}}class l extends y{async fireAsync(c,u,S){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new P.LinkedList);for(const A of this._listeners)this._asyncDeliveryQueue.push([A,c]);for(;this._asyncDeliveryQueue.size>0&&!u.isCancellationRequested;){const[A,M]=this._asyncDeliveryQueue.shift(),$=[],Q={...M,token:u,waitUntil:_=>{if(Object.isFrozen($))throw new Error("waitUntil can NOT be called asynchronous");S&&(_=S(_,A.callback)),$.push(_)}};try{A.invoke(Q)}catch(_){(0,I.onUnexpectedError)(_);continue}Object.freeze($),await Promise.allSettled($).then(_=>{for(const q of _)q.status==="rejected"&&(0,I.onUnexpectedError)(q.reason)})}}}}e.AsyncEmitter=l;class f extends y{constructor(c){super(c);this._isPaused=0,this._eventQueue=new P.LinkedList,this._mergeFn=c?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const c=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(c))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(c){this._listeners&&(this._isPaused!==0?this._eventQueue.push(c):super.fire(c))}}e.PauseableEmitter=f;class i extends f{constructor(c){super(c);this._delay=c.delay??100}fire(c){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(c)}}e.DebounceEmitter=i;class a extends y{constructor(c){super(c);this._queuedEvents=[],this._mergeFn=c?.merge}fire(c){this._queuedEvents.push(c),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(u=>super.fire(u)),this._queuedEvents=[]})}}e.MicrotaskEmitter=a;class n{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new y({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(c){const u={event:c,listener:null};this.events.push(u),this.hasListeners&&this.hook(u);const S=()=>{this.hasListeners&&this.unhook(u);const A=this.events.indexOf(u);this.events.splice(A,1)};return(0,v.toDisposable)((0,t.once)(S))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(c=>this.hook(c))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(c=>this.unhook(c))}hook(c){c.listener=c.event(u=>this.emitter.fire(u))}unhook(c){c.listener&&c.listener.dispose(),c.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=n;class o{constructor(){this.buffers=[]}wrapEvent(c){return(u,S,A)=>c(M=>{const $=this.buffers[this.buffers.length-1];$?$.push(()=>u.call(S,M)):u.call(S,M)},void 0,A)}bufferEvents(c){const u=[];this.buffers.push(u);const S=c();return this.buffers.pop(),u.forEach(A=>A()),S}}e.EventBufferer=o;class r{constructor(){this.listening=!1,this.inputEvent=D.None,this.inputEventListener=v.Disposable.None,this.emitter=new y({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(c){this.inputEvent=c,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=c(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=r}),define(ve[20],we([0,1,7]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(w,p){const D=setTimeout(w.bind(p),0);return{dispose(){clearTimeout(D)}}});var v;(function(w){function p(D){return D===w.None||D===w.Cancelled||D instanceof P?!0:!D||typeof D!="object"?!1:typeof D.isCancellationRequested=="boolean"&&typeof D.onCancellationRequested=="function"}w.isCancellationToken=p,w.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:I.Event.None}),w.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(v=e.CancellationToken||(e.CancellationToken={}));class P{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new I.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class k{constructor(p){this._token=void 0,this._parentListener=void 0,this._parentListener=p&&p.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new P),this._token}cancel(){this._token?this._token instanceof P&&this._token.cancel():this._token=v.Cancelled}dispose(p=!1){p&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof P&&this._token.dispose():this._token=v.None}}e.CancellationTokenSource=k}),define(ve[146],we([0,1,20]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(w){this.task=w,this.result=null}get(){if(this.result)return this.result;const w=new I.CancellationTokenSource,p=this.task(w.token);return this.result={promise:p,dispose:()=>{this.result=null,w.cancel(),w.dispose()}},this.result}}e.Cache=t;class v{constructor(w){this.fn=w,this.lastCache=void 0,this.lastArgKey=void 0}get(w){const p=JSON.stringify(w);return this.lastArgKey!==p&&(this.lastArgKey=p,this.lastCache=this.fn(w)),this.lastCache}}e.LRUCachedFunction=v;class P{constructor(w){this.fn=w,this._map=new Map}get cachedValues(){return this._map}get(w){if(this._map.has(w))return this._map.get(w);const p=this.fn(w);return this._map.set(w,p),p}}e.CachedFunction=P}),define(ve[85],we([0,1,7,2]),function(oe,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const v=k=>({onDidChange:I.Event.None,value:k});e.staticObservableValue=v;class P extends t.Disposable{constructor(w){super();this._value=w,this.changeEmitter=this._register(new I.Emitter),this.onDidChange=this.changeEmitter.event}get value(){return this._value}set value(w){w!==this._value&&(this._value=w,this.changeEmitter.fire(w))}}e.MutableObservableValue=P}),define(ve[15],we([0,1,146,131]),function(oe,e,I,t){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function P(ue){return!ue||typeof ue!="string"?!0:ue.trim().length===0}e.isFalsyOrWhitespace=P;const k=/{(\d+)}/g;function w(ue,...Ce){return Ce.length===0?ue:ue.replace(k,function(Pe,Ae){const Le=parseInt(Ae,10);return isNaN(Le)||Le<0||Le>=Ce.length?Pe:Ce[Le]})}e.format=w;const p=/{([^}]+)}/g;function D(ue,Ce){return ue.replace(p,(Pe,Ae)=>Ce[Ae]??Pe)}e.format2=D;function T(ue){return ue.replace(/[<>&]/g,function(Ce){switch(Ce){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ce}})}e.escape=T;function R(ue){return ue.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=R;function E(ue,Ce){let Pe=0;const Ae=Ce.charCodeAt(0);for(let Le=ue.length-1;Le>=0;Le--)ue.charCodeAt(Le)===Ae&&Pe++;return Pe}e.count=E;function b(ue,Ce,Pe="\u2026"){return ue.length<=Ce?ue:`${ue.substr(0,Ce)}${Pe}`}e.truncate=b;function d(ue,Ce=" "){const Pe=C(ue,Ce);return y(Pe,Ce)}e.trim=d;function C(ue,Ce){if(!ue||!Ce)return ue;const Pe=Ce.length;if(Pe===0||ue.length===0)return ue;let Ae=0;for(;ue.indexOf(Ce,Ae)===Ae;)Ae=Ae+Pe;return ue.substring(Ae)}e.ltrim=C;function y(ue,Ce){if(!ue||!Ce)return ue;const Pe=Ce.length,Ae=ue.length;if(Pe===0||Ae===0)return ue;let Le=Ae,Ue=-1;for(;Ue=ue.lastIndexOf(Ce,Le-1),!(Ue===-1||Ue+Pe!==Le);){if(Ue===0)return"";Le=Ue}return ue.substring(0,Le)}e.rtrim=y;function m(ue){return ue.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=m;function g(ue){return ue.replace(/\*/g,"")}e.stripWildcards=g;function h(ue,Ce,Pe={}){if(!ue)throw new Error("Cannot create regex from empty string");Ce||(ue=R(ue)),Pe.wholeWord&&(/\B/.test(ue.charAt(0))||(ue="\\b"+ue),/\B/.test(ue.charAt(ue.length-1))||(ue=ue+"\\b"));let Ae="";return Pe.global&&(Ae+="g"),Pe.matchCase||(Ae+="i"),Pe.multiline&&(Ae+="m"),Pe.unicode&&(Ae+="u"),new RegExp(ue,Ae)}e.createRegExp=h;function l(ue){return ue.source==="^"||ue.source==="^$"||ue.source==="$"||ue.source==="^\\s*$"?!1:!!(ue.exec("")&&ue.lastIndex===0)}e.regExpLeadsToEndlessLoop=l;function f(ue){return!!ue.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=f;function i(ue){return(ue.global?"g":"")+(ue.ignoreCase?"i":"")+(ue.multiline?"m":"")+(ue.unicode?"u":"")}e.regExpFlags=i;function a(ue){return ue.split(/\r\n|\r|\n/)}e.splitLines=a;function n(ue){for(let Ce=0,Pe=ue.length;Ce<Pe;Ce++){const Ae=ue.charCodeAt(Ce);if(Ae!==32&&Ae!==9)return Ce}return-1}e.firstNonWhitespaceIndex=n;function o(ue,Ce=0,Pe=ue.length){for(let Ae=Ce;Ae<Pe;Ae++){const Le=ue.charCodeAt(Ae);if(Le!==32&&Le!==9)return ue.substring(Ce,Ae)}return ue.substring(Ce,Pe)}e.getLeadingWhitespace=o;function r(ue,Ce=ue.length-1){for(let Pe=Ce;Pe>=0;Pe--){const Ae=ue.charCodeAt(Pe);if(Ae!==32&&Ae!==9)return Pe}return-1}e.lastNonWhitespaceIndex=r;function s(ue,Ce,Pe){const Ae=[];let Le=0;for(const Ue of ue.matchAll(Ce)){if(Ae.push(ue.slice(Le,Ue.index)),Ue.index===void 0)throw new Error("match.index should be defined");Le=Ue.index+Ue[0].length,Ae.push(Pe(Ue[0],...Ue.slice(1),Ue.index,ue,Ue.groups))}return Ae.push(ue.slice(Le)),Promise.all(Ae).then(Ue=>Ue.join(""))}e.replaceAsync=s;function c(ue,Ce){return ue<Ce?-1:ue>Ce?1:0}e.compare=c;function u(ue,Ce,Pe=0,Ae=ue.length,Le=0,Ue=Ce.length){for(;Pe<Ae&&Le<Ue;Pe++,Le++){const et=ue.charCodeAt(Pe),nt=Ce.charCodeAt(Le);if(et<nt)return-1;if(et>nt)return 1}const Ve=Ae-Pe,Ke=Ue-Le;return Ve<Ke?-1:Ve>Ke?1:0}e.compareSubstring=u;function S(ue,Ce){return A(ue,Ce,0,ue.length,0,Ce.length)}e.compareIgnoreCase=S;function A(ue,Ce,Pe=0,Ae=ue.length,Le=0,Ue=Ce.length){for(;Pe<Ae&&Le<Ue;Pe++,Le++){let et=ue.charCodeAt(Pe),nt=Ce.charCodeAt(Le);if(et===nt)continue;if(et>=128||nt>=128)return u(ue.toLowerCase(),Ce.toLowerCase(),Pe,Ae,Le,Ue);$(et)&&(et-=32),$(nt)&&(nt-=32);const it=et-nt;if(it!==0)return it}const Ve=Ae-Pe,Ke=Ue-Le;return Ve<Ke?-1:Ve>Ke?1:0}e.compareSubstringIgnoreCase=A;function M(ue){return ue>=48&&ue<=57}e.isAsciiDigit=M;function $(ue){return ue>=97&&ue<=122}e.isLowerAsciiLetter=$;function Q(ue){return ue>=65&&ue<=90}e.isUpperAsciiLetter=Q;function _(ue,Ce){return ue.length===Ce.length&&A(ue,Ce)===0}e.equalsIgnoreCase=_;function q(ue,Ce){const Pe=Ce.length;return Ce.length>ue.length?!1:A(ue,Ce,0,Pe)===0}e.startsWithIgnoreCase=q;function U(ue,Ce){const Pe=Math.min(ue.length,Ce.length);let Ae;for(Ae=0;Ae<Pe;Ae++)if(ue.charCodeAt(Ae)!==Ce.charCodeAt(Ae))return Ae;return Pe}e.commonPrefixLength=U;function ne(ue,Ce){const Pe=Math.min(ue.length,Ce.length);let Ae;const Le=ue.length-1,Ue=Ce.length-1;for(Ae=0;Ae<Pe;Ae++)if(ue.charCodeAt(Le-Ae)!==Ce.charCodeAt(Ue-Ae))return Ae;return Pe}e.commonSuffixLength=ne;function Z(ue){return 55296<=ue&&ue<=56319}e.isHighSurrogate=Z;function F(ue){return 56320<=ue&&ue<=57343}e.isLowSurrogate=F;function x(ue,Ce){return(ue-55296<<10)+(Ce-56320)+65536}e.computeCodePoint=x;function z(ue,Ce,Pe){const Ae=ue.charCodeAt(Pe);if(Z(Ae)&&Pe+1<Ce){const Le=ue.charCodeAt(Pe+1);if(F(Le))return x(Ae,Le)}return Ae}e.getNextCodePoint=z;function W(ue,Ce){const Pe=ue.charCodeAt(Ce-1);if(F(Pe)&&Ce>1){const Ae=ue.charCodeAt(Ce-2);if(Z(Ae))return x(Ae,Pe)}return Pe}class re{constructor(Ce,Pe=0){this._str=Ce,this._len=Ce.length,this._offset=Pe}get offset(){return this._offset}setOffset(Ce){this._offset=Ce}prevCodePoint(){const Ce=W(this._str,this._offset);return this._offset-=Ce>=65536?2:1,Ce}nextCodePoint(){const Ce=z(this._str,this._len,this._offset);return this._offset+=Ce>=65536?2:1,Ce}eol(){return this._offset>=this._len}}e.CodePointIterator=re;class V{constructor(Ce,Pe=0){this._iterator=new re(Ce,Pe)}get offset(){return this._iterator.offset}nextGraphemeLength(){const Ce=Oe.getInstance(),Pe=this._iterator,Ae=Pe.offset;let Le=Ce.getGraphemeBreakType(Pe.nextCodePoint());for(;!Pe.eol();){const Ue=Pe.offset,Ve=Ce.getGraphemeBreakType(Pe.nextCodePoint());if(Se(Le,Ve)){Pe.setOffset(Ue);break}Le=Ve}return Pe.offset-Ae}prevGraphemeLength(){const Ce=Oe.getInstance(),Pe=this._iterator,Ae=Pe.offset;let Le=Ce.getGraphemeBreakType(Pe.prevCodePoint());for(;Pe.offset>0;){const Ue=Pe.offset,Ve=Ce.getGraphemeBreakType(Pe.prevCodePoint());if(Se(Ve,Le)){Pe.setOffset(Ue);break}Le=Ve}return Ae-Pe.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=V;function X(ue,Ce){return new V(ue,Ce).nextGraphemeLength()}e.nextCharLength=X;function ae(ue,Ce){return new V(ue,Ce).prevGraphemeLength()}e.prevCharLength=ae;function ie(ue,Ce){Ce>0&&F(ue.charCodeAt(Ce))&&Ce--;const Pe=Ce+X(ue,Ce);return[Pe-ae(ue,Pe),Pe]}e.getCharContainingOffset=ie;const O=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function B(ue){return O.test(ue)}e.containsRTL=B;const ee=/^[\t\n\r\x20-\x7E]*$/;function ce(ue){return ee.test(ue)}e.isBasicASCII=ce,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function K(ue){return e.UNUSUAL_LINE_TERMINATORS.test(ue)}e.containsUnusualLineTerminators=K;function he(ue){return ue>=11904&&ue<=55215||ue>=63744&&ue<=64255||ue>=65281&&ue<=65374}e.isFullWidthCharacter=he;function te(ue){return ue>=127462&&ue<=127487||ue===8986||ue===8987||ue===9200||ue===9203||ue>=9728&&ue<=10175||ue===11088||ue===11093||ue>=127744&&ue<=128591||ue>=128640&&ue<=128764||ue>=128992&&ue<=129008||ue>=129280&&ue<=129535||ue>=129648&&ue<=129782}e.isEmojiImprecise=te;function le(ue,Ce){if(ue.length<Ce)return ue;const Pe=/\b/g;let Ae=0;for(;Pe.test(ue)&&!(ue.length-Pe.lastIndex<Ce);)Ae=Pe.lastIndex,Pe.lastIndex+=1;return ue.substring(Ae).replace(/^\s/,"")}e.lcut=le;const de=/\x1B\x5B[12]?K/g,Y=/\x1b\[\d+m/g,J=/\x1b\[0?m/g;function H(ue){return ue&&(ue=ue.replace(de,""),ue=ue.replace(Y,""),ue=ue.replace(J,"")),ue}e.removeAnsiEscapeCodes=H,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function G(ue){return!!(ue&&ue.length>0&&ue.charCodeAt(0)===65279)}e.startsWithUTF8BOM=G;function fe(ue){return G(ue)?ue.substr(1):ue}e.stripUTF8BOM=fe;function pe(ue,Ce){if(!ue||!Ce||ue.length<Ce.length)return!1;const Pe=Ce.length,Ae=ue.toLowerCase();let Le=0,Ue=-1;for(;Le<Pe;){const Ve=Ae.indexOf(Ce[Le],Ue+1);if(Ve<0)return!1;Ue=Ve,Le++}return!0}e.fuzzyContains=pe;function ke(ue,Ce=!1){return ue?(Ce&&(ue=ue.replace(/\\./g,"")),ue.toLowerCase()!==ue):!1}e.containsUppercaseCharacter=ke;function Te(ue){return ue.charAt(0).toUpperCase()+ue.slice(1)}e.uppercaseFirstLetter=Te;function Me(ue,Ce=1){if(Ce===0)return"";let Pe=-1;do Pe=ue.indexOf(`
`,Pe+1),Ce--;while(Ce>0&&Pe>=0);return Pe===-1?ue:(ue[Pe-1]==="\r"&&Pe--,ue.substr(0,Pe))}e.getNLines=Me;function Be(ue){const Ce=90-65+1;return ue=ue%(2*Ce),ue<Ce?String.fromCharCode(97+ue):String.fromCharCode(65+ue-Ce)}e.singleLetterHash=Be;function ge(ue){return Oe.getInstance().getGraphemeBreakType(ue)}e.getGraphemeBreakType=ge;function Se(ue,Ce){return ue===0?Ce!==5&&Ce!==7:ue===2&&Ce===3?!1:ue===4||ue===2||ue===3||Ce===4||Ce===2||Ce===3?!0:!(ue===8&&(Ce===8||Ce===9||Ce===11||Ce===12)||(ue===11||ue===9)&&(Ce===9||Ce===10)||(ue===12||ue===10)&&Ce===10||Ce===5||Ce===13||Ce===7||ue===1||ue===13&&Ce===14||ue===6&&Ce===6)}var ye;(function(ue){ue[ue.Other=0]="Other",ue[ue.Prepend=1]="Prepend",ue[ue.CR=2]="CR",ue[ue.LF=3]="LF",ue[ue.Control=4]="Control",ue[ue.Extend=5]="Extend",ue[ue.Regional_Indicator=6]="Regional_Indicator",ue[ue.SpacingMark=7]="SpacingMark",ue[ue.L=8]="L",ue[ue.V=9]="V",ue[ue.T=10]="T",ue[ue.LV=11]="LV",ue[ue.LVT=12]="LVT",ue[ue.ZWJ=13]="ZWJ",ue[ue.Extended_Pictographic=14]="Extended_Pictographic"})(ye=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Oe{constructor(){this._data=Ne()}static getInstance(){return Oe._INSTANCE||(Oe._INSTANCE=new Oe),Oe._INSTANCE}getGraphemeBreakType(Ce){if(Ce<32)return Ce===10?3:Ce===13?2:4;if(Ce<127)return 0;const Pe=this._data,Ae=Pe.length/3;let Le=1;for(;Le<=Ae;)if(Ce<Pe[3*Le])Le=2*Le;else if(Ce>Pe[3*Le+1])Le=2*Le+1;else return Pe[3*Le+2];return 0}}Oe._INSTANCE=null;function Ne(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Je(ue,Ce){if(ue===0)return 0;const Pe=$e(ue,Ce);if(Pe!==void 0)return Pe;const Ae=new re(Ce,ue);return Ae.prevCodePoint(),Ae.offset}e.getLeftDeleteOffset=Je;function $e(ue,Ce){const Pe=new re(Ce,ue);let Ae=Pe.prevCodePoint();for(;He(Ae)||Ae===65039||Ae===8419;){if(Pe.offset===0)return;Ae=Pe.prevCodePoint()}if(!te(Ae))return;let Le=Pe.offset;return Le>0&&Pe.prevCodePoint()===8205&&(Le=Pe.offset),Le}function He(ue){return 127995<=ue&&ue<=127999}var We;(function(ue){ue[ue.zwj=8205]="zwj",ue[ue.emojiVariantSelector=65039]="emojiVariantSelector",ue[ue.enclosingKeyCap=8419]="enclosingKeyCap"})(We||(We={})),e.noBreakWhitespace="\xA0";class je{constructor(Ce){this.confusableDictionary=Ce}static getInstance(Ce){return je.cache.get(Array.from(Ce))}static getLocales(){return je._locales.getValue()}isAmbiguous(Ce){return this.confusableDictionary.has(Ce)}getPrimaryConfusable(Ce){return this.confusableDictionary.get(Ce)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=je,v=je,je.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),je.cache=new I.LRUCachedFunction(ue=>{function Ce(nt){const it=new Map;for(let rt=0;rt<nt.length;rt+=2)it.set(nt[rt],nt[rt+1]);return it}function Pe(nt,it){const rt=new Map(nt);for(const[dt,pt]of it)rt.set(dt,pt);return rt}function Ae(nt,it){if(!nt)return it;const rt=new Map;for(const[dt,pt]of nt)it.has(dt)&&rt.set(dt,pt);return rt}const Le=v.ambiguousCharacterData.getValue();let Ue=ue.filter(nt=>!nt.startsWith("_")&&nt in Le);Ue.length===0&&(Ue=["_default"]);let Ve;for(const nt of Ue){const it=Ce(Le[nt]);Ve=Ae(Ve,it)}const Ke=Ce(Le._common),et=Pe(Ke,Ve);return new je(et)}),je._locales=new t.Lazy(()=>Object.keys(je.ambiguousCharacterData.getValue()).filter(ue=>!ue.startsWith("_")));class Ge{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Ge.getRawData())),this._data}static isInvisibleCharacter(Ce){return Ge.getData().has(Ce)}static get codePoints(){return Ge.getData()}}e.InvisibleCharacters=Ge,Ge._data=void 0}),define(ve[33],we([0,1,5,3,15,12]),function(oe,e,I,t,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function k(r){return r===47||r===92}e.isPathSeparator=k;function w(r){return r.replace(/[\\/]/g,I.posix.sep)}e.toSlashes=w;function p(r){return r.indexOf("/")===-1&&(r=w(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=p;function D(r,s=I.posix.sep){if(!r)return"";const c=r.length,u=r.charCodeAt(0);if(k(u)){if(k(r.charCodeAt(1))&&!k(r.charCodeAt(2))){let A=3;const M=A;for(;A<c&&!k(r.charCodeAt(A));A++);if(M!==A&&!k(r.charCodeAt(A+1))){for(A+=1;A<c;A++)if(k(r.charCodeAt(A)))return r.slice(0,A+1).replace(/[\\/]/g,s)}}return s}else if(m(u)&&r.charCodeAt(1)===58)return k(r.charCodeAt(2))?r.slice(0,2)+s:r.slice(0,2);let S=r.indexOf("://");if(S!==-1){for(S+=3;S<c;S++)if(k(r.charCodeAt(S)))return r.slice(0,S+1)}return""}e.getRoot=D;function T(r){if(!t.isWindows||!r||r.length<5)return!1;let s=r.charCodeAt(0);if(s!==92||(s=r.charCodeAt(1),s!==92))return!1;let c=2;const u=c;for(;c<r.length&&(s=r.charCodeAt(c),s!==92);c++);return!(u===c||(s=r.charCodeAt(c+1),isNaN(s)||s===92))}e.isUNC=T;const R=/[\\/:\*\?"<>\|]/g,E=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(r,s=t.isWindows){const c=s?R:E;return!(!r||r.length===0||/^\s+$/.test(r)||(c.lastIndex=0,c.test(r))||s&&b.test(r)||r==="."||r===".."||s&&r[r.length-1]==="."||s&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=d;function C(r,s,c){const u=r===s;return!c||u?u:!r||!s?!1:(0,v.equalsIgnoreCase)(r,s)}e.isEqual=C;function y(r,s,c,u=I.sep){if(r===s)return!0;if(!r||!s||s.length>r.length)return!1;if(c){if(!(0,v.startsWithIgnoreCase)(r,s))return!1;if(s.length===r.length)return!0;let A=s.length;return s.charAt(s.length-1)===u&&A--,r.charAt(A)===u}return s.charAt(s.length-1)!==u&&(s+=u),r.indexOf(s)===0}e.isEqualOrParent=y;function m(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=m;function g(r,s){return t.isWindows&&r.endsWith(":")&&(r+=I.sep),(0,I.isAbsolute)(r)||(r=(0,I.join)(s,r)),r=(0,I.normalize)(r),t.isWindows?(r=(0,v.rtrim)(r,I.sep),r.endsWith(":")&&(r+=I.sep)):(r=(0,v.rtrim)(r,I.sep),r||(r=I.sep)),r}e.sanitizeFilePath=g;function h(r){const s=(0,I.normalize)(r);return t.isWindows?r.length>3?!1:l(s)&&(r.length===2||s.charCodeAt(2)===92):s===I.posix.sep}e.isRootOrDriveLetter=h;function l(r,s=t.isWindows){return s?m(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=l;function f(r){return l(r)?r[0]:void 0}e.getDriveLetter=f;function i(r,s,c){return s.length>r.length?-1:r===s?0:(c&&(r=r.toLowerCase(),s=s.toLowerCase()),r.indexOf(s))}e.indexOfPath=i;function a(r){const s=r.split(":");let c,u,S;for(const A of s){const M=Number(A);(0,P.isNumber)(M)?u===void 0?u=M:S===void 0&&(S=M):c=c?[c,A].join(":"):A}if(!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:u!==void 0?u:void 0,column:S!==void 0?S:u!==void 0?1:void 0}}e.parseLineAndColumnAware=a;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function o(r,s,c=8){let u="";for(let A=0;A<c;A++)u+=n.charAt(Math.floor(Math.random()*n.length));let S;return s?S=`${s}-${u}`:S=u,r?(0,I.join)(r,S):S}e.randomPath=o}),define(ve[86],we([0,1,15]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(m){return v(m,0)}e.hash=t;function v(m,g){switch(typeof m){case"object":return m===null?P(349,g):Array.isArray(m)?p(m,g):D(m,g);case"string":return w(m,g);case"boolean":return k(m,g);case"number":return P(m,g);case"undefined":return P(937,g);default:return P(617,g)}}e.doHash=v;function P(m,g){return(g<<5)-g+m|0}e.numberHash=P;function k(m,g){return P(m?433:863,g)}function w(m,g){g=P(149417,g);for(let h=0,l=m.length;h<l;h++)g=P(m.charCodeAt(h),g);return g}e.stringHash=w;function p(m,g){return g=P(104579,g),m.reduce((h,l)=>v(l,h),g)}function D(m,g){return g=P(181387,g),Object.keys(m).sort().reduce((h,l)=>(h=w(l,h),v(m[l],h)),g)}class T{constructor(){this._value=0}get value(){return this._value}hash(g){return this._value=v(g,this._value),this._value}}e.Hasher=T;var R;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(R||(R={}));function E(m,g,h=32){const l=h-g,f=~((1<<l)-1);return(m<<g|(f&m)>>>l)>>>0}function b(m,g=0,h=m.byteLength,l=0){for(let f=0;f<h;f++)m[g+f]=l}function d(m,g,h="0"){for(;m.length<g;)m=h+m;return m}function C(m,g=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(h=>h.toString(16).padStart(2,"0")).join(""):d((m>>>0).toString(16),g/4)}e.toHexString=C;class y{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(g){const h=g.length;if(h===0)return;const l=this._buff;let f=this._buffLen,i=this._leftoverHighSurrogate,a,n;for(i!==0?(a=i,n=-1,i=0):(a=g.charCodeAt(0),n=0);;){let o=a;if(I.isHighSurrogate(a))if(n+1<h){const r=g.charCodeAt(n+1);I.isLowSurrogate(r)?(n++,o=I.computeCodePoint(a,r)):o=65533}else{i=a;break}else I.isLowSurrogate(a)&&(o=65533);if(f=this._push(l,f,o),n++,n<h)a=g.charCodeAt(n);else break}this._buffLen=f,this._leftoverHighSurrogate=i}_push(g,h,l){return l<128?g[h++]=l:l<2048?(g[h++]=192|(l&1984)>>>6,g[h++]=128|(l&63)>>>0):l<65536?(g[h++]=224|(l&61440)>>>12,g[h++]=128|(l&4032)>>>6,g[h++]=128|(l&63)>>>0):(g[h++]=240|(l&1835008)>>>18,g[h++]=128|(l&258048)>>>12,g[h++]=128|(l&4032)>>>6,g[h++]=128|(l&63)>>>0),h>=64&&(this._step(),h-=64,this._totalLen+=64,g[0]=g[64+0],g[1]=g[64+1],g[2]=g[64+2]),h}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),C(this._h0)+C(this._h1)+C(this._h2)+C(this._h3)+C(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,b(this._buff,this._buffLen),this._buffLen>56&&(this._step(),b(this._buff));const g=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(g/4294967296),!1),this._buffDV.setUint32(60,g%4294967296,!1),this._step()}_step(){const g=y._bigBlock32,h=this._buffDV;for(let c=0;c<64;c+=4)g.setUint32(c,h.getUint32(c,!1),!1);for(let c=64;c<320;c+=4)g.setUint32(c,E(g.getUint32(c-12,!1)^g.getUint32(c-32,!1)^g.getUint32(c-56,!1)^g.getUint32(c-64,!1),1),!1);let l=this._h0,f=this._h1,i=this._h2,a=this._h3,n=this._h4,o,r,s;for(let c=0;c<80;c++)c<20?(o=f&i|~f&a,r=1518500249):c<40?(o=f^i^a,r=1859775393):c<60?(o=f&i|f&a|i&a,r=2400959708):(o=f^i^a,r=3395469782),s=E(l,5)+o+n+r+g.getUint32(c*4,!1)&4294967295,n=a,a=i,i=E(f,30),f=l,l=s;this._h0=this._h0+l&4294967295,this._h1=this._h1+f&4294967295,this._h2=this._h2+i&4294967295,this._h3=this._h3+a&4294967295,this._h4=this._h4+n&4294967295}}e.StringSHA1=y,y._bigBlock32=new DataView(new ArrayBuffer(320))});var Dt=this&&this.__classPrivateFieldSet||function(oe,e,I,t,v){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!v)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!v:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?v.call(oe,I):v?v.value=I:e.set(oe,I),I},tt=this&&this.__classPrivateFieldGet||function(oe,e,I,t){if(I==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!t:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return I==="m"?t:I==="a"?t.call(oe):t?t.value:e.get(oe)};define(ve[29],we([0,1,18,15]),function(oe,e,I,t){"use strict";var v,P,k,w;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function p(r,s,c){let u=r.get(s);return u===void 0&&(u=c,r.set(s,u)),u}e.getOrSet=p;function D(r){const s=[];return r.forEach((c,u)=>{s.push(`${u} => ${c}`)}),`Map(${r.size}) {${s.join(", ")}}`}e.mapToString=D;function T(r){const s=[];return r.forEach(c=>{s.push(c)}),`Set(${r.size}) {${s.join(", ")}}`}e.setToString=T;class R{constructor(){this._value="",this._pos=0}reset(s){return this._value=s,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(s){const c=s.charCodeAt(0),u=this._value.charCodeAt(this._pos);return c-u}value(){return this._value[this._pos]}}e.StringIterator=R;class E{constructor(s=!0){this._caseSensitive=s}reset(s){return this._value=s,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let s=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(s)this._from++;else break;else s=!1;return this}cmp(s){return this._caseSensitive?(0,t.compareSubstring)(s,this._value,0,s.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=E;class b{constructor(s=!0,c=!0){this._splitOnBackslash=s,this._caseSensitive=c}reset(s){this._from=0,this._to=0,this._value=s,this._valueLen=s.length;for(let c=s.length-1;c>=0;c--,this._valueLen--){const u=this._value.charCodeAt(c);if(!(u===47||this._splitOnBackslash&&u===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let s=!0;for(;this._to<this._valueLen;this._to++){const c=this._value.charCodeAt(this._to);if(c===47||this._splitOnBackslash&&c===92)if(s)this._from++;else break;else s=!1}return this}cmp(s){return this._caseSensitive?(0,t.compareSubstring)(s,this._value,0,s.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=b;var d;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(d||(d={}));class C{constructor(s,c){this._ignorePathCasing=s,this._ignoreQueryAndFragment=c,this._states=[],this._stateIdx=0}reset(s){return this._value=s,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new b(!1,!this._ignorePathCasing(s)),this._pathIterator.reset(s.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(s)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(s){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(s,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(s,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(s);if(this._states[this._stateIdx]===4)return(0,t.compare)(s,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(s,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=C;class y{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const s=this.right;return this.right=s.left,s.left=this,this.updateHeight(),s.updateHeight(),s}rotateRight(){const s=this.left;return this.left=s.right,s.right=this,this.updateHeight(),s.updateHeight(),s}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var m;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(m||(m={}));class g{constructor(s){this._iter=s}static forUris(s=()=>!1,c=()=>!1){return new g(new C(s,c))}static forPaths(s=!1){return new g(new b(void 0,!s))}static forStrings(){return new g(new R)}static forConfigKeys(){return new g(new E)}clear(){this._root=void 0}fill(s,c){if(c){const u=c.slice(0);(0,I.shuffle)(u);for(const S of u)this.set(S,s)}else{const u=s.slice(0);(0,I.shuffle)(u);for(const S of u)this.set(S[0],S[1])}}set(s,c){const u=this._iter.reset(s);let S;this._root||(this._root=new y,this._root.segment=u.value());const A=[];for(S=this._root;;){const $=u.cmp(S.segment);if($>0)S.left||(S.left=new y,S.left.segment=u.value()),A.push([-1,S]),S=S.left;else if($<0)S.right||(S.right=new y,S.right.segment=u.value()),A.push([1,S]),S=S.right;else if(u.hasNext())u.next(),S.mid||(S.mid=new y,S.mid.segment=u.value()),A.push([0,S]),S=S.mid;else break}const M=S.value;S.value=c,S.key=s;for(let $=A.length-1;$>=0;$--){const Q=A[$][1];Q.updateHeight();const _=Q.balanceFactor();if(_<-1||_>1){const q=A[$][0],U=A[$+1][0];if(q===1&&U===1)A[$][1]=Q.rotateLeft();else if(q===-1&&U===-1)A[$][1]=Q.rotateRight();else if(q===1&&U===-1)Q.right=A[$+1][1]=A[$+1][1].rotateRight(),A[$][1]=Q.rotateLeft();else if(q===-1&&U===1)Q.left=A[$+1][1]=A[$+1][1].rotateLeft(),A[$][1]=Q.rotateRight();else throw new Error;if($>0)switch(A[$-1][0]){case-1:A[$-1][1].left=A[$][1];break;case 1:A[$-1][1].right=A[$][1];break;case 0:A[$-1][1].mid=A[$][1];break}else this._root=A[0][1]}}return M}get(s){return this._getNode(s)?.value}_getNode(s){const c=this._iter.reset(s);let u=this._root;for(;u;){const S=c.cmp(u.segment);if(S>0)u=u.left;else if(S<0)u=u.right;else if(c.hasNext())c.next(),u=u.mid;else break}return u}has(s){const c=this._getNode(s);return!(c?.value===void 0&&c?.mid===void 0)}delete(s){return this._delete(s,!1)}deleteSuperstr(s){return this._delete(s,!0)}_delete(s,c){const u=this._iter.reset(s),S=[];let A=this._root;for(;A;){const M=u.cmp(A.segment);if(M>0)S.push([-1,A]),A=A.left;else if(M<0)S.push([1,A]),A=A.right;else if(u.hasNext())u.next(),S.push([0,A]),A=A.mid;else break}if(!!A){if(c?(A.left=void 0,A.mid=void 0,A.right=void 0,A.height=1):(A.key=void 0,A.value=void 0),!A.mid&&!A.value)if(A.left&&A.right){const M=this._min(A.right),{key:$,value:Q,segment:_}=M;this._delete(M.key,!1),A.key=$,A.value=Q,A.segment=_}else{const M=A.left??A.right;if(S.length>0){const[$,Q]=S[S.length-1];switch($){case-1:Q.left=M;break;case 0:Q.mid=M;break;case 1:Q.right=M;break}}else this._root=M}for(let M=S.length-1;M>=0;M--){const $=S[M][1];$.updateHeight();const Q=$.balanceFactor();if(Q>1?($.right.balanceFactor()>=0||($.right=$.right.rotateRight()),S[M][1]=$.rotateLeft()):Q<-1&&($.left.balanceFactor()<=0||($.left=$.left.rotateLeft()),S[M][1]=$.rotateRight()),M>0)switch(S[M-1][0]){case-1:S[M-1][1].left=S[M][1];break;case 1:S[M-1][1].right=S[M][1];break;case 0:S[M-1][1].mid=S[M][1];break}else this._root=S[0][1]}}}_min(s){for(;s.left;)s=s.left;return s}findSubstr(s){const c=this._iter.reset(s);let u=this._root,S;for(;u;){const A=c.cmp(u.segment);if(A>0)u=u.left;else if(A<0)u=u.right;else if(c.hasNext())c.next(),S=u.value||S,u=u.mid;else break}return u&&u.value||S}findSuperstr(s){const c=this._iter.reset(s);let u=this._root;for(;u;){const S=c.cmp(u.segment);if(S>0)u=u.left;else if(S<0)u=u.right;else if(c.hasNext())c.next(),u=u.mid;else return u.mid?this._entries(u.mid):void 0}}forEach(s){for(const[c,u]of this)s(u,c)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(s){!s||(s.left&&(yield*this._entries(s.left)),s.value&&(yield[s.key,s.value]),s.mid&&(yield*this._entries(s.mid)),s.right&&(yield*this._entries(s.right)))}_isBalanced(){const s=c=>{if(!c)return!0;const u=c.balanceFactor();return u<-1||u>1?!1:s(c.left)&&s(c.right)};return s(this._root)}}e.TernarySearchTree=g;class h{constructor(s,c){this.uri=s,this.value=c}}class l{constructor(s,c){this[v]="ResourceMap",s instanceof l?(this.map=new Map(s.map),this.toKey=c??l.defaultToKey):(this.map=new Map,this.toKey=s??l.defaultToKey)}set(s,c){return this.map.set(this.toKey(s),new h(s,c)),this}get(s){return this.map.get(this.toKey(s))?.value}has(s){return this.map.has(this.toKey(s))}get size(){return this.map.size}clear(){this.map.clear()}delete(s){return this.map.delete(this.toKey(s))}forEach(s,c){typeof c!="undefined"&&(s=s.bind(c));for(const[u,S]of this.map)s(S.value,S.uri,this)}*values(){for(const s of this.map.values())yield s.value}*keys(){for(const s of this.map.values())yield s.uri}*entries(){for(const s of this.map.values())yield[s.uri,s.value]}*[(v=Symbol.toStringTag,Symbol.iterator)](){for(const[,s]of this.map)yield[s.uri,s.value]}}e.ResourceMap=l,l.defaultToKey=r=>r.toString();class f{constructor(s,c){this[P]="ResourceSet",!s||typeof s=="function"?this._map=new l(s):(this._map=new l(c),s.forEach(this.add,this))}get size(){return this._map.size}add(s){return this._map.set(s,s),this}clear(){this._map.clear()}delete(s){return this._map.delete(s)}forEach(s,c){this._map.forEach((u,S)=>s.call(c,S,S,this))}has(s){return this._map.has(s)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=f;var i;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(i=e.Touch||(e.Touch={}));class a{constructor(){this[k]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(s){return this._map.has(s)}get(s,c=0){const u=this._map.get(s);if(!!u)return c!==0&&this.touch(u,c),u.value}set(s,c,u=0){let S=this._map.get(s);if(S)S.value=c,u!==0&&this.touch(S,u);else{switch(S={key:s,value:c,next:void 0,previous:void 0},u){case 0:this.addItemLast(S);break;case 1:this.addItemFirst(S);break;case 2:this.addItemLast(S);break;default:this.addItemLast(S);break}this._map.set(s,S),this._size++}return this}delete(s){return!!this.remove(s)}remove(s){const c=this._map.get(s);if(!!c)return this._map.delete(s),this.removeItem(c),this._size--,c.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const s=this._head;return this._map.delete(s.key),this.removeItem(s),this._size--,s.value}forEach(s,c){const u=this._state;let S=this._head;for(;S;){if(c?s.bind(c)(S.value,S.key,this):s(S.value,S.key,this),this._state!==u)throw new Error("LinkedMap got modified during iteration.");S=S.next}}keys(){const s=this,c=this._state;let u=this._head;const S={[Symbol.iterator](){return S},next(){if(s._state!==c)throw new Error("LinkedMap got modified during iteration.");if(u){const A={value:u.key,done:!1};return u=u.next,A}else return{value:void 0,done:!0}}};return S}values(){const s=this,c=this._state;let u=this._head;const S={[Symbol.iterator](){return S},next(){if(s._state!==c)throw new Error("LinkedMap got modified during iteration.");if(u){const A={value:u.value,done:!1};return u=u.next,A}else return{value:void 0,done:!0}}};return S}entries(){const s=this,c=this._state;let u=this._head;const S={[Symbol.iterator](){return S},next(){if(s._state!==c)throw new Error("LinkedMap got modified during iteration.");if(u){const A={value:[u.key,u.value],done:!1};return u=u.next,A}else return{value:void 0,done:!0}}};return S}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(s){if(s>=this.size)return;if(s===0){this.clear();return}let c=this._head,u=this.size;for(;c&&u>s;)this._map.delete(c.key),c=c.next,u--;this._head=c,this._size=u,c&&(c.previous=void 0),this._state++}addItemFirst(s){if(!this._head&&!this._tail)this._tail=s;else if(this._head)s.next=this._head,this._head.previous=s;else throw new Error("Invalid list");this._head=s,this._state++}addItemLast(s){if(!this._head&&!this._tail)this._head=s;else if(this._tail)s.previous=this._tail,this._tail.next=s;else throw new Error("Invalid list");this._tail=s,this._state++}removeItem(s){if(s===this._head&&s===this._tail)this._head=void 0,this._tail=void 0;else if(s===this._head){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this._head=s.next}else if(s===this._tail){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this._tail=s.previous}else{const c=s.next,u=s.previous;if(!c||!u)throw new Error("Invalid list");c.previous=u,u.next=c}s.next=void 0,s.previous=void 0,this._state++}touch(s,c){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(c!==1&&c!==2)){if(c===1){if(s===this._head)return;const u=s.next,S=s.previous;s===this._tail?(S.next=void 0,this._tail=S):(u.previous=S,S.next=u),s.previous=void 0,s.next=this._head,this._head.previous=s,this._head=s,this._state++}else if(c===2){if(s===this._tail)return;const u=s.next,S=s.previous;s===this._head?(u.previous=void 0,this._head=u):(u.previous=S,S.next=u),s.next=void 0,s.previous=this._tail,this._tail.next=s,this._tail=s,this._state++}}}toJSON(){const s=[];return this.forEach((c,u)=>{s.push([u,c])}),s}fromJSON(s){this.clear();for(const[c,u]of s)this.set(c,u)}}e.LinkedMap=a;class n extends a{constructor(s,c=1){super();this._limit=s,this._ratio=Math.min(Math.max(0,c),1)}get limit(){return this._limit}set limit(s){this._limit=s,this.checkTrim()}get ratio(){return this._ratio}set ratio(s){this._ratio=Math.min(Math.max(0,s),1),this.checkTrim()}get(s,c=2){return super.get(s,c)}peek(s){return super.get(s,0)}set(s,c){return super.set(s,c,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=n;class o{constructor(s){w.set(this,void 0),Dt(this,w,s,"f")}get size(){return tt(this,w,"f").size}forEach(s,c){tt(this,w,"f").forEach(s,c)}get(s){return tt(this,w,"f").get(s)}has(s){return tt(this,w,"f").has(s)}entries(){return tt(this,w,"f").entries()}keys(){return tt(this,w,"f").keys()}values(){return tt(this,w,"f").values()}[(w=new WeakMap,Symbol.iterator)](){return tt(this,w,"f").entries()}}e.ReadonlyMapView=o}),define(ve[147],we([0,1,29,15]),function(oe,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function v(...H){return function(G,fe){for(let pe=0,ke=H.length;pe<ke;pe++){const Te=H[pe](G,fe);if(Te)return Te}return null}}e.or=v,e.matchesStrictPrefix=P.bind(void 0,!1),e.matchesPrefix=P.bind(void 0,!0);function P(H,G,fe){if(!fe||fe.length<G.length)return null;let pe;return H?pe=t.startsWithIgnoreCase(fe,G):pe=fe.indexOf(G)===0,pe?G.length>0?[{start:0,end:G.length}]:[]:null}function k(H,G){const fe=G.toLowerCase().indexOf(H.toLowerCase());return fe===-1?null:[{start:fe,end:fe+H.length}]}e.matchesContiguousSubString=k;function w(H,G){return p(H.toLowerCase(),G.toLowerCase(),0,0)}e.matchesSubString=w;function p(H,G,fe,pe){if(fe===H.length)return[];if(pe===G.length)return null;if(H[fe]===G[pe]){let ke=null;return(ke=p(H,G,fe+1,pe+1))?m({start:pe,end:pe+1},ke):null}return p(H,G,fe,pe+1)}function D(H){return 97<=H&&H<=122}function T(H){return 65<=H&&H<=90}e.isUpper=T;function R(H){return 48<=H&&H<=57}function E(H){return H===32||H===9||H===10||H===13}const b=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(H=>b.add(H.charCodeAt(0)));function d(H){return E(H)||b.has(H)}function C(H,G){return H===G||d(H)&&d(G)}function y(H){return D(H)||T(H)||R(H)}function m(H,G){return G.length===0?G=[H]:H.end===G[0].start?G[0].start=H.start:G.unshift(H),G}function g(H,G){for(let fe=G;fe<H.length;fe++){const pe=H.charCodeAt(fe);if(T(pe)||R(pe)||fe>0&&!y(H.charCodeAt(fe-1)))return fe}return H.length}function h(H,G,fe,pe){if(fe===H.length)return[];if(pe===G.length)return null;if(H[fe]!==G[pe].toLowerCase())return null;{let ke=null,Te=pe+1;for(ke=h(H,G,fe+1,pe+1);!ke&&(Te=g(G,Te))<G.length;)ke=h(H,G,fe+1,Te),Te++;return ke===null?null:m({start:pe,end:pe+1},ke)}}function l(H){let G=0,fe=0,pe=0,ke=0,Te=0;for(let ye=0;ye<H.length;ye++)Te=H.charCodeAt(ye),T(Te)&&G++,D(Te)&&fe++,y(Te)&&pe++,R(Te)&&ke++;const Me=G/H.length,Be=fe/H.length,ge=pe/H.length,Se=ke/H.length;return{upperPercent:Me,lowerPercent:Be,alphaPercent:ge,numericPercent:Se}}function f(H){const{upperPercent:G,lowerPercent:fe}=H;return fe===0&&G>.6}function i(H){const{upperPercent:G,lowerPercent:fe,alphaPercent:pe,numericPercent:ke}=H;return fe>.2&&G<.8&&pe>.6&&ke<.2}function a(H){let G=0,fe=0,pe=0,ke=0;for(let Te=0;Te<H.length;Te++)pe=H.charCodeAt(Te),T(pe)&&G++,D(pe)&&fe++,E(pe)&&ke++;return(G===0||fe===0)&&ke===0?H.length<=30:G<=5}function n(H,G){if(!G||(G=G.trim(),G.length===0)||!a(H)||G.length>60)return null;const fe=l(G);if(!i(fe)){if(!f(fe))return null;G=G.toLowerCase()}let pe=null,ke=0;for(H=H.toLowerCase();ke<G.length&&(pe=h(H,G,0,ke))===null;)ke=g(G,ke+1);return pe}e.matchesCamelCase=n;function o(H,G,fe=!1){if(!G||G.length===0)return null;let pe=null,ke=0;for(H=H.toLowerCase(),G=G.toLowerCase();ke<G.length&&(pe=r(H,G,0,ke,fe))===null;)ke=s(G,ke+1);return pe}e.matchesWords=o;function r(H,G,fe,pe,ke){if(fe===H.length)return[];if(pe===G.length)return null;if(C(H.charCodeAt(fe),G.charCodeAt(pe))){let Te=null,Me=pe+1;if(Te=r(H,G,fe+1,pe+1,ke),!ke)for(;!Te&&(Me=s(G,Me))<G.length;)Te=r(H,G,fe+1,Me,ke),Me++;return Te===null?null:m({start:pe,end:pe+1},Te)}else return null}function s(H,G){for(let fe=G;fe<H.length;fe++)if(d(H.charCodeAt(fe))||fe>0&&d(H.charCodeAt(fe-1)))return fe;return H.length}const c=v(e.matchesPrefix,n,k),u=v(e.matchesPrefix,n,w),S=new I.LRUCache(1e4);function A(H,G,fe=!1){if(typeof H!="string"||typeof G!="string")return null;let pe=S.get(H);pe||(pe=new RegExp(t.convertSimple2RegExpPattern(H),"i"),S.set(H,pe));const ke=pe.exec(G);return ke?[{start:ke.index,end:ke.index+ke[0].length}]:fe?u(H,G):c(H,G)}e.matchesFuzzy=A;function M(H,G){const fe=K(H,H.toLowerCase(),0,G,G.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return fe?Q(fe):null}e.matchesFuzzy2=M;function $(H,G,fe,pe,ke,Te){const Me=Math.min(13,H.length);for(;fe<Me;fe++){const Be=K(H,G,fe,pe,ke,Te,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(Be)return Be}return[0,Te]}e.anyScore=$;function Q(H){if(typeof H=="undefined")return[];const G=[],fe=H[1];for(let pe=H.length-1;pe>1;pe--){const ke=H[pe]+fe,Te=G[G.length-1];Te&&Te.end===ke?Te.end=ke+1:G.push({start:ke,end:ke+1})}return G}e.createMatches=Q;const _=128;function q(){const H=[],G=[];for(let fe=0;fe<=_;fe++)G[fe]=0;for(let fe=0;fe<=_;fe++)H.push(G.slice(0));return H}function U(H){const G=[];for(let fe=0;fe<=H;fe++)G[fe]=0;return G}const ne=U(2*_),Z=U(2*_),F=q(),x=q(),z=q(),W=!1;function re(H,G,fe,pe,ke){function Te(Be,ge,Se=" "){for(;Be.length<ge;)Be=Se+Be;return Be}let Me=` |   |${pe.split("").map(Be=>Te(Be,3)).join("|")}
`;for(let Be=0;Be<=fe;Be++)Be===0?Me+=" |":Me+=`${G[Be-1]}|`,Me+=H[Be].slice(0,ke+1).map(ge=>Te(ge.toString(),3)).join("|")+`
`;return Me}function V(H,G,fe,pe){H=H.substr(G),fe=fe.substr(pe),console.log(re(x,H,H.length,fe,fe.length)),console.log(re(z,H,H.length,fe,fe.length)),console.log(re(F,H,H.length,fe,fe.length))}function X(H,G){if(G<0||G>=H.length)return!1;const fe=H.codePointAt(G);switch(fe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!t.isEmojiImprecise(fe)}}function ae(H,G){if(G<0||G>=H.length)return!1;switch(H.charCodeAt(G)){case 32:case 9:return!0;default:return!1}}function ie(H,G,fe){return G[H]!==fe[H]}function O(H,G,fe,pe,ke,Te,Me=!1){for(;G<fe&&ke<Te;)H[G]===pe[ke]&&(Me&&(ne[G]=ke),G+=1),ke+=1;return G===fe}e.isPatternInWord=O;var B;(function(H){H[H.Diag=1]="Diag",H[H.Left=2]="Left",H[H.LeftLeft=3]="LeftLeft"})(B||(B={}));var ee;(function(H){H.Default=[-100,0];function G(fe){return!fe||fe.length===2&&fe[0]===-100&&fe[1]===0}H.isDefault=G})(ee=e.FuzzyScore||(e.FuzzyScore={}));class ce{constructor(G,fe){this.firstMatchCanBeWeak=G,this.boostFullMatch=fe}}e.FuzzyScoreOptions=ce,ce.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function K(H,G,fe,pe,ke,Te,Me=ce.default){const Be=H.length>_?_:H.length,ge=pe.length>_?_:pe.length;if(fe>=Be||Te>=ge||Be-fe>ge-Te||!O(G,fe,Be,ke,Te,ge,!0))return;he(Be,ge,fe,Te,G,ke);let Se=1,ye=1,Oe=fe,Ne=Te;const Je=[!1];for(Se=1,Oe=fe;Oe<Be;Se++,Oe++){const Ge=ne[Oe],ue=Z[Oe],Ce=Oe+1<Be?Z[Oe+1]:ge;for(ye=Ge-Te+1,Ne=Ge;Ne<Ce;ye++,Ne++){let Pe=Number.MIN_SAFE_INTEGER,Ae=!1;Ne<=ue&&(Pe=te(H,G,Oe,fe,pe,ke,Ne,ge,Te,F[Se-1][ye-1]===0,Je));let Le=0;Pe!==Number.MAX_SAFE_INTEGER&&(Ae=!0,Le=Pe+x[Se-1][ye-1]);const Ue=Ne>Ge,Ve=Ue?x[Se][ye-1]+(F[Se][ye-1]>0?-5:0):0,Ke=Ne>Ge+1&&F[Se][ye-1]>0,et=Ke?x[Se][ye-2]+(F[Se][ye-2]>0?-5:0):0;if(Ke&&(!Ue||et>=Ve)&&(!Ae||et>=Le))x[Se][ye]=et,z[Se][ye]=3,F[Se][ye]=0;else if(Ue&&(!Ae||Ve>=Le))x[Se][ye]=Ve,z[Se][ye]=2,F[Se][ye]=0;else if(Ae)x[Se][ye]=Le,z[Se][ye]=1,F[Se][ye]=F[Se-1][ye-1]+1;else throw new Error("not possible")}}if(W&&V(H,fe,pe,Te),!Je[0]&&!Me.firstMatchCanBeWeak)return;Se--,ye--;const $e=[x[Se][ye],Te];let He=0,We=0;for(;Se>=1;){let Ge=ye;do{const ue=z[Se][Ge];if(ue===3)Ge=Ge-2;else if(ue===2)Ge=Ge-1;else break}while(Ge>=1);He>1&&G[fe+Se-1]===ke[Te+ye-1]&&!ie(Ge+Te-1,pe,ke)&&He+1>F[Se][Ge]&&(Ge=ye),Ge===ye?He++:He=1,We||(We=Ge),Se--,ye=Ge-1,$e.push(ye)}ge===Be&&Me.boostFullMatch&&($e[0]+=2);const je=We-Be;return $e[0]-=je,$e}e.fuzzyScore=K;function he(H,G,fe,pe,ke,Te){let Me=H-1,Be=G-1;for(;Me>=fe&&Be>=pe;)ke[Me]===Te[Be]&&(Z[Me]=Be,Me--),Be--}function te(H,G,fe,pe,ke,Te,Me,Be,ge,Se,ye){if(G[fe]!==Te[Me])return Number.MIN_SAFE_INTEGER;let Oe=1,Ne=!1;return Me===fe-pe?Oe=H[fe]===ke[Me]?7:5:ie(Me,ke,Te)&&(Me===0||!ie(Me-1,ke,Te))?(Oe=H[fe]===ke[Me]?7:5,Ne=!0):X(Te,Me)&&(Me===0||!X(Te,Me-1))?Oe=5:(X(Te,Me-1)||ae(Te,Me-1))&&(Oe=5,Ne=!0),Oe>1&&fe===pe&&(ye[0]=!0),Ne||(Ne=ie(Me,ke,Te)||X(Te,Me-1)||ae(Te,Me-1)),fe===pe?Me>ge&&(Oe-=Ne?3:5):Se?Oe+=Ne?2:0:Oe+=Ne?0:1,Me+1===Be&&(Oe-=Ne?3:5),Oe}function le(H,G,fe,pe,ke,Te,Me){return Y(H,G,fe,pe,ke,Te,!0,Me)}e.fuzzyScoreGracefulAggressive=le;function de(H,G,fe,pe,ke,Te,Me){return Y(H,G,fe,pe,ke,Te,!1,Me)}e.fuzzyScoreGraceful=de;function Y(H,G,fe,pe,ke,Te,Me,Be){let ge=K(H,G,fe,pe,ke,Te,Be);if(ge&&!Me)return ge;if(H.length>=3){const Se=Math.min(7,H.length-1);for(let ye=fe+1;ye<Se;ye++){const Oe=J(H,ye);if(Oe){const Ne=K(Oe,Oe.toLowerCase(),fe,pe,ke,Te,Be);Ne&&(Ne[0]-=3,(!ge||Ne[0]>ge[0])&&(ge=Ne))}}}return ge}function J(H,G){if(G+1>=H.length)return;const fe=H[G],pe=H[G+1];if(fe!==pe)return H.slice(0,G)+pe+fe+H.slice(G+2)}}),define(ve[148],we([0,1,40,147,15]),function(oe,e,I,t,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const P=new RegExp(`\\$\\(${I.CSSIcon.iconNameExpression}(?:${I.CSSIcon.iconModifierExpression})?\\)`,"g"),k=new RegExp(I.CSSIcon.iconNameCharacter),w=new RegExp(`(\\\\)?${P.source}`,"g");function p(y){return y.replace(w,(m,g)=>g?m:`\\${m}`)}e.escapeIcons=p;const D=new RegExp(`\\\\${P.source}`,"g");function T(y){return y.replace(D,m=>`\\${m}`)}e.markdownEscapeEscapedIcons=T;const R=new RegExp(`(\\s)?(\\\\)?${P.source}(\\s)?`,"g");function E(y){return y.indexOf(e.iconStartMarker)===-1?y:y.replace(R,(m,g,h,l)=>h?m:g||l||"")}e.stripIcons=E;function b(y){const m=y.indexOf(e.iconStartMarker);return m===-1?{text:y}:d(y,m)}e.parseLabelWithIcons=b;function d(y,m){const g=[];let h="";function l(c){if(c){h+=c;for(const u of c)g.push(a)}}let f=-1,i="",a=0,n,o,r=m;const s=y.length;for(l(y.substr(0,m));r<s;)n=y[r],o=y[r+1],n===e.iconStartMarker[0]&&o===e.iconStartMarker[1]?(f=r,l(i),i=e.iconStartMarker,r++):n===")"&&f!==-1?(a+=r-f+1,f=-1,i=""):f!==-1?k.test(n)?i+=n:(l(i),f=-1,i=""):l(n),r++;return l(i),{text:h,iconOffsets:g}}function C(y,m,g=!1){const{text:h,iconOffsets:l}=m;if(!l||l.length===0)return(0,t.matchesFuzzy)(y,h,g);const f=(0,v.ltrim)(h," "),i=h.length-f.length,a=(0,t.matchesFuzzy)(y,f,g);if(a)for(const n of a){const o=l[n.start+i]+i;n.start+=o,n.end+=o}return a}e.matchesFuzzyIconAware=C}),define(ve[87],we([0,1,29]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new I.LRUCache(1e4);function v(D){return p(D,"NFC",t)}e.normalizeNFC=v;const P=new I.LRUCache(1e4);function k(D){return p(D,"NFD",P)}e.normalizeNFD=k;const w=/[^\u0000-\u0080]/;function p(D,T,R){if(!D)return D;const E=R.get(D);if(E)return E;let b;return w.test(D)?b=D.normalize(T):b=D,R.set(D,b),b}e.removeAccents=function(){const D=/[\u0300-\u036f]/g;return function(T){return k(T).replace(D,"")}}()}),define(ve[68],we([0,1,15]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(v){v[v.Ignore=0]="Ignore",v[v.Info=1]="Info",v[v.Warning=2]="Warning",v[v.Error=3]="Error"})(t||(t={})),function(v){const P="error",k="warning",w="warn",p="info",D="ignore";function T(E){return E?I.equalsIgnoreCase(P,E)?v.Error:I.equalsIgnoreCase(k,E)||I.equalsIgnoreCase(w,E)?v.Warning:I.equalsIgnoreCase(p,E)?v.Info:v.Ignore:v.Ignore}v.fromValue=T;function R(E){switch(E){case v.Error:return P;case v.Warning:return k;case v.Info:return p;default:return D}}v.toString=R}(t||(t={})),e.default=t}),define(ve[4],we([0,1,5,3]),function(oe,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const v=/^\w[\w\d+.-]*$/,P=/^\//,k=/^\/\//;function w(n,o){if(!n.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!v.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!P.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(k.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function p(n,o){return!n&&!o?"file":n}function D(n,o){switch(n){case"https":case"http":case"file":o?o[0]!==R&&(o=R+o):o=R;break}return o}const T="",R="/",E=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class b{constructor(o,r,s,c,u,S=!1){typeof o=="object"?(this.scheme=o.scheme||T,this.authority=o.authority||T,this.path=o.path||T,this.query=o.query||T,this.fragment=o.fragment||T):(this.scheme=p(o,S),this.authority=r||T,this.path=D(this.scheme,s||T),this.query=c||T,this.fragment=u||T,w(this,S))}static isUri(o){return o instanceof b?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}get fsPath(){return h(this,!1)}with(o){if(!o)return this;let{scheme:r,authority:s,path:c,query:u,fragment:S}=o;return r===void 0?r=this.scheme:r===null&&(r=T),s===void 0?s=this.authority:s===null&&(s=T),c===void 0?c=this.path:c===null&&(c=T),u===void 0?u=this.query:u===null&&(u=T),S===void 0?S=this.fragment:S===null&&(S=T),r===this.scheme&&s===this.authority&&c===this.path&&u===this.query&&S===this.fragment?this:new C(r,s,c,u,S)}static parse(o,r=!1){const s=E.exec(o);return s?new C(s[2]||T,a(s[4]||T),a(s[5]||T),a(s[7]||T),a(s[9]||T),r):new C(T,T,T,T,T)}static file(o){let r=T;if(t.isWindows&&(o=o.replace(/\\/g,R)),o[0]===R&&o[1]===R){const s=o.indexOf(R,2);s===-1?(r=o.substring(2),o=R):(r=o.substring(2,s),o=o.substring(s)||R)}return new C("file",r,o,T,T)}static from(o){const r=new C(o.scheme,o.authority,o.path,o.query,o.fragment);return w(r,!0),r}static joinPath(o,...r){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let s;return t.isWindows&&o.scheme==="file"?s=b.file(I.win32.join(h(o,!0),...r)).path:s=I.posix.join(o.path,...r),o.with({path:s})}toString(o=!1){return l(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof b)return o;{const r=new C(o);return r._formatted=o.external,r._fsPath=o._sep===d?o.fsPath:null,r}}else return o}}e.URI=b;const d=t.isWindows?1:void 0;class C extends b{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=h(this,!1)),this._fsPath}toString(o=!1){return o?l(this,!0):(this._formatted||(this._formatted=l(this,!1)),this._formatted)}toJSON(){const o={$mid:1};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=d),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const y={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function m(n,o){let r,s=-1;for(let c=0;c<n.length;c++){const u=n.charCodeAt(c);if(u>=97&&u<=122||u>=65&&u<=90||u>=48&&u<=57||u===45||u===46||u===95||u===126||o&&u===47)s!==-1&&(r+=encodeURIComponent(n.substring(s,c)),s=-1),r!==void 0&&(r+=n.charAt(c));else{r===void 0&&(r=n.substr(0,c));const S=y[u];S!==void 0?(s!==-1&&(r+=encodeURIComponent(n.substring(s,c)),s=-1),r+=S):s===-1&&(s=c)}}return s!==-1&&(r+=encodeURIComponent(n.substring(s))),r!==void 0?r:n}function g(n){let o;for(let r=0;r<n.length;r++){const s=n.charCodeAt(r);s===35||s===63?(o===void 0&&(o=n.substr(0,r)),o+=y[s]):o!==void 0&&(o+=n[r])}return o!==void 0?o:n}function h(n,o){let r;return n.authority&&n.path.length>1&&n.scheme==="file"?r=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?o?r=n.path.substr(1):r=n.path[1].toLowerCase()+n.path.substr(2):r=n.path,t.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=h;function l(n,o){const r=o?g:m;let s="",{scheme:c,authority:u,path:S,query:A,fragment:M}=n;if(c&&(s+=c,s+=":"),(u||c==="file")&&(s+=R,s+=R),u){let $=u.indexOf("@");if($!==-1){const Q=u.substr(0,$);u=u.substr($+1),$=Q.indexOf(":"),$===-1?s+=r(Q,!1):(s+=r(Q.substr(0,$),!1),s+=":",s+=r(Q.substr($+1),!1)),s+="@"}u=u.toLowerCase(),$=u.indexOf(":"),$===-1?s+=r(u,!1):(s+=r(u.substr(0,$),!1),s+=u.substr($))}if(S){if(S.length>=3&&S.charCodeAt(0)===47&&S.charCodeAt(2)===58){const $=S.charCodeAt(1);$>=65&&$<=90&&(S=`/${String.fromCharCode($+32)}:${S.substr(3)}`)}else if(S.length>=2&&S.charCodeAt(1)===58){const $=S.charCodeAt(0);$>=65&&$<=90&&(S=`${String.fromCharCode($+32)}:${S.substr(2)}`)}s+=r(S,!0)}return A&&(s+="?",s+=r(A,!1)),M&&(s+="#",s+=o?M:m(M,!1)),s}function f(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+f(n.substr(3)):n}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function a(n){return n.match(i)?n.replace(i,o=>f(o)):n}}),define(ve[149],we([0,1,4]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function t(D){const T=D;return T&&typeof T.type=="string"&&typeof T.severity=="string"}e.isRemoteConsoleLog=t;function v(D){const T=[];let R;try{const E=JSON.parse(D.arguments),b=E[E.length-1];b&&b.__$stack&&(E.pop(),R=b.__$stack),T.push(...E)}catch{T.push("Unable to log remote console arguments",D.arguments)}return{args:T,stack:R}}e.parse=v;function P(D){if(typeof D!="string")return P(v(D).stack);const T=D;if(T){const R=k(T),E=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(R||"");if(E&&E.length===4)return{uri:I.URI.file(E[1]),line:Number(E[2]),column:Number(E[3])}}}e.getFirstFrame=P;function k(D){if(!D)return D;const T=D.indexOf(`
`);return T===-1?D:D.substring(0,T)}function w(D,T){const{args:R,stack:E}=v(D),b=typeof R[0]=="string"&&R.length===1;let d=k(E);d&&(d=`(${d.trim()})`);let C=[];if(typeof R[0]=="string"?d&&b?C=[`%c[${T}] %c${R[0]} %c${d}`,p("blue"),p(""),p("grey")]:C=[`%c[${T}] %c${R[0]}`,p("blue"),p(""),...R.slice(1)]:C=[`%c[${T}]%`,p("blue"),...R],d&&!b&&C.push(d),typeof console[D.severity]!="function")throw new Error("Unknown console method");console[D.severity].apply(console,C)}e.log=w;function p(D){return`color: ${D}`}}),define(ve[41],we([0,1,16,15,4]),function(oe,e,I,t,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function P(D){return JSON.stringify(D,w)}e.stringify=P;function k(D){let T=JSON.parse(D);return T=p(T),T}e.parse=k;function w(D,T){return T instanceof RegExp?{$mid:2,source:T.source,flags:(0,t.regExpFlags)(T)}:T}function p(D,T=0){if(!D||T>200)return D;if(typeof D=="object"){switch(D.$mid){case 1:return v.URI.revive(D);case 2:return new RegExp(D.source,D.flags);case 14:return new Date(D.source)}if(D instanceof I.VSBuffer||D instanceof Uint8Array)return D;if(Array.isArray(D))for(let R=0;R<D.length;++R)D[R]=p(D[R],T+1);else for(const R in D)Object.hasOwnProperty.call(D,R)&&(D[R]=p(D[R],T+1))}return D}e.revive=p}),define(ve[10],we([0,1,3,4]),function(oe,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var v;(function(w){w.inMemory="inmemory",w.vscode="vscode",w.internal="private",w.walkThrough="walkThrough",w.walkThroughSnippet="walkThroughSnippet",w.http="http",w.https="https",w.file="file",w.mailto="mailto",w.untitled="untitled",w.data="data",w.command="command",w.vscodeRemote="vscode-remote",w.vscodeRemoteResource="vscode-remote-resource",w.vscodeUserData="vscode-userdata",w.vscodeCustomEditor="vscode-custom-editor",w.vscodeNotebook="vscode-notebook",w.vscodeNotebookCell="vscode-notebook-cell",w.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",w.vscodeNotebookCellOutput="vscode-notebook-cell-output",w.vscodeInteractive="vscode-interactive",w.vscodeInteractiveInput="vscode-interactive-input",w.vscodeSettings="vscode-settings",w.vscodeWorkspaceTrust="vscode-workspace-trust",w.vscodeTerminal="vscode-terminal",w.webviewPanel="webview-panel",w.vscodeWebview="vscode-webview",w.extension="extension",w.vscodeFileResource="vscode-file",w.tmp="tmp",w.vsls="vsls"})(v=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class P{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${v.vscodeRemoteResource}`}setPreferredWebSchema(p){this._preferredWebSchema=p}setDelegate(p){this._delegate=p}setServerRootPath(p){this._remoteResourcesPath=`${p}/${v.vscodeRemoteResource}`}set(p,D,T){this._hosts[p]=D,this._ports[p]=T}setConnectionToken(p,D){this._connectionTokens[p]=D}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(p){if(this._delegate)return this._delegate(p);const D=p.authority;let T=this._hosts[D];T&&T.indexOf(":")!==-1&&(T=`[${T}]`);const R=this._ports[D],E=this._connectionTokens[D];let b=`path=${encodeURIComponent(p.path)}`;return typeof E=="string"&&(b+=`&${e.connectionTokenQueryName}=${encodeURIComponent(E)}`),t.URI.from({scheme:I.isWeb?this._preferredWebSchema:v.vscodeRemoteResource,authority:`${T}:${R}`,path:this._remoteResourcesPath,query:b})}}e.RemoteAuthorities=new P;class k{asBrowserUri(p,D){const T=this.toUri(p,D);return T.scheme===v.vscodeRemote?e.RemoteAuthorities.rewrite(T):T.scheme===v.file&&(I.isNative||I.isWebWorker&&I.globals.origin===`${v.vscodeFileResource}://${k.FALLBACK_AUTHORITY}`)?T.with({scheme:v.vscodeFileResource,authority:T.authority||k.FALLBACK_AUTHORITY,query:null,fragment:null}):T}asFileUri(p,D){const T=this.toUri(p,D);return T.scheme===v.vscodeFileResource?T.with({scheme:v.file,authority:T.authority!==k.FALLBACK_AUTHORITY?T.authority:null,query:null,fragment:null}):T}toUri(p,D){return t.URI.isUri(p)?p:t.URI.parse(D.toUrl(p))}}k.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new k}),define(ve[19],we([0,1,33,10,5,3,15,4]),function(oe,e,I,t,v,P,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function p(b){return(0,w.uriToFsPath)(b,!0)}e.originalFSPath=p;class D{constructor(d){this._ignorePathCasing=d}compare(d,C,y=!1){return d===C?0:(0,k.compare)(this.getComparisonKey(d,y),this.getComparisonKey(C,y))}isEqual(d,C,y=!1){return d===C?!0:!d||!C?!1:this.getComparisonKey(d,y)===this.getComparisonKey(C,y)}getComparisonKey(d,C=!1){return d.with({path:this._ignorePathCasing(d)?d.path.toLowerCase():void 0,fragment:C?null:void 0}).toString()}ignorePathCasing(d){return this._ignorePathCasing(d)}isEqualOrParent(d,C,y=!1){if(d.scheme===C.scheme){if(d.scheme===t.Schemas.file)return I.isEqualOrParent(p(d),p(C),this._ignorePathCasing(d))&&d.query===C.query&&(y||d.fragment===C.fragment);if((0,e.isEqualAuthority)(d.authority,C.authority))return I.isEqualOrParent(d.path,C.path,this._ignorePathCasing(d),"/")&&d.query===C.query&&(y||d.fragment===C.fragment)}return!1}joinPath(d,...C){return w.URI.joinPath(d,...C)}basenameOrAuthority(d){return(0,e.basename)(d)||d.authority}basename(d){return v.posix.basename(d.path)}extname(d){return v.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let C;return d.scheme===t.Schemas.file?C=w.URI.file(v.dirname(p(d))).path:(C=v.posix.dirname(d.path),d.authority&&C.length&&C.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),C="/")),d.with({path:C})}normalizePath(d){if(!d.path.length)return d;let C;return d.scheme===t.Schemas.file?C=w.URI.file(v.normalize(p(d))).path:C=v.posix.normalize(d.path),d.with({path:C})}relativePath(d,C){if(d.scheme!==C.scheme||!(0,e.isEqualAuthority)(d.authority,C.authority))return;if(d.scheme===t.Schemas.file){const g=v.relative(p(d),p(C));return P.isWindows?I.toSlashes(g):g}let y=d.path||"/";const m=C.path||"/";if(this._ignorePathCasing(d)){let g=0;for(const h=Math.min(y.length,m.length);g<h&&!(y.charCodeAt(g)!==m.charCodeAt(g)&&y.charAt(g).toLowerCase()!==m.charAt(g).toLowerCase());g++);y=m.substr(0,g)+y.substr(g)}return v.posix.relative(y,m)}resolvePath(d,C){if(d.scheme===t.Schemas.file){const y=w.URI.file(v.resolve(p(d),C));return d.with({authority:y.authority,path:y.path})}return C=I.toPosixPath(C),d.with({path:v.posix.resolve(d.path,C)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,C){return d===C||d!==void 0&&C!==void 0&&(0,k.equalsIgnoreCase)(d,C)}hasTrailingPathSeparator(d,C=v.sep){if(d.scheme===t.Schemas.file){const y=p(d);return y.length>I.getRoot(y).length&&y[y.length-1]===C}else{const y=d.path;return y.length>1&&y.charCodeAt(y.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,C=v.sep){return(0,e.hasTrailingPathSeparator)(d,C)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,C=v.sep){let y=!1;if(d.scheme===t.Schemas.file){const m=p(d);y=m!==void 0&&m.length===I.getRoot(m).length&&m[m.length-1]===C}else{C="/";const m=d.path;y=m.length===1&&m.charCodeAt(m.length-1)===47}return!y&&!(0,e.hasTrailingPathSeparator)(d,C)?d.with({path:d.path+"/"}):d}}e.ExtUri=D,e.extUri=new D(()=>!1),e.extUriBiasedIgnorePathCase=new D(b=>b.scheme===t.Schemas.file?!P.isLinux:!0),e.extUriIgnorePathCase=new D(b=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function T(b,d){const C=[];for(let y=0;y<b.length;y++){const m=d(b[y]);b.some((g,h)=>h===y?!1:(0,e.isEqualOrParent)(m,d(g)))||C.push(b[y])}return C}e.distinctParents=T;var R;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function d(C){const y=new Map;C.path.substring(C.path.indexOf(";")+1,C.path.lastIndexOf(";")).split(";").forEach(h=>{const[l,f]=h.split(":");l&&f&&y.set(l,f)});const g=C.path.substring(0,C.path.indexOf(";"));return g&&y.set(b.META_DATA_MIME,g),y}b.parseMetaData=d})(R=e.DataUri||(e.DataUri={}));function E(b,d,C){if(d){let y=b.path;return y&&y[0]!==v.posix.sep&&(y=v.posix.sep+y),b.with({scheme:C,authority:d,path:y})}return b.with({scheme:C})}e.toLocalResource=E}),define(ve[14],we([0,1,20,11,7,2,19,3]),function(oe,e,I,t,v,P,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function p(ie){return!!ie&&typeof ie.then=="function"}e.isThenable=p;function D(ie){const O=new I.CancellationTokenSource,B=ie(O.token),ee=new Promise((ce,K)=>{const he=O.token.onCancellationRequested(()=>{he.dispose(),O.dispose(),K(new t.CancellationError)});Promise.resolve(B).then(te=>{he.dispose(),O.dispose(),ce(te)},te=>{he.dispose(),O.dispose(),K(te)})});return new class{cancel(){O.cancel()}then(ce,K){return ee.then(ce,K)}catch(ce){return this.then(void 0,ce)}finally(ce){return ee.finally(ce)}}}e.createCancelablePromise=D;function T(ie,O,B){return new Promise((ee,ce)=>{const K=O.onCancellationRequested(()=>{K.dispose(),ee(B)});ie.then(ee,ce).finally(()=>K.dispose())})}e.raceCancellation=T;function R(ie,O){return new Promise((B,ee)=>{const ce=O.onCancellationRequested(()=>{ce.dispose(),ee(new t.CancellationError)});ie.then(B,ee).finally(()=>ce.dispose())})}e.raceCancellationError=R;async function E(ie){let O=-1;const B=ie.map((ce,K)=>ce.then(he=>(O=K,he))),ee=await Promise.race(B);return ie.forEach((ce,K)=>{K!==O&&ce.cancel()}),ee}e.raceCancellablePromises=E;function b(ie,O,B){let ee;const ce=setTimeout(()=>{ee?.(void 0),B?.()},O);return Promise.race([ie.finally(()=>clearTimeout(ce)),new Promise(K=>ee=K)])}e.raceTimeout=b;function d(ie){return new Promise((O,B)=>{const ee=ie();p(ee)?ee.then(O,B):O(ee)})}e.asPromise=d;class C{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(O){if(this.activePromise){if(this.queuedPromiseFactory=O,!this.queuedPromise){const B=()=>{this.queuedPromise=null;const ee=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,ee};this.queuedPromise=new Promise(ee=>{this.activePromise.then(B,B).then(ee)})}return new Promise((B,ee)=>{this.queuedPromise.then(B,ee)})}return this.activePromise=O(),new Promise((B,ee)=>{this.activePromise.then(ce=>{this.activePromise=null,B(ce)},ce=>{this.activePromise=null,ee(ce)})})}}e.Throttler=C;class y{constructor(){this.current=Promise.resolve(null)}queue(O){return this.current=this.current.then(()=>O(),()=>O())}}e.Sequencer=y;class m{constructor(){this.promiseMap=new Map}queue(O,B){const ce=(this.promiseMap.get(O)??Promise.resolve()).catch(()=>{}).then(B).finally(()=>{this.promiseMap.get(O)===ce&&this.promiseMap.delete(O)});return this.promiseMap.set(O,ce),ce}}e.SequencerByKey=m;const g=(ie,O)=>{let B=!0;const ee=setTimeout(()=>{B=!1,O()},ie);return{isTriggered:()=>B,dispose:()=>{clearTimeout(ee),B=!1}}},h=ie=>{let O=!0;return queueMicrotask(()=>{O&&(O=!1,ie())}),{isTriggered:()=>O,dispose:()=>{O=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class l{constructor(O){this.defaultDelay=O,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(O,B=this.defaultDelay){this.task=O,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((ce,K)=>{this.doResolve=ce,this.doReject=K}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const ce=this.task;return this.task=null,ce()}}));const ee=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=B===e.MicrotaskDelay?h(ee):g(B,ee),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=l;class f{constructor(O){this.delayer=new l(O),this.throttler=new C}trigger(O,B){return this.delayer.trigger(()=>this.throttler.queue(O),B)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=f;class i{constructor(){this._isOpen=!1,this._promise=new Promise((O,B)=>{this._completePromise=O})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=i;class a extends i{constructor(O){super();this._timeout=setTimeout(()=>this.open(),O)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=a;function n(ie,O){return O?new Promise((B,ee)=>{const ce=setTimeout(()=>{K.dispose(),B()},ie),K=O.onCancellationRequested(()=>{clearTimeout(ce),K.dispose(),ee(new t.CancellationError)})}):D(B=>n(ie,B))}e.timeout=n;function o(ie,O=0){const B=setTimeout(ie,O);return(0,P.toDisposable)(()=>clearTimeout(B))}e.disposableTimeout=o;function r(ie){const O=[];let B=0;const ee=ie.length;function ce(){return B<ee?ie[B++]():null}function K(he){he!=null&&O.push(he);const te=ce();return te?te.then(K):Promise.resolve(O)}return Promise.resolve(null).then(K)}e.sequence=r;function s(ie,O=ee=>!!ee,B=null){let ee=0;const ce=ie.length,K=()=>{if(ee>=ce)return Promise.resolve(B);const he=ie[ee++];return Promise.resolve(he()).then(le=>O(le)?Promise.resolve(le):K())};return K()}e.first=s;function c(ie,O=ee=>!!ee,B=null){if(ie.length===0)return Promise.resolve(B);let ee=ie.length;const ce=()=>{ee=-1;for(const K of ie)K.cancel?.()};return new Promise((K,he)=>{for(const te of ie)te.then(le=>{--ee>=0&&O(le)?(ce(),K(le)):ee===0&&K(B)}).catch(le=>{--ee>=0&&(ce(),he(le))})})}e.firstParallel=c;class u{constructor(O){this._size=0,this.maxDegreeOfParalellism=O,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new v.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(O){return this._size++,new Promise((B,ee)=>{this.outstandingPromises.push({factory:O,c:B,e:ee}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const O=this.outstandingPromises.shift();this.runningPromises++;const B=O.factory();B.then(O.c,O.e),B.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=u;class S extends u{constructor(){super(1)}}e.Queue=S;class A{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const O=new z;return this.drainers.add(O),O.p}isDrained(){for(const[,O]of this.queues)if(O.size>0)return!1;return!0}queueFor(O,B=k.extUri){const ee=B.getComparisonKey(O);let ce=this.queues.get(ee);return ce||(ce=new S,v.Event.once(ce.onDrained)(()=>{ce?.dispose(),this.queues.delete(ee),this.onDidQueueDrain()}),this.queues.set(ee,ce)),ce}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const O of this.drainers)O.complete();this.drainers.clear()}dispose(){for(const[,O]of this.queues)O.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=A;class M{constructor(O,B){this._token=-1,typeof O=="function"&&typeof B=="number"&&this.setIfNotSet(O,B)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(O,B){this.cancel(),this._token=setTimeout(()=>{this._token=-1,O()},B)}setIfNotSet(O,B){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,O()},B))}}e.TimeoutTimer=M;class ${constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(O,B){this.cancel(),this._token=setInterval(()=>{O()},B)}}e.IntervalTimer=$;class Q{constructor(O,B){this.timeoutToken=-1,this.runner=O,this.timeout=B,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(O=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,O)}get delay(){return this.timeout}set delay(O){this.timeout=O}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=Q;class _{constructor(O,B){B%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${B}ms is not a multiple of 1000ms.`),this.runner=O,this.timeout=B,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(O=this.timeout){O%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${O}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(O/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=_;class q extends Q{constructor(O,B){super(O,B);this.units=[]}work(O){this.units.push(O),this.isScheduled()||this.schedule()}doRun(){const O=this.units;this.units=[],this.runner?.(O)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=q;class U extends P.Disposable{constructor(O,B){super();this.options=O,this.handler=B,this.pendingWork=[],this.throttler=this._register(new P.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(O){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+O.length>this.options.maxBufferedWork)return!1}else if(this.pending+O.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...O),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new Q(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=U,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=ie=>{(0,w.setTimeout0)(()=>{if(O)return;const B=Date.now()+15;ie(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,B-Date.now())}}))});let O=!1;return{dispose(){O||(O=!0)}}}:e.runWhenIdle=(ie,O)=>{const B=requestIdleCallback(ie,typeof O=="number"?{timeout:O}:void 0);let ee=!1;return{dispose(){ee||(ee=!0,cancelIdleCallback(B))}}}}();class ne{constructor(O){this._didRun=!1,this._executor=()=>{try{this._value=O()}catch(B){this._error=B}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=ne;async function Z(ie,O,B){let ee;for(let ce=0;ce<B;ce++)try{return await ie()}catch(K){ee=K,await n(O)}throw ee}e.retry=Z;class F{hasPending(O){return this._pending?typeof O=="number"?this._pending.taskId===O:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(O,B,ee){return this._pending={taskId:O,cancel:()=>ee?.(),promise:B},B.then(()=>this.donePending(O),()=>this.donePending(O)),B}donePending(O){this._pending&&O===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const O=this._next;this._next=void 0,O.run().then(O.promiseResolve,O.promiseReject)}}setNext(O){if(this._next)this._next.run=O;else{let B,ee;const ce=new Promise((K,he)=>{B=K,ee=he});this._next={run:O,promise:ce,promiseResolve:B,promiseReject:ee}}return this._next.promise}}e.TaskSequentializer=F;class x{constructor(O,B=()=>Date.now()){this.interval=O,this.nowFn=B,this.lastIncrementTime=0,this.value=0}increment(){const O=this.nowFn();return O-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=O,this.value=0),this.value++,this.value}}e.IntervalCounter=x;class z{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((O,B)=>{this.completeCallback=O,this.errorCallback=B})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(O){return new Promise(B=>{this.completeCallback(O),this.resolved=!0,B()})}error(O){return new Promise(B=>{this.errorCallback(O),this.rejected=!0,B()})}cancel(){new Promise(O=>{this.errorCallback(new t.CancellationError),this.rejected=!0,O()})}}e.DeferredPromise=z;var W;(function(ie){async function O(ee){let ce;const K=await Promise.all(ee.map(he=>he.then(te=>te,te=>{ce||(ce=te)})));if(typeof ce!="undefined")throw ce;return K}ie.settled=O;function B(ee){return new Promise(async(ce,K)=>{try{await ee(ce,K)}catch(he){K(he)}})}ie.withAsyncBody=B})(W=e.Promises||(e.Promises={}));var re;(function(ie){ie[ie.Initial=0]="Initial",ie[ie.DoneOK=1]="DoneOK",ie[ie.DoneError=2]="DoneError"})(re||(re={}));class V{constructor(O){this._state=0,this._results=[],this._error=null,this._onStateChanged=new v.Emitter,queueMicrotask(async()=>{const B={emitOne:ee=>this.emitOne(ee),emitMany:ee=>this.emitMany(ee),reject:ee=>this.reject(ee)};try{await Promise.resolve(O(B)),this.resolve()}catch(ee){this.reject(ee)}finally{B.emitOne=void 0,B.emitMany=void 0,B.reject=void 0}})}static fromArray(O){return new V(B=>{B.emitMany(O)})}static fromPromise(O){return new V(async B=>{B.emitMany(await O)})}static fromPromises(O){return new V(async B=>{await Promise.all(O.map(async ee=>B.emitOne(await ee)))})}static merge(O){return new V(async B=>{await Promise.all(O.map(async ee=>{for await(const ce of ee)B.emitOne(ce)}))})}[Symbol.asyncIterator](){let O=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(O<this._results.length)return{done:!1,value:this._results[O++]};if(this._state===1)return{done:!0,value:void 0};await v.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(O,B){return new V(async ee=>{for await(const ce of O)ee.emitOne(B(ce))})}map(O){return V.map(this,O)}static filter(O,B){return new V(async ee=>{for await(const ce of O)B(ce)&&ee.emitOne(ce)})}filter(O){return V.filter(this,O)}static coalesce(O){return V.filter(O,B=>!!B)}coalesce(){return V.coalesce(this)}static async toPromise(O){const B=[];for await(const ee of O)B.push(ee);return B}toPromise(){return V.toPromise(this)}emitOne(O){this._state===0&&(this._results.push(O),this._onStateChanged.fire())}emitMany(O){this._state===0&&(this._results=this._results.concat(O),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(O){this._state===0&&(this._state=2,this._error=O,this._onStateChanged.fire())}}e.AsyncIterableObject=V,V.EMPTY=V.fromArray([]);class X extends V{constructor(O,B){super(B);this._source=O}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=X;function ae(ie){const O=new I.CancellationTokenSource,B=ie(O.token);return new X(O,async ee=>{const ce=O.token.onCancellationRequested(()=>{ce.dispose(),O.dispose(),ee.reject(new t.CancellationError)});try{for await(const K of B){if(O.token.isCancellationRequested)return;ee.emitOne(K)}ce.dispose(),O.dispose()}catch(K){ce.dispose(),O.dispose(),ee.reject(K)}})}e.createCancelableAsyncIterable=ae}),define(ve[69],we([0,1,18,14,33,29,5,3,15]),function(oe,e,I,t,v,P,k,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function D(){return Object.create(null)}e.getEmptyExpression=D,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const T="[/\\\\]",R="[^/\\\\]",E=/\//g;function b(z,W){switch(z){case 0:return"";case 1:return`${R}*?`;default:return`(?:${T}|${R}+${T}${W?`|${T}${R}+`:""})*?`}}function d(z,W){if(!z)return[];const re=[];let V=!1,X=!1,ae="";for(const ie of z){switch(ie){case W:if(!V&&!X){re.push(ae),ae="";continue}break;case"{":V=!0;break;case"}":V=!1;break;case"[":X=!0;break;case"]":X=!1;break}ae+=ie}return ae&&re.push(ae),re}e.splitGlobAware=d;function C(z){if(!z)return"";let W="";const re=d(z,e.GLOB_SPLIT);if(re.every(V=>V===e.GLOBSTAR))W=".*";else{let V=!1;re.forEach((X,ae)=>{if(X===e.GLOBSTAR){if(V)return;W+=b(2,ae===re.length-1)}else{let ie=!1,O="",B=!1,ee="";for(const ce of X){if(ce!=="}"&&ie){O+=ce;continue}if(B&&(ce!=="]"||!ee)){let K;ce==="-"?K=ce:(ce==="^"||ce==="!")&&!ee?K="^":ce===e.GLOB_SPLIT?K="":K=(0,p.escapeRegExpCharacters)(ce),ee+=K;continue}switch(ce){case"{":ie=!0;continue;case"[":B=!0;continue;case"}":{W+=`(?:${d(O,",").map(te=>C(te)).join("|")})`,ie=!1,O="";break}case"]":{W+="["+ee+"]",B=!1,ee="";break}case"?":W+=R;continue;case"*":W+=b(1);continue;default:W+=(0,p.escapeRegExpCharacters)(ce)}}ae<re.length-1&&(re[ae+1]!==e.GLOBSTAR||ae+2<re.length)&&(W+=T)}V=X===e.GLOBSTAR})}return W}const y=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,g=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,h=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,l=/^\*\*((\/[\w\.-]+)+)\/?$/,f=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new P.LRUCache(1e4),a=function(){return!1},n=function(){return null};function o(z,W){if(!z)return n;let re;typeof z!="string"?re=z.pattern:re=z,re=re.trim();const V=`${re}_${!!W.trimForExclusions}`;let X=i.get(V);if(X)return r(X,z);let ae;return y.test(re)?X=c(re.substr(4),re):(ae=m.exec(s(re,W)))?X=u(ae[1],re):(W.trimForExclusions?h:g).test(re)?X=S(re,W):(ae=l.exec(s(re,W)))?X=A(ae[1].substr(1),re,!0):(ae=f.exec(s(re,W)))?X=A(ae[1],re,!1):X=M(re),i.set(V,X),r(X,z)}function r(z,W){if(typeof W=="string")return z;const re=function(V,X){return(0,v.isEqualOrParent)(V,W.base,!w.isLinux)?z(V.substr(W.base.length+1),X):null};return re.allBasenames=z.allBasenames,re.allPaths=z.allPaths,re.basenames=z.basenames,re.patterns=z.patterns,re}function s(z,W){return W.trimForExclusions&&z.endsWith("/**")?z.substr(0,z.length-2):z}function c(z,W){return function(re,V){return typeof re=="string"&&re.endsWith(z)?W:null}}function u(z,W){const re=`/${z}`,V=`\\${z}`,X=function(ie,O){return typeof ie!="string"?null:O?O===z?W:null:ie===z||ie.endsWith(re)||ie.endsWith(V)?W:null},ae=[z];return X.basenames=ae,X.patterns=[W],X.allBasenames=ae,X}function S(z,W){const re=F(z.slice(1,-1).split(",").map(O=>o(O,W)).filter(O=>O!==n),z),V=re.length;if(!V)return n;if(V===1)return re[0];const X=function(O,B){for(let ee=0,ce=re.length;ee<ce;ee++)if(re[ee](O,B))return z;return null},ae=re.find(O=>!!O.allBasenames);ae&&(X.allBasenames=ae.allBasenames);const ie=re.reduce((O,B)=>B.allPaths?O.concat(B.allPaths):O,[]);return ie.length&&(X.allPaths=ie),X}function A(z,W,re){const V=k.sep===k.posix.sep,X=V?z:z.replace(E,k.sep),ae=k.sep+X,ie=k.posix.sep+z;let O;return re?O=function(B,ee){return typeof B=="string"&&(B===X||B.endsWith(ae)||!V&&(B===z||B.endsWith(ie)))?W:null}:O=function(B,ee){return typeof B=="string"&&(B===X||!V&&B===z)?W:null},O.allPaths=[(re?"*/":"./")+z],O}function M(z){try{const W=new RegExp(`^${C(z)}$`);return function(re){return W.lastIndex=0,typeof re=="string"&&W.test(re)?z:null}}catch{return n}}function $(z,W,re){return!z||typeof W!="string"?!1:Q(z)(W,void 0,re)}e.match=$;function Q(z,W={}){if(!z)return a;if(typeof z=="string"||_(z)){const re=o(z,W);if(re===n)return a;const V=function(X,ae){return!!re(X,ae)};return re.allBasenames&&(V.allBasenames=re.allBasenames),re.allPaths&&(V.allPaths=re.allPaths),V}return ne(z,W)}e.parse=Q;function _(z){const W=z;return W?typeof W.base=="string"&&typeof W.pattern=="string":!1}e.isRelativePattern=_;function q(z){return z.allBasenames||[]}e.getBasenameTerms=q;function U(z){return z.allPaths||[]}e.getPathTerms=U;function ne(z,W){const re=F(Object.getOwnPropertyNames(z).map(O=>Z(O,z[O],W)).filter(O=>O!==n)),V=re.length;if(!V)return n;if(!re.some(O=>!!O.requiresSiblings)){if(V===1)return re[0];const O=function(ce,K){let he;for(let te=0,le=re.length;te<le;te++){const de=re[te](ce,K);if(typeof de=="string")return de;(0,t.isThenable)(de)&&(he||(he=[]),he.push(de))}return he?(async()=>{for(const te of he){const le=await te;if(typeof le=="string")return le}return null})():null},B=re.find(ce=>!!ce.allBasenames);B&&(O.allBasenames=B.allBasenames);const ee=re.reduce((ce,K)=>K.allPaths?ce.concat(K.allPaths):ce,[]);return ee.length&&(O.allPaths=ee),O}const X=function(O,B,ee){let ce,K;for(let he=0,te=re.length;he<te;he++){const le=re[he];le.requiresSiblings&&ee&&(B||(B=(0,k.basename)(O)),ce||(ce=B.substr(0,B.length-(0,k.extname)(O).length)));const de=le(O,B,ce,ee);if(typeof de=="string")return de;(0,t.isThenable)(de)&&(K||(K=[]),K.push(de))}return K?(async()=>{for(const he of K){const te=await he;if(typeof te=="string")return te}return null})():null},ae=re.find(O=>!!O.allBasenames);ae&&(X.allBasenames=ae.allBasenames);const ie=re.reduce((O,B)=>B.allPaths?O.concat(B.allPaths):O,[]);return ie.length&&(X.allPaths=ie),X}function Z(z,W,re){if(W===!1)return n;const V=o(z,re);if(V===n)return n;if(typeof W=="boolean")return V;if(W){const X=W.when;if(typeof X=="string"){const ae=(ie,O,B,ee)=>{if(!ee||!V(ie,O))return null;const ce=X.replace("$(basename)",B),K=ee(ce);return(0,t.isThenable)(K)?K.then(he=>he?z:null):K?z:null};return ae.requiresSiblings=!0,ae}}return V}function F(z,W){const re=z.filter(O=>!!O.basenames);if(re.length<2)return z;const V=re.reduce((O,B)=>{const ee=B.basenames;return ee?O.concat(ee):O},[]);let X;if(W){X=[];for(let O=0,B=V.length;O<B;O++)X.push(W)}else X=re.reduce((O,B)=>{const ee=B.patterns;return ee?O.concat(ee):O},[]);const ae=function(O,B){if(typeof O!="string")return null;if(!B){let ce;for(ce=O.length;ce>0;ce--){const K=O.charCodeAt(ce-1);if(K===47||K===92)break}B=O.substr(ce)}const ee=V.indexOf(B);return ee!==-1?X[ee]:null};ae.basenames=V,ae.patterns=X,ae.allBasenames=V;const ie=z.filter(O=>!O.basenames);return ie.push(ae),ie}function x(z,W){return(0,I.equals)(z,W,(re,V)=>typeof re=="string"&&typeof V=="string"?re===V:typeof re!="string"&&typeof V!="string"?re.base===V.base&&re.pattern===V.pattern:!1)}e.patternsEquals=x}),define(ve[88],we([0,1,11,148,19,15,4]),function(oe,e,I,t,v,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var w;(function(y){y[y.Paragraph=0]="Paragraph",y[y.Break=1]="Break"})(w=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class p{constructor(m="",g=!1){if(this.value=m,typeof this.value!="string")throw(0,I.illegalArgument)("value");typeof g=="boolean"?(this.isTrusted=g,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=g.isTrusted??void 0,this.supportThemeIcons=g.supportThemeIcons??!1,this.supportHtml=g.supportHtml??!1)}appendText(m,g=0){return this.value+=E(this.supportThemeIcons?(0,t.escapeIcons)(m):m).replace(/([ \t]+)/g,(h,l)=>"&nbsp;".repeat(l.length)).replace(/\>/gm,"\\>").replace(/\n/g,g===1?`\\
`:`

`),this}appendMarkdown(m){return this.value+=m,this}appendCodeblock(m,g){return this.value+="\n```",this.value+=m,this.value+=`
`,this.value+=g,this.value+="\n```\n",this}appendLink(m,g,h){return this.value+="[",this.value+=this._escape(g,"]"),this.value+="](",this.value+=this._escape(String(m),")"),h&&(this.value+=` "${this._escape(this._escape(h,'"'),")")}"`),this.value+=")",this}_escape(m,g){const h=new RegExp((0,P.escapeRegExpCharacters)(g),"g");return m.replace(h,(l,f)=>m.charAt(f-1)!=="\\"?`\\${l}`:l)}}e.MarkdownString=p;function D(y){return T(y)?!y.value:Array.isArray(y)?y.every(D):!0}e.isEmptyMarkdownString=D;function T(y){return y instanceof p?!0:y&&typeof y=="object"?typeof y.value=="string"&&(typeof y.isTrusted=="boolean"||y.isTrusted===void 0)&&(typeof y.supportThemeIcons=="boolean"||y.supportThemeIcons===void 0):!1}e.isMarkdownString=T;function R(y,m){return y===m?!0:!y||!m?!1:y.value===m.value&&y.isTrusted===m.isTrusted&&y.supportThemeIcons===m.supportThemeIcons&&y.supportHtml===m.supportHtml&&(y.baseUri===m.baseUri||!!y.baseUri&&!!m.baseUri&&(0,v.isEqual)(k.URI.from(y.baseUri),k.URI.from(m.baseUri)))}e.markdownStringEqual=R;function E(y){return y.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=E;function b(y){return y.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=b;function d(y){return y&&y.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=d;function C(y){const m=[],g=y.split("|").map(l=>l.trim());y=g[0];const h=g[1];if(h){const l=/height=(\d+)/.exec(h),f=/width=(\d+)/.exec(h),i=l?l[1]:"",a=f?f[1]:"",n=isFinite(parseInt(a)),o=isFinite(parseInt(i));n&&m.push(`width="${a}"`),o&&m.push(`height="${i}"`)}return{href:y,dimensions:m}}e.parseHrefAndDimensions=C}),define(ve[150],we([0,1,18,33,5,3,19,15]),function(oe,e,I,t,v,P,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function p(n,o){const{os:r,tildify:s,relative:c}=o;if(c){const A=D(n,c,r);if(typeof A=="string")return A}let u=n.fsPath;if(r===1&&!P.isWindows?u=u.replace(/\//g,"\\"):r!==1&&P.isWindows&&(u=u.replace(/\\/g,"/")),r!==1&&s?.userHome){const A=s.userHome.fsPath;let M;n.scheme!==s.userHome.scheme&&n.path.startsWith(v.posix.sep)?M=s.userHome.with({path:n.path}).fsPath:M=n.fsPath,u=E(M,A,r)}return(r===1?v.win32:v.posix).normalize(T(u,r===1))}e.getPathLabel=p;function D(n,o,r){const s=r===1?v.win32:v.posix,c=r===3?k.extUri:k.extUriIgnorePathCase,u=o.getWorkspace(),S=(0,I.firstOrDefault)(u.folders);if(!S)return;n.scheme!==S.uri.scheme&&n.path.startsWith(v.posix.sep)&&(n=S.uri.with({path:n.path}));const A=o.getWorkspaceFolder(n);if(!A)return;let M;if(c.isEqual(A.uri,n)?M="":M=c.relativePath(A.uri,n)??"",M&&(M=s.normalize(M)),u.folders.length>1&&!o.noPrefix){const $=A.name?A.name:c.basenameOrAuthority(A.uri);M=M?`${$} \u2022 ${M}`:$}return M}function T(n,o=P.isWindows){return(0,t.hasDriveLetter)(n,o)?n.charAt(0).toUpperCase()+n.slice(1):n}e.normalizeDriveLetter=T;let R=Object.create(null);function E(n,o,r=P.OS){if(r===1||!n||!o)return n;let s=R.original===o?R.normalized:void 0;s||(s=o,P.isWindows&&(s=(0,t.toSlashes)(s)),s=`${(0,w.rtrim)(s,v.posix.sep)}${v.posix.sep}`,R={original:o,normalized:s});let c=n;return P.isWindows&&(c=(0,t.toSlashes)(c)),(r===3?c.startsWith(s):(0,w.startsWithIgnoreCase)(c,s))?`~/${c.substr(s.length)}`:n}e.tildify=E;function b(n,o){return n.replace(/^~($|\/|\\)/,`${o}$1`)}e.untildify=b;const d="\u2026",C="\\\\",y="~";function m(n,o=v.sep){const r=new Array(n.length);let s=!1;for(let c=0;c<n.length;c++){const u=n[c];if(u===""){r[c]=`.${o}`;continue}if(!u){r[c]=u;continue}s=!0;let S="",A=u;A.indexOf(C)===0?(S=A.substr(0,A.indexOf(C)+C.length),A=A.substr(A.indexOf(C)+C.length)):A.indexOf(o)===0?(S=A.substr(0,A.indexOf(o)+o.length),A=A.substr(A.indexOf(o)+o.length)):A.indexOf(y)===0&&(S=A.substr(0,A.indexOf(y)+y.length),A=A.substr(A.indexOf(y)+y.length));const M=A.split(o);for(let $=1;s&&$<=M.length;$++)for(let Q=M.length-$;s&&Q>=0;Q--){s=!1;let _=M.slice(Q,Q+$).join(o);for(let q=0;!s&&q<n.length;q++)if(q!==c&&n[q]&&n[q].indexOf(_)>-1){const U=Q+$===M.length,ne=Q>0&&n[q].indexOf(o)>-1?o+_:_,Z=n[q].endsWith(ne);s=!U||Z}if(!s){let q="";(M[0].endsWith(":")||S!=="")&&(Q===1&&(Q=0,$++,_=M[0]+o+_),Q>0&&(q=M[0]+o),q=S+q),Q>0&&(q=q+d+o),q=q+_,Q+$<M.length&&(q=q+o+d),r[c]=q}}s&&(r[c]=u)}return r}e.shorten=m;var g;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(g||(g={}));function h(n,o=Object.create(null)){const r=[];let s=!1,c="";for(const u of n)if(u==="$"||s&&u==="{")c&&r.push({value:c,type:g.TEXT}),c="",s=!0;else if(u==="}"&&s){const S=o[c];if(typeof S=="string")S.length&&r.push({value:S,type:g.VARIABLE});else if(S){const A=r[r.length-1];(!A||A.type!==g.SEPARATOR)&&r.push({value:S.label,type:g.SEPARATOR})}c="",s=!1}else c+=u;return c&&!s&&r.push({value:c,type:g.TEXT}),r.filter((u,S)=>{if(u.type===g.SEPARATOR){const A=r[S-1],M=r[S+1];return[A,M].every($=>$&&($.type===g.VARIABLE||$.type===g.TEXT)&&$.value.length>0)}return!0}).map(u=>u.value).join("")}e.template=h;function l(n,o){return P.isMacintosh||o?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,P.isMacintosh?"&":"&&"):n.replace(/&&|&/g,r=>r==="&"?"&&":"&")}e.mnemonicMenuLabel=l;function f(n,o){return P.isMacintosh||o?n.replace(/\(&&\w\)|&&/g,""):P.isWindows?n.replace(/&&|&/g,r=>r==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.mnemonicButtonLabel=f;function i(n){return n.replace(/&/g,"&&")}e.unmnemonicLabel=i;function a(n){const o=n.indexOf("/")!==-1?v.posix:v.win32,r=o.basename(n),s=o.dirname(n);return r.length?{name:r,parentPath:s}:{name:s,parentPath:""}}e.splitName=a}),define(ve[70],we([0,1,4]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(T){return T.toJSON()}class v{constructor(R){this._uriTransformer=R}transformIncoming(R){const E=this._uriTransformer.transformIncoming(R);return E===R?R:t(I.URI.from(E))}transformOutgoing(R){const E=this._uriTransformer.transformOutgoing(R);return E===R?R:t(I.URI.from(E))}transformOutgoingURI(R){const E=this._uriTransformer.transformOutgoing(R);return E===R?R:I.URI.from(E)}transformOutgoingScheme(R){return this._uriTransformer.transformOutgoingScheme(R)}}e.URITransformer=v,e.DefaultURITransformer=new class{transformIncoming(T){return T}transformOutgoing(T){return T}transformOutgoingURI(T){return T}transformOutgoingScheme(T){return T}};function P(T,R,E){if(!T||E>200)return null;if(typeof T=="object"){if(T instanceof I.URI)return R.transformOutgoing(T);for(const b in T)if(Object.hasOwnProperty.call(T,b)){const d=P(T[b],R,E+1);d!==null&&(T[b]=d)}}return null}function k(T,R){const E=P(T,R,0);return E===null?T:E}e.transformOutgoingURIs=k;function w(T,R,E,b){if(!T||b>200)return null;if(typeof T=="object"){if(T.$mid===1)return E?I.URI.revive(R.transformIncoming(T)):R.transformIncoming(T);for(const d in T)if(Object.hasOwnProperty.call(T,d)){const C=w(T[d],R,E,b+1);C!==null&&(T[d]=C)}}return null}function p(T,R){const E=w(T,R,!1,0);return E===null?T:E}e.transformIncomingURIs=p;function D(T,R){const E=w(T,R,!0,0);return E===null?T:E}e.transformAndReviveIncomingURIs=D}),define(ve[89],we([0,1,27,11,29,26,137]),function(oe,e,I,t,v,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(T){return this._virtualMachineOUIs||(this._virtualMachineOUIs=v.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(T)}value(){if(this._value===void 0){let T=0,R=0;const E=(0,I.networkInterfaces)();for(const b in E){const d=E[b];if(d)for(const{mac:C,internal:y}of d)y||(R+=1,this._isVirtualMachineMacAddress(C.toUpperCase())&&(T+=1))}this._value=R>0?T/R:0}return this._value}};let w;async function p(){return w||(w=(async()=>await D()||P.generateUuid())()),w}e.getMachineId=p;async function D(){try{const T=await new Promise((E,b)=>{oe(["crypto"],E,b)}),R=(0,k.getMac)();return T.createHash("sha256").update(R,"utf8").digest("hex")}catch(T){t.onUnexpectedError(T);return}}}),define(ve[21],we([0,1,30,27,266,14,33,87,5,3,19,4]),function(oe,e,I,t,v,P,k,w,p,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var E;(function(U){U[U.UNLINK=0]="UNLINK",U[U.MOVE=1]="MOVE"})(E=e.RimRafMode||(e.RimRafMode={}));async function b(U,ne=E.UNLINK){if((0,k.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");return ne===E.UNLINK?C(U):d(U)}async function d(U){try{const ne=(0,k.randomPath)((0,t.tmpdir)());try{await I.promises.rename(U,ne)}catch{return C(U)}C(ne).catch(Z=>{})}catch(ne){if(ne.code!=="ENOENT")throw ne}}async function C(U){return(0,v.promisify)(I.rm)(U,{recursive:!0,force:!0,maxRetries:3})}function y(U){if((0,k.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");I.rmSync(U,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=y;async function m(U,ne){return l(await(ne?g(U):(0,v.promisify)(I.readdir)(U)))}async function g(U){try{return await(0,v.promisify)(I.readdir)(U,{withFileTypes:!0})}catch(F){console.warn("[node.js fs] readdir with filetypes failed with error: ",F)}const ne=[],Z=await m(U);for(const F of Z){let x=!1,z=!1,W=!1;try{const re=await e.Promises.lstat((0,p.join)(U,F));x=re.isFile(),z=re.isDirectory(),W=re.isSymbolicLink()}catch(re){console.warn("[node.js fs] unexpected error from lstat after readdir: ",re)}ne.push({name:F,isFile:()=>x,isDirectory:()=>z,isSymbolicLink:()=>W})}return ne}function h(U){return l(I.readdirSync(U))}e.readdirSync=h;function l(U){return U.map(ne=>typeof ne=="string"?D.isMacintosh?(0,w.normalizeNFC)(ne):ne:(ne.name=D.isMacintosh?(0,w.normalizeNFC)(ne.name):ne.name,ne))}async function f(U){const ne=await m(U),Z=[];for(const F of ne)await a.existsDirectory((0,p.join)(U,F))&&Z.push(F);return Z}function i(U,ne=1e3){return new Promise(Z=>{let F=!1;const x=setInterval(()=>{F||(F=!0,I.access(U,z=>{F=!1,z&&(clearInterval(x),Z(void 0))}))},ne)})}e.whenDeleted=i;var a;(function(U){async function ne(x){let z;try{if(z=await e.Promises.lstat(x),!z.isSymbolicLink())return{stat:z}}catch{}try{return{stat:await e.Promises.stat(x),symbolicLink:z?.isSymbolicLink()?{dangling:!1}:void 0}}catch(W){if(W.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};if(D.isWindows&&W.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(x)),symbolicLink:{dangling:!1}}}catch(re){if(re.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};throw re}throw W}}U.stat=ne;async function Z(x){try{const{stat:z,symbolicLink:W}=await U.stat(x);return z.isFile()&&W?.dangling!==!0}catch{}return!1}U.existsFile=Z;async function F(x){try{const{stat:z,symbolicLink:W}=await U.stat(x);return z.isDirectory()&&W?.dangling!==!0}catch{}return!1}U.existsDirectory=F})(a=e.SymlinkSupport||(e.SymlinkSupport={}));const n=new P.ResourceQueue;function o(U,ne,Z){return n.queueFor(R.URI.file(U),T.extUriBiasedIgnorePathCase).queue(()=>{const F=u(Z);return new Promise((x,z)=>s(U,ne,F,W=>W?z(W):x()))})}let r=!0;function s(U,ne,Z,F){if(!r)return I.writeFile(U,ne,{mode:Z.mode,flag:Z.flag},F);I.open(U,Z.flag,Z.mode,(x,z)=>{if(x)return F(x);I.writeFile(z,ne,W=>{if(W)return I.close(z,()=>F(W));I.fdatasync(z,re=>(re&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",re),r=!1),I.close(z,V=>F(V))))})})}function c(U,ne,Z){const F=u(Z);if(!r)return I.writeFileSync(U,ne,{mode:F.mode,flag:F.flag});const x=I.openSync(U,F.flag,F.mode);try{I.writeFileSync(x,ne);try{I.fdatasyncSync(x)}catch(z){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",z),r=!1}}finally{I.closeSync(x)}}e.writeFileSync=c;function u(U){return U?{mode:typeof U.mode=="number"?U.mode:438,flag:typeof U.flag=="string"?U.flag:"w"}:{mode:438,flag:"w"}}async function S(U,ne){if(U!==ne)try{await e.Promises.rename(U,ne)}catch(Z){if(U.toLowerCase()!==ne.toLowerCase()&&Z.code==="EXDEV"||U.endsWith("."))await A(U,ne,{preserveSymlinks:!1}),await b(U,E.MOVE);else throw Z}}async function A(U,ne,Z){return $(U,ne,{root:{source:U,target:ne},options:Z,handledSourcePaths:new Set})}const M=511;async function $(U,ne,Z){if(Z.handledSourcePaths.has(U))return;Z.handledSourcePaths.add(U);const{stat:F,symbolicLink:x}=await a.stat(U);if(x){if(Z.options.preserveSymlinks)try{return await q(U,ne,Z)}catch(z){console.warn("[node.js fs] copy of symlink failed: ",z)}if(x.dangling)return}return F.isDirectory()?Q(U,ne,F.mode&M,Z):_(U,ne,F.mode&M)}async function Q(U,ne,Z,F){await e.Promises.mkdir(ne,{recursive:!0,mode:Z});const x=await m(U);for(const z of x)await $((0,p.join)(U,z),(0,p.join)(ne,z),F)}async function _(U,ne,Z){await e.Promises.copyFile(U,ne),await e.Promises.chmod(ne,Z)}async function q(U,ne,Z){let F=await e.Promises.readlink(U);(0,k.isEqualOrParent)(F,Z.root.source,!D.isLinux)&&(F=(0,p.join)(Z.root.target,F.substr(Z.root.source.length+1))),await e.Promises.symlink(F,ne)}e.Promises=new class{get access(){return(0,v.promisify)(I.access)}get stat(){return(0,v.promisify)(I.stat)}get lstat(){return(0,v.promisify)(I.lstat)}get utimes(){return(0,v.promisify)(I.utimes)}get read(){return(U,ne,Z,F,x)=>new Promise((z,W)=>{I.read(U,ne,Z,F,x,(re,V,X)=>re?W(re):z({bytesRead:V,buffer:X}))})}get readFile(){return(0,v.promisify)(I.readFile)}get write(){return(U,ne,Z,F,x)=>new Promise((z,W)=>{I.write(U,ne,Z,F,x,(re,V,X)=>re?W(re):z({bytesWritten:V,buffer:X}))})}get appendFile(){return(0,v.promisify)(I.appendFile)}get fdatasync(){return(0,v.promisify)(I.fdatasync)}get truncate(){return(0,v.promisify)(I.truncate)}get rename(){return(0,v.promisify)(I.rename)}get copyFile(){return(0,v.promisify)(I.copyFile)}get open(){return(0,v.promisify)(I.open)}get close(){return(0,v.promisify)(I.close)}get symlink(){return(0,v.promisify)(I.symlink)}get readlink(){return(0,v.promisify)(I.readlink)}get chmod(){return(0,v.promisify)(I.chmod)}get mkdir(){return(0,v.promisify)(I.mkdir)}get unlink(){return(0,v.promisify)(I.unlink)}get rmdir(){return(0,v.promisify)(I.rmdir)}get realpath(){return(0,v.promisify)(I.realpath)}async exists(U){try{return await e.Promises.access(U),!0}catch{return!1}}get readdir(){return m}get readDirsInDir(){return f}get writeFile(){return o}get rm(){return b}get move(){return S}get copy(){return A}}}),define(ve[151],we([0,1,30,5,3,15,21]),function(oe,e,I,t,v,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function w(E){if(v.isLinux)return E;const b=(0,t.dirname)(E);if(E===b)return E;const d=((0,t.basename)(E)||E).toLowerCase();try{const y=(0,k.readdirSync)(b).filter(m=>m.toLowerCase()===d);if(y.length===1){const m=w(b);if(m)return(0,t.join)(m,y[0])}else if(y.length>1){const m=y.indexOf(d);if(m>=0){const g=w(b);if(g)return(0,t.join)(g,y[m])}}}catch{}return null}e.realcaseSync=w;async function p(E){if(v.isLinux)return E;const b=(0,t.dirname)(E);if(E===b)return E;const d=((0,t.basename)(E)||E).toLowerCase();try{const y=(await k.Promises.readdir(b)).filter(m=>m.toLowerCase()===d);if(y.length===1){const m=await p(b);if(m)return(0,t.join)(m,y[0])}else if(y.length>1){const m=y.indexOf(d);if(m>=0){const g=await p(b);if(g)return(0,t.join)(g,y[m])}}}catch{}return null}e.realcase=p;async function D(E){try{return await k.Promises.realpath(E)}catch{const d=R(E);return await k.Promises.access(d,I.constants.R_OK),d}}e.realpath=D;function T(E){try{return I.realpathSync(E)}catch{const d=R(E);return I.accessSync(d,I.constants.R_OK),d}}e.realpathSync=T;function R(E){return(0,P.rtrim)((0,t.normalize)(E),t.sep)}}),define(ve[90],we([0,1,27,5,21]),function(oe,e,I,t,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const P=/^\d+$/,k=/^Microsoft.PowerShell_.*/,w=/^Microsoft.PowerShellPreview_.*/;var p;(function(l){l[l.x64=0]="x64",l[l.x86=1]="x86",l[l.ARM=2]="ARM"})(p||(p={}));let D;switch(process.arch){case"ia32":case"x32":D=1;break;case"arm":case"arm64":D=2;break;default:D=0;break}let T;process.env.PROCESSOR_ARCHITEW6432?T=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?T=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?T=1:T=0;class R{constructor(f,i,a){this.exePath=f,this.displayName=i,this.knownToExist=a}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await v.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function E({useAlternateBitness:l=!1}={}){return l?D===0?process.env["ProgramFiles(x86)"]||null:T===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function b({useAlternateBitness:l=!1,findPreview:f=!1}={}){const i=E({useAlternateBitness:l});if(!i)return null;const a=t.join(i,"PowerShell");if(!await v.SymlinkSupport.existsDirectory(a))return null;let n=-1,o=null;for(const c of await v.Promises.readdir(a)){let u=-1;if(f){const A=c.indexOf("-");if(A<0)continue;const M=c.substring(0,A);if(!P.test(M)||c.substring(A+1)!=="preview")continue;u=parseInt(M,10)}else{if(!P.test(c))continue;u=parseInt(c,10)}if(u<=n)continue;const S=t.join(a,c,"pwsh.exe");!await v.SymlinkSupport.existsFile(S)||(o=S,n=u)}if(!o)return null;const r=i.includes("x86")?" (x86)":"",s=f?" Preview":"";return new R(o,`PowerShell${s}${r}`,!0)}async function d({findPreview:l}={}){if(!process.env.LOCALAPPDATA)return null;const f=t.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await v.SymlinkSupport.existsDirectory(f))return null;const{pwshMsixDirRegex:i,pwshMsixName:a}=l?{pwshMsixDirRegex:w,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:k,pwshMsixName:"PowerShell (Store)"};for(const n of await v.Promises.readdir(f))if(i.test(n)){const o=t.join(f,n,"pwsh.exe");return new R(o,a)}return null}function C(){const l=t.join(I.homedir(),".dotnet","tools","pwsh.exe");return new R(l,".NET Core PowerShell Global Tool")}function y(){const l=t.join(process.env.windir,D===1&&T!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new R(l,"Windows PowerShell",!0)}async function*m(){let l=await b();l&&(yield l),l=await b({useAlternateBitness:!0}),l&&(yield l),l=await d(),l&&(yield l),l=C(),l&&(yield l),l=await b({findPreview:!0}),l&&(yield l),l=await d({findPreview:!0}),l&&(yield l),l=await b({useAlternateBitness:!0,findPreview:!0}),l&&(yield l),l=y(),l&&(yield l)}async function*g(){for await(const l of m())await l.exists()&&(yield l)}e.enumeratePowerShellInstallations=g;async function h(){for await(const l of g())return l;return null}e.getFirstAvailablePowerShellInstallation=h}),define(ve[91],we([0,1,42,10]),function(oe,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function v(k){return new Promise((w,p)=>{let D;const T=new Map;function R(b,d,C,y,m){const g=T.get(d);if(b===k||g){const h={name:E(C),cmd:C,pid:b,ppid:d,load:y,mem:m};T.set(b,h),b===k&&(D=h),g&&(g.children||(g.children=[]),g.children.push(h),g.children.length>1&&(g.children=g.children.sort((l,f)=>l.pid-f.pid)))}}function E(b){const d=/--vscode-window-kind=shared-process/,C=/--vscode-window-kind=issue-reporter/,y=/--vscode-window-kind=process-explorer/,m=/--utility-sub-type=network/,g=/--crashes-directory/,h=/\\pipe\\winpty-control/,l=/conhost\.exe/,f=/--type=([a-zA-Z-]+)/;if(g.exec(b))return"electron-crash-reporter";if(h.exec(b))return"winpty-process";if(l.exec(b))return"console-window-host (Windows internal process)";let i=f.exec(b);if(i&&i.length===2)return i[1]==="renderer"?d.exec(b)?"shared-process":C.exec(b)?"issue-reporter":y.exec(b)?"process-explorer":"window":i[1]==="utility"&&m.exec(b)?"utility-network-service":i[1];const a=/[a-zA-Z-]+\.js/g;let n="";do i=a.exec(b),i&&(n+=i+" ");while(i);return n&&b.indexOf("node ")<0&&b.indexOf("node.exe")<0?`electron_node ${n}`:b}if(process.platform==="win32"){const b=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substr(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substr(5):d;new Promise((d,C)=>{oe(["windows-process-tree"],d,C)}).then(d=>{d.getProcessList(k,C=>{if(!C){p(new Error(`Root process ${k} not found`));return}d.getProcessCpuUsage(C,y=>{const m=new Map;y.forEach(g=>{const h=b(g.commandLine||"");m.set(g.pid,{name:E(h),cmd:h,pid:g.pid,ppid:g.ppid,load:g.cpu||0,mem:g.memory||0})}),D=m.get(k),D?(m.forEach(g=>{const h=m.get(g.ppid);h&&(h.children||(h.children=[]),h.children.push(g))}),m.forEach(g=>{g.children&&(g.children=g.children.sort((h,l)=>h.pid-l.pid))}),w(D)):p(new Error(`Root process ${k} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let b=function(){let d=[D];const C=[];for(;d.length;){const m=d.shift();m&&(C.push(m.pid),m.children&&(d=d.concat(m.children)))}let y=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",oe).fsPath);y+=" "+C.join(" "),(0,I.exec)(y,{},(m,g,h)=>{if(m||h)p(m||new Error(h.toString()));else{const l=g.toString().split(`
`);for(let f=0;f<C.length;f++){const i=T.get(C[f]);i.load=parseFloat(l[f])}if(!D){p(new Error(`Root process ${k} not found`));return}w(D)}})};(0,I.exec)("which ps",{},(d,C,y)=>{if(d||y)if(process.platform!=="linux")p(d||new Error(y.toString()));else{const m=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/ps.sh",oe).fsPath);(0,I.exec)(m,{},(g,h,l)=>{g||l?p(g||new Error(l.toString())):(P(h,R),b())})}else{const m=C.toString().trim(),g="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,I.exec)(`${m} ${g}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(h,l,f)=>{h||f&&!f.includes("screen size is bogus")?p(h||new Error(f.toString())):(P(l,R),process.platform==="linux"?b():D?w(D):p(new Error(`Root process ${k} not found`)))})}})}})}e.listProcesses=v;function P(k,w){const p=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,D=k.toString().split(`
`);for(const T of D){const R=p.exec(T.trim());R&&R.length===6&&w(parseInt(R[1]),parseInt(R[2]),R[5],parseFloat(R[3]),parseFloat(R[4]))}}});var Re=this&&this.__decorate||function(oe,e,I,t){var v=arguments.length,P=v<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,I):t,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")P=Reflect.decorate(oe,e,I,t);else for(var w=oe.length-1;w>=0;w--)(k=oe[w])&&(P=(v<3?k(P):v>3?k(e,I,P):k(e,I))||P);return v>3&&P&&Object.defineProperty(e,I,P),P};define(ve[43],we([0,1,18,14,16,20,82,11,7,2,41,15,12]),function(oe,e,I,t,v,P,k,w,p,D,T,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var b;(function(z){z[z.Promise=100]="Promise",z[z.PromiseCancel=101]="PromiseCancel",z[z.EventListen=102]="EventListen",z[z.EventDispose=103]="EventDispose"})(b=e.RequestType||(e.RequestType={}));function d(z){switch(z){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var C;(function(z){z[z.Initialize=200]="Initialize",z[z.PromiseSuccess=201]="PromiseSuccess",z[z.PromiseError=202]="PromiseError",z[z.PromiseErrorObj=203]="PromiseErrorObj",z[z.EventFire=204]="EventFire"})(C=e.ResponseType||(e.ResponseType={}));function y(z){switch(z){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var m;(function(z){z[z.Uninitialized=0]="Uninitialized",z[z.Idle=1]="Idle"})(m||(m={}));class g{constructor(W){this.buffer=W,this.pos=0}read(W){const re=this.buffer.slice(this.pos,this.pos+W);return this.pos+=re.byteLength,re}}class h{constructor(){this.buffers=[]}get buffer(){return v.VSBuffer.concat(this.buffers)}write(W){this.buffers.push(W)}}var l;(function(z){z[z.Undefined=0]="Undefined",z[z.String=1]="String",z[z.Buffer=2]="Buffer",z[z.VSBuffer=3]="VSBuffer",z[z.Array=4]="Array",z[z.Object=5]="Object"})(l||(l={}));function f(z){const W=v.VSBuffer.alloc(4);return W.writeUInt32BE(z,0),W}function i(z){return z.read(4).readUInt32BE(0)}function a(z){const W=v.VSBuffer.alloc(1);return W.writeUInt8(z,0),W}const n={Undefined:a(l.Undefined),String:a(l.String),Buffer:a(l.Buffer),VSBuffer:a(l.VSBuffer),Array:a(l.Array),Object:a(l.Object)},o=typeof Buffer!="undefined";function r(z,W){if(typeof W=="undefined")z.write(n.Undefined);else if(typeof W=="string"){const re=v.VSBuffer.fromString(W);z.write(n.String),z.write(f(re.byteLength)),z.write(re)}else if(o&&Buffer.isBuffer(W)){const re=v.VSBuffer.wrap(W);z.write(n.Buffer),z.write(f(re.byteLength)),z.write(re)}else if(W instanceof v.VSBuffer)z.write(n.VSBuffer),z.write(f(W.byteLength)),z.write(W);else if(Array.isArray(W)){z.write(n.Array),z.write(f(W.length));for(const re of W)r(z,re)}else{const re=v.VSBuffer.fromString(JSON.stringify(W));z.write(n.Object),z.write(f(re.byteLength)),z.write(re)}}function s(z){switch(z.read(1).readUInt8(0)){case l.Undefined:return;case l.String:return z.read(i(z)).toString();case l.Buffer:return z.read(i(z)).buffer;case l.VSBuffer:return z.read(i(z));case l.Array:{const re=i(z),V=[];for(let X=0;X<re;X++)V.push(s(z));return V}case l.Object:return JSON.parse(z.read(i(z)).toString())}}class c{constructor(W,re,V=null,X=1e3){this.protocol=W,this.ctx=re,this.logger=V,this.timeoutDelay=X,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(ae=>this.onRawMessage(ae)),this.sendResponse({type:200})}registerChannel(W,re){this.channels.set(W,re),setTimeout(()=>this.flushPendingRequests(W),0)}sendResponse(W){switch(W.type){case 200:{const re=this.send([W.type]);this.logger?.logOutgoing(re,0,1,y(W.type));return}case 201:case 202:case 204:case 203:{const re=this.send([W.type,W.id],W.data);this.logger?.logOutgoing(re,W.id,1,y(W.type),W.data);return}}}send(W,re=void 0){const V=new h;return r(V,W),r(V,re),this.sendBuffer(V.buffer)}sendBuffer(W){try{return this.protocol.send(W),W.byteLength}catch{return 0}}onRawMessage(W){const re=new g(W),V=s(re),X=s(re),ae=V[0];switch(ae){case 100:return this.logger?.logIncoming(W.byteLength,V[1],1,`${d(ae)}: ${V[2]}.${V[3]}`,X),this.onPromise({type:ae,id:V[1],channelName:V[2],name:V[3],arg:X});case 102:return this.logger?.logIncoming(W.byteLength,V[1],1,`${d(ae)}: ${V[2]}.${V[3]}`,X),this.onEventListen({type:ae,id:V[1],channelName:V[2],name:V[3],arg:X});case 101:return this.logger?.logIncoming(W.byteLength,V[1],1,`${d(ae)}`),this.disposeActiveRequest({type:ae,id:V[1]});case 103:return this.logger?.logIncoming(W.byteLength,V[1],1,`${d(ae)}`),this.disposeActiveRequest({type:ae,id:V[1]})}}onPromise(W){const re=this.channels.get(W.channelName);if(!re){this.collectPendingRequest(W);return}const V=new P.CancellationTokenSource;let X;try{X=re.call(this.ctx,W.name,W.arg,V.token)}catch(O){X=Promise.reject(O)}const ae=W.id;X.then(O=>{this.sendResponse({id:ae,data:O,type:201}),this.activeRequests.delete(W.id)},O=>{O instanceof Error?this.sendResponse({id:ae,data:{message:O.message,name:O.name,stack:O.stack?O.stack.split?O.stack.split(`
`):O.stack:void 0},type:202}):this.sendResponse({id:ae,data:O,type:203}),this.activeRequests.delete(W.id)});const ie=(0,D.toDisposable)(()=>V.cancel());this.activeRequests.set(W.id,ie)}onEventListen(W){const re=this.channels.get(W.channelName);if(!re){this.collectPendingRequest(W);return}const V=W.id,ae=re.listen(this.ctx,W.name,W.arg)(ie=>this.sendResponse({id:V,data:ie,type:204}));this.activeRequests.set(W.id,ae)}disposeActiveRequest(W){const re=this.activeRequests.get(W.id);re&&(re.dispose(),this.activeRequests.delete(W.id))}collectPendingRequest(W){let re=this.pendingRequests.get(W.channelName);re||(re=[],this.pendingRequests.set(W.channelName,re));const V=setTimeout(()=>{console.error(`Unknown channel: ${W.channelName}`),W.type===100&&this.sendResponse({id:W.id,data:{name:"Unknown channel",message:`Channel name '${W.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);re.push({request:W,timeoutTimer:V})}flushPendingRequests(W){const re=this.pendingRequests.get(W);if(re){for(const V of re)switch(clearTimeout(V.timeoutTimer),V.request.type){case 100:this.onPromise(V.request);break;case 102:this.onEventListen(V.request);break}this.pendingRequests.delete(W)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,D.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=c;var u;(function(z){z[z.LocalSide=0]="LocalSide",z[z.OtherSide=1]="OtherSide"})(u=e.RequestInitiator||(e.RequestInitiator={}));class S{constructor(W,re=null){this.protocol=W,this.isDisposed=!1,this.state=m.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new p.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(V=>this.onBuffer(V)),this.logger=re}getChannel(W){const re=this;return{call(V,X,ae){return re.isDisposed?Promise.reject(w.canceled()):re.requestPromise(W,V,X,ae)},listen(V,X){return re.isDisposed?p.Event.None:re.requestEvent(W,V,X)}}}requestPromise(W,re,V,X=P.CancellationToken.None){const ae=this.lastRequestId++,O={id:ae,type:100,channelName:W,name:re,arg:V};if(X.isCancellationRequested)return Promise.reject(w.canceled());let B;return new Promise((ce,K)=>{if(X.isCancellationRequested)return K(w.canceled());const he=()=>{const Y=J=>{switch(J.type){case 201:this.handlers.delete(ae),ce(J.data);break;case 202:{this.handlers.delete(ae);const H=new Error(J.data.message);H.stack=J.data.stack,H.name=J.data.name,K(H);break}case 203:this.handlers.delete(ae),K(J.data);break}};this.handlers.set(ae,Y),this.sendRequest(O)};let te=null;this.state===m.Idle?he():(te=(0,t.createCancelablePromise)(Y=>this.whenInitialized()),te.then(()=>{te=null,he()}));const le=()=>{te?(te.cancel(),te=null):this.sendRequest({id:ae,type:101}),K(w.canceled())},de=X.onCancellationRequested(le);B=(0,D.combinedDisposable)((0,D.toDisposable)(le),de),this.activeRequests.add(B)}).finally(()=>{this.activeRequests.delete(B)})}requestEvent(W,re,V){const X=this.lastRequestId++,ie={id:X,type:102,channelName:W,name:re,arg:V};let O=null;const B=new p.Emitter({onFirstListenerAdd:()=>{O=(0,t.createCancelablePromise)(ce=>this.whenInitialized()),O.then(()=>{O=null,this.activeRequests.add(B),this.sendRequest(ie)})},onLastListenerRemove:()=>{O?(O.cancel(),O=null):(this.activeRequests.delete(B),this.sendRequest({id:X,type:103}))}}),ee=ce=>B.fire(ce.data);return this.handlers.set(X,ee),B.event}sendRequest(W){switch(W.type){case 100:case 102:{const re=this.send([W.type,W.id,W.channelName,W.name],W.arg);this.logger?.logOutgoing(re,W.id,0,`${d(W.type)}: ${W.channelName}.${W.name}`,W.arg);return}case 101:case 103:{const re=this.send([W.type,W.id]);this.logger?.logOutgoing(re,W.id,0,d(W.type));return}}}send(W,re=void 0){const V=new h;return r(V,W),r(V,re),this.sendBuffer(V.buffer)}sendBuffer(W){try{return this.protocol.send(W),W.byteLength}catch{return 0}}onBuffer(W){const re=new g(W),V=s(re),X=s(re),ae=V[0];switch(ae){case 200:return this.logger?.logIncoming(W.byteLength,0,0,y(ae)),this.onResponse({type:V[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(W.byteLength,V[1],0,y(ae),X),this.onResponse({type:V[0],id:V[1],data:X})}}onResponse(W){if(W.type===200){this.state=m.Idle,this._onDidInitialize.fire();return}this.handlers.get(W.id)?.(W)}get onDidInitializePromise(){return p.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,D.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}Re([k.memoize],S.prototype,"onDidInitializePromise",null),e.ChannelClient=S;class A{constructor(W){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new p.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new p.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,W(({protocol:re,onDidClientDisconnect:V})=>{p.Event.once(re.onMessage)(ae=>{const ie=new g(ae),O=s(ie),B=new c(re,O),ee=new S(re);this.channels.forEach((K,he)=>B.registerChannel(he,K));const ce={channelServer:B,channelClient:ee,ctx:O};this._connections.add(ce),this._onDidAddConnection.fire(ce),V(()=>{B.dispose(),ee.dispose(),this._connections.delete(ce),this._onDidRemoveConnection.fire(ce)})})})}get connections(){const W=[];return this._connections.forEach(re=>W.push(re)),W}getChannel(W,re){const V=this;return{call(X,ae,ie){let O;if((0,E.isFunction)(re)){const ee=(0,I.getRandomElement)(V.connections.filter(re));O=ee?Promise.resolve(ee):p.Event.toPromise(p.Event.filter(V.onDidAddConnection,re))}else O=re.routeCall(V,X,ae);const B=O.then(ee=>ee.channelClient.getChannel(W));return $(B).call(X,ae,ie)},listen(X,ae){if((0,E.isFunction)(re))return V.getMulticastEvent(W,re,X,ae);const ie=re.routeEvent(V,X,ae).then(O=>O.channelClient.getChannel(W));return $(ie).listen(X,ae)}}}getMulticastEvent(W,re,V,X){const ae=this;let ie=new D.DisposableStore;const O=new p.Emitter({onFirstListenerAdd:()=>{ie=new D.DisposableStore;const B=new p.EventMultiplexer,ee=new Map,ce=he=>{const le=he.channelClient.getChannel(W).listen(V,X),de=B.add(le);ee.set(he,de)},K=he=>{const te=ee.get(he);!te||(te.dispose(),ee.delete(he))};ae.connections.filter(re).forEach(ce),p.Event.filter(ae.onDidAddConnection,re)(ce,void 0,ie),ae.onDidRemoveConnection(K,void 0,ie),B.event(O.fire,O,ie),ie.add(B)},onLastListenerRemove:()=>{ie.dispose()}});return O.event}registerChannel(W,re){this.channels.set(W,re),this._connections.forEach(V=>{V.channelServer.registerChannel(W,re)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=A;class M{constructor(W,re,V=null){const X=new h;r(X,re),W.send(X.buffer),this.channelClient=new S(W,V),this.channelServer=new c(W,re,V)}getChannel(W){return this.channelClient.getChannel(W)}registerChannel(W,re){this.channelServer.registerChannel(W,re)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=M;function $(z){return{call(W,re,V){return z.then(X=>X.call(W,re,V))},listen(W,re){const V=new p.Relay;return z.then(X=>V.input=X.listen(W,re)),V.event}}}e.getDelayedChannel=$;function Q(z){let W=!1;return{call(re,V,X){return W?z.call(re,V,X):(0,t.timeout)(0).then(()=>W=!0).then(()=>z.call(re,V,X))},listen(re,V){if(W)return z.listen(re,V);const X=new p.Relay;return(0,t.timeout)(0).then(()=>W=!0).then(()=>X.input=z.listen(re,V)),X.event}}}e.getNextTickChannel=Q;class _{constructor(W){this.fn=W}routeCall(W){return this.route(W)}routeEvent(W){return this.route(W)}async route(W){for(const re of W.connections)if(await Promise.resolve(this.fn(re.ctx)))return Promise.resolve(re);return await p.Event.toPromise(W.onDidAddConnection),await this.route(W)}}e.StaticRouter=_;var q;(function(z){function W(ae,ie){const O=ae,B=ie&&ie.disableMarshalling,ee=new Map;for(const ce in O)V(ce)&&ee.set(ce,p.Event.buffer(O[ce],!0));return new class{listen(ce,K,he){const te=ee.get(K);if(te)return te;if(X(K)){const le=O[K];if(typeof le=="function")return le.call(O,he)}throw new Error(`Event not found: ${K}`)}call(ce,K,he){const te=O[K];if(typeof te=="function"){if(!B&&Array.isArray(he))for(let le=0;le<he.length;le++)he[le]=(0,T.revive)(he[le]);return te.apply(O,he)}throw new Error(`Method not found: ${K}`)}}}z.fromService=W;function re(ae,ie){const O=ie&&ie.disableMarshalling;return new Proxy({},{get(B,ee){if(typeof ee=="string")return ie?.properties?.has(ee)?ie.properties.get(ee):X(ee)?function(ce){return ae.listen(ee,ce)}:V(ee)?ae.listen(ee):async function(...ce){let K;ie&&!(0,E.isUndefinedOrNull)(ie.context)?K=[ie.context,...ce]:K=ce;const he=await ae.call(ee,K);return O?he:(0,T.revive)(he)};throw new Error(`Property not found: ${String(ee)}`)}})}z.toService=re;function V(ae){return ae[0]==="o"&&ae[1]==="n"&&R.isUpperAsciiLetter(ae.charCodeAt(2))}function X(ae){return/^onDynamic/.test(ae)&&R.isUpperAsciiLetter(ae.charCodeAt(9))}})(q=e.ProxyChannel||(e.ProxyChannel={}));const U=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ne(z){if(Array.isArray(z))return z;if(z&&typeof z=="object"&&typeof z.toString=="function"){const W=z.toString();if(W!=="[object Object]")return W}return z}function Z(z){return Array.isArray(z)?z.map(ne):ne(z)}function F(z,W,re,V,X,ae,ie){ie=Z(ie);const O=U[X],B=O[V%O.length];let ee=[`%c[${z}]%c[${String(W).padStart(7," ")}]%c[len: ${String(re).padStart(5," ")}]%c${String(V).padStart(5," ")} - ${ae}`,"color: darkgreen","color: grey","color: grey",`color: ${B}`];/\($/.test(ae)?(ee=ee.concat(ie),ee.push(")")):ee.push(ie),console.log.apply(console,ee)}e.logWithColors=F;class x{constructor(W,re){this._outgoingPrefix=W,this._incomingPrefix=re,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(W,re,V,X,ae){this._totalOutgoing+=W,F(this._outgoingPrefix,this._totalOutgoing,W,re,V,X,ae)}logIncoming(W,re,V,X,ae){this._totalIncoming+=W,F(this._incomingPrefix,this._totalIncoming,W,re,V,X,ae)}}e.IPCLogger=x}),define(ve[92],we([0,1,16,7,2,43]),function(oe,e,I,t,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var k;(function(o){o.Created="created",o.Read="read",o.Write="write",o.Open="open",o.Error="error",o.Close="close",o.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",o.NodeEndReceived="nodeEndReceived",o.NodeEndSent="nodeEndSent",o.NodeDrainBegin="nodeDrainBegin",o.NodeDrainEnd="nodeDrainEnd",o.zlibInflateError="zlibInflateError",o.zlibInflateData="zlibInflateData",o.zlibInflateInitialWrite="zlibInflateInitialWrite",o.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",o.zlibInflateWrite="zlibInflateWrite",o.zlibInflateFlushFired="zlibInflateFlushFired",o.zlibDeflateError="zlibDeflateError",o.zlibDeflateData="zlibDeflateData",o.zlibDeflateWrite="zlibDeflateWrite",o.zlibDeflateFlushFired="zlibDeflateFlushFired",o.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",o.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",o.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",o.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",o.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",o.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",o.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",o.ProtocolHeaderRead="protocolHeaderRead",o.ProtocolMessageRead="protocolMessageRead",o.ProtocolHeaderWrite="protocolHeaderWrite",o.ProtocolMessageWrite="protocolMessageWrite",o.ProtocolWrite="protocolWrite"})(k=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var w;(function(o){o.enableDiagnostics=!1,o.records=[];const r=new WeakMap;let s=0;function c(S,A){if(!r.has(S)){const M=String(++s);r.set(S,M)}return r.get(S)}function u(S,A,M,$){if(!o.enableDiagnostics)return;const Q=c(S,A);if($ instanceof I.VSBuffer||$ instanceof Uint8Array||$ instanceof ArrayBuffer||ArrayBuffer.isView($)){const _=I.VSBuffer.alloc($.byteLength);_.set($),o.records.push({timestamp:Date.now(),id:Q,label:A,type:M,buff:_})}else o.records.push({timestamp:Date.now(),id:Q,label:A,type:M,data:$})}o.traceSocketEvent=u})(w=e.SocketDiagnostics||(e.SocketDiagnostics={}));var p;(function(o){o[o.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",o[o.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(p=e.SocketCloseEventType||(e.SocketCloseEventType={}));let D=null;function T(){return D||(D=I.VSBuffer.alloc(0)),D}class R{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(r){this._chunks.push(r),this._totalLength+=r.byteLength}read(r){return this._read(r,!0)}peek(r){return this._read(r,!1)}_read(r,s){if(r===0)return T();if(r>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===r){const A=this._chunks[0];return s&&(this._chunks.shift(),this._totalLength-=r),A}if(this._chunks[0].byteLength>r){const A=this._chunks[0].slice(0,r);return s&&(this._chunks[0]=this._chunks[0].slice(r),this._totalLength-=r),A}const c=I.VSBuffer.alloc(r);let u=0,S=0;for(;r>0;){const A=this._chunks[S];if(A.byteLength>r){const M=A.slice(0,r);c.set(M,u),u+=r,s&&(this._chunks[S]=A.slice(r),this._totalLength-=r),r-=r}else c.set(A,u),u+=A.byteLength,s?(this._chunks.shift(),this._totalLength-=A.byteLength):S++,r-=A.byteLength}return c}}e.ChunkStream=R;var E;(function(o){o[o.None=0]="None",o[o.Regular=1]="Regular",o[o.Control=2]="Control",o[o.Ack=3]="Ack",o[o.Disconnect=5]="Disconnect",o[o.ReplayRequest=6]="ReplayRequest",o[o.Pause=7]="Pause",o[o.Resume=8]="Resume"})(E||(E={}));function b(o){switch(o){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var d;(function(o){o[o.HeaderLength=13]="HeaderLength",o[o.AcknowledgeTime=2e3]="AcknowledgeTime",o[o.TimeoutTime=2e4]="TimeoutTime",o[o.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",o[o.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(d=e.ProtocolConstants||(e.ProtocolConstants={}));class C{constructor(r,s,c,u){this.type=r,this.id=s,this.ack=c,this.data=u,this.writtenTime=0}get size(){return this.data.byteLength}}class y extends v.Disposable{constructor(r){super();this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=r,this._isDisposed=!1,this._incomingData=new R,this._register(this._socket.onData(s=>this.acceptChunk(s))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(r);this._incomingData.byteLength>=this._state.readLen;){const s=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=s.readUInt32BE(9),this._state.messageType=s.readUInt8(0),this._state.id=s.readUInt32BE(1),this._state.ack=s.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:b(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const c=this._state.messageType,u=this._state.id,S=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",s),this._onMessage.fire(new C(c,u,S,s)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class m{constructor(r){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=r,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(r){if(this._isDisposed)return;r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const s=I.VSBuffer.alloc(13);s.writeUInt8(r.type,0),s.writeUInt32BE(r.id,1),s.writeUInt32BE(r.ack,5),s.writeUInt32BE(r.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:b(r.type),id:r.id,ack:r.ack,messageSize:r.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",r.data),this._writeSoon(s,r.data)}_bufferAdd(r,s){const c=this._totalLength===0;return this._data.push(r,s),this._totalLength+=r.byteLength+s.byteLength,c}_bufferTake(){const r=I.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,r}_writeSoon(r,s){this._bufferAdd(r,s)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const r=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:r.byteLength}),this._socket.write(r)}}class g extends v.Disposable{constructor(r){super();this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=r,this._socketWriter=this._register(new m(this._socket)),this._socketReader=this._register(new y(this._socket)),this._register(this._socketReader.onMessage(s=>{s.type===1&&this._onMessage.fire(s.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(r){this._socketWriter.write(new C(1,0,0,r))}}e.Protocol=g;class h extends P.IPCClient{constructor(r,s,c=null){super(r,s,c);this.protocol=r}static fromSocket(r,s){return new h(new g(r),s)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const r=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),r.end()}}e.Client=h;class l{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(r){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(r):this._emitter.fire(r):this._bufferedMessages.push(r)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=l;class f{constructor(r){this.data=r,this.next=null}}class i{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){const r=[];let s=0,c=this._first;for(;c;)r[s++]=c.data,c=c.next;return r}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(r){const s=new f(r);if(!this._first){this._first=s,this._last=s;return}this._last.next=s,this._last=s}}class a{constructor(){this.lastRuns=[];const r=Date.now();for(let s=0;s<a._HISTORY_LENGTH;s++)this.lastRuns[s]=r-1e3*s;setInterval(()=>{for(let s=a._HISTORY_LENGTH;s>=1;s--)this.lastRuns[s]=this.lastRuns[s-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return a._INSTANCE||(a._INSTANCE=new a),a._INSTANCE}load(){const r=Date.now(),s=(1+a._HISTORY_LENGTH)*1e3;let c=0;for(let u=0;u<a._HISTORY_LENGTH;u++)r-this.lastRuns[u]<=s&&c++;return 1-c/a._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}a._HISTORY_LENGTH=10,a._INSTANCE=null;class n{constructor(r,s=null,c=a.getInstance()){this._onControlMessage=new l,this.onControlMessage=this._onControlMessage.event,this._onMessage=new l,this.onMessage=this._onMessage.event,this._onDidDispose=new l,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new l,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new l,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=c,this._isReconnecting=!1,this._outgoingUnackMsg=new i,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=r,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new y(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(u=>this._receiveMessage(u))),this._socketDisposables.push(this._socket.onClose(u=>this._onSocketClose.fire(u))),s&&this._socketReader.acceptChunk(s)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,v.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const r=new C(5,0,0,T());this._socketWriter.write(r),this._socketWriter.flush()}sendPause(){const r=new C(7,0,0,T());this._socketWriter.write(r)}sendResume(){const r=new C(8,0,0,T());this._socketWriter.write(r)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(r,s){this._isReconnecting=!0,this._socketDisposables=(0,v.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=r,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new y(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(c=>this._receiveMessage(c))),this._socketDisposables.push(this._socket.onClose(c=>this._onSocketClose.fire(c))),this._socketReader.acceptChunk(s)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const r=new C(3,0,this._incomingAckId,T());this._socketWriter.write(r);const s=this._outgoingUnackMsg.toArray();for(let c=0,u=s.length;c<u;c++)this._socketWriter.write(s[c]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(r){if(r.ack>this._outgoingAckId){this._outgoingAckId=r.ack;do{const s=this._outgoingUnackMsg.peek();if(s&&s.id<=r.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(r.type){case 0:break;case 1:{if(r.id>this._incomingMsgId)if(r.id!==this._incomingMsgId+1){const s=Date.now();s-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=s,this._socketWriter.write(new C(6,0,0,T())))}else this._incomingMsgId=r.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(r.data);break}case 2:{this._onControlMessage.fire(r.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const s=this._outgoingUnackMsg.toArray();for(let c=0,u=s.length;c<u;c++)this._socketWriter.write(s[c]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(r){const s=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const c=new C(1,s,this._incomingAckId,r);this._outgoingUnackMsg.push(c),this._isReconnecting||(this._socketWriter.write(c),this._recvAckCheck())}sendControl(r){const s=new C(2,0,0,r);this._socketWriter.write(s)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const r=Date.now()-this._incomingMsgLastTime;if(r>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-r+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const r=this._outgoingUnackMsg.peek(),s=Date.now()-r.writtenTime,c=Date.now()-this._socketReader.lastReadTime,u=Date.now()-this._lastSocketTimeoutTime;if(s>=2e4&&c>=2e4&&u>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const S=Math.max(2e4-s,2e4-c,2e4-u,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},S)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const r=new C(3,0,this._incomingAckId,T());this._socketWriter.write(r)}}e.PersistentProtocol=n}),define(ve[152],we([0,1,14,7,2,12]),function(oe,e,I,t,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var k;(function(R){R[R.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(k=e.StorageHint||(e.StorageHint={}));function w(R){const E=R;return E?.changed instanceof Map||E?.deleted instanceof Set}e.isStorageItemsChangeEvent=w;var p;(function(R){R[R.None=0]="None",R[R.Initialized=1]="Initialized",R[R.Closed=2]="Closed"})(p=e.StorageState||(e.StorageState={}));class D extends v.Disposable{constructor(E,b=Object.create(null)){super();this.database=E,this.options=b,this._onDidChangeStorage=this._register(new t.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=p.None,this.cache=new Map,this.flushDelayer=new I.ThrottledDelayer(D.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(E=>this.onDidChangeItemsExternal(E)))}onDidChangeItemsExternal(E){E.changed?.forEach((b,d)=>this.accept(d,b)),E.deleted?.forEach(b=>this.accept(b,void 0))}accept(E,b){if(this.state===p.Closed)return;let d=!1;(0,P.isUndefinedOrNull)(b)?d=this.cache.delete(E):this.cache.get(E)!==b&&(this.cache.set(E,b),d=!0),d&&this._onDidChangeStorage.fire(E)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===p.None&&(this.state=p.Initialized,this.options.hint!==k.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(E,b){const d=this.cache.get(E);return(0,P.isUndefinedOrNull)(d)?b:d}getBoolean(E,b){const d=this.get(E);return(0,P.isUndefinedOrNull)(d)?b:d==="true"}getNumber(E,b){const d=this.get(E);return(0,P.isUndefinedOrNull)(d)?b:parseInt(d,10)}async set(E,b){if(this.state===p.Closed)return;if((0,P.isUndefinedOrNull)(b))return this.delete(E);const d=String(b);if(this.cache.get(E)!==d)return this.cache.set(E,d),this.pendingInserts.set(E,d),this.pendingDeletes.delete(E),this._onDidChangeStorage.fire(E),this.doFlush()}async delete(E){if(!(this.state===p.Closed||!this.cache.delete(E)))return this.pendingDeletes.has(E)||this.pendingDeletes.add(E),this.pendingInserts.delete(E),this._onDidChangeStorage.fire(E),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=p.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const E={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(E).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(E){if(!!this.hasPending)return this.doFlush(E)}async doFlush(E){return this.flushDelayer.trigger(()=>this.flushPending(),E)}async whenFlushed(){if(!!this.hasPending)return new Promise(E=>this.whenFlushedCallbacks.push(E))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=D,D.DEFAULT_FLUSH_DELAY=100;class T{constructor(){this.onDidChangeItemsExternal=t.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(E){E.insert?.forEach((b,d)=>this.items.set(d,b)),E.delete?.forEach(b=>this.items.delete(b))}async close(){}}e.InMemoryStorageDatabase=T}),define(ve[153],we([0,1,7,2]),function(oe,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class v{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(w){this._onDidChange.fire({changedLanguages:w,changedColorMap:!1})}register(w,p){return this._map.set(w,p),this.fire([w]),(0,t.toDisposable)(()=>{this._map.get(w)===p&&(this._map.delete(w),this.fire([w]))})}registerFactory(w,p){this._factories.get(w)?.dispose();const D=new P(this,w,p);return this._factories.set(w,D),(0,t.toDisposable)(()=>{const T=this._factories.get(w);!T||T!==D||(this._factories.delete(w),T.dispose())})}async getOrCreate(w){const p=this.get(w);if(p)return p;const D=this._factories.get(w);return!D||D.isResolved?null:(await D.resolve(),this.get(w))}get(w){return this._map.get(w)||null}isResolved(w){if(this.get(w))return!0;const D=this._factories.get(w);return!!(!D||D.isResolved)}setColorMap(w){this._colorMap=w,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=v;class P extends t.Disposable{constructor(w,p,D){super();this._registry=w,this._languageId=p,this._factory=D,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}get isResolved(){return this._isResolved}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const w=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,w&&!this._isDisposed&&this._register(this._registry.register(this._languageId,w))}}}),define(ve[154],we([0,1,40,4,50,153]),function(oe,e,I,t,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class k{constructor(S,A,M){this._tokenBrand=void 0,this.offset=S,this.type=A,this.language=M}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=k;class w{constructor(S,A){this._tokenizationResultBrand=void 0,this.tokens=S,this.endState=A}}e.TokenizationResult=w;class p{constructor(S,A){this._encodedTokenizationResultBrand=void 0,this.tokens=S,this.endState=A}}e.EncodedTokenizationResult=p;var D;(function(u){u[u.Method=0]="Method",u[u.Function=1]="Function",u[u.Constructor=2]="Constructor",u[u.Field=3]="Field",u[u.Variable=4]="Variable",u[u.Class=5]="Class",u[u.Struct=6]="Struct",u[u.Interface=7]="Interface",u[u.Module=8]="Module",u[u.Property=9]="Property",u[u.Event=10]="Event",u[u.Operator=11]="Operator",u[u.Unit=12]="Unit",u[u.Value=13]="Value",u[u.Constant=14]="Constant",u[u.Enum=15]="Enum",u[u.EnumMember=16]="EnumMember",u[u.Keyword=17]="Keyword",u[u.Text=18]="Text",u[u.Color=19]="Color",u[u.File=20]="File",u[u.Reference=21]="Reference",u[u.Customcolor=22]="Customcolor",u[u.Folder=23]="Folder",u[u.TypeParameter=24]="TypeParameter",u[u.User=25]="User",u[u.Issue=26]="Issue",u[u.Snippet=27]="Snippet"})(D=e.CompletionItemKind||(e.CompletionItemKind={}));var T;(function(u){const S=new Map;S.set(0,I.Codicon.symbolMethod),S.set(1,I.Codicon.symbolFunction),S.set(2,I.Codicon.symbolConstructor),S.set(3,I.Codicon.symbolField),S.set(4,I.Codicon.symbolVariable),S.set(5,I.Codicon.symbolClass),S.set(6,I.Codicon.symbolStruct),S.set(7,I.Codicon.symbolInterface),S.set(8,I.Codicon.symbolModule),S.set(9,I.Codicon.symbolProperty),S.set(10,I.Codicon.symbolEvent),S.set(11,I.Codicon.symbolOperator),S.set(12,I.Codicon.symbolUnit),S.set(13,I.Codicon.symbolValue),S.set(15,I.Codicon.symbolEnum),S.set(14,I.Codicon.symbolConstant),S.set(15,I.Codicon.symbolEnum),S.set(16,I.Codicon.symbolEnumMember),S.set(17,I.Codicon.symbolKeyword),S.set(27,I.Codicon.symbolSnippet),S.set(18,I.Codicon.symbolText),S.set(19,I.Codicon.symbolColor),S.set(20,I.Codicon.symbolFile),S.set(21,I.Codicon.symbolReference),S.set(22,I.Codicon.symbolCustomColor),S.set(23,I.Codicon.symbolFolder),S.set(24,I.Codicon.symbolTypeParameter),S.set(25,I.Codicon.account),S.set(26,I.Codicon.issues);function A(Q){let _=S.get(Q);return _||(console.info("No codicon found for CompletionItemKind "+Q),_=I.Codicon.symbolProperty),_}u.toIcon=A;const M=new Map;M.set("method",0),M.set("function",1),M.set("constructor",2),M.set("field",3),M.set("variable",4),M.set("class",5),M.set("struct",6),M.set("interface",7),M.set("module",8),M.set("property",9),M.set("event",10),M.set("operator",11),M.set("unit",12),M.set("value",13),M.set("constant",14),M.set("enum",15),M.set("enum-member",16),M.set("enumMember",16),M.set("keyword",17),M.set("snippet",27),M.set("text",18),M.set("color",19),M.set("file",20),M.set("reference",21),M.set("customcolor",22),M.set("folder",23),M.set("type-parameter",24),M.set("typeParameter",24),M.set("account",25),M.set("issue",26);function $(Q,_){let q=M.get(Q);return typeof q=="undefined"&&!_&&(q=9),q}u.fromString=$})(T=e.CompletionItemKinds||(e.CompletionItemKinds={}));var R;(function(u){u[u.Deprecated=1]="Deprecated"})(R=e.CompletionItemTag||(e.CompletionItemTag={}));var E;(function(u){u[u.KeepWhitespace=1]="KeepWhitespace",u[u.InsertAsSnippet=4]="InsertAsSnippet"})(E=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var b;(function(u){u[u.Invoke=0]="Invoke",u[u.TriggerCharacter=1]="TriggerCharacter",u[u.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(b=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var d;(function(u){u[u.Automatic=0]="Automatic",u[u.Explicit=1]="Explicit"})(d=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var C;(function(u){u[u.Invoke=1]="Invoke",u[u.Auto=2]="Auto"})(C=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var y;(function(u){u[u.Invoke=1]="Invoke",u[u.TriggerCharacter=2]="TriggerCharacter",u[u.ContentChange=3]="ContentChange"})(y=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var m;(function(u){u[u.Text=0]="Text",u[u.Read=1]="Read",u[u.Write=2]="Write"})(m=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function g(u){return u&&t.URI.isUri(u.uri)&&v.Range.isIRange(u.range)&&(v.Range.isIRange(u.originSelectionRange)||v.Range.isIRange(u.targetSelectionRange))}e.isLocationLink=g;var h;(function(u){u[u.File=0]="File",u[u.Module=1]="Module",u[u.Namespace=2]="Namespace",u[u.Package=3]="Package",u[u.Class=4]="Class",u[u.Method=5]="Method",u[u.Property=6]="Property",u[u.Field=7]="Field",u[u.Constructor=8]="Constructor",u[u.Enum=9]="Enum",u[u.Interface=10]="Interface",u[u.Function=11]="Function",u[u.Variable=12]="Variable",u[u.Constant=13]="Constant",u[u.String=14]="String",u[u.Number=15]="Number",u[u.Boolean=16]="Boolean",u[u.Array=17]="Array",u[u.Object=18]="Object",u[u.Key=19]="Key",u[u.Null=20]="Null",u[u.EnumMember=21]="EnumMember",u[u.Struct=22]="Struct",u[u.Event=23]="Event",u[u.Operator=24]="Operator",u[u.TypeParameter=25]="TypeParameter"})(h=e.SymbolKind||(e.SymbolKind={}));var l;(function(u){u[u.Deprecated=1]="Deprecated"})(l=e.SymbolTag||(e.SymbolTag={}));var f;(function(u){const S=new Map;S.set(0,I.Codicon.symbolFile),S.set(1,I.Codicon.symbolModule),S.set(2,I.Codicon.symbolNamespace),S.set(3,I.Codicon.symbolPackage),S.set(4,I.Codicon.symbolClass),S.set(5,I.Codicon.symbolMethod),S.set(6,I.Codicon.symbolProperty),S.set(7,I.Codicon.symbolField),S.set(8,I.Codicon.symbolConstructor),S.set(9,I.Codicon.symbolEnum),S.set(10,I.Codicon.symbolInterface),S.set(11,I.Codicon.symbolFunction),S.set(12,I.Codicon.symbolVariable),S.set(13,I.Codicon.symbolConstant),S.set(14,I.Codicon.symbolString),S.set(15,I.Codicon.symbolNumber),S.set(16,I.Codicon.symbolBoolean),S.set(17,I.Codicon.symbolArray),S.set(18,I.Codicon.symbolObject),S.set(19,I.Codicon.symbolKey),S.set(20,I.Codicon.symbolNull),S.set(21,I.Codicon.symbolEnumMember),S.set(22,I.Codicon.symbolStruct),S.set(23,I.Codicon.symbolEvent),S.set(24,I.Codicon.symbolOperator),S.set(25,I.Codicon.symbolTypeParameter);function A(M){let $=S.get(M);return $||(console.info("No codicon found for SymbolKind "+M),$=I.Codicon.symbolProperty),$}u.toIcon=A})(f=e.SymbolKinds||(e.SymbolKinds={}));class i{constructor(S){this.value=S}}e.FoldingRangeKind=i,i.Comment=new i("comment"),i.Imports=new i("imports"),i.Region=new i("region");var a;(function(u){function S(A){return!A||typeof A!="object"?!1:typeof A.id=="string"&&typeof A.title=="string"}u.is=S})(a=e.Command||(e.Command={}));var n;(function(u){u[u.Collapsed=0]="Collapsed",u[u.Expanded=1]="Expanded"})(n=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var o;(function(u){u[u.Unresolved=0]="Unresolved",u[u.Resolved=1]="Resolved"})(o=e.CommentThreadState||(e.CommentThreadState={}));var r;(function(u){u[u.Editing=0]="Editing",u[u.Preview=1]="Preview"})(r=e.CommentMode||(e.CommentMode={}));var s;(function(u){u[u.Type=1]="Type",u[u.Parameter=2]="Parameter"})(s=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new P.TokenizationRegistry;var c;(function(u){u[u.None=0]="None",u[u.Option=1]="Option",u[u.Default=2]="Default",u[u.Preferred=3]="Preferred"})(c=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ve[155],we([8,9]),function(oe,e){return oe.create("vs/base/node/processes",e)}),define(ve[93],we([0,1,42,33,10,22,5,3,28,56,12,135,21,155]),function(oe,e,I,t,v,P,k,w,p,D,T,R,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return D.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return D.TerminateResponseCode}});function d(f){switch(f){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function C(f,i){if(w.isWindows)try{const a={stdio:["pipe","pipe","ignore"]};i&&(a.cwd=i);const n=I.execFile("taskkill",["/T","/F","/PID",f.pid.toString()],a);return new Promise(o=>{n.once("error",r=>{o({success:!1,error:r})}),n.once("exit",(r,s)=>{o(r===0?{success:!0}:{success:!1,code:r!==null?r:1})})})}catch(a){return Promise.resolve({success:!1,error:a,code:a.status?d(a.status):1})}else if(w.isLinux||w.isMacintosh)try{const a=v.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",oe).fsPath;return new Promise(n=>{I.execFile(a,[f.pid.toString()],{encoding:"utf8",shell:!0},(o,r,s)=>{n(o?{success:!1,error:o}:{success:!0})})})}catch(a){return Promise.resolve({success:!1,error:a})}else f.kill("SIGKILL");return Promise.resolve({success:!0})}function y(f=p.env){return f.comspec||"cmd.exe"}e.getWindowsShell=y;class m{constructor(i,a,n,o){if(a!==void 0&&n!==void 0&&o!==void 0)this.cmd=i,this.args=a,this.shell=n,this.options=o;else{const r=i;this.cmd=r.command,this.shell=r.isShellCommand,this.args=r.args.slice(0),this.options=r.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const r=Object.create(null);Object.keys(p.env).forEach(s=>{r[s]=p.env[s]}),Object.keys(this.options.env).forEach(s=>{r[s]=this.options.env[s]}),this.options.env=r}}getSanitizedCommand(){let i=this.cmd.toLowerCase();const a=i.lastIndexOf(k.sep);return a!==-1&&(i=i.substring(a+1)),m.WellKnowCommands[i]?i:"other"}start(i){return w.isWindows&&(this.options&&this.options.cwd&&t.isUNC(this.options.cwd)||!this.options&&t.isUNC(p.cwd()))?Promise.reject(new Error(b.localize(0,null))):this.useExec().then(a=>{let n,o;const r=new Promise((s,c)=>{n=s,o=c});if(a){let s=this.cmd;this.args&&(s=s+" "+this.args.join(" ")),this.childProcess=I.exec(s,this.options,(c,u,S)=>{this.childProcess=null;const A=c;A&&A.killed?o({killed:this.terminateRequested,stdout:u.toString(),stderr:S.toString()}):this.handleExec(n,i,c,u,S)})}else{let s=null;const c=u=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(u,n,i,o);const S={terminated:this.terminateRequested};T.isNumber(u)&&(S.cmdCode=u),n(S)};if(this.shell&&w.isWindows){const u=P.deepClone(this.options);u.windowsVerbatimArguments=!0,u.detached=!1;let S=!1,A=!1;const M=[];let $=this.ensureQuotes(this.cmd);M.push($.value),S=$.quoted,this.args&&this.args.forEach(_=>{$=this.ensureQuotes(_),M.push($.value),A=A&&$.quoted});const Q=["/s","/c"];S?A?Q.push('"'+M.join(" ")+'"'):M.length>1?Q.push('"'+M[0]+'" '+M.slice(1).join(" ")):Q.push('"'+M[0]+'"'):Q.push(M.join(" ")),s=I.spawn(y(),Q,u)}else this.cmd&&(s=I.spawn(this.cmd,this.args,this.options));s&&(this.childProcess=s,this.childProcessPromise=Promise.resolve(s),this.pidResolve&&(this.pidResolve(T.isNumber(s.pid)?s.pid:-1),this.pidResolve=void 0),s.on("error",u=>{this.childProcess=null,o({terminated:this.terminateRequested,error:u})}),s.pid&&(this.childProcess.on("close",c),this.handleSpawn(s,n,i,o,!0)))}return r})}handleClose(i,a,n,o){}ensureQuotes(i){return m.regexp.test(i)?{value:'"'+i+'"',quoted:!0}:{value:i,quoted:i.length>0&&i[0]==='"'&&i[i.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(i=>i.pid,i=>-1):new Promise(i=>{this.pidResolve=i})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(i=>(this.terminateRequested=!0,C(i,this.options.cwd).then(a=>(a.success&&(this.childProcess=null),a))),i=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(i=>{if(!this.shell||!w.isWindows)return i(!1);const a=I.spawn(y(),["/s","/c"]);a.on("error",n=>i(!0)),a.on("exit",n=>i(!1))})}}e.AbstractProcess=m,m.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},m.regexp=/^[^"].* .*[^"]/;class g extends m{constructor(i,a,n,o){super(i,a,n,o);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(i,a,n,o,r){[o,r].forEach((s,c)=>{const u=new R.LineDecoder;u.write(s).forEach(M=>{a({line:M,source:c===0?0:1})});const A=u.end();A&&a({line:A,source:c===0?0:1})}),i({terminated:this.terminateRequested,error:n})}handleSpawn(i,a,n,o,r){const s=new R.LineDecoder,c=new R.LineDecoder;i.stdout.on("data",u=>{s.write(u).forEach(A=>n({line:A,source:0}))}),i.stderr.on("data",u=>{c.write(u).forEach(A=>n({line:A,source:1}))}),this.stdoutLineDecoder=s,this.stderrLineDecoder=c}handleClose(i,a,n,o){const r=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;r&&n({line:r,source:0});const s=this.stderrLineDecoder?this.stderrLineDecoder.end():null;s&&n({line:s,source:1})}}e.LineProcess=g;function h(f){let i=[],a=!1;const n=function(o){if(a){i.push(o);return}(!f.send(o,s=>{if(s&&console.error(s),a=!1,i.length>0){const c=i.slice(0);i=[],c.forEach(u=>n(u))}})||w.isWindows)&&(a=!0)};return{send:n}}e.createQueuedSender=h;var l;(function(f){async function i(a,n,o){if(k.isAbsolute(a))return a;if(n===void 0&&(n=p.cwd()),k.dirname(a)!=="."||(o===void 0&&T.isString(p.env.PATH)&&(o=p.env.PATH.split(k.delimiter)),o===void 0||o.length===0))return k.join(n,a);async function s(c){if(await E.Promises.exists(c)){let u;try{u=await E.Promises.stat(c)}catch(S){S.message.startsWith("EACCES")&&(u=await E.Promises.lstat(c))}return u?!u.isDirectory():!1}return!1}for(const c of o){let u;if(k.isAbsolute(c)?u=k.join(c,a):u=k.join(n,c,a),await s(u))return u;let S=u+".com";if(await s(S)||(S=u+".exe",await s(S)))return S}return k.join(n,a)}f.findExecutable=i})(l=e.win32||(e.win32={}))}),define(ve[156],we([0,1,27,3,90,93]),function(oe,e,I,t,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function k(b,d){return b===1?t.isWindows?R():P.getWindowsShell(d):D(b,d)}e.getSystemShell=k;function w(b,d){return b===1?t.isWindows?E(d):P.getWindowsShell(d):D(b,d)}e.getSystemShellSync=w;let p=null;function D(b,d){if(t.isLinux&&b===2||t.isMacintosh&&b===3)return"/bin/bash";if(!p){let C;if(t.isWindows)C="/bin/bash";else{if(C=d.SHELL,!C)try{C=(0,I.userInfo)().shell}catch{}C||(C="sh"),C==="/bin/false"&&(C="/bin/bash")}p=C}return p}let T=null;async function R(){return T||(T=(await(0,v.getFirstAvailablePowerShellInstallation)()).exePath),T}function E(b){if(T)return T;const d=t.isWindows&&parseFloat((0,I.release)())>=10,C=b.hasOwnProperty("PROCESSOR_ARCHITEW6432"),y=`${b.windir}\\${C?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return d?y:P.getWindowsShell(b)}}),define(ve[94],we([0,1,42,14,16,20,149,11,7,2,22,93,56,43]),function(oe,e,I,t,v,P,k,w,p,D,T,R,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class d extends b.ChannelServer{constructor(m){super({send:g=>{try{process.send?.(g.buffer.toString("base64"))}catch{}},onMessage:p.Event.fromNodeEventEmitter(process,"message",g=>v.VSBuffer.wrap(Buffer.from(g,"base64")))},m);process.once("disconnect",()=>this.dispose())}}e.Server=d;class C{constructor(m,g){this.modulePath=m,this.options=g,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new p.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const h=g&&g.timeout?g.timeout:6e4;this.disposeDelayer=new t.Delayer(h),this.child=null,this._client=null}getChannel(m){const g=this;return{call(h,l,f){return g.requestPromise(m,h,l,f)},listen(h,l){return g.requestEvent(m,h,l)}}}requestPromise(m,g,h,l=P.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(l.isCancellationRequested)return Promise.reject(w.canceled());this.disposeDelayer.cancel();const f=this.getCachedChannel(m),i=(0,t.createCancelablePromise)(o=>f.call(g,h,o)),a=l.onCancellationRequested(()=>i.cancel()),n=(0,D.toDisposable)(()=>i.cancel());return this.activeRequests.add(n),i.finally(()=>{a.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),i}requestEvent(m,g,h){if(!this.disposeDelayer)return p.Event.None;this.disposeDelayer.cancel();let l;const f=new p.Emitter({onFirstListenerAdd:()=>{l=this.getCachedChannel(m).listen(g,h)(f.fire,f),this.activeRequests.add(l)},onLastListenerRemove:()=>{this.activeRequests.delete(l),l.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return f.event}get client(){if(!this._client){const m=this.options&&this.options.args?this.options.args:[],g=Object.create(null);g.env={...(0,T.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(g.env={...g.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(g.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(g.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(g.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),g.execArgv===void 0&&(g.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r))),(0,E.removeDangerousEnvVariables)(g.env),this.child=(0,I.fork)(this.modulePath,m,g);const h=new p.Emitter;p.Event.fromNodeEventEmitter(this.child,"message",r=>r)(r=>{if((0,k.isRemoteConsoleLog)(r)){(0,k.log)(r,`IPC Library: ${this.options.serverName}`);return}h.fire(v.VSBuffer.wrap(Buffer.from(r,"base64")))});const f=this.options.useQueue?(0,R.createQueuedSender)(this.child):this.child,i=r=>this.child&&this.child.connected&&f.send(r.buffer.toString("base64")),a=h.event,n={send:i,onMessage:a};this._client=new b.ChannelClient(n);const o=()=>this.disposeClient();process.once("exit",o),this.child.on("error",r=>console.warn('IPC "'+this.options.serverName+'" errored with '+r)),this.child.on("exit",(r,s)=>{process.removeListener("exit",o),this.activeRequests.forEach(c=>(0,D.dispose)(c)),this.activeRequests.clear(),r!==0&&s!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+r+" and signal "+s),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:r,signal:s})})}return this._client}getCachedChannel(m){let g=this.channels.get(m);return g||(g=this.client.getChannel(m),this.channels.set(m,g)),g}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=C}),define(ve[157],we([8,9]),function(oe,e){return oe.create("vs/base/node/zip",e)}),define(ve[158],we([8,9]),function(oe,e){return oe.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ve[159],we([8,9]),function(oe,e){return oe.create("vs/platform/environment/node/argv",e)}),define(ve[160],we([8,9]),function(oe,e){return oe.create("vs/platform/environment/node/argvHelper",e)}),define(ve[161],we([8,9]),function(oe,e){return oe.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ve[162],we([8,9]),function(oe,e){return oe.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ve[163],we([8,9]),function(oe,e){return oe.create("vs/platform/extensionManagement/common/extensionManagementCLIService",e)}),define(ve[164],we([8,9]),function(oe,e){return oe.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ve[165],we([8,9]),function(oe,e){return oe.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ve[166],we([8,9]),function(oe,e){return oe.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ve[167],we([8,9]),function(oe,e){return oe.create("vs/platform/extensions/common/extensionValidator",e)}),define(ve[168],we([8,9]),function(oe,e){return oe.create("vs/platform/files/common/fileService",e)}),define(ve[169],we([8,9]),function(oe,e){return oe.create("vs/platform/files/common/files",e)}),define(ve[170],we([8,9]),function(oe,e){return oe.create("vs/platform/files/common/io",e)}),define(ve[171],we([8,9]),function(oe,e){return oe.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ve[172],we([8,9]),function(oe,e){return oe.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ve[173],we([8,9]),function(oe,e){return oe.create("vs/platform/markers/common/markers",e)}),define(ve[174],we([8,9]),function(oe,e){return oe.create("vs/platform/request/common/request",e)}),define(ve[175],we([8,9]),function(oe,e){return oe.create("vs/platform/shell/node/shellEnv",e)}),define(ve[176],we([8,9]),function(oe,e){return oe.create("vs/platform/telemetry/common/telemetryService",e)}),define(ve[177],we([8,9]),function(oe,e){return oe.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ve[178],we([8,9]),function(oe,e){return oe.create("vs/platform/terminal/common/terminalProfiles",e)}),define(ve[179],we([8,9]),function(oe,e){return oe.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ve[180],we([8,9]),function(oe,e){return oe.create("vs/platform/workspace/common/workspace",e)}),define(ve[181],we([8,9]),function(oe,e){return oe.create("vs/server/node/serverEnvironmentService",e)}),define(ve[182],we([8,9]),function(oe,e){return oe.create("vs/workbench/common/editor",e)}),define(ve[183],we([8,9]),function(oe,e){return oe.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ve[184],we([8,9]),function(oe,e){return oe.create("vs/workbench/services/extensions/common/extensionsUtil",e)}),define(ve[185],we([0,1,7,2]),function(oe,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class v{constructor(){this._onCloseEmitter=new I.Emitter,this._onReloadEmitter=new I.Emitter,this._onTerminateEmitter=new I.Emitter,this._onAttachEmitter=new I.Emitter}call(w,p,D){switch(p){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:D[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:D[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:D[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:D[0],port:D[1],subId:D[2]}))}throw new Error("Method not implemented.")}listen(w,p,D){switch(p){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=v,v.ChannelName="extensionhostdebugservice";class P extends t.Disposable{constructor(w){super();this.channel=w}reload(w){this.channel.call("reload",[w])}get onReload(){return this.channel.listen("reload")}close(w){this.channel.call("close",[w])}get onClose(){return this.channel.listen("close")}attachSession(w,p,D){this.channel.call("attach",[w,p,D])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(w,p){this.channel.call("terminate",[w,p])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(w,p){return this.channel.call("openExtensionDevelopmentHostWindow",[w,p])}}e.ExtensionHostDebugChannelClient=P}),define(ve[186],we([0,1,4]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadServiceChannelClient=e.DownloadServiceChannel=void 0;class t{constructor(k){this.service=k}listen(k,w,p){throw new Error("Invalid listen")}call(k,w,p){switch(w){case"download":return this.service.download(I.URI.revive(p[0]),I.URI.revive(p[1]))}throw new Error("Invalid call")}}e.DownloadServiceChannel=t;class v{constructor(k,w){this.channel=k,this.getUriTransformer=w}async download(k,w){const p=this.getUriTransformer();p&&(k=p.transformOutgoingURI(k),w=p.transformOutgoingURI(w)),await this.channel.call("download",[k,w])}}e.DownloadServiceChannelClient=v}),define(ve[187],we([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionSource=e.TextEditorSelectionRevealType=e.EditorOpenSource=e.EditorResolution=e.EditorActivation=void 0;var I;(function(w){w[w.ACTIVATE=1]="ACTIVATE",w[w.RESTORE=2]="RESTORE",w[w.PRESERVE=3]="PRESERVE"})(I=e.EditorActivation||(e.EditorActivation={}));var t;(function(w){w[w.PICK=0]="PICK",w[w.DISABLED=1]="DISABLED",w[w.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(t=e.EditorResolution||(e.EditorResolution={}));var v;(function(w){w[w.API=0]="API",w[w.USER=1]="USER"})(v=e.EditorOpenSource||(e.EditorOpenSource={}));var P;(function(w){w[w.Center=0]="Center",w[w.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",w[w.NearTop=2]="NearTop",w[w.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(P=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}));var k;(function(w){w.PROGRAMMATIC="api",w.NAVIGATION="code.navigation",w.JUMP="code.jump"})(k=e.TextEditorSelectionSource||(e.TextEditorSelectionSource={}))}),define(ve[188],we([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;class I{constructor(v){this.machineId=v}encryption(){return new Promise((v,P)=>oe(["vscode-encrypt"],v,P))}async encrypt(v){try{return(await this.encryption()).encrypt(this.machineId,v)}catch{return v}}async decrypt(v){try{return(await this.encryption()).decrypt(this.machineId,v)}catch{return v}}}e.EncryptionMainService=I}),define(ve[95],we([0,1,140,82,10,5,28,19,4]),function(oe,e,I,t,v,P,k,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class D{constructor(C,y,m){this._args=C,this.paths=y,this.productService=m,this.editSessionId=this.args.editSessionId}get appRoot(){return(0,P.dirname)(v.FileAccess.asFileUri("",oe).fsPath)}get userHome(){return p.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return p.URI.file((0,P.join)(this.userDataPath,"User"))}get tmpDir(){return p.URI.file(this.paths.tmpDir)}get cacheHome(){return p.URI.file(this.userDataPath)}get stateResource(){return(0,w.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,w.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const C=(0,I.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,P.join)(this.userDataPath,"logs",C)}return this.args.logsPath}get userDataSyncLogResource(){return p.URI.file((0,P.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,w.joinPath)(p.URI.file((0,P.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,w.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,w.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,w.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const C=k.env.VSCODE_PORTABLE;return C?p.URI.file((0,P.join)(C,"argv.json")):(0,w.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return p.URI.file((0,P.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,P.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const C=this.args["builtin-extensions-dir"];return C?(0,P.resolve)(C):(0,P.normalize)((0,P.join)(v.FileAccess.asFileUri("",oe).fsPath,"..","extensions"))}get extensionsDownloadPath(){const C=this.args["extensions-download-dir"];return C?(0,P.resolve)(C):(0,P.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const C=this.args["extensions-dir"];if(C)return(0,P.resolve)(C);const y=k.env.VSCODE_EXTENSIONS;if(y)return y;const m=k.env.VSCODE_PORTABLE;return m?(0,P.join)(m,"extensions"):(0,w.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const C=this.args.extensionDevelopmentPath;if(Array.isArray(C))return C.map(y=>/^[^:/?#]+?:\/\//.test(y)?p.URI.parse(y):p.URI.file((0,P.normalize)(y)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(C=>C==="ui"||C==="workspace"||C==="web"?C:"workspace")}get extensionTestsLocationURI(){const C=this.args.extensionTestsPath;if(C)return/^[^:/?#]+?:\/\//.test(C)?p.URI.parse(C):p.URI.file((0,P.normalize)(C))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const C=this.args["disable-extension"];if(C){if(typeof C=="string")return[C];if(Array.isArray(C)&&C.length>0)return C}return!1}get debugExtensionHost(){return T(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!k.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,w.joinPath)(p.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return p.URI.file((0,P.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const C=k.env.VSCODE_PORTABLE;return C?p.URI.file((0,P.join)(C,"policy.json")):(0,w.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get args(){return this._args}}Re([t.memoize],D.prototype,"appRoot",null),Re([t.memoize],D.prototype,"userHome",null),Re([t.memoize],D.prototype,"userDataPath",null),Re([t.memoize],D.prototype,"appSettingsHome",null),Re([t.memoize],D.prototype,"tmpDir",null),Re([t.memoize],D.prototype,"cacheHome",null),Re([t.memoize],D.prototype,"stateResource",null),Re([t.memoize],D.prototype,"userRoamingDataHome",null),Re([t.memoize],D.prototype,"userDataSyncHome",null),Re([t.memoize],D.prototype,"userDataSyncLogResource",null),Re([t.memoize],D.prototype,"sync",null),Re([t.memoize],D.prototype,"machineSettingsResource",null),Re([t.memoize],D.prototype,"workspaceStorageHome",null),Re([t.memoize],D.prototype,"localHistoryHome",null),Re([t.memoize],D.prototype,"keyboardLayoutResource",null),Re([t.memoize],D.prototype,"argvResource",null),Re([t.memoize],D.prototype,"isExtensionDevelopment",null),Re([t.memoize],D.prototype,"untitledWorkspacesHome",null),Re([t.memoize],D.prototype,"installSourcePath",null),Re([t.memoize],D.prototype,"builtinExtensionsPath",null),Re([t.memoize],D.prototype,"extensionsPath",null),Re([t.memoize],D.prototype,"extensionDevelopmentLocationURI",null),Re([t.memoize],D.prototype,"extensionDevelopmentKind",null),Re([t.memoize],D.prototype,"extensionTestsLocationURI",null),Re([t.memoize],D.prototype,"debugExtensionHost",null),Re([t.memoize],D.prototype,"serviceMachineIdResource",null),Re([t.memoize],D.prototype,"telemetryLogResource",null),Re([t.memoize],D.prototype,"disableWorkspaceTrust",null),Re([t.memoize],D.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=D;function T(d,C){return b(d["inspect-extensions"],d["inspect-brk-extensions"],5870,C,d.debugId,d.extensionEnvironment)}e.parseExtensionHostPort=T;function R(d,C){return b(d["inspect-search"],d["inspect-brk-search"],5876,C,d.extensionEnvironment)}e.parseSearchPort=R;function E(d,C){return b(d["inspect-ptyhost"],d["inspect-brk-ptyhost"],5877,C,d.extensionEnvironment)}e.parsePtyHostPort=E;function b(d,C,y,m,g,h){const f=Number(C||d)||(m?null:y),i=f?Boolean(!!C):!1;let a;if(h)try{a=JSON.parse(h)}catch{}return{port:f,break:i,debugId:g,env:a}}}),define(ve[57],we([0,1,267,3,159]),function(oe,e,I,t,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const P={o:(0,v.localize)(0,null),e:(0,v.localize)(1,null),t:(0,v.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,v.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,v.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,v.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,v.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,v.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,v.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,v.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,v.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,v.localize)(11,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,v.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,v.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,v.localize)(14,null)},category:{type:"string",cat:"e",description:(0,v.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,v.localize)(16,null)},"pre-release":{type:"boolean",cat:"e",description:(0,v.localize)(17,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,v.localize)(18,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,v.localize)(19,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,v.localize)(20,null)},verbose:{type:"boolean",cat:"t",description:(0,v.localize)(21,null)},log:{type:"string",cat:"t",args:"level",description:(0,v.localize)(22,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,v.localize)(23,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,v.localize)(24,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,v.localize)(25,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,v.localize)(26,null)},sync:{type:"string",cat:"t",description:(0,v.localize)(27,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,v.localize)(28,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,v.localize)(29,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,v.localize)(30,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,v.localize)(31,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,v.localize)(32,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},_:{type:"string[]"}};const k={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function w(d,C,y=k){const m={},g=["_"],h=[];for(const a in C){const n=C[a];n.alias&&(m[a]=n.alias),n.type==="string"||n.type==="string[]"?(g.push(a),n.deprecates&&g.push(...n.deprecates)):n.type==="boolean"&&(h.push(a),n.deprecates&&h.push(...n.deprecates))}const l=I(d,{string:g,boolean:h,alias:m}),f={},i=l;f._=l._.map(a=>String(a)).filter(a=>a.length>0),delete i._;for(const a in C){const n=C[a];n.alias&&delete i[n.alias];let o=i[a];if(n.deprecates)for(const r of n.deprecates)i.hasOwnProperty(r)&&(o||(o=i[r],o&&y.onDeprecatedOption(r,n.deprecationMessage||(0,v.localize)(33,null,a))),delete i[r]);if(typeof o!="undefined"){if(n.type==="string[]"){if(Array.isArray(o)||(o=[o]),!n.allowEmptyValue){const r=o.filter(s=>s.length>0);r.length!==o.length&&(y.onEmptyValue(a),o=r.length>0?r:void 0)}}else n.type==="string"&&(Array.isArray(o)?(o=o.pop(),y.onMultipleValues(a,o)):!o&&!n.allowEmptyValue&&(y.onEmptyValue(a),o=void 0));f[a]=o,n.deprecationMessage&&y.onDeprecatedOption(a,n.deprecationMessage)}delete i[a]}for(const a in i)y.onUnknownOption(a);return f}e.parseArgs=w;function p(d,C){let y="";return C.args&&(Array.isArray(C.args)?y=` <${C.args.join("> <")}>`:y=` <${C.args}>`),C.alias?`-${C.alias} --${d}${y}`:`--${d}${y}`}function D(d,C){let y=0;const m=[];for(const f in d){const i=d[f],a=p(f,i);y=Math.max(y,a.length),m.push([a,i.description])}const g=y+2+1;if(C-g<25)return m.reduce((f,i)=>f.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);const h=C-g-1,l=[];for(const f of m){const i=f[0],a=R(f[1],h),n=T(g-i.length-2);l.push("  "+i+n+a[0]);for(let o=1;o<a.length;o++)l.push(T(g)+a[o])}return l}e.formatOptions=D;function T(d){return" ".repeat(d)}function R(d,C){const y=[];for(;d.length;){const m=d.length<C?d.length:d.lastIndexOf(" ",C),g=d.slice(0,m).trim();d=d.slice(m),y.push(g)}return y}function E(d,C,y,m,g){const h=process.stdout.isTTY&&process.stdout.columns||80,l=g?.noInputFiles!==!0?`[${(0,v.localize)(34,null)}...]`:"",f=[`${d} ${y}`];f.push(""),f.push(`${(0,v.localize)(35,null)}: ${C} [${(0,v.localize)(36,null)}]${l}`),f.push(""),g?.noPipe!==!0&&(t.isWindows?f.push((0,v.localize)(37,null,C)):f.push((0,v.localize)(38,null,C)),f.push(""));const i={};for(const a in m){const n=m[a];if(n.description&&n.cat){let o=i[n.cat];o||(i[n.cat]=o={}),o[a]=n}}for(const a in i){const n=a,o=i[n];o&&(f.push(P[n]),f.push(...D(o,h)),f.push(""))}return f.join(`
`)}e.buildHelpMessage=E;function b(d,C){return`${d||(0,v.localize)(39,null)}
${C||(0,v.localize)(40,null)}
${process.arch}`}e.buildVersionMessage=b}),define(ve[189],we([0,1,268,160,57]),function(oe,e,I,t,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const P=2048;function k(E,b){const d={onUnknownOption:y=>{console.warn((0,t.localize)(0,null,y))},onMultipleValues:(y,m)=>{console.warn((0,t.localize)(1,null,y,m))},onEmptyValue:y=>{console.warn((0,t.localize)(2,null,y))},onDeprecatedOption:(y,m)=>{console.warn((0,t.localize)(3,null,y,m))}},C=(0,v.parseArgs)(E,v.OPTIONS,b?d:void 0);return C.goto&&C._.forEach(y=>I(/^(\w:)?[^:]+(:\d*){0,2}$/.test(y),(0,t.localize)(4,null))),C["max-memory"]&&I(parseInt(C["max-memory"])>=P,`The max-memory argument cannot be specified lower than ${P} MB.`),C}function w(E){const b=E.findIndex(d=>!/^-/.test(d));if(b>-1)return[...E.slice(0,b),...E.slice(b+1)]}function p(E){let[,...b]=E;process.env.VSCODE_DEV&&(b=w(b)||[]);const d=!R(process.env);return k(b,d)}e.parseMainProcessArgv=p;function D(E){const[,,...b]=E;return k(b,!0)}e.parseCLIProcessArgv=D;function T(E,...b){const d=E.indexOf("--");return d===-1?E.push(...b):E.splice(d,0,...b),E}e.addArg=T;function R(E){return E.VSCODE_CLI==="1"}e.isLaunchedFromCli=R}),function(){"use strict";function oe(e,I,t,v){function P(w){const p=k(w),D=[p];return e.isAbsolute(p)||D.unshift(v),e.resolve(...D)}function k(w){const p=process.env.VSCODE_PORTABLE;if(p)return e.join(p,"user-data");let D=process.env.VSCODE_APPDATA;if(D)return e.join(D,t);const T=w["user-data-dir"];if(T)return T;switch(process.platform){case"win32":if(D=process.env.APPDATA,!D){const R=process.env.USERPROFILE;if(typeof R!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");D=e.join(R,"AppData","Roaming")}break;case"darwin":D=e.join(I.homedir(),"Library","Application Support");break;case"linux":D=process.env.XDG_CONFIG_HOME||e.join(I.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(D,t)}return{getUserDataPath:P}}if(typeof define=="function")define(ve[190],we([0,83,27,10,19,28]),function(e,I,t,v,P,k){const w=P.dirname(v.FileAccess.asFileUri("",e)),p=e.__$__nodeRequire(P.joinPath(w,"package.json").fsPath);return oe(I,t,p.name,k.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),I=require("path"),t=require("os");module.exports=oe(I,t,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ve[191],we([0,1,27,95,190]),function(oe,e,I,t,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class P extends t.AbstractNativeEnvironmentService{constructor(w,p){super(w,{homeDir:(0,I.homedir)(),tmpDir:(0,I.tmpdir)(),userDataDir:(0,v.getUserDataPath)(w)},p)}}e.NativeEnvironmentService=P}),define(ve[71],we([0,1,19,68,167,51]),function(oe,e,I,t,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const k=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,w=/^-(\d{4})(\d{2})(\d{2})$/;function p(m){return m=m.trim(),m==="*"||k.test(m)}e.isValidVersionStr=p;function D(m){if(!p(m))return null;if(m=m.trim(),m==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const g=m.match(k);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=D;function T(m){if(!m)return null;const g=m.majorBase,h=m.majorMustEqual,l=m.minorBase;let f=m.minorMustEqual;const i=m.patchBase;let a=m.patchMustEqual;m.hasCaret&&(g===0||(f=!1),a=!1);let n=0;if(m.preRelease){const o=w.exec(m.preRelease);if(o){const[,r,s,c]=o;n=Date.UTC(Number(r),Number(s)-1,Number(c))}}return{majorBase:g,majorMustEqual:h,minorBase:l,minorMustEqual:f,patchBase:i,patchMustEqual:a,isMinimum:m.hasGreaterEquals,notBefore:n}}e.normalizeVersion=T;function R(m,g,h){let l;typeof m=="string"?l=T(D(m)):l=m;let f;g instanceof Date?f=g.getTime():typeof g=="string"&&(f=new Date(g).getTime());let i;if(typeof h=="string"?i=T(D(h)):i=h,!l||!i)return!1;const a=l.majorBase,n=l.minorBase,o=l.patchBase;let r=i.majorBase,s=i.minorBase,c=i.patchBase;const u=i.notBefore;let S=i.majorMustEqual,A=i.minorMustEqual,M=i.patchMustEqual;return i.isMinimum?a>r?!0:a<r?!1:n>s?!0:n<s||f&&f<u?!1:o>=c:(a===1&&r===0&&(!S||!A||!M)&&(r=1,s=0,c=0,S=!0,A=!1,M=!1),a<r?!1:a>r?!S:n<s?!1:n>s?!A:o<c?!1:o>c?!M:!(f&&f<u))}e.isValidVersion=R;function E(m,g,h,l,f){const i=[];if(typeof l.publisher!="undefined"&&typeof l.publisher!="string")return i.push([t.default.Error,v.localize(0,null)]),i;if(typeof l.name!="string")return i.push([t.default.Error,v.localize(1,null,"name")]),i;if(typeof l.version!="string")return i.push([t.default.Error,v.localize(2,null,"version")]),i;if(!l.engines)return i.push([t.default.Error,v.localize(3,null,"engines")]),i;if(typeof l.engines.vscode!="string")return i.push([t.default.Error,v.localize(4,null,"engines.vscode")]),i;if(typeof l.extensionDependencies!="undefined"&&!y(l.extensionDependencies))return i.push([t.default.Error,v.localize(5,null,"extensionDependencies")]),i;if(typeof l.activationEvents!="undefined"){if(!y(l.activationEvents))return i.push([t.default.Error,v.localize(6,null,"activationEvents")]),i;if(typeof l.main=="undefined"&&typeof l.browser=="undefined")return i.push([t.default.Error,v.localize(7,null,"activationEvents","main")]),i}if(typeof l.extensionKind!="undefined"&&typeof l.main=="undefined"&&i.push([t.default.Warning,v.localize(8,null,"extensionKind")]),typeof l.main!="undefined"){if(typeof l.main!="string")return i.push([t.default.Error,v.localize(9,null,"main")]),i;{const o=(0,I.joinPath)(h,l.main);(0,I.isEqualOrParent)(o,h)||i.push([t.default.Warning,v.localize(10,null,o.path,h.path)])}if(typeof l.activationEvents=="undefined")return i.push([t.default.Error,v.localize(11,null,"activationEvents","main")]),i}if(typeof l.browser!="undefined"){if(typeof l.browser!="string")return i.push([t.default.Error,v.localize(12,null,"browser")]),i;{const o=(0,I.joinPath)(h,l.browser);(0,I.isEqualOrParent)(o,h)||i.push([t.default.Warning,v.localize(13,null,o.path,h.path)])}if(typeof l.activationEvents=="undefined")return i.push([t.default.Error,v.localize(14,null,"activationEvents","browser")]),i}if(!P.valid(l.version))return i.push([t.default.Error,v.localize(15,null)]),i;const a=[];if(!b(m,g,l,f,a))for(const o of a)i.push([t.default.Error,o]);return i}e.validateExtensionManifest=E;function b(m,g,h,l,f){return l||typeof h.main=="undefined"&&typeof h.browser=="undefined"?!0:C(m,g,h.engines.vscode,f)}e.isValidExtensionVersion=b;function d(m,g,h){return m==="*"||C(g,h,m)}e.isEngineValid=d;function C(m,g,h,l=[]){const f=T(D(h));if(!f)return l.push(v.localize(16,null,h)),!1;if(f.majorBase===0){if(!f.majorMustEqual||!f.minorMustEqual)return l.push(v.localize(17,null,h)),!1}else if(!f.majorMustEqual)return l.push(v.localize(18,null,h)),!1;return R(m,g,f)?!0:(l.push(v.localize(19,null,m,h)),!1)}function y(m){if(!Array.isArray(m))return!1;for(let g=0,h=m.length;g<h;g++)if(typeof m[g]!="string")return!1;return!0}}),define(ve[192],we([0,1,16,26]),function(oe,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function v(P,k,w){let p=w&&w.get("storage.serviceMachineId",-1)||null;if(p)return p;try{const T=(await k.readFile(P.serviceMachineIdResource)).value.toString();p=(0,t.isUUID)(T)?T:null}catch{p=null}if(!p){p=(0,t.generateUuid)();try{await k.writeFile(P.serviceMachineIdResource,I.VSBuffer.fromString(p))}catch{}}return w?.store("storage.serviceMachineId",p,-1,1),p}e.getServiceMachineId=v}),define(ve[58],we([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class I{constructor(v,P=[],k=!1){this.ctor=v,this.staticArguments=P,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=I}),define(ve[193],we([0,1,58]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const t=[];function v(k,w,p){w instanceof I.SyncDescriptor||(w=new I.SyncDescriptor(w,[],p)),t.push([k,w])}e.registerSingleton=v;function P(){return t}e.getSingletonServiceDescriptors=P}),define(ve[194],we([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class I{constructor(P){this.incoming=new Map,this.outgoing=new Map,this.data=P}}e.Node=I;class t{constructor(P){this._hashFn=P,this._nodes=new Map}roots(){const P=[];for(const k of this._nodes.values())k.outgoing.size===0&&P.push(k);return P}insertEdge(P,k){const w=this.lookupOrInsertNode(P),p=this.lookupOrInsertNode(k);w.outgoing.set(this._hashFn(k),p),p.incoming.set(this._hashFn(P),w)}removeNode(P){const k=this._hashFn(P);this._nodes.delete(k);for(const w of this._nodes.values())w.outgoing.delete(k),w.incoming.delete(k)}lookupOrInsertNode(P){const k=this._hashFn(P);let w=this._nodes.get(k);return w||(w=new I(P),this._nodes.set(k,w)),w}lookup(P){return this._nodes.get(this._hashFn(P))}isEmpty(){return this._nodes.size===0}toString(){const P=[];for(const[k,w]of this._nodes)P.push(`${k}, (incoming)[${[...w.incoming.keys()].join(", ")}], (outgoing)[${[...w.outgoing.keys()].join(",")}]`);return P.join(`
`)}findCycleSlow(){for(const[P,k]of this._nodes){const w=new Set([P]),p=this._findCycle(k,w);if(p)return p}}_findCycle(P,k){for(const[w,p]of P.outgoing){if(k.has(w))return[...k,w].join(" -> ");k.add(w);const D=this._findCycle(p,k);if(D)return D;k.delete(w)}}}e.Graph=t}),define(ve[6],we([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var I;(function(k){k.serviceIds=new Map,k.DI_TARGET="$di$target",k.DI_DEPENDENCIES="$di$dependencies";function w(p){return p[k.DI_DEPENDENCIES]||[]}k.getServiceDependencies=w})(I=e._util||(e._util={})),e.IInstantiationService=v("instantiationService");function t(k,w,p){w[I.DI_TARGET]===w?w[I.DI_DEPENDENCIES].push({id:k,index:p}):(w[I.DI_DEPENDENCIES]=[{id:k,index:p}],w[I.DI_TARGET]=w)}function v(k){if(I.serviceIds.has(k))return I.serviceIds.get(k);const w=function(p,D,T){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(w,p,T)};return w.toString=()=>k,I.serviceIds.set(k,w),w}e.createDecorator=v;function P(k){return k}e.refineServiceDecorator=P}),define(ve[23],we([0,1,12,4,6]),function(oe,e,I,t,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,v.createDecorator)("configurationService");function P(m){return m&&typeof m=="object"&&(!m.overrideIdentifier||typeof m.overrideIdentifier=="string")&&(!m.resource||m.resource instanceof t.URI)}e.isConfigurationOverrides=P;function k(m){return m&&typeof m=="object"&&(!m.overrideIdentifiers||I.isArray(m.overrideIdentifiers))&&!m.overrideIdentifier&&(!m.resource||m.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=k;var w;(function(m){m[m.USER=1]="USER",m[m.USER_LOCAL=2]="USER_LOCAL",m[m.USER_REMOTE=3]="USER_REMOTE",m[m.WORKSPACE=4]="WORKSPACE",m[m.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",m[m.DEFAULT=6]="DEFAULT",m[m.MEMORY=7]="MEMORY"})(w=e.ConfigurationTarget||(e.ConfigurationTarget={}));function p(m){switch(m){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=p;function D(m,g){const h=Object.create(null);for(const l in m)T(h,l,m[l],g);return h}e.toValuesTree=D;function T(m,g,h,l){const f=g.split("."),i=f.pop();let a=m;for(let n=0;n<f.length;n++){const o=f[n];let r=a[o];switch(typeof r){case"undefined":r=a[o]=Object.create(null);break;case"object":break;default:l(`Ignoring ${g} as ${f.slice(0,n+1).join(".")} is ${JSON.stringify(r)}`);return}a=r}if(typeof a=="object"&&a!==null)try{a[i]=h}catch{l(`Ignoring ${g} as ${f.join(".")} is ${JSON.stringify(a)}`)}else l(`Ignoring ${g} as ${f.join(".")} is ${JSON.stringify(a)}`)}e.addToValueTree=T;function R(m,g){const h=g.split(".");E(m,h)}e.removeFromValueTree=R;function E(m,g){const h=g.shift();if(g.length===0){delete m[h];return}if(Object.keys(m).indexOf(h)!==-1){const l=m[h];typeof l=="object"&&!Array.isArray(l)&&(E(l,g),Object.keys(l).length===0&&delete m[h])}}function b(m,g,h){function l(a,n){let o=a;for(const r of n){if(typeof o!="object"||o===null)return;o=o[r]}return o}const f=g.split("."),i=l(m,f);return typeof i=="undefined"?h:i}e.getConfigurationValue=b;function d(m,g,h){Object.keys(g).forEach(l=>{l!=="__proto__"&&(l in m?I.isObject(m[l])&&I.isObject(g[l])?d(m[l],g[l],h):h&&(m[l]=g[l]):m[l]=g[l])})}e.merge=d;function C(m,g,h){const l=m.inspect(g),f=m.inspect(h);return typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:l.defaultValue}e.getMigratedSettingValue=C;function y(m){return m.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=y}),define(ve[96],we([0,1,3,15,6]),function(oe,e,I,t,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const P=new Map;P.set("false",!1),P.set("true",!0),P.set("isMac",I.isMacintosh),P.set("isLinux",I.isLinux),P.set("isWindows",I.isWindows),P.set("isWeb",I.isWeb),P.set("isMacNative",I.isMacintosh&&!I.isWeb),P.set("isEdge",I.isEdge),P.set("isFirefox",I.isFirefox),P.set("isChrome",I.isChrome),P.set("isSafari",I.isSafari);const k=Object.prototype.hasOwnProperty;var w;(function(Q){Q[Q.False=0]="False",Q[Q.True=1]="True",Q[Q.Defined=2]="Defined",Q[Q.Not=3]="Not",Q[Q.Equals=4]="Equals",Q[Q.NotEquals=5]="NotEquals",Q[Q.And=6]="And",Q[Q.Regex=7]="Regex",Q[Q.NotRegex=8]="NotRegex",Q[Q.Or=9]="Or",Q[Q.In=10]="In",Q[Q.NotIn=11]="NotIn",Q[Q.Greater=12]="Greater",Q[Q.GreaterEquals=13]="GreaterEquals",Q[Q.Smaller=14]="Smaller",Q[Q.SmallerEquals=15]="SmallerEquals"})(w=e.ContextKeyExprType||(e.ContextKeyExprType={}));class p{static false(){return R.INSTANCE}static true(){return E.INSTANCE}static has(_){return b.create(_)}static equals(_,q){return d.create(_,q)}static notEquals(_,q){return m.create(_,q)}static regex(_,q){return n.create(_,q)}static in(_,q){return C.create(_,q)}static not(_){return g.create(_)}static and(..._){return s.create(_,null)}static or(..._){return c.create(_,null,!0)}static greater(_,q){return l.create(_,q)}static greaterEquals(_,q){return f.create(_,q)}static smaller(_,q){return i.create(_,q)}static smallerEquals(_,q){return a.create(_,q)}static deserialize(_,q=!1){if(!!_)return this._deserializeOrExpression(_,q)}static _deserializeOrExpression(_,q){const U=_.split("||");return c.create(U.map(ne=>this._deserializeAndExpression(ne,q)),null,!0)}static _deserializeAndExpression(_,q){const U=_.split("&&");return s.create(U.map(ne=>this._deserializeOne(ne,q)),null)}static _deserializeOne(_,q){if(_=_.trim(),_.indexOf("!=")>=0){const U=_.split("!=");return m.create(U[0].trim(),this._deserializeValue(U[1],q))}if(_.indexOf("==")>=0){const U=_.split("==");return d.create(U[0].trim(),this._deserializeValue(U[1],q))}if(_.indexOf("=~")>=0){const U=_.split("=~");return n.create(U[0].trim(),this._deserializeRegexValue(U[1],q))}if(_.indexOf(" in ")>=0){const U=_.split(" in ");return C.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(_)){const U=_.split(">=");return f.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(_)){const U=_.split(">");return l.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(_)){const U=_.split("<=");return a.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(_)){const U=_.split("<");return i.create(U[0].trim(),U[1].trim())}return/^\!\s*/.test(_)?g.create(_.substr(1).trim()):b.create(_)}static _deserializeValue(_,q){if(_=_.trim(),_==="true")return!0;if(_==="false")return!1;const U=/^'([^']*)'$/.exec(_);return U?U[1].trim():_}static _deserializeRegexValue(_,q){if((0,t.isFalsyOrWhitespace)(_)){if(q)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const U=_.indexOf("/"),ne=_.lastIndexOf("/");if(U===ne||U<0){if(q)throw new Error(`bad regexp-value '${_}', missing /-enclosure`);return console.warn(`bad regexp-value '${_}', missing /-enclosure`),null}const Z=_.slice(U+1,ne),F=_[ne+1]==="i"?"i":"";try{return new RegExp(Z,F)}catch(x){if(q)throw new Error(`bad regexp-value '${_}', parse error: ${x}`);return console.warn(`bad regexp-value '${_}', parse error: ${x}`),null}}}e.ContextKeyExpr=p;function D(Q,_){const q=Q?Q.substituteConstants():void 0,U=_?_.substituteConstants():void 0;return!q&&!U?!0:!q||!U?!1:q.equals(U)}e.expressionsAreEqualWithConstantSubstitution=D;function T(Q,_){return Q.cmp(_)}class R{constructor(){this.type=0}cmp(_){return this.type-_.type}equals(_){return _.type===this.type}substituteConstants(){return this}evaluate(_){return!1}serialize(){return"false"}keys(){return[]}map(_){return this}negate(){return E.INSTANCE}}e.ContextKeyFalseExpr=R,R.INSTANCE=new R;class E{constructor(){this.type=1}cmp(_){return this.type-_.type}equals(_){return _.type===this.type}substituteConstants(){return this}evaluate(_){return!0}serialize(){return"true"}keys(){return[]}map(_){return this}negate(){return R.INSTANCE}}e.ContextKeyTrueExpr=E,E.INSTANCE=new E;class b{constructor(_,q){this.key=_,this.negated=q,this.type=2}static create(_,q=null){const U=P.get(_);return typeof U=="boolean"?U?E.INSTANCE:R.INSTANCE:new b(_,q)}cmp(_){return _.type!==this.type?this.type-_.type:S(this.key,_.key)}equals(_){return _.type===this.type?this.key===_.key:!1}substituteConstants(){const _=P.get(this.key);return typeof _=="boolean"?_?E.INSTANCE:R.INSTANCE:this}evaluate(_){return!!_.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(_){return _.mapDefined(this.key)}negate(){return this.negated||(this.negated=g.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=b;class d{constructor(_,q,U){this.key=_,this.value=q,this.negated=U,this.type=4}static create(_,q,U=null){if(typeof q=="boolean")return q?b.create(_,U):g.create(_,U);const ne=P.get(_);return typeof ne=="boolean"?q===(ne?"true":"false")?E.INSTANCE:R.INSTANCE:new d(_,q,U)}cmp(_){return _.type!==this.type?this.type-_.type:A(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){const _=P.get(this.key);if(typeof _=="boolean"){const q=_?"true":"false";return this.value===q?E.INSTANCE:R.INSTANCE}return this}evaluate(_){return _.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(_){return _.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=m.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=d;class C{constructor(_,q){this.key=_,this.valueKey=q,this.type=10,this.negated=null}static create(_,q){return new C(_,q)}cmp(_){return _.type!==this.type?this.type-_.type:A(this.key,this.valueKey,_.key,_.valueKey)}equals(_){return _.type===this.type?this.key===_.key&&this.valueKey===_.valueKey:!1}substituteConstants(){return this}evaluate(_){const q=_.getValue(this.valueKey),U=_.getValue(this.key);return Array.isArray(q)?q.includes(U):typeof U=="string"&&typeof q=="object"&&q!==null?k.call(q,U):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(_){return _.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=y.create(this)),this.negated}}e.ContextKeyInExpr=C;class y{constructor(_){this._actual=_,this.type=11}static create(_){return new y(_)}cmp(_){return _.type!==this.type?this.type-_.type:this._actual.cmp(_._actual)}equals(_){return _.type===this.type?this._actual.equals(_._actual):!1}substituteConstants(){return this}evaluate(_){return!this._actual.evaluate(_)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(_){return new y(this._actual.map(_))}negate(){return this._actual}}e.ContextKeyNotInExpr=y;class m{constructor(_,q,U){this.key=_,this.value=q,this.negated=U,this.type=5}static create(_,q,U=null){if(typeof q=="boolean")return q?g.create(_,U):b.create(_,U);const ne=P.get(_);return typeof ne=="boolean"?q===(ne?"true":"false")?R.INSTANCE:E.INSTANCE:new m(_,q,U)}cmp(_){return _.type!==this.type?this.type-_.type:A(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){const _=P.get(this.key);if(typeof _=="boolean"){const q=_?"true":"false";return this.value===q?R.INSTANCE:E.INSTANCE}return this}evaluate(_){return _.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(_){return _.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=d.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=m;class g{constructor(_,q){this.key=_,this.negated=q,this.type=3}static create(_,q=null){const U=P.get(_);return typeof U=="boolean"?U?R.INSTANCE:E.INSTANCE:new g(_,q)}cmp(_){return _.type!==this.type?this.type-_.type:S(this.key,_.key)}equals(_){return _.type===this.type?this.key===_.key:!1}substituteConstants(){const _=P.get(this.key);return typeof _=="boolean"?_?R.INSTANCE:E.INSTANCE:this}evaluate(_){return!_.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(_){return _.mapNot(this.key)}negate(){return this.negated||(this.negated=b.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=g;function h(Q,_){if(typeof Q=="string"){const q=parseFloat(Q);isNaN(q)||(Q=q)}return typeof Q=="string"||typeof Q=="number"?_(Q):R.INSTANCE}class l{constructor(_,q,U){this.key=_,this.value=q,this.negated=U,this.type=12}static create(_,q,U=null){return h(q,ne=>new l(_,ne,U))}cmp(_){return _.type!==this.type?this.type-_.type:A(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){return this}evaluate(_){return typeof this.value=="string"?!1:parseFloat(_.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(_){return _.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=l;class f{constructor(_,q,U){this.key=_,this.value=q,this.negated=U,this.type=13}static create(_,q,U=null){return h(q,ne=>new f(_,ne,U))}cmp(_){return _.type!==this.type?this.type-_.type:A(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){return this}evaluate(_){return typeof this.value=="string"?!1:parseFloat(_.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(_){return _.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=i.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=f;class i{constructor(_,q,U){this.key=_,this.value=q,this.negated=U,this.type=14}static create(_,q,U=null){return h(q,ne=>new i(_,ne,U))}cmp(_){return _.type!==this.type?this.type-_.type:A(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){return this}evaluate(_){return typeof this.value=="string"?!1:parseFloat(_.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(_){return _.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=f.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=i;class a{constructor(_,q,U){this.key=_,this.value=q,this.negated=U,this.type=15}static create(_,q,U=null){return h(q,ne=>new a(_,ne,U))}cmp(_){return _.type!==this.type?this.type-_.type:A(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){return this}evaluate(_){return typeof this.value=="string"?!1:parseFloat(_.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(_){return _.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=a;class n{constructor(_,q){this.key=_,this.regexp=q,this.type=7,this.negated=null}static create(_,q){return new n(_,q)}cmp(_){if(_.type!==this.type)return this.type-_.type;if(this.key<_.key)return-1;if(this.key>_.key)return 1;const q=this.regexp?this.regexp.source:"",U=_.regexp?_.regexp.source:"";return q<U?-1:q>U?1:0}equals(_){if(_.type===this.type){const q=this.regexp?this.regexp.source:"",U=_.regexp?_.regexp.source:"";return this.key===_.key&&q===U}return!1}substituteConstants(){return this}evaluate(_){const q=_.getValue(this.key);return this.regexp?this.regexp.test(q):!1}serialize(){const _=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${_}`}keys(){return[this.key]}map(_){return _.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=o.create(this)),this.negated}}e.ContextKeyRegexExpr=n;class o{constructor(_){this._actual=_,this.type=8}static create(_){return new o(_)}cmp(_){return _.type!==this.type?this.type-_.type:this._actual.cmp(_._actual)}equals(_){return _.type===this.type?this._actual.equals(_._actual):!1}substituteConstants(){return this}evaluate(_){return!this._actual.evaluate(_)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(_){return new o(this._actual.map(_))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=o;function r(Q){let _=null;for(let q=0,U=Q.length;q<U;q++){const ne=Q[q].substituteConstants();if(Q[q]!==ne&&_===null){_=[];for(let Z=0;Z<q;Z++)_[Z]=Q[Z]}_!==null&&(_[q]=ne)}return _===null?Q:_}class s{constructor(_,q){this.expr=_,this.negated=q,this.type=6}static create(_,q){return s._normalizeArr(_,q)}cmp(_){if(_.type!==this.type)return this.type-_.type;if(this.expr.length<_.expr.length)return-1;if(this.expr.length>_.expr.length)return 1;for(let q=0,U=this.expr.length;q<U;q++){const ne=T(this.expr[q],_.expr[q]);if(ne!==0)return ne}return 0}equals(_){if(_.type===this.type){if(this.expr.length!==_.expr.length)return!1;for(let q=0,U=this.expr.length;q<U;q++)if(!this.expr[q].equals(_.expr[q]))return!1;return!0}return!1}substituteConstants(){const _=r(this.expr);return _===this.expr?this:s.create(_,this.negated)}evaluate(_){for(let q=0,U=this.expr.length;q<U;q++)if(!this.expr[q].evaluate(_))return!1;return!0}static _normalizeArr(_,q){const U=[];let ne=!1;for(const Z of _)if(!!Z){if(Z.type===1){ne=!0;continue}if(Z.type===0)return R.INSTANCE;if(Z.type===6){U.push(...Z.expr);continue}U.push(Z)}if(U.length===0&&ne)return E.INSTANCE;if(U.length!==0){if(U.length===1)return U[0];U.sort(T);for(let Z=1;Z<U.length;Z++)U[Z-1].equals(U[Z])&&(U.splice(Z,1),Z--);if(U.length===1)return U[0];for(;U.length>1;){const Z=U[U.length-1];if(Z.type!==9)break;U.pop();const F=U.pop(),x=U.length===0,z=c.create(Z.expr.map(W=>s.create([W,F],null)),null,x);z&&(U.push(z),U.sort(T))}return U.length===1?U[0]:new s(U,q)}}serialize(){return this.expr.map(_=>_.serialize()).join(" && ")}keys(){const _=[];for(const q of this.expr)_.push(...q.keys());return _}map(_){return new s(this.expr.map(q=>q.map(_)),null)}negate(){if(!this.negated){const _=[];for(const q of this.expr)_.push(q.negate());this.negated=c.create(_,this,!0)}return this.negated}}class c{constructor(_,q){this.expr=_,this.negated=q,this.type=9}static create(_,q,U){return c._normalizeArr(_,q,U)}cmp(_){if(_.type!==this.type)return this.type-_.type;if(this.expr.length<_.expr.length)return-1;if(this.expr.length>_.expr.length)return 1;for(let q=0,U=this.expr.length;q<U;q++){const ne=T(this.expr[q],_.expr[q]);if(ne!==0)return ne}return 0}equals(_){if(_.type===this.type){if(this.expr.length!==_.expr.length)return!1;for(let q=0,U=this.expr.length;q<U;q++)if(!this.expr[q].equals(_.expr[q]))return!1;return!0}return!1}substituteConstants(){const _=r(this.expr);return _===this.expr?this:c.create(_,this.negated,!1)}evaluate(_){for(let q=0,U=this.expr.length;q<U;q++)if(this.expr[q].evaluate(_))return!0;return!1}static _normalizeArr(_,q,U){let ne=[],Z=!1;if(_){for(let F=0,x=_.length;F<x;F++){const z=_[F];if(!!z){if(z.type===0){Z=!0;continue}if(z.type===1)return E.INSTANCE;if(z.type===9){ne=ne.concat(z.expr);continue}ne.push(z)}}if(ne.length===0&&Z)return R.INSTANCE;ne.sort(T)}if(ne.length!==0){if(ne.length===1)return ne[0];for(let F=1;F<ne.length;F++)ne[F-1].equals(ne[F])&&(ne.splice(F,1),F--);if(ne.length===1)return ne[0];if(U){for(let F=0;F<ne.length;F++)for(let x=F+1;x<ne.length;x++)M(ne[F],ne[x])&&(ne.splice(x,1),x--);if(ne.length===1)return ne[0]}return new c(ne,q)}}serialize(){return this.expr.map(_=>_.serialize()).join(" || ")}keys(){const _=[];for(const q of this.expr)_.push(...q.keys());return _}map(_){return new c(this.expr.map(q=>q.map(_)),null)}negate(){if(!this.negated){const _=[];for(const q of this.expr)_.push(q.negate());for(;_.length>1;){const q=_.shift(),U=_.shift(),ne=[];for(const F of $(q))for(const x of $(U))ne.push(s.create([F,x],null));const Z=_.length===0;_.unshift(c.create(ne,null,Z))}this.negated=_[0]}return this.negated}}class u extends b{constructor(_,q,U){super(_,null);this._defaultValue=q,typeof U=="object"?u._info.push({...U,key:_}):U!==!0&&u._info.push({key:_,description:U,type:q!=null?typeof q:void 0})}static all(){return u._info.values()}bindTo(_){return _.createKey(this.key,this._defaultValue)}getValue(_){return _.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(_){return d.create(this.key,_)}notEqualsTo(_){return m.create(this.key,_)}}e.RawContextKey=u,u._info=[],e.IContextKeyService=(0,v.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function S(Q,_){return Q<_?-1:Q>_?1:0}function A(Q,_,q,U){return Q<q?-1:Q>q?1:_<U?-1:_>U?1:0}function M(Q,_){if(_.type===6&&Q.type!==9&&Q.type!==6){for(const ne of _.expr)if(Q.equals(ne))return!0}const q=Q.negate(),U=$(q).concat($(_));U.sort(T);for(let ne=0;ne<U.length;ne++){const F=U[ne].negate();for(let x=ne+1;x<U.length;x++){const z=U[x];if(F.equals(z))return!0}}return!1}e.implies=M;function $(Q){return Q.type===9?Q.expr:[Q]}}),define(ve[72],we([0,1,6]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,I.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,I.createDecorator)("credentialsMainService");class t{constructor(){this.secretVault={}}async getPassword(P,k){return this.secretVault[P]?.[k]??null}async setPassword(P,k,w){this.secretVault[P]=this.secretVault[P]??{},this.secretVault[P][k]=w}async deletePassword(P,k){return this.secretVault[P]?.[k]?(delete this.secretVault[P][k],Object.keys(this.secretVault[P]).length===0&&delete this.secretVault[P],!0):!1}async findPassword(P){return JSON.stringify(this.secretVault[P])??null}async findCredentials(P){const k=[];for(const w of Object.keys(this.secretVault[P]||{}))k.push({account:w,password:this.secretVault[P][w]});return k}async clear(){this.secretVault={}}}e.InMemoryCredentialsProvider=t}),define(ve[195],we([0,1,6]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,I.createDecorator)(e.ID);function t(P){return!!P.hostName&&!!P.errorMessage}e.isRemoteDiagnosticError=t;class v{async getPerformanceInfo(k,w){return{}}async getSystemInfo(k,w){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(k,w){return""}async getWorkspaceFileExtensions(k){return{extensions:[]}}async reportWorkspaceStats(k){}}e.NullDiagnosticsService=v}),define(ve[73],we([0,1,6]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,I.createDecorator)("downloadService")}),define(ve[196],we([0,1,6]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,I.createDecorator)("encryptionMainService")}),define(ve[24],we([0,1,6]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,I.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,I.refineServiceDecorator)(e.IEnvironmentService)}),define(ve[31],we([0,1,162,6]),function(oe,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IServerExtensionManagementService=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function v(m){switch(m){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=v;function P(m){switch(m){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=P;function k(m,g){switch(m){case 3:return g==="x64"?"win32-x64":g==="ia32"?"win32-ia32":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=k;function w(m,g){return g==="web"&&!m.includes("web")}e.isNotWebExtensionInWebTargetPlatform=w;function p(m,g,h){return w(g,h)?!1:m==="undefined"||m==="universal"?!0:m==="unknown"?!1:m===h?!0:D(h).includes(m)}e.isTargetPlatformCompatible=p;function D(m){switch(m){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=D;function T(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}e.isIExtensionIdentifier=T;var R;(function(m){m[m.NoneOrRelevance=0]="NoneOrRelevance",m[m.LastUpdatedDate=1]="LastUpdatedDate",m[m.Title=2]="Title",m[m.PublisherName=3]="PublisherName",m[m.InstallCount=4]="InstallCount",m[m.PublishedDate=10]="PublishedDate",m[m.AverageRating=6]="AverageRating",m[m.WeightedRating=12]="WeightedRating"})(R=e.SortBy||(e.SortBy={}));var E;(function(m){m[m.Default=0]="Default",m[m.Ascending=1]="Ascending",m[m.Descending=2]="Descending"})(E=e.SortOrder||(e.SortOrder={}));var b;(function(m){m.Install="install",m.Uninstall="uninstall"})(b=e.StatisticType||(e.StatisticType={}));var d;(function(m){m[m.None=1]="None",m[m.Install=2]="Install",m[m.Update=3]="Update",m[m.Migrate=4]="Migrate"})(d=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var C;(function(m){m.Unsupported="Unsupported",m.Deprecated="Deprecated",m.Malicious="Malicious",m.Incompatible="Incompatible",m.IncompatiblePreRelease="IncompatiblePreRelease",m.IncompatibleTargetPlatform="IncompatibleTargetPlatform",m.ReleaseVersionNotFound="ReleaseVersionNotFound",m.Invalid="Invalid",m.Download="Download",m.Extract="Extract",m.Delete="Delete",m.Rename="Rename",m.CorruptZip="CorruptZip",m.IncompleteZip="IncompleteZip",m.Internal="Internal"})(C=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class y extends Error{constructor(g,h){super(g);this.code=h,this.name=h}}e.ExtensionManagementError=y,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.IServerExtensionManagementService=(0,t.refineServiceDecorator)(e.IExtensionManagementService),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,I.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,I.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,t.createDecorator)("IExtensionManagementCLIService")}),define(ve[197],we([0,1,7,2,41,22,4,70,31]),function(oe,e,I,t,v,P,k,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function D(y,m){return k.URI.revive(m?m.transformIncoming(y):y)}function T(y,m){return m?m.transformOutgoingURI(y):y}function R(y,m){m=m||w.DefaultURITransformer;const g=y.manifest;return{...(0,w.transformAndReviveIncomingURIs)({...y,manifest:void 0},m),manifest:g}}function E(y,m){return m?(0,P.cloneAndChange)(y,g=>g instanceof k.URI?m.transformOutgoingURI(g):void 0):y}class b{constructor(m,g){this.service=m,this.getUriTransformer=g,this.onInstallExtension=I.Event.buffer(m.onInstallExtension,!0),this.onDidInstallExtensions=I.Event.buffer(m.onDidInstallExtensions,!0),this.onUninstallExtension=I.Event.buffer(m.onUninstallExtension,!0),this.onDidUninstallExtension=I.Event.buffer(m.onDidUninstallExtension,!0)}listen(m,g){const h=this.getUriTransformer(m);switch(g){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return I.Event.map(this.onDidInstallExtensions,l=>l.map(f=>({...f,local:f.local?E(f.local,h):f.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(m,g,h){const l=this.getUriTransformer(m);switch(g){case"zip":return this.service.zip(R(h[0],l)).then(f=>T(f,l));case"unzip":return this.service.unzip(D(h[0],l));case"install":return this.service.install(D(h[0],l),(0,v.revive)(h[1]));case"getManifest":return this.service.getManifest(D(h[0],l));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(h[0]);case"installFromGallery":return this.service.installFromGallery(h[0],(0,v.revive)(h[1]));case"uninstall":return this.service.uninstall(R(h[0],l),(0,v.revive)(h[1]));case"reinstallFromGallery":return this.service.reinstallFromGallery(R(h[0],l));case"getInstalled":return this.service.getInstalled(h[0],k.URI.revive(h[1])).then(f=>f.map(i=>E(i,l)));case"getMetadata":return this.service.getMetadata(R(h[0],l));case"updateMetadata":return this.service.updateMetadata(R(h[0],l),h[1]).then(f=>E(f,l));case"updateExtensionScope":return this.service.updateExtensionScope(R(h[0],l),h[1]).then(f=>E(f,l));case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=b;class d extends t.Disposable{constructor(m){super();this.channel=m,this._onInstallExtension=this._register(new I.Emitter),this._onDidInstallExtensions=this._register(new I.Emitter),this._onUninstallExtension=this._register(new I.Emitter),this._onDidUninstallExtension=this._register(new I.Emitter),this._register(this.channel.listen("onInstallExtension")(g=>this._onInstallExtension.fire({identifier:g.identifier,source:this.isUriComponents(g.source)?k.URI.revive(g.source):g.source,profileLocation:k.URI.revive(g.profileLocation)}))),this._register(this.channel.listen("onDidInstallExtensions")(g=>this._onDidInstallExtensions.fire(g.map(h=>({...h,local:h.local?R(h.local,null):h.local,source:this.isUriComponents(h.source)?k.URI.revive(h.source):h.source,profileLocation:k.URI.revive(h.profileLocation)}))))),this._register(this.channel.listen("onUninstallExtension")(g=>this._onUninstallExtension.fire({identifier:g.identifier,profileLocation:k.URI.revive(g.profileLocation)}))),this._register(this.channel.listen("onDidUninstallExtension")(g=>this._onDidUninstallExtension.fire({...g,profileLocation:k.URI.revive(g.profileLocation)})))}get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}isUriComponents(m){return m?typeof m.path=="string"&&typeof m.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(m){const g=await this.getTargetPlatform();return m.allTargetPlatforms.some(h=>(0,p.isTargetPlatformCompatible)(h,m.allTargetPlatforms,g))}zip(m){return Promise.resolve(this.channel.call("zip",[m]).then(g=>k.URI.revive(g)))}unzip(m){return Promise.resolve(this.channel.call("unzip",[m]))}install(m,g){return Promise.resolve(this.channel.call("install",[m,g])).then(h=>R(h,null))}getManifest(m){return Promise.resolve(this.channel.call("getManifest",[m]))}installFromGallery(m,g){return Promise.resolve(this.channel.call("installFromGallery",[m,g])).then(h=>R(h,null))}uninstall(m,g){return Promise.resolve(this.channel.call("uninstall",[m,g]))}reinstallFromGallery(m){return Promise.resolve(this.channel.call("reinstallFromGallery",[m]))}getInstalled(m=null,g){return Promise.resolve(this.channel.call("getInstalled",[m,g])).then(h=>h.map(l=>R(l,null)))}getMetadata(m){return Promise.resolve(this.channel.call("getMetadata",[m]))}updateMetadata(m,g){return Promise.resolve(this.channel.call("updateMetadata",[m,g])).then(h=>R(h,null))}updateExtensionScope(m,g){return Promise.resolve(this.channel.call("updateExtensionScope",[m,g])).then(h=>R(h,null))}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=d;class C{constructor(m){this.service=m}listen(m,g){throw new Error("Invalid listen")}call(m,g,h){switch(g){case"getConfigBasedTips":return this.service.getConfigBasedTips(k.URI.revive(h[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=C}),define(ve[17],we([0,1,29,5,15,12,4,169,6]),function(oe,e,I,t,v,P,k,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,p.createDecorator)("fileService");function D(F){return F.create===!0}e.isFileOpenForWriteOptions=D;var T;(function(F){F[F.Unknown=0]="Unknown",F[F.File=1]="File",F[F.Directory=2]="Directory",F[F.SymbolicLink=64]="SymbolicLink"})(T=e.FileType||(e.FileType={}));var R;(function(F){F[F.Readonly=1]="Readonly"})(R=e.FilePermission||(e.FilePermission={}));var E;(function(F){F[F.FileReadWrite=2]="FileReadWrite",F[F.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",F[F.FileReadStream=16]="FileReadStream",F[F.FileFolderCopy=8]="FileFolderCopy",F[F.PathCaseSensitive=1024]="PathCaseSensitive",F[F.Readonly=2048]="Readonly",F[F.Trash=4096]="Trash",F[F.FileWriteUnlock=8192]="FileWriteUnlock",F[F.FileAtomicRead=16384]="FileAtomicRead",F[F.FileClone=32768]="FileClone"})(E=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function b(F){return!!(F.capabilities&2)}e.hasReadWriteCapability=b;function d(F){return!!(F.capabilities&8)}e.hasFileFolderCopyCapability=d;function C(F){return!!(F.capabilities&32768)}e.hasFileCloneCapability=C;function y(F){return!!(F.capabilities&4)}e.hasOpenReadWriteCloseCapability=y;function m(F){return!!(F.capabilities&16)}e.hasFileReadStreamCapability=m;function g(F){return b(F)?!!(F.capabilities&16384):!1}e.hasFileAtomicReadCapability=g;var h;(function(F){F.FileExists="EntryExists",F.FileNotFound="EntryNotFound",F.FileNotADirectory="EntryNotADirectory",F.FileIsADirectory="EntryIsADirectory",F.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",F.FileTooLarge="EntryTooLarge",F.FileWriteLocked="EntryWriteLocked",F.NoPermissions="NoPermissions",F.Unavailable="Unavailable",F.Unknown="Unknown"})(h=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class l extends Error{constructor(x,z){super(x);this.code=z}}e.FileSystemProviderError=l;function f(F,x){const z=new l(F.toString(),x);return a(z,x),z}e.createFileSystemProviderError=f;function i(F){return F||f((0,w.localize)(0,null),h.Unknown)}e.ensureFileSystemProviderError=i;function a(F,x){return F.name=x?`${x} (FileSystemError)`:"FileSystemError",F}e.markAsFileSystemProviderError=a;function n(F){if(!F)return h.Unknown;if(F instanceof l)return F.code;const x=/^(.+) \(FileSystemError\)$/.exec(F.name);if(!x)return h.Unknown;switch(x[1]){case h.FileExists:return h.FileExists;case h.FileIsADirectory:return h.FileIsADirectory;case h.FileNotADirectory:return h.FileNotADirectory;case h.FileNotFound:return h.FileNotFound;case h.FileExceedsMemoryLimit:return h.FileExceedsMemoryLimit;case h.FileTooLarge:return h.FileTooLarge;case h.FileWriteLocked:return h.FileWriteLocked;case h.NoPermissions:return h.NoPermissions;case h.Unavailable:return h.Unavailable}return h.Unknown}e.toFileSystemProviderErrorCode=n;function o(F){if(F instanceof A)return F.fileOperationResult;switch(n(F)){case h.FileNotFound:return 1;case h.FileIsADirectory:return 0;case h.FileNotADirectory:return 10;case h.FileWriteLocked:return 5;case h.NoPermissions:return 6;case h.FileExists:return 4;case h.FileExceedsMemoryLimit:return 9;case h.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=o;var r;(function(F){F[F.CREATE=0]="CREATE",F[F.DELETE=1]="DELETE",F[F.MOVE=2]="MOVE",F[F.COPY=3]="COPY",F[F.WRITE=4]="WRITE"})(r=e.FileOperation||(e.FileOperation={}));class s{constructor(x,z,W){this.resource=x,this.operation=z,this.target=W}isOperation(x){return this.operation===x}}e.FileOperationEvent=s;var c;(function(F){F[F.UPDATED=0]="UPDATED",F[F.ADDED=1]="ADDED",F[F.DELETED=2]="DELETED"})(c=e.FileChangeType||(e.FileChangeType={}));class u{constructor(x,z){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=x;const W=new Map;for(const re of x){const V=W.get(re.type);switch(V?V.push([re.resource,re]):W.set(re.type,[[re.resource,re]]),re.type){case 1:this.rawAdded.push(re.resource);break;case 0:this.rawUpdated.push(re.resource);break;case 2:this.rawDeleted.push(re.resource);break}}for(const[re,V]of W)switch(re){case 1:this.added=I.TernarySearchTree.forUris(()=>z),this.added.fill(V);break;case 0:this.updated=I.TernarySearchTree.forUris(()=>z),this.updated.fill(V);break;case 2:this.deleted=I.TernarySearchTree.forUris(()=>z),this.deleted.fill(V);break}}contains(x,...z){return this.doContains(x,{includeChildren:!1},...z)}affects(x,...z){return this.doContains(x,{includeChildren:!0},...z)}doContains(x,z,...W){if(!x)return!1;const re=W.length>0;return!!((!re||W.includes(1))&&(this.added?.get(x)||z.includeChildren&&this.added?.findSuperstr(x))||(!re||W.includes(0))&&(this.updated?.get(x)||z.includeChildren&&this.updated?.findSuperstr(x))||(!re||W.includes(2))&&(this.deleted?.findSubstr(x)||z.includeChildren&&this.deleted?.findSuperstr(x)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=u;function S(F,x,z){return!F||!x||F===x||x.length>F.length?!1:(x.charAt(x.length-1)!==t.sep&&(x+=t.sep),z?(0,v.startsWithIgnoreCase)(F,x):F.indexOf(x)===0)}e.isParent=S;class A extends Error{constructor(x,z,W){super(x);this.fileOperationResult=z,this.options=W}}e.FileOperationError=A;class M extends A{constructor(x,z,W){super(x,2,W);this.stat=z}}e.NotModifiedSinceFileOperationError=M;var $;(function(F){F[F.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",F[F.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",F[F.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",F[F.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",F[F.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",F[F.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",F[F.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",F[F.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",F[F.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",F[F.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",F[F.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",F[F.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})($=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var Q;(function(F){F[F.FILE=0]="FILE",F[F.FOLDER=1]="FOLDER",F[F.ROOT_FOLDER=2]="ROOT_FOLDER"})(Q=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function _(F){if(!(typeof F.size!="number"||typeof F.mtime!="number"))return F.mtime.toString(29)+F.size.toString(31)}e.etag=_;async function q(F,x){if(!x.hasProvider(k.URI.from({scheme:F.scheme})))return new Promise(z=>{const W=x.onDidChangeFileSystemProviderRegistrations(re=>{re.scheme===F.scheme&&re.added&&(W.dispose(),z())})})}e.whenProviderRegistered=q,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class U{static formatSize(x){return(0,P.isNumber)(x)||(x=0),x<U.KB?(0,w.localize)(1,null,x.toFixed(0)):x<U.MB?(0,w.localize)(2,null,(x/U.KB).toFixed(2)):x<U.GB?(0,w.localize)(3,null,(x/U.MB).toFixed(2)):x<U.TB?(0,w.localize)(4,null,(x/U.GB).toFixed(2)):(0,w.localize)(5,null,(x/U.TB).toFixed(2))}}e.ByteSize=U,U.KB=1024,U.MB=U.KB*U.KB,U.GB=U.MB*U.KB,U.TB=U.GB*U.KB;var ne;(function(F){F[F.IA32=0]="IA32",F[F.OTHER=1]="OTHER"})(ne=e.Arch||(e.Arch={}));function Z(F){return{maxFileSize:F===0?300*U.MB:16*U.GB,maxHeapSize:F===0?700*U.MB:2*700*U.MB}}e.getPlatformLimits=Z}),define(ve[198],we([0,1,16,37,11,7,2,48,4,26,17]),function(oe,e,I,t,v,P,k,w,p,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class R extends k.Disposable{constructor(b,d){super();this.channel=b,this.extraCapabilities=d,this.onDidChangeCapabilities=P.Event.None,this._onDidChange=this._register(new P.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new P.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,D.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(b){return this.channel.call("stat",[b])}readdir(b){return this.channel.call("readdir",[b])}async readFile(b,d){const{buffer:C}=await this.channel.call("readFile",[b,d]);return C}readFileStream(b,d,C){const y=(0,w.newWriteableStream)(g=>I.VSBuffer.concat(g.map(h=>I.VSBuffer.wrap(h))).buffer),m=this.channel.listen("readFileStream",[b,d])(g=>{if(g instanceof I.VSBuffer)y.write(g.buffer);else{if(g==="end")y.end();else{let h=g;h instanceof Error||(h=(0,T.createFileSystemProviderError)((0,t.toErrorMessage)(h),T.FileSystemProviderErrorCode.Unknown)),y.error(h),y.end()}m.dispose()}});return C.onCancellationRequested(()=>{y.error((0,v.canceled)()),y.end(),m.dispose()}),y}writeFile(b,d,C){return this.channel.call("writeFile",[b,I.VSBuffer.wrap(d),C])}open(b,d){return this.channel.call("open",[b,d])}close(b){return this.channel.call("close",[b])}async read(b,d,C,y,m){const[g,h]=await this.channel.call("read",[b,d,m]);return C.set(g.buffer.slice(0,h),y),h}write(b,d,C,y,m){return this.channel.call("write",[b,d,I.VSBuffer.wrap(C),y,m])}mkdir(b){return this.channel.call("mkdir",[b])}delete(b,d){return this.channel.call("delete",[b,d])}rename(b,d,C){return this.channel.call("rename",[b,d,C])}copy(b,d,C){return this.channel.call("copy",[b,d,C])}cloneFile(b,d){return this.channel.call("cloneFile",[b,d])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(b=>{if(Array.isArray(b)){const d=b;this._onDidChange.fire(d.map(C=>({resource:p.URI.revive(C.resource),type:C.type})))}else{const d=b;this._onDidWatchError.fire(d)}}))}watch(b,d){const C=(0,D.generateUuid)();return this.channel.call("watch",[this.sessionId,C,b,d]),(0,k.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,C]))}}e.DiskFileSystemProviderClient=R}),define(ve[97],we([0,1,16,11,170,17]),function(oe,e,I,t,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function k(T,R,E,b,d,C){let y;try{await w(T,R,E,b,d,C)}catch(m){y=m}finally{y&&d.errorTransformer&&(y=d.errorTransformer(y)),typeof y!="undefined"&&E.error(y),E.end()}}e.readFileIntoStream=k;async function w(T,R,E,b,d,C){p(C);const y=await T.open(R,{create:!1});try{p(C);let m=0,g=0,h=d&&typeof d.length=="number"?d.length:void 0,l=I.VSBuffer.alloc(Math.min(d.bufferSize,typeof h=="number"?h:d.bufferSize)),f=d&&typeof d.position=="number"?d.position:0,i=0;do g=await T.read(y,f,l.buffer,i,l.byteLength-i),f+=g,i+=g,m+=g,typeof h=="number"&&(h-=g),i===l.byteLength&&(await E.write(b(l)),l=I.VSBuffer.alloc(Math.min(d.bufferSize,typeof h=="number"?h:d.bufferSize)),i=0);while(g>0&&(typeof h!="number"||h>0)&&p(C)&&D(m,d));if(i>0){let a=i;typeof h=="number"&&(a=Math.min(i,h)),E.write(b(l.slice(0,a)))}}catch(m){throw(0,P.ensureFileSystemProviderError)(m)}finally{await T.close(y)}}function p(T){if(T.isCancellationRequested)throw(0,t.canceled)();return!0}function D(T,R){if(R?.limits){if(typeof R.limits.memory=="number"&&T>R.limits.memory)throw(0,P.createFileSystemProviderError)((0,v.localize)(0,null),P.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof R.limits.size=="number"&&T>R.limits.size)throw(0,P.createFileSystemProviderError)((0,v.localize)(1,null),P.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ve[59],we([0,1,69,2,5,3,4,17]),function(oe,e,I,t,v,P,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function p(m){return m.recursive===!0}e.isRecursiveWatchRequest=p;class D extends t.Disposable{constructor(g,h,l,f){super();this.onFileChanges=g,this.onLogMessage=h,this.verboseLogging=l,this.options=f,this.watcherDisposables=this._register(new t.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const g=new t.DisposableStore;this.watcherDisposables.value=g,this.watcher=this.createWatcher(g),this.watcher.setVerboseLogging(this.verboseLogging),g.add(this.watcher.onDidChangeFile(h=>this.onFileChanges(h))),g.add(this.watcher.onDidLogMessage(h=>this.onLogMessage(h))),g.add(this.watcher.onDidError(h=>this.onError(h)))}onError(g){this.options.restartOnError?this.restartCounter<D.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${g}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${g}`):this.error(g)}restart(g){this.restartCounter++,this.init(),this.watch(g)}async watch(g){this.requests=g,await this.watcher?.watch(g)}async setVerboseLogging(g){this.verboseLogging=g,await this.watcher?.setVerboseLogging(g)}error(g){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${g}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=D,D.MAX_RESTARTS=5;class T extends D{constructor(g,h,l){super(g,h,l,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=T;class R extends D{constructor(g,h,l){super(g,h,l,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=R;function E(m){return m.map(g=>({type:g.type,resource:k.URI.file(g.path)}))}e.toFileChanges=E;function b(m){const g=new y;for(const h of m)g.processEvent(h);return g.coalesce()}e.coalesceEvents=b;function d(m,g){return typeof g=="string"&&!g.startsWith(I.GLOBSTAR)&&!(0,v.isAbsolute)(g)?{base:m,pattern:g}:g}e.normalizeWatcherPattern=d;function C(m,g){const h=[];for(const l of g)h.push((0,I.parse)(d(m,l)));return h}e.parseWatcherPatterns=C;class y{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(g){return P.isLinux?g.path:g.path.toLowerCase()}processEvent(g){const h=this.mapPathToChange.get(this.toKey(g));let l=!1;if(h){const f=h.type,i=g.type;h.path!==g.path&&(g.type===2||g.type===1)?l=!0:f===1&&i===2?(this.mapPathToChange.delete(this.toKey(g)),this.coalesced.delete(h)):f===2&&i===1?h.type=0:f===1&&i===0||(h.type=i)}else l=!0;l&&(this.coalesced.add(g),this.mapPathToChange.set(this.toKey(g),g))}coalesce(){const g=[],h=[];return Array.from(this.coalesced).filter(l=>l.type!==2?(g.push(l),!1):!0).sort((l,f)=>l.path.length-f.path.length).filter(l=>h.some(f=>(0,w.isParent)(l.path,f,!P.isLinux))?!1:(h.push(l.path),!0)).concat(g)}}}),define(ve[199],we([0,1,30,14,20,33,2,87,5,3,151,21,59]),function(oe,e,I,t,v,P,k,w,p,D,T,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class b extends k.Disposable{constructor(y,m,g,h){super();this.request=y,this.onDidFilesChange=m,this.onLogMessage=g,this.verboseLogging=h,this.throttledFileChangesWorker=new t.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},l=>this.onDidFilesChange(l)),this.fileChangesDelayer=this._register(new t.ThrottledDelayer(b.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=(0,E.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,E.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new v.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const y=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const m=await R.Promises.stat(y);this._register(await this.doWatch(y,m.isDirectory()))}catch(y){y.code!=="ENOENT"?this.error(y):this.trace(y)}}async normalizePath(y){let m=y.path;try{m=await R.Promises.realpath(y.path),y.path===m&&(m=await(0,T.realcase)(y.path)??y.path),y.path!==m&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${y.path}, real: ${m})`)}catch{}return m}async doWatch(y,m){if(D.isMacintosh&&(0,P.isEqualOrParent)(y,"/Volumes/",!0))return this.error(`Refusing to watch ${y} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),k.Disposable.None;const g=new v.CancellationTokenSource(this.cts.token),h=new k.DisposableStore;try{const l=(0,p.basename)(y),f=(0,I.watch)(y);h.add((0,k.toDisposable)(()=>{f.removeAllListeners(),f.close()})),this.trace(`Started watching: '${y}'`);const i=new Set;if(m)try{for(const n of await R.Promises.readdir(y))i.add(n)}catch(n){this.error(n)}const a=new Map;h.add((0,k.toDisposable)(()=>{for(const[,n]of a)n.dispose();a.clear()})),f.on("error",(n,o)=>{this.error(`Failed to watch ${y} for changes using fs.watch() (${n}, ${o})`),this.dispose()}),f.on("change",(n,o)=>{if(g.token.isCancellationRequested)return;this.trace(`[raw] ["${n}"] ${o}`);let r="";if(o&&(r=o.toString(),D.isMacintosh&&(r=(0,w.normalizeNFC)(r))),!(!r||n!=="change"&&n!=="rename"))if(m)if(n==="rename"){a.get(r)?.dispose();const s=setTimeout(async()=>{if(a.delete(r),r===l&&!await R.Promises.exists(y)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const c=await this.existsChildStrictCase((0,p.join)(y,r));if(g.token.isCancellationRequested)return;let u;c?i.has(r)?u=0:(u=1,i.add(r)):(i.delete(r),u=2),this.onFileChange({path:(0,p.join)(this.request.path,r),type:u})},b.FILE_DELETE_HANDLER_DELAY);a.set(r,(0,k.toDisposable)(()=>clearTimeout(s)))}else{let s;i.has(r)?s=0:(s=1,i.add(r)),this.onFileChange({path:(0,p.join)(this.request.path,r),type:s})}else if(n==="rename"||r!==l){const s=setTimeout(async()=>{const c=await R.Promises.exists(y);g.token.isCancellationRequested||(c?(this.onFileChange({path:this.request.path,type:0},!0),h.add(await this.doWatch(y,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},b.FILE_DELETE_HANDLER_DELAY);h.clear(),h.add((0,k.toDisposable)(()=>clearTimeout(s)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(l){await R.Promises.exists(y)&&!g.token.isCancellationRequested&&this.error(`Failed to watch ${y} for changes using fs.watch() (${l.toString()})`)}return(0,k.toDisposable)(()=>{g.dispose(!0),h.dispose()})}async onFileChange(y,m=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${y.type===1?"[ADDED]":y.type===2?"[DELETED]":"[CHANGED]"} ${y.path}`),!m&&this.excludes.some(g=>g(y.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${y.path}`):!m&&this.includes&&this.includes.length>0&&!this.includes.some(g=>g(y.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${y.path}`):this.fileChangesBuffer.push(y);try{await this.fileChangesDelayer.trigger(async()=>{const g=this.fileChangesBuffer;this.fileChangesBuffer=[];const h=(0,E.coalesceEvents)(g);if(h.length>0){if(this.verboseLogging)for(const f of h)this.trace(`>> normalized ${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.path}`);this.throttledFileChangesWorker.work(h)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${h[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${h.length}, most recent change: ${h[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(y){if(D.isLinux)return R.Promises.exists(y);try{const m=(0,p.basename)(y);return(await R.Promises.readdir((0,p.dirname)(y))).some(h=>h===m)}catch(m){return this.trace(m),!1}}setVerboseLogging(y){this.verboseLogging=y}error(y){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${y}`})}warn(y){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${y}`})}trace(y){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${y}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=b,b.FILE_DELETE_HANDLER_DELAY=100,b.FILE_CHANGES_HANDLER_DELAY=50;async function d(C,y,m,g,h=512){const l=await R.Promises.open(C,"r"),f=Buffer.allocUnsafe(h),i=new v.CancellationTokenSource(g);let a,n=!1;const o={path:C,excludes:[],recursive:!1},r=new b(o,s=>{(async()=>{for(const{type:c}of s)if(c===0){if(n)return;n=!0;try{for(;!i.token.isCancellationRequested;){const{bytesRead:u}=await R.Promises.read(l,f,0,h,null);if(!u||i.token.isCancellationRequested)break;y(f.slice(0,u))}}catch(u){a=new Error(u),i.dispose(!0)}finally{n=!1}}})()});return await r.ready,m(),new Promise((s,c)=>{i.token.onCancellationRequested(async()=>{r.dispose();try{await R.Promises.close(l)}catch(u){a=new Error(u)}a?c(a):s()})})}e.watchFileContents=d}),define(ve[200],we([0,1,7,69,2,3,199]),function(oe,e,I,t,v,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class w extends v.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new I.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new I.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=I.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(D){const T=this.normalizeRequests(D),R=T.filter(b=>{const d=this.watchers.get(b.path);return d?!(0,t.patternsEquals)(d.request.excludes,b.excludes)||!(0,t.patternsEquals)(d.request.includes,b.includes):!0}),E=Array.from(this.watchers.values()).filter(({request:b})=>!T.find(d=>d.path===b.path&&(0,t.patternsEquals)(d.excludes,b.excludes)&&(0,t.patternsEquals)(d.includes,b.includes))).map(({request:b})=>b.path);R.length&&this.trace(`Request to start watching: ${R.map(b=>`${b.path} (excludes: ${b.excludes.length>0?b.excludes:"<none>"}, includes: ${b.includes&&b.includes.length>0?JSON.stringify(b.includes):"<all>"})`).join(",")}`),E.length&&this.trace(`Request to stop watching: ${E.join(",")}`);for(const b of E)this.stopWatching(b);for(const b of R)this.startWatching(b)}startWatching(D){const T=new k.NodeJSFileWatcherLibrary(D,E=>this._onDidChangeFile.fire(E),E=>this._onDidLogMessage.fire(E),this.verboseLogging),R={request:D,instance:T};this.watchers.set(D.path,R)}async stop(){for(const[D]of this.watchers)this.stopWatching(D);this.watchers.clear()}stopWatching(D){const T=this.watchers.get(D);T&&(this.watchers.delete(D),T.instance.dispose())}normalizeRequests(D){const T=new Map;for(const R of D){const E=P.isLinux?R.path:R.path.toLowerCase();T.set(E,R)}return Array.from(T.values())}async setVerboseLogging(D){this.verboseLogging=D;for(const[,T]of this.watchers)T.instance.setVerboseLogging(D)}trace(D){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(D)})}toMessage(D,T){return T?`[File Watcher (node.js)] ${D} (path: ${T.request.path})`:`[File Watcher (node.js)] ${D}`}}e.NodeJSWatcher=w}),define(ve[201],we([0,1,59,200]),function(oe,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class v extends I.AbstractNonRecursiveWatcherClient{constructor(k,w,p){super(k,w,p);this.init()}createWatcher(){return new t.NodeJSWatcher}}e.NodeJSWatcherClient=v}),define(ve[202],we([0,1,10,43,94,59]),function(oe,e,I,t,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class k extends P.AbstractUniversalWatcherClient{constructor(p,D,T){super(p,D,T);this.init()}createWatcher(p){const D=p.add(new v.Client(I.FileAccess.asFileUri("bootstrap-fork",oe).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return p.add(D.onDidProcessExit(({code:T,signal:R})=>this.onError(`terminated by itself with code ${T}, signal: ${R}`))),t.ProxyChannel.toService((0,t.getNextTickChannel)(D.getChannel("watcher")))}}e.UniversalWatcherClient=k}),define(ve[74],we([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class I{constructor(...v){this._entries=new Map;for(const[P,k]of v)this.set(P,k)}set(v,P){const k=this._entries.get(v);return this._entries.set(v,P),k}has(v){return this._entries.has(v)}get(v){return this._entries.get(v)}}e.ServiceCollection=I}),define(ve[98],we([0,1,14,11,58,194,6,74]),function(oe,e,I,t,v,P,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const p=!1;class D extends Error{constructor(d){super("cyclic dependency between services");this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class T{constructor(d=new w.ServiceCollection,C=!1,y){this._activeInstantiations=new Set,this._services=d,this._strict=C,this._parent=y,this._services.set(k.IInstantiationService,this)}createChild(d){return new T(d,this._strict,this)}invokeFunction(d,...C){const y=E.traceInvocation(d);let m=!1;try{return d({get:h=>{if(m)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const l=this._getOrCreateServiceInstance(h,y);if(!l)throw new Error(`[invokeFunction] unknown service '${h}'`);return l}},...C)}finally{m=!0,y.stop()}}createInstance(d,...C){let y,m;return d instanceof v.SyncDescriptor?(y=E.traceCreation(d.ctor),m=this._createInstance(d.ctor,d.staticArguments.concat(C),y)):(y=E.traceCreation(d),m=this._createInstance(d,C,y)),y.stop(),m}_createInstance(d,C=[],y){const m=k._util.getServiceDependencies(d).sort((l,f)=>l.index-f.index),g=[];for(const l of m){const f=this._getOrCreateServiceInstance(l.id,y);f||this._throwIfStrict(`[createInstance] ${d.name} depends on UNKNOWN service ${l.id}.`,!1),g.push(f)}const h=m.length>0?m[0].index:C.length;if(C.length!==h){console.trace(`[createInstance] First service dependency of ${d.name} at position ${h+1} conflicts with ${C.length} static arguments`);const l=h-C.length;l>0?C=C.concat(new Array(l)):C=C.slice(0,h)}return new d(...[...C,...g])}_setServiceInstance(d,C){if(this._services.get(d)instanceof v.SyncDescriptor)this._services.set(d,C);else if(this._parent)this._parent._setServiceInstance(d,C);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(d){const C=this._services.get(d);return!C&&this._parent?this._parent._getServiceInstanceOrDescriptor(d):C}_getOrCreateServiceInstance(d,C){const y=this._getServiceInstanceOrDescriptor(d);return y instanceof v.SyncDescriptor?this._safeCreateAndCacheServiceInstance(d,y,C.branch(d,!0)):(C.branch(d,!1),y)}_safeCreateAndCacheServiceInstance(d,C,y){if(this._activeInstantiations.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this._activeInstantiations.add(d);try{return this._createAndCacheServiceInstance(d,C,y)}finally{this._activeInstantiations.delete(d)}}_createAndCacheServiceInstance(d,C,y){const m=new P.Graph(l=>l.id.toString());let g=0;const h=[{id:d,desc:C,_trace:y}];for(;h.length;){const l=h.pop();if(m.lookupOrInsertNode(l),g++>1e3)throw new D(m);for(const f of k._util.getServiceDependencies(l.desc.ctor)){const i=this._getServiceInstanceOrDescriptor(f.id);if(i||this._throwIfStrict(`[createInstance] ${d} depends on ${f.id} which is NOT registered.`,!0),i instanceof v.SyncDescriptor){const a={id:f.id,desc:i,_trace:l._trace.branch(f.id,!0)};m.insertEdge(l,a),h.push(a)}}}for(;;){const l=m.roots();if(l.length===0){if(!m.isEmpty())throw new D(m);break}for(const{data:f}of l){if(this._getServiceInstanceOrDescriptor(f.id)instanceof v.SyncDescriptor){const a=this._createServiceInstanceWithOwner(f.id,f.desc.ctor,f.desc.staticArguments,f.desc.supportsDelayedInstantiation,f._trace);this._setServiceInstance(f.id,a)}m.removeNode(f)}}return this._getServiceInstanceOrDescriptor(d)}_createServiceInstanceWithOwner(d,C,y=[],m,g){if(this._services.get(d)instanceof v.SyncDescriptor)return this._createServiceInstance(C,y,m,g);if(this._parent)return this._parent._createServiceInstanceWithOwner(d,C,y,m,g);throw new Error(`illegalState - creating UNKNOWN service instance ${C.name}`)}_createServiceInstance(d,C=[],y,m){if(y){const g=new I.IdleValue(()=>this._createInstance(d,C,m));return new Proxy(Object.create(null),{get(h,l){if(l in h)return h[l];const f=g.value;let i=f[l];return typeof i!="function"||(i=i.bind(f),h[l]=i),i},set(h,l,f){return g.value[l]=f,!0}})}else return this._createInstance(d,C,m)}_throwIfStrict(d,C){if(C&&console.warn(C),this._strict)throw new Error(d)}}e.InstantiationService=T;var R;(function(b){b[b.Creation=0]="Creation",b[b.Invocation=1]="Invocation",b[b.Branch=2]="Branch"})(R||(R={}));class E{constructor(d,C){this.type=d,this.name=C,this._start=Date.now(),this._dep=[]}static traceInvocation(d){return p?new E(1,d.name||d.toString().substring(0,42).replace(/\n/g,"")):E._None}static traceCreation(d){return p?new E(0,d.name):E._None}branch(d,C){const y=new E(2,d.toString());return this._dep.push([d,C,y]),y}stop(){const d=Date.now()-this._start;E._totals+=d;let C=!1;function y(g,h){const l=[],f=new Array(g+1).join("	");for(const[i,a,n]of h._dep)if(a&&n){C=!0,l.push(`${f}CREATES -> ${i}`);const o=y(g+1,n);o&&l.push(o)}else l.push(`${f}uses -> ${i}`);return l.join(`
`)}const m=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${y(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${E._totals.toFixed(2)}ms)`];(d>2||C)&&console.log(m.join(`
`))}}e.Trace=E,E._None=new class extends E{constructor(){super(-1,null)}stop(){}branch(){return this}},E._totals=0}),define(ve[203],we([0,1,6]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILabelService=void 0,e.ILabelService=(0,I.createDecorator)("labelService")});var _e=this&&this.__param||function(oe,e){return function(I,t){e(I,t,oe)}};define(ve[75],we([0,1,20,2,3,172,31,6]),function(oe,e,I,t,v,P,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=void 0,e.ILanguagePackService=(0,w.createDecorator)("languagePackService");let p=class extends t.Disposable{constructor(T){super();this.extensionGalleryService=T}async getAvailableLanguages(){const T=new I.CancellationTokenSource;setTimeout(()=>T.cancel(),1e3);let R;try{R=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},T.token)}catch{return[]}const b=R.firstPage.filter(d=>d.properties.localizedLanguages?.length&&d.tags.some(C=>C.startsWith("lp-"))).map(d=>{const C=d.properties.localizedLanguages?.[0],y=d.tags.find(g=>g.startsWith("lp-")).split("lp-")[1];return{...this.createQuickPickItem({locale:y,label:C}),extensionId:d.identifier.id,galleryExtension:d}});return b.push({...this.createQuickPickItem({locale:"en",label:"English"}),extensionId:"default"}),b}createQuickPickItem(T){const R=T.label??T.locale;let E=T.locale!==T.label?T.locale:void 0;return T.locale.toLowerCase()===v.language.toLowerCase()&&(E||(E=""),E+=(0,P.localize)(0,null)),{id:T.locale,label:R,description:E}}};p=Re([_e(0,k.IExtensionGalleryService)],p),e.LanguagePackBaseService=p}),define(ve[13],we([0,1,37,7,2,3,6]),function(oe,e,I,t,v,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,k.createDecorator)("logService"),e.ILoggerService=(0,k.createDecorator)("loggerService");function w(){return new Date().toISOString()}var p;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(p=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=p.Info;function D(a,n,o){switch(n){case p.Trace:a.trace(o);break;case p.Debug:a.debug(o);break;case p.Info:a.info(o);break;case p.Warning:a.warn(o);break;case p.Error:a.error(o);break;case p.Critical:a.critical(o);break;default:throw new Error("Invalid log level")}}e.log=D;function T(a){let n="";for(let o=0;o<a.length;o++){let r=a[o];if(typeof r=="object")try{r=JSON.stringify(r)}catch{}n+=(o>0?" ":"")+r}return n}e.format=T;class R extends v.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(n){this.level!==n&&(this.level=n,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=R;class E extends R{constructor(n){super();this.logAlways=n}checkLogLevel(n){return this.logAlways||this.getLevel()<=n}trace(n,...o){this.checkLogLevel(p.Trace)&&this.log(p.Trace,T([n,...o]))}debug(n,...o){this.checkLogLevel(p.Debug)&&this.log(p.Debug,T([n,...o]))}info(n,...o){this.checkLogLevel(p.Info)&&this.log(p.Info,T([n,...o]))}warn(n,...o){this.checkLogLevel(p.Warning)&&this.log(p.Warning,T([n,...o]))}error(n,...o){if(this.checkLogLevel(p.Error))if(n instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=n.stack,this.log(p.Error,T(r))}else this.log(p.Error,T([n,...o]))}critical(n,...o){this.checkLogLevel(p.Critical)&&this.log(p.Critical,T([n,...o]))}flush(){}}e.AbstractMessageLogger=E;class b extends R{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n),this.useColors=!P.isWindows}trace(n,...o){this.getLevel()<=p.Trace&&(this.useColors?console.log(`[90m[main ${w()}][0m`,n,...o):console.log(`[main ${w()}]`,n,...o))}debug(n,...o){this.getLevel()<=p.Debug&&(this.useColors?console.log(`[90m[main ${w()}][0m`,n,...o):console.log(`[main ${w()}]`,n,...o))}info(n,...o){this.getLevel()<=p.Info&&(this.useColors?console.log(`[90m[main ${w()}][0m`,n,...o):console.log(`[main ${w()}]`,n,...o))}warn(n,...o){this.getLevel()<=p.Warning&&(this.useColors?console.warn(`[93m[main ${w()}][0m`,n,...o):console.warn(`[main ${w()}]`,n,...o))}error(n,...o){this.getLevel()<=p.Error&&(this.useColors?console.error(`[91m[main ${w()}][0m`,n,...o):console.error(`[main ${w()}]`,n,...o))}critical(n,...o){this.getLevel()<=p.Critical&&(this.useColors?console.error(`[90m[main ${w()}][0m`,n,...o):console.error(`[main ${w()}]`,n,...o))}dispose(){}flush(){}}e.ConsoleMainLogger=b;class d extends R{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n)}trace(n,...o){this.getLevel()<=p.Trace&&console.log("%cTRACE","color: #888",n,...o)}debug(n,...o){this.getLevel()<=p.Debug&&console.log("%cDEBUG","background: #eee; color: #888",n,...o)}info(n,...o){this.getLevel()<=p.Info&&console.log("%c INFO","color: #33f",n,...o)}warn(n,...o){this.getLevel()<=p.Warning&&console.log("%c WARN","color: #993",n,...o)}error(n,...o){this.getLevel()<=p.Error&&console.log("%c  ERR","color: #f33",n,...o)}critical(n,...o){this.getLevel()<=p.Critical&&console.log("%cCRITI","background: #f33; color: white",n,...o)}dispose(){}flush(){}}e.ConsoleLogger=d;class C extends R{constructor(n,o=e.DEFAULT_LOG_LEVEL){super();this.adapter=n,this.setLevel(o)}trace(n,...o){this.getLevel()<=p.Trace&&this.adapter.log(p.Trace,[this.extractMessage(n),...o])}debug(n,...o){this.getLevel()<=p.Debug&&this.adapter.log(p.Debug,[this.extractMessage(n),...o])}info(n,...o){this.getLevel()<=p.Info&&this.adapter.log(p.Info,[this.extractMessage(n),...o])}warn(n,...o){this.getLevel()<=p.Warning&&this.adapter.log(p.Warning,[this.extractMessage(n),...o])}error(n,...o){this.getLevel()<=p.Error&&this.adapter.log(p.Error,[this.extractMessage(n),...o])}critical(n,...o){this.getLevel()<=p.Critical&&this.adapter.log(p.Critical,[this.extractMessage(n),...o])}extractMessage(n){return typeof n=="string"?n:(0,I.toErrorMessage)(n,this.getLevel()<=p.Trace)}dispose(){}flush(){}}e.AdapterLogger=C;class y extends R{constructor(n){super();this.logServices=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const o of this.logServices)o.setLevel(n);super.setLevel(n)}trace(n,...o){for(const r of this.logServices)r.trace(n,...o)}debug(n,...o){for(const r of this.logServices)r.debug(n,...o)}info(n,...o){for(const r of this.logServices)r.info(n,...o)}warn(n,...o){for(const r of this.logServices)r.warn(n,...o)}error(n,...o){for(const r of this.logServices)r.error(n,...o)}critical(n,...o){for(const r of this.logServices)r.critical(n,...o)}flush(){for(const n of this.logServices)n.flush()}dispose(){for(const n of this.logServices)n.dispose()}}e.MultiplexLogService=y;class m extends v.Disposable{constructor(n){super();this.logger=n,this._register(n)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(n){this.logger.setLevel(n)}getLevel(){return this.logger.getLevel()}trace(n,...o){this.logger.trace(n,...o)}debug(n,...o){this.logger.debug(n,...o)}info(n,...o){this.logger.info(n,...o)}warn(n,...o){this.logger.warn(n,...o)}error(n,...o){this.logger.error(n,...o)}critical(n,...o){this.logger.critical(n,...o)}flush(){this.logger.flush()}}e.LogService=m;class g extends v.Disposable{constructor(n,o){super();this.logLevel=n,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(o(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(s=>s.setLevel(r))}))}getLogger(n){return this.loggers.get(n.toString())}createLogger(n,o){let r=this.loggers.get(n.toString());return r||(r=this.doCreateLogger(n,o?.always?p.Trace:this.logLevel,o),this.loggers.set(n.toString(),r),o?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(n=>n.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=g;class h{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(n){}getLevel(){return p.Info}trace(n,...o){}debug(n,...o){}info(n,...o){}warn(n,...o){}error(n,...o){}critical(n,...o){}dispose(){}flush(){}}e.NullLogService=h;function l(a){if(a.verbose)return p.Trace;if(typeof a.logLevel=="string"){const n=f(a.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=l;function f(a){switch(a){case"trace":return p.Trace;case"debug":return p.Debug;case"info":return p.Info;case"warn":return p.Warning;case"error":return p.Error;case"critical":return p.Critical;case"off":return p.Off}}e.parseLogLevel=f;function i(a){switch(a){case p.Trace:return"trace";case p.Debug:return"debug";case p.Info:return"info";case p.Warning:return"warn";case p.Error:return"error";case p.Critical:return"critical";case p.Off:return"off"}}e.LogLevelToString=i}),define(ve[204],we([0,1,72,7,2,13,3]),function(oe,e,I,t,v,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let w=class Bt extends v.Disposable{constructor(D){super();this.logService=D,this._onDidChangePassword=this._register(new t.Emitter),this.onDidChangePassword=this._onDidChangePassword.event}async getPassword(D,T){let R;try{R=await this.withKeytar()}catch{return null}const E=await R.getPassword(D,T);if(E)try{let{content:b,hasNextChunk:d}=JSON.parse(E);if(!b||!d)return E;let C=1;for(;d;){const y=await R.getPassword(D,`${T}-${C}`),m=JSON.parse(y);b+=m.content,d=m.hasNextChunk,C++}return b}catch{return E}return E}async setPassword(D,T,R){let E;try{E=await this.withKeytar()}catch(C){throw this.surfaceKeytarLoadError?.(C),C}const b=3,d=async(C,y,m)=>{let g=0,h;for(;g<b;)try{await E.setPassword(C,y,m);return}catch(l){h=l,this.logService.warn("Error attempting to set a password: ",l?.message??l),g++,await new Promise(f=>setTimeout(f,200))}throw h};if(k.isWindows&&R.length>Bt.MAX_PASSWORD_LENGTH){let C=0,y=0,m=!0;for(;m;){const g=R.substring(C,C+Bt.PASSWORD_CHUNK_SIZE);C+=Bt.PASSWORD_CHUNK_SIZE,m=R.length-C>0;const h={content:g,hasNextChunk:m};await d(D,y?`${T}-${y}`:T,JSON.stringify(h)),y++}}else await d(D,T,R);this._onDidChangePassword.fire({service:D,account:T})}async deletePassword(D,T){let R;try{R=await this.withKeytar()}catch(d){throw this.surfaceKeytarLoadError?.(d),d}const E=await R.getPassword(D,T);if(!E)return!1;const b=await R.deletePassword(D,T);try{let{content:d,hasNextChunk:C}=JSON.parse(E);if(d&&C){let y=1;for(;C;){const m=`${T}-${y}`,g=await R.getPassword(D,m);await R.deletePassword(D,m),C=JSON.parse(g).hasNextChunk,y++}}}catch{}return b&&this._onDidChangePassword.fire({service:D,account:T}),b}async findPassword(D){let T;try{T=await this.withKeytar()}catch{return null}return T.findPassword(D)}async findCredentials(D){let T;try{T=await this.withKeytar()}catch{return[]}return T.findCredentials(D)}clear(){return this._keytarCache instanceof I.InMemoryCredentialsProvider?this._keytarCache.clear():Promise.resolve()}};w.MAX_PASSWORD_LENGTH=2500,w.PASSWORD_CHUNK_SIZE=w.MAX_PASSWORD_LENGTH-100,w=Re([_e(0,P.ILogService)],w),e.BaseCredentialsMainService=w}),define(ve[205],we([0,1,18,14,11,7,2,5,59,13]),function(oe,e,I,t,v,P,k,w,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class T extends k.Disposable{constructor(E,b){super();this.logService=E,this.options=b,this._onDidChangeFile=this._register(new P.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new P.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new t.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new t.ThrottledDelayer(0))}watch(E,b){return b.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(E,b):this.watchNonRecursive(E,b)}watchUniversal(E,b){const d={path:this.toFilePath(E),excludes:b.excludes,includes:b.includes,recursive:b.recursive},C=(0,I.insert)(this.universalPathsToWatch,d);return this.refreshUniversalWatchers(),(0,k.toDisposable)(()=>{C(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(E=>(0,v.onUnexpectedError)(E))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(b=>this._onDidChangeFile.fire((0,p.toFileChanges)(b)),b=>this.onWatcherLogMessage(b),this.logService.getLevel()===D.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===D.LogLevel.Trace)})));const E=this.options?.watcher?.recursive?.usePolling;if(E===!0)for(const b of this.universalPathsToWatch)(0,p.isRecursiveWatchRequest)(b)&&(b.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(E))for(const b of this.universalPathsToWatch)(0,p.isRecursiveWatchRequest)(b)&&E.includes(b.path)&&(b.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(E,b){const d={path:this.toFilePath(E),excludes:b.excludes,includes:b.includes,recursive:!1},C=(0,I.insert)(this.nonRecursivePathsToWatch,d);return this.refreshNonRecursiveWatchers(),(0,k.toDisposable)(()=>{C(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(E=>(0,v.onUnexpectedError)(E))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(E=>this._onDidChangeFile.fire((0,p.toFileChanges)(E)),E=>this.onWatcherLogMessage(E),this.logService.getLevel()===D.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===D.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(E){E.type==="error"&&this._onDidWatchError.fire(E.message),this.logService[E.type](E.message)}toFilePath(E){return(0,w.normalize)(E.fsPath)}}e.AbstractDiskFileSystemProvider=T}),define(ve[99],we([0,1,18,14,16,20,7,86,47,2,29,10,49,19,48,168,17,97,13]),function(oe,e,I,t,v,P,k,w,p,D,T,R,E,b,d,C,y,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let h=class extends D.Disposable{constructor(f){super();this.logService=f,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new k.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new k.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new k.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new k.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new k.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new k.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new t.ResourceQueue)}registerProvider(f,i){if(this.provider.has(f))throw new Error(`A filesystem provider for the scheme '${f}' is already registered.`);(0,E.mark)(`code/registerFilesystem/${f}`);const a=new D.DisposableStore;return this.provider.set(f,i),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:f,provider:i}),a.add(i.onDidChangeFile(n=>this._onDidFilesChange.fire(new y.FileChangesEvent(n,!this.isPathCaseSensitive(i))))),typeof i.onDidWatchError=="function"&&a.add(i.onDidWatchError(n=>this._onDidWatchError.fire(new Error(n)))),a.add(i.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:i,scheme:f}))),(0,D.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:f,provider:i}),this.provider.delete(f),(0,D.dispose)(a)})}getProvider(f){return this.provider.get(f)}async activateProvider(f){const i=[];this._onWillActivateFileSystemProvider.fire({scheme:f,join(a){i.push(a)}}),!this.provider.has(f)&&await t.Promises.settled(i)}async canHandleResource(f){return await this.activateProvider(f.scheme),this.hasProvider(f)}hasProvider(f){return this.provider.has(f.scheme)}hasCapability(f,i){const a=this.provider.get(f.scheme);return!!(a&&a.capabilities&i)}listCapabilities(){return p.Iterable.map(this.provider,([f,i])=>({scheme:f,capabilities:i.capabilities}))}async withProvider(f){if(!(0,b.isAbsolutePath)(f))throw new y.FileOperationError((0,C.localize)(0,null,this.resourceForError(f)),8);await this.activateProvider(f.scheme);const i=this.provider.get(f.scheme);if(!i){const a=new Error;throw a.name="ENOPRO",a.message=(0,C.localize)(1,null,f.toString()),a}return i}async withReadProvider(f){const i=await this.withProvider(f);if((0,y.hasOpenReadWriteCloseCapability)(i)||(0,y.hasReadWriteCapability)(i)||(0,y.hasFileReadStreamCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${f.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(f){const i=await this.withProvider(f);if((0,y.hasOpenReadWriteCloseCapability)(i)||(0,y.hasReadWriteCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${f.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(f,i){try{return await this.doResolveFile(f,i)}catch(a){throw(0,y.toFileSystemProviderErrorCode)(a)===y.FileSystemProviderErrorCode.FileNotFound?new y.FileOperationError((0,C.localize)(2,null,this.resourceForError(f)),1):(0,y.ensureFileSystemProviderError)(a)}}async doResolveFile(f,i){const a=await this.withProvider(f),n=this.isPathCaseSensitive(a),o=i?.resolveTo,r=i?.resolveSingleChildDescendants,s=i?.resolveMetadata,c=await a.stat(f);let u;return this.toFileStat(a,f,c,void 0,!!s,(S,A)=>(u||(u=T.TernarySearchTree.forUris(()=>!n),u.set(f,!0),o&&u.fill(!0,o)),u.get(S.resource)||u.findSuperstr(S.resource.with({query:null,fragment:null}))?!0:S.isDirectory&&r?A===1:!1))}async toFileStat(f,i,a,n,o,r){const{providerExtUri:s}=this.getExtUri(f),c={resource:i,name:s.basename(i),isFile:(a.type&y.FileType.File)!=0,isDirectory:(a.type&y.FileType.Directory)!=0,isSymbolicLink:(a.type&y.FileType.SymbolicLink)!=0,mtime:a.mtime,ctime:a.ctime,size:a.size,readonly:Boolean((a.permissions??0)&y.FilePermission.Readonly)||Boolean(f.capabilities&2048),etag:(0,y.etag)({mtime:a.mtime,size:a.size}),children:void 0};if(c.isDirectory&&r(c,n)){try{const u=await f.readdir(i),S=await t.Promises.settled(u.map(async([A,M])=>{try{const $=s.joinPath(i,A),Q=o?await f.stat($):{type:M};return await this.toFileStat(f,$,Q,u.length,o,r)}catch($){return this.logService.trace($),null}}));c.children=(0,I.coalesce)(S)}catch(u){this.logService.trace(u),c.children=[]}return c}return c}async resolveAll(f){return t.Promises.settled(f.map(async i=>{try{return{stat:await this.doResolveFile(i.resource,i.options),success:!0}}catch(a){return this.logService.trace(a),{stat:void 0,success:!1}}}))}async stat(f){const i=await this.withProvider(f),a=await i.stat(f);return this.toFileStat(i,f,a,void 0,!0,()=>!1)}async exists(f){const i=await this.withProvider(f);try{return!!await i.stat(f)}catch{return!1}}async canCreateFile(f,i){try{await this.doValidateCreateFile(f,i)}catch(a){return a}return!0}async doValidateCreateFile(f,i){if(!i?.overwrite&&await this.exists(f))throw new y.FileOperationError((0,C.localize)(3,null,this.resourceForError(f)),3,i)}async createFile(f,i=v.VSBuffer.fromString(""),a){await this.doValidateCreateFile(f,a);const n=await this.writeFile(f,i);return this._onDidRunOperation.fire(new y.FileOperationEvent(f,0,n)),n}async writeFile(f,i,a){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(f),f),{providerExtUri:o}=this.getExtUri(n);try{await this.validateWriteFile(n,f,a)||await this.mkdirp(n,o.dirname(f));let s;if((0,y.hasReadWriteCapability)(n)&&!(i instanceof v.VSBuffer))if((0,d.isReadableStream)(i)){const c=await(0,d.peekStream)(i,3);c.ended?s=v.VSBuffer.concat(c.buffer):s=c}else s=(0,d.peekReadable)(i,c=>v.VSBuffer.concat(c),3);else s=i;!(0,y.hasOpenReadWriteCloseCapability)(n)||(0,y.hasReadWriteCapability)(n)&&s instanceof v.VSBuffer?await this.doWriteUnbuffered(n,f,a,s):await this.doWriteBuffered(n,f,a,s instanceof v.VSBuffer?(0,v.bufferToReadable)(s):s),this._onDidRunOperation.fire(new y.FileOperationEvent(f,4))}catch(r){throw new y.FileOperationError((0,C.localize)(4,null,this.resourceForError(f),(0,y.ensureFileSystemProviderError)(r).toString()),(0,y.toFileOperationResult)(r),a)}return this.resolve(f,{resolveMetadata:!0})}async validateWriteFile(f,i,a){if(!!a?.unlock&&!(f.capabilities&8192))throw new Error((0,C.localize)(5,null,this.resourceForError(i)));let o;try{o=await f.stat(i)}catch{return}if((o.type&y.FileType.Directory)!=0)throw new y.FileOperationError((0,C.localize)(6,null,this.resourceForError(i)),0,a);if(this.throwIfFileIsReadonly(i,o),typeof a?.mtime=="number"&&typeof a.etag=="string"&&a.etag!==y.ETAG_DISABLED&&typeof o.mtime=="number"&&typeof o.size=="number"&&a.mtime<o.mtime&&a.etag!==(0,y.etag)({mtime:a.mtime,size:o.size}))throw new y.FileOperationError((0,C.localize)(7,null),3,a);return o}async readFile(f,i,a){const n=await this.withReadProvider(f);return i?.atomic?this.doReadFileAtomic(n,f,i,a):this.doReadFile(n,f,i,a)}async doReadFileAtomic(f,i,a,n){return new Promise((o,r)=>{this.writeQueue.queueFor(i,this.getExtUri(f).providerExtUri).queue(async()=>{try{const s=await this.doReadFile(f,i,a,n);o(s)}catch(s){r(s)}})})}async doReadFile(f,i,a,n){const o=await this.doReadFileStream(f,i,{...a,preferUnbuffered:!0},n);return{...o,value:await(0,v.streamToBuffer)(o.value)}}async readFileStream(f,i,a){const n=await this.withReadProvider(f);return this.doReadFileStream(n,f,i,a)}async doReadFileStream(f,i,a,n){const o=new P.CancellationTokenSource(n),r=this.validateReadFile(i,a).then(c=>c,c=>{throw o.cancel(),c});let s;try{return typeof a?.etag=="string"&&a.etag!==y.ETAG_DISABLED&&await r,a?.atomic&&(0,y.hasFileAtomicReadCapability)(f)||!((0,y.hasOpenReadWriteCloseCapability)(f)||(0,y.hasFileReadStreamCapability)(f))||(0,y.hasReadWriteCapability)(f)&&a?.preferUnbuffered?s=this.readFileUnbuffered(f,i,a):(0,y.hasFileReadStreamCapability)(f)?s=this.readFileStreamed(f,i,o.token,a):s=this.readFileBuffered(f,i,o.token,a),{...await r,value:s}}catch(c){s&&await(0,d.consumeStream)(s);const u=(0,C.localize)(8,null,this.resourceForError(i),(0,y.ensureFileSystemProviderError)(c).toString());throw c instanceof y.NotModifiedSinceFileOperationError?new y.NotModifiedSinceFileOperationError(u,c.stat,a):new y.FileOperationError(u,(0,y.toFileOperationResult)(c),a)}}readFileStreamed(f,i,a,n=Object.create(null)){const o=f.readFileStream(i,n,a);return(0,d.transform)(o,{data:r=>r instanceof v.VSBuffer?r:v.VSBuffer.wrap(r),error:r=>new y.FileOperationError((0,C.localize)(9,null,this.resourceForError(i),(0,y.ensureFileSystemProviderError)(r).toString()),(0,y.toFileOperationResult)(r),n)},r=>v.VSBuffer.concat(r))}readFileBuffered(f,i,a,n=Object.create(null)){const o=(0,v.newWriteableBufferStream)();return(0,m.readFileIntoStream)(f,i,o,r=>r,{...n,bufferSize:this.BUFFER_SIZE,errorTransformer:r=>new y.FileOperationError((0,C.localize)(10,null,this.resourceForError(i),(0,y.ensureFileSystemProviderError)(r).toString()),(0,y.toFileOperationResult)(r),n)},a),o}readFileUnbuffered(f,i,a){const n=(0,d.newWriteableStream)(o=>v.VSBuffer.concat(o));return(async()=>{try{let o;a?.atomic&&(0,y.hasFileAtomicReadCapability)(f)?o=await f.readFile(i,{atomic:!0}):o=await f.readFile(i),typeof a?.position=="number"&&(o=o.slice(a.position)),typeof a?.length=="number"&&(o=o.slice(0,a.length)),this.validateReadFileLimits(i,o.byteLength,a),n.end(v.VSBuffer.wrap(o))}catch(o){n.error(o),n.end()}})(),n}async validateReadFile(f,i){const a=await this.resolve(f,{resolveMetadata:!0});if(a.isDirectory)throw new y.FileOperationError((0,C.localize)(11,null,this.resourceForError(f)),0,i);if(typeof i?.etag=="string"&&i.etag!==y.ETAG_DISABLED&&i.etag===a.etag)throw new y.NotModifiedSinceFileOperationError((0,C.localize)(12,null),a,i);return this.validateReadFileLimits(f,a.size,i),a}validateReadFileLimits(f,i,a){if(a?.limits){let n;if(typeof a.limits.memory=="number"&&i>a.limits.memory&&(n=9),typeof a.limits.size=="number"&&i>a.limits.size&&(n=7),typeof n=="number")throw new y.FileOperationError((0,C.localize)(13,null,this.resourceForError(f)),n)}}async canMove(f,i,a){return this.doCanMoveCopy(f,i,"move",a)}async canCopy(f,i,a){return this.doCanMoveCopy(f,i,"copy",a)}async doCanMoveCopy(f,i,a,n){if(f.toString()!==i.toString())try{const o=a==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(f),f):await this.withReadProvider(f),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i);await this.doValidateMoveCopy(o,f,r,i,a,n)}catch(o){return o}return!0}async move(f,i,a){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(f),f),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),r=await this.doMoveCopy(n,f,o,i,"move",!!a),s=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(f,r==="move"?2:3,s)),s}async copy(f,i,a){const n=await this.withReadProvider(f),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),r=await this.doMoveCopy(n,f,o,i,"copy",!!a),s=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(f,r==="copy"?3:2,s)),s}async doMoveCopy(f,i,a,n,o,r){if(i.toString()===n.toString())return o;const{exists:s,isSameResourceWithDifferentPathCase:c}=await this.doValidateMoveCopy(f,i,a,n,o,r);if(s&&!c&&r&&await this.del(n,{recursive:!0}),await this.mkdirp(a,this.getExtUri(a).providerExtUri.dirname(n)),o==="copy"){if(f===a&&(0,y.hasFileFolderCopyCapability)(f))await f.copy(i,n,{overwrite:r});else{const u=await this.resolve(i);u.isDirectory?await this.doCopyFolder(f,u,a,n):await this.doCopyFile(f,i,a,n)}return o}else return f===a?(await f.rename(i,n,{overwrite:r}),o):(await this.doMoveCopy(f,i,a,n,"copy",r),await this.del(i,{recursive:!0}),"copy")}async doCopyFile(f,i,a,n){if((0,y.hasOpenReadWriteCloseCapability)(f)&&(0,y.hasOpenReadWriteCloseCapability)(a))return this.doPipeBuffered(f,i,a,n);if((0,y.hasOpenReadWriteCloseCapability)(f)&&(0,y.hasReadWriteCapability)(a))return this.doPipeBufferedToUnbuffered(f,i,a,n);if((0,y.hasReadWriteCapability)(f)&&(0,y.hasOpenReadWriteCloseCapability)(a))return this.doPipeUnbufferedToBuffered(f,i,a,n);if((0,y.hasReadWriteCapability)(f)&&(0,y.hasReadWriteCapability)(a))return this.doPipeUnbuffered(f,i,a,n)}async doCopyFolder(f,i,a,n){await a.mkdir(n),Array.isArray(i.children)&&await t.Promises.settled(i.children.map(async o=>{const r=this.getExtUri(a).providerExtUri.joinPath(n,o.name);return o.isDirectory?this.doCopyFolder(f,await this.resolve(o.resource),a,r):this.doCopyFile(f,o.resource,a,r)}))}async doValidateMoveCopy(f,i,a,n,o,r){let s=!1;if(f===a){const{providerExtUri:u,isPathCaseSensitive:S}=this.getExtUri(f);if(S||(s=u.isEqual(i,n)),s&&o==="copy")throw new Error((0,C.localize)(14,null,this.resourceForError(i),this.resourceForError(n)));if(!s&&u.isEqualOrParent(n,i))throw new Error((0,C.localize)(15,null,this.resourceForError(i),this.resourceForError(n)))}const c=await this.exists(n);if(c&&!s){if(!r)throw new y.FileOperationError((0,C.localize)(16,null,this.resourceForError(i),this.resourceForError(n)),4);if(f===a){const{providerExtUri:u}=this.getExtUri(f);if(u.isEqualOrParent(i,n))throw new Error((0,C.localize)(17,null,this.resourceForError(i),this.resourceForError(n)))}}return{exists:c,isSameResourceWithDifferentPathCase:s}}getExtUri(f){const i=this.isPathCaseSensitive(f);return{providerExtUri:i?b.extUri:b.extUriIgnorePathCase,isPathCaseSensitive:i}}isPathCaseSensitive(f){return!!(f.capabilities&1024)}async createFolder(f){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(f),f);await this.mkdirp(i,f);const a=await this.resolve(f,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(f,0,a)),a}async mkdirp(f,i){const a=[],{providerExtUri:n}=this.getExtUri(f);for(;!n.isEqual(i,n.dirname(i));)try{if(((await f.stat(i)).type&y.FileType.Directory)==0)throw new Error((0,C.localize)(18,null,this.resourceForError(i)));break}catch(o){if((0,y.toFileSystemProviderErrorCode)(o)!==y.FileSystemProviderErrorCode.FileNotFound)throw o;a.push(n.basename(i)),i=n.dirname(i)}for(let o=a.length-1;o>=0;o--){i=n.joinPath(i,a[o]);try{await f.mkdir(i)}catch(r){if((0,y.toFileSystemProviderErrorCode)(r)!==y.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(f,i){try{await this.doValidateDelete(f,i)}catch(a){return a}return!0}async doValidateDelete(f,i){const a=this.throwIfFileSystemIsReadonly(await this.withProvider(f),f);if(!!i?.useTrash&&!(a.capabilities&4096))throw new Error((0,C.localize)(19,null,this.resourceForError(f)));let o;try{o=await a.stat(f)}catch{}if(o)this.throwIfFileIsReadonly(f,o);else throw new y.FileOperationError((0,C.localize)(20,null,this.resourceForError(f)),1);if(!!!i?.recursive){const s=await this.resolve(f);if(s.isDirectory&&Array.isArray(s.children)&&s.children.length>0)throw new Error((0,C.localize)(21,null,this.resourceForError(f)))}return a}async del(f,i){const a=await this.doValidateDelete(f,i),n=!!i?.useTrash,o=!!i?.recursive;await a.delete(f,{recursive:o,useTrash:n}),this._onDidRunOperation.fire(new y.FileOperationEvent(f,1))}async cloneFile(f,i){const a=await this.withProvider(f),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i);if(a===n&&this.getExtUri(a).providerExtUri.isEqual(f,i))return;if(a===n&&(0,y.hasFileCloneCapability)(a))return a.cloneFile(f,i);await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(i));const o=this.writeQueue.queueFor(f,this.getExtUri(a).providerExtUri);return a===n&&(0,y.hasFileFolderCopyCapability)(a)?o.queue(()=>a.copy(f,i,{overwrite:!0})):o.queue(()=>this.doCopyFile(a,f,n,i))}watch(f,i={recursive:!1,excludes:[]}){const a=new D.DisposableStore;let n=!1,o=()=>{n=!0};return a.add((0,D.toDisposable)(()=>o())),(async()=>{try{const r=await this.doWatch(f,i);n?(0,D.dispose)(r):o=()=>(0,D.dispose)(r)}catch(r){this.logService.error(r)}})(),a}async doWatch(f,i){const a=await this.withProvider(f),n=(0,w.hash)([this.getExtUri(a).providerExtUri.getComparisonKey(f),i]);let o=this.activeWatchers.get(n);return o||(o={count:0,disposable:a.watch(f,i)},this.activeWatchers.set(n,o)),o.count+=1,(0,D.toDisposable)(()=>{o&&(o.count--,o.count===0&&((0,D.dispose)(o.disposable),this.activeWatchers.delete(n)))})}dispose(){super.dispose();for(const[,f]of this.activeWatchers)(0,D.dispose)(f.disposable);this.activeWatchers.clear()}async doWriteBuffered(f,i,a,n){return this.writeQueue.queueFor(i,this.getExtUri(f).providerExtUri).queue(async()=>{const o=await f.open(i,{create:!0,unlock:a?.unlock??!1});try{(0,d.isReadableStream)(n)||(0,d.isReadableBufferedStream)(n)?await this.doWriteStreamBufferedQueued(f,o,n):await this.doWriteReadableBufferedQueued(f,o,n)}catch(r){throw(0,y.ensureFileSystemProviderError)(r)}finally{await f.close(o)}})}async doWriteStreamBufferedQueued(f,i,a){let n=0,o;if((0,d.isReadableBufferedStream)(a)){if(a.buffer.length>0){const r=v.VSBuffer.concat(a.buffer);await this.doWriteBuffer(f,i,r,r.byteLength,n,0),n+=r.byteLength}if(a.ended)return;o=a.stream}else o=a;return new Promise((r,s)=>{(0,d.listenStream)(o,{onData:async c=>{o.pause();try{await this.doWriteBuffer(f,i,c,c.byteLength,n,0)}catch(u){return s(u)}n+=c.byteLength,setTimeout(()=>o.resume())},onError:c=>s(c),onEnd:()=>r()})})}async doWriteReadableBufferedQueued(f,i,a){let n=0,o;for(;(o=a.read())!==null;)await this.doWriteBuffer(f,i,o,o.byteLength,n,0),n+=o.byteLength}async doWriteBuffer(f,i,a,n,o,r){let s=0;for(;s<n;)s+=await f.write(i,o+s,a.buffer,r+s,n-s)}async doWriteUnbuffered(f,i,a,n){return this.writeQueue.queueFor(i,this.getExtUri(f).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(f,i,a,n))}async doWriteUnbufferedQueued(f,i,a,n){let o;n instanceof v.VSBuffer?o=n:(0,d.isReadableStream)(n)?o=await(0,v.streamToBuffer)(n):(0,d.isReadableBufferedStream)(n)?o=await(0,v.bufferedStreamToBuffer)(n):o=(0,v.readableToBuffer)(n),await f.writeFile(i,o.buffer,{create:!0,overwrite:!0,unlock:a?.unlock??!1})}async doPipeBuffered(f,i,a,n){return this.writeQueue.queueFor(n,this.getExtUri(a).providerExtUri).queue(()=>this.doPipeBufferedQueued(f,i,a,n))}async doPipeBufferedQueued(f,i,a,n){let o,r;try{o=await f.open(i,{create:!1}),r=await a.open(n,{create:!0,unlock:!1});const s=v.VSBuffer.alloc(this.BUFFER_SIZE);let c=0,u=0,S=0;do S=await f.read(o,c,s.buffer,u,s.byteLength-u),await this.doWriteBuffer(a,r,s,S,c,u),c+=S,u+=S,u===s.byteLength&&(u=0);while(S>0)}catch(s){throw(0,y.ensureFileSystemProviderError)(s)}finally{await t.Promises.settled([typeof o=="number"?f.close(o):Promise.resolve(),typeof r=="number"?a.close(r):Promise.resolve()])}}async doPipeUnbuffered(f,i,a,n){return this.writeQueue.queueFor(n,this.getExtUri(a).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(f,i,a,n))}async doPipeUnbufferedQueued(f,i,a,n){return a.writeFile(n,await f.readFile(i),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(f,i,a,n){return this.writeQueue.queueFor(n,this.getExtUri(a).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(f,i,a,n))}async doPipeUnbufferedToBufferedQueued(f,i,a,n){const o=await a.open(n,{create:!0,unlock:!1});try{const r=await f.readFile(i);await this.doWriteBuffer(a,o,v.VSBuffer.wrap(r),r.byteLength,0,0)}catch(r){throw(0,y.ensureFileSystemProviderError)(r)}finally{await a.close(o)}}async doPipeBufferedToUnbuffered(f,i,a,n){const o=await(0,v.streamToBuffer)(this.readFileBuffered(f,i,P.CancellationToken.None));await this.doWriteUnbuffered(a,n,void 0,o)}throwIfFileSystemIsReadonly(f,i){if(f.capabilities&2048)throw new y.FileOperationError((0,C.localize)(22,null,this.resourceForError(i)),6);return f}throwIfFileIsReadonly(f,i){if((i.permissions??0)&y.FilePermission.Readonly)throw new y.FileOperationError((0,C.localize)(23,null,this.resourceForError(f)),6)}resourceForError(f){return f.scheme===R.Schemas.file?f.fsPath:f.toString(!0)}};h=Re([_e(0,g.ILogService)],h),e.FileService=h}),define(ve[60],we([0,1,30,269,14,29,16,7,33,2,5,3,19,48,21,171,17,97,205,37,202,201]),function(oe,e,I,t,v,P,k,w,p,D,T,R,E,b,d,C,y,m,g,h,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,t.gracefulify)(I)}catch(a){console.error(`Error enabling graceful-fs: ${(0,h.toErrorMessage)(a)}`)}})();class i extends g.AbstractDiskFileSystemProvider{constructor(n,o){super(n,o);this.onDidChangeCapabilities=w.Event.None,this.resourceLocks=new P.ResourceMap(r=>E.extUriBiasedIgnorePathCase.getComparisonKey(r)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,R.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(n){try{const{stat:o,symbolicLink:r}=await d.SymlinkSupport.stat(this.toFilePath(n));return{type:this.toType(o,r),ctime:o.birthtime.getTime(),mtime:o.mtime.getTime(),size:o.size}}catch(o){throw this.toFileSystemProviderError(o)}}async readdir(n){try{const o=await d.Promises.readdir(this.toFilePath(n),{withFileTypes:!0}),r=[];return await Promise.all(o.map(async s=>{try{let c;s.isSymbolicLink()?c=(await this.stat((0,E.joinPath)(n,s.name))).type:c=this.toType(s),r.push([s.name,c])}catch(c){this.logService.trace(c)}})),r}catch(o){throw this.toFileSystemProviderError(o)}}toType(n,o){let r;return o?.dangling?r=y.FileType.Unknown:n.isFile()?r=y.FileType.File:n.isDirectory()?r=y.FileType.Directory:r=y.FileType.Unknown,o&&(r|=y.FileType.SymbolicLink),r}async createResourceLock(n){const o=this.toFilePath(n);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${o})`);let r;for(;r=this.resourceLocks.get(n);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${o})`),await r.wait();const s=new v.Barrier;return this.resourceLocks.set(n,s),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${o})`),(0,D.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${o})`),this.resourceLocks.get(n)===s&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${o})`),this.resourceLocks.delete(n)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${o})`),s.open()})}async readFile(n,o){let r;try{o?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(n)})`),r=await this.createResourceLock(n));const s=this.toFilePath(n);return await d.Promises.readFile(s)}catch(s){throw this.toFileSystemProviderError(s)}finally{r?.dispose()}}readFileStream(n,o,r){const s=(0,b.newWriteableStream)(c=>k.VSBuffer.concat(c.map(u=>k.VSBuffer.wrap(u))).buffer);return(0,m.readFileIntoStream)(this,n,s,c=>c.buffer,{...o,bufferSize:256*1024},r),s}async writeFile(n,o,r){let s;try{const c=this.toFilePath(n);if(!r.create||!r.overwrite){if(await d.Promises.exists(c)){if(!r.overwrite)throw(0,y.createFileSystemProviderError)((0,C.localize)(0,null),y.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,y.createFileSystemProviderError)((0,C.localize)(1,null),y.FileSystemProviderErrorCode.FileNotFound)}s=await this.open(n,{create:!0,unlock:r.unlock}),await this.write(s,0,o,0,o.byteLength)}catch(c){throw await this.toFileSystemProviderWriteError(n,c)}finally{typeof s=="number"&&await this.close(s)}}async open(n,o){const r=this.toFilePath(n);let s;(0,y.isFileOpenForWriteOptions)(o)&&(s=await this.createResourceLock(n));let c;try{if((0,y.isFileOpenForWriteOptions)(o)&&o.unlock)try{const{stat:S}=await d.SymlinkSupport.stat(r);S.mode&128||await d.Promises.chmod(r,S.mode|128)}catch(S){this.logService.trace(S)}let u;if((0,y.isFileOpenForWriteOptions)(o)){if(R.isWindows)try{await d.Promises.truncate(r,0),u="r+"}catch(S){S.code!=="ENOENT"&&this.logService.trace(S)}u||(u="w")}else u="r";c=await d.Promises.open(r,u)}catch(u){throw s?.dispose(),(0,y.isFileOpenForWriteOptions)(o)?await this.toFileSystemProviderWriteError(n,u):this.toFileSystemProviderError(u)}if(this.mapHandleToPos.set(c,0),(0,y.isFileOpenForWriteOptions)(o)&&this.writeHandles.set(c,n),s){const u=this.mapHandleToLock.get(c);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${c} (${r})`),this.mapHandleToLock.set(c,s),u&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${c} (${r})`),u.dispose())}return c}async close(n){const o=this.mapHandleToLock.get(n);try{if(this.mapHandleToPos.delete(n),this.writeHandles.delete(n)&&this.canFlush)try{await d.Promises.fdatasync(n)}catch(r){this.canFlush=!1,this.logService.error(r)}return await d.Promises.close(n)}catch(r){throw this.toFileSystemProviderError(r)}finally{o&&(this.mapHandleToLock.get(n)===o&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.mapHandleToLock.delete(n)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),o.dispose())}}async read(n,o,r,s,c){const u=this.normalizePos(n,o);let S=null;try{S=(await d.Promises.read(n,r,s,c,u)).bytesRead}catch(A){throw this.toFileSystemProviderError(A)}finally{this.updatePos(n,u,S)}return S}normalizePos(n,o){return o===this.mapHandleToPos.get(n)?null:o}updatePos(n,o,r){const s=this.mapHandleToPos.get(n);typeof s=="number"&&(typeof o=="number"||(typeof r=="number"?this.mapHandleToPos.set(n,s+r):this.mapHandleToPos.delete(n)))}async write(n,o,r,s,c){return(0,v.retry)(()=>this.doWrite(n,o,r,s,c),100,3)}async doWrite(n,o,r,s,c){const u=this.normalizePos(n,o);let S=null;try{S=(await d.Promises.write(n,r,s,c,u)).bytesWritten}catch(A){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(n),A)}finally{this.updatePos(n,u,S)}return S}async mkdir(n){try{await d.Promises.mkdir(this.toFilePath(n))}catch(o){throw this.toFileSystemProviderError(o)}}async delete(n,o){try{const r=this.toFilePath(n);o.recursive?await d.Promises.rm(r,d.RimRafMode.MOVE):await d.Promises.unlink(r)}catch(r){throw this.toFileSystemProviderError(r)}}async rename(n,o,r){const s=this.toFilePath(n),c=this.toFilePath(o);if(s!==c)try{await this.validateTargetDeleted(n,o,"move",r.overwrite),await d.Promises.move(s,c)}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,C.localize)(2,null,(0,T.basename)(s),(0,T.basename)((0,T.dirname)(c)),u.toString()))),this.toFileSystemProviderError(u)}}async copy(n,o,r){const s=this.toFilePath(n),c=this.toFilePath(o);if(s!==c)try{await this.validateTargetDeleted(n,o,"copy",r.overwrite),await d.Promises.copy(s,c,{preserveSymlinks:!0})}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,C.localize)(3,null,(0,T.basename)(s),(0,T.basename)((0,T.dirname)(c)),u.toString()))),this.toFileSystemProviderError(u)}}async validateTargetDeleted(n,o,r,s){const c=this.toFilePath(n),u=this.toFilePath(o);let S=!1;if(!!(this.capabilities&1024)||(S=(0,p.isEqual)(c,u,!0)),S&&r==="copy")throw(0,y.createFileSystemProviderError)((0,C.localize)(4,null),y.FileSystemProviderErrorCode.FileExists);if(!S&&await d.Promises.exists(u)){if(!s)throw(0,y.createFileSystemProviderError)((0,C.localize)(5,null),y.FileSystemProviderErrorCode.FileExists);await this.delete(o,{recursive:!0,useTrash:!1})}}async cloneFile(n,o){return this.doCloneFile(n,o,!1)}async doCloneFile(n,o,r){const s=this.toFilePath(n),c=this.toFilePath(o),u=!!(this.capabilities&1024);if((0,p.isEqual)(s,c,!u))return;const S=new D.DisposableStore;try{const[A,M]=await Promise.all([this.createResourceLock(n),this.createResourceLock(o)]);S.add(A),S.add(M),r&&await d.Promises.mkdir((0,T.dirname)(c),{recursive:!0}),await d.Promises.copyFile(s,c)}catch(A){if(A.code==="ENOENT"&&!r)return this.doCloneFile(n,o,!0);throw this.toFileSystemProviderError(A)}finally{S.dispose()}}createUniversalWatcher(n,o,r){return new l.UniversalWatcherClient(s=>n(s),s=>o(s),r)}createNonRecursiveWatcher(n,o,r){return new f.NodeJSWatcherClient(s=>n(s),s=>o(s),r)}toFileSystemProviderError(n){if(n instanceof y.FileSystemProviderError)return n;let o;switch(n.code){case"ENOENT":o=y.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":o=y.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":o=y.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":o=y.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":o=y.FileSystemProviderErrorCode.NoPermissions;break;default:o=y.FileSystemProviderErrorCode.Unknown}return(0,y.createFileSystemProviderError)(n,o)}async toFileSystemProviderWriteError(n,o){let r=this.toFileSystemProviderError(o);if(n&&r.code===y.FileSystemProviderErrorCode.NoPermissions)try{const{stat:s}=await d.SymlinkSupport.stat(this.toFilePath(n));s.mode&128||(r=(0,y.createFileSystemProviderError)(o,y.FileSystemProviderErrorCode.FileWriteLocked))}catch(s){this.logService.trace(s)}return r}}e.DiskFileSystemProvider=i}),define(ve[206],we([0,1,7,60,2,16,48,20]),function(oe,e,I,t,v,P,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class p extends v.Disposable{constructor(R,E){super();this.provider=R,this.logService=E,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(R,E,b){const d=this.getUriTransformer(R);switch(E){case"stat":return this.stat(d,b[0]);case"readdir":return this.readdir(d,b[0]);case"open":return this.open(d,b[0],b[1]);case"close":return this.close(b[0]);case"read":return this.read(b[0],b[1],b[2]);case"readFile":return this.readFile(d,b[0],b[1]);case"write":return this.write(b[0],b[1],b[2],b[3],b[4]);case"writeFile":return this.writeFile(d,b[0],b[1],b[2]);case"rename":return this.rename(d,b[0],b[1],b[2]);case"copy":return this.copy(d,b[0],b[1],b[2]);case"cloneFile":return this.cloneFile(d,b[0],b[1]);case"mkdir":return this.mkdir(d,b[0]);case"delete":return this.delete(d,b[0],b[1]);case"watch":return this.watch(d,b[0],b[1],b[2],b[3]);case"unwatch":return this.unwatch(b[0],b[1])}throw new Error(`IPC Command ${E} not found`)}listen(R,E,b){const d=this.getUriTransformer(R);switch(E){case"fileChange":return this.onFileChange(d,b[0]);case"readFileStream":return this.onReadFileStream(d,b[0],b[1])}throw new Error(`Unknown event ${E}`)}stat(R,E){const b=this.transformIncoming(R,E,!0);return this.provider.stat(b)}readdir(R,E){const b=this.transformIncoming(R,E);return this.provider.readdir(b)}async readFile(R,E,b){const d=this.transformIncoming(R,E,!0),C=await this.provider.readFile(d,b);return P.VSBuffer.wrap(C)}onReadFileStream(R,E,b){const d=this.transformIncoming(R,E,!0),C=new w.CancellationTokenSource,y=new I.Emitter({onLastListenerRemove:()=>{C.cancel()}}),m=this.provider.readFileStream(d,b,C.token);return(0,k.listenStream)(m,{onData:g=>y.fire(P.VSBuffer.wrap(g)),onError:g=>y.fire(g),onEnd:()=>{y.fire("end"),y.dispose(),C.dispose()}}),y.event}writeFile(R,E,b,d){const C=this.transformIncoming(R,E);return this.provider.writeFile(C,b.buffer,d)}open(R,E,b){const d=this.transformIncoming(R,E,!0);return this.provider.open(d,b)}close(R){return this.provider.close(R)}async read(R,E,b){const d=P.VSBuffer.alloc(b),C=0,y=await this.provider.read(R,E,d.buffer,C,b);return[d,y]}write(R,E,b,d,C){return this.provider.write(R,E,b.buffer,d,C)}mkdir(R,E){const b=this.transformIncoming(R,E);return this.provider.mkdir(b)}delete(R,E,b){const d=this.transformIncoming(R,E);return this.provider.delete(d,b)}rename(R,E,b,d){const C=this.transformIncoming(R,E),y=this.transformIncoming(R,b);return this.provider.rename(C,y,d)}copy(R,E,b,d){const C=this.transformIncoming(R,E),y=this.transformIncoming(R,b);return this.provider.copy(C,y,d)}cloneFile(R,E,b){const d=this.transformIncoming(R,E),C=this.transformIncoming(R,b);return this.provider.cloneFile(d,C)}onFileChange(R,E){const b=new I.Emitter({onFirstListenerAdd:()=>{this.sessionToWatcher.set(E,this.createSessionFileWatcher(R,b))},onLastListenerRemove:()=>{(0,v.dispose)(this.sessionToWatcher.get(E)),this.sessionToWatcher.delete(E)}});return b.event}async watch(R,E,b,d,C){const y=this.sessionToWatcher.get(E);if(y){const m=this.transformIncoming(R,d),g=y.watch(b,m,C);this.watchRequests.set(E+b,g)}}async unwatch(R,E){const b=R+E,d=this.watchRequests.get(b);d&&((0,v.dispose)(d),this.watchRequests.delete(b))}dispose(){super.dispose();for(const[,R]of this.watchRequests)R.dispose();this.watchRequests.clear();for(const[,R]of this.sessionToWatcher)R.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=p;class D extends v.Disposable{constructor(R,E,b,d){super();this.uriTransformer=R,this.logService=b,this.environmentService=d,this.watcherRequests=new Map,this.fileWatcher=this._register(new t.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(E)}registerListeners(R){const E=this._register(new I.Emitter);this._register(E.event(b=>{R.fire(b.map(d=>({resource:this.uriTransformer.transformOutgoingURI(d.resource),type:d.type})))})),this._register(this.fileWatcher.onDidChangeFile(b=>E.fire(b))),this._register(this.fileWatcher.onDidWatchError(b=>R.fire(b)))}getRecursiveWatcherOptions(R){}getExtraExcludes(R){}watch(R,E,b){const d=this.getExtraExcludes(this.environmentService);return Array.isArray(d)&&(b.excludes=[...b.excludes,...d]),this.watcherRequests.set(R,this.fileWatcher.watch(E,b)),(0,v.toDisposable)(()=>{(0,v.dispose)(this.watcherRequests.get(R)),this.watcherRequests.delete(R)})}dispose(){super.dispose();for(const[,R]of this.watcherRequests)R.dispose();this.watcherRequests.clear()}}e.AbstractSessionFileWatcher=D}),define(ve[100],we([0,1,7,4,13]),function(oe,e,I,t,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class P{constructor(E){this.service=E,this.onDidChangeLogLevel=I.Event.buffer(E.onDidChangeLogLevel,!0)}listen(E,b){switch(b){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${b}`)}async call(E,b,d){switch(b){case"setLevel":return this.service.setLevel(d)}throw new Error(`Call not found: ${b}`)}}e.LogLevelChannel=P;class k{constructor(E){this.channel=E}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(E){k.setLevel(this.channel,E)}static setLevel(E,b){return E.call("setLevel",b)}}e.LogLevelChannelClient=k;class w{constructor(E){this.loggerService=E,this.loggers=new Map}listen(E,b){throw new Error(`Event not found: ${b}`)}async call(E,b,d){switch(b){case"createLogger":this.createLogger(t.URI.revive(d[0]),d[1]);return;case"log":return this.log(t.URI.revive(d[0]),d[1]);case"consoleLog":return this.consoleLog(d[0],d[1])}throw new Error(`Call not found: ${b}`)}createLogger(E,b){this.loggers.set(E.toString(),this.loggerService.createLogger(E,b))}consoleLog(E,b){let d=console.log;switch(E){case v.LogLevel.Error:d=console.error;break;case v.LogLevel.Warning:d=console.warn;break;case v.LogLevel.Info:d=console.info;break}d.call(console,...b)}log(E,b){const d=this.loggers.get(E.toString());if(!d)throw new Error("Create the logger before logging");for(const[C,y]of b)(0,v.log)(d,C,y)}}e.LoggerChannel=w;class p extends v.AbstractLoggerService{constructor(E,b,d){super(E,b);this.channel=d}createConsoleMainLogger(){return new v.AdapterLogger({log:(E,b)=>{this.channel.call("consoleLog",[E,b])}})}doCreateLogger(E,b,d){return new D(this.channel,E,b,d)}}e.LoggerChannelClient=p;class D extends v.AbstractMessageLogger{constructor(E,b,d,C){super(C?.always);this.channel=E,this.file=b,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(d),this.channel.call("createLogger",[b,C]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(E,b){const d=[[E,b]];this.isLoggerCreated?this.doLog(d):this.buffer.push(...d)}doLog(E){this.channel.call("log",[this.file,E])}}class T extends v.LogService{constructor(E,b){super(b);this.parent=E,this._register(E.onDidChangeLogLevel(d=>b.setLevel(d)))}setLevel(E){super.setLevel(E),this.parent.setLevel(E)}}e.FollowerLogService=T}),define(ve[101],we([0,1,17,13]),function(oe,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function v(w,p,D,T,R){try{const E=await new Promise((d,C)=>{oe(["spdlog"],d,C)});E.setFlushOn(t.LogLevel.Trace);const b=await E.createAsyncRotatingLogger(w,p,D,T);return R&&b.clearFormatters(),b}catch(E){console.error(E)}return null}function P(w,p,D){switch(p){case t.LogLevel.Trace:w.trace(D);break;case t.LogLevel.Debug:w.debug(D);break;case t.LogLevel.Info:w.info(D);break;case t.LogLevel.Warning:w.warn(D);break;case t.LogLevel.Error:w.error(D);break;case t.LogLevel.Critical:w.critical(D);break;default:throw new Error("Invalid log level")}}class k extends t.AbstractMessageLogger{constructor(p,D,T,R,E){super();this.buffer=[],this.setLevel(E),this._loggerCreationPromise=this._createSpdLogLogger(p,D,T,R),this._register(this.onDidChangeLogLevel(b=>{this._logger?.setLevel(b)}))}async _createSpdLogLogger(p,D,T,R){const E=T?6:1,b=30/E*I.ByteSize.MB,d=await v(p,D,b,E,R);if(d){this._logger=d,this._logger.setLevel(this.getLevel());for(const{level:C,message:y}of this.buffer)P(this._logger,C,y);this.buffer=[]}}log(p,D){this._logger?P(this._logger,p,D):this.getLevel()<=p&&this.buffer.push({level:p,message:D})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=k}),define(ve[207],we([0,1,68,173,6]),function(oe,e,I,t,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var P;(function(p){p[p.Unnecessary=1]="Unnecessary",p[p.Deprecated=2]="Deprecated"})(P=e.MarkerTag||(e.MarkerTag={}));var k;(function(p){p[p.Hint=1]="Hint",p[p.Info=2]="Info",p[p.Warning=4]="Warning",p[p.Error=8]="Error"})(k=e.MarkerSeverity||(e.MarkerSeverity={})),function(p){function D(d,C){return C-d}p.compare=D;const T=Object.create(null);T[p.Error]=(0,t.localize)(0,null),T[p.Warning]=(0,t.localize)(1,null),T[p.Info]=(0,t.localize)(2,null);function R(d){return T[d]||""}p.toString=R;function E(d){switch(d){case I.default.Error:return p.Error;case I.default.Warning:return p.Warning;case I.default.Info:return p.Info;case I.default.Ignore:return p.Hint}}p.fromSeverity=E;function b(d){switch(d){case p.Error:return I.default.Error;case p.Warning:return I.default.Warning;case p.Info:return I.default.Info;case p.Hint:return I.default.Ignore}}p.toSeverity=b}(k=e.MarkerSeverity||(e.MarkerSeverity={}));var w;(function(p){const D="";function T(E){return R(E,!0)}p.makeKey=T;function R(E,b){const d=[D];return E.source?d.push(E.source.replace("\xA6","\\\xA6")):d.push(D),E.code?typeof E.code=="string"?d.push(E.code.replace("\xA6","\\\xA6")):d.push(E.code.value.replace("\xA6","\\\xA6")):d.push(D),E.severity!==void 0&&E.severity!==null?d.push(k.toString(E.severity)):d.push(D),E.message&&b?d.push(E.message.replace("\xA6","\\\xA6")):d.push(D),E.startLineNumber!==void 0&&E.startLineNumber!==null?d.push(E.startLineNumber.toString()):d.push(D),E.startColumn!==void 0&&E.startColumn!==null?d.push(E.startColumn.toString()):d.push(D),E.endLineNumber!==void 0&&E.endLineNumber!==null?d.push(E.endLineNumber.toString()):d.push(D),E.endColumn!==void 0&&E.endColumn!==null?d.push(E.endColumn.toString()):d.push(D),d.push(D),d.join("\xA6")}p.makeKeyOptionalMessage=R})(w=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,v.createDecorator)("markerService")}),define(ve[61],we([0,1,7,47,2,6]),function(oe,e,I,t,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,P.createDecorator)("policy");class k extends v.Disposable{constructor(){super(...arguments);this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new I.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(D){const T=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...D,...this.policyDefinitions},T!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(D),t.Iterable.reduce(this.policies.entries(),(R,[E,b])=>({...R,[E]:b}),{})}getPolicyValue(D){return this.policies.get(D)}serialize(){return t.Iterable.reduce(Object.entries(this.policyDefinitions),(D,[T,R])=>({...D,[T]:{definition:R,value:this.policies.get(T)}}),{})}}e.AbstractPolicyService=k;class w{constructor(){this.onDidChange=I.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=w}),define(ve[52],we([0,1,10,3,28,19]),function(oe,e,I,t,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let k;if(typeof t.globals.vscode!="undefined"&&typeof t.globals.vscode.context!="undefined"){const w=t.globals.vscode.context.configuration();if(w)k=w.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof oe?.__$__nodeRequire=="function"){const w=(0,P.dirname)(I.FileAccess.asFileUri("",oe));k=oe.__$__nodeRequire((0,P.joinPath)(w,"product.json").fsPath);const p=oe.__$__nodeRequire((0,P.joinPath)(w,"package.json").fsPath);v.env.VSCODE_DEV&&Object.assign(k,{nameShort:`${k.nameShort} Dev`,nameLong:`${k.nameLong} Dev`,dataFolderName:`${k.dataFolderName}-dev`,serverDataFolderName:k.serverDataFolderName?`${k.serverDataFolderName}-dev`:void 0}),Object.assign(k,{version:p.version})}else k={nameShort:"Code",nameLong:"Visual Studio Code",applicationName:"code",win32AppId:"{{F8A2A208-72B3-4D61-95FC-8A65D340689B}",win32x64AppId:"{{EA457B21-F73E-494C-ACAB-524FDE069978}",win32arm64AppId:"{{A5270FC5-65AD-483E-AC30-2C276B63D0AC}",win32UserAppId:"{{D628A17A-9713-46BF-8D57-E671B46A741E}",win32x64UserAppId:"{{771FD6B0-FA20-440A-A002-3B3BAC16DC50}",win32arm64UserAppId:"{{D9E514E7-1A56-452D-9337-2990C0DC4310}",win32NameVersion:"Microsoft Visual Studio Code",win32DirName:"Microsoft VS Code",win32SetupExeBasename:"VSCodeSetup",win32AppUserModelId:"Microsoft.VisualStudioCode",win32ShellNameShort:"Code",win32MutexName:"vscode",win32RegValueName:"VSCode",darwinCredits:"resources/darwin/Credits.rtf",darwinBundleIdentifier:"com.microsoft.VSCode",darwinExecutable:"VSCode",linuxIconName:"com.visualstudio.code",licenseFileName:"LICENSE.rtf",licenseName:"Multiple, see https://code.visualstudio.com/license",serverLicense:["*","* Visual Studio Code Server","*","* By using the software, you agree to","* the Visual Studio Code Server License Terms (https://aka.ms/vscode-server-license) and","* the Microsoft Privacy Statement (https://privacy.microsoft.com/en-US/privacystatement).","*"],serverLicensePrompt:"Do you accept the terms in the License Agreement (Y/n)?",serverApplicationName:"code-server",urlProtocol:"vscode",dataFolderName:".vscode",serverDataFolderName:".vscode-server",downloadUrl:"https://code.visualstudio.com",updateUrl:"https://update.code.visualstudio.com",webEndpointUrl:"https://main.vscode-cdn.net",webEndpointUrlTemplate:"https://{{uuid}}.vscode-cdn.net/{{quality}}/{{commit}}",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/{{quality}}/{{commit}}/out/vs/workbench/contrib/webview/browser/pre/",quality:"stable",extensionsGallery:{nlsBaseUrl:"https://www.vscode-unpkg.net/_lp/",serviceUrl:"https://marketplace.visualstudio.com/_apis/public/gallery",cacheUrl:"https://vscode.blob.core.windows.net/gallery/index",itemUrl:"https://marketplace.visualstudio.com/items",publisherUrl:"https://marketplace.visualstudio.com/publishers",resourceUrlTemplate:"https://{publisher}.vscode-unpkg.net/{publisher}/{name}/{version}/{path}",controlUrl:"https://az764295.vo.msecnd.net/extensions/marketplace.json",recommendationsUrl:"https://az764295.vo.msecnd.net/extensions/workspaceRecommendations.json.gz"},extensionTips:{"ms-dotnettools.csharp":"{**/*.cs,**/project.json,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln,**/appsettings.json}","firefox-devtools.vscode-firefox-debug":"{**/*.ts,**/*.tsx,**/*.js,**/*.jsx,**/*.es6,**/.babelrc}","ms-edgedevtools.vscode-edge-devtools":"{**/*.ts,**/*.tsx,**/*.js,**/*.css,**/*.html}","golang.Go":"**/*.go","ms-vscode.PowerShell":"{**/*.ps1,**/*.psd1,**/*.psm1,**/*.ps.config,**/*.ps1.config}","Ionide.Ionide-fsharp":"{**/*.fsx,**/*.fsi,**/*.fs,**/*.ml,**/*.mli}","dbaeumer.vscode-eslint":"{**/*.js,**/*.jsx,**/*.es6,**/.eslintrc.*,**/.eslintrc,**/.babelrc,**/jsconfig.json}","ms-vscode.vscode-typescript-tslint-plugin":"{**/tslint.json}","bmewburn.vscode-intelephense-client":"{**/*.php,**/php.ini}","xdebug.php-debug":"{**/*.php,**/php.ini}","rust-lang.rust-analyzer":"{**/*.rs,**/*.rslib}","ms-vscode.cpptools-extension-pack":"{**/*.c,**/*.cpp,**/*.cc,**/.cxx,**/*.hh,**/*.hpp,**/*.hxx,**/*.h}","DavidAnson.vscode-markdownlint":"{**/*.md}","ms-azuretools.vscode-docker":"{**/dockerfile,**/Dockerfile,**/docker-compose.yml,**/docker-compose.*.yml,**/*.cs,**/project.json,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln,**/appsettings.json,**/*.py,**/*.ipynb,**/*.js,**/*.ts,**/package.json}","EditorConfig.EditorConfig":"{**/.editorconfig}","HookyQR.beautify":"{**/.jsbeautifyrc}","donjayamanne.githistory":"{**/.gitignore,**/.git}","felipecaputo.git-project-manager":"{**/.gitignore,**/.git}","eamodio.gitlens":"{**/.gitignore,**/.git}","rebornix.Ruby":"{**/*.rb,**/*.erb,**/*.reek,**/.fasterer.yml,**/ruby-lint.yml,**/.rubocop.yml}","DotJoshJohnson.xml":"{**/*.xml}","stylelint.vscode-stylelint":"{**/.stylelintrc,**/stylelint.config.js}","eg2.vscode-npm-script":"{**/package.json}","ms-mssql.mssql":"{**/*.sql}","mtxr.sqltools":"{**/*.sql}","usqlextpublisher.usql-vscode-ext":"{**/*.usql}","ms-vscode.sublime-keybindings":"{**/.sublime-project,**/.sublime-workspace}","k--kato.intellij-idea-keybindings":"{**/.idea}","christian-kohler.npm-intellisense":"{**/package.json}","vue.volar":"{**/*.vue}","ms-python.python":"{**/*.py,**/*.ipynb}","ms-toolsai.jupyter":"{**/*.ipynb}","cake-build.cake-vscode":"{**/build.cake}","Angular.ng-template":"{**/.angular-cli.json,**/angular.json,**/*.ng.html,**/*.ng,**/*.ngml}","vscjava.vscode-maven":"**/pom.xml","ms-azuretools.vscode-azureterraform":"**/*.tf","HashiCorp.terraform":"**/*.tf","vsciot-vscode.vscode-arduino":"**/*.ino","ms-kubernetes-tools.vscode-kubernetes-tools":"{**/Chart.yaml}","GoogleCloudTools.cloudcode":"{**/skaffold.yaml}","Oracle.oracledevtools":"{**/*.sql}","ms-vscode.vscode-github-issue-notebooks":"{**/*.github-issues}","REditorSupport.r":"**/*.r"},extensionImportantTips:{"ms-dotnettools.csharp":{name:"C#",languages:["csharp"],pattern:"{**/*.cs,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln}"},"ms-python.python":{name:"Python",languages:["python"],pattern:"{**/*.py}"},"ms-toolsai.jupyter":{name:"Jupyter",pattern:"{**/*.ipynb}"},"golang.Go":{name:"Go",languages:["go"],pattern:"**/*.go"},"vscjava.vscode-java-pack":{name:"Java",languages:["java"],pattern:"{**/*.java}",isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]},"ms-vscode.PowerShell":{name:"PowerShell",languages:["powershell"],pattern:"{**/*.ps1,**/*.psd1,**/*.psm1}"},"ms-vscode.cpptools-extension-pack":{name:"C/C++",languages:["c","cpp"],pattern:"{**/*.c,**/*.cpp,**/*.cc,**/.cxx,**/*.hh,**/*.hpp,**/*.hxx,**/*.h}"},"ms-azuretools.vscode-docker":{name:"Docker",languages:["dockerfile"],pattern:"{**/dockerfile,**/Dockerfile,**/docker-compose.yml,**/docker-compose.*.yml}"},"vue.volar":{name:"Vetur",languages:["vue"],pattern:"{**/*.vue}"},"ms-vscode.makefile-tools":{name:"Makefile Tools",languages:["makefile"],pattern:"{**/makefile,**/Makefile}"},"ms-vscode.cmake-tools":{name:"CMake Tools",pattern:"{**/CMakeLists.txt}"},"ms-azure-devops.azure-pipelines":{name:"Azure Pipelines",pattern:"{**/azure-pipelines.yaml}"},"msazurermtools.azurerm-vscode-tools":{name:"Azure Resource Manager",pattern:"{**/azuredeploy.json}"},"ms-vscode-remote.remote-containers":{name:"Remote - Containers",pattern:"{**/devcontainer.json}"},"ms-azuretools.vscode-bicep":{name:"Bicep",pattern:"{**/*.bicep}"},"svelte.svelte-vscode":{name:"Svelte",pattern:"{**/*.svelte}"},"ms-vscode.vscode-github-issue-notebooks":{name:"GitHub Issue Notebooks",pattern:"{**/*.github-issues}"},"ms-playwright.playwright":{name:"Playwright",pattern:"{**/*playwright*.config.ts,**/*playwright*.config.js,**/*playwright*.config.mjs}"},"REditorSupport.r":{name:"R",languages:["r"],pattern:"{**/*.r}"}},keymapExtensionTips:["vscodevim.vim","ms-vscode.sublime-keybindings","ms-vscode.atom-keybindings","ms-vscode.brackets-keybindings","ms-vscode.vs-keybindings","ms-vscode.notepadplusplus-keybindings","k--kato.intellij-idea-keybindings","lfs.vscode-emacs-friendly","alphabotsec.vscode-eclipse-keybindings","alefragnani.delphi-keybindings"],languageExtensionTips:["ms-python.python","ms-vscode.cpptools-extension-pack","ms-dotnettools.csharp","ms-toolsai.jupyter","vscjava.vscode-java-pack","ecmel.vscode-html-css","vue.volar","bmewburn.vscode-intelephense-client","dsznajder.es7-react-js-snippets","golang.go","ms-vscode.powershell","dart-code.dart-code","rust-lang.rust-analyzer","rebornix.ruby"],configBasedExtensionTips:{git:{configPath:".git/config",configName:"Git",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",remotes:["github.com"]},"eamodio.gitlens":{name:"GitLens"}}},devContainer:{configPath:".devcontainer/devcontainer.json",configName:"Dev Container",recommendations:{"ms-vscode-remote.remote-containers":{name:"Remote - Containers",important:!0}}},maven:{configPath:"pom.xml",configName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]},"Pivotal.vscode-boot-dev-pack":{name:"Spring Boot Extension Pack",isExtensionPack:!0}}},gradle:{configPath:"build.gradle",configName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}}},"github-pull-request":{configPath:".vscode/.github-pull-request.rec",configName:"GitHub",configScheme:"vscode-vfs",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",important:!0}}}},exeBasedExtensionTips:{az:{friendlyName:"Azure CLI",windowsPath:"%ProgramFiles(x86)%\\Microsoft SDKs\\Azure\\CLI2\\wbin\\az.cmd",recommendations:{"ms-vscode.azurecli":{name:"Azure CLI Tools"}}},heroku:{friendlyName:"Heroku CLI",windowsPath:"%ProgramFiles%\\Heroku\\bin\\heroku.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"pkosta2005.heroku-command":{name:"heroku-cli"}}},mongo:{friendlyName:"Mongo",windowsPath:"%ProgramFiles%\\MongoDB\\Server\\3.6\\bin\\mongod.exe",recommendations:{"ms-azuretools.vscode-cosmosdb":{name:"Azure Databases"}}},serverless:{friendlyName:"Serverless framework",windowsPath:"%APPDATA%\\npm\\serverless.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},func:{friendlyName:"Azure Function SDK",windowsPath:"%APPDATA%\\npm\\func.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},mysql:{friendlyName:"MySQL",windowsPath:"%ProgramFiles%\\MySQL\\MySQL Server 8.0\\bin\\mysqld.exe",recommendations:{"mtxr.sqltools":{name:"SQLTools"}}},postgres:{friendlyName:"PostgreSQL",windowsPath:"%ProgramFiles%\\PostgreSQL\\11\\bin\\psql.exe",recommendations:{"ms-ossdata.vscode-postgresql":{name:"PostgreSQL"},"mtxr.sqltools":{name:"SQLTools"}}},sqlcmd:{friendlyName:"SQL CLI",recommendations:{"ms-mssql.mssql":{name:"SQL Server (mssql)"}}},now:{friendlyName:"Now CLI",windowsPath:"%APPDATA%\\npm\\now.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"ms-azuretools.vscode-docker":{name:"Docker"}}},docker:{friendlyName:"Docker",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\docker.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker",important:!0},"ms-vscode-remote.remote-containers":{name:"Remote - Containers",important:!0},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},kubectl:{friendlyName:"Kubernetes",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\kubectl.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"ms-vscode-remote.remote-containers":{name:"Remote - Containers"}}},ng:{friendlyName:"Angular CLI",windowsPath:"%APPDATA%\\npmexit\\ng.cmd",recommendations:{"johnpapa.Angular2":{name:"Angular Snippets"}}},"create-react-app":{friendlyName:"Create React App",windowsPath:"%APPDATA%\\npm\\create-react-app.cmd",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},"react-native":{friendlyName:"React Native",windowsPath:"%APPDATA%\\npm\\react-native-cli",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},p4:{friendlyName:"Perforce",recommendations:{"slevesque.perforce":{name:"Perforce for VS Code"}}},hg:{friendlyName:"Mercurial",recommendations:{"mrcrowl.hg":{name:"Hg"}}},git:{friendlyName:"Git",windowsPath:"%ProgramFiles%\\Git\\git-bash.exe",recommendations:{"eamodio.gitlens":{name:"GitLens"}}},svn:{friendlyName:"Subversion",windowsPath:"%ProgramFiles%\\TortoiseSVN\\bin\\TortoiseProc.exe",recommendations:{"johnstoncode.svn-scm":{name:"SVN"}}},subl:{friendlyName:"Sublime",windowsPath:"%ProgramFiles%\\Sublime Text3\\sublime_text.exe",recommendations:{"ms-vscode.sublime-keybindings":{name:"Sublime Text Keymap and Settings Importer"}}},atom:{friendlyName:"Atom",windowsPath:"%USERPROFILE%\\AppData\\Local\\atom\\bin\\atom.cmd",recommendations:{"ms-vscode.atom-keybindings":{name:"Atom Keymap"}}},brackets:{friendlyName:"Brackets",windowsPath:"%ProgramFiles(x86)%\\Brackets\\Brackets.exe",recommendations:{"ms-vscode.brackets-keybindings":{name:"Brackets Keymap"}}},notepadplusplus:{friendlyName:"Notepad++",windowsPath:"%ProgramFiles%\\Notepad++\\Notepad++.exe",recommendations:{"ms-vscode.notepadplusplus-keybindings":{name:"Notepad++ keymap"}}},vi:{friendlyName:"VIM",windowsPath:"%ProgramFiles(x86)%\\Vim\\vim80\\gvim.exe",recommendations:{"vscodevim.vim":{name:"Vim"}}},mvn:{friendlyName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}}},gradle:{friendlyName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}}},"Microsoft Edge":{friendlyName:"Microsoft Edge",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Dev":{friendlyName:"Microsoft Edge Dev",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Dev\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Beta":{friendlyName:"Microsoft Edge Beta",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Beta\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Canary":{friendlyName:"Microsoft Edge Canary",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge SxS\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Mozilla Firefox (x86)":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles(x86)%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition (x86)":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles(x86)%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},cordova:{friendlyName:"Cordova",windowsPath:"%APPDATA%\\npm\\cordova",recommendations:{"msjsdiag.cordova-tools":{name:"Cordova Tools"}}},gcloud:{friendlyName:"Google GCloud CLI",windowsPath:"%ProgramFiles(x86)%\\Google\\Cloud SDK\\google-cloud-sdk\\bin\\gcloud.cmd",recommendations:{"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},skaffold:{friendlyName:"Skaffold Code to Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},minikube:{friendlyName:"MiniKube Local Kubernetes Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"ms-vscode-remote.remote-containers":{name:"Remote - Containers"}}},podman:{friendlyName:"Podman",recommendations:{"ms-vscode-remote.remote-containers":{name:"Remote - Containers"}}},wsl:{friendlyName:"Windows Subsystem for Linux (WSL)",windowsPath:"%WINDIR%\\system32\\lxss\\LxssManager.dll",important:!0,recommendations:{"ms-vscode-remote.remote-wsl":{name:"Remote - WSL",important:!0}}}},webExtensionTips:["tyriar.luna-paint","codespaces-contrib.codeswing","ms-vscode.vscode-github-issue-notebooks","esbenp.prettier-vscode","hediet.vscode-drawio"],remoteExtensionTips:{wsl:{friendlyName:"Remote - WSL",extensionId:"ms-vscode-remote.remote-wsl"},"ssh-remote":{friendlyName:"Remote - SSH",extensionId:"ms-vscode-remote.remote-ssh"},"dev-container":{friendlyName:"Remote - Containers",extensionId:"ms-vscode-remote.remote-containers"},"attached-container":{friendlyName:"Remote - Containers",extensionId:"ms-vscode-remote.remote-containers"},vsonline:{friendlyName:"Visual Studio Online",extensionId:"ms-vsonline.vsonline"}},extensionKeywords:{md:["Markdown"],js:["JavaScript"],jsx:["JavaScript"],es6:["JavaScript"],html:["Html"],ts:["TypeScript"],tsx:["TypeScript"],css:["CSS"],scss:["SASS"],txt:["Text"],php:["PHP"],php3:["PHP"],php4:["PHP"],ph3:["PHP"],ph4:["PHP"],xml:["XML"],py:["Python"],pyc:["Python"],pyd:["Python"],pyo:["Python"],pyw:["Python"],pyz:["Python"],java:["Java"],class:["Java"],jar:["Java"],c:["c","objective c","objective-c"],m:["objective c","objective-c"],mm:["objective c","objective-c"],cpp:["cpp","c plus plus","c","c++"],cc:["cpp","c plus plus","c","c++"],cxx:["cpp","c plus plus","c++"],hh:["cpp","c plus plus","c++"],hpp:["cpp","c++"],h:["cpp","c plus plus","c++","c","objective c","objective-c"],sql:["sql"],sh:["bash"],bash:["bash"],zsh:["bash","zshell"],cs:["c#","csharp"],csproj:["c#","csharp"],sln:["c#","csharp"],go:["go"],sty:["latex"],tex:["latex"],ps:["powershell"],ps1:["powershell"],rs:["rust"],rslib:["rust"],hs:["haskell"],lhs:["haskell"],scm:["scheme"],ss:["scheme"],clj:["clojure"],cljs:["clojure"],cljc:["clojure"],edn:["clojure"],erl:["erlang"],hrl:["erlang"],scala:["scala"],sc:["scala"],pl:["perl"],pm:["perl"],t:["perl"],pod:["perl"],groovy:["groovy"],swift:["swift"],rb:["ruby"],rbw:["ruby"],jl:["julia"],f:["fortran"],for:["fortran"],f90:["fortran"],f95:["fortran"],coffee:["CoffeeScript"],litcoffee:["CoffeeScript"],yaml:["yaml"],yml:["yaml"],dart:["dart"],json:["json"]},extensionAllowedBadgeProviders:["api.bintray.com","api.travis-ci.com","api.travis-ci.org","app.fossa.io","badge.buildkite.com","badge.fury.io","badge.waffle.io","badgen.net","badges.frapsoft.com","badges.gitter.im","badges.greenkeeper.io","cdn.travis-ci.com","cdn.travis-ci.org","ci.appveyor.com","circleci.com","cla.opensource.microsoft.com","codacy.com","codeclimate.com","codecov.io","coveralls.io","david-dm.org","deepscan.io","dev.azure.com","docs.rs","flat.badgen.net","gemnasium.com","githost.io","gitlab.com","godoc.org","goreportcard.com","img.shields.io","isitmaintained.com","marketplace.visualstudio.com","nodesecurity.io","opencollective.com","snyk.io","travis-ci.com","travis-ci.org","visualstudio.com","vsmarketplacebadge.apphb.com","www.bithound.io","www.versioneye.com"],extensionAllowedBadgeProvidersRegex:["^https:\\/\\/github\\.com\\/[^/]+\\/[^/]+\\/(actions\\/)?workflows\\/.*badge\\.svg"],crashReporter:{productName:"VSCode",companyName:"Microsoft"},appCenter:{"win32-ia32":"appcenter://code?aid=f4289815-a66e-4ad9-b74f-d8e5bc093e41","win32-x64":"appcenter://code?aid=a4e3233c-699c-46ec-b4f4-9c2a77254662","win32-arm64":"appcenter://code?aid=3712d786-7cc8-4f11-8b08-cc12eab6d4f7","linux-x64":"appcenter://code?aid=fba07a4d-84bd-4fc8-a125-9640fc8ce171",darwin:"appcenter://code?aid=860d6632-f65b-490b-85a8-3e72944f7774","darwin-arm64":"appcenter://code?aid=be71415d-3893-4ae5-b453-e537b9668a10","darwin-universal":"appcenter://code?aid=de75e3cc-e22f-4f42-a03f-1409c21d8af8"},enableTelemetry:!0,aiConfig:{asimovKey:"AIF-444c3af9-8e69-4462-ab49-4191e6ad1916",ariaKey:"5bbf946d11a54f6783919c455abaddaf-fd62977b-c92d-4714-a45d-649d06980372-7168"},msftInternalDomains:["redmond.corp.microsoft.com","northamerica.corp.microsoft.com","fareast.corp.microsoft.com","ntdev.corp.microsoft.com","wingroup.corp.microsoft.com","southpacific.corp.microsoft.com","wingroup.windeploy.ntdev.microsoft.com","ddnet.microsoft.com","europe.corp.microsoft.com"],sendASmile:{reportIssueUrl:"https://go.microsoft.com/fwlink/?LinkId=534872",requestFeatureUrl:"https://go.microsoft.com/fwlink/?LinkID=533482"},documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",releaseNotesUrl:"https://go.microsoft.com/fwlink/?LinkID=533483#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",twitterUrl:"https://go.microsoft.com/fwlink/?LinkID=533687",requestFeatureUrl:"https://go.microsoft.com/fwlink/?LinkID=533482",reportIssueUrl:"https://github.com/Microsoft/vscode/issues/new",reportMarketplaceIssueUrl:"https://github.com/microsoft/vsmarketplace/issues/new",licenseUrl:"https://go.microsoft.com/fwlink/?LinkID=533485",privacyStatementUrl:"https://go.microsoft.com/fwlink/?LinkId=786907",showTelemetryOptOut:!0,npsSurveyUrl:"https://aka.ms/vscode-nps",cesSurveyUrl:"https://aka.ms/new-to-vscode-feedback",checksumFailMoreInfoUrl:"https://go.microsoft.com/fwlink/?LinkId=828886",electronRepository:"Microsoft/vscode-electron-prebuilt",settingsSearchUrl:"https://bingsettingssearch.trafficmanager.net/api/Search",surveys:[{surveyId:"cpp.1",surveyUrl:"https://www.research.net/r/VBVV6C6",languageId:"cpp",editCount:10,userProbability:.15},{surveyId:"java.2",surveyUrl:"https://www.research.net/r/vscodejava",languageId:"java",editCount:10,userProbability:.3},{surveyId:"javascript.1",surveyUrl:"https://www.research.net/r/vscode-js",languageId:"javascript",editCount:10,userProbability:.05},{surveyId:"typescript.1",surveyUrl:"https://www.research.net/r/vscode-ts",languageId:"typescript",editCount:10,userProbability:.05}],extensionEnabledApiProposals:{"ms-vscode.vscode-selfhost-test-provider":["testObserver"],"VisualStudioExptTeam.vscodeintellicode-completions":["inlineCompletionsNew","inlineCompletionsAdditions"],"ms-vsliveshare.vsliveshare":["contribMenuBarHome","diffCommand","documentFiltersExclusive","fileSearchProvider","findTextInFiles","notebookCellExecutionState","notebookContentProvider","notebookEditor","notebookEditorEdit","notebookLiveShare","notebookWorkspaceEdit","terminalDimensions","terminalDataWriteEvent","textSearchProvider"],"ms-vscode.js-debug":["portsAttributes","findTextInFiles","workspaceTrust","resolvers"],"ms-toolsai.vscode-ai-remote":["resolvers","notebookEditor"],"ms-python.python":["quickPickSortByLabel","testObserver","notebookEditor"],"ms-dotnettools.dotnet-interactive-vscode":["notebookCellExecutionState","notebookControllerKind","notebookDebugOptions","notebookEditor","notebookLiveShare","notebookMessaging","notebookMime","notebookWorkspaceEdit"],"GitHub.codespaces":["contribMenuBarHome","contribRemoteHelp","contribViewsRemote","notebookEditor","resolvers","terminalDataWriteEvent","treeViewReveal"],"ms-vscode.azure-repos":["extensionRuntime","fileSearchProvider","textSearchProvider"],"ms-vscode.remote-repositories":["contribEditSessions","contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","documentFiltersExclusive","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","scmSelectedProvider","scmValidation","textSearchProvider","timeline","notebookEditor"],"ms-vscode.remote-server":["resolvers"],"ms-vscode-remote.remote-wsl":["resolvers","contribViewsRemote","telemetry"],"ms-vscode-remote.remote-ssh":["resolvers","terminalDataWriteEvent","contribViewsRemote","telemetry"],"ms-vscode-remote.remote-containers":["resolvers","workspaceTrust","terminalDimensions","contribViewsRemote"],"ms-vscode.js-debug-nightly":["portsAttributes","findTextInFiles","workspaceTrust","resolvers"],"ms-vscode.lsif-browser":["documentFiltersExclusive"],"GitHub.vscode-pull-request-github":["tokenInformation","commentsResolvedState"],"GitHub.copilot":["inlineCompletionsNew","inlineCompletionsAdditions"],"GitHub.copilot-nightly":["inlineCompletionsNew","inlineCompletionsAdditions"],"GitHub.remotehub":["contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","documentFiltersExclusive","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","scmSelectedProvider","scmValidation","textSearchProvider","timeline","notebookEditor"],"GitHub.remotehub-insiders":["contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","documentFiltersExclusive","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","scmSelectedProvider","scmValidation","textSearchProvider","timeline","notebookEditor"],"ms-python.gather":["notebookEditor","notebookCellExecutionState"],"ms-python.vscode-pylance":["notebookEditor","notebookCellExecutionState"],"ms-toolsai.jupyter":["notebookControllerKind","notebookDebugOptions","notebookDeprecated","notebookEditor","notebookWorkspaceEdit","notebookMessaging","notebookMime","notebookCellExecutionState","portsAttributes","quickPickSortByLabel","notebookKernelSource"],"ms-toolsai.vscode-jupyter-powertoys":["notebookEditor","notebookEditorEdit","notebookWorkspaceEdit"],"dbaeumer.vscode-eslint":["notebookEditor","notebookCellExecutionState"],"ms-vscode.azure-sphere-tools-ui":["resolvers"],"ms-azuretools.vscode-azureappservice":["terminalDataWriteEvent"],"ms-vscode.anycode":["extensionsAny"],"ms-vscode.cpptools":["terminalDataWriteEvent"]},tasConfig:{endpoint:"https://default.exp-tas.com/vscode/ab",telemetryEventName:"query-expfeature",featuresTelemetryPropertyName:"VSCode.ABExp.Features",assignmentContextTelemetryPropertyName:"abexp.assignmentcontext"},experimentsUrl:"https://vscodeexperiments.azureedge.net/experiments/vscode-experiments.json",extensionKind:{"Shan.code-settings-sync":["ui"],"shalldie.background":["ui"],"techer.open-in-browser":["ui"],"CoenraadS.bracket-pair-colorizer-2":["ui"],"CoenraadS.bracket-pair-colorizer":["ui","workspace"],"hiro-sun.vscode-emacs":["ui","workspace"],"hnw.vscode-auto-open-markdown-preview":["ui","workspace"],"wayou.vscode-todo-highlight":["ui","workspace"],"aaron-bond.better-comments":["ui","workspace"],"vscodevim.vim":["ui"],"ollyhayes.colmak-vim":["ui"]},extensionPointExtensionKind:{typescriptServerPlugins:["workspace"]},extensionSyncedKeys:{"ritwickdey.liveserver":["liveServer.setup.version"]},extensionVirtualWorkspacesSupport:{"esbenp.prettier-vscode":{default:!1},"msjsdiag.debugger-for-chrome":{default:!1},"redhat.java":{default:!1},"HookyQR.beautify":{default:!1},"ritwickdey.LiveServer":{default:!1},"VisualStudioExptTeam.vscodeintellicode":{default:!1},"octref.vetur":{default:!1},"formulahendry.code-runner":{default:!1},"xdebug.php-debug":{default:!1},"ms-mssql.mssql":{default:!1},"christian-kohler.path-intellisense":{default:!1},"eg2.tslint":{default:!1},"eg2.vscode-npm-script":{default:!1},"donjayamanne.githistory":{default:!1},"Zignd.html-css-class-completion":{default:!1},"christian-kohler.npm-intellisense":{default:!1},"EditorConfig.EditorConfig":{default:!1},"austin.code-gnu-global":{default:!1},"johnpapa.Angular2":{default:!1},"ms-vscode.vscode-typescript-tslint-plugin":{default:!1},"DotJoshJohnson.xml":{default:!1},"techer.open-in-browser":{default:!1},"tht13.python":{default:!1},"bmewburn.vscode-intelephense-client":{default:!1},"Angular.ng-template":{default:!1},"xdebug.php-pack":{default:!1},"dbaeumer.jshint":{default:!1},"yzhang.markdown-all-in-one":{default:!1},"Dart-Code.flutter":{default:!1},"streetsidesoftware.code-spell-checker":{default:!1},"rebornix.Ruby":{default:!1},"ms-vscode.sublime-keybindings":{default:!1},"mitaki28.vscode-clang":{default:!1},"steoates.autoimport":{default:!1},"donjayamanne.python-extension-pack":{default:!1},"shd101wyy.markdown-preview-enhanced":{default:!1},"mikestead.dotenv":{default:!1},"pranaygp.vscode-css-peek":{default:!1},"ikappas.phpcs":{default:!1},"platformio.platformio-ide":{default:!1},"jchannon.csharpextensions":{default:!1},"gruntfuggly.todo-tree":{default:!1}},linkProtectionTrustedDomains:["https://*.visualstudio.com","https://*.microsoft.com","https://aka.ms","https://*.gallerycdn.vsassets.io","https://github.com/microsoft/","https://github.com/MicrosoftDocs/","https://login.microsoftonline.com"],auth:{loginUrl:"https://login.microsoftonline.com/common/oauth2/authorize",tokenUrl:"https://login.microsoftonline.com/common/oauth2/token",redirectUrl:"https://vscode-redirect.azurewebsites.net/",clientId:"aebc6443-996d-45c2-90f0-388ff96faa56"},"configurationSync.store":{url:"https://vscode-sync.trafficmanager.net/",stableUrl:"https://vscode-sync.trafficmanager.net/",insidersUrl:"https://vscode-sync-insiders.trafficmanager.net/",canSwitch:!1,authenticationProviders:{microsoft:{scopes:["openid","profile","email","offline_access"]},github:{scopes:["user:email"]}}},"sessionSync.store":{url:"https://vscode-sync.trafficmanager.net/",authenticationProviders:{microsoft:{scopes:["openid","profile","email","offline_access"]},github:{scopes:["user:email"]}}},builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.0.18",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.69.0",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.2",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode-remote.remote-wsl-recommender",version:"0.0.15",repo:"https://github.com/microsoft/vscode-remote-wsl-recommender",metadata:{id:"cb296d3c-017a-4dee-83af-ebb5a5a16e9a",publisherId:{publisherId:"ac9410a2-0d75-40ec-90de-b59bb705801d",publisherName:"ms-vscode-remote",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"},platforms:["win32"],clientOnly:!0}],version:"1.69.1",commit:"b06ae3b2d2dbfe28bca3134cc6be65935cdfea6a",date:"2022-07-12T08:08:34.173Z"},Object.keys(k).length===0&&Object.assign(k,{version:"1.67.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=k}),define(ve[25],we([0,1,6]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,I.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ve[208],we([0,1,72,13,24,25,204]),function(oe,e,I,t,v,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsWebMainService=void 0;let w=class extends k.BaseCredentialsMainService{constructor(D,T,R){super(D);this.environmentMainService=T,this.productService=R}async getSecretStoragePrefix(){return Promise.resolve(`${this.productService.urlProtocol}-server`)}async withKeytar(){if(this._keytarCache)return this._keytarCache;if(this.environmentMainService.disableKeytar)return this.logService.info("Keytar is disabled. Using in-memory credential store instead."),this._keytarCache=new I.InMemoryCredentialsProvider,this._keytarCache;try{this._keytarCache=await new Promise((D,T)=>{oe(["keytar"],D,T)}),await this._keytarCache.findCredentials("test-keytar-loads")}catch(D){this.logService.warn(`Using the in-memory credential store as the operating system's credential store could not be accessed. Please see https://aka.ms/vscode-server-keyring on how to set this up. Details: ${D.message??D}`),this._keytarCache=new I.InMemoryCredentialsProvider}return this._keytarCache}};w=Re([_e(0,t.ILogService),_e(1,v.INativeEnvironmentService),_e(2,P.IProductService)],w),e.CredentialsWebMainService=w}),define(ve[34],we([0,1,130,12]),function(oe,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class v{constructor(){this.data=new Map}add(k,w){I.ok(t.isString(k)),I.ok(t.isObject(w)),I.ok(!this.data.has(k),"There is already an extension with this id"),this.data.set(k,w)}knows(k){return this.data.has(k)}as(k){return this.data.get(k)||null}}e.Registry=new v}),define(ve[209],we([0,1,7,34]),function(oe,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function v(w){return w.length>0&&w.charAt(w.length-1)==="#"?w.substring(0,w.length-1):w}class P{constructor(){this._onDidChangeSchema=new I.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(p,D){this.schemasById[v(p)]=D,this._onDidChangeSchema.fire(p)}notifySchemaChanged(p){this._onDidChangeSchema.fire(p)}getSchemaContributions(){return{schemas:this.schemasById}}}const k=new P;t.Registry.add(e.Extensions.JSONContribution,k)}),define(ve[53],we([0,1,18,7,12,158,23,209,34]),function(oe,e,I,t,v,P,k,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var D;(function(f){f.Multiline="multilineText",f.Singleline="singlelineText"})(D=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var T;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.MACHINE=2]="MACHINE",f[f.WINDOW=3]="WINDOW",f[f.RESOURCE=4]="RESOURCE",f[f.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",f[f.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(T=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const R=p.Registry.as(w.Extensions.JSONContribution);class E{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:P.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(i,a=!0){this.registerConfigurations([i],a)}registerConfigurations(i,a=!0){const n=this.doRegisterConfigurations(i,a);R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}deregisterConfigurations(i){const a=this.doDeregisterConfigurations(i);R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a})}updateConfigurations({add:i,remove:a}){const n=[];n.push(...this.doDeregisterConfigurations(a)),n.push(...this.doRegisterConfigurations(i,!1)),R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,I.distinct)(n)})}registerDefaultConfigurations(i){const a=[],n=[];for(const{overrides:o,source:r}of i)for(const s in o)if(a.push(s),e.OVERRIDE_PROPERTY_REGEX.test(s)){const c=this.configurationDefaultsOverrides.get(s),u=c?.valuesSources??new Map;if(r)for(const $ of Object.keys(o[s]))u.set($,r);const S={...c?.value||{},...o[s]};this.configurationDefaultsOverrides.set(s,{source:r,value:S,valuesSources:u});const A=(0,k.getLanguageTagSettingPlainKey)(s),M={type:"object",default:S,description:P.localize(1,null,A),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:S,source:v.isString(r)?void 0:r,defaultValueSource:r};n.push(...C(s)),this.configurationProperties[s]=M,this.defaultLanguageConfigurationOverridesNode.properties[s]=M}else{this.configurationDefaultsOverrides.set(s,{value:o[s],source:r});const c=this.configurationProperties[s];c&&(this.updatePropertyDefaultValue(s,c),this.updateSchema(s,c))}this.registerOverrideIdentifiers(n),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a,defaultsOverrides:!0})}deregisterDefaultConfigurations(i){const a=[];for(const{overrides:n,source:o}of i)for(const r in n){const s=this.configurationDefaultsOverrides.get(r),c=v.isString(o)?o:o?.id,u=v.isString(s?.source)?s?.source:s?.source?.id;if(c===u)if(a.push(r),this.configurationDefaultsOverrides.delete(r),e.OVERRIDE_PROPERTY_REGEX.test(r))delete this.configurationProperties[r],delete this.defaultLanguageConfigurationOverridesNode.properties[r];else{const S=this.configurationProperties[r];S&&(this.updatePropertyDefaultValue(r,S),this.updateSchema(r,S))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...i){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(i){for(const a of i)this.overrideIdentifiers.add(a);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(i,a){const n=[];return i.forEach(o=>{n.push(...this.validateAndRegisterProperties(o,a,o.extensionInfo,o.restrictedProperties)),this.configurationContributors.push(o),this.registerJSONConfiguration(o)}),n}doDeregisterConfigurations(i){const a=[],n=o=>{if(o.properties)for(const r in o.properties){a.push(r);const s=this.configurationProperties[r];s?.policy?.name&&this.policyConfigurations.delete(s.policy.name),delete this.configurationProperties[r],this.removeFromSchema(r,o.properties[r])}o.allOf?.forEach(r=>n(r))};for(const o of i){n(o);const r=this.configurationContributors.indexOf(o);r!==-1&&this.configurationContributors.splice(r,1)}return a}validateAndRegisterProperties(i,a=!0,n,o,r=3){r=v.isUndefinedOrNull(i.scope)?r:i.scope;const s=[],c=i.properties;if(c)for(const S in c){const A=c[S];if(a&&h(S,A)){delete c[S];continue}if(A.source=n,A.defaultDefaultValue=c[S].default,this.updatePropertyDefaultValue(S,A),e.OVERRIDE_PROPERTY_REGEX.test(S)?A.scope=void 0:(A.scope=v.isUndefinedOrNull(A.scope)?r:A.scope,A.restricted=v.isUndefinedOrNull(A.restricted)?!!o?.includes(S):A.restricted),c[S].hasOwnProperty("included")&&!c[S].included){this.excludedConfigurationProperties[S]=c[S],delete c[S];continue}else this.configurationProperties[S]=c[S],c[S].policy?.name&&this.policyConfigurations.set(c[S].policy.name,S);!c[S].deprecationMessage&&c[S].markdownDeprecationMessage&&(c[S].deprecationMessage=c[S].markdownDeprecationMessage),s.push(S)}const u=i.allOf;if(u)for(const S of u)s.push(...this.validateAndRegisterProperties(S,a,n,o,r));return s}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(i){const a=n=>{const o=n.properties;if(o)for(const s in o)this.updateSchema(s,o[s]);n.allOf?.forEach(a)};a(i)}updateSchema(i,a){switch(e.allSettings.properties[i]=a,a.scope){case 1:e.applicationSettings.properties[i]=a;break;case 2:e.machineSettings.properties[i]=a;break;case 6:e.machineOverridableSettings.properties[i]=a;break;case 3:e.windowSettings.properties[i]=a;break;case 4:e.resourceSettings.properties[i]=a;break;case 5:e.resourceSettings.properties[i]=a,this.resourceLanguageSettingsSchema.properties[i]=a;break}}removeFromSchema(i,a){switch(delete e.allSettings.properties[i],a.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.resourceLanguageSettingsSchema.properties[i];break}}updateOverridePropertyPatternKey(){for(const i of this.overrideIdentifiers.values()){const a=`[${i}]`,n={type:"object",description:P.localize(2,null),errorMessage:P.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(a,n),e.allSettings.properties[a]=n,e.applicationSettings.properties[a]=n,e.machineSettings.properties[a]=n,e.machineOverridableSettings.properties[a]=n,e.windowSettings.properties[a]=n,e.resourceSettings.properties[a]=n}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const i={type:"object",description:P.localize(4,null),errorMessage:P.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(i,a){const n=this.configurationDefaultsOverrides.get(i);let o=n?.value,r=n?.source;v.isUndefined(o)&&(o=a.defaultDefaultValue,r=void 0),v.isUndefined(o)&&(o=m(a.type)),a.default=o,a.defaultValueSource=r}}const b="\\[([^\\]]+)\\]",d=new RegExp(b,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${b})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function C(f){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(f)){let a=d.exec(f);for(;a?.length;){const n=a[1].trim();n&&i.push(n),a=d.exec(f)}}return(0,I.distinct)(i)}e.overrideIdentifiersFromKey=C;function y(f){return f.reduce((i,a)=>`${i}[${a}]`,"")}e.keyFromOverrideIdentifiers=y;function m(f){switch(Array.isArray(f)?f[0]:f){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=m;const g=new E;p.Registry.add(e.Extensions.Configuration,g);function h(f,i){return f.trim()?e.OVERRIDE_PROPERTY_REGEX.test(f)?P.localize(7,null,f):g.getConfigurationProperties()[f]!==void 0?P.localize(8,null,f):i.policy?.name&&g.getPolicyConfigurations().get(i.policy?.name)!==void 0?P.localize(9,null,f,i.policy?.name,g.getPolicyConfigurations().get(i.policy?.name)):null:P.localize(6,null)}e.validateProperty=h;function l(){const f=[],i=g.getConfigurationProperties();for(const a of Object.keys(i))f.push([a,i[a].scope]);return f.push(["launch",4]),f.push(["task",4]),f}e.getScopes=l}),define(ve[102],we([0,1,18,7,65,2,29,22,12,4,23,53,34]),function(oe,e,I,t,v,P,k,w,p,D,T,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class b{constructor(a={},n=[],o=[]){this._contents=a,this._keys=n,this._overrides=o,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(a){return a?(0,T.getConfigurationValue)(this.contents,a):this.contents}getOverrideValue(a,n){const o=this.getContentsForOverrideIdentifer(n);return o?a?(0,T.getConfigurationValue)(o,a):o:void 0}getKeysForOverrideIdentifier(a){const n=[];for(const o of this.overrides)o.identifiers.includes(a)&&n.push(...o.keys);return I.distinct(n)}getAllOverrideIdentifiers(){const a=[];for(const n of this.overrides)a.push(...n.identifiers);return I.distinct(a)}override(a){let n=this.overrideConfigurations.get(a);return n||(n=this.createOverrideConfigurationModel(a),this.overrideConfigurations.set(a,n)),n}merge(...a){const n=w.deepClone(this.contents),o=w.deepClone(this.overrides),r=[...this.keys];for(const s of a)if(!s.isEmpty()){this.mergeContents(n,s.contents);for(const c of s.overrides){const[u]=o.filter(S=>I.equals(S.identifiers,c.identifiers));u?(this.mergeContents(u.contents,c.contents),u.keys.push(...c.keys),u.keys=I.distinct(u.keys)):o.push(w.deepClone(c))}for(const c of s.keys)r.indexOf(c)===-1&&r.push(c)}return new b(n,r,o)}freeze(){return this.frozen=!0,this}clone(){return new b(w.deepClone(this.contents),[...this.keys],w.deepClone(this.overrides))}createOverrideConfigurationModel(a){const n=this.getContentsForOverrideIdentifer(a);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const o={};for(const r of I.distinct([...Object.keys(this.contents),...Object.keys(n)])){let s=this.contents[r];const c=n[r];c&&(typeof s=="object"&&typeof c=="object"?(s=w.deepClone(s),this.mergeContents(s,c)):s=c),o[r]=s}return new b(o,this.keys,this.overrides)}mergeContents(a,n){for(const o of Object.keys(n)){if(o in a&&p.isObject(a[o])&&p.isObject(n[o])){this.mergeContents(a[o],n[o]);continue}a[o]=w.deepClone(n[o])}}checkAndFreeze(a){return this.frozen&&!Object.isFrozen(a)?w.deepFreeze(a):a}getContentsForOverrideIdentifer(a){let n=null,o=null;const r=s=>{s&&(o?this.mergeContents(o,s):o=w.deepClone(s))};for(const s of this.overrides)I.equals(s.identifiers,[a])?n=s.contents:s.identifiers.includes(a)&&r(s.contents);return r(n),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(a,n){this.addKey(a),(0,T.addToValueTree)(this.contents,a,n,o=>{throw new Error(o)})}removeValue(a){this.removeKey(a)&&(0,T.removeFromValueTree)(this.contents,a)}addKey(a){let n=this.keys.length;for(let o=0;o<n;o++)a.indexOf(this.keys[o])===0&&(n=o);this.keys.splice(n,1,a)}removeKey(a){const n=this.keys.indexOf(a);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=b;class d{constructor(a){this._name=a,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new b}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(a,n){if(!p.isUndefinedOrNull(a)){const o=this.doParseContent(a);this.parseRaw(o,n)}}reparse(a){this._raw&&this.parseRaw(this._raw,a)}parseRaw(a,n){this._raw=a;const{contents:o,keys:r,overrides:s,restricted:c}=this.doParseRaw(a,n);this._configurationModel=new b(o,r,s),this._restrictedConfigurations=c||[]}doParseContent(a){let n={},o=null,r=[];const s=[],c=[];function u(A){Array.isArray(r)?r.push(A):o!==null&&(r[o]=A)}const S={onObjectBegin:()=>{const A={};u(A),s.push(r),r=A,o=null},onObjectProperty:A=>{o=A},onObjectEnd:()=>{r=s.pop()},onArrayBegin:()=>{const A=[];u(A),s.push(r),r=A,o=null},onArrayEnd:()=>{r=s.pop()},onLiteralValue:u,onError:(A,M,$)=>{c.push({error:A,offset:M,length:$})}};if(a)try{v.visit(a,S),n=r[0]||{}}catch(A){console.error(`Error while parsing settings file ${this._name}: ${A}`),this._parseErrors=[A]}return n}doParseRaw(a,n){const o=E.Registry.as(R.Extensions.Configuration).getConfigurationProperties(),r=this.filter(a,o,!0,n);a=r.raw;const s=(0,T.toValuesTree)(a,S=>console.error(`Conflict in settings file ${this._name}: ${S}`)),c=Object.keys(a),u=this.toOverrides(a,S=>console.error(`Conflict in settings file ${this._name}: ${S}`));return{contents:s,keys:c,overrides:u,restricted:r.restricted}}filter(a,n,o,r){if(!r?.scopes&&!r?.skipRestricted)return{raw:a,restricted:[]};const s={},c=[];for(const u in a)if(R.OVERRIDE_PROPERTY_REGEX.test(u)&&o){const S=this.filter(a[u],n,!1,r);s[u]=S.raw,c.push(...S.restricted)}else{const S=n[u],A=S?typeof S.scope!="undefined"?S.scope:3:void 0;S?.restricted&&c.push(u),(A===void 0||r.scopes===void 0||r.scopes.includes(A))&&(r.skipRestricted&&S?.restricted||(s[u]=a[u]))}return{raw:s,restricted:c}}toOverrides(a,n){const o=[];for(const r of Object.keys(a))if(R.OVERRIDE_PROPERTY_REGEX.test(r)){const s={};for(const c in a[r])s[c]=a[r][c];o.push({identifiers:(0,R.overrideIdentifiersFromKey)(r),keys:Object.keys(s),contents:(0,T.toValuesTree)(s,n)})}return o}}e.ConfigurationModelParser=d;class C extends P.Disposable{constructor(a,n,o,r){super();this.userSettingsResource=a,this.scopes=n,this.fileService=r,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new d(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.any(t.Event.filter(this.fileService.onDidFilesChange,s=>s.contains(this.userSettingsResource)),t.Event.filter(this.fileService.onDidRunOperation,s=>(s.isOperation(0)||s.isOperation(3)||s.isOperation(1)||s.isOperation(4))&&o.isEqual(s.resource,a)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const a=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(a.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new b}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=C;class y{constructor(a,n,o,r,s=new b,c=new b,u=new k.ResourceMap,S=new b,A=new k.ResourceMap,M=!0){this._defaultConfiguration=a,this._policyConfiguration=n,this._applicationConfiguration=o,this._localUserConfiguration=r,this._remoteUserConfiguration=s,this._workspaceConfiguration=c,this._folderConfigurations=u,this._memoryConfiguration=S,this._memoryConfigurationByResource=A,this._freeze=M,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new k.ResourceMap,this._userConfiguration=null}getValue(a,n,o){return this.getConsolidatedConfigurationModel(a,n,o).getValue(a)}updateValue(a,n,o={}){let r;o.resource?(r=this._memoryConfigurationByResource.get(o.resource),r||(r=new b,this._memoryConfigurationByResource.set(o.resource,r))):r=this._memoryConfiguration,n===void 0?r.removeValue(a):r.setValue(a,n),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(a,n,o){const r=this.getConsolidatedConfigurationModel(a,n,o),s=this.getFolderConfigurationModelForResource(n.resource,o),c=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,u=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(a):this._defaultConfiguration.freeze().getValue(a),S=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(a),A=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().getValue(a),M=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(a):this.userConfiguration.freeze().getValue(a),$=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(a):this.localUserConfiguration.freeze().getValue(a),Q=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(a):this.remoteUserConfiguration.freeze().getValue(a),_=o?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(a):this._workspaceConfiguration.freeze().getValue(a):void 0,q=s?n.overrideIdentifier?s.freeze().override(n.overrideIdentifier).getValue(a):s.freeze().getValue(a):void 0,U=n.overrideIdentifier?c.override(n.overrideIdentifier).getValue(a):c.getValue(a),ne=r.getValue(a),Z=I.distinct(r.overrides.map(F=>F.identifiers).flat()).filter(F=>r.getOverrideValue(a,F)!==void 0);return{defaultValue:u,policyValue:S,applicationValue:A,userValue:M,userLocalValue:$,userRemoteValue:Q,workspaceValue:_,workspaceFolderValue:q,memoryValue:U,value:ne,default:u!==void 0?{value:this._defaultConfiguration.freeze().getValue(a),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(a,n.overrideIdentifier):void 0}:void 0,policy:S!==void 0?{value:S}:void 0,application:A!==void 0?{value:A,override:n.overrideIdentifier?this.applicationConfiguration.freeze().getOverrideValue(a,n.overrideIdentifier):void 0}:void 0,user:M!==void 0?{value:this.userConfiguration.freeze().getValue(a),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(a,n.overrideIdentifier):void 0}:void 0,userLocal:$!==void 0?{value:this.localUserConfiguration.freeze().getValue(a),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(a,n.overrideIdentifier):void 0}:void 0,userRemote:Q!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(a),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(a,n.overrideIdentifier):void 0}:void 0,workspace:_!==void 0?{value:this._workspaceConfiguration.freeze().getValue(a),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(a,n.overrideIdentifier):void 0}:void 0,workspaceFolder:q!==void 0?{value:s?.freeze().getValue(a),override:n.overrideIdentifier?s?.freeze().getOverrideValue(a,n.overrideIdentifier):void 0}:void 0,memory:U!==void 0?{value:c.getValue(a),override:n.overrideIdentifier?c.getOverrideValue(a,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:Z.length?Z:void 0}}keys(a){const n=this.getFolderConfigurationModelForResource(void 0,a);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(a){this._defaultConfiguration=a,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(a){this._policyConfiguration=a}updateApplicationConfiguration(a){this._applicationConfiguration=a,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(a){this._localUserConfiguration=a,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(a){this._remoteUserConfiguration=a,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(a){this._workspaceConfiguration=a,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(a,n){this._folderConfigurations.set(a,n),this._foldersConsolidatedConfigurations.delete(a)}deleteFolderConfiguration(a){this.folderConfigurations.delete(a),this._foldersConsolidatedConfigurations.delete(a)}compareAndUpdateDefaultConfiguration(a,n){const o=[];if(!n){const{added:r,updated:s,removed:c}=l(this._defaultConfiguration,a);n=[...r,...s,...c]}for(const r of n)for(const s of(0,R.overrideIdentifiersFromKey)(r)){const c=this._defaultConfiguration.getKeysForOverrideIdentifier(s),u=a.getKeysForOverrideIdentifier(s),S=[...u.filter(A=>c.indexOf(A)===-1),...c.filter(A=>u.indexOf(A)===-1),...c.filter(A=>!w.equals(this._defaultConfiguration.override(s).getValue(A),a.override(s).getValue(A)))];o.push([s,S])}return this.updateDefaultConfiguration(a),{keys:n,overrides:o}}compareAndUpdatePolicyConfiguration(a){const{added:n,updated:o,removed:r}=l(this._policyConfiguration,a),s=[...n,...o,...r];return s.length&&this.updatePolicyConfiguration(a),{keys:s,overrides:[]}}compareAndUpdateApplicationConfiguration(a){const{added:n,updated:o,removed:r,overrides:s}=l(this.applicationConfiguration,a),c=[...n,...o,...r];return c.length&&this.updateApplicationConfiguration(a),{keys:c,overrides:s}}compareAndUpdateLocalUserConfiguration(a){const{added:n,updated:o,removed:r,overrides:s}=l(this.localUserConfiguration,a),c=[...n,...o,...r];return c.length&&this.updateLocalUserConfiguration(a),{keys:c,overrides:s}}compareAndUpdateRemoteUserConfiguration(a){const{added:n,updated:o,removed:r,overrides:s}=l(this.remoteUserConfiguration,a),c=[...n,...o,...r];return c.length&&this.updateRemoteUserConfiguration(a),{keys:c,overrides:s}}compareAndUpdateWorkspaceConfiguration(a){const{added:n,updated:o,removed:r,overrides:s}=l(this.workspaceConfiguration,a),c=[...n,...o,...r];return c.length&&this.updateWorkspaceConfiguration(a),{keys:c,overrides:s}}compareAndUpdateFolderConfiguration(a,n){const o=this.folderConfigurations.get(a),{added:r,updated:s,removed:c,overrides:u}=l(o,n),S=[...r,...s,...c];return(S.length||!o)&&this.updateFolderConfiguration(a,n),{keys:S,overrides:u}}compareAndDeleteFolderConfiguration(a){const n=this.folderConfigurations.get(a);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(a);const{added:o,updated:r,removed:s,overrides:c}=l(n,void 0);return{keys:[...o,...r,...s],overrides:c}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(a,n,o){let r=this.getConsolidatedConfigurationModelForResource(n,o);return n.overrideIdentifier&&(r=r.override(n.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(a)!==void 0&&(r=r.merge(this._policyConfiguration)),r}getConsolidatedConfigurationModelForResource({resource:a},n){let o=this.getWorkspaceConsolidatedConfiguration();if(n&&a){const r=n.getFolder(a);r&&(o=this.getFolderConsolidatedConfiguration(r.uri)||o);const s=this._memoryConfigurationByResource.get(a);s&&(o=o.merge(s))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(a){let n=this._foldersConsolidatedConfigurations.get(a);if(!n){const o=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(a);r?(n=o.merge(r),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(a,n)):n=o}return n}getFolderConfigurationModelForResource(a,n){if(n&&a){const o=n.getFolder(a);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((a,n)=>{const{contents:o,overrides:r,keys:s}=this._folderConfigurations.get(n);return a.push([n,{contents:o,overrides:r,keys:s}]),a},[])}}allKeys(){const a=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>a.add(n)),this.userConfiguration.freeze().keys.forEach(n=>a.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>a.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(o=>a.add(o))),[...a.values()]}allOverrideIdentifiers(){const a=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>a.add(n)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>a.add(n)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>a.add(n)),this._folderConfigurations.forEach(n=>n.freeze().getAllOverrideIdentifiers().forEach(o=>a.add(o))),[...a.values()]}getAllKeysForOverrideIdentifier(a){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(a).forEach(o=>n.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(a).forEach(o=>n.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(a).forEach(o=>n.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(a).forEach(r=>n.add(r))),[...n.values()]}static parse(a){const n=this.parseConfigurationModel(a.defaults),o=this.parseConfigurationModel(a.policy),r=this.parseConfigurationModel(a.application),s=this.parseConfigurationModel(a.user),c=this.parseConfigurationModel(a.workspace),u=a.folders.reduce((S,A)=>(S.set(D.URI.revive(A[0]),this.parseConfigurationModel(A[1])),S),new k.ResourceMap);return new y(n,o,r,s,new b,c,u,new b,new k.ResourceMap,!1)}static parseConfigurationModel(a){return new b(a.contents,a.keys,a.overrides).freeze()}}e.Configuration=y;function m(...i){if(i.length===0)return{keys:[],overrides:[]};if(i.length===1)return i[0];const a=new Set,n=new Map;for(const r of i)r.keys.forEach(s=>a.add(s)),r.overrides.forEach(([s,c])=>{const u=(0,k.getOrSet)(n,s,new Set);c.forEach(S=>u.add(S))});const o=[];return n.forEach((r,s)=>o.push([s,[...r.values()]])),{keys:[...a.values()],overrides:o}}e.mergeChanges=m;class g{constructor(a,n,o,r){this.change=a,this.previous=n,this.currentConfiguraiton=o,this.currentWorkspace=r,this._previousConfiguration=void 0;const s=new Set;a.keys.forEach(u=>s.add(u)),a.overrides.forEach(([,u])=>u.forEach(S=>s.add(S))),this.affectedKeys=[...s.values()];const c=new b;this.affectedKeys.forEach(u=>c.setValue(u,{})),this.affectedKeysTree=c.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=y.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(a,n){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,a)){if(n){const o=this.previousConfiguration?this.previousConfiguration.getValue(a,n,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(a,n,this.currentWorkspace);return!w.equals(o,r)}return!0}return!1}doesAffectedKeysTreeContains(a,n){let o=(0,T.toValuesTree)({[n]:!0},()=>{}),r;for(;typeof o=="object"&&(r=Object.keys(o)[0]);){if(a=a[r],!a)return!1;o=o[r]}return!0}}e.ConfigurationChangeEvent=g;class h extends g{constructor(a,n,o,r){super({keys:a.allKeys(),overrides:[]},void 0,a,n);this.source=o,this.sourceConfig=r}}e.AllKeysConfigurationChangeEvent=h;function l(i,a){const{added:n,removed:o,updated:r}=f(a,i),s=[],c=i?.getAllOverrideIdentifiers()||[],u=a?.getAllOverrideIdentifiers()||[];if(a){const S=u.filter(A=>!c.includes(A));for(const A of S)s.push([A,a.getKeysForOverrideIdentifier(A)])}if(i){const S=c.filter(A=>!u.includes(A));for(const A of S)s.push([A,i.getKeysForOverrideIdentifier(A)])}if(a&&i){for(const S of c)if(u.includes(S)){const A=f({contents:i.getOverrideValue(void 0,S)||{},keys:i.getKeysForOverrideIdentifier(S)},{contents:a.getOverrideValue(void 0,S)||{},keys:a.getKeysForOverrideIdentifier(S)});s.push([S,[...A.added,...A.removed,...A.updated]])}}return{added:n,removed:o,updated:r,overrides:s}}function f(i,a){const n=i?a?i.keys.filter(s=>a.keys.indexOf(s)===-1):[...i.keys]:[],o=a?i?a.keys.filter(s=>i.keys.indexOf(s)===-1):[...a.keys]:[],r=[];if(i&&a){for(const s of a.keys)if(i.keys.indexOf(s)!==-1){const c=(0,T.getConfigurationValue)(a.contents,s),u=(0,T.getConfigurationValue)(i.contents,s);w.equals(c,u)||r.push(s)}}return{added:n,removed:o,updated:r}}}),define(ve[210],we([0,1,18,7,2,22,12,23,102,53,13,61,34]),function(oe,e,I,t,v,P,k,w,p,D,T,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class b extends v.Disposable{constructor(){super(...arguments);this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new d(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(E.Registry.as(D.Extensions.Configuration).onDidUpdateConfiguration(({properties:g,defaultsOverrides:h})=>this.onDidUpdateConfiguration(g,h))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(g,h){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:g})}getConfigurationDefaultOverrides(){return{}}}e.DefaultConfiguration=b;class d extends p.ConfigurationModel{constructor(g={}){const h=E.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),l=Object.keys(h),f=Object.create(null),i=[];for(const a in h){const n=g[a],o=n!==void 0?n:h[a].default;(0,w.addToValueTree)(f,a,o,r=>console.error(`Conflict in default settings: ${r}`))}for(const a of Object.keys(f))D.OVERRIDE_PROPERTY_REGEX.test(a)&&i.push({identifiers:(0,D.overrideIdentifiersFromKey)(a),keys:Object.keys(f[a]),contents:(0,w.toValuesTree)(f[a],n=>console.error(`Conflict in default settings file: ${n}`))});super(f,l,i)}}e.DefaultConfigurationModel=d;class C{constructor(){this.onDidChangeConfiguration=t.Event.None,this.configurationModel=new p.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=C;let y=class extends v.Disposable{constructor(g,h,l){super();this.defaultConfiguration=g,this.policyService=h,this.logService=l,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new p.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(g=>this.onDidChangePolicies(g))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:g})=>this.update(await this.registerPolicyDefinitions(g),!0))),this._configurationModel}async registerPolicyDefinitions(g){const h={},l=[],f=E.Registry.as(D.Extensions.Configuration).getConfigurationProperties();for(const i of g){const a=f[i];if(!a){l.push(i);continue}if(a.policy){if(a.type!=="string"&&a.type!=="number"){this.logService.warn(`Policy ${a.policy.name} has unsupported type ${a.type}`);continue}l.push(i),h[a.policy.name]={type:a.type}}}return(0,k.isEmptyObject)(h)||await this.policyService.registerPolicyDefinitions(h),l}onDidChangePolicies(g){const h=E.Registry.as(D.Extensions.Configuration).getPolicyConfigurations(),l=(0,I.coalesce)(g.map(f=>h.get(f)));this.update(l,!0)}update(g,h){const l=E.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),f=[],i=this._configurationModel.isEmpty();for(const a of g){const n=l[a]?.policy?.name;if(n){const o=this.policyService.getPolicyValue(n);(i?o!==void 0:!(0,P.equals)(this._configurationModel.getValue(a),o))&&f.push([a,o])}else this._configurationModel.getValue(a)!==void 0&&f.push([a,void 0])}if(f.length){const a=this._configurationModel;this._configurationModel=new p.ConfigurationModel;for(const n of a.keys)this._configurationModel.setValue(n,a.getValue(n));for(const[n,o]of f)o===void 0?this._configurationModel.removeValue(n):this._configurationModel.setValue(n,o);h&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};y=Re([_e(1,R.IPolicyService),_e(2,T.ILogService)],y),e.PolicyConfiguration=y}),define(ve[103],we([0,1,14,7,2,19,23,102,210,61]),function(oe,e,I,t,v,P,k,w,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class T extends v.Disposable{constructor(E,b,d,C){super();this.settingsResource=E,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new p.DefaultConfiguration),this.policyConfiguration=d instanceof D.NullPolicyService?new p.NullPolicyConfiguration:this._register(new p.PolicyConfiguration(this.defaultConfiguration,d,C)),this.userConfiguration=this._register(new w.UserSettings(this.settingsResource,void 0,P.extUriBiasedIgnorePathCase,b)),this.configuration=new w.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new w.ConfigurationModel,new w.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new I.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:y,properties:m})=>this.onDidDefaultConfigurationChange(y,m))),this._register(this.policyConfiguration.onDidChangeConfiguration(y=>this.onDidPolicyConfigurationChange(y))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[E,b,d]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new w.Configuration(E,b,new w.ConfigurationModel,d)}getConfigurationData(){return this.configuration.toData()}getValue(E,b){const d=typeof E=="string"?E:void 0,C=(0,k.isConfigurationOverrides)(E)?E:(0,k.isConfigurationOverrides)(b)?b:{};return this.configuration.getValue(d,C,void 0)}updateValue(E,b,d,C){return Promise.reject(new Error("not supported"))}inspect(E){return this.configuration.inspect(E,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const E=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(E)}onDidChangeUserConfiguration(E){const b=this.configuration.toData(),d=this.configuration.compareAndUpdateLocalUserConfiguration(E);this.trigger(d,b,1)}onDidDefaultConfigurationChange(E,b){const d=this.configuration.toData(),C=this.configuration.compareAndUpdateDefaultConfiguration(E,b);this.trigger(C,d,6)}onDidPolicyConfigurationChange(E){const b=this.configuration.toData(),d=this.configuration.compareAndUpdatePolicyConfiguration(E);this.trigger(d,b,6)}trigger(E,b,d){const C=new w.ConfigurationChangeEvent(E,{data:b},this.configuration);C.source=d,C.sourceConfig=this.getTargetConfiguration(d),this._onDidChangeConfiguration.fire(C)}getTargetConfiguration(E){switch(E){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=T}),define(ve[104],we([0,1,11,6]),function(oe,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var v;(function(k){k.Unknown="Unknown",k.NotAvailable="NotAvailable",k.TemporarilyNotAvailable="TemporarilyNotAvailable",k.NoResolverFound="NoResolverFound"})(v=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class P extends I.ErrorNoTelemetry{constructor(w,p=v.Unknown,D){super(w);this._message=w,this._code=p,this._detail=D,this.isHandled=p===v.NotAvailable&&D===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,P.prototype)}static isTemporarilyNotAvailable(w){return w instanceof P&&w._code===v.TemporarilyNotAvailable}static isNoResolverFound(w){return w instanceof P&&w._code===v.NoResolverFound}static isHandled(w){return w instanceof P&&w.isHandled}}e.RemoteAuthorityResolverError=P}),define(ve[76],we([0,1,10]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(D){return D.scheme===I.Schemas.vscodeRemote?D.authority:void 0}e.getRemoteAuthority=t;function v(D){if(!D)return;const T=D.indexOf("+");return T<0?D:D.substr(0,T)}e.getRemoteName=v;function P(D){return`/${D.quality??"oss"}-${D.commit??"dev"}`}e.getRemoteServerRootPath=P;function k(D){const{host:T,port:R}=p(D);if(typeof R=="undefined")throw new Error("Remote authority doesn't contain a port!");return{host:T,port:R}}e.parseAuthorityWithPort=k;function w(D,T){let{host:R,port:E}=p(D);return typeof E=="undefined"&&(E=T),{host:R,port:E}}e.parseAuthorityWithOptionalPort=w;function p(D){const T=D.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(T)return{host:T[1],port:parseInt(T[2],10)};const R=D.match(/^(\[[0-9a-z:]+\])$/);if(R)return{host:R[1],port:void 0};const E=D.match(/(.*):(\d+)$/);return E?{host:E[1],port:parseInt(E[2],10)}:{host:D,port:void 0}}}),define(ve[38],we([0,1,15,6,76]),function(oe,e,I,t,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function P(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.getWorkspaceSupportTypeMessage=P;function k(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=k,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var w;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(w=e.ExtensionType||(e.ExtensionType={}));var p;(function(d){d.WIN32_X64="win32-x64",d.WIN32_IA32="win32-ia32",d.WIN32_ARM64="win32-arm64",d.LINUX_X64="linux-x64",d.LINUX_ARM64="linux-arm64",d.LINUX_ARMHF="linux-armhf",d.ALPINE_X64="alpine-x64",d.ALPINE_ARM64="alpine-arm64",d.DARWIN_X64="darwin-x64",d.DARWIN_ARM64="darwin-arm64",d.WEB="web",d.UNIVERSAL="universal",d.UNKNOWN="unknown",d.UNDEFINED="undefined"})(p=e.TargetPlatform||(e.TargetPlatform={}));class D{constructor(C){this.value=C,this._lower=C.toLowerCase()}static equals(C,y){if(typeof C=="undefined"||C===null)return typeof y=="undefined"||y===null;if(typeof y=="undefined"||y===null)return!1;if(typeof C=="string"||typeof y=="string"){const m=typeof C=="string"?C:C.value,g=typeof y=="string"?y:y.value;return I.equalsIgnoreCase(m,g)}return C._lower===y._lower}static toKey(C){return typeof C=="string"?C.toLowerCase():C._lower}}e.ExtensionIdentifier=D;function T(d){return R(d)}e.isApplicationScopedExtension=T;function R(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}e.isLanguagePackExtension=R;function E(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=E;function b(d,C){if(C){const y=`onResolveRemoteAuthority:${(0,v.getRemoteName)(C)}`;return d.activationEvents?.indexOf(y)!==-1}return!1}e.isResolverExtension=b,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(ve[35],we([0,1,15,31,38,3,4,11,28]),function(oe,e,I,t,v,P,k,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function D(n,o){return n.uuid&&o.uuid?n.uuid===o.uuid:n.id===o.id?!0:(0,I.compareIgnoreCase)(n.id,o.id)===0}e.areSameExtensions=D;const T=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class R{constructor(o,r,s="undefined"){this.version=r,this.targetPlatform=s,this.id=o.id}static create(o){const r=o.manifest?o.manifest.version:o.version,s=o.manifest?o.targetPlatform:o.properties.targetPlatform;return new R(o.identifier,r,s)}static parse(o){const r=T.exec(o);return r&&r[1]&&r[2]?new R({id:r[1]},r[2],r[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(o){return o instanceof R?D(this,o)&&this.version===o.version&&this.targetPlatform===o.targetPlatform:!1}}e.ExtensionKey=R;const E=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function b(n){const o=E.exec(n);return o&&o[1]?[C(o[1]),o[2]]:[C(n),void 0]}e.getIdAndVersion=b;function d(n,o){return`${n}.${o}`}e.getExtensionId=d;function C(n){return n.toLocaleLowerCase()}e.adoptToGalleryExtensionId=C;function y(n,o){return C(d(n,o))}e.getGalleryExtensionId=y;function m(n,o){const r=[],s=c=>{for(const u of r)if(u.some(S=>D(o(S),o(c))))return u;return null};for(const c of n){const u=s(c);u?u.push(c):r.push([c])}return r}e.groupByExtension=m;function g(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=g;function h(n){return{id:n.identifier.id,name:n.name,galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),...n.telemetryData}}e.getGalleryExtensionTelemetryData=h,e.BetterMergeId=new v.ExtensionIdentifier("pprice.better-merge");function l(n){const o=new Set;if(n.malicious)for(const r of n.malicious)o.add(r.id);return o}e.getMaliciousExtensionsSet=l;function f(n,o){const r=[],s=o.manifest.extensionDependencies?.slice(0)??[];for(;s.length;){const c=s.shift();if(c&&r.every(u=>!D(u.identifier,{id:c}))){const u=n.filter(S=>D(S.identifier,{id:c}));u.length===1&&(r.push(u[0]),s.push(...u[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=f;async function i(n,o){if(!P.isLinux)return!1;let r;try{r=(await n.readFile(k.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await n.readFile(k.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){o.debug("Error while getting the os-release file.",(0,w.getErrorMessage)(c))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=i;async function a(n,o){const r=await i(n,o),s=(0,t.getTargetPlatform)(r?"alpine":P.platform,p.arch);return o.debug("ComputeTargetPlatform:",s),s}e.computeTargetPlatform=a}),define(ve[105],we([0,1,20,11,10,19,51,4,163,31,35,38]),function(oe,e,I,t,v,P,k,w,p,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLIService=void 0;const E=y=>(0,p.localize)(0,null,y),b=(0,p.localize)(1,null,"ms-dotnettools.csharp");function d(y,m){return m?`${y.publisher}.${y.name}@${y.version}`:`${y.publisher}.${y.name}`}let C=class{constructor(m,g){this.extensionManagementService=m,this.extensionGalleryService=g}get location(){}async listExtensions(m,g,h=console){let l=await this.extensionManagementService.getInstalled(1);const f=R.EXTENSION_CATEGORIES.map(a=>a.toLowerCase());if(g&&g!==""){if(f.indexOf(g.toLowerCase())<0){h.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}l=l.filter(a=>a.manifest.categories?a.manifest.categories.map(o=>o.toLowerCase()).indexOf(g.toLowerCase())>-1:!1)}else if(g===""){h.log("Possible Categories: "),f.forEach(a=>{h.log(a)});return}this.location&&h.log((0,p.localize)(2,null,this.location)),l=l.sort((a,n)=>a.identifier.id.localeCompare(n.identifier.id));let i;for(const a of l)i!==a.identifier.id&&(i=a.identifier.id,h.log(d(a.manifest,m)))}async installExtensions(m,g,h,l,f=console){const i=[],a=[];m.length&&f.log(this.location?(0,p.localize)(3,null,this.location):(0,p.localize)(4,null));const n=await this.extensionManagementService.getInstalled(1),o=(u,S)=>{const A=n.find(M=>(0,T.areSameExtensions)(M.identifier,{id:u}));if(A){if(!l&&(!S||S==="prerelease"&&A.preRelease))return f.log((0,p.localize)(5,null,u,A.manifest.version,u)),!1;if(S&&A.manifest.version===S)return f.log((0,p.localize)(6,null,`${u}@${S}`)),!1}return!0},r=(u,S,A)=>{c.push({id:u,version:S!=="prerelease"?S:void 0,installOptions:{...h,isBuiltin:A,installPreReleaseVersion:S==="prerelease"||h.installPreReleaseVersion}})},s=[],c=[];for(const u of m)if(u instanceof w.URI)s.push(u);else{const[S,A]=(0,T.getIdAndVersion)(u);o(S,A)&&r(S,A,!1)}for(const u of g){const[S,A]=(0,T.getIdAndVersion)(u);o(S,A)&&r(S,A,!0)}if(s.length&&await Promise.all(s.map(async u=>{try{const S=await this.installVSIX(u,{...h,isBuiltin:!1},l,f);S&&a.push(S)}catch(S){f.error(S.message||S.stack||S),i.push(u.toString())}})),c.length){const u=await this.getGalleryExtensions(c);await Promise.all(c.map(async S=>{const A=u.get(S.id.toLowerCase());if(A)try{const M=await this.installFromGallery(S,A,n,l,f);M&&a.push(M)}catch(M){f.error(M.message||M.stack||M),i.push(S.id)}else f.error(`${E(S.version?`${S.id}@${S.version}`:S.id)}
${b}`),i.push(S.id)}))}if(i.length)throw new Error((0,p.localize)(7,null,i.join(", ")))}async installVSIX(m,g,h,l){const f=await this.extensionManagementService.getManifest(m);if(!f)throw new Error("Invalid vsix");if(await this.validateVSIX(f,h,l))try{return await this.extensionManagementService.install(m,g),l.log((0,p.localize)(8,null,(0,P.basename)(m))),f}catch(a){if((0,t.isCancellationError)(a))return l.log((0,p.localize)(9,null,(0,P.basename)(m))),null;throw a}return null}async getGalleryExtensions(m){const g=new Map,h=m.some(f=>f.installOptions.installPreReleaseVersion),l=await this.extensionGalleryService.getExtensions(m.map(f=>({...f,preRelease:h})),I.CancellationToken.None);for(const f of l)g.set(f.identifier.id.toLowerCase(),f);return g}async installFromGallery({id:m,version:g,installOptions:h},l,f,i,a){const n=await this.extensionGalleryService.getManifest(l,I.CancellationToken.None);if(n&&!this.validateExtensionKind(n,a))return null;const o=f.find(r=>(0,T.areSameExtensions)(r.identifier,l.identifier));if(o){if(l.version===o.manifest.version)return a.log((0,p.localize)(10,null,g?`${m}@${g}`:m)),null;a.log((0,p.localize)(11,null,m,l.version))}try{return h.isBuiltin?a.log(g?(0,p.localize)(12,null,m,g):(0,p.localize)(13,null,m)):a.log(g?(0,p.localize)(14,null,m,g):(0,p.localize)(15,null,m)),await this.extensionManagementService.installFromGallery(l,{...h,installGivenVersion:!!g}),a.log((0,p.localize)(16,null,m,l.version)),n}catch(r){if((0,t.isCancellationError)(r))return a.log((0,p.localize)(17,null,m)),null;throw r}}validateExtensionKind(m,g){return!0}async validateVSIX(m,g,h){const l={id:(0,T.getGalleryExtensionId)(m.publisher,m.name)},i=(await this.extensionManagementService.getInstalled(1)).find(a=>(0,T.areSameExtensions)(l,a.identifier)&&(0,k.gt)(a.manifest.version,m.version));return i&&!g?(h.log((0,p.localize)(18,null,i.identifier.id,i.manifest.version,m.version)),!1):this.validateExtensionKind(m,h)}async uninstallExtensions(m,g,h=console){const l=async i=>{if(i instanceof w.URI){const a=await this.extensionManagementService.getManifest(i);return d(a)}return i},f=[];for(const i of m){const a=await l(i),o=(await this.extensionManagementService.getInstalled()).filter(r=>(0,T.areSameExtensions)(r.identifier,{id:a}));if(!o.length)throw new Error(`${this.notInstalled(a)}
${b}`);if(o.some(r=>r.type===0)){h.log((0,p.localize)(19,null,a));return}if(!g&&o.some(r=>r.isBuiltin)){h.log((0,p.localize)(20,null,a));return}h.log((0,p.localize)(21,null,a));for(const r of o)await this.extensionManagementService.uninstall(r),f.push(r);this.location?h.log((0,p.localize)(22,null,a,this.location)):h.log((0,p.localize)(23,null,a))}}async locateExtension(m,g=console){const h=await this.extensionManagementService.getInstalled();m.forEach(l=>{h.forEach(f=>{if(f.identifier.id===l&&f.location.scheme===v.Schemas.file){g.log(f.location.fsPath);return}})})}notInstalled(m){return this.location?(0,p.localize)(24,null,m,this.location):(0,p.localize)(25,null,m)}};C=Re([_e(0,D.IExtensionManagementService),_e(1,D.IExtensionGalleryService)],C),e.ExtensionManagementCLIService=C}),define(ve[211],we([0,1,14,11,2,3,19,51,4,26,21,24,31,35,17,13]),function(oe,e,I,t,v,P,k,w,p,D,T,R,E,b,d,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let y=class extends v.Disposable{constructor(g,h,l,f){super();this.fileService=h,this.extensionGalleryService=l,this.logService=f,this.extensionsDownloadDir=p.URI.file(g.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(g,h){await this.cleanUpPromise;const l=this.getName(g),f=(0,k.joinPath)(this.extensionsDownloadDir,l);if(!await this.fileService.exists(f)){const i=(0,k.joinPath)(this.extensionsDownloadDir,`.${(0,D.generateUuid)()}`);await this.fileService.exists(i)||await this.extensionGalleryService.download(g,i,h);try{await this.rename(i,f,Date.now()+2*60*1e3)}catch(a){try{await this.fileService.del(i)}catch{}if(a.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",g.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,t.getErrorMessage)(a)}. Deleted the vsix from downloaded location`,i.path),a}}return f}async delete(g){await this.cleanUpPromise,await this.fileService.del(g)}async rename(g,h,l){try{await T.Promises.rename(g.fsPath,h.fsPath)}catch(f){if(P.isWindows&&f&&f.code==="EPERM"&&Date.now()<l)return this.logService.info(`Failed renaming ${g} to ${h} with 'EPERM' error. Trying again...`),this.rename(g,h,l);throw f}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const g=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(g.children){const h=[],l=[];for(const a of g.children){const n=b.ExtensionKey.parse(a.name);n&&l.push([n,a])}const f=(0,b.groupByExtension)(l,([a])=>a),i=[];for(const a of f)a.sort((n,o)=>w.rcompare(n[0].version,o[0].version)),h.push(...a.slice(1).map(n=>n[1].resource)),i.push(a[0][1]);i.sort((a,n)=>a.mtime-n.mtime),h.push(...i.slice(0,Math.max(0,i.length-this.cache)).map(a=>a.resource)),await I.Promises.settled(h.map(a=>(this.logService.trace("Deleting vsix from cache",a.path),this.fileService.del(a))))}}catch(g){this.logService.error(g)}}getName(g){return this.cache?b.ExtensionKey.create(g).toString().toLowerCase():(0,D.generateUuid)()}};y=Re([_e(0,R.INativeEnvironmentService),_e(1,d.IFileService),_e(2,E.IExtensionGalleryService),_e(3,C.ILogService)],y),e.ExtensionsDownloader=y}),define(ve[212],we([0,1,2,5,21,38]),function(oe,e,I,t,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class k extends I.Disposable{constructor(p,D){super();this.environmentService=p,this.extensionsManifestCache=(0,t.join)(this.environmentService.userDataPath,P.MANIFEST_CACHE_FOLDER,P.USER_MANIFEST_CACHE_FILE),this._register(D.onDidInstallExtensions(T=>this.onDidInstallExtensions(T))),this._register(D.onDidUninstallExtension(T=>this.onDidUnInstallExtension(T)))}onDidInstallExtensions(p){p.some(D=>!!D.local)&&this.invalidate()}onDidUnInstallExtension(p){p.error||this.invalidate()}invalidate(){v.Promises.rm(this.extensionsManifestCache,v.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=k}),define(ve[106],we([0,1,77,18,14,2,10,5,21,24,31,35,13,75]),function(oe,e,I,t,v,P,k,w,p,D,T,R,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let d=class extends b.LanguagePackBaseService{constructor(g,h,l,f){super(l);this.extensionManagementService=g,this.logService=f,this.cache=this._register(new C(h,f)),this.extensionManagementService.registerParticipant({postInstall:async i=>this.postInstallExtension(i),postUninstall:async i=>this.postUninstallExtension(i)})}async getInstalledLanguages(){const g=await this.cache.getLanguagePacks(),h=Object.keys(g).map(l=>{const f=g[l];return{...this.createQuickPickItem({locale:l,label:f.label}),extensionId:f.extensions[0].extensionIdentifier.id}});return h.push({...this.createQuickPickItem({locale:"en",label:"English"}),extensionId:"default"}),h}async postInstallExtension(g){g&&g.manifest&&g.manifest.contributes&&g.manifest.contributes.localizations&&g.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",g.identifier.id),await this.update())}async postUninstallExtension(g){const h=await this.cache.getLanguagePacks();Object.keys(h).some(l=>h[l]&&h[l].extensions.some(f=>(0,R.areSameExtensions)(f.extensionIdentifier,g.identifier)))&&(this.logService.info("Removing language packs from the extension",g.identifier.id),await this.update())}async update(){const[g,h]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),l=await this.cache.update(h);return!(0,t.equals)(Object.keys(g),Object.keys(l))}};d=Re([_e(0,T.IExtensionManagementService),_e(1,D.INativeEnvironmentService),_e(2,T.IExtensionGalleryService),_e(3,E.ILogService)],d),e.NativeLanguagePackService=d;let C=class extends P.Disposable{constructor(g,h){super();this.logService=h,this.languagePacks={},this.languagePacksFilePath=(0,w.join)(g.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new v.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(g){return this.withLanguagePacks(h=>{Object.keys(h).forEach(l=>delete h[l]),this.createLanguagePacksFromExtensions(h,...g)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(g,...h){for(const l of h)l&&l.manifest&&l.manifest.contributes&&l.manifest.contributes.localizations&&l.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(g,l);Object.keys(g).forEach(l=>this.updateHash(g[l]))}createLanguagePacksFromExtension(g,h){const l=h.identifier,f=h.manifest.contributes&&h.manifest.contributes.localizations?h.manifest.contributes.localizations:[];for(const i of f)if(h.location.scheme===k.Schemas.file&&y(i)){let a=g[i.languageId];a||(a={hash:"",extensions:[],translations:{},label:i.localizedLanguageName??i.languageName},g[i.languageId]=a);const n=a.extensions.filter(o=>(0,R.areSameExtensions)(o.extensionIdentifier,l))[0];n?n.version=h.manifest.version:a.extensions.push({extensionIdentifier:l,version:h.manifest.version});for(const o of i.translations)a.translations[o.id]=(0,w.join)(h.location.fsPath,o.path)}}updateHash(g){if(g){const h=(0,I.createHash)("md5");for(const l of g.extensions)h.update(l.extensionIdentifier.uuid||l.extensionIdentifier.id).update(l.version);g.hash=h.digest("hex")}}withLanguagePacks(g=()=>null){return this.languagePacksFileLimiter.queue(()=>{let h=null;return p.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,l=>l.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(l)).then(l=>{try{return JSON.parse(l)}catch{return{}}}).then(l=>(h=g(l),l)).then(l=>{for(const i of Object.keys(l))l[i]||delete l[i];this.languagePacks=l,this.initializedCache=!0;const f=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",f),p.Promises.writeFile(this.languagePacksFilePath,f)}).then(()=>h,l=>this.logService.error(l))})}};C=Re([_e(0,D.INativeEnvironmentService),_e(1,E.ILogService)],C);function y(m){if(typeof m.languageId!="string"||!Array.isArray(m.translations)||m.translations.length===0)return!1;for(const g of m.translations)if(typeof g.id!="string"||typeof g.path!="string")return!1;return!(m.languageName&&typeof m.languageName!="string"||m.localizedLanguageName&&typeof m.localizedLanguageName!="string")}}),define(ve[54],we([0,1,16,174,53,6,34]),function(oe,e,I,t,v,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,P.createDecorator)("requestService");function w(C){return C.res.statusCode&&C.res.statusCode>=200&&C.res.statusCode<300||C.res.statusCode===1223}e.isSuccess=w;function p(C){return C.res.statusCode===204}async function D(C){return p(C)?null:(await(0,I.streamToBuffer)(C.stream)).toString()}e.asText=D;async function T(C){if(!w(C))throw new Error("Server returned "+C.res.statusCode);return D(C)}e.asTextOrError=T;async function R(C){if(!w(C))throw new Error("Server returned "+C.res.statusCode);if(p(C))return null;const m=(await(0,I.streamToBuffer)(C.stream)).toString();try{return JSON.parse(m)}catch(g){throw g.message+=`:
`+m,g}}e.asJson=R;function E(C){d(C)}e.updateProxyConfigurationsScope=E;let b;function d(C){const y=k.Registry.as(v.Extensions.Configuration),m=b;b={id:"http",order:15,title:(0,t.localize)(0,null),type:"object",scope:C,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,t.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,t.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,t.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,t.localize)(4,null),(0,t.localize)(5,null),(0,t.localize)(6,null),(0,t.localize)(7,null)],default:"override",description:(0,t.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,t.localize)(9,null),restricted:!0}}},y.updateConfigurations({add:[b],remove:m?[m]:[]})}d(2)}),define(ve[213],we([0,1,20,10,17,54]),function(oe,e,I,t,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let k=class{constructor(p,D){this.requestService=p,this.fileService=D}async download(p,D,T=I.CancellationToken.None){if(p.scheme===t.Schemas.file||p.scheme===t.Schemas.vscodeRemote){await this.fileService.copy(p,D);return}const R={type:"GET",url:p.toString(!0)},E=await this.requestService.request(R,T);if(E.res.statusCode===200)await this.fileService.writeFile(D,E.stream);else{const b=await(0,P.asTextOrError)(E);throw new Error(`Expected 200, got back ${E.res.statusCode} instead.

${b}`)}}};k=Re([_e(0,P.IRequestService),_e(1,v.IFileService)],k),e.DownloadService=k}),define(ve[214],we([0,1,16,20]),function(oe,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class v{constructor(w){this.service=w}listen(w,p){throw new Error("Invalid listen")}call(w,p,D){switch(p){case"request":return this.service.request(D[0],t.CancellationToken.None).then(async({res:T,stream:R})=>{const E=await(0,I.streamToBuffer)(R);return[{statusCode:T.statusCode,headers:T.headers},E]})}throw new Error("Invalid call")}}e.RequestChannel=v;class P{constructor(w){this.channel=w}async request(w,p){return P.request(this.channel,w,p)}static async request(w,p,D){const[T,R]=await w.call("request",[p]);return{res:T,stream:(0,I.bufferToStream)(R)}}}e.RequestChannelClient=P}),define(ve[215],we([0,1,78,12]),function(oe,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function v(k,w){return k.protocol==="http:"?w.HTTP_PROXY||w.http_proxy||null:k.protocol==="https:"&&(w.HTTPS_PROXY||w.https_proxy||w.HTTP_PROXY||w.http_proxy)||null}async function P(k,w,p={}){const D=(0,I.parse)(k),T=p.proxyUrl||v(D,w);if(!T)return null;const R=(0,I.parse)(T);if(!/^https?:$/.test(R.protocol||""))return null;const E={host:R.hostname||"",port:R.port||(R.protocol==="https"?"443":"80"),auth:R.auth,rejectUnauthorized:(0,t.isBoolean)(p.strictSSL)?p.strictSSL:!0};return D.protocol==="http:"?new(await new Promise((b,d)=>{oe(["http-proxy-agent"],b,d)}))(E):new(await new Promise((b,d)=>{oe(["https-proxy-agent"],b,d)}))(E)}e.getProxyAgent=P}),define(ve[79],we([0,1,42,5,175,20,37,11,3,26,156,189,14]),function(oe,e,I,t,v,P,k,w,p,D,T,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const b=1e4;let d;async function C(m,g,h){return g["force-disable-user-env"]?(m.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):p.isWindows?(m.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,R.isLaunchedFromCli)(h)&&!g["force-user-env"]?(m.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,R.isLaunchedFromCli)(h)?m.trace("resolveShellEnv(): running (--force-user-env)"):m.trace("resolveShellEnv(): running (macOS/Linux)"),d||(d=E.Promises.withAsyncBody(async(l,f)=>{const i=new P.CancellationTokenSource,a=setTimeout(()=>{i.dispose(!0),f(new Error((0,v.localize)(0,null)))},b);try{l(await y(m,i.token))}catch(n){!(0,w.isCancellationError)(n)&&!i.token.isCancellationRequested?f(new Error((0,v.localize)(1,null,(0,k.toErrorMessage)(n)))):l({})}finally{clearTimeout(a),i.dispose()}})),d)}e.getResolvedShellEnv=C;async function y(m,g){const h=process.env.ELECTRON_RUN_AS_NODE;m.trace("getUnixShellEnvironment#runAsNode",h);const l=process.env.ELECTRON_NO_ATTACH_CONSOLE;m.trace("getUnixShellEnvironment#noAttach",l);const f=(0,D.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(f+"(.*)"+f),a={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};m.trace("getUnixShellEnvironment#env",a);const n=await(0,T.getSystemShell)(p.OS,a);return m.trace("getUnixShellEnvironment#shell",n),new Promise((o,r)=>{if(g.isCancellationRequested)return r((0,w.canceled)());const s=(0,t.basename)(n);let c,u;const S=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(s)?(c=`& '${process.execPath}' ${S} -p '''${f}'' + JSON.stringify(process.env) + ''${f}'''`,u=["-Login","-Command"]):(c=`'${process.execPath}' ${S} -p '"${f}" + JSON.stringify(process.env) + "${f}"'`,s==="tcsh"?u=["-ic"]:u=["-ilc"]),m.trace("getUnixShellEnvironment#spawn",JSON.stringify(u),c);const A=(0,I.spawn)(n,[...u,c],{detached:!0,stdio:["ignore","pipe","pipe"],env:a});g.onCancellationRequested(()=>(A.kill(),r((0,w.canceled)()))),A.on("error",Q=>{m.error("getUnixShellEnvironment#errorChildProcess",(0,k.toErrorMessage)(Q)),r(Q)});const M=[];A.stdout.on("data",Q=>M.push(Q));const $=[];A.stderr.on("data",Q=>$.push(Q)),A.on("close",(Q,_)=>{const q=Buffer.concat(M).toString("utf8");m.trace("getUnixShellEnvironment#raw",q);const U=Buffer.concat($).toString("utf8");if(U.trim()&&m.trace("getUnixShellEnvironment#stderr",U),Q||_)return r(new Error((0,v.localize)(2,null,Q,_)));const ne=i.exec(q),Z=ne?ne[1]:"{}";try{const F=JSON.parse(Z);h?F.ELECTRON_RUN_AS_NODE=h:delete F.ELECTRON_RUN_AS_NODE,l?F.ELECTRON_NO_ATTACH_CONSOLE=l:delete F.ELECTRON_NO_ATTACH_CONSOLE,delete F.XDG_RUNTIME_DIR,m.trace("getUnixShellEnvironment#result",F),o(F)}catch(F){m.error("getUnixShellEnvironment#errorCaught",(0,k.toErrorMessage)(F)),r(F)}})})}}),define(ve[216],we([0,1,3,28,4,26]),function(oe,e,I,t,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function k(D){if(I.platform===2&&/^penguin(\.|$)/i.test(D))return"chromebook"}async function w(D,T,R,E,b,d,C,y,m,g){const h=Object.create(null);h["common.machineId"]=C,h.sessionID=(0,P.generateUuid)()+Date.now(),h.commitHash=b,h.version=d,h["common.platformVersion"]=(T||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),h["common.platform"]=(0,I.PlatformToString)(I.platform),h["common.nodePlatform"]=t.platform,h["common.nodeArch"]=E,h["common.product"]=g||"desktop";const l=p(y||[]);l&&(h["common.msftInternal"]=l);let f=0;const i=Date.now();Object.defineProperties(h,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-i,enumerable:!0},"common.sequence":{get:()=>f++,enumerable:!0}}),I.isLinuxSnap&&(h["common.snap"]="true");const a=k(R);a&&(h["common.platformDetail"]=a);try{const n=await D.readFile(v.URI.file(m));h["common.source"]=n.value.toString().slice(0,30)}catch{}return h}e.resolveCommonProperties=w;function p(D){const T=t.env.USERDNSDOMAIN;if(!T)return!1;const R=T.toLowerCase();return D.some(E=>R===E)}e.verifyMicrosoftInternalDomain=p}),define(ve[217],we([0,1,18,11,2,22]),function(oe,e,I,t,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorEvent=void 0;var k;(function(p){function D(T,R){return T.callstack<R.callstack?-1:T.callstack>R.callstack?1:0}p.compare=D})(k=e.ErrorEvent||(e.ErrorEvent={}));class w{constructor(D,T=w.ERROR_FLUSH_TIMEOUT){this._flushHandle=-1,this._buffer=[],this._disposables=new v.DisposableStore,this._telemetryService=D,this._flushDelay=T;const R=t.errorHandler.addListener(E=>this._onErrorEvent(E));this._disposables.add((0,v.toDisposable)(R)),this.installErrorListeners()}dispose(){clearTimeout(this._flushHandle),this._flushBuffer(),this._disposables.dispose()}installErrorListeners(){}_onErrorEvent(D){if(!D||(D.detail&&D.detail.stack&&(D=D.detail),t.ErrorNoTelemetry.isErrorNoTelemetry(D)))return;const T=Array.isArray(D.stack)?D.stack.join(`
`):D.stack,R=D.message?D.message:(0,P.safeStringify)(D);!T||this._enqueue({msg:R,callstack:T})}_enqueue(D){const T=(0,I.binarySearch)(this._buffer,D,k.compare);T<0?(D.count=1,this._buffer.splice(~T,0,D)):(this._buffer[T].count||(this._buffer[T].count=0),this._buffer[T].count+=1),this._flushHandle===-1&&(this._flushHandle=setTimeout(()=>{this._flushBuffer(),this._flushHandle=-1},this._flushDelay))}_flushBuffer(){for(const D of this._buffer)this._telemetryService.publicLogError2("UnhandledError",D);this._buffer.length=0}}e.default=w,w.ERROR_FLUSH_TIMEOUT=5*1e3}),define(ve[218],we([0,1,2]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerTelemetryChannel=void 0;class t extends I.Disposable{constructor(P,k){super();this.telemetryService=P,this.telemetryAppender=k}async call(P,k,w){switch(k){case"updateTelemetryLevel":{const{telemetryLevel:p}=w;return this.telemetryService.updateInjectedTelemetryLevel(p)}case"logTelemetry":{const{eventName:p,data:D}=w;return this.telemetryAppender?this.telemetryAppender.log(p,D):Promise.resolve()}case"flushTelemetry":return this.telemetryAppender?this.telemetryAppender.flush():Promise.resolve();case"ping":return}throw new Error(`IPC Command ${k} not found`)}listen(P,k,w){throw new Error("Not supported")}dispose(){this.telemetryService.updateInjectedTelemetryLevel(0),super.dispose()}}e.ServerTelemetryChannel=t}),define(ve[32],we([0,1,6]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,I.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,I.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(P){P[P.NONE=0]="NONE",P[P.CRASH=1]="CRASH",P[P.ERROR=2]="ERROR",P[P.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var v;(function(P){P.OFF="off",P.CRASH="crash",P.ERROR="error",P.ON="all"})(v=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ve[219],we([0,1,27,47,14,65,10,5,3,4,89,21,91,195,17,25,32]),function(oe,e,I,t,v,P,k,w,p,D,T,R,E,b,d,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const m=new Map;async function g(a,n){const o=`${a}::${n.join(":")}`,r=m.get(o);if(r)return r;const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],c=new Map,u=new Map,S=2e4;function A($,Q,_,q){const U=Q.substring($.length+1);return v.Promises.withAsyncBody(async ne=>{let Z;try{Z=await R.Promises.readdir(Q,{withFileTypes:!0})}catch{ne();return}if(q.count>=S){q.count+=Z.length,q.maxReached=!0,ne();return}let F=Z.length;if(F===0){ne();return}let x=Z;q.count+Z.length>S&&(q.maxReached=!0,F=S-q.count,x=Z.slice(0,F)),q.count+=Z.length;for(const z of x)if(z.isDirectory()){if(_.includes(z.name)||await A($,(0,w.join)(Q,z.name),_,q),--F==0){ne();return}}else{const W=z.name.lastIndexOf(".");if(W>=0){const re=z.name.substring(W+1);re&&c.set(re,(c.get(re)??0)+1)}for(const re of s)re.relativePathPattern?.test(U)!==!1&&re.filePattern.test(z.name)&&u.set(re.tag,(u.get(re.tag)??0)+1);if(--F==0){ne();return}}})}const M=v.Promises.withAsyncBody(async $=>{const Q={count:0,maxReached:!1};await A(a,a,n,Q);const _=await f(a);$({configFiles:h(u),fileTypes:h(c),fileCount:Q.count,maxFilesReached:Q.maxReached,launchConfigFiles:_})});return m.set(o,M),M}e.collectWorkspaceStats=g;function h(a){return[...t.Iterable.map(a.entries(),([n,o])=>({name:n,count:o}))].sort((n,o)=>o.count-n.count)}function l(){const a={os:`${I.type()} ${I.arch()} ${I.release()}`,memory:`${(I.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(I.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(T.virtualMachineHint.value()*100)}%`},n=I.cpus();return n&&n.length>0&&(a.cpus=`${n[0].model} (${n.length} x ${n[0].speed})`),a}e.getMachineInfo=l;async function f(a){try{const n=new Map,o=(0,w.join)(a,".vscode","launch.json"),r=await R.Promises.readFile(o),s=[],c=(0,P.parse)(r.toString(),s);if(s.length)return console.log(`Unable to parse ${o}`),[];if((0,P.getNodeType)(c)==="object"&&c.configurations)for(const u of c.configurations){const S=u.type;S&&(n.has(S)?n.set(S,n.get(S)+1):n.set(S,1))}return h(n)}catch{return[]}}e.collectLaunchConfigs=f;let i=class{constructor(n,o){this.telemetryService=n,this.productService=o}formatMachineInfo(n){const o=[];return o.push(`OS Version:       ${n.os}`),o.push(`CPUs:             ${n.cpus}`),o.push(`Memory (System):  ${n.memory}`),o.push(`VM:               ${n.vmHint}`),o.join(`
`)}formatEnvironment(n){const o=[];o.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),o.push(`OS Version:       ${I.type()} ${I.arch()} ${I.release()}`);const r=I.cpus();return r&&r.length>0&&o.push(`CPUs:             ${r[0].model} (${r.length} x ${r[0].speed})`),o.push(`Memory (System):  ${(I.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(I.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`),p.isWindows||o.push(`Load (avg):       ${I.loadavg().map(s=>Math.round(s)).join(", ")}`),o.push(`VM:               ${Math.round(T.virtualMachineHint.value()*100)}%`),o.push(`Screen Reader:    ${n.screenReader?"yes":"no"}`),o.push(`Process Argv:     ${n.mainArguments.join(" ")}`),o.push(`GPU Status:       ${this.expandGPUFeatures(n.gpuFeatureStatus)}`),o.join(`
`)}async getPerformanceInfo(n,o){return Promise.all([(0,E.listProcesses)(n.mainPID),this.formatWorkspaceMetadata(n)]).then(async r=>{let[s,c]=r,u=this.formatProcessList(n,s);return o.forEach(S=>{if((0,b.isRemoteDiagnosticError)(S))u+=`
${S.errorMessage}`,c+=`
${S.errorMessage}`;else if(u+=`

Remote: ${S.hostName}`,S.processes&&(u+=`
${this.formatProcessList(n,S.processes)}`),S.workspaceMetadata){c+=`
|  Remote: ${S.hostName}`;for(const A of Object.keys(S.workspaceMetadata)){const M=S.workspaceMetadata[A];let $=`${M.fileCount} files`;M.maxFilesReached&&($=`more than ${$}`),c+=`|    Folder (${A}): ${$}`,c+=this.formatWorkspaceStats(M)}}}),{processInfo:u,workspaceInfo:c}})}async getSystemInfo(n,o){const{memory:r,vmHint:s,os:c,cpus:u}=l(),S={os:c,memory:r,cpus:u,vmHint:s,processArgs:`${n.mainArguments.join(" ")}`,gpuStatus:n.gpuFeatureStatus,screenReader:`${n.screenReader?"yes":"no"}`,remoteData:o};return p.isWindows||(S.load=`${I.loadavg().map(A=>Math.round(A)).join(", ")}`),p.isLinux&&(S.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(S)}async getDiagnostics(n,o){const r=[];return(0,E.listProcesses)(n.mainPID).then(async s=>(r.push(""),r.push(this.formatEnvironment(n)),r.push(""),r.push(this.formatProcessList(n,s)),n.windows.some(c=>c.folderURIs&&c.folderURIs.length>0&&!c.remoteAuthority)&&(r.push(""),r.push("Workspace Stats: "),r.push(await this.formatWorkspaceMetadata(n))),o.forEach(c=>{if((0,b.isRemoteDiagnosticError)(c))r.push(`
${c.errorMessage}`);else if(r.push(`

`),r.push(`Remote:           ${c.hostName}`),r.push(this.formatMachineInfo(c.machineInfo)),c.processes&&r.push(this.formatProcessList(n,c.processes)),c.workspaceMetadata)for(const u of Object.keys(c.workspaceMetadata)){const S=c.workspaceMetadata[u];let A=`${S.fileCount} files`;S.maxFilesReached&&(A=`more than ${A}`),r.push(`Folder (${u}): ${A}`),r.push(this.formatWorkspaceStats(S))}}),r.push(""),r.push(""),r.join(`
`)))}formatWorkspaceStats(n){const o=[],r=60;let s=0;const c=(M,$)=>{const Q=` ${M}(${$})`;s+Q.length>r?(o.push(u),u="|                 ",s=u.length):s+=Q.length,u+=Q};let u="|      File types:";const S=10,A=n.fileTypes.length>S?S:n.fileTypes.length;for(let M=0;M<A;M++){const $=n.fileTypes[M];c($.name,$.count)}if(o.push(u),n.configFiles.length>=0&&(u="|      Conf files:",s=0,n.configFiles.forEach(M=>{c(M.name,M.count)}),o.push(u)),n.launchConfigFiles.length>0){let M="|      Launch Configs:";n.launchConfigFiles.forEach($=>{M+=$.count>1?` ${$.name}(${$.count})`:` ${$.name}`}),o.push(M)}return o.join(`
`)}expandGPUFeatures(n){const o=Math.max(...Object.keys(n).map(r=>r.length));return Object.keys(n).map(r=>`${r}:  ${" ".repeat(o-r.length)}  ${n[r]}`).join(`
                  `)}formatWorkspaceMetadata(n){const o=[],r=[];return n.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(o.push(`|  Window (${s.title})`),s.folderURIs.forEach(c=>{const u=D.URI.revive(c);if(u.scheme===k.Schemas.file){const S=u.fsPath;r.push(g(S,["node_modules",".git"]).then(A=>{let M=`${A.fileCount} files`;A.maxFilesReached&&(M=`more than ${M}`),o.push(`|    Folder (${(0,w.basename)(S)}): ${M}`),o.push(this.formatWorkspaceStats(A))}).catch(A=>{o.push(`|      Error: Unable to collect workspace stats for folder ${S} (${A.toString()})`)}))}else o.push(`|    Folder (${u.toString()}): Workspace stats not available.`)}))}),Promise.all(r).then(s=>o.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}formatProcessList(n,o){const r=new Map;n.windows.forEach(c=>r.set(c.pid,c.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),o&&this.formatProcessItem(n.mainPID,r,s,o,0),s.join(`
`)}formatProcessItem(n,o,r,s,c){const u=c===0;let S;u?S=s.pid===n?`${this.productService.applicationName} main`:"remote agent":(S=`${"  ".repeat(c)} ${s.name}`,s.name==="window"&&(S=`${S} (${o.get(s.pid)})`));const A=process.platform==="win32"?s.mem:I.totalmem()*(s.mem/100);r.push(`${s.load.toFixed(0).padStart(5," ")}	${(A/d.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${S}`),Array.isArray(s.children)&&s.children.forEach(M=>this.formatProcessItem(n,o,r,M,c+1))}async getWorkspaceFileExtensions(n){const o=new Set;for(const{uri:r}of n.folders){const s=D.URI.revive(r);if(s.scheme!==k.Schemas.file)continue;const c=s.fsPath;try{(await g(c,["node_modules",".git"])).fileTypes.forEach(S=>o.add(S.name))}catch{}}return{extensions:[...o]}}async reportWorkspaceStats(n){for(const{uri:o}of n.folders){const r=D.URI.revive(o);if(r.scheme!==k.Schemas.file)continue;const s=r.fsPath;try{const c=await g(s,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":n.telemetryId,rendererSessionId:n.rendererSessionId}),c.fileTypes.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:n.rendererSessionId,type:u.name,count:u.count})}),c.launchConfigFiles.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:n.rendererSessionId,type:u.name,count:u.count})}),c.configFiles.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:n.rendererSessionId,type:u.name,count:u.count})})}catch{}}}};i=Re([_e(0,y.ITelemetryService),_e(1,C.IProductService)],i),e.DiagnosticsService=i}),define(ve[44],we([0,1,22,85,12,23,32]),function(oe,e,I,t,v,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPiiPathsFromEnvironment=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class w{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,t.staticObservableValue)(0)}publicLog(l,f){return Promise.resolve(void 0)}publicLog2(l,f){return this.publicLog(l,f)}publicLogError(l,f){return Promise.resolve(void 0)}publicLogError2(l,f){return this.publicLogError(l,f)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=w,e.NullTelemetryService=new w;class p{async publicLog(l,f,i){}async publicLogError(l,f,i){}}e.NullEndpointTelemetryService=p,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function D(h,l){return l.onDidChangeConfiguration(f=>{f.source!==6&&h.publicLog2("updateConfiguration",{configurationSource:(0,P.ConfigurationTargetToString)(f.source),configurationKeys:y(f.sourceConfig)})})}e.configurationTelemetry=D;function T(h,l){return!(l.disableTelemetry||!h.enableTelemetry||l.extensionTestsLocationURI)}e.supportsTelemetry=T;function R(h){const l=h.getValue(k.TELEMETRY_SETTING_ID),f=h.getValue("telemetry.enableCrashReporter");if(h.getValue(k.TELEMETRY_OLD_SETTING_ID)===!1||f===!1)return 0;switch(l??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=R;function E(h){const l={},f={},i={};C(h,i);for(let a in i){a=a.length>150?a.substr(a.length-149):a;const n=i[a];typeof n=="number"?f[a]=n:typeof n=="boolean"?f[a]=n?1:0:typeof n=="string"?(n.length>8192&&console.warn(`Telemetry property: ${a} has been trimmed to 8192, the original length is ${n.length}`),l[a]=n.substring(0,8191)):typeof n!="undefined"&&n!==null&&(l[a]=n)}return{properties:l,measurements:f}}e.validateTelemetryData=E;const b=["ssh-remote","dev-container","attached-container","wsl","tunneling"];function d(h){if(!h)return"none";for(const l of b)if(h.startsWith(`${l}+`))return l;return"other"}e.cleanRemoteAuthority=d;function C(h,l,f=0,i){if(!!h)for(const a of Object.getOwnPropertyNames(h)){const n=h[a],o=i?i+a:a;Array.isArray(n)?l[o]=(0,I.safeStringify)(n):n instanceof Date?l[o]=n.toISOString():(0,v.isObject)(n)?f<2?C(n,l,f+1,o+"."):l[o]=(0,I.safeStringify)(n):l[o]=n}}function y(h){if(!h)return[];const l=[];return m(l,"",h),l}function m(h,l,f){f&&typeof f=="object"&&!Array.isArray(f)?Object.keys(f).forEach(i=>m(h,l?`${l}.${i}`:i,f[i])):h.push(l)}function g(h){return[h.appRoot,h.extensionsPath,h.userHome.fsPath,h.tmpDir.fsPath,h.userDataPath]}e.getPiiPathsFromEnvironment=g}),define(ve[220],we([0,1,192,44]),function(oe,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function v(P,k,w,p,D,T,R){const E={"X-Market-Client-Id":`VSCode ${P}`,"User-Agent":`VSCode ${P} (${k.nameShort})`},b=await(0,I.getServiceMachineId)(w,D,T),{sessionId:d}=await R.getTelemetryInfo();return(0,t.supportsTelemetry)(k,w)&&(0,t.getTelemetryLevel)(p)===3&&(E["X-Market-User-Id"]=b,E["VSCode-SessionId"]=d),E}e.resolveMarketplaceHeaders=v}),define(ve[221],we([0,1,2,22,85,3,15,176,23,53,52,25,34,32,44]),function(oe,e,I,t,v,P,k,w,p,D,T,R,E,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let C=class{constructor(g,h,l){this._configurationService=h,this._productService=l,this._experimentProperties={},this.telemetryLevel=new v.MutableObservableValue(3),this._disposables=new I.DisposableStore,this._cleanupPatterns=[],this._appenders=g.appenders,this._commonProperties=g.commonProperties||Promise.resolve({}),this._piiPaths=g.piiPaths||[],this._sendErrorTelemetry=!!g.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(const f of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,k.escapeRegExpCharacters)(f),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(g,h){this._experimentProperties[g]=h}_updateTelemetryLevel(){let g=(0,d.getTelemetryLevel)(this._configurationService);const h=this._productService.enabledTelemetryLevels;if(h){this._sendErrorTelemetry=this.sendErrorTelemetry?h.error:!1;const l=h.usage?3:h.error?2:0;g=Math.min(g,l)}this.telemetryLevel.value=g}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const g=await this._commonProperties,h=g.sessionID,l=g["common.machineId"],f=g["common.firstSessionDate"],i=g["common.msftInternal"];return{sessionId:h,machineId:l,firstSessionDate:f,msftInternal:i}}dispose(){this._disposables.dispose()}_log(g,h,l,f){return this.telemetryLevel.value<h?Promise.resolve(void 0):this._commonProperties.then(i=>{l=(0,t.mixin)(l,i),l=(0,t.mixin)(l,this._experimentProperties),l=(0,t.cloneAndChange)(l,a=>{if(typeof a=="string")return this._cleanupInfo(a,f)}),this._appenders.forEach(a=>a.log(g,l))},i=>{console.error(i)})}publicLog(g,h,l){return this._log(g,3,h,l)}publicLog2(g,h,l){return this.publicLog(g,h,l)}publicLogError(g,h){return this._sendErrorTelemetry?this._log(g,2,h,!0):Promise.resolve(void 0)}publicLogError2(g,h){return this.publicLogError(g,h)}_anonymizeFilePaths(g){let h=g;const l=[];for(const n of this._cleanupPatterns)for(;;){const o=n.exec(g);if(!o)break;l.push([o.index,n.lastIndex])}const f=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,i=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let a=0;for(h="";;){const n=i.exec(g);if(!n)break;!f.test(n[0])&&l.every(([o,r])=>n.index<o||n.index>=r)&&(h+=g.substring(a,n.index)+"<REDACTED: user-file-path>",a=i.lastIndex)}return a<g.length&&(h+=g.substr(a)),h}_removePropertiesWithPossibleUserInfo(g){if(!g)return g;const h=g.toLowerCase(),l=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-.]+/}];for(const f of l)if(f.regex.test(h))return`<REDACTED: ${f.label}>`;return g}_cleanupInfo(g,h){let l=g;h&&(l=this._anonymizeFilePaths(l));for(const f of this._cleanupPatterns)l=l.replace(f,"");return l=this._removePropertiesWithPossibleUserInfo(l),l}};C.IDLE_START_EVENT_NAME="UserIdleStart",C.IDLE_STOP_EVENT_NAME="UserIdleStop",C=Re([_e(1,p.IConfigurationService),_e(2,R.IProductService)],C),e.TelemetryService=C;function y(){const m=(0,w.localize)(0,null,T.default.nameLong),g=T.default.privacyStatementUrl?(0,w.localize)(2,null,"https://aka.ms/vscode-telemetry",T.default.privacyStatementUrl):(0,w.localize)(1,null,"https://aka.ms/vscode-telemetry"),h=P.isWeb?"":(0,w.localize)(3,null),l=(0,w.localize)(4,null),f=(0,w.localize)(5,null),i=(0,w.localize)(6,null),a=(0,w.localize)(7,null),n=`
|       | ${l} | ${f} | ${i} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,o=(0,w.localize)(8,null);return`
${m} ${g} ${h}

&nbsp;

${a}
${n}

&nbsp;

${o}
`}E.Registry.as(D.Extensions.Configuration).registerConfiguration({id:b.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,w.localize)(9,null),properties:{[b.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,w.localize)(10,null),(0,w.localize)(11,null),(0,w.localize)(12,null),(0,w.localize)(13,null)],markdownDescription:y(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),E.Registry.as(D.Extensions.Configuration).registerConfiguration({id:b.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,w.localize)(14,null),properties:{[b.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:T.default.privacyStatementUrl?(0,w.localize)(16,null,T.default.nameLong,T.default.privacyStatementUrl):(0,w.localize)(15,null,T.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,w.localize)(17,null,`\`#${b.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ve[222],we([0,1,23,6,25,32,221,44]),function(oe,e,I,t,v,P,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IServerTelemetryService=e.ServerNullTelemetryService=e.ServerTelemetryService=void 0;let p=class extends k.TelemetryService{constructor(T,R,E,b){super(T,E,b);this._injectedTelemetryLevel=R}publicLog(T,R,E){return this._injectedTelemetryLevel<3?Promise.resolve(void 0):super.publicLog(T,R,E)}publicLog2(T,R,E){return this.publicLog(T,R,E)}publicLogError(T,R){return this._injectedTelemetryLevel<2?Promise.resolve(void 0):super.publicLogError(T,R)}publicLogError2(T,R){return this.publicLogError(T,R)}async updateInjectedTelemetryLevel(T){if(T===void 0)throw this._injectedTelemetryLevel=0,new Error("Telemetry level cannot be undefined. This will cause infinite looping!");this._injectedTelemetryLevel=this._injectedTelemetryLevel?Math.min(this._injectedTelemetryLevel,T):T,this._injectedTelemetryLevel===0&&this.dispose()}};p=Re([_e(2,I.IConfigurationService),_e(3,v.IProductService)],p),e.ServerTelemetryService=p,e.ServerNullTelemetryService=new class extends w.NullTelemetryServiceShape{async updateInjectedTelemetryLevel(){}},e.IServerTelemetryService=(0,t.refineServiceDecorator)(P.ITelemetryService)}),define(ve[223],we([0,1,11,22,44]),function(oe,e,I,t,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function P(w){const p=await new Promise((T,R)=>{oe(["applicationinsights"],T,R)});let D;return p.defaultClient?(D=new p.TelemetryClient(w),D.channel.setUseDiskRetryCaching(!0)):(p.setup(w).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),D=p.defaultClient),w.indexOf("AIF-")===0&&(D.config.endpointUrl="https://mobile.events.data.microsoft.com/collect/v1"),D}class k{constructor(p,D,T){this._eventPrefix=p,this._defaultData=D,this._defaultData||(this._defaultData=Object.create(null)),typeof T=="function"?this._aiClient=T():this._aiClient=T,this._asyncAIClient=null}_withAIClient(p){if(!!this._aiClient){if(typeof this._aiClient!="string"){p(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=P(this._aiClient)),this._asyncAIClient.then(D=>{p(D)},D=>{(0,I.onUnexpectedError)(D),console.error(D)})}}log(p,D){if(!!this._aiClient){D=(0,t.mixin)(D,this._defaultData),D=(0,v.validateTelemetryData)(D);try{this._withAIClient(T=>T.trackEvent({name:this._eventPrefix+"/"+p,properties:D.properties,measurements:D.measurements}))}catch{}}}flush(){return this._aiClient?new Promise(p=>{this._withAIClient(D=>{try{D.flush({callback:()=>{this._aiClient=void 0,p(void 0)}})}catch{}})}):Promise.resolve(void 0)}}e.AppInsightsAppender=k}),define(ve[224],we([0,1,11,217]),function(oe,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class v extends t.default{installErrorListeners(){(0,I.setUnexpectedErrorHandler)(w=>console.error(w));const k=[];process.on("unhandledRejection",(w,p)=>{k.push(p),setTimeout(()=>{const D=k.indexOf(p);D>=0&&p.catch(T=>{k.splice(D,1),(0,I.isCancellationError)(T)||(console.warn(`rejected promise not handled within 1 second: ${T}`),T.stack&&console.warn(`stack trace: ${T.stack}`),w&&(0,I.onUnexpectedError)(w))})},1e3)}),process.on("rejectionHandled",w=>{const p=k.indexOf(w);p>=0&&k.splice(p,1)}),process.on("uncaughtException",w=>{(0,I.onUnexpectedError)(w)})}}e.default=v}),define(ve[225],we([0,1,14,20,7,2,13]),function(oe,e,I,t,v,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let w=class extends P.Disposable{constructor(D,T){super();this._logService=T,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new v.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=D===void 0?15e3:D}createRequest(D){return new Promise((T,R)=>{const E=++this._lastRequestId;this._pendingRequests.set(E,T),this._onCreateRequest.fire({requestId:E,...D});const b=new t.CancellationTokenSource;(0,I.timeout)(this._timeout,b.token).then(()=>R(`Request ${E} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(E,[(0,P.toDisposable)(()=>b.cancel())])})}acceptReply(D,T){const R=this._pendingRequests.get(D);R?(this._pendingRequests.delete(D),(0,P.dispose)(this._pendingRequestDisposables.get(D)||[]),this._pendingRequestDisposables.delete(D),R(T)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${D}`)}};w=Re([_e(1,k.ILogService)],w),e.RequestStore=w}),define(ve[107],we([0,1,6]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalLogConstants=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var t;(function(m){m.Shell="terminal.integrated.shell.",m.ShellArgs="terminal.integrated.shellArgs.",m.DefaultProfile="terminal.integrated.defaultProfile.",m.Profiles="terminal.integrated.profiles."})(t=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var v;(function(m){m.ShellLinux="terminal.integrated.shell.linux",m.ShellMacOs="terminal.integrated.shell.osx",m.ShellWindows="terminal.integrated.shell.windows",m.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",m.AutomationShellLinux="terminal.integrated.automationShell.linux",m.AutomationShellMacOs="terminal.integrated.automationShell.osx",m.AutomationShellWindows="terminal.integrated.automationShell.windows",m.AutomationProfileLinux="terminal.integrated.automationProfile.linux",m.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",m.AutomationProfileWindows="terminal.integrated.automationProfile.windows",m.ShellArgsLinux="terminal.integrated.shellArgs.linux",m.ShellArgsMacOs="terminal.integrated.shellArgs.osx",m.ShellArgsWindows="terminal.integrated.shellArgs.windows",m.ProfilesWindows="terminal.integrated.profiles.windows",m.ProfilesMacOs="terminal.integrated.profiles.osx",m.ProfilesLinux="terminal.integrated.profiles.linux",m.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",m.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",m.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",m.UseWslProfiles="terminal.integrated.useWslProfiles",m.TabsEnabled="terminal.integrated.tabs.enabled",m.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",m.TabsHideCondition="terminal.integrated.tabs.hideCondition",m.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",m.TabsShowActions="terminal.integrated.tabs.showActions",m.TabsLocation="terminal.integrated.tabs.location",m.TabsFocusMode="terminal.integrated.tabs.focusMode",m.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",m.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",m.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",m.CopyOnSelection="terminal.integrated.copyOnSelection",m.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",m.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",m.FontFamily="terminal.integrated.fontFamily",m.FontSize="terminal.integrated.fontSize",m.LetterSpacing="terminal.integrated.letterSpacing",m.LineHeight="terminal.integrated.lineHeight",m.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",m.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",m.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",m.BellDuration="terminal.integrated.bellDuration",m.FontWeight="terminal.integrated.fontWeight",m.FontWeightBold="terminal.integrated.fontWeightBold",m.CursorBlinking="terminal.integrated.cursorBlinking",m.CursorStyle="terminal.integrated.cursorStyle",m.CursorWidth="terminal.integrated.cursorWidth",m.Scrollback="terminal.integrated.scrollback",m.DetectLocale="terminal.integrated.detectLocale",m.DefaultLocation="terminal.integrated.defaultLocation",m.GpuAcceleration="terminal.integrated.gpuAcceleration",m.TerminalTitleSeparator="terminal.integrated.tabs.separator",m.TerminalTitle="terminal.integrated.tabs.title",m.TerminalDescription="terminal.integrated.tabs.description",m.RightClickBehavior="terminal.integrated.rightClickBehavior",m.Cwd="terminal.integrated.cwd",m.ConfirmOnExit="terminal.integrated.confirmOnExit",m.ConfirmOnKill="terminal.integrated.confirmOnKill",m.EnableBell="terminal.integrated.enableBell",m.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",m.AllowChords="terminal.integrated.allowChords",m.AllowMnemonics="terminal.integrated.allowMnemonics",m.EnvMacOs="terminal.integrated.env.osx",m.EnvLinux="terminal.integrated.env.linux",m.EnvWindows="terminal.integrated.env.windows",m.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",m.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",m.ShowExitAlert="terminal.integrated.showExitAlert",m.SplitCwd="terminal.integrated.splitCwd",m.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",m.WordSeparators="terminal.integrated.wordSeparators",m.EnableFileLinks="terminal.integrated.enableFileLinks",m.UnicodeVersion="terminal.integrated.unicodeVersion",m.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",m.LocalEchoEnabled="terminal.integrated.localEchoEnabled",m.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",m.LocalEchoStyle="terminal.integrated.localEchoStyle",m.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",m.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",m.CustomGlyphs="terminal.integrated.customGlyphs",m.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",m.InheritEnv="terminal.integrated.inheritEnv",m.ShowLinkHover="terminal.integrated.showLinkHover",m.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",m.AutoReplies="terminal.integrated.autoReplies",m.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",m.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",m.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",m.ShellIntegrationDecorationIcon="terminal.integrated.shellIntegration.decorationIcon",m.ShellIntegrationDecorationIconError="terminal.integrated.shellIntegration.decorationIconError",m.ShellIntegrationDecorationIconSuccess="terminal.integrated.shellIntegration.decorationIconSuccess",m.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history"})(v=e.TerminalSettingId||(e.TerminalSettingId={}));var P;(function(m){m.FileName="ptyhost"})(P=e.TerminalLogConstants||(e.TerminalLogConstants={}));var k;(function(m){m.PowerShell="pwsh",m.Bash="bash",m.Fish="fish",m.Sh="sh",m.Csh="csh",m.Ksh="ksh",m.Zsh="zsh"})(k=e.PosixShellType||(e.PosixShellType={}));var w;(function(m){m.CommandPrompt="cmd",m.PowerShell="pwsh",m.Wsl="wsl",m.GitBash="gitbash"})(w=e.WindowsShellType||(e.WindowsShellType={}));var p;(function(m){m[m.Api=0]="Api",m[m.Process=1]="Process",m[m.Sequence=2]="Sequence",m[m.Config=3]="Config"})(p=e.TitleEventSource||(e.TitleEventSource={}));var D;(function(m){m.LocalPty="localPty",m.PtyHost="ptyHost",m.Log="log",m.Heartbeat="heartbeat"})(D=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,I.createDecorator)("ptyService");var T;(function(m){m.Cwd="cwd",m.InitialCwd="initialCwd",m.FixedDimensions="fixedDimensions",m.Title="title",m.ShellType="shellType",m.HasChildProcesses="hasChildProcesses",m.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",m.OverrideDimensions="overrideDimensions",m.FailedShellIntegrationActivation="failedShellIntegrationActivation",m.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(T=e.ProcessPropertyType||(e.ProcessPropertyType={}));var R;(function(m){m[m.BeatInterval=5e3]="BeatInterval",m[m.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",m[m.SecondWaitMultiplier=1]="SecondWaitMultiplier",m[m.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(R=e.HeartbeatConstants||(e.HeartbeatConstants={}));var E;(function(m){m[m.Panel=1]="Panel",m[m.Editor=2]="Editor"})(E=e.TerminalLocation||(e.TerminalLocation={}));var b;(function(m){m.TerminalView="view",m.Editor="editor"})(b=e.TerminalLocationString||(e.TerminalLocationString={}));var d;(function(m){m[m.GraceTime=6e4]="GraceTime",m[m.ShortGraceTime=6e3]="ShortGraceTime"})(d=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var C;(function(m){m[m.HighWatermarkChars=1e5]="HighWatermarkChars",m[m.LowWatermarkChars=5e3]="LowWatermarkChars",m[m.CharCountAckSize=5e3]="CharCountAckSize"})(C=e.FlowControlConstants||(e.FlowControlConstants={}));var y;(function(m){m.GitBash="Git Bash",m.Pwsh="PowerShell"})(y=e.ProfileSource||(e.ProfileSource={}))}),define(ve[226],we([0,1,27,10,22,5,3,28,15,12,21]),function(oe,e,I,t,v,P,k,w,p,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shellIntegrationArgs=e.ShellIntegrationExecutable=e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function R(){const l=/(\d+)\.(\d+)\.(\d+)/g.exec(I.release());let f=0;return l&&l.length===4&&(f=parseInt(l[3])),f}e.getWindowsBuildNumber=R;async function E(l,f,i,a=w.env,n=T.Promises.exists){if(P.isAbsolute(l))return await n(l)?l:void 0;if(f===void 0&&(f=w.cwd()),P.dirname(l)!=="."){const c=P.join(f,l);return await n(c)?c:void 0}const r=(0,v.getCaseInsensitive)(a,"PATH");if(i===void 0&&(0,D.isString)(r)&&(i=r.split(P.delimiter)),i===void 0||i.length===0){const c=P.join(f,l);return await n(c)?c:void 0}for(const c of i){let u;if(P.isAbsolute(c)?u=P.join(c,l):u=P.join(f,c,l),await n(u))return u;if(k.isWindows){let S=u+".com";if(await n(S)||(S=u+".exe",await n(S)))return S}}const s=P.join(f,l);return await n(s)?s:void 0}e.findExecutable=E;function b(l,f,i){if(!f.enabled||!l.executable||l.isFeatureTerminal||l.hideFromUser||l.ignoreShellIntegration)return;const a=l.args,n=w.platform==="win32"?P.basename(l.executable).toLowerCase():P.basename(l.executable),o=P.dirname(t.FileAccess.asFileUri("",oe).fsPath);let r;const s={VSCODE_INJECTION:"1"};if(k.isWindows){if(n==="pwsh.exe")return!a||g(a)?r=e.shellIntegrationArgs.get(d.WindowsPwsh):m(a)&&(r=e.shellIntegrationArgs.get(d.WindowsPwshLogin)),r?(r&&(r=[...r],r[r.length-1]=(0,p.format)(r[r.length-1],o,"")),{newArgs:r,envMixin:s}):void 0;i.warn(`Shell integration cannot be enabled for executable "${l.executable}" and args`,l.args);return}switch(n){case"bash":return!a||a.length===0?r=e.shellIntegrationArgs.get(d.Bash):h(a)&&(s.VSCODE_SHELL_LOGIN="1",r=e.shellIntegrationArgs.get(d.Bash)),r?(r=[...r],r[r.length-1]=(0,p.format)(r[r.length-1],o),{newArgs:r,envMixin:s}):void 0;case"pwsh":return!a||g(a)?r=e.shellIntegrationArgs.get(d.Pwsh):m(a)&&(r=e.shellIntegrationArgs.get(d.PwshLogin)),r?(r=[...r],r[r.length-1]=(0,p.format)(r[r.length-1],o,""),{newArgs:r,envMixin:s}):void 0;case"zsh":{if(!a||a.length===0?r=e.shellIntegrationArgs.get(d.Zsh):h(a)?r=e.shellIntegrationArgs.get(d.ZshLogin):(a===e.shellIntegrationArgs.get(d.Zsh)||a===e.shellIntegrationArgs.get(d.ZshLogin))&&(r=a),!r)return;r=[...r],r[r.length-1]=(0,p.format)(r[r.length-1],o);const c=P.join(I.tmpdir(),"vscode-zsh");s.ZDOTDIR=c;const u=[];return u.push({source:P.join(o,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:P.join(c,".zshrc")}),u.push({source:P.join(o,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:P.join(c,".zprofile")}),u.push({source:P.join(o,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:P.join(c,".zshenv")}),u.push({source:P.join(o,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:P.join(c,".zlogin")}),{newArgs:r,envMixin:s,filesToCopy:u}}}i.warn(`Shell integration cannot be enabled for executable "${l.executable}" and args`,l.args)}e.getShellIntegrationInjection=b;var d;(function(l){l.WindowsPwsh="windows-pwsh",l.WindowsPwshLogin="windows-pwsh-login",l.Pwsh="pwsh",l.PwshLogin="pwsh-login",l.Zsh="zsh",l.ZshLogin="zsh-login",l.Bash="bash"})(d=e.ShellIntegrationExecutable||(e.ShellIntegrationExecutable={})),e.shellIntegrationArgs=new Map,e.shellIntegrationArgs.set(d.WindowsPwsh,["-noexit","-command",'. "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(d.WindowsPwshLogin,["-l","-noexit","-command",'. "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(d.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(d.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),e.shellIntegrationArgs.set(d.Zsh,["-i"]),e.shellIntegrationArgs.set(d.ZshLogin,["-il"]),e.shellIntegrationArgs.set(d.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const C=["-login","-l"],y=["-nol","-nologo"];function m(l){return typeof l=="string"?C.includes(l.toLowerCase()):l.length===1&&C.includes(l[0].toLowerCase())||l.length===2&&(C.includes(l[0].toLowerCase())||C.includes(l[1].toLowerCase()))&&(y.includes(l[0].toLowerCase())||y.includes(l[1].toLowerCase()))}function g(l){return typeof l=="string"?y.includes(l.toLowerCase()):l.length===0||l?.length===1&&y.includes(l[0].toLowerCase())}function h(l){return l==="string"&&C.includes(l.toLowerCase())||typeof l!="string"&&l.length===1&&C.includes(l[0].toLowerCase())}}),define(ve[227],we([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var I;(function(P){P.DARK="dark",P.LIGHT="light",P.HIGH_CONTRAST_DARK="hcDark",P.HIGH_CONTRAST_LIGHT="hcLight"})(I=e.ColorScheme||(e.ColorScheme={}));function t(P){return P===I.HIGH_CONTRAST_DARK||P===I.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function v(P){return P===I.DARK||P===I.HIGH_CONTRAST_DARK}e.isDark=v}),define(ve[108],we([0,1,40,7,2,6,34,227]),function(oe,e,I,t,v,P,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,P.createDecorator)("themeService");var p;(function(y){function m(g){return g&&typeof g=="object"&&typeof g.id=="string"}y.isThemeColor=m})(p=e.ThemeColor||(e.ThemeColor={}));function D(y){return{id:y}}e.themeColorFromId=D;var T;(function(y){function m(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(typeof o.color=="undefined"||p.isThemeColor(o.color))}y.isThemeIcon=m;const g=new RegExp(`^\\$\\((${I.CSSIcon.iconNameExpression}(?:${I.CSSIcon.iconModifierExpression})?)\\)$`);function h(o){const r=g.exec(o);if(!r)return;const[,s]=r;return{id:s}}y.fromString=h;function l(o){return{id:o}}y.fromId=l;function f(o,r){let s=o.id;const c=s.lastIndexOf("~");return c!==-1&&(s=s.substring(0,c)),r&&(s=`${s}~${r}`),{id:s}}y.modify=f;function i(o){const r=o.id.lastIndexOf("~");if(r!==-1)return o.id.substring(r+1)}y.getModifier=i;function a(o,r){return o.id===r.id&&o.color?.id===r.color?.id}y.isEqual=a;function n(o,r){return{id:o.id,color:r?D(r):void 0}}y.asThemeIcon=n,y.asClassNameArray=I.CSSIcon.asClassNameArray,y.asClassName=I.CSSIcon.asClassName,y.asCSSSelector=I.CSSIcon.asCSSSelector})(T=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=I.Codicon.file,e.FolderThemeIcon=I.Codicon.folder;function R(y){switch(y){case w.ColorScheme.DARK:return"vs-dark";case w.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case w.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=R,e.Extensions={ThemingContribution:"base.contributions.theming"};class E{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(m){return this.themingParticipants.push(m),this.onThemingParticipantAddedEmitter.fire(m),(0,v.toDisposable)(()=>{const g=this.themingParticipants.indexOf(m);this.themingParticipants.splice(g,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const b=new E;k.Registry.add(e.Extensions.ThemingContribution,b);function d(y){return b.onColorThemeChange(y)}e.registerThemingParticipant=d;class C extends v.Disposable{constructor(m){super();this.themeService=m,this.theme=m.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(g=>this.onThemeChange(g)))}onThemeChange(m){this.theme=m,this.updateStyles()}updateStyles(){}getColor(m,g){let h=this.theme.getColor(m);return h&&g&&(h=g(h,this.theme)),h?h.toString():null}}e.Themable=C}),define(ve[228],we([0,1,40,4,178,108]),function(oe,e,I,t,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function k(E,b){const d=[{name:null,description:(0,v.localize)(0,null)}];return d.push(...E.map(C=>({name:C.profileName,description:w(C)}))),b&&d.push(...b.map(C=>({name:C.title,description:p(C)}))),{values:d.map(C=>C.name),markdownDescriptions:d.map(C=>C.description)}}e.createProfileSchemaEnums=k;function w(E){let b=`$(${P.ThemeIcon.isThemeIcon(E.icon)?E.icon.id:E.icon?E.icon:I.Codicon.terminal.id}) ${E.profileName}
- path: ${E.path}`;return E.args&&(typeof E.args=="string"?b+=`
- args: "${E.args}"`:b+=`
- args: [${E.args.length===0?"":`'${E.args.join("','")}'`}]`),E.overrideName!==void 0&&(b+=`
- overrideName: ${E.overrideName}`),E.color&&(b+=`
- color: ${E.color}`),E.env&&(b+=`
- env: ${JSON.stringify(E.env)}`),b}function p(E){return`$(${P.ThemeIcon.isThemeIcon(E.icon)?E.icon.id:E.icon?E.icon:I.Codicon.terminal.id}) ${E.title}
- extensionIdentifier: ${E.extensionIdentifier}`}function D(E,b){if(!E&&!b)return!0;if(typeof E=="string"&&typeof b=="string")return E===b;if(Array.isArray(E)&&Array.isArray(b)){if(E.length!==b.length)return!1;for(let d=0;d<E.length;d++)if(E[d]!==b[d])return!1;return!0}return!1}e.terminalProfileArgsMatch=D;function T(E,b){if(!E&&!b)return!0;if(!E||!b)return!1;if(P.ThemeIcon.isThemeIcon(E)&&P.ThemeIcon.isThemeIcon(b))return E.id===b.id&&E.color===b.color;if(typeof E=="object"&&E&&"light"in E&&"dark"in E&&typeof b=="object"&&b&&"light"in b&&"dark"in b){const d=E,C=b;if((t.URI.isUri(d.light)||R(d.light))&&(t.URI.isUri(d.dark)||R(d.dark))&&(t.URI.isUri(C.light)||R(C.light))&&(t.URI.isUri(C.dark)||R(C.dark)))return d.light.path===C.light.path&&d.dark.path===C.dark.path}if(t.URI.isUri(E)&&t.URI.isUri(b)||R(E)||R(b)){const d=E,C=b;return d.path===C.path&&d.scheme===C.scheme}return!1}e.terminalIconsEqual=T;function R(E){return E?typeof E.path=="string"&&typeof E.scheme=="string":!1}e.isUriComponents=R}),define(ve[229],we([0,1,40,177,53,34,228]),function(oe,e,I,t,v,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const w={args:{description:(0,t.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,t.localize)(1,null),type:"boolean"},icon:{description:(0,t.localize)(2,null),type:"string",enum:Array.from(I.Codicon.getAll(),l=>l.id),markdownEnumDescriptions:Array.from(I.Codicon.getAll(),l=>`$(${l.id})`)},color:{description:(0,t.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,t.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},p={type:"object",required:["path"],properties:{path:{description:(0,t.localize)(5,null),type:["string","array"],items:{type:"string"}},...w}},D={type:"object",required:["path"],properties:{path:{description:(0,t.localize)(6,null),type:["string"],items:{type:"string"}},...w}},T=(0,t.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),R=(0,t.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),E=(0,t.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),b=(0,t.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),d=(0,t.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),C=(0,t.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),y={id:"terminal",order:100,title:(0,t.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:b},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:d},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:C},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(17,null,"`#terminal.integrated.automationShell.linux#`"),type:["object","null"],default:null,anyOf:[{type:"null"},D],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(18,null,"`#terminal.integrated.automationShell.osx#`"),type:["object","null"],default:null,anyOf:[{type:"null"},D],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(19,null,"`#terminal.integrated.automationShell.windows#`"),type:["object","null"],default:null,anyOf:[{type:"null"},D],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:T},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:R},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:E},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:T},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:R},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,t.localize)(26,null)}},{type:"string",markdownDescription:(0,t.localize)(27,null)}],default:[],markdownDeprecationMessage:E},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,t.localize)(29,null),enum:["PowerShell","Git Bash"]},...w}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(30,null),type:"string"},id:{description:(0,t.localize)(31,null),type:"string"},title:{description:(0,t.localize)(32,null),type:"string"},...w}},{type:"null"},p]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(34,null),type:"string"},id:{description:(0,t.localize)(35,null),type:"string"},title:{description:(0,t.localize)(36,null),type:"string"},...w}},{type:"null"},p]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(38,null),type:"string"},id:{description:(0,t.localize)(39,null),type:"string"},title:{description:(0,t.localize)(40,null),type:"string"},...w}},{type:"null"},p]}},["terminal.integrated.useWslProfiles"]:{description:(0,t.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,t.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,t.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,t.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,t.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function m(){P.Registry.as(v.Extensions.Configuration).registerConfiguration(y),h()}e.registerTerminalPlatformConfiguration=m;let g;function h(l,f){const i=P.Registry.as(v.Extensions.Configuration);let a;l&&(a=(0,k.createProfileSchemaEnums)(l?.profiles,f));const n=g;g={id:"terminal",order:100,title:(0,t.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:l?.os===3?a?.values:void 0,markdownEnumDescriptions:l?.os===3?a?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:l?.os===2?a?.values:void 0,markdownEnumDescriptions:l?.os===2?a?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:l?.os===1?a?.values:void 0,markdownEnumDescriptions:l?.os===1?a?.markdownDescriptions:void 0}}},i.updateConfigurations({add:[g],remove:n?[n]:[]})}e.registerTerminalDefaultProfileConfiguration=h}),define(ve[230],we([0,1,42,40,5,3,21,90,226,108]),function(oe,e,I,t,v,P,k,w,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let T,R=!0;function E(a,n,o,r,s=process.env,c,u,S,A){return c=c||{existsFile:k.SymlinkSupport.existsFile,readFile:k.Promises.readFile},P.isWindows?b(o,c,s,u,r.getValue("terminal.integrated.useWslProfiles")!==!1,a&&typeof a=="object"?{...a}:r.getValue("terminal.integrated.profiles.windows"),typeof n=="string"?n:r.getValue("terminal.integrated.defaultProfile.windows"),A,S):l(c,u,o,a&&typeof a=="object"?{...a}:r.getValue(P.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof n=="string"?n:r.getValue(P.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),A,S,s)}e.detectAvailableProfiles=E;async function b(a,n,o,r,s,c,u,S,A){const M=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),$=`${process.env.windir}\\${M?"Sysnative":"System32"}`;let Q=!1;(0,p.getWindowsBuildNumber)()>=16299&&(Q=!0),await y(S);const _=new Map;a&&(_.set("PowerShell",{source:"PowerShell",icon:t.Codicon.terminalPowershell,isAutoDetected:!0}),_.set("Windows PowerShell",{path:`${$}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:t.Codicon.terminalPowershell,isAutoDetected:!0}),_.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),_.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),_.set("Command Prompt",{path:`${$}\\cmd.exe`,icon:t.Codicon.terminalCmd,isAutoDetected:!0})),f(c,_);const q=await d(_.entries(),u,n,o,r,A);if(a||!a&&s)try{const U=await g(`${$}\\${Q?"wsl":"bash"}.exe`,u);for(const ne of U)(!c||!(ne.profileName in c))&&q.push(ne)}catch{R&&(r?.info("WSL is not installed, so could not detect WSL profiles"),R=!1)}return q}async function d(a,n,o,r=process.env,s,c){const u=[];for(const[S,A]of a){if(A===null)continue;let M,$,Q;if("source"in A){const U=T?.get(A.source);if(!U)continue;M=U.paths,$=A.args||U.args,A.icon?Q=C(A.icon):U.icon&&(Q=U.icon)}else M=Array.isArray(A.path)?A.path:[A.path],$=P.isWindows||Array.isArray(A.args)?A.args:void 0,Q=C(A.icon);const _=await c?.(M)||M.slice(),q=await i(S,n,_,o,r,$,A.env,A.overrideName,A.isAutoDetected,s);q?(q.isAutoDetected=A.isAutoDetected,q.icon=Q,q.color=A.color,u.push(q)):s?.debug("Terminal profile not validated",S,M)}return s?.debug("Validated terminal profiles",u),u}function C(a){return typeof a=="string"?{id:a}:a}async function y(a){T&&!a||(T=new Map,T.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),T.set("PowerShell",{profileName:"PowerShell",paths:a||await m(),icon:D.ThemeIcon.asThemeIcon(t.Codicon.terminalPowershell)}))}async function m(){const a=[];for await(const n of(0,w.enumeratePowerShellInstallations)())a.push(n.exePath);return a}async function g(a,n){const o=[],r=await new Promise((u,S)=>{I.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(A,M)=>{if(A)return S("Problem occurred when getting wsl distros");u(M)})});if(!r)return[];const s=new RegExp(/[\r?\n]/),c=r.split(s).filter(u=>u.trim().length>0&&u!=="");for(const u of c){if(u===""||u.startsWith("docker-desktop"))continue;const S=`${u} (WSL)`,A={profileName:S,path:a,args:["-d",`${u}`],isDefault:S===n,icon:h(u),isAutoDetected:!1};o.push(A)}return o}function h(a){return a.includes("Ubuntu")?D.ThemeIcon.asThemeIcon(t.Codicon.terminalUbuntu):a.includes("Debian")?D.ThemeIcon.asThemeIcon(t.Codicon.terminalDebian):D.ThemeIcon.asThemeIcon(t.Codicon.terminalLinux)}async function l(a,n,o,r,s,c,u,S){const A=new Map;if(o){const M=(await a.readFile("/etc/shells")).toString(),$=c||M.split(`
`).filter(_=>_.trim().indexOf("#")!==0&&_.trim().length>0),Q=new Map;for(const _ of $){let q=(0,v.basename)(_),U=Q.get(q)||0;U++,U>1&&(q=`${q} (${U})`),Q.set(q,U),A.set(q,{path:_,isAutoDetected:!0})}}return f(r,A),await d(A.entries(),s,a,S,n,u)}function f(a,n){if(!!a)for(const[o,r]of Object.entries(a))r===null||!("path"in r)&&!("source"in r)?n.delete(o):(r.icon=r.icon||n.get(o)?.icon,n.set(o,r))}async function i(a,n,o,r,s,c,u,S,A,M){if(o.length===0)return Promise.resolve(void 0);const $=o.shift();if($==="")return i(a,n,o,r,s,c,u,S,A);const Q={profileName:a,path:$,args:c,env:u,overrideName:S,isAutoDetected:A,isDefault:a===n};if((0,v.basename)($)===$){const q=s.PATH?s.PATH.split(v.delimiter):void 0,U=await(0,p.findExecutable)($,void 0,q,void 0,r.existsFile);return U?(Q.path=U,Q.isFromPath=!0,Q):i(a,n,o,r,s,c)}return await r.existsFile((0,v.normalize)($))?Q:i(a,n,o,r,s,c,u,S,A)}}),define(ve[231],we([0,1,7,2,10,3,43,94,23,24,95,79,13,100,225,107,229,230]),function(oe,e,I,t,v,P,k,w,p,D,T,R,E,b,d,C,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var g;(function(f){f[f.MaxRestarts=5]="MaxRestarts"})(g||(g={}));let h=0,l=class extends t.Disposable{constructor(i,a,n,o){super();this._reconnectConstants=i,this._configurationService=a,this._environmentService=n,this._logService=o,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new I.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new I.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new I.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new I.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new I.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new I.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new I.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new I.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new I.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new I.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new I.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new I.Emitter),this.onProcessExit=this._onProcessExit.event,(0,y.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,t.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new d.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async r=>{r.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}initialize(){this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(P.isWindows)return process.env;try{return await(0,R.getResolvedShellEnv)(this._logService,{_:[]},process.env)}catch(i){return this._logService.error("ptyHost was unable to resolve shell environment",i),{}}}_startPtyHost(){const i={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this._environmentService.logsPath],env:{VSCODE_LAST_PTY_ID:h,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},a=(0,T.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);a&&(a.break&&a.port?i.debugBrk=a.port:!a.break&&a.port&&(i.debug=a.port));const n=new w.Client(v.FileAccess.asFileUri("bootstrap-fork",oe).fsPath,i);this._onPtyHostStart.fire(),k.ProxyChannel.toService(n.getChannel(C.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(n.onDidProcessExit(c=>{this._onPtyHostExit.fire(c.code),this._isDisposed||(this._restartCount<=g.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${c.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${c.code}, giving up`))}));const r=n.getChannel(C.TerminalIpcChannels.Log);b.LogLevelChannelClient.setLevel(r,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{b.LogLevelChannelClient.setLevel(r,this._logService.getLevel())}));const s=k.ProxyChannel.toService(n.getChannel(C.TerminalIpcChannels.PtyHost));return this._register(s.onProcessData(c=>this._onProcessData.fire(c))),this._register(s.onProcessReady(c=>this._onProcessReady.fire(c))),this._register(s.onProcessExit(c=>this._onProcessExit.fire(c))),this._register(s.onDidChangeProperty(c=>this._onDidChangeProperty.fire(c))),this._register(s.onProcessReplay(c=>this._onProcessReplay.fire(c))),this._register(s.onProcessOrphanQuestion(c=>this._onProcessOrphanQuestion.fire(c))),this._register(s.onDidRequestDetach(c=>this._onDidRequestDetach.fire(c))),[n,s]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(i,a,n,o,r,s,c,u,S,A,M){const $=setTimeout(()=>this._handleUnresponsiveCreateProcess(),C.HeartbeatConstants.CreateProcessTimeout),Q=await this._proxy.createProcess(i,a,n,o,r,s,c,u,S,A,M);return clearTimeout($),h=Math.max(h,Q),Q}updateTitle(i,a,n){return this._proxy.updateTitle(i,a,n)}updateIcon(i,a,n){return this._proxy.updateIcon(i,a,n)}attachToProcess(i){return this._proxy.attachToProcess(i)}detachFromProcess(i){return this._proxy.detachFromProcess(i)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(i){return this._proxy.start(i)}shutdown(i,a){return this._proxy.shutdown(i,a)}input(i,a){return this._proxy.input(i,a)}processBinary(i,a){return this._proxy.processBinary(i,a)}resize(i,a,n){return this._proxy.resize(i,a,n)}acknowledgeDataEvent(i,a){return this._proxy.acknowledgeDataEvent(i,a)}setUnicodeVersion(i,a){return this._proxy.setUnicodeVersion(i,a)}getInitialCwd(i){return this._proxy.getInitialCwd(i)}getCwd(i){return this._proxy.getCwd(i)}getLatency(i){return this._proxy.getLatency(i)}orphanQuestionReply(i){return this._proxy.orphanQuestionReply(i)}installAutoReply(i,a){return this._proxy.installAutoReply(i,a)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(i){return this._proxy.uninstallAutoReply(i)}getDefaultSystemShell(i){return this._proxy.getDefaultSystemShell(i)}async getProfiles(i,a,n,o=!1){const r=await this._shellEnv;return(0,m.detectAvailableProfiles)(a,n,o,this._configurationService,r,void 0,this._logService,this._resolveVariables.bind(this,i))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(i){return this._proxy.getWslPath(i)}setTerminalLayoutInfo(i){return this._proxy.setTerminalLayoutInfo(i)}async getTerminalLayoutInfo(i){return await this._proxy.getTerminalLayoutInfo(i)}async requestDetachInstance(i,a){return this._proxy.requestDetachInstance(i,a)}async acceptDetachInstanceReply(i,a){return this._proxy.acceptDetachInstanceReply(i,a)}async serializeTerminalState(i){return this._proxy.serializeTerminalState(i)}async reviveTerminalProcesses(i,a){return this._proxy.reviveTerminalProcesses(i,a)}async refreshProperty(i,a){return this._proxy.refreshProperty(i,a)}async updateProperty(i,a,n){return this._proxy.updateProperty(i,a,n)}async restartPtyHost(){this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),C.HeartbeatConstants.BeatInterval*C.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._isResponsive=!0,this._onPtyHostResponsive.fire())}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${C.HeartbeatConstants.BeatInterval*C.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),C.HeartbeatConstants.BeatInterval*C.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(C.HeartbeatConstants.BeatInterval*C.HeartbeatConstants.FirstWaitMultiplier+C.HeartbeatConstants.BeatInterval*C.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${C.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(i,a){return this._resolveVariablesRequestStore.createRequest({workspaceId:i,originalText:a})}async acceptPtyHostResolvedVariables(i,a){this._resolveVariablesRequestStore.acceptReply(i,a)}};l=Re([_e(1,p.IConfigurationService),_e(2,D.IEnvironmentService),_e(3,E.ILogService)],l),e.PtyHostService=l}),define(ve[39],we([0,1,6]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,I.createDecorator)("IUriIdentityService")}),define(ve[232],we([0,1,7,2,4,24,35,17,13,39]),function(oe,e,I,t,v,P,k,w,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let T=class extends t.Disposable{constructor(E,b,d,C,y){super();this.extensionsManagementService=E,this.logService=C,this.uriIdentityService=y,this._onDidChangeExtensionsByAnotherSource=this._register(new I.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled().then(g=>{this.installedExtensions=g.map(h=>h.identifier),this.startTimestamp=Date.now()}),this._register(E.onInstallExtension(g=>this.onInstallExtension(g))),this._register(E.onDidInstallExtensions(g=>this.onDidInstallExtensions(g))),this._register(E.onDidUninstallExtension(g=>this.onDidUninstallExtension(g)));const m=v.URI.file(d.extensionsPath);this._register(b.watch(m)),this._register(I.Event.filter(b.onDidFilesChange,g=>g.rawChanges.some(h=>this.doesChangeAffects(h,m)))(()=>this.onDidChange()))}doesChangeAffects(E,b){return E.type!==1&&E.type!==2||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(E.resource),b)?!1:this.uriIdentityService.extUri.isEqual(E.resource,this.uriIdentityService.extUri.joinPath(b,".obsolete"))?!0:!this.uriIdentityService.extUri.basename(E.resource).startsWith(".")}onInstallExtension(E){this.addInstallingExtension(E.identifier)}onDidInstallExtensions(E){for(const b of E)this.removeInstallingExtension(b.identifier),b.local&&this.addInstalledExtension(b.identifier)}onDidUninstallExtension(E){E.error||this.removeInstalledExtension(E.identifier)}addInstallingExtension(E){this.removeInstallingExtension(E),this.installingExtensions.push(E)}removeInstallingExtension(E){this.installingExtensions=this.installingExtensions.filter(b=>!(0,k.areSameExtensions)(b,E))}addInstalledExtension(E){this.installedExtensions&&(this.removeInstalledExtension(E),this.installedExtensions.push(E))}removeInstalledExtension(E){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(b=>!(0,k.areSameExtensions)(b,E)))}async onDidChange(){if(this.installedExtensions){const E=await this.extensionsManagementService.getInstalled(),b=E.filter(C=>[...this.installingExtensions,...this.installedExtensions].some(y=>(0,k.areSameExtensions)(y,C.identifier))?!1:C.installedTimestamp&&C.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",C.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",C.identifier.id),!1)),d=this.installedExtensions.filter(C=>this.installingExtensions.some(y=>(0,k.areSameExtensions)(y,C))?!1:E.every(y=>!(0,k.areSameExtensions)(y.identifier,C))?(this.logService.info("Detected extension removed from another source",C.id),!0):!1);this.installedExtensions=E.map(C=>C.identifier),(b.length||d.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:b,removed:d})}}};T=Re([_e(1,w.IFileService),_e(2,P.INativeEnvironmentService),_e(3,p.ILogService),_e(4,D.IUriIdentityService)],T),e.ExtensionsWatcher=T}),define(ve[109],we([0,1,39,193,17,19,134,7,2]),function(oe,e,I,t,v,P,k,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class D{constructor(E){this.uri=E,this.time=D._clock++}touch(){return this.time=D._clock++,this}}D._clock=0;let T=class{constructor(E){this._fileService=E,this._dispooables=new p.DisposableStore,this._limit=2**16;const b=new Map,d=C=>{let y=b.get(C.scheme);return y===void 0&&(y=E.hasProvider(C)&&!this._fileService.hasCapability(C,1024),b.set(C.scheme,y)),y};this._dispooables.add(w.Event.any(E.onDidChangeFileSystemProviderRegistrations,E.onDidChangeFileSystemProviderCapabilities)(C=>{b.delete(C.scheme)})),this.extUri=new P.ExtUri(d),this._canonicalUris=new k.SkipList((C,y)=>this.extUri.compare(C,y,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(E){this._fileService.hasProvider(E)&&(E=(0,P.normalizePath)(E));const b=this._canonicalUris.get(E);return b?b.touch().uri.with({fragment:E.fragment}):(this._canonicalUris.set(E,new D(E)),this._checkTrim(),E)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const E=[...this._canonicalUris.entries()].sort((d,C)=>d[1].touch<C[1].touch?1:d[1].touch>C[1].touch?-1:0);D._clock=0,this._canonicalUris.clear();const b=this._limit*.5;for(let d=0;d<b;d++)this._canonicalUris.set(E[d][0],E[d][1].touch())}};T=Re([_e(0,v.IFileService)],T),e.UriIdentityService=T,(0,t.registerSingleton)(I.IUriIdentityService,T,!0)}),define(ve[36],we([0,1,86,7,2,19,12,4,179,24,17,6,13]),function(oe,e,I,t,v,P,k,w,p,D,T,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.toUserDataProfile=e.EXTENSIONS_RESOURCE_NAME=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function b(m){const g=m;return!!(g&&typeof g=="object"&&typeof g.id=="string"&&typeof g.isDefault=="boolean"&&typeof g.name=="string"&&w.URI.isUri(g.location)&&w.URI.isUri(g.globalStorageHome)&&w.URI.isUri(g.settingsResource)&&w.URI.isUri(g.keybindingsResource)&&w.URI.isUri(g.tasksResource)&&w.URI.isUri(g.snippetsHome)&&((0,k.isUndefined)(g.extensionsResource)||w.URI.isUri(g.extensionsResource)))}e.isUserDataProfile=b,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,R.createDecorator)("IUserDataProfilesService");function d(m,g){return{id:m.id,isDefault:m.isDefault,name:m.name,location:w.URI.revive(m.location).with({scheme:g}),globalStorageHome:w.URI.revive(m.globalStorageHome).with({scheme:g}),settingsResource:w.URI.revive(m.settingsResource).with({scheme:g}),keybindingsResource:w.URI.revive(m.keybindingsResource).with({scheme:g}),tasksResource:w.URI.revive(m.tasksResource).with({scheme:g}),snippetsHome:w.URI.revive(m.snippetsHome).with({scheme:g}),extensionsResource:w.URI.revive(m.extensionsResource)?.with({scheme:g})}}e.reviveProfile=d,e.EXTENSIONS_RESOURCE_NAME="extensions.json";function C(m,g,h){return{id:(0,I.hash)(g.toString()).toString(16),name:m,location:g,isDefault:!1,globalStorageHome:(0,P.joinPath)(g,"globalStorage"),settingsResource:(0,P.joinPath)(g,"settings.json"),keybindingsResource:(0,P.joinPath)(g,"keybindings.json"),tasksResource:(0,P.joinPath)(g,"tasks.json"),snippetsHome:(0,P.joinPath)(g,"snippets"),extensionsResource:(0,P.joinPath)(g,e.EXTENSIONS_RESOURCE_NAME),useDefaultFlags:h}}e.toUserDataProfile=C;let y=class extends v.Disposable{constructor(g,h,l){super();this.environmentService=g,this.fileService=h,this.logService=l,this._defaultProfile=this.createDefaultUserDataProfile(!1),this._onDidChangeProfiles=this._register(new t.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this.profilesHome=(0,P.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}get defaultProfile(){return this.profiles[0]??this._defaultProfile}get profiles(){return[]}newProfile(g,h){return C(g,(0,P.joinPath)(this.profilesHome,(0,I.hash)(g).toString(16)),h)}createDefaultUserDataProfile(g){const h=C((0,p.localize)(0,null),this.environmentService.userRoamingDataHome);return{...h,isDefault:!0,extensionsResource:g?h.extensionsResource:void 0}}createProfile(g,h){throw new Error("Not implemented")}setProfileForWorkspace(g,h){throw new Error("Not implemented")}getProfile(g){throw new Error("Not implemented")}removeProfile(g){throw new Error("Not implemented")}};y=Re([_e(0,D.IEnvironmentService),_e(1,T.IFileService),_e(2,E.ILogService)],y),e.UserDataProfilesService=y}),define(ve[45],we([0,1,14,16,2,29,4,35,17,6,13,39,36]),function(oe,e,I,t,v,P,k,w,p,D,T,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,D.createDecorator)("IExtensionsProfileScannerService");let b=class extends v.Disposable{constructor(C,y,m,g){super();this.fileService=C,this.uriIdentityService=y,this.userDataProfilesService=m,this.logService=g,this.resourcesAccessQueueMap=new P.ResourceMap,this.migratePromise=this.migrate()}async migrate(){await Promise.all(this.userDataProfilesService.profiles.map(async C=>{if(!!C.extensionsResource)try{let y=!1;const m=JSON.parse((await this.fileService.readFile(C.extensionsResource)).value.toString());for(const g of m)if(!!g.location&&!g.version)try{const h=(await this.fileService.readFile(this.uriIdentityService.extUri.joinPath(k.URI.revive(g.location),"package.json"))).value.toString();g.version=JSON.parse(h).version,y=!0}catch{}y&&await this.fileService.writeFile(C.extensionsResource,t.VSBuffer.fromString(JSON.stringify(m)))}catch{}}))}scanProfileExtensions(C){return this.withProfileExtensions(C)}addExtensionsToProfile(C,y){return this.withProfileExtensions(y,m=>(m=m.filter(g=>C.some(([h])=>!(0,w.areSameExtensions)(g.identifier,h.identifier))),m.push(...C.map(([g,h])=>({identifier:g.identifier,version:g.manifest.version,location:g.location,metadata:h}))),m))}removeExtensionFromProfile(C,y){return this.withProfileExtensions(y,m=>m.filter(g=>!(0,w.areSameExtensions)(g.identifier,C)))}async withProfileExtensions(C,y){return await this.migratePromise,this.getResourceAccessQueue(C).queue(async()=>{let m=[];try{const g=await this.fileService.readFile(C),h=JSON.parse(g.value.toString());for(const l of h){if(!l.identifier){this.logService.info("Ignoring invalid extension while scanning. Identifier does not exist.",l);continue}if(!l.location){this.logService.info("Ignoring invalid extension while scanning. Location does not exist.",l);continue}if(!l.version){this.logService.info("Ignoring invalid extension while scanning. Version does not exist.",l);continue}m.push({identifier:l.identifier,location:k.URI.revive(l.location),version:l.version,metadata:l.metadata})}}catch(g){g.fileOperationResult!==1&&this.logService.error(g)}if(y){m=y(m);const g=m.map(h=>({identifier:h.identifier,version:h.version,location:h.location.toJSON(),metadata:h.metadata}));await this.fileService.writeFile(C,t.VSBuffer.fromString(JSON.stringify(g)))}return m})}getResourceAccessQueue(C){let y=this.resourcesAccessQueueMap.get(C);return y||(y=new I.Queue,this.resourcesAccessQueueMap.set(C,y)),y}};b=Re([_e(0,p.IFileService),_e(1,R.IUriIdentityService),_e(2,E.IUserDataProfilesService),_e(3,T.ILogService)],b),e.ExtensionsProfileScannerService=b}),define(ve[233],we([0,1,18,14,20,11,7,2,3,4,161,31,35,45,13,25,32,39,36]),function(oe,e,I,t,v,P,k,w,p,D,T,R,E,b,d,C,y,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let h=class extends w.Disposable{constructor(s,c,u,S,A,M,$){super();this.userDataProfilesService=s,this.uriIdenityService=c,this.galleryService=u,this.extensionsProfileScannerService=S,this.telemetryService=A,this.logService=M,this.productService=$,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new k.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new k.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new k.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new k.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,w.toDisposable)(()=>{this.installingExtensions.forEach(Q=>Q.cancel()),this.uninstallingExtensions.forEach(Q=>Q.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(s){const c=await this.getTargetPlatform();return s.allTargetPlatforms.some(u=>(0,R.isTargetPlatformCompatible)(u,s.allTargetPlatforms,c))}async installFromGallery(s,c={}){try{if(!this.galleryService.isEnabled())throw new R.ExtensionManagementError(T.localize(0,null),R.ExtensionManagementErrorCode.Internal);const u=await this.checkAndGetCompatibleVersion(s,!!c.installGivenVersion,!!c.installPreReleaseVersion);return await this.installExtension(u.manifest,u.extension,c)}catch(u){throw i(this.telemetryService,"extensionGallery:install",{extensionData:(0,E.getGalleryExtensionTelemetryData)(s),error:u}),this.logService.error("Failed to install extension.",s.identifier.id),this.logService.error(u),f(u)}}async uninstall(s,c={}){return this.logService.trace("ExtensionManagementService#uninstall",s.identifier.id),this.unininstallExtension(s,c)}async reinstallFromGallery(s){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",s.identifier.id),!this.galleryService.isEnabled())throw new Error(T.localize(1,null));const c=await this.getTargetPlatform(),[u]=await this.galleryService.getExtensions([{...s.identifier,preRelease:s.preRelease}],{targetPlatform:c,compatible:!0},v.CancellationToken.None);if(!u)throw new Error(T.localize(2,null));await this.createDefaultUninstallExtensionTask(s,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(u)}getExtensionsControlManifest(){const s=new Date().getTime();return(!this.extensionsControlManifest||s-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=s),this.extensionsControlManifest}registerParticipant(s){this.participants.push(s)}async installExtension(s,c,u){if(!D.URI.isUri(c)){const Q=this.installingExtensions.get(E.ExtensionKey.create(c).toString());if(Q){this.logService.info("Extensions is already requested to install",c.identifier.id);const _=this.createWaitUntilInstallExtensionTaskIsFinishedTask(Q,u),{local:q}=await _.waitUntilTaskIsFinished();return q}u={...u,installOnlyNewlyAddedFromExtensionPack:!0}}const S=[],A=[],M=this.createInstallExtensionTask(s,c,u);D.URI.isUri(c)||this.installingExtensions.set(E.ExtensionKey.create(c).toString(),M),this._onInstallExtension.fire({identifier:M.identifier,source:c,profileLocation:u.profileLocation}),this.logService.info("Installing extension:",M.identifier.id),S.push({task:M,manifest:s});let $=!1;try{if(u.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",M.identifier.id);else try{const _=await this.getAllDepsAndPackExtensionsToInstall(M.identifier,s,!!u.installOnlyNewlyAddedFromExtensionPack,!!u.installPreReleaseVersion,u.profileLocation);for(const{gallery:q,manifest:U}of _){$=$||!!U.extensionDependencies?.some(Z=>(0,E.areSameExtensions)({id:Z},M.identifier));const ne=E.ExtensionKey.create(q).toString();if(this.installingExtensions.has(ne))this.logService.info("Extension is already requested to install",q.identifier.id);else{const Z=this.createInstallExtensionTask(U,q,{...u,donotIncludePackAndDependencies:!0});this.installingExtensions.set(ne,Z),this._onInstallExtension.fire({identifier:Z.identifier,source:q,profileLocation:u.profileLocation}),this.logService.info("Installing extension:",Z.identifier.id),S.push({task:Z,manifest:U})}}}catch(_){if(D.URI.isUri(M.source))(0,I.isNonEmptyArray)(s.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",M.identifier.id,_.message),(0,I.isNonEmptyArray)(s.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",M.identifier.id,_.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",M.identifier.id),_}const Q=S.reduce((_,{task:q,manifest:U})=>(_.set(q.identifier.id.toLowerCase(),{task:q,manifest:U}),_),new Map);for(;Q.size;){let _;const q=[...Q.values()].filter(({manifest:U})=>!U.extensionDependencies?.some(ne=>Q.has(ne.toLowerCase())));q.length?_=Q.size===1?q:q.filter(({task:U})=>!(U===M&&!$)):(this.logService.info("Found extensions with circular dependencies",q.map(({task:U})=>U.identifier.id)),_=[...Q.values()]),await this.joinAllSettled(_.map(async({task:U})=>{const ne=new Date().getTime();try{const{local:Z}=await U.run();if(await this.joinAllSettled(this.participants.map(F=>F.postInstall(Z,U.source,u,v.CancellationToken.None))),!D.URI.isUri(U.source)){const F=U.operation===3,x=F?void 0:(new Date().getTime()-U.source.lastUpdated)/1e3;if(i(this.telemetryService,F?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,E.getGalleryExtensionTelemetryData)(U.source),duration:new Date().getTime()-ne,durationSinceUpdate:x}),p.isWeb&&U.operation!==3)try{await this.galleryService.reportStatistic(Z.manifest.publisher,Z.manifest.name,Z.manifest.version,"install")}catch{}}A.push({local:Z,identifier:U.identifier,operation:U.operation,source:U.source,context:u.context,profileLocation:u.profileLocation,applicationScoped:Z.isApplicationScoped})}catch(Z){throw D.URI.isUri(U.source)||i(this.telemetryService,U.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,E.getGalleryExtensionTelemetryData)(U.source),duration:new Date().getTime()-ne,error:Z}),this.logService.error("Error while installing the extension:",U.identifier.id),Z}finally{Q.delete(U.identifier.id.toLowerCase())}}))}return A.forEach(({identifier:_})=>this.logService.info("Extension installed successfully:",_.id)),this._onDidInstallExtensions.fire(A),A.filter(({identifier:_})=>(0,E.areSameExtensions)(_,M.identifier))[0].local}catch(Q){if(S.forEach(({task:_})=>_.cancel()),A.length)try{const _=await Promise.allSettled(A.map(({local:q})=>this.createUninstallExtensionTask(q,{versionOnly:!0},u.profileLocation).run()));for(let q=0;q<_.length;q++){const U=_[q],{identifier:ne}=A[q];U.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",ne.id):this.logService.warn("Rollback: Error while uninstalling extension",ne.id,(0,P.getErrorMessage)(U.reason))}}catch(_){this.logService.warn("Error while rolling back extensions",(0,P.getErrorMessage)(_),A.map(({identifier:q})=>q.id))}throw this._onDidInstallExtensions.fire(S.map(({task:_})=>({identifier:_.identifier,operation:2,source:_.source,context:u.context,profileLocation:u.profileLocation}))),Q}finally{for(const{task:Q}of S)if(!D.URI.isUri(Q.source)){const _=E.ExtensionKey.create(Q.source).toString();this.installingExtensions.delete(_)||this.logService.warn("Installation task is not found in the cache",_)}}}async joinAllSettled(s){const c=[],u=[],S=await Promise.allSettled(s);for(const A of S)A.status==="fulfilled"?c.push(A.value):u.push(A.reason);if(u.length)throw l(u);return c}async getAllDepsAndPackExtensionsToInstall(s,c,u,S,A){if(!this.galleryService.isEnabled())return[];let M=await this.getInstalled(void 0,A);const $=[s,...M.map(q=>q.identifier)],Q=[],_=async(q,U)=>{const ne=U.extensionDependencies||[],Z=[...ne];if(U.extensionPack){const F=u?M.find(x=>(0,E.areSameExtensions)(x.identifier,q)):void 0;for(const x of U.extensionPack)F&&F.manifest.extensionPack&&F.manifest.extensionPack.some(z=>(0,E.areSameExtensions)({id:z},{id:x}))||Z.every(z=>!(0,E.areSameExtensions)({id:z},{id:x}))&&Z.push(x)}if(Z.length){const F=[...$,...Q.map(z=>z.gallery.identifier)],x=Z.filter(z=>F.every(W=>!(0,E.areSameExtensions)(W,{id:z})));if(x.length){const z=await this.galleryService.getExtensions(x.map(W=>({id:W,preRelease:S})),v.CancellationToken.None);for(const W of z){if(F.find(X=>(0,E.areSameExtensions)(X,W.identifier)))continue;const re=ne.some(X=>(0,E.areSameExtensions)({id:X},W.identifier));let V;try{V=await this.checkAndGetCompatibleVersion(W,!1,S)}catch(X){if(X instanceof R.ExtensionManagementError&&X.code===R.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!re){this.logService.info("Skipping the packed extension as it cannot be installed",W.identifier.id);continue}else throw X}Q.push({gallery:V.extension,manifest:V.manifest}),await _(V.extension.identifier,V.manifest)}}}};return await _(s,c),M=await this.getInstalled(void 0,A),Q.filter(q=>!M.some(U=>(0,E.areSameExtensions)(U.identifier,q.gallery.identifier)))}async checkAndGetCompatibleVersion(s,c,u){const S=await this.getExtensionsControlManifest();if((0,E.getMaliciousExtensionsSet)(S).has(s.identifier.id))throw new R.ExtensionManagementError(T.localize(3,null,s.identifier.id),R.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(s)){const $=await this.getTargetPlatform();throw new R.ExtensionManagementError(T.localize(4,null,s.identifier.id,this.productService.nameLong,(0,R.TargetPlatformToString)($)),R.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const A=await this.getCompatibleVersion(s,c,u);if(A){if(u&&!c&&s.hasPreReleaseVersion&&!A.properties.isPreReleaseVersion)throw new R.ExtensionManagementError(T.localize(5,null,s.identifier.id,this.productService.nameLong,this.productService.version),R.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!u&&s.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([s.identifier],v.CancellationToken.None))[0]?new R.ExtensionManagementError(T.localize(6,null,s.identifier.id),R.ExtensionManagementErrorCode.ReleaseVersionNotFound):new R.ExtensionManagementError(T.localize(7,null,s.identifier.id,this.productService.nameLong,this.productService.version),R.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",A.identifier.id);const M=await this.galleryService.getManifest(A,v.CancellationToken.None);if(M===null)throw new R.ExtensionManagementError(`Missing manifest for extension ${s.identifier.id}`,R.ExtensionManagementErrorCode.Invalid);if(M.version!==A.version)throw new R.ExtensionManagementError(`Cannot install '${s.identifier.id}' extension because of version mismatch in Marketplace`,R.ExtensionManagementErrorCode.Invalid);return{extension:A,manifest:M}}async getCompatibleVersion(s,c,u){const S=await this.getTargetPlatform();let A=null;return!c&&s.hasPreReleaseVersion&&s.properties.isPreReleaseVersion!==u&&(A=(await this.galleryService.getExtensions([{...s.identifier,preRelease:u}],{targetPlatform:S,compatible:!0},v.CancellationToken.None))[0]||null),!A&&await this.galleryService.isExtensionCompatible(s,u,S)&&(A=s),A||(c?A=(await this.galleryService.getExtensions([{...s.identifier,version:s.version}],{targetPlatform:S,compatible:!0},v.CancellationToken.None))[0]||null:A=await this.galleryService.getCompatibleExtension(s,u,S)),A}async unininstallExtension(s,c){const u=_=>`${_.id.toLowerCase()}${c.profileLocation?`@${c.profileLocation.toString()}`:""}`,S=this.uninstallingExtensions.get(u(s.identifier));if(S)return this.logService.info("Extensions is already requested to uninstall",s.identifier.id),S.waitUntilTaskIsFinished();const A=(_,q)=>{const U=this.createUninstallExtensionTask(_,q,c.profileLocation);return this.uninstallingExtensions.set(u(U.extension.identifier),U),c.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${_.identifier.id}@${_.manifest.version}`,c.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${_.identifier.id}@${_.manifest.version}`),this._onUninstallExtension.fire({identifier:_.identifier,profileLocation:c.profileLocation,applicationScoped:_.isApplicationScoped}),U},M=(_,q)=>{q?c.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${_.identifier.id}@${_.manifest.version}`,c.profileLocation.toString(),q.message):this.logService.error("Failed to uninstall extension:",`${_.identifier.id}@${_.manifest.version}`,q.message):c.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${_.identifier.id}@${_.manifest.version}`,c.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${_.identifier.id}@${_.manifest.version}`),i(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,E.getLocalExtensionTelemetryData)(_),error:q}),this._onDidUninstallExtension.fire({identifier:_.identifier,version:_.manifest.version,error:q?.code,profileLocation:c.profileLocation,applicationScoped:_.isApplicationScoped})},$=[],Q=[];try{$.push(A(s,c));const _=await this.getInstalled(1,c.profileLocation);if(c.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${s.identifier.id}@${s.manifest.version}`);else{const q=this.getAllPackExtensionsToUninstall(s,_);for(const U of q)this.uninstallingExtensions.has(u(U.identifier))?this.logService.info("Extensions is already requested to uninstall",U.identifier.id):$.push(A(U,c))}c.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${s.identifier.id}@${s.manifest.version}`):this.checkForDependents($.map(q=>q.extension),_,s),await this.joinAllSettled($.map(async q=>{try{if(await q.run(),await this.joinAllSettled(this.participants.map(U=>U.postUninstall(q.extension,c,v.CancellationToken.None))),q.extension.identifier.uuid)try{await this.galleryService.reportStatistic(q.extension.manifest.publisher,q.extension.manifest.name,q.extension.manifest.version,"uninstall")}catch{}M(q.extension)}catch(U){const ne=U instanceof R.ExtensionManagementError?U:new R.ExtensionManagementError((0,P.getErrorMessage)(U),R.ExtensionManagementErrorCode.Internal);throw M(q.extension,ne),ne}finally{Q.push(q)}}))}catch(_){const q=_ instanceof R.ExtensionManagementError?_:new R.ExtensionManagementError((0,P.getErrorMessage)(_),R.ExtensionManagementErrorCode.Internal);for(const U of $){try{U.cancel()}catch{}Q.includes(U)||M(U.extension,q)}throw q}finally{for(const _ of $)this.uninstallingExtensions.delete(u(_.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",_.extension.identifier.id)}}checkForDependents(s,c,u){for(const S of s){const A=this.getDependents(S,c);if(A.length){const M=A.filter($=>!s.some(Q=>(0,E.areSameExtensions)(Q.identifier,$.identifier)));if(M.length)throw new Error(this.getDependentsErrorMessage(S,M,u))}}}getDependentsErrorMessage(s,c,u){return u===s?c.length===1?T.localize(8,null,u.manifest.displayName||u.manifest.name,c[0].manifest.displayName||c[0].manifest.name):c.length===2?T.localize(9,null,u.manifest.displayName||u.manifest.name,c[0].manifest.displayName||c[0].manifest.name,c[1].manifest.displayName||c[1].manifest.name):T.localize(10,null,u.manifest.displayName||u.manifest.name,c[0].manifest.displayName||c[0].manifest.name,c[1].manifest.displayName||c[1].manifest.name):c.length===1?T.localize(11,null,u.manifest.displayName||u.manifest.name,s.manifest.displayName||s.manifest.name,c[0].manifest.displayName||c[0].manifest.name):c.length===2?T.localize(12,null,u.manifest.displayName||u.manifest.name,s.manifest.displayName||s.manifest.name,c[0].manifest.displayName||c[0].manifest.name,c[1].manifest.displayName||c[1].manifest.name):T.localize(13,null,u.manifest.displayName||u.manifest.name,s.manifest.displayName||s.manifest.name,c[0].manifest.displayName||c[0].manifest.name,c[1].manifest.displayName||c[1].manifest.name)}getAllPackExtensionsToUninstall(s,c,u=[]){if(u.indexOf(s)!==-1)return[];u.push(s);const S=s.manifest.extensionPack?s.manifest.extensionPack:[];if(S.length){const A=c.filter($=>!$.isBuiltin&&S.some(Q=>(0,E.areSameExtensions)({id:Q},$.identifier))),M=[];for(const $ of A)M.push(...this.getAllPackExtensionsToUninstall($,c,u));return[...A,...M]}return[]}getDependents(s,c){return c.filter(u=>u.manifest.extensionDependencies&&u.manifest.extensionDependencies.some(S=>(0,E.areSameExtensions)({id:S},s.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const s=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",s),s}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}createInstallExtensionTask(s,c,u){const S=this.createDefaultInstallExtensionTask(s,c,u);return u.profileLocation&&this.userDataProfilesService.defaultProfile.extensionsResource?new n(S,u.profileLocation,this.userDataProfilesService.defaultProfile.extensionsResource,this.extensionsProfileScannerService):S}createWaitUntilInstallExtensionTaskIsFinishedTask(s,c){return!c.profileLocation||!this.userDataProfilesService.defaultProfile.extensionsResource||s instanceof n&&this.uriIdenityService.extUri.isEqual(s.profileLocation,c.profileLocation)?s:new n(s,c.profileLocation,this.userDataProfilesService.defaultProfile.extensionsResource,this.extensionsProfileScannerService)}createUninstallExtensionTask(s,c,u){return u&&this.userDataProfilesService.defaultProfile.extensionsResource?new o(s,u,this.userDataProfilesService,this.extensionsProfileScannerService):this.createDefaultUninstallExtensionTask(s,c)}};h=Re([_e(0,g.IUserDataProfilesService),_e(1,m.IUriIdentityService),_e(2,R.IExtensionGalleryService),_e(3,b.IExtensionsProfileScannerService),_e(4,y.ITelemetryService),_e(5,d.ILogService),_e(6,C.IProductService)],h),e.AbstractExtensionManagementService=h;function l(r){const s=Array.isArray(r)?r:[r];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((c,u)=>new Error(`${c.message}${c.message?",":""}${u instanceof Error?u.message:u}`),new Error(""))}e.joinErrors=l;function f(r){if(r instanceof R.ExtensionManagementError)return r;const s=new R.ExtensionManagementError(r.message,R.ExtensionManagementErrorCode.Internal);return s.stack=r.stack,s}function i(r,s,{extensionData:c,duration:u,error:S,durationSinceUpdate:A}){const M=S?S instanceof R.ExtensionManagementError?S.code:R.ExtensionManagementErrorCode.Internal:void 0;r.publicLog(s,{...c,success:!S,duration:u,errorcode:M,durationSinceUpdate:A})}e.reportTelemetry=i;class a{constructor(){this.barrier=new t.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,t.createCancelablePromise)(s=>this.doRun(s))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,t.createCancelablePromise)(s=>new Promise((c,u)=>{const S=s.onCancellationRequested(()=>{S.dispose(),u(new P.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=a;class n{constructor(s,c,u,S){this.task=s,this.profileLocation=c,this.defaultProfileLocation=u,this.extensionsProfileScannerService=S,this.identifier=this.task.identifier,this.source=this.task.source,this.operation=this.task.operation,this.promise=this.waitAndAddExtensionToProfile()}async waitAndAddExtensionToProfile(){const s=await this.task.waitUntilTaskIsFinished(),c=s.local.isApplicationScoped?this.defaultProfileLocation:this.profileLocation;return await this.extensionsProfileScannerService.addExtensionsToProfile([[s.local,s.metadata]],c),s}async run(){return await this.task.run(),this.promise}waitUntilTaskIsFinished(){return this.promise}cancel(){return this.task.cancel()}}class o extends a{constructor(s,c,u,S){super();this.extension=s,this.profileLocation=c,this.userDataProfilesService=u,this.extensionsProfileScannerService=S}async doRun(s){const c=[];c.push(this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension.identifier,this.profileLocation)),this.extension.isApplicationScoped&&this.userDataProfilesService.defaultProfile.extensionsResource&&c.push(this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension.identifier,this.userDataProfilesService.defaultProfile.extensionsResource)),await Promise.all(c)}}}),define(ve[55],we([0,1,18,14,22,16,11,65,143,2,10,5,3,19,51,68,12,4,164,24,35,38,71,17,6,13,25,7,41,45,36]),function(oe,e,I,t,v,P,k,w,p,D,T,R,E,b,d,C,y,m,g,h,l,f,i,a,n,o,r,s,c,u,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var A;(function(ne){function Z(F,x){if(F===x)return!0;const z=Object.keys(F),W=new Set;for(const re of Object.keys(x))W.add(re);if(z.length!==W.size)return!1;for(const re of z){if(F[re]!==x[re])return!1;W.delete(re)}return W.size===0}ne.equals=Z})(A=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,n.createDecorator)("IExtensionsScannerService");let M=class extends D.Disposable{constructor(Z,F,x,z,W,re,V,X,ae,ie){super();this.systemExtensionsLocation=Z,this.userExtensionsLocation=F,this.extensionsControlLocation=x,this.cacheLocation=z,this.userDataProfilesService=W,this.extensionsProfileScannerService=re,this.fileService=V,this.logService=X,this.environmentService=ae,this.productService=ie,this._onDidChangeCache=this._register(new s.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,b.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(new _((0,b.joinPath)(this.cacheLocation,f.BUILTIN_MANIFEST_CACHE_FILE),this.obsoleteFile,this.extensionsProfileScannerService,this.fileService,this.logService)),this.userExtensionsCachedScanner=this._register(new _((0,b.joinPath)(this.cacheLocation,f.USER_MANIFEST_CACHE_FILE),this.obsoleteFile,this.extensionsProfileScannerService,this.fileService,this.logService)),this.extensionsScanner=this._register(new Q(this.obsoleteFile,this.extensionsProfileScannerService,this.fileService,this.logService)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,l.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(Z,F){const[x,z]=await Promise.all([this.scanSystemExtensions(Z),this.scanUserExtensions(F)]),W=await this.scanExtensionsUnderDevelopment(Z,[...x,...z]);return this.dedupExtensions(x,z,W,await this.getTargetPlatform(),!0)}async scanSystemExtensions(Z){const F=[];F.push(this.scanDefaultSystemExtensions(!!Z.useCache,Z.language)),F.push(this.scanDevSystemExtensions(Z.language,!!Z.checkControlFile));const[x,z]=await Promise.all(F);return this.applyScanOptions([...x,...z],0,Z,!1)}async scanUserExtensions(Z){this.logService.trace("Started scanning user extensions");const F=await this.createExtensionScannerInput(Z.profileLocation??this.userExtensionsLocation,!!Z.profileLocation,1,!Z.includeUninstalled,Z.language);let z=await(Z.useCache&&!F.devMode&&F.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(F);return z=await this.applyScanOptions(z,1,Z,!0),this.logService.trace("Scanned user extensions:",z.length),z}async scanExtensionsUnderDevelopment(Z,F){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const x=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(z=>z.scheme===T.Schemas.file).map(async z=>{const W=await this.createExtensionScannerInput(z,!1,1,!0,Z.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions(W)).map(V=>(V.type=F.find(X=>(0,l.areSameExtensions)(X.identifier,V.identifier))?.type??V.type,this.extensionsScanner.validate(V,W)))}))).flat();return this.applyScanOptions(x,"development",Z,!0)}return[]}async scanExistingExtension(Z,F,x){const z=await this.createExtensionScannerInput(Z,!1,F,!0,x.language),W=await this.extensionsScanner.scanExtension(z);return!W||!x.includeInvalid&&!W.isValid?null:W}async scanOneOrMultipleExtensions(Z,F,x){const z=await this.createExtensionScannerInput(Z,!1,F,!0,x.language),W=await this.extensionsScanner.scanOneOrMultipleExtensions(z);return this.applyScanOptions(W,F,x,!0)}async scanMetadata(Z){const F=(0,b.joinPath)(Z,"package.json"),x=(await this.fileService.readFile(F)).value.toString();return JSON.parse(x).__metadata}async updateMetadata(Z,F){const x=(0,b.joinPath)(Z,"package.json"),z=(await this.fileService.readFile(x)).value.toString(),W=JSON.parse(z);F.isMachineScoped=F.isMachineScoped||void 0,F.isBuiltin=F.isBuiltin||void 0,F.installedTimestamp=F.installedTimestamp||void 0,W.__metadata={...W.__metadata,...F},await this.fileService.writeFile((0,b.joinPath)(Z,"package.json"),P.VSBuffer.fromString(JSON.stringify(W,null,"	")))}async applyScanOptions(Z,F,x,z){return x.includeAllVersions||(Z=this.dedupExtensions(F===0?Z:void 0,F===1?Z:void 0,F==="development"?Z:void 0,await this.getTargetPlatform(),z)),x.includeInvalid||(Z=Z.filter(W=>W.isValid)),Z.sort((W,re)=>{const V=R.basename(W.location.fsPath),X=R.basename(re.location.fsPath);return V<X?-1:V>X?1:0})}dedupExtensions(Z,F,x,z,W){const re=(X,ae)=>{if(X.isValid&&!ae.isValid)return!1;if(X.isValid===ae.isValid){if(W&&d.gt(X.manifest.version,ae.manifest.version))return this.logService.debug(`Skipping extension ${ae.location.path} with lower version ${ae.manifest.version} in favour of ${X.location.path} with version ${X.manifest.version}`),!1;if(d.eq(X.manifest.version,ae.manifest.version)){if(X.type===0)return this.logService.debug(`Skipping extension ${ae.location.path} in favour of system extension ${X.location.path} with same version`),!1;if(X.targetPlatform===z)return this.logService.debug(`Skipping extension ${ae.location.path} from different target platform ${ae.targetPlatform}`),!1}}return X.type===0?this.logService.debug(`Overwriting system extension ${X.location.path} with ${ae.location.path}.`):this.logService.warn(`Overwriting user extension ${X.location.path} with ${ae.location.path}.`),!0},V=new Map;return Z?.forEach(X=>{const ae=f.ExtensionIdentifier.toKey(X.identifier.id),ie=V.get(ae);(!ie||re(ie,X))&&V.set(ae,X)}),F?.forEach(X=>{const ae=f.ExtensionIdentifier.toKey(X.identifier.id),ie=V.get(ae);if(!ie&&Z&&X.type===0){this.logService.debug(`Skipping obsolete system extension ${X.location.path}.`);return}(!ie||re(ie,X))&&V.set(ae,X)}),x?.forEach(X=>{const ae=f.ExtensionIdentifier.toKey(X.identifier.id),ie=V.get(ae);(!ie||re(ie,X))&&V.set(ae,X),V.set(ae,X)}),[...V.values()]}async scanDefaultSystemExtensions(Z,F){this.logService.trace("Started scanning system extensions");const x=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,F),W=await(Z&&!x.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(x);return this.logService.trace("Scanned system extensions:",W.length),W}async scanDevSystemExtensions(Z,F){const x=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!x?.length)return[];this.logService.trace("Started scanning dev system extensions");const z=F?await this.getBuiltInExtensionControl():{},W=[],re=m.URI.file(R.normalize(R.join(T.FileAccess.asFileUri("",oe).fsPath,"..",".build","builtInExtensions")));for(const X of x){const ae=z[X.name]||"marketplace";switch(ae){case"disabled":break;case"marketplace":W.push((0,b.joinPath)(re,X.name));break;default:W.push(m.URI.file(ae));break}}const V=await Promise.all(W.map(async X=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(X,!1,0,!0,Z))));return this.logService.trace("Scanned dev system extensions:",V.length),(0,I.coalesce)(V)}async getBuiltInExtensionControl(){try{const Z=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(Z.value.toString())}catch{return{}}}async createExtensionScannerInput(Z,F,x,z,W,re=!0){const V=await this.getTranslations(W??E.language),X=await this.getMtime(Z),ae=this.userDataProfilesService.defaultProfile.extensionsResource,ie=ae?await this.getMtime(ae):void 0;return new $(Z,X,ae,ie,F,x,z,re,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,W,V)}async getMtime(Z){try{const F=await this.fileService.stat(Z);if(typeof F.mtime=="number")return F.mtime}catch{}}};M=Re([_e(4,S.IUserDataProfilesService),_e(5,u.IExtensionsProfileScannerService),_e(6,a.IFileService),_e(7,o.ILogService),_e(8,h.IEnvironmentService),_e(9,r.IProductService)],M),e.AbstractExtensionsScannerService=M;class ${constructor(Z,F,x,z,W,re,V,X,ae,ie,O,B,ee,ce){this.location=Z,this.mtime=F,this.applicationExtensionslocation=x,this.applicationExtensionslocationMtime=z,this.profile=W,this.type=re,this.excludeObsolete=V,this.validate=X,this.productVersion=ae,this.productDate=ie,this.productCommit=O,this.devMode=B,this.language=ee,this.translations=ce}static createNlsConfiguration(Z){return{language:Z.language,pseudo:Z.language==="pseudo",devMode:Z.devMode,translations:Z.translations}}static equals(Z,F){return(0,b.isEqual)(Z.location,F.location)&&Z.mtime===F.mtime&&(0,b.isEqual)(Z.applicationExtensionslocation,F.applicationExtensionslocation)&&Z.applicationExtensionslocationMtime===F.applicationExtensionslocationMtime&&Z.profile===F.profile&&Z.type===F.type&&Z.excludeObsolete===F.excludeObsolete&&Z.validate===F.validate&&Z.productVersion===F.productVersion&&Z.productDate===F.productDate&&Z.productCommit===F.productCommit&&Z.devMode===F.devMode&&Z.language===F.language&&A.equals(Z.translations,F.translations)}}class Q extends D.Disposable{constructor(Z,F,x,z){super();this.obsoleteFile=Z,this.extensionsProfileScannerService=F,this.fileService=x,this.logService=z}async scanExtensions(Z){const F=Z.profile?await this.scanExtensionsFromProfile(Z):await this.scanExtensionsFromLocation(Z);let x={};if(Z.excludeObsolete&&Z.type===1)try{const z=(await this.fileService.readFile(this.obsoleteFile)).value.toString();x=JSON.parse(z)}catch{}return(0,y.isEmptyObject)(x)?F:F.filter(z=>!x[l.ExtensionKey.create(z).toString()])}async scanExtensionsFromLocation(Z){const F=await this.fileService.resolve(Z.location);if(!F.children?.length)return[];const x=await Promise.all(F.children.map(async z=>{if(!z.isDirectory||Z.type===1&&(0,b.basename)(z.resource).indexOf(".")===0)return null;const W=new $(z.resource,Z.mtime,Z.applicationExtensionslocation,Z.applicationExtensionslocationMtime,Z.profile,Z.type,Z.excludeObsolete,Z.validate,Z.productVersion,Z.productDate,Z.productCommit,Z.devMode,Z.language,Z.translations);return this.scanExtension(W)}));return(0,I.coalesce)(x)}async scanExtensionsFromProfile(Z){const F=await this.scanExtensionsFromProfileResource(Z.location,()=>!0,Z),x=await this.scanApplicationExtensions(Z);return[...F,...x]}async scanApplicationExtensions(Z){return Z.applicationExtensionslocation?this.scanExtensionsFromProfileResource(Z.applicationExtensionslocation,F=>!!F.metadata?.isApplicationScoped,Z):[]}async scanExtensionsFromProfileResource(Z,F,x){const z=await this.extensionsProfileScannerService.scanProfileExtensions(Z);if(!z.length)return[];const W=await Promise.all(z.map(async re=>{if(F(re)){const V=new $(re.location,x.mtime,x.applicationExtensionslocation,x.applicationExtensionslocationMtime,x.profile,x.type,x.excludeObsolete,x.validate,x.productVersion,x.productDate,x.productCommit,x.devMode,x.language,x.translations);return this.scanExtension(V,re.metadata)}return null}));return(0,I.coalesce)(W)}async scanOneOrMultipleExtensions(Z){try{if(await this.fileService.exists((0,b.joinPath)(Z.location,"package.json"))){const F=await this.scanExtension(Z);return F?[F]:[]}else return await this.scanExtensions(Z)}catch(F){return this.logService.error(`Error scanning extensions at ${Z.location.path}:`,(0,k.getErrorMessage)(F)),[]}}async scanExtension(Z,F){try{let x=await this.scanExtensionManifest(Z.location);if(x){x.publisher||(x.publisher=f.UNDEFINED_PUBLISHER),F=F??x.__metadata,delete x.__metadata;const z=(0,l.getGalleryExtensionId)(x.publisher,x.name),W=F?.id?{id:z,uuid:F.id}:{id:z},re=F?.isSystem?0:Z.type,V=re===0||!!F?.isBuiltin;x=await this.translateManifest(Z.location,x,$.createNlsConfiguration(Z));const X={type:re,identifier:W,manifest:x,location:Z.location,isBuiltin:V,targetPlatform:F?.targetPlatform??"undefined",metadata:F,isValid:!0,validations:[]};return Z.validate?this.validate(X,Z):X}}catch(x){Z.type!==0&&this.logService.error(x)}return null}validate(Z,F){let x=!0;const z=(0,i.validateExtensionManifest)(F.productVersion,F.productDate,F.location,Z.manifest,Z.isBuiltin);for(const[W,re]of z)W===C.default.Error&&(x=!1,this.logService.error(this.formatMessage(F.location,re)));return Z.isValid=x,Z.validations=z,Z}async scanExtensionManifest(Z){const F=(0,b.joinPath)(Z,"package.json");let x;try{x=(await this.fileService.readFile(F)).value.toString()}catch(W){return(0,a.toFileOperationResult)(W)!==1&&this.logService.error(this.formatMessage(Z,(0,g.localize)(0,null,F.path,W.message))),null}let z;try{z=JSON.parse(x)}catch{const re=[];(0,w.parse)(x,re);for(const V of re)this.logService.error(this.formatMessage(Z,(0,g.localize)(1,null,F.path,V.offset,V.length,(0,p.getParseErrorMessage)(V.error))));return null}return(0,w.getNodeType)(z)!=="object"?(this.logService.error(this.formatMessage(Z,(0,g.localize)(2,null,F.path))),null):z}async translateManifest(Z,F,x){const z=await this.getLocalizedMessages(Z,F,x);if(z)try{const W=[],re=await this.resolveOriginalMessageBundle(z.default,W);if(W.length>0)return W.forEach(X=>{this.logService.error(this.formatMessage(Z,(0,g.localize)(3,null,z.default?.path,(0,p.getParseErrorMessage)(X.error))))}),F;if((0,w.getNodeType)(z)!=="object")return this.logService.error(this.formatMessage(Z,(0,g.localize)(4,null,z.default?.path))),F;const V=z.values||Object.create(null);this.replaceNLStrings(x.pseudo,F,V,re,Z)}catch{}return F}async getLocalizedMessages(Z,F,x){const z=(0,b.joinPath)(Z,"package.nls.json"),W=(ae,ie)=>{ie.forEach(O=>{this.logService.error(this.formatMessage(Z,(0,g.localize)(5,null,ae?.path,(0,p.getParseErrorMessage)(O.error))))})},re=ae=>{this.logService.error(this.formatMessage(Z,(0,g.localize)(6,null,ae?.path)))},V=`${F.publisher}.${F.name}`,X=x.translations[V];if(X)try{const ae=m.URI.file(X),ie=(await this.fileService.readFile(ae)).value.toString(),O=[],B=(0,w.parse)(ie,O);return O.length>0?(W(ae,O),{values:void 0,default:z}):(0,w.getNodeType)(B)!=="object"?(re(ae),{values:void 0,default:z}):{values:B.contents?B.contents.package:void 0,default:z}}catch{return{values:void 0,default:z}}else{if(!await this.fileService.exists(z))return;let ie;try{ie=await this.findMessageBundles(Z,x)}catch{return}if(!ie.localized)return{values:void 0,default:ie.original};try{const O=(await this.fileService.readFile(ie.localized)).value.toString(),B=[],ee=(0,w.parse)(O,B);return B.length>0?(W(ie.localized,B),{values:void 0,default:ie.original}):(0,w.getNodeType)(ee)!=="object"?(re(ie.localized),{values:void 0,default:ie.original}):{values:ee,default:ie.original}}catch{return{values:void 0,default:ie.original}}}}async resolveOriginalMessageBundle(Z,F){if(Z)try{const x=(await this.fileService.readFile(Z)).value.toString();return(0,w.parse)(x,F)}catch{return null}else return null}findMessageBundles(Z,F){return new Promise((x,z)=>{const W=re=>{const V=(0,b.joinPath)(Z,`package.nls.${re}.json`);this.fileService.exists(V).then(X=>{X&&x({localized:V,original:(0,b.joinPath)(Z,"package.nls.json")});const ae=re.lastIndexOf("-");ae===-1?x({localized:(0,b.joinPath)(Z,"package.nls.json"),original:null}):(re=re.substring(0,ae),W(re))})};if(F.devMode||F.pseudo||!F.language)return x({localized:(0,b.joinPath)(Z,"package.nls.json"),original:null});W(F.language)})}replaceNLStrings(Z,F,x,z,W){const re=(V,X,ae)=>{const ie=V[X];if((0,y.isString)(ie)){const O=ie,B=O.length;if(B>1&&O[0]==="%"&&O[B-1]==="%"){const ee=O.substr(1,B-2);let ce=x[ee];ce===void 0&&z&&(ce=z[ee]);let K=typeof ce=="string"?ce:typeof ce?.message=="string"?ce.message:void 0;K!==void 0?(Z&&(K="\uFF3B"+K.replace(/[aouei]/g,"$&$&")+"\uFF3D"),V[X]=ae&&(X==="title"||X==="category")&&z?{value:K,original:z[ee]}:K):this.logService.warn(this.formatMessage(W,(0,g.localize)(7,null,ee)))}}else if((0,y.isObject)(ie))for(const O in ie)ie.hasOwnProperty(O)&&(O==="commands"?re(ie,O,!0):re(ie,O,ae));else if((0,y.isArray)(ie))for(let O=0;O<ie.length;O++)re(ie,O,ae)};for(const V in F)F.hasOwnProperty(V)&&re(F,V)}formatMessage(Z,F){return`[${Z.path}]: ${F}`}}class _ extends Q{constructor(Z,F,x,z,W){super(F,x,z,W);this.cacheFile=Z,this.cacheValidatorThrottler=this._register(new t.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new s.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(Z){const F=await this.readExtensionCache();if(this.input=Z,F&&F.input&&$.equals(F.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),F.result.map(z=>(z.location=m.URI.revive(z.location),z));const x=await super.scanExtensions(Z);return await this.writeExtensionCache({input:Z,result:x}),x}async readExtensionCache(){try{const Z=await this.fileService.readFile(this.cacheFile),F=JSON.parse(Z.value.toString());return{result:F.result,input:(0,c.revive)(F.input)}}catch(Z){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,k.getErrorMessage)(Z))}return null}async writeExtensionCache(Z){try{await this.fileService.writeFile(this.cacheFile,P.VSBuffer.fromString(JSON.stringify(Z)))}catch(F){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,k.getErrorMessage)(F))}}async validateCache(){if(!this.input)return;const Z=await this.readExtensionCache();if(!Z)return;const F=Z.result,x=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!v.equals(x,F))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(z){this.logService.error(z)}}}function q(ne,Z){const F=(0,l.getExtensionId)(ne.manifest.publisher,ne.manifest.name);return{id:F,identifier:new f.ExtensionIdentifier(F),isBuiltin:ne.type===0,isUserBuiltin:ne.type===1&&ne.isBuiltin,isUnderDevelopment:Z,extensionLocation:ne.location,uuid:ne.identifier.uuid,targetPlatform:ne.targetPlatform,...ne.manifest}}e.toExtensionDescription=q;class U extends M{constructor(Z,F,x,z,W,re,V,X,ae,ie){super(Z,F,(0,b.joinPath)(x,".vscode-oss-dev","extensions","control.json"),(0,b.joinPath)(z,f.MANIFEST_CACHE_FOLDER),W,re,V,X,ae,ie);this.translationsPromise=(async()=>{if(E.translationsConfigFile)try{const O=await this.fileService.readFile(m.URI.file(E.translationsConfigFile));return JSON.parse(O.value.toString())}catch{}return Object.create(null)})()}getTranslations(Z){return this.translationsPromise}}e.NativeExtensionsScannerService=U}),define(ve[234],we([0,1,42,14,37,7,2,10,5,21,13,36]),function(oe,e,I,t,v,P,k,w,p,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let E=class extends k.Disposable{constructor(d,C){super();this.userDataProfilesService=d,this.logService=C,this.processesLimiter=new t.Limiter(5)}async postUninstall(d){const C=this.parseScript(d,"uninstall");return C&&(this.logService.info(d.identifier.id,d.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(C.script,"uninstall",C.args,!0,d).then(()=>this.logService.info(d.identifier.id,d.manifest.version,"Finished running post uninstall script"),y=>this.logService.error(d.identifier.id,d.manifest.version,`Failed to run post uninstall script: ${y}`)))),D.Promises.rm(this.getExtensionStoragePath(d)).then(void 0,y=>this.logService.error("Error while removing extension storage path",y))}parseScript(d,C){const y=`vscode:${C}`;if(d.location.scheme===w.Schemas.file&&d.manifest&&d.manifest.scripts&&typeof d.manifest.scripts[y]=="string"){const m=d.manifest.scripts[y].split(" ");return m.length<2||m[0]!=="node"||!m[1]?(this.logService.warn(d.identifier.id,d.manifest.version,`${y} should be a node script`),null):{script:(0,p.join)(d.location.fsPath,m[1]),args:m.slice(2)||[]}}return null}runLifecycleHook(d,C,y,m,g){return new Promise((h,l)=>{const f=this.start(d,C,y,g);let i;const a=n=>{i&&(clearTimeout(i),i=null),n?l(n):h(void 0)};f.on("error",n=>{a((0,v.toErrorMessage)(n)||"Unknown")}),f.on("exit",(n,o)=>{a(n?`post-${C} process exited with code ${n}`:void 0)}),m&&(i=setTimeout(()=>{i=null,f.kill(),l("timed out")},5e3))})}start(d,C,y,m){const g={silent:!0,execArgv:void 0},h=(0,I.fork)(d,[`--type=extension-post-${C}`,...y],g);h.stdout.setEncoding("utf8"),h.stderr.setEncoding("utf8");const l=P.Event.fromNodeEventEmitter(h.stdout,"data"),f=P.Event.fromNodeEventEmitter(h.stderr,"data");l(n=>this.logService.info(m.identifier.id,m.manifest.version,`post-${C}`,n)),f(n=>this.logService.error(m.identifier.id,m.manifest.version,`post-${C}`,n));const i=P.Event.any(P.Event.map(l,n=>({data:`%c${n}`,format:[""]})),P.Event.map(f,n=>({data:`%c${n}`,format:["color: red"]})));return P.Event.debounce(i,(n,o)=>n?{data:n.data+o.data,format:[...n.format,...o.format]}:{data:o.data,format:o.format},100)(n=>{console.group(m.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),h}getExtensionStoragePath(d){return(0,p.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,d.identifier.id.toLowerCase())}};E=Re([_e(0,R.IUserDataProfilesService),_e(1,T.ILogService)],E),e.ExtensionsLifecycle=E}),define(ve[235],we([0,1,14,7,2,49,12,152,6,36]),function(oe,e,I,t,v,P,k,w,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const T="__$__targetStorageMarker";e.IStorageService=(0,p.createDecorator)("storageService");var R;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(R=e.WillSaveStateReason||(e.WillSaveStateReason={}));var E;(function(g){g[g.APPLICATION=-1]="APPLICATION",g[g.PROFILE=0]="PROFILE",g[g.WORKSPACE=1]="WORKSPACE"})(E=e.StorageScope||(e.StorageScope={}));var b;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(b=e.StorageTarget||(e.StorageTarget={}));class d extends v.Disposable{constructor(h={flushInterval:d.DEFAULT_FLUSH_INTERVAL}){super();this.options=h,this._onDidChangeValue=this._register(new t.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new t.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new t.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new I.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new v.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,I.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,v.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,P.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,P.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(h,l){if(l===T){switch(h){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:h})}else this._onDidChangeValue.fire({scope:h,key:l,target:this.getKeyTargets(h)[l]})}emitWillSaveState(h){this._onWillSaveState.fire({reason:h})}get(h,l,f){return this.getStorage(l)?.get(h,f)}getBoolean(h,l,f){return this.getStorage(l)?.getBoolean(h,f)}getNumber(h,l,f){return this.getStorage(l)?.getNumber(h,f)}store(h,l,f,i){if((0,k.isUndefinedOrNull)(l)){this.remove(h,f);return}this.withPausedEmitters(()=>{this.updateKeyTarget(h,f,i),this.getStorage(f)?.set(h,l)})}remove(h,l){this.withPausedEmitters(()=>{this.updateKeyTarget(h,l,void 0),this.getStorage(l)?.delete(h)})}withPausedEmitters(h){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{h()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(h,l){const f=[],i=this.getKeyTargets(h);for(const a of Object.keys(i))i[a]===l&&f.push(a);return f}updateKeyTarget(h,l,f){const i=this.getKeyTargets(l);typeof f=="number"?i[h]!==f&&(i[h]=f,this.getStorage(l)?.set(T,JSON.stringify(i))):typeof i[h]=="number"&&(delete i[h],this.getStorage(l)?.set(T,JSON.stringify(i)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(h){switch(h){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(h){const l=this.get(T,h);if(l)try{return JSON.parse(l)}catch{}return Object.create(null)}isNew(h){return this.getBoolean(e.IS_NEW_KEY,h)===!0}async flush(h=R.NONE){this._onWillSaveState.fire({reason:h});const l=this.getStorage(-1),f=this.getStorage(0),i=this.getStorage(1);switch(h){case R.NONE:await I.Promises.settled([l?.whenFlushed()??Promise.resolve(),f?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case R.SHUTDOWN:await I.Promises.settled([l?.flush(0)??Promise.resolve(),f?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const h=this.getStorage(-1)?.items??new Map,l=this.getStorage(0)?.items??new Map,f=this.getStorage(1)?.items??new Map;return m(h,l,f,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(h,l){return this.emitWillSaveState(R.NONE),(0,D.isUserDataProfile)(h)?this.switchToProfile(h,l):this.switchToWorkspace(h,l)}canSwitchProfile(h,l){return!(h.id===l.id||C(l)&&C(h))}switchData(h,l,f,i){this.withPausedEmitters(()=>{if(i)for(const[a,n]of h)l.set(a,n);else{const a=new Set;for(const[n,o]of h)a.add(n),l.get(n)!==o&&this.emitDidChangeValue(f,n);for(const[n]of l.items)a.has(n)||this.emitDidChangeValue(f,n)}})}}e.AbstractStorageService=d,d.DEFAULT_FLUSH_INTERVAL=60*1e3;function C(g){return g.isDefault||!!g.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=C;class y extends d{constructor(){super();this.applicationStorage=this._register(new w.Storage(new w.InMemoryStorageDatabase)),this.profileStorage=this._register(new w.Storage(new w.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new w.Storage(new w.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(h=>this.emitDidChangeValue(1,h))),this._register(this.profileStorage.onDidChangeStorage(h=>this.emitDidChangeValue(0,h))),this._register(this.applicationStorage.onDidChangeStorage(h=>this.emitDidChangeValue(-1,h)))}getStorage(h){switch(h){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(h){switch(h){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}}e.InMemoryStorageService=y;async function m(g,h,l,f,i,a){const n=$=>{try{return JSON.parse($)}catch{return $}},o=new Map,r=new Map;g.forEach(($,Q)=>{o.set(Q,$),r.set(Q,n($))});const s=new Map,c=new Map;h.forEach(($,Q)=>{s.set(Q,$),c.set(Q,n($))});const u=new Map,S=new Map;l.forEach(($,Q)=>{u.set(Q,$),S.set(Q,n($))}),console.group(f!==i?`Storage: Application (path: ${f})`:`Storage: Application & Profile (path: ${f}, default profile)`);const A=[];if(o.forEach(($,Q)=>{A.push({key:Q,value:$})}),console.table(A),console.groupEnd(),console.log(r),f!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const $=[];s.forEach((Q,_)=>{$.push({key:_,value:Q})}),console.table($),console.groupEnd(),console.log(c)}console.group(`Storage: Workspace (path: ${a})`);const M=[];u.forEach(($,Q)=>{M.push({key:Q,value:$})}),console.table(M),console.groupEnd(),console.log(S)}e.logStorage=m}),define(ve[110],we([0,1,18,20,11,3,28,12,4,23,24,31,35,71,17,13,25,54,220,235,32]),function(oe,e,I,t,v,P,k,w,p,D,T,R,E,b,d,C,y,m,g,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const f=P.isWeb?"web":(0,R.getTargetPlatform)(P.platform,k.arch);var i;(function(O){O[O.None=0]="None",O[O.IncludeVersions=1]="IncludeVersions",O[O.IncludeFiles=2]="IncludeFiles",O[O.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",O[O.IncludeSharedAccounts=8]="IncludeSharedAccounts",O[O.IncludeVersionProperties=16]="IncludeVersionProperties",O[O.ExcludeNonValidated=32]="ExcludeNonValidated",O[O.IncludeInstallationTargets=64]="IncludeInstallationTargets",O[O.IncludeAssetUri=128]="IncludeAssetUri",O[O.IncludeStatistics=256]="IncludeStatistics",O[O.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",O[O.Unpublished=4096]="Unpublished",O[O.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(i||(i={}));function a(...O){return String(O.reduce((B,ee)=>B|ee,0))}var n;(function(O){O[O.Tag=1]="Tag",O[O.ExtensionId=4]="ExtensionId",O[O.Category=5]="Category",O[O.ExtensionName=7]="ExtensionName",O[O.Target=8]="Target",O[O.Featured=9]="Featured",O[O.SearchText=10]="SearchText",O[O.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},r={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},c={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:i.None,criteria:[],assetTypes:[]};class u{constructor(B=c){this.state=B}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(B,ee=this.state.pageSize){return new u({...this.state,pageNumber:B,pageSize:ee})}withFilter(B,...ee){const ce=[...this.state.criteria,...ee.length?ee.map(K=>({filterType:B,value:K})):[{filterType:B}]];return new u({...this.state,criteria:ce})}withSortBy(B){return new u({...this.state,sortBy:B})}withSortOrder(B){return new u({...this.state,sortOrder:B})}withFlags(...B){return new u({...this.state,flags:B.reduce((ee,ce)=>ee|ce,0)})}withAssetTypes(...B){return new u({...this.state,assetTypes:B})}withSource(B){return new u({...this.state,source:B})}get raw(){const{criteria:B,pageNumber:ee,pageSize:ce,sortBy:K,sortOrder:he,flags:te,assetTypes:le}=this.state;return{filters:[{criteria:B,pageNumber:ee,pageSize:ce,sortBy:K,sortOrder:he}],assetTypes:le,flags:te}}get searchText(){const B=this.state.criteria.filter(ee=>ee.filterType===n.SearchText)[0];return B&&B.value?B.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(B=>String(B.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function S(O,B){const ee=(O||[]).filter(ce=>ce.statisticName===B)[0];return ee?ee.value:0}function A(O){const B="Microsoft.VisualStudio.Code.Translation.";return O.files.filter(ce=>ce.assetType.indexOf(B)===0).reduce((ce,K)=>{const he=Q(O,K.assetType);return he&&ce.push([K.assetType.substring(B.length),he]),ce},[])}function M(O){if(O.properties){const B=O.properties.filter(K=>K.key===o.Repository),ee=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),ce=B.filter(K=>ee.test(K.value))[0];return ce?{uri:ce.value,fallbackUri:ce.value}:null}return Q(O,o.Repository)}function $(O){return{uri:`${O.fallbackAssetUri}/${o.VSIX}?redirect=true${O.targetPlatform?`&targetPlatform=${O.targetPlatform}`:""}`,fallbackUri:`${O.fallbackAssetUri}/${o.VSIX}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`}}function Q(O,B){return O.files.filter(ce=>ce.assetType===B)[0]?{uri:`${O.assetUri}/${B}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`,fallbackUri:`${O.fallbackAssetUri}/${B}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`}:null}function _(O,B){const ee=O.properties?O.properties.filter(K=>K.key===B):[],ce=ee.length>0&&ee[0].value;return ce?ce.split(",").map(K=>(0,E.adoptToGalleryExtensionId)(K)):[]}function q(O){const B=O.properties?O.properties.filter(ee=>ee.key===r.Engine):[];return B.length>0&&B[0].value||""}function U(O){const B=O.properties?O.properties.filter(ee=>ee.key===r.PreRelease):[];return B.length>0&&B[0].value==="true"}function ne(O){const B=O.properties?O.properties.filter(ce=>ce.key===r.LocalizedLanguages):[],ee=B.length>0&&B[0].value||"";return ee?ee.split(","):[]}function Z(O){return O.properties?.find(B=>B.key===r.SponsorLink)?.value}function F(O){return O.indexOf("preview")!==-1}function x(O){return O.targetPlatform?(0,R.toTargetPlatform)(O.targetPlatform):"undefined"}function z(O){const B=(0,I.distinct)(O.versions.map(x)),ee=!!O.tags?.includes(R.WEB_EXTENSION_TAG),ce=B.indexOf("web");return ee?ce===-1&&B.push("web"):ce!==-1&&B.splice(ce,1),B}function W(O,B){const ee=(0,R.getFallbackTargetPlarforms)(B);for(let ce=0;ce<O.length;ce++){const K=O[ce];if(K.version===O[ce-1]?.version){let he=ce;const te=x(K);if(te===B)for(;he>0&&O[he-1].version===K.version;)he--;else if(ee.includes(te))for(;he>0&&O[he-1].version===K.version&&x(O[he-1])!==B;)he--;he!==ce&&(O.splice(ce,1),O.splice(he,0,K))}}return O}e.sortExtensionVersions=W;function re(O,B,ee){O.telemetryData={index:B,querySource:ee}}function V(O,B,ee){const ce=O.versions[0],K={manifest:Q(B,o.Manifest),readme:Q(B,o.Details),changelog:Q(B,o.Changelog),license:Q(B,o.License),repository:M(B),download:$(B),icon:Q(B,o.Icon),coreTranslations:A(B)};return{identifier:{id:(0,E.getGalleryExtensionId)(O.publisher.publisherName,O.extensionName),uuid:O.extensionId},name:O.extensionName,version:B.version,displayName:O.displayName,publisherId:O.publisher.publisherId,publisher:O.publisher.publisherName,publisherDisplayName:O.publisher.displayName,publisherDomain:O.publisher.domain?{link:O.publisher.domain,verified:!!O.publisher.isDomainVerified}:void 0,publisherSponsorLink:Z(ce),description:O.shortDescription||"",installCount:S(O.statistics,"install"),rating:S(O.statistics,"averagerating"),ratingCount:S(O.statistics,"ratingcount"),categories:O.categories||[],tags:O.tags||[],releaseDate:Date.parse(O.releaseDate),lastUpdated:Date.parse(O.lastUpdated),allTargetPlatforms:ee,assets:K,properties:{dependencies:_(B,r.Dependency),extensionPack:_(B,r.ExtensionPack),engine:q(B),localizedLanguages:ne(B),targetPlatform:x(B),isPreReleaseVersion:U(B)},hasPreReleaseVersion:U(ce),hasReleaseVersion:!0,preview:F(O.flags)}}let X=class{constructor(B,ee,ce,K,he,te,le,de){this.requestService=ee,this.logService=ce,this.environmentService=K,this.telemetryService=he,this.fileService=te,this.productService=le,this.configurationService=de;const Y=le.extensionsGallery;this.extensionsGalleryUrl=Y&&Y.serviceUrl,this.extensionsControlUrl=Y&&Y.controlUrl,this.commonHeadersPromise=(0,g.resolveMarketplaceHeaders)(le.version,le,this.environmentService,this.configurationService,this.fileService,B,this.telemetryService)}api(B=""){return`${this.extensionsGalleryUrl}${B}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(B,ee,ce){const K=t.CancellationToken.isCancellationToken(ee)?{}:ee,he=t.CancellationToken.isCancellationToken(ee)?ee:ce,te=[],le=[],de=[],Y=[];let J=!0;for(const fe of B){fe.uuid?le.push(fe.uuid):te.push(fe.id);const pe=!!(fe.version||fe.preRelease);de.push({id:fe.id,uuid:fe.uuid,includePreRelease:pe}),fe.version&&Y.push({id:fe.id,uuid:fe.uuid,version:fe.version}),J=J&&!!fe.hasPreRelease&&!pe}if(!le.length&&!te.length)return[];let H=new u().withPage(1,B.length);le.length&&(H=H.withFilter(n.ExtensionId,...le)),te.length&&(H=H.withFilter(n.ExtensionName,...te)),(K.queryAllVersions||J)&&(H=H.withFlags(H.flags,i.IncludeVersions)),K.source&&(H=H.withSource(K.source));const{extensions:G}=await this.queryGalleryExtensions(H,{targetPlatform:K.targetPlatform??f,includePreRelease:de,versions:Y,compatible:!!K.compatible},he);return K.source&&G.forEach((fe,pe)=>re(fe,pe,K.source)),G}async getCompatibleExtension(B,ee,ce){if((0,R.isNotWebExtensionInWebTargetPlatform)(B.allTargetPlatforms,ce))return null;if(await this.isExtensionCompatible(B,ee,ce))return B;const K=new u().withFlags(i.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,B.identifier.uuid),{extensions:he}=await this.queryGalleryExtensions(K,{targetPlatform:ce,compatible:!0,includePreRelease:ee},t.CancellationToken.None);return he[0]||null}async isExtensionCompatible(B,ee,ce){if(!(0,R.isTargetPlatformCompatible)(B.properties.targetPlatform,B.allTargetPlatforms,ce)||!ee&&B.properties.isPreReleaseVersion)return!1;let K=B.properties.engine;if(!K){const he=await this.getManifest(B,t.CancellationToken.None);if(!he)throw new Error("Manifest was not found");K=he.engines.vscode}return(0,b.isEngineValid)(K,this.productService.version,this.productService.date)}async isValidVersion(B,ee,ce,K,he){if(!(0,R.isTargetPlatformCompatible)(x(B),K,he)||ee!=="any"&&U(B)!==(ee==="prerelease"))return!1;if(ce)try{const te=await this.getEngine(B);if(!(0,b.isEngineValid)(te,this.productService.version,this.productService.date))return!1}catch(te){return this.logService.error(`Error while getting the engine for the version ${B.version}.`,(0,v.getErrorMessage)(te)),!1}return!0}async query(B,ee){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let ce=B.text||"";const K=B.pageSize??50;let he=new u().withPage(1,K);ce?(ce=ce.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(J,H,G)=>(he=he.withFilter(n.Category,G||H),"")),ce=ce.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(J,H,G)=>(he=he.withFilter(n.Tag,G||H),"")),ce=ce.replace(/\bfeatured(\s+|\b|$)/g,()=>(he=he.withFilter(n.Featured),"")),ce=ce.trim(),ce&&(ce=ce.length<200?ce:ce.substring(0,200),he=he.withFilter(n.SearchText,ce)),he=he.withSortBy(0)):B.ids?he=he.withFilter(n.ExtensionId,...B.ids):B.names?he=he.withFilter(n.ExtensionName,...B.names):he=he.withSortBy(4),typeof B.sortBy=="number"&&(he=he.withSortBy(B.sortBy)),typeof B.sortOrder=="number"&&(he=he.withSortOrder(B.sortOrder)),B.source&&(he=he.withSource(B.source));const te=async(J,H)=>{const{extensions:G,total:fe}=await this.queryGalleryExtensions(J,{targetPlatform:f,compatible:!1,includePreRelease:!!B.includePreRelease},H);return G.forEach((pe,ke)=>re(pe,(J.pageNumber-1)*J.pageSize+ke,B.source)),{extensions:G,total:fe}},{extensions:le,total:de}=await te(he,ee),Y=async(J,H)=>{if(H.isCancellationRequested)throw new v.CancellationError;const{extensions:G}=await te(he.withPage(J+1),H);return G};return{firstPage:le,total:de,pageSize:he.pageSize,getPage:Y}}async queryGalleryExtensions(B,ee,ce){const K=B.flags;!!(B.flags&i.IncludeLatestVersionOnly)&&!!(B.flags&i.IncludeVersions)&&(B=B.withFlags(B.flags&~i.IncludeVersions,i.IncludeLatestVersionOnly)),!(B.flags&i.IncludeLatestVersionOnly)&&!(B.flags&i.IncludeVersions)&&(B=B.withFlags(B.flags,i.IncludeLatestVersionOnly)),ee.versions?.length&&(B=B.withFlags(B.flags&~i.IncludeLatestVersionOnly,i.IncludeVersions)),B=B.withFlags(B.flags,i.IncludeAssetUri,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeStatistics,i.IncludeVersionProperties);const{galleryExtensions:he,total:te}=await this.queryRawGalleryExtensions(B,ce);if(!(B.flags&i.IncludeLatestVersionOnly)){const J=[];for(const H of he){const G=await this.toGalleryExtensionWithCriteria(H,ee);G&&J.push(G)}return{extensions:J,total:te}}const de=[],Y=new Map;for(let J=0;J<he.length;J++){const H=he[J],G={id:(0,E.getGalleryExtensionId)(H.publisher.publisherName,H.extensionName),uuid:H.extensionId},fe=(0,w.isBoolean)(ee.includePreRelease)?ee.includePreRelease:!!ee.includePreRelease.find(ke=>(0,E.areSameExtensions)(ke,G))?.includePreRelease;if(ee.compatible&&(0,R.isNotWebExtensionInWebTargetPlatform)(z(H),ee.targetPlatform))continue;const pe=await this.toGalleryExtensionWithCriteria(H,ee);!pe||pe.properties.isPreReleaseVersion&&(!fe||!pe.hasReleaseVersion)||!pe.properties.isPreReleaseVersion&&pe.properties.targetPlatform!==ee.targetPlatform&&pe.hasPreReleaseVersion?Y.set(H.extensionId,J):de.push([J,pe])}if(Y.size){const J=new Date().getTime(),H=new u().withFlags(K&~i.IncludeLatestVersionOnly,i.IncludeVersions).withPage(1,Y.size).withFilter(n.ExtensionId,...Y.keys()),{extensions:G}=await this.queryGalleryExtensions(H,ee,ce);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-J,count:Y.size});for(const fe of G){const pe=Y.get(fe.identifier.uuid);de.push([pe,fe])}}return{extensions:de.sort((J,H)=>J[0]-H[0]).map(([,J])=>J),total:te}}async toGalleryExtensionWithCriteria(B,ee){const ce={id:(0,E.getGalleryExtensionId)(B.publisher.publisherName,B.extensionName),uuid:B.extensionId},K=ee.versions?.find(de=>(0,E.areSameExtensions)(de,ce))?.version,he=(0,w.isBoolean)(ee.includePreRelease)?ee.includePreRelease:!!ee.includePreRelease.find(de=>(0,E.areSameExtensions)(de,ce))?.includePreRelease,te=z(B),le=W(B.versions,ee.targetPlatform);if(ee.compatible&&(0,R.isNotWebExtensionInWebTargetPlatform)(te,ee.targetPlatform))return null;for(let de=0;de<le.length;de++){const Y=le[de];if(!(K&&Y.version!==K)){if(await this.isValidVersion(Y,he?"any":"release",ee.compatible,te,ee.targetPlatform))return V(B,Y,te);if(K&&Y.version===K)return null}}return K||ee.compatible?null:V(B,B.versions[0],te)}async queryRawGalleryExtensions(B,ee){if(!this.isEnabled())throw new Error("No extension gallery service configured.");B=B.withFlags(B.flags,i.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,a(i.Unpublished));const ce=await this.commonHeadersPromise,K=JSON.stringify(B.raw),he={...ce,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(K.length)},te=new Date().getTime();let le,de,Y=0;try{if(le=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:K,headers:he},ee),le.res.statusCode&&le.res.statusCode>=400&&le.res.statusCode<500)return{galleryExtensions:[],total:Y};const J=await(0,m.asJson)(le);if(J){const H=J.results[0],G=H.extensions,fe=H.resultMetadata&&H.resultMetadata.filter(pe=>pe.metadataType==="ResultCount")[0];return Y=fe&&fe.metadataItems.filter(pe=>pe.name==="TotalCount")[0].count||0,{galleryExtensions:G,total:Y}}return{galleryExtensions:[],total:Y}}catch(J){throw de=J,J}finally{this.telemetryService.publicLog2("galleryService:query",{...B.telemetryData,requestBodySize:String(K.length),duration:new Date().getTime()-te,success:!!le&&(0,m.isSuccess)(le),responseBodySize:le?.res.headers["Content-Length"],statusCode:le?String(le.res.statusCode):void 0,errorCode:de?(0,v.isCancellationError)(de)?"canceled":(0,v.getErrorMessage)(de).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Y)})}}async reportStatistic(B,ee,ce,K){if(!this.isEnabled())return;const he=P.isWeb?this.api(`/itemName/${B}.${ee}/version/${ce}/statType/${K==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${B}/extensions/${ee}/${ce}/stats?statType=${K}`),te=P.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",de={...await this.commonHeadersPromise,Accept:te};try{await this.requestService.request({type:"POST",url:he,headers:de},t.CancellationToken.None)}catch{}}async download(B,ee,ce){this.logService.trace("ExtensionGalleryService#download",B.identifier.id);const K=(0,E.getGalleryExtensionTelemetryData)(B),he=new Date().getTime(),te=J=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...K,duration:J}),le=ce===2?"install":ce===3?"update":"",de=le?{uri:`${B.assets.download.uri}${p.URI.parse(B.assets.download.uri).query?"&":"?"}${le}=true`,fallbackUri:`${B.assets.download.fallbackUri}${p.URI.parse(B.assets.download.fallbackUri).query?"&":"?"}${le}=true`}:B.assets.download,Y=await this.getAsset(de);await this.fileService.writeFile(ee,Y.stream),te(new Date().getTime()-he)}async getReadme(B,ee){if(B.assets.readme){const ce=await this.getAsset(B.assets.readme,{},ee);return await(0,m.asTextOrError)(ce)||""}return""}async getManifest(B,ee){if(B.assets.manifest){const ce=await this.getAsset(B.assets.manifest,{},ee),K=await(0,m.asTextOrError)(ce);return K?JSON.parse(K):null}return null}async getManifestFromRawExtensionVersion(B,ee){const ce=Q(B,o.Manifest);if(!ce)throw new Error("Manifest was not found");const K={"Accept-Encoding":"gzip"},he=await this.getAsset(ce,{headers:K});return await(0,m.asJson)(he)}async getCoreTranslation(B,ee){const ce=B.assets.coreTranslations.filter(K=>K[0]===ee.toUpperCase())[0];if(ce){const K=await this.getAsset(ce[1]),he=await(0,m.asTextOrError)(K);return he?JSON.parse(he):null}return null}async getChangelog(B,ee){if(B.assets.changelog){const ce=await this.getAsset(B.assets.changelog,{},ee);return await(0,m.asTextOrError)(ce)||""}return""}async getAllCompatibleVersions(B,ee,ce){let K=new u().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1);B.identifier.uuid?K=K.withFilter(n.ExtensionId,B.identifier.uuid):K=K.withFilter(n.ExtensionName,B.identifier.id);const{galleryExtensions:he}=await this.queryRawGalleryExtensions(K,t.CancellationToken.None);if(!he.length)return[];const te=z(he[0]);if((0,R.isNotWebExtensionInWebTargetPlatform)(te,ce))return[];const le=[];await Promise.all(he[0].versions.map(async J=>{try{await this.isValidVersion(J,ee?"any":"release",!0,te,ce)&&le.push(J)}catch{}}));const de=[],Y=new Set;for(const J of W(le,ce))Y.has(J.version)||(Y.add(J.version),de.push({version:J.version,date:J.lastUpdated,isPreReleaseVersion:U(J)}));return de}async getAsset(B,ee={},ce=t.CancellationToken.None){const K=await this.commonHeadersPromise,he={type:"GET"},te={...K,...ee.headers||{}};ee={...ee,...he,headers:te};const le=B.uri,de=B.fallbackUri,Y={...ee,url:le};try{const J=await this.requestService.request(Y,ce);if(J.res.statusCode===200)return J;const H=await(0,m.asTextOrError)(J);throw new Error(`Expected 200, got back ${J.res.statusCode} instead.

${H}`)}catch(J){if((0,v.isCancellationError)(J))throw J;const H=(0,v.getErrorMessage)(J);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:le,message:H});const G={...ee,url:de};return this.requestService.request(G,ce)}}async getEngine(B){let ee=q(B);if(!ee){const ce=await this.getManifestFromRawExtensionVersion(B,t.CancellationToken.None);if(!ce)throw new Error("Manifest was not found");ee=ce.engines.vscode}return ee}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{}};const B=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},t.CancellationToken.None);if(B.res.statusCode!==200)throw new Error("Could not get extensions report.");const ee=await(0,m.asJson)(B),ce=[],K={};if(ee){for(const he of ee.malicious)ce.push({id:he});if(ee.migrateToPreRelease)for(const[he,te]of Object.entries(ee.migrateToPreRelease))(!te.engine||(0,b.isEngineValid)(te.engine,this.productService.version,this.productService.date))&&(K[he.toLowerCase()]={disallowInstall:!0,extension:{id:te.id,displayName:te.displayName,autoMigrate:{storage:!!te.migrateStorage},preRelease:!0}});if(ee.deprecated)for(const[he,te]of Object.entries(ee.deprecated))te&&(K[he.toLowerCase()]=(0,w.isBoolean)(te)?{}:te)}return{malicious:ce,deprecated:K}}};X=Re([_e(1,m.IRequestService),_e(2,C.ILogService),_e(3,T.IEnvironmentService),_e(4,l.ITelemetryService),_e(5,d.IFileService),_e(6,y.IProductService),_e(7,D.IConfigurationService)],X);let ae=class extends X{constructor(B,ee,ce,K,he,te,le,de){super(B,ee,ce,K,he,te,le,de)}};ae=Re([_e(0,h.IStorageService),_e(1,m.IRequestService),_e(2,C.ILogService),_e(3,T.IEnvironmentService),_e(4,l.ITelemetryService),_e(5,d.IFileService),_e(6,y.IProductService),_e(7,D.IConfigurationService)],ae),e.ExtensionGalleryService=ae;let ie=class extends X{constructor(B,ee,ce,K,he,te,le){super(void 0,B,ee,ce,K,he,te,le)}};ie=Re([_e(0,m.IRequestService),_e(1,C.ILogService),_e(2,T.IEnvironmentService),_e(3,l.ITelemetryService),_e(4,d.IFileService),_e(5,y.IProductService),_e(6,D.IConfigurationService)],ie),e.ExtensionGalleryServiceWithNoStorageService=ie}),define(ve[111],we([0,1,180,5,29,19,4,6,10]),function(oe,e,I,t,v,P,k,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,w.createDecorator)("contextService");function D(n){const o=n;return typeof o?.id=="string"&&k.URI.isUri(o.uri)}e.isSingleFolderWorkspaceIdentifier=D;function T(n){if(n.configuration)return{id:n.id,configPath:n.configuration};if(n.folders.length===1)return{id:n.id,uri:n.folders[0].uri}}e.toWorkspaceIdentifier=T;function R(n){const o=n;return typeof o?.id=="string"&&k.URI.isUri(o.configPath)}e.isWorkspaceIdentifier=R;function E(n){const o=n;if(o?.uri)return{id:o.id,uri:k.URI.revive(o.uri)};const r=n;if(r?.configPath)return{id:r.id,configPath:k.URI.revive(r.configPath)};if(n?.id)return{id:n.id}}e.reviveIdentifier=E;var b;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(b=e.WorkbenchState||(e.WorkbenchState={}));function d(n){const o=n;return!!(o&&typeof o=="object"&&typeof o.id=="string"&&Array.isArray(o.folders))}e.isWorkspace=d;function C(n){const o=n;return!!(o&&typeof o=="object"&&k.URI.isUri(o.uri)&&typeof o.name=="string"&&typeof o.toResource=="function")}e.isWorkspaceFolder=C;class y{constructor(o,r,s,c,u){this._id=o,this._transient=s,this._configuration=c,this._ignorePathCasing=u,this._foldersMap=v.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=r}update(o){this._id=o.id,this._configuration=o.configuration,this._transient=o.transient,this._ignorePathCasing=o._ignorePathCasing,this.folders=o.folders}get folders(){return this._folders}set folders(o){this._folders=o,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(o){this._configuration=o}getFolder(o){return o&&this._foldersMap.findSubstr(o)||null}updateFoldersMap(){this._foldersMap=v.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const o of this.folders)this._foldersMap.set(o.uri,o)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=y;class m{constructor(o,r){this.raw=r,this.uri=o.uri,this.index=o.index,this.name=o.name}toResource(o){return(0,P.joinPath)(this.uri,o)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=m;function g(n){return new m({uri:n,index:0,name:(0,P.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=g,e.WORKSPACE_EXTENSION="code-workspace";const h=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,I.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function l(n,o){return P.extUriBiasedIgnorePathCase.isEqualOrParent(n,o.untitledWorkspacesHome)}e.isUntitledWorkspace=l;function f(n){let o;return k.URI.isUri(n)?o=n:o=n.configuration,o?.scheme===p.Schemas.tmp}e.isTemporaryWorkspace=f;function i(n,o){return!l(n,o)&&!f(n)}e.isSavedWorkspace=i;function a(n){return(typeof n=="string"?(0,t.extname)(n):(0,P.extname)(n))===h}e.hasWorkspaceFileExtension=a}),define(ve[112],we([0,1,6]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStatusService=e.IExtensionHostStatusService=void 0,e.IExtensionHostStatusService=(0,I.createDecorator)("extensionHostStatusService");class t{constructor(){this._exitInfo=new Map}setExitInfo(P,k){this._exitInfo.set(P,k)}getExitInfo(P){return this._exitInfo.get(P)||null}}e.ExtensionHostStatusService=t}),define(ve[236],we([0,1,7,14]),function(oe,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ManagementConnection=e.printTime=void 0;function v(k){let w=0,p=0,D=0;k>=1e3&&(D=Math.floor(k/1e3),k-=D*1e3),D>=60&&(p=Math.floor(D/60),D-=p*60),p>=60&&(w=Math.floor(p/60),p-=w*60);const T=w?`${w}h`:"",R=p?`${p}m`:"",E=D?`${D}s`:"",b=k?`${k}ms`:"";return`${T}${R}${E}${b}`}e.printTime=v;class P{constructor(w,p,D,T){this._logService=w,this._reconnectionToken=p,this._onClose=new I.Emitter,this.onClose=this._onClose.event,this._reconnectionGraceTime=108e5,this._reconnectionShortGraceTime=3e5,this._remoteAddress=D,this.protocol=T,this._disposed=!1,this._disconnectRunner1=new t.ProcessTimeRunOnceScheduler(()=>{this._log(`The reconnection grace time of ${v(this._reconnectionGraceTime)} has expired, so the connection will be disposed.`),this._cleanResources()},this._reconnectionGraceTime),this._disconnectRunner2=new t.ProcessTimeRunOnceScheduler(()=>{this._log(`The reconnection short grace time of ${v(this._reconnectionShortGraceTime)} has expired, so the connection will be disposed.`),this._cleanResources()},this._reconnectionShortGraceTime),this.protocol.onDidDispose(()=>{this._log("The client has disconnected gracefully, so the connection will be disposed."),this._cleanResources()}),this.protocol.onSocketClose(()=>{this._log(`The client has disconnected, will wait for reconnection ${v(this._reconnectionGraceTime)} before disposing...`),this._disconnectRunner1.schedule()}),this._log("New connection established.")}_log(w){this._logService.info(`[${this._remoteAddress}][${this._reconnectionToken.substr(0,8)}][ManagementConnection] ${w}`)}shortenReconnectionGraceTimeIfNecessary(){this._disconnectRunner2.isScheduled()||this._disconnectRunner1.isScheduled()&&(this._log(`Another client has connected, will shorten the wait for reconnection ${v(this._reconnectionShortGraceTime)} before disposing...`),this._disconnectRunner2.schedule())}_cleanResources(){if(this._disposed)return;this._disposed=!0,this._disconnectRunner1.dispose(),this._disconnectRunner2.dispose();const w=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),w.end(),this._onClose.fire(void 0)}acceptReconnection(w,p,D){this._remoteAddress=w,this._log("The client has reconnected."),this._disconnectRunner1.cancel(),this._disconnectRunner2.cancel(),this.protocol.beginAcceptReconnection(p,D),this.protocol.endAcceptReconnection()}}e.ManagementConnection=P}),define(ve[113],we([0,1,30,10,5,136,52]),function(oe,e,I,t,v,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InternalNLSConfiguration=e.getNLSConfiguration=void 0;const w=v.join(t.FileAccess.asFileUri("",oe).fsPath,"nls.metadata.json"),p=new Map;function D(E){return new Promise(b=>I.exists(E,b))}function T(E,b){return D(w).then(d=>{if(!d||!k.default.commit)return Promise.resolve({locale:"en",availableLanguages:{}});const C=`${E}||${b}`;let y=p.get(C);return y||(y=P.getNLSConfiguration(k.default.commit,b,w,E).then(m=>(R.is(m)&&(m._languagePackSupport=!0),m)),p.set(C,y)),y})}e.getNLSConfiguration=T;var R;(function(E){function b(d){const C=d;return C&&typeof C._languagePackId=="string"}E.is=b})(R=e.InternalNLSConfiguration||(e.InternalNLSConfiguration={}))}),define(ve[114],we([0,1,19,4,24,45,55,38,17,13,25,36,113]),function(oe,e,I,t,v,P,k,w,p,D,T,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let b=class extends k.AbstractExtensionsScannerService{constructor(C,y,m,g,h,l){super(t.URI.file(h.builtinExtensionsPath),t.URI.file(h.extensionsPath),(0,I.joinPath)(h.userHome,".vscode-oss-dev","extensions","control.json"),(0,I.joinPath)(t.URI.file(h.userDataPath),w.MANIFEST_CACHE_FOLDER),C,y,m,g,h,l);this.nativeEnvironmentService=h}async getTranslations(C){const y=await(0,E.getNLSConfiguration)(C,this.nativeEnvironmentService.userDataPath);if(E.InternalNLSConfiguration.is(y))try{const m=await this.fileService.readFile(t.URI.file(y._translationsConfigFile));return JSON.parse(m.value.toString())}catch{}return Object.create(null)}};b=Re([_e(0,R.IUserDataProfilesService),_e(1,P.IExtensionsProfileScannerService),_e(2,p.IFileService),_e(3,D.ILogService),_e(4,v.INativeEnvironmentService),_e(5,T.IProductService)],b),e.ExtensionsScannerService=b}),define(ve[237],we([0,1,238,30,5,26,10,21]),function(oe,e,I,t,v,P,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.requestHasValidConnectionToken=e.determineServerConnectionToken=e.parseServerConnectionToken=e.ServerConnectionTokenParseError=e.MandatoryServerConnectionToken=e.OptionalServerConnectionToken=e.NoneServerConnectionToken=e.ServerConnectionTokenType=void 0;const p=/^[0-9A-Za-z-]+$/;var D;(function(m){m[m.None=0]="None",m[m.Optional=1]="Optional",m[m.Mandatory=2]="Mandatory"})(D=e.ServerConnectionTokenType||(e.ServerConnectionTokenType={}));class T{constructor(){this.type=0}validate(g){return!0}}e.NoneServerConnectionToken=T;class R{constructor(g){this.value=g,this.type=1}validate(g){return g===this.value}}e.OptionalServerConnectionToken=R;class E{constructor(g){this.value=g,this.type=2}validate(g){return g===this.value}}e.MandatoryServerConnectionToken=E;class b{constructor(g){this.message=g}}e.ServerConnectionTokenParseError=b;async function d(m,g){const h=m["without-connection-token"],l=m["connection-token"],f=m["connection-token-file"],i=m.compatibility==="1.63";if(h)return typeof l!="undefined"||typeof f!="undefined"?new b("Please do not use the argument '--connection-token' or '--connection-token-file' at the same time as '--without-connection-token'."):new T;if(typeof f!="undefined"){if(typeof l!="undefined")return new b("Please do not use the argument '--connection-token' at the same time as '--connection-token-file'.");let a;try{a=t.readFileSync(f).toString().replace(/\r?\n$/,"")}catch{return new b(`Unable to read the connection token file at '${f}'.`)}return p.test(a)?new E(a):new b(`The connection token defined in '${f} does not adhere to the characters 0-9, a-z, A-Z or -.`)}return typeof l!="undefined"?p.test(l)?i?new R(l):new E(l):new b(`The connection token '${l} does not adhere to the characters 0-9, a-z, A-Z or -.`):i?(console.log("Breaking change in the next release: Please use one of the following arguments: '--connection-token', '--connection-token-file' or '--without-connection-token'."),new R(await g())):new E(await g())}e.parseServerConnectionToken=d;async function C(m){return d(m,async()=>{if(!m["user-data-dir"])return(0,P.generateUuid)();const h=v.join(m["user-data-dir"],"token");try{const i=(await w.Promises.readFile(h)).toString().replace(/\r?\n$/,"");if(p.test(i))return i}catch{}const l=(0,P.generateUuid)();try{await w.Promises.writeFile(h,l,{mode:384})}catch{}return l})}e.determineServerConnectionToken=C;function y(m,g,h){if(m.validate(h.query[k.connectionTokenQueryName]))return!0;const l=I.parse(g.headers.cookie||"");return m.validate(l[k.connectionTokenCookieName])}e.requestHasValidConnectionToken=y}),define(ve[46],we([0,1,181,191,57,6,24]),function(oe,e,I,t,v,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerEnvironmentService=e.IServerEnvironmentService=e.serverOptions=void 0,e.serverOptions={host:{type:"string",cat:"o",args:"ip-address",description:I.localize(0,null)},port:{type:"string",cat:"o",args:"port | port range",description:I.localize(1,null)},"pick-port":{type:"string",deprecationMessage:"Use the range notation in 'port' instead."},"socket-path":{type:"string",cat:"o",args:"path",description:I.localize(2,null)},"connection-token":{type:"string",cat:"o",args:"token",deprecates:["connectionToken"],description:I.localize(3,null)},"connection-token-file":{type:"string",cat:"o",args:"path",deprecates:["connection-secret","connectionTokenFile"],description:I.localize(4,null)},"without-connection-token":{type:"boolean",cat:"o",description:I.localize(5,null)},"disable-websocket-compression":{type:"boolean"},"print-startup-performance":{type:"boolean"},"print-ip-address":{type:"boolean"},"accept-server-license-terms":{type:"boolean",cat:"o",description:I.localize(6,null)},"server-data-dir":{type:"string",cat:"o",description:I.localize(7,null)},"telemetry-level":{type:"string",cat:"o",args:"level",description:I.localize(8,null)},"user-data-dir":v.OPTIONS["user-data-dir"],"enable-smoke-test-driver":v.OPTIONS["enable-smoke-test-driver"],"disable-telemetry":v.OPTIONS["disable-telemetry"],"disable-workspace-trust":v.OPTIONS["disable-workspace-trust"],"file-watcher-polling":{type:"string",deprecates:["fileWatcherPolling"]},log:v.OPTIONS.log,logsPath:v.OPTIONS.logsPath,"force-disable-user-env":v.OPTIONS["force-disable-user-env"],folder:{type:"string",deprecationMessage:"No longer supported. Folder needs to be provided in the browser URL or with `default-folder`."},workspace:{type:"string",deprecationMessage:"No longer supported. Workspace needs to be provided in the browser URL or with `default-workspace`."},"default-folder":{type:"string",description:I.localize(9,null)},"default-workspace":{type:"string",description:I.localize(10,null)},"enable-sync":{type:"boolean"},"github-auth":{type:"string"},"extensions-dir":v.OPTIONS["extensions-dir"],"extensions-download-dir":v.OPTIONS["extensions-download-dir"],"builtin-extensions-dir":v.OPTIONS["builtin-extensions-dir"],"install-extension":v.OPTIONS["install-extension"],"install-builtin-extension":v.OPTIONS["install-builtin-extension"],"uninstall-extension":v.OPTIONS["uninstall-extension"],"list-extensions":v.OPTIONS["list-extensions"],"locate-extension":v.OPTIONS["locate-extension"],"show-versions":v.OPTIONS["show-versions"],category:v.OPTIONS.category,force:v.OPTIONS.force,"do-not-sync":v.OPTIONS["do-not-sync"],"pre-release":v.OPTIONS["pre-release"],"start-server":{type:"boolean",cat:"e",description:I.localize(11,null)},"enable-remote-auto-shutdown":{type:"boolean"},"remote-auto-shutdown-without-delay":{type:"boolean"},"use-host-proxy":{type:"boolean"},"without-browser-env-var":{type:"boolean"},help:v.OPTIONS.help,version:v.OPTIONS.version,compatibility:{type:"string"},_:v.OPTIONS._},e.IServerEnvironmentService=(0,P.refineServiceDecorator)(k.IEnvironmentService);class w extends t.NativeEnvironmentService{get args(){return super.args}}e.ServerEnvironmentService=w}),define(ve[239],we([0,1,30,83,78,238,77,33,67,3,13,46,5,10,26,25,54,20,4,16,12,76]),function(oe,e,I,t,v,P,k,w,p,D,T,R,E,b,d,C,y,m,g,h,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebClientServer=e.serveFile=e.CacheControl=e.serveError=void 0;const i={".html":"text/html",".js":"text/javascript",".json":"application/json",".css":"text/css",".svg":"image/svg+xml"};async function a(c,u,S,A){u.writeHead(S,{"Content-Type":"text/plain"}),u.end(A)}e.serveError=a;var n;(function(c){c[c.NO_CACHING=0]="NO_CACHING",c[c.ETAG=1]="ETAG",c[c.NO_EXPIRY=2]="NO_EXPIRY"})(n=e.CacheControl||(e.CacheControl={}));async function o(c,u,S,A,M,$){try{const Q=await I.promises.stat(c);if(u===1){const _=`W/"${[Q.ino,Q.size,Q.mtime.getTime()].join("-")}"`;if(A.headers["if-none-match"]===_)return M.writeHead(304),M.end();$.Etag=_}else u===2?$["Cache-Control"]="public, max-age=31536000":u===0&&($["Cache-Control"]="no-store");$["Content-Type"]=i[(0,E.extname)(c)]||(0,p.getMediaMime)(c)||"text/plain",M.writeHead(200,$),(0,I.createReadStream)(c).pipe(M)}catch(Q){return Q.code!=="ENOENT"?(S.error(Q),console.error(Q.toString())):console.error(`File not found: ${c}`),M.writeHead(404,{"Content-Type":"text/plain"}),M.end("Not found")}}e.serveFile=o;const r=(0,E.dirname)(b.FileAccess.asFileUri("",oe).fsPath);let s=class{constructor(u,S,A,M,$){this._connectionToken=u,this._environmentService=S,this._logService=A,this._requestService=M,this._productService=$,this._webExtensionResourceUrlTemplate=this._productService.extensionsGallery?.resourceUrlTemplate?g.URI.parse(this._productService.extensionsGallery.resourceUrlTemplate):void 0;const Q=(0,f.getRemoteServerRootPath)($);this._staticRoute=`${Q}/static`,this._callbackRoute=`${Q}/callback`,this._webExtensionRoute=`${Q}/web-extension-resource`}async handle(u,S,A){try{const M=A.pathname;return M.startsWith(this._staticRoute)&&M.charCodeAt(this._staticRoute.length)===47?this._handleStatic(u,S,A):M==="/"?this._handleRoot(u,S,A):M===this._callbackRoute?this._handleCallback(S):M.startsWith(this._webExtensionRoute)&&M.charCodeAt(this._webExtensionRoute.length)===47?this._handleWebExtensionResource(u,S,A):a(u,S,404,"Not found.")}catch(M){return this._logService.error(M),console.error(M.toString()),a(u,S,500,"Internal Server Error.")}}async _handleStatic(u,S,A){const M=Object.create(null),Q=decodeURIComponent(A.pathname).substring(this._staticRoute.length+1),_=(0,E.join)(r,Q);return(0,w.isEqualOrParent)(_,r,!D.isLinux)?o(_,this._environmentService.isBuilt?2:1,this._logService,u,S,M):a(u,S,400,"Bad request.")}_getResourceURLTemplateAuthority(u){const S=u.authority.indexOf(".");return S!==-1?u.authority.substring(S+1):void 0}async _handleWebExtensionResource(u,S,A){if(!this._webExtensionResourceUrlTemplate)return a(u,S,500,"No extension gallery service configured.");const M=decodeURIComponent(A.pathname),$=(0,E.normalize)(M.substring(this._webExtensionRoute.length+1)),Q=g.URI.parse($).with({scheme:this._webExtensionResourceUrlTemplate.scheme,authority:$.substring(0,$.indexOf("/")),path:$.substring($.indexOf("/")+1)});if(this._getResourceURLTemplateAuthority(this._webExtensionResourceUrlTemplate)!==this._getResourceURLTemplateAuthority(Q))return a(u,S,403,"Request Forbidden");const _={},q=z=>{const W=u.headers[z];W&&((0,l.isString)(W)||W[0])?_[z]=(0,l.isString)(W)?W:W[0]:z!==z.toLowerCase()&&q(z.toLowerCase())};q("X-Client-Name"),q("X-Client-Version"),q("X-Machine-Id"),q("X-Client-Commit");const U=await this._requestService.request({type:"GET",url:Q.toString(!0),headers:_},m.CancellationToken.None),ne=U.res.statusCode||500;if(ne!==200){let z=null;try{z=await(0,y.asTextOrError)(U)}catch{}return a(u,S,ne,z||`Request failed with status ${ne}`)}const Z=Object.create(null),F=z=>{const W=U.res.headers[z];W?Z[z]=W:z!==z.toLowerCase()&&F(z.toLowerCase())};F("Cache-Control"),F("Content-Type"),S.writeHead(200,Z);const x=await(0,h.streamToBuffer)(U.stream);return S.end(x.buffer)}async _handleRoot(u,S,A){const M=A.query[b.connectionTokenQueryName];if(typeof M=="string"){const X=Object.create(null);X["Set-Cookie"]=P.serialize(b.connectionTokenCookieName,M,{sameSite:"lax",maxAge:60*60*24*7});const ae=Object.create(null);for(const O in A.query)O!==b.connectionTokenQueryName&&(ae[O]=A.query[O]);const ie=v.format({pathname:"/",query:ae});return X.Location=ie,S.writeHead(302,X),S.end()}const $=X=>{const ae=u.headers[X];return Array.isArray(ae)?ae[0]:ae},Q=$("x-original-host")||$("x-forwarded-host")||u.headers.host;if(!Q)return a(u,S,400,"Bad request.");function _(X){return JSON.stringify(X).replace(/"/g,"&quot;")}let q;this._environmentService.args["enable-smoke-test-driver"]&&(q=!1);const U=X=>X&&g.URI.file(t.resolve(X)).with({scheme:b.Schemas.vscodeRemote,authority:Q}),ne=b.FileAccess.asFileUri(this._environmentService.isBuilt?"vs/code/browser/workbench/workbench.html":"vs/code/browser/workbench/workbench-dev.html",oe).fsPath,Z=!this._environmentService.isBuilt&&this._environmentService.args["github-auth"]?{id:(0,d.generateUuid)(),providerId:"github",accessToken:this._environmentService.args["github-auth"],scopes:[["user:email"],["repo"]]}:void 0,F={remoteAuthority:Q,_wrapWebWorkerExtHostInIframe:q,developmentOptions:{enableSmokeTestDriver:this._environmentService.args["enable-smoke-test-driver"]?!0:void 0},settingsSyncOptions:!this._environmentService.isBuilt&&this._environmentService.args["enable-sync"]?{enabled:!0}:void 0,enableWorkspaceTrust:!this._environmentService.args["disable-workspace-trust"],folderUri:U(this._environmentService.args["default-folder"]),workspaceUri:U(this._environmentService.args["default-workspace"]),productConfiguration:{embedderIdentifier:"server-distro",extensionsGallery:this._webExtensionResourceUrlTemplate?{...this._productService.extensionsGallery,resourceUrlTemplate:this._webExtensionResourceUrlTemplate.with({scheme:"http",authority:Q,path:`${this._webExtensionRoute}/${this._webExtensionResourceUrlTemplate.authority}${this._webExtensionResourceUrlTemplate.path}`}).toString(!0)}:void 0},callbackRoute:this._callbackRoute},x=this._productService.extensionsGallery?.nlsBaseUrl,z={WORKBENCH_WEB_CONFIGURATION:_(F),WORKBENCH_AUTH_SESSION:Z?_(Z):"",WORKBENCH_WEB_BASE_URL:this._staticRoute,WORKBENCH_NLS_BASE_URL:x?`${x}${x.endsWith("/")?"":"/"}${this._productService.commit}/${this._productService.version}/`:""};let W;try{W=(await I.promises.readFile(ne)).toString().replace(/\{\{([^}]+)\}\}/g,(ae,ie)=>z[ie]??"undefined")}catch{return S.writeHead(404,{"Content-Type":"text/plain"}),S.end("Not found")}const re=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'self';",`script-src 'self' 'unsafe-eval' ${this._getScriptCspHashes(W).join(" ")} 'sha256-fh3TwPMflhsEIpR8g1OYTIMVWhXTLcjQ9kh2tIpmv54=' http://${Q};`,"child-src 'self';","frame-src 'self' https://*.vscode-cdn.net data:;","worker-src 'self' data:;","style-src 'self' 'unsafe-inline';","connect-src 'self' ws: wss: https:;","font-src 'self' blob:;","manifest-src 'self';"].join(" "),V={"Content-Type":"text/html","Content-Security-Policy":re};return this._connectionToken.type!==0&&(V["Set-Cookie"]=P.serialize(b.connectionTokenCookieName,this._connectionToken.value,{sameSite:"lax",maxAge:60*60*24*7})),S.writeHead(200,V),S.end(W)}_getScriptCspHashes(u){const S=/<script>([\s\S]+?)<\/script>/img,A=[];let M;for(;M=S.exec(u);){const $=k.createHash("sha256"),Q=M[1].replace(/\r\n/g,`
`),_=$.update(Buffer.from(Q)).digest().toString("base64");A.push(`'sha256-${_}'`)}return A}async _handleCallback(u){const S=b.FileAccess.asFileUri("vs/code/browser/workbench/callback.html",oe).fsPath,A=(await I.promises.readFile(S)).toString(),M=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'none';",`script-src 'self' ${this._getScriptCspHashes(A).join(" ")};`,"style-src 'self' 'unsafe-inline';","font-src 'self' blob:;"].join(" ");return u.writeHead(200,{"Content-Type":"text/html","Content-Security-Policy":M}),u.end(A)}};s=Re([_e(1,R.IServerEnvironmentService),_e(2,T.ILogService),_e(3,y.IRequestService),_e(4,C.IProductService)],s),e.WebClientServer=s}),define(ve[240],we([0,1,6]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,I.createDecorator)("IExtHostRpcService");class t{constructor(P){this.getProxy=P.getProxy.bind(P),this.set=P.set.bind(P),this.dispose=P.dispose.bind(P),this.assertRegistered=P.assertRegistered.bind(P),this.drain=P.drain.bind(P)}}e.ExtHostRpcService=t});var Dt=this&&this.__classPrivateFieldSet||function(oe,e,I,t,v){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!v)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!v:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?v.call(oe,I):v?v.value=I:e.set(oe,I),I},tt=this&&this.__classPrivateFieldGet||function(oe,e,I,t){if(I==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!t:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return I==="m"?t:I==="a"?t.call(oe):t?t.value:e.get(oe)};define(ve[115],we([0,1,18,11,88,29,67,15,12,4,26,17,104]),function(oe,e,I,t,v,P,k,w,p,D,T,R,E){"use strict";var b,d,C,y,m,g,h,l,f,i,a,n,o,r,s,c,u,S,A,M,$,Q;Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKindNew=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionsNew=e.InlineSuggestionNew=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function _(N){function L(){return Reflect.construct(N,arguments,this.constructor)}return Object.defineProperty(L,"name",Object.getOwnPropertyDescriptor(N,"name")),Object.setPrototypeOf(L,N),Object.setPrototypeOf(L.prototype,N.prototype),L}let q=g=class{constructor(L){b.set(this,void 0),Dt(this,b,L,"f")}static from(...L){let se=L;return new g(function(){if(se){for(const be of se)be&&typeof be.dispose=="function"&&be.dispose();se=void 0}})}dispose(){typeof tt(this,b,"f")=="function"&&(tt(this,b,"f").call(this),Dt(this,b,void 0,"f"))}};b=new WeakMap,q=g=Re([_],q),e.Disposable=q;let U=h=class{constructor(L,se){if(L<0)throw(0,t.illegalArgument)("line must be non-negative");if(se<0)throw(0,t.illegalArgument)("character must be non-negative");this._line=L,this._character=se}static Min(...L){if(L.length===0)throw new TypeError;let se=L[0];for(let be=1;be<L.length;be++){const ze=L[be];ze.isBefore(se)&&(se=ze)}return se}static Max(...L){if(L.length===0)throw new TypeError;let se=L[0];for(let be=1;be<L.length;be++){const ze=L[be];ze.isAfter(se)&&(se=ze)}return se}static isPosition(L){if(!L)return!1;if(L instanceof h)return!0;const{line:se,character:be}=L;return typeof se=="number"&&typeof be=="number"}static of(L){if(L instanceof h)return L;if(this.isPosition(L))return new h(L.line,L.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}isBefore(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<L._character}isBeforeOrEqual(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<=L._character}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this._line===L._line&&this._character===L._character}compareTo(L){return this._line<L._line?-1:this._line>L.line?1:this._character<L._character?-1:this._character>L._character?1:0}translate(L,se=0){if(L===null||se===null)throw(0,t.illegalArgument)();let be;return typeof L=="undefined"?be=0:typeof L=="number"?be=L:(be=typeof L.lineDelta=="number"?L.lineDelta:0,se=typeof L.characterDelta=="number"?L.characterDelta:0),be===0&&se===0?this:new h(this.line+be,this.character+se)}with(L,se=this.character){if(L===null||se===null)throw(0,t.illegalArgument)();let be;return typeof L=="undefined"?be=this.line:typeof L=="number"?be=L:(be=typeof L.line=="number"?L.line:this.line,se=typeof L.character=="number"?L.character:this.character),be===this.line&&se===this.character?this:new h(be,se)}toJSON(){return{line:this.line,character:this.character}}};U=h=Re([_],U),e.Position=U;let ne=l=class{constructor(L,se,be,ze){let qe,Xe;if(typeof L=="number"&&typeof se=="number"&&typeof be=="number"&&typeof ze=="number"?(qe=new U(L,se),Xe=new U(be,ze)):U.isPosition(L)&&U.isPosition(se)&&(qe=U.of(L),Xe=U.of(se)),!qe||!Xe)throw new Error("Invalid arguments");qe.isBefore(Xe)?(this._start=qe,this._end=Xe):(this._start=Xe,this._end=qe)}static isRange(L){return L instanceof l?!0:L?U.isPosition(L.start)&&U.isPosition(L.end):!1}static of(L){if(L instanceof l)return L;if(this.isRange(L))return new l(L.start,L.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}contains(L){return l.isRange(L)?this.contains(L.start)&&this.contains(L.end):U.isPosition(L)?!(U.of(L).isBefore(this._start)||this._end.isBefore(L)):!1}isEqual(L){return this._start.isEqual(L._start)&&this._end.isEqual(L._end)}intersection(L){const se=U.Max(L.start,this._start),be=U.Min(L.end,this._end);if(!se.isAfter(be))return new l(se,be)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const se=U.Min(L.start,this._start),be=U.Max(L.end,this.end);return new l(se,be)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(L,se=this.end){if(L===null||se===null)throw(0,t.illegalArgument)();let be;return L?U.isPosition(L)?be=L:(be=L.start||this.start,se=L.end||this.end):be=this.start,be.isEqual(this._start)&&se.isEqual(this.end)?this:new l(be,se)}toJSON(){return[this.start,this.end]}};ne=l=Re([_],ne),e.Range=ne;let Z=f=class extends ne{constructor(L,se,be,ze){let qe,Xe;if(typeof L=="number"&&typeof se=="number"&&typeof be=="number"&&typeof ze=="number"?(qe=new U(L,se),Xe=new U(be,ze)):U.isPosition(L)&&U.isPosition(se)&&(qe=U.of(L),Xe=U.of(se)),!qe||!Xe)throw new Error("Invalid arguments");super(qe,Xe);this._anchor=qe,this._active=Xe}static isSelection(L){return L instanceof f?!0:L?ne.isRange(L)&&U.isPosition(L.anchor)&&U.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};Z=f=Re([_],Z),e.Selection=Z;class F{constructor(L,se,be){if(typeof L!="string"||L.length===0)throw(0,t.illegalArgument)("host");if(typeof se!="number"||se===0||Math.round(se)!==se)throw(0,t.illegalArgument)("port");if(typeof be!="undefined"&&(typeof be!="string"||be.length===0||!/^[0-9A-Za-z\-]+$/.test(be)))throw(0,t.illegalArgument)("connectionToken");this.host=L,this.port=Math.round(se),this.connectionToken=be}}e.ResolvedAuthority=F;class x extends Error{constructor(L,se=E.RemoteAuthorityResolverErrorCode.Unknown,be){super(L);this._message=L,this._code=se,this._detail=be,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,x.prototype)}static NotAvailable(L,se){return new x(L,E.RemoteAuthorityResolverErrorCode.NotAvailable,se)}static TemporarilyNotAvailable(L){return new x(L,E.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=x;var z;(function(N){N[N.LF=1]="LF",N[N.CRLF=2]="CRLF"})(z=e.EndOfLine||(e.EndOfLine={}));var W;(function(N){N[N.Replace=1]="Replace",N[N.Append=2]="Append",N[N.Prepend=3]="Prepend"})(W=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let re=i=class{constructor(L,se){this._range=L,this._newText=se}static isTextEdit(L){return L instanceof i?!0:L?ne.isRange(L)&&typeof L.newText=="string":!1}static replace(L,se){return new i(L,se)}static insert(L,se){return i.replace(new ne(L,L),se)}static delete(L){return i.replace(L,"")}static setEndOfLine(L){const se=new i(new ne(new U(0,0),new U(0,0)),"");return se.newEol=L,se}get range(){return this._range}set range(L){if(L&&!ne.isRange(L))throw(0,t.illegalArgument)("range");this._range=L}get newText(){return this._newText||""}set newText(L){if(L&&typeof L!="string")throw(0,t.illegalArgument)("newText");this._newText=L}get newEol(){return this._newEol}set newEol(L){if(L&&typeof L!="number")throw(0,t.illegalArgument)("newEol");this._newEol=L}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};re=i=Re([_],re),e.TextEdit=re;let V=a=class{constructor(L,se){this.range=L,this.newCells=se}static isNotebookCellEdit(L){return L instanceof a?!0:L?Ct.isNotebookRange(L)&&Array.isArray(L.newCells):!1}static replaceCells(L,se){return new a(L,se)}static insertCells(L,se){return new a(new Ct(L,L),se)}static deleteCells(L){return new a(L,[])}static updateCellMetadata(L,se){const be=new a(new Ct(L,L),[]);return be.newCellMetadata=se,be}static updateNotebookMetadata(L){const se=new a(new Ct(0,0),[]);return se.newNotebookMetadata=L,se}};V=a=Re([_],V),e.NotebookEdit=V;var X;(function(N){N[N.File=1]="File",N[N.Text=2]="Text",N[N.Cell=3]="Cell",N[N.CellReplace=5]="CellReplace"})(X=e.FileEditType||(e.FileEditType={}));let ae=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(L,se,be,ze){this._edits.push({_type:1,from:L,to:se,options:be,metadata:ze})}createFile(L,se,be){this._edits.push({_type:1,from:void 0,to:L,options:se,metadata:be})}deleteFile(L,se,be){this._edits.push({_type:1,from:L,to:void 0,options:se,metadata:be})}replaceNotebookMetadata(L,se,be){this._edits.push({_type:3,metadata:be,uri:L,edit:{editType:5,metadata:se},notebookMetadata:se})}replaceNotebookCells(L,se,be,ze,qe){let Xe,Ze,at=[],lt;if(Ct.isNotebookRange(se)&&kt.isNotebookCellDataArray(be)&&!kt.isNotebookCellDataArray(ze)?(Xe=se.start,Ze=se.end,at=be,lt=ze):typeof se=="number"&&typeof be=="number"&&kt.isNotebookCellDataArray(ze)&&(Xe=se,Ze=be,at=ze,lt=qe),Xe===void 0||Ze===void 0)throw new Error("Invalid arguments");(Xe!==Ze||at.length>0)&&this._edits.push({_type:5,uri:L,index:Xe,count:Ze-Xe,cells:at,metadata:lt})}replaceNotebookCellMetadata(L,se,be,ze){this._edits.push({_type:3,metadata:ze,uri:L,edit:{editType:8,index:se,metadata:be}})}replace(L,se,be,ze){this._edits.push({_type:2,uri:L,edit:new re(se,be),metadata:ze})}insert(L,se,be,ze){this.replace(L,new ne(se,se),be,ze)}delete(L,se,be){this.replace(L,se,"",be)}has(L){return this._edits.some(se=>se._type===2&&se.uri.toString()===L.toString())}set(L,se){if(se)for(const be of se)be&&(V.isNotebookCellEdit(be)?be.newCellMetadata?this.replaceNotebookCellMetadata(L,be.range.start,be.newCellMetadata):be.newNotebookMetadata?this.replaceNotebookMetadata(L,be.newNotebookMetadata):this.replaceNotebookCells(L,be.range,be.newCells):this._edits.push({_type:2,uri:L,edit:be}));else{for(let be=0;be<this._edits.length;be++){const ze=this._edits[be];ze._type===2&&ze.uri.toString()===L.toString()&&(this._edits[be]=void 0)}(0,I.coalesceInPlace)(this._edits)}}get(L){const se=[];for(const be of this._edits)be._type===2&&be.uri.toString()===L.toString()&&se.push(be.edit);return se}entries(){const L=new P.ResourceMap;for(const se of this._edits)if(se._type===2){let be=L.get(se.uri);be||(be=[se.uri,[]],L.set(se.uri,be)),be[1].push(se.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};ae=Re([_],ae),e.WorkspaceEdit=ae;let ie=n=class{constructor(L){this._tabstop=1,this.value=L||""}static isSnippetString(L){return L instanceof n?!0:L?typeof L.value=="string":!1}static _escape(L){return L.replace(/\$|}|\\/g,"\\$&")}appendText(L){return this.value+=n._escape(L),this}appendTabstop(L=this._tabstop++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,se=this._tabstop++){if(typeof L=="function"){const be=new n;be._tabstop=this._tabstop,L(be),this._tabstop=be._tabstop,L=be.value}else L=n._escape(L);return this.value+="${",this.value+=se,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,se=this._tabstop++){const be=L.map(ze=>ze.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=se,this.value+="|",this.value+=be,this.value+="|}",this}appendVariable(L,se){if(typeof se=="function"){const be=new n;be._tabstop=this._tabstop,se(be),this._tabstop=be._tabstop,se=be.value}else typeof se=="string"&&(se=se.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,se&&(this.value+=":",this.value+=se),this.value+="}",this}};ie=n=Re([_],ie),e.SnippetString=ie;var O;(function(N){N[N.Unnecessary=1]="Unnecessary",N[N.Deprecated=2]="Deprecated"})(O=e.DiagnosticTag||(e.DiagnosticTag={}));var B;(function(N){N[N.Hint=3]="Hint",N[N.Information=2]="Information",N[N.Warning=1]="Warning",N[N.Error=0]="Error"})(B=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ee=o=class{constructor(L,se){if(this.uri=L,se)if(ne.isRange(se))this.range=ne.of(se);else if(U.isPosition(se))this.range=new ne(se,se);else throw new Error("Illegal argument")}static isLocation(L){return L instanceof o?!0:L?ne.isRange(L.range)&&D.URI.isUri(L.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};ee=o=Re([_],ee),e.Location=ee;let ce=class{constructor(L,se){this.location=L,this.message=se}static is(L){return L?typeof L.message=="string"&&L.location&&ne.isRange(L.location.range)&&D.URI.isUri(L.location.uri):!1}static isEqual(L,se){return L===se?!0:!L||!se?!1:L.message===se.message&&L.location.range.isEqual(se.location.range)&&L.location.uri.toString()===se.location.uri.toString()}};ce=Re([_],ce),e.DiagnosticRelatedInformation=ce;let K=class{constructor(L,se,be=B.Error){if(!ne.isRange(L))throw new TypeError("range must be set");if(!se)throw new TypeError("message must be set");this.range=L,this.message=se,this.severity=be}toJSON(){return{severity:B[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,se){return L===se?!0:!L||!se?!1:L.message===se.message&&L.severity===se.severity&&L.code===se.code&&L.severity===se.severity&&L.source===se.source&&L.range.isEqual(se.range)&&(0,I.equals)(L.tags,se.tags)&&(0,I.equals)(L.relatedInformation,se.relatedInformation,ce.isEqual)}};K=Re([_],K),e.Diagnostic=K;let he=class{constructor(L,se){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:this.contents=[L],this.range=se}};he=Re([_],he),e.Hover=he;var te;(function(N){N[N.Text=0]="Text",N[N.Read=1]="Read",N[N.Write=2]="Write"})(te=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let le=class{constructor(L,se=te.Text){this.range=L,this.kind=se}toJSON(){return{range:this.range,kind:te[this.kind]}}};le=Re([_],le),e.DocumentHighlight=le;var de;(function(N){N[N.File=0]="File",N[N.Module=1]="Module",N[N.Namespace=2]="Namespace",N[N.Package=3]="Package",N[N.Class=4]="Class",N[N.Method=5]="Method",N[N.Property=6]="Property",N[N.Field=7]="Field",N[N.Constructor=8]="Constructor",N[N.Enum=9]="Enum",N[N.Interface=10]="Interface",N[N.Function=11]="Function",N[N.Variable=12]="Variable",N[N.Constant=13]="Constant",N[N.String=14]="String",N[N.Number=15]="Number",N[N.Boolean=16]="Boolean",N[N.Array=17]="Array",N[N.Object=18]="Object",N[N.Key=19]="Key",N[N.Null=20]="Null",N[N.EnumMember=21]="EnumMember",N[N.Struct=22]="Struct",N[N.Event=23]="Event",N[N.Operator=24]="Operator",N[N.TypeParameter=25]="TypeParameter"})(de=e.SymbolKind||(e.SymbolKind={}));var Y;(function(N){N[N.Deprecated=1]="Deprecated"})(Y=e.SymbolTag||(e.SymbolTag={}));let J=r=class{constructor(L,se,be,ze,qe){this.name=L,this.kind=se,this.containerName=qe,typeof be=="string"&&(this.containerName=be),ze instanceof ee?this.location=ze:be instanceof ne&&(this.location=new ee(ze,be)),r.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:de[this.kind],location:this.location,containerName:this.containerName}}};J=r=Re([_],J),e.SymbolInformation=J;let H=s=class{constructor(L,se,be,ze,qe){this.name=L,this.detail=se,this.kind=be,this.range=ze,this.selectionRange=qe,this.children=[],s.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children?.forEach(s.validate)}};H=s=Re([_],H),e.DocumentSymbol=H;var G;(function(N){N[N.Invoke=1]="Invoke",N[N.Automatic=2]="Automatic"})(G=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let fe=class{constructor(L,se){this.title=L,this.kind=se}};fe=Re([_],fe),e.CodeAction=fe;let pe=c=class{constructor(L){this.value=L}append(L){return new c(this.value?this.value+c.sep+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+c.sep)}};pe.sep=".",pe=c=Re([_],pe),e.CodeActionKind=pe,pe.Empty=new pe(""),pe.QuickFix=pe.Empty.append("quickfix"),pe.Refactor=pe.Empty.append("refactor"),pe.RefactorExtract=pe.Refactor.append("extract"),pe.RefactorInline=pe.Refactor.append("inline"),pe.RefactorRewrite=pe.Refactor.append("rewrite"),pe.Source=pe.Empty.append("source"),pe.SourceOrganizeImports=pe.Source.append("organizeImports"),pe.SourceFixAll=pe.Source.append("fixAll");let ke=class{constructor(L,se){if(this.range=L,this.parent=se,se&&!se.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ke=Re([_],ke),e.SelectionRange=ke;class Te{constructor(L,se,be,ze,qe,Xe){this.kind=L,this.name=se,this.detail=be,this.uri=ze,this.range=qe,this.selectionRange=Xe}}e.CallHierarchyItem=Te;class Me{constructor(L,se){this.fromRanges=se,this.from=L}}e.CallHierarchyIncomingCall=Me;class Be{constructor(L,se){this.fromRanges=se,this.to=L}}e.CallHierarchyOutgoingCall=Be;var ge;(function(N){N[N.Information=0]="Information",N[N.Warning=1]="Warning",N[N.Error=2]="Error"})(ge=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Se=class{constructor(L,se){this.range=L,this.command=se}get isResolved(){return!!this.command}};Se=Re([_],Se),e.CodeLens=Se;let ye=u=class{constructor(L,se=!1){d.set(this,void 0),Dt(this,d,new v.MarkdownString(L,{supportThemeIcons:se}),"f")}static isMarkdownString(L){return L instanceof u?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}get value(){return tt(this,d,"f").value}set value(L){tt(this,d,"f").value=L}get isTrusted(){return tt(this,d,"f").isTrusted}set isTrusted(L){tt(this,d,"f").isTrusted=L}get supportThemeIcons(){return tt(this,d,"f").supportThemeIcons}set supportThemeIcons(L){tt(this,d,"f").supportThemeIcons=L}get supportHtml(){return tt(this,d,"f").supportHtml}set supportHtml(L){tt(this,d,"f").supportHtml=L}get baseUri(){return tt(this,d,"f").baseUri}set baseUri(L){tt(this,d,"f").baseUri=L}appendText(L){return tt(this,d,"f").appendText(L),this}appendMarkdown(L){return tt(this,d,"f").appendMarkdown(L),this}appendCodeblock(L,se){return tt(this,d,"f").appendCodeblock(se??"",L),this}};d=new WeakMap,ye=u=Re([_],ye),e.MarkdownString=ye;let Oe=class{constructor(L,se){this.label=L,this.documentation=se}};Oe=Re([_],Oe),e.ParameterInformation=Oe;let Ne=class{constructor(L,se){this.label=L,this.documentation=se,this.parameters=[]}};Ne=Re([_],Ne),e.SignatureInformation=Ne;let Je=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Je=Re([_],Je),e.SignatureHelp=Je;var $e;(function(N){N[N.Invoke=1]="Invoke",N[N.TriggerCharacter=2]="TriggerCharacter",N[N.ContentChange=3]="ContentChange"})($e=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var He;(function(N){N[N.Type=1]="Type",N[N.Parameter=2]="Parameter"})(He=e.InlayHintKind||(e.InlayHintKind={}));let We=class{constructor(L){this.value=L}};We=Re([_],We),e.InlayHintLabelPart=We;let je=class{constructor(L,se,be){this.position=L,this.label=se,this.kind=be}};je=Re([_],je),e.InlayHint=je;var Ge;(function(N){N[N.Invoke=0]="Invoke",N[N.TriggerCharacter=1]="TriggerCharacter",N[N.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ge=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ue;(function(N){N[N.Text=0]="Text",N[N.Method=1]="Method",N[N.Function=2]="Function",N[N.Constructor=3]="Constructor",N[N.Field=4]="Field",N[N.Variable=5]="Variable",N[N.Class=6]="Class",N[N.Interface=7]="Interface",N[N.Module=8]="Module",N[N.Property=9]="Property",N[N.Unit=10]="Unit",N[N.Value=11]="Value",N[N.Enum=12]="Enum",N[N.Keyword=13]="Keyword",N[N.Snippet=14]="Snippet",N[N.Color=15]="Color",N[N.File=16]="File",N[N.Reference=17]="Reference",N[N.Folder=18]="Folder",N[N.EnumMember=19]="EnumMember",N[N.Constant=20]="Constant",N[N.Struct=21]="Struct",N[N.Event=22]="Event",N[N.Operator=23]="Operator",N[N.TypeParameter=24]="TypeParameter",N[N.User=25]="User",N[N.Issue=26]="Issue"})(ue=e.CompletionItemKind||(e.CompletionItemKind={}));var Ce;(function(N){N[N.Deprecated=1]="Deprecated"})(Ce=e.CompletionItemTag||(e.CompletionItemTag={}));let Pe=class{constructor(L,se){this.label=L,this.kind=se}toJSON(){return{label:this.label,kind:this.kind&&ue[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Pe=Re([_],Pe),e.CompletionItem=Pe;let Ae=class{constructor(L=[],se=!1){this.items=L,this.isIncomplete=se}};Ae=Re([_],Ae),e.CompletionList=Ae;let Le=class{constructor(L,se,be){this.insertText=L,this.range=se,this.command=be}};Le=Re([_],Le),e.InlineSuggestion=Le;let Ue=class{constructor(L){this.commands=void 0,this.items=L}};Ue=Re([_],Ue),e.InlineSuggestionList=Ue;let Ve=class{constructor(L,se,be){this.insertText=L,this.range=se,this.command=be}};Ve=Re([_],Ve),e.InlineSuggestionNew=Ve;let Ke=class{constructor(L,se){this.items=L,this.commands=se}};Ke=Re([_],Ke),e.InlineSuggestionsNew=Ke;var et;(function(N){N[N.Active=-1]="Active",N[N.Beside=-2]="Beside",N[N.One=1]="One",N[N.Two=2]="Two",N[N.Three=3]="Three",N[N.Four=4]="Four",N[N.Five=5]="Five",N[N.Six=6]="Six",N[N.Seven=7]="Seven",N[N.Eight=8]="Eight",N[N.Nine=9]="Nine"})(et=e.ViewColumn||(e.ViewColumn={}));var nt;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(nt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var it;(function(N){N[N.Off=0]="Off",N[N.On=1]="On",N[N.Relative=2]="Relative"})(it=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var rt;(function(N){N[N.Manual=1]="Manual",N[N.AfterDelay=2]="AfterDelay",N[N.FocusOut=3]="FocusOut"})(rt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var dt;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(dt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var pt;(function(N){N[N.Keyboard=1]="Keyboard",N[N.Mouse=2]="Mouse",N[N.Command=3]="Command"})(pt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var vt;(function(N){N[N.Undo=1]="Undo",N[N.Redo=2]="Redo"})(vt=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Et;(function(N){N[N.OpenOpen=0]="OpenOpen",N[N.ClosedClosed=1]="ClosedClosed",N[N.OpenClosed=2]="OpenClosed",N[N.ClosedOpen=3]="ClosedOpen"})(Et=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(N){function L(se){switch(se){case"keyboard":return N.Keyboard;case"mouse":return N.Mouse;case"api":return N.Command}}N.fromValue=L}(pt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let St=class{constructor(L,se){if(se&&!D.URI.isUri(se))throw(0,t.illegalArgument)("target");if(!ne.isRange(L)||L.isEmpty)throw(0,t.illegalArgument)("range");this.range=L,this.target=se}};St=Re([_],St),e.DocumentLink=St;let ot=class{constructor(L,se,be,ze){this.red=L,this.green=se,this.blue=be,this.alpha=ze}};ot=Re([_],ot),e.Color=ot;let ct=class{constructor(L,se){if(se&&!(se instanceof ot))throw(0,t.illegalArgument)("color");if(!ne.isRange(L)||L.isEmpty)throw(0,t.illegalArgument)("range");this.range=L,this.color=se}};ct=Re([_],ct),e.ColorInformation=ct;let ft=class{constructor(L){if(!L||typeof L!="string")throw(0,t.illegalArgument)("label");this.label=L}};ft=Re([_],ft),e.ColorPresentation=ft;var _t;(function(N){N[N.RGB=0]="RGB",N[N.HEX=1]="HEX",N[N.HSL=2]="HSL"})(_t=e.ColorFormat||(e.ColorFormat={}));var Lt;(function(N){N[N.Error=0]="Error",N[N.Warning=1]="Warning",N[N.Information=2]="Information"})(Lt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class Tt{constructor(L,se,be){if(this.startIndex=L,this.length=se,this.tooltip=be,typeof L!="number"||L<0)throw(0,t.illegalArgument)("startIndex");if(typeof se!="number"||se<1)throw(0,t.illegalArgument)("length");if(be!==void 0&&typeof be!="string")throw(0,t.illegalArgument)("tooltip")}}e.TerminalLink=Tt;var Ft;(function(N){N[N.Panel=1]="Panel",N[N.Editor=2]="Editor"})(Ft=e.TerminalLocation||(e.TerminalLocation={}));class Ee{constructor(L){if(this.options=L,typeof L!="object")throw(0,t.illegalArgument)("options")}}e.TerminalProfile=Ee;var Ie;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(Ie=e.TaskRevealKind||(e.TaskRevealKind={}));var me;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(me=e.TaskPanelKind||(e.TaskPanelKind={}));let j=S=class{constructor(L,se){if(this.label=se,typeof L!="string"||typeof se!="string")throw(0,t.illegalArgument)("name");this._id=L}static from(L){switch(L){case"clean":return S.Clean;case"build":return S.Build;case"rebuild":return S.Rebuild;case"test":return S.Test;default:return}}get id(){return this._id}};j.Clean=new S("clean","Clean"),j.Build=new S("build","Build"),j.Rebuild=new S("rebuild","Rebuild"),j.Test=new S("test","Test"),j=S=Re([_],j),e.TaskGroup=j;function De(N){let L="";for(let se=0;se<N.length;se++)L+=N[se].replace(/,/g,",,")+",";return L}let Fe=class{constructor(L,se,be){if(typeof L!="string")throw(0,t.illegalArgument)("process");this._args=[],this._process=L,se!==void 0&&(Array.isArray(se)?(this._args=se,this._options=be):this._options=se)}get process(){return this._process}set process(L){if(typeof L!="string")throw(0,t.illegalArgument)("process");this._process=L}get args(){return this._args}set args(L){Array.isArray(L)||(L=[]),this._args=L}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("process"),this._process!==void 0&&L.push(this._process),this._args&&this._args.length>0)for(const se of this._args)L.push(se);return De(L)}};Fe=Re([_],Fe),e.ProcessExecution=Fe;let Qe=class{constructor(L,se,be){if(this._args=[],Array.isArray(se)){if(!L)throw(0,t.illegalArgument)("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw(0,t.illegalArgument)("command");this._command=L,this._args=se,this._options=be}else{if(typeof L!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=L,this._options=se}}get commandLine(){return this._commandLine}set commandLine(L){if(typeof L!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=L}get command(){return this._command?this._command:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw(0,t.illegalArgument)("command");this._command=L}get args(){return this._args}set args(L){this._args=L||[]}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("shell"),this._commandLine!==void 0&&L.push(this._commandLine),this._command!==void 0&&L.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const se of this._args)L.push(typeof se=="string"?se:se.value);return De(L)}};Qe=Re([_],Qe),e.ShellExecution=Qe;var Ye;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(Ye=e.ShellQuoting||(e.ShellQuoting={}));var xe;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace"})(xe=e.TaskScope||(e.TaskScope={}));class st{constructor(L){this._callback=L}computeId(){return"customExecution"+(0,T.generateUuid)()}set callback(L){this._callback=L}get callback(){return this._callback}}e.CustomExecution=st;let ht=A=class{constructor(L,se,be,ze,qe,Xe){this.__deprecated=!1,this._definition=this.definition=L;let Ze;typeof se=="string"?(this._name=this.name=se,this._source=this.source=be,this.execution=ze,Ze=qe,this.__deprecated=!0):se===xe.Global||se===xe.Workspace?(this.target=se,this._name=this.name=be,this._source=this.source=ze,this.execution=qe,Ze=Xe):(this.target=se,this._name=this.name=be,this._source=this.source=ze,this.execution=qe,Ze=Xe),typeof Ze=="string"?(this._problemMatchers=[Ze],this._hasDefinedMatchers=!0):Array.isArray(Ze)?(this._problemMatchers=Ze,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(L){this.__id=L}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Fe?this._definition={type:A.ProcessType,id:this._execution.computeId()}:this._execution instanceof Qe?this._definition={type:A.ShellType,id:this._execution.computeId()}:this._execution instanceof st?this._definition={type:A.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:A.EmptyType,id:(0,T.generateUuid)()}}get definition(){return this._definition}set definition(L){if(L==null)throw(0,t.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=L}get scope(){return this._scope}set target(L){this.clear(),this._scope=L}get name(){return this._name}set name(L){if(typeof L!="string")throw(0,t.illegalArgument)("name");this.clear(),this._name=L}get execution(){return this._execution}set execution(L){L===null&&(L=void 0),this.clear(),this._execution=L;const se=this._definition.type;(A.EmptyType===se||A.ProcessType===se||A.ShellType===se||A.ExtensionCallbackType===se)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(L){if(Array.isArray(L))this.clear(),this._problemMatchers=L,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.clear(),this._isBackground=L}get source(){return this._source}set source(L){if(typeof L!="string"||L.length===0)throw(0,t.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=L}get group(){return this._group}set group(L){L===null&&(L=void 0),this.clear(),this._group=L}get detail(){return this._detail}set detail(L){L===null&&(L=void 0),this._detail=L}get presentationOptions(){return this._presentationOptions}set presentationOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._presentationOptions=L}get runOptions(){return this._runOptions}set runOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._runOptions=L}};ht.ExtensionCallbackType="customExecution",ht.ProcessType="process",ht.ShellType="shell",ht.EmptyType="$empty",ht=A=Re([_],ht),e.Task=ht;var bt;(function(N){N[N.SourceControl=1]="SourceControl",N[N.Window=10]="Window",N[N.Notification=15]="Notification"})(bt=e.ProgressLocation||(e.ProgressLocation={}));let ut=class{constructor(L,se=wt.None){this.collapsibleState=se,D.URI.isUri(L)?this.resourceUri=L:this.label=L}};ut=Re([_],ut),e.TreeItem=ut;var wt;(function(N){N[N.None=0]="None",N[N.Collapsed=1]="Collapsed",N[N.Expanded=2]="Expanded"})(wt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let zt=class{constructor(L){this.value=L}async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}};zt=Re([_],zt),e.DataTransferItem=zt;let $t=class{constructor(L){C.set(this,new Map);for(const[se,be]of L??[]){const ze=tt(this,C,"f").get(se);ze?ze.push(be):tt(this,C,"f").set(se,[be])}}get(L){return tt(this,C,"f").get(L)?.[0]}set(L,se){tt(this,C,"f").set(L,[se])}forEach(L,se){for(const[be,ze]of tt(this,C,"f"))for(const qe of ze)L.call(se,qe,be,this)}*[(C=new WeakMap,Symbol.iterator)](){for(const[L,se]of tt(this,C,"f"))for(const be of se)yield[L,be]}};$t=Re([_],$t),e.DataTransfer=$t;let Wt=class{constructor(L){this.insertText=L}};Wt=Re([_],Wt),e.DocumentDropEdit=Wt;let jt=class{constructor(L){this.insertText=L}};jt=Re([_],jt),e.DocumentPasteEdit=jt;let Pt=class{constructor(L,se){this.id=L,this.color=se}};Pt=Re([_],Pt),e.ThemeIcon=Pt,Pt.File=new Pt("file"),Pt.Folder=new Pt("folder");let Ht=class{constructor(L){this.id=L}};Ht=Re([_],Ht),e.ThemeColor=Ht;var wn;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.WorkspaceFolder=3]="WorkspaceFolder"})(wn=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Vt=class{constructor(L,se){if(typeof L!="string"&&(!L||!D.URI.isUri(L)&&!D.URI.isUri(L.uri)))throw(0,t.illegalArgument)("base");if(typeof se!="string")throw(0,t.illegalArgument)("pattern");typeof L=="string"?this.baseUri=D.URI.file(L):D.URI.isUri(L)?this.baseUri=L:this.baseUri=L.uri,this.pattern=se}get base(){return this._base}set base(L){this._base=L,this._baseUri=D.URI.file(L)}get baseUri(){return this._baseUri}set baseUri(L){this._baseUri=L,this._base=L.fsPath}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};Vt=Re([_],Vt),e.RelativePattern=Vt;let Rt=class{constructor(L,se,be,ze){this.enabled=typeof L=="boolean"?L:!0,typeof se=="string"&&(this.condition=se),typeof be=="string"&&(this.hitCondition=be),typeof ze=="string"&&(this.logMessage=ze)}get id(){return this._id||(this._id=(0,T.generateUuid)()),this._id}};Rt=Re([_],Rt),e.Breakpoint=Rt;let qt=class extends Rt{constructor(L,se,be,ze,qe){super(se,be,ze,qe);if(L===null)throw(0,t.illegalArgument)("location");this.location=L}};qt=Re([_],qt),e.SourceBreakpoint=qt;let xt=class extends Rt{constructor(L,se,be,ze,qe){super(se,be,ze,qe);this.functionName=L}};xt=Re([_],xt),e.FunctionBreakpoint=xt;let Gt=class extends Rt{constructor(L,se,be,ze,qe,Xe,Ze){super(ze,qe,Xe,Ze);if(!se)throw(0,t.illegalArgument)("dataId");this.label=L,this.dataId=se,this.canPersist=be}};Gt=Re([_],Gt),e.DataBreakpoint=Gt;let Kt=class{constructor(L,se,be){this.command=L,this.args=se||[],this.options=be}};Kt=Re([_],Kt),e.DebugAdapterExecutable=Kt;let Qt=class{constructor(L,se){this.port=L,this.host=se}};Qt=Re([_],Qt),e.DebugAdapterServer=Qt;let Yt=class{constructor(L){this.path=L}};Yt=Re([_],Yt),e.DebugAdapterNamedPipeServer=Yt;let Xt=class{constructor(L){this.implementation=L}};Xt=Re([_],Xt),e.DebugAdapterInlineImplementation=Xt;let Jt=class{constructor(L,se){this.range=L,this.expression=se}};Jt=Re([_],Jt),e.EvaluatableExpression=Jt;var yn;(function(N){N[N.Invoke=0]="Invoke",N[N.Automatic=1]="Automatic"})(yn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var En;(function(N){N[N.Invoke=0]="Invoke",N[N.Automatic=1]="Automatic"})(En=e.InlineCompletionTriggerKindNew||(e.InlineCompletionTriggerKindNew={}));let Zt=class{constructor(L,se){this.range=L,this.text=se}};Zt=Re([_],Zt),e.InlineValueText=Zt;let en=class{constructor(L,se,be=!0){this.range=L,this.variableName=se,this.caseSensitiveLookup=be}};en=Re([_],en),e.InlineValueVariableLookup=en;let tn=class{constructor(L,se){this.range=L,this.expression=se}};tn=Re([_],tn),e.InlineValueEvaluatableExpression=tn;let nn=class{constructor(L,se){this.frameId=L,this.stoppedLocation=se}};nn=Re([_],nn),e.InlineValueContext=nn;var Sn;(function(N){N[N.Changed=1]="Changed",N[N.Created=2]="Created",N[N.Deleted=3]="Deleted"})(Sn=e.FileChangeType||(e.FileChangeType={}));let rn=M=class extends Error{constructor(L,se=R.FileSystemProviderErrorCode.Unknown,be){super(D.URI.isUri(L)?L.toString(!0):L);this.code=be?.name??"Unknown",(0,R.markAsFileSystemProviderError)(this,se),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,M.prototype),typeof Error.captureStackTrace=="function"&&typeof be=="function"&&Error.captureStackTrace(this,be)}static FileExists(L){return new M(L,R.FileSystemProviderErrorCode.FileExists,M.FileExists)}static FileNotFound(L){return new M(L,R.FileSystemProviderErrorCode.FileNotFound,M.FileNotFound)}static FileNotADirectory(L){return new M(L,R.FileSystemProviderErrorCode.FileNotADirectory,M.FileNotADirectory)}static FileIsADirectory(L){return new M(L,R.FileSystemProviderErrorCode.FileIsADirectory,M.FileIsADirectory)}static NoPermissions(L){return new M(L,R.FileSystemProviderErrorCode.NoPermissions,M.NoPermissions)}static Unavailable(L){return new M(L,R.FileSystemProviderErrorCode.Unavailable,M.Unavailable)}};rn=M=Re([_],rn),e.FileSystemError=rn;let sn=class{constructor(L,se,be){this.start=L,this.end=se,this.kind=be}};sn=Re([_],sn),e.FoldingRange=sn;var bn;(function(N){N[N.Comment=1]="Comment",N[N.Imports=2]="Imports",N[N.Region=3]="Region"})(bn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Cn;(function(N){N[N.Collapsed=0]="Collapsed",N[N.Expanded=1]="Expanded"})(Cn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var In;(function(N){N[N.Editing=0]="Editing",N[N.Preview=1]="Preview"})(In=e.CommentMode||(e.CommentMode={}));var Dn;(function(N){N[N.Unresolved=0]="Unresolved",N[N.Resolved=1]="Resolved"})(Dn=e.CommentThreadState||(e.CommentThreadState={}));class Pn{constructor(L,se=[]){this.tokenTypes=L,this.tokenModifiers=se}}e.SemanticTokensLegend=Pn;function kn(N){return typeof N=="undefined"||(0,p.isStringArray)(N)}class on{constructor(L){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,L){this._hasLegend=!0;for(let se=0,be=L.tokenTypes.length;se<be;se++)this._tokenTypeStrToInt.set(L.tokenTypes[se],se);for(let se=0,be=L.tokenModifiers.length;se<be;se++)this._tokenModifierStrToInt.set(L.tokenModifiers[se],se)}}push(L,se,be,ze,qe){if(typeof L=="number"&&typeof se=="number"&&typeof be=="number"&&typeof ze=="number"&&(typeof qe=="number"||typeof qe=="undefined"))return typeof qe=="undefined"&&(qe=0),this._pushEncoded(L,se,be,ze,qe);if(ne.isRange(L)&&typeof se=="string"&&kn(be))return this._push(L,se,be);throw(0,t.illegalArgument)()}_push(L,se,be){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(se))throw new Error("`tokenType` is not in the provided legend");const ze=L.start.line,qe=L.start.character,Xe=L.end.character-L.start.character,Ze=this._tokenTypeStrToInt.get(se);let at=0;if(be)for(const lt of be){if(!this._tokenModifierStrToInt.has(lt))throw new Error("`tokenModifier` is not in the provided legend");const gt=this._tokenModifierStrToInt.get(lt);at|=1<<gt>>>0}this._pushEncoded(ze,qe,Xe,Ze,at)}_pushEncoded(L,se,be,ze,qe){if(this._dataIsSortedAndDeltaEncoded&&(L<this._prevLine||L===this._prevLine&&se<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const at=this._data.length/5|0;let lt=0,gt=0;for(let yt=0;yt<at;yt++){let It=this._data[5*yt],Ot=this._data[5*yt+1];It===0?(It=lt,Ot+=gt):It+=lt,this._data[5*yt]=It,this._data[5*yt+1]=Ot,lt=It,gt=Ot}}let Xe=L,Ze=se;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(Xe-=this._prevLine,Xe===0&&(Ze-=this._prevChar)),this._data[this._dataLen++]=Xe,this._data[this._dataLen++]=Ze,this._data[this._dataLen++]=be,this._data[this._dataLen++]=ze,this._data[this._dataLen++]=qe,this._prevLine=L,this._prevChar=se}static _sortAndDeltaEncode(L){const se=[],be=L.length/5|0;for(let Ze=0;Ze<be;Ze++)se[Ze]=Ze;se.sort((Ze,at)=>{const lt=L[5*Ze],gt=L[5*at];if(lt===gt){const yt=L[5*Ze+1],It=L[5*at+1];return yt-It}return lt-gt});const ze=new Uint32Array(L.length);let qe=0,Xe=0;for(let Ze=0;Ze<be;Ze++){const at=5*se[Ze],lt=L[at+0],gt=L[at+1],yt=L[at+2],It=L[at+3],Ot=L[at+4],vn=lt-qe,li=vn===0?gt-Xe:gt,Nt=5*Ze;ze[Nt+0]=vn,ze[Nt+1]=li,ze[Nt+2]=yt,ze[Nt+3]=It,ze[Nt+4]=Ot,qe=lt,Xe=gt}return ze}build(L){return this._dataIsSortedAndDeltaEncoded?new an(new Uint32Array(this._data),L):new an(on._sortAndDeltaEncode(this._data),L)}}e.SemanticTokensBuilder=on;class an{constructor(L,se){this.resultId=se,this.data=L}}e.SemanticTokens=an;class Tn{constructor(L,se,be){this.start=L,this.deleteCount=se,this.data=be}}e.SemanticTokensEdit=Tn;class Rn{constructor(L,se){this.resultId=se,this.edits=L}}e.SemanticTokensEdits=Rn;var An;(function(N){N[N.Separate=0]="Separate",N[N.MergeWithParent=1]="MergeWithParent"})(An=e.DebugConsoleMode||(e.DebugConsoleMode={}));let Mt=class{constructor(){}};Mt.Back={iconPath:new Pt("arrow-left")},Mt=Re([_],Mt),e.QuickInputButtons=Mt;var _n;(function(N){N[N.Separator=-1]="Separator",N[N.Default=0]="Default"})(_n=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Ln;(function(N){N[N.Info=1]="Info",N[N.Warning=2]="Warning",N[N.Error=3]="Error"})(Ln=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var Fn;(function(N){N[N.UI=1]="UI",N[N.Workspace=2]="Workspace"})(Fn=e.ExtensionKind||(e.ExtensionKind={}));class On{constructor(L,se,be){this.badge=L,this.tooltip=se,this.color=be}static validate(L){if(L.badge){let se=(0,w.nextCharLength)(L.badge,0);if(se<L.badge.length&&(se+=(0,w.nextCharLength)(L.badge,se)),L.badge.length>se)throw new Error("The 'badge'-property must be undefined or a short character")}if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=On;let ln=class{constructor(L){this.kind=L}};ln=Re([_],ln),e.ColorTheme=ln;var Nn;(function(N){N[N.Light=1]="Light",N[N.Dark=2]="Dark",N[N.HighContrast=3]="HighContrast",N[N.HighContrastLight=4]="HighContrastLight"})(Nn=e.ColorThemeKind||(e.ColorThemeKind={}));class Ct{constructor(L,se){if(L<0)throw(0,t.illegalArgument)("start must be positive");if(se<0)throw(0,t.illegalArgument)("end must be positive");L<=se?(this._start=L,this._end=se):(this._start=se,this._end=L)}static isNotebookRange(L){return L instanceof Ct?!0:L?typeof L.start=="number"&&typeof L.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(L){let se=this._start,be=this._end;return L.start!==void 0&&(se=L.start),L.end!==void 0&&(be=L.end),se===this._start&&be===this._end?this:new Ct(se,be)}}e.NotebookRange=Ct;class kt{constructor(L,se,be,ze,qe,Xe,Ze){this.kind=L,this.value=se,this.languageId=be,this.mime=ze,this.outputs=qe??[],this.metadata=Xe,this.executionSummary=Ze,kt.validate(this)}static validate(L){if(typeof L.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof L.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof L.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(L){return Array.isArray(L)&&L.every(se=>kt.isNotebookCellData(se))}static isNotebookCellData(L){return!0}}e.NotebookCellData=kt;class Mn{constructor(L){this.cells=L}}e.NotebookData=Mn;class mt{constructor(L,se){this.data=L,this.mime=se;const be=(0,k.normalizeMimeType)(se,!0);if(!be)throw new Error(`INVALID mime type: ${se}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=be}static isNotebookCellOutputItem(L){return L instanceof mt?!0:L?typeof L.mime=="string"&&L.data instanceof Uint8Array:!1}static error(L){const se={name:L.name,message:L.message,stack:L.stack};return mt.json(se,"application/vnd.code.notebook.error")}static stdout(L){return mt.text(L,"application/vnd.code.notebook.stdout")}static stderr(L){return mt.text(L,"application/vnd.code.notebook.stderr")}static bytes(L,se="application/octet-stream"){return new mt(L,se)}static text(L,se=k.Mimes.text){const be=tt(mt,y,"f",m).encode(String(L));return new mt(be,se)}static json(L,se="text/x-json"){const be=JSON.stringify(L,void 0,"	");return mt.text(be,se)}}e.NotebookCellOutputItem=mt,y=mt,m={value:new TextEncoder};class Ut{constructor(L,se,be){this.items=Ut.ensureUniqueMimeTypes(L,!0),typeof se=="string"?(this.id=se,this.metadata=be):(this.id=(0,T.generateUuid)(),this.metadata=se??be)}static isNotebookCellOutput(L){return L instanceof Ut?!0:!L||typeof L!="object"?!1:typeof L.id=="string"&&(0,p.isArray)(L.items)}static ensureUniqueMimeTypes(L,se=!1){const be=new Set,ze=new Set;for(let qe=0;qe<L.length;qe++){const Xe=L[qe],Ze=(0,k.normalizeMimeType)(Xe.mime);if(!be.has(Ze)){be.add(Ze);continue}ze.add(qe),se&&console.warn(`DUPLICATED mime type '${Xe.mime}' will be dropped`)}return ze.size===0?L:L.filter((qe,Xe)=>!ze.has(Xe))}}e.NotebookCellOutput=Ut;var Un;(function(N){N[N.Markup=1]="Markup",N[N.Code=2]="Code"})(Un=e.NotebookCellKind||(e.NotebookCellKind={}));var Bn;(function(N){N[N.Idle=1]="Idle",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(Bn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var zn;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(zn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var $n;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})($n=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Wn{constructor(L,se){this.text=L,this.alignment=se}}e.NotebookCellStatusBarItem=Wn;var jn;(function(N){N[N.Default=1]="Default",N[N.Preferred=2]="Preferred"})(jn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Hn{constructor(L,se=[]){this.uri=L,this.provides=(0,I.asArray)(se)}}e.NotebookRendererScript=Hn;let cn=class{constructor(L,se){this.label=L,this.timestamp=se}};cn=Re([_],cn),e.TimelineItem=cn;var Vn;(function(N){N[N.Production=1]="Production",N[N.Development=2]="Development",N[N.Test=3]="Test"})(Vn=e.ExtensionMode||(e.ExtensionMode={}));var qn;(function(N){N[N.Node=1]="Node",N[N.Webworker=2]="Webworker"})(qn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var xn;(function(N){N[N.Other=0]="Other",N[N.Comment=1]="Comment",N[N.String=2]="String",N[N.RegEx=3]="RegEx"})(xn=e.StandardTokenType||(e.StandardTokenType={}));class Gn{constructor(L,se){this.ranges=L,this.wordPattern=se}}e.LinkedEditingRanges=Gn;class Kn{constructor(L,se){this._port=L,this._autoForwardAction=se}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Kn;var Qn;(function(N){N[N.Queued=1]="Queued",N[N.Running=2]="Running",N[N.Passed=3]="Passed",N[N.Failed=4]="Failed",N[N.Skipped=5]="Skipped",N[N.Errored=6]="Errored"})(Qn=e.TestResultState||(e.TestResultState={}));var Yn;(function(N){N[N.Run=1]="Run",N[N.Debug=2]="Debug",N[N.Coverage=3]="Coverage"})(Yn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let un=class{constructor(L=void 0,se=void 0,be=void 0){this.include=L,this.exclude=se,this.profile=be}};un=Re([_],un),e.TestRunRequest=un;let fn=$=class{constructor(L){this.message=L}static diff(L,se,be){const ze=new $(L);return ze.expectedOutput=se,ze.actualOutput=be,ze}};fn=$=Re([_],fn),e.TestMessage=fn;let hn=class{constructor(L){this.id=L}};hn=Re([_],hn),e.TestTag=hn;let At=class{constructor(L,se){this.covered=L,this.total=se}};At=Re([_],At),e.CoveredCount=At;let dn=Q=class{constructor(L,se,be,ze){this.uri=L,this.statementCoverage=se,this.branchCoverage=be,this.functionCoverage=ze}static fromDetails(L,se){const be=new At(0,0),ze=new At(0,0),qe=new At(0,0);for(const Ze of se)if("branches"in Ze){be.total+=1,be.covered+=Ze.executionCount>0?1:0;for(const at of Ze.branches)ze.total+=1,ze.covered+=at.executionCount>0?1:0}else qe.total+=1,qe.covered+=Ze.executionCount>0?1:0;const Xe=new Q(L,be,ze.total>0?ze:void 0,qe.total>0?qe:void 0);return Xe.detailedCoverage=se,Xe}};dn=Q=Re([_],dn),e.FileCoverage=dn;let mn=class{constructor(L,se,be=[]){this.executionCount=L,this.location=se,this.branches=be}};mn=Re([_],mn),e.StatementCoverage=mn;let gn=class{constructor(L,se){this.executionCount=L,this.location=se}};gn=Re([_],gn),e.BranchCoverage=gn;let pn=class{constructor(L,se){this.executionCount=L,this.location=se}};pn=Re([_],pn),e.FunctionCoverage=pn;var Xn;(function(N){N[N.None=0]="None",N[N.Option=1]="Option",N[N.Default=2]="Default",N[N.Preferred=3]="Preferred"})(Xn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Jn;(function(N){N[N.Untrusted=0]="Untrusted",N[N.Trusted=1]="Trusted",N[N.Unspecified=2]="Unspecified"})(Jn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Zn;(function(N){N[N.Notify=1]="Notify",N[N.OpenBrowser=2]="OpenBrowser",N[N.OpenPreview=3]="OpenPreview",N[N.Silent=4]="Silent",N[N.Ignore=5]="Ignore",N[N.OpenBrowserOnce=6]="OpenBrowserOnce"})(Zn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class ei{constructor(L,se,be,ze,qe,Xe){this.kind=L,this.name=se,this.detail=be,this.uri=ze,this.range=qe,this.selectionRange=Xe}}e.TypeHierarchyItem=ei;class ti{constructor(L){this.uri=L}}e.TextTabInput=ti;class ni{constructor(L,se){this.original=L,this.modified=se}}e.TextDiffTabInput=ni;class ii{constructor(L,se){this.uri=L,this.viewType=se}}e.CustomEditorTabInput=ii;class ri{constructor(L){this.viewType=L}}e.WebviewEditorTabInput=ri;class si{constructor(L,se){this.uri=L,this.notebookType=se}}e.NotebookEditorTabInput=si;class oi{constructor(L,se,be){this.original=L,this.modified=se,this.notebookType=be}}e.NotebookDiffEditorTabInput=oi;class ai{constructor(){}}e.TerminalEditorTabInput=ai}),define(ve[62],we([0,1,70]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function t(P){return{transformIncoming:k=>k.scheme==="vscode-remote"?{scheme:"file",path:k.path,query:k.query,fragment:k.fragment}:k.scheme==="file"?{scheme:"vscode-local",path:k.path,query:k.query,fragment:k.fragment}:k,transformOutgoing:k=>k.scheme==="file"?{scheme:"vscode-remote",authority:P,path:k.path,query:k.query,fragment:k.fragment}:k.scheme==="vscode-local"?{scheme:"file",path:k.path,query:k.query,fragment:k.fragment}:k,transformOutgoingScheme:k=>k==="file"?"vscode-remote":k==="vscode-local"?"file":k}}function v(P){return new I.URITransformer(t(P))}e.createURITransformer=v}),define(ve[241],we([0,1,4,62,60,5,206]),function(oe,e,I,t,v,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentFileSystemProviderChannel=void 0;class w extends k.AbstractDiskFileSystemProviderChannel{constructor(T,R){super(new v.DiskFileSystemProvider(T),T);this.environmentService=R,this.uriTransformerCache=new Map,this._register(this.provider)}getUriTransformer(T){let R=this.uriTransformerCache.get(T.remoteAuthority);return R||(R=(0,t.createURITransformer)(T.remoteAuthority),this.uriTransformerCache.set(T.remoteAuthority,R)),R}transformIncoming(T,R,E=!1){if(E&&R.path==="/vscode-resource"&&R.query){const b=JSON.parse(R.query).requestResourcePath;return I.URI.from({scheme:"file",path:b})}return I.URI.revive(T.transformIncoming(R))}createSessionFileWatcher(T,R){return new p(T,R,this.logService,this.environmentService)}}e.RemoteAgentFileSystemProviderChannel=w;class p extends k.AbstractSessionFileWatcher{constructor(T,R,E,b){super(T,R,E,b)}getRecursiveWatcherOptions(T){const R=T.args["file-watcher-polling"];if(R){const E=R.split(P.delimiter),b=Number(E[0]);if(b>0)return{usePolling:E.length>1?E.slice(1):!0,pollingInterval:b}}}getExtraExcludes(T){if(T.extensionsPath)return[P.posix.join(T.extensionsPath,"**")]}}}),define(ve[116],we([0,1,182,12,4,2,6,34,17,18,10]),function(oe,e,I,t,v,P,k,w,p,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,I.localize)(0,null),providerDisplayName:(0,I.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var R;(function(F){F[F.PROGRAMMATIC=1]="PROGRAMMATIC",F[F.USER=2]="USER",F[F.EDIT=3]="EDIT",F[F.NAVIGATION=4]="NAVIGATION",F[F.JUMP=5]="JUMP"})(R=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var E;(function(F){F[F.IDENTICAL=1]="IDENTICAL",F[F.SIMILAR=2]="SIMILAR",F[F.DIFFERENT=3]="DIFFERENT"})(E=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function b(F){const x=F;return!!x&&typeof x.getSelection=="function"&&!!x.onDidChangeSelection}e.isEditorPaneWithSelection=b;function d(F,x,z){for(const W of z.visibleEditorPanes)if(W.group.id===x&&F.matches(W.input))return W.getViewState()}e.findViewStateForEditor=d;function C(F){if(n(F))return!1;const x=F;return v.URI.isUri(x?.resource)}e.isResourceEditorInput=C;function y(F){if(n(F))return!1;const x=F;return x?.original!==void 0&&x.modified!==void 0}e.isResourceDiffEditorInput=y;function m(F){if(n(F)||y(F))return!1;const x=F;return x?.primary!==void 0&&x.secondary!==void 0}e.isResourceSideBySideEditorInput=m;function g(F){if(n(F))return!1;const x=F;return x?x.resource===void 0||x.resource.scheme===T.Schemas.untitled||x.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=g;var h;(function(F){F[F.SHORT=0]="SHORT",F[F.MEDIUM=1]="MEDIUM",F[F.LONG=2]="LONG"})(h=e.Verbosity||(e.Verbosity={}));var l;(function(F){F[F.EXPLICIT=1]="EXPLICIT",F[F.AUTO=2]="AUTO",F[F.FOCUS_CHANGE=3]="FOCUS_CHANGE",F[F.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(l=e.SaveReason||(e.SaveReason={}));class f{constructor(){this.mapIdToSaveSource=new Map}registerSource(x,z){let W=this.mapIdToSaveSource.get(x);return W||(W={source:x,label:z},this.mapIdToSaveSource.set(x,W)),W.source}getSourceLabel(x){return this.mapIdToSaveSource.get(x)?.label??x}}e.SaveSourceRegistry=new f;var i;(function(F){F[F.None=0]="None",F[F.Readonly=2]="Readonly",F[F.Untitled=4]="Untitled",F[F.Singleton=8]="Singleton",F[F.RequiresTrust=16]="RequiresTrust",F[F.CanSplitInGroup=32]="CanSplitInGroup",F[F.ForceDescription=64]="ForceDescription",F[F.CanDropIntoEditor=128]="CanDropIntoEditor"})(i=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class a extends P.Disposable{}e.AbstractEditorInput=a;function n(F){return F instanceof a}e.isEditorInput=n;function o(F){const x=F;return v.URI.isUri(x?.preferredResource)}function r(F){const x=F;return n(x?.primary)&&n(x?.secondary)}e.isSideBySideEditorInput=r;function s(F){const x=F;return n(x?.modified)&&n(x?.original)}e.isDiffEditorInput=s;function c(F){return n(F?.editor)}e.isEditorInputWithOptions=c;function u(F){const x=F;return c(F)&&x?.group!==void 0}e.isEditorInputWithOptionsAndGroup=u;function S(F){const x=F;return typeof x?.groupId=="number"&&n(x.editor)}e.isEditorIdentifier=S;var A;(function(F){F[F.UNKNOWN=0]="UNKNOWN",F[F.REPLACE=1]="REPLACE",F[F.MOVE=2]="MOVE",F[F.UNPIN=3]="UNPIN"})(A=e.EditorCloseContext||(e.EditorCloseContext={}));var M;(function(F){F[F.GROUP_ACTIVE=0]="GROUP_ACTIVE",F[F.GROUP_INDEX=1]="GROUP_INDEX",F[F.GROUP_LOCKED=2]="GROUP_LOCKED",F[F.EDITOR_OPEN=3]="EDITOR_OPEN",F[F.EDITOR_CLOSE=4]="EDITOR_CLOSE",F[F.EDITOR_MOVE=5]="EDITOR_MOVE",F[F.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",F[F.EDITOR_LABEL=7]="EDITOR_LABEL",F[F.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",F[F.EDITOR_PIN=9]="EDITOR_PIN",F[F.EDITOR_STICKY=10]="EDITOR_STICKY",F[F.EDITOR_DIRTY=11]="EDITOR_DIRTY",F[F.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(M=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var $;(function(F){F[F.PRIMARY=1]="PRIMARY",F[F.SECONDARY=2]="SECONDARY",F[F.BOTH=3]="BOTH",F[F.ANY=4]="ANY"})($=e.SideBySideEditor||(e.SideBySideEditor={}));class Q{getOriginalUri(x,z){if(!x)return;if(z?.supportSideBySide){const{primary:re,secondary:V}=this.getSideEditors(x);if(re&&V){if(z?.supportSideBySide===$.BOTH)return{primary:this.getOriginalUri(re,{filterByScheme:z.filterByScheme}),secondary:this.getOriginalUri(V,{filterByScheme:z.filterByScheme})};if(z?.supportSideBySide===$.ANY)return this.getOriginalUri(re,{filterByScheme:z.filterByScheme})??this.getOriginalUri(V,{filterByScheme:z.filterByScheme});x=z.supportSideBySide===$.PRIMARY?re:V}}if(y(x)||m(x))return;const W=o(x)?x.preferredResource:x.resource;return!W||!z||!z.filterByScheme?W:this.filterUri(W,z.filterByScheme)}getSideEditors(x){return r(x)||m(x)?{primary:x.primary,secondary:x.secondary}:s(x)||y(x)?{primary:x.modified,secondary:x.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(x,z){if(!x)return;if(z?.supportSideBySide){const{primary:re,secondary:V}=this.getSideEditors(x);if(re&&V){if(z?.supportSideBySide===$.BOTH)return{primary:this.getCanonicalUri(re,{filterByScheme:z.filterByScheme}),secondary:this.getCanonicalUri(V,{filterByScheme:z.filterByScheme})};if(z?.supportSideBySide===$.ANY)return this.getCanonicalUri(re,{filterByScheme:z.filterByScheme})??this.getCanonicalUri(V,{filterByScheme:z.filterByScheme});x=z.supportSideBySide===$.PRIMARY?re:V}}if(y(x)||m(x))return;const W=x.resource;return!W||!z||!z.filterByScheme?W:this.filterUri(W,z.filterByScheme)}filterUri(x,z){if(Array.isArray(z)){if(z.some(W=>x.scheme===W))return x}else if(z===x.scheme)return x}}e.EditorResourceAccessor=new Q;var _;(function(F){F[F.LEFT=0]="LEFT",F[F.RIGHT=1]="RIGHT"})(_=e.CloseDirection||(e.CloseDirection={}));class q{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(x){const z=this.instantiationService=x.get(k.IInstantiationService);for(const[W,re]of this.editorSerializerConstructors)this.createEditorSerializer(W,re,z);this.editorSerializerConstructors.clear()}createEditorSerializer(x,z,W){const re=W.createInstance(z);this.editorSerializerInstances.set(x,re)}registerFileEditorFactory(x){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=x}getFileEditorFactory(){return(0,t.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(x,z){if(this.editorSerializerConstructors.has(x)||this.editorSerializerInstances.has(x))throw new Error(`A editor serializer with type ID '${x}' was already registered.`);return this.instantiationService?this.createEditorSerializer(x,z,this.instantiationService):this.editorSerializerConstructors.set(x,z),(0,P.toDisposable)(()=>{this.editorSerializerConstructors.delete(x),this.editorSerializerInstances.delete(x)})}getEditorSerializer(x){return this.editorSerializerInstances.get(typeof x=="string"?x:x.typeId)}}w.Registry.add(e.EditorExtensions.EditorFactory,new q);async function U(F,x){if(!F||!F.length)return[];const z=await Promise.all(F.map(async W=>{const re=v.URI.revive(W.fileUri);if(!re||!await x.canHandleResource(re))return;let X=W.exists,ae=W.type;if(typeof X!="boolean"||typeof ae!="number")try{ae=(await x.stat(re)).isDirectory?p.FileType.Directory:p.FileType.Unknown,X=!0}catch{X=!1}if(!X&&W.openOnlyIfExists||ae===p.FileType.Directory)return;const ie={...W.options,pinned:!0};let O;return X?O={resource:re,options:ie}:O={resource:re,options:ie,forceUntitled:!0},O}));return(0,D.coalesce)(z)}e.pathsToEditors=U;var ne;(function(F){F[F.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",F[F.SEQUENTIAL=1]="SEQUENTIAL"})(ne=e.EditorsOrder||(e.EditorsOrder={}));function Z(F){const x=F;if(!x)return!1;const z=x;if(z.modified)return Z(z.modified);const W=x;return!!(W.contributionsState&&W.viewState&&Array.isArray(W.cursorState))}e.isTextEditorViewState=Z}),define(ve[242],we([0,1,69,47,67,10,5,3,96]),function(oe,e,I,t,v,P,k,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var D;(function(r){r[r.Markup=1]="Markup",r[r.Code=2]="Code"})(D=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",v.Mimes.latex,v.Mimes.markdown,"image/png","image/jpeg",v.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[v.Mimes.latex,v.Mimes.markdown,"application/json",v.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var T;(function(r){r[r.Running=1]="Running",r[r.Idle=2]="Idle"})(T=e.NotebookRunState||(e.NotebookRunState={}));var R;(function(r){r[r.Unconfirmed=1]="Unconfirmed",r[r.Pending=2]="Pending",r[r.Executing=3]="Executing"})(R=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var E;(function(r){r[r.WithHardKernelDependency=0]="WithHardKernelDependency",r[r.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",r[r.Pure=2]="Pure",r[r.Never=3]="Never"})(E=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var b;(function(r){r.Always="always",r.Never="never",r.Optional="optional"})(b=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var d;(function(r){r[r.ModelChange=1]="ModelChange",r[r.Move=2]="Move",r[r.ChangeCellLanguage=5]="ChangeCellLanguage",r[r.Initialize=6]="Initialize",r[r.ChangeCellMetadata=7]="ChangeCellMetadata",r[r.Output=8]="Output",r[r.OutputItem=9]="OutputItem",r[r.ChangeCellContent=10]="ChangeCellContent",r[r.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",r[r.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",r[r.ChangeCellMime=13]="ChangeCellMime",r[r.Unknown=100]="Unknown"})(d=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var C;(function(r){r[r.Handle=0]="Handle",r[r.Index=1]="Index"})(C=e.SelectionStateType||(e.SelectionStateType={}));var y;(function(r){r[r.Replace=1]="Replace",r[r.Output=2]="Output",r[r.Metadata=3]="Metadata",r[r.CellLanguage=4]="CellLanguage",r[r.DocumentMetadata=5]="DocumentMetadata",r[r.Move=6]="Move",r[r.OutputItems=7]="OutputItems",r[r.PartialMetadata=8]="PartialMetadata",r[r.PartialInternalMetadata=9]="PartialInternalMetadata"})(y=e.CellEditType||(e.CellEditType={}));var m;(function(r){r.scheme=P.Schemas.vscodeNotebookCell;const s=/^ch(\d{7,})/;function c(Q,_){return Q.with({scheme:r.scheme,fragment:`ch${_.toString().padStart(7,"0")}${Q.scheme!==P.Schemas.file?Q.scheme:""}`})}r.generate=c;function u(Q){if(Q.scheme!==r.scheme)return;const _=s.exec(Q.fragment);return _?{handle:Number(_[1]),notebook:Q.with({scheme:Q.fragment.substring(_[0].length)||P.Schemas.file,fragment:null})}:void 0}r.parse=u;function S(Q,_){return Q.with({scheme:P.Schemas.vscodeNotebookCellOutput,fragment:`op${_??""},${Q.scheme!==P.Schemas.file?Q.scheme:""}`})}r.generateCellOutputUri=S;function A(Q){if(Q.scheme!==P.Schemas.vscodeNotebookCellOutput)return;const _=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(Q.fragment);if(!_)return;const q=_[1]&&_[1]!==""?_[1]:void 0,U=_[2];return{outputId:q,notebook:Q.with({scheme:U||P.Schemas.file,fragment:null})}}r.parseCellOutputUri=A;function M(Q,_,q){return Q.with({scheme:q,fragment:`ch${_.toString().padStart(7,"0")}${Q.scheme!==P.Schemas.file?Q.scheme:""}`})}r.generateCellUri=M;function $(Q,_){if(Q.scheme!==_)return;const q=s.exec(Q.fragment);return q?{handle:Number(q[1]),notebook:Q.with({scheme:Q.fragment.substring(q[0].length)||P.Schemas.file,fragment:null})}:void 0}r.parseCellUri=$})(m=e.CellUri||(e.CellUri={}));const g=r=>w.isWindows?r.replace(/\//g,"\\"):r;class h{constructor(s=[],c=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=c,this.order=[...new Set(s)].map(u=>({pattern:u,matches:I.parse(g(u))}))}sort(s){const c=new Map(t.Iterable.map(s,S=>[S,g(S)]));let u=[];for(const{matches:S}of this.order)for(const[A,M]of c)if(S(M)){u.push(A),c.delete(A);break}return c.size&&(u=u.concat([...c.keys()].sort((S,A)=>this.defaultOrder.indexOf(S)-this.defaultOrder.indexOf(A)))),u}prioritize(s,c){const u=this.findIndex(s);if(u===-1){this.order.unshift({pattern:s,matches:I.parse(g(s))});return}const S=new Set(c.map(M=>this.findIndex(M,u)));S.delete(-1);const A=Array.from(S).sort();this.order.splice(u+1,0,...A.map(M=>this.order[M]));for(let M=A.length-1;M>=0;M--)this.order.splice(A[M],1)}toArray(){return this.order.map(s=>s.pattern)}findIndex(s,c=this.order.length){const u=g(s);for(let S=0;S<c;S++)if(this.order[S].matches(u))return S;return-1}}e.MimeTypeDisplayOrder=h;function l(r,s,c,u=(S,A)=>S===A){const S=[];function A(Q,_,q){if(_===0&&q.length===0)return;const U=S[S.length-1];U&&U.start+U.deleteCount===Q?(U.deleteCount+=_,U.toInsert.push(...q)):S.push({start:Q,deleteCount:_,toInsert:q})}let M=0,$=0;for(;;){if(M===r.length){A(M,0,s.slice($));break}if($===s.length){A(M,r.length-M,[]);break}const Q=r[M],_=s[$];if(u(Q,_)){M+=1,$+=1;continue}c(_)?(A(M,1,[]),M+=1):(A(M,0,[_]),$+=1)}return S}e.diff=l,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new p.RawContextKey("notebookEditorCursorAtBoundary","none");var f;(function(r){r.default="default",r.option="option"})(f=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function i(r){const s=r;return!!((typeof s.include=="string"||I.isRelativePattern(s.include))&&(typeof s.exclude=="string"||I.isRelativePattern(s.exclude)))}e.isDocumentExcludePattern=i;function a(r,s,c){if(Array.isArray(r.viewType)&&r.viewType.indexOf(s)>=0||r.viewType===s)return!0;if(r.filenamePattern){const u=i(r.filenamePattern)?r.filenamePattern.include:r.filenamePattern,S=i(r.filenamePattern)?r.filenamePattern.exclude:void 0;if(I.match(u,(0,k.basename)(c.fsPath).toLowerCase()))return!(S&&I.match(S,(0,k.basename)(c.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=a,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily",interactiveWindowAlwaysScrollOnNewCell:"interactiveWindow.alwaysScrollOnNewCell"};var n;(function(r){r[r.Left=1]="Left",r[r.Right=2]="Right"})(n=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class o{static create(s){return`${o._prefix}${s}`}static parse(s){if(s.startsWith(o._prefix))return s.substring(o._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=o,o._prefix="notebook/"}),define(ve[117],we([0,1,6]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=e.IEnvironmentVariableService=void 0,e.IEnvironmentVariableService=(0,I.createDecorator)("environmentVariableService");var t;(function(v){v[v.Replace=1]="Replace",v[v.Append=2]="Append",v[v.Prepend=3]="Prepend"})(t=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}))}),define(ve[243],we([0,1,3,117]),function(oe,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;class v{constructor(p){this.collections=p,this.map=new Map,p.forEach((D,T)=>{const R=D.map.entries();let E=R.next();for(;!E.done;){const b=E.value[0];let d=this.map.get(b);if(d||(d=[],this.map.set(b,d)),d.length>0&&d[0].type===t.EnvironmentVariableMutatorType.Replace){E=R.next();continue}const C=E.value[1];d.unshift({extensionIdentifier:T,value:C.value,type:C.type}),E=R.next()}})}async applyToProcessEnvironment(p,D){let T;I.isWindows&&(T={},Object.keys(p).forEach(R=>T[R.toLowerCase()]=R));for(const[R,E]of this.map){const b=I.isWindows&&T[R.toLowerCase()]||R;for(const d of E){const C=D?await D(d.value):d.value;switch(d.type){case t.EnvironmentVariableMutatorType.Append:p[b]=(p[b]||"")+C;break;case t.EnvironmentVariableMutatorType.Prepend:p[b]=C+(p[b]||"");break;case t.EnvironmentVariableMutatorType.Replace:p[b]=C;break}}}}diff(p){const D=new Map,T=new Map,R=new Map;if(p.map.forEach((E,b)=>{const d=this.map.get(b),C=P(E,d);C&&D.set(b,C)}),this.map.forEach((E,b)=>{const d=p.map.get(b),C=P(E,d);C&&R.set(b,C)}),this.map.forEach((E,b)=>{const d=p.map.get(b),C=k(E,d);C&&T.set(b,C)}),!(D.size===0&&T.size===0&&R.size===0))return{added:D,changed:T,removed:R}}}e.MergedEnvironmentVariableCollection=v;function P(w,p){if(!p)return w;const D=new Set;p.forEach(R=>D.add(R.extensionIdentifier));const T=[];return w.forEach(R=>{D.has(R.extensionIdentifier)||T.push(R)}),T.length===0?void 0:T}function k(w,p){if(!p)return;const D=new Map;p.forEach(R=>D.set(R.extensionIdentifier,R));const T=[];return w.forEach(R=>{const E=D.get(R.extensionIdentifier);E&&(R.type!==E.type||R.value!==E.value)&&T.push(E)}),T.length===0?void 0:T}}),define(ve[118],we([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function I(k){return[...k.entries()]}e.serializeEnvironmentVariableCollection=I;function t(k){return new Map(k)}e.deserializeEnvironmentVariableCollection=t;function v(k){return Array.from(k.entries()).map(w=>[w[0],I(w[1].map)])}e.serializeEnvironmentVariableCollections=v;function P(k){return new Map(k.map(w=>[w[0],{map:t(w[1])}]))}e.deserializeEnvironmentVariableCollections=P}),define(ve[244],we([0,1,5,56,3]),function(oe,e,I,t,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTerminalEnvironment=e.getDefaultShellArgs=e.getDefaultShell=e.createVariableResolver=e.getCwd=e.getLangEnvVariable=e.shouldSetLangEnvVariable=e.addTerminalEnvironmentKeys=e.mergeEnvironments=void 0;function P(l,f){if(!!f)if(v.isWindows)for(const i in f){let a=i;for(const o in l)if(i.toLowerCase()===o.toLowerCase()){a=o;break}const n=f[i];n!==void 0&&k(l,a,n)}else Object.keys(f).forEach(i=>{const a=f[i];a!==void 0&&k(l,i,a)})}e.mergeEnvironments=P;function k(l,f,i){typeof i=="string"?l[f]=i:delete l[f]}function w(l,f,i,a){l.TERM_PROGRAM="vscode",f&&(l.TERM_PROGRAM_VERSION=f),T(l,a)&&(l.LANG=R(i)),l.COLORTERM="truecolor"}e.addTerminalEnvironmentKeys=w;function p(l,f){if(!!f)for(const i of Object.keys(f)){const a=f[i];a&&(l[i]=a)}}async function D(l,f){return await Promise.all(Object.entries(f).map(async([i,a])=>{if(typeof a=="string")try{f[i]=await l(a)}catch{f[i]=a}})),f}function T(l,f){if(f==="on")return!0;if(f==="auto"){const i=l.LANG;return!i||i.search(/\.UTF\-8$/)===-1&&i.search(/\.utf8$/)===-1&&i.search(/\.euc.+/)===-1}return!1}e.shouldSetLangEnvVariable=T;function R(l){const f=l?l.split("-"):[],i=f.length;if(i===0)return"en_US.UTF-8";if(i===1){const a={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};f[0]in a&&f.push(a[f[0]])}else f[1]=f[1].toUpperCase();return f.join("_")+".UTF-8"}e.getLangEnvVariable=R;async function E(l,f,i,a,n,o){if(l.cwd){const s=typeof l.cwd=="object"?l.cwd.fsPath:l.cwd,c=await b(s,i);return d(c||s)}let r;return!l.ignoreConfigurationCwd&&n&&(i&&(n=await b(n,i,o)),n&&(I.isAbsolute(n)?r=n:a&&(r=I.join(a.fsPath,n)))),r||(r=a?a.fsPath:f||""),d(r)}e.getCwd=E;async function b(l,f,i){if(f)try{return await f(l)}catch(a){i?.error("Could not resolve terminal cwd",a);return}return l}function d(l){return v.OS===1&&l&&l[1]===":"?l[0].toUpperCase()+l.substr(1):l}function C(l,f,i){if(!!i)return a=>i.resolveWithEnvironment(f,l,a)}e.createVariableResolver=C;async function y(l,f,i,a,n,o,r,s=v.platform){let c;r&&(c=g(l,"automationShell",s)),c||(c=g(l,"shell",s));let u=c||f;if(s===3&&!i&&a){const S=I.join(a,"Sysnative").replace(/\//g,"\\").toLowerCase();u&&u.toLowerCase().indexOf(S)===0&&(u=I.join(a,"System32",u.substr(S.length+1)))}if(u&&s===3&&(u=u.replace(/\//g,"\\")),n)try{u=await n(u)}catch(S){o.error("Could not resolve shell",S)}return u}e.getDefaultShell=y;async function m(l,f,i,a,n=v.platform){if(f&&g(l,"automationShell",n))return[];const o=n===3?"windows":n===1?"osx":"linux";let r=l(`terminal.integrated.shellArgs.${o}`);if(!r)return[];if(typeof r=="string"&&n===3)return i?await i(r):r;if(i){const s=[];for(const c of r)try{s.push(await i(c))}catch(u){a.error(`Could not resolve terminal.integrated.shellArgs.${o}`,u),s.push(c)}r=s}return r}e.getDefaultShellArgs=m;function g(l,f,i=v.platform){return l(`terminal.integrated.${f}.${i===3?"windows":i===1?"osx":"linux"}`)}async function h(l,f,i,a,n,o){const r={};if(l.strictEnv)p(r,l.env);else{p(r,o);const s={...f};i&&(s&&await D(i,s),l.env&&await D(i,l.env)),(0,t.sanitizeProcessEnvironment)(r,"VSCODE_IPC_HOOK_CLI"),P(r,s),P(r,l.env),w(r,a,v.locale,n)}return r}e.createTerminalEnvironment=h}),define(ve[80],we([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var I;(function(P){P.Delimiter="\0"})(I=e.TestIdPathParts||(e.TestIdPathParts={}));var t;(function(P){P[P.IsSame=0]="IsSame",P[P.Disconnected=1]="Disconnected",P[P.IsChild=2]="IsChild",P[P.IsParent=3]="IsParent"})(t=e.TestPosition||(e.TestPosition={}));class v{constructor(k,w=k.length){if(this.path=k,this.viewEnd=w,k.length===0||w<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(k,w,p=k.parent){if(k.id===w)return new v([w]);const D=[k.id];for(let T=p;T&&T.id!==w;T=T.parent)D.push(T.id);return D.push(w),new v(D.reverse())}static isRoot(k){return!k.includes("\0")}static root(k){const w=k.indexOf("\0");return w===-1?k:k.slice(0,w)}static fromString(k){return new v(k.split("\0"))}static join(k,w){return new v([...k.path,w])}static joinToString(k,w){return k.toString()+"\0"+w}static compare(k,w){return k===w?0:w.startsWith(k+"\0")?2:k.startsWith(w+"\0")?3:1}get parentId(){return this.viewEnd>1?new v(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let k=1;k<=this.viewEnd;k++)yield new v(this.path,k)}compare(k){if(typeof k=="string")return v.compare(this.toString(),k);for(let w=0;w<k.viewEnd&&w<this.viewEnd;w++)if(k.path[w]!==this.path[w])return 1;return k.viewEnd>this.viewEnd?2:k.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let k=1;k<this.viewEnd;k++)this.stringifed+="\0",this.stringifed+=this.path[k]}return this.stringifed}}e.TestId=v}),define(ve[81],we([0,1,4,50]),function(oe,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var v;(function(r){r[r.Unset=0]="Unset",r[r.Queued=1]="Queued",r[r.Running=2]="Running",r[r.Passed=3]="Passed",r[r.Failed=4]="Failed",r[r.Skipped=5]="Skipped",r[r.Errored=6]="Errored"})(v=e.TestResultState||(e.TestResultState={}));var P;(function(r){r[r.Run=2]="Run",r[r.Debug=4]="Debug",r[r.Coverage=8]="Coverage",r[r.HasNonDefaultProfile=16]="HasNonDefaultProfile",r[r.HasConfigurable=32]="HasConfigurable"})(P=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var k;(function(r){r.serialize=s=>({range:s.range.toJSON(),uri:s.uri.toJSON()}),r.deserialize=s=>({range:t.Range.lift(s.range),uri:I.URI.revive(s.uri)})})(k=e.IRichLocation||(e.IRichLocation={}));var w;(function(r){r[r.Error=0]="Error",r[r.Output=1]="Output"})(w=e.TestMessageType||(e.TestMessageType={}));var p;(function(r){r.serialize=s=>({message:s.message,type:0,expected:s.expected,actual:s.actual,location:s.location&&k.serialize(s.location)}),r.deserialize=s=>({message:s.message,type:0,expected:s.expected,actual:s.actual,location:s.location&&k.deserialize(s.location)})})(p=e.ITestErrorMessage||(e.ITestErrorMessage={}));var D;(function(r){r.serialize=s=>({message:s.message,type:1,offset:s.offset,location:s.location&&k.serialize(s.location)}),r.deserialize=s=>({message:s.message,type:1,offset:s.offset,location:s.location&&k.deserialize(s.location)})})(D=e.ITestOutputMessage||(e.ITestOutputMessage={}));var T;(function(r){r.serialize=s=>s.type===0?p.serialize(s):D.serialize(s),r.deserialize=s=>s.type===0?p.deserialize(s):D.deserialize(s)})(T=e.ITestMessage||(e.ITestMessage={}));var R;(function(r){r.serialize=s=>({state:s.state,duration:s.duration,messages:s.messages.map(T.serialize)}),r.deserialize=s=>({state:s.state,duration:s.duration,messages:s.messages.map(T.deserialize)})})(R=e.ITestTaskState||(e.ITestTaskState={}));const E="\0",b=(r,s)=>r+E+s;e.namespaceTestTag=b;const d=r=>{const s=r.indexOf(E);return{ctrlId:r.slice(0,s),tagId:r.slice(s+1)}};e.denamespaceTestTag=d;var C;(function(r){r.serialize=s=>({extId:s.extId,label:s.label,tags:s.tags,busy:s.busy,children:void 0,uri:s.uri?.toJSON(),range:s.range?.toJSON()||null,description:s.description,error:s.error,sortText:s.sortText}),r.deserialize=s=>({extId:s.extId,label:s.label,tags:s.tags,busy:s.busy,children:void 0,uri:s.uri?I.URI.revive(s.uri):void 0,range:s.range?t.Range.lift(s.range):null,description:s.description,error:s.error,sortText:s.sortText})})(C=e.ITestItem||(e.ITestItem={}));var y;(function(r){r[r.NotExpandable=0]="NotExpandable",r[r.Expandable=1]="Expandable",r[r.BusyExpanding=2]="BusyExpanding",r[r.Expanded=3]="Expanded"})(y=e.TestItemExpandState||(e.TestItemExpandState={}));var m;(function(r){r.serialize=s=>({controllerId:s.controllerId,expand:s.expand,parent:s.parent,item:C.serialize(s.item)}),r.deserialize=s=>({controllerId:s.controllerId,expand:s.expand,parent:s.parent,item:C.deserialize(s.item)})})(m=e.InternalTestItem||(e.InternalTestItem={}));var g;(function(r){r.serialize=s=>{let c;return s.item&&(c={},s.item.label!==void 0&&(c.label=s.item.label),s.item.tags!==void 0&&(c.tags=s.item.tags),s.item.busy!==void 0&&(c.busy=s.item.busy),s.item.uri!==void 0&&(c.uri=s.item.uri?.toJSON()),s.item.range!==void 0&&(c.range=s.item.range?.toJSON()),s.item.description!==void 0&&(c.description=s.item.description),s.item.error!==void 0&&(c.error=s.item.error),s.item.sortText!==void 0&&(c.sortText=s.item.sortText)),{extId:s.extId,expand:s.expand,item:c}},r.deserialize=s=>{let c;return s.item&&(c={},s.item.label!==void 0&&(c.label=s.item.label),s.item.tags!==void 0&&(c.tags=s.item.tags),s.item.busy!==void 0&&(c.busy=s.item.busy),s.item.range!==void 0&&(c.range=s.item.range?t.Range.lift(s.item.range):null),s.item.description!==void 0&&(c.description=s.item.description),s.item.error!==void 0&&(c.error=s.item.error),s.item.sortText!==void 0&&(c.sortText=s.item.sortText)),{extId:s.extId,expand:s.expand,item:c}}})(g=e.ITestItemUpdate||(e.ITestItemUpdate={}));const h=(r,s)=>{s.expand!==void 0&&(r.expand=s.expand),s.item!==void 0&&(r.item=r.item?Object.assign(r.item,s.item):s.item)};e.applyTestItemUpdate=h;var l;(function(r){r.serialize=(s,c)=>({...m.serialize(s),children:c,ownComputedState:s.ownComputedState,computedState:s.computedState,tasks:s.tasks.map(R.serialize)})})(l=e.TestResultItem||(e.TestResultItem={}));var f;(function(r){r[r.Function=0]="Function",r[r.Statement=1]="Statement"})(f=e.DetailType||(e.DetailType={}));var i;(function(r){r[r.Add=0]="Add",r[r.Update=1]="Update",r[r.Remove=2]="Remove",r[r.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",r[r.Retire=4]="Retire",r[r.AddTag=5]="AddTag",r[r.RemoveTag=6]="RemoveTag"})(i=e.TestDiffOpType||(e.TestDiffOpType={}));var a;(function(r){r.deserialize=s=>s.op===0?{op:s.op,item:m.deserialize(s.item)}:s.op===1?{op:s.op,item:g.deserialize(s.item)}:s,r.serialize=s=>s.op===0?{op:s.op,item:m.serialize(s.item)}:s.op===1?{op:s.op,item:g.serialize(s.item)}:s})(a=e.TestsDiffOp||(e.TestsDiffOp={}));class n{add(s){}update(s){}remove(s,c){}complete(){}}e.IncrementalChangeCollector=n;class o{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(s){const c=this.createChangeCollector();for(const u of s)switch(u.op){case 0:{const S=m.deserialize(u.item);if(S.parent){if(this.items.has(S.parent)){const A=this.items.get(S.parent);A.children.add(S.item.extId);const M=this.createItem(S,A);this.items.set(S.item.extId,M),c.add(M)}}else{const A=this.createItem(S);this.roots.add(A),this.items.set(S.item.extId,A),c.add(A)}S.expand===2&&this.busyControllerCount++;break}case 1:{const S=g.deserialize(u.item),A=this.items.get(S.extId);if(!A)break;S.expand!==void 0&&(A.expand===2&&this.busyControllerCount--,S.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(A,S),c.update(A);break}case 2:{const S=this.items.get(u.itemId);if(!S)break;S.parent?this.items.get(S.parent).children.delete(S.item.extId):this.roots.delete(S);const A=[[u.itemId]];for(;A.length;)for(const M of A.pop()){const $=this.items.get(M);$&&(A.push($.children),this.items.delete(M),c.remove($,$!==S),$.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(u.itemId);break;case 3:this.updatePendingRoots(u.amount);break;case 5:this._tags.set(u.tag.id,u.tag);break;case 6:this._tags.delete(u.id);break}c.complete()}retireTest(s){}updatePendingRoots(s){this.pendingRootCount+=s}createChangeCollector(){return new n}}e.AbstractIncrementalTestCollection=o}),define(ve[119],we([0,1,14,7,2,12,81,80]),function(oe,e,I,t,v,P,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var p;(function(m){m[m.Upsert=0]="Upsert",m[m.SetTags=1]="SetTags",m[m.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",m[m.RemoveChild=3]="RemoveChild",m[m.SetProp=4]="SetProp",m[m.Bulk=5]="Bulk"})(p=e.TestItemEventOp||(e.TestItemEventOp={}));const D=(m,g)=>m===g,T={range:(m,g)=>m===g?!0:!m||!g?!1:m.equalsRange(g),busy:D,label:D,description:D,error:D,tags:(m,g)=>!(m.length!==g.length||m.some(h=>!g.includes(h)))},R=(m,g)=>{let h;for(const[l,f]of Object.entries(T))f(m[l],g[l])||(h?h[l]=g[l]:h={[l]:g[l]});return h};class E extends v.Disposable{constructor(g){super();this.options=g,this.debounceSendDiff=this._register(new I.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new t.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}get root(){return this.options.root}set resolveHandler(g){this._resolveHandler=g;for(const h of this.tree.values())this.updateExpandability(h)}collectDiff(){const g=this.diff;return this.diff=[],g}pushDiff(g){const h=this.diff[this.diff.length-1];if(h&&g.op===1){if(h.op===1&&h.item.extId===g.item.extId){(0,k.applyTestItemUpdate)(h.item,g.item);return}if(h.op===0&&h.item.item.extId===g.item.extId){(0,k.applyTestItemUpdate)(h.item,g.item);return}}this.diff.push(g),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(g,h){const l=this.tree.get(g);if(!!l){if((l.expandLevels===void 0||h>l.expandLevels)&&(l.expandLevels=h),l.expand===1){const f=this.resolveChildren(l);return f.isOpen()?this.expandChildren(l,h-1):f.wait().then(()=>this.expandChildren(l,h-1))}else if(l.expand===3)return l.resolveBarrier?.isOpen()===!1?l.resolveBarrier.wait().then(()=>this.expandChildren(l,h-1)):this.expandChildren(l,h-1)}}dispose(){for(const g of this.tree.values())this.options.getApiFor(g.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(g,h){switch(h.op){case 3:this.removeItem(w.TestId.joinToString(g.fullId,h.id));break;case 0:this.upsertItem(h.item,g);break;case 5:for(const l of h.ops)this.onTestItemEvent(g,l);break;case 1:this.diffTagRefs(h.new,h.old,g.fullId.toString());break;case 2:this.updateExpandability(g);break;case 4:this.pushDiff({op:1,item:{extId:g.fullId.toString(),item:h.update}});break;default:(0,P.assertNever)(h)}}upsertItem(g,h){const l=w.TestId.fromExtHostTestItem(g,this.root.id,h?.actual),f=this.options.getApiFor(g);f.parent&&f.parent!==h?.actual&&this.options.getChildren(f.parent).delete(g.id);let i=this.tree.get(l.toString());if(!i){i={fullId:l,actual:g,parent:h?l.parentId:null,expandLevels:h?.expandLevels?h.expandLevels-1:void 0,expand:0},g.tags.forEach(this.incrementTagRefs,this),this.tree.set(i.fullId.toString(),i),this.setItemParent(g,h),this.pushDiff({op:0,item:{parent:i.parent&&i.parent.toString(),controllerId:this.options.controllerId,expand:i.expand,item:this.options.toITestItem(g)}}),this.connectItemAndChildren(g,i,h);return}if(i.actual===g){this.connectItem(g,i,h);return}const a=this.options.getChildren(i.actual),n=i.actual,o=R(this.options.toITestItem(n),this.options.toITestItem(g));this.options.getApiFor(n).listener=void 0,i.actual=g,i.expand=0,o&&(o.hasOwnProperty("tags")&&(this.diffTagRefs(g.tags,n.tags,l.toString()),delete o.tags),this.onTestItemEvent(i,{op:4,update:o})),this.connectItemAndChildren(g,i,h);for(const[r,s]of a)this.options.getChildren(g).get(s.id)||this.removeItem(w.TestId.joinToString(l,s.id))}diffTagRefs(g,h,l){const f=new Set(h.map(i=>i.id));for(const i of g)f.delete(i.id)||this.incrementTagRefs(i);this.pushDiff({op:1,item:{extId:l,item:{tags:g.map(i=>(0,k.namespaceTestTag)(this.options.controllerId,i.id))}}}),f.forEach(this.decrementTagRefs,this)}incrementTagRefs(g){const h=this.tags.get(g.id);h?h.refCount++:(this.tags.set(g.id,{refCount:1}),this.pushDiff({op:5,tag:{id:(0,k.namespaceTestTag)(this.options.controllerId,g.id)}}))}decrementTagRefs(g){const h=this.tags.get(g);h&&!--h.refCount&&(this.tags.delete(g),this.pushDiff({op:6,id:(0,k.namespaceTestTag)(this.options.controllerId,g)}))}setItemParent(g,h){this.options.getApiFor(g).parent=h&&h.actual!==this.root?h.actual:void 0}connectItem(g,h,l){this.setItemParent(g,l);const f=this.options.getApiFor(g);f.parent=l?.actual,f.listener=i=>this.onTestItemEvent(h,i),this.updateExpandability(h)}connectItemAndChildren(g,h,l){this.connectItem(g,h,l);for(const[f,i]of this.options.getChildren(g))this.upsertItem(i,h)}updateExpandability(g){let h;this._resolveHandler?g.resolveBarrier?h=g.resolveBarrier.isOpen()?3:2:h=g.actual.canResolveChildren?1:0:h=0,h!==g.expand&&(g.expand=h,this.pushDiff({op:1,item:{extId:g.fullId.toString(),expand:h}}),h===1&&g.expandLevels!==void 0&&this.resolveChildren(g))}expandChildren(g,h){if(h<0)return;const l=[];for(const[f,i]of this.options.getChildren(g.actual)){const a=this.expand(w.TestId.joinToString(g.fullId,i.id),h);(0,I.isThenable)(a)&&l.push(a)}if(l.length)return Promise.all(l).then(()=>{})}resolveChildren(g){if(g.resolveBarrier)return g.resolveBarrier;if(!this._resolveHandler){const i=new I.Barrier;return i.open(),i}g.expand=2,this.pushExpandStateUpdate(g);const h=g.resolveBarrier=new I.Barrier,l=i=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,i)};let f;try{f=this._resolveHandler(g.actual===this.root?void 0:g.actual)}catch(i){l(i)}return(0,I.isThenable)(f)?f.catch(l).then(()=>{h.open(),this.updateExpandability(g)}):(h.open(),this.updateExpandability(g)),g.resolveBarrier}pushExpandStateUpdate(g){this.pushDiff({op:1,item:{extId:g.fullId.toString(),expand:g.expand}})}removeItem(g){const h=this.tree.get(g);if(!h)throw new Error("attempting to remove non-existent child");this.pushDiff({op:2,itemId:g});const l=[h];for(;l.length;){const f=l.pop();if(!!f){this.options.getApiFor(f.actual).listener=void 0;for(const i of f.actual.tags)this.decrementTagRefs(i.id);this.tree.delete(f.fullId.toString());for(const[i,a]of this.options.getChildren(f.actual))l.push(this.tree.get(w.TestId.joinToString(f.fullId,a.id)))}}}flushDiff(){const g=this.collectDiff();g.length&&this.diffOpEmitter.fire(g)}}e.TestItemCollection=E;class b extends Error{constructor(g){super(`Attempted to insert a duplicate test item ID ${g}`)}}e.DuplicateTestItemError=b;class d extends Error{constructor(g){super(`TestItem with ID "${g}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=d;class C extends Error{constructor(g,h,l){super(`TestItem with ID "${g}" is from controller "${h}" and cannot be added as a child of an item from controller "${l}".`)}}e.MixedTestItemController=C;const y=(m,g,h)=>{let l=new Map;return{get size(){return l.size},forEach(f,i){for(const a of l.values())f.call(i,a,this)},[Symbol.iterator](){return l.entries()},replace(f){const i=new Map,a=new Set(l.keys()),n={op:5,ops:[]};for(const o of f){if(!(o instanceof h))throw new d(o.id);const r=g(o).controllerId;if(r!==m.controllerId)throw new C(o.id,r,m.controllerId);if(i.has(o.id))throw new b(o.id);i.set(o.id,o),a.delete(o.id),n.ops.push({op:0,item:o})}for(const o of a.keys())n.ops.push({op:3,id:o});m.listener?.(n),l=i},add(f){if(!(f instanceof h))throw new d(f.id);l.set(f.id,f),m.listener?.({op:0,item:f})},delete(f){l.delete(f)&&m.listener?.({op:3,id:f})},get(f){return l.get(f)},toJSON(){return Array.from(l.values())}}};e.createTestItemChildren=y}),define(ve[120],we([0,1,119]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const t=new WeakMap,v=(k,w)=>{const p={controllerId:w};return t.set(k,p),p};e.createPrivateApiFor=v;const P=k=>{const w=t.get(k);if(!w)throw new I.InvalidTestItemError(k?.id||"<unknown>");return w};e.getPrivateApiFor=P}),define(ve[245],we([0,1,23,6]),function(oe,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TASKS_DEFAULT=e.IWorkbenchConfigurationService=e.USER_STANDALONE_CONFIGURATIONS=e.WORKSPACE_STANDALONE_CONFIGURATIONS=e.LAUNCH_CONFIGURATION_KEY=e.TASKS_CONFIGURATION_KEY=e.FOLDER_SCOPES=e.WORKSPACE_SCOPES=e.REMOTE_MACHINE_SCOPES=e.LOCAL_MACHINE_SCOPES=e.LOCAL_MACHINE_PROFILE_SCOPES=e.PROFILE_SCOPES=e.tasksSchemaId=e.launchSchemaId=e.folderSettingsSchemaId=e.workspaceSettingsSchemaId=e.machineSettingsSchemaId=e.profileSettingsSchemaId=e.userSettingsSchemaId=e.defaultSettingsSchemaId=e.FOLDER_SETTINGS_PATH=e.FOLDER_SETTINGS_NAME=e.FOLDER_CONFIG_FOLDER_NAME=void 0,e.FOLDER_CONFIG_FOLDER_NAME=".vscode",e.FOLDER_SETTINGS_NAME="settings",e.FOLDER_SETTINGS_PATH=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.FOLDER_SETTINGS_NAME}.json`,e.defaultSettingsSchemaId="vscode://schemas/settings/default",e.userSettingsSchemaId="vscode://schemas/settings/user",e.profileSettingsSchemaId="vscode://schemas/settings/profile",e.machineSettingsSchemaId="vscode://schemas/settings/machine",e.workspaceSettingsSchemaId="vscode://schemas/settings/workspace",e.folderSettingsSchemaId="vscode://schemas/settings/folder",e.launchSchemaId="vscode://schemas/launch",e.tasksSchemaId="vscode://schemas/tasks",e.PROFILE_SCOPES=[2,3,4,5],e.LOCAL_MACHINE_PROFILE_SCOPES=[3,4,5],e.LOCAL_MACHINE_SCOPES=[1,...e.LOCAL_MACHINE_PROFILE_SCOPES],e.REMOTE_MACHINE_SCOPES=[2,3,4,5,6],e.WORKSPACE_SCOPES=[3,4,5,6],e.FOLDER_SCOPES=[4,5,6],e.TASKS_CONFIGURATION_KEY="tasks",e.LAUNCH_CONFIGURATION_KEY="launch",e.WORKSPACE_STANDALONE_CONFIGURATIONS=Object.create(null),e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.TASKS_CONFIGURATION_KEY}.json`,e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.LAUNCH_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.LAUNCH_CONFIGURATION_KEY}.json`,e.USER_STANDALONE_CONFIGURATIONS=Object.create(null),e.USER_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.TASKS_CONFIGURATION_KEY}.json`,e.IWorkbenchConfigurationService=(0,t.refineServiceDecorator)(I.IConfigurationService),e.TASKS_DEFAULT=`{
	"version": "2.0.0",
	"tasks": []
}`}),define(ve[246],we([0,1,6]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,I.createDecorator)("configurationResolverService")}),define(ve[247],we([0,1,5,28,12,22,3,150,183,15]),function(oe,e,I,t,v,P,k,w,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class T{constructor(E,b,d,C){this._contributedVariables=new Map,this._context=E,this._labelService=b,this._userHomePromise=d,C&&(this._envVariablesPromise=C.then(y=>this.prepareEnv(y)))}prepareEnv(E){if(k.isWindows){const b=Object.create(null);return Object.keys(E).forEach(d=>{b[d.toLowerCase()]=E[d]}),b}return E}resolveWithEnvironment(E,b,d){return this.recursiveResolve({env:this.prepareEnv(E),userHome:void 0},b?b.uri:void 0,d)}async resolveAsync(E,b){const d={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(d,E?E.uri:void 0,b)}async resolveAnyBase(E,b,d,C){const y=P.deepClone(b);k.isWindows&&y.windows?Object.keys(y.windows).forEach(g=>y[g]=y.windows[g]):k.isMacintosh&&y.osx?Object.keys(y.osx).forEach(g=>y[g]=y.osx[g]):k.isLinux&&y.linux&&Object.keys(y.linux).forEach(g=>y[g]=y.linux[g]),delete y.windows,delete y.osx,delete y.linux;const m={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(m,E?E.uri:void 0,y,d,C)}async resolveAnyAsync(E,b,d){return this.resolveAnyBase(E,b,d)}async resolveAnyMap(E,b,d){const C=new Map;return{newConfig:await this.resolveAnyBase(E,b,d,C),resolvedVariables:C}}resolveWithInteractionReplace(E,b,d,C){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(E,b,d,C){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(E,b){if(this._contributedVariables.has(E))throw new Error("Variable "+E+" is contributed twice.");this._contributedVariables.set(E,b)}async recursiveResolve(E,b,d,C,y){if(v.isString(d))return this.resolveString(E,b,d,C,y);if(v.isArray(d))return Promise.all(d.map(m=>this.recursiveResolve(E,b,m,C,y)));if(v.isObject(d)){const m=Object.create(null),g=await Promise.all(Object.keys(d).map(async h=>[await this.resolveString(E,b,h,C,y),await this.recursiveResolve(E,b,d[h],C,y)]));for(const[h,l]of g)m[h]=l;return m}return d}resolveString(E,b,d,C,y){return(0,D.replaceAsync)(d,T.VARIABLE_REGEXP,async(m,g)=>{if(g.includes(T.VARIABLE_LHS))return m;let h=await this.evaluateSingleVariable(E,m,g,b,C);return y?.set(g,h),h!==m&&v.isString(h)&&h.match(T.VARIABLE_REGEXP)&&(h=await this.resolveString(E,b,h,C,y)),h})}fsPath(E){return this._labelService?this._labelService.getUriLabel(E,{noPrefix:!0}):E.fsPath}async evaluateSingleVariable(E,b,d,C,y){let m;const g=d.split(":");g.length>1&&(d=g[0],m=g[1]);const h=()=>{const i=this._context.getFilePath();if(i)return i;throw new Error((0,p.localize)(0,null,b))},l=()=>{const i=h();if(this._context.getWorkspaceFolderPathForFile){const a=this._context.getWorkspaceFolderPathForFile();if(a)return a}throw new Error((0,p.localize)(1,null,b,I.basename(i)))},f=()=>{if(m){const i=this._context.getFolderUri(m);if(i)return i;throw new Error((0,p.localize)(2,null,b,m))}if(C)return C;throw this._context.getWorkspaceFolderCount()>1?new Error((0,p.localize)(3,null,b)):new Error((0,p.localize)(4,null,b))};switch(d){case"env":if(m){if(E.env){const i=E.env[k.isWindows?m.toLowerCase():m];if(v.isString(i))return i}return""}throw new Error((0,p.localize)(5,null,b));case"config":if(m){const i=this._context.getConfigurationValue(C,m);if(v.isUndefinedOrNull(i))throw new Error((0,p.localize)(6,null,b,m));if(v.isObject(i))throw new Error((0,p.localize)(7,null,b,m));return i}throw new Error((0,p.localize)(8,null,b));case"command":return this.resolveFromMap(b,m,y,"command");case"input":return this.resolveFromMap(b,m,y,"input");case"extensionInstallFolder":if(m){const i=await this._context.getExtension(m);if(!i)throw new Error((0,p.localize)(9,null,b,m));return this.fsPath(i.extensionLocation)}throw new Error((0,p.localize)(10,null,b));default:switch(d){case"workspaceRoot":case"workspaceFolder":return(0,w.normalizeDriveLetter)(this.fsPath(f()));case"cwd":return C||m?(0,w.normalizeDriveLetter)(this.fsPath(f())):t.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return I.basename(this.fsPath(f()));case"userHome":{if(E.userHome)return E.userHome;throw new Error((0,p.localize)(11,null,b))}case"lineNumber":{const i=this._context.getLineNumber();if(i)return i;throw new Error((0,p.localize)(12,null,b))}case"selectedText":{const i=this._context.getSelectedText();if(i)return i;throw new Error((0,p.localize)(13,null,b))}case"file":return h();case"fileWorkspaceFolder":return l();case"relativeFile":return C||m?I.relative(this.fsPath(f()),h()):h();case"relativeFileDirname":{const i=I.dirname(h());if(C||m){const a=I.relative(this.fsPath(f()),i);return a.length===0?".":a}return i}case"fileDirname":return I.dirname(h());case"fileExtname":return I.extname(h());case"fileBasename":return I.basename(h());case"fileBasenameNoExtension":{const i=I.basename(h());return i.slice(0,i.length-I.extname(i).length)}case"fileDirnameBasename":return I.basename(I.dirname(h()));case"execPath":{const i=this._context.getExecPath();return i||b}case"execInstallFolder":{const i=this._context.getAppRoot();return i||b}case"pathSeparator":return I.sep;default:try{const i=m?`${d}:${m}`:d;return this.resolveFromMap(b,i,y,void 0)}catch{return b}}}}resolveFromMap(E,b,d,C){if(b&&d){const y=C===void 0?d[b]:d[C+":"+b];if(typeof y=="string")return y;throw new Error((0,p.localize)(14,null,E))}return E}}e.AbstractVariableResolverService=T,T.VARIABLE_LHS="${",T.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ve[248],we([0,1,6,116]),function(oe,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,I.createDecorator)("editorGroupsService");var v;(function(d){d[d.UP=0]="UP",d[d.DOWN=1]="DOWN",d[d.LEFT=2]="LEFT",d[d.RIGHT=3]="RIGHT"})(v=e.GroupDirection||(e.GroupDirection={}));var P;(function(d){d[d.HORIZONTAL=0]="HORIZONTAL",d[d.VERTICAL=1]="VERTICAL"})(P=e.GroupOrientation||(e.GroupOrientation={}));var k;(function(d){d[d.FIRST=0]="FIRST",d[d.LAST=1]="LAST",d[d.NEXT=2]="NEXT",d[d.PREVIOUS=3]="PREVIOUS"})(k=e.GroupLocation||(e.GroupLocation={}));var w;(function(d){d[d.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",d[d.EVEN=1]="EVEN",d[d.TOGGLE=2]="TOGGLE"})(w=e.GroupsArrangement||(e.GroupsArrangement={}));var p;(function(d){d[d.COPY_EDITORS=0]="COPY_EDITORS",d[d.MOVE_EDITORS=1]="MOVE_EDITORS"})(p=e.MergeGroupMode||(e.MergeGroupMode={}));function D(d){const C=d;return(0,t.isEditorInput)(C?.editor)&&(0,t.isEditorInput)(C?.replacement)}e.isEditorReplacement=D;var T;(function(d){d[d.CREATION_TIME=0]="CREATION_TIME",d[d.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",d[d.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(T=e.GroupsOrder||(e.GroupsOrder={}));var R;(function(d){d[d.NEW_EDITOR=1]="NEW_EDITOR",d[d.MOVE_EDITOR=2]="MOVE_EDITOR",d[d.COPY_EDITOR=3]="COPY_EDITOR"})(R=e.OpenEditorContext||(e.OpenEditorContext={}));function E(d){const C=d;return!!C&&typeof C.id=="number"&&Array.isArray(C.editors)}e.isEditorGroup=E;function b(d){return d.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=b}),define(ve[121],we([0,1,6,248]),function(oe,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,I.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function v(P){const k=P;return typeof P=="number"||(0,t.isEditorGroup)(k)}e.isPreferredGroup=v}),define(ve[122],we([0,1,18,16,88,29,133,41,22,12,4,50,154,187,207,120,242,80,81,121,115,64]),function(oe,e,I,t,v,P,k,w,p,D,T,R,E,b,d,C,y,m,g,h,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var i;(function(Ee){function Ie(j){const{selectionStartLineNumber:De,selectionStartColumn:Fe,positionLineNumber:Qe,positionColumn:Ye}=j,xe=new l.Position(De-1,Fe-1),st=new l.Position(Qe-1,Ye-1);return new l.Selection(xe,st)}Ee.to=Ie;function me(j){const{anchor:De,active:Fe}=j;return{selectionStartLineNumber:De.line+1,selectionStartColumn:De.character+1,positionLineNumber:Fe.line+1,positionColumn:Fe.character+1}}Ee.from=me})(i=e.Selection||(e.Selection={}));var a;(function(Ee){function Ie(j){if(!j)return;const{start:De,end:Fe}=j;return{startLineNumber:De.line+1,startColumn:De.character+1,endLineNumber:Fe.line+1,endColumn:Fe.character+1}}Ee.from=Ie;function me(j){if(!j)return;const{startLineNumber:De,startColumn:Fe,endLineNumber:Qe,endColumn:Ye}=j;return new l.Range(De-1,Fe-1,Qe-1,Ye-1)}Ee.to=me})(a=e.Range||(e.Range={}));var n;(function(Ee){function Ie(me){switch(me){case 1:return l.StandardTokenType.Comment;case 0:return l.StandardTokenType.Other;case 3:return l.StandardTokenType.RegEx;case 2:return l.StandardTokenType.String}}Ee.to=Ie})(n=e.TokenType||(e.TokenType={}));var o;(function(Ee){function Ie(j){return new l.Position(j.lineNumber-1,j.column-1)}Ee.to=Ie;function me(j){return{lineNumber:j.line+1,column:j.character+1}}Ee.from=me})(o=e.Position||(e.Position={}));var r;(function(Ee){function Ie(De,Fe){return(0,I.coalesce)((0,I.asArray)(De).map(Qe=>me(Qe,Fe)))}Ee.from=Ie;function me(De,Fe){if(typeof De=="string")return{$serialized:!0,language:De};if(De)return{$serialized:!0,language:De.language,scheme:j(De.scheme,Fe),pattern:ue.from(De.pattern)??void 0,exclusive:De.exclusive,notebookType:De.notebookType}}function j(De,Fe){return Fe&&typeof De=="string"?Fe.transformOutgoingScheme(De):De}})(r=e.DocumentSelector||(e.DocumentSelector={}));var s;(function(Ee){function Ie(j){switch(j){case l.DiagnosticTag.Unnecessary:return 1;case l.DiagnosticTag.Deprecated:return 2}}Ee.from=Ie;function me(j){switch(j){case 1:return l.DiagnosticTag.Unnecessary;case 2:return l.DiagnosticTag.Deprecated;default:return}}Ee.to=me})(s=e.DiagnosticTag||(e.DiagnosticTag={}));var c;(function(Ee){function Ie(j){let De;return j.code&&((0,D.isString)(j.code)||(0,D.isNumber)(j.code)?De=String(j.code):De={value:String(j.code.value),target:j.code.target}),{...a.from(j.range),message:j.message,source:j.source,code:De,severity:S.from(j.severity),relatedInformation:j.relatedInformation&&j.relatedInformation.map(u.from),tags:Array.isArray(j.tags)?(0,I.coalesce)(j.tags.map(s.from)):void 0}}Ee.from=Ie;function me(j){const De=new l.Diagnostic(a.to(j),j.message,S.to(j.severity));return De.source=j.source,De.code=(0,D.isString)(j.code)?j.code:j.code?.value,De.relatedInformation=j.relatedInformation&&j.relatedInformation.map(u.to),De.tags=j.tags&&(0,I.coalesce)(j.tags.map(s.to)),De}Ee.to=me})(c=e.Diagnostic||(e.Diagnostic={}));var u;(function(Ee){function Ie(j){return{...a.from(j.location.range),message:j.message,resource:j.location.uri}}Ee.from=Ie;function me(j){return new l.DiagnosticRelatedInformation(new l.Location(j.resource,a.to(j)),j.message)}Ee.to=me})(u=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var S;(function(Ee){function Ie(j){switch(j){case l.DiagnosticSeverity.Error:return d.MarkerSeverity.Error;case l.DiagnosticSeverity.Warning:return d.MarkerSeverity.Warning;case l.DiagnosticSeverity.Information:return d.MarkerSeverity.Info;case l.DiagnosticSeverity.Hint:return d.MarkerSeverity.Hint}return d.MarkerSeverity.Error}Ee.from=Ie;function me(j){switch(j){case d.MarkerSeverity.Info:return l.DiagnosticSeverity.Information;case d.MarkerSeverity.Warning:return l.DiagnosticSeverity.Warning;case d.MarkerSeverity.Error:return l.DiagnosticSeverity.Error;case d.MarkerSeverity.Hint:return l.DiagnosticSeverity.Hint;default:return l.DiagnosticSeverity.Error}}Ee.to=me})(S=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var A;(function(Ee){function Ie(j){return typeof j=="number"&&j>=l.ViewColumn.One?j-1:j===l.ViewColumn.Beside?h.SIDE_GROUP:h.ACTIVE_GROUP}Ee.from=Ie;function me(j){if(typeof j=="number"&&j>=0)return j+1;throw new Error("invalid 'EditorGroupColumn'")}Ee.to=me})(A=e.ViewColumn||(e.ViewColumn={}));function M(Ee){return typeof Ee.range!="undefined"}function $(Ee){return Ee.length===0?!0:!!M(Ee[0])}e.isDecorationOptionsArr=$;var Q;(function(Ee){function Ie(Ye){return Ye.map(Ee.from)}Ee.fromMany=Ie;function me(Ye){return Ye&&typeof Ye=="object"&&typeof Ye.language=="string"&&typeof Ye.value=="string"}function j(Ye){let xe;if(me(Ye)){const{language:ut,value:wt}=Ye;xe={value:"```"+ut+`
`+wt+"\n```\n"}}else l.MarkdownString.isMarkdownString(Ye)?xe={value:Ye.value,isTrusted:Ye.isTrusted,supportThemeIcons:Ye.supportThemeIcons,supportHtml:Ye.supportHtml,baseUri:Ye.baseUri}:typeof Ye=="string"?xe={value:Ye}:xe={value:""};const st=Object.create(null);xe.uris=st;const ht=ut=>{try{let wt=T.URI.parse(ut,!0);wt=wt.with({query:De(wt.query,st)}),st[ut]=wt}catch{}return""},bt=new k.marked.Renderer;return bt.link=ht,bt.image=ut=>typeof ut=="string"?ht(v.parseHrefAndDimensions(ut).href):"",(0,k.marked)(xe.value,{renderer:bt}),xe}Ee.from=j;function De(Ye,xe){if(!Ye)return Ye;let st;try{st=(0,w.parse)(Ye)}catch{}if(!st)return Ye;let ht=!1;return st=(0,p.cloneAndChange)(st,bt=>{if(T.URI.isUri(bt)){const ut=`__uri_${Math.random().toString(16).slice(2,8)}`;return xe[ut]=bt,ht=!0,ut}else return}),ht?JSON.stringify(st):Ye}function Fe(Ye){const xe=new l.MarkdownString(Ye.value,Ye.supportThemeIcons);return xe.isTrusted=Ye.isTrusted,xe.supportHtml=Ye.supportHtml,xe.baseUri=Ye.baseUri?T.URI.from(Ye.baseUri):void 0,xe}Ee.to=Fe;function Qe(Ye){if(!!Ye)return typeof Ye=="string"?Ye:Ee.from(Ye)}Ee.fromStrict=Qe})(Q=e.MarkdownString||(e.MarkdownString={}));function _(Ee){return $(Ee)?Ee.map(Ie=>({range:a.from(Ie.range),hoverMessage:Array.isArray(Ie.hoverMessage)?Q.fromMany(Ie.hoverMessage):Ie.hoverMessage?Q.from(Ie.hoverMessage):void 0,renderOptions:Ie.renderOptions})):Ee.map(Ie=>({range:a.from(Ie)}))}e.fromRangeOrRangeWithMessage=_;function q(Ee){return typeof Ee=="undefined"?Ee:typeof Ee=="string"?T.URI.file(Ee):Ee}e.pathOrURIToURI=q;var U;(function(Ee){function Ie(me){return typeof me=="undefined"?me:{contentText:me.contentText,contentIconPath:me.contentIconPath?q(me.contentIconPath):void 0,border:me.border,borderColor:me.borderColor,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,color:me.color,backgroundColor:me.backgroundColor,margin:me.margin,width:me.width,height:me.height}}Ee.from=Ie})(U=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var ne;(function(Ee){function Ie(me){return typeof me=="undefined"?me:{backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?q(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?U.from(me.before):void 0,after:me.after?U.from(me.after):void 0}}Ee.from=Ie})(ne=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var Z;(function(Ee){function Ie(me){if(typeof me=="undefined")return me;switch(me){case l.DecorationRangeBehavior.OpenOpen:return 0;case l.DecorationRangeBehavior.ClosedClosed:return 1;case l.DecorationRangeBehavior.OpenClosed:return 2;case l.DecorationRangeBehavior.ClosedOpen:return 3}}Ee.from=Ie})(Z=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var F;(function(Ee){function Ie(me){return{isWholeLine:me.isWholeLine,rangeBehavior:me.rangeBehavior?Z.from(me.rangeBehavior):void 0,overviewRulerLane:me.overviewRulerLane,light:me.light?ne.from(me.light):void 0,dark:me.dark?ne.from(me.dark):void 0,backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?q(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?U.from(me.before):void 0,after:me.after?U.from(me.after):void 0}}Ee.from=Ie})(F=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var x;(function(Ee){function Ie(j){return{text:j.newText,eol:j.newEol&&$e.from(j.newEol),range:a.from(j.range)}}Ee.from=Ie;function me(j){const De=new l.TextEdit(a.to(j.range),j.text);return De.newEol=typeof j.eol=="undefined"?void 0:$e.to(j.eol),De}Ee.to=me})(x=e.TextEdit||(e.TextEdit={}));var z;(function(Ee){function Ie(j,De,Fe){const Qe={edits:[]};if(j instanceof l.WorkspaceEdit){const Ye=new P.ResourceSet;for(const xe of j._allEntries())xe._type===1&&T.URI.isUri(xe.to)&&xe.from===void 0&&Ye.add(xe.to);for(const xe of j._allEntries())if(xe._type===1)Qe.edits.push({_type:1,oldUri:xe.from,newUri:xe.to,options:xe.options,metadata:xe.metadata});else if(xe._type===2){const st={_type:2,resource:xe.uri,edit:x.from(xe.edit),modelVersionId:Ye.has(xe.uri)?void 0:De?.getTextDocumentVersion(xe.uri),metadata:xe.metadata};Fe&&xe.edit.newText2 instanceof l.SnippetString&&(st.edit.insertAsSnippet=!0,st.edit.text=xe.edit.newText2.value),Qe.edits.push(st)}else xe._type===3?Qe.edits.push({_type:3,metadata:xe.metadata,resource:xe.uri,edit:xe.edit,notebookMetadata:xe.notebookMetadata,notebookVersionId:De?.getNotebookDocumentVersion(xe.uri)}):xe._type===5&&Qe.edits.push({_type:3,metadata:xe.metadata,resource:xe.uri,notebookVersionId:De?.getNotebookDocumentVersion(xe.uri),edit:{editType:1,index:xe.index,count:xe.count,cells:xe.cells.map(Ke.from)}})}return Qe}Ee.from=Ie;function me(j){const De=new l.WorkspaceEdit;for(const Fe of j.edits)Fe.edit?De.replace(T.URI.revive(Fe.resource),a.to(Fe.edit.range),Fe.edit.text):De.renameFile(T.URI.revive(Fe.oldUri),T.URI.revive(Fe.newUri),Fe.options);return De}Ee.to=me})(z=e.WorkspaceEdit||(e.WorkspaceEdit={}));var W;(function(Ee){const Ie=Object.create(null);Ie[l.SymbolKind.File]=0,Ie[l.SymbolKind.Module]=1,Ie[l.SymbolKind.Namespace]=2,Ie[l.SymbolKind.Package]=3,Ie[l.SymbolKind.Class]=4,Ie[l.SymbolKind.Method]=5,Ie[l.SymbolKind.Property]=6,Ie[l.SymbolKind.Field]=7,Ie[l.SymbolKind.Constructor]=8,Ie[l.SymbolKind.Enum]=9,Ie[l.SymbolKind.Interface]=10,Ie[l.SymbolKind.Function]=11,Ie[l.SymbolKind.Variable]=12,Ie[l.SymbolKind.Constant]=13,Ie[l.SymbolKind.String]=14,Ie[l.SymbolKind.Number]=15,Ie[l.SymbolKind.Boolean]=16,Ie[l.SymbolKind.Array]=17,Ie[l.SymbolKind.Object]=18,Ie[l.SymbolKind.Key]=19,Ie[l.SymbolKind.Null]=20,Ie[l.SymbolKind.EnumMember]=21,Ie[l.SymbolKind.Struct]=22,Ie[l.SymbolKind.Event]=23,Ie[l.SymbolKind.Operator]=24,Ie[l.SymbolKind.TypeParameter]=25;function me(De){return typeof Ie[De]=="number"?Ie[De]:6}Ee.from=me;function j(De){for(const Fe in Ie)if(Ie[Fe]===De)return Number(Fe);return l.SymbolKind.Property}Ee.to=j})(W=e.SymbolKind||(e.SymbolKind={}));var re;(function(Ee){function Ie(j){switch(j){case l.SymbolTag.Deprecated:return 1}}Ee.from=Ie;function me(j){switch(j){case 1:return l.SymbolTag.Deprecated}}Ee.to=me})(re=e.SymbolTag||(e.SymbolTag={}));var V;(function(Ee){function Ie(j){return{name:j.name,kind:W.from(j.kind),tags:j.tags&&j.tags.map(re.from),containerName:j.containerName,location:B.from(j.location)}}Ee.from=Ie;function me(j){const De=new l.SymbolInformation(j.name,W.to(j.kind),j.containerName,B.to(j.location));return De.tags=j.tags&&j.tags.map(re.to),De}Ee.to=me})(V=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var X;(function(Ee){function Ie(j){const De={name:j.name||"!!MISSING: name!!",detail:j.detail,range:a.from(j.range),selectionRange:a.from(j.selectionRange),kind:W.from(j.kind),tags:j.tags?.map(re.from)??[]};return j.children&&(De.children=j.children.map(Ie)),De}Ee.from=Ie;function me(j){const De=new l.DocumentSymbol(j.name,j.detail,W.to(j.kind),a.to(j.range),a.to(j.selectionRange));return(0,I.isNonEmptyArray)(j.tags)&&(De.tags=j.tags.map(re.to)),j.children&&(De.children=j.children.map(me)),De}Ee.to=me})(X=e.DocumentSymbol||(e.DocumentSymbol={}));var ae;(function(Ee){function Ie(j){const De=new l.CallHierarchyItem(W.to(j.kind),j.name,j.detail||"",T.URI.revive(j.uri),a.to(j.range),a.to(j.selectionRange));return De._sessionId=j._sessionId,De._itemId=j._itemId,De}Ee.to=Ie;function me(j,De,Fe){if(De=De??j._sessionId,Fe=Fe??j._itemId,De===void 0||Fe===void 0)throw new Error("invalid item");return{_sessionId:De,_itemId:Fe,name:j.name,detail:j.detail,kind:W.from(j.kind),uri:j.uri,range:a.from(j.range),selectionRange:a.from(j.selectionRange),tags:j.tags?.map(re.from)}}Ee.from=me})(ae=e.CallHierarchyItem||(e.CallHierarchyItem={}));var ie;(function(Ee){function Ie(me){return new l.CallHierarchyIncomingCall(ae.to(me.from),me.fromRanges.map(j=>a.to(j)))}Ee.to=Ie})(ie=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var O;(function(Ee){function Ie(me){return new l.CallHierarchyOutgoingCall(ae.to(me.to),me.fromRanges.map(j=>a.to(j)))}Ee.to=Ie})(O=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var B;(function(Ee){function Ie(j){return{range:j.range&&a.from(j.range),uri:j.uri}}Ee.from=Ie;function me(j){return new l.Location(T.URI.revive(j.uri),a.to(j.range))}Ee.to=me})(B=e.location||(e.location={}));var ee;(function(Ee){function Ie(j){const De=j,Fe=j;return{originSelectionRange:De.originSelectionRange?a.from(De.originSelectionRange):void 0,uri:De.targetUri?De.targetUri:Fe.uri,range:a.from(De.targetRange?De.targetRange:Fe.range),targetSelectionRange:De.targetSelectionRange?a.from(De.targetSelectionRange):void 0}}Ee.from=Ie;function me(j){return{targetUri:T.URI.revive(j.uri),targetRange:a.to(j.range),targetSelectionRange:j.targetSelectionRange?a.to(j.targetSelectionRange):void 0,originSelectionRange:j.originSelectionRange?a.to(j.originSelectionRange):void 0}}Ee.to=me})(ee=e.DefinitionLink||(e.DefinitionLink={}));var ce;(function(Ee){function Ie(j){return{range:a.from(j.range),contents:Q.fromMany(j.contents)}}Ee.from=Ie;function me(j){return new l.Hover(j.contents.map(Q.to),a.to(j.range))}Ee.to=me})(ce=e.Hover||(e.Hover={}));var K;(function(Ee){function Ie(j){return{range:a.from(j.range),expression:j.expression}}Ee.from=Ie;function me(j){return new l.EvaluatableExpression(a.to(j.range),j.expression)}Ee.to=me})(K=e.EvaluatableExpression||(e.EvaluatableExpression={}));var he;(function(Ee){function Ie(j){if(j instanceof l.InlineValueText)return{type:"text",range:a.from(j.range),text:j.text};if(j instanceof l.InlineValueVariableLookup)return{type:"variable",range:a.from(j.range),variableName:j.variableName,caseSensitiveLookup:j.caseSensitiveLookup};if(j instanceof l.InlineValueEvaluatableExpression)return{type:"expression",range:a.from(j.range),expression:j.expression};throw new Error("Unknown 'InlineValue' type")}Ee.from=Ie;function me(j){switch(j.type){case"text":return{range:a.to(j.range),text:j.text};case"variable":return{range:a.to(j.range),variableName:j.variableName,caseSensitiveLookup:j.caseSensitiveLookup};case"expression":return{range:a.to(j.range),expression:j.expression}}}Ee.to=me})(he=e.InlineValue||(e.InlineValue={}));var te;(function(Ee){function Ie(j){return{frameId:j.frameId,stoppedLocation:a.from(j.stoppedLocation)}}Ee.from=Ie;function me(j){return new l.InlineValueContext(j.frameId,a.to(j.stoppedLocation))}Ee.to=me})(te=e.InlineValueContext||(e.InlineValueContext={}));var le;(function(Ee){function Ie(j){return{range:a.from(j.range),kind:j.kind}}Ee.from=Ie;function me(j){return new l.DocumentHighlight(a.to(j.range),j.kind)}Ee.to=me})(le=e.DocumentHighlight||(e.DocumentHighlight={}));var de;(function(Ee){function Ie(me){switch(me){case 1:return l.CompletionTriggerKind.TriggerCharacter;case 2:return l.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return l.CompletionTriggerKind.Invoke}}Ee.to=Ie})(de=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Y;(function(Ee){function Ie(me){return{triggerKind:de.to(me.triggerKind),triggerCharacter:me.triggerCharacter}}Ee.to=Ie})(Y=e.CompletionContext||(e.CompletionContext={}));var J;(function(Ee){function Ie(j){switch(j){case l.CompletionItemTag.Deprecated:return 1}}Ee.from=Ie;function me(j){switch(j){case 1:return l.CompletionItemTag.Deprecated}}Ee.to=me})(J=e.CompletionItemTag||(e.CompletionItemTag={}));var H;(function(Ee){const Ie=new Map([[l.CompletionItemKind.Method,0],[l.CompletionItemKind.Function,1],[l.CompletionItemKind.Constructor,2],[l.CompletionItemKind.Field,3],[l.CompletionItemKind.Variable,4],[l.CompletionItemKind.Class,5],[l.CompletionItemKind.Interface,7],[l.CompletionItemKind.Struct,6],[l.CompletionItemKind.Module,8],[l.CompletionItemKind.Property,9],[l.CompletionItemKind.Unit,12],[l.CompletionItemKind.Value,13],[l.CompletionItemKind.Constant,14],[l.CompletionItemKind.Enum,15],[l.CompletionItemKind.EnumMember,16],[l.CompletionItemKind.Keyword,17],[l.CompletionItemKind.Snippet,27],[l.CompletionItemKind.Text,18],[l.CompletionItemKind.Color,19],[l.CompletionItemKind.File,20],[l.CompletionItemKind.Reference,21],[l.CompletionItemKind.Folder,23],[l.CompletionItemKind.Event,10],[l.CompletionItemKind.Operator,11],[l.CompletionItemKind.TypeParameter,24],[l.CompletionItemKind.Issue,26],[l.CompletionItemKind.User,25]]);function me(Fe){return Ie.get(Fe)??9}Ee.from=me;const j=new Map([[0,l.CompletionItemKind.Method],[1,l.CompletionItemKind.Function],[2,l.CompletionItemKind.Constructor],[3,l.CompletionItemKind.Field],[4,l.CompletionItemKind.Variable],[5,l.CompletionItemKind.Class],[7,l.CompletionItemKind.Interface],[6,l.CompletionItemKind.Struct],[8,l.CompletionItemKind.Module],[9,l.CompletionItemKind.Property],[12,l.CompletionItemKind.Unit],[13,l.CompletionItemKind.Value],[14,l.CompletionItemKind.Constant],[15,l.CompletionItemKind.Enum],[16,l.CompletionItemKind.EnumMember],[17,l.CompletionItemKind.Keyword],[27,l.CompletionItemKind.Snippet],[18,l.CompletionItemKind.Text],[19,l.CompletionItemKind.Color],[20,l.CompletionItemKind.File],[21,l.CompletionItemKind.Reference],[23,l.CompletionItemKind.Folder],[10,l.CompletionItemKind.Event],[11,l.CompletionItemKind.Operator],[24,l.CompletionItemKind.TypeParameter],[25,l.CompletionItemKind.User],[26,l.CompletionItemKind.Issue]]);function De(Fe){return j.get(Fe)??l.CompletionItemKind.Property}Ee.to=De})(H=e.CompletionItemKind||(e.CompletionItemKind={}));var G;(function(Ee){function Ie(me,j){const De=new l.CompletionItem(me.label);return De.insertText=me.insertText,De.kind=H.to(me.kind),De.tags=me.tags?.map(J.to),De.detail=me.detail,De.documentation=v.isMarkdownString(me.documentation)?Q.to(me.documentation):me.documentation,De.sortText=me.sortText,De.filterText=me.filterText,De.preselect=me.preselect,De.commitCharacters=me.commitCharacters,R.Range.isIRange(me.range)?De.range=a.to(me.range):typeof me.range=="object"&&(De.range={inserting:a.to(me.range.insert),replacing:a.to(me.range.replace)}),De.keepWhitespace=typeof me.insertTextRules=="undefined"?!1:Boolean(me.insertTextRules&1),typeof me.insertTextRules!="undefined"&&me.insertTextRules&4?De.insertText=new l.SnippetString(me.insertText):(De.insertText=me.insertText,De.textEdit=De.range instanceof l.Range?new l.TextEdit(De.range,De.insertText):void 0),me.additionalTextEdits&&me.additionalTextEdits.length>0&&(De.additionalTextEdits=me.additionalTextEdits.map(Fe=>x.to(Fe))),De.command=j&&me.command?j.fromInternal(me.command):void 0,De}Ee.to=Ie})(G=e.CompletionItem||(e.CompletionItem={}));var fe;(function(Ee){function Ie(j){return{label:j.label,documentation:Q.fromStrict(j.documentation)}}Ee.from=Ie;function me(j){return{label:j.label,documentation:v.isMarkdownString(j.documentation)?Q.to(j.documentation):j.documentation}}Ee.to=me})(fe=e.ParameterInformation||(e.ParameterInformation={}));var pe;(function(Ee){function Ie(j){return{label:j.label,documentation:Q.fromStrict(j.documentation),parameters:Array.isArray(j.parameters)?j.parameters.map(fe.from):[],activeParameter:j.activeParameter}}Ee.from=Ie;function me(j){return{label:j.label,documentation:v.isMarkdownString(j.documentation)?Q.to(j.documentation):j.documentation,parameters:Array.isArray(j.parameters)?j.parameters.map(fe.to):[],activeParameter:j.activeParameter}}Ee.to=me})(pe=e.SignatureInformation||(e.SignatureInformation={}));var ke;(function(Ee){function Ie(j){return{activeSignature:j.activeSignature,activeParameter:j.activeParameter,signatures:Array.isArray(j.signatures)?j.signatures.map(pe.from):[]}}Ee.from=Ie;function me(j){return{activeSignature:j.activeSignature,activeParameter:j.activeParameter,signatures:Array.isArray(j.signatures)?j.signatures.map(pe.to):[]}}Ee.to=me})(ke=e.SignatureHelp||(e.SignatureHelp={}));var Te;(function(Ee){function Ie(me,j){const De=new l.InlayHint(o.to(j.position),typeof j.label=="string"?j.label:j.label.map(Me.to.bind(void 0,me)),j.kind&&Be.to(j.kind));return De.textEdits=j.textEdits&&j.textEdits.map(x.to),De.tooltip=v.isMarkdownString(j.tooltip)?Q.to(j.tooltip):j.tooltip,De.paddingLeft=j.paddingLeft,De.paddingRight=j.paddingRight,De}Ee.to=Ie})(Te=e.InlayHint||(e.InlayHint={}));var Me;(function(Ee){function Ie(me,j){const De=new l.InlayHintLabelPart(j.label);return De.tooltip=v.isMarkdownString(j.tooltip)?Q.to(j.tooltip):j.tooltip,E.Command.is(j.command)&&(De.command=me.fromInternal(j.command)),j.location&&(De.location=B.to(j.location)),De}Ee.to=Ie})(Me=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var Be;(function(Ee){function Ie(j){return j}Ee.from=Ie;function me(j){return j}Ee.to=me})(Be=e.InlayHintKind||(e.InlayHintKind={}));var ge;(function(Ee){function Ie(j){return{range:a.from(j.range),url:j.target,tooltip:j.tooltip}}Ee.from=Ie;function me(j){let De;if(j.url)try{De=typeof j.url=="string"?T.URI.parse(j.url,!0):T.URI.revive(j.url)}catch{}return new l.DocumentLink(a.to(j.range),De)}Ee.to=me})(ge=e.DocumentLink||(e.DocumentLink={}));var Se;(function(Ee){function Ie(j){const De=new l.ColorPresentation(j.label);return j.textEdit&&(De.textEdit=x.to(j.textEdit)),j.additionalTextEdits&&(De.additionalTextEdits=j.additionalTextEdits.map(Fe=>x.to(Fe))),De}Ee.to=Ie;function me(j){return{label:j.label,textEdit:j.textEdit?x.from(j.textEdit):void 0,additionalTextEdits:j.additionalTextEdits?j.additionalTextEdits.map(De=>x.from(De)):void 0}}Ee.from=me})(Se=e.ColorPresentation||(e.ColorPresentation={}));var ye;(function(Ee){function Ie(j){return new l.Color(j[0],j[1],j[2],j[3])}Ee.to=Ie;function me(j){return[j.red,j.green,j.blue,j.alpha]}Ee.from=me})(ye=e.Color||(e.Color={}));var Oe;(function(Ee){function Ie(j){return{range:a.from(j.range)}}Ee.from=Ie;function me(j){return new l.SelectionRange(a.to(j.range))}Ee.to=me})(Oe=e.SelectionRange||(e.SelectionRange={}));var Ne;(function(Ee){function Ie(me){switch(me){case 2:return l.TextDocumentSaveReason.AfterDelay;case 1:return l.TextDocumentSaveReason.Manual;case 3:case 4:return l.TextDocumentSaveReason.FocusOut}}Ee.to=Ie})(Ne=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Je;(function(Ee){function Ie(j){switch(j){case l.TextEditorLineNumbersStyle.Off:return 0;case l.TextEditorLineNumbersStyle.Relative:return 2;case l.TextEditorLineNumbersStyle.On:default:return 1}}Ee.from=Ie;function me(j){switch(j){case 0:return l.TextEditorLineNumbersStyle.Off;case 2:return l.TextEditorLineNumbersStyle.Relative;case 1:default:return l.TextEditorLineNumbersStyle.On}}Ee.to=me})(Je=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var $e;(function(Ee){function Ie(j){if(j===l.EndOfLine.CRLF)return 1;if(j===l.EndOfLine.LF)return 0}Ee.from=Ie;function me(j){if(j===1)return l.EndOfLine.CRLF;if(j===0)return l.EndOfLine.LF}Ee.to=me})($e=e.EndOfLine||(e.EndOfLine={}));var He;(function(Ee){function Ie(me){if(typeof me=="object")return me.viewId;switch(me){case l.ProgressLocation.SourceControl:return 3;case l.ProgressLocation.Window:return 10;case l.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ee.from=Ie})(He=e.ProgressLocation||(e.ProgressLocation={}));var We;(function(Ee){function Ie(me){const j={start:me.start+1,end:me.end+1};return me.kind&&(j.kind=je.from(me.kind)),j}Ee.from=Ie})(We=e.FoldingRange||(e.FoldingRange={}));var je;(function(Ee){function Ie(me){if(me)switch(me){case l.FoldingRangeKind.Comment:return E.FoldingRangeKind.Comment;case l.FoldingRangeKind.Imports:return E.FoldingRangeKind.Imports;case l.FoldingRangeKind.Region:return E.FoldingRangeKind.Region}}Ee.from=Ie})(je=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ge;(function(Ee){function Ie(me){if(me)return{pinned:typeof me.preview=="boolean"?!me.preview:void 0,inactive:me.background,preserveFocus:me.preserveFocus,selection:typeof me.selection=="object"?a.from(me.selection):void 0,override:typeof me.override=="boolean"?b.EditorResolution.DISABLED:void 0}}Ee.from=Ie})(Ge=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var ue;(function(Ee){function Ie(Fe){return Fe instanceof l.RelativePattern?Fe.toJSON():typeof Fe=="string"?Fe:me(Fe)||j(Fe)?new l.RelativePattern(Fe.baseUri??Fe.base,Fe.pattern).toJSON():Fe}Ee.from=Ie;function me(Fe){const Qe=Fe;return Qe?T.URI.isUri(Qe.baseUri)&&typeof Qe.pattern=="string":!1}function j(Fe){const Qe=Fe;return Qe?typeof Qe.base=="string"&&typeof Qe.pattern=="string":!1}function De(Fe){return typeof Fe=="string"?Fe:new l.RelativePattern(T.URI.revive(Fe.baseUri),Fe.pattern)}Ee.to=De})(ue=e.GlobPattern||(e.GlobPattern={}));var Ce;(function(Ee){function Ie(me){if(me){if(Array.isArray(me))return me.map(Ie);if(typeof me=="string")return me;{const j=me;return{language:j.language,scheme:j.scheme,pattern:ue.from(j.pattern),exclusive:j.exclusive,notebookType:j.notebookType}}}else return}Ee.from=Ie})(Ce=e.LanguageSelector||(e.LanguageSelector={}));var Pe;(function(Ee){function Ie(j){return{start:j.start,end:j.end}}Ee.from=Ie;function me(j){return new l.NotebookRange(j.start,j.end)}Ee.to=me})(Pe=e.NotebookRange||(e.NotebookRange={}));var Ae;(function(Ee){function Ie(j){return{timing:typeof j.runStartTime=="number"&&typeof j.runEndTime=="number"?{startTime:j.runStartTime,endTime:j.runEndTime}:void 0,executionOrder:j.executionOrder,success:j.lastRunSuccess}}Ee.to=Ie;function me(j){return{lastRunSuccess:j.success,runStartTime:j.timing?.startTime,runEndTime:j.timing?.endTime,executionOrder:j.executionOrder}}Ee.from=me})(Ae=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Le;(function(Ee){function Ie(me){if(me===y.NotebookCellExecutionState.Executing)return l.NotebookCellExecutionState.Executing;if(me===y.NotebookCellExecutionState.Pending)return l.NotebookCellExecutionState.Pending;if(me===y.NotebookCellExecutionState.Unconfirmed)return l.NotebookCellExecutionState.Pending;throw new Error(`Unknown state: ${me}`)}Ee.to=Ie})(Le=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ue;(function(Ee){function Ie(j){switch(j){case l.NotebookCellKind.Markup:return y.CellKind.Markup;case l.NotebookCellKind.Code:default:return y.CellKind.Code}}Ee.from=Ie;function me(j){switch(j){case y.CellKind.Markup:return l.NotebookCellKind.Markup;case y.CellKind.Code:default:return l.NotebookCellKind.Code}}Ee.to=me})(Ue=e.NotebookCellKind||(e.NotebookCellKind={}));var Ve;(function(Ee){function Ie(j){const De={metadata:j.metadata??Object.create(null),cells:[]};for(const Fe of j.cells)l.NotebookCellData.validate(Fe),De.cells.push(Ke.from(Fe));return De}Ee.from=Ie;function me(j){const De=new l.NotebookData(j.cells.map(Ke.to));return(0,D.isEmptyObject)(j.metadata)||(De.metadata=j.metadata),De}Ee.to=me})(Ve=e.NotebookData||(e.NotebookData={}));var Ke;(function(Ee){function Ie(j){return{cellKind:Ue.from(j.kind),language:j.languageId,mime:j.mime,source:j.value,metadata:j.metadata,internalMetadata:Ae.from(j.executionSummary??{}),outputs:j.outputs?j.outputs.map(nt.from):[]}}Ee.from=Ie;function me(j){return new l.NotebookCellData(Ue.to(j.cellKind),j.source,j.language,j.mime,j.outputs?j.outputs.map(nt.to):void 0,j.metadata,j.internalMetadata?Ae.to(j.internalMetadata):void 0)}Ee.to=me})(Ke=e.NotebookCellData||(e.NotebookCellData={}));var et;(function(Ee){function Ie(j){return{mime:j.mime,valueBytes:t.VSBuffer.wrap(j.data)}}Ee.from=Ie;function me(j){return new l.NotebookCellOutputItem(j.valueBytes.buffer,j.mime)}Ee.to=me})(et=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var nt;(function(Ee){function Ie(j){return{outputId:j.id,items:j.items.map(et.from),metadata:j.metadata}}Ee.from=Ie;function me(j){const De=j.items.map(et.to);return new l.NotebookCellOutput(De,j.outputId,j.metadata)}Ee.to=me})(nt=e.NotebookCellOutput||(e.NotebookCellOutput={}));var it;(function(Ee){function Ie(De){return j(De)?{include:(0,D.withNullAsUndefined)(ue.from(De.include)),exclude:(0,D.withNullAsUndefined)(ue.from(De.exclude))}:(0,D.withNullAsUndefined)(ue.from(De))}Ee.from=Ie;function me(De){return j(De)?{include:ue.to(De.include),exclude:ue.to(De.exclude)}:ue.to(De)}Ee.to=me;function j(De){const Fe=De;return Fe?!(0,D.isUndefinedOrNull)(Fe.include)&&!(0,D.isUndefinedOrNull)(Fe.exclude):!1}})(it=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var rt;(function(Ee){function Ie(me,j,De){const Fe=typeof me.command=="string"?{title:"",command:me.command}:me.command;return{alignment:me.alignment===l.NotebookCellStatusBarAlignment.Left?1:2,command:j.toInternal(Fe,De),text:me.text,tooltip:me.tooltip,accessibilityInformation:me.accessibilityInformation,priority:me.priority}}Ee.from=Ie})(rt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var dt;(function(Ee){function Ie(me){return{transientOutputs:me?.transientOutputs??!1,transientCellMetadata:me?.transientCellMetadata??{},transientDocumentMetadata:me?.transientDocumentMetadata??{}}}Ee.from=Ie})(dt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var pt;(function(Ee){function Ie(j){return{uri:j.uri,provides:j.provides}}Ee.from=Ie;function me(j){return new l.NotebookRendererScript(T.URI.revive(j.uri),j.provides)}Ee.to=me})(pt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var vt;(function(Ee){function Ie(j){return{message:Q.fromStrict(j.message)||"",type:0,expected:j.expectedOutput,actual:j.actualOutput,location:j.location&&{range:a.from(j.location.range),uri:j.location.uri}}}Ee.from=Ie;function me(j){const De=new l.TestMessage(typeof j.message=="string"?j.message:Q.to(j.message));return De.actualOutput=j.actual,De.expectedOutput=j.expected,De.location=j.location?B.to(j.location):void 0,De}Ee.to=me})(vt=e.TestMessage||(e.TestMessage={}));var Et;(function(Ee){Ee.namespace=g.namespaceTestTag,Ee.denamespace=g.denamespaceTestTag})(Et=e.TestTag||(e.TestTag={}));var St;(function(Ee){function Ie(j){const De=(0,C.getPrivateApiFor)(j).controllerId;return{extId:m.TestId.fromExtHostTestItem(j,De).toString(),label:j.label,uri:T.URI.revive(j.uri),busy:!1,tags:j.tags.map(Fe=>Et.namespace(De,Fe.id)),range:R.Range.lift(a.from(j.range)),description:j.description||null,sortText:j.sortText||null,error:j.error&&Q.fromStrict(j.error)||null}}Ee.from=Ie;function me(j){return{parent:void 0,error:void 0,id:m.TestId.fromString(j.extId).localId,label:j.label,uri:T.URI.revive(j.uri),tags:(j.tags||[]).map(De=>{const{tagId:Fe}=Et.denamespace(De);return new l.TestTag(Fe)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:a.to(j.range||void 0),canResolveChildren:!1,busy:!1,description:j.description||void 0,sortText:j.sortText||void 0}}Ee.toPlain=me})(St=e.TestItem||(e.TestItem={})),function(Ee){function Ie(j){return{id:j.id}}Ee.from=Ie;function me(j){return new l.TestTag(j.id)}Ee.to=me}(Et=e.TestTag||(e.TestTag={}));var ot;(function(Ee){const Ie=(j,De)=>{const Fe={...St.toPlain(j.item),parent:void 0,taskStates:j.tasks.map(Qe=>({state:Qe.state,duration:Qe.duration,messages:Qe.messages.filter(Ye=>Ye.type===0).map(vt.to)})),children:j.children.map(Qe=>De.get(Qe)).filter(D.isDefined).map(Qe=>Ie(Qe,De))};for(const Qe of Fe.children)Qe.parent=Fe;return Fe};function me(j){const De=[],Fe=new Map;for(const Qe of j.items)Fe.set(Qe.item.extId,Qe),j.request.targets.some(Ye=>Ye.controllerId===Qe.controllerId&&Ye.testIds.includes(Qe.item.extId))&&De.push(Qe);return{completedAt:j.completedAt,results:De.map(Qe=>Ie(Qe,Fe))}}Ee.to=me})(ot=e.TestResults||(e.TestResults={}));var ct;(function(Ee){function Ie(Fe){return{covered:Fe.covered,total:Fe.covered}}function me(Fe){return"line"in Fe?o.from(Fe):a.from(Fe)}function j(Fe){return"branches"in Fe?{count:Fe.executionCount,location:me(Fe.location),type:1,branches:Fe.branches.length?Fe.branches.map(Qe=>({count:Qe.executionCount,location:Qe.location&&me(Qe.location)})):void 0}:{type:0,count:Fe.executionCount,location:me(Fe.location)}}Ee.fromDetailed=j;function De(Fe){return{uri:Fe.uri,statement:Ie(Fe.statementCoverage),branch:Fe.branchCoverage&&Ie(Fe.branchCoverage),function:Fe.functionCoverage&&Ie(Fe.functionCoverage),details:Fe.detailedCoverage?.map(j)}}Ee.fromFile=De})(ct=e.TestCoverage||(e.TestCoverage={}));var ft;(function(Ee){function Ie(me){switch(me){case 1:return l.CodeActionTriggerKind.Invoke;case 2:return l.CodeActionTriggerKind.Automatic}}Ee.to=Ie})(ft=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var _t;(function(Ee){function Ie(j){const De=new l.TypeHierarchyItem(W.to(j.kind),j.name,j.detail||"",T.URI.revive(j.uri),a.to(j.range),a.to(j.selectionRange));return De._sessionId=j._sessionId,De._itemId=j._itemId,De}Ee.to=Ie;function me(j,De,Fe){if(De=De??j._sessionId,Fe=Fe??j._itemId,De===void 0||Fe===void 0)throw new Error("invalid item");return{_sessionId:De,_itemId:Fe,kind:W.from(j.kind),name:j.name,detail:j.detail??"",uri:j.uri,range:a.from(j.range),selectionRange:a.from(j.selectionRange),tags:j.tags?.map(re.from)}}Ee.from=me})(_t=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Lt;(function(Ee){function Ie(me){if(!!me)return{value:me.value,tooltip:me.tooltip}}Ee.from=Ie})(Lt=e.ViewBadge||(e.ViewBadge={}));var Tt;(function(Ee){function Ie(me,j){const De=me.fileData;return De?new class extends l.DataTransferItem{asFile(){return{name:De.name,uri:T.URI.revive(De.uri),data:(0,f.once)(()=>j())}}}(""):new l.DataTransferItem(me.asString)}Ee.toDataTransferItem=Ie})(Tt=e.DataTransferItem||(e.DataTransferItem={}));var Ft;(function(Ee){function Ie(j,De){const Fe=j.items.map(([Qe,Ye],xe)=>[Qe,Tt.toDataTransferItem(Ye,()=>De(xe))]);return new l.DataTransfer(Fe)}Ee.toDataTransfer=Ie;async function me(j){const De={items:[]},Fe=[];return j.forEach((Qe,Ye)=>{Fe.push((async()=>{const xe=await Qe.asString(),st=Qe.asFile();De.items.push([Ye,{asString:xe,fileData:st?{name:st.name,uri:st.uri}:void 0}])})())}),await Promise.all(Fe),De}Ee.toDataTransferDTO=me})(Ft=e.DataTransfer||(e.DataTransfer={}))}),define(ve[249],we([0,1,50,120,80,119,81,122,4]),function(oe,e,I,t,v,P,k,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const D=(h,l,f,i)=>{let a=l;return{enumerable:!0,configurable:!1,get(){return a},set(n){if(!f(a,n)){const o=a;a=n,h.listener?.(i(n,o))}}}},T=(h,l)=>h===l,R={range:(h,l)=>h===l?!0:!h||!l?!1:h.isEqual(l),label:T,description:T,sortText:T,busy:T,error:T,canResolveChildren:T,tags:(h,l)=>!(h.length!==l.length||h.some(f=>!l.find(i=>f.id===i.id)))},E=h=>l=>({op:4,update:h(l)}),b=(h,l)=>({range:D(h,void 0,R.range,E(f=>({range:I.Range.lift(w.Range.from(f))}))),label:D(h,l,R.label,E(f=>({label:f}))),description:D(h,void 0,R.description,E(f=>({description:f}))),sortText:D(h,void 0,R.sortText,E(f=>({sortText:f}))),canResolveChildren:D(h,!1,R.canResolveChildren,f=>({op:2,state:f})),busy:D(h,!1,R.busy,E(f=>({busy:f}))),error:D(h,void 0,R.error,E(f=>({error:w.MarkdownString.fromStrict(f)||null}))),tags:D(h,[],R.tags,(f,i)=>({op:1,new:f.map(w.TestTag.from),old:i.map(w.TestTag.from)}))}),d=h=>{const l=v.TestId.fromString(h.extId),f=new y(l.controllerId,l.localId,h.label,p.URI.revive(h.uri)||void 0);return f.range=w.Range.to(h.range||void 0),f.description=h.description||void 0,f.sortText=h.sortText||void 0,f.tags=h.tags.map(i=>w.TestTag.to({id:(0,k.denamespaceTestTag)(i).tagId})),f},C=h=>{let l;for(const f of h.tests){const i=d(f.item);(0,t.getPrivateApiFor)(i).parent=l,l=i}return l};e.toItemFromContext=C;class y{constructor(l,f,i,a){if(f.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(f)} symbol`);const n=(0,t.createPrivateApiFor)(this,l);Object.defineProperties(this,{id:{value:f,enumerable:!0,writable:!1},uri:{value:a,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return n.parent instanceof m?void 0:n.parent}},children:{value:(0,P.createTestItemChildren)(n,t.getPrivateApiFor,y),enumerable:!0,writable:!1},...b(n,i)})}}e.TestItemImpl=y;class m extends y{constructor(l,f){super(l,l,f,void 0)}}e.TestItemRootImpl=m;class g extends P.TestItemCollection{constructor(l,f){super({controllerId:l,getApiFor:t.getPrivateApiFor,getChildren:i=>i.children,root:new m(l,f),toITestItem:w.TestItem.from})}}e.ExtHostTestItemCollection=g}),define(ve[250],we([0,1,12,245,13,104,111,118,246,116,121,10,203,117]),function(oe,e,I,t,v,P,k,w,p,D,T,R,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannelClient=e.REMOTE_TERMINAL_CHANNEL_NAME=void 0,e.REMOTE_TERMINAL_CHANNEL_NAME="remoteterminal";let d=class{constructor(y,m,g,h,l,f,i,a,n,o){this._remoteAuthority=y,this._channel=m,this._configurationService=g,this._workspaceContextService=h,this._resolverService=l,this._environmentVariableService=f,this._remoteAuthorityResolverService=i,this._logService=a,this._editorService=n,this._labelService=o}get onPtyHostExit(){return this._channel.listen("$onPtyHostExitEvent")}get onPtyHostStart(){return this._channel.listen("$onPtyHostStartEvent")}get onPtyHostUnresponsive(){return this._channel.listen("$onPtyHostUnresponsiveEvent")}get onPtyHostResponsive(){return this._channel.listen("$onPtyHostResponsiveEvent")}get onPtyHostRequestResolveVariables(){return this._channel.listen("$onPtyHostRequestResolveVariablesEvent")}get onProcessData(){return this._channel.listen("$onProcessDataEvent")}get onProcessExit(){return this._channel.listen("$onProcessExitEvent")}get onProcessReady(){return this._channel.listen("$onProcessReadyEvent")}get onProcessReplay(){return this._channel.listen("$onProcessReplayEvent")}get onProcessOrphanQuestion(){return this._channel.listen("$onProcessOrphanQuestion")}get onExecuteCommand(){return this._channel.listen("$onExecuteCommand")}get onDidRequestDetach(){return this._channel.listen("$onDidRequestDetach")}get onDidChangeProperty(){return this._channel.listen("$onDidChangeProperty")}restartPtyHost(){return this._channel.call("$restartPtyHost",[])}async createProcess(y,m,g,h,l,f,i,a){await this._configurationService.whenRemoteConfigurationLoaded();const n=Object.create(null),o=g?(0,I.withNullAsUndefined)(this._workspaceContextService.getWorkspaceFolder(g)):void 0;let r;try{r=(await this._resolverService.resolveAnyMap(o,{shellLaunchConfig:y,configuration:m})).resolvedVariables}catch(_){this._logService.error(_)}if(r)for(const[_,q]of r.entries())(/^config:/.test(_)||_==="selectedText"||_==="lineNumber")&&(n[_]=q);const s=[];for(const[_,q]of this._environmentVariableService.collections.entries())s.push([_,(0,w.serializeEnvironmentVariableCollection)(q.map)]);const c=await this._remoteAuthorityResolverService.resolveAuthority(this._remoteAuthority),u=c.options&&c.options.extensionHostEnv,S=this._workspaceContextService.getWorkspace(),A=S.folders,M=g?this._workspaceContextService.getWorkspaceFolder(g):null,$=D.EditorResourceAccessor.getOriginalUri(this._editorService.activeEditor,{supportSideBySide:D.SideBySideEditor.PRIMARY,filterByScheme:[R.Schemas.file,R.Schemas.vscodeUserData,R.Schemas.vscodeRemote]}),Q={configuration:m,resolvedVariables:n,envVariableCollections:s,shellLaunchConfig:y,workspaceId:S.id,workspaceName:this._labelService.getWorkspaceLabel(S),workspaceFolders:A,activeWorkspaceFolder:M,activeFileResource:$,shouldPersistTerminal:l,options:h,cols:f,rows:i,unicodeVersion:a,resolverEnv:u};return await this._channel.call("$createProcess",Q)}requestDetachInstance(y,m){return this._channel.call("$requestDetachInstance",[y,m])}acceptDetachInstanceReply(y,m){return this._channel.call("$acceptDetachInstanceReply",[y,m])}attachToProcess(y){return this._channel.call("$attachToProcess",[y])}detachFromProcess(y){return this._channel.call("$detachFromProcess",[y])}listProcesses(){return this._channel.call("$listProcesses")}reduceConnectionGraceTime(){return this._channel.call("$reduceConnectionGraceTime")}processBinary(y,m){return this._channel.call("$processBinary",[y,m])}start(y){return this._channel.call("$start",[y])}input(y,m){return this._channel.call("$input",[y,m])}acknowledgeDataEvent(y,m){return this._channel.call("$acknowledgeDataEvent",[y,m])}setUnicodeVersion(y,m){return this._channel.call("$setUnicodeVersion",[y,m])}shutdown(y,m){return this._channel.call("$shutdown",[y,m])}resize(y,m,g){return this._channel.call("$resize",[y,m,g])}getInitialCwd(y){return this._channel.call("$getInitialCwd",[y])}getCwd(y){return this._channel.call("$getCwd",[y])}orphanQuestionReply(y){return this._channel.call("$orphanQuestionReply",[y])}sendCommandResult(y,m,g){return this._channel.call("$sendCommandResult",[y,m,g])}installAutoReply(y,m){return this._channel.call("$installAutoReply",[y,m])}uninstallAllAutoReplies(){return this._channel.call("$uninstallAllAutoReplies",[])}getDefaultSystemShell(y){return this._channel.call("$getDefaultSystemShell",[y])}getProfiles(y,m,g){return this._channel.call("$getProfiles",[this._workspaceContextService.getWorkspace().id,y,m,g])}acceptPtyHostResolvedVariables(y,m){return this._channel.call("$acceptPtyHostResolvedVariables",[y,m])}getEnvironment(){return this._channel.call("$getEnvironment")}getWslPath(y){return this._channel.call("$getWslPath",[y])}setTerminalLayoutInfo(y){const g={workspaceId:this._workspaceContextService.getWorkspace().id,tabs:y?y.tabs:[]};return this._channel.call("$setTerminalLayoutInfo",g)}updateTitle(y,m,g){return this._channel.call("$updateTitle",[y,m,g])}updateIcon(y,m,g){return this._channel.call("$updateIcon",[y,m,g])}refreshProperty(y,m){return this._channel.call("$refreshProperty",[y,m])}updateProperty(y,m,g){return this._channel.call("$updateProperty",[y,m,g])}getTerminalLayoutInfo(){const m={workspaceId:this._workspaceContextService.getWorkspace().id};return this._channel.call("$getTerminalLayoutInfo",m)}reviveTerminalProcesses(y,m){return this._channel.call("$reviveTerminalProcesses",[y,m])}serializeTerminalState(y){return this._channel.call("$serializeTerminalState",[y])}};d=Re([_e(2,t.IWorkbenchConfigurationService),_e(3,k.IWorkspaceContextService),_e(4,p.IConfigurationResolverService),_e(5,b.IEnvironmentVariableService),_e(6,P.IRemoteAuthorityResolverService),_e(7,v.ILogService),_e(8,T.IEditorService),_e(9,E.ILabelService)],d),e.RemoteTerminalChannelClient=d}),define(ve[251],we([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var I;(function(T){T[T.IPC=1]="IPC",T[T.Socket=2]="Socket",T[T.MessagePort=3]="MessagePort"})(I=e.ExtHostConnectionType||(e.ExtHostConnectionType={}));class t{constructor(R){this.pipeName=R,this.type=1}serialize(R){R[t.ENV_KEY]=this.pipeName}}e.IPCExtHostConnection=t,t.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class v{constructor(){this.type=2}serialize(R){R[v.ENV_KEY]="1"}}e.SocketExtHostConnection=v,v.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class P{constructor(){this.type=3}serialize(R){R[P.ENV_KEY]="1"}}e.MessagePortExtHostConnection=P,P.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function k(T){delete T[t.ENV_KEY],delete T[v.ENV_KEY],delete T[P.ENV_KEY]}function w(T,R){k(R),T.serialize(R)}e.writeExtHostConnection=w;function p(T){if(T[t.ENV_KEY])return D(T,new t(T[t.ENV_KEY]));if(T[v.ENV_KEY])return D(T,new v);if(T[P.ENV_KEY])return D(T,new P);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=p;function D(T,R){return k(T),R}}),define(ve[252],we([0,1,38,184,51]),function(oe,e,I,t,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.dedupExtensions=void 0;function P(k,w,p,D){const T=new Map;k.forEach(E=>{const b=I.ExtensionIdentifier.toKey(E.identifier),d=T.get(b);d&&D.warn((0,t.localize)(0,null,d.extensionLocation.fsPath,E.extensionLocation.fsPath)),T.set(b,E)}),w.forEach(E=>{const b=I.ExtensionIdentifier.toKey(E.identifier),d=T.get(b);if(d)if(d.isBuiltin){if(v.gte(d.version,E.version)){D.warn(`Skipping extension ${E.extensionLocation.path} in favour of the builtin extension ${d.extensionLocation.path}.`);return}E.isBuiltin=!0}else D.warn((0,t.localize)(1,null,d.extensionLocation.fsPath,E.extensionLocation.fsPath));else if(E.isBuiltin){D.warn(`Skipping obsolete builtin extension ${E.extensionLocation.path}`);return}T.set(b,E)}),p.forEach(E=>{D.info((0,t.localize)(2,null,E.extensionLocation.fsPath));const b=I.ExtensionIdentifier.toKey(E.identifier),d=T.get(b);d&&d.isBuiltin&&(E.isBuiltin=!0),T.set(b,E)});const R=[];return T.forEach(E=>R.push(E)),R}e.dedupExtensions=P}),define(ve[253],we([0,1,3,49,4,62,10,70,96,91,219,5,28,55,252]),function(oe,e,I,t,v,P,k,w,p,D,T,R,E,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentEnvironmentChannel=void 0;class C{constructor(m,g,h,l,f,i,a){if(this._connectionToken=m,this._environmentService=g,this._userDataProfilesService=h,this._logService=f,this._extensionHostStatusService=i,this._extensionsScannerService=a,g.args["install-builtin-extension"]){const o={isMachineScoped:!!g.args["do-not-sync"],installPreReleaseVersion:!!g.args["pre-release"]};this.whenExtensionsReady=l.installExtensions([],g.args["install-builtin-extension"],o,!!g.args.force).then(null,r=>{f.error(r)})}else this.whenExtensionsReady=Promise.resolve();const n=g.args["install-extension"];if(n){const o=n.map(r=>/\.vsix$/i.test(r)?v.URI.file((0,R.isAbsolute)(r)?r:(0,R.join)((0,E.cwd)(),r)):r);this.whenExtensionsReady.then(()=>l.installExtensions(o,[],{isMachineScoped:!!g.args["do-not-sync"],installPreReleaseVersion:!!g.args["pre-release"]},!!g.args.force)).then(null,r=>{f.error(r)})}}async call(m,g,h){switch(g){case"getEnvironmentData":{const l=h,f=(0,P.createURITransformer)(l.remoteAuthority);let i=await this._getEnvironmentData();return i=(0,w.transformOutgoingURIs)(i,f),i}case"getExtensionHostExitInfo":{const l=h;return this._extensionHostStatusService.getExitInfo(l.reconnectionToken)}case"whenExtensionsReady":{await this.whenExtensionsReady;return}case"scanExtensions":{await this.whenExtensionsReady;const l=h,f=l.language;this._logService.trace(`Scanning extensions using UI language: ${f}`);const i=(0,P.createURITransformer)(l.remoteAuthority),a=l.extensionDevelopmentPath&&l.extensionDevelopmentPath.map(r=>v.URI.revive(i.transformIncoming(r))),n=a?a.filter(r=>r.scheme===k.Schemas.file).map(r=>r.fsPath):void 0;let o=await this._scanExtensions(f,n);return o=(0,w.transformOutgoingURIs)(o,i),this._logService.trace("Scanned Extensions",o),C._massageWhenConditions(o),o}case"scanSingleExtension":{await this.whenExtensionsReady;const l=h,f=l.language,i=l.isBuiltin,a=(0,P.createURITransformer)(l.remoteAuthority),n=v.URI.revive(a.transformIncoming(l.extensionLocation)),o=n.scheme===k.Schemas.file?n.fsPath:null;if(!o)return null;let r=await this._scanSingleExtension(o,i,f);return r?(r=(0,w.transformOutgoingURIs)(r,a),C._massageWhenConditions([r]),r):null}case"getDiagnosticInfo":{const l=h,f={machineInfo:(0,T.getMachineInfo)()},i=l.includeProcesses?(0,D.listProcesses)(process.pid):Promise.resolve();let a=[];const n={};if(l.folders){const o=(0,P.createURITransformer)("");a=l.folders.map(s=>v.URI.revive(o.transformIncoming(s))).filter(s=>s.scheme==="file").map(s=>(0,T.collectWorkspaceStats)(s.fsPath,["node_modules",".git"]).then(c=>{n[(0,R.basename)(s.fsPath)]=c}))}return Promise.all([i,...a]).then(([o,r])=>(f.processes=o||void 0,f.workspaceMetadata=l.folders?n:void 0,f))}}throw new Error(`IPC Command ${g} not found`)}listen(m,g,h){throw new Error("Not supported")}static _massageWhenConditions(m){const g=(n,o)=>n.replace(/file/g,"vscode-remote"),h=n=>{let o="";return o+=n.global?"g":"",o+=n.ignoreCase?"i":"",o+=n.multiline?"m":"",new RegExp(g(n.source,!0),o)},l=new class{mapDefined(n){return p.ContextKeyDefinedExpr.create(n)}mapNot(n){return p.ContextKeyNotExpr.create(n)}mapEquals(n,o){return n==="resourceScheme"&&typeof o=="string"?p.ContextKeyEqualsExpr.create(n,g(o,!1)):p.ContextKeyEqualsExpr.create(n,o)}mapNotEquals(n,o){return n==="resourceScheme"&&typeof o=="string"?p.ContextKeyNotEqualsExpr.create(n,g(o,!1)):p.ContextKeyNotEqualsExpr.create(n,o)}mapGreater(n,o){return p.ContextKeyGreaterExpr.create(n,o)}mapGreaterEquals(n,o){return p.ContextKeyGreaterEqualsExpr.create(n,o)}mapSmaller(n,o){return p.ContextKeySmallerExpr.create(n,o)}mapSmallerEquals(n,o){return p.ContextKeySmallerEqualsExpr.create(n,o)}mapRegex(n,o){return n==="resourceScheme"&&o?p.ContextKeyRegexExpr.create(n,h(o)):p.ContextKeyRegexExpr.create(n,o)}mapIn(n,o){return p.ContextKeyInExpr.create(n,o)}},f=n=>{if(!n||!n.when||!/resourceScheme/.test(n.when))return;const o=p.ContextKeyExpr.deserialize(n.when);if(!o)return;const r=o.map(l);n.when=r.serialize()},i=n=>{if(Array.isArray(n))for(const o of n)f(o);else f(n)},a=n=>{for(const o in n)i(n[o])};m.forEach(n=>{n.contributes&&(n.contributes.menus&&a(n.contributes.menus),n.contributes.keybindings&&i(n.contributes.keybindings),n.contributes.views&&a(n.contributes.views))})}async _getEnvironmentData(){return{pid:process.pid,connectionToken:this._connectionToken.type!==0?this._connectionToken.value:"",appRoot:v.URI.file(this._environmentService.appRoot),settingsPath:this._environmentService.machineSettingsResource,logsPath:v.URI.file(this._environmentService.logsPath),extensionsPath:v.URI.file(this._environmentService.extensionsPath),extensionHostLogsPath:v.URI.file((0,R.join)(this._environmentService.logsPath,`exthost${C._namePool++}`)),globalStorageHome:this._userDataProfilesService.defaultProfile.globalStorageHome,workspaceStorageHome:this._environmentService.workspaceStorageHome,localHistoryHome:this._environmentService.localHistoryHome,userHome:this._environmentService.userHome,os:I.OS,arch:process.arch,marks:t.getMarks(),useHostProxy:!!this._environmentService.args["use-host-proxy"]}}async _scanExtensions(m,g){const[h,l,f]=await Promise.all([this._scanBuiltinExtensions(m),this._scanInstalledExtensions(m),this._scanDevelopedExtensions(m,g)]);return(0,d.dedupExtensions)(h,l,f,this._logService)}async _scanDevelopedExtensions(m,g){return g?(await Promise.all(g.map(h=>this._extensionsScannerService.scanOneOrMultipleExtensions(v.URI.file((0,R.resolve)(h)),1,{language:m})))).flat().map(h=>(0,b.toExtensionDescription)(h,!0)):[]}async _scanBuiltinExtensions(m){return(await this._extensionsScannerService.scanSystemExtensions({language:m,useCache:!0})).map(h=>(0,b.toExtensionDescription)(h,!1))}async _scanInstalledExtensions(m){return(await this._extensionsScannerService.scanUserExtensions({language:m,useCache:!0})).map(h=>(0,b.toExtensionDescription)(h,!1))}async _scanSingleExtension(m,g,h){const l=v.URI.file((0,R.resolve)(m)),f=g?0:1,i=await this._extensionsScannerService.scanExistingExtension(l,f,{language:h});return i?(0,b.toExtensionDescription)(i,!1):null}}e.RemoteAgentEnvironmentChannel=C,C._namePool=1}),define(ve[123],we([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class I{constructor(p){this._proxyIdentifierBrand=void 0,this.sid=p,this.nid=++I.count}}e.ProxyIdentifier=I,I.count=0;const t=[];function v(w){const p=new I(w);return t[p.nid]=p,p}e.createProxyIdentifier=v;function P(w){return t[w].sid}e.getStringIdentifierForProxy=P;class k{constructor(p){this.value=p}}e.SerializableObjectWithBuffers=k}),define(ve[254],we([0,1,41,4,123]),function(oe,e,I,t,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var P;(function(h){h[h.Default=0]="Default",h[h.InCenter=1]="InCenter",h[h.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",h[h.AtTop=3]="AtTop"})(P=e.TextEditorRevealType||(e.TextEditorRevealType={}));var k;(function(h){h[h.UnknownInput=0]="UnknownInput",h[h.TextInput=1]="TextInput",h[h.TextDiffInput=2]="TextDiffInput",h[h.NotebookInput=3]="NotebookInput",h[h.NotebookDiffInput=4]="NotebookDiffInput",h[h.CustomEditorInput=5]="CustomEditorInput",h[h.WebviewEditorInput=6]="WebviewEditorInput",h[h.TerminalEditorInput=7]="TerminalEditorInput"})(k=e.TabInputKind||(e.TabInputKind={}));var w;(function(h){h[h.TAB_OPEN=0]="TAB_OPEN",h[h.TAB_CLOSE=1]="TAB_CLOSE",h[h.TAB_UPDATE=2]="TAB_UPDATE",h[h.TAB_MOVE=3]="TAB_MOVE"})(w=e.TabModelOperationKind||(e.TabModelOperationKind={}));var p;(function(h){h[h.Editable=0]="Editable",h[h.SupportsHotExit=1]="SupportsHotExit"})(p=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var D;(function(h){h[h.Int8Array=1]="Int8Array",h[h.Uint8Array=2]="Uint8Array",h[h.Uint8ClampedArray=3]="Uint8ClampedArray",h[h.Int16Array=4]="Int16Array",h[h.Uint16Array=5]="Uint16Array",h[h.Int32Array=6]="Int32Array",h[h.Uint32Array=7]="Uint32Array",h[h.Float32Array=8]="Float32Array",h[h.Float64Array=9]="Float64Array",h[h.BigInt64Array=10]="BigInt64Array",h[h.BigUint64Array=11]="BigUint64Array"})(D=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var T;(function(h){h[h.Text=1]="Text",h[h.Error=2]="Error",h[h.Rich=3]="Rich"})(T=e.CellOutputKind||(e.CellOutputKind={}));var R;(function(h){h[h.Default=0]="Default",h[h.InCenter=1]="InCenter",h[h.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",h[h.AtTop=3]="AtTop"})(R=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var E;(function(h){h[h.None=0]="None",h[h.Process=1]="Process",h[h.Output=2]="Output"})(E=e.CandidatePortSource||(e.CandidatePortSource={}));class b{static mixin(l){return l._id=b._n++,l}}e.IdObject=b,b._n=0;var d;(function(h){h.label="a",h.kind="b",h.detail="c",h.documentation="d",h.sortText="e",h.filterText="f",h.preselect="g",h.insertText="h",h.insertTextRules="i",h.range="j",h.commitCharacters="k",h.additionalTextEdits="l",h.command="m",h.kindModifier="n"})(d=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var C;(function(h){h.defaultRanges="a",h.completions="b",h.isIncomplete="c",h.duration="d"})(C=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var y;(function(h){h[h.File=1]="File",h[h.Text=2]="Text",h[h.Cell=3]="Cell"})(y=e.WorkspaceEditType||(e.WorkspaceEditType={}));function m(h){if(h&&h.edits)for(const l of h.edits)typeof l.resource=="object"?l.resource=t.URI.revive(l.resource):(l.newUri=t.URI.revive(l.newUri),l.oldUri=t.URI.revive(l.oldUri)),l.metadata&&l.metadata.iconPath&&(l.metadata=(0,I.revive)(l.metadata));return h}e.reviveWorkspaceEditDto=m;var g;(function(h){h[h.Workspace=0]="Workspace",h[h.TextDocument=1]="TextDocument"})(g=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,v.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,v.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,v.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,v.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,v.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,v.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,v.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,v.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,v.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,v.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,v.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,v.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,v.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,v.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,v.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,v.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,v.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,v.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,v.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,v.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,v.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,v.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,v.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,v.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,v.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,v.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,v.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,v.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,v.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,v.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,v.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,v.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,v.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,v.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,v.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,v.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,v.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,v.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,v.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,v.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,v.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,v.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,v.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,v.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,v.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,v.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,v.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,v.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,v.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,v.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,v.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,v.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,v.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,v.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,v.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,v.createProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,v.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,v.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,v.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,v.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,v.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,v.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,v.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,v.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,v.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,v.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,v.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,v.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,v.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,v.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,v.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,v.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,v.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,v.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,v.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,v.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,v.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,v.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,v.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,v.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,v.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,v.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,v.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,v.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,v.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,v.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,v.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,v.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,v.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,v.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,v.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,v.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,v.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,v.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,v.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,v.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,v.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,v.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,v.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,v.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,v.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,v.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,v.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,v.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,v.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,v.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,v.createProxyIdentifier)("ExtHostTelemetry")}});var Dt=this&&this.__classPrivateFieldSet||function(oe,e,I,t,v){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!v)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!v:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?v.call(oe,I):v?v.value=I:e.set(oe,I),I},tt=this&&this.__classPrivateFieldGet||function(oe,e,I,t){if(I==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!t:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return I==="m"?t:I==="a"?t.call(oe):t?t.value:e.get(oe)};define(ve[255],we([0,1,12,115,122,22,254,18,13,41,50,84,4,2,6,240,249,16,123,37]),function(oe,e,I,t,v,P,k,w,p,D,T,R,E,b,d,C,y,m,g,h){"use strict";var l,f;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let i=class{constructor(c,u){l.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,f.set(this,void 0),Dt(this,l,c.getProxy(k.MainContext.MainThreadCommands),"f"),this._logService=u,Dt(this,f,c.getProxy(k.MainContext.MainThreadTelemetry),"f"),this.converter=new a(this,S=>{const A=this._apiCommands.get(S);return A?.result===o.Void?A:void 0},u),this._argumentProcessors=[{processArgument(S){return(0,D.revive)(S)}},{processArgument(S){return(0,P.cloneAndChange)(S,function(A){if(T.Range.isIRange(A))return v.Range.to(A);if(R.Position.isIPosition(A))return v.Position.to(A);if(T.Range.isIRange(A.range)&&E.URI.isUri(A.uri))return v.location.to(A);if(A instanceof m.VSBuffer)return A.buffer.buffer;if(!Array.isArray(A))return A})}}]}registerArgumentProcessor(c){this._argumentProcessors.push(c)}registerApiCommand(c){const u=this.registerCommand(!1,c.id,async(...S)=>{const A=c.args.map(($,Q)=>{if(!$.validate(S[Q]))throw new Error(`Invalid argument '${$.name}' when running '${c.id}', received: ${S[Q]}`);return $.convert(S[Q])}),M=await this.executeCommand(c.internalId,...A);return c.result.convert(M,S,this.converter)},void 0,{description:c.description,args:c.args,returns:c.result.description});return this._apiCommands.set(c.id,c),new t.Disposable(()=>{u.dispose(),this._apiCommands.delete(c.id)})}registerCommand(c,u,S,A,M,$){if(this._logService.trace("ExtHostCommands#registerCommand",u),!u.trim().length)throw new Error("invalid id");if(this._commands.has(u))throw new Error(`command '${u}' already exists`);return this._commands.set(u,{callback:S,thisArg:A,description:M,extension:$}),c&&tt(this,l,"f").$registerCommand(u),new t.Disposable(()=>{this._commands.delete(u)&&c&&tt(this,l,"f").$unregisterCommand(u)})}executeCommand(c,...u){return this._logService.trace("ExtHostCommands#executeCommand",c),this._doExecuteCommand(c,u,!0)}async _doExecuteCommand(c,u,S){if(this._commands.has(c))return tt(this,l,"f").$fireCommandActivationEvent(c),this._executeContributedCommand(c,u,!1);{let A=!1;const M=(0,P.cloneAndChange)(u,function($){if($ instanceof t.Position)return v.Position.from($);if($ instanceof t.Range)return v.Range.from($);if($ instanceof t.Location)return v.location.from($);if(t.NotebookRange.isNotebookRange($))return v.NotebookRange.from($);if($ instanceof ArrayBuffer)return A=!0,m.VSBuffer.wrap(new Uint8Array($));if($ instanceof Uint8Array)return A=!0,m.VSBuffer.wrap($);if($ instanceof m.VSBuffer)return A=!0,$;if(!Array.isArray($))return $});try{const $=await tt(this,l,"f").$executeCommand(c,A?new g.SerializableObjectWithBuffers(M):M,S);return(0,D.revive)($)}catch($){if($ instanceof Error&&$.message==="$executeCommand:retry")return this._doExecuteCommand(c,u,!1);throw $}}}async _executeContributedCommand(c,u,S){const A=this._commands.get(c);if(!A)throw new Error("Unknown command");this._reportTelemetry(A,c);const{callback:M,thisArg:$,description:Q}=A;if(Q)for(let _=0;_<Q.args.length;_++)try{(0,I.validateConstraint)(u[_],Q.args[_].constraint)}catch{throw new Error(`Running the contributed command: '${c}' failed. Illegal argument '${Q.args[_].name}' - ${Q.args[_].description}`)}try{return await M.apply($,u)}catch(_){if(c===this.converter.delegatingCommandId){const q=this.converter.getActualCommand(...u);q&&(c=q.command)}throw this._logService.error(_,c,A.extension?.identifier),S?new class extends Error{constructor(){super((0,h.toErrorMessage)(_));this.id=c,this.source=A.extension?.displayName??A.extension?.name}}:_}}_reportTelemetry(c,u){!c.extension||c.extension.isBuiltin||tt(this,f,"f").$publicLog2("Extension:ActionExecuted",{extensionId:c.extension.identifier.value,id:u})}$executeContributedCommand(c,...u){return this._logService.trace("ExtHostCommands#$executeContributedCommand",c),this._commands.has(c)?(u=u.map(S=>this._argumentProcessors.reduce((A,M)=>M.processArgument(A),S)),this._executeContributedCommand(c,u,!0)):Promise.reject(new Error(`Contributed command '${c}' does not exist.`))}getCommands(c=!1){return this._logService.trace("ExtHostCommands#getCommands",c),tt(this,l,"f").$getCommands().then(u=>(c&&(u=u.filter(S=>S[0]!=="_")),u))}$getContributedCommandHandlerDescriptions(){const c=Object.create(null);for(const[u,S]of this._commands){const{description:A}=S;A&&(c[u]=A)}return Promise.resolve(c)}};l=new WeakMap,f=new WeakMap,i=Re([_e(0,C.IExtHostRpcService),_e(1,p.ILogService)],i),e.ExtHostCommands=i,e.IExtHostCommands=(0,d.createDecorator)("IExtHostCommands");class a{constructor(c,u,S){this._commands=c,this._lookupApiCommand=u,this._logService=S,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(c,u){if(!c)return;const S={$ident:void 0,id:c.command,title:c.title,tooltip:c.tooltip};if(!c.command)return S;const A=this._lookupApiCommand(c.command);if(A)S.id=A.internalId,S.arguments=A.args.map((M,$)=>M.convert(c.arguments&&c.arguments[$]));else if((0,w.isNonEmptyArray)(c.arguments)){const M=++this._cachIdPool;this._cache.set(M,c),u.add((0,b.toDisposable)(()=>{this._cache.delete(M),this._logService.trace("CommandsConverter#DISPOSE",M)})),S.$ident=M,S.id=this.delegatingCommandId,S.arguments=[M],this._logService.trace("CommandsConverter#CREATE",c.command,M)}return S}fromInternal(c){return typeof c.$ident=="number"?this._cache.get(c.$ident):{command:c.id,title:c.title,arguments:c.arguments}}getActualCommand(...c){return this._cache.get(c[0])}_executeConvertedCommand(...c){const u=this.getActualCommand(...c);return this._logService.trace("CommandsConverter#EXECUTE",c[0],u?u.command:"MISSING"),u?this._commands.executeCommand(u.command,...u.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=a;class n{constructor(c,u,S,A){this.name=c,this.description=u,this.validate=S,this.convert=A}optional(){return new n(this.name,`(optional) ${this.description}`,c=>c==null||this.validate(c),c=>c===void 0?void 0:c===null?null:this.convert(c))}with(c,u){return new n(c??this.name,u??this.description,this.validate,this.convert)}}e.ApiCommandArgument=n,n.Uri=new n("uri","Uri of a text document",s=>E.URI.isUri(s),s=>s),n.Position=new n("position","A position in a text document",s=>t.Position.isPosition(s),v.Position.from),n.Range=new n("range","A range in a text document",s=>t.Range.isRange(s),v.Range.from),n.Selection=new n("selection","A selection in a text document",s=>t.Selection.isSelection(s),v.Selection.from),n.Number=new n("number","",s=>typeof s=="number",s=>s),n.String=new n("string","",s=>typeof s=="string",s=>s),n.CallHierarchyItem=new n("item","A call hierarchy item",s=>s instanceof t.CallHierarchyItem,v.CallHierarchyItem.from),n.TypeHierarchyItem=new n("item","A type hierarchy item",s=>s instanceof t.TypeHierarchyItem,v.TypeHierarchyItem.from),n.TestItem=new n("testItem","A VS Code TestItem",s=>s instanceof y.TestItemImpl,v.TestItem.from);class o{constructor(c,u){this.description=c,this.convert=u}}e.ApiCommandResult=o,o.Void=new o("no result",s=>s);class r{constructor(c,u,S,A,M){this.id=c,this.internalId=u,this.description=S,this.args=A,this.result=M}}e.ApiCommand=r}),define(ve[124],we([0,1,6]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,I.createDecorator)("remoteAgentService")}),define(ve[256],we([0,1,11,2,10,198]),function(oe,e,I,t,v,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteFileSystemProviderClient=e.REMOTE_FILE_SYSTEM_CHANNEL_NAME=void 0,e.REMOTE_FILE_SYSTEM_CHANNEL_NAME="remoteFilesystem";class k extends P.DiskFileSystemProviderClient{static register(p,D,T){const R=p.getConnection();if(!R)return t.Disposable.None;const E=new t.DisposableStore,b=(async()=>{try{const d=await p.getRawEnvironment();d?D.registerProvider(v.Schemas.vscodeRemote,E.add(new k(d,R))):T.error("Cannot register remote filesystem provider. Remote environment doesnot exist.")}catch(d){T.error("Cannot register remote filesystem provider. Error while fetching remote environment.",(0,I.getErrorMessage)(d))}})();return E.add(D.onWillActivateFileSystemProvider(d=>{d.scheme===v.Schemas.vscodeRemote&&d.join(b)})),E}constructor(p,D){super(D.getChannel(e.REMOTE_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:p.os===3})}}e.RemoteFileSystemProviderClient=k}),define(ve[125],we([0,1,30,14,5,12,21,157,270,271]),function(oe,e,I,t,v,P,k,w,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class T extends Error{constructor(i,a){let n=a.message;switch(i){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n);this.type=i,this.cause=a}}e.ExtractError=T;function R(f){const i=f.externalFileAttributes>>16||33188;return[448,56,7].map(a=>i&a).reduce((a,n)=>a+n,i&61440)}function E(f){if(f instanceof T)return f;let i;return/end of central directory record signature not found/.test(f.message)&&(i="CorruptZip"),new T(i,f)}function b(f,i,a,n,o,r){const s=v.dirname(i),c=v.join(n,s);if(!c.startsWith(n))return Promise.reject(new Error(w.localize(0,null,i)));const u=v.join(n,i);let S;return r.onCancellationRequested(()=>{S&&S.destroy()}),Promise.resolve(k.Promises.mkdir(c,{recursive:!0})).then(()=>new Promise((A,M)=>{if(!r.isCancellationRequested)try{S=(0,I.createWriteStream)(u,{mode:a}),S.once("close",()=>A()),S.once("error",M),f.once("error",M),f.pipe(S)}catch($){M($)}}))}function d(f,i,a,n){let o=(0,t.createCancelablePromise)(()=>Promise.resolve()),r=0;return n.onCancellationRequested(()=>{o.cancel(),f.close()}),new Promise((s,c)=>{const u=new t.Sequencer,S=A=>{A.isCancellationRequested||(r++,f.readEntry())};f.once("error",c),f.once("close",()=>o.then(()=>{n.isCancellationRequested||f.entryCount===r?s():c(new T("Incomplete",new Error(w.localize(1,null,r,f.entryCount))))},c)),f.readEntry(),f.on("entry",A=>{if(n.isCancellationRequested)return;if(!a.sourcePathRegex.test(A.fileName)){S(n);return}const M=A.fileName.replace(a.sourcePathRegex,"");if(/\/$/.test(M)){const _=v.join(i,M);o=(0,t.createCancelablePromise)(q=>k.Promises.mkdir(_,{recursive:!0}).then(()=>S(q)).then(void 0,c));return}const $=y(f,A),Q=R(A);o=(0,t.createCancelablePromise)(_=>u.queue(()=>$.then(q=>b(q,M,Q,i,a,_).then(()=>S(_)))).then(null,c))})})}function C(f,i=!1){return new Promise((a,n)=>{(0,p.open)(f,i?{lazyEntries:!0}:void 0,(o,r)=>{o?n(E(o)):a((0,P.assertIsDefined)(r))})})}function y(f,i){return new Promise((a,n)=>{f.openReadStream(i,(o,r)=>{o?n(E(o)):a((0,P.assertIsDefined)(r))})})}function m(f,i){return new Promise((a,n)=>{const o=new D.ZipFile;i.forEach(s=>{s.contents?o.addBuffer(typeof s.contents=="string"?Buffer.from(s.contents,"utf8"):s.contents,s.path):s.localPath&&o.addFile(s.localPath,s.path)}),o.end();const r=(0,I.createWriteStream)(f);o.outputStream.pipe(r),o.outputStream.once("error",n),r.once("error",n),r.once("finish",()=>a(f))})}e.zip=m;function g(f,i,a={},n){const o=new RegExp(a.sourcePath?`^${a.sourcePath}`:"");let r=C(f,!0);return a.overwrite&&(r=r.then(s=>k.Promises.rm(i).then(()=>s))),r.then(s=>d(s,i,{sourcePathRegex:o},n))}e.extract=g;function h(f,i){return C(f).then(a=>new Promise((n,o)=>{a.on("entry",r=>{r.fileName===i&&y(a,r).then(s=>n(s),s=>o(s))}),a.once("close",()=>o(new Error(w.localize(2,null,i))))}))}function l(f,i){return h(f,i).then(a=>new Promise((n,o)=>{const r=[];a.once("error",o),a.on("data",s=>r.push(s)),a.on("end",()=>n(Buffer.concat(r)))}))}e.buffer=l}),define(ve[257],we([0,1,125,166]),function(oe,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function v(P){return(0,I.buffer)(P,"extension/package.json").then(k=>{try{return JSON.parse(k.toString("utf8"))}catch{throw new Error((0,t.localize)(0,null))}})}e.getManifest=v}),define(ve[126],we([0,1,14,37,11,2,10,5,3,19,51,12,4,26,21,125,165,73,24,233,31,35,45,55,211,234,257,212,232,38,71,17,6,13,25,32,39,36]),function(oe,e,I,t,v,P,k,w,p,D,T,R,E,b,d,C,y,m,g,h,l,f,i,a,n,o,r,s,c,u,S,A,M,$,Q,_,q,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,M.refineServiceDecorator)(l.IServerExtensionManagementService);let ne=class extends h.AbstractExtensionManagementService{constructor(V,X,ae,ie,O,B,ee,ce,K,he,te,le){super(le,te,V,B,X,ae,he);this.environmentService=ie,this.extensionsScannerService=O,this.downloadService=ee,this.fileService=K;const de=this._register(ce.createInstance(o.ExtensionsLifecycle));this.extensionsScanner=this._register(ce.createInstance(Z,J=>de.postUninstall(J))),this.manifestCache=this._register(new s.ExtensionsManifestCache(ie,this)),this.extensionsDownloader=this._register(ce.createInstance(n.ExtensionsDownloader));const Y=this._register(new c.ExtensionsWatcher(this,K,ie,ae,te));this._register(Y.onDidChangeExtensionsByAnotherSource(({added:J,removed:H})=>{J.length&&this._onDidInstallExtensions.fire(J.map(G=>({identifier:G.identifier,operation:1,local:G}))),H.forEach(G=>this._onDidUninstallExtension.fire({identifier:G}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,f.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(V){this.logService.trace("ExtensionManagementService#zip",V.identifier.id);const X=await this.collectFiles(V),ae=await(0,C.zip)((0,D.joinPath)(this.environmentService.tmpDir,(0,b.generateUuid)()).fsPath,X);return E.URI.file(ae)}async unzip(V){return this.logService.trace("ExtensionManagementService#unzip",V.toString()),(await this.install(V)).identifier}async getManifest(V){const X=await this.downloadVsix(V),ae=w.resolve(X.fsPath);return(0,r.getManifest)(ae)}getInstalled(V,X){return this.extensionsScanner.scanExtensions(V??null,X)}getAllUserInstalled(){return this.extensionsScanner.scanUserExtensions(!1)}async install(V,X={}){this.logService.trace("ExtensionManagementService#install",V.toString());const ae=await this.downloadVsix(V),ie=await(0,r.getManifest)(w.resolve(ae.fsPath));if(ie.engines&&ie.engines.vscode&&!(0,S.isEngineValid)(ie.engines.vscode,this.productService.version,this.productService.date))throw new Error(y.localize(0,null,(0,f.getGalleryExtensionId)(ie.publisher,ie.name),this.productService.version));return this.installExtension(ie,ae,X)}getMetadata(V){return this.extensionsScannerService.scanMetadata(V.location)}async updateMetadata(V,X){this.logService.trace("ExtensionManagementService#updateMetadata",V.identifier.id);const ae={...X};return X.isPreReleaseVersion&&(ae.preRelease=!0),V=await this.extensionsScanner.updateMetadata(V,ae),this.manifestCache.invalidate(),V}async updateExtensionScope(V,X){return this.logService.trace("ExtensionManagementService#updateExtensionScope",V.identifier.id),V=await this.extensionsScanner.updateMetadata(V,{isMachineScoped:X}),this.manifestCache.invalidate(),V}removeUninstalledExtensions(V){return this.extensionsScanner.cleanUp(V)}async downloadVsix(V){if(V.scheme===k.Schemas.file)return V;const X=(0,D.joinPath)(this.environmentService.tmpDir,(0,b.generateUuid)());return await this.downloadService.download(V,X),X}createDefaultInstallExtensionTask(V,X,ae){return E.URI.isUri(X)?new z(V,X,ae,this.galleryService,this.extensionsScanner,this.logService):new x(V,X,ae,this.extensionsDownloader,this.extensionsScanner,this.logService)}createDefaultUninstallExtensionTask(V,X){return new W(V,X,this.extensionsScanner)}async collectFiles(V){const X=async ie=>{let O=await d.Promises.readdir(ie);O=O.map(ce=>w.join(ie,ce));const B=await Promise.all(O.map(ce=>d.Promises.stat(ce)));let ee=Promise.resolve([]);return B.forEach((ce,K)=>{const he=O[K];ce.isFile()&&(ee=ee.then(te=>[...te,he])),ce.isDirectory()&&(ee=ee.then(te=>X(he).then(le=>[...te,...le])))}),ee};return(await X(V.location.fsPath)).map(ie=>({path:`extension/${w.relative(V.location.fsPath,ie)}`,localPath:ie}))}};ne=Re([_e(0,l.IExtensionGalleryService),_e(1,_.ITelemetryService),_e(2,$.ILogService),_e(3,g.INativeEnvironmentService),_e(4,a.IExtensionsScannerService),_e(5,i.IExtensionsProfileScannerService),_e(6,m.IDownloadService),_e(7,M.IInstantiationService),_e(8,A.IFileService),_e(9,Q.IProductService),_e(10,q.IUriIdentityService),_e(11,U.IUserDataProfilesService)],ne),e.ExtensionManagementService=ne;let Z=class extends P.Disposable{constructor(V,X,ae,ie){super();this.beforeRemovingExtension=V,this.fileService=X,this.extensionsScannerService=ae,this.logService=ie,this.uninstalledPath=(0,D.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete").fsPath,this.uninstalledFileLimiter=new I.Queue}async cleanUp(V){await this.removeUninstalledExtensions(),V&&await this.removeOutdatedExtensions()}async scanExtensions(V,X){const ae={includeInvalid:!0,profileLocation:X};let ie=[];return V===null||V===0?ie.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},ae)):V===1&&ie.push(...await this.extensionsScannerService.scanUserExtensions(ae)),ie=V!==null?ie.filter(O=>O.type===V):ie,Promise.all(ie.map(O=>this.toLocalExtension(O)))}async scanUserExtensions(V){const X=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!V,includeInvalid:!0});return Promise.all(X.map(ae=>this.toLocalExtension(ae)))}async extractUserExtension(V,X,ae,ie){const O=V.toString(),B=w.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,b.generateUuid)()}`),ee=w.join(this.extensionsScannerService.userExtensionsLocation.fsPath,O);try{await d.Promises.rm(ee)}catch{throw new l.ExtensionManagementError(y.localize(1,null,ee,V.id),l.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(V,X,B,ie),ae={...ae,installedTimestamp:Date.now()},await this.extensionsScannerService.updateMetadata(E.URI.file(B),ae);try{await this.rename(V,B,ee,Date.now()+2*60*1e3),this.logService.info("Renamed to",ee)}catch(ce){try{await d.Promises.rm(B)}catch{}if(ce.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",V.id);else throw this.logService.info(`Rename failed because of ${(0,v.getErrorMessage)(ce)}. Deleted from extracted location`,B),ce}return this.scanLocalExtension(E.URI.file(ee),1)}async updateMetadata(V,X){return await this.extensionsScannerService.updateMetadata(V.location,X),this.scanLocalExtension(V.location,V.type)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...V){const X=V.map(ae=>f.ExtensionKey.create(ae));await this.withUninstalledExtensions(ae=>{X.forEach(ie=>ae[ie.toString()]=!0)})}async setInstalled(V){await this.withUninstalledExtensions(ie=>delete ie[V.toString()]);const ae=(await this.scanUserExtensions(!0)).find(ie=>f.ExtensionKey.create(ie).equals(V))||null;return ae?this.updateMetadata(ae,{installedTimestamp:Date.now()}):null}async removeExtension(V,X){this.logService.trace(`Deleting ${X} extension from disk`,V.identifier.id,V.location.fsPath),await d.Promises.rm(V.location.fsPath),this.logService.info("Deleted from disk",V.identifier.id,V.location.fsPath)}async removeUninstalledExtension(V){await this.removeExtension(V,"uninstalled"),await this.withUninstalledExtensions(X=>delete X[f.ExtensionKey.create(V).toString()])}async withUninstalledExtensions(V){return this.uninstalledFileLimiter.queue(async()=>{let X;try{X=await d.Promises.readFile(this.uninstalledPath,"utf8")}catch(ie){if(ie.code!=="ENOENT")throw ie}let ae={};if(X)try{ae=JSON.parse(X)}catch{}return V&&(V(ae),Object.keys(ae).length?await d.Promises.writeFile(this.uninstalledPath,JSON.stringify(ae)):await d.Promises.rm(this.uninstalledPath)),ae})}async extractAtLocation(V,X,ae,ie){this.logService.trace(`Started extracting the extension from ${X} to ${ae}`);try{await d.Promises.rm(ae)}catch(O){throw new l.ExtensionManagementError(this.joinErrors(O).message,l.ExtensionManagementErrorCode.Delete)}try{await(0,C.extract)(X,ae,{sourcePath:"extension",overwrite:!0},ie),this.logService.info(`Extracted extension to ${ae}:`,V.id)}catch(O){try{await d.Promises.rm(ae)}catch{}let B=l.ExtensionManagementErrorCode.Extract;throw O instanceof C.ExtractError&&(O.type==="CorruptZip"?B=l.ExtensionManagementErrorCode.CorruptZip:O.type==="Incomplete"&&(B=l.ExtensionManagementErrorCode.IncompleteZip)),new l.ExtensionManagementError(O.message,B)}}async rename(V,X,ae,ie){try{await d.Promises.rename(X,ae)}catch(O){if(p.isWindows&&O&&O.code==="EPERM"&&Date.now()<ie)return this.logService.info(`Failed renaming ${X} to ${ae} with 'EPERM' error. Trying again...`,V.id),this.rename(V,X,ae,ie);throw new l.ExtensionManagementError(O.message||y.localize(2,null,X,ae),O.code||l.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(V,X){const ae=await this.extensionsScannerService.scanExistingExtension(V,X,{includeInvalid:!0});if(ae)return this.toLocalExtension(ae);throw new Error(y.localize(3,null,V.path))}async toLocalExtension(V){const X=await this.fileService.resolve(V.location);let ae,ie;return X.children&&(ae=X.children.find(({name:O})=>/^readme(\.txt|\.md|)$/i.test(O))?.resource,ie=X.children.find(({name:O})=>/^changelog(\.txt|\.md|)$/i.test(O))?.resource),{identifier:V.identifier,type:V.type,isBuiltin:V.isBuiltin||!!V.metadata?.isBuiltin,location:V.location,manifest:V.manifest,targetPlatform:V.targetPlatform,validations:V.validations,isValid:V.isValid,readmeUrl:ae,changelogUrl:ie,publisherDisplayName:V.metadata?.publisherDisplayName||null,publisherId:V.metadata?.publisherId||null,isApplicationScoped:!!V.metadata?.isApplicationScoped,isMachineScoped:!!V.metadata?.isMachineScoped,isPreReleaseVersion:!!V.metadata?.isPreReleaseVersion,preRelease:!!V.metadata?.preRelease,installedTimestamp:V.metadata?.installedTimestamp,updated:!!V.metadata?.updated}}async removeUninstalledExtensions(){const V=await this.getUninstalledExtensions(),X=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),ae=new Set;for(const B of X)V[f.ExtensionKey.create(B).toString()]||ae.add(B.identifier.id.toLowerCase());const ie=(0,f.groupByExtension)(X,B=>B.identifier);await I.Promises.settled(ie.map(async B=>{const ee=B.sort((ce,K)=>T.rcompare(ce.manifest.version,K.manifest.version))[0];ae.has(ee.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(ee))}));const O=X.filter(B=>V[f.ExtensionKey.create(B).toString()]);await I.Promises.settled(O.map(B=>this.removeUninstalledExtension(B)))}async removeOutdatedExtensions(){const V=await this.extensionsScannerService.scanSystemExtensions({}),X=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),ae=[],ie=await this.extensionsScannerService.getTargetPlatform(),O=(0,f.groupByExtension)(X,B=>B.identifier);for(const B of O)if(B.length>1&&ae.push(...B.sort((ee,ce)=>{const K=T.rcompare(ee.manifest.version,ce.manifest.version);return K!==0?K:ee.targetPlatform===ie?-1:1}).slice(1)),B[0].type===0){const ee=V.find(ce=>(0,f.areSameExtensions)(ce.identifier,B[0].identifier));(!ee||T.gte(ee.manifest.version,B[0].manifest.version))&&ae.push(B[0])}await I.Promises.settled(ae.map(B=>this.removeExtension(B,"outdated")))}joinErrors(V){const X=Array.isArray(V)?V:[V];return X.length===1?X[0]instanceof Error?X[0]:new Error(X[0]):X.reduce((ae,ie)=>new Error(`${ae.message}${ae.message?",":""}${ie instanceof Error?ie.message:ie}`),new Error(""))}};Z=Re([_e(1,A.IFileService),_e(2,a.IExtensionsScannerService),_e(3,$.ILogService)],Z);class F extends h.AbstractExtensionTask{constructor(V,X,ae,ie,O){super();this.identifier=V,this.source=X,this.options=ae,this.extensionsScanner=ie,this.logService=O,this._operation=2}get operation(){return(0,R.isUndefined)(this.options.operation)?this._operation:this.options.operation}async installExtension(V,X){try{const ae=await this.unsetUninstalledAndGetLocal(V.key);if(ae)return V.metadata?this.extensionsScanner.updateMetadata(ae,V.metadata):ae}catch{throw p.isMacintosh?new l.ExtensionManagementError(y.localize(4,null),l.ExtensionManagementErrorCode.Internal):new l.ExtensionManagementError(y.localize(5,null),l.ExtensionManagementErrorCode.Internal)}return this.extract(V,X)}async unsetUninstalledAndGetLocal(V){if(!await this.isUninstalled(V))return null;this.logService.trace("Removing the extension from uninstalled list:",V.id);const ae=await this.extensionsScanner.setInstalled(V);return this.logService.info("Removed the extension from uninstalled list:",V.id),ae}async isUninstalled(V){return!!(await this.extensionsScanner.getUninstalledExtensions())[V.toString()]}async extract({zipPath:V,key:X,metadata:ae},ie){const O=await this.extensionsScanner.extractUserExtension(X,V,ae,ie);return this.logService.info("Extracting completed.",X.id),O}}class x extends F{constructor(V,X,ae,ie,O,B){super(X.identifier,X,ae,O,B);this.manifest=V,this.gallery=X,this.extensionsDownloader=ie}async doRun(V){const ae=(await this.extensionsScanner.scanExtensions(null,void 0)).find(B=>(0,f.areSameExtensions)(B.identifier,this.gallery.identifier));ae&&(this._operation=3);const ie={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:(0,u.isApplicationScopedExtension)(this.manifest),isMachineScoped:this.options.isMachineScoped||ae?.isMachineScoped,isBuiltin:this.options.isBuiltin||ae?.isBuiltin,isSystem:ae?.type===0?!0:void 0,updated:!!ae,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,preRelease:this.gallery.properties.isPreReleaseVersion||((0,R.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:ae?.preRelease)};if(ae?.manifest.version===this.gallery.version)return{local:await this.extensionsScanner.updateMetadata(ae,ie),metadata:ie};const O=await this.downloadExtension(this.gallery,this._operation);try{const B=await this.installExtension({zipPath:O,key:f.ExtensionKey.create(this.gallery),metadata:ie},V);return ae&&!this.options.profileLocation&&(ae.targetPlatform!==B.targetPlatform||T.neq(ae.manifest.version,B.manifest.version))&&await this.extensionsScanner.setUninstalled(ae),{local:B,metadata:ie}}catch(B){throw await this.deleteDownloadedVSIX(O),B}}async deleteDownloadedVSIX(V){try{await this.extensionsDownloader.delete(E.URI.file(V))}catch(X){this.logService.warn("Error while deleting the downloaded vsix",V.toString(),(0,v.getErrorMessage)(X))}}async downloadExtension(V,X){let ae;try{this.logService.trace("Started downloading extension:",V.identifier.id),ae=(await this.extensionsDownloader.downloadExtension(V,X)).fsPath,this.logService.info("Downloaded extension:",V.identifier.id,ae)}catch(ie){throw new l.ExtensionManagementError((0,h.joinErrors)(ie).message,l.ExtensionManagementErrorCode.Download)}try{return await(0,r.getManifest)(ae),ae}catch(ie){throw await this.deleteDownloadedVSIX(ae),new l.ExtensionManagementError((0,h.joinErrors)(ie).message,l.ExtensionManagementErrorCode.Invalid)}}}class z extends F{constructor(V,X,ae,ie,O,B){super({id:(0,f.getGalleryExtensionId)(V.publisher,V.name)},X,ae,O,B);this.manifest=V,this.location=X,this.galleryService=ie}async doRun(V){const X=new f.ExtensionKey(this.identifier,this.manifest.version),ie=(await this.extensionsScanner.scanExtensions(1,void 0)).find(ee=>(0,f.areSameExtensions)(this.identifier,ee.identifier)),O=await this.getMetadata(this.identifier.id,this.manifest.version,V);if(O.isApplicationScoped=(0,u.isApplicationScopedExtension)(this.manifest),O.isMachineScoped=this.options.isMachineScoped||ie?.isMachineScoped,O.isBuiltin=this.options.isBuiltin||ie?.isBuiltin,ie)if(this._operation=3,X.equals(new f.ExtensionKey(ie.identifier,ie.manifest.version)))try{await this.extensionsScanner.removeExtension(ie,"existing")}catch{throw new Error(y.localize(6,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&T.gt(ie.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(ie);else{const ee=await this.unsetUninstalledAndGetLocal(X);if(ee)try{await this.extensionsScanner.removeExtension(ee,"existing")}catch{throw new Error(y.localize(7,null,this.manifest.displayName||this.manifest.name))}}return{local:await this.installExtension({zipPath:w.resolve(this.location.fsPath),key:X,metadata:O},V),metadata:O}}async getMetadata(V,X,ae){try{let[ie]=await this.galleryService.getExtensions([{id:V,version:X}],ae);if(ie||([ie]=await this.galleryService.getExtensions([{id:V}],ae)),ie)return{id:ie.identifier.uuid,publisherDisplayName:ie.publisherDisplayName,publisherId:ie.publisherId,isPreReleaseVersion:ie.properties.isPreReleaseVersion,preRelease:ie.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class W extends h.AbstractExtensionTask{constructor(V,X,ae){super();this.extension=V,this.options=X,this.extensionsScanner=ae}async doRun(V){const X=[],ae=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const ie=f.ExtensionKey.create(this.extension);X.push(...ae.filter(O=>ie.equals(f.ExtensionKey.create(O))))}else X.push(...ae.filter(ie=>(0,f.areSameExtensions)(ie.identifier,this.extension.identifier)));if(!X.length)throw new Error(y.localize(8,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...X),this.options.remove)for(const ie of X)try{V.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(ie)}catch(O){throw new Error(y.localize(9,null,(0,t.toErrorMessage)(O)))}}}}),define(ve[63],we([0,1,77,66,27,16,11,7,2,5,3,26,43,92,258]),function(oe,e,I,t,v,P,k,w,p,D,T,R,E,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class C{constructor(A,M=""){this.debugLabel=M,this.socket=A,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=$=>{if(this.traceSocketEvent("error",{code:$?.code,message:$?.message}),$){if($.code==="EPIPE")return;(0,k.onUnexpectedError)($)}},this.socket.on("error",this._errorListener)}traceSocketEvent(A,M){b.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,A,M)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(A){const M=$=>{this.traceSocketEvent("read",$),A(P.VSBuffer.wrap($))};return this.socket.on("data",M),{dispose:()=>this.socket.off("data",M)}}onClose(A){const M=$=>{this.traceSocketEvent("close",{hadError:$}),A({type:0,hadError:$,error:void 0})};return this.socket.on("close",M),{dispose:()=>this.socket.off("close",M)}}onEnd(A){const M=()=>{this.traceSocketEvent("nodeEndReceived"),A()};return this.socket.on("end",M),{dispose:()=>this.socket.off("end",M)}}write(A){if(!this.socket.destroyed)try{this.traceSocketEvent("write",A),this.socket.write(A.buffer,M=>{if(M){if(M.code==="EPIPE")return;(0,k.onUnexpectedError)(M)}})}catch(M){if(M.code==="EPIPE")return;(0,k.onUnexpectedError)(M)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((A,M)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),A();return}const $=()=>{this.socket.off("close",$),this.socket.off("end",$),this.socket.off("error",$),this.socket.off("timeout",$),this.socket.off("drain",$),this.traceSocketEvent("nodeDrainEnd"),A()};this.socket.on("close",$),this.socket.on("end",$),this.socket.on("error",$),this.socket.on("timeout",$),this.socket.on("drain",$)})}}e.NodeSocket=C;var y;(function(S){S[S.MinHeaderByteSize=2]="MinHeaderByteSize"})(y||(y={}));var m;(function(S){S[S.PeekHeader=1]="PeekHeader",S[S.ReadHeader=2]="ReadHeader",S[S.ReadBody=3]="ReadBody",S[S.Fin=4]="Fin"})(m||(m={}));class g extends p.Disposable{constructor(A,M,$,Q){super();this._onData=this._register(new w.Emitter),this._onClose=this._register(new w.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=A,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:M,inflateBytesLength:$?.byteLength||0,recordInflateBytes:Q}),this._flowManager=this._register(new h(this,M,$,Q,this._onData,(_,q)=>this._write(_,q))),this._register(this._flowManager.onError(_=>{console.error(_),(0,k.onUnexpectedError)(_),this._onClose.fire({type:0,hadError:!0,error:_})})),this._incomingData=new b.ChunkStream,this._register(this.socket.onData(_=>this._acceptChunk(_))),this._register(this.socket.onClose(_=>this._onClose.fire(_)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(A,M){this.socket.traceSocketEvent(A,M)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(A){return this._onData.event(A)}onClose(A){return this._onClose.event(A)}onEnd(A){return this.socket.onEnd(A)}write(A){this._flowManager.writeMessage(A)}_write(A,M){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",A);let $=2;A.byteLength<126?$+=0:A.byteLength<2**16?$+=2:$+=8;const Q=P.VSBuffer.alloc($);if(M?Q.writeUInt8(194,0):Q.writeUInt8(130,0),A.byteLength<126)Q.writeUInt8(A.byteLength,1);else if(A.byteLength<2**16){Q.writeUInt8(126,1);let _=1;Q.writeUInt8(A.byteLength>>>8&255,++_),Q.writeUInt8(A.byteLength>>>0&255,++_)}else{Q.writeUInt8(127,1);let _=1;Q.writeUInt8(0,++_),Q.writeUInt8(0,++_),Q.writeUInt8(0,++_),Q.writeUInt8(0,++_),Q.writeUInt8(A.byteLength>>>24&255,++_),Q.writeUInt8(A.byteLength>>>16&255,++_),Q.writeUInt8(A.byteLength>>>8&255,++_),Q.writeUInt8(A.byteLength>>>0&255,++_)}this.socket.write(P.VSBuffer.concat([Q,A]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(A){if(A.byteLength!==0){for(this._incomingData.acceptChunk(A);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const M=this._incomingData.peek(this._state.readLen),$=M.readUInt8(0),Q=($&128)>>>7,_=($&64)>>>6,q=M.readUInt8(1),U=(q&128)>>>7,ne=q&127;this._state.state=2,this._state.readLen=2+(U?4:0)+(ne===126?2:0)+(ne===127?8:0),this._state.fin=Q,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(_)),this._state.firstFrameOfMessage=Boolean(Q),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const M=this._incomingData.read(this._state.readLen),$=M.readUInt8(1),Q=($&128)>>>7;let _=$&127,q=1;_===126?_=M.readUInt8(++q)*2**8+M.readUInt8(++q):_===127&&(_=M.readUInt8(++q)*0+M.readUInt8(++q)*0+M.readUInt8(++q)*0+M.readUInt8(++q)*0+M.readUInt8(++q)*2**24+M.readUInt8(++q)*2**16+M.readUInt8(++q)*2**8+M.readUInt8(++q));let U=0;Q&&(U=M.readUInt8(++q)*2**24+M.readUInt8(++q)*2**16+M.readUInt8(++q)*2**8+M.readUInt8(++q)),this._state.state=3,this._state.readLen=_,this._state.mask=U,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const M=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",M),i(M,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",M),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(M,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await w.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=g;class h extends p.Disposable{constructor(A,M,$,Q,_,q){super();this._tracer=A,this._onData=_,this._writeFn=q,this._onError=this._register(new w.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new w.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,M?(this._zlibInflateStream=this._register(new l(this._tracer,Q,$,{windowBits:15})),this._zlibDeflateStream=this._register(new f(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(U=>this._onError.fire(U))),this._register(this._zlibDeflateStream.onError(U=>this._onError.fire(U)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:P.VSBuffer.alloc(0)}writeMessage(A){this._writeQueue.push(A),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const A=this._writeQueue.shift();if(this._zlibDeflateStream){const M=await this._deflateMessage(this._zlibDeflateStream,A);this._writeFn(M,!0)}else this._writeFn(A,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(A,M){return new Promise(($,Q)=>{A.write(M),A.flush(_=>$(_))})}acceptFrame(A,M,$){this._readQueue.push({data:A,isCompressed:M,isLastFrameOfMessage:$}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const A=this._readQueue.shift();if(this._zlibInflateStream&&A.isCompressed){const M=await this._inflateFrame(this._zlibInflateStream,A.data,A.isLastFrameOfMessage);this._onData.fire(M)}else this._onData.fire(A.data)}this._isProcessingReadQueue=!1}}_inflateFrame(A,M,$){return new Promise((Q,_)=>{A.write(M),$&&A.write(P.VSBuffer.fromByteArray([0,0,255,255])),A.flush(q=>Q(q))})}}class l extends p.Disposable{constructor(A,M,$,Q){super();this._tracer=A,this._recordInflateBytes=M,this._onError=this._register(new w.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=d.createInflateRaw(Q),this._zlibInflate.on("error",_=>{this._tracer.traceSocketEvent("zlibInflateError",{message:_?.message,code:_?.code}),this._onError.fire(_)}),this._zlibInflate.on("data",_=>{this._tracer.traceSocketEvent("zlibInflateData",_),this._pendingInflateData.push(P.VSBuffer.wrap(_))}),$&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",$.buffer),this._zlibInflate.write($.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?P.VSBuffer.concat(this._recordedInflateBytes):P.VSBuffer.alloc(0)}write(A){this._recordInflateBytes&&this._recordedInflateBytes.push(A.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",A),this._zlibInflate.write(A.buffer)}flush(A){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const M=P.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,A(M)})}}class f extends p.Disposable{constructor(A,M){super();this._tracer=A,this._onError=this._register(new w.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=d.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",$=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:$?.message,code:$?.code}),this._onError.fire($)}),this._zlibDeflate.on("data",$=>{this._tracer.traceSocketEvent("zlibDeflateData",$),this._pendingDeflateData.push(P.VSBuffer.wrap($))})}write(A){this._tracer.traceSocketEvent("zlibDeflateWrite",A.buffer),this._zlibDeflate.write(A.buffer)}flush(A){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let M=P.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,M=M.slice(0,M.byteLength-4),A(M)})}}function i(S,A){if(A===0)return;const M=S.byteLength>>>2;for(let ne=0;ne<M;ne++){const Z=S.readUInt32BE(ne*4);S.writeUInt32BE(Z^A,ne*4)}const $=M*4,Q=S.byteLength-$,_=A>>>24&255,q=A>>>16&255,U=A>>>8&255;Q>=1&&S.writeUInt8(S.readUInt8($)^_,$),Q>=2&&S.writeUInt8(S.readUInt8($+1)^q,$+1),Q>=3&&S.writeUInt8(S.readUInt8($+2)^U,$+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const a={[2]:107,[1]:103};function n(){const S=(0,R.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${S}-sock`;let A;return e.XDG_RUNTIME_DIR?A=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${S}.sock`):A=(0,D.join)((0,v.tmpdir)(),`vscode-ipc-${S}.sock`),r(A),A}e.createRandomIPCHandle=n;function o(S,A,M){const $=(0,I.createHash)("md5").update(S).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${$}-${M}-${A}-sock`;let Q;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?Q=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-${$.substr(0,8)}-${M}-${A}.sock`):Q=(0,D.join)(S,`${M}-${A}.sock`),r(Q),Q}e.createStaticIPCHandle=o;function r(S){const A=a[T.platform];typeof A=="number"&&S.length>=A&&console.warn(`WARNING: IPC handle "${S}" is longer than ${A} chars, try a shorter --user-data-dir`)}class s extends E.IPCServer{constructor(A){super(s.toClientConnectionEvent(A));this.server=A}static toClientConnectionEvent(A){const M=w.Event.fromNodeEventEmitter(A,"connection");return w.Event.map(M,$=>({protocol:new b.Protocol(new C($,"ipc-server-connection")),onDidClientDisconnect:w.Event.once(w.Event.fromNodeEventEmitter($,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function c(S){return new Promise((A,M)=>{const $=(0,t.createServer)();$.on("error",M),$.listen(S,()=>{$.removeListener("error",M),A(new s($))})})}e.serve=c;function u(S,A){return new Promise((M,$)=>{const Q=(0,t.createConnection)(S,()=>{Q.removeListener("error",$),M(b.Client.fromSocket(new C(Q,`ipc-client${A}`),A))});Q.once("error",$)})}e.connect=u}),define(ve[127],we([0,1,78,14,16,11,2,12,23,24,79,13,215,258]),function(oe,e,I,t,v,P,k,w,p,D,T,R,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let d=class extends k.Disposable{constructor(y,m,g){super();this.environmentService=m,this.logService=g,this.configure(y.getValue()),this._register(y.onDidChangeConfiguration(()=>this.configure(y.getValue()),this))}configure(y){this.proxyUrl=y.http&&y.http.proxy,this.strictSSL=!!(y.http&&y.http.proxyStrictSSL),this.authorization=y.http&&y.http.proxyAuthorization}async request(y,m){this.logService.trace("RequestService#request (node) - begin",y.url);const{proxyUrl:g,strictSSL:h}=this;let l;try{l=await(0,T.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(a){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request (node) resolving shell environment failed",a))}const f={...process.env,...l},i=y.agent?y.agent:await(0,E.getProxyAgent)(y.url||"",f,{proxyUrl:g,strictSSL:h});y.agent=i,y.strictSSL=h,this.authorization&&(y.headers={...y.headers||{},"Proxy-Authorization":this.authorization});try{const a=await this._request(y,m);return this.logService.trace("RequestService#request (node) - success",y.url),a}catch(a){throw this.logService.trace("RequestService#request (node) - error",y.url,a),a}}async getNodeRequest(y){return((0,I.parse)(y.url).protocol==="https:"?await new Promise((h,l)=>{oe(["https"],h,l)}):await new Promise((h,l)=>{oe(["http"],h,l)})).request}_request(y,m){return t.Promises.withAsyncBody(async(g,h)=>{const l=(0,I.parse)(y.url),f=y.getRawRequest?y.getRawRequest(y):await this.getNodeRequest(y),i={hostname:l.hostname,port:l.port?parseInt(l.port):l.protocol==="https:"?443:80,protocol:l.protocol,path:l.path,method:y.type||"GET",headers:y.headers,agent:y.agent,rejectUnauthorized:(0,w.isBoolean)(y.strictSSL)?y.strictSSL:!0};y.user&&y.password&&(i.auth=y.user+":"+y.password);const a=f(i,n=>{const o=(0,w.isNumber)(y.followRedirects)?y.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&o>0&&n.headers.location)this._request({...y,url:n.headers.location,followRedirects:o-1},m).then(g,h);else{let r=n;n.headers["content-encoding"]==="gzip"&&(r=n.pipe((0,b.createGunzip)())),g({res:n,stream:(0,v.streamToBufferReadableStream)(r)})}});a.on("error",h),y.timeout&&a.setTimeout(y.timeout),y.data&&typeof y.data=="string"&&a.write(y.data),a.end(),m.onCancellationRequested(()=>{a.abort(),h((0,P.canceled)())})})}async resolveProxy(y){}};d=Re([_e(0,p.IConfigurationService),_e(1,D.INativeEnvironmentService),_e(2,R.ILogService)],d),e.RequestService=d}),define(ve[128],we([0,1,42,66,113,10,5,16,7,63,79,13,46,3,56,112,2,251]),function(oe,e,I,t,v,P,k,w,p,D,T,R,E,b,d,C,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostConnection=e.buildUserEnvironment=void 0;async function g(n={},o,r,s,c){const u=await(0,v.getNLSConfiguration)(r,s.userDataPath);let S={};if(o)try{S=await(0,T.getResolvedShellEnv)(c,s.args,process.env)}catch(q){c.error("ExtensionHostConnection#buildUserEnvironment resolving shell environment failed",q)}const M={...process.env,...S,VSCODE_AMD_ENTRYPOINT:"vs/workbench/api/node/extensionHostProcess",VSCODE_HANDLES_UNCAUGHT_ERRORS:"true",VSCODE_NLS_CONFIG:JSON.stringify(u,void 0,0),...n},$=s.isBuilt?(0,k.join)(s.appRoot,"bin"):(0,k.join)(s.appRoot,"resources","server","bin-dev"),Q=(0,k.join)($,"remote-cli");let _=f(M,"PATH");return _?_=Q+k.delimiter+_:_=Q,i(M,"PATH",_),s.args["without-browser-env-var"]||(M.BROWSER=(0,k.join)($,"helpers",b.isWindows?"browser.cmd":"browser.sh")),a(M),M}e.buildUserEnvironment=g;class h{constructor(o,r){this.socket=o,this.initialDataChunk=r}socketDrain(){return this.socket.drain()}toIExtHostSocketMessage(){let o,r,s;return this.socket instanceof D.NodeSocket?(o=!0,r=!1,s=w.VSBuffer.alloc(0)):(o=!1,r=this.socket.permessageDeflate,s=this.socket.recordedInflateBytes),{type:"VSCODE_EXTHOST_IPC_SOCKET",initialDataChunk:this.initialDataChunk.buffer.toString("base64"),skipWebSocketFrames:o,permessageDeflate:r,inflateBytes:s.buffer.toString("base64")}}}let l=class{constructor(o,r,s,c,u,S,A){this._reconnectionToken=o,this._environmentService=u,this._logService=S,this._extensionHostStatusService=A,this._onClose=new p.Emitter,this.onClose=this._onClose.event,this._canSendSocket=!b.isWindows||!this._environmentService.args["socket-path"],this._disposed=!1,this._remoteAddress=r,this._extensionHostProcess=null,this._connectionData=new h(s,c),this._log("New connection established.")}get _logPrefix(){return`[${this._remoteAddress}][${this._reconnectionToken.substr(0,8)}][ExtensionHostConnection] `}_log(o){this._logService.info(`${this._logPrefix}${o}`)}_logError(o){this._logService.error(`${this._logPrefix}${o}`)}async _pipeSockets(o,r){const s=new y.DisposableStore;s.add(r.socket),s.add((0,y.toDisposable)(()=>{o.destroy()}));const c=()=>{s.dispose()};s.add(r.socket.onEnd(c)),s.add(r.socket.onClose(c)),s.add(p.Event.fromNodeEventEmitter(o,"end")(c)),s.add(p.Event.fromNodeEventEmitter(o,"close")(c)),s.add(p.Event.fromNodeEventEmitter(o,"error")(c)),s.add(r.socket.onData(u=>o.write(u.buffer))),s.add(p.Event.fromNodeEventEmitter(o,"data")(u=>{r.socket.write(w.VSBuffer.wrap(u))})),r.initialDataChunk.byteLength>0&&o.write(r.initialDataChunk.buffer)}async _sendSocketToExtensionHost(o,r){await r.socketDrain();const s=r.toIExtHostSocketMessage();let c;r.socket instanceof D.NodeSocket?c=r.socket.socket:c=r.socket.socket.socket,o.send(s,c)}shortenReconnectionGraceTimeIfNecessary(){if(!this._extensionHostProcess)return;const o={type:"VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"};this._extensionHostProcess.send(o)}acceptReconnection(o,r,s){this._remoteAddress=o,this._log("The client has reconnected.");const c=new h(r,s);if(!this._extensionHostProcess){this._connectionData=c;return}this._sendSocketToExtensionHost(this._extensionHostProcess,c)}_cleanResources(){this._disposed||(this._disposed=!0,this._connectionData&&(this._connectionData.socket.end(),this._connectionData=null),this._extensionHostProcess&&(this._extensionHostProcess.kill(),this._extensionHostProcess=null),this._onClose.fire(void 0))}async start(o){try{let r=[];o.port&&!process.pkg&&(r=[`--inspect${o.break?"-brk":""}=${o.port}`]);const s=await g(o.env,!0,o.language,this._environmentService,this._logService);(0,d.removeDangerousEnvVariables)(s);let c;if(this._canSendSocket)(0,m.writeExtHostConnection)(new m.SocketExtHostConnection,s),c=null;else{const{namedPipeServer:_,pipeName:q}=await this._listenOnPipe();(0,m.writeExtHostConnection)(new m.IPCExtHostConnection(q),s),c=_}const u={env:s,execArgv:r,silent:!0},S=["--type=extensionHost","--transformURIs"],A=this._environmentService.args["use-host-proxy"];S.push(`--useHostProxy=${A?"true":"false"}`),this._extensionHostProcess=I.fork(P.FileAccess.asFileUri("bootstrap-fork",oe).fsPath,S,u);const M=this._extensionHostProcess.pid;this._log(`<${M}> Launched Extension Host Process.`),this._extensionHostProcess.stdout.setEncoding("utf8"),this._extensionHostProcess.stderr.setEncoding("utf8");const $=p.Event.fromNodeEventEmitter(this._extensionHostProcess.stdout,"data"),Q=p.Event.fromNodeEventEmitter(this._extensionHostProcess.stderr,"data");if($(_=>this._log(`<${M}> ${_}`)),Q(_=>this._log(`<${M}><stderr> ${_}`)),this._extensionHostProcess.on("error",_=>{this._logError(`<${M}> Extension Host Process had an error`),this._logService.error(_),this._cleanResources()}),this._extensionHostProcess.on("exit",(_,q)=>{this._extensionHostStatusService.setExitInfo(this._reconnectionToken,{code:_,signal:q}),this._log(`<${M}> Extension Host Process exited with code: ${_}, signal: ${q}.`),this._cleanResources()}),c)c.on("connection",_=>{c.close(),this._pipeSockets(_,this._connectionData)});else{const _=q=>{q.type==="VSCODE_EXTHOST_IPC_READY"&&(this._extensionHostProcess.removeListener("message",_),this._sendSocketToExtensionHost(this._extensionHostProcess,this._connectionData),this._connectionData=null)};this._extensionHostProcess.on("message",_)}}catch(r){console.error("ExtensionHostConnection errored"),r&&console.error(r)}}_listenOnPipe(){return new Promise((o,r)=>{const s=(0,D.createRandomIPCHandle)(),c=t.createServer();c.on("error",r),c.listen(s,()=>{c?.removeListener("error",r),o({pipeName:s,namedPipeServer:c})})})}};l=Re([_e(4,E.IServerEnvironmentService),_e(5,R.ILogService),_e(6,C.IExtensionHostStatusService)],l),e.ExtensionHostConnection=l;function f(n,o){const r=Object.keys(n).filter(c=>c.toLowerCase()===o.toLowerCase()),s=r.length>0?r[0]:o;return n[s]}function i(n,o,r){const s=Object.keys(n).filter(u=>u.toLowerCase()===o.toLowerCase()),c=s.length>0?s[0]:o;n[c]=r}function a(n){for(const o of Object.keys(n))n[o]===null&&delete n[o]}}),define(ve[259],we([0,1,74,13,58,103,23,54,127,44,32,31,110,126,98,52,2,99,60,10,17,25,101,124,46,105,75,106,11,4,5,28,213,73,39,109,57,3,55,114,36,45,61]),function(oe,e,I,t,v,P,k,w,p,D,T,R,E,b,d,C,y,m,g,h,l,f,i,a,n,o,r,s,c,u,S,A,M,$,Q,_,q,U,ne,Z,F,x,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.run=void 0;class W extends y.Disposable{constructor(ae,ie){super();this.args=ae,this.remoteDataFolder=ie,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){await(await this.initServices()).invokeFunction(async ie=>{const O=ie.get(t.ILogService),B=ie.get(R.IExtensionManagementCLIService);try{await this.doRun(B)}catch(ee){throw O.error(ee),console.error((0,c.getErrorMessage)(ee)),ee}})}async initServices(){const ae=new I.ServiceCollection,ie={_serviceBrand:void 0,...C.default};ae.set(f.IProductService,ie);const O=new n.ServerEnvironmentService(this.args,ie);ae.set(n.IServerEnvironmentService,O);const B=new t.LogService(new i.SpdLogLogger(a.RemoteExtensionLogFileName,(0,S.join)(O.logsPath,`${a.RemoteExtensionLogFileName}.log`),!0,!1,(0,t.getLogLevel)(O)));ae.set(t.ILogService,B),B.trace(`Remote configuration data at ${this.remoteDataFolder}`),B.trace("process arguments:",this.args);const ee=this._register(new m.FileService(B));ae.set(l.IFileService,ee),ee.registerProvider(h.Schemas.file,this._register(new g.DiskFileSystemProvider(B)));const ce=this._register(new F.UserDataProfilesService(O,ee,B));ae.set(F.IUserDataProfilesService,ce);const K=this._register(new P.ConfigurationService(ce.defaultProfile.settingsResource,ee,new z.NullPolicyService,B));return await K.initialize(),ae.set(k.IConfigurationService,K),ae.set(Q.IUriIdentityService,new _.UriIdentityService(ee)),ae.set(w.IRequestService,new v.SyncDescriptor(p.RequestService)),ae.set($.IDownloadService,new v.SyncDescriptor(M.DownloadService)),ae.set(T.ITelemetryService,D.NullTelemetryService),ae.set(R.IExtensionGalleryService,new v.SyncDescriptor(E.ExtensionGalleryServiceWithNoStorageService)),ae.set(x.IExtensionsProfileScannerService,new v.SyncDescriptor(x.ExtensionsProfileScannerService)),ae.set(ne.IExtensionsScannerService,new v.SyncDescriptor(Z.ExtensionsScannerService)),ae.set(b.INativeServerExtensionManagementService,new v.SyncDescriptor(b.ExtensionManagementService)),ae.set(R.IExtensionManagementCLIService,new v.SyncDescriptor(o.ExtensionManagementCLIService)),ae.set(r.ILanguagePackService,new v.SyncDescriptor(s.NativeLanguagePackService)),new d.InstantiationService(ae)}async doRun(ae){if(this.args["list-extensions"])return ae.listExtensions(!!this.args["show-versions"],this.args.category);if(this.args["install-extension"]||this.args["install-builtin-extension"]){const ie={isMachineScoped:!!this.args["do-not-sync"],installPreReleaseVersion:!!this.args["pre-release"]};return ae.installExtensions(this.asExtensionIdOrVSIX(this.args["install-extension"]||[]),this.args["install-builtin-extension"]||[],ie,!!this.args.force)}else{if(this.args["uninstall-extension"])return ae.uninstallExtensions(this.asExtensionIdOrVSIX(this.args["uninstall-extension"]),!!this.args.force);if(this.args["locate-extension"])return ae.locateExtension(this.args["locate-extension"])}}asExtensionIdOrVSIX(ae){return ae.map(ie=>/\.vsix$/i.test(ie)?u.URI.file((0,S.isAbsolute)(ie)?ie:(0,S.join)((0,A.cwd)(),ie)):ie)}}function re(X){setTimeout(()=>process.exit(X),0)}async function V(X,ae,ie){if(X.help){const B=C.default.serverApplicationName+(U.isWindows?".cmd":"");console.log((0,q.buildHelpMessage)(C.default.nameLong,B,C.default.version,ie,{noInputFiles:!0,noPipe:!0}));return}if(X.version){console.log((0,q.buildVersionMessage)(C.default.version,C.default.commit));return}const O=new W(X,ae);try{await O.run(),re(0)}catch{re(1)}finally{O.dispose()}}e.run=V}),define(ve[260],we([0,1,63,272,30,255,4,13,111]),function(oe,e,I,t,v,P,k,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class D{constructor(E,b,d){this._commands=E,this.logService=b,this._ipcHandlePath=d,this._server=t.createServer((C,y)=>this.onRequest(C,y)),this.setup().catch(C=>(b.error(C),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",E=>this.logService.error(E))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(E,b){const d=(y,m)=>{b.writeHead(y,{"content-type":"application/json"}),b.end(JSON.stringify(m||null),g=>g&&this.logService.error(g))},C=[];E.setEncoding("utf8"),E.on("data",y=>C.push(y)),E.on("end",async()=>{try{const y=JSON.parse(C.join(""));let m;switch(y.type){case"open":m=await this.open(y);break;case"openExternal":m=await this.openExternal(y);break;case"status":m=await this.getStatus(y);break;case"extensionManagement":m=await this.manageExtensions(y);break;default:d(404,`Unknown message type: ${y.type}`);break}d(200,m)}catch(y){const m=y instanceof Error?y.message:JSON.stringify(y);d(500,m),this.logService.error("Error while processing pipe request",y)}})}async open(E){const{fileURIs:b,folderURIs:d,forceNewWindow:C,diffMode:y,addMode:m,forceReuseWindow:g,gotoLineMode:h,waitMarkerFilePath:l,remoteAuthority:f}=E,i=[];if(Array.isArray(d))for(const r of d)try{i.push({folderUri:k.URI.parse(r)})}catch{}if(Array.isArray(b))for(const r of b)try{(0,p.hasWorkspaceFileExtension)(r)?i.push({workspaceUri:k.URI.parse(r)}):i.push({fileUri:k.URI.parse(r)})}catch{}const a=l?k.URI.file(l):void 0,o={forceNewWindow:C,diffMode:y,addMode:m,gotoLineMode:h,forceReuseWindow:g,preferNewWindow:!g&&!a&&!m,waitMarkerFileURI:a,remoteAuthority:f};return this._commands.executeCommand("_remoteCLI.windowOpen",i,o),""}async openExternal(E){for(const b of E.uris){const d=k.URI.parse(b),C=d.scheme==="file"?d:b;await this._commands.executeCommand("_remoteCLI.openExternal",C)}}async manageExtensions(E){const b=C=>C?.map(y=>/\.vsix$/i.test(y)?k.URI.parse(y):y),d={list:E.list,install:b(E.install),uninstall:b(E.uninstall),force:E.force};return await this._commands.executeCommand("_remoteCLI.manageExtensions",d)}async getStatus(E){return await this._commands.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&v.existsSync(this._ipcHandlePath)&&v.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=D;let T=class extends D{constructor(E,b){super(E,b,(0,I.createRandomIPCHandle)())}};T=Re([_e(0,P.IExtHostCommands),_e(1,w.ILogService)],T),e.CLIServer=T}),define(ve[261],we([0,1,27,7,22,2,5,3,4,63,62,260,243,118,244,247,128]),function(oe,e,I,t,v,P,k,w,p,D,T,R,E,b,d,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannel=void 0;class m extends C.AbstractVariableResolverService{constructor(l,f,i,a,n){super({getFolderUri:o=>{const r=f.filter(s=>s.name===o);if(r&&r.length>0)return r[0].uri},getWorkspaceFolderCount:()=>f.length,getConfigurationValue:(o,r)=>a[`config:${r}`],getExecPath:()=>l.VSCODE_EXEC_PATH,getAppRoot:()=>l.VSCODE_CWD,getFilePath:()=>{if(i)return k.normalize(i.fsPath)},getSelectedText:()=>a.selectedText,getLineNumber:()=>a.lineNumber,getExtension:async o=>{const s=(await n.getInstalled()).find(c=>c.identifier.id===o);return s&&{extensionLocation:s.location}}},void 0,Promise.resolve(I.homedir()),Promise.resolve(l))}}class g extends P.Disposable{constructor(l,f,i,a,n){super();this._environmentService=l,this._logService=f,this._ptyService=i,this._productService=a,this._extensionManagementService=n,this._lastReqId=0,this._pendingCommands=new Map,this._onExecuteCommand=this._register(new t.Emitter),this.onExecuteCommand=this._onExecuteCommand.event}async call(l,f,i){switch(f){case"$restartPtyHost":return this._ptyService.restartPtyHost?.apply(this._ptyService,i);case"$createProcess":{const a=(0,T.createURITransformer)(l.remoteAuthority);return this._createProcess(a,i)}case"$attachToProcess":return this._ptyService.attachToProcess.apply(this._ptyService,i);case"$detachFromProcess":return this._ptyService.detachFromProcess.apply(this._ptyService,i);case"$listProcesses":return this._ptyService.listProcesses.apply(this._ptyService,i);case"$orphanQuestionReply":return this._ptyService.orphanQuestionReply.apply(this._ptyService,i);case"$acceptPtyHostResolvedVariables":return this._ptyService.acceptPtyHostResolvedVariables?.apply(this._ptyService,i);case"$start":return this._ptyService.start.apply(this._ptyService,i);case"$input":return this._ptyService.input.apply(this._ptyService,i);case"$acknowledgeDataEvent":return this._ptyService.acknowledgeDataEvent.apply(this._ptyService,i);case"$shutdown":return this._ptyService.shutdown.apply(this._ptyService,i);case"$resize":return this._ptyService.resize.apply(this._ptyService,i);case"$getInitialCwd":return this._ptyService.getInitialCwd.apply(this._ptyService,i);case"$getCwd":return this._ptyService.getCwd.apply(this._ptyService,i);case"$processBinary":return this._ptyService.processBinary.apply(this._ptyService,i);case"$sendCommandResult":return this._sendCommandResult(i[0],i[1],i[2]);case"$installAutoReply":return this._ptyService.installAutoReply.apply(this._ptyService,i);case"$uninstallAllAutoReplies":return this._ptyService.uninstallAllAutoReplies.apply(this._ptyService,i);case"$getDefaultSystemShell":return this._getDefaultSystemShell.apply(this,i);case"$getProfiles":return this._getProfiles.apply(this,i);case"$getEnvironment":return this._getEnvironment();case"$getWslPath":return this._getWslPath(i[0]);case"$getTerminalLayoutInfo":return this._ptyService.getTerminalLayoutInfo(i);case"$setTerminalLayoutInfo":return this._ptyService.setTerminalLayoutInfo(i);case"$serializeTerminalState":return this._ptyService.serializeTerminalState.apply(this._ptyService,i);case"$reviveTerminalProcesses":return this._ptyService.reviveTerminalProcesses.apply(this._ptyService,i);case"$setUnicodeVersion":return this._ptyService.setUnicodeVersion.apply(this._ptyService,i);case"$reduceConnectionGraceTime":return this._reduceConnectionGraceTime();case"$updateIcon":return this._ptyService.updateIcon.apply(this._ptyService,i);case"$updateTitle":return this._ptyService.updateTitle.apply(this._ptyService,i);case"$updateProperty":return this._ptyService.updateProperty.apply(this._ptyService,i);case"$refreshProperty":return this._ptyService.refreshProperty.apply(this._ptyService,i);case"$requestDetachInstance":return this._ptyService.requestDetachInstance(i[0],i[1]);case"$acceptDetachedInstance":return this._ptyService.acceptDetachInstanceReply(i[0],i[1])}throw new Error(`IPC Command ${f} not found`)}listen(l,f,i){switch(f){case"$onPtyHostExitEvent":return this._ptyService.onPtyHostExit||t.Event.None;case"$onPtyHostStartEvent":return this._ptyService.onPtyHostStart||t.Event.None;case"$onPtyHostUnresponsiveEvent":return this._ptyService.onPtyHostUnresponsive||t.Event.None;case"$onPtyHostResponsiveEvent":return this._ptyService.onPtyHostResponsive||t.Event.None;case"$onPtyHostRequestResolveVariablesEvent":return this._ptyService.onPtyHostRequestResolveVariables||t.Event.None;case"$onProcessDataEvent":return this._ptyService.onProcessData;case"$onProcessReadyEvent":return this._ptyService.onProcessReady;case"$onProcessExitEvent":return this._ptyService.onProcessExit;case"$onProcessReplayEvent":return this._ptyService.onProcessReplay;case"$onProcessOrphanQuestion":return this._ptyService.onProcessOrphanQuestion;case"$onExecuteCommand":return this.onExecuteCommand;case"$onDidRequestDetach":return this._ptyService.onDidRequestDetach||t.Event.None;case"$onDidChangeProperty":return this._ptyService.onDidChangeProperty;default:break}throw new Error("Not supported")}async _createProcess(l,f){const i={name:f.shellLaunchConfig.name,executable:f.shellLaunchConfig.executable,args:f.shellLaunchConfig.args,cwd:typeof f.shellLaunchConfig.cwd=="string"||typeof f.shellLaunchConfig.cwd=="undefined"?f.shellLaunchConfig.cwd:p.URI.revive(l.transformIncoming(f.shellLaunchConfig.cwd)),env:f.shellLaunchConfig.env,useShellEnvironment:f.shellLaunchConfig.useShellEnvironment},a=await(0,y.buildUserEnvironment)(f.resolverEnv,!!f.shellLaunchConfig.useShellEnvironment,w.language,this._environmentService,this._logService);this._logService.trace("baseEnv",a);const n=ne=>({uri:p.URI.revive(l.transformIncoming(ne.uri)),name:ne.name,index:ne.index,toResource:()=>{throw new Error("Not implemented")}}),o=f.workspaceFolders.map(n),r=f.activeWorkspaceFolder?n(f.activeWorkspaceFolder):void 0,s=f.activeFileResource?p.URI.revive(l.transformIncoming(f.activeFileResource)):void 0,c=new m(a,o,s,f.resolvedVariables,this._extensionManagementService),u=d.createVariableResolver(r,process.env,c),S=await d.getCwd(i,I.homedir(),u,r?.uri,f.configuration["terminal.integrated.cwd"],this._logService);i.cwd=S;const A=w.isWindows?"terminal.integrated.env.windows":w.isMacintosh?"terminal.integrated.env.osx":"terminal.integrated.env.linux",M=f.configuration[A],$=await d.createTerminalEnvironment(i,M,u,this._productService.version,f.configuration["terminal.integrated.detectLocale"],a);if(!i.strictEnv){const ne=[];for(const[x,z]of f.envVariableCollections)ne.push([x,{map:(0,b.deserializeEnvironmentVariableCollection)(z)}]);const Z=new Map(ne);await new E.MergedEnvironmentVariableCollection(Z).applyToProcessEnvironment($,u)}this._logService.debug("Terminal process launching on remote agent",{shellLaunchConfig:i,initialCwd:S,cols:f.cols,rows:f.rows,env:$});const Q=(0,D.createRandomIPCHandle)();$.VSCODE_IPC_HOOK_CLI=Q;const _={executeCommand:(ne,...Z)=>this._executeCommand(ne,Z,l)},q=new R.CLIServerBase(_,this._logService,Q),U=await this._ptyService.createProcess(i,S,f.cols,f.rows,f.unicodeVersion,$,a,f.options,f.shouldPersistTerminal,f.workspaceId,f.workspaceName);return this._ptyService.onProcessExit(ne=>ne.id===U&&q.dispose()),{persistentTerminalId:U,resolvedShellLaunchConfig:i}}_executeCommand(l,f,i){let a,n;const o=new Promise((c,u)=>{a=c,n=u}),r=++this._lastReqId;this._pendingCommands.set(r,{resolve:a,reject:n,uriTransformer:i});const s=(0,v.cloneAndChange)(f,c=>{if(c&&c.$mid===1)return i.transformOutgoing(c);if(c&&c instanceof p.URI)return i.transformOutgoingURI(c)});return this._onExecuteCommand.fire({reqId:r,commandId:l,commandArgs:s}),o}_sendCommandResult(l,f,i){const a=this._pendingCommands.get(l);if(!a)return;this._pendingCommands.delete(l);const n=(0,v.cloneAndChange)(i,o=>{if(o&&o.$mid===1)return a.uriTransformer.transformIncoming(o)});f?a.reject(n):a.resolve(n)}_getDefaultSystemShell(l){return this._ptyService.getDefaultSystemShell(l)}async _getProfiles(l,f,i,a){return this._ptyService.getProfiles?.(l,f,i,a)||[]}_getEnvironment(){return{...process.env}}_getWslPath(l){return this._ptyService.getWslPath(l)}_reduceConnectionGraceTime(){return this._ptyService.reduceConnectionGraceTime()}}e.RemoteTerminalChannel=g}),define(ve[262],we([0,1,27,7,2,10,5,89,21,43,23,103,72,208,185,73,186,196,188,24,110,31,105,197,126,17,99,60,58,98,74,75,106,13,100,101,52,25,54,214,127,216,32,44,223,224,107,231,39,109,253,241,218,222,261,62,46,250,124,256,112,55,114,45,36,61]),function(oe,e,I,t,v,P,k,w,p,D,T,R,E,b,d,C,y,m,g,h,l,f,i,a,n,o,r,s,c,u,S,A,M,$,Q,_,q,U,ne,Z,F,x,z,W,re,V,X,ae,ie,O,B,ee,ce,K,he,te,le,de,Y,J,H,G,fe,pe,ke,Te){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SocketServer=e.setupServerServices=void 0;const Me="monacoworkbench";async function Be(He,We,je,Ge){const ue=new S.ServiceCollection,Ce=new ye,Pe={_serviceBrand:void 0,...q.default};ue.set(U.IProductService,Pe);const Ae=new le.ServerEnvironmentService(We,Pe);ue.set(h.IEnvironmentService,Ae),ue.set(h.INativeEnvironmentService,Ae);const Le=new $.LogService(new _.SpdLogLogger(Y.RemoteExtensionLogFileName,k.join(Ae.logsPath,`${Y.RemoteExtensionLogFileName}.log`),!0,!1,(0,$.getLogLevel)(Ae))),Ue=new $.MultiplexLogService([new Oe((0,$.getLogLevel)(Ae)),Le]);ue.set($.ILogService,Ue),setTimeout(()=>$e(Ae.logsPath).then(null,ot=>Ue.error(ot)),1e4),Ue.trace(`Remote configuration data at ${je}`),Ue.trace("process arguments:",Ae.args),Array.isArray(Pe.serverGreeting)&&Le.info(`

${Pe.serverGreeting.join(`
`)}

`),Ce.registerChannel(d.ExtensionHostDebugBroadcastChannel.ChannelName,new d.ExtensionHostDebugBroadcastChannel);const Ve=new D.StaticRouter(ot=>ot.clientId==="renderer");Ce.registerChannel("logger",new Q.LogLevelChannel(Ue));const Ke=Ge.add(new r.FileService(Ue));ue.set(o.IFileService,Ke),Ke.registerProvider(P.Schemas.file,Ge.add(new s.DiskFileSystemProvider(Ue)));const et=new ke.UserDataProfilesService(Ae,Ke,Ue);ue.set(ke.IUserDataProfilesService,et);const nt=new R.ConfigurationService(Ae.machineSettingsResource,Ke,new Te.NullPolicyService,Ue);ue.set(T.IConfigurationService,nt),await nt.initialize();const it=new H.ExtensionHostStatusService;ue.set(H.IExtensionHostStatusService,it),ue.set(ie.IUriIdentityService,new O.UriIdentityService(Ke)),ue.set(ne.IRequestService,new c.SyncDescriptor(F.RequestService));let rt=W.NullAppender;const dt=await(0,w.getMachineId)();if((0,W.supportsTelemetry)(Pe,Ae)){Pe.aiConfig&&Pe.aiConfig.asimovKey&&(rt=new re.AppInsightsAppender(Me,null,Pe.aiConfig.asimovKey),Ge.add((0,v.toDisposable)(()=>rt.flush())));const ot={appenders:[rt],commonProperties:(0,x.resolveCommonProperties)(Ke,(0,I.release)(),(0,I.hostname)(),process.arch,Pe.commit,Pe.version+"-remote",dt,Pe.msftInternalDomains,Ae.installSourcePath,"remoteAgent"),piiPaths:(0,W.getPiiPathsFromEnvironment)(Ae)},ct=Ae.args["telemetry-level"];let ft=3;ct==="all"?ft=3:ct==="error"?ft=2:ct==="crash"?ft=1:ct!==void 0&&(ft=0),ue.set(K.IServerTelemetryService,new c.SyncDescriptor(K.ServerTelemetryService,[ot,ft]))}else ue.set(K.IServerTelemetryService,K.ServerNullTelemetryService);ue.set(f.IExtensionGalleryService,new c.SyncDescriptor(l.ExtensionGalleryServiceWithNoStorageService));const pt=Ce.getChannel("download",Ve);ue.set(C.IDownloadService,new y.DownloadServiceChannelClient(pt,()=>Se("renderer"))),ue.set(pe.IExtensionsProfileScannerService,new c.SyncDescriptor(pe.ExtensionsProfileScannerService)),ue.set(G.IExtensionsScannerService,new c.SyncDescriptor(fe.ExtensionsScannerService)),ue.set(n.INativeServerExtensionManagementService,new c.SyncDescriptor(n.ExtensionManagementService));const vt=new u.InstantiationService(ue);ue.set(A.ILanguagePackService,vt.createInstance(M.NativeLanguagePackService));const Et=vt.createInstance(i.ExtensionManagementCLIService);ue.set(f.IExtensionManagementCLIService,Et);const St=vt.createInstance(ae.PtyHostService,{graceTime:108e5,shortGraceTime:3e5,scrollback:nt.getValue("terminal.integrated.persistentSessionScrollback")??100});return ue.set(X.IPtyService,St),ue.set(m.IEncryptionMainService,new c.SyncDescriptor(g.EncryptionMainService,[dt])),ue.set(E.ICredentialsMainService,new c.SyncDescriptor(b.CredentialsWebMainService)),vt.invokeFunction(ot=>{const ct=ot.get(n.INativeServerExtensionManagementService),ft=ot.get(G.IExtensionsScannerService),_t=new B.RemoteAgentEnvironmentChannel(He,Ae,et,Et,Ue,it,ft);Ce.registerChannel("remoteextensionsenvironment",_t);const Lt=new ce.ServerTelemetryChannel(ot.get(K.IServerTelemetryService),rt);Ce.registerChannel("telemetry",Lt),Ce.registerChannel(de.REMOTE_TERMINAL_CHANNEL_NAME,new he.RemoteTerminalChannel(Ae,Ue,St,Pe,ct));const Tt=new ee.RemoteAgentFileSystemProviderChannel(Ue,Ae);Ce.registerChannel(J.REMOTE_FILE_SYSTEM_CHANNEL_NAME,Tt),Ce.registerChannel("request",new Z.RequestChannel(ot.get(ne.IRequestService)));const Ft=new a.ExtensionManagementChannel(ct,me=>Se(me.remoteAuthority));Ce.registerChannel("extensions",Ft);const Ee=D.ProxyChannel.fromService(ot.get(m.IEncryptionMainService));Ce.registerChannel("encryption",Ee);const Ie=D.ProxyChannel.fromService(ot.get(E.ICredentialsMainService));return Ce.registerChannel("credentials",Ie),ct.removeUninstalledExtensions(!0),Ge.add(new V.default(ot.get(z.ITelemetryService))),{telemetryService:ot.get(z.ITelemetryService)}}),{socketServer:Ce,instantiationService:vt}}e.setupServerServices=Be;const ge=Object.create(null);function Se(He){return ge[He]||(ge[He]=(0,te.createURITransformer)(He)),ge[He]}class ye extends D.IPCServer{constructor(){const We=new t.Emitter;super(We.event);this._onDidConnectEmitter=We}acceptConnection(We,je){this._onDidConnectEmitter.fire({protocol:We,onDidClientDisconnect:je})}}e.SocketServer=ye;class Oe extends $.AbstractLogger{constructor(We=$.DEFAULT_LOG_LEVEL){super();this.setLevel(We),this.useColors=Boolean(process.stdout.isTTY)}trace(We,...je){this.getLevel()<=$.LogLevel.Trace&&(this.useColors?console.log(`[90m[${Ne()}][0m`,We,...je):console.log(`[${Ne()}]`,We,...je))}debug(We,...je){this.getLevel()<=$.LogLevel.Debug&&(this.useColors?console.log(`[90m[${Ne()}][0m`,We,...je):console.log(`[${Ne()}]`,We,...je))}info(We,...je){this.getLevel()<=$.LogLevel.Info&&(this.useColors?console.log(`[90m[${Ne()}][0m`,We,...je):console.log(`[${Ne()}]`,We,...je))}warn(We,...je){this.getLevel()<=$.LogLevel.Warning&&(this.useColors?console.warn(`[93m[${Ne()}][0m`,We,...je):console.warn(`[${Ne()}]`,We,...je))}error(We,...je){this.getLevel()<=$.LogLevel.Error&&(this.useColors?console.error(`[91m[${Ne()}][0m`,We,...je):console.error(`[${Ne()}]`,We,...je))}critical(We,...je){this.getLevel()<=$.LogLevel.Critical&&(this.useColors?console.error(`[90m[${Ne()}][0m`,We,...je):console.error(`[${Ne()}]`,We,...je))}dispose(){}flush(){}}function Ne(){const He=new Date;return`${Je(He.getHours())}:${Je(He.getMinutes())}:${Je(He.getSeconds())}`}function Je(He){return He<10?`0${He}`:String(He)}async function $e(He){const We=k.basename(He),je=k.dirname(He),Ce=(await p.Promises.readdir(je)).filter(Ae=>/^\d{8}T\d{6}$/.test(Ae)).sort().filter(Ae=>Ae!==We),Pe=Ce.slice(0,Math.max(0,Ce.length-9));await Promise.all(Pe.map(Ae=>p.Promises.rm(k.join(je,Ae))))}}),define(ve[263],we([0,1,77,30,66,264,78,129,16,11,33,2,10,5,49,3,15,4,26,138,92,63,6,13,25,76,32,128,236,237,46,262,239]),function(oe,e,I,t,v,P,k,w,p,D,T,R,E,b,d,C,y,m,g,h,l,f,i,a,n,o,r,s,c,u,S,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.RemoteExtensionHostAgentServer=void 0;const $=5*60*1e3;let Q=class extends R.Disposable{constructor(ne,Z,F,x,z,W,re,V){super();this._socketServer=ne,this._connectionToken=Z,this._vsdaMod=F,this._environmentService=z,this._productService=W,this._logService=re,this._instantiationService=V,this._webEndpointOriginChecker=q.create(this._productService),this._serverRootPath=(0,o.getRemoteServerRootPath)(W),this._extHostConnections=Object.create(null),this._managementConnections=Object.create(null),this._allReconnectionTokens=new Set,this._webClientServer=x?this._instantiationService.createInstance(M.WebClientServer,this._connectionToken):null,this._logService.info("Extension host agent started.")}async handleRequest(ne,Z){if(ne.method!=="GET")return(0,M.serveError)(ne,Z,405,`Unsupported method ${ne.method}`);if(!ne.url)return(0,M.serveError)(ne,Z,400,"Bad request.");const F=k.parse(ne.url,!0);let x=F.pathname;if(!x)return(0,M.serveError)(ne,Z,400,"Bad request.");if(x.startsWith(this._serverRootPath)&&x.charCodeAt(this._serverRootPath.length)===47&&(x=x.substring(this._serverRootPath.length)),x==="/version")return Z.writeHead(200,{"Content-Type":"text/plain"}),Z.end(this._productService.commit||"");if(x==="/delay-shutdown")return this._delayShutdown(),Z.writeHead(200),Z.end("OK");if(!(0,u.requestHasValidConnectionToken)(this._connectionToken,ne,F))return(0,M.serveError)(ne,Z,403,"Forbidden.");if(x==="/vscode-remote-resource"){const z=F.query.path;if(typeof z!="string")return(0,M.serveError)(ne,Z,400,"Bad request.");let W;try{W=m.URI.from({scheme:E.Schemas.file,path:z}).fsPath}catch{return(0,M.serveError)(ne,Z,400,"Bad request.")}const re=Object.create(null);this._environmentService.isBuilt&&((0,T.isEqualOrParent)(W,this._environmentService.builtinExtensionsPath,!C.isLinux)||(0,T.isEqualOrParent)(W,this._environmentService.extensionsPath,!C.isLinux))&&(re["Cache-Control"]="public, max-age=31536000"),re.Vary="Origin";const V=ne.headers.origin;return V&&this._webEndpointOriginChecker.matches(V)&&(re["Access-Control-Allow-Origin"]=V),(0,M.serveFile)(W,1,this._logService,ne,Z,re)}if(this._webClientServer){this._webClientServer.handle(ne,Z,F);return}return Z.writeHead(404,{"Content-Type":"text/plain"}),Z.end("Not found")}handleUpgrade(ne,Z){let F=(0,g.generateUuid)(),x=!1,z=!1;if(ne.url){const ie=k.parse(ne.url,!0).query;typeof ie.reconnectionToken=="string"&&(F=ie.reconnectionToken),ie.reconnection==="true"&&(x=!0),ie.skipWebSocketFrames==="true"&&(z=!0)}if(ne.headers.upgrade===void 0||ne.headers.upgrade.toLowerCase()!=="websocket"){Z.end("HTTP/1.1 400 Bad Request");return}const W=ne.headers["sec-websocket-key"],re=I.createHash("sha1");re.update(W+"258EAFA5-E914-47DA-95CA-C5AB0DC85B11");const V=re.digest("base64"),X=["HTTP/1.1 101 Switching Protocols","Upgrade: websocket","Connection: Upgrade",`Sec-WebSocket-Accept: ${V}`];let ae=!1;if(!z&&!this._environmentService.args["disable-websocket-compression"]&&ne.headers["sec-websocket-extensions"]){const ie=Array.isArray(ne.headers["sec-websocket-extensions"])?ne.headers["sec-websocket-extensions"]:[ne.headers["sec-websocket-extensions"]];for(const O of ie)if(!/\b((server_max_window_bits)|(server_no_context_takeover)|(client_no_context_takeover))\b/.test(O)){if(/\b(permessage-deflate)\b/.test(O)){ae=!0,X.push("Sec-WebSocket-Extensions: permessage-deflate");break}if(/\b(x-webkit-deflate-frame)\b/.test(O)){ae=!0,X.push("Sec-WebSocket-Extensions: x-webkit-deflate-frame");break}}}Z.write(X.join(`\r
`)+`\r
\r
`),Z.setTimeout(0),Z.setNoDelay(!0),z?this._handleWebSocketConnection(new f.NodeSocket(Z,`server-connection-${F}`),x,F):this._handleWebSocketConnection(new f.WebSocketNodeSocket(new f.NodeSocket(Z,`server-connection-${F}`),ae,null,!0),x,F)}handleServerError(ne){this._logService.error("Error occurred in server"),this._logService.error(ne)}_getRemoteAddress(ne){let Z;return ne instanceof f.NodeSocket?Z=ne.socket:Z=ne.socket.socket,Z.remoteAddress||"<unknown>"}async _rejectWebSocketConnection(ne,Z,F){const x=Z.getSocket();this._logService.error(`${ne} ${F}.`);const z={type:"error",reason:F};Z.sendControl(p.VSBuffer.fromString(JSON.stringify(z))),Z.dispose(),await x.drain(),x.dispose()}_handleWebSocketConnection(ne,Z,F){const x=this._getRemoteAddress(ne),z=`[${x}][${F.substr(0,8)}]`,W=new l.PersistentProtocol(ne),re=this._vsdaMod?new this._vsdaMod.validator:null,V=this._vsdaMod?new this._vsdaMod.signer:null;let X;(function(B){B[B.WaitingForAuth=0]="WaitingForAuth",B[B.WaitingForConnectionType=1]="WaitingForConnectionType",B[B.Done=2]="Done",B[B.Error=3]="Error"})(X||(X={}));let ae=0;const ie=B=>{ae=3,O.dispose(),this._rejectWebSocketConnection(z,W,B)},O=W.onControlMessage(B=>{if(ae===0){let ee;try{ee=JSON.parse(B.toString())}catch{return ie("Malformed first message")}if(ee.type!=="auth")return ie("Invalid first message");if(this._connectionToken.type===2&&!this._connectionToken.validate(ee.auth))return ie("Unauthorized client refused: auth mismatch");let ce=(0,g.generateUuid)();if(V)try{ce=V.sign(ee.data)}catch{}let K=(0,g.generateUuid)();if(re)try{K=re.createNewMessage(K)}catch{}const he={type:"sign",data:K,signedData:ce};W.sendControl(p.VSBuffer.fromString(JSON.stringify(he))),ae=1}else if(ae===1){let ee;try{ee=JSON.parse(B.toString())}catch{return ie("Malformed second message")}if(ee.type!=="connectionType")return ie("Invalid second message");if(typeof ee.signedData!="string")return ie("Invalid second message field type");const ce=ee.commit,K=this._productService.commit;if(ce&&K&&ce!==K)return ie("Client refused: version mismatch");let he=!1;if(!re)he=!0;else if(this._connectionToken.validate(ee.signedData))he=!0;else try{he=re.validate(ee.signedData)==="ok"}catch{}if(!he){if(this._environmentService.isBuilt)return ie("Unauthorized client refused");this._logService.error(`${z} Unauthorized client handshake failed but we proceed because of dev mode.`)}for(const te in this._managementConnections)this._managementConnections[te].shortenReconnectionGraceTimeIfNecessary();for(const te in this._extHostConnections)this._extHostConnections[te].shortenReconnectionGraceTimeIfNecessary();ae=2,O.dispose(),this._handleConnectionType(x,z,W,ne,Z,F,ee)}})}async _handleConnectionType(ne,Z,F,x,z,W,re){const V=re.desiredConnectionType===1?`${Z}[ManagementConnection]`:re.desiredConnectionType===2?`${Z}[ExtensionHostConnection]`:Z;if(re.desiredConnectionType===1)if(z){if(!this._managementConnections[W])return this._allReconnectionTokens.has(W)?this._rejectWebSocketConnection(V,F,"Unknown reconnection token (seen before)"):this._rejectWebSocketConnection(V,F,"Unknown reconnection token (never seen)");F.sendControl(p.VSBuffer.fromString(JSON.stringify({type:"ok"})));const X=F.readEntireBuffer();F.dispose(),this._managementConnections[W].acceptReconnection(ne,x,X)}else{if(this._managementConnections[W])return this._rejectWebSocketConnection(V,F,"Duplicate reconnection token");F.sendControl(p.VSBuffer.fromString(JSON.stringify({type:"ok"})));const X=new c.ManagementConnection(this._logService,W,ne,F);this._socketServer.acceptConnection(X.protocol,X.onClose),this._managementConnections[W]=X,this._allReconnectionTokens.add(W),X.onClose(()=>{delete this._managementConnections[W]})}else if(re.desiredConnectionType===2){const X=re.args||{language:"en"},ae=await this._updateWithFreeDebugPort(X);if(ae.port&&this._logService.trace(`${V} - startParams debug port ${ae.port}`),this._logService.trace(`${V} - startParams language: ${ae.language}`),this._logService.trace(`${V} - startParams env: ${JSON.stringify(ae.env)}`),z){if(!this._extHostConnections[W])return this._allReconnectionTokens.has(W)?this._rejectWebSocketConnection(V,F,"Unknown reconnection token (seen before)"):this._rejectWebSocketConnection(V,F,"Unknown reconnection token (never seen)");F.sendPause(),F.sendControl(p.VSBuffer.fromString(JSON.stringify(ae.port?{debugPort:ae.port}:{})));const ie=F.readEntireBuffer();F.dispose(),this._extHostConnections[W].acceptReconnection(ne,x,ie)}else{if(this._extHostConnections[W])return this._rejectWebSocketConnection(V,F,"Duplicate reconnection token");F.sendPause(),F.sendControl(p.VSBuffer.fromString(JSON.stringify(ae.port?{debugPort:ae.port}:{})));const ie=F.readEntireBuffer();F.dispose();const O=this._instantiationService.createInstance(s.ExtensionHostConnection,W,ne,x,ie);this._extHostConnections[W]=O,this._allReconnectionTokens.add(W),O.onClose(()=>{delete this._extHostConnections[W],this._onDidCloseExtHostConnection()}),O.start(ae)}}else if(re.desiredConnectionType===3){const X=re.args;this._createTunnel(F,X)}else return this._rejectWebSocketConnection(V,F,"Unknown initial data received")}async _createTunnel(ne,Z){const F=ne.getSocket().socket,x=ne.readEntireBuffer();ne.dispose(),F.pause();const z=await this._connectTunnelSocket(Z.host,Z.port);x.byteLength>0&&z.write(x.buffer),z.on("end",()=>F.end()),z.on("close",()=>F.end()),z.on("error",()=>F.destroy()),F.on("end",()=>z.end()),F.on("close",()=>z.end()),F.on("error",()=>z.destroy()),z.pipe(F),F.pipe(z)}_connectTunnelSocket(ne,Z){return new Promise((F,x)=>{const z=v.createConnection({host:ne,port:Z},()=>{z.removeListener("error",x),z.pause(),F(z)});z.once("error",x)})}_updateWithFreeDebugPort(ne){return typeof ne.port=="number"?(0,h.findFreePort)(ne.port,10,5e3).then(Z=>(ne.port=Z,ne)):(ne.debugId=void 0,ne.port=void 0,ne.break=void 0,Promise.resolve(ne))}async _onDidCloseExtHostConnection(){if(!this._environmentService.args["enable-remote-auto-shutdown"])return;this._cancelShutdown(),!!Object.keys(this._extHostConnections).length||(console.log("Last EH closed, waiting before shutting down"),this._logService.info("Last EH closed, waiting before shutting down"),this._waitThenShutdown())}_waitThenShutdown(){!this._environmentService.args["enable-remote-auto-shutdown"]||(this._environmentService.args["remote-auto-shutdown-without-delay"]?this._shutdown():this.shutdownTimer=setTimeout(()=>{this.shutdownTimer=void 0,this._shutdown()},$))}_shutdown(){if(!!Object.keys(this._extHostConnections).length){console.log("New EH opened, aborting shutdown"),this._logService.info("New EH opened, aborting shutdown");return}else console.log("Last EH closed, shutting down"),this._logService.info("Last EH closed, shutting down"),this.dispose(),process.exit(0)}_delayShutdown(){this.shutdownTimer&&(console.log("Got delay-shutdown request while in shutdown timeout, delaying"),this._logService.info("Got delay-shutdown request while in shutdown timeout, delaying"),this._cancelShutdown(),this._waitThenShutdown())}_cancelShutdown(){this.shutdownTimer&&(console.log("Cancelling previous shutdown timeout"),this._logService.info("Cancelling previous shutdown timeout"),clearTimeout(this.shutdownTimer),this.shutdownTimer=void 0)}};Q=Re([_e(4,S.IServerEnvironmentService),_e(5,n.IProductService),_e(6,a.ILogService),_e(7,i.IInstantiationService)],Q),e.RemoteExtensionHostAgentServer=Q;async function _(U,ne,Z){const F=await(0,u.determineServerConnectionToken)(ne);F instanceof u.ServerConnectionTokenParseError&&(console.warn(F.message),process.exit(1));const x=new R.DisposableStore,{socketServer:z,instantiationService:W}=await(0,A.setupServerServices)(F,ne,Z,x);W.invokeFunction(ee=>{const ce=ee.get(a.ILogService);(0,D.setUnexpectedErrorHandler)(K=>{K&&K.code==="EPIPE"&&K.syscall==="write"&&K.stack&&/unexpectedErrorHandler/.test(K.stack)||ce.error(K)}),process.on("SIGPIPE",()=>{(0,D.onUnexpectedError)(new Error("Unexpected SIGPIPE"))})}),W.invokeFunction(ee=>{const ce=ee.get(a.ILogService);if(process.platform==="win32"&&process.env.HOMEDRIVE&&process.env.HOMEPATH){const K=(0,b.join)(process.env.HOMEDRIVE,"node_modules"),he=(0,b.dirname)((0,b.join)(process.env.HOMEDRIVE,process.env.HOMEPATH)),te=(0,b.join)(he,"node_modules");if(t.existsSync(K)||t.existsSync(te)){const le=`

*
* !!!! Server terminated due to presence of CVE-2020-1416 !!!!
*
* Please remove the following directories and re-try
* ${K}
* ${te}
*
* For more information on the vulnerability https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2020-1416
*

`;ce.warn(le),console.warn(le),process.exit(0)}}});const re=W.invokeFunction(ee=>{const ce=ee.get(a.ILogService);if(t.existsSync((0,b.join)(E.FileAccess.asFileUri("",oe).fsPath,"../node_modules/vsda")))try{return oe.__$__nodeRequire("vsda")}catch(he){ce.error(he)}return null}),V=t.existsSync(E.FileAccess.asFileUri("vs/code/browser/workbench/workbench.html",oe).fsPath);if(V&&U&&typeof U!="string"){const ee=F.type!==0?`?${E.connectionTokenQueryName}=${F.value}`:"";console.log(`Web UI available at http://localhost${U.port===80?"":`:${U.port}`}/${ee}`)}const X=W.createInstance(Q,z,F,re,V);d.mark("code/server/ready");const ae=P.performance.now(),ie=global.vscodeServerStartTime,O=global.vscodeServerListenTime,B=global.vscodeServerCodeLoadedTime;if(W.invokeFunction(ee=>{ee.get(r.ITelemetryService).publicLog2("serverStart",{startTime:ie,startedTime:O,codeLoadedTime:B,readyTime:ae})}),ne["print-startup-performance"]){const ee=w.LoaderStats.get();let ce="";ce+=`

### Load AMD-module
`,ce+=w.LoaderStats.toMarkdownTable(["Module","Duration"],ee.amdLoad),ce+=`

### Load commonjs-module
`,ce+=w.LoaderStats.toMarkdownTable(["Module","Duration"],ee.nodeRequire),ce+=`

### Invoke AMD-module factory
`,ce+=w.LoaderStats.toMarkdownTable(["Module","Duration"],ee.amdInvoke),ce+=`

### Invoke commonjs-module
`,ce+=w.LoaderStats.toMarkdownTable(["Module","Duration"],ee.nodeEval),ce+=`Start-up time: ${O-ie}
`,ce+=`Code loading time: ${B-ie}
`,ce+=`Initialized time: ${ae-ie}
`,ce+=`
`,console.log(ce)}return X}e.createServer=_;class q{constructor(ne){this._originRegExp=ne}static create(ne){const Z=ne.webEndpointUrlTemplate,F=ne.commit,x=ne.quality;if(!Z||!F||!x)return new q(null);const z=(0,g.generateUuid)(),re=new URL(Z.replace("{{uuid}}",z).replace("{{commit}}",F).replace("{{quality}}",x)).origin,V=(0,y.escapeRegExpCharacters)(re).replace(z,"[a-zA-Z0-9\\-]+");try{const X=(0,y.createRegExp)(`^${V}$`,!0,{matchCase:!1});return new q(X)}catch{return new q(null)}}matches(ne){return this._originRegExp?this._originRegExp.test(ne):!1}}}),define(ve[273],we([0,1,27,30,10,259,263,57,5,264,46,52,49]),function(oe,e,I,t,v,P,k,w,p,D,T,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.spawnCli=void 0,E.mark("code/server/codeLoaded"),global.vscodeServerCodeLoadedTime=D.performance.now();const b={onMultipleValues:(o,r)=>{console.error(`Option '${o}' can only be defined once. Using value ${r}.`)},onEmptyValue:o=>{console.error(`Ignoring option '${o}': Value must not be empty.`)},onUnknownOption:o=>{console.error(`Ignoring option '${o}': not supported for server.`)},onDeprecatedOption:(o,r)=>{console.warn(`Option '${o}' is deprecated: ${r}`)}},d=(0,w.parseArgs)(process.argv.slice(2),T.serverOptions,b),C=d["server-data-dir"]||process.env.VSCODE_AGENT_FOLDER||(0,p.join)(I.homedir(),R.default.serverDataFolderName||".vscode-remote"),y=(0,p.join)(C,"data"),m=(0,p.join)(y,"User"),g=(0,p.join)(m,"globalStorage"),h=(0,p.join)(m,"History"),l=(0,p.join)(y,"Machine");d["user-data-dir"]=y;const f=(0,p.dirname)(v.FileAccess.asFileUri("",oe).fsPath),i=(0,p.join)(f,"extensions");d["builtin-extensions-dir"]=i,d["extensions-dir"]=d["extensions-dir"]||(0,p.join)(C,"extensions"),[C,d["extensions-dir"],y,m,l,g,h].forEach(o=>{try{t.existsSync(o)||t.mkdirSync(o,{mode:448})}catch(r){console.error(r)}});function a(){(0,P.run)(d,C,T.serverOptions)}e.spawnCli=a;function n(o){return(0,k.createServer)(o,d,C)}e.createServer=n})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/b06ae3b2d2dbfe28bca3134cc6be65935cdfea6a/core/vs/server/node/server.main.js.map
