/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ie=["exports","require","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/types","vs/base/common/network","vs/base/common/errors","vs/base/common/platform","vs/platform/log/common/log","vs/workbench/api/common/extHostTypeConverters","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/async","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/buffer","vs/base/common/objects","vs/base/common/map","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/platform/extensions/common/extensions","vs/base/node/pfs","vs/base/common/extpath","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/uuid","vs/editor/common/core/range","vs/base/common/glob","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/process","vs/base/common/severity","child_process","vs/platform/files/common/files","vs/platform/registry/common/platform","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/editor/common/core/position","vs/base/common/errorMessage","vs/base/common/stopwatch","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTunnelService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/base/common/assert","vs/base/common/decorators","vs/base/common/functional","vs/base/common/iterator","vs/base/common/hash","vs/base/common/marshalling","fs","os","vs/editor/common/languages","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/codicons","vs/base/common/collections","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/normalization","vs/platform/instantiation/common/extensions","vs/platform/configuration/common/configuration","vs/platform/extensionManagement/common/extensionManagement","vs/platform/instantiation/common/serviceCollection","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/common/webview","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/stream","vs/base/common/uint","string_decoder","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/mime","vs/base/common/processes","vs/base/common/filters","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/uriIpc","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/services/semanticTokensDto","vs/base/node/processes","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/platform/tunnel/common/tunnel","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/json","vs/base/common/marked/marked","vs/base/node/decoder","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/iconLabels","vs/editor/common/languageSelector","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/uriTransformer","vs/workbench/common/editor","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/textfile/common/encoding","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","https","tls","vscode-proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],ke=function(Q){for(var e=[],u=0,n=Q.length;u<n;u++)e[u]=Ie[Q[u]];return e};define(Ie[56],ke([1,0]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function u(n,y){if(!n)throw new Error(y?`Assertion failed (${y})`:"Assertion Failed")}e.ok=u}),define(Ie[77],ke([1,0]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function u(D){return D?D.replace(/\$\((.*?)\)/g,(C,S)=>` ${S} `).trim():""}e.getCodiconAriaLabel=u;class n{constructor(C,S,P){this.id=C,this.definition=S,this.description=P,n._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return n._allCodicons}}e.Codicon=n,n._allCodicons=[],n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",n.add.definition),n.gistNew=new n("gist-new",n.add.definition),n.repoCreate=new n("repo-create",n.add.definition),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolCustomColor=new n("symbol-customcolor",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.circleSmallFilled=new n("circle-small-filled",{fontCharacter:"\\eb8a"}),n.debugStackframeDot=new n("debug-stackframe-dot",n.circleSmallFilled.definition),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.runErrors=new n("run-errors",{fontCharacter:"\\ebde"}),n.folderLibrary=new n("folder-library",{fontCharacter:"\\ebdf"}),n.debugContinueSmall=new n("debug-continue-small",{fontCharacter:"\\ebe0"}),n.beakerStop=new n("beaker-stop",{fontCharacter:"\\ebe1"}),n.graphLine=new n("graph-line",{fontCharacter:"\\ebe2"}),n.graphScatter=new n("graph-scatter",{fontCharacter:"\\ebe3"}),n.pieChart=new n("pie-chart",{fontCharacter:"\\ebe4"}),n.bracket=new n("bracket",n.json.definition),n.bracketDot=new n("bracket-dot",{fontCharacter:"\\ebe5"}),n.bracketError=new n("bracket-error",{fontCharacter:"\\ebe6"}),n.lockSmall=new n("lock-small",{fontCharacter:"\\ebe7"}),n.azureDevops=new n("azure-devops",{fontCharacter:"\\ebe8"}),n.verifiedFilled=new n("verified-filled",{fontCharacter:"\\ebe9"}),n.newLine=new n("newline",{fontCharacter:"\\ebea"}),n.layout=new n("layout",{fontCharacter:"\\ebeb"}),n.layoutActivitybarLeft=new n("layout-activitybar-left",{fontCharacter:"\\ebec"}),n.layoutActivitybarRight=new n("layout-activitybar-right",{fontCharacter:"\\ebed"}),n.layoutPanelLeft=new n("layout-panel-left",{fontCharacter:"\\ebee"}),n.layoutPanelCenter=new n("layout-panel-center",{fontCharacter:"\\ebef"}),n.layoutPanelJustify=new n("layout-panel-justify",{fontCharacter:"\\ebf0"}),n.layoutPanelRight=new n("layout-panel-right",{fontCharacter:"\\ebf1"}),n.layoutPanel=new n("layout-panel",{fontCharacter:"\\ebf2"}),n.layoutSidebarLeft=new n("layout-sidebar-left",{fontCharacter:"\\ebf3"}),n.layoutSidebarRight=new n("layout-sidebar-right",{fontCharacter:"\\ebf4"}),n.layoutStatusbar=new n("layout-statusbar",{fontCharacter:"\\ebf5"}),n.layoutMenubar=new n("layout-menubar",{fontCharacter:"\\ebf6"}),n.layoutCentered=new n("layout-centered",{fontCharacter:"\\ebf7"}),n.layoutSidebarRightOff=new n("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),n.layoutPanelOff=new n("layout-panel-off",{fontCharacter:"\\ec01"}),n.layoutSidebarLeftOff=new n("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),n.target=new n("target",{fontCharacter:"\\ebf8"}),n.indent=new n("indent",{fontCharacter:"\\ebf9"}),n.recordSmall=new n("record-small",{fontCharacter:"\\ebfa"}),n.errorSmall=new n("error-small",{fontCharacter:"\\ebfb"}),n.arrowCircleDown=new n("arrow-circle-down",{fontCharacter:"\\ebfc"}),n.arrowCircleLeft=new n("arrow-circle-left",{fontCharacter:"\\ebfd"}),n.arrowCircleRight=new n("arrow-circle-right",{fontCharacter:"\\ebfe"}),n.arrowCircleUp=new n("arrow-circle-up",{fontCharacter:"\\ebff"}),n.heartFilled=new n("heart-filled",{fontCharacter:"\\ec04"}),n.map=new n("map",{fontCharacter:"\\ec05"}),n.mapFilled=new n("map-filled",{fontCharacter:"\\ec06"}),n.circleSmall=new n("circle-small",{fontCharacter:"\\ec07"}),n.bellSlash=new n("bell-slash",{fontCharacter:"\\ec08"}),n.bellSlashDot=new n("bell-slash-dot",{fontCharacter:"\\f101"}),n.dialogError=new n("dialog-error",n.error.definition),n.dialogWarning=new n("dialog-warning",n.warning.definition),n.dialogInfo=new n("dialog-info",n.info.definition),n.dialogClose=new n("dialog-close",n.close.definition),n.treeItemExpanded=new n("tree-item-expanded",n.chevronDown.definition),n.treeFilterOnTypeOn=new n("tree-filter-on-type-on",n.listFilter.definition),n.treeFilterOnTypeOff=new n("tree-filter-on-type-off",n.listSelection.definition),n.treeFilterClear=new n("tree-filter-clear",n.close.definition),n.treeItemLoading=new n("tree-item-loading",n.loading.definition),n.menuSelection=new n("menu-selection",n.check.definition),n.menuSubmenu=new n("menu-submenu",n.chevronRight.definition),n.menuBarMore=new n("menubar-more",n.more.definition),n.scrollbarButtonLeft=new n("scrollbar-button-left",n.triangleLeft.definition),n.scrollbarButtonRight=new n("scrollbar-button-right",n.triangleRight.definition),n.scrollbarButtonUp=new n("scrollbar-button-up",n.triangleUp.definition),n.scrollbarButtonDown=new n("scrollbar-button-down",n.triangleDown.definition),n.toolBarMore=new n("toolbar-more",n.more.definition),n.quickInputBack=new n("quick-input-back",n.arrowLeft.definition);function y(D,C){const S=["codicon","codicon-"+D];return C&&S.push("codicon-modifier-"+C),S}e.getClassNamesArray=y;var A;(function(D){D.iconNameSegment="[A-Za-z0-9]+",D.iconNameExpression="[A-Za-z0-9-]+",D.iconModifierExpression="~[A-Za-z]+",D.iconNameCharacter="[A-Za-z0-9~-]";const C=new RegExp(`^(${D.iconNameExpression})(${D.iconModifierExpression})?$`);function S(I){if(I instanceof n)return["codicon","codicon-"+I.id];const _=C.exec(I.id);if(!_)return S(n.error);const[,T,w]=_,b=["codicon","codicon-"+T];return w&&b.push("codicon-modifier-"+w.substr(1)),b}D.asClassNameArray=S;function P(I){return S(I).join(" ")}D.asClassName=P;function L(I){return"."+S(I).join(".")}D.asCSSSelector=L})(A=e.CSSIcon||(e.CSSIcon={}))}),define(Ie[78],ke([1,0]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=e.forEach=void 0;function u(C,S){for(const[P,L]of Object.entries(C))if(S({key:P,value:L})===!1)return}e.forEach=u;function n(C,S){const P=Object.create(null);for(const L of C){const I=S(L);let _=P[I];_||(_=P[I]=[]),_.push(L)}return P}e.groupBy=n;function y(C,S){const P=[],L=[];for(const I of C)S.has(I)||P.push(I);for(const I of S)C.has(I)||L.push(I);return{removed:P,added:L}}e.diffSets=y;function A(C,S){const P=[],L=[];for(const[I,_]of C)S.has(I)||P.push(_);for(const[I,_]of S)C.has(I)||L.push(_);return{removed:P,added:L}}e.diffMaps=A;class D{constructor(){this.map=new Map}add(S,P){let L=this.map.get(S);L||(L=new Set,this.map.set(S,L)),L.add(P)}delete(S,P){const L=this.map.get(S);!L||(L.delete(P),L.size===0&&this.map.delete(S))}forEach(S,P){const L=this.map.get(S);!L||L.forEach(P)}}e.SetMap=D}),define(Ie[57],ke([1,0]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function u(D){return(C,S,P)=>{let L=null,I=null;if(typeof P.value=="function"?(L="value",I=P.value):typeof P.get=="function"&&(L="get",I=P.get),!I)throw new Error("not supported");P[L]=D(I,S)}}e.createDecorator=u;function n(D,C,S){let P=null,L=null;if(typeof S.value=="function"?(P="value",L=S.value,L.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(P="get",L=S.get),!L)throw new Error("not supported");const I=`$memoize$${C}`;S[P]=function(..._){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:L.apply(this,_)}),this[I]}}e.memoize=n;function y(D,C,S){return u((P,L)=>{const I=`$debounce$${L}`,_=`$debounce$result$${L}`;return function(...T){this[_]||(this[_]=S?S():void 0),clearTimeout(this[I]),C&&(this[_]=C(this[_],...T),T=[this[_]]),this[I]=setTimeout(()=>{P.apply(this,T),this[_]=S?S():void 0},D)}})}e.debounce=y;function A(D,C,S){return u((P,L)=>{const I=`$throttle$timer$${L}`,_=`$throttle$result$${L}`,T=`$throttle$lastRun$${L}`,w=`$throttle$pending$${L}`;return function(...b){if(this[_]||(this[_]=S?S():void 0),(this[T]===null||this[T]===void 0)&&(this[T]=-Number.MAX_VALUE),C&&(this[_]=C(this[_],...b)),this[w])return;const p=this[T]+D;p<=Date.now()?(this[T]=Date.now(),P.apply(this,[this[_]]),this[_]=S?S():void 0):(this[w]=!0,this[I]=setTimeout(()=>{this[w]=!1,this[T]=Date.now(),P.apply(this,[this[_]]),this[_]=S?S():void 0},p-Date.now()))}})}e.throttle=A}),define(Ie[12],ke([1,0]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class u{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(o){setTimeout(()=>{throw o.stack?f.isErrorNoTelemetry(o)?new f(o.message+`

`+o.stack):new Error(o.message+`

`+o.stack):o},0)}}addListener(o){return this.listeners.push(o),()=>{this._removeListener(o)}}emit(o){this.listeners.forEach(d=>{d(o)})}_removeListener(o){this.listeners.splice(this.listeners.indexOf(o),1)}setUnexpectedErrorHandler(o){this.unexpectedErrorHandler=o}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(o){this.unexpectedErrorHandler(o),this.emit(o)}onUnexpectedExternalError(o){this.unexpectedErrorHandler(o)}}e.ErrorHandler=u,e.errorHandler=new u;function n(m){e.errorHandler.setUnexpectedErrorHandler(m)}e.setUnexpectedErrorHandler=n;function y(m){S(m)||e.errorHandler.onUnexpectedError(m)}e.onUnexpectedError=y;function A(m){S(m)||e.errorHandler.onUnexpectedExternalError(m)}e.onUnexpectedExternalError=A;function D(m){if(m instanceof Error){const{name:o,message:d}=m,r=m.stacktrace||m.stack;return{$isError:!0,name:o,message:d,stack:r,noTelemetry:f.isErrorNoTelemetry(m)}}return m}e.transformErrorForSerialization=D;const C="Canceled";function S(m){return m instanceof P?!0:m instanceof Error&&m.name===C&&m.message===C}e.isCancellationError=S;class P extends Error{constructor(){super(C);this.name=this.message}}e.CancellationError=P;function L(){const m=new Error(C);return m.name=m.message,m}e.canceled=L;function I(m){return m?new Error(`Illegal argument: ${m}`):new Error("Illegal argument")}e.illegalArgument=I;function _(m){return m?new Error(`Illegal state: ${m}`):new Error("Illegal state")}e.illegalState=_;function T(m){return m?new Error(`readonly property '${m} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=T;function w(m){const o=new Error(`${m} has been disposed`);return o.name="DISPOSED",o}e.disposed=w;function b(m){return m?m.message?m.message:m.stack?m.stack.split(`
`)[0]:String(m):"Error"}e.getErrorMessage=b;class p extends Error{constructor(o){super("NotImplemented");o&&(this.message=o)}}e.NotImplementedError=p;class g extends Error{constructor(o){super("NotSupported");o&&(this.message=o)}}e.NotSupportedError=g;class v extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=v;class f extends Error{constructor(o){super(o);this.name="ErrorNoTelemetry"}static fromError(o){if(o instanceof f)return o;const d=new f;return d.message=o.message,d.stack=o.stack,d}static isErrorNoTelemetry(o){return o.name==="ErrorNoTelemetry"}}e.ErrorNoTelemetry=f;class a extends Error{constructor(o){super(o||"An unexpected bug occurred.");Object.setPrototypeOf(this,a.prototype);debugger}}e.BugIndicatingError=a}),define(Ie[16],ke([1,0,12]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function n(pe,Pe=0){return pe[pe.length-(1+Pe)]}e.tail=n;function y(pe){if(pe.length===0)throw new Error("Invalid tail call");return[pe.slice(0,pe.length-1),pe[pe.length-1]]}e.tail2=y;function A(pe,Pe,fe=(ve,_e)=>ve===_e){if(pe===Pe)return!0;if(!pe||!Pe||pe.length!==Pe.length)return!1;for(let ve=0,_e=pe.length;ve<_e;ve++)if(!fe(pe[ve],Pe[ve]))return!1;return!0}e.equals=A;function D(pe,Pe,fe){return C(pe.length,ve=>fe(pe[ve],Pe))}e.binarySearch=D;function C(pe,Pe){let fe=0,ve=pe-1;for(;fe<=ve;){const _e=(fe+ve)/2|0,ae=Pe(_e);if(ae<0)fe=_e+1;else if(ae>0)ve=_e-1;else return _e}return-(fe+1)}e.binarySearch2=C;function S(pe,Pe){let fe=0,ve=pe.length;if(ve===0)return 0;for(;fe<ve;){const _e=Math.floor((fe+ve)/2);Pe(pe[_e])?ve=_e:fe=_e+1}return fe}e.findFirstInSorted=S;function P(pe,Pe,fe){if(pe=pe|0,pe>=Pe.length)throw new TypeError("invalid index");const ve=Pe[Math.floor(Pe.length*Math.random())],_e=[],ae=[],he=[];for(const te of Pe){const ie=fe(te,ve);ie<0?_e.push(te):ie>0?ae.push(te):he.push(te)}return pe<_e.length?P(pe,_e,fe):pe<_e.length+he.length?he[0]:P(pe-(_e.length+he.length),ae,fe)}e.quickSelect=P;function L(pe,Pe){const fe=[];let ve;for(const _e of pe.slice(0).sort(Pe))!ve||Pe(ve[0],_e)!==0?(ve=[_e],fe.push(ve)):ve.push(_e);return fe}e.groupBy=L;function I(pe,Pe,fe){const ve=[];function _e(te,ie,M){if(ie===0&&M.length===0)return;const H=ve[ve.length-1];H&&H.start+H.deleteCount===te?(H.deleteCount+=ie,H.toInsert.push(...M)):ve.push({start:te,deleteCount:ie,toInsert:M})}let ae=0,he=0;for(;;){if(ae===pe.length){_e(ae,0,Pe.slice(he));break}if(he===Pe.length){_e(ae,pe.length-ae,[]);break}const te=pe[ae],ie=Pe[he],M=fe(te,ie);M===0?(ae+=1,he+=1):M<0?(_e(ae,1,[]),ae+=1):M>0&&(_e(ae,0,[ie]),he+=1)}return ve}e.sortedDiff=I;function _(pe,Pe,fe){const ve=I(pe,Pe,fe),_e=[],ae=[];for(const he of ve)_e.push(...pe.slice(he.start,he.start+he.deleteCount)),ae.push(...he.toInsert);return{removed:_e,added:ae}}e.delta=_;function T(pe,Pe,fe){if(fe===0)return[];const ve=pe.slice(0,fe).sort(Pe);return b(pe,Pe,ve,fe,pe.length),ve}e.top=T;function w(pe,Pe,fe,ve,_e){return fe===0?Promise.resolve([]):new Promise((ae,he)=>{(async()=>{const te=pe.length,ie=pe.slice(0,fe).sort(Pe);for(let M=fe,H=Math.min(fe+ve,te);M<te;M=H,H=Math.min(H+ve,te)){if(M>fe&&await new Promise(G=>setTimeout(G)),_e&&_e.isCancellationRequested)throw new u.CancellationError;b(pe,Pe,ie,M,H)}return ie})().then(ae,he)})}e.topAsync=w;function b(pe,Pe,fe,ve,_e){for(const ae=fe.length;ve<_e;ve++){const he=pe[ve];if(Pe(he,fe[ae-1])<0){fe.pop();const te=S(fe,ie=>Pe(he,ie)<0);fe.splice(te,0,he)}}}function p(pe){return pe.filter(Pe=>!!Pe)}e.coalesce=p;function g(pe){let Pe=0;for(let fe=0;fe<pe.length;fe++)pe[fe]&&(pe[Pe]=pe[fe],Pe+=1);pe.length=Pe}e.coalesceInPlace=g;function v(pe,Pe,fe){pe.splice(fe,0,pe.splice(Pe,1)[0])}e.move=v;function f(pe){return!Array.isArray(pe)||pe.length===0}e.isFalsyOrEmpty=f;function a(pe){return Array.isArray(pe)&&pe.length>0}e.isNonEmptyArray=a;function m(pe,Pe=fe=>fe){const fe=new Set;return pe.filter(ve=>{const _e=Pe(ve);return fe.has(_e)?!1:(fe.add(_e),!0)})}e.distinct=m;function o(pe){const Pe=new Set;return fe=>{const ve=pe(fe);return Pe.has(ve)?!1:(Pe.add(ve),!0)}}e.uniqueFilter=o;function d(pe,Pe){const fe=r(pe,Pe);if(fe!==-1)return pe[fe]}e.findLast=d;function r(pe,Pe){for(let fe=pe.length-1;fe>=0;fe--){const ve=pe[fe];if(Pe(ve))return fe}return-1}e.lastIndex=r;function s(pe,Pe){return pe.length>0?pe[0]:Pe}e.firstOrDefault=s;function i(pe,Pe){return pe.length>0?pe[pe.length-1]:Pe}e.lastOrDefault=i;function t(pe,Pe,fe=(ve,_e)=>ve===_e){let ve=0;for(let _e=0,ae=Math.min(pe.length,Pe.length);_e<ae&&fe(pe[_e],Pe[_e]);_e++)ve++;return ve}e.commonPrefixLength=t;function c(pe){return[].concat(...pe)}e.flatten=c;function l(pe,Pe){let fe=typeof Pe=="number"?pe:0;typeof Pe=="number"?fe=pe:(fe=0,Pe=pe);const ve=[];if(fe<=Pe)for(let _e=fe;_e<Pe;_e++)ve.push(_e);else for(let _e=fe;_e>Pe;_e--)ve.push(_e);return ve}e.range=l;function h(pe,Pe,fe){return pe.reduce((ve,_e)=>(ve[Pe(_e)]=fe?fe(_e):_e,ve),Object.create(null))}e.index=h;function E(pe,Pe){return pe.push(Pe),()=>R(pe,Pe)}e.insert=E;function R(pe,Pe){const fe=pe.indexOf(Pe);if(fe>-1)return pe.splice(fe,1),Pe}e.remove=R;function N(pe,Pe,fe){const ve=pe.slice(0,Pe),_e=pe.slice(Pe);return ve.concat(fe,_e)}e.arrayInsert=N;function O(pe,Pe){let fe;if(typeof Pe=="number"){let ve=Pe;fe=()=>{const _e=Math.sin(ve++)*179426549;return _e-Math.floor(_e)}}else fe=Math.random;for(let ve=pe.length-1;ve>0;ve-=1){const _e=Math.floor(fe()*(ve+1)),ae=pe[ve];pe[ve]=pe[_e],pe[_e]=ae}}e.shuffle=O;function k(pe,Pe){const fe=pe.indexOf(Pe);fe>-1&&(pe.splice(fe,1),pe.unshift(Pe))}e.pushToStart=k;function U(pe,Pe){const fe=pe.indexOf(Pe);fe>-1&&(pe.splice(fe,1),pe.push(Pe))}e.pushToEnd=U;function F(pe,Pe){for(const fe of Pe)pe.push(fe)}e.pushMany=F;function $(pe,Pe){return Array.isArray(pe)?pe.map(Pe):Pe(pe)}e.mapArrayOrNot=$;function ee(pe){return Array.isArray(pe)?pe:[pe]}e.asArray=ee;function B(pe){return pe[Math.floor(Math.random()*pe.length)]}e.getRandomElement=B;function z(pe,Pe){for(const fe of pe){const ve=Pe(fe);if(ve!==void 0)return ve}}e.mapFind=z;function q(pe,Pe,fe){const ve=j(pe,Pe),_e=pe.length,ae=fe.length;pe.length=_e+ae;for(let he=_e-1;he>=ve;he--)pe[he+ae]=pe[he];for(let he=0;he<ae;he++)pe[he+ve]=fe[he]}e.insertInto=q;function V(pe,Pe,fe,ve){const _e=j(pe,Pe),ae=pe.splice(_e,fe);return q(pe,_e,ve),ae}e.splice=V;function j(pe,Pe){return Pe<0?Math.max(Pe+pe.length,0):Math.min(Pe,pe.length)}var ne;(function(pe){function Pe(_e){return _e<0}pe.isLessThan=Pe;function fe(_e){return _e>0}pe.isGreaterThan=fe;function ve(_e){return _e===0}pe.isNeitherLessOrGreaterThan=ve,pe.greaterThan=1,pe.lessThan=-1,pe.neitherLessOrGreaterThan=0})(ne=e.CompareResult||(e.CompareResult={}));function Y(pe,Pe){return(fe,ve)=>Pe(pe(fe),pe(ve))}e.compareBy=Y;function le(...pe){return(Pe,fe)=>{for(const ve of pe){const _e=ve(Pe,fe);if(!ne.isNeitherLessOrGreaterThan(_e))return _e}return ne.neitherLessOrGreaterThan}}e.tieBreakComparators=le;const ue=(pe,Pe)=>pe-Pe;e.numberComparator=ue;function K(pe,Pe){if(pe.length===0)return;let fe=pe[0];for(let ve=1;ve<pe.length;ve++){const _e=pe[ve];Pe(_e,fe)>0&&(fe=_e)}return fe}e.findMaxBy=K;function ge(pe,Pe){if(pe.length===0)return;let fe=pe[0];for(let ve=1;ve<pe.length;ve++){const _e=pe[ve];Pe(_e,fe)>=0&&(fe=_e)}return fe}e.findLastMaxBy=ge;function ye(pe,Pe){return K(pe,(fe,ve)=>-Pe(fe,ve))}e.findMinBy=ye;class Te{constructor(Pe){this.items=Pe,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(Pe){let fe=this.firstIdx;for(;fe<this.items.length&&Pe(this.items[fe]);)fe++;const ve=fe===this.firstIdx?null:this.items.slice(this.firstIdx,fe);return this.firstIdx=fe,ve}takeFromEndWhile(Pe){let fe=this.lastIdx;for(;fe>=0&&Pe(this.items[fe]);)fe--;const ve=fe===this.lastIdx?null:this.items.slice(fe+1,this.lastIdx+1);return this.lastIdx=fe,ve}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const Pe=this.items[this.firstIdx];return this.firstIdx++,Pe}removeLast(){const Pe=this.items[this.lastIdx];return this.lastIdx--,Pe}takeCount(Pe){const fe=this.items.slice(this.firstIdx,this.firstIdx+Pe);return this.firstIdx+=Pe,fe}}e.ArrayQueue=Te}),define(Ie[58],ke([1,0]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function u(n){const y=this;let A=!1,D;return function(){return A||(A=!0,D=n.apply(y,arguments)),D}}e.once=u}),define(Ie[93],ke([1,0]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class u{constructor(y){this._prefix=y,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=u,e.defaultGenerator=new u("id#")}),define(Ie[59],ke([1,0]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var u;(function(n){function y(d){return d&&typeof d=="object"&&typeof d[Symbol.iterator]=="function"}n.is=y;const A=Object.freeze([]);function D(){return A}n.empty=D;function*C(d){yield d}n.single=C;function S(d){return d||A}n.from=S;function P(d){return!d||d[Symbol.iterator]().next().done===!0}n.isEmpty=P;function L(d){return d[Symbol.iterator]().next().value}n.first=L;function I(d,r){for(const s of d)if(r(s))return!0;return!1}n.some=I;function _(d,r){for(const s of d)if(r(s))return s}n.find=_;function*T(d,r){for(const s of d)r(s)&&(yield s)}n.filter=T;function*w(d,r){let s=0;for(const i of d)yield r(i,s++)}n.map=w;function*b(...d){for(const r of d)for(const s of r)yield s}n.concat=b;function*p(d){for(const r of d)for(const s of r)yield s}n.concatNested=p;function g(d,r,s){let i=s;for(const t of d)i=r(i,t);return i}n.reduce=g;function v(d,r){let s=0;for(const i of d)r(i,s++)}n.forEach=v;function*f(d,r,s=d.length){for(r<0&&(r+=d.length),s<0?s+=d.length:s>d.length&&(s=d.length);r<s;r++)yield d[r]}n.slice=f;function a(d,r=Number.POSITIVE_INFINITY){const s=[];if(r===0)return[s,d];const i=d[Symbol.iterator]();for(let t=0;t<r;t++){const c=i.next();if(c.done)return[s,n.empty()];s.push(c.value)}return[s,{[Symbol.iterator](){return i}}]}n.consume=a;function m(d){return a(d)[0]}n.collect=m;function o(d,r,s=(i,t)=>i===t){const i=d[Symbol.iterator](),t=r[Symbol.iterator]();for(;;){const c=i.next(),l=t.next();if(c.done!==l.done)return!1;if(c.done)return!0;if(!s(c.value,l.value))return!1}}n.equals=o})(u=e.Iterable||(e.Iterable={}))}),define(Ie[143],ke([1,0]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var u;(function(o){o[o.None=0]="None",o[o.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=2]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",o[o.InvalidUnicode=4]="InvalidUnicode",o[o.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",o[o.InvalidCharacter=6]="InvalidCharacter"})(u=e.ScanError||(e.ScanError={}));var n;(function(o){o[o.OpenBraceToken=1]="OpenBraceToken",o[o.CloseBraceToken=2]="CloseBraceToken",o[o.OpenBracketToken=3]="OpenBracketToken",o[o.CloseBracketToken=4]="CloseBracketToken",o[o.CommaToken=5]="CommaToken",o[o.ColonToken=6]="ColonToken",o[o.NullKeyword=7]="NullKeyword",o[o.TrueKeyword=8]="TrueKeyword",o[o.FalseKeyword=9]="FalseKeyword",o[o.StringLiteral=10]="StringLiteral",o[o.NumericLiteral=11]="NumericLiteral",o[o.LineCommentTrivia=12]="LineCommentTrivia",o[o.BlockCommentTrivia=13]="BlockCommentTrivia",o[o.LineBreakTrivia=14]="LineBreakTrivia",o[o.Trivia=15]="Trivia",o[o.Unknown=16]="Unknown",o[o.EOF=17]="EOF"})(n=e.SyntaxKind||(e.SyntaxKind={}));var y;(function(o){o[o.InvalidSymbol=1]="InvalidSymbol",o[o.InvalidNumberFormat=2]="InvalidNumberFormat",o[o.PropertyNameExpected=3]="PropertyNameExpected",o[o.ValueExpected=4]="ValueExpected",o[o.ColonExpected=5]="ColonExpected",o[o.CommaExpected=6]="CommaExpected",o[o.CloseBraceExpected=7]="CloseBraceExpected",o[o.CloseBracketExpected=8]="CloseBracketExpected",o[o.EndOfFileExpected=9]="EndOfFileExpected",o[o.InvalidCommentToken=10]="InvalidCommentToken",o[o.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=12]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",o[o.InvalidUnicode=14]="InvalidUnicode",o[o.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",o[o.InvalidCharacter=16]="InvalidCharacter"})(y=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(o){o.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function D(o,d=!1){let r=0;const s=o.length;let i="",t=0,c=16,l=0;function h(F){let $=0,ee=0;for(;$<F;){const B=o.charCodeAt(r);if(B>=48&&B<=57)ee=ee*16+B-48;else if(B>=65&&B<=70)ee=ee*16+B-65+10;else if(B>=97&&B<=102)ee=ee*16+B-97+10;else break;r++,$++}return $<F&&(ee=-1),ee}function E(F){r=F,i="",t=0,c=16,l=0}function R(){const F=r;if(o.charCodeAt(r)===48)r++;else for(r++;r<o.length&&P(o.charCodeAt(r));)r++;if(r<o.length&&o.charCodeAt(r)===46)if(r++,r<o.length&&P(o.charCodeAt(r)))for(r++;r<o.length&&P(o.charCodeAt(r));)r++;else return l=3,o.substring(F,r);let $=r;if(r<o.length&&(o.charCodeAt(r)===69||o.charCodeAt(r)===101))if(r++,(r<o.length&&o.charCodeAt(r)===43||o.charCodeAt(r)===45)&&r++,r<o.length&&P(o.charCodeAt(r))){for(r++;r<o.length&&P(o.charCodeAt(r));)r++;$=r}else l=3;return o.substring(F,$)}function N(){let F="",$=r;for(;;){if(r>=s){F+=o.substring($,r),l=2;break}const ee=o.charCodeAt(r);if(ee===34){F+=o.substring($,r),r++;break}if(ee===92){if(F+=o.substring($,r),r++,r>=s){l=2;break}switch(o.charCodeAt(r++)){case 34:F+='"';break;case 92:F+="\\";break;case 47:F+="/";break;case 98:F+="\b";break;case 102:F+="\f";break;case 110:F+=`
`;break;case 114:F+="\r";break;case 116:F+="	";break;case 117:{const z=h(4);z>=0?F+=String.fromCharCode(z):l=4;break}default:l=5}$=r;continue}if(ee>=0&&ee<=31)if(S(ee)){F+=o.substring($,r),l=2;break}else l=6;r++}return F}function O(){if(i="",l=0,t=r,r>=s)return t=s,c=17;let F=o.charCodeAt(r);if(C(F)){do r++,i+=String.fromCharCode(F),F=o.charCodeAt(r);while(C(F));return c=15}if(S(F))return r++,i+=String.fromCharCode(F),F===13&&o.charCodeAt(r)===10&&(r++,i+=`
`),c=14;switch(F){case 123:return r++,c=1;case 125:return r++,c=2;case 91:return r++,c=3;case 93:return r++,c=4;case 58:return r++,c=6;case 44:return r++,c=5;case 34:return r++,i=N(),c=10;case 47:{const $=r-1;if(o.charCodeAt(r+1)===47){for(r+=2;r<s&&!S(o.charCodeAt(r));)r++;return i=o.substring($,r),c=12}if(o.charCodeAt(r+1)===42){r+=2;const ee=s-1;let B=!1;for(;r<ee;){if(o.charCodeAt(r)===42&&o.charCodeAt(r+1)===47){r+=2,B=!0;break}r++}return B||(r++,l=1),i=o.substring($,r),c=13}return i+=String.fromCharCode(F),r++,c=16}case 45:if(i+=String.fromCharCode(F),r++,r===s||!P(o.charCodeAt(r)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return i+=R(),c=11;default:for(;r<s&&k(F);)r++,F=o.charCodeAt(r);if(t!==r){switch(i=o.substring(t,r),i){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return i+=String.fromCharCode(F),r++,c=16}}function k(F){if(C(F)||S(F))return!1;switch(F){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function U(){let F;do F=O();while(F>=12&&F<=15);return F}return{setPosition:E,getPosition:()=>r,scan:d?U:O,getToken:()=>c,getTokenValue:()=>i,getTokenOffset:()=>t,getTokenLength:()=>r-t,getTokenError:()=>l}}e.createScanner=D;function C(o){return o===32||o===9||o===11||o===12||o===160||o===5760||o>=8192&&o<=8203||o===8239||o===8287||o===12288||o===65279}function S(o){return o===10||o===13||o===8232||o===8233}function P(o){return o>=48&&o<=57}var L;(function(o){o[o.nullCharacter=0]="nullCharacter",o[o.maxAsciiCharacter=127]="maxAsciiCharacter",o[o.lineFeed=10]="lineFeed",o[o.carriageReturn=13]="carriageReturn",o[o.lineSeparator=8232]="lineSeparator",o[o.paragraphSeparator=8233]="paragraphSeparator",o[o.nextLine=133]="nextLine",o[o.space=32]="space",o[o.nonBreakingSpace=160]="nonBreakingSpace",o[o.enQuad=8192]="enQuad",o[o.emQuad=8193]="emQuad",o[o.enSpace=8194]="enSpace",o[o.emSpace=8195]="emSpace",o[o.threePerEmSpace=8196]="threePerEmSpace",o[o.fourPerEmSpace=8197]="fourPerEmSpace",o[o.sixPerEmSpace=8198]="sixPerEmSpace",o[o.figureSpace=8199]="figureSpace",o[o.punctuationSpace=8200]="punctuationSpace",o[o.thinSpace=8201]="thinSpace",o[o.hairSpace=8202]="hairSpace",o[o.zeroWidthSpace=8203]="zeroWidthSpace",o[o.narrowNoBreakSpace=8239]="narrowNoBreakSpace",o[o.ideographicSpace=12288]="ideographicSpace",o[o.mathematicalSpace=8287]="mathematicalSpace",o[o.ogham=5760]="ogham",o[o._=95]="_",o[o.$=36]="$",o[o._0=48]="_0",o[o._1=49]="_1",o[o._2=50]="_2",o[o._3=51]="_3",o[o._4=52]="_4",o[o._5=53]="_5",o[o._6=54]="_6",o[o._7=55]="_7",o[o._8=56]="_8",o[o._9=57]="_9",o[o.a=97]="a",o[o.b=98]="b",o[o.c=99]="c",o[o.d=100]="d",o[o.e=101]="e",o[o.f=102]="f",o[o.g=103]="g",o[o.h=104]="h",o[o.i=105]="i",o[o.j=106]="j",o[o.k=107]="k",o[o.l=108]="l",o[o.m=109]="m",o[o.n=110]="n",o[o.o=111]="o",o[o.p=112]="p",o[o.q=113]="q",o[o.r=114]="r",o[o.s=115]="s",o[o.t=116]="t",o[o.u=117]="u",o[o.v=118]="v",o[o.w=119]="w",o[o.x=120]="x",o[o.y=121]="y",o[o.z=122]="z",o[o.A=65]="A",o[o.B=66]="B",o[o.C=67]="C",o[o.D=68]="D",o[o.E=69]="E",o[o.F=70]="F",o[o.G=71]="G",o[o.H=72]="H",o[o.I=73]="I",o[o.J=74]="J",o[o.K=75]="K",o[o.L=76]="L",o[o.M=77]="M",o[o.N=78]="N",o[o.O=79]="O",o[o.P=80]="P",o[o.Q=81]="Q",o[o.R=82]="R",o[o.S=83]="S",o[o.T=84]="T",o[o.U=85]="U",o[o.V=86]="V",o[o.W=87]="W",o[o.X=88]="X",o[o.Y=89]="Y",o[o.Z=90]="Z",o[o.ampersand=38]="ampersand",o[o.asterisk=42]="asterisk",o[o.at=64]="at",o[o.backslash=92]="backslash",o[o.bar=124]="bar",o[o.caret=94]="caret",o[o.closeBrace=125]="closeBrace",o[o.closeBracket=93]="closeBracket",o[o.closeParen=41]="closeParen",o[o.colon=58]="colon",o[o.comma=44]="comma",o[o.dot=46]="dot",o[o.doubleQuote=34]="doubleQuote",o[o.equals=61]="equals",o[o.exclamation=33]="exclamation",o[o.greaterThan=62]="greaterThan",o[o.lessThan=60]="lessThan",o[o.minus=45]="minus",o[o.openBrace=123]="openBrace",o[o.openBracket=91]="openBracket",o[o.openParen=40]="openParen",o[o.percent=37]="percent",o[o.plus=43]="plus",o[o.question=63]="question",o[o.semicolon=59]="semicolon",o[o.singleQuote=39]="singleQuote",o[o.slash=47]="slash",o[o.tilde=126]="tilde",o[o.backspace=8]="backspace",o[o.formFeed=12]="formFeed",o[o.byteOrderMark=65279]="byteOrderMark",o[o.tab=9]="tab",o[o.verticalTab=11]="verticalTab"})(L||(L={}));function I(o,d){const r=[],s=new Object;let i;const t={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function l(h,E,R,N){t.value=h,t.offset=E,t.length=R,t.type=N,t.colonOffset=void 0,i=t}try{f(o,{onObjectBegin:(h,E)=>{if(d<=h)throw s;i=void 0,c=d>h,r.push("")},onObjectProperty:(h,E,R)=>{if(d<E||(l(h,E,R,"property"),r[r.length-1]=h,d<=E+R))throw s},onObjectEnd:(h,E)=>{if(d<=h)throw s;i=void 0,r.pop()},onArrayBegin:(h,E)=>{if(d<=h)throw s;i=void 0,r.push(0)},onArrayEnd:(h,E)=>{if(d<=h)throw s;i=void 0,r.pop()},onLiteralValue:(h,E,R)=>{if(d<E||(l(h,E,R,m(h)),d<=E+R))throw s},onSeparator:(h,E,R)=>{if(d<=E)throw s;if(h===":"&&i&&i.type==="property")i.colonOffset=E,c=!1,i=void 0;else if(h===","){const N=r[r.length-1];typeof N=="number"?r[r.length-1]=N+1:(c=!0,r[r.length-1]=""),i=void 0}}})}catch(h){if(h!==s)throw h}return{path:r,previousNode:i,isAtPropertyKey:c,matches:h=>{let E=0;for(let R=0;E<h.length&&R<r.length;R++)if(h[E]===r[R]||h[E]==="*")E++;else if(h[E]!=="**")return!1;return E===h.length}}}e.getLocation=I;function _(o,d=[],r=A.DEFAULT){let s=null,i=[];const t=[];function c(h){Array.isArray(i)?i.push(h):s!==null&&(i[s]=h)}return f(o,{onObjectBegin:()=>{const h={};c(h),t.push(i),i=h,s=null},onObjectProperty:h=>{s=h},onObjectEnd:()=>{i=t.pop()},onArrayBegin:()=>{const h=[];c(h),t.push(i),i=h,s=null},onArrayEnd:()=>{i=t.pop()},onLiteralValue:c,onError:(h,E,R)=>{d.push({error:h,offset:E,length:R})}},r),i[0]}e.parse=_;function T(o,d=[],r=A.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function i(h){s.type==="property"&&(s.length=h-s.offset,s=s.parent)}function t(h){return s.children.push(h),h}f(o,{onObjectBegin:h=>{s=t({type:"object",offset:h,length:-1,parent:s,children:[]})},onObjectProperty:(h,E,R)=>{s=t({type:"property",offset:E,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:h,offset:E,length:R,parent:s})},onObjectEnd:(h,E)=>{s.length=h+E-s.offset,s=s.parent,i(h+E)},onArrayBegin:(h,E)=>{s=t({type:"array",offset:h,length:-1,parent:s,children:[]})},onArrayEnd:(h,E)=>{s.length=h+E-s.offset,s=s.parent,i(h+E)},onLiteralValue:(h,E,R)=>{t({type:m(h),offset:E,length:R,parent:s,value:h}),i(E+R)},onSeparator:(h,E,R)=>{s.type==="property"&&(h===":"?s.colonOffset=E:h===","&&i(E))},onError:(h,E,R)=>{d.push({error:h,offset:E,length:R})}},r);const l=s.children[0];return l&&delete l.parent,l}e.parseTree=T;function w(o,d){if(!o)return;let r=o;for(const s of d)if(typeof s=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let i=!1;for(const t of r.children)if(Array.isArray(t.children)&&t.children[0].value===s){r=t.children[1],i=!0;break}if(!i)return}else{const i=s;if(r.type!=="array"||i<0||!Array.isArray(r.children)||i>=r.children.length)return;r=r.children[i]}return r}e.findNodeAtLocation=w;function b(o){if(!o.parent||!o.parent.children)return[];const d=b(o.parent);if(o.parent.type==="property"){const r=o.parent.children[0].value;d.push(r)}else if(o.parent.type==="array"){const r=o.parent.children.indexOf(o);r!==-1&&d.push(r)}return d}e.getNodePath=b;function p(o){switch(o.type){case"array":return o.children.map(p);case"object":{const d=Object.create(null);for(const r of o.children){const s=r.children[1];s&&(d[r.children[0].value]=p(s))}return d}case"null":case"string":case"number":case"boolean":return o.value;default:return}}e.getNodeValue=p;function g(o,d,r=!1){return d>=o.offset&&d<o.offset+o.length||r&&d===o.offset+o.length}e.contains=g;function v(o,d,r=!1){if(g(o,d,r)){const s=o.children;if(Array.isArray(s))for(let i=0;i<s.length&&s[i].offset<=d;i++){const t=v(s[i],d,r);if(t)return t}return o}}e.findNodeAtOffset=v;function f(o,d,r=A.DEFAULT){const s=D(o,!1);function i(le){return le?()=>le(s.getTokenOffset(),s.getTokenLength()):()=>!0}function t(le){return le?ue=>le(ue,s.getTokenOffset(),s.getTokenLength()):()=>!0}const c=i(d.onObjectBegin),l=t(d.onObjectProperty),h=i(d.onObjectEnd),E=i(d.onArrayBegin),R=i(d.onArrayEnd),N=t(d.onLiteralValue),O=t(d.onSeparator),k=i(d.onComment),U=t(d.onError),F=r&&r.disallowComments,$=r&&r.allowTrailingComma;function ee(){for(;;){const le=s.scan();switch(s.getTokenError()){case 4:B(14);break;case 5:B(15);break;case 3:B(13);break;case 1:F||B(11);break;case 2:B(12);break;case 6:B(16);break}switch(le){case 12:case 13:F?B(10):k();break;case 16:B(1);break;case 15:case 14:break;default:return le}}}function B(le,ue=[],K=[]){if(U(le),ue.length+K.length>0){let ge=s.getToken();for(;ge!==17;){if(ue.indexOf(ge)!==-1){ee();break}else if(K.indexOf(ge)!==-1)break;ge=ee()}}}function z(le){const ue=s.getTokenValue();return le?N(ue):l(ue),ee(),!0}function q(){switch(s.getToken()){case 11:{let le=0;try{le=JSON.parse(s.getTokenValue()),typeof le!="number"&&(B(2),le=0)}catch{B(2)}N(le);break}case 7:N(null);break;case 8:N(!0);break;case 9:N(!1);break;default:return!1}return ee(),!0}function V(){return s.getToken()!==10?(B(3,[],[2,5]),!1):(z(!1),s.getToken()===6?(O(":"),ee(),Y()||B(4,[],[2,5])):B(5,[],[2,5]),!0)}function j(){c(),ee();let le=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(le||B(4,[],[]),O(","),ee(),s.getToken()===2&&$)break}else le&&B(6,[],[]);V()||B(4,[],[2,5]),le=!0}return h(),s.getToken()!==2?B(7,[2],[]):ee(),!0}function ne(){E(),ee();let le=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(le||B(4,[],[]),O(","),ee(),s.getToken()===4&&$)break}else le&&B(6,[],[]);Y()||B(4,[],[4,5]),le=!0}return R(),s.getToken()!==4?B(8,[4],[]):ee(),!0}function Y(){switch(s.getToken()){case 3:return ne();case 1:return j();case 10:return z(!0);default:return q()}}return ee(),s.getToken()===17?r.allowEmptyContent?!0:(B(4,[],[]),!1):Y()?(s.getToken()!==17&&B(9,[],[]),!0):(B(4,[],[]),!1)}e.visit=f;function a(o,d){const r=D(o),s=[];let i,t=0,c;do switch(c=r.getPosition(),i=r.scan(),i){case 12:case 13:case 17:t!==c&&s.push(o.substring(t,c)),d!==void 0&&s.push(r.getTokenValue().replace(/[^\r\n]/g,d)),t=r.getPosition();break}while(i!==17);return s.join("")}e.stripComments=a;function m(o){switch(typeof o){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(o){if(Array.isArray(o))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=m}),define(Ie[79],ke([1,0]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class u{constructor(y){this.executor=y,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(y){this._error=y}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(y){return new u(()=>y(this.getValue()))}}e.Lazy=u}),define(Ie[6],ke([1,0,58,59]),function(Q,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const y=!1;let A=null;function D(i){A=i}if(e.setDisposableTracker=D,y){const i="__is_disposable_tracked__";D(new class{trackDisposable(t){const c=new Error("Potentially leaked disposable").stack;setTimeout(()=>{t[i]||console.log(c)},3e3)}setParent(t,c){if(t&&t!==v.None)try{t[i]=!0}catch{}}markAsDisposed(t){if(t&&t!==v.None)try{t[i]=!0}catch{}}markAsSingleton(t){}})}function C(i){return A?.trackDisposable(i),i}function S(i){A?.markAsDisposed(i)}function P(i,t){A?.setParent(i,t)}function L(i,t){if(!!A)for(const c of i)A.setParent(c,t)}function I(i){return A?.markAsSingleton(i),i}e.markAsSingleton=I;class _ extends Error{constructor(t){super(`Encountered errors while disposing of store. Errors: [${t.join(", ")}]`);this.errors=t}}e.MultiDisposeError=_;function T(i){return typeof i.dispose=="function"&&i.dispose.length===0}e.isDisposable=T;function w(i){if(n.Iterable.is(i)){const t=[];for(const c of i)if(c)try{c.dispose()}catch(l){t.push(l)}if(t.length===1)throw t[0];if(t.length>1)throw new _(t);return Array.isArray(i)?[]:i}else if(i)return i.dispose(),i}e.dispose=w;function b(...i){const t=p(()=>w(i));return L(i,t),t}e.combinedDisposable=b;function p(i){const t=C({dispose:(0,u.once)(()=>{S(t),i()})});return t}e.toDisposable=p;class g{constructor(){this._toDispose=new Set,this._isDisposed=!1,C(this)}dispose(){this._isDisposed||(S(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{w(this._toDispose.values())}finally{this._toDispose.clear()}}add(t){if(!t)return t;if(t===this)throw new Error("Cannot register a disposable on itself!");return P(t,this),this._isDisposed?g.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(t),t}}e.DisposableStore=g,g.DISABLE_DISPOSED_WARNING=!1;class v{constructor(){this._store=new g,C(this),P(this._store,this)}dispose(){S(this),this._store.dispose()}_register(t){if(t===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(t)}}e.Disposable=v,v.None=Object.freeze({dispose(){}});class f{constructor(){this._isDisposed=!1,C(this)}get value(){return this._isDisposed?void 0:this._value}set value(t){this._isDisposed||t===this._value||(this._value?.dispose(),t&&P(t,this),this._value=t)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,S(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const t=this._value;return this._value=void 0,t&&P(t,null),t}}e.MutableDisposable=f;class a{constructor(t){this._disposable=t,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=a;class m{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,C(this)}set(t){let c=t;return this.unset=()=>c=void 0,this.isset=()=>c!==void 0,this.dispose=()=>{c&&(c(),c=void 0,S(this))},this}}e.SafeDisposable=m;class o{constructor(){this.references=new Map}acquire(t,...c){let l=this.references.get(t);l||(l={counter:0,object:this.createReferencedObject(t,...c)},this.references.set(t,l));const{object:h}=l,E=(0,u.once)(()=>{--l.counter==0&&(this.destroyReferencedObject(t,l.object),this.references.delete(t))});return l.counter++,{object:h,dispose:E}}}e.ReferenceCollection=o;class d{constructor(t){this.referenceCollection=t}async acquire(t,...c){const l=this.referenceCollection.acquire(t,...c);try{return{object:await l.object,dispose:()=>l.dispose()}}catch(h){throw l.dispose(),h}}}e.AsyncReferenceCollection=d;class r{constructor(t){this.object=t}dispose(){}}e.ImmortalReference=r;function s(i){const t=new g;try{i(t)}finally{t.dispose()}}e.disposeOnReturn=s}),define(Ie[80],ke([1,0]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class u{constructor(A){this.element=A,this.next=u.Undefined,this.prev=u.Undefined}}u.Undefined=new u(void 0);class n{constructor(){this._first=u.Undefined,this._last=u.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===u.Undefined}clear(){let A=this._first;for(;A!==u.Undefined;){const D=A.next;A.prev=u.Undefined,A.next=u.Undefined,A=D}this._first=u.Undefined,this._last=u.Undefined,this._size=0}unshift(A){return this._insert(A,!1)}push(A){return this._insert(A,!0)}_insert(A,D){const C=new u(A);if(this._first===u.Undefined)this._first=C,this._last=C;else if(D){const P=this._last;this._last=C,C.prev=P,P.next=C}else{const P=this._first;this._first=C,C.next=P,P.prev=C}this._size+=1;let S=!1;return()=>{S||(S=!0,this._remove(C))}}shift(){if(this._first!==u.Undefined){const A=this._first.element;return this._remove(this._first),A}}pop(){if(this._last!==u.Undefined){const A=this._last.element;return this._remove(this._last),A}}_remove(A){if(A.prev!==u.Undefined&&A.next!==u.Undefined){const D=A.prev;D.next=A.next,A.next.prev=D}else A.prev===u.Undefined&&A.next===u.Undefined?(this._first=u.Undefined,this._last=u.Undefined):A.next===u.Undefined?(this._last=this._last.prev,this._last.next=u.Undefined):A.prev===u.Undefined&&(this._first=this._first.next,this._first.prev=u.Undefined);this._size-=1}*[Symbol.iterator](){let A=this._first;for(;A!==u.Undefined;)yield A.element,A=A.next}}e.LinkedList=n}),function(Q,e){typeof exports=="object"&&typeof module!="undefined"?e(exports):typeof define=="function"&&define.amd?define(Ie[144],ke([0]),e):(Q=typeof globalThis!="undefined"?globalThis:Q||self,e(Q.marked={}))}(this,function(Q){"use strict";function e(fe,ve){for(var _e=0;_e<ve.length;_e++){var ae=ve[_e];ae.enumerable=ae.enumerable||!1,ae.configurable=!0,"value"in ae&&(ae.writable=!0),Object.defineProperty(fe,ae.key,ae)}}function u(fe,ve,_e){return ve&&e(fe.prototype,ve),_e&&e(fe,_e),Object.defineProperty(fe,"prototype",{writable:!1}),fe}function n(fe,ve){if(!!fe){if(typeof fe=="string")return y(fe,ve);var _e=Object.prototype.toString.call(fe).slice(8,-1);if(_e==="Object"&&fe.constructor&&(_e=fe.constructor.name),_e==="Map"||_e==="Set")return Array.from(fe);if(_e==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(_e))return y(fe,ve)}}function y(fe,ve){(ve==null||ve>fe.length)&&(ve=fe.length);for(var _e=0,ae=new Array(ve);_e<ve;_e++)ae[_e]=fe[_e];return ae}function A(fe,ve){var _e=typeof Symbol!="undefined"&&fe[Symbol.iterator]||fe["@@iterator"];if(_e)return(_e=_e.call(fe)).next.bind(_e);if(Array.isArray(fe)||(_e=n(fe))||ve&&fe&&typeof fe.length=="number"){_e&&(fe=_e);var ae=0;return function(){return ae>=fe.length?{done:!0}:{done:!1,value:fe[ae++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function D(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}Q.defaults=D();function C(fe){Q.defaults=fe}var S=/[&<>"']/,P=/[&<>"']/g,L=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,_={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},T=function(ve){return _[ve]};function w(fe,ve){if(ve){if(S.test(fe))return fe.replace(P,T)}else if(L.test(fe))return fe.replace(I,T);return fe}var b=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function p(fe){return fe.replace(b,function(ve,_e){return _e=_e.toLowerCase(),_e==="colon"?":":_e.charAt(0)==="#"?_e.charAt(1)==="x"?String.fromCharCode(parseInt(_e.substring(2),16)):String.fromCharCode(+_e.substring(1)):""})}var g=/(^|[^\[])\^/g;function v(fe,ve){fe=typeof fe=="string"?fe:fe.source,ve=ve||"";var _e={replace:function(he,te){return te=te.source||te,te=te.replace(g,"$1"),fe=fe.replace(he,te),_e},getRegex:function(){return new RegExp(fe,ve)}};return _e}var f=/[^\w:]/g,a=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function m(fe,ve,_e){if(fe){var ae;try{ae=decodeURIComponent(p(_e)).replace(f,"").toLowerCase()}catch{return null}if(ae.indexOf("javascript:")===0||ae.indexOf("vbscript:")===0||ae.indexOf("data:")===0)return null}ve&&!a.test(_e)&&(_e=i(ve,_e));try{_e=encodeURI(_e).replace(/%25/g,"%")}catch{return null}return _e}var o={},d=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function i(fe,ve){o[" "+fe]||(d.test(fe)?o[" "+fe]=fe+"/":o[" "+fe]=h(fe,"/",!0)),fe=o[" "+fe];var _e=fe.indexOf(":")===-1;return ve.substring(0,2)==="//"?_e?ve:fe.replace(r,"$1")+ve:ve.charAt(0)==="/"?_e?ve:fe.replace(s,"$1")+ve:fe+ve}var t={exec:function(){}};function c(fe){for(var ve=1,_e,ae;ve<arguments.length;ve++){_e=arguments[ve];for(ae in _e)Object.prototype.hasOwnProperty.call(_e,ae)&&(fe[ae]=_e[ae])}return fe}function l(fe,ve){var _e=fe.replace(/\|/g,function(te,ie,M){for(var H=!1,G=ie;--G>=0&&M[G]==="\\";)H=!H;return H?"|":" |"}),ae=_e.split(/ \|/),he=0;if(ae[0].trim()||ae.shift(),ae.length>0&&!ae[ae.length-1].trim()&&ae.pop(),ae.length>ve)ae.splice(ve);else for(;ae.length<ve;)ae.push("");for(;he<ae.length;he++)ae[he]=ae[he].trim().replace(/\\\|/g,"|");return ae}function h(fe,ve,_e){var ae=fe.length;if(ae===0)return"";for(var he=0;he<ae;){var te=fe.charAt(ae-he-1);if(te===ve&&!_e)he++;else if(te!==ve&&_e)he++;else break}return fe.slice(0,ae-he)}function E(fe,ve){if(fe.indexOf(ve[1])===-1)return-1;for(var _e=fe.length,ae=0,he=0;he<_e;he++)if(fe[he]==="\\")he++;else if(fe[he]===ve[0])ae++;else if(fe[he]===ve[1]&&(ae--,ae<0))return he;return-1}function R(fe){fe&&fe.sanitize&&!fe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function N(fe,ve){if(ve<1)return"";for(var _e="";ve>1;)ve&1&&(_e+=fe),ve>>=1,fe+=fe;return _e+fe}function O(fe,ve,_e,ae){var he=ve.href,te=ve.title?w(ve.title):null,ie=fe[1].replace(/\\([\[\]])/g,"$1");if(fe[0].charAt(0)!=="!"){ae.state.inLink=!0;var M={type:"link",raw:_e,href:he,title:te,text:ie,tokens:ae.inlineTokens(ie,[])};return ae.state.inLink=!1,M}return{type:"image",raw:_e,href:he,title:te,text:w(ie)}}function k(fe,ve){var _e=fe.match(/^(\s+)(?:```)/);if(_e===null)return ve;var ae=_e[1];return ve.split(`
`).map(function(he){var te=he.match(/^\s+/);if(te===null)return he;var ie=te[0];return ie.length>=ae.length?he.slice(ae.length):he}).join(`
`)}var U=function(){function fe(_e){this.options=_e||Q.defaults}var ve=fe.prototype;return ve.space=function(ae){var he=this.rules.block.newline.exec(ae);if(he&&he[0].length>0)return{type:"space",raw:he[0]}},ve.code=function(ae){var he=this.rules.block.code.exec(ae);if(he){var te=he[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:he[0],codeBlockStyle:"indented",text:this.options.pedantic?te:h(te,`
`)}}},ve.fences=function(ae){var he=this.rules.block.fences.exec(ae);if(he){var te=he[0],ie=k(te,he[3]||"");return{type:"code",raw:te,lang:he[2]?he[2].trim():he[2],text:ie}}},ve.heading=function(ae){var he=this.rules.block.heading.exec(ae);if(he){var te=he[2].trim();if(/#$/.test(te)){var ie=h(te,"#");(this.options.pedantic||!ie||/ $/.test(ie))&&(te=ie.trim())}var M={type:"heading",raw:he[0],depth:he[1].length,text:te,tokens:[]};return this.lexer.inline(M.text,M.tokens),M}},ve.hr=function(ae){var he=this.rules.block.hr.exec(ae);if(he)return{type:"hr",raw:he[0]}},ve.blockquote=function(ae){var he=this.rules.block.blockquote.exec(ae);if(he){var te=he[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:he[0],tokens:this.lexer.blockTokens(te,[]),text:te}}},ve.list=function(ae){var he=this.rules.block.list.exec(ae);if(he){var te,ie,M,H,G,X,de,be,se,De,Ce,ze,Ke=he[1].trim(),Ne=Ke.length>1,Ye={type:"list",raw:"",ordered:Ne,start:Ne?+Ke.slice(0,-1):"",loose:!1,items:[]};Ke=Ne?"\\d{1,9}\\"+Ke.slice(-1):"\\"+Ke,this.options.pedantic&&(Ke=Ne?Ke:"[*+-]");for(var Z=new RegExp("^( {0,3}"+Ke+")((?:[	 ][^\\n]*)?(?:\\n|$))");ae&&(ze=!1,!(!(he=Z.exec(ae))||this.rules.block.hr.test(ae)));){if(te=he[0],ae=ae.substring(te.length),be=he[2].split(`
`,1)[0],se=ae.split(`
`,1)[0],this.options.pedantic?(H=2,Ce=be.trimLeft()):(H=he[2].search(/[^ ]/),H=H>4?1:H,Ce=be.slice(H),H+=he[1].length),X=!1,!be&&/^ *$/.test(se)&&(te+=se+`
`,ae=ae.substring(se.length+1),ze=!0),!ze)for(var re=new RegExp("^ {0,"+Math.min(3,H-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Se=new RegExp("^ {0,"+Math.min(3,H-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)");ae&&(De=ae.split(`
`,1)[0],be=De,this.options.pedantic&&(be=be.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(re.test(be)||Se.test(ae)));){if(be.search(/[^ ]/)>=H||!be.trim())Ce+=`
`+be.slice(H);else if(!X)Ce+=`
`+be;else break;!X&&!be.trim()&&(X=!0),te+=De+`
`,ae=ae.substring(De.length+1)}Ye.loose||(de?Ye.loose=!0:/\n *\n *$/.test(te)&&(de=!0)),this.options.gfm&&(ie=/^\[[ xX]\] /.exec(Ce),ie&&(M=ie[0]!=="[ ] ",Ce=Ce.replace(/^\[[ xX]\] +/,""))),Ye.items.push({type:"list_item",raw:te,task:!!ie,checked:M,loose:!1,text:Ce}),Ye.raw+=te}Ye.items[Ye.items.length-1].raw=te.trimRight(),Ye.items[Ye.items.length-1].text=Ce.trimRight(),Ye.raw=Ye.raw.trimRight();var We=Ye.items.length;for(G=0;G<We;G++){this.lexer.state.top=!1,Ye.items[G].tokens=this.lexer.blockTokens(Ye.items[G].text,[]);var oe=Ye.items[G].tokens.filter(function(Be){return Be.type==="space"}),Re=oe.every(function(Be){for(var qe=Be.raw.split(""),je=0,Ve=A(qe),nt;!(nt=Ve()).done;){var ot=nt.value;if(ot===`
`&&(je+=1),je>1)return!0}return!1});!Ye.loose&&oe.length&&Re&&(Ye.loose=!0,Ye.items[G].loose=!0)}return Ye}},ve.html=function(ae){var he=this.rules.block.html.exec(ae);if(he){var te={type:"html",raw:he[0],pre:!this.options.sanitizer&&(he[1]==="pre"||he[1]==="script"||he[1]==="style"),text:he[0]};return this.options.sanitize&&(te.type="paragraph",te.text=this.options.sanitizer?this.options.sanitizer(he[0]):w(he[0]),te.tokens=[],this.lexer.inline(te.text,te.tokens)),te}},ve.def=function(ae){var he=this.rules.block.def.exec(ae);if(he){he[3]&&(he[3]=he[3].substring(1,he[3].length-1));var te=he[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:te,raw:he[0],href:he[2],title:he[3]}}},ve.table=function(ae){var he=this.rules.block.table.exec(ae);if(he){var te={type:"table",header:l(he[1]).map(function(de){return{text:de}}),align:he[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:he[3]&&he[3].trim()?he[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(te.header.length===te.align.length){te.raw=he[0];var ie=te.align.length,M,H,G,X;for(M=0;M<ie;M++)/^ *-+: *$/.test(te.align[M])?te.align[M]="right":/^ *:-+: *$/.test(te.align[M])?te.align[M]="center":/^ *:-+ *$/.test(te.align[M])?te.align[M]="left":te.align[M]=null;for(ie=te.rows.length,M=0;M<ie;M++)te.rows[M]=l(te.rows[M],te.header.length).map(function(de){return{text:de}});for(ie=te.header.length,H=0;H<ie;H++)te.header[H].tokens=[],this.lexer.inline(te.header[H].text,te.header[H].tokens);for(ie=te.rows.length,H=0;H<ie;H++)for(X=te.rows[H],G=0;G<X.length;G++)X[G].tokens=[],this.lexer.inline(X[G].text,X[G].tokens);return te}}},ve.lheading=function(ae){var he=this.rules.block.lheading.exec(ae);if(he){var te={type:"heading",raw:he[0],depth:he[2].charAt(0)==="="?1:2,text:he[1],tokens:[]};return this.lexer.inline(te.text,te.tokens),te}},ve.paragraph=function(ae){var he=this.rules.block.paragraph.exec(ae);if(he){var te={type:"paragraph",raw:he[0],text:he[1].charAt(he[1].length-1)===`
`?he[1].slice(0,-1):he[1],tokens:[]};return this.lexer.inline(te.text,te.tokens),te}},ve.text=function(ae){var he=this.rules.block.text.exec(ae);if(he){var te={type:"text",raw:he[0],text:he[0],tokens:[]};return this.lexer.inline(te.text,te.tokens),te}},ve.escape=function(ae){var he=this.rules.inline.escape.exec(ae);if(he)return{type:"escape",raw:he[0],text:w(he[1])}},ve.tag=function(ae){var he=this.rules.inline.tag.exec(ae);if(he)return!this.lexer.state.inLink&&/^<a /i.test(he[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(he[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(he[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(he[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:he[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):w(he[0]):he[0]}},ve.link=function(ae){var he=this.rules.inline.link.exec(ae);if(he){var te=he[2].trim();if(!this.options.pedantic&&/^</.test(te)){if(!/>$/.test(te))return;var ie=h(te.slice(0,-1),"\\");if((te.length-ie.length)%2==0)return}else{var M=E(he[2],"()");if(M>-1){var H=he[0].indexOf("!")===0?5:4,G=H+he[1].length+M;he[2]=he[2].substring(0,M),he[0]=he[0].substring(0,G).trim(),he[3]=""}}var X=he[2],de="";if(this.options.pedantic){var be=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(X);be&&(X=be[1],de=be[3])}else de=he[3]?he[3].slice(1,-1):"";return X=X.trim(),/^</.test(X)&&(this.options.pedantic&&!/>$/.test(te)?X=X.slice(1):X=X.slice(1,-1)),O(he,{href:X&&X.replace(this.rules.inline._escapes,"$1"),title:de&&de.replace(this.rules.inline._escapes,"$1")},he[0],this.lexer)}},ve.reflink=function(ae,he){var te;if((te=this.rules.inline.reflink.exec(ae))||(te=this.rules.inline.nolink.exec(ae))){var ie=(te[2]||te[1]).replace(/\s+/g," ");if(ie=he[ie.toLowerCase()],!ie||!ie.href){var M=te[0].charAt(0);return{type:"text",raw:M,text:M}}return O(te,ie,te[0],this.lexer)}},ve.emStrong=function(ae,he,te){te===void 0&&(te="");var ie=this.rules.inline.emStrong.lDelim.exec(ae);if(!!ie&&!(ie[3]&&te.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var M=ie[1]||ie[2]||"";if(!M||M&&(te===""||this.rules.inline.punctuation.exec(te))){var H=ie[0].length-1,G,X,de=H,be=0,se=ie[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(se.lastIndex=0,he=he.slice(-1*ae.length+H);(ie=se.exec(he))!=null;)if(G=ie[1]||ie[2]||ie[3]||ie[4]||ie[5]||ie[6],!!G){if(X=G.length,ie[3]||ie[4]){de+=X;continue}else if((ie[5]||ie[6])&&H%3&&!((H+X)%3)){be+=X;continue}if(de-=X,!(de>0)){if(X=Math.min(X,X+de+be),Math.min(H,X)%2){var De=ae.slice(1,H+ie.index+X);return{type:"em",raw:ae.slice(0,H+ie.index+X+1),text:De,tokens:this.lexer.inlineTokens(De,[])}}var Ce=ae.slice(2,H+ie.index+X-1);return{type:"strong",raw:ae.slice(0,H+ie.index+X+1),text:Ce,tokens:this.lexer.inlineTokens(Ce,[])}}}}}},ve.codespan=function(ae){var he=this.rules.inline.code.exec(ae);if(he){var te=he[2].replace(/\n/g," "),ie=/[^ ]/.test(te),M=/^ /.test(te)&&/ $/.test(te);return ie&&M&&(te=te.substring(1,te.length-1)),te=w(te,!0),{type:"codespan",raw:he[0],text:te}}},ve.br=function(ae){var he=this.rules.inline.br.exec(ae);if(he)return{type:"br",raw:he[0]}},ve.del=function(ae){var he=this.rules.inline.del.exec(ae);if(he)return{type:"del",raw:he[0],text:he[2],tokens:this.lexer.inlineTokens(he[2],[])}},ve.autolink=function(ae,he){var te=this.rules.inline.autolink.exec(ae);if(te){var ie,M;return te[2]==="@"?(ie=w(this.options.mangle?he(te[1]):te[1]),M="mailto:"+ie):(ie=w(te[1]),M=ie),{type:"link",raw:te[0],text:ie,href:M,tokens:[{type:"text",raw:ie,text:ie}]}}},ve.url=function(ae,he){var te;if(te=this.rules.inline.url.exec(ae)){var ie,M;if(te[2]==="@")ie=w(this.options.mangle?he(te[0]):te[0]),M="mailto:"+ie;else{var H;do H=te[0],te[0]=this.rules.inline._backpedal.exec(te[0])[0];while(H!==te[0]);ie=w(te[0]),te[1]==="www."?M="http://"+ie:M=ie}return{type:"link",raw:te[0],text:ie,href:M,tokens:[{type:"text",raw:ie,text:ie}]}}},ve.inlineText=function(ae,he){var te=this.rules.inline.text.exec(ae);if(te){var ie;return this.lexer.state.inRawBlock?ie=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(te[0]):w(te[0]):te[0]:ie=w(this.options.smartypants?he(te[0]):te[0]),{type:"text",raw:te[0],text:ie}}},fe}(),F={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:t,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};F._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,F._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,F.def=v(F.def).replace("label",F._label).replace("title",F._title).getRegex(),F.bullet=/(?:[*+-]|\d{1,9}[.)])/,F.listItemStart=v(/^( *)(bull) */).replace("bull",F.bullet).getRegex(),F.list=v(F.list).replace(/bull/g,F.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+F.def.source+")").getRegex(),F._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",F._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,F.html=v(F.html,"i").replace("comment",F._comment).replace("tag",F._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),F.paragraph=v(F._paragraph).replace("hr",F.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",F._tag).getRegex(),F.blockquote=v(F.blockquote).replace("paragraph",F.paragraph).getRegex(),F.normal=c({},F),F.gfm=c({},F.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),F.gfm.table=v(F.gfm.table).replace("hr",F.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",F._tag).getRegex(),F.gfm.paragraph=v(F._paragraph).replace("hr",F.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",F.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",F._tag).getRegex(),F.pedantic=c({},F.normal,{html:v(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",F._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:t,paragraph:v(F.normal._paragraph).replace("hr",F.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",F.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var $={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:t,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:t,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};$._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",$.punctuation=v($.punctuation).replace(/punctuation/g,$._punctuation).getRegex(),$.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,$.escapedEmSt=/\\\*|\\_/g,$._comment=v(F._comment).replace("(?:-->|$)","-->").getRegex(),$.emStrong.lDelim=v($.emStrong.lDelim).replace(/punct/g,$._punctuation).getRegex(),$.emStrong.rDelimAst=v($.emStrong.rDelimAst,"g").replace(/punct/g,$._punctuation).getRegex(),$.emStrong.rDelimUnd=v($.emStrong.rDelimUnd,"g").replace(/punct/g,$._punctuation).getRegex(),$._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,$._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,$._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,$.autolink=v($.autolink).replace("scheme",$._scheme).replace("email",$._email).getRegex(),$._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,$.tag=v($.tag).replace("comment",$._comment).replace("attribute",$._attribute).getRegex(),$._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,$._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,$._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,$.link=v($.link).replace("label",$._label).replace("href",$._href).replace("title",$._title).getRegex(),$.reflink=v($.reflink).replace("label",$._label).replace("ref",F._label).getRegex(),$.nolink=v($.nolink).replace("ref",F._label).getRegex(),$.reflinkSearch=v($.reflinkSearch,"g").replace("reflink",$.reflink).replace("nolink",$.nolink).getRegex(),$.normal=c({},$),$.pedantic=c({},$.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:v(/^!?\[(label)\]\((.*?)\)/).replace("label",$._label).getRegex(),reflink:v(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",$._label).getRegex()}),$.gfm=c({},$.normal,{escape:v($.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),$.gfm.url=v($.gfm.url,"i").replace("email",$.gfm._extended_email).getRegex(),$.breaks=c({},$.gfm,{br:v($.br).replace("{2,}","*").getRegex(),text:v($.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function ee(fe){return fe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function B(fe){var ve="",_e,ae,he=fe.length;for(_e=0;_e<he;_e++)ae=fe.charCodeAt(_e),Math.random()>.5&&(ae="x"+ae.toString(16)),ve+="&#"+ae+";";return ve}var z=function(){function fe(_e){this.tokens=[],this.tokens.links=Object.create(null),this.options=_e||Q.defaults,this.options.tokenizer=this.options.tokenizer||new U,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ae={block:F.normal,inline:$.normal};this.options.pedantic?(ae.block=F.pedantic,ae.inline=$.pedantic):this.options.gfm&&(ae.block=F.gfm,this.options.breaks?ae.inline=$.breaks:ae.inline=$.gfm),this.tokenizer.rules=ae}fe.lex=function(ae,he){var te=new fe(he);return te.lex(ae)},fe.lexInline=function(ae,he){var te=new fe(he);return te.inlineTokens(ae)};var ve=fe.prototype;return ve.lex=function(ae){ae=ae.replace(/\r\n|\r/g,`
`),this.blockTokens(ae,this.tokens);for(var he;he=this.inlineQueue.shift();)this.inlineTokens(he.src,he.tokens);return this.tokens},ve.blockTokens=function(ae,he){var te=this;he===void 0&&(he=[]),this.options.pedantic?ae=ae.replace(/\t/g,"    ").replace(/^ +$/gm,""):ae=ae.replace(/^( *)(\t+)/gm,function(de,be,se){return be+"    ".repeat(se.length)});for(var ie,M,H,G;ae;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(de){return(ie=de.call({lexer:te},ae,he))?(ae=ae.substring(ie.raw.length),he.push(ie),!0):!1}))){if(ie=this.tokenizer.space(ae)){ae=ae.substring(ie.raw.length),ie.raw.length===1&&he.length>0?he[he.length-1].raw+=`
`:he.push(ie);continue}if(ie=this.tokenizer.code(ae)){ae=ae.substring(ie.raw.length),M=he[he.length-1],M&&(M.type==="paragraph"||M.type==="text")?(M.raw+=`
`+ie.raw,M.text+=`
`+ie.text,this.inlineQueue[this.inlineQueue.length-1].src=M.text):he.push(ie);continue}if(ie=this.tokenizer.fences(ae)){ae=ae.substring(ie.raw.length),he.push(ie);continue}if(ie=this.tokenizer.heading(ae)){ae=ae.substring(ie.raw.length),he.push(ie);continue}if(ie=this.tokenizer.hr(ae)){ae=ae.substring(ie.raw.length),he.push(ie);continue}if(ie=this.tokenizer.blockquote(ae)){ae=ae.substring(ie.raw.length),he.push(ie);continue}if(ie=this.tokenizer.list(ae)){ae=ae.substring(ie.raw.length),he.push(ie);continue}if(ie=this.tokenizer.html(ae)){ae=ae.substring(ie.raw.length),he.push(ie);continue}if(ie=this.tokenizer.def(ae)){ae=ae.substring(ie.raw.length),M=he[he.length-1],M&&(M.type==="paragraph"||M.type==="text")?(M.raw+=`
`+ie.raw,M.text+=`
`+ie.raw,this.inlineQueue[this.inlineQueue.length-1].src=M.text):this.tokens.links[ie.tag]||(this.tokens.links[ie.tag]={href:ie.href,title:ie.title});continue}if(ie=this.tokenizer.table(ae)){ae=ae.substring(ie.raw.length),he.push(ie);continue}if(ie=this.tokenizer.lheading(ae)){ae=ae.substring(ie.raw.length),he.push(ie);continue}if(H=ae,this.options.extensions&&this.options.extensions.startBlock&&function(){var de=1/0,be=ae.slice(1),se=void 0;te.options.extensions.startBlock.forEach(function(De){se=De.call({lexer:this},be),typeof se=="number"&&se>=0&&(de=Math.min(de,se))}),de<1/0&&de>=0&&(H=ae.substring(0,de+1))}(),this.state.top&&(ie=this.tokenizer.paragraph(H))){M=he[he.length-1],G&&M.type==="paragraph"?(M.raw+=`
`+ie.raw,M.text+=`
`+ie.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=M.text):he.push(ie),G=H.length!==ae.length,ae=ae.substring(ie.raw.length);continue}if(ie=this.tokenizer.text(ae)){ae=ae.substring(ie.raw.length),M=he[he.length-1],M&&M.type==="text"?(M.raw+=`
`+ie.raw,M.text+=`
`+ie.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=M.text):he.push(ie);continue}if(ae){var X="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(X);break}else throw new Error(X)}}return this.state.top=!0,he},ve.inline=function(ae,he){this.inlineQueue.push({src:ae,tokens:he})},ve.inlineTokens=function(ae,he){var te=this;he===void 0&&(he=[]);var ie,M,H,G=ae,X,de,be;if(this.tokens.links){var se=Object.keys(this.tokens.links);if(se.length>0)for(;(X=this.tokenizer.rules.inline.reflinkSearch.exec(G))!=null;)se.includes(X[0].slice(X[0].lastIndexOf("[")+1,-1))&&(G=G.slice(0,X.index)+"["+N("a",X[0].length-2)+"]"+G.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(X=this.tokenizer.rules.inline.blockSkip.exec(G))!=null;)G=G.slice(0,X.index)+"["+N("a",X[0].length-2)+"]"+G.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(X=this.tokenizer.rules.inline.escapedEmSt.exec(G))!=null;)G=G.slice(0,X.index)+"++"+G.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ae;)if(de||(be=""),de=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Ce){return(ie=Ce.call({lexer:te},ae,he))?(ae=ae.substring(ie.raw.length),he.push(ie),!0):!1}))){if(ie=this.tokenizer.escape(ae)){ae=ae.substring(ie.raw.length),he.push(ie);continue}if(ie=this.tokenizer.tag(ae)){ae=ae.substring(ie.raw.length),M=he[he.length-1],M&&ie.type==="text"&&M.type==="text"?(M.raw+=ie.raw,M.text+=ie.text):he.push(ie);continue}if(ie=this.tokenizer.link(ae)){ae=ae.substring(ie.raw.length),he.push(ie);continue}if(ie=this.tokenizer.reflink(ae,this.tokens.links)){ae=ae.substring(ie.raw.length),M=he[he.length-1],M&&ie.type==="text"&&M.type==="text"?(M.raw+=ie.raw,M.text+=ie.text):he.push(ie);continue}if(ie=this.tokenizer.emStrong(ae,G,be)){ae=ae.substring(ie.raw.length),he.push(ie);continue}if(ie=this.tokenizer.codespan(ae)){ae=ae.substring(ie.raw.length),he.push(ie);continue}if(ie=this.tokenizer.br(ae)){ae=ae.substring(ie.raw.length),he.push(ie);continue}if(ie=this.tokenizer.del(ae)){ae=ae.substring(ie.raw.length),he.push(ie);continue}if(ie=this.tokenizer.autolink(ae,B)){ae=ae.substring(ie.raw.length),he.push(ie);continue}if(!this.state.inLink&&(ie=this.tokenizer.url(ae,B))){ae=ae.substring(ie.raw.length),he.push(ie);continue}if(H=ae,this.options.extensions&&this.options.extensions.startInline&&function(){var Ce=1/0,ze=ae.slice(1),Ke=void 0;te.options.extensions.startInline.forEach(function(Ne){Ke=Ne.call({lexer:this},ze),typeof Ke=="number"&&Ke>=0&&(Ce=Math.min(Ce,Ke))}),Ce<1/0&&Ce>=0&&(H=ae.substring(0,Ce+1))}(),ie=this.tokenizer.inlineText(H,ee)){ae=ae.substring(ie.raw.length),ie.raw.slice(-1)!=="_"&&(be=ie.raw.slice(-1)),de=!0,M=he[he.length-1],M&&M.type==="text"?(M.raw+=ie.raw,M.text+=ie.text):he.push(ie);continue}if(ae){var De="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(De);break}else throw new Error(De)}}return he},u(fe,null,[{key:"rules",get:function(){return{block:F,inline:$}}}]),fe}(),q=function(){function fe(_e){this.options=_e||Q.defaults}var ve=fe.prototype;return ve.code=function(ae,he,te){var ie=(he||"").match(/\S*/)[0];if(this.options.highlight){var M=this.options.highlight(ae,ie);M!=null&&M!==ae&&(te=!0,ae=M)}return ae=ae.replace(/\n$/,"")+`
`,ie?'<pre><code class="'+this.options.langPrefix+w(ie,!0)+'">'+(te?ae:w(ae,!0))+`</code></pre>
`:"<pre><code>"+(te?ae:w(ae,!0))+`</code></pre>
`},ve.blockquote=function(ae){return`<blockquote>
`+ae+`</blockquote>
`},ve.html=function(ae){return ae},ve.heading=function(ae,he,te,ie){if(this.options.headerIds){var M=this.options.headerPrefix+ie.slug(te);return"<h"+he+' id="'+M+'">'+ae+"</h"+he+`>
`}return"<h"+he+">"+ae+"</h"+he+`>
`},ve.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ve.list=function(ae,he,te){var ie=he?"ol":"ul",M=he&&te!==1?' start="'+te+'"':"";return"<"+ie+M+`>
`+ae+"</"+ie+`>
`},ve.listitem=function(ae){return"<li>"+ae+`</li>
`},ve.checkbox=function(ae){return"<input "+(ae?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ve.paragraph=function(ae){return"<p>"+ae+`</p>
`},ve.table=function(ae,he){return he&&(he="<tbody>"+he+"</tbody>"),`<table>
<thead>
`+ae+`</thead>
`+he+`</table>
`},ve.tablerow=function(ae){return`<tr>
`+ae+`</tr>
`},ve.tablecell=function(ae,he){var te=he.header?"th":"td",ie=he.align?"<"+te+' align="'+he.align+'">':"<"+te+">";return ie+ae+("</"+te+`>
`)},ve.strong=function(ae){return"<strong>"+ae+"</strong>"},ve.em=function(ae){return"<em>"+ae+"</em>"},ve.codespan=function(ae){return"<code>"+ae+"</code>"},ve.br=function(){return this.options.xhtml?"<br/>":"<br>"},ve.del=function(ae){return"<del>"+ae+"</del>"},ve.link=function(ae,he,te){if(ae=m(this.options.sanitize,this.options.baseUrl,ae),ae===null)return te;var ie='<a href="'+w(ae)+'"';return he&&(ie+=' title="'+he+'"'),ie+=">"+te+"</a>",ie},ve.image=function(ae,he,te){if(ae=m(this.options.sanitize,this.options.baseUrl,ae),ae===null)return te;var ie='<img src="'+ae+'" alt="'+te+'"';return he&&(ie+=' title="'+he+'"'),ie+=this.options.xhtml?"/>":">",ie},ve.text=function(ae){return ae},fe}(),V=function(){function fe(){}var ve=fe.prototype;return ve.strong=function(ae){return ae},ve.em=function(ae){return ae},ve.codespan=function(ae){return ae},ve.del=function(ae){return ae},ve.html=function(ae){return ae},ve.text=function(ae){return ae},ve.link=function(ae,he,te){return""+te},ve.image=function(ae,he,te){return""+te},ve.br=function(){return""},fe}(),j=function(){function fe(){this.seen={}}var ve=fe.prototype;return ve.serialize=function(ae){return ae.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ve.getNextSafeSlug=function(ae,he){var te=ae,ie=0;if(this.seen.hasOwnProperty(te)){ie=this.seen[ae];do ie++,te=ae+"-"+ie;while(this.seen.hasOwnProperty(te))}return he||(this.seen[ae]=ie,this.seen[te]=0),te},ve.slug=function(ae,he){he===void 0&&(he={});var te=this.serialize(ae);return this.getNextSafeSlug(te,he.dryrun)},fe}(),ne=function(){function fe(_e){this.options=_e||Q.defaults,this.options.renderer=this.options.renderer||new q,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new V,this.slugger=new j}fe.parse=function(ae,he){var te=new fe(he);return te.parse(ae)},fe.parseInline=function(ae,he){var te=new fe(he);return te.parseInline(ae)};var ve=fe.prototype;return ve.parse=function(ae,he){he===void 0&&(he=!0);var te="",ie,M,H,G,X,de,be,se,De,Ce,ze,Ke,Ne,Ye,Z,re,Se,We,oe,Re=ae.length;for(ie=0;ie<Re;ie++){if(Ce=ae[ie],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ce.type]&&(oe=this.options.extensions.renderers[Ce.type].call({parser:this},Ce),oe!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Ce.type))){te+=oe||"";continue}switch(Ce.type){case"space":continue;case"hr":{te+=this.renderer.hr();continue}case"heading":{te+=this.renderer.heading(this.parseInline(Ce.tokens),Ce.depth,p(this.parseInline(Ce.tokens,this.textRenderer)),this.slugger);continue}case"code":{te+=this.renderer.code(Ce.text,Ce.lang,Ce.escaped);continue}case"table":{for(se="",be="",G=Ce.header.length,M=0;M<G;M++)be+=this.renderer.tablecell(this.parseInline(Ce.header[M].tokens),{header:!0,align:Ce.align[M]});for(se+=this.renderer.tablerow(be),De="",G=Ce.rows.length,M=0;M<G;M++){for(de=Ce.rows[M],be="",X=de.length,H=0;H<X;H++)be+=this.renderer.tablecell(this.parseInline(de[H].tokens),{header:!1,align:Ce.align[H]});De+=this.renderer.tablerow(be)}te+=this.renderer.table(se,De);continue}case"blockquote":{De=this.parse(Ce.tokens),te+=this.renderer.blockquote(De);continue}case"list":{for(ze=Ce.ordered,Ke=Ce.start,Ne=Ce.loose,G=Ce.items.length,De="",M=0;M<G;M++)Z=Ce.items[M],re=Z.checked,Se=Z.task,Ye="",Z.task&&(We=this.renderer.checkbox(re),Ne?Z.tokens.length>0&&Z.tokens[0].type==="paragraph"?(Z.tokens[0].text=We+" "+Z.tokens[0].text,Z.tokens[0].tokens&&Z.tokens[0].tokens.length>0&&Z.tokens[0].tokens[0].type==="text"&&(Z.tokens[0].tokens[0].text=We+" "+Z.tokens[0].tokens[0].text)):Z.tokens.unshift({type:"text",text:We}):Ye+=We),Ye+=this.parse(Z.tokens,Ne),De+=this.renderer.listitem(Ye,Se,re);te+=this.renderer.list(De,ze,Ke);continue}case"html":{te+=this.renderer.html(Ce.text);continue}case"paragraph":{te+=this.renderer.paragraph(this.parseInline(Ce.tokens));continue}case"text":{for(De=Ce.tokens?this.parseInline(Ce.tokens):Ce.text;ie+1<Re&&ae[ie+1].type==="text";)Ce=ae[++ie],De+=`
`+(Ce.tokens?this.parseInline(Ce.tokens):Ce.text);te+=he?this.renderer.paragraph(De):De;continue}default:{var Be='Token with "'+Ce.type+'" type was not found.';if(this.options.silent){console.error(Be);return}else throw new Error(Be)}}}return te},ve.parseInline=function(ae,he){he=he||this.renderer;var te="",ie,M,H,G=ae.length;for(ie=0;ie<G;ie++){if(M=ae[ie],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[M.type]&&(H=this.options.extensions.renderers[M.type].call({parser:this},M),H!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(M.type))){te+=H||"";continue}switch(M.type){case"escape":{te+=he.text(M.text);break}case"html":{te+=he.html(M.text);break}case"link":{te+=he.link(M.href,M.title,this.parseInline(M.tokens,he));break}case"image":{te+=he.image(M.href,M.title,M.text);break}case"strong":{te+=he.strong(this.parseInline(M.tokens,he));break}case"em":{te+=he.em(this.parseInline(M.tokens,he));break}case"codespan":{te+=he.codespan(M.text);break}case"br":{te+=he.br();break}case"del":{te+=he.del(this.parseInline(M.tokens,he));break}case"text":{te+=he.text(M.text);break}default:{var X='Token with "'+M.type+'" type was not found.';if(this.options.silent){console.error(X);return}else throw new Error(X)}}}return te},fe}();function Y(fe,ve,_e){if(typeof fe=="undefined"||fe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof fe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(fe)+", string expected");if(typeof ve=="function"&&(_e=ve,ve=null),ve=c({},Y.defaults,ve||{}),R(ve),_e){var ae=ve.highlight,he;try{he=z.lex(fe,ve)}catch(H){return _e(H)}var te=function(G){var X;if(!G)try{ve.walkTokens&&Y.walkTokens(he,ve.walkTokens),X=ne.parse(he,ve)}catch(de){G=de}return ve.highlight=ae,G?_e(G):_e(null,X)};if(!ae||ae.length<3||(delete ve.highlight,!he.length))return te();var ie=0;Y.walkTokens(he,function(H){H.type==="code"&&(ie++,setTimeout(function(){ae(H.text,H.lang,function(G,X){if(G)return te(G);X!=null&&X!==H.text&&(H.text=X,H.escaped=!0),ie--,ie===0&&te()})},0))}),ie===0&&te();return}try{var M=z.lex(fe,ve);return ve.walkTokens&&Y.walkTokens(M,ve.walkTokens),ne.parse(M,ve)}catch(H){if(H.message+=`
Please report this to https://github.com/markedjs/marked.`,ve.silent)return"<p>An error occurred:</p><pre>"+w(H.message+"",!0)+"</pre>";throw H}}Y.options=Y.setOptions=function(fe){return c(Y.defaults,fe),C(Y.defaults),Y},Y.getDefaults=D,Y.defaults=Q.defaults,Y.use=function(){for(var fe=arguments.length,ve=new Array(fe),_e=0;_e<fe;_e++)ve[_e]=arguments[_e];var ae=c.apply(void 0,[{}].concat(ve)),he=Y.defaults.extensions||{renderers:{},childTokens:{}},te;ve.forEach(function(ie){if(ie.extensions&&(te=!0,ie.extensions.forEach(function(H){if(!H.name)throw new Error("extension name required");if(H.renderer){var G=he.renderers?he.renderers[H.name]:null;G?he.renderers[H.name]=function(){for(var X=arguments.length,de=new Array(X),be=0;be<X;be++)de[be]=arguments[be];var se=H.renderer.apply(this,de);return se===!1&&(se=G.apply(this,de)),se}:he.renderers[H.name]=H.renderer}if(H.tokenizer){if(!H.level||H.level!=="block"&&H.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");he[H.level]?he[H.level].unshift(H.tokenizer):he[H.level]=[H.tokenizer],H.start&&(H.level==="block"?he.startBlock?he.startBlock.push(H.start):he.startBlock=[H.start]:H.level==="inline"&&(he.startInline?he.startInline.push(H.start):he.startInline=[H.start]))}H.childTokens&&(he.childTokens[H.name]=H.childTokens)})),ie.renderer&&function(){var H=Y.defaults.renderer||new q,G=function(be){var se=H[be];H[be]=function(){for(var De=arguments.length,Ce=new Array(De),ze=0;ze<De;ze++)Ce[ze]=arguments[ze];var Ke=ie.renderer[be].apply(H,Ce);return Ke===!1&&(Ke=se.apply(H,Ce)),Ke}};for(var X in ie.renderer)G(X);ae.renderer=H}(),ie.tokenizer&&function(){var H=Y.defaults.tokenizer||new U,G=function(be){var se=H[be];H[be]=function(){for(var De=arguments.length,Ce=new Array(De),ze=0;ze<De;ze++)Ce[ze]=arguments[ze];var Ke=ie.tokenizer[be].apply(H,Ce);return Ke===!1&&(Ke=se.apply(H,Ce)),Ke}};for(var X in ie.tokenizer)G(X);ae.tokenizer=H}(),ie.walkTokens){var M=Y.defaults.walkTokens;ae.walkTokens=function(H){ie.walkTokens.call(this,H),M&&M.call(this,H)}}te&&(ae.extensions=he),Y.setOptions(ae)})},Y.walkTokens=function(fe,ve){for(var _e=function(){var ie=he.value;switch(ve.call(Y,ie),ie.type){case"table":{for(var M=A(ie.header),H;!(H=M()).done;){var G=H.value;Y.walkTokens(G.tokens,ve)}for(var X=A(ie.rows),de;!(de=X()).done;)for(var be=de.value,se=A(be),De;!(De=se()).done;){var Ce=De.value;Y.walkTokens(Ce.tokens,ve)}break}case"list":{Y.walkTokens(ie.items,ve);break}default:Y.defaults.extensions&&Y.defaults.extensions.childTokens&&Y.defaults.extensions.childTokens[ie.type]?Y.defaults.extensions.childTokens[ie.type].forEach(function(ze){Y.walkTokens(ie[ze],ve)}):ie.tokens&&Y.walkTokens(ie.tokens,ve)}},ae=A(fe),he;!(he=ae()).done;)_e()},Y.parseInline=function(fe,ve){if(typeof fe=="undefined"||fe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof fe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(fe)+", string expected");ve=c({},Y.defaults,ve||{}),R(ve);try{var _e=z.lexInline(fe,ve);return ve.walkTokens&&Y.walkTokens(_e,ve.walkTokens),ne.parseInline(_e,ve)}catch(ae){if(ae.message+=`
Please report this to https://github.com/markedjs/marked.`,ve.silent)return"<p>An error occurred:</p><pre>"+w(ae.message+"",!0)+"</pre>";throw ae}},Y.Parser=ne,Y.parser=ne.parse,Y.Renderer=q,Y.TextRenderer=V,Y.Lexer=z,Y.lexer=z.lex,Y.Tokenizer=U,Y.Slugger=j,Y.parse=Y;var le=Y.options,ue=Y.setOptions,K=Y.use,ge=Y.walkTokens,ye=Y.parseInline,Te=Y,pe=ne.parse,Pe=z.lex;Q.Lexer=z,Q.Parser=ne,Q.Renderer=q,Q.Slugger=j,Q.TextRenderer=V,Q.Tokenizer=U,Q.getDefaults=D,Q.lexer=Pe,Q.marked=Y,Q.options=le,Q.parse=Te,Q.parseInline=ye,Q.parser=pe,Q.setOptions=ue,Q.use=K,Q.walkTokens=ge,Object.defineProperty(Q,"__esModule",{value:!0})}),define(Ie[94],ke([1,0]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function u(C,S,P){return Math.min(Math.max(C,S),P)}e.clamp=u;function n(C,S){return(S+C%S)%S}e.rot=n;class y{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=y;class A{constructor(){this._n=1,this._val=0}update(S){return this._val=this._val+(S-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=A;class D{constructor(S){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(S),this._values.fill(0,0,S)}update(S){const P=this._values[this._index];return this._values[this._index]=S,this._index=(this._index+1)%this._values.length,this._sum-=P,this._sum+=S,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=D}),function(){function Q(y){const A=[];typeof y=="number"&&A.push("code/timeOrigin",y);function D(S){A.push(S,Date.now())}function C(){const S=[];for(let P=0;P<A.length;P+=2)S.push({name:A[P],startTime:A[P+1]});return S}return{mark:D,getMarks:C}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Q():{mark(y){performance.mark(y)},getMarks(){let y=performance.timeOrigin;typeof y!="number"&&(y=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(y)}];for(const D of performance.getEntriesByType("mark"))A.push({name:D.name,startTime:Math.round(y+D.startTime)});return A}};if(typeof process=="object"){const y=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Q(y)}else return console.trace("perf-util loaded in UNKNOWN environment"),Q()}function u(y){return y.MonacoPerformanceMarks||(y.MonacoPerformanceMarks=e()),y.MonacoPerformanceMarks}var n;typeof global=="object"?n=global:typeof self=="object"?n=self:n={},typeof define=="function"?define("vs/base/common/performance",[],function(){return u(n)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=u(n):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),n.perf=u(n))}(),function(Q,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var u=e();for(var n in u)(typeof exports=="object"?exports:Q)[n]=u[n]}}(typeof self!="undefined"?self:this,function(){return function(Q){var e={};function u(n){if(e[n])return e[n].exports;var y=e[n]={i:n,l:!1,exports:{}};return Q[n].call(y.exports,y,y.exports,u),y.l=!0,y.exports}return u.m=Q,u.c=e,u.d=function(n,y,A){u.o(n,y)||Object.defineProperty(n,y,{enumerable:!0,get:A})},u.r=function(n){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(n,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(n,"__esModule",{value:!0})},u.t=function(n,y){if(1&y&&(n=u(n)),8&y||4&y&&typeof n=="object"&&n&&n.__esModule)return n;var A=Object.create(null);if(u.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:n}),2&y&&typeof n!="string")for(var D in n)u.d(A,D,function(C){return n[C]}.bind(null,D));return A},u.n=function(n){var y=n&&n.__esModule?function(){return n.default}:function(){return n};return u.d(y,"a",y),y},u.o=function(n,y){return Object.prototype.hasOwnProperty.call(n,y)},u.p="",u(u.s=0)}([function(Q,e,u){(function(n){var y;e=Q.exports=K,y=typeof n=="object"&&n.env&&n.env.NODE_DEBUG&&/\bsemver\b/i.test(n.env.NODE_DEBUG)?function(){var se=Array.prototype.slice.call(arguments,0);se.unshift("SEMVER"),console.log.apply(console,se)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,C=e.re=[],S=e.src=[],P=0,L=P++;S[L]="0|[1-9]\\d*";var I=P++;S[I]="[0-9]+";var _=P++;S[_]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var T=P++;S[T]="("+S[L]+")\\.("+S[L]+")\\.("+S[L]+")";var w=P++;S[w]="("+S[I]+")\\.("+S[I]+")\\.("+S[I]+")";var b=P++;S[b]="(?:"+S[L]+"|"+S[_]+")";var p=P++;S[p]="(?:"+S[I]+"|"+S[_]+")";var g=P++;S[g]="(?:-("+S[b]+"(?:\\."+S[b]+")*))";var v=P++;S[v]="(?:-?("+S[p]+"(?:\\."+S[p]+")*))";var f=P++;S[f]="[0-9A-Za-z-]+";var a=P++;S[a]="(?:\\+("+S[f]+"(?:\\."+S[f]+")*))";var m=P++,o="v?"+S[T]+S[g]+"?"+S[a]+"?";S[m]="^"+o+"$";var d="[v=\\s]*"+S[w]+S[v]+"?"+S[a]+"?",r=P++;S[r]="^"+d+"$";var s=P++;S[s]="((?:<|>)?=?)";var i=P++;S[i]=S[I]+"|x|X|\\*";var t=P++;S[t]=S[L]+"|x|X|\\*";var c=P++;S[c]="[v=\\s]*("+S[t]+")(?:\\.("+S[t]+")(?:\\.("+S[t]+")(?:"+S[g]+")?"+S[a]+"?)?)?";var l=P++;S[l]="[v=\\s]*("+S[i]+")(?:\\.("+S[i]+")(?:\\.("+S[i]+")(?:"+S[v]+")?"+S[a]+"?)?)?";var h=P++;S[h]="^"+S[s]+"\\s*"+S[c]+"$";var E=P++;S[E]="^"+S[s]+"\\s*"+S[l]+"$";var R=P++;S[R]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var N=P++;S[N]="(?:~>?)";var O=P++;S[O]="(\\s*)"+S[N]+"\\s+",C[O]=new RegExp(S[O],"g");var k=P++;S[k]="^"+S[N]+S[c]+"$";var U=P++;S[U]="^"+S[N]+S[l]+"$";var F=P++;S[F]="(?:\\^)";var $=P++;S[$]="(\\s*)"+S[F]+"\\s+",C[$]=new RegExp(S[$],"g");var ee=P++;S[ee]="^"+S[F]+S[c]+"$";var B=P++;S[B]="^"+S[F]+S[l]+"$";var z=P++;S[z]="^"+S[s]+"\\s*("+d+")$|^$";var q=P++;S[q]="^"+S[s]+"\\s*("+o+")$|^$";var V=P++;S[V]="(\\s*)"+S[s]+"\\s*("+d+"|"+S[c]+")",C[V]=new RegExp(S[V],"g");var j=P++;S[j]="^\\s*("+S[c]+")\\s+-\\s+("+S[c]+")\\s*$";var ne=P++;S[ne]="^\\s*("+S[l]+")\\s+-\\s+("+S[l]+")\\s*$";var Y=P++;S[Y]="(<|>)?=?\\s*\\*";for(var le=0;le<35;le++)y(le,S[le]),C[le]||(C[le]=new RegExp(S[le]));function ue(se,De){if(se instanceof K)return se;if(typeof se!="string"||se.length>A||!(De?C[r]:C[m]).test(se))return null;try{return new K(se,De)}catch{return null}}function K(se,De){if(se instanceof K){if(se.loose===De)return se;se=se.version}else if(typeof se!="string")throw new TypeError("Invalid Version: "+se);if(se.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof K))return new K(se,De);y("SemVer",se,De),this.loose=De;var Ce=se.trim().match(De?C[r]:C[m]);if(!Ce)throw new TypeError("Invalid Version: "+se);if(this.raw=se,this.major=+Ce[1],this.minor=+Ce[2],this.patch=+Ce[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");Ce[4]?this.prerelease=Ce[4].split(".").map(function(ze){if(/^[0-9]+$/.test(ze)){var Ke=+ze;if(Ke>=0&&Ke<D)return Ke}return ze}):this.prerelease=[],this.build=Ce[5]?Ce[5].split("."):[],this.format()}e.parse=ue,e.valid=function(se,De){var Ce=ue(se,De);return Ce?Ce.version:null},e.clean=function(se,De){var Ce=ue(se.trim().replace(/^[=v]+/,""),De);return Ce?Ce.version:null},e.SemVer=K,K.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},K.prototype.toString=function(){return this.version},K.prototype.compare=function(se){return y("SemVer.compare",this.version,this.loose,se),se instanceof K||(se=new K(se,this.loose)),this.compareMain(se)||this.comparePre(se)},K.prototype.compareMain=function(se){return se instanceof K||(se=new K(se,this.loose)),ye(this.major,se.major)||ye(this.minor,se.minor)||ye(this.patch,se.patch)},K.prototype.comparePre=function(se){if(se instanceof K||(se=new K(se,this.loose)),this.prerelease.length&&!se.prerelease.length)return-1;if(!this.prerelease.length&&se.prerelease.length)return 1;if(!this.prerelease.length&&!se.prerelease.length)return 0;var De=0;do{var Ce=this.prerelease[De],ze=se.prerelease[De];if(y("prerelease compare",De,Ce,ze),Ce===void 0&&ze===void 0)return 0;if(ze===void 0)return 1;if(Ce===void 0)return-1;if(Ce!==ze)return ye(Ce,ze)}while(++De)},K.prototype.inc=function(se,De){switch(se){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",De);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",De);break;case"prepatch":this.prerelease.length=0,this.inc("patch",De),this.inc("pre",De);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",De),this.inc("pre",De);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Ce=this.prerelease.length;--Ce>=0;)typeof this.prerelease[Ce]=="number"&&(this.prerelease[Ce]++,Ce=-2);Ce===-1&&this.prerelease.push(0)}De&&(this.prerelease[0]===De?isNaN(this.prerelease[1])&&(this.prerelease=[De,0]):this.prerelease=[De,0]);break;default:throw new Error("invalid increment argument: "+se)}return this.format(),this.raw=this.version,this},e.inc=function(se,De,Ce,ze){typeof Ce=="string"&&(ze=Ce,Ce=void 0);try{return new K(se,Ce).inc(De,ze).version}catch{return null}},e.diff=function(se,De){if(fe(se,De))return null;var Ce=ue(se),ze=ue(De);if(Ce.prerelease.length||ze.prerelease.length){for(var Ke in Ce)if((Ke==="major"||Ke==="minor"||Ke==="patch")&&Ce[Ke]!==ze[Ke])return"pre"+Ke;return"prerelease"}for(var Ke in Ce)if((Ke==="major"||Ke==="minor"||Ke==="patch")&&Ce[Ke]!==ze[Ke])return Ke},e.compareIdentifiers=ye;var ge=/^[0-9]+$/;function ye(se,De){var Ce=ge.test(se),ze=ge.test(De);return Ce&&ze&&(se=+se,De=+De),Ce&&!ze?-1:ze&&!Ce?1:se<De?-1:se>De?1:0}function Te(se,De,Ce){return new K(se,Ce).compare(new K(De,Ce))}function pe(se,De,Ce){return Te(se,De,Ce)>0}function Pe(se,De,Ce){return Te(se,De,Ce)<0}function fe(se,De,Ce){return Te(se,De,Ce)===0}function ve(se,De,Ce){return Te(se,De,Ce)!==0}function _e(se,De,Ce){return Te(se,De,Ce)>=0}function ae(se,De,Ce){return Te(se,De,Ce)<=0}function he(se,De,Ce,ze){var Ke;switch(De){case"===":typeof se=="object"&&(se=se.version),typeof Ce=="object"&&(Ce=Ce.version),Ke=se===Ce;break;case"!==":typeof se=="object"&&(se=se.version),typeof Ce=="object"&&(Ce=Ce.version),Ke=se!==Ce;break;case"":case"=":case"==":Ke=fe(se,Ce,ze);break;case"!=":Ke=ve(se,Ce,ze);break;case">":Ke=pe(se,Ce,ze);break;case">=":Ke=_e(se,Ce,ze);break;case"<":Ke=Pe(se,Ce,ze);break;case"<=":Ke=ae(se,Ce,ze);break;default:throw new TypeError("Invalid operator: "+De)}return Ke}function te(se,De){if(se instanceof te){if(se.loose===De)return se;se=se.value}if(!(this instanceof te))return new te(se,De);y("comparator",se,De),this.loose=De,this.parse(se),this.semver===ie?this.value="":this.value=this.operator+this.semver.version,y("comp",this)}e.rcompareIdentifiers=function(se,De){return ye(De,se)},e.major=function(se,De){return new K(se,De).major},e.minor=function(se,De){return new K(se,De).minor},e.patch=function(se,De){return new K(se,De).patch},e.compare=Te,e.compareLoose=function(se,De){return Te(se,De,!0)},e.rcompare=function(se,De,Ce){return Te(De,se,Ce)},e.sort=function(se,De){return se.sort(function(Ce,ze){return e.compare(Ce,ze,De)})},e.rsort=function(se,De){return se.sort(function(Ce,ze){return e.rcompare(Ce,ze,De)})},e.gt=pe,e.lt=Pe,e.eq=fe,e.neq=ve,e.gte=_e,e.lte=ae,e.cmp=he,e.Comparator=te;var ie={};function M(se,De){if(se instanceof M)return se.loose===De?se:new M(se.raw,De);if(se instanceof te)return new M(se.value,De);if(!(this instanceof M))return new M(se,De);if(this.loose=De,this.raw=se,this.set=se.split(/\s*\|\|\s*/).map(function(Ce){return this.parseRange(Ce.trim())},this).filter(function(Ce){return Ce.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+se);this.format()}function H(se){return!se||se.toLowerCase()==="x"||se==="*"}function G(se,De,Ce,ze,Ke,Ne,Ye,Z,re,Se,We,oe,Re){return((De=H(Ce)?"":H(ze)?">="+Ce+".0.0":H(Ke)?">="+Ce+"."+ze+".0":">="+De)+" "+(Z=H(re)?"":H(Se)?"<"+(+re+1)+".0.0":H(We)?"<"+re+"."+(+Se+1)+".0":oe?"<="+re+"."+Se+"."+We+"-"+oe:"<="+Z)).trim()}function X(se,De){for(var Ce=0;Ce<se.length;Ce++)if(!se[Ce].test(De))return!1;if(De.prerelease.length){for(Ce=0;Ce<se.length;Ce++)if(y(se[Ce].semver),se[Ce].semver!==ie&&se[Ce].semver.prerelease.length>0){var ze=se[Ce].semver;if(ze.major===De.major&&ze.minor===De.minor&&ze.patch===De.patch)return!0}return!1}return!0}function de(se,De,Ce){try{De=new M(De,Ce)}catch{return!1}return De.test(se)}function be(se,De,Ce,ze){var Ke,Ne,Ye,Z,re;switch(se=new K(se,ze),De=new M(De,ze),Ce){case">":Ke=pe,Ne=ae,Ye=Pe,Z=">",re=">=";break;case"<":Ke=Pe,Ne=_e,Ye=pe,Z="<",re="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(de(se,De,ze))return!1;for(var Se=0;Se<De.set.length;++Se){var We=De.set[Se],oe=null,Re=null;if(We.forEach(function(Be){Be.semver===ie&&(Be=new te(">=0.0.0")),oe=oe||Be,Re=Re||Be,Ke(Be.semver,oe.semver,ze)?oe=Be:Ye(Be.semver,Re.semver,ze)&&(Re=Be)}),oe.operator===Z||oe.operator===re||(!Re.operator||Re.operator===Z)&&Ne(se,Re.semver)||Re.operator===re&&Ye(se,Re.semver))return!1}return!0}te.prototype.parse=function(se){var De=this.loose?C[z]:C[q],Ce=se.match(De);if(!Ce)throw new TypeError("Invalid comparator: "+se);this.operator=Ce[1],this.operator==="="&&(this.operator=""),Ce[2]?this.semver=new K(Ce[2],this.loose):this.semver=ie},te.prototype.toString=function(){return this.value},te.prototype.test=function(se){return y("Comparator.test",se,this.loose),this.semver===ie||(typeof se=="string"&&(se=new K(se,this.loose)),he(se,this.operator,this.semver,this.loose))},te.prototype.intersects=function(se,De){if(!(se instanceof te))throw new TypeError("a Comparator is required");var Ce;if(this.operator==="")return Ce=new M(se.value,De),de(this.value,Ce,De);if(se.operator==="")return Ce=new M(this.value,De),de(se.semver,Ce,De);var ze=!(this.operator!==">="&&this.operator!==">"||se.operator!==">="&&se.operator!==">"),Ke=!(this.operator!=="<="&&this.operator!=="<"||se.operator!=="<="&&se.operator!=="<"),Ne=this.semver.version===se.semver.version,Ye=!(this.operator!==">="&&this.operator!=="<="||se.operator!==">="&&se.operator!=="<="),Z=he(this.semver,"<",se.semver,De)&&(this.operator===">="||this.operator===">")&&(se.operator==="<="||se.operator==="<"),re=he(this.semver,">",se.semver,De)&&(this.operator==="<="||this.operator==="<")&&(se.operator===">="||se.operator===">");return ze||Ke||Ne&&Ye||Z||re},e.Range=M,M.prototype.format=function(){return this.range=this.set.map(function(se){return se.join(" ").trim()}).join("||").trim(),this.range},M.prototype.toString=function(){return this.range},M.prototype.parseRange=function(se){var De=this.loose;se=se.trim(),y("range",se,De);var Ce=De?C[ne]:C[j];se=se.replace(Ce,G),y("hyphen replace",se),se=se.replace(C[V],"$1$2$3"),y("comparator trim",se,C[V]),se=(se=(se=se.replace(C[O],"$1~")).replace(C[$],"$1^")).split(/\s+/).join(" ");var ze=De?C[z]:C[q],Ke=se.split(" ").map(function(Ne){return function(Ye,Z){return y("comp",Ye),Ye=function(re,Se){return re.trim().split(/\s+/).map(function(We){return function(oe,Re){y("caret",oe,Re);var Be=Re?C[B]:C[ee];return oe.replace(Be,function(qe,je,Ve,nt,ot){var st;return y("caret",oe,qe,je,Ve,nt,ot),H(je)?st="":H(Ve)?st=">="+je+".0.0 <"+(+je+1)+".0.0":H(nt)?st=je==="0"?">="+je+"."+Ve+".0 <"+je+"."+(+Ve+1)+".0":">="+je+"."+Ve+".0 <"+(+je+1)+".0.0":ot?(y("replaceCaret pr",ot),ot.charAt(0)!=="-"&&(ot="-"+ot),st=je==="0"?Ve==="0"?">="+je+"."+Ve+"."+nt+ot+" <"+je+"."+Ve+"."+(+nt+1):">="+je+"."+Ve+"."+nt+ot+" <"+je+"."+(+Ve+1)+".0":">="+je+"."+Ve+"."+nt+ot+" <"+(+je+1)+".0.0"):(y("no pr"),st=je==="0"?Ve==="0"?">="+je+"."+Ve+"."+nt+" <"+je+"."+Ve+"."+(+nt+1):">="+je+"."+Ve+"."+nt+" <"+je+"."+(+Ve+1)+".0":">="+je+"."+Ve+"."+nt+" <"+(+je+1)+".0.0"),y("caret return",st),st})}(We,Se)}).join(" ")}(Ye,Z),y("caret",Ye),Ye=function(re,Se){return re.trim().split(/\s+/).map(function(We){return function(oe,Re){var Be=Re?C[U]:C[k];return oe.replace(Be,function(qe,je,Ve,nt,ot){var st;return y("tilde",oe,qe,je,Ve,nt,ot),H(je)?st="":H(Ve)?st=">="+je+".0.0 <"+(+je+1)+".0.0":H(nt)?st=">="+je+"."+Ve+".0 <"+je+"."+(+Ve+1)+".0":ot?(y("replaceTilde pr",ot),ot.charAt(0)!=="-"&&(ot="-"+ot),st=">="+je+"."+Ve+"."+nt+ot+" <"+je+"."+(+Ve+1)+".0"):st=">="+je+"."+Ve+"."+nt+" <"+je+"."+(+Ve+1)+".0",y("tilde return",st),st})}(We,Se)}).join(" ")}(Ye,Z),y("tildes",Ye),Ye=function(re,Se){return y("replaceXRanges",re,Se),re.split(/\s+/).map(function(We){return function(oe,Re){oe=oe.trim();var Be=Re?C[E]:C[h];return oe.replace(Be,function(qe,je,Ve,nt,ot,st){y("xRange",oe,qe,je,Ve,nt,ot,st);var it=H(Ve),at=it||H(nt),wt=at||H(ot);return je==="="&&wt&&(je=""),it?qe=je===">"||je==="<"?"<0.0.0":"*":je&&wt?(at&&(nt=0),wt&&(ot=0),je===">"?(je=">=",at?(Ve=+Ve+1,nt=0,ot=0):wt&&(nt=+nt+1,ot=0)):je==="<="&&(je="<",at?Ve=+Ve+1:nt=+nt+1),qe=je+Ve+"."+nt+"."+ot):at?qe=">="+Ve+".0.0 <"+(+Ve+1)+".0.0":wt&&(qe=">="+Ve+"."+nt+".0 <"+Ve+"."+(+nt+1)+".0"),y("xRange return",qe),qe})}(We,Se)}).join(" ")}(Ye,Z),y("xrange",Ye),Ye=function(re,Se){return y("replaceStars",re,Se),re.trim().replace(C[Y],"")}(Ye,Z),y("stars",Ye),Ye}(Ne,De)}).join(" ").split(/\s+/);return this.loose&&(Ke=Ke.filter(function(Ne){return!!Ne.match(ze)})),Ke=Ke.map(function(Ne){return new te(Ne,De)})},M.prototype.intersects=function(se,De){if(!(se instanceof M))throw new TypeError("a Range is required");return this.set.some(function(Ce){return Ce.every(function(ze){return se.set.some(function(Ke){return Ke.every(function(Ne){return ze.intersects(Ne,De)})})})})},e.toComparators=function(se,De){return new M(se,De).set.map(function(Ce){return Ce.map(function(ze){return ze.value}).join(" ").trim().split(" ")})},M.prototype.test=function(se){if(!se)return!1;typeof se=="string"&&(se=new K(se,this.loose));for(var De=0;De<this.set.length;De++)if(X(this.set[De],se))return!0;return!1},e.satisfies=de,e.maxSatisfying=function(se,De,Ce){var ze=null,Ke=null;try{var Ne=new M(De,Ce)}catch{return null}return se.forEach(function(Ye){Ne.test(Ye)&&(ze&&Ke.compare(Ye)!==-1||(Ke=new K(ze=Ye,Ce)))}),ze},e.minSatisfying=function(se,De,Ce){var ze=null,Ke=null;try{var Ne=new M(De,Ce)}catch{return null}return se.forEach(function(Ye){Ne.test(Ye)&&(ze&&Ke.compare(Ye)!==1||(Ke=new K(ze=Ye,Ce)))}),ze},e.validRange=function(se,De){try{return new M(se,De).range||"*"}catch{return null}},e.ltr=function(se,De,Ce){return be(se,De,"<",Ce)},e.gtr=function(se,De,Ce){return be(se,De,">",Ce)},e.outside=be,e.prerelease=function(se,De){var Ce=ue(se,De);return Ce&&Ce.prerelease.length?Ce.prerelease:null},e.intersects=function(se,De,Ce){return se=new M(se,Ce),De=new M(De,Ce),se.intersects(De)},e.coerce=function(se){if(se instanceof K)return se;if(typeof se!="string")return null;var De=se.match(C[R]);return De==null?null:ue((De[1]||"0")+"."+(De[2]||"0")+"."+(De[3]||"0"))}}).call(this,u(1))},function(Q,e){var u,n,y=Q.exports={};function A(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function C(p){if(u===setTimeout)return setTimeout(p,0);if((u===A||!u)&&setTimeout)return u=setTimeout,setTimeout(p,0);try{return u(p,0)}catch{try{return u.call(null,p,0)}catch{return u.call(this,p,0)}}}(function(){try{u=typeof setTimeout=="function"?setTimeout:A}catch{u=A}try{n=typeof clearTimeout=="function"?clearTimeout:D}catch{n=D}})();var S,P=[],L=!1,I=-1;function _(){L&&S&&(L=!1,S.length?P=S.concat(P):I=-1,P.length&&T())}function T(){if(!L){var p=C(_);L=!0;for(var g=P.length;g;){for(S=P,P=[];++I<g;)S&&S[I].run();I=-1,g=P.length}S=null,L=!1,function(v){if(n===clearTimeout)return clearTimeout(v);if((n===D||!n)&&clearTimeout)return n=clearTimeout,clearTimeout(v);try{n(v)}catch{try{return n.call(null,v)}catch{return n.call(this,v)}}}(p)}}function w(p,g){this.fun=p,this.array=g}function b(){}y.nextTick=function(p){var g=new Array(arguments.length-1);if(arguments.length>1)for(var v=1;v<arguments.length;v++)g[v-1]=arguments[v];P.push(new w(p,g)),P.length!==1||L||C(T)},w.prototype.run=function(){this.fun.apply(null,this.array)},y.title="browser",y.browser=!0,y.env={},y.argv=[],y.version="",y.versions={},y.on=b,y.addListener=b,y.once=b,y.off=b,y.removeListener=b,y.removeAllListeners=b,y.emit=b,y.prependListener=b,y.prependOnceListener=b,y.listeners=function(p){return[]},y.binding=function(p){throw new Error("process.binding is not supported")},y.cwd=function(){return"/"},y.chdir=function(p){throw new Error("process.chdir is not supported")},y.umask=function(){return 0}}])}),define(Ie[95],ke([1,0,12,6]),function(Q,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function y(a){const m=a;return m?typeof m.read=="function":!1}e.isReadable=y;function A(a){const m=a;return m?[m.on,m.pause,m.resume,m.destroy].every(o=>typeof o=="function"):!1}e.isReadableStream=A;function D(a){const m=a;return m?A(m.stream)&&Array.isArray(m.buffer)&&typeof m.ended=="boolean":!1}e.isReadableBufferedStream=D;function C(a,m){return new S(a,m)}e.newWriteableStream=C;class S{constructor(m,o){this.reducer=m,this.options=o,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(m){if(!this.state.destroyed){if(this.state.flowing)this.emitData(m);else if(this.buffer.data.push(m),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(o=>this.pendingWritePromises.push(o))}}error(m){this.state.destroyed||(this.state.flowing?this.emitError(m):this.buffer.error.push(m))}end(m){this.state.destroyed||(typeof m!="undefined"&&this.write(m),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(m){this.listeners.data.slice(0).forEach(o=>o(m))}emitError(m){this.listeners.error.length===0?(0,u.onUnexpectedError)(m):this.listeners.error.slice(0).forEach(o=>o(m))}emitEnd(){this.listeners.end.slice(0).forEach(m=>m())}on(m,o){if(!this.state.destroyed)switch(m){case"data":this.listeners.data.push(o),this.resume();break;case"end":this.listeners.end.push(o),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(o),this.state.flowing&&this.flowErrors();break}}removeListener(m,o){if(this.state.destroyed)return;let d;switch(m){case"data":d=this.listeners.data;break;case"end":d=this.listeners.end;break;case"error":d=this.listeners.error;break}if(d){const r=d.indexOf(o);r>=0&&d.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const m=this.reducer(this.buffer.data);this.emitData(m),this.buffer.data.length=0;const o=[...this.pendingWritePromises];this.pendingWritePromises.length=0,o.forEach(d=>d())}}flowErrors(){if(this.listeners.error.length>0){for(const m of this.buffer.error)this.emitError(m);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function P(a,m){const o=[];let d;for(;(d=a.read())!==null;)o.push(d);return m(o)}e.consumeReadable=P;function L(a,m,o){const d=[];let r;for(;(r=a.read())!==null&&d.length<o;)d.push(r);return r===null&&d.length>0?m(d):{read:()=>{if(d.length>0)return d.shift();if(typeof r!="undefined"){const s=r;return r=void 0,s}return a.read()}}}e.peekReadable=L;function I(a,m){return new Promise((o,d)=>{const r=[];_(a,{onData:s=>{m&&r.push(s)},onError:s=>{m?d(s):o(void 0)},onEnd:()=>{o(m?m(r):void 0)}})})}e.consumeStream=I;function _(a,m){let o=!1;return a.on("error",d=>{o||m.onError(d)}),a.on("end",()=>{o||m.onEnd()}),a.on("data",d=>{o||m.onData(d)}),(0,n.toDisposable)(()=>o=!0)}e.listenStream=_;function T(a,m){return new Promise((o,d)=>{const r=new n.DisposableStore,s=[],i=l=>{if(s.push(l),s.length>m)return r.dispose(),a.pause(),o({stream:a,buffer:s,ended:!1})},t=l=>d(l),c=()=>o({stream:a,buffer:s,ended:!0});r.add((0,n.toDisposable)(()=>a.removeListener("error",t))),a.on("error",t),r.add((0,n.toDisposable)(()=>a.removeListener("end",c))),a.on("end",c),r.add((0,n.toDisposable)(()=>a.removeListener("data",i))),a.on("data",i)})}e.peekStream=T;function w(a,m){const o=C(m);return o.end(a),o}e.toStream=w;function b(){const a=C(()=>{throw new Error("not supported")});return a.end(),a}e.emptyStream=b;function p(a){let m=!1;return{read:()=>m?null:(m=!0,a)}}e.toReadable=p;function g(a,m,o){const d=C(o);return _(a,{onData:r=>d.write(m.data(r)),onError:r=>d.error(m.error?m.error(r):r),onEnd:()=>d.end()}),d}e.transform=g;function v(a,m,o){let d=!1;return{read:()=>{const r=m.read();return d?r:(d=!0,r!==null?o([a,r]):a)}}}e.prefixedReadable=v;function f(a,m,o){let d=!1;const r=C(o);return _(m,{onData:s=>d?r.write(s):(d=!0,r.write(o([a,s]))),onError:s=>r.error(s),onEnd:()=>{d||(d=!0,r.write(a)),r.end()}}),r}e.prefixedStream=f}),define(Ie[23],ke([1,0,95]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const n=typeof Buffer!="undefined";let y,A;class D{constructor(l){this.buffer=l,this.byteLength=this.buffer.byteLength}static alloc(l){return n?new D(Buffer.allocUnsafe(l)):new D(new Uint8Array(l))}static wrap(l){return n&&!Buffer.isBuffer(l)&&(l=Buffer.from(l.buffer,l.byteOffset,l.byteLength)),new D(l)}static fromString(l,h){return!(h?.dontUseNodeBuffer||!1)&&n?new D(Buffer.from(l)):(y||(y=new TextEncoder),new D(y.encode(l)))}static fromByteArray(l){const h=D.alloc(l.length);for(let E=0,R=l.length;E<R;E++)h.buffer[E]=l[E];return h}static concat(l,h){if(typeof h=="undefined"){h=0;for(let N=0,O=l.length;N<O;N++)h+=l[N].byteLength}const E=D.alloc(h);let R=0;for(let N=0,O=l.length;N<O;N++){const k=l[N];E.set(k,R),R+=k.byteLength}return E}clone(){const l=D.alloc(this.byteLength);return l.set(this),l}toString(){return n?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(l,h){return new D(this.buffer.subarray(l,h))}set(l,h){if(l instanceof D)this.buffer.set(l.buffer,h);else if(l instanceof Uint8Array)this.buffer.set(l,h);else if(l instanceof ArrayBuffer)this.buffer.set(new Uint8Array(l),h);else if(ArrayBuffer.isView(l))this.buffer.set(new Uint8Array(l.buffer,l.byteOffset,l.byteLength),h);else throw new Error("Unknown argument 'array'")}readUInt32BE(l){return P(this.buffer,l)}writeUInt32BE(l,h){L(this.buffer,l,h)}readUInt32LE(l){return I(this.buffer,l)}writeUInt32LE(l,h){_(this.buffer,l,h)}readUInt8(l){return T(this.buffer,l)}writeUInt8(l,h){w(this.buffer,l,h)}}e.VSBuffer=D;function C(c,l){return c[l+0]<<0>>>0|c[l+1]<<8>>>0}e.readUInt16LE=C;function S(c,l,h){c[h+0]=l&255,l=l>>>8,c[h+1]=l&255}e.writeUInt16LE=S;function P(c,l){return c[l]*2**24+c[l+1]*2**16+c[l+2]*2**8+c[l+3]}e.readUInt32BE=P;function L(c,l,h){c[h+3]=l,l=l>>>8,c[h+2]=l,l=l>>>8,c[h+1]=l,l=l>>>8,c[h]=l}e.writeUInt32BE=L;function I(c,l){return c[l+0]<<0>>>0|c[l+1]<<8>>>0|c[l+2]<<16>>>0|c[l+3]<<24>>>0}e.readUInt32LE=I;function _(c,l,h){c[h+0]=l&255,l=l>>>8,c[h+1]=l&255,l=l>>>8,c[h+2]=l&255,l=l>>>8,c[h+3]=l&255}e.writeUInt32LE=_;function T(c,l){return c[l]}e.readUInt8=T;function w(c,l,h){c[h]=l}e.writeUInt8=w;function b(c){return u.consumeReadable(c,l=>D.concat(l))}e.readableToBuffer=b;function p(c){return u.toReadable(c)}e.bufferToReadable=p;function g(c){return u.consumeStream(c,l=>D.concat(l))}e.streamToBuffer=g;async function v(c){return c.ended?D.concat(c.buffer):D.concat([...c.buffer,await g(c.stream)])}e.bufferedStreamToBuffer=v;function f(c){return u.toStream(c,l=>D.concat(l))}e.bufferToStream=f;function a(c){return u.transform(c,{data:l=>typeof l=="string"?D.fromString(l):D.wrap(l)},l=>D.concat(l))}e.streamToBufferReadableStream=a;function m(c){return u.newWriteableStream(l=>D.concat(l),c)}e.newWriteableBufferStream=m;function o(c,l){return u.prefixedReadable(c,l,h=>D.concat(h))}e.prefixedBufferReadable=o;function d(c,l){return u.prefixedStream(c,l,h=>D.concat(h))}e.prefixedBufferStream=d;function r(c){let l=0,h=0,E=0;const R=new Uint8Array(Math.floor(c.length/4*3)),N=k=>{switch(h){case 3:R[E++]=l|k,h=0;break;case 2:R[E++]=l|k>>>2,l=k<<6,h=3;break;case 1:R[E++]=l|k>>>4,l=k<<4,h=2;break;default:l=k<<2,h=1}};for(let k=0;k<c.length;k++){const U=c.charCodeAt(k);if(U>=65&&U<=90)N(U-65);else if(U>=97&&U<=122)N(U-97+26);else if(U>=48&&U<=57)N(U-48+52);else if(U===43||U===45)N(62);else if(U===47||U===95)N(63);else{if(U===61)break;throw new SyntaxError(`Unexpected base64 character ${c[k]}`)}}const O=E;for(;h>0;)N(0);return D.wrap(R).slice(0,O)}e.decodeBase64=r;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function t({buffer:c},l=!0,h=!1){const E=h?i:s;let R="";const N=c.byteLength%3;let O=0;for(;O<c.byteLength-N;O+=3){const k=c[O+0],U=c[O+1],F=c[O+2];R+=E[k>>>2],R+=E[(k<<4|U>>>4)&63],R+=E[(U<<2|F>>>6)&63],R+=E[F&63]}if(N===1){const k=c[O+0];R+=E[k>>>2],R+=E[k<<4&63],l&&(R+="==")}else if(N===2){const k=c[O+0],U=c[O+1];R+=E[k>>>2],R+=E[(k<<4|U>>>4)&63],R+=E[U<<2&63],l&&(R+="=")}return R}e.encodeBase64=t}),define(Ie[10],ke([1,0]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function u(c){return Array.isArray(c)}e.isArray=u;function n(c){return typeof c=="string"}e.isString=n;function y(c){return Array.isArray(c)&&c.every(l=>n(l))}e.isStringArray=y;function A(c){return typeof c=="object"&&c!==null&&!Array.isArray(c)&&!(c instanceof RegExp)&&!(c instanceof Date)}e.isObject=A;function D(c){return typeof c=="object"&&(c instanceof Uint8Array||c instanceof Uint16Array||c instanceof Uint32Array||c instanceof Float32Array||c instanceof Float64Array||c instanceof Int8Array||c instanceof Int16Array||c instanceof Int32Array||c instanceof BigInt64Array||c instanceof BigUint64Array||c instanceof Uint8ClampedArray)}e.isTypedArray=D;function C(c){return typeof c=="number"&&!isNaN(c)}e.isNumber=C;function S(c){return!!c&&typeof c[Symbol.iterator]=="function"}e.isIterable=S;function P(c){return c===!0||c===!1}e.isBoolean=P;function L(c){return typeof c=="undefined"}e.isUndefined=L;function I(c){return!_(c)}e.isDefined=I;function _(c){return L(c)||c===null}e.isUndefinedOrNull=_;function T(c,l){if(!c)throw new Error(l?`Unexpected type, expected '${l}'`:"Unexpected type")}e.assertType=T;function w(c){if(_(c))throw new Error("Assertion Failed: argument is undefined or null");return c}e.assertIsDefined=w;function b(...c){const l=[];for(let h=0;h<c.length;h++){const E=c[h];if(_(E))throw new Error(`Assertion Failed: argument at index ${h} is undefined or null`);l.push(E)}return l}e.assertAllDefined=b;const p=Object.prototype.hasOwnProperty;function g(c){if(!A(c))return!1;for(const l in c)if(p.call(c,l))return!1;return!0}e.isEmptyObject=g;function v(c){return typeof c=="function"}e.isFunction=v;function f(...c){return c.length>0&&c.every(v)}e.areFunctions=f;function a(c,l){const h=Math.min(c.length,l.length);for(let E=0;E<h;E++)m(c[E],l[E])}e.validateConstraints=a;function m(c,l){if(n(l)){if(typeof c!==l)throw new Error(`argument does not match constraint: typeof ${l}`)}else if(v(l)){try{if(c instanceof l)return}catch{}if(!_(c)&&c.constructor===l||l.length===1&&l.call(void 0,c)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=m;function o(c){let l=[],h=Object.getPrototypeOf(c);for(;Object.prototype!==h;)l=l.concat(Object.getOwnPropertyNames(h)),h=Object.getPrototypeOf(h);return l}e.getAllPropertyNames=o;function d(c){const l=[];for(const h of o(c))typeof c[h]=="function"&&l.push(h);return l}e.getAllMethodNames=d;function r(c,l){const h=R=>function(){const N=Array.prototype.slice.call(arguments,0);return l(R,N)},E={};for(const R of c)E[R]=h(R);return E}e.createProxyObject=r;function s(c){return c===null?void 0:c}e.withNullAsUndefined=s;function i(c){return typeof c=="undefined"?null:c}e.withUndefinedAsNull=i;function t(c,l="Unreachable"){throw new Error(l)}e.assertNever=t}),define(Ie[24],ke([1,0,10]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function n(w){if(!w||typeof w!="object"||w instanceof RegExp)return w;const b=Array.isArray(w)?[]:{};return Object.keys(w).forEach(p=>{w[p]&&typeof w[p]=="object"?b[p]=n(w[p]):b[p]=w[p]}),b}e.deepClone=n;function y(w){if(!w||typeof w!="object")return w;const b=[w];for(;b.length>0;){const p=b.shift();Object.freeze(p);for(const g in p)if(A.call(p,g)){const v=p[g];typeof v=="object"&&!Object.isFrozen(v)&&!(0,u.isTypedArray)(v)&&b.push(v)}}return w}e.deepFreeze=y;const A=Object.prototype.hasOwnProperty;function D(w,b){return C(w,b,new Set)}e.cloneAndChange=D;function C(w,b,p){if((0,u.isUndefinedOrNull)(w))return w;const g=b(w);if(typeof g!="undefined")return g;if((0,u.isArray)(w)){const v=[];for(const f of w)v.push(C(f,b,p));return v}if((0,u.isObject)(w)){if(p.has(w))throw new Error("Cannot clone recursive data-structure");p.add(w);const v={};for(const f in w)A.call(w,f)&&(v[f]=C(w[f],b,p));return p.delete(w),v}return w}function S(w,b,p=!0){return(0,u.isObject)(w)?((0,u.isObject)(b)&&Object.keys(b).forEach(g=>{g in w?p&&((0,u.isObject)(w[g])&&(0,u.isObject)(b[g])?S(w[g],b[g],p):w[g]=b[g]):w[g]=b[g]}),w):b}e.mixin=S;function P(w,b){if(w===b)return!0;if(w==null||b===null||b===void 0||typeof w!=typeof b||typeof w!="object"||Array.isArray(w)!==Array.isArray(b))return!1;let p,g;if(Array.isArray(w)){if(w.length!==b.length)return!1;for(p=0;p<w.length;p++)if(!P(w[p],b[p]))return!1}else{const v=[];for(g in w)v.push(g);v.sort();const f=[];for(g in b)f.push(g);if(f.sort(),!P(v,f))return!1;for(p=0;p<v.length;p++)if(!P(w[v[p]],b[v[p]]))return!1}return!0}e.equals=P;function L(w){const b=new Set;return JSON.stringify(w,(p,g)=>{if((0,u.isObject)(g)||Array.isArray(g)){if(b.has(g))return"[Circular]";b.add(g)}return g})}e.safeStringify=L;function I(w,b){const p=Object.create(null);return!w||!b||Object.keys(b).forEach(v=>{const f=w[v],a=b[v];P(f,a)||(p[v]=a)}),p}e.distinct=I;function _(w,b){const p=b.toLowerCase(),g=Object.keys(w).find(v=>v.toLowerCase()===p);return g?w[g]:w[b]}e.getCaseInsensitive=_;function T(w,b){const p=Object.create(null);for(const[g,v]of Object.entries(w))b(g,v)&&(p[g]=v);return p}e.filter=T}),define(Ie[96],ke([1,0]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var u;(function(A){A[A.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",A[A.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",A[A.MAX_UINT_8=255]="MAX_UINT_8",A[A.MAX_UINT_16=65535]="MAX_UINT_16",A[A.MAX_UINT_32=4294967295]="MAX_UINT_32",A[A.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(u=e.Constants||(e.Constants={}));function n(A){return A<0?0:A>255?255:A|0}e.toUint8=n;function y(A){return A<0?0:A>4294967295?4294967295:A|0}e.toUint32=y}),define(Ie[34],ke([1,0]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const u=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function n(y){return u.test(y)}e.isUUID=n,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let y;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?y=crypto.getRandomValues.bind(crypto):y=function(C){for(let S=0;S<C.length;S++)C[S]=Math.floor(Math.random()*256);return C};const A=new Uint8Array(16),D=[];for(let C=0;C<256;C++)D.push(C.toString(16).padStart(2,"0"));return function(){y(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let S=0,P="";return P+=D[A[S++]],P+=D[A[S++]],P+=D[A[S++]],P+=D[A[S++]],P+="-",P+=D[A[S++]],P+=D[A[S++]],P+="-",P+=D[A[S++]],P+=D[A[S++]],P+="-",P+=D[A[S++]],P+=D[A[S++]],P+="-",P+=D[A[S++]],P+=D[A[S++]],P+=D[A[S++]],P+=D[A[S++]],P+=D[A[S++]],P+=D[A[S++]],P}}()}),define(Ie[145],ke([1,0,97]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class n{constructor(A="utf8"){this.stringDecoder=new u.StringDecoder(A),this.remaining=null}write(A){const D=[],C=this.remaining?this.remaining+this.stringDecoder.write(A):this.stringDecoder.write(A);if(C.length<1)return D;let S=0,P,L=S;for(;L<C.length;)if(P=C.charCodeAt(L),P===13||P===10){if(D.push(C.substring(S,L)),L++,L<C.length){const I=P;P=C.charCodeAt(L),(I===13&&P===10||I===10&&P===13)&&L++}S=L}else L++;return this.remaining=S<C.length?C.substr(S):null,D}end(){return this.remaining}}e.LineDecoder=n}),define(Ie[98],ke([1,0,96]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class n{constructor(C){const S=(0,u.toUint8)(C);this._defaultValue=S,this._asciiMap=n._createAsciiMap(S),this._map=new Map}static _createAsciiMap(C){const S=new Uint8Array(256);for(let P=0;P<256;P++)S[P]=C;return S}set(C,S){const P=(0,u.toUint8)(S);C>=0&&C<256?this._asciiMap[C]=P:this._map.set(C,P)}get(C){return C>=0&&C<256?this._asciiMap[C]:this._map.get(C)||this._defaultValue}}e.CharacterClassifier=n;var y;(function(D){D[D.False=0]="False",D[D.True=1]="True"})(y||(y={}));class A{constructor(){this._actual=new n(0)}add(C){this._actual.set(C,1)}has(C){return this._actual.get(C)===1}}e.CharacterSet=A}),define(Ie[48],ke([1,0]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class u{constructor(y,A){this.lineNumber=y,this.column=A}with(y=this.lineNumber,A=this.column){return y===this.lineNumber&&A===this.column?this:new u(y,A)}delta(y=0,A=0){return this.with(this.lineNumber+y,this.column+A)}equals(y){return u.equals(this,y)}static equals(y,A){return!y&&!A?!0:!!y&&!!A&&y.lineNumber===A.lineNumber&&y.column===A.column}isBefore(y){return u.isBefore(this,y)}static isBefore(y,A){return y.lineNumber<A.lineNumber?!0:A.lineNumber<y.lineNumber?!1:y.column<A.column}isBeforeOrEqual(y){return u.isBeforeOrEqual(this,y)}static isBeforeOrEqual(y,A){return y.lineNumber<A.lineNumber?!0:A.lineNumber<y.lineNumber?!1:y.column<=A.column}static compare(y,A){const D=y.lineNumber|0,C=A.lineNumber|0;if(D===C){const S=y.column|0,P=A.column|0;return S-P}return D-C}clone(){return new u(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(y){return new u(y.lineNumber,y.column)}static isIPosition(y){return y&&typeof y.lineNumber=="number"&&typeof y.column=="number"}}e.Position=u}),define(Ie[35],ke([1,0,48]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class n{constructor(A,D,C,S){A>C||A===C&&D>S?(this.startLineNumber=C,this.startColumn=S,this.endLineNumber=A,this.endColumn=D):(this.startLineNumber=A,this.startColumn=D,this.endLineNumber=C,this.endColumn=S)}isEmpty(){return n.isEmpty(this)}static isEmpty(A){return A.startLineNumber===A.endLineNumber&&A.startColumn===A.endColumn}containsPosition(A){return n.containsPosition(this,A)}static containsPosition(A,D){return!(D.lineNumber<A.startLineNumber||D.lineNumber>A.endLineNumber||D.lineNumber===A.startLineNumber&&D.column<A.startColumn||D.lineNumber===A.endLineNumber&&D.column>A.endColumn)}static strictContainsPosition(A,D){return!(D.lineNumber<A.startLineNumber||D.lineNumber>A.endLineNumber||D.lineNumber===A.startLineNumber&&D.column<=A.startColumn||D.lineNumber===A.endLineNumber&&D.column>=A.endColumn)}containsRange(A){return n.containsRange(this,A)}static containsRange(A,D){return!(D.startLineNumber<A.startLineNumber||D.endLineNumber<A.startLineNumber||D.startLineNumber>A.endLineNumber||D.endLineNumber>A.endLineNumber||D.startLineNumber===A.startLineNumber&&D.startColumn<A.startColumn||D.endLineNumber===A.endLineNumber&&D.endColumn>A.endColumn)}strictContainsRange(A){return n.strictContainsRange(this,A)}static strictContainsRange(A,D){return!(D.startLineNumber<A.startLineNumber||D.endLineNumber<A.startLineNumber||D.startLineNumber>A.endLineNumber||D.endLineNumber>A.endLineNumber||D.startLineNumber===A.startLineNumber&&D.startColumn<=A.startColumn||D.endLineNumber===A.endLineNumber&&D.endColumn>=A.endColumn)}plusRange(A){return n.plusRange(this,A)}static plusRange(A,D){let C,S,P,L;return D.startLineNumber<A.startLineNumber?(C=D.startLineNumber,S=D.startColumn):D.startLineNumber===A.startLineNumber?(C=D.startLineNumber,S=Math.min(D.startColumn,A.startColumn)):(C=A.startLineNumber,S=A.startColumn),D.endLineNumber>A.endLineNumber?(P=D.endLineNumber,L=D.endColumn):D.endLineNumber===A.endLineNumber?(P=D.endLineNumber,L=Math.max(D.endColumn,A.endColumn)):(P=A.endLineNumber,L=A.endColumn),new n(C,S,P,L)}intersectRanges(A){return n.intersectRanges(this,A)}static intersectRanges(A,D){let C=A.startLineNumber,S=A.startColumn,P=A.endLineNumber,L=A.endColumn;const I=D.startLineNumber,_=D.startColumn,T=D.endLineNumber,w=D.endColumn;return C<I?(C=I,S=_):C===I&&(S=Math.max(S,_)),P>T?(P=T,L=w):P===T&&(L=Math.min(L,w)),C>P||C===P&&S>L?null:new n(C,S,P,L)}equalsRange(A){return n.equalsRange(this,A)}static equalsRange(A,D){return!!A&&!!D&&A.startLineNumber===D.startLineNumber&&A.startColumn===D.startColumn&&A.endLineNumber===D.endLineNumber&&A.endColumn===D.endColumn}getEndPosition(){return n.getEndPosition(this)}static getEndPosition(A){return new u.Position(A.endLineNumber,A.endColumn)}getStartPosition(){return n.getStartPosition(this)}static getStartPosition(A){return new u.Position(A.startLineNumber,A.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(A,D){return new n(this.startLineNumber,this.startColumn,A,D)}setStartPosition(A,D){return new n(A,D,this.endLineNumber,this.endColumn)}collapseToStart(){return n.collapseToStart(this)}static collapseToStart(A){return new n(A.startLineNumber,A.startColumn,A.startLineNumber,A.startColumn)}static fromPositions(A,D=A){return new n(A.lineNumber,A.column,D.lineNumber,D.column)}static lift(A){return A?new n(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):null}static isIRange(A){return A&&typeof A.startLineNumber=="number"&&typeof A.startColumn=="number"&&typeof A.endLineNumber=="number"&&typeof A.endColumn=="number"}static areIntersectingOrTouching(A,D){return!(A.endLineNumber<D.startLineNumber||A.endLineNumber===D.startLineNumber&&A.endColumn<D.startColumn||D.endLineNumber<A.startLineNumber||D.endLineNumber===A.startLineNumber&&D.endColumn<A.startColumn)}static areIntersecting(A,D){return!(A.endLineNumber<D.startLineNumber||A.endLineNumber===D.startLineNumber&&A.endColumn<=D.startColumn||D.endLineNumber<A.startLineNumber||D.endLineNumber===A.startLineNumber&&D.endColumn<=A.startColumn)}static compareRangesUsingStarts(A,D){if(A&&D){const P=A.startLineNumber|0,L=D.startLineNumber|0;if(P===L){const I=A.startColumn|0,_=D.startColumn|0;if(I===_){const T=A.endLineNumber|0,w=D.endLineNumber|0;if(T===w){const b=A.endColumn|0,p=D.endColumn|0;return b-p}return T-w}return I-_}return P-L}return(A?1:0)-(D?1:0)}static compareRangesUsingEnds(A,D){return A.endLineNumber===D.endLineNumber?A.endColumn===D.endColumn?A.startLineNumber===D.startLineNumber?A.startColumn-D.startColumn:A.startLineNumber-D.startLineNumber:A.endColumn-D.endColumn:A.endLineNumber-D.endLineNumber}static spansMultipleLines(A){return A.endLineNumber>A.startLineNumber}toJSON(){return this}}e.Range=n}),define(Ie[146],ke([1,0,48,35]),function(Q,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var y;(function(D){D[D.LTR=0]="LTR",D[D.RTL=1]="RTL"})(y=e.SelectionDirection||(e.SelectionDirection={}));class A extends n.Range{constructor(C,S,P,L){super(C,S,P,L);this.selectionStartLineNumber=C,this.selectionStartColumn=S,this.positionLineNumber=P,this.positionColumn=L}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(C){return A.selectionsEqual(this,C)}static selectionsEqual(C,S){return C.selectionStartLineNumber===S.selectionStartLineNumber&&C.selectionStartColumn===S.selectionStartColumn&&C.positionLineNumber===S.positionLineNumber&&C.positionColumn===S.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(C,S){return this.getDirection()===0?new A(this.startLineNumber,this.startColumn,C,S):new A(C,S,this.startLineNumber,this.startColumn)}getPosition(){return new u.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new u.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(C,S){return this.getDirection()===0?new A(C,S,this.endLineNumber,this.endColumn):new A(this.endLineNumber,this.endColumn,C,S)}static fromPositions(C,S=C){return new A(C.lineNumber,C.column,S.lineNumber,S.column)}static fromRange(C,S){return S===0?new A(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn):new A(C.endLineNumber,C.endColumn,C.startLineNumber,C.startColumn)}static liftSelection(C){return new A(C.selectionStartLineNumber,C.selectionStartColumn,C.positionLineNumber,C.positionColumn)}static selectionsArrEqual(C,S){if(C&&!S||!C&&S)return!1;if(!C&&!S)return!0;if(C.length!==S.length)return!1;for(let P=0,L=C.length;P<L;P++)if(!this.selectionsEqual(C[P],S[P]))return!1;return!0}static isISelection(C){return C&&typeof C.selectionStartLineNumber=="number"&&typeof C.selectionStartColumn=="number"&&typeof C.positionLineNumber=="number"&&typeof C.positionColumn=="number"}static createWithDirection(C,S,P,L,I){return I===0?new A(C,S,P,L):new A(P,L,C,S)}}e.Selection=A}),define(Ie[147],ke([1,0]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ie[148],ke([1,0,98]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var n;(function(D){D[D.Regular=0]="Regular",D[D.Whitespace=1]="Whitespace",D[D.WordSeparator=2]="WordSeparator"})(n=e.WordCharacterClass||(e.WordCharacterClass={}));class y extends u.CharacterClassifier{constructor(C){super(0);for(let S=0,P=C.length;S<P;S++)this.set(C.charCodeAt(S),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=y;function A(D){const C={};return S=>(C.hasOwnProperty(S)||(C[S]=D(S)),C[S])}e.getMapForWordSeparators=A(D=>new y(D))}),define(Ie[99],ke([1,0,59,6,80]),function(Q,e,u,n,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.setDefaultGetWordAtTextConfig=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function A(I=""){let _="(-?\\d*\\.\\d\\w*)|([^";for(const T of e.USUAL_WORD_SEPARATORS)I.indexOf(T)>=0||(_+="\\"+T);return _+="\\s]+)",new RegExp(_,"g")}e.DEFAULT_WORD_REGEXP=A();function D(I){let _=e.DEFAULT_WORD_REGEXP;if(I&&I instanceof RegExp)if(I.global)_=I;else{let T="g";I.ignoreCase&&(T+="i"),I.multiline&&(T+="m"),I.unicode&&(T+="u"),_=new RegExp(I.source,T)}return _.lastIndex=0,_}e.ensureValidWordDefinition=D;const C=new y.LinkedList;C.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function S(I){const _=C.unshift(I);return(0,n.toDisposable)(_)}e.setDefaultGetWordAtTextConfig=S;function P(I,_,T,w,b){if(b||(b=u.Iterable.first(C)),T.length>b.maxLen){let a=I-b.maxLen/2;return a<0?a=0:w+=a,T=T.substring(a,I+b.maxLen/2),P(I,_,T,w,b)}const p=Date.now(),g=I-1-w;let v=-1,f=null;for(let a=1;!(Date.now()-p>=b.timeBudget);a++){const m=g-b.windowSize*a;_.lastIndex=Math.max(0,m);const o=L(_,T,g,v);if(!o&&f||(f=o,m<=0))break;v=m}if(f){const a={word:f[0],startColumn:w+1+f.index,endColumn:w+1+f.index+f[0].length};return _.lastIndex=0,a}return null}e.getWordAtText=P;function L(I,_,T,w){let b;for(;b=I.exec(_);){const p=b.index||0;if(p<=T&&I.lastIndex>=T)return b;if(w>0&&p>w)return null}return null}}),define(Ie[149],ke([1,0]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var u;(function(D){D[D.None=0]="None",D[D.Indent=1]="Indent",D[D.IndentOutdent=2]="IndentOutdent",D[D.Outdent=3]="Outdent"})(u=e.IndentAction||(e.IndentAction={}));class n{constructor(C){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=C.open,this.close=C.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(C.notIn))for(let S=0,P=C.notIn.length;S<P;S++)switch(C.notIn[S]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(C){switch(C){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(C,S){if(C.getTokenCount()===0)return!0;const P=C.findTokenIndexAtOffset(S-2),L=C.getStandardTokenType(P);return this.isOK(L)}_findNeutralCharacterInRange(C,S){for(let P=C;P<=S;P++){const L=String.fromCharCode(P);if(!this.open.includes(L)&&!this.close.includes(L))return L}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=n;class y{constructor(C){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of C)A(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),A(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),A(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),A(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&A(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=y;function A(D,C,S){D.has(C)?D.get(C).push(S):D.set(C,[S])}}),define(Ie[150],ke([1,0,98]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var n;(function(T){T[T.Invalid=0]="Invalid",T[T.Start=1]="Start",T[T.H=2]="H",T[T.HT=3]="HT",T[T.HTT=4]="HTT",T[T.HTTP=5]="HTTP",T[T.F=6]="F",T[T.FI=7]="FI",T[T.FIL=8]="FIL",T[T.BeforeColon=9]="BeforeColon",T[T.AfterColon=10]="AfterColon",T[T.AlmostThere=11]="AlmostThere",T[T.End=12]="End",T[T.Accept=13]="Accept",T[T.LastKnownState=14]="LastKnownState"})(n=e.State||(e.State={}));class y{constructor(w,b,p){const g=new Uint8Array(w*b);for(let v=0,f=w*b;v<f;v++)g[v]=p;this._data=g,this.rows=w,this.cols=b}get(w,b){return this._data[w*this.cols+b]}set(w,b,p){this._data[w*this.cols+b]=p}}e.Uint8Matrix=y;class A{constructor(w){let b=0,p=0;for(let v=0,f=w.length;v<f;v++){const[a,m,o]=w[v];m>b&&(b=m),a>p&&(p=a),o>p&&(p=o)}b++,p++;const g=new y(p,b,0);for(let v=0,f=w.length;v<f;v++){const[a,m,o]=w[v];g.set(a,m,o)}this._states=g,this._maxCharCode=b}nextState(w,b){return b<0||b>=this._maxCharCode?0:this._states.get(w,b)}}e.StateMachine=A;let D=null;function C(){return D===null&&(D=new A([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),D}var S;(function(T){T[T.None=0]="None",T[T.ForceTermination=1]="ForceTermination",T[T.CannotEndIn=2]="CannotEndIn"})(S||(S={}));let P=null;function L(){if(P===null){P=new u.CharacterClassifier(0);const T=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let b=0;b<T.length;b++)P.set(T.charCodeAt(b),1);const w=".,;:";for(let b=0;b<w.length;b++)P.set(w.charCodeAt(b),2)}return P}class I{static _createLink(w,b,p,g,v){let f=v-1;do{const a=b.charCodeAt(f);if(w.get(a)!==2)break;f--}while(f>g);if(g>0){const a=b.charCodeAt(g-1),m=b.charCodeAt(f);(a===40&&m===41||a===91&&m===93||a===123&&m===125)&&f--}return{range:{startLineNumber:p,startColumn:g+1,endLineNumber:p,endColumn:f+2},url:b.substring(g,f+1)}}static computeLinks(w,b=C()){const p=L(),g=[];for(let v=1,f=w.getLineCount();v<=f;v++){const a=w.getLineContent(v),m=a.length;let o=0,d=0,r=0,s=1,i=!1,t=!1,c=!1,l=!1;for(;o<m;){let h=!1;const E=a.charCodeAt(o);if(s===13){let R;switch(E){case 40:i=!0,R=0;break;case 41:R=i?0:1;break;case 91:c=!0,t=!0,R=0;break;case 93:c=!1,R=t?0:1;break;case 123:l=!0,R=0;break;case 125:R=l?0:1;break;case 39:R=r===39?1:0;break;case 34:R=r===34?1:0;break;case 96:R=r===96?1:0;break;case 42:R=r===42?1:0;break;case 124:R=r===124?1:0;break;case 32:R=c?0:1;break;default:R=p.get(E)}R===1&&(g.push(I._createLink(p,a,v,d,o)),h=!0)}else if(s===12){let R;E===91?(t=!0,R=0):R=p.get(E),R===1?h=!0:s=13}else s=b.nextState(s,E),s===0&&(h=!0);h&&(s=1,i=!1,t=!1,l=!1,d=o+1,r=E),o++}s===13&&g.push(I._createLink(p,a,v,d,m))}return g}}e.LinkComputer=I;function _(T){return!T||typeof T.getLineCount!="function"||typeof T.getLineContent!="function"?[]:I.computeLinks(T)}e.computeLinks=_}),define(Ie[100],ke([1,0,24]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.OverviewRulerLane=void 0;var n;(function(v){v[v.Left=1]="Left",v[v.Center=2]="Center",v[v.Right=4]="Right",v[v.Full=7]="Full"})(n=e.OverviewRulerLane||(e.OverviewRulerLane={}));var y;(function(v){v[v.Inline=1]="Inline",v[v.Gutter=2]="Gutter"})(y=e.MinimapPosition||(e.MinimapPosition={}));var A;(function(v){v[v.Both=0]="Both",v[v.Right=1]="Right",v[v.Left=2]="Left",v[v.None=3]="None"})(A=e.InjectedTextCursorStops||(e.InjectedTextCursorStops={}));var D;(function(v){v[v.TextDefined=0]="TextDefined",v[v.LF=1]="LF",v[v.CRLF=2]="CRLF"})(D=e.EndOfLinePreference||(e.EndOfLinePreference={}));var C;(function(v){v[v.LF=1]="LF",v[v.CRLF=2]="CRLF"})(C=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var S;(function(v){v[v.LF=0]="LF",v[v.CRLF=1]="CRLF"})(S=e.EndOfLineSequence||(e.EndOfLineSequence={}));class P{constructor(f){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,f.tabSize|0),this.indentSize=f.tabSize|0,this.insertSpaces=Boolean(f.insertSpaces),this.defaultEOL=f.defaultEOL|0,this.trimAutoWhitespace=Boolean(f.trimAutoWhitespace),this.bracketPairColorizationOptions=f.bracketPairColorizationOptions}equals(f){return this.tabSize===f.tabSize&&this.indentSize===f.indentSize&&this.insertSpaces===f.insertSpaces&&this.defaultEOL===f.defaultEOL&&this.trimAutoWhitespace===f.trimAutoWhitespace&&(0,u.equals)(this.bracketPairColorizationOptions,f.bracketPairColorizationOptions)}createChangeEvent(f){return{tabSize:this.tabSize!==f.tabSize,indentSize:this.indentSize!==f.indentSize,insertSpaces:this.insertSpaces!==f.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==f.trimAutoWhitespace}}}e.TextModelResolvedOptions=P;class L{constructor(f,a){this._findMatchBrand=void 0,this.range=f,this.matches=a}}e.FindMatch=L;var I;(function(v){v[v.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",v[v.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",v[v.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",v[v.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(I=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var _;(function(v){v[v.Left=0]="Left",v[v.Right=1]="Right",v[v.None=2]="None",v[v.LeftOfInjectedText=3]="LeftOfInjectedText",v[v.RightOfInjectedText=4]="RightOfInjectedText"})(_=e.PositionAffinity||(e.PositionAffinity={}));var T;(function(v){v[v.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(T=e.ModelConstants||(e.ModelConstants={}));class w{constructor(f,a,m,o,d,r){this.identifier=f,this.range=a,this.text=m,this.forceMoveMarkers=o,this.isAutoWhitespaceEdit=d,this._isTracked=r}}e.ValidAnnotatedEditOperation=w;class b{constructor(f,a,m){this.regex=f,this.wordSeparators=a,this.simpleSearch=m}}e.SearchData=b;class p{constructor(f,a,m){this.reverseEdits=f,this.changes=a,this.trimAutoWhitespaceLineNumbers=m}}e.ApplyEditsResult=p;function g(v){return!v.isTooLargeForSyncing()&&!v.isForSimpleWidget}e.shouldSynchronizeModel=g}),define(Ie[151],ke([1,0,16,96]),function(Q,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class y{constructor(S){this.values=S,this.prefixSum=new Uint32Array(S.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(S,P){S=(0,n.toUint32)(S);const L=this.values,I=this.prefixSum,_=P.length;return _===0?!1:(this.values=new Uint32Array(L.length+_),this.values.set(L.subarray(0,S),0),this.values.set(L.subarray(S),S+_),this.values.set(P,S),S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(I.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(S,P){return S=(0,n.toUint32)(S),P=(0,n.toUint32)(P),this.values[S]===P?!1:(this.values[S]=P,S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),!0)}removeValues(S,P){S=(0,n.toUint32)(S),P=(0,n.toUint32)(P);const L=this.values,I=this.prefixSum;if(S>=L.length)return!1;const _=L.length-S;return P>=_&&(P=_),P===0?!1:(this.values=new Uint32Array(L.length-P),this.values.set(L.subarray(0,S),0),this.values.set(L.subarray(S+P),S),this.prefixSum=new Uint32Array(this.values.length),S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(I.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(S){return S<0?0:(S=(0,n.toUint32)(S),this._getPrefixSum(S))}_getPrefixSum(S){if(S<=this.prefixSumValidIndex[0])return this.prefixSum[S];let P=this.prefixSumValidIndex[0]+1;P===0&&(this.prefixSum[0]=this.values[0],P++),S>=this.values.length&&(S=this.values.length-1);for(let L=P;L<=S;L++)this.prefixSum[L]=this.prefixSum[L-1]+this.values[L];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],S),this.prefixSum[S]}getIndexOf(S){S=Math.floor(S),this.getTotalSum();let P=0,L=this.values.length-1,I=0,_=0,T=0;for(;P<=L;)if(I=P+(L-P)/2|0,_=this.prefixSum[I],T=_-this.values[I],S<T)L=I-1;else if(S>=_)P=I+1;else break;return new D(I,S-T)}}e.PrefixSumComputer=y;class A{constructor(S){this._values=S,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(S){return this._ensureValid(),S===0?0:this._prefixSum[S-1]}getIndexOf(S){this._ensureValid();const P=this._indexBySum[S],L=P>0?this._prefixSum[P-1]:0;return new D(P,S-L)}removeValues(S,P){this._values.splice(S,P),this._invalidate(S)}insertValues(S,P){this._values=(0,u.arrayInsert)(this._values,S,P),this._invalidate(S)}_invalidate(S){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,S-1)}_ensureValid(){if(!this._isValid){for(let S=this._validEndIndex+1,P=this._values.length;S<P;S++){const L=this._values[S],I=S>0?this._prefixSum[S-1]:0;this._prefixSum[S]=I+L;for(let _=0;_<L;_++)this._indexBySum[I+_]=S}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(S,P){this._values[S]!==P&&(this._values[S]=P,this._invalidate(S))}}e.ConstantTimePrefixSumComputer=A;class D{constructor(S,P){this.index=S,this.remainder=P,this._prefixSumIndexOfResultBrand=void 0,this.index=S,this.remainder=P}}e.PrefixSumIndexOfResult=D}),define(Ie[152],ke([19,20]),function(Q,e){return Q.create("vs/base/common/date",e)}),define(Ie[153],ke([1,0,152]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const n=60,y=n*60,A=y*24,D=A*7,C=A*30,S=A*365;function P(I,_,T){typeof I!="number"&&(I=I.getTime());const w=Math.round((new Date().getTime()-I)/1e3);if(w<-30)return(0,u.localize)(0,null,P(new Date().getTime()+w*1e3,!1));if(w<30)return(0,u.localize)(1,null);let b;return w<n?(b=w,_?b===1?T?(0,u.localize)(2,null,b):(0,u.localize)(3,null,b):T?(0,u.localize)(4,null,b):(0,u.localize)(5,null,b):b===1?T?(0,u.localize)(6,null,b):(0,u.localize)(7,null,b):T?(0,u.localize)(8,null,b):(0,u.localize)(9,null,b)):w<y?(b=Math.floor(w/n),_?b===1?T?(0,u.localize)(10,null,b):(0,u.localize)(11,null,b):T?(0,u.localize)(12,null,b):(0,u.localize)(13,null,b):b===1?T?(0,u.localize)(14,null,b):(0,u.localize)(15,null,b):T?(0,u.localize)(16,null,b):(0,u.localize)(17,null,b)):w<A?(b=Math.floor(w/y),_?b===1?T?(0,u.localize)(18,null,b):(0,u.localize)(19,null,b):T?(0,u.localize)(20,null,b):(0,u.localize)(21,null,b):b===1?T?(0,u.localize)(22,null,b):(0,u.localize)(23,null,b):T?(0,u.localize)(24,null,b):(0,u.localize)(25,null,b)):w<D?(b=Math.floor(w/A),_?b===1?(0,u.localize)(26,null,b):(0,u.localize)(27,null,b):b===1?(0,u.localize)(28,null,b):(0,u.localize)(29,null,b)):w<C?(b=Math.floor(w/D),_?b===1?T?(0,u.localize)(30,null,b):(0,u.localize)(31,null,b):T?(0,u.localize)(32,null,b):(0,u.localize)(33,null,b):b===1?T?(0,u.localize)(34,null,b):(0,u.localize)(35,null,b):T?(0,u.localize)(36,null,b):(0,u.localize)(37,null,b)):w<S?(b=Math.floor(w/C),_?b===1?T?(0,u.localize)(38,null,b):(0,u.localize)(39,null,b):T?(0,u.localize)(40,null,b):(0,u.localize)(41,null,b):b===1?T?(0,u.localize)(42,null,b):(0,u.localize)(43,null,b):T?(0,u.localize)(44,null,b):(0,u.localize)(45,null,b)):(b=Math.floor(w/S),_?b===1?T?(0,u.localize)(46,null,b):(0,u.localize)(47,null,b):T?(0,u.localize)(48,null,b):(0,u.localize)(49,null,b):b===1?T?(0,u.localize)(50,null,b):(0,u.localize)(51,null,b):T?(0,u.localize)(52,null,b):(0,u.localize)(53,null,b))}e.fromNow=P;function L(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=L}),define(Ie[154],ke([19,20]),function(Q,e){return Q.create("vs/base/common/errorMessage",e)}),define(Ie[49],ke([1,0,16,10,154]),function(Q,e,u,n,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function A(I,_){return _&&(I.stack||I.stacktrace)?y.localize(0,null,C(I),D(I.stack)||D(I.stacktrace)):C(I)}function D(I){return Array.isArray(I)?I.join(`
`):I}function C(I){return typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?y.localize(1,null,I.message):I.message||y.localize(2,null)}function S(I=null,_=!1){if(!I)return y.localize(3,null);if(Array.isArray(I)){const T=u.coalesce(I),w=S(T[0],_);return T.length>1?y.localize(4,null,w,T.length):w}if(n.isString(I))return I;if(I.detail){const T=I.detail;if(T.error)return A(T.error,_);if(T.exception)return A(T.exception,_)}return I.stack?A(I,_):I.message?I.message:y.localize(5,null)}e.toErrorMessage=S;function P(I){const _=I;return _ instanceof Error&&Array.isArray(_.actions)}e.isErrorWithActions=P;function L(I,_){let T;return typeof I=="string"?T=new Error(I):T=I,T.actions=_,T}e.createErrorWithActions=L}),define(Ie[155],ke([19,20]),function(Q,e){return Q.create("vs/base/common/platform",e)}),define(Ie[13],ke([1,0,155]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=void 0;const n="en";let y=!1,A=!1,D=!1,C=!1,S=!1,P=!1,L=!1,I=!1,_=!1,T,w=n,b,p;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let g;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?g=e.globals.vscode.process:typeof process!="undefined"&&(g=process);const v=typeof g?.versions?.electron=="string",f=v&&g?.type==="renderer";if(typeof navigator=="object"&&!f)p=navigator.userAgent,y=p.indexOf("Windows")>=0,A=p.indexOf("Macintosh")>=0,I=(p.indexOf("Macintosh")>=0||p.indexOf("iPad")>=0||p.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,D=p.indexOf("Linux")>=0,P=!0,T=u.getConfiguredDefaultLocale(u.localize(0,null))||n,w=T;else if(typeof g=="object"){y=g.platform==="win32",A=g.platform==="darwin",D=g.platform==="linux",C=D&&!!g.env.SNAP&&!!g.env.SNAP_REVISION,L=v,_=!!g.env.CI||!!g.env.BUILD_ARTIFACTSTAGINGDIRECTORY,T=n,w=n;const c=g.env.VSCODE_NLS_CONFIG;if(c)try{const l=JSON.parse(c),h=l.availableLanguages["*"];T=l.locale,w=h||n,b=l._translationsConfigFile}catch{}S=!0}else console.error("Unable to resolve platform.");var a;(function(c){c[c.Web=0]="Web",c[c.Mac=1]="Mac",c[c.Linux=2]="Linux",c[c.Windows=3]="Windows"})(a=e.Platform||(e.Platform={}));function m(c){switch(c){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=m;let o=0;A?o=1:y?o=3:D&&(o=2),e.isWindows=y,e.isMacintosh=A,e.isLinux=D,e.isLinuxSnap=C,e.isNative=S,e.isElectron=L,e.isWeb=P,e.isWebWorker=P&&typeof e.globals.importScripts=="function",e.isIOS=I,e.isCI=_,e.platform=o,e.userAgent=p,e.language=w;var d;(function(c){function l(){return e.language}c.value=l;function h(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}c.isDefaultVariant=h;function E(){return e.language==="en"}c.isDefault=E})(d=e.Language||(e.Language={})),e.locale=T,e.translationsConfigFile=b,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const c=[];e.globals.addEventListener("message",h=>{if(h.data&&h.data.vscodeScheduleAsyncWork)for(let E=0,R=c.length;E<R;E++){const N=c[E];if(N.id===h.data.vscodeScheduleAsyncWork){c.splice(E,1),N.callback();return}}});let l=0;return h=>{const E=++l;c.push({id:E,callback:h}),e.globals.postMessage({vscodeScheduleAsyncWork:E},"*")}}return c=>setTimeout(c)})();var r;(function(c){c[c.Windows=1]="Windows",c[c.Macintosh=2]="Macintosh",c[c.Linux=3]="Linux"})(r=e.OperatingSystem||(e.OperatingSystem={})),e.OS=A||I?2:y?1:3;let s=!0,i=!1;function t(){if(!i){i=!0;const c=new Uint8Array(2);c[0]=1,c[1]=2,s=new Uint16Array(c.buffer)[0]===(2<<8)+1}return s}e.isLittleEndian=t,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(Ie[40],ke([1,0,13]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let n;if(typeof u.globals.vscode!="undefined"&&typeof u.globals.vscode.process!="undefined"){const y=u.globals.vscode.process;n={get platform(){return y.platform},get arch(){return y.arch},get env(){return y.env},cwd(){return y.cwd()}}}else typeof process!="undefined"?n={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:n={get platform(){return u.isWindows?"win32":u.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=n.cwd,e.env=n.env,e.platform=n.platform,e.arch=n.arch}),define(Ie[9],ke([1,0,40]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const n=65,y=97,A=90,D=122,C=46,S=47,P=92,L=58,I=63;class _ extends Error{constructor(a,m,o){let d;typeof m=="string"&&m.indexOf("not ")===0?(d="must not be",m=m.replace(/^not /,"")):d="must be";const r=a.indexOf(".")!==-1?"property":"argument";let s=`The "${a}" ${r} ${d} of type ${m}`;s+=`. Received type ${typeof o}`;super(s);this.code="ERR_INVALID_ARG_TYPE"}}function T(f,a){if(typeof f!="string")throw new _(a,"string",f)}function w(f){return f===S||f===P}function b(f){return f===S}function p(f){return f>=n&&f<=A||f>=y&&f<=D}function g(f,a,m,o){let d="",r=0,s=-1,i=0,t=0;for(let c=0;c<=f.length;++c){if(c<f.length)t=f.charCodeAt(c);else{if(o(t))break;t=S}if(o(t)){if(!(s===c-1||i===1))if(i===2){if(d.length<2||r!==2||d.charCodeAt(d.length-1)!==C||d.charCodeAt(d.length-2)!==C){if(d.length>2){const l=d.lastIndexOf(m);l===-1?(d="",r=0):(d=d.slice(0,l),r=d.length-1-d.lastIndexOf(m)),s=c,i=0;continue}else if(d.length!==0){d="",r=0,s=c,i=0;continue}}a&&(d+=d.length>0?`${m}..`:"..",r=2)}else d.length>0?d+=`${m}${f.slice(s+1,c)}`:d=f.slice(s+1,c),r=c-s-1;s=c,i=0}else t===C&&i!==-1?++i:i=-1}return d}function v(f,a){if(a===null||typeof a!="object")throw new _("pathObject","Object",a);const m=a.dir||a.root,o=a.base||`${a.name||""}${a.ext||""}`;return m?m===a.root?`${m}${o}`:`${m}${f}${o}`:o}e.win32={resolve(...f){let a="",m="",o=!1;for(let d=f.length-1;d>=-1;d--){let r;if(d>=0){if(r=f[d],T(r,"path"),r.length===0)continue}else a.length===0?r=u.cwd():(r=u.env[`=${a}`]||u.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==a.toLowerCase()&&r.charCodeAt(2)===P)&&(r=`${a}\\`));const s=r.length;let i=0,t="",c=!1;const l=r.charCodeAt(0);if(s===1)w(l)&&(i=1,c=!0);else if(w(l))if(c=!0,w(r.charCodeAt(1))){let h=2,E=h;for(;h<s&&!w(r.charCodeAt(h));)h++;if(h<s&&h!==E){const R=r.slice(E,h);for(E=h;h<s&&w(r.charCodeAt(h));)h++;if(h<s&&h!==E){for(E=h;h<s&&!w(r.charCodeAt(h));)h++;(h===s||h!==E)&&(t=`\\\\${R}\\${r.slice(E,h)}`,i=h)}}}else i=1;else p(l)&&r.charCodeAt(1)===L&&(t=r.slice(0,2),i=2,s>2&&w(r.charCodeAt(2))&&(c=!0,i=3));if(t.length>0)if(a.length>0){if(t.toLowerCase()!==a.toLowerCase())continue}else a=t;if(o){if(a.length>0)break}else if(m=`${r.slice(i)}\\${m}`,o=c,c&&a.length>0)break}return m=g(m,!o,"\\",w),o?`${a}\\${m}`:`${a}${m}`||"."},normalize(f){T(f,"path");const a=f.length;if(a===0)return".";let m=0,o,d=!1;const r=f.charCodeAt(0);if(a===1)return b(r)?"\\":f;if(w(r))if(d=!0,w(f.charCodeAt(1))){let i=2,t=i;for(;i<a&&!w(f.charCodeAt(i));)i++;if(i<a&&i!==t){const c=f.slice(t,i);for(t=i;i<a&&w(f.charCodeAt(i));)i++;if(i<a&&i!==t){for(t=i;i<a&&!w(f.charCodeAt(i));)i++;if(i===a)return`\\\\${c}\\${f.slice(t)}\\`;i!==t&&(o=`\\\\${c}\\${f.slice(t,i)}`,m=i)}}}else m=1;else p(r)&&f.charCodeAt(1)===L&&(o=f.slice(0,2),m=2,a>2&&w(f.charCodeAt(2))&&(d=!0,m=3));let s=m<a?g(f.slice(m),!d,"\\",w):"";return s.length===0&&!d&&(s="."),s.length>0&&w(f.charCodeAt(a-1))&&(s+="\\"),o===void 0?d?`\\${s}`:s:d?`${o}\\${s}`:`${o}${s}`},isAbsolute(f){T(f,"path");const a=f.length;if(a===0)return!1;const m=f.charCodeAt(0);return w(m)||a>2&&p(m)&&f.charCodeAt(1)===L&&w(f.charCodeAt(2))},join(...f){if(f.length===0)return".";let a,m;for(let r=0;r<f.length;++r){const s=f[r];T(s,"path"),s.length>0&&(a===void 0?a=m=s:a+=`\\${s}`)}if(a===void 0)return".";let o=!0,d=0;if(typeof m=="string"&&w(m.charCodeAt(0))){++d;const r=m.length;r>1&&w(m.charCodeAt(1))&&(++d,r>2&&(w(m.charCodeAt(2))?++d:o=!1))}if(o){for(;d<a.length&&w(a.charCodeAt(d));)d++;d>=2&&(a=`\\${a.slice(d)}`)}return e.win32.normalize(a)},relative(f,a){if(T(f,"from"),T(a,"to"),f===a)return"";const m=e.win32.resolve(f),o=e.win32.resolve(a);if(m===o||(f=m.toLowerCase(),a=o.toLowerCase(),f===a))return"";let d=0;for(;d<f.length&&f.charCodeAt(d)===P;)d++;let r=f.length;for(;r-1>d&&f.charCodeAt(r-1)===P;)r--;const s=r-d;let i=0;for(;i<a.length&&a.charCodeAt(i)===P;)i++;let t=a.length;for(;t-1>i&&a.charCodeAt(t-1)===P;)t--;const c=t-i,l=s<c?s:c;let h=-1,E=0;for(;E<l;E++){const N=f.charCodeAt(d+E);if(N!==a.charCodeAt(i+E))break;N===P&&(h=E)}if(E!==l){if(h===-1)return o}else{if(c>l){if(a.charCodeAt(i+E)===P)return o.slice(i+E+1);if(E===2)return o.slice(i+E)}s>l&&(f.charCodeAt(d+E)===P?h=E:E===2&&(h=3)),h===-1&&(h=0)}let R="";for(E=d+h+1;E<=r;++E)(E===r||f.charCodeAt(E)===P)&&(R+=R.length===0?"..":"\\..");return i+=h,R.length>0?`${R}${o.slice(i,t)}`:(o.charCodeAt(i)===P&&++i,o.slice(i,t))},toNamespacedPath(f){if(typeof f!="string")return f;if(f.length===0)return"";const a=e.win32.resolve(f);if(a.length<=2)return f;if(a.charCodeAt(0)===P){if(a.charCodeAt(1)===P){const m=a.charCodeAt(2);if(m!==I&&m!==C)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(p(a.charCodeAt(0))&&a.charCodeAt(1)===L&&a.charCodeAt(2)===P)return`\\\\?\\${a}`;return f},dirname(f){T(f,"path");const a=f.length;if(a===0)return".";let m=-1,o=0;const d=f.charCodeAt(0);if(a===1)return w(d)?f:".";if(w(d)){if(m=o=1,w(f.charCodeAt(1))){let i=2,t=i;for(;i<a&&!w(f.charCodeAt(i));)i++;if(i<a&&i!==t){for(t=i;i<a&&w(f.charCodeAt(i));)i++;if(i<a&&i!==t){for(t=i;i<a&&!w(f.charCodeAt(i));)i++;if(i===a)return f;i!==t&&(m=o=i+1)}}}}else p(d)&&f.charCodeAt(1)===L&&(m=a>2&&w(f.charCodeAt(2))?3:2,o=m);let r=-1,s=!0;for(let i=a-1;i>=o;--i)if(w(f.charCodeAt(i))){if(!s){r=i;break}}else s=!1;if(r===-1){if(m===-1)return".";r=m}return f.slice(0,r)},basename(f,a){a!==void 0&&T(a,"ext"),T(f,"path");let m=0,o=-1,d=!0,r;if(f.length>=2&&p(f.charCodeAt(0))&&f.charCodeAt(1)===L&&(m=2),a!==void 0&&a.length>0&&a.length<=f.length){if(a===f)return"";let s=a.length-1,i=-1;for(r=f.length-1;r>=m;--r){const t=f.charCodeAt(r);if(w(t)){if(!d){m=r+1;break}}else i===-1&&(d=!1,i=r+1),s>=0&&(t===a.charCodeAt(s)?--s==-1&&(o=r):(s=-1,o=i))}return m===o?o=i:o===-1&&(o=f.length),f.slice(m,o)}for(r=f.length-1;r>=m;--r)if(w(f.charCodeAt(r))){if(!d){m=r+1;break}}else o===-1&&(d=!1,o=r+1);return o===-1?"":f.slice(m,o)},extname(f){T(f,"path");let a=0,m=-1,o=0,d=-1,r=!0,s=0;f.length>=2&&f.charCodeAt(1)===L&&p(f.charCodeAt(0))&&(a=o=2);for(let i=f.length-1;i>=a;--i){const t=f.charCodeAt(i);if(w(t)){if(!r){o=i+1;break}continue}d===-1&&(r=!1,d=i+1),t===C?m===-1?m=i:s!==1&&(s=1):m!==-1&&(s=-1)}return m===-1||d===-1||s===0||s===1&&m===d-1&&m===o+1?"":f.slice(m,d)},format:v.bind(null,"\\"),parse(f){T(f,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return a;const m=f.length;let o=0,d=f.charCodeAt(0);if(m===1)return w(d)?(a.root=a.dir=f,a):(a.base=a.name=f,a);if(w(d)){if(o=1,w(f.charCodeAt(1))){let h=2,E=h;for(;h<m&&!w(f.charCodeAt(h));)h++;if(h<m&&h!==E){for(E=h;h<m&&w(f.charCodeAt(h));)h++;if(h<m&&h!==E){for(E=h;h<m&&!w(f.charCodeAt(h));)h++;h===m?o=h:h!==E&&(o=h+1)}}}}else if(p(d)&&f.charCodeAt(1)===L){if(m<=2)return a.root=a.dir=f,a;if(o=2,w(f.charCodeAt(2))){if(m===3)return a.root=a.dir=f,a;o=3}}o>0&&(a.root=f.slice(0,o));let r=-1,s=o,i=-1,t=!0,c=f.length-1,l=0;for(;c>=o;--c){if(d=f.charCodeAt(c),w(d)){if(!t){s=c+1;break}continue}i===-1&&(t=!1,i=c+1),d===C?r===-1?r=c:l!==1&&(l=1):r!==-1&&(l=-1)}return i!==-1&&(r===-1||l===0||l===1&&r===i-1&&r===s+1?a.base=a.name=f.slice(s,i):(a.name=f.slice(s,r),a.base=f.slice(s,i),a.ext=f.slice(r,i))),s>0&&s!==o?a.dir=f.slice(0,s-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...f){let a="",m=!1;for(let o=f.length-1;o>=-1&&!m;o--){const d=o>=0?f[o]:u.cwd();T(d,"path"),d.length!==0&&(a=`${d}/${a}`,m=d.charCodeAt(0)===S)}return a=g(a,!m,"/",b),m?`/${a}`:a.length>0?a:"."},normalize(f){if(T(f,"path"),f.length===0)return".";const a=f.charCodeAt(0)===S,m=f.charCodeAt(f.length-1)===S;return f=g(f,!a,"/",b),f.length===0?a?"/":m?"./":".":(m&&(f+="/"),a?`/${f}`:f)},isAbsolute(f){return T(f,"path"),f.length>0&&f.charCodeAt(0)===S},join(...f){if(f.length===0)return".";let a;for(let m=0;m<f.length;++m){const o=f[m];T(o,"path"),o.length>0&&(a===void 0?a=o:a+=`/${o}`)}return a===void 0?".":e.posix.normalize(a)},relative(f,a){if(T(f,"from"),T(a,"to"),f===a||(f=e.posix.resolve(f),a=e.posix.resolve(a),f===a))return"";const m=1,o=f.length,d=o-m,r=1,s=a.length-r,i=d<s?d:s;let t=-1,c=0;for(;c<i;c++){const h=f.charCodeAt(m+c);if(h!==a.charCodeAt(r+c))break;h===S&&(t=c)}if(c===i)if(s>i){if(a.charCodeAt(r+c)===S)return a.slice(r+c+1);if(c===0)return a.slice(r+c)}else d>i&&(f.charCodeAt(m+c)===S?t=c:c===0&&(t=0));let l="";for(c=m+t+1;c<=o;++c)(c===o||f.charCodeAt(c)===S)&&(l+=l.length===0?"..":"/..");return`${l}${a.slice(r+t)}`},toNamespacedPath(f){return f},dirname(f){if(T(f,"path"),f.length===0)return".";const a=f.charCodeAt(0)===S;let m=-1,o=!0;for(let d=f.length-1;d>=1;--d)if(f.charCodeAt(d)===S){if(!o){m=d;break}}else o=!1;return m===-1?a?"/":".":a&&m===1?"//":f.slice(0,m)},basename(f,a){a!==void 0&&T(a,"ext"),T(f,"path");let m=0,o=-1,d=!0,r;if(a!==void 0&&a.length>0&&a.length<=f.length){if(a===f)return"";let s=a.length-1,i=-1;for(r=f.length-1;r>=0;--r){const t=f.charCodeAt(r);if(t===S){if(!d){m=r+1;break}}else i===-1&&(d=!1,i=r+1),s>=0&&(t===a.charCodeAt(s)?--s==-1&&(o=r):(s=-1,o=i))}return m===o?o=i:o===-1&&(o=f.length),f.slice(m,o)}for(r=f.length-1;r>=0;--r)if(f.charCodeAt(r)===S){if(!d){m=r+1;break}}else o===-1&&(d=!1,o=r+1);return o===-1?"":f.slice(m,o)},extname(f){T(f,"path");let a=-1,m=0,o=-1,d=!0,r=0;for(let s=f.length-1;s>=0;--s){const i=f.charCodeAt(s);if(i===S){if(!d){m=s+1;break}continue}o===-1&&(d=!1,o=s+1),i===C?a===-1?a=s:r!==1&&(r=1):a!==-1&&(r=-1)}return a===-1||o===-1||r===0||r===1&&a===o-1&&a===m+1?"":f.slice(a,o)},format:v.bind(null,"/"),parse(f){T(f,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return a;const m=f.charCodeAt(0)===S;let o;m?(a.root="/",o=1):o=0;let d=-1,r=0,s=-1,i=!0,t=f.length-1,c=0;for(;t>=o;--t){const l=f.charCodeAt(t);if(l===S){if(!i){r=t+1;break}continue}s===-1&&(i=!1,s=t+1),l===C?d===-1?d=t:c!==1&&(c=1):d!==-1&&(c=-1)}if(s!==-1){const l=r===0&&m?1:r;d===-1||c===0||c===1&&d===s-1&&d===r+1?a.base=a.name=f.slice(l,s):(a.name=f.slice(l,d),a.base=f.slice(l,s),a.ext=f.slice(d,s))}return r>0?a.dir=f.slice(0,r-1):m&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=u.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=u.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=u.platform==="win32"?e.win32.join:e.posix.join,e.resolve=u.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=u.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=u.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=u.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=u.platform==="win32"?e.win32.extname:e.posix.extname,e.format=u.platform==="win32"?e.win32.format:e.posix.format,e.parse=u.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=u.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=u.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=u.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(Ie[101],ke([1,0,9]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const n={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},y={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(L){const I=(0,u.extname)(L),_=n[I.toLowerCase()];return _!==void 0?_:D(L)}e.getMediaOrTextMime=A;function D(L){const I=(0,u.extname)(L);return y[I.toLowerCase()]}e.getMediaMime=D;function C(L){for(const I in y)if(y[I]===L)return I}e.getExtensionForMimeType=C;const S=/^(.+)\/(.+?)(;.+)?$/;function P(L,I){const _=S.exec(L);return _?`${_[1].toLowerCase()}/${_[2].toLowerCase()}${_[3]??""}`:I?void 0:L}e.normalizeMimeType=P}),define(Ie[102],ke([1,0,13]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var n;(function(C){C[C.stdout=0]="stdout",C[C.stderr=1]="stderr"})(n=e.Source||(e.Source={}));var y;(function(C){C[C.Success=0]="Success",C[C.Unknown=1]="Unknown",C[C.AccessDenied=2]="AccessDenied",C[C.ProcessNotFound=3]="ProcessNotFound"})(y=e.TerminateResponseCode||(e.TerminateResponseCode={}));function A(C,...S){const P=S.reduce((_,T)=>(_[T]=!0,_),{}),L=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(C).filter(_=>!P[_]).forEach(_=>{for(let T=0;T<L.length;T++)if(_.search(L[T])!==-1){delete C[_];break}})}e.sanitizeProcessEnvironment=A;function D(C){!C||(delete C.DEBUG,u.isMacintosh&&delete C.DYLD_LIBRARY_PATH,u.isLinux&&delete C.LD_PRELOAD)}e.removeDangerousEnvVariables=D}),define(Ie[50],ke([1,0,13]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const n=u.globals.performance&&typeof u.globals.performance.now=="function";class y{constructor(D){this._highResolution=n&&D,this._startTime=this._now(),this._stopTime=-1}static create(D=!0){return new y(D)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?u.globals.performance.now():Date.now()}}e.StopWatch=y}),define(Ie[3],ke([1,0,12,58,6,80,50]),function(Q,e,u,n,y,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;const C=!1,S=!1;var P;(function(t){t.None=()=>y.Disposable.None;function c(ue){if(S){const{onListenerDidAdd:K}=ue,ge=w.create();let ye=0;ue.onListenerDidAdd=()=>{++ye==2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ge.print()),K?.()}}}function l(ue){return(K,ge=null,ye)=>{let Te=!1,pe;return pe=ue(Pe=>{if(!Te)return pe?pe.dispose():Te=!0,K.call(ge,Pe)},null,ye),Te&&pe.dispose(),pe}}t.once=l;function h(ue,K,ge){return U((ye,Te=null,pe)=>ue(Pe=>ye.call(Te,K(Pe)),null,pe),ge)}t.map=h;function E(ue,K,ge){return U((ye,Te=null,pe)=>ue(Pe=>{K(Pe),ye.call(Te,Pe)},null,pe),ge)}t.forEach=E;function R(ue,K,ge){return U((ye,Te=null,pe)=>ue(Pe=>K(Pe)&&ye.call(Te,Pe),null,pe),ge)}t.filter=R;function N(ue){return ue}t.signal=N;function O(...ue){return(K,ge=null,ye)=>(0,y.combinedDisposable)(...ue.map(Te=>Te(pe=>K.call(ge,pe),null,ye)))}t.any=O;function k(ue,K,ge,ye){let Te=ge;return h(ue,pe=>(Te=K(Te,pe),Te),ye)}t.reduce=k;function U(ue,K){let ge;const ye={onFirstListenerAdd(){ge=ue(Te.fire,Te)},onLastListenerRemove(){ge?.dispose()}};K||c(ye);const Te=new p(ye);return K?.add(Te),Te.event}function F(ue,K,ge=100,ye=!1,Te,pe){let Pe,fe,ve,_e=0;const ae={leakWarningThreshold:Te,onFirstListenerAdd(){Pe=ue(te=>{_e++,fe=K(fe,te),ye&&!ve&&(he.fire(fe),fe=void 0),clearTimeout(ve),ve=setTimeout(()=>{const ie=fe;fe=void 0,ve=void 0,(!ye||_e>1)&&he.fire(ie),_e=0},ge)})},onLastListenerRemove(){Pe.dispose()}};pe||c(ae);const he=new p(ae);return pe?.add(he),he.event}t.debounce=F;function $(ue,K=(ye,Te)=>ye===Te,ge){let ye=!0,Te;return R(ue,pe=>{const Pe=ye||!K(pe,Te);return ye=!1,Te=pe,Pe},ge)}t.latch=$;function ee(ue,K,ge){return[t.filter(ue,K,ge),t.filter(ue,ye=>!K(ye),ge)]}t.split=ee;function B(ue,K=!1,ge=[]){let ye=ge.slice(),Te=ue(fe=>{ye?ye.push(fe):Pe.fire(fe)});const pe=()=>{ye?.forEach(fe=>Pe.fire(fe)),ye=null},Pe=new p({onFirstListenerAdd(){Te||(Te=ue(fe=>Pe.fire(fe)))},onFirstListenerDidAdd(){ye&&(K?setTimeout(pe):pe())},onLastListenerRemove(){Te&&Te.dispose(),Te=null}});return Pe.event}t.buffer=B;class z{constructor(K){this.event=K,this.disposables=new y.DisposableStore}map(K){return new z(h(this.event,K,this.disposables))}forEach(K){return new z(E(this.event,K,this.disposables))}filter(K){return new z(R(this.event,K,this.disposables))}reduce(K,ge){return new z(k(this.event,K,ge,this.disposables))}latch(){return new z($(this.event,void 0,this.disposables))}debounce(K,ge=100,ye=!1,Te){return new z(F(this.event,K,ge,ye,Te,this.disposables))}on(K,ge,ye){return this.event(K,ge,ye)}once(K,ge,ye){return l(this.event)(K,ge,ye)}dispose(){this.disposables.dispose()}}function q(ue){return new z(ue)}t.chain=q;function V(ue,K,ge=ye=>ye){const ye=(...fe)=>Pe.fire(ge(...fe)),Te=()=>ue.on(K,ye),pe=()=>ue.removeListener(K,ye),Pe=new p({onFirstListenerAdd:Te,onLastListenerRemove:pe});return Pe.event}t.fromNodeEventEmitter=V;function j(ue,K,ge=ye=>ye){const ye=(...fe)=>Pe.fire(ge(...fe)),Te=()=>ue.addEventListener(K,ye),pe=()=>ue.removeEventListener(K,ye),Pe=new p({onFirstListenerAdd:Te,onLastListenerRemove:pe});return Pe.event}t.fromDOMEventEmitter=j;function ne(ue){return new Promise(K=>l(ue)(K))}t.toPromise=ne;function Y(ue,K){return K(void 0),ue(ge=>K(ge))}t.runAndSubscribe=Y;function le(ue,K){let ge=null;function ye(pe){ge?.dispose(),ge=new y.DisposableStore,K(pe,ge)}ye(void 0);const Te=ue(pe=>ye(pe));return(0,y.toDisposable)(()=>{Te.dispose(),ge?.dispose()})}t.runAndSubscribeWithStore=le})(P=e.Event||(e.Event={}));class L{constructor(c){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${c}_${L._idPool++}`}start(c){this._stopWatch=new D.StopWatch(!0),this._listenerCount=c}stop(){if(this._stopWatch){const c=this._stopWatch.elapsed();this._elapsedOverall+=c,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${c.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}L._idPool=0;let I=-1;function _(t){const c=I;return I=t,{dispose(){I=c}}}e.setGlobalLeakWarningThreshold=_;class T{constructor(c,l=Math.random().toString(18).slice(2,5)){this.customThreshold=c,this.name=l,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(c,l){let h=I;if(typeof this.customThreshold=="number"&&(h=this.customThreshold),h<=0||l<h)return;this._stacks||(this._stacks=new Map);const E=this._stacks.get(c.value)||0;if(this._stacks.set(c.value,E+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=h*.5;let R,N=0;for(const[O,k]of this._stacks)(!R||N<k)&&(R=O,N=k);console.warn(`[${this.name}] potential listener LEAK detected, having ${l} listeners already. MOST frequent listener (${N}):`),console.warn(R)}return()=>{const R=this._stacks.get(c.value)||0;this._stacks.set(c.value,R-1)}}}class w{constructor(c){this.value=c}static create(){return new w(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class b{constructor(c,l,h){this.callback=c,this.callbackThis=l,this.stack=h,this.subscription=new y.SafeDisposable}invoke(c){this.callback.call(this.callbackThis,c)}}class p{constructor(c){this._disposed=!1,this._options=c,this._leakageMon=I>0?new T(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new L(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(C){const c=Array.from(this._listeners);queueMicrotask(()=>{for(const l of c)l.subscription.isset()&&(l.subscription.unset(),l.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(c,l,h)=>{this._listeners||(this._listeners=new A.LinkedList);const E=this._listeners.isEmpty();E&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let R,N;this._leakageMon&&this._listeners.size>=30&&(N=w.create(),R=this._leakageMon.check(N,this._listeners.size+1)),C&&(N=N??w.create());const O=new b(c,l,N),k=this._listeners.push(O);E&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,c,l);const U=O.subscription.set(()=>{R?.(),this._disposed||(k(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return h instanceof y.DisposableStore?h.add(U):Array.isArray(h)&&h.push(U),U}),this._event}fire(c){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new v);for(const l of this._listeners)this._deliveryQueue.push(this,l,c);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=p;class g{constructor(){this._queue=new A.LinkedList}get size(){return this._queue.size}push(c,l,h){this._queue.push(new f(c,l,h))}clear(c){const l=new A.LinkedList;for(const h of this._queue)h.emitter!==c&&l.push(h);this._queue=l}deliver(){for(;this._queue.size>0;){const c=this._queue.shift();try{c.listener.invoke(c.event)}catch(l){(0,u.onUnexpectedError)(l)}}}}e.EventDeliveryQueue=g;class v extends g{clear(c){this._queue.clear()}}class f{constructor(c,l,h){this.emitter=c,this.listener=l,this.event=h}}class a extends p{async fireAsync(c,l,h){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new A.LinkedList);for(const E of this._listeners)this._asyncDeliveryQueue.push([E,c]);for(;this._asyncDeliveryQueue.size>0&&!l.isCancellationRequested;){const[E,R]=this._asyncDeliveryQueue.shift(),N=[],O={...R,token:l,waitUntil:k=>{if(Object.isFrozen(N))throw new Error("waitUntil can NOT be called asynchronous");h&&(k=h(k,E.callback)),N.push(k)}};try{E.invoke(O)}catch(k){(0,u.onUnexpectedError)(k);continue}Object.freeze(N),await Promise.allSettled(N).then(k=>{for(const U of k)U.status==="rejected"&&(0,u.onUnexpectedError)(U.reason)})}}}}e.AsyncEmitter=a;class m extends p{constructor(c){super(c);this._isPaused=0,this._eventQueue=new A.LinkedList,this._mergeFn=c?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const c=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(c))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(c){this._listeners&&(this._isPaused!==0?this._eventQueue.push(c):super.fire(c))}}e.PauseableEmitter=m;class o extends m{constructor(c){super(c);this._delay=c.delay??100}fire(c){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(c)}}e.DebounceEmitter=o;class d extends p{constructor(c){super(c);this._queuedEvents=[],this._mergeFn=c?.merge}fire(c){this._queuedEvents.push(c),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(l=>super.fire(l)),this._queuedEvents=[]})}}e.MicrotaskEmitter=d;class r{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new p({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(c){const l={event:c,listener:null};this.events.push(l),this.hasListeners&&this.hook(l);const h=()=>{this.hasListeners&&this.unhook(l);const E=this.events.indexOf(l);this.events.splice(E,1)};return(0,y.toDisposable)((0,n.once)(h))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(c=>this.hook(c))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(c=>this.unhook(c))}hook(c){c.listener=c.event(l=>this.emitter.fire(l))}unhook(c){c.listener&&c.listener.dispose(),c.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=r;class s{constructor(){this.buffers=[]}wrapEvent(c){return(l,h,E)=>c(R=>{const N=this.buffers[this.buffers.length-1];N?N.push(()=>l.call(h,R)):l.call(h,R)},void 0,E)}bufferEvents(c){const l=[];this.buffers.push(l);const h=c();return this.buffers.pop(),l.forEach(E=>E()),h}}e.EventBufferer=s;class i{constructor(){this.listening=!1,this.inputEvent=P.None,this.inputEventListener=y.Disposable.None,this.emitter=new p({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(c){this.inputEvent=c,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=c(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=i}),define(Ie[21],ke([1,0,3]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const n=Object.freeze(function(C,S){const P=setTimeout(C.bind(S),0);return{dispose(){clearTimeout(P)}}});var y;(function(C){function S(P){return P===C.None||P===C.Cancelled||P instanceof A?!0:!P||typeof P!="object"?!1:typeof P.isCancellationRequested=="boolean"&&typeof P.onCancellationRequested=="function"}C.isCancellationToken=S,C.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:u.Event.None}),C.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:n})})(y=e.CancellationToken||(e.CancellationToken={}));class A{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?n:(this._emitter||(this._emitter=new u.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class D{constructor(S){this._token=void 0,this._parentListener=void 0,this._parentListener=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new A),this._token}cancel(){this._token?this._token instanceof A&&this._token.cancel():this._token=y.Cancelled}dispose(S=!1){S&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof A&&this._token.dispose():this._token=y.None}}e.CancellationTokenSource=D}),define(Ie[156],ke([1,0,21]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class n{constructor(C){this.task=C,this.result=null}get(){if(this.result)return this.result;const C=new u.CancellationTokenSource,S=this.task(C.token);return this.result={promise:S,dispose:()=>{this.result=null,C.cancel(),C.dispose()}},this.result}}e.Cache=n;class y{constructor(C){this.fn=C,this.lastCache=void 0,this.lastArgKey=void 0}get(C){const S=JSON.stringify(C);return this.lastArgKey!==S&&(this.lastArgKey=S,this.lastCache=this.fn(C)),this.lastCache}}e.LRUCachedFunction=y;class A{constructor(C){this.fn=C,this._map=new Map}get cachedValues(){return this._map}get(C){if(this._map.has(C))return this._map.get(C);const S=this.fn(C);return this._map.set(C,S),S}}e.CachedFunction=A}),define(Ie[8],ke([1,0,156,79]),function(Q,e,u,n){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function A(oe){return!oe||typeof oe!="string"?!0:oe.trim().length===0}e.isFalsyOrWhitespace=A;const D=/{(\d+)}/g;function C(oe,...Re){return Re.length===0?oe:oe.replace(D,function(Be,qe){const je=parseInt(qe,10);return isNaN(je)||je<0||je>=Re.length?Be:Re[je]})}e.format=C;const S=/{([^}]+)}/g;function P(oe,Re){return oe.replace(S,(Be,qe)=>Re[qe]??Be)}e.format2=P;function L(oe){return oe.replace(/[<>&]/g,function(Re){switch(Re){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Re}})}e.escape=L;function I(oe){return oe.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=I;function _(oe,Re){let Be=0;const qe=Re.charCodeAt(0);for(let je=oe.length-1;je>=0;je--)oe.charCodeAt(je)===qe&&Be++;return Be}e.count=_;function T(oe,Re,Be="\u2026"){return oe.length<=Re?oe:`${oe.substr(0,Re)}${Be}`}e.truncate=T;function w(oe,Re=" "){const Be=b(oe,Re);return p(Be,Re)}e.trim=w;function b(oe,Re){if(!oe||!Re)return oe;const Be=Re.length;if(Be===0||oe.length===0)return oe;let qe=0;for(;oe.indexOf(Re,qe)===qe;)qe=qe+Be;return oe.substring(qe)}e.ltrim=b;function p(oe,Re){if(!oe||!Re)return oe;const Be=Re.length,qe=oe.length;if(Be===0||qe===0)return oe;let je=qe,Ve=-1;for(;Ve=oe.lastIndexOf(Re,je-1),!(Ve===-1||Ve+Be!==je);){if(Ve===0)return"";je=Ve}return oe.substring(0,je)}e.rtrim=p;function g(oe){return oe.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=g;function v(oe){return oe.replace(/\*/g,"")}e.stripWildcards=v;function f(oe,Re,Be={}){if(!oe)throw new Error("Cannot create regex from empty string");Re||(oe=I(oe)),Be.wholeWord&&(/\B/.test(oe.charAt(0))||(oe="\\b"+oe),/\B/.test(oe.charAt(oe.length-1))||(oe=oe+"\\b"));let qe="";return Be.global&&(qe+="g"),Be.matchCase||(qe+="i"),Be.multiline&&(qe+="m"),Be.unicode&&(qe+="u"),new RegExp(oe,qe)}e.createRegExp=f;function a(oe){return oe.source==="^"||oe.source==="^$"||oe.source==="$"||oe.source==="^\\s*$"?!1:!!(oe.exec("")&&oe.lastIndex===0)}e.regExpLeadsToEndlessLoop=a;function m(oe){return!!oe.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=m;function o(oe){return(oe.global?"g":"")+(oe.ignoreCase?"i":"")+(oe.multiline?"m":"")+(oe.unicode?"u":"")}e.regExpFlags=o;function d(oe){return oe.split(/\r\n|\r|\n/)}e.splitLines=d;function r(oe){for(let Re=0,Be=oe.length;Re<Be;Re++){const qe=oe.charCodeAt(Re);if(qe!==32&&qe!==9)return Re}return-1}e.firstNonWhitespaceIndex=r;function s(oe,Re=0,Be=oe.length){for(let qe=Re;qe<Be;qe++){const je=oe.charCodeAt(qe);if(je!==32&&je!==9)return oe.substring(Re,qe)}return oe.substring(Re,Be)}e.getLeadingWhitespace=s;function i(oe,Re=oe.length-1){for(let Be=Re;Be>=0;Be--){const qe=oe.charCodeAt(Be);if(qe!==32&&qe!==9)return Be}return-1}e.lastNonWhitespaceIndex=i;function t(oe,Re,Be){const qe=[];let je=0;for(const Ve of oe.matchAll(Re)){if(qe.push(oe.slice(je,Ve.index)),Ve.index===void 0)throw new Error("match.index should be defined");je=Ve.index+Ve[0].length,qe.push(Be(Ve[0],...Ve.slice(1),Ve.index,oe,Ve.groups))}return qe.push(oe.slice(je)),Promise.all(qe).then(Ve=>Ve.join(""))}e.replaceAsync=t;function c(oe,Re){return oe<Re?-1:oe>Re?1:0}e.compare=c;function l(oe,Re,Be=0,qe=oe.length,je=0,Ve=Re.length){for(;Be<qe&&je<Ve;Be++,je++){const st=oe.charCodeAt(Be),it=Re.charCodeAt(je);if(st<it)return-1;if(st>it)return 1}const nt=qe-Be,ot=Ve-je;return nt<ot?-1:nt>ot?1:0}e.compareSubstring=l;function h(oe,Re){return E(oe,Re,0,oe.length,0,Re.length)}e.compareIgnoreCase=h;function E(oe,Re,Be=0,qe=oe.length,je=0,Ve=Re.length){for(;Be<qe&&je<Ve;Be++,je++){let st=oe.charCodeAt(Be),it=Re.charCodeAt(je);if(st===it)continue;if(st>=128||it>=128)return l(oe.toLowerCase(),Re.toLowerCase(),Be,qe,je,Ve);N(st)&&(st-=32),N(it)&&(it-=32);const at=st-it;if(at!==0)return at}const nt=qe-Be,ot=Ve-je;return nt<ot?-1:nt>ot?1:0}e.compareSubstringIgnoreCase=E;function R(oe){return oe>=48&&oe<=57}e.isAsciiDigit=R;function N(oe){return oe>=97&&oe<=122}e.isLowerAsciiLetter=N;function O(oe){return oe>=65&&oe<=90}e.isUpperAsciiLetter=O;function k(oe,Re){return oe.length===Re.length&&E(oe,Re)===0}e.equalsIgnoreCase=k;function U(oe,Re){const Be=Re.length;return Re.length>oe.length?!1:E(oe,Re,0,Be)===0}e.startsWithIgnoreCase=U;function F(oe,Re){const Be=Math.min(oe.length,Re.length);let qe;for(qe=0;qe<Be;qe++)if(oe.charCodeAt(qe)!==Re.charCodeAt(qe))return qe;return Be}e.commonPrefixLength=F;function $(oe,Re){const Be=Math.min(oe.length,Re.length);let qe;const je=oe.length-1,Ve=Re.length-1;for(qe=0;qe<Be;qe++)if(oe.charCodeAt(je-qe)!==Re.charCodeAt(Ve-qe))return qe;return Be}e.commonSuffixLength=$;function ee(oe){return 55296<=oe&&oe<=56319}e.isHighSurrogate=ee;function B(oe){return 56320<=oe&&oe<=57343}e.isLowSurrogate=B;function z(oe,Re){return(oe-55296<<10)+(Re-56320)+65536}e.computeCodePoint=z;function q(oe,Re,Be){const qe=oe.charCodeAt(Be);if(ee(qe)&&Be+1<Re){const je=oe.charCodeAt(Be+1);if(B(je))return z(qe,je)}return qe}e.getNextCodePoint=q;function V(oe,Re){const Be=oe.charCodeAt(Re-1);if(B(Be)&&Re>1){const qe=oe.charCodeAt(Re-2);if(ee(qe))return z(qe,Be)}return Be}class j{constructor(Re,Be=0){this._str=Re,this._len=Re.length,this._offset=Be}get offset(){return this._offset}setOffset(Re){this._offset=Re}prevCodePoint(){const Re=V(this._str,this._offset);return this._offset-=Re>=65536?2:1,Re}nextCodePoint(){const Re=q(this._str,this._len,this._offset);return this._offset+=Re>=65536?2:1,Re}eol(){return this._offset>=this._len}}e.CodePointIterator=j;class ne{constructor(Re,Be=0){this._iterator=new j(Re,Be)}get offset(){return this._iterator.offset}nextGraphemeLength(){const Re=ze.getInstance(),Be=this._iterator,qe=Be.offset;let je=Re.getGraphemeBreakType(Be.nextCodePoint());for(;!Be.eol();){const Ve=Be.offset,nt=Re.getGraphemeBreakType(Be.nextCodePoint());if(De(je,nt)){Be.setOffset(Ve);break}je=nt}return Be.offset-qe}prevGraphemeLength(){const Re=ze.getInstance(),Be=this._iterator,qe=Be.offset;let je=Re.getGraphemeBreakType(Be.prevCodePoint());for(;Be.offset>0;){const Ve=Be.offset,nt=Re.getGraphemeBreakType(Be.prevCodePoint());if(De(nt,je)){Be.setOffset(Ve);break}je=nt}return qe-Be.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=ne;function Y(oe,Re){return new ne(oe,Re).nextGraphemeLength()}e.nextCharLength=Y;function le(oe,Re){return new ne(oe,Re).prevGraphemeLength()}e.prevCharLength=le;function ue(oe,Re){Re>0&&B(oe.charCodeAt(Re))&&Re--;const Be=Re+Y(oe,Re);return[Be-le(oe,Be),Be]}e.getCharContainingOffset=ue;const K=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function ge(oe){return K.test(oe)}e.containsRTL=ge;const ye=/^[\t\n\r\x20-\x7E]*$/;function Te(oe){return ye.test(oe)}e.isBasicASCII=Te,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function pe(oe){return e.UNUSUAL_LINE_TERMINATORS.test(oe)}e.containsUnusualLineTerminators=pe;function Pe(oe){return oe>=11904&&oe<=55215||oe>=63744&&oe<=64255||oe>=65281&&oe<=65374}e.isFullWidthCharacter=Pe;function fe(oe){return oe>=127462&&oe<=127487||oe===8986||oe===8987||oe===9200||oe===9203||oe>=9728&&oe<=10175||oe===11088||oe===11093||oe>=127744&&oe<=128591||oe>=128640&&oe<=128764||oe>=128992&&oe<=129008||oe>=129280&&oe<=129535||oe>=129648&&oe<=129782}e.isEmojiImprecise=fe;function ve(oe,Re){if(oe.length<Re)return oe;const Be=/\b/g;let qe=0;for(;Be.test(oe)&&!(oe.length-Be.lastIndex<Re);)qe=Be.lastIndex,Be.lastIndex+=1;return oe.substring(qe).replace(/^\s/,"")}e.lcut=ve;const _e=/\x1B\x5B[12]?K/g,ae=/\x1b\[\d+m/g,he=/\x1b\[0?m/g;function te(oe){return oe&&(oe=oe.replace(_e,""),oe=oe.replace(ae,""),oe=oe.replace(he,"")),oe}e.removeAnsiEscapeCodes=te,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ie(oe){return!!(oe&&oe.length>0&&oe.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ie;function M(oe){return ie(oe)?oe.substr(1):oe}e.stripUTF8BOM=M;function H(oe,Re){if(!oe||!Re||oe.length<Re.length)return!1;const Be=Re.length,qe=oe.toLowerCase();let je=0,Ve=-1;for(;je<Be;){const nt=qe.indexOf(Re[je],Ve+1);if(nt<0)return!1;Ve=nt,je++}return!0}e.fuzzyContains=H;function G(oe,Re=!1){return oe?(Re&&(oe=oe.replace(/\\./g,"")),oe.toLowerCase()!==oe):!1}e.containsUppercaseCharacter=G;function X(oe){return oe.charAt(0).toUpperCase()+oe.slice(1)}e.uppercaseFirstLetter=X;function de(oe,Re=1){if(Re===0)return"";let Be=-1;do Be=oe.indexOf(`
`,Be+1),Re--;while(Re>0&&Be>=0);return Be===-1?oe:(oe[Be-1]==="\r"&&Be--,oe.substr(0,Be))}e.getNLines=de;function be(oe){const Re=90-65+1;return oe=oe%(2*Re),oe<Re?String.fromCharCode(97+oe):String.fromCharCode(65+oe-Re)}e.singleLetterHash=be;function se(oe){return ze.getInstance().getGraphemeBreakType(oe)}e.getGraphemeBreakType=se;function De(oe,Re){return oe===0?Re!==5&&Re!==7:oe===2&&Re===3?!1:oe===4||oe===2||oe===3||Re===4||Re===2||Re===3?!0:!(oe===8&&(Re===8||Re===9||Re===11||Re===12)||(oe===11||oe===9)&&(Re===9||Re===10)||(oe===12||oe===10)&&Re===10||Re===5||Re===13||Re===7||oe===1||oe===13&&Re===14||oe===6&&Re===6)}var Ce;(function(oe){oe[oe.Other=0]="Other",oe[oe.Prepend=1]="Prepend",oe[oe.CR=2]="CR",oe[oe.LF=3]="LF",oe[oe.Control=4]="Control",oe[oe.Extend=5]="Extend",oe[oe.Regional_Indicator=6]="Regional_Indicator",oe[oe.SpacingMark=7]="SpacingMark",oe[oe.L=8]="L",oe[oe.V=9]="V",oe[oe.T=10]="T",oe[oe.LV=11]="LV",oe[oe.LVT=12]="LVT",oe[oe.ZWJ=13]="ZWJ",oe[oe.Extended_Pictographic=14]="Extended_Pictographic"})(Ce=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ze{constructor(){this._data=Ke()}static getInstance(){return ze._INSTANCE||(ze._INSTANCE=new ze),ze._INSTANCE}getGraphemeBreakType(Re){if(Re<32)return Re===10?3:Re===13?2:4;if(Re<127)return 0;const Be=this._data,qe=Be.length/3;let je=1;for(;je<=qe;)if(Re<Be[3*je])je=2*je;else if(Re>Be[3*je+1])je=2*je+1;else return Be[3*je+2];return 0}}ze._INSTANCE=null;function Ke(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ne(oe,Re){if(oe===0)return 0;const Be=Ye(oe,Re);if(Be!==void 0)return Be;const qe=new j(Re,oe);return qe.prevCodePoint(),qe.offset}e.getLeftDeleteOffset=Ne;function Ye(oe,Re){const Be=new j(Re,oe);let qe=Be.prevCodePoint();for(;Z(qe)||qe===65039||qe===8419;){if(Be.offset===0)return;qe=Be.prevCodePoint()}if(!fe(qe))return;let je=Be.offset;return je>0&&Be.prevCodePoint()===8205&&(je=Be.offset),je}function Z(oe){return 127995<=oe&&oe<=127999}var re;(function(oe){oe[oe.zwj=8205]="zwj",oe[oe.emojiVariantSelector=65039]="emojiVariantSelector",oe[oe.enclosingKeyCap=8419]="enclosingKeyCap"})(re||(re={})),e.noBreakWhitespace="\xA0";class Se{constructor(Re){this.confusableDictionary=Re}static getInstance(Re){return Se.cache.get(Array.from(Re))}static getLocales(){return Se._locales.getValue()}isAmbiguous(Re){return this.confusableDictionary.has(Re)}getPrimaryConfusable(Re){return this.confusableDictionary.get(Re)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Se,y=Se,Se.ambiguousCharacterData=new n.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Se.cache=new u.LRUCachedFunction(oe=>{function Re(it){const at=new Map;for(let wt=0;wt<it.length;wt+=2)at.set(it[wt],it[wt+1]);return at}function Be(it,at){const wt=new Map(it);for(const[Tt,_t]of at)wt.set(Tt,_t);return wt}function qe(it,at){if(!it)return at;const wt=new Map;for(const[Tt,_t]of it)at.has(Tt)&&wt.set(Tt,_t);return wt}const je=y.ambiguousCharacterData.getValue();let Ve=oe.filter(it=>!it.startsWith("_")&&it in je);Ve.length===0&&(Ve=["_default"]);let nt;for(const it of Ve){const at=Re(je[it]);nt=qe(nt,at)}const ot=Re(je._common),st=Be(ot,nt);return new Se(st)}),Se._locales=new n.Lazy(()=>Object.keys(Se.ambiguousCharacterData.getValue()).filter(oe=>!oe.startsWith("_")));class We{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(We.getRawData())),this._data}static isInvisibleCharacter(Re){return We.getData().has(Re)}static get codePoints(){return We.getData()}}e.InvisibleCharacters=We,We._data=void 0}),define(Ie[30],ke([1,0,9,13,8,10]),function(Q,e,u,n,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function D(i){return i===47||i===92}e.isPathSeparator=D;function C(i){return i.replace(/[\\/]/g,u.posix.sep)}e.toSlashes=C;function S(i){return i.indexOf("/")===-1&&(i=C(i)),/^[a-zA-Z]:(\/|$)/.test(i)&&(i="/"+i),i}e.toPosixPath=S;function P(i,t=u.posix.sep){if(!i)return"";const c=i.length,l=i.charCodeAt(0);if(D(l)){if(D(i.charCodeAt(1))&&!D(i.charCodeAt(2))){let E=3;const R=E;for(;E<c&&!D(i.charCodeAt(E));E++);if(R!==E&&!D(i.charCodeAt(E+1))){for(E+=1;E<c;E++)if(D(i.charCodeAt(E)))return i.slice(0,E+1).replace(/[\\/]/g,t)}}return t}else if(g(l)&&i.charCodeAt(1)===58)return D(i.charCodeAt(2))?i.slice(0,2)+t:i.slice(0,2);let h=i.indexOf("://");if(h!==-1){for(h+=3;h<c;h++)if(D(i.charCodeAt(h)))return i.slice(0,h+1)}return""}e.getRoot=P;function L(i){if(!n.isWindows||!i||i.length<5)return!1;let t=i.charCodeAt(0);if(t!==92||(t=i.charCodeAt(1),t!==92))return!1;let c=2;const l=c;for(;c<i.length&&(t=i.charCodeAt(c),t!==92);c++);return!(l===c||(t=i.charCodeAt(c+1),isNaN(t)||t===92))}e.isUNC=L;const I=/[\\/:\*\?"<>\|]/g,_=/[\\/]/g,T=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function w(i,t=n.isWindows){const c=t?I:_;return!(!i||i.length===0||/^\s+$/.test(i)||(c.lastIndex=0,c.test(i))||t&&T.test(i)||i==="."||i===".."||t&&i[i.length-1]==="."||t&&i.length!==i.trim().length||i.length>255)}e.isValidBasename=w;function b(i,t,c){const l=i===t;return!c||l?l:!i||!t?!1:(0,y.equalsIgnoreCase)(i,t)}e.isEqual=b;function p(i,t,c,l=u.sep){if(i===t)return!0;if(!i||!t||t.length>i.length)return!1;if(c){if(!(0,y.startsWithIgnoreCase)(i,t))return!1;if(t.length===i.length)return!0;let E=t.length;return t.charAt(t.length-1)===l&&E--,i.charAt(E)===l}return t.charAt(t.length-1)!==l&&(t+=l),i.indexOf(t)===0}e.isEqualOrParent=p;function g(i){return i>=65&&i<=90||i>=97&&i<=122}e.isWindowsDriveLetter=g;function v(i,t){return n.isWindows&&i.endsWith(":")&&(i+=u.sep),(0,u.isAbsolute)(i)||(i=(0,u.join)(t,i)),i=(0,u.normalize)(i),n.isWindows?(i=(0,y.rtrim)(i,u.sep),i.endsWith(":")&&(i+=u.sep)):(i=(0,y.rtrim)(i,u.sep),i||(i=u.sep)),i}e.sanitizeFilePath=v;function f(i){const t=(0,u.normalize)(i);return n.isWindows?i.length>3?!1:a(t)&&(i.length===2||t.charCodeAt(2)===92):t===u.posix.sep}e.isRootOrDriveLetter=f;function a(i,t=n.isWindows){return t?g(i.charCodeAt(0))&&i.charCodeAt(1)===58:!1}e.hasDriveLetter=a;function m(i){return a(i)?i[0]:void 0}e.getDriveLetter=m;function o(i,t,c){return t.length>i.length?-1:i===t?0:(c&&(i=i.toLowerCase(),t=t.toLowerCase()),i.indexOf(t))}e.indexOfPath=o;function d(i){const t=i.split(":");let c,l,h;for(const E of t){const R=Number(E);(0,A.isNumber)(R)?l===void 0?l=R:h===void 0&&(h=R):c=c?[c,E].join(":"):E}if(!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:l!==void 0?l:void 0,column:h!==void 0?h:l!==void 0?1:void 0}}e.parseLineAndColumnAware=d;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function s(i,t,c=8){let l="";for(let E=0;E<c;E++)l+=r.charAt(Math.floor(Math.random()*r.length));let h;return t?h=`${t}-${l}`:h=l,i?(0,u.join)(i,h):h}e.randomPath=s}),define(Ie[60],ke([1,0,8]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function n(g){return y(g,0)}e.hash=n;function y(g,v){switch(typeof g){case"object":return g===null?A(349,v):Array.isArray(g)?S(g,v):P(g,v);case"string":return C(g,v);case"boolean":return D(g,v);case"number":return A(g,v);case"undefined":return A(937,v);default:return A(617,v)}}e.doHash=y;function A(g,v){return(v<<5)-v+g|0}e.numberHash=A;function D(g,v){return A(g?433:863,v)}function C(g,v){v=A(149417,v);for(let f=0,a=g.length;f<a;f++)v=A(g.charCodeAt(f),v);return v}e.stringHash=C;function S(g,v){return v=A(104579,v),g.reduce((f,a)=>y(a,f),v)}function P(g,v){return v=A(181387,v),Object.keys(g).sort().reduce((f,a)=>(f=C(a,f),y(g[a],f)),v)}class L{constructor(){this._value=0}get value(){return this._value}hash(v){return this._value=y(v,this._value),this._value}}e.Hasher=L;var I;(function(g){g[g.BLOCK_SIZE=64]="BLOCK_SIZE",g[g.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function _(g,v,f=32){const a=f-v,m=~((1<<a)-1);return(g<<v|(m&g)>>>a)>>>0}function T(g,v=0,f=g.byteLength,a=0){for(let m=0;m<f;m++)g[v+m]=a}function w(g,v,f="0"){for(;g.length<v;)g=f+g;return g}function b(g,v=32){return g instanceof ArrayBuffer?Array.from(new Uint8Array(g)).map(f=>f.toString(16).padStart(2,"0")).join(""):w((g>>>0).toString(16),v/4)}e.toHexString=b;class p{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(v){const f=v.length;if(f===0)return;const a=this._buff;let m=this._buffLen,o=this._leftoverHighSurrogate,d,r;for(o!==0?(d=o,r=-1,o=0):(d=v.charCodeAt(0),r=0);;){let s=d;if(u.isHighSurrogate(d))if(r+1<f){const i=v.charCodeAt(r+1);u.isLowSurrogate(i)?(r++,s=u.computeCodePoint(d,i)):s=65533}else{o=d;break}else u.isLowSurrogate(d)&&(s=65533);if(m=this._push(a,m,s),r++,r<f)d=v.charCodeAt(r);else break}this._buffLen=m,this._leftoverHighSurrogate=o}_push(v,f,a){return a<128?v[f++]=a:a<2048?(v[f++]=192|(a&1984)>>>6,v[f++]=128|(a&63)>>>0):a<65536?(v[f++]=224|(a&61440)>>>12,v[f++]=128|(a&4032)>>>6,v[f++]=128|(a&63)>>>0):(v[f++]=240|(a&1835008)>>>18,v[f++]=128|(a&258048)>>>12,v[f++]=128|(a&4032)>>>6,v[f++]=128|(a&63)>>>0),f>=64&&(this._step(),f-=64,this._totalLen+=64,v[0]=v[64+0],v[1]=v[64+1],v[2]=v[64+2]),f}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),b(this._h0)+b(this._h1)+b(this._h2)+b(this._h3)+b(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,T(this._buff,this._buffLen),this._buffLen>56&&(this._step(),T(this._buff));const v=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(v/4294967296),!1),this._buffDV.setUint32(60,v%4294967296,!1),this._step()}_step(){const v=p._bigBlock32,f=this._buffDV;for(let c=0;c<64;c+=4)v.setUint32(c,f.getUint32(c,!1),!1);for(let c=64;c<320;c+=4)v.setUint32(c,_(v.getUint32(c-12,!1)^v.getUint32(c-32,!1)^v.getUint32(c-56,!1)^v.getUint32(c-64,!1),1),!1);let a=this._h0,m=this._h1,o=this._h2,d=this._h3,r=this._h4,s,i,t;for(let c=0;c<80;c++)c<20?(s=m&o|~m&d,i=1518500249):c<40?(s=m^o^d,i=1859775393):c<60?(s=m&o|m&d|o&d,i=2400959708):(s=m^o^d,i=3395469782),t=_(a,5)+s+r+i+v.getUint32(c*4,!1)&4294967295,r=d,d=o,o=_(m,30),m=a,a=t;this._h0=this._h0+a&4294967295,this._h1=this._h1+m&4294967295,this._h2=this._h2+o&4294967295,this._h3=this._h3+d&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=p,p._bigBlock32=new DataView(new ArrayBuffer(320))});var tt=this&&this.__classPrivateFieldSet||function(Q,e,u,n,y){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!y:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?y.call(Q,u):y?y.value=u:e.set(Q,u),u},Me=this&&this.__classPrivateFieldGet||function(Q,e,u,n){if(u==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!n:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?n:u==="a"?n.call(Q):n?n.value:e.get(Q)};define(Ie[25],ke([1,0,16,8]),function(Q,e,u,n){"use strict";var y,A,D,C;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function S(i,t,c){let l=i.get(t);return l===void 0&&(l=c,i.set(t,l)),l}e.getOrSet=S;function P(i){const t=[];return i.forEach((c,l)=>{t.push(`${l} => ${c}`)}),`Map(${i.size}) {${t.join(", ")}}`}e.mapToString=P;function L(i){const t=[];return i.forEach(c=>{t.push(c)}),`Set(${i.size}) {${t.join(", ")}}`}e.setToString=L;class I{constructor(){this._value="",this._pos=0}reset(t){return this._value=t,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(t){const c=t.charCodeAt(0),l=this._value.charCodeAt(this._pos);return c-l}value(){return this._value[this._pos]}}e.StringIterator=I;class _{constructor(t=!0){this._caseSensitive=t}reset(t){return this._value=t,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(t)this._from++;else break;else t=!1;return this}cmp(t){return this._caseSensitive?(0,n.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=_;class T{constructor(t=!0,c=!0){this._splitOnBackslash=t,this._caseSensitive=c}reset(t){this._from=0,this._to=0,this._value=t,this._valueLen=t.length;for(let c=t.length-1;c>=0;c--,this._valueLen--){const l=this._value.charCodeAt(c);if(!(l===47||this._splitOnBackslash&&l===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let t=!0;for(;this._to<this._valueLen;this._to++){const c=this._value.charCodeAt(this._to);if(c===47||this._splitOnBackslash&&c===92)if(t)this._from++;else break;else t=!1}return this}cmp(t){return this._caseSensitive?(0,n.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=T;var w;(function(i){i[i.Scheme=1]="Scheme",i[i.Authority=2]="Authority",i[i.Path=3]="Path",i[i.Query=4]="Query",i[i.Fragment=5]="Fragment"})(w||(w={}));class b{constructor(t,c){this._ignorePathCasing=t,this._ignoreQueryAndFragment=c,this._states=[],this._stateIdx=0}reset(t){return this._value=t,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new T(!1,!this._ignorePathCasing(t)),this._pathIterator.reset(t.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(t)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(t){if(this._states[this._stateIdx]===1)return(0,n.compareIgnoreCase)(t,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,n.compareIgnoreCase)(t,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(t);if(this._states[this._stateIdx]===4)return(0,n.compare)(t,this._value.query);if(this._states[this._stateIdx]===5)return(0,n.compare)(t,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=b;class p{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const t=this.right;return this.right=t.left,t.left=this,this.updateHeight(),t.updateHeight(),t}rotateRight(){const t=this.left;return this.left=t.right,t.right=this,this.updateHeight(),t.updateHeight(),t}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var g;(function(i){i[i.Left=-1]="Left",i[i.Mid=0]="Mid",i[i.Right=1]="Right"})(g||(g={}));class v{constructor(t){this._iter=t}static forUris(t=()=>!1,c=()=>!1){return new v(new b(t,c))}static forPaths(t=!1){return new v(new T(void 0,!t))}static forStrings(){return new v(new I)}static forConfigKeys(){return new v(new _)}clear(){this._root=void 0}fill(t,c){if(c){const l=c.slice(0);(0,u.shuffle)(l);for(const h of l)this.set(h,t)}else{const l=t.slice(0);(0,u.shuffle)(l);for(const h of l)this.set(h[0],h[1])}}set(t,c){const l=this._iter.reset(t);let h;this._root||(this._root=new p,this._root.segment=l.value());const E=[];for(h=this._root;;){const N=l.cmp(h.segment);if(N>0)h.left||(h.left=new p,h.left.segment=l.value()),E.push([-1,h]),h=h.left;else if(N<0)h.right||(h.right=new p,h.right.segment=l.value()),E.push([1,h]),h=h.right;else if(l.hasNext())l.next(),h.mid||(h.mid=new p,h.mid.segment=l.value()),E.push([0,h]),h=h.mid;else break}const R=h.value;h.value=c,h.key=t;for(let N=E.length-1;N>=0;N--){const O=E[N][1];O.updateHeight();const k=O.balanceFactor();if(k<-1||k>1){const U=E[N][0],F=E[N+1][0];if(U===1&&F===1)E[N][1]=O.rotateLeft();else if(U===-1&&F===-1)E[N][1]=O.rotateRight();else if(U===1&&F===-1)O.right=E[N+1][1]=E[N+1][1].rotateRight(),E[N][1]=O.rotateLeft();else if(U===-1&&F===1)O.left=E[N+1][1]=E[N+1][1].rotateLeft(),E[N][1]=O.rotateRight();else throw new Error;if(N>0)switch(E[N-1][0]){case-1:E[N-1][1].left=E[N][1];break;case 1:E[N-1][1].right=E[N][1];break;case 0:E[N-1][1].mid=E[N][1];break}else this._root=E[0][1]}}return R}get(t){return this._getNode(t)?.value}_getNode(t){const c=this._iter.reset(t);let l=this._root;for(;l;){const h=c.cmp(l.segment);if(h>0)l=l.left;else if(h<0)l=l.right;else if(c.hasNext())c.next(),l=l.mid;else break}return l}has(t){const c=this._getNode(t);return!(c?.value===void 0&&c?.mid===void 0)}delete(t){return this._delete(t,!1)}deleteSuperstr(t){return this._delete(t,!0)}_delete(t,c){const l=this._iter.reset(t),h=[];let E=this._root;for(;E;){const R=l.cmp(E.segment);if(R>0)h.push([-1,E]),E=E.left;else if(R<0)h.push([1,E]),E=E.right;else if(l.hasNext())l.next(),h.push([0,E]),E=E.mid;else break}if(!!E){if(c?(E.left=void 0,E.mid=void 0,E.right=void 0,E.height=1):(E.key=void 0,E.value=void 0),!E.mid&&!E.value)if(E.left&&E.right){const R=this._min(E.right),{key:N,value:O,segment:k}=R;this._delete(R.key,!1),E.key=N,E.value=O,E.segment=k}else{const R=E.left??E.right;if(h.length>0){const[N,O]=h[h.length-1];switch(N){case-1:O.left=R;break;case 0:O.mid=R;break;case 1:O.right=R;break}}else this._root=R}for(let R=h.length-1;R>=0;R--){const N=h[R][1];N.updateHeight();const O=N.balanceFactor();if(O>1?(N.right.balanceFactor()>=0||(N.right=N.right.rotateRight()),h[R][1]=N.rotateLeft()):O<-1&&(N.left.balanceFactor()<=0||(N.left=N.left.rotateLeft()),h[R][1]=N.rotateRight()),R>0)switch(h[R-1][0]){case-1:h[R-1][1].left=h[R][1];break;case 1:h[R-1][1].right=h[R][1];break;case 0:h[R-1][1].mid=h[R][1];break}else this._root=h[0][1]}}}_min(t){for(;t.left;)t=t.left;return t}findSubstr(t){const c=this._iter.reset(t);let l=this._root,h;for(;l;){const E=c.cmp(l.segment);if(E>0)l=l.left;else if(E<0)l=l.right;else if(c.hasNext())c.next(),h=l.value||h,l=l.mid;else break}return l&&l.value||h}findSuperstr(t){const c=this._iter.reset(t);let l=this._root;for(;l;){const h=c.cmp(l.segment);if(h>0)l=l.left;else if(h<0)l=l.right;else if(c.hasNext())c.next(),l=l.mid;else return l.mid?this._entries(l.mid):void 0}}forEach(t){for(const[c,l]of this)t(l,c)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(t){!t||(t.left&&(yield*this._entries(t.left)),t.value&&(yield[t.key,t.value]),t.mid&&(yield*this._entries(t.mid)),t.right&&(yield*this._entries(t.right)))}_isBalanced(){const t=c=>{if(!c)return!0;const l=c.balanceFactor();return l<-1||l>1?!1:t(c.left)&&t(c.right)};return t(this._root)}}e.TernarySearchTree=v;class f{constructor(t,c){this.uri=t,this.value=c}}class a{constructor(t,c){this[y]="ResourceMap",t instanceof a?(this.map=new Map(t.map),this.toKey=c??a.defaultToKey):(this.map=new Map,this.toKey=t??a.defaultToKey)}set(t,c){return this.map.set(this.toKey(t),new f(t,c)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,c){typeof c!="undefined"&&(t=t.bind(c));for(const[l,h]of this.map)t(h.value,h.uri,this)}*values(){for(const t of this.map.values())yield t.value}*keys(){for(const t of this.map.values())yield t.uri}*entries(){for(const t of this.map.values())yield[t.uri,t.value]}*[(y=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=a,a.defaultToKey=i=>i.toString();class m{constructor(t,c){this[A]="ResourceSet",!t||typeof t=="function"?this._map=new a(t):(this._map=new a(c),t.forEach(this.add,this))}get size(){return this._map.size}add(t){return this._map.set(t,t),this}clear(){this._map.clear()}delete(t){return this._map.delete(t)}forEach(t,c){this._map.forEach((l,h)=>t.call(c,h,h,this))}has(t){return this._map.has(t)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=m;var o;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(o=e.Touch||(e.Touch={}));class d{constructor(){this[D]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,c=0){const l=this._map.get(t);if(!!l)return c!==0&&this.touch(l,c),l.value}set(t,c,l=0){let h=this._map.get(t);if(h)h.value=c,l!==0&&this.touch(h,l);else{switch(h={key:t,value:c,next:void 0,previous:void 0},l){case 0:this.addItemLast(h);break;case 1:this.addItemFirst(h);break;case 2:this.addItemLast(h);break;default:this.addItemLast(h);break}this._map.set(t,h),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const c=this._map.get(t);if(!!c)return this._map.delete(t),this.removeItem(c),this._size--,c.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,c){const l=this._state;let h=this._head;for(;h;){if(c?t.bind(c)(h.value,h.key,this):t(h.value,h.key,this),this._state!==l)throw new Error("LinkedMap got modified during iteration.");h=h.next}}keys(){const t=this,c=this._state;let l=this._head;const h={[Symbol.iterator](){return h},next(){if(t._state!==c)throw new Error("LinkedMap got modified during iteration.");if(l){const E={value:l.key,done:!1};return l=l.next,E}else return{value:void 0,done:!0}}};return h}values(){const t=this,c=this._state;let l=this._head;const h={[Symbol.iterator](){return h},next(){if(t._state!==c)throw new Error("LinkedMap got modified during iteration.");if(l){const E={value:l.value,done:!1};return l=l.next,E}else return{value:void 0,done:!0}}};return h}entries(){const t=this,c=this._state;let l=this._head;const h={[Symbol.iterator](){return h},next(){if(t._state!==c)throw new Error("LinkedMap got modified during iteration.");if(l){const E={value:[l.key,l.value],done:!1};return l=l.next,E}else return{value:void 0,done:!0}}};return h}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let c=this._head,l=this.size;for(;c&&l>t;)this._map.delete(c.key),c=c.next,l--;this._head=c,this._size=l,c&&(c.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const c=t.next,l=t.previous;if(!c||!l)throw new Error("Invalid list");c.previous=l,l.next=c}t.next=void 0,t.previous=void 0,this._state++}touch(t,c){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(c!==1&&c!==2)){if(c===1){if(t===this._head)return;const l=t.next,h=t.previous;t===this._tail?(h.next=void 0,this._tail=h):(l.previous=h,h.next=l),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(c===2){if(t===this._tail)return;const l=t.next,h=t.previous;t===this._head?(l.previous=void 0,this._head=l):(l.previous=h,h.next=l),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((c,l)=>{t.push([l,c])}),t}fromJSON(t){this.clear();for(const[c,l]of t)this.set(c,l)}}e.LinkedMap=d;class r extends d{constructor(t,c=1){super();this._limit=t,this._ratio=Math.min(Math.max(0,c),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,c=2){return super.get(t,c)}peek(t){return super.get(t,0)}set(t,c){return super.set(t,c,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=r;class s{constructor(t){C.set(this,void 0),tt(this,C,t,"f")}get size(){return Me(this,C,"f").size}forEach(t,c){Me(this,C,"f").forEach(t,c)}get(t){return Me(this,C,"f").get(t)}has(t){return Me(this,C,"f").has(t)}entries(){return Me(this,C,"f").entries()}keys(){return Me(this,C,"f").keys()}values(){return Me(this,C,"f").values()}[(C=new WeakMap,Symbol.iterator)](){return Me(this,C,"f").entries()}}e.ReadonlyMapView=s}),define(Ie[103],ke([1,0,25,8]),function(Q,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function y(...te){return function(ie,M){for(let H=0,G=te.length;H<G;H++){const X=te[H](ie,M);if(X)return X}return null}}e.or=y,e.matchesStrictPrefix=A.bind(void 0,!1),e.matchesPrefix=A.bind(void 0,!0);function A(te,ie,M){if(!M||M.length<ie.length)return null;let H;return te?H=n.startsWithIgnoreCase(M,ie):H=M.indexOf(ie)===0,H?ie.length>0?[{start:0,end:ie.length}]:[]:null}function D(te,ie){const M=ie.toLowerCase().indexOf(te.toLowerCase());return M===-1?null:[{start:M,end:M+te.length}]}e.matchesContiguousSubString=D;function C(te,ie){return S(te.toLowerCase(),ie.toLowerCase(),0,0)}e.matchesSubString=C;function S(te,ie,M,H){if(M===te.length)return[];if(H===ie.length)return null;if(te[M]===ie[H]){let G=null;return(G=S(te,ie,M+1,H+1))?g({start:H,end:H+1},G):null}return S(te,ie,M,H+1)}function P(te){return 97<=te&&te<=122}function L(te){return 65<=te&&te<=90}e.isUpper=L;function I(te){return 48<=te&&te<=57}function _(te){return te===32||te===9||te===10||te===13}const T=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(te=>T.add(te.charCodeAt(0)));function w(te){return _(te)||T.has(te)}function b(te,ie){return te===ie||w(te)&&w(ie)}function p(te){return P(te)||L(te)||I(te)}function g(te,ie){return ie.length===0?ie=[te]:te.end===ie[0].start?ie[0].start=te.start:ie.unshift(te),ie}function v(te,ie){for(let M=ie;M<te.length;M++){const H=te.charCodeAt(M);if(L(H)||I(H)||M>0&&!p(te.charCodeAt(M-1)))return M}return te.length}function f(te,ie,M,H){if(M===te.length)return[];if(H===ie.length)return null;if(te[M]!==ie[H].toLowerCase())return null;{let G=null,X=H+1;for(G=f(te,ie,M+1,H+1);!G&&(X=v(ie,X))<ie.length;)G=f(te,ie,M+1,X),X++;return G===null?null:g({start:H,end:H+1},G)}}function a(te){let ie=0,M=0,H=0,G=0,X=0;for(let Ce=0;Ce<te.length;Ce++)X=te.charCodeAt(Ce),L(X)&&ie++,P(X)&&M++,p(X)&&H++,I(X)&&G++;const de=ie/te.length,be=M/te.length,se=H/te.length,De=G/te.length;return{upperPercent:de,lowerPercent:be,alphaPercent:se,numericPercent:De}}function m(te){const{upperPercent:ie,lowerPercent:M}=te;return M===0&&ie>.6}function o(te){const{upperPercent:ie,lowerPercent:M,alphaPercent:H,numericPercent:G}=te;return M>.2&&ie<.8&&H>.6&&G<.2}function d(te){let ie=0,M=0,H=0,G=0;for(let X=0;X<te.length;X++)H=te.charCodeAt(X),L(H)&&ie++,P(H)&&M++,_(H)&&G++;return(ie===0||M===0)&&G===0?te.length<=30:ie<=5}function r(te,ie){if(!ie||(ie=ie.trim(),ie.length===0)||!d(te)||ie.length>60)return null;const M=a(ie);if(!o(M)){if(!m(M))return null;ie=ie.toLowerCase()}let H=null,G=0;for(te=te.toLowerCase();G<ie.length&&(H=f(te,ie,0,G))===null;)G=v(ie,G+1);return H}e.matchesCamelCase=r;function s(te,ie,M=!1){if(!ie||ie.length===0)return null;let H=null,G=0;for(te=te.toLowerCase(),ie=ie.toLowerCase();G<ie.length&&(H=i(te,ie,0,G,M))===null;)G=t(ie,G+1);return H}e.matchesWords=s;function i(te,ie,M,H,G){if(M===te.length)return[];if(H===ie.length)return null;if(b(te.charCodeAt(M),ie.charCodeAt(H))){let X=null,de=H+1;if(X=i(te,ie,M+1,H+1,G),!G)for(;!X&&(de=t(ie,de))<ie.length;)X=i(te,ie,M+1,de,G),de++;return X===null?null:g({start:H,end:H+1},X)}else return null}function t(te,ie){for(let M=ie;M<te.length;M++)if(w(te.charCodeAt(M))||M>0&&w(te.charCodeAt(M-1)))return M;return te.length}const c=y(e.matchesPrefix,r,D),l=y(e.matchesPrefix,r,C),h=new u.LRUCache(1e4);function E(te,ie,M=!1){if(typeof te!="string"||typeof ie!="string")return null;let H=h.get(te);H||(H=new RegExp(n.convertSimple2RegExpPattern(te),"i"),h.set(te,H));const G=H.exec(ie);return G?[{start:G.index,end:G.index+G[0].length}]:M?l(te,ie):c(te,ie)}e.matchesFuzzy=E;function R(te,ie){const M=pe(te,te.toLowerCase(),0,ie,ie.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return M?O(M):null}e.matchesFuzzy2=R;function N(te,ie,M,H,G,X){const de=Math.min(13,te.length);for(;M<de;M++){const be=pe(te,ie,M,H,G,X,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(be)return be}return[0,X]}e.anyScore=N;function O(te){if(typeof te=="undefined")return[];const ie=[],M=te[1];for(let H=te.length-1;H>1;H--){const G=te[H]+M,X=ie[ie.length-1];X&&X.end===G?X.end=G+1:ie.push({start:G,end:G+1})}return ie}e.createMatches=O;const k=128;function U(){const te=[],ie=[];for(let M=0;M<=k;M++)ie[M]=0;for(let M=0;M<=k;M++)te.push(ie.slice(0));return te}function F(te){const ie=[];for(let M=0;M<=te;M++)ie[M]=0;return ie}const $=F(2*k),ee=F(2*k),B=U(),z=U(),q=U(),V=!1;function j(te,ie,M,H,G){function X(be,se,De=" "){for(;be.length<se;)be=De+be;return be}let de=` |   |${H.split("").map(be=>X(be,3)).join("|")}
`;for(let be=0;be<=M;be++)be===0?de+=" |":de+=`${ie[be-1]}|`,de+=te[be].slice(0,G+1).map(se=>X(se.toString(),3)).join("|")+`
`;return de}function ne(te,ie,M,H){te=te.substr(ie),M=M.substr(H),console.log(j(z,te,te.length,M,M.length)),console.log(j(q,te,te.length,M,M.length)),console.log(j(B,te,te.length,M,M.length))}function Y(te,ie){if(ie<0||ie>=te.length)return!1;const M=te.codePointAt(ie);switch(M){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!n.isEmojiImprecise(M)}}function le(te,ie){if(ie<0||ie>=te.length)return!1;switch(te.charCodeAt(ie)){case 32:case 9:return!0;default:return!1}}function ue(te,ie,M){return ie[te]!==M[te]}function K(te,ie,M,H,G,X,de=!1){for(;ie<M&&G<X;)te[ie]===H[G]&&(de&&($[ie]=G),ie+=1),G+=1;return ie===M}e.isPatternInWord=K;var ge;(function(te){te[te.Diag=1]="Diag",te[te.Left=2]="Left",te[te.LeftLeft=3]="LeftLeft"})(ge||(ge={}));var ye;(function(te){te.Default=[-100,0];function ie(M){return!M||M.length===2&&M[0]===-100&&M[1]===0}te.isDefault=ie})(ye=e.FuzzyScore||(e.FuzzyScore={}));class Te{constructor(ie,M){this.firstMatchCanBeWeak=ie,this.boostFullMatch=M}}e.FuzzyScoreOptions=Te,Te.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function pe(te,ie,M,H,G,X,de=Te.default){const be=te.length>k?k:te.length,se=H.length>k?k:H.length;if(M>=be||X>=se||be-M>se-X||!K(ie,M,be,G,X,se,!0))return;Pe(be,se,M,X,ie,G);let De=1,Ce=1,ze=M,Ke=X;const Ne=[!1];for(De=1,ze=M;ze<be;De++,ze++){const We=$[ze],oe=ee[ze],Re=ze+1<be?ee[ze+1]:se;for(Ce=We-X+1,Ke=We;Ke<Re;Ce++,Ke++){let Be=Number.MIN_SAFE_INTEGER,qe=!1;Ke<=oe&&(Be=fe(te,ie,ze,M,H,G,Ke,se,X,B[De-1][Ce-1]===0,Ne));let je=0;Be!==Number.MAX_SAFE_INTEGER&&(qe=!0,je=Be+z[De-1][Ce-1]);const Ve=Ke>We,nt=Ve?z[De][Ce-1]+(B[De][Ce-1]>0?-5:0):0,ot=Ke>We+1&&B[De][Ce-1]>0,st=ot?z[De][Ce-2]+(B[De][Ce-2]>0?-5:0):0;if(ot&&(!Ve||st>=nt)&&(!qe||st>=je))z[De][Ce]=st,q[De][Ce]=3,B[De][Ce]=0;else if(Ve&&(!qe||nt>=je))z[De][Ce]=nt,q[De][Ce]=2,B[De][Ce]=0;else if(qe)z[De][Ce]=je,q[De][Ce]=1,B[De][Ce]=B[De-1][Ce-1]+1;else throw new Error("not possible")}}if(V&&ne(te,M,H,X),!Ne[0]&&!de.firstMatchCanBeWeak)return;De--,Ce--;const Ye=[z[De][Ce],X];let Z=0,re=0;for(;De>=1;){let We=Ce;do{const oe=q[De][We];if(oe===3)We=We-2;else if(oe===2)We=We-1;else break}while(We>=1);Z>1&&ie[M+De-1]===G[X+Ce-1]&&!ue(We+X-1,H,G)&&Z+1>B[De][We]&&(We=Ce),We===Ce?Z++:Z=1,re||(re=We),De--,Ce=We-1,Ye.push(Ce)}se===be&&de.boostFullMatch&&(Ye[0]+=2);const Se=re-be;return Ye[0]-=Se,Ye}e.fuzzyScore=pe;function Pe(te,ie,M,H,G,X){let de=te-1,be=ie-1;for(;de>=M&&be>=H;)G[de]===X[be]&&(ee[de]=be,de--),be--}function fe(te,ie,M,H,G,X,de,be,se,De,Ce){if(ie[M]!==X[de])return Number.MIN_SAFE_INTEGER;let ze=1,Ke=!1;return de===M-H?ze=te[M]===G[de]?7:5:ue(de,G,X)&&(de===0||!ue(de-1,G,X))?(ze=te[M]===G[de]?7:5,Ke=!0):Y(X,de)&&(de===0||!Y(X,de-1))?ze=5:(Y(X,de-1)||le(X,de-1))&&(ze=5,Ke=!0),ze>1&&M===H&&(Ce[0]=!0),Ke||(Ke=ue(de,G,X)||Y(X,de-1)||le(X,de-1)),M===H?de>se&&(ze-=Ke?3:5):De?ze+=Ke?2:0:ze+=Ke?0:1,de+1===be&&(ze-=Ke?3:5),ze}function ve(te,ie,M,H,G,X,de){return ae(te,ie,M,H,G,X,!0,de)}e.fuzzyScoreGracefulAggressive=ve;function _e(te,ie,M,H,G,X,de){return ae(te,ie,M,H,G,X,!1,de)}e.fuzzyScoreGraceful=_e;function ae(te,ie,M,H,G,X,de,be){let se=pe(te,ie,M,H,G,X,be);if(se&&!de)return se;if(te.length>=3){const De=Math.min(7,te.length-1);for(let Ce=M+1;Ce<De;Ce++){const ze=he(te,Ce);if(ze){const Ke=pe(ze,ze.toLowerCase(),M,H,G,X,be);Ke&&(Ke[0]-=3,(!se||Ke[0]>se[0])&&(se=Ke))}}}return se}function he(te,ie){if(ie+1>=te.length)return;const M=te[ie],H=te[ie+1];if(M!==H)return te.slice(0,ie)+H+M+te.slice(ie+2)}}),define(Ie[157],ke([1,0,77,103,8]),function(Q,e,u,n,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const A=new RegExp(`\\$\\(${u.CSSIcon.iconNameExpression}(?:${u.CSSIcon.iconModifierExpression})?\\)`,"g"),D=new RegExp(u.CSSIcon.iconNameCharacter),C=new RegExp(`(\\\\)?${A.source}`,"g");function S(p){return p.replace(C,(g,v)=>v?g:`\\${g}`)}e.escapeIcons=S;const P=new RegExp(`\\\\${A.source}`,"g");function L(p){return p.replace(P,g=>`\\${g}`)}e.markdownEscapeEscapedIcons=L;const I=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function _(p){return p.indexOf(e.iconStartMarker)===-1?p:p.replace(I,(g,v,f,a)=>f?g:v||a||"")}e.stripIcons=_;function T(p){const g=p.indexOf(e.iconStartMarker);return g===-1?{text:p}:w(p,g)}e.parseLabelWithIcons=T;function w(p,g){const v=[];let f="";function a(c){if(c){f+=c;for(const l of c)v.push(d)}}let m=-1,o="",d=0,r,s,i=g;const t=p.length;for(a(p.substr(0,g));i<t;)r=p[i],s=p[i+1],r===e.iconStartMarker[0]&&s===e.iconStartMarker[1]?(m=i,a(o),o=e.iconStartMarker,i++):r===")"&&m!==-1?(d+=i-m+1,m=-1,o=""):m!==-1?D.test(r)?o+=r:(a(o),m=-1,o=""):a(r),i++;return a(o),{text:f,iconOffsets:v}}function b(p,g,v=!1){const{text:f,iconOffsets:a}=g;if(!a||a.length===0)return(0,n.matchesFuzzy)(p,f,v);const m=(0,y.ltrim)(f," "),o=f.length-m.length,d=(0,n.matchesFuzzy)(p,m,v);if(d)for(const r of d){const s=a[r.start+o]+o;r.start+=s,r.end+=s}return d}e.matchesFuzzyIconAware=b}),define(Ie[81],ke([1,0,25]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const n=new u.LRUCache(1e4);function y(P){return S(P,"NFC",n)}e.normalizeNFC=y;const A=new u.LRUCache(1e4);function D(P){return S(P,"NFD",A)}e.normalizeNFD=D;const C=/[^\u0000-\u0080]/;function S(P,L,I){if(!P)return P;const _=I.get(P);if(_)return _;let T;return C.test(P)?T=P.normalize(L):T=P,I.set(P,T),T}e.removeAccents=function(){const P=/[\u0300-\u036f]/g;return function(L){return D(L).replace(P,"")}}()}),define(Ie[41],ke([1,0,8]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var n;(function(y){y[y.Ignore=0]="Ignore",y[y.Info=1]="Info",y[y.Warning=2]="Warning",y[y.Error=3]="Error"})(n||(n={})),function(y){const A="error",D="warning",C="warn",S="info",P="ignore";function L(_){return _?u.equalsIgnoreCase(A,_)?y.Error:u.equalsIgnoreCase(D,_)||u.equalsIgnoreCase(C,_)?y.Warning:u.equalsIgnoreCase(S,_)?y.Info:y.Ignore:y.Ignore}y.fromValue=L;function I(_){switch(_){case y.Error:return A;case y.Warning:return D;case y.Info:return S;default:return P}}y.toString=I}(n||(n={})),e.default=n}),define(Ie[2],ke([1,0,9,13]),function(Q,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const y=/^\w[\w\d+.-]*$/,A=/^\//,D=/^\/\//;function C(r,s){if(!r.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!y.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!A.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(r,s){return!r&&!s?"file":r}function P(r,s){switch(r){case"https":case"http":case"file":s?s[0]!==I&&(s=I+s):s=I;break}return s}const L="",I="/",_=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class T{constructor(s,i,t,c,l,h=!1){typeof s=="object"?(this.scheme=s.scheme||L,this.authority=s.authority||L,this.path=s.path||L,this.query=s.query||L,this.fragment=s.fragment||L):(this.scheme=S(s,h),this.authority=i||L,this.path=P(this.scheme,t||L),this.query=c||L,this.fragment=l||L,C(this,h))}static isUri(s){return s instanceof T?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}get fsPath(){return f(this,!1)}with(s){if(!s)return this;let{scheme:i,authority:t,path:c,query:l,fragment:h}=s;return i===void 0?i=this.scheme:i===null&&(i=L),t===void 0?t=this.authority:t===null&&(t=L),c===void 0?c=this.path:c===null&&(c=L),l===void 0?l=this.query:l===null&&(l=L),h===void 0?h=this.fragment:h===null&&(h=L),i===this.scheme&&t===this.authority&&c===this.path&&l===this.query&&h===this.fragment?this:new b(i,t,c,l,h)}static parse(s,i=!1){const t=_.exec(s);return t?new b(t[2]||L,d(t[4]||L),d(t[5]||L),d(t[7]||L),d(t[9]||L),i):new b(L,L,L,L,L)}static file(s){let i=L;if(n.isWindows&&(s=s.replace(/\\/g,I)),s[0]===I&&s[1]===I){const t=s.indexOf(I,2);t===-1?(i=s.substring(2),s=I):(i=s.substring(2,t),s=s.substring(t)||I)}return new b("file",i,s,L,L)}static from(s){const i=new b(s.scheme,s.authority,s.path,s.query,s.fragment);return C(i,!0),i}static joinPath(s,...i){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let t;return n.isWindows&&s.scheme==="file"?t=T.file(u.win32.join(f(s,!0),...i)).path:t=u.posix.join(s.path,...i),s.with({path:t})}toString(s=!1){return a(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof T)return s;{const i=new b(s);return i._formatted=s.external,i._fsPath=s._sep===w?s.fsPath:null,i}}else return s}}e.URI=T;const w=n.isWindows?1:void 0;class b extends T{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=f(this,!1)),this._fsPath}toString(s=!1){return s?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=w),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const p={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function g(r,s){let i,t=-1;for(let c=0;c<r.length;c++){const l=r.charCodeAt(c);if(l>=97&&l<=122||l>=65&&l<=90||l>=48&&l<=57||l===45||l===46||l===95||l===126||s&&l===47)t!==-1&&(i+=encodeURIComponent(r.substring(t,c)),t=-1),i!==void 0&&(i+=r.charAt(c));else{i===void 0&&(i=r.substr(0,c));const h=p[l];h!==void 0?(t!==-1&&(i+=encodeURIComponent(r.substring(t,c)),t=-1),i+=h):t===-1&&(t=c)}}return t!==-1&&(i+=encodeURIComponent(r.substring(t))),i!==void 0?i:r}function v(r){let s;for(let i=0;i<r.length;i++){const t=r.charCodeAt(i);t===35||t===63?(s===void 0&&(s=r.substr(0,i)),s+=p[t]):s!==void 0&&(s+=r[i])}return s!==void 0?s:r}function f(r,s){let i;return r.authority&&r.path.length>1&&r.scheme==="file"?i=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?s?i=r.path.substr(1):i=r.path[1].toLowerCase()+r.path.substr(2):i=r.path,n.isWindows&&(i=i.replace(/\//g,"\\")),i}e.uriToFsPath=f;function a(r,s){const i=s?v:g;let t="",{scheme:c,authority:l,path:h,query:E,fragment:R}=r;if(c&&(t+=c,t+=":"),(l||c==="file")&&(t+=I,t+=I),l){let N=l.indexOf("@");if(N!==-1){const O=l.substr(0,N);l=l.substr(N+1),N=O.indexOf(":"),N===-1?t+=i(O,!1):(t+=i(O.substr(0,N),!1),t+=":",t+=i(O.substr(N+1),!1)),t+="@"}l=l.toLowerCase(),N=l.indexOf(":"),N===-1?t+=i(l,!1):(t+=i(l.substr(0,N),!1),t+=l.substr(N))}if(h){if(h.length>=3&&h.charCodeAt(0)===47&&h.charCodeAt(2)===58){const N=h.charCodeAt(1);N>=65&&N<=90&&(h=`/${String.fromCharCode(N+32)}:${h.substr(3)}`)}else if(h.length>=2&&h.charCodeAt(1)===58){const N=h.charCodeAt(0);N>=65&&N<=90&&(h=`${String.fromCharCode(N+32)}:${h.substr(2)}`)}t+=i(h,!0)}return E&&(t+="?",t+=i(E,!1)),R&&(t+="#",t+=s?R:g(R,!1)),t}function m(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+m(r.substr(3)):r}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function d(r){return r.match(o)?r.replace(o,s=>m(s)):r}}),define(Ie[61],ke([1,0,23,8,2]),function(Q,e,u,n,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function A(P){return JSON.stringify(P,C)}e.stringify=A;function D(P){let L=JSON.parse(P);return L=S(L),L}e.parse=D;function C(P,L){return L instanceof RegExp?{$mid:2,source:L.source,flags:(0,n.regExpFlags)(L)}:L}function S(P,L=0){if(!P||L>200)return P;if(typeof P=="object"){switch(P.$mid){case 1:return y.URI.revive(P);case 2:return new RegExp(P.source,P.flags);case 14:return new Date(P.source)}if(P instanceof u.VSBuffer||P instanceof Uint8Array)return P;if(Array.isArray(P))for(let I=0;I<P.length;++I)P[I]=S(P[I],L+1);else for(const I in P)Object.hasOwnProperty.call(P,I)&&(P[I]=S(P[I],L+1))}return P}e.revive=S}),define(Ie[11],ke([1,0,13,2]),function(Q,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var y;(function(C){C.inMemory="inmemory",C.vscode="vscode",C.internal="private",C.walkThrough="walkThrough",C.walkThroughSnippet="walkThroughSnippet",C.http="http",C.https="https",C.file="file",C.mailto="mailto",C.untitled="untitled",C.data="data",C.command="command",C.vscodeRemote="vscode-remote",C.vscodeRemoteResource="vscode-remote-resource",C.vscodeUserData="vscode-userdata",C.vscodeCustomEditor="vscode-custom-editor",C.vscodeNotebook="vscode-notebook",C.vscodeNotebookCell="vscode-notebook-cell",C.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",C.vscodeNotebookCellOutput="vscode-notebook-cell-output",C.vscodeInteractive="vscode-interactive",C.vscodeInteractiveInput="vscode-interactive-input",C.vscodeSettings="vscode-settings",C.vscodeWorkspaceTrust="vscode-workspace-trust",C.vscodeTerminal="vscode-terminal",C.webviewPanel="webview-panel",C.vscodeWebview="vscode-webview",C.extension="extension",C.vscodeFileResource="vscode-file",C.tmp="tmp",C.vsls="vsls"})(y=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class A{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${y.vscodeRemoteResource}`}setPreferredWebSchema(S){this._preferredWebSchema=S}setDelegate(S){this._delegate=S}setServerRootPath(S){this._remoteResourcesPath=`${S}/${y.vscodeRemoteResource}`}set(S,P,L){this._hosts[S]=P,this._ports[S]=L}setConnectionToken(S,P){this._connectionTokens[S]=P}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(S){if(this._delegate)return this._delegate(S);const P=S.authority;let L=this._hosts[P];L&&L.indexOf(":")!==-1&&(L=`[${L}]`);const I=this._ports[P],_=this._connectionTokens[P];let T=`path=${encodeURIComponent(S.path)}`;return typeof _=="string"&&(T+=`&${e.connectionTokenQueryName}=${encodeURIComponent(_)}`),n.URI.from({scheme:u.isWeb?this._preferredWebSchema:y.vscodeRemoteResource,authority:`${L}:${I}`,path:this._remoteResourcesPath,query:T})}}e.RemoteAuthorities=new A;class D{asBrowserUri(S,P){const L=this.toUri(S,P);return L.scheme===y.vscodeRemote?e.RemoteAuthorities.rewrite(L):L.scheme===y.file&&(u.isNative||u.isWebWorker&&u.globals.origin===`${y.vscodeFileResource}://${D.FALLBACK_AUTHORITY}`)?L.with({scheme:y.vscodeFileResource,authority:L.authority||D.FALLBACK_AUTHORITY,query:null,fragment:null}):L}asFileUri(S,P){const L=this.toUri(S,P);return L.scheme===y.vscodeFileResource?L.with({scheme:y.file,authority:L.authority!==D.FALLBACK_AUTHORITY?L.authority:null,query:null,fragment:null}):L}toUri(S,P){return n.URI.isUri(S)?S:n.URI.parse(P.toUrl(S))}}D.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new D}),define(Ie[22],ke([1,0,30,11,9,13,8,2]),function(Q,e,u,n,y,A,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(T){return(0,C.uriToFsPath)(T,!0)}e.originalFSPath=S;class P{constructor(w){this._ignorePathCasing=w}compare(w,b,p=!1){return w===b?0:(0,D.compare)(this.getComparisonKey(w,p),this.getComparisonKey(b,p))}isEqual(w,b,p=!1){return w===b?!0:!w||!b?!1:this.getComparisonKey(w,p)===this.getComparisonKey(b,p)}getComparisonKey(w,b=!1){return w.with({path:this._ignorePathCasing(w)?w.path.toLowerCase():void 0,fragment:b?null:void 0}).toString()}ignorePathCasing(w){return this._ignorePathCasing(w)}isEqualOrParent(w,b,p=!1){if(w.scheme===b.scheme){if(w.scheme===n.Schemas.file)return u.isEqualOrParent(S(w),S(b),this._ignorePathCasing(w))&&w.query===b.query&&(p||w.fragment===b.fragment);if((0,e.isEqualAuthority)(w.authority,b.authority))return u.isEqualOrParent(w.path,b.path,this._ignorePathCasing(w),"/")&&w.query===b.query&&(p||w.fragment===b.fragment)}return!1}joinPath(w,...b){return C.URI.joinPath(w,...b)}basenameOrAuthority(w){return(0,e.basename)(w)||w.authority}basename(w){return y.posix.basename(w.path)}extname(w){return y.posix.extname(w.path)}dirname(w){if(w.path.length===0)return w;let b;return w.scheme===n.Schemas.file?b=C.URI.file(y.dirname(S(w))).path:(b=y.posix.dirname(w.path),w.authority&&b.length&&b.charCodeAt(0)!==47&&(console.error(`dirname("${w.toString})) resulted in a relative path`),b="/")),w.with({path:b})}normalizePath(w){if(!w.path.length)return w;let b;return w.scheme===n.Schemas.file?b=C.URI.file(y.normalize(S(w))).path:b=y.posix.normalize(w.path),w.with({path:b})}relativePath(w,b){if(w.scheme!==b.scheme||!(0,e.isEqualAuthority)(w.authority,b.authority))return;if(w.scheme===n.Schemas.file){const v=y.relative(S(w),S(b));return A.isWindows?u.toSlashes(v):v}let p=w.path||"/";const g=b.path||"/";if(this._ignorePathCasing(w)){let v=0;for(const f=Math.min(p.length,g.length);v<f&&!(p.charCodeAt(v)!==g.charCodeAt(v)&&p.charAt(v).toLowerCase()!==g.charAt(v).toLowerCase());v++);p=g.substr(0,v)+p.substr(v)}return y.posix.relative(p,g)}resolvePath(w,b){if(w.scheme===n.Schemas.file){const p=C.URI.file(y.resolve(S(w),b));return w.with({authority:p.authority,path:p.path})}return b=u.toPosixPath(b),w.with({path:y.posix.resolve(w.path,b)})}isAbsolutePath(w){return!!w.path&&w.path[0]==="/"}isEqualAuthority(w,b){return w===b||w!==void 0&&b!==void 0&&(0,D.equalsIgnoreCase)(w,b)}hasTrailingPathSeparator(w,b=y.sep){if(w.scheme===n.Schemas.file){const p=S(w);return p.length>u.getRoot(p).length&&p[p.length-1]===b}else{const p=w.path;return p.length>1&&p.charCodeAt(p.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(w.fsPath)}}removeTrailingPathSeparator(w,b=y.sep){return(0,e.hasTrailingPathSeparator)(w,b)?w.with({path:w.path.substr(0,w.path.length-1)}):w}addTrailingPathSeparator(w,b=y.sep){let p=!1;if(w.scheme===n.Schemas.file){const g=S(w);p=g!==void 0&&g.length===u.getRoot(g).length&&g[g.length-1]===b}else{b="/";const g=w.path;p=g.length===1&&g.charCodeAt(g.length-1)===47}return!p&&!(0,e.hasTrailingPathSeparator)(w,b)?w.with({path:w.path+"/"}):w}}e.ExtUri=P,e.extUri=new P(()=>!1),e.extUriBiasedIgnorePathCase=new P(T=>T.scheme===n.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new P(T=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function L(T,w){const b=[];for(let p=0;p<T.length;p++){const g=w(T[p]);T.some((v,f)=>f===p?!1:(0,e.isEqualOrParent)(g,w(v)))||b.push(T[p])}return b}e.distinctParents=L;var I;(function(T){T.META_DATA_LABEL="label",T.META_DATA_DESCRIPTION="description",T.META_DATA_SIZE="size",T.META_DATA_MIME="mime";function w(b){const p=new Map;b.path.substring(b.path.indexOf(";")+1,b.path.lastIndexOf(";")).split(";").forEach(f=>{const[a,m]=f.split(":");a&&m&&p.set(a,m)});const v=b.path.substring(0,b.path.indexOf(";"));return v&&p.set(T.META_DATA_MIME,v),p}T.parseMetaData=w})(I=e.DataUri||(e.DataUri={}));function _(T,w,b){if(w){let p=T.path;return p&&p[0]!==y.posix.sep&&(p=y.posix.sep+p),T.with({scheme:b,authority:w,path:p})}return T.with({scheme:b})}e.toLocalResource=_}),define(Ie[18],ke([1,0,21,12,3,6,22,13]),function(Q,e,u,n,y,A,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function S(ue){return!!ue&&typeof ue.then=="function"}e.isThenable=S;function P(ue){const K=new u.CancellationTokenSource,ge=ue(K.token),ye=new Promise((Te,pe)=>{const Pe=K.token.onCancellationRequested(()=>{Pe.dispose(),K.dispose(),pe(new n.CancellationError)});Promise.resolve(ge).then(fe=>{Pe.dispose(),K.dispose(),Te(fe)},fe=>{Pe.dispose(),K.dispose(),pe(fe)})});return new class{cancel(){K.cancel()}then(Te,pe){return ye.then(Te,pe)}catch(Te){return this.then(void 0,Te)}finally(Te){return ye.finally(Te)}}}e.createCancelablePromise=P;function L(ue,K,ge){return new Promise((ye,Te)=>{const pe=K.onCancellationRequested(()=>{pe.dispose(),ye(ge)});ue.then(ye,Te).finally(()=>pe.dispose())})}e.raceCancellation=L;function I(ue,K){return new Promise((ge,ye)=>{const Te=K.onCancellationRequested(()=>{Te.dispose(),ye(new n.CancellationError)});ue.then(ge,ye).finally(()=>Te.dispose())})}e.raceCancellationError=I;async function _(ue){let K=-1;const ge=ue.map((Te,pe)=>Te.then(Pe=>(K=pe,Pe))),ye=await Promise.race(ge);return ue.forEach((Te,pe)=>{pe!==K&&Te.cancel()}),ye}e.raceCancellablePromises=_;function T(ue,K,ge){let ye;const Te=setTimeout(()=>{ye?.(void 0),ge?.()},K);return Promise.race([ue.finally(()=>clearTimeout(Te)),new Promise(pe=>ye=pe)])}e.raceTimeout=T;function w(ue){return new Promise((K,ge)=>{const ye=ue();S(ye)?ye.then(K,ge):K(ye)})}e.asPromise=w;class b{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(K){if(this.activePromise){if(this.queuedPromiseFactory=K,!this.queuedPromise){const ge=()=>{this.queuedPromise=null;const ye=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,ye};this.queuedPromise=new Promise(ye=>{this.activePromise.then(ge,ge).then(ye)})}return new Promise((ge,ye)=>{this.queuedPromise.then(ge,ye)})}return this.activePromise=K(),new Promise((ge,ye)=>{this.activePromise.then(Te=>{this.activePromise=null,ge(Te)},Te=>{this.activePromise=null,ye(Te)})})}}e.Throttler=b;class p{constructor(){this.current=Promise.resolve(null)}queue(K){return this.current=this.current.then(()=>K(),()=>K())}}e.Sequencer=p;class g{constructor(){this.promiseMap=new Map}queue(K,ge){const Te=(this.promiseMap.get(K)??Promise.resolve()).catch(()=>{}).then(ge).finally(()=>{this.promiseMap.get(K)===Te&&this.promiseMap.delete(K)});return this.promiseMap.set(K,Te),Te}}e.SequencerByKey=g;const v=(ue,K)=>{let ge=!0;const ye=setTimeout(()=>{ge=!1,K()},ue);return{isTriggered:()=>ge,dispose:()=>{clearTimeout(ye),ge=!1}}},f=ue=>{let K=!0;return queueMicrotask(()=>{K&&(K=!1,ue())}),{isTriggered:()=>K,dispose:()=>{K=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class a{constructor(K){this.defaultDelay=K,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(K,ge=this.defaultDelay){this.task=K,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Te,pe)=>{this.doResolve=Te,this.doReject=pe}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Te=this.task;return this.task=null,Te()}}));const ye=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=ge===e.MicrotaskDelay?f(ye):v(ge,ye),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new n.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=a;class m{constructor(K){this.delayer=new a(K),this.throttler=new b}trigger(K,ge){return this.delayer.trigger(()=>this.throttler.queue(K),ge)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=m;class o{constructor(){this._isOpen=!1,this._promise=new Promise((K,ge)=>{this._completePromise=K})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=o;class d extends o{constructor(K){super();this._timeout=setTimeout(()=>this.open(),K)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=d;function r(ue,K){return K?new Promise((ge,ye)=>{const Te=setTimeout(()=>{pe.dispose(),ge()},ue),pe=K.onCancellationRequested(()=>{clearTimeout(Te),pe.dispose(),ye(new n.CancellationError)})}):P(ge=>r(ue,ge))}e.timeout=r;function s(ue,K=0){const ge=setTimeout(ue,K);return(0,A.toDisposable)(()=>clearTimeout(ge))}e.disposableTimeout=s;function i(ue){const K=[];let ge=0;const ye=ue.length;function Te(){return ge<ye?ue[ge++]():null}function pe(Pe){Pe!=null&&K.push(Pe);const fe=Te();return fe?fe.then(pe):Promise.resolve(K)}return Promise.resolve(null).then(pe)}e.sequence=i;function t(ue,K=ye=>!!ye,ge=null){let ye=0;const Te=ue.length,pe=()=>{if(ye>=Te)return Promise.resolve(ge);const Pe=ue[ye++];return Promise.resolve(Pe()).then(ve=>K(ve)?Promise.resolve(ve):pe())};return pe()}e.first=t;function c(ue,K=ye=>!!ye,ge=null){if(ue.length===0)return Promise.resolve(ge);let ye=ue.length;const Te=()=>{ye=-1;for(const pe of ue)pe.cancel?.()};return new Promise((pe,Pe)=>{for(const fe of ue)fe.then(ve=>{--ye>=0&&K(ve)?(Te(),pe(ve)):ye===0&&pe(ge)}).catch(ve=>{--ye>=0&&(Te(),Pe(ve))})})}e.firstParallel=c;class l{constructor(K){this._size=0,this.maxDegreeOfParalellism=K,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new y.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(K){return this._size++,new Promise((ge,ye)=>{this.outstandingPromises.push({factory:K,c:ge,e:ye}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const K=this.outstandingPromises.shift();this.runningPromises++;const ge=K.factory();ge.then(K.c,K.e),ge.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=l;class h extends l{constructor(){super(1)}}e.Queue=h;class E{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const K=new q;return this.drainers.add(K),K.p}isDrained(){for(const[,K]of this.queues)if(K.size>0)return!1;return!0}queueFor(K,ge=D.extUri){const ye=ge.getComparisonKey(K);let Te=this.queues.get(ye);return Te||(Te=new h,y.Event.once(Te.onDrained)(()=>{Te?.dispose(),this.queues.delete(ye),this.onDidQueueDrain()}),this.queues.set(ye,Te)),Te}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const K of this.drainers)K.complete();this.drainers.clear()}dispose(){for(const[,K]of this.queues)K.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=E;class R{constructor(K,ge){this._token=-1,typeof K=="function"&&typeof ge=="number"&&this.setIfNotSet(K,ge)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(K,ge){this.cancel(),this._token=setTimeout(()=>{this._token=-1,K()},ge)}setIfNotSet(K,ge){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,K()},ge))}}e.TimeoutTimer=R;class N{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(K,ge){this.cancel(),this._token=setInterval(()=>{K()},ge)}}e.IntervalTimer=N;class O{constructor(K,ge){this.timeoutToken=-1,this.runner=K,this.timeout=ge,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(K=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,K)}get delay(){return this.timeout}set delay(K){this.timeout=K}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=O;class k{constructor(K,ge){ge%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ge}ms is not a multiple of 1000ms.`),this.runner=K,this.timeout=ge,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(K=this.timeout){K%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${K}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(K/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=k;class U extends O{constructor(K,ge){super(K,ge);this.units=[]}work(K){this.units.push(K),this.isScheduled()||this.schedule()}doRun(){const K=this.units;this.units=[],this.runner?.(K)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=U;class F extends A.Disposable{constructor(K,ge){super();this.options=K,this.handler=ge,this.pendingWork=[],this.throttler=this._register(new A.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(K){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+K.length>this.options.maxBufferedWork)return!1}else if(this.pending+K.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...K),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new O(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=F,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=ue=>{(0,C.setTimeout0)(()=>{if(K)return;const ge=Date.now()+15;ue(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ge-Date.now())}}))});let K=!1;return{dispose(){K||(K=!0)}}}:e.runWhenIdle=(ue,K)=>{const ge=requestIdleCallback(ue,typeof K=="number"?{timeout:K}:void 0);let ye=!1;return{dispose(){ye||(ye=!0,cancelIdleCallback(ge))}}}}();class ${constructor(K){this._didRun=!1,this._executor=()=>{try{this._value=K()}catch(ge){this._error=ge}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=$;async function ee(ue,K,ge){let ye;for(let Te=0;Te<ge;Te++)try{return await ue()}catch(pe){ye=pe,await r(K)}throw ye}e.retry=ee;class B{hasPending(K){return this._pending?typeof K=="number"?this._pending.taskId===K:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(K,ge,ye){return this._pending={taskId:K,cancel:()=>ye?.(),promise:ge},ge.then(()=>this.donePending(K),()=>this.donePending(K)),ge}donePending(K){this._pending&&K===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const K=this._next;this._next=void 0,K.run().then(K.promiseResolve,K.promiseReject)}}setNext(K){if(this._next)this._next.run=K;else{let ge,ye;const Te=new Promise((pe,Pe)=>{ge=pe,ye=Pe});this._next={run:K,promise:Te,promiseResolve:ge,promiseReject:ye}}return this._next.promise}}e.TaskSequentializer=B;class z{constructor(K,ge=()=>Date.now()){this.interval=K,this.nowFn=ge,this.lastIncrementTime=0,this.value=0}increment(){const K=this.nowFn();return K-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=K,this.value=0),this.value++,this.value}}e.IntervalCounter=z;class q{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((K,ge)=>{this.completeCallback=K,this.errorCallback=ge})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(K){return new Promise(ge=>{this.completeCallback(K),this.resolved=!0,ge()})}error(K){return new Promise(ge=>{this.errorCallback(K),this.rejected=!0,ge()})}cancel(){new Promise(K=>{this.errorCallback(new n.CancellationError),this.rejected=!0,K()})}}e.DeferredPromise=q;var V;(function(ue){async function K(ye){let Te;const pe=await Promise.all(ye.map(Pe=>Pe.then(fe=>fe,fe=>{Te||(Te=fe)})));if(typeof Te!="undefined")throw Te;return pe}ue.settled=K;function ge(ye){return new Promise(async(Te,pe)=>{try{await ye(Te,pe)}catch(Pe){pe(Pe)}})}ue.withAsyncBody=ge})(V=e.Promises||(e.Promises={}));var j;(function(ue){ue[ue.Initial=0]="Initial",ue[ue.DoneOK=1]="DoneOK",ue[ue.DoneError=2]="DoneError"})(j||(j={}));class ne{constructor(K){this._state=0,this._results=[],this._error=null,this._onStateChanged=new y.Emitter,queueMicrotask(async()=>{const ge={emitOne:ye=>this.emitOne(ye),emitMany:ye=>this.emitMany(ye),reject:ye=>this.reject(ye)};try{await Promise.resolve(K(ge)),this.resolve()}catch(ye){this.reject(ye)}finally{ge.emitOne=void 0,ge.emitMany=void 0,ge.reject=void 0}})}static fromArray(K){return new ne(ge=>{ge.emitMany(K)})}static fromPromise(K){return new ne(async ge=>{ge.emitMany(await K)})}static fromPromises(K){return new ne(async ge=>{await Promise.all(K.map(async ye=>ge.emitOne(await ye)))})}static merge(K){return new ne(async ge=>{await Promise.all(K.map(async ye=>{for await(const Te of ye)ge.emitOne(Te)}))})}[Symbol.asyncIterator](){let K=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(K<this._results.length)return{done:!1,value:this._results[K++]};if(this._state===1)return{done:!0,value:void 0};await y.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(K,ge){return new ne(async ye=>{for await(const Te of K)ye.emitOne(ge(Te))})}map(K){return ne.map(this,K)}static filter(K,ge){return new ne(async ye=>{for await(const Te of K)ge(Te)&&ye.emitOne(Te)})}filter(K){return ne.filter(this,K)}static coalesce(K){return ne.filter(K,ge=>!!ge)}coalesce(){return ne.coalesce(this)}static async toPromise(K){const ge=[];for await(const ye of K)ge.push(ye);return ge}toPromise(){return ne.toPromise(this)}emitOne(K){this._state===0&&(this._results.push(K),this._onStateChanged.fire())}emitMany(K){this._state===0&&(this._results=this._results.concat(K),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(K){this._state===0&&(this._state=2,this._error=K,this._onStateChanged.fire())}}e.AsyncIterableObject=ne,ne.EMPTY=ne.fromArray([]);class Y extends ne{constructor(K,ge){super(ge);this._source=K}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=Y;function le(ue){const K=new u.CancellationTokenSource,ge=ue(K.token);return new Y(K,async ye=>{const Te=K.token.onCancellationRequested(()=>{Te.dispose(),K.dispose(),ye.reject(new n.CancellationError)});try{for await(const pe of ge){if(K.token.isCancellationRequested)return;ye.emitOne(pe)}Te.dispose(),K.dispose()}catch(pe){Te.dispose(),K.dispose(),ye.reject(pe)}})}e.createCancelableAsyncIterable=le}),define(Ie[104],ke([1,0,18,9]),function(Q,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const y=new u.IdleValue(()=>{const h=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:h,collatorIsNumeric:h.resolvedOptions().numeric}}),A=new u.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),D=new u.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function C(h,E,R=!1){const N=h||"",O=E||"",k=y.value.collator.compare(N,O);return y.value.collatorIsNumeric&&k===0&&N!==O?N<O?-1:1:k}e.compareFileNames=C;function S(h,E){const R=A.value.collator;return h=h||"",E=E||"",m(R,h,E)}e.compareFileNamesDefault=S;function P(h,E){const R=A.value.collator;return h=h||"",E=E||"",s(h,E)||m(R,h,E)}e.compareFileNamesUpper=P;function L(h,E){const R=A.value.collator;return h=h||"",E=E||"",r(h,E)||m(R,h,E)}e.compareFileNamesLower=L;function I(h,E){return h=h||"",E=E||"",h===E?0:h<E?-1:1}e.compareFileNamesUnicode=I;function _(h,E,R=!1){R||(h=h&&h.toLowerCase(),E=E&&E.toLowerCase());const[N,O]=f(h),[k,U]=f(E);return N!==k?N<k?-1:1:O===U?0:O<U?-1:1}e.noIntlCompareFileNames=_;function T(h,E){const[R,N]=f(h),[O,k]=f(E);let U=y.value.collator.compare(N,k);if(U===0){if(y.value.collatorIsNumeric&&N!==k)return N<k?-1:1;if(U=y.value.collator.compare(R,O),y.value.collatorIsNumeric&&U===0&&R!==O)return R<O?-1:1}return U}e.compareFileExtensions=T;function w(h,E){h=h||"",E=E||"";const R=a(h),N=a(E),O=A.value.collator,k=D.value.collator;return m(k,R,N)||m(O,h,E)}e.compareFileExtensionsDefault=w;function b(h,E){h=h||"",E=E||"";const R=a(h),N=a(E),O=A.value.collator,k=D.value.collator;return m(k,R,N)||s(h,E)||m(O,h,E)}e.compareFileExtensionsUpper=b;function p(h,E){h=h||"",E=E||"";const R=a(h),N=a(E),O=A.value.collator,k=D.value.collator;return m(k,R,N)||r(h,E)||m(O,h,E)}e.compareFileExtensionsLower=p;function g(h,E){h=h||"",E=E||"";const R=a(h).toLowerCase(),N=a(E).toLowerCase();return R!==N?R<N?-1:1:h!==E?h<E?-1:1:0}e.compareFileExtensionsUnicode=g;const v=/^(.*?)(\.([^.]*))?$/;function f(h,E=!1){const R=h?v.exec(h):[];let N=[R&&R[1]||"",R&&R[3]||""];return E&&(!N[0]&&N[1]||N[0]&&N[0].charAt(0)===".")&&(N=[N[0]+"."+N[1],""]),N}function a(h){const E=h?v.exec(h):[];return E&&E[1]&&E[1].charAt(0)!=="."&&E[3]||""}function m(h,E,R){const N=h.compare(E,R);return N!==0?N:E.length!==R.length?E.length<R.length?-1:1:0}function o(h){const E=h.charAt(0);return E.toLocaleUpperCase()!==E}function d(h){const E=h.charAt(0);return E.toLocaleLowerCase()!==E}function r(h,E){return o(h)&&d(E)?-1:d(h)&&o(E)?1:0}function s(h,E){return d(h)&&o(E)?-1:o(h)&&d(E)?1:0}function i(h,E,R=!1){return R||(h=h&&h.toLowerCase(),E=E&&E.toLowerCase()),h===E?0:h<E?-1:1}function t(h,E,R=!1){const N=h.split(n.sep),O=E.split(n.sep),k=N.length-1,U=O.length-1;let F,$;for(let ee=0;;ee++){if(F=k===ee,$=U===ee,F&&$)return C(N[ee],O[ee],R);if(F)return-1;if($)return 1;const B=i(N[ee],O[ee],R);if(B!==0)return B}}e.comparePaths=t;function c(h,E,R){const N=h.toLowerCase(),O=E.toLowerCase(),k=l(h,E,R);if(k)return k;const U=N.endsWith(R),F=O.endsWith(R);if(U!==F)return U?-1:1;const $=C(N,O);return $!==0?$:N.localeCompare(O)}e.compareAnything=c;function l(h,E,R){const N=h.toLowerCase(),O=E.toLowerCase(),k=N.startsWith(R),U=O.startsWith(R);if(k!==U)return k?-1:1;if(k&&U){if(N.length<O.length)return-1;if(N.length>O.length)return 1}return 0}e.compareByPrefix=l}),define(Ie[105],ke([1,0,104,103,60,9,13,8]),function(Q,e,u,n,y,A,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const S=0,P=[S,[]];function L(B,z,q,V){if(!B||!z)return P;const j=B.length,ne=z.length;if(j<ne)return P;const Y=B.toLowerCase();return I(z,q,ne,B,Y,j,V)}e.scoreFuzzy=L;function I(B,z,q,V,j,ne,Y){const le=[],ue=[];for(let Te=0;Te<q;Te++){const pe=Te*ne,Pe=pe-ne,fe=Te>0,ve=B[Te],_e=z[Te];for(let ae=0;ae<ne;ae++){const he=ae>0,te=pe+ae,ie=te-1,M=Pe+ae-1,H=he?le[ie]:0,G=fe&&he?le[M]:0,X=fe&&he?ue[M]:0;let de;!G&&fe?de=0:de=_(ve,_e,V,j,ae,X),de&&G+de>=H&&(Y||fe||j.startsWith(z,ae))?(ue[te]=X+1,le[te]=G+de):(ue[te]=S,le[te]=H)}}const K=[];let ge=q-1,ye=ne-1;for(;ge>=0&&ye>=0;){const Te=ge*ne+ye;ue[Te]===S||(K.push(ye),ge--),ye--}return[le[q*ne-1],K.reverse()]}function _(B,z,q,V,j,ne){let Y=0;if(!T(z,V[j]))return Y;if(Y+=1,ne>0&&(Y+=ne*5),B===q[j]&&(Y+=1),j===0)Y+=8;else{const le=w(q.charCodeAt(j-1));le?Y+=le:(0,n.isUpper)(q.charCodeAt(j))&&ne===0&&(Y+=2)}return Y}function T(B,z){return B===z?!0:B==="/"||B==="\\"?z==="/"||z==="\\":!1}function w(B){switch(B){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const b=[void 0,[]];function p(B,z,q=0,V=0){const j=z;return j.values&&j.values.length>1?g(B,j.values,q,V):v(B,z,q,V)}e.scoreFuzzy2=p;function g(B,z,q,V){let j=0;const ne=[];for(const Y of z){const[le,ue]=v(B,Y,q,V);if(typeof le!="number")return b;j+=le,ne.push(...ue)}return[j,l(ne)]}function v(B,z,q,V){const j=(0,n.fuzzyScore)(z.original,z.originalLowercase,q,B,B.toLowerCase(),V,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return j?[j[0],(0,n.createMatches)(j)]:b}const f=Object.freeze({score:0}),a=1<<18,m=1<<17,o=1<<16;function d(B,z,q,V){const j=V.values?V.values:[V];return(0,y.hash)({[V.normalized]:{values:j.map(Y=>({value:Y.normalized,expectContiguousMatch:Y.expectContiguousMatch})),label:B,description:z,allowNonContiguousMatches:q}})}function r(B,z,q,V,j){if(!B||!z.normalized)return f;const ne=V.getItemLabel(B);if(!ne)return f;const Y=V.getItemDescription(B),le=d(ne,Y,q,z),ue=j[le];if(ue)return ue;const K=s(ne,Y,V.getItemPath(B),z,q);return j[le]=K,K}e.scoreItemFuzzy=r;function s(B,z,q,V,j){const ne=!q||!V.containsPathSeparator;return q&&(D.isLinux?V.pathNormalized===q:(0,C.equalsIgnoreCase)(V.pathNormalized,q))?{score:a,labelMatch:[{start:0,end:B.length}],descriptionMatch:z?[{start:0,end:z.length}]:void 0}:V.values&&V.values.length>1?i(B,z,q,V.values,ne,j):t(B,z,q,V,ne,j)}function i(B,z,q,V,j,ne){let Y=0;const le=[],ue=[];for(const K of V){const{score:ge,labelMatch:ye,descriptionMatch:Te}=t(B,z,q,K,j,ne);if(ge===S)return f;Y+=ge,ye&&le.push(...ye),Te&&ue.push(...Te)}return{score:Y,labelMatch:l(le),descriptionMatch:l(ue)}}function t(B,z,q,V,j,ne){if(j||!z){const[Y,le]=L(B,V.normalized,V.normalizedLowercase,ne&&!V.expectContiguousMatch);if(Y){const ue=(0,n.matchesPrefix)(V.normalized,B);let K;return ue?(K=m,K+=Math.round(V.normalized.length/B.length*100)):K=o,{score:K+Y,labelMatch:ue||c(le)}}}if(z){let Y=z;q&&(Y=`${z}${A.sep}`);const le=Y.length,ue=`${Y}${B}`,[K,ge]=L(ue,V.normalized,V.normalizedLowercase,ne&&!V.expectContiguousMatch);if(K){const ye=c(ge),Te=[],pe=[];return ye.forEach(Pe=>{Pe.start<le&&Pe.end>le?(Te.push({start:0,end:Pe.end-le}),pe.push({start:Pe.start,end:le})):Pe.start>=le?Te.push({start:Pe.start-le,end:Pe.end-le}):pe.push(Pe)}),{score:K,labelMatch:Te,descriptionMatch:pe}}}return f}function c(B){const z=[];if(!B)return z;let q;for(const V of B)q&&q.end===V?q.end+=1:(q={start:V,end:V+1},z.push(q));return z}function l(B){const z=B.sort((j,ne)=>j.start-ne.start),q=[];let V;for(const j of z)!V||!h(V,j)?(V=j,q.push(j)):(V.start=Math.min(V.start,j.start),V.end=Math.max(V.end,j.end));return q}function h(B,z){return!(B.end<z.start||z.end<B.start)}function E(B,z,q,V,j,ne){const Y=r(B,q,V,j,ne),le=r(z,q,V,j,ne),ue=Y.score,K=le.score;if((ue===a||K===a)&&ue!==K)return ue===a?-1:1;if(ue>o||K>o){if(ue!==K)return ue>K?-1:1;if(ue<m&&K<m){const ve=N(Y.labelMatch,le.labelMatch);if(ve!==0)return ve}const Pe=j.getItemLabel(B)||"",fe=j.getItemLabel(z)||"";if(Pe.length!==fe.length)return Pe.length-fe.length}if(ue!==K)return ue>K?-1:1;const ge=Array.isArray(Y.labelMatch)&&Y.labelMatch.length>0,ye=Array.isArray(le.labelMatch)&&le.labelMatch.length>0;if(ge&&!ye)return-1;if(ye&&!ge)return 1;const Te=R(B,Y,j),pe=R(z,le,j);return Te&&pe&&Te!==pe?pe>Te?-1:1:O(B,z,q,j)}e.compareItemsByFuzzyScore=E;function R(B,z,q){let V=-1,j=-1;if(z.descriptionMatch&&z.descriptionMatch.length?V=z.descriptionMatch[0].start:z.labelMatch&&z.labelMatch.length&&(V=z.labelMatch[0].start),z.labelMatch&&z.labelMatch.length){if(j=z.labelMatch[z.labelMatch.length-1].end,z.descriptionMatch&&z.descriptionMatch.length){const ne=q.getItemDescription(B);ne&&(j+=ne.length)}}else z.descriptionMatch&&z.descriptionMatch.length&&(j=z.descriptionMatch[z.descriptionMatch.length-1].end);return j-V}function N(B,z){if(!B&&!z||(!B||!B.length)&&(!z||!z.length))return 0;if(!z||!z.length)return-1;if(!B||!B.length)return 1;const q=B[0].start,j=B[B.length-1].end-q,ne=z[0].start,le=z[z.length-1].end-ne;return j===le?0:le<j?1:-1}function O(B,z,q,V){const j=V.getItemLabel(B)||"",ne=V.getItemLabel(z)||"",Y=V.getItemDescription(B),le=V.getItemDescription(z),ue=j.length+(Y?Y.length:0),K=ne.length+(le?le.length:0);if(ue!==K)return ue-K;const ge=V.getItemPath(B),ye=V.getItemPath(z);return ge&&ye&&ge.length!==ye.length?ge.length-ye.length:j!==ne?(0,u.compareAnything)(j,ne,q.normalized):Y&&le&&Y!==le?(0,u.compareAnything)(Y,le,q.normalized):ge&&ye&&ge!==ye?(0,u.compareAnything)(ge,ye,q.normalized):0}function k(B){return B.startsWith('"')&&B.endsWith('"')}const U=" ";function F(B){typeof B!="string"&&(B="");const z=B.toLowerCase(),{pathNormalized:q,normalized:V,normalizedLowercase:j}=$(B),ne=q.indexOf(A.sep)>=0,Y=k(B);let le;const ue=B.split(U);if(ue.length>1)for(const K of ue){const ge=k(K),{pathNormalized:ye,normalized:Te,normalizedLowercase:pe}=$(K);Te&&(le||(le=[]),le.push({original:K,originalLowercase:K.toLowerCase(),pathNormalized:ye,normalized:Te,normalizedLowercase:pe,expectContiguousMatch:ge}))}return{original:B,originalLowercase:z,pathNormalized:q,normalized:V,normalizedLowercase:j,values:le,containsPathSeparator:ne,expectContiguousMatch:Y}}e.prepareQuery=F;function $(B){let z;D.isWindows?z=B.replace(/\//g,A.sep):z=B.replace(/\\/g,A.sep);const q=(0,C.stripWildcards)(z).replace(/\s|"/g,"");return{pathNormalized:z,normalized:q,normalizedLowercase:q.toLowerCase()}}function ee(B){return Array.isArray(B)?F(B.map(z=>z.original).join(U)):F(B.original)}e.pieceToQuery=ee}),define(Ie[36],ke([1,0,16,18,30,25,9,13,8]),function(Q,e,u,n,y,A,D,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const L="[/\\\\]",I="[^/\\\\]",_=/\//g;function T(q,V){switch(q){case 0:return"";case 1:return`${I}*?`;default:return`(?:${L}|${I}+${L}${V?`|${L}${I}+`:""})*?`}}function w(q,V){if(!q)return[];const j=[];let ne=!1,Y=!1,le="";for(const ue of q){switch(ue){case V:if(!ne&&!Y){j.push(le),le="";continue}break;case"{":ne=!0;break;case"}":ne=!1;break;case"[":Y=!0;break;case"]":Y=!1;break}le+=ue}return le&&j.push(le),j}e.splitGlobAware=w;function b(q){if(!q)return"";let V="";const j=w(q,e.GLOB_SPLIT);if(j.every(ne=>ne===e.GLOBSTAR))V=".*";else{let ne=!1;j.forEach((Y,le)=>{if(Y===e.GLOBSTAR){if(ne)return;V+=T(2,le===j.length-1)}else{let ue=!1,K="",ge=!1,ye="";for(const Te of Y){if(Te!=="}"&&ue){K+=Te;continue}if(ge&&(Te!=="]"||!ye)){let pe;Te==="-"?pe=Te:(Te==="^"||Te==="!")&&!ye?pe="^":Te===e.GLOB_SPLIT?pe="":pe=(0,S.escapeRegExpCharacters)(Te),ye+=pe;continue}switch(Te){case"{":ue=!0;continue;case"[":ge=!0;continue;case"}":{V+=`(?:${w(K,",").map(fe=>b(fe)).join("|")})`,ue=!1,K="";break}case"]":{V+="["+ye+"]",ge=!1,ye="";break}case"?":V+=I;continue;case"*":V+=T(1);continue;default:V+=(0,S.escapeRegExpCharacters)(Te)}}le<j.length-1&&(j[le+1]!==e.GLOBSTAR||le+2<j.length)&&(V+=L)}ne=Y===e.GLOBSTAR})}return V}const p=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,f=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,a=/^\*\*((\/[\w\.-]+)+)\/?$/,m=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,o=new A.LRUCache(1e4),d=function(){return!1},r=function(){return null};function s(q,V){if(!q)return r;let j;typeof q!="string"?j=q.pattern:j=q,j=j.trim();const ne=`${j}_${!!V.trimForExclusions}`;let Y=o.get(ne);if(Y)return i(Y,q);let le;return p.test(j)?Y=c(j.substr(4),j):(le=g.exec(t(j,V)))?Y=l(le[1],j):(V.trimForExclusions?f:v).test(j)?Y=h(j,V):(le=a.exec(t(j,V)))?Y=E(le[1].substr(1),j,!0):(le=m.exec(t(j,V)))?Y=E(le[1],j,!1):Y=R(j),o.set(ne,Y),i(Y,q)}function i(q,V){if(typeof V=="string")return q;const j=function(ne,Y){return(0,y.isEqualOrParent)(ne,V.base,!C.isLinux)?q(ne.substr(V.base.length+1),Y):null};return j.allBasenames=q.allBasenames,j.allPaths=q.allPaths,j.basenames=q.basenames,j.patterns=q.patterns,j}function t(q,V){return V.trimForExclusions&&q.endsWith("/**")?q.substr(0,q.length-2):q}function c(q,V){return function(j,ne){return typeof j=="string"&&j.endsWith(q)?V:null}}function l(q,V){const j=`/${q}`,ne=`\\${q}`,Y=function(ue,K){return typeof ue!="string"?null:K?K===q?V:null:ue===q||ue.endsWith(j)||ue.endsWith(ne)?V:null},le=[q];return Y.basenames=le,Y.patterns=[V],Y.allBasenames=le,Y}function h(q,V){const j=B(q.slice(1,-1).split(",").map(K=>s(K,V)).filter(K=>K!==r),q),ne=j.length;if(!ne)return r;if(ne===1)return j[0];const Y=function(K,ge){for(let ye=0,Te=j.length;ye<Te;ye++)if(j[ye](K,ge))return q;return null},le=j.find(K=>!!K.allBasenames);le&&(Y.allBasenames=le.allBasenames);const ue=j.reduce((K,ge)=>ge.allPaths?K.concat(ge.allPaths):K,[]);return ue.length&&(Y.allPaths=ue),Y}function E(q,V,j){const ne=D.sep===D.posix.sep,Y=ne?q:q.replace(_,D.sep),le=D.sep+Y,ue=D.posix.sep+q;let K;return j?K=function(ge,ye){return typeof ge=="string"&&(ge===Y||ge.endsWith(le)||!ne&&(ge===q||ge.endsWith(ue)))?V:null}:K=function(ge,ye){return typeof ge=="string"&&(ge===Y||!ne&&ge===q)?V:null},K.allPaths=[(j?"*/":"./")+q],K}function R(q){try{const V=new RegExp(`^${b(q)}$`);return function(j){return V.lastIndex=0,typeof j=="string"&&V.test(j)?q:null}}catch{return r}}function N(q,V,j){return!q||typeof V!="string"?!1:O(q)(V,void 0,j)}e.match=N;function O(q,V={}){if(!q)return d;if(typeof q=="string"||k(q)){const j=s(q,V);if(j===r)return d;const ne=function(Y,le){return!!j(Y,le)};return j.allBasenames&&(ne.allBasenames=j.allBasenames),j.allPaths&&(ne.allPaths=j.allPaths),ne}return $(q,V)}e.parse=O;function k(q){const V=q;return V?typeof V.base=="string"&&typeof V.pattern=="string":!1}e.isRelativePattern=k;function U(q){return q.allBasenames||[]}e.getBasenameTerms=U;function F(q){return q.allPaths||[]}e.getPathTerms=F;function $(q,V){const j=B(Object.getOwnPropertyNames(q).map(K=>ee(K,q[K],V)).filter(K=>K!==r)),ne=j.length;if(!ne)return r;if(!j.some(K=>!!K.requiresSiblings)){if(ne===1)return j[0];const K=function(Te,pe){let Pe;for(let fe=0,ve=j.length;fe<ve;fe++){const _e=j[fe](Te,pe);if(typeof _e=="string")return _e;(0,n.isThenable)(_e)&&(Pe||(Pe=[]),Pe.push(_e))}return Pe?(async()=>{for(const fe of Pe){const ve=await fe;if(typeof ve=="string")return ve}return null})():null},ge=j.find(Te=>!!Te.allBasenames);ge&&(K.allBasenames=ge.allBasenames);const ye=j.reduce((Te,pe)=>pe.allPaths?Te.concat(pe.allPaths):Te,[]);return ye.length&&(K.allPaths=ye),K}const Y=function(K,ge,ye){let Te,pe;for(let Pe=0,fe=j.length;Pe<fe;Pe++){const ve=j[Pe];ve.requiresSiblings&&ye&&(ge||(ge=(0,D.basename)(K)),Te||(Te=ge.substr(0,ge.length-(0,D.extname)(K).length)));const _e=ve(K,ge,Te,ye);if(typeof _e=="string")return _e;(0,n.isThenable)(_e)&&(pe||(pe=[]),pe.push(_e))}return pe?(async()=>{for(const Pe of pe){const fe=await Pe;if(typeof fe=="string")return fe}return null})():null},le=j.find(K=>!!K.allBasenames);le&&(Y.allBasenames=le.allBasenames);const ue=j.reduce((K,ge)=>ge.allPaths?K.concat(ge.allPaths):K,[]);return ue.length&&(Y.allPaths=ue),Y}function ee(q,V,j){if(V===!1)return r;const ne=s(q,j);if(ne===r)return r;if(typeof V=="boolean")return ne;if(V){const Y=V.when;if(typeof Y=="string"){const le=(ue,K,ge,ye)=>{if(!ye||!ne(ue,K))return null;const Te=Y.replace("$(basename)",ge),pe=ye(Te);return(0,n.isThenable)(pe)?pe.then(Pe=>Pe?q:null):pe?q:null};return le.requiresSiblings=!0,le}}return ne}function B(q,V){const j=q.filter(K=>!!K.basenames);if(j.length<2)return q;const ne=j.reduce((K,ge)=>{const ye=ge.basenames;return ye?K.concat(ye):K},[]);let Y;if(V){Y=[];for(let K=0,ge=ne.length;K<ge;K++)Y.push(V)}else Y=j.reduce((K,ge)=>{const ye=ge.patterns;return ye?K.concat(ye):K},[]);const le=function(K,ge){if(typeof K!="string")return null;if(!ge){let Te;for(Te=K.length;Te>0;Te--){const pe=K.charCodeAt(Te-1);if(pe===47||pe===92)break}ge=K.substr(Te)}const ye=ne.indexOf(ge);return ye!==-1?Y[ye]:null};le.basenames=ne,le.patterns=Y,le.allBasenames=ne;const ue=q.filter(K=>!K.basenames);return ue.push(le),ue}function z(q,V){return(0,u.equals)(q,V,(j,ne)=>typeof j=="string"&&typeof ne=="string"?j===ne:typeof j!="string"&&typeof ne!="string"?j.base===ne.base&&j.pattern===ne.pattern:!1)}e.patternsEquals=z}),define(Ie[106],ke([1,0,12,157,22,8,2]),function(Q,e,u,n,y,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var C;(function(p){p[p.Paragraph=0]="Paragraph",p[p.Break=1]="Break"})(C=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class S{constructor(g="",v=!1){if(this.value=g,typeof this.value!="string")throw(0,u.illegalArgument)("value");typeof v=="boolean"?(this.isTrusted=v,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=v.isTrusted??void 0,this.supportThemeIcons=v.supportThemeIcons??!1,this.supportHtml=v.supportHtml??!1)}appendText(g,v=0){return this.value+=_(this.supportThemeIcons?(0,n.escapeIcons)(g):g).replace(/([ \t]+)/g,(f,a)=>"&nbsp;".repeat(a.length)).replace(/\>/gm,"\\>").replace(/\n/g,v===1?`\\
`:`

`),this}appendMarkdown(g){return this.value+=g,this}appendCodeblock(g,v){return this.value+="\n```",this.value+=g,this.value+=`
`,this.value+=v,this.value+="\n```\n",this}appendLink(g,v,f){return this.value+="[",this.value+=this._escape(v,"]"),this.value+="](",this.value+=this._escape(String(g),")"),f&&(this.value+=` "${this._escape(this._escape(f,'"'),")")}"`),this.value+=")",this}_escape(g,v){const f=new RegExp((0,A.escapeRegExpCharacters)(v),"g");return g.replace(f,(a,m)=>g.charAt(m-1)!=="\\"?`\\${a}`:a)}}e.MarkdownString=S;function P(p){return L(p)?!p.value:Array.isArray(p)?p.every(P):!0}e.isEmptyMarkdownString=P;function L(p){return p instanceof S?!0:p&&typeof p=="object"?typeof p.value=="string"&&(typeof p.isTrusted=="boolean"||p.isTrusted===void 0)&&(typeof p.supportThemeIcons=="boolean"||p.supportThemeIcons===void 0):!1}e.isMarkdownString=L;function I(p,g){return p===g?!0:!p||!g?!1:p.value===g.value&&p.isTrusted===g.isTrusted&&p.supportThemeIcons===g.supportThemeIcons&&p.supportHtml===g.supportHtml&&(p.baseUri===g.baseUri||!!p.baseUri&&!!g.baseUri&&(0,y.isEqual)(D.URI.from(p.baseUri),D.URI.from(g.baseUri)))}e.markdownStringEqual=I;function _(p){return p.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=_;function T(p){return p.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=T;function w(p){return p&&p.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=w;function b(p){const g=[],v=p.split("|").map(a=>a.trim());p=v[0];const f=v[1];if(f){const a=/height=(\d+)/.exec(f),m=/width=(\d+)/.exec(f),o=a?a[1]:"",d=m?m[1]:"",r=isFinite(parseInt(d)),s=isFinite(parseInt(o));r&&g.push(`width="${d}"`),s&&g.push(`height="${o}"`)}return{href:p,dimensions:g}}e.parseHrefAndDimensions=b}),define(Ie[107],ke([1,0,16,30,9,13,22,8]),function(Q,e,u,n,y,A,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function S(r,s){const{os:i,tildify:t,relative:c}=s;if(c){const E=P(r,c,i);if(typeof E=="string")return E}let l=r.fsPath;if(i===1&&!A.isWindows?l=l.replace(/\//g,"\\"):i!==1&&A.isWindows&&(l=l.replace(/\\/g,"/")),i!==1&&t?.userHome){const E=t.userHome.fsPath;let R;r.scheme!==t.userHome.scheme&&r.path.startsWith(y.posix.sep)?R=t.userHome.with({path:r.path}).fsPath:R=r.fsPath,l=_(R,E,i)}return(i===1?y.win32:y.posix).normalize(L(l,i===1))}e.getPathLabel=S;function P(r,s,i){const t=i===1?y.win32:y.posix,c=i===3?D.extUri:D.extUriIgnorePathCase,l=s.getWorkspace(),h=(0,u.firstOrDefault)(l.folders);if(!h)return;r.scheme!==h.uri.scheme&&r.path.startsWith(y.posix.sep)&&(r=h.uri.with({path:r.path}));const E=s.getWorkspaceFolder(r);if(!E)return;let R;if(c.isEqual(E.uri,r)?R="":R=c.relativePath(E.uri,r)??"",R&&(R=t.normalize(R)),l.folders.length>1&&!s.noPrefix){const N=E.name?E.name:c.basenameOrAuthority(E.uri);R=R?`${N} \u2022 ${R}`:N}return R}function L(r,s=A.isWindows){return(0,n.hasDriveLetter)(r,s)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=L;let I=Object.create(null);function _(r,s,i=A.OS){if(i===1||!r||!s)return r;let t=I.original===s?I.normalized:void 0;t||(t=s,A.isWindows&&(t=(0,n.toSlashes)(t)),t=`${(0,C.rtrim)(t,y.posix.sep)}${y.posix.sep}`,I={original:s,normalized:t});let c=r;return A.isWindows&&(c=(0,n.toSlashes)(c)),(i===3?c.startsWith(t):(0,C.startsWithIgnoreCase)(c,t))?`~/${c.substr(t.length)}`:r}e.tildify=_;function T(r,s){return r.replace(/^~($|\/|\\)/,`${s}$1`)}e.untildify=T;const w="\u2026",b="\\\\",p="~";function g(r,s=y.sep){const i=new Array(r.length);let t=!1;for(let c=0;c<r.length;c++){const l=r[c];if(l===""){i[c]=`.${s}`;continue}if(!l){i[c]=l;continue}t=!0;let h="",E=l;E.indexOf(b)===0?(h=E.substr(0,E.indexOf(b)+b.length),E=E.substr(E.indexOf(b)+b.length)):E.indexOf(s)===0?(h=E.substr(0,E.indexOf(s)+s.length),E=E.substr(E.indexOf(s)+s.length)):E.indexOf(p)===0&&(h=E.substr(0,E.indexOf(p)+p.length),E=E.substr(E.indexOf(p)+p.length));const R=E.split(s);for(let N=1;t&&N<=R.length;N++)for(let O=R.length-N;t&&O>=0;O--){t=!1;let k=R.slice(O,O+N).join(s);for(let U=0;!t&&U<r.length;U++)if(U!==c&&r[U]&&r[U].indexOf(k)>-1){const F=O+N===R.length,$=O>0&&r[U].indexOf(s)>-1?s+k:k,ee=r[U].endsWith($);t=!F||ee}if(!t){let U="";(R[0].endsWith(":")||h!=="")&&(O===1&&(O=0,N++,k=R[0]+s+k),O>0&&(U=R[0]+s),U=h+U),O>0&&(U=U+w+s),U=U+k,O+N<R.length&&(U=U+s+w),i[c]=U}}t&&(i[c]=l)}return i}e.shorten=g;var v;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(v||(v={}));function f(r,s=Object.create(null)){const i=[];let t=!1,c="";for(const l of r)if(l==="$"||t&&l==="{")c&&i.push({value:c,type:v.TEXT}),c="",t=!0;else if(l==="}"&&t){const h=s[c];if(typeof h=="string")h.length&&i.push({value:h,type:v.VARIABLE});else if(h){const E=i[i.length-1];(!E||E.type!==v.SEPARATOR)&&i.push({value:h.label,type:v.SEPARATOR})}c="",t=!1}else c+=l;return c&&!t&&i.push({value:c,type:v.TEXT}),i.filter((l,h)=>{if(l.type===v.SEPARATOR){const E=i[h-1],R=i[h+1];return[E,R].every(N=>N&&(N.type===v.VARIABLE||N.type===v.TEXT)&&N.value.length>0)}return!0}).map(l=>l.value).join("")}e.template=f;function a(r,s){return A.isMacintosh||s?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.isMacintosh?"&":"&&"):r.replace(/&&|&/g,i=>i==="&"?"&&":"&")}e.mnemonicMenuLabel=a;function m(r,s){return A.isMacintosh||s?r.replace(/\(&&\w\)|&&/g,""):A.isWindows?r.replace(/&&|&/g,i=>i==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=m;function o(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=o;function d(r){const s=r.indexOf("/")!==-1?y.posix:y.win32,i=s.basename(r),t=s.dirname(r);return i.length?{name:i,parentPath:t}:{name:t,parentPath:""}}e.splitName=d}),define(Ie[108],ke([1,0,2]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function n(L){return L.toJSON()}class y{constructor(I){this._uriTransformer=I}transformIncoming(I){const _=this._uriTransformer.transformIncoming(I);return _===I?I:n(u.URI.from(_))}transformOutgoing(I){const _=this._uriTransformer.transformOutgoing(I);return _===I?I:n(u.URI.from(_))}transformOutgoingURI(I){const _=this._uriTransformer.transformOutgoing(I);return _===I?I:u.URI.from(_)}transformOutgoingScheme(I){return this._uriTransformer.transformOutgoingScheme(I)}}e.URITransformer=y,e.DefaultURITransformer=new class{transformIncoming(L){return L}transformOutgoing(L){return L}transformOutgoingURI(L){return L}transformOutgoingScheme(L){return L}};function A(L,I,_){if(!L||_>200)return null;if(typeof L=="object"){if(L instanceof u.URI)return I.transformOutgoing(L);for(const T in L)if(Object.hasOwnProperty.call(L,T)){const w=A(L[T],I,_+1);w!==null&&(L[T]=w)}}return null}function D(L,I){const _=A(L,I,0);return _===null?L:_}e.transformOutgoingURIs=D;function C(L,I,_,T){if(!L||T>200)return null;if(typeof L=="object"){if(L.$mid===1)return _?u.URI.revive(I.transformIncoming(L)):I.transformIncoming(L);for(const w in L)if(Object.hasOwnProperty.call(L,w)){const b=C(L[w],I,_,T+1);b!==null&&(L[w]=b)}}return null}function S(L,I){const _=C(L,I,!1,0);return _===null?L:_}e.transformIncomingURIs=S;function P(L,I){const _=C(L,I,!0,0);return _===null?L:_}e.transformAndReviveIncomingURIs=P}),define(Ie[29],ke([1,0,62,63,302,18,30,81,9,13,22,2]),function(Q,e,u,n,y,A,D,C,S,P,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var _;(function(F){F[F.UNLINK=0]="UNLINK",F[F.MOVE=1]="MOVE"})(_=e.RimRafMode||(e.RimRafMode={}));async function T(F,$=_.UNLINK){if((0,D.isRootOrDriveLetter)(F))throw new Error("rimraf - will refuse to recursively delete root");return $===_.UNLINK?b(F):w(F)}async function w(F){try{const $=(0,D.randomPath)((0,n.tmpdir)());try{await u.promises.rename(F,$)}catch{return b(F)}b($).catch(ee=>{})}catch($){if($.code!=="ENOENT")throw $}}async function b(F){return(0,y.promisify)(u.rm)(F,{recursive:!0,force:!0,maxRetries:3})}function p(F){if((0,D.isRootOrDriveLetter)(F))throw new Error("rimraf - will refuse to recursively delete root");u.rmSync(F,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=p;async function g(F,$){return a(await($?v(F):(0,y.promisify)(u.readdir)(F)))}async function v(F){try{return await(0,y.promisify)(u.readdir)(F,{withFileTypes:!0})}catch(B){console.warn("[node.js fs] readdir with filetypes failed with error: ",B)}const $=[],ee=await g(F);for(const B of ee){let z=!1,q=!1,V=!1;try{const j=await e.Promises.lstat((0,S.join)(F,B));z=j.isFile(),q=j.isDirectory(),V=j.isSymbolicLink()}catch(j){console.warn("[node.js fs] unexpected error from lstat after readdir: ",j)}$.push({name:B,isFile:()=>z,isDirectory:()=>q,isSymbolicLink:()=>V})}return $}function f(F){return a(u.readdirSync(F))}e.readdirSync=f;function a(F){return F.map($=>typeof $=="string"?P.isMacintosh?(0,C.normalizeNFC)($):$:($.name=P.isMacintosh?(0,C.normalizeNFC)($.name):$.name,$))}async function m(F){const $=await g(F),ee=[];for(const B of $)await d.existsDirectory((0,S.join)(F,B))&&ee.push(B);return ee}function o(F,$=1e3){return new Promise(ee=>{let B=!1;const z=setInterval(()=>{B||(B=!0,u.access(F,q=>{B=!1,q&&(clearInterval(z),ee(void 0))}))},$)})}e.whenDeleted=o;var d;(function(F){async function $(z){let q;try{if(q=await e.Promises.lstat(z),!q.isSymbolicLink())return{stat:q}}catch{}try{return{stat:await e.Promises.stat(z),symbolicLink:q?.isSymbolicLink()?{dangling:!1}:void 0}}catch(V){if(V.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};if(P.isWindows&&V.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(z)),symbolicLink:{dangling:!1}}}catch(j){if(j.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};throw j}throw V}}F.stat=$;async function ee(z){try{const{stat:q,symbolicLink:V}=await F.stat(z);return q.isFile()&&V?.dangling!==!0}catch{}return!1}F.existsFile=ee;async function B(z){try{const{stat:q,symbolicLink:V}=await F.stat(z);return q.isDirectory()&&V?.dangling!==!0}catch{}return!1}F.existsDirectory=B})(d=e.SymlinkSupport||(e.SymlinkSupport={}));const r=new A.ResourceQueue;function s(F,$,ee){return r.queueFor(I.URI.file(F),L.extUriBiasedIgnorePathCase).queue(()=>{const B=l(ee);return new Promise((z,q)=>t(F,$,B,V=>V?q(V):z()))})}let i=!0;function t(F,$,ee,B){if(!i)return u.writeFile(F,$,{mode:ee.mode,flag:ee.flag},B);u.open(F,ee.flag,ee.mode,(z,q)=>{if(z)return B(z);u.writeFile(q,$,V=>{if(V)return u.close(q,()=>B(V));u.fdatasync(q,j=>(j&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",j),i=!1),u.close(q,ne=>B(ne))))})})}function c(F,$,ee){const B=l(ee);if(!i)return u.writeFileSync(F,$,{mode:B.mode,flag:B.flag});const z=u.openSync(F,B.flag,B.mode);try{u.writeFileSync(z,$);try{u.fdatasyncSync(z)}catch(q){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",q),i=!1}}finally{u.closeSync(z)}}e.writeFileSync=c;function l(F){return F?{mode:typeof F.mode=="number"?F.mode:438,flag:typeof F.flag=="string"?F.flag:"w"}:{mode:438,flag:"w"}}async function h(F,$){if(F!==$)try{await e.Promises.rename(F,$)}catch(ee){if(F.toLowerCase()!==$.toLowerCase()&&ee.code==="EXDEV"||F.endsWith("."))await E(F,$,{preserveSymlinks:!1}),await T(F,_.MOVE);else throw ee}}async function E(F,$,ee){return N(F,$,{root:{source:F,target:$},options:ee,handledSourcePaths:new Set})}const R=511;async function N(F,$,ee){if(ee.handledSourcePaths.has(F))return;ee.handledSourcePaths.add(F);const{stat:B,symbolicLink:z}=await d.stat(F);if(z){if(ee.options.preserveSymlinks)try{return await U(F,$,ee)}catch(q){console.warn("[node.js fs] copy of symlink failed: ",q)}if(z.dangling)return}return B.isDirectory()?O(F,$,B.mode&R,ee):k(F,$,B.mode&R)}async function O(F,$,ee,B){await e.Promises.mkdir($,{recursive:!0,mode:ee});const z=await g(F);for(const q of z)await N((0,S.join)(F,q),(0,S.join)($,q),B)}async function k(F,$,ee){await e.Promises.copyFile(F,$),await e.Promises.chmod($,ee)}async function U(F,$,ee){let B=await e.Promises.readlink(F);(0,D.isEqualOrParent)(B,ee.root.source,!P.isLinux)&&(B=(0,S.join)(ee.root.target,B.substr(ee.root.source.length+1))),await e.Promises.symlink(B,$)}e.Promises=new class{get access(){return(0,y.promisify)(u.access)}get stat(){return(0,y.promisify)(u.stat)}get lstat(){return(0,y.promisify)(u.lstat)}get utimes(){return(0,y.promisify)(u.utimes)}get read(){return(F,$,ee,B,z)=>new Promise((q,V)=>{u.read(F,$,ee,B,z,(j,ne,Y)=>j?V(j):q({bytesRead:ne,buffer:Y}))})}get readFile(){return(0,y.promisify)(u.readFile)}get write(){return(F,$,ee,B,z)=>new Promise((q,V)=>{u.write(F,$,ee,B,z,(j,ne,Y)=>j?V(j):q({bytesWritten:ne,buffer:Y}))})}get appendFile(){return(0,y.promisify)(u.appendFile)}get fdatasync(){return(0,y.promisify)(u.fdatasync)}get truncate(){return(0,y.promisify)(u.truncate)}get rename(){return(0,y.promisify)(u.rename)}get copyFile(){return(0,y.promisify)(u.copyFile)}get open(){return(0,y.promisify)(u.open)}get close(){return(0,y.promisify)(u.close)}get symlink(){return(0,y.promisify)(u.symlink)}get readlink(){return(0,y.promisify)(u.readlink)}get chmod(){return(0,y.promisify)(u.chmod)}get mkdir(){return(0,y.promisify)(u.mkdir)}get unlink(){return(0,y.promisify)(u.unlink)}get rmdir(){return(0,y.promisify)(u.rmdir)}get realpath(){return(0,y.promisify)(u.realpath)}async exists(F){try{return await e.Promises.access(F),!0}catch{return!1}}get readdir(){return g}get readDirsInDir(){return m}get writeFile(){return s}get rm(){return T}get move(){return h}get copy(){return E}}}),define(Ie[109],ke([1,0,62,9,13,8,29]),function(Q,e,u,n,y,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function C(_){if(y.isLinux)return _;const T=(0,n.dirname)(_);if(_===T)return _;const w=((0,n.basename)(_)||_).toLowerCase();try{const p=(0,D.readdirSync)(T).filter(g=>g.toLowerCase()===w);if(p.length===1){const g=C(T);if(g)return(0,n.join)(g,p[0])}else if(p.length>1){const g=p.indexOf(w);if(g>=0){const v=C(T);if(v)return(0,n.join)(v,p[g])}}}catch{}return null}e.realcaseSync=C;async function S(_){if(y.isLinux)return _;const T=(0,n.dirname)(_);if(_===T)return _;const w=((0,n.basename)(_)||_).toLowerCase();try{const p=(await D.Promises.readdir(T)).filter(g=>g.toLowerCase()===w);if(p.length===1){const g=await S(T);if(g)return(0,n.join)(g,p[0])}else if(p.length>1){const g=p.indexOf(w);if(g>=0){const v=await S(T);if(v)return(0,n.join)(v,p[g])}}}catch{}return null}e.realcase=S;async function P(_){try{return await D.Promises.realpath(_)}catch{const w=I(_);return await D.Promises.access(w,u.constants.R_OK),w}}e.realpath=P;function L(_){try{return u.realpathSync(_)}catch{const w=I(_);return u.accessSync(w,u.constants.R_OK),w}}e.realpathSync=L;function I(_){return(0,A.rtrim)((0,n.normalize)(_),n.sep)}});var Ge=this&&this.__decorate||function(Q,e,u,n){var y=arguments.length,A=y<3?e:n===null?n=Object.getOwnPropertyDescriptor(e,u):n,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(Q,e,u,n);else for(var C=Q.length-1;C>=0;C--)(D=Q[C])&&(A=(y<3?D(A):y>3?D(e,u,A):D(e,u))||A);return y>3&&A&&Object.defineProperty(e,u,A),A};define(Ie[110],ke([1,0,16,18,23,21,57,12,3,6,61,8,10]),function(Q,e,u,n,y,A,D,C,S,P,L,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var T;(function(q){q[q.Promise=100]="Promise",q[q.PromiseCancel=101]="PromiseCancel",q[q.EventListen=102]="EventListen",q[q.EventDispose=103]="EventDispose"})(T=e.RequestType||(e.RequestType={}));function w(q){switch(q){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var b;(function(q){q[q.Initialize=200]="Initialize",q[q.PromiseSuccess=201]="PromiseSuccess",q[q.PromiseError=202]="PromiseError",q[q.PromiseErrorObj=203]="PromiseErrorObj",q[q.EventFire=204]="EventFire"})(b=e.ResponseType||(e.ResponseType={}));function p(q){switch(q){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var g;(function(q){q[q.Uninitialized=0]="Uninitialized",q[q.Idle=1]="Idle"})(g||(g={}));class v{constructor(V){this.buffer=V,this.pos=0}read(V){const j=this.buffer.slice(this.pos,this.pos+V);return this.pos+=j.byteLength,j}}class f{constructor(){this.buffers=[]}get buffer(){return y.VSBuffer.concat(this.buffers)}write(V){this.buffers.push(V)}}var a;(function(q){q[q.Undefined=0]="Undefined",q[q.String=1]="String",q[q.Buffer=2]="Buffer",q[q.VSBuffer=3]="VSBuffer",q[q.Array=4]="Array",q[q.Object=5]="Object"})(a||(a={}));function m(q){const V=y.VSBuffer.alloc(4);return V.writeUInt32BE(q,0),V}function o(q){return q.read(4).readUInt32BE(0)}function d(q){const V=y.VSBuffer.alloc(1);return V.writeUInt8(q,0),V}const r={Undefined:d(a.Undefined),String:d(a.String),Buffer:d(a.Buffer),VSBuffer:d(a.VSBuffer),Array:d(a.Array),Object:d(a.Object)},s=typeof Buffer!="undefined";function i(q,V){if(typeof V=="undefined")q.write(r.Undefined);else if(typeof V=="string"){const j=y.VSBuffer.fromString(V);q.write(r.String),q.write(m(j.byteLength)),q.write(j)}else if(s&&Buffer.isBuffer(V)){const j=y.VSBuffer.wrap(V);q.write(r.Buffer),q.write(m(j.byteLength)),q.write(j)}else if(V instanceof y.VSBuffer)q.write(r.VSBuffer),q.write(m(V.byteLength)),q.write(V);else if(Array.isArray(V)){q.write(r.Array),q.write(m(V.length));for(const j of V)i(q,j)}else{const j=y.VSBuffer.fromString(JSON.stringify(V));q.write(r.Object),q.write(m(j.byteLength)),q.write(j)}}function t(q){switch(q.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return q.read(o(q)).toString();case a.Buffer:return q.read(o(q)).buffer;case a.VSBuffer:return q.read(o(q));case a.Array:{const j=o(q),ne=[];for(let Y=0;Y<j;Y++)ne.push(t(q));return ne}case a.Object:return JSON.parse(q.read(o(q)).toString())}}class c{constructor(V,j,ne=null,Y=1e3){this.protocol=V,this.ctx=j,this.logger=ne,this.timeoutDelay=Y,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(le=>this.onRawMessage(le)),this.sendResponse({type:200})}registerChannel(V,j){this.channels.set(V,j),setTimeout(()=>this.flushPendingRequests(V),0)}sendResponse(V){switch(V.type){case 200:{const j=this.send([V.type]);this.logger?.logOutgoing(j,0,1,p(V.type));return}case 201:case 202:case 204:case 203:{const j=this.send([V.type,V.id],V.data);this.logger?.logOutgoing(j,V.id,1,p(V.type),V.data);return}}}send(V,j=void 0){const ne=new f;return i(ne,V),i(ne,j),this.sendBuffer(ne.buffer)}sendBuffer(V){try{return this.protocol.send(V),V.byteLength}catch{return 0}}onRawMessage(V){const j=new v(V),ne=t(j),Y=t(j),le=ne[0];switch(le){case 100:return this.logger?.logIncoming(V.byteLength,ne[1],1,`${w(le)}: ${ne[2]}.${ne[3]}`,Y),this.onPromise({type:le,id:ne[1],channelName:ne[2],name:ne[3],arg:Y});case 102:return this.logger?.logIncoming(V.byteLength,ne[1],1,`${w(le)}: ${ne[2]}.${ne[3]}`,Y),this.onEventListen({type:le,id:ne[1],channelName:ne[2],name:ne[3],arg:Y});case 101:return this.logger?.logIncoming(V.byteLength,ne[1],1,`${w(le)}`),this.disposeActiveRequest({type:le,id:ne[1]});case 103:return this.logger?.logIncoming(V.byteLength,ne[1],1,`${w(le)}`),this.disposeActiveRequest({type:le,id:ne[1]})}}onPromise(V){const j=this.channels.get(V.channelName);if(!j){this.collectPendingRequest(V);return}const ne=new A.CancellationTokenSource;let Y;try{Y=j.call(this.ctx,V.name,V.arg,ne.token)}catch(K){Y=Promise.reject(K)}const le=V.id;Y.then(K=>{this.sendResponse({id:le,data:K,type:201}),this.activeRequests.delete(V.id)},K=>{K instanceof Error?this.sendResponse({id:le,data:{message:K.message,name:K.name,stack:K.stack?K.stack.split?K.stack.split(`
`):K.stack:void 0},type:202}):this.sendResponse({id:le,data:K,type:203}),this.activeRequests.delete(V.id)});const ue=(0,P.toDisposable)(()=>ne.cancel());this.activeRequests.set(V.id,ue)}onEventListen(V){const j=this.channels.get(V.channelName);if(!j){this.collectPendingRequest(V);return}const ne=V.id,le=j.listen(this.ctx,V.name,V.arg)(ue=>this.sendResponse({id:ne,data:ue,type:204}));this.activeRequests.set(V.id,le)}disposeActiveRequest(V){const j=this.activeRequests.get(V.id);j&&(j.dispose(),this.activeRequests.delete(V.id))}collectPendingRequest(V){let j=this.pendingRequests.get(V.channelName);j||(j=[],this.pendingRequests.set(V.channelName,j));const ne=setTimeout(()=>{console.error(`Unknown channel: ${V.channelName}`),V.type===100&&this.sendResponse({id:V.id,data:{name:"Unknown channel",message:`Channel name '${V.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);j.push({request:V,timeoutTimer:ne})}flushPendingRequests(V){const j=this.pendingRequests.get(V);if(j){for(const ne of j)switch(clearTimeout(ne.timeoutTimer),ne.request.type){case 100:this.onPromise(ne.request);break;case 102:this.onEventListen(ne.request);break}this.pendingRequests.delete(V)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,P.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=c;var l;(function(q){q[q.LocalSide=0]="LocalSide",q[q.OtherSide=1]="OtherSide"})(l=e.RequestInitiator||(e.RequestInitiator={}));class h{constructor(V,j=null){this.protocol=V,this.isDisposed=!1,this.state=g.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new S.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(ne=>this.onBuffer(ne)),this.logger=j}getChannel(V){const j=this;return{call(ne,Y,le){return j.isDisposed?Promise.reject(C.canceled()):j.requestPromise(V,ne,Y,le)},listen(ne,Y){return j.isDisposed?S.Event.None:j.requestEvent(V,ne,Y)}}}requestPromise(V,j,ne,Y=A.CancellationToken.None){const le=this.lastRequestId++,K={id:le,type:100,channelName:V,name:j,arg:ne};if(Y.isCancellationRequested)return Promise.reject(C.canceled());let ge;return new Promise((Te,pe)=>{if(Y.isCancellationRequested)return pe(C.canceled());const Pe=()=>{const ae=he=>{switch(he.type){case 201:this.handlers.delete(le),Te(he.data);break;case 202:{this.handlers.delete(le);const te=new Error(he.data.message);te.stack=he.data.stack,te.name=he.data.name,pe(te);break}case 203:this.handlers.delete(le),pe(he.data);break}};this.handlers.set(le,ae),this.sendRequest(K)};let fe=null;this.state===g.Idle?Pe():(fe=(0,n.createCancelablePromise)(ae=>this.whenInitialized()),fe.then(()=>{fe=null,Pe()}));const ve=()=>{fe?(fe.cancel(),fe=null):this.sendRequest({id:le,type:101}),pe(C.canceled())},_e=Y.onCancellationRequested(ve);ge=(0,P.combinedDisposable)((0,P.toDisposable)(ve),_e),this.activeRequests.add(ge)}).finally(()=>{this.activeRequests.delete(ge)})}requestEvent(V,j,ne){const Y=this.lastRequestId++,ue={id:Y,type:102,channelName:V,name:j,arg:ne};let K=null;const ge=new S.Emitter({onFirstListenerAdd:()=>{K=(0,n.createCancelablePromise)(Te=>this.whenInitialized()),K.then(()=>{K=null,this.activeRequests.add(ge),this.sendRequest(ue)})},onLastListenerRemove:()=>{K?(K.cancel(),K=null):(this.activeRequests.delete(ge),this.sendRequest({id:Y,type:103}))}}),ye=Te=>ge.fire(Te.data);return this.handlers.set(Y,ye),ge.event}sendRequest(V){switch(V.type){case 100:case 102:{const j=this.send([V.type,V.id,V.channelName,V.name],V.arg);this.logger?.logOutgoing(j,V.id,0,`${w(V.type)}: ${V.channelName}.${V.name}`,V.arg);return}case 101:case 103:{const j=this.send([V.type,V.id]);this.logger?.logOutgoing(j,V.id,0,w(V.type));return}}}send(V,j=void 0){const ne=new f;return i(ne,V),i(ne,j),this.sendBuffer(ne.buffer)}sendBuffer(V){try{return this.protocol.send(V),V.byteLength}catch{return 0}}onBuffer(V){const j=new v(V),ne=t(j),Y=t(j),le=ne[0];switch(le){case 200:return this.logger?.logIncoming(V.byteLength,0,0,p(le)),this.onResponse({type:ne[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(V.byteLength,ne[1],0,p(le),Y),this.onResponse({type:ne[0],id:ne[1],data:Y})}}onResponse(V){if(V.type===200){this.state=g.Idle,this._onDidInitialize.fire();return}this.handlers.get(V.id)?.(V)}get onDidInitializePromise(){return S.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===g.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,P.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}Ge([D.memoize],h.prototype,"onDidInitializePromise",null),e.ChannelClient=h;class E{constructor(V){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new S.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new S.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,V(({protocol:j,onDidClientDisconnect:ne})=>{S.Event.once(j.onMessage)(le=>{const ue=new v(le),K=t(ue),ge=new c(j,K),ye=new h(j);this.channels.forEach((pe,Pe)=>ge.registerChannel(Pe,pe));const Te={channelServer:ge,channelClient:ye,ctx:K};this._connections.add(Te),this._onDidAddConnection.fire(Te),ne(()=>{ge.dispose(),ye.dispose(),this._connections.delete(Te),this._onDidRemoveConnection.fire(Te)})})})}get connections(){const V=[];return this._connections.forEach(j=>V.push(j)),V}getChannel(V,j){const ne=this;return{call(Y,le,ue){let K;if((0,_.isFunction)(j)){const ye=(0,u.getRandomElement)(ne.connections.filter(j));K=ye?Promise.resolve(ye):S.Event.toPromise(S.Event.filter(ne.onDidAddConnection,j))}else K=j.routeCall(ne,Y,le);const ge=K.then(ye=>ye.channelClient.getChannel(V));return N(ge).call(Y,le,ue)},listen(Y,le){if((0,_.isFunction)(j))return ne.getMulticastEvent(V,j,Y,le);const ue=j.routeEvent(ne,Y,le).then(K=>K.channelClient.getChannel(V));return N(ue).listen(Y,le)}}}getMulticastEvent(V,j,ne,Y){const le=this;let ue=new P.DisposableStore;const K=new S.Emitter({onFirstListenerAdd:()=>{ue=new P.DisposableStore;const ge=new S.EventMultiplexer,ye=new Map,Te=Pe=>{const ve=Pe.channelClient.getChannel(V).listen(ne,Y),_e=ge.add(ve);ye.set(Pe,_e)},pe=Pe=>{const fe=ye.get(Pe);!fe||(fe.dispose(),ye.delete(Pe))};le.connections.filter(j).forEach(Te),S.Event.filter(le.onDidAddConnection,j)(Te,void 0,ue),le.onDidRemoveConnection(pe,void 0,ue),ge.event(K.fire,K,ue),ue.add(ge)},onLastListenerRemove:()=>{ue.dispose()}});return K.event}registerChannel(V,j){this.channels.set(V,j),this._connections.forEach(ne=>{ne.channelServer.registerChannel(V,j)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=E;class R{constructor(V,j,ne=null){const Y=new f;i(Y,j),V.send(Y.buffer),this.channelClient=new h(V,ne),this.channelServer=new c(V,j,ne)}getChannel(V){return this.channelClient.getChannel(V)}registerChannel(V,j){this.channelServer.registerChannel(V,j)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=R;function N(q){return{call(V,j,ne){return q.then(Y=>Y.call(V,j,ne))},listen(V,j){const ne=new S.Relay;return q.then(Y=>ne.input=Y.listen(V,j)),ne.event}}}e.getDelayedChannel=N;function O(q){let V=!1;return{call(j,ne,Y){return V?q.call(j,ne,Y):(0,n.timeout)(0).then(()=>V=!0).then(()=>q.call(j,ne,Y))},listen(j,ne){if(V)return q.listen(j,ne);const Y=new S.Relay;return(0,n.timeout)(0).then(()=>V=!0).then(()=>Y.input=q.listen(j,ne)),Y.event}}}e.getNextTickChannel=O;class k{constructor(V){this.fn=V}routeCall(V){return this.route(V)}routeEvent(V){return this.route(V)}async route(V){for(const j of V.connections)if(await Promise.resolve(this.fn(j.ctx)))return Promise.resolve(j);return await S.Event.toPromise(V.onDidAddConnection),await this.route(V)}}e.StaticRouter=k;var U;(function(q){function V(le,ue){const K=le,ge=ue&&ue.disableMarshalling,ye=new Map;for(const Te in K)ne(Te)&&ye.set(Te,S.Event.buffer(K[Te],!0));return new class{listen(Te,pe,Pe){const fe=ye.get(pe);if(fe)return fe;if(Y(pe)){const ve=K[pe];if(typeof ve=="function")return ve.call(K,Pe)}throw new Error(`Event not found: ${pe}`)}call(Te,pe,Pe){const fe=K[pe];if(typeof fe=="function"){if(!ge&&Array.isArray(Pe))for(let ve=0;ve<Pe.length;ve++)Pe[ve]=(0,L.revive)(Pe[ve]);return fe.apply(K,Pe)}throw new Error(`Method not found: ${pe}`)}}}q.fromService=V;function j(le,ue){const K=ue&&ue.disableMarshalling;return new Proxy({},{get(ge,ye){if(typeof ye=="string")return ue?.properties?.has(ye)?ue.properties.get(ye):Y(ye)?function(Te){return le.listen(ye,Te)}:ne(ye)?le.listen(ye):async function(...Te){let pe;ue&&!(0,_.isUndefinedOrNull)(ue.context)?pe=[ue.context,...Te]:pe=Te;const Pe=await le.call(ye,pe);return K?Pe:(0,L.revive)(Pe)};throw new Error(`Property not found: ${String(ye)}`)}})}q.toService=j;function ne(le){return le[0]==="o"&&le[1]==="n"&&I.isUpperAsciiLetter(le.charCodeAt(2))}function Y(le){return/^onDynamic/.test(le)&&I.isUpperAsciiLetter(le.charCodeAt(9))}})(U=e.ProxyChannel||(e.ProxyChannel={}));const F=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function $(q){if(Array.isArray(q))return q;if(q&&typeof q=="object"&&typeof q.toString=="function"){const V=q.toString();if(V!=="[object Object]")return V}return q}function ee(q){return Array.isArray(q)?q.map($):$(q)}function B(q,V,j,ne,Y,le,ue){ue=ee(ue);const K=F[Y],ge=K[ne%K.length];let ye=[`%c[${q}]%c[${String(V).padStart(7," ")}]%c[len: ${String(j).padStart(5," ")}]%c${String(ne).padStart(5," ")} - ${le}`,"color: darkgreen","color: grey","color: grey",`color: ${ge}`];/\($/.test(le)?(ye=ye.concat(ue),ye.push(")")):ye.push(ue),console.log.apply(console,ye)}e.logWithColors=B;class z{constructor(V,j){this._outgoingPrefix=V,this._incomingPrefix=j,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(V,j,ne,Y,le){this._totalOutgoing+=V,B(this._outgoingPrefix,this._totalOutgoing,V,j,ne,Y,le)}logIncoming(V,j,ne,Y,le){this._totalIncoming+=V,B(this._incomingPrefix,this._totalIncoming,V,j,ne,Y,le)}}e.IPCLogger=z}),define(Ie[111],ke([1,0,23,3,6,110]),function(Q,e,u,n,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var D;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(D=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var C;(function(s){s.enableDiagnostics=!1,s.records=[];const i=new WeakMap;let t=0;function c(h,E){if(!i.has(h)){const R=String(++t);i.set(h,R)}return i.get(h)}function l(h,E,R,N){if(!s.enableDiagnostics)return;const O=c(h,E);if(N instanceof u.VSBuffer||N instanceof Uint8Array||N instanceof ArrayBuffer||ArrayBuffer.isView(N)){const k=u.VSBuffer.alloc(N.byteLength);k.set(N),s.records.push({timestamp:Date.now(),id:O,label:E,type:R,buff:k})}else s.records.push({timestamp:Date.now(),id:O,label:E,type:R,data:N})}s.traceSocketEvent=l})(C=e.SocketDiagnostics||(e.SocketDiagnostics={}));var S;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(S=e.SocketCloseEventType||(e.SocketCloseEventType={}));let P=null;function L(){return P||(P=u.VSBuffer.alloc(0)),P}class I{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(i){this._chunks.push(i),this._totalLength+=i.byteLength}read(i){return this._read(i,!0)}peek(i){return this._read(i,!1)}_read(i,t){if(i===0)return L();if(i>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===i){const E=this._chunks[0];return t&&(this._chunks.shift(),this._totalLength-=i),E}if(this._chunks[0].byteLength>i){const E=this._chunks[0].slice(0,i);return t&&(this._chunks[0]=this._chunks[0].slice(i),this._totalLength-=i),E}const c=u.VSBuffer.alloc(i);let l=0,h=0;for(;i>0;){const E=this._chunks[h];if(E.byteLength>i){const R=E.slice(0,i);c.set(R,l),l+=i,t&&(this._chunks[h]=E.slice(i),this._totalLength-=i),i-=i}else c.set(E,l),l+=E.byteLength,t?(this._chunks.shift(),this._totalLength-=E.byteLength):h++,i-=E.byteLength}return c}}e.ChunkStream=I;var _;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume"})(_||(_={}));function T(s){switch(s){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var w;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(w=e.ProtocolConstants||(e.ProtocolConstants={}));class b{constructor(i,t,c,l){this.type=i,this.id=t,this.ack=c,this.data=l,this.writtenTime=0}get size(){return this.data.byteLength}}class p extends y.Disposable{constructor(i){super();this._onMessage=this._register(new n.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=i,this._isDisposed=!1,this._incomingData=new I,this._register(this._socket.onData(t=>this.acceptChunk(t))),this.lastReadTime=Date.now()}acceptChunk(i){if(!(!i||i.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(i);this._incomingData.byteLength>=this._state.readLen;){const t=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=t.readUInt32BE(9),this._state.messageType=t.readUInt8(0),this._state.id=t.readUInt32BE(1),this._state.ack=t.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:T(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const c=this._state.messageType,l=this._state.id,h=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",t),this._onMessage.fire(new b(c,l,h,t)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class g{constructor(i){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=i,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(i){if(this._isDisposed)return;i.writtenTime=Date.now(),this.lastWriteTime=Date.now();const t=u.VSBuffer.alloc(13);t.writeUInt8(i.type,0),t.writeUInt32BE(i.id,1),t.writeUInt32BE(i.ack,5),t.writeUInt32BE(i.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:T(i.type),id:i.id,ack:i.ack,messageSize:i.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",i.data),this._writeSoon(t,i.data)}_bufferAdd(i,t){const c=this._totalLength===0;return this._data.push(i,t),this._totalLength+=i.byteLength+t.byteLength,c}_bufferTake(){const i=u.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,i}_writeSoon(i,t){this._bufferAdd(i,t)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const i=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:i.byteLength}),this._socket.write(i)}}class v extends y.Disposable{constructor(i){super();this._onMessage=new n.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new n.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=i,this._socketWriter=this._register(new g(this._socket)),this._socketReader=this._register(new p(this._socket)),this._register(this._socketReader.onMessage(t=>{t.type===1&&this._onMessage.fire(t.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(i){this._socketWriter.write(new b(1,0,0,i))}}e.Protocol=v;class f extends A.IPCClient{constructor(i,t,c=null){super(i,t,c);this.protocol=i}static fromSocket(i,t){return new f(new v(i),t)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const i=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),i.end()}}e.Client=f;class a{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new n.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(i){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(i):this._emitter.fire(i):this._bufferedMessages.push(i)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=a;class m{constructor(i){this.data=i,this.next=null}}class o{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){const i=[];let t=0,c=this._first;for(;c;)i[t++]=c.data,c=c.next;return i}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(i){const t=new m(i);if(!this._first){this._first=t,this._last=t;return}this._last.next=t,this._last=t}}class d{constructor(){this.lastRuns=[];const i=Date.now();for(let t=0;t<d._HISTORY_LENGTH;t++)this.lastRuns[t]=i-1e3*t;setInterval(()=>{for(let t=d._HISTORY_LENGTH;t>=1;t--)this.lastRuns[t]=this.lastRuns[t-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return d._INSTANCE||(d._INSTANCE=new d),d._INSTANCE}load(){const i=Date.now(),t=(1+d._HISTORY_LENGTH)*1e3;let c=0;for(let l=0;l<d._HISTORY_LENGTH;l++)i-this.lastRuns[l]<=t&&c++;return 1-c/d._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}d._HISTORY_LENGTH=10,d._INSTANCE=null;class r{constructor(i,t=null,c=d.getInstance()){this._onControlMessage=new a,this.onControlMessage=this._onControlMessage.event,this._onMessage=new a,this.onMessage=this._onMessage.event,this._onDidDispose=new a,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new a,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new a,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=c,this._isReconnecting=!1,this._outgoingUnackMsg=new o,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=i,this._socketWriter=new g(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new p(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(l=>this._receiveMessage(l))),this._socketDisposables.push(this._socket.onClose(l=>this._onSocketClose.fire(l))),t&&this._socketReader.acceptChunk(t)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,y.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const i=new b(5,0,0,L());this._socketWriter.write(i),this._socketWriter.flush()}sendPause(){const i=new b(7,0,0,L());this._socketWriter.write(i)}sendResume(){const i=new b(8,0,0,L());this._socketWriter.write(i)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(i,t){this._isReconnecting=!0,this._socketDisposables=(0,y.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=i,this._socketWriter=new g(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new p(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(c=>this._receiveMessage(c))),this._socketDisposables.push(this._socket.onClose(c=>this._onSocketClose.fire(c))),this._socketReader.acceptChunk(t)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const i=new b(3,0,this._incomingAckId,L());this._socketWriter.write(i);const t=this._outgoingUnackMsg.toArray();for(let c=0,l=t.length;c<l;c++)this._socketWriter.write(t[c]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(i){if(i.ack>this._outgoingAckId){this._outgoingAckId=i.ack;do{const t=this._outgoingUnackMsg.peek();if(t&&t.id<=i.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(i.type){case 0:break;case 1:{if(i.id>this._incomingMsgId)if(i.id!==this._incomingMsgId+1){const t=Date.now();t-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=t,this._socketWriter.write(new b(6,0,0,L())))}else this._incomingMsgId=i.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(i.data);break}case 2:{this._onControlMessage.fire(i.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const t=this._outgoingUnackMsg.toArray();for(let c=0,l=t.length;c<l;c++)this._socketWriter.write(t[c]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(i){const t=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const c=new b(1,t,this._incomingAckId,i);this._outgoingUnackMsg.push(c),this._isReconnecting||(this._socketWriter.write(c),this._recvAckCheck())}sendControl(i){const t=new b(2,0,0,i);this._socketWriter.write(t)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const i=Date.now()-this._incomingMsgLastTime;if(i>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-i+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const i=this._outgoingUnackMsg.peek(),t=Date.now()-i.writtenTime,c=Date.now()-this._socketReader.lastReadTime,l=Date.now()-this._lastSocketTimeoutTime;if(t>=2e4&&c>=2e4&&l>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const h=Math.max(2e4-t,2e4-c,2e4-l,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},h)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const i=new b(3,0,this._incomingAckId,L());this._socketWriter.write(i)}}e.PersistentProtocol=r}),define(Ie[158],ke([1,0,36,9]),function(Q,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function y(A,D,C,S,P,L){if(Array.isArray(A)){let I=0;for(const _ of A){const T=y(_,D,C,S,P,L);if(T===10)return T;T>I&&(I=T)}return I}else{if(typeof A=="string")return S?A==="*"?5:A===C?10:0:0;if(A){const{language:I,pattern:_,scheme:T,hasAccessToAllModels:w,notebookType:b}=A;if(!S&&!w)return 0;b&&P&&(D=P);let p=0;if(T)if(T===D.scheme)p=10;else if(T==="*")p=5;else return 0;if(I)if(I===C)p=10;else if(I==="*")p=Math.max(p,5);else return 0;if(b)if(b===L)p=10;else if(b==="*"&&L!==void 0)p=Math.max(p,5);else return 0;if(_){let g;if(typeof _=="string"?g=_:g={..._,base:(0,n.normalize)(_.base)},g===D.fsPath||(0,u.match)(g,D.fsPath))p=10;else return 0}return p}else return 0}}e.score=y}),define(Ie[159],ke([1,0,8,48,151]),function(Q,e,u,n,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class A{constructor(C,S,P,L){this._uri=C,this._lines=S,this._eol=P,this._versionId=L,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(C){C.eol&&C.eol!==this._eol&&(this._eol=C.eol,this._lineStarts=null);const S=C.changes;for(const P of S)this._acceptDeleteRange(P.range),this._acceptInsertText(new n.Position(P.range.startLineNumber,P.range.startColumn),P.text);this._versionId=C.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const C=this._eol.length,S=this._lines.length,P=new Uint32Array(S);for(let L=0;L<S;L++)P[L]=this._lines[L].length+C;this._lineStarts=new y.PrefixSumComputer(P)}}_setLineText(C,S){this._lines[C]=S,this._lineStarts&&this._lineStarts.setValue(C,this._lines[C].length+this._eol.length)}_acceptDeleteRange(C){if(C.startLineNumber===C.endLineNumber){if(C.startColumn===C.endColumn)return;this._setLineText(C.startLineNumber-1,this._lines[C.startLineNumber-1].substring(0,C.startColumn-1)+this._lines[C.startLineNumber-1].substring(C.endColumn-1));return}this._setLineText(C.startLineNumber-1,this._lines[C.startLineNumber-1].substring(0,C.startColumn-1)+this._lines[C.endLineNumber-1].substring(C.endColumn-1)),this._lines.splice(C.startLineNumber,C.endLineNumber-C.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(C.startLineNumber,C.endLineNumber-C.startLineNumber)}_acceptInsertText(C,S){if(S.length===0)return;const P=(0,u.splitLines)(S);if(P.length===1){this._setLineText(C.lineNumber-1,this._lines[C.lineNumber-1].substring(0,C.column-1)+P[0]+this._lines[C.lineNumber-1].substring(C.column-1));return}P[P.length-1]+=this._lines[C.lineNumber-1].substring(C.column-1),this._setLineText(C.lineNumber-1,this._lines[C.lineNumber-1].substring(0,C.column-1)+P[0]);const L=new Uint32Array(P.length-1);for(let I=1;I<P.length;I++)this._lines.splice(C.lineNumber+I-1,0,P[I]),L[I-1]=P[I].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(C.lineNumber,L)}}e.MirrorTextModel=A}),define(Ie[160],ke([1,0,8,148,48,35,100]),function(Q,e,u,n,y,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const C=999;class S{constructor(v,f,a,m){this.searchString=v,this.isRegex=f,this.matchCase=a,this.wordSeparators=m}parseSearchRequest(){if(this.searchString==="")return null;let v;this.isRegex?v=P(this.searchString):v=this.searchString.indexOf(`
`)>=0;let f=null;try{f=u.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:v,global:!0,unicode:!0})}catch{return null}if(!f)return null;let a=!this.isRegex&&!v;return a&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(a=this.matchCase),new D.SearchData(f,this.wordSeparators?(0,n.getMapForWordSeparators)(this.wordSeparators):null,a?this.searchString:null)}}e.SearchParams=S;function P(g){if(!g||g.length===0)return!1;for(let v=0,f=g.length;v<f;v++)if(g.charCodeAt(v)===92){if(v++,v>=f)break;const m=g.charCodeAt(v);if(m===110||m===114||m===87)return!0}return!1}e.isMultilineRegexSource=P;function L(g,v,f){if(!f)return new D.FindMatch(g,null);const a=[];for(let m=0,o=v.length;m<o;m++)a[m]=v[m];return new D.FindMatch(g,a)}e.createFindMatch=L;class I{constructor(v){const f=[];let a=0;for(let m=0,o=v.length;m<o;m++)v.charCodeAt(m)===10&&(f[a++]=m);this._lineFeedsOffsets=f}findLineFeedCountBeforeOffset(v){const f=this._lineFeedsOffsets;let a=0,m=f.length-1;if(m===-1||v<=f[0])return 0;for(;a<m;){const o=a+((m-a)/2>>0);f[o]>=v?m=o-1:f[o+1]>=v?(a=o,m=o):a=o+1}return a+1}}class _{static findMatches(v,f,a,m,o){const d=f.parseSearchRequest();return d?d.regex.multiline?this._doFindMatchesMultiline(v,a,new p(d.wordSeparators,d.regex),m,o):this._doFindMatchesLineByLine(v,a,d,m,o):[]}static _getMultilineMatchRange(v,f,a,m,o,d){let r,s=0;m?(s=m.findLineFeedCountBeforeOffset(o),r=f+o+s):r=f+o;let i;if(m){const h=m.findLineFeedCountBeforeOffset(o+d.length)-s;i=r+d.length+h}else i=r+d.length;const t=v.getPositionAt(r),c=v.getPositionAt(i);return new A.Range(t.lineNumber,t.column,c.lineNumber,c.column)}static _doFindMatchesMultiline(v,f,a,m,o){const d=v.getOffsetAt(f.getStartPosition()),r=v.getValueInRange(f,1),s=v.getEOL()===`\r
`?new I(r):null,i=[];let t=0,c;for(a.reset(0);c=a.next(r);)if(i[t++]=L(this._getMultilineMatchRange(v,d,r,s,c.index,c[0]),c,m),t>=o)return i;return i}static _doFindMatchesLineByLine(v,f,a,m,o){const d=[];let r=0;if(f.startLineNumber===f.endLineNumber){const i=v.getLineContent(f.startLineNumber).substring(f.startColumn-1,f.endColumn-1);return r=this._findMatchesInLine(a,i,f.startLineNumber,f.startColumn-1,r,d,m,o),d}const s=v.getLineContent(f.startLineNumber).substring(f.startColumn-1);r=this._findMatchesInLine(a,s,f.startLineNumber,f.startColumn-1,r,d,m,o);for(let i=f.startLineNumber+1;i<f.endLineNumber&&r<o;i++)r=this._findMatchesInLine(a,v.getLineContent(i),i,0,r,d,m,o);if(r<o){const i=v.getLineContent(f.endLineNumber).substring(0,f.endColumn-1);r=this._findMatchesInLine(a,i,f.endLineNumber,0,r,d,m,o)}return d}static _findMatchesInLine(v,f,a,m,o,d,r,s){const i=v.wordSeparators;if(!r&&v.simpleSearch){const l=v.simpleSearch,h=l.length,E=f.length;let R=-h;for(;(R=f.indexOf(l,R+h))!==-1;)if((!i||b(i,f,E,R,h))&&(d[o++]=new D.FindMatch(new A.Range(a,R+1+m,a,R+1+h+m),null),o>=s))return o;return o}const t=new p(v.wordSeparators,v.regex);let c;t.reset(0);do if(c=t.next(f),c&&(d[o++]=L(new A.Range(a,c.index+1+m,a,c.index+1+c[0].length+m),c,r),o>=s))return o;while(c);return o}static findNextMatch(v,f,a,m){const o=f.parseSearchRequest();if(!o)return null;const d=new p(o.wordSeparators,o.regex);return o.regex.multiline?this._doFindNextMatchMultiline(v,a,d,m):this._doFindNextMatchLineByLine(v,a,d,m)}static _doFindNextMatchMultiline(v,f,a,m){const o=new y.Position(f.lineNumber,1),d=v.getOffsetAt(o),r=v.getLineCount(),s=v.getValueInRange(new A.Range(o.lineNumber,o.column,r,v.getLineMaxColumn(r)),1),i=v.getEOL()===`\r
`?new I(s):null;a.reset(f.column-1);const t=a.next(s);return t?L(this._getMultilineMatchRange(v,d,s,i,t.index,t[0]),t,m):f.lineNumber!==1||f.column!==1?this._doFindNextMatchMultiline(v,new y.Position(1,1),a,m):null}static _doFindNextMatchLineByLine(v,f,a,m){const o=v.getLineCount(),d=f.lineNumber,r=v.getLineContent(d),s=this._findFirstMatchInLine(a,r,d,f.column,m);if(s)return s;for(let i=1;i<=o;i++){const t=(d+i-1)%o,c=v.getLineContent(t+1),l=this._findFirstMatchInLine(a,c,t+1,1,m);if(l)return l}return null}static _findFirstMatchInLine(v,f,a,m,o){v.reset(m-1);const d=v.next(f);return d?L(new A.Range(a,d.index+1,a,d.index+1+d[0].length),d,o):null}static findPreviousMatch(v,f,a,m){const o=f.parseSearchRequest();if(!o)return null;const d=new p(o.wordSeparators,o.regex);return o.regex.multiline?this._doFindPreviousMatchMultiline(v,a,d,m):this._doFindPreviousMatchLineByLine(v,a,d,m)}static _doFindPreviousMatchMultiline(v,f,a,m){const o=this._doFindMatchesMultiline(v,new A.Range(1,1,f.lineNumber,f.column),a,m,10*C);if(o.length>0)return o[o.length-1];const d=v.getLineCount();return f.lineNumber!==d||f.column!==v.getLineMaxColumn(d)?this._doFindPreviousMatchMultiline(v,new y.Position(d,v.getLineMaxColumn(d)),a,m):null}static _doFindPreviousMatchLineByLine(v,f,a,m){const o=v.getLineCount(),d=f.lineNumber,r=v.getLineContent(d).substring(0,f.column-1),s=this._findLastMatchInLine(a,r,d,m);if(s)return s;for(let i=1;i<=o;i++){const t=(o+d-i-1)%o,c=v.getLineContent(t+1),l=this._findLastMatchInLine(a,c,t+1,m);if(l)return l}return null}static _findLastMatchInLine(v,f,a,m){let o=null,d;for(v.reset(0);d=v.next(f);)o=L(new A.Range(a,d.index+1,a,d.index+1+d[0].length),d,m);return o}}e.TextModelSearch=_;function T(g,v,f,a,m){if(a===0)return!0;const o=v.charCodeAt(a-1);if(g.get(o)!==0||o===13||o===10)return!0;if(m>0){const d=v.charCodeAt(a);if(g.get(d)!==0)return!0}return!1}function w(g,v,f,a,m){if(a+m===f)return!0;const o=v.charCodeAt(a+m);if(g.get(o)!==0||o===13||o===10)return!0;if(m>0){const d=v.charCodeAt(a+m-1);if(g.get(d)!==0)return!0}return!1}function b(g,v,f,a,m){return T(g,v,f,a,m)&&w(g,v,f,a,m)}e.isValidMatch=b;class p{constructor(v,f){this._wordSeparators=v,this._searchRegex=f,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(v){this._searchRegex.lastIndex=v,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(v){const f=v.length;let a;do{if(this._prevMatchStartIndex+this._prevMatchLength===f||(a=this._searchRegex.exec(v),!a))return null;const m=a.index,o=a[0].length;if(m===this._prevMatchStartIndex&&o===this._prevMatchLength){if(o===0){u.getNextCodePoint(v,f,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=m,this._prevMatchLength=o,!this._wordSeparators||b(this._wordSeparators,v,f,m,o))return a}while(a);return null}}e.Searcher=p}),define(Ie[112],ke([1,0,23,13]),function(Q,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var y;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(y||(y={}));function A(I){for(let _=0,T=I.length;_<T;_+=4){const w=I[_+0],b=I[_+1],p=I[_+2],g=I[_+3];I[_+0]=g,I[_+1]=p,I[_+2]=b,I[_+3]=w}}function D(I){const _=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return n.isLittleEndian()||A(_),u.VSBuffer.wrap(_)}function C(I){const _=I.buffer;if(n.isLittleEndian()||A(_),_.byteOffset%4==0)return new Uint32Array(_.buffer,_.byteOffset,_.length/4);{const T=new Uint8Array(_.byteLength);return T.set(_),new Uint32Array(T.buffer,T.byteOffset,T.length/4)}}function S(I){const _=new Uint32Array(P(I));let T=0;if(_[T++]=I.id,I.type==="full")_[T++]=1,_[T++]=I.data.length,_.set(I.data,T),T+=I.data.length;else{_[T++]=2,_[T++]=I.deltas.length;for(const w of I.deltas)_[T++]=w.start,_[T++]=w.deleteCount,w.data?(_[T++]=w.data.length,_.set(w.data,T),T+=w.data.length):_[T++]=0}return D(_)}e.encodeSemanticTokensDto=S;function P(I){let _=0;if(_+=1+1,I.type==="full")_+=1+I.data.length;else{_+=1,_+=(1+1+1)*I.deltas.length;for(const T of I.deltas)T.data&&(_+=T.data.length)}return _}function L(I){const _=C(I);let T=0;const w=_[T++];if(_[T++]===1){const v=_[T++],f=_.subarray(T,T+v);return T+=v,{id:w,type:"full",data:f}}const p=_[T++],g=[];for(let v=0;v<p;v++){const f=_[T++],a=_[T++],m=_[T++];let o;m>0&&(o=_.subarray(T,T+m),T+=m),g[v]={start:f,deleteCount:a,data:o}}return{id:w,type:"delta",deltas:g}}e.decodeSemanticTokensDto=L}),define(Ie[161],ke([1,0,3,6]),function(Q,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class y{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new u.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(C){this._onDidChange.fire({changedLanguages:C,changedColorMap:!1})}register(C,S){return this._map.set(C,S),this.fire([C]),(0,n.toDisposable)(()=>{this._map.get(C)===S&&(this._map.delete(C),this.fire([C]))})}registerFactory(C,S){this._factories.get(C)?.dispose();const P=new A(this,C,S);return this._factories.set(C,P),(0,n.toDisposable)(()=>{const L=this._factories.get(C);!L||L!==P||(this._factories.delete(C),L.dispose())})}async getOrCreate(C){const S=this.get(C);if(S)return S;const P=this._factories.get(C);return!P||P.isResolved?null:(await P.resolve(),this.get(C))}get(C){return this._map.get(C)||null}isResolved(C){if(this.get(C))return!0;const P=this._factories.get(C);return!!(!P||P.isResolved)}setColorMap(C){this._colorMap=C,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=y;class A extends n.Disposable{constructor(C,S,P){super();this._registry=C,this._languageId=S,this._factory=P,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}get isResolved(){return this._isResolved}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const C=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,C&&!this._isDisposed&&this._register(this._registry.register(this._languageId,C))}}}),define(Ie[64],ke([1,0,77,2,35,161]),function(Q,e,u,n,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class D{constructor(h,E,R){this._tokenBrand=void 0,this.offset=h,this.type=E,this.language=R}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=D;class C{constructor(h,E){this._tokenizationResultBrand=void 0,this.tokens=h,this.endState=E}}e.TokenizationResult=C;class S{constructor(h,E){this._encodedTokenizationResultBrand=void 0,this.tokens=h,this.endState=E}}e.EncodedTokenizationResult=S;var P;(function(l){l[l.Method=0]="Method",l[l.Function=1]="Function",l[l.Constructor=2]="Constructor",l[l.Field=3]="Field",l[l.Variable=4]="Variable",l[l.Class=5]="Class",l[l.Struct=6]="Struct",l[l.Interface=7]="Interface",l[l.Module=8]="Module",l[l.Property=9]="Property",l[l.Event=10]="Event",l[l.Operator=11]="Operator",l[l.Unit=12]="Unit",l[l.Value=13]="Value",l[l.Constant=14]="Constant",l[l.Enum=15]="Enum",l[l.EnumMember=16]="EnumMember",l[l.Keyword=17]="Keyword",l[l.Text=18]="Text",l[l.Color=19]="Color",l[l.File=20]="File",l[l.Reference=21]="Reference",l[l.Customcolor=22]="Customcolor",l[l.Folder=23]="Folder",l[l.TypeParameter=24]="TypeParameter",l[l.User=25]="User",l[l.Issue=26]="Issue",l[l.Snippet=27]="Snippet"})(P=e.CompletionItemKind||(e.CompletionItemKind={}));var L;(function(l){const h=new Map;h.set(0,u.Codicon.symbolMethod),h.set(1,u.Codicon.symbolFunction),h.set(2,u.Codicon.symbolConstructor),h.set(3,u.Codicon.symbolField),h.set(4,u.Codicon.symbolVariable),h.set(5,u.Codicon.symbolClass),h.set(6,u.Codicon.symbolStruct),h.set(7,u.Codicon.symbolInterface),h.set(8,u.Codicon.symbolModule),h.set(9,u.Codicon.symbolProperty),h.set(10,u.Codicon.symbolEvent),h.set(11,u.Codicon.symbolOperator),h.set(12,u.Codicon.symbolUnit),h.set(13,u.Codicon.symbolValue),h.set(15,u.Codicon.symbolEnum),h.set(14,u.Codicon.symbolConstant),h.set(15,u.Codicon.symbolEnum),h.set(16,u.Codicon.symbolEnumMember),h.set(17,u.Codicon.symbolKeyword),h.set(27,u.Codicon.symbolSnippet),h.set(18,u.Codicon.symbolText),h.set(19,u.Codicon.symbolColor),h.set(20,u.Codicon.symbolFile),h.set(21,u.Codicon.symbolReference),h.set(22,u.Codicon.symbolCustomColor),h.set(23,u.Codicon.symbolFolder),h.set(24,u.Codicon.symbolTypeParameter),h.set(25,u.Codicon.account),h.set(26,u.Codicon.issues);function E(O){let k=h.get(O);return k||(console.info("No codicon found for CompletionItemKind "+O),k=u.Codicon.symbolProperty),k}l.toIcon=E;const R=new Map;R.set("method",0),R.set("function",1),R.set("constructor",2),R.set("field",3),R.set("variable",4),R.set("class",5),R.set("struct",6),R.set("interface",7),R.set("module",8),R.set("property",9),R.set("event",10),R.set("operator",11),R.set("unit",12),R.set("value",13),R.set("constant",14),R.set("enum",15),R.set("enum-member",16),R.set("enumMember",16),R.set("keyword",17),R.set("snippet",27),R.set("text",18),R.set("color",19),R.set("file",20),R.set("reference",21),R.set("customcolor",22),R.set("folder",23),R.set("type-parameter",24),R.set("typeParameter",24),R.set("account",25),R.set("issue",26);function N(O,k){let U=R.get(O);return typeof U=="undefined"&&!k&&(U=9),U}l.fromString=N})(L=e.CompletionItemKinds||(e.CompletionItemKinds={}));var I;(function(l){l[l.Deprecated=1]="Deprecated"})(I=e.CompletionItemTag||(e.CompletionItemTag={}));var _;(function(l){l[l.KeepWhitespace=1]="KeepWhitespace",l[l.InsertAsSnippet=4]="InsertAsSnippet"})(_=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var T;(function(l){l[l.Invoke=0]="Invoke",l[l.TriggerCharacter=1]="TriggerCharacter",l[l.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(T=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var w;(function(l){l[l.Automatic=0]="Automatic",l[l.Explicit=1]="Explicit"})(w=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var b;(function(l){l[l.Invoke=1]="Invoke",l[l.Auto=2]="Auto"})(b=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var p;(function(l){l[l.Invoke=1]="Invoke",l[l.TriggerCharacter=2]="TriggerCharacter",l[l.ContentChange=3]="ContentChange"})(p=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var g;(function(l){l[l.Text=0]="Text",l[l.Read=1]="Read",l[l.Write=2]="Write"})(g=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function v(l){return l&&n.URI.isUri(l.uri)&&y.Range.isIRange(l.range)&&(y.Range.isIRange(l.originSelectionRange)||y.Range.isIRange(l.targetSelectionRange))}e.isLocationLink=v;var f;(function(l){l[l.File=0]="File",l[l.Module=1]="Module",l[l.Namespace=2]="Namespace",l[l.Package=3]="Package",l[l.Class=4]="Class",l[l.Method=5]="Method",l[l.Property=6]="Property",l[l.Field=7]="Field",l[l.Constructor=8]="Constructor",l[l.Enum=9]="Enum",l[l.Interface=10]="Interface",l[l.Function=11]="Function",l[l.Variable=12]="Variable",l[l.Constant=13]="Constant",l[l.String=14]="String",l[l.Number=15]="Number",l[l.Boolean=16]="Boolean",l[l.Array=17]="Array",l[l.Object=18]="Object",l[l.Key=19]="Key",l[l.Null=20]="Null",l[l.EnumMember=21]="EnumMember",l[l.Struct=22]="Struct",l[l.Event=23]="Event",l[l.Operator=24]="Operator",l[l.TypeParameter=25]="TypeParameter"})(f=e.SymbolKind||(e.SymbolKind={}));var a;(function(l){l[l.Deprecated=1]="Deprecated"})(a=e.SymbolTag||(e.SymbolTag={}));var m;(function(l){const h=new Map;h.set(0,u.Codicon.symbolFile),h.set(1,u.Codicon.symbolModule),h.set(2,u.Codicon.symbolNamespace),h.set(3,u.Codicon.symbolPackage),h.set(4,u.Codicon.symbolClass),h.set(5,u.Codicon.symbolMethod),h.set(6,u.Codicon.symbolProperty),h.set(7,u.Codicon.symbolField),h.set(8,u.Codicon.symbolConstructor),h.set(9,u.Codicon.symbolEnum),h.set(10,u.Codicon.symbolInterface),h.set(11,u.Codicon.symbolFunction),h.set(12,u.Codicon.symbolVariable),h.set(13,u.Codicon.symbolConstant),h.set(14,u.Codicon.symbolString),h.set(15,u.Codicon.symbolNumber),h.set(16,u.Codicon.symbolBoolean),h.set(17,u.Codicon.symbolArray),h.set(18,u.Codicon.symbolObject),h.set(19,u.Codicon.symbolKey),h.set(20,u.Codicon.symbolNull),h.set(21,u.Codicon.symbolEnumMember),h.set(22,u.Codicon.symbolStruct),h.set(23,u.Codicon.symbolEvent),h.set(24,u.Codicon.symbolOperator),h.set(25,u.Codicon.symbolTypeParameter);function E(R){let N=h.get(R);return N||(console.info("No codicon found for SymbolKind "+R),N=u.Codicon.symbolProperty),N}l.toIcon=E})(m=e.SymbolKinds||(e.SymbolKinds={}));class o{constructor(h){this.value=h}}e.FoldingRangeKind=o,o.Comment=new o("comment"),o.Imports=new o("imports"),o.Region=new o("region");var d;(function(l){function h(E){return!E||typeof E!="object"?!1:typeof E.id=="string"&&typeof E.title=="string"}l.is=h})(d=e.Command||(e.Command={}));var r;(function(l){l[l.Collapsed=0]="Collapsed",l[l.Expanded=1]="Expanded"})(r=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var s;(function(l){l[l.Unresolved=0]="Unresolved",l[l.Resolved=1]="Resolved"})(s=e.CommentThreadState||(e.CommentThreadState={}));var i;(function(l){l[l.Editing=0]="Editing",l[l.Preview=1]="Preview"})(i=e.CommentMode||(e.CommentMode={}));var t;(function(l){l[l.Type=1]="Type",l[l.Parameter=2]="Parameter"})(t=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new A.TokenizationRegistry;var c;(function(l){l[l.None=0]="None",l[l.Option=1]="Option",l[l.Default=2]="Default",l[l.Preferred=3]="Preferred"})(c=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(Ie[162],ke([19,20]),function(Q,e){return Q.create("vs/base/node/processes",e)}),define(Ie[113],ke([1,0,42,30,11,24,9,13,40,102,10,145,29,162]),function(Q,e,u,n,y,A,D,C,S,P,L,I,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return P.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return P.TerminateResponseCode}});function w(m){switch(m){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function b(m,o){if(C.isWindows)try{const d={stdio:["pipe","pipe","ignore"]};o&&(d.cwd=o);const r=u.execFile("taskkill",["/T","/F","/PID",m.pid.toString()],d);return new Promise(s=>{r.once("error",i=>{s({success:!1,error:i})}),r.once("exit",(i,t)=>{s(i===0?{success:!0}:{success:!1,code:i!==null?i:1})})})}catch(d){return Promise.resolve({success:!1,error:d,code:d.status?w(d.status):1})}else if(C.isLinux||C.isMacintosh)try{const d=y.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",Q).fsPath;return new Promise(r=>{u.execFile(d,[m.pid.toString()],{encoding:"utf8",shell:!0},(s,i,t)=>{r(s?{success:!1,error:s}:{success:!0})})})}catch(d){return Promise.resolve({success:!1,error:d})}else m.kill("SIGKILL");return Promise.resolve({success:!0})}function p(m=S.env){return m.comspec||"cmd.exe"}e.getWindowsShell=p;class g{constructor(o,d,r,s){if(d!==void 0&&r!==void 0&&s!==void 0)this.cmd=o,this.args=d,this.shell=r,this.options=s;else{const i=o;this.cmd=i.command,this.shell=i.isShellCommand,this.args=i.args.slice(0),this.options=i.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const i=Object.create(null);Object.keys(S.env).forEach(t=>{i[t]=S.env[t]}),Object.keys(this.options.env).forEach(t=>{i[t]=this.options.env[t]}),this.options.env=i}}getSanitizedCommand(){let o=this.cmd.toLowerCase();const d=o.lastIndexOf(D.sep);return d!==-1&&(o=o.substring(d+1)),g.WellKnowCommands[o]?o:"other"}start(o){return C.isWindows&&(this.options&&this.options.cwd&&n.isUNC(this.options.cwd)||!this.options&&n.isUNC(S.cwd()))?Promise.reject(new Error(T.localize(0,null))):this.useExec().then(d=>{let r,s;const i=new Promise((t,c)=>{r=t,s=c});if(d){let t=this.cmd;this.args&&(t=t+" "+this.args.join(" ")),this.childProcess=u.exec(t,this.options,(c,l,h)=>{this.childProcess=null;const E=c;E&&E.killed?s({killed:this.terminateRequested,stdout:l.toString(),stderr:h.toString()}):this.handleExec(r,o,c,l,h)})}else{let t=null;const c=l=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(l,r,o,s);const h={terminated:this.terminateRequested};L.isNumber(l)&&(h.cmdCode=l),r(h)};if(this.shell&&C.isWindows){const l=A.deepClone(this.options);l.windowsVerbatimArguments=!0,l.detached=!1;let h=!1,E=!1;const R=[];let N=this.ensureQuotes(this.cmd);R.push(N.value),h=N.quoted,this.args&&this.args.forEach(k=>{N=this.ensureQuotes(k),R.push(N.value),E=E&&N.quoted});const O=["/s","/c"];h?E?O.push('"'+R.join(" ")+'"'):R.length>1?O.push('"'+R[0]+'" '+R.slice(1).join(" ")):O.push('"'+R[0]+'"'):O.push(R.join(" ")),t=u.spawn(p(),O,l)}else this.cmd&&(t=u.spawn(this.cmd,this.args,this.options));t&&(this.childProcess=t,this.childProcessPromise=Promise.resolve(t),this.pidResolve&&(this.pidResolve(L.isNumber(t.pid)?t.pid:-1),this.pidResolve=void 0),t.on("error",l=>{this.childProcess=null,s({terminated:this.terminateRequested,error:l})}),t.pid&&(this.childProcess.on("close",c),this.handleSpawn(t,r,o,s,!0)))}return i})}handleClose(o,d,r,s){}ensureQuotes(o){return g.regexp.test(o)?{value:'"'+o+'"',quoted:!0}:{value:o,quoted:o.length>0&&o[0]==='"'&&o[o.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(o=>o.pid,o=>-1):new Promise(o=>{this.pidResolve=o})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(o=>(this.terminateRequested=!0,b(o,this.options.cwd).then(d=>(d.success&&(this.childProcess=null),d))),o=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(o=>{if(!this.shell||!C.isWindows)return o(!1);const d=u.spawn(p(),["/s","/c"]);d.on("error",r=>o(!0)),d.on("exit",r=>o(!1))})}}e.AbstractProcess=g,g.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},g.regexp=/^[^"].* .*[^"]/;class v extends g{constructor(o,d,r,s){super(o,d,r,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(o,d,r,s,i){[s,i].forEach((t,c)=>{const l=new I.LineDecoder;l.write(t).forEach(R=>{d({line:R,source:c===0?0:1})});const E=l.end();E&&d({line:E,source:c===0?0:1})}),o({terminated:this.terminateRequested,error:r})}handleSpawn(o,d,r,s,i){const t=new I.LineDecoder,c=new I.LineDecoder;o.stdout.on("data",l=>{t.write(l).forEach(E=>r({line:E,source:0}))}),o.stderr.on("data",l=>{c.write(l).forEach(E=>r({line:E,source:1}))}),this.stdoutLineDecoder=t,this.stderrLineDecoder=c}handleClose(o,d,r,s){const i=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;i&&r({line:i,source:0});const t=this.stderrLineDecoder?this.stderrLineDecoder.end():null;t&&r({line:t,source:1})}}e.LineProcess=v;function f(m){let o=[],d=!1;const r=function(s){if(d){o.push(s);return}(!m.send(s,t=>{if(t&&console.error(t),d=!1,o.length>0){const c=o.slice(0);o=[],c.forEach(l=>r(l))}})||C.isWindows)&&(d=!0)};return{send:r}}e.createQueuedSender=f;var a;(function(m){async function o(d,r,s){if(D.isAbsolute(d))return d;if(r===void 0&&(r=S.cwd()),D.dirname(d)!=="."||(s===void 0&&L.isString(S.env.PATH)&&(s=S.env.PATH.split(D.delimiter)),s===void 0||s.length===0))return D.join(r,d);async function t(c){if(await _.Promises.exists(c)){let l;try{l=await _.Promises.stat(c)}catch(h){h.message.startsWith("EACCES")&&(l=await _.Promises.lstat(c))}return l?!l.isDirectory():!1}return!1}for(const c of s){let l;if(D.isAbsolute(c)?l=D.join(c,d):l=D.join(r,c,d),await t(l))return l;let h=l+".com";if(await t(h)||(h=l+".exe",await t(h)))return h}return D.join(r,d)}m.findExecutable=o})(a=e.win32||(e.win32={}))}),define(Ie[163],ke([19,20]),function(Q,e){return Q.create("vs/editor/common/config/editorOptions",e)}),define(Ie[114],ke([1,0,163,13,99,16,24,147]),function(Q,e,u,n,y,A,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var S;(function(Z){Z[Z.None=0]="None",Z[Z.Keep=1]="Keep",Z[Z.Brackets=2]="Brackets",Z[Z.Advanced=3]="Advanced",Z[Z.Full=4]="Full"})(S=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class P{constructor(re){this._values=re}hasChanged(re){return this._values[re]}}e.ConfigurationChangedEvent=P;class L{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=L;class I{constructor(re,Se,We,oe){this.id=re,this.name=Se,this.defaultValue=We,this.schema=oe}applyUpdate(re,Se){return T(re,Se)}compute(re,Se,We){return We}}class _{constructor(re,Se){this.newValue=re,this.didChange=Se}}e.ApplyUpdateResult=_;function T(Z,re){if(typeof Z!="object"||typeof re!="object"||!Z||!re)return new _(re,Z!==re);if(Array.isArray(Z)||Array.isArray(re)){const We=Array.isArray(Z)&&Array.isArray(re)&&A.equals(Z,re);return new _(re,We)}let Se=!1;for(const We in re)if(re.hasOwnProperty(We)){const oe=T(Z[We],re[We]);oe.didChange&&(Z[We]=oe.newValue,Se=!0)}return new _(Z,Se)}class w{constructor(re){this.schema=void 0,this.id=re,this.name="_never_",this.defaultValue=void 0}applyUpdate(re,Se){return T(re,Se)}validate(re){return this.defaultValue}}class b{constructor(re,Se,We,oe){this.id=re,this.name=Se,this.defaultValue=We,this.schema=oe}applyUpdate(re,Se){return T(re,Se)}validate(re){return typeof re=="undefined"?this.defaultValue:re}compute(re,Se,We){return We}}function p(Z,re){return typeof Z=="undefined"?re:Z==="false"?!1:Boolean(Z)}e.boolean=p;class g extends b{constructor(re,Se,We,oe=void 0){typeof oe!="undefined"&&(oe.type="boolean",oe.default=We);super(re,Se,We,oe)}validate(re){return p(re,this.defaultValue)}}function v(Z,re,Se,We){if(typeof Z=="undefined")return re;let oe=parseInt(Z,10);return isNaN(oe)?re:(oe=Math.max(Se,oe),oe=Math.min(We,oe),oe|0)}e.clampedInt=v;class f extends b{constructor(re,Se,We,oe,Re,Be=void 0){typeof Be!="undefined"&&(Be.type="integer",Be.default=We,Be.minimum=oe,Be.maximum=Re);super(re,Se,We,Be);this.minimum=oe,this.maximum=Re}static clampedInt(re,Se,We,oe){return v(re,Se,We,oe)}validate(re){return f.clampedInt(re,this.defaultValue,this.minimum,this.maximum)}}class a extends b{constructor(re,Se,We,oe,Re){typeof Re!="undefined"&&(Re.type="number",Re.default=We);super(re,Se,We,Re);this.validationFn=oe}static clamp(re,Se,We){return re<Se?Se:re>We?We:re}static float(re,Se){if(typeof re=="number")return re;if(typeof re=="undefined")return Se;const We=parseFloat(re);return isNaN(We)?Se:We}validate(re){return this.validationFn(a.float(re,this.defaultValue))}}class m extends b{static string(re,Se){return typeof re!="string"?Se:re}constructor(re,Se,We,oe=void 0){typeof oe!="undefined"&&(oe.type="string",oe.default=We);super(re,Se,We,oe)}validate(re){return m.string(re,this.defaultValue)}}function o(Z,re,Se){return typeof Z!="string"||Se.indexOf(Z)===-1?re:Z}e.stringSet=o;class d extends b{constructor(re,Se,We,oe,Re=void 0){typeof Re!="undefined"&&(Re.type="string",Re.enum=oe,Re.default=We);super(re,Se,We,Re);this._allowedValues=oe}validate(re){return o(re,this.defaultValue,this._allowedValues)}}class r extends I{constructor(re,Se,We,oe,Re,Be,qe=void 0){typeof qe!="undefined"&&(qe.type="string",qe.enum=Re,qe.default=oe);super(re,Se,We,qe);this._allowedValues=Re,this._convert=Be}validate(re){return typeof re!="string"?this.defaultValue:this._allowedValues.indexOf(re)===-1?this.defaultValue:this._convert(re)}}function s(Z){switch(Z){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class i extends I{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[u.localize(0,null),u.localize(1,null),u.localize(2,null)],default:"auto",description:u.localize(3,null)})}validate(re){switch(re){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(re,Se,We){return We===0?re.accessibilitySupport:We}}class t extends I{constructor(){const re={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",re,{"editor.comments.insertSpace":{type:"boolean",default:re.insertSpace,description:u.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:re.ignoreEmptyLines,description:u.localize(5,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Se=re;return{insertSpace:p(Se.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:p(Se.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var c;(function(Z){Z[Z.Hidden=0]="Hidden",Z[Z.Blink=1]="Blink",Z[Z.Smooth=2]="Smooth",Z[Z.Phase=3]="Phase",Z[Z.Expand=4]="Expand",Z[Z.Solid=5]="Solid"})(c=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function l(Z){switch(Z){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var h;(function(Z){Z[Z.Line=1]="Line",Z[Z.Block=2]="Block",Z[Z.Underline=3]="Underline",Z[Z.LineThin=4]="LineThin",Z[Z.BlockOutline=5]="BlockOutline",Z[Z.UnderlineThin=6]="UnderlineThin"})(h=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function E(Z){switch(Z){case h.Line:return"line";case h.Block:return"block";case h.Underline:return"underline";case h.LineThin:return"line-thin";case h.BlockOutline:return"block-outline";case h.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=E;function R(Z){switch(Z){case"line":return h.Line;case"block":return h.Block;case"underline":return h.Underline;case"line-thin":return h.LineThin;case"block-outline":return h.BlockOutline;case"underline-thin":return h.UnderlineThin}}class N extends w{constructor(){super(129)}compute(re,Se,We){const oe=["monaco-editor"];return Se.get(34)&&oe.push(Se.get(34)),re.extraEditorClassName&&oe.push(re.extraEditorClassName),Se.get(67)==="default"?oe.push("mouse-default"):Se.get(67)==="copy"&&oe.push("mouse-copy"),Se.get(101)&&oe.push("showUnused"),Se.get(127)&&oe.push("showDeprecated"),oe.join(" ")}}class O extends g{constructor(){super(33,"emptySelectionClipboard",!0,{description:u.localize(6,null)})}compute(re,Se,We){return We&&re.emptySelectionClipboard}}class k extends I{constructor(){const re={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(36,"find",re,{"editor.find.cursorMoveOnType":{type:"boolean",default:re.cursorMoveOnType,description:u.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:re.seedSearchStringFromSelection,enumDescriptions:[u.localize(8,null),u.localize(9,null),u.localize(10,null)],description:u.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:re.autoFindInSelection,enumDescriptions:[u.localize(12,null),u.localize(13,null),u.localize(14,null)],description:u.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:re.globalFindClipboard,description:u.localize(16,null),included:n.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:re.addExtraSpaceOnTop,description:u.localize(17,null)},"editor.find.loop":{type:"boolean",default:re.loop,description:u.localize(18,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Se=re;return{cursorMoveOnType:p(Se.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof re.seedSearchStringFromSelection=="boolean"?re.seedSearchStringFromSelection?"always":"never":o(Se.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof re.autoFindInSelection=="boolean"?re.autoFindInSelection?"always":"never":o(Se.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:p(Se.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:p(Se.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:p(Se.loop,this.defaultValue.loop)}}}class U extends I{constructor(){super(46,"fontLigatures",U.OFF,{anyOf:[{type:"boolean",description:u.localize(19,null)},{type:"string",description:u.localize(20,null)}],description:u.localize(21,null),default:!1})}validate(re){return typeof re=="undefined"?this.defaultValue:typeof re=="string"?re==="false"?U.OFF:re==="true"?U.ON:re:Boolean(re)?U.ON:U.OFF}}e.EditorFontLigatures=U,U.OFF='"liga" off, "calt" off',U.ON='"liga" on, "calt" on';class F extends w{constructor(){super(45)}compute(re,Se,We){return re.fontInfo}}class $ extends b{constructor(){super(47,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:u.localize(22,null)})}validate(re){const Se=a.float(re,this.defaultValue);return Se===0?e.EDITOR_FONT_DEFAULTS.fontSize:a.clamp(Se,6,100)}compute(re,Se,We){return re.fontInfo.fontSize}}class ee extends I{constructor(){super(48,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:ee.MINIMUM_VALUE,maximum:ee.MAXIMUM_VALUE,errorMessage:u.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:ee.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:u.localize(24,null)})}validate(re){return re==="normal"||re==="bold"?re:String(f.clampedInt(re,e.EDITOR_FONT_DEFAULTS.fontWeight,ee.MINIMUM_VALUE,ee.MAXIMUM_VALUE))}}ee.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],ee.MINIMUM_VALUE=1,ee.MAXIMUM_VALUE=1e3;class B extends I{constructor(){const re={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Se={type:"string",enum:["peek","gotoAndPeek","goto"],default:re.multiple,enumDescriptions:[u.localize(25,null),u.localize(26,null),u.localize(27,null)]},We=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(52,"gotoLocation",re,{"editor.gotoLocation.multiple":{deprecationMessage:u.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:u.localize(29,null),...Se},"editor.gotoLocation.multipleTypeDefinitions":{description:u.localize(30,null),...Se},"editor.gotoLocation.multipleDeclarations":{description:u.localize(31,null),...Se},"editor.gotoLocation.multipleImplementations":{description:u.localize(32,null),...Se},"editor.gotoLocation.multipleReferences":{description:u.localize(33,null),...Se},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:re.alternativeDefinitionCommand,enum:We,description:u.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:re.alternativeTypeDefinitionCommand,enum:We,description:u.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:re.alternativeDeclarationCommand,enum:We,description:u.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:re.alternativeImplementationCommand,enum:We,description:u.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:re.alternativeReferenceCommand,enum:We,description:u.localize(38,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Se=re;return{multiple:o(Se.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Se.multipleDefinitions??o(Se.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Se.multipleTypeDefinitions??o(Se.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Se.multipleDeclarations??o(Se.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Se.multipleImplementations??o(Se.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Se.multipleReferences??o(Se.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:m.string(Se.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:m.string(Se.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:m.string(Se.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:m.string(Se.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:m.string(Se.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class z extends I{constructor(){const re={enabled:!0,delay:300,sticky:!0,above:!0};super(54,"hover",re,{"editor.hover.enabled":{type:"boolean",default:re.enabled,description:u.localize(39,null)},"editor.hover.delay":{type:"number",default:re.delay,minimum:0,maximum:1e4,description:u.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:re.sticky,description:u.localize(41,null)},"editor.hover.above":{type:"boolean",default:re.above,description:u.localize(42,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Se=re;return{enabled:p(Se.enabled,this.defaultValue.enabled),delay:f.clampedInt(Se.delay,this.defaultValue.delay,0,1e4),sticky:p(Se.sticky,this.defaultValue.sticky),above:p(Se.above,this.defaultValue.above)}}}var q;(function(Z){Z[Z.None=0]="None",Z[Z.Text=1]="Text",Z[Z.Blocks=2]="Blocks"})(q=e.RenderMinimap||(e.RenderMinimap={}));class V extends w{constructor(){super(132)}compute(re,Se,We){return V.computeLayout(Se,{memory:re.memory,outerWidth:re.outerWidth,outerHeight:re.outerHeight,isDominatedByLongLines:re.isDominatedByLongLines,lineHeight:re.fontInfo.lineHeight,viewLineCount:re.viewLineCount,lineNumbersDigitCount:re.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:re.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:re.fontInfo.maxDigitWidth,pixelRatio:re.pixelRatio})}static computeContainedMinimapLineCount(re){const Se=re.height/re.lineHeight,We=re.scrollBeyondLastLine?Se-1:0,oe=(re.viewLineCount+We)/(re.pixelRatio*re.height),Re=Math.floor(re.viewLineCount/oe);return{typicalViewportLineCount:Se,extraLinesBeyondLastLine:We,desiredRatio:oe,minimapLineCount:Re}}static _computeMinimapLayout(re,Se){const We=re.outerWidth,oe=re.outerHeight,Re=re.pixelRatio;if(!re.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Re*oe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:oe};const Be=Se.stableMinimapLayoutInput,qe=Be&&re.outerHeight===Be.outerHeight&&re.lineHeight===Be.lineHeight&&re.typicalHalfwidthCharacterWidth===Be.typicalHalfwidthCharacterWidth&&re.pixelRatio===Be.pixelRatio&&re.scrollBeyondLastLine===Be.scrollBeyondLastLine&&re.minimap.enabled===Be.minimap.enabled&&re.minimap.side===Be.minimap.side&&re.minimap.size===Be.minimap.size&&re.minimap.showSlider===Be.minimap.showSlider&&re.minimap.renderCharacters===Be.minimap.renderCharacters&&re.minimap.maxColumn===Be.minimap.maxColumn&&re.minimap.scale===Be.minimap.scale&&re.verticalScrollbarWidth===Be.verticalScrollbarWidth&&re.isViewportWrapping===Be.isViewportWrapping,je=re.lineHeight,Ve=re.typicalHalfwidthCharacterWidth,nt=re.scrollBeyondLastLine,ot=re.minimap.renderCharacters;let st=Re>=2?Math.round(re.minimap.scale*2):re.minimap.scale;const it=re.minimap.maxColumn,at=re.minimap.size,wt=re.minimap.side,Tt=re.verticalScrollbarWidth,_t=re.viewLineCount,ft=re.remainingWidth,It=re.isViewportWrapping,Ft=ot?2:3;let At=Math.floor(Re*oe);const Xe=At/Re;let Rt=!1,Mt=!1,Ot=Ft*st,mt=st/Re,Dt=1;if(at==="fill"||at==="fit"){const{typicalViewportLineCount:Je,extraLinesBeyondLastLine:et,desiredRatio:Ze,minimapLineCount:gt}=V.computeContainedMinimapLineCount({viewLineCount:_t,scrollBeyondLastLine:nt,height:oe,lineHeight:je,pixelRatio:Re});if(_t/gt>1)Rt=!0,Mt=!0,st=1,Ot=1,mt=st/Re;else{let yt=!1,vt=st+1;if(at==="fit"){const ht=Math.ceil((_t+et)*Ot);It&&qe&&ft<=Se.stableFitRemainingWidth?(yt=!0,vt=Se.stableFitMaxMinimapScale):yt=ht>At}if(at==="fill"||yt){Rt=!0;const ht=st;Ot=Math.min(je*Re,Math.max(1,Math.floor(1/Ze))),It&&qe&&ft<=Se.stableFitRemainingWidth&&(vt=Se.stableFitMaxMinimapScale),st=Math.min(vt,Math.max(1,Math.floor(Ot/Ft))),st>ht&&(Dt=Math.min(2,st/ht)),mt=st/Re/Dt,At=Math.ceil(Math.max(Je,_t+et)*Ot),It?(Se.stableMinimapLayoutInput=re,Se.stableFitRemainingWidth=ft,Se.stableFitMaxMinimapScale=st):(Se.stableMinimapLayoutInput=null,Se.stableFitRemainingWidth=0)}}}const Ae=Math.floor(it*mt),Oe=Math.min(Ae,Math.max(0,Math.floor((ft-Tt-2)*mt/(Ve+mt)))+e.MINIMAP_GUTTER_WIDTH);let Ee=Math.floor(Re*Oe);const J=Ee/Re;Ee=Math.floor(Ee*Dt);const Fe=ot?1:2,xe=wt==="left"?0:We-Oe-Tt;return{renderMinimap:Fe,minimapLeft:xe,minimapWidth:Oe,minimapHeightIsEditorHeight:Rt,minimapIsSampling:Mt,minimapScale:st,minimapLineHeight:Ot,minimapCanvasInnerWidth:Ee,minimapCanvasInnerHeight:At,minimapCanvasOuterWidth:J,minimapCanvasOuterHeight:Xe}}static computeLayout(re,Se){const We=Se.outerWidth|0,oe=Se.outerHeight|0,Re=Se.lineHeight|0,Be=Se.lineNumbersDigitCount|0,qe=Se.typicalHalfwidthCharacterWidth,je=Se.maxDigitWidth,Ve=Se.pixelRatio,nt=Se.viewLineCount,ot=re.get(124),st=ot==="inherit"?re.get(123):ot,it=st==="inherit"?re.get(119):st,at=re.get(122),wt=re.get(2),Tt=Se.isDominatedByLongLines,_t=re.get(51),ft=re.get(61).renderType!==0,It=re.get(62),Ft=re.get(95),At=re.get(66),Xe=re.get(93),Rt=Xe.verticalScrollbarSize,Mt=Xe.verticalHasArrows,Ot=Xe.arrowSize,mt=Xe.horizontalScrollbarSize,Dt=re.get(59),Ae=re.get(38);let Oe;if(typeof Dt=="string"&&/^\d+(\.\d+)?ch$/.test(Dt)){const Et=parseFloat(Dt.substr(0,Dt.length-2));Oe=f.clampedInt(Et*qe,0,0,1e3)}else Oe=f.clampedInt(Dt,0,0,1e3);Ae&&(Oe+=16);let Ee=0;if(ft){const Et=Math.max(Be,It);Ee=Math.round(Et*je)}let J=0;_t&&(J=Re);let Fe=0,xe=Fe+J,Je=xe+Ee,et=Je+Oe;const Ze=We-J-Ee-Oe;let gt=!1,pt=!1,yt=-1;wt!==2&&(st==="inherit"&&Tt?(gt=!0,pt=!0):it==="on"||it==="bounded"?pt=!0:it==="wordWrapColumn"&&(yt=at));const vt=V._computeMinimapLayout({outerWidth:We,outerHeight:oe,lineHeight:Re,typicalHalfwidthCharacterWidth:qe,pixelRatio:Ve,scrollBeyondLastLine:Ft,minimap:At,verticalScrollbarWidth:Rt,viewLineCount:nt,remainingWidth:Ze,isViewportWrapping:pt},Se.memory||new L);vt.renderMinimap!==0&&vt.minimapLeft===0&&(Fe+=vt.minimapWidth,xe+=vt.minimapWidth,Je+=vt.minimapWidth,et+=vt.minimapWidth);const ht=Ze-vt.minimapWidth,Kt=Math.max(1,Math.floor((ht-Rt-2)/qe)),Xt=Mt?Ot:0;return pt&&(yt=Math.max(1,Kt),it==="bounded"&&(yt=Math.min(yt,at))),{width:We,height:oe,glyphMarginLeft:Fe,glyphMarginWidth:J,lineNumbersLeft:xe,lineNumbersWidth:Ee,decorationsLeft:Je,decorationsWidth:Oe,contentLeft:et,contentWidth:ht,minimap:vt,viewportColumn:Kt,isWordWrapMinified:gt,isViewportWrapping:pt,wrappingColumn:yt,verticalScrollbarWidth:Rt,horizontalScrollbarHeight:mt,overviewRuler:{top:Xt,width:Rt,height:oe-2*Xt,right:0}}}}e.EditorLayoutInfoComputer=V;class j extends I{constructor(){const re={enabled:!0};super(58,"lightbulb",re,{"editor.lightbulb.enabled":{type:"boolean",default:re.enabled,description:u.localize(43,null)}})}validate(re){return!re||typeof re!="object"?this.defaultValue:{enabled:p(re.enabled,this.defaultValue.enabled)}}}class ne extends I{constructor(){const re={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(128,"inlayHints",re,{"editor.inlayHints.enabled":{type:"string",default:re.enabled,description:u.localize(44,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[u.localize(45,null),u.localize(46,null),u.localize(47,null),u.localize(48,null)]},"editor.inlayHints.fontSize":{type:"number",default:re.fontSize,markdownDescription:u.localize(49,null)},"editor.inlayHints.fontFamily":{type:"string",default:re.fontFamily,markdownDescription:u.localize(50,null)},"editor.inlayHints.padding":{type:"boolean",default:re.padding,description:u.localize(51,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Se=re;return typeof Se.enabled=="boolean"&&(Se.enabled=Se.enabled?"on":"off"),{enabled:o(Se.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:f.clampedInt(Se.fontSize,this.defaultValue.fontSize,0,100),fontFamily:m.string(Se.fontFamily,this.defaultValue.fontFamily),padding:p(Se.padding,this.defaultValue.padding)}}}class Y extends a{constructor(){super(60,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,re=>a.clamp(re,0,150),{markdownDescription:u.localize(52,null)})}compute(re,Se,We){return re.fontInfo.lineHeight}}class le extends I{constructor(){const re={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(66,"minimap",re,{"editor.minimap.enabled":{type:"boolean",default:re.enabled,description:u.localize(53,null)},"editor.minimap.autohide":{type:"boolean",default:re.autohide,description:u.localize(54,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[u.localize(55,null),u.localize(56,null),u.localize(57,null)],default:re.size,description:u.localize(58,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:re.side,description:u.localize(59,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:re.showSlider,description:u.localize(60,null)},"editor.minimap.scale":{type:"number",default:re.scale,minimum:1,maximum:3,enum:[1,2,3],description:u.localize(61,null)},"editor.minimap.renderCharacters":{type:"boolean",default:re.renderCharacters,description:u.localize(62,null)},"editor.minimap.maxColumn":{type:"number",default:re.maxColumn,description:u.localize(63,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Se=re;return{enabled:p(Se.enabled,this.defaultValue.enabled),autohide:p(Se.autohide,this.defaultValue.autohide),size:o(Se.size,this.defaultValue.size,["proportional","fill","fit"]),side:o(Se.side,this.defaultValue.side,["right","left"]),showSlider:o(Se.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:p(Se.renderCharacters,this.defaultValue.renderCharacters),scale:f.clampedInt(Se.scale,1,1,3),maxColumn:f.clampedInt(Se.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ue(Z){return Z==="ctrlCmd"?n.isMacintosh?"metaKey":"ctrlKey":"altKey"}class K extends I{constructor(){super(76,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:u.localize(64,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:u.localize(65,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Se=re;return{top:f.clampedInt(Se.top,0,0,1e3),bottom:f.clampedInt(Se.bottom,0,0,1e3)}}}class ge extends I{constructor(){const re={enabled:!0,cycle:!1};super(77,"parameterHints",re,{"editor.parameterHints.enabled":{type:"boolean",default:re.enabled,description:u.localize(66,null)},"editor.parameterHints.cycle":{type:"boolean",default:re.cycle,description:u.localize(67,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Se=re;return{enabled:p(Se.enabled,this.defaultValue.enabled),cycle:p(Se.cycle,this.defaultValue.cycle)}}}class ye extends w{constructor(){super(130)}compute(re,Se,We){return re.pixelRatio}}class Te extends I{constructor(){const re={other:"on",comments:"off",strings:"off"},Se=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[u.localize(68,null),u.localize(69,null),u.localize(70,null)]}];super(80,"quickSuggestions",re,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Se,default:re.strings,description:u.localize(71,null)},comments:{anyOf:Se,default:re.comments,description:u.localize(72,null)},other:{anyOf:Se,default:re.other,description:u.localize(73,null)}},default:re,markdownDescription:u.localize(74,null)});this.defaultValue=re}validate(re){if(typeof re=="boolean"){const Ve=re?"on":"off";return{comments:Ve,strings:Ve,other:Ve}}if(!re||typeof re!="object")return this.defaultValue;const{other:Se,comments:We,strings:oe}=re,Re=["on","inline","off"];let Be,qe,je;return typeof Se=="boolean"?Be=Se?"on":"off":Be=o(Se,this.defaultValue.other,Re),typeof We=="boolean"?qe=We?"on":"off":qe=o(We,this.defaultValue.comments,Re),typeof oe=="boolean"?je=oe?"on":"off":je=o(oe,this.defaultValue.strings,Re),{other:Be,comments:qe,strings:je}}}var pe;(function(Z){Z[Z.Off=0]="Off",Z[Z.On=1]="On",Z[Z.Relative=2]="Relative",Z[Z.Interval=3]="Interval",Z[Z.Custom=4]="Custom"})(pe=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Pe extends I{constructor(){super(61,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[u.localize(75,null),u.localize(76,null),u.localize(77,null),u.localize(78,null)],default:"on",description:u.localize(79,null)})}validate(re){let Se=this.defaultValue.renderType,We=this.defaultValue.renderFn;return typeof re!="undefined"&&(typeof re=="function"?(Se=4,We=re):re==="interval"?Se=3:re==="relative"?Se=2:re==="on"?Se=1:Se=0),{renderType:Se,renderFn:We}}}function fe(Z){const re=Z.get(88);return re==="editable"?Z.get(82):re!=="on"}e.filterValidationDecorations=fe;class ve extends I{constructor(){const re=[],Se={type:"number",description:u.localize(80,null)};super(92,"rulers",re,{type:"array",items:{anyOf:[Se,{type:["object"],properties:{column:Se,color:{type:"string",description:u.localize(81,null),format:"color-hex"}}}]},default:re,description:u.localize(82,null)})}validate(re){if(Array.isArray(re)){const Se=[];for(const We of re)if(typeof We=="number")Se.push({column:f.clampedInt(We,0,0,1e4),color:null});else if(We&&typeof We=="object"){const oe=We;Se.push({column:f.clampedInt(oe.column,0,0,1e4),color:oe.color})}return Se.sort((We,oe)=>We.column-oe.column),Se}return this.defaultValue}}function _e(Z,re){if(typeof Z!="string")return re;switch(Z){case"hidden":return 2;case"visible":return 3;default:return 1}}class ae extends I{constructor(){const re={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(93,"scrollbar",re,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[u.localize(83,null),u.localize(84,null),u.localize(85,null)],default:"auto",description:u.localize(86,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[u.localize(87,null),u.localize(88,null),u.localize(89,null)],default:"auto",description:u.localize(90,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:re.verticalScrollbarSize,description:u.localize(91,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:re.horizontalScrollbarSize,description:u.localize(92,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:re.scrollByPage,description:u.localize(93,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Se=re,We=f.clampedInt(Se.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),oe=f.clampedInt(Se.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:f.clampedInt(Se.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:_e(Se.vertical,this.defaultValue.vertical),horizontal:_e(Se.horizontal,this.defaultValue.horizontal),useShadows:p(Se.useShadows,this.defaultValue.useShadows),verticalHasArrows:p(Se.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:p(Se.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:p(Se.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:p(Se.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:We,horizontalSliderSize:f.clampedInt(Se.horizontalSliderSize,We,0,1e3),verticalScrollbarSize:oe,verticalSliderSize:f.clampedInt(Se.verticalSliderSize,oe,0,1e3),scrollByPage:p(Se.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class he extends I{constructor(){const re={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(114,"unicodeHighlight",re,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:re.nonBasicASCII,description:u.localize(94,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:re.invisibleCharacters,description:u.localize(95,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:re.ambiguousCharacters,description:u.localize(96,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:re.includeComments,description:u.localize(97,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:re.includeStrings,description:u.localize(98,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:re.allowedCharacters,description:u.localize(99,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:re.allowedLocales,description:u.localize(100,null)}})}applyUpdate(re,Se){let We=!1;Se.allowedCharacters&&re&&(D.equals(re.allowedCharacters,Se.allowedCharacters)||(re={...re,allowedCharacters:Se.allowedCharacters},We=!0)),Se.allowedLocales&&re&&(D.equals(re.allowedLocales,Se.allowedLocales)||(re={...re,allowedLocales:Se.allowedLocales},We=!0));const oe=super.applyUpdate(re,Se);return We?new _(oe.newValue,!0):oe}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Se=re;return{nonBasicASCII:H(Se.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:p(Se.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:p(Se.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:H(Se.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:H(Se.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(re.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(re.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(re,Se){if(typeof re!="object"||!re)return Se;const We={};for(const[oe,Re]of Object.entries(re))Re===!0&&(We[oe]=!0);return We}}class te extends I{constructor(){const re={enabled:!0,mode:"subwordSmart"};super(56,"inlineSuggest",re,{"editor.inlineSuggest.enabled":{type:"boolean",default:re.enabled,description:u.localize(101,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Se=re;return{enabled:p(Se.enabled,this.defaultValue.enabled),mode:o(Se.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class ie extends I{constructor(){const re={enabled:C.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:C.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",re,{"editor.bracketPairColorization.enabled":{type:"boolean",default:re.enabled,markdownDescription:u.localize(102,null)},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:re.independentColorPoolPerBracketType,description:u.localize(103,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Se=re;return{enabled:p(Se.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:p(Se.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class M extends I{constructor(){const re={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",re,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[u.localize(104,null),u.localize(105,null),u.localize(106,null)],default:re.bracketPairs,description:u.localize(107,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[u.localize(108,null),u.localize(109,null),u.localize(110,null)],default:re.bracketPairsHorizontal,description:u.localize(111,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:re.highlightActiveBracketPair,description:u.localize(112,null)},"editor.guides.indentation":{type:"boolean",default:re.indentation,description:u.localize(113,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[u.localize(114,null),u.localize(115,null),u.localize(116,null)],default:re.highlightActiveIndentation,description:u.localize(117,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Se=re;return{bracketPairs:H(Se.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:H(Se.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:p(Se.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:p(Se.indentation,this.defaultValue.indentation),highlightActiveIndentation:H(Se.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function H(Z,re,Se){const We=Se.indexOf(Z);return We===-1?re:Se[We]}class G extends I{constructor(){const re={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(107,"suggest",re,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[u.localize(118,null),u.localize(119,null)],default:re.insertMode,description:u.localize(120,null)},"editor.suggest.filterGraceful":{type:"boolean",default:re.filterGraceful,description:u.localize(121,null)},"editor.suggest.localityBonus":{type:"boolean",default:re.localityBonus,description:u.localize(122,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:re.shareSuggestSelections,markdownDescription:u.localize(123,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:re.snippetsPreventQuickSuggestions,description:u.localize(124,null)},"editor.suggest.showIcons":{type:"boolean",default:re.showIcons,description:u.localize(125,null)},"editor.suggest.showStatusBar":{type:"boolean",default:re.showStatusBar,description:u.localize(126,null)},"editor.suggest.preview":{type:"boolean",default:re.preview,description:u.localize(127,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:re.showInlineDetails,description:u.localize(128,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:u.localize(129,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:u.localize(130,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:u.localize(131,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:u.localize(132,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:u.localize(133,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:u.localize(134,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:u.localize(135,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:u.localize(136,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:u.localize(137,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:u.localize(138,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:u.localize(139,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:u.localize(140,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:u.localize(141,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:u.localize(142,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:u.localize(143,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:u.localize(144,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:u.localize(145,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:u.localize(146,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:u.localize(147,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:u.localize(148,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:u.localize(149,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:u.localize(150,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:u.localize(151,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:u.localize(152,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:u.localize(153,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:u.localize(154,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:u.localize(155,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:u.localize(156,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:u.localize(157,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:u.localize(158,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:u.localize(159,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const Se=re;return{insertMode:o(Se.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:p(Se.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:p(Se.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:p(Se.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:p(Se.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:p(Se.showIcons,this.defaultValue.showIcons),showStatusBar:p(Se.showStatusBar,this.defaultValue.showStatusBar),preview:p(Se.preview,this.defaultValue.preview),previewMode:o(Se.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:p(Se.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:p(Se.showMethods,this.defaultValue.showMethods),showFunctions:p(Se.showFunctions,this.defaultValue.showFunctions),showConstructors:p(Se.showConstructors,this.defaultValue.showConstructors),showDeprecated:p(Se.showDeprecated,this.defaultValue.showDeprecated),showFields:p(Se.showFields,this.defaultValue.showFields),showVariables:p(Se.showVariables,this.defaultValue.showVariables),showClasses:p(Se.showClasses,this.defaultValue.showClasses),showStructs:p(Se.showStructs,this.defaultValue.showStructs),showInterfaces:p(Se.showInterfaces,this.defaultValue.showInterfaces),showModules:p(Se.showModules,this.defaultValue.showModules),showProperties:p(Se.showProperties,this.defaultValue.showProperties),showEvents:p(Se.showEvents,this.defaultValue.showEvents),showOperators:p(Se.showOperators,this.defaultValue.showOperators),showUnits:p(Se.showUnits,this.defaultValue.showUnits),showValues:p(Se.showValues,this.defaultValue.showValues),showConstants:p(Se.showConstants,this.defaultValue.showConstants),showEnums:p(Se.showEnums,this.defaultValue.showEnums),showEnumMembers:p(Se.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:p(Se.showKeywords,this.defaultValue.showKeywords),showWords:p(Se.showWords,this.defaultValue.showWords),showColors:p(Se.showColors,this.defaultValue.showColors),showFiles:p(Se.showFiles,this.defaultValue.showFiles),showReferences:p(Se.showReferences,this.defaultValue.showReferences),showFolders:p(Se.showFolders,this.defaultValue.showFolders),showTypeParameters:p(Se.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:p(Se.showSnippets,this.defaultValue.showSnippets),showUsers:p(Se.showUsers,this.defaultValue.showUsers),showIssues:p(Se.showIssues,this.defaultValue.showIssues)}}}class X extends I{constructor(){super(103,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:u.localize(160,null),default:!0,type:"boolean"}})}validate(re){return!re||typeof re!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:p(re.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class de extends w{constructor(){super(131)}compute(re,Se,We){return Se.get(82)?!0:re.tabFocusMode}}var be;(function(Z){Z[Z.None=0]="None",Z[Z.Same=1]="Same",Z[Z.Indent=2]="Indent",Z[Z.DeepIndent=3]="DeepIndent"})(be=e.WrappingIndent||(e.WrappingIndent={}));function se(Z){switch(Z){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class De extends w{constructor(){super(133)}compute(re,Se,We){const oe=Se.get(132);return{isDominatedByLongLines:re.isDominatedByLongLines,isWordWrapMinified:oe.isWordWrapMinified,isViewportWrapping:oe.isViewportWrapping,wrappingColumn:oe.wrappingColumn}}}const Ce="Consolas, 'Courier New', monospace",ze="Menlo, Monaco, 'Courier New', monospace",Ke="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:n.isMacintosh?ze:n.isLinux?Ke:Ce,fontWeight:"normal",fontSize:n.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ne(Z){return e.editorOptionsRegistry[Z.id]=Z,Z}var Ye;(function(Z){Z[Z.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Z[Z.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Z[Z.accessibilitySupport=2]="accessibilitySupport",Z[Z.accessibilityPageSize=3]="accessibilityPageSize",Z[Z.ariaLabel=4]="ariaLabel",Z[Z.autoClosingBrackets=5]="autoClosingBrackets",Z[Z.autoClosingDelete=6]="autoClosingDelete",Z[Z.autoClosingOvertype=7]="autoClosingOvertype",Z[Z.autoClosingQuotes=8]="autoClosingQuotes",Z[Z.autoIndent=9]="autoIndent",Z[Z.automaticLayout=10]="automaticLayout",Z[Z.autoSurround=11]="autoSurround",Z[Z.bracketPairColorization=12]="bracketPairColorization",Z[Z.guides=13]="guides",Z[Z.codeLens=14]="codeLens",Z[Z.codeLensFontFamily=15]="codeLensFontFamily",Z[Z.codeLensFontSize=16]="codeLensFontSize",Z[Z.colorDecorators=17]="colorDecorators",Z[Z.columnSelection=18]="columnSelection",Z[Z.comments=19]="comments",Z[Z.contextmenu=20]="contextmenu",Z[Z.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",Z[Z.cursorBlinking=22]="cursorBlinking",Z[Z.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",Z[Z.cursorStyle=24]="cursorStyle",Z[Z.cursorSurroundingLines=25]="cursorSurroundingLines",Z[Z.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",Z[Z.cursorWidth=27]="cursorWidth",Z[Z.disableLayerHinting=28]="disableLayerHinting",Z[Z.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",Z[Z.domReadOnly=30]="domReadOnly",Z[Z.dragAndDrop=31]="dragAndDrop",Z[Z.enableDropIntoEditor=32]="enableDropIntoEditor",Z[Z.emptySelectionClipboard=33]="emptySelectionClipboard",Z[Z.extraEditorClassName=34]="extraEditorClassName",Z[Z.fastScrollSensitivity=35]="fastScrollSensitivity",Z[Z.find=36]="find",Z[Z.fixedOverflowWidgets=37]="fixedOverflowWidgets",Z[Z.folding=38]="folding",Z[Z.foldingStrategy=39]="foldingStrategy",Z[Z.foldingHighlight=40]="foldingHighlight",Z[Z.foldingImportsByDefault=41]="foldingImportsByDefault",Z[Z.foldingMaximumRegions=42]="foldingMaximumRegions",Z[Z.unfoldOnClickAfterEndOfLine=43]="unfoldOnClickAfterEndOfLine",Z[Z.fontFamily=44]="fontFamily",Z[Z.fontInfo=45]="fontInfo",Z[Z.fontLigatures=46]="fontLigatures",Z[Z.fontSize=47]="fontSize",Z[Z.fontWeight=48]="fontWeight",Z[Z.formatOnPaste=49]="formatOnPaste",Z[Z.formatOnType=50]="formatOnType",Z[Z.glyphMargin=51]="glyphMargin",Z[Z.gotoLocation=52]="gotoLocation",Z[Z.hideCursorInOverviewRuler=53]="hideCursorInOverviewRuler",Z[Z.hover=54]="hover",Z[Z.inDiffEditor=55]="inDiffEditor",Z[Z.inlineSuggest=56]="inlineSuggest",Z[Z.letterSpacing=57]="letterSpacing",Z[Z.lightbulb=58]="lightbulb",Z[Z.lineDecorationsWidth=59]="lineDecorationsWidth",Z[Z.lineHeight=60]="lineHeight",Z[Z.lineNumbers=61]="lineNumbers",Z[Z.lineNumbersMinChars=62]="lineNumbersMinChars",Z[Z.linkedEditing=63]="linkedEditing",Z[Z.links=64]="links",Z[Z.matchBrackets=65]="matchBrackets",Z[Z.minimap=66]="minimap",Z[Z.mouseStyle=67]="mouseStyle",Z[Z.mouseWheelScrollSensitivity=68]="mouseWheelScrollSensitivity",Z[Z.mouseWheelZoom=69]="mouseWheelZoom",Z[Z.multiCursorMergeOverlapping=70]="multiCursorMergeOverlapping",Z[Z.multiCursorModifier=71]="multiCursorModifier",Z[Z.multiCursorPaste=72]="multiCursorPaste",Z[Z.occurrencesHighlight=73]="occurrencesHighlight",Z[Z.overviewRulerBorder=74]="overviewRulerBorder",Z[Z.overviewRulerLanes=75]="overviewRulerLanes",Z[Z.padding=76]="padding",Z[Z.parameterHints=77]="parameterHints",Z[Z.peekWidgetDefaultFocus=78]="peekWidgetDefaultFocus",Z[Z.definitionLinkOpensInPeek=79]="definitionLinkOpensInPeek",Z[Z.quickSuggestions=80]="quickSuggestions",Z[Z.quickSuggestionsDelay=81]="quickSuggestionsDelay",Z[Z.readOnly=82]="readOnly",Z[Z.renameOnType=83]="renameOnType",Z[Z.renderControlCharacters=84]="renderControlCharacters",Z[Z.renderFinalNewline=85]="renderFinalNewline",Z[Z.renderLineHighlight=86]="renderLineHighlight",Z[Z.renderLineHighlightOnlyWhenFocus=87]="renderLineHighlightOnlyWhenFocus",Z[Z.renderValidationDecorations=88]="renderValidationDecorations",Z[Z.renderWhitespace=89]="renderWhitespace",Z[Z.revealHorizontalRightPadding=90]="revealHorizontalRightPadding",Z[Z.roundedSelection=91]="roundedSelection",Z[Z.rulers=92]="rulers",Z[Z.scrollbar=93]="scrollbar",Z[Z.scrollBeyondLastColumn=94]="scrollBeyondLastColumn",Z[Z.scrollBeyondLastLine=95]="scrollBeyondLastLine",Z[Z.scrollPredominantAxis=96]="scrollPredominantAxis",Z[Z.selectionClipboard=97]="selectionClipboard",Z[Z.selectionHighlight=98]="selectionHighlight",Z[Z.selectOnLineNumbers=99]="selectOnLineNumbers",Z[Z.showFoldingControls=100]="showFoldingControls",Z[Z.showUnused=101]="showUnused",Z[Z.snippetSuggestions=102]="snippetSuggestions",Z[Z.smartSelect=103]="smartSelect",Z[Z.smoothScrolling=104]="smoothScrolling",Z[Z.stickyTabStops=105]="stickyTabStops",Z[Z.stopRenderingLineAfter=106]="stopRenderingLineAfter",Z[Z.suggest=107]="suggest",Z[Z.suggestFontSize=108]="suggestFontSize",Z[Z.suggestLineHeight=109]="suggestLineHeight",Z[Z.suggestOnTriggerCharacters=110]="suggestOnTriggerCharacters",Z[Z.suggestSelection=111]="suggestSelection",Z[Z.tabCompletion=112]="tabCompletion",Z[Z.tabIndex=113]="tabIndex",Z[Z.unicodeHighlighting=114]="unicodeHighlighting",Z[Z.unusualLineTerminators=115]="unusualLineTerminators",Z[Z.useShadowDOM=116]="useShadowDOM",Z[Z.useTabStops=117]="useTabStops",Z[Z.wordSeparators=118]="wordSeparators",Z[Z.wordWrap=119]="wordWrap",Z[Z.wordWrapBreakAfterCharacters=120]="wordWrapBreakAfterCharacters",Z[Z.wordWrapBreakBeforeCharacters=121]="wordWrapBreakBeforeCharacters",Z[Z.wordWrapColumn=122]="wordWrapColumn",Z[Z.wordWrapOverride1=123]="wordWrapOverride1",Z[Z.wordWrapOverride2=124]="wordWrapOverride2",Z[Z.wrappingIndent=125]="wrappingIndent",Z[Z.wrappingStrategy=126]="wrappingStrategy",Z[Z.showDeprecated=127]="showDeprecated",Z[Z.inlayHints=128]="inlayHints",Z[Z.editorClassName=129]="editorClassName",Z[Z.pixelRatio=130]="pixelRatio",Z[Z.tabFocusMode=131]="tabFocusMode",Z[Z.layoutInfo=132]="layoutInfo",Z[Z.wrappingInfo=133]="wrappingInfo"})(Ye=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ne(new g(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:u.localize(161,null)})),acceptSuggestionOnEnter:Ne(new d(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",u.localize(162,null),""],markdownDescription:u.localize(163,null)})),accessibilitySupport:Ne(new i),accessibilityPageSize:Ne(new f(3,"accessibilityPageSize",10,1,1073741824,{description:u.localize(164,null)})),ariaLabel:Ne(new m(4,"ariaLabel",u.localize(165,null))),autoClosingBrackets:Ne(new d(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",u.localize(166,null),u.localize(167,null),""],description:u.localize(168,null)})),autoClosingDelete:Ne(new d(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",u.localize(169,null),""],description:u.localize(170,null)})),autoClosingOvertype:Ne(new d(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",u.localize(171,null),""],description:u.localize(172,null)})),autoClosingQuotes:Ne(new d(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",u.localize(173,null),u.localize(174,null),""],description:u.localize(175,null)})),autoIndent:Ne(new r(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],s,{enumDescriptions:[u.localize(176,null),u.localize(177,null),u.localize(178,null),u.localize(179,null),u.localize(180,null)],description:u.localize(181,null)})),automaticLayout:Ne(new g(10,"automaticLayout",!1)),autoSurround:Ne(new d(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[u.localize(182,null),u.localize(183,null),u.localize(184,null),""],description:u.localize(185,null)})),bracketPairColorization:Ne(new ie),bracketPairGuides:Ne(new M),stickyTabStops:Ne(new g(105,"stickyTabStops",!1,{description:u.localize(186,null)})),codeLens:Ne(new g(14,"codeLens",!0,{description:u.localize(187,null)})),codeLensFontFamily:Ne(new m(15,"codeLensFontFamily","",{description:u.localize(188,null)})),codeLensFontSize:Ne(new f(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:u.localize(189,null)})),colorDecorators:Ne(new g(17,"colorDecorators",!0,{description:u.localize(190,null)})),columnSelection:Ne(new g(18,"columnSelection",!1,{description:u.localize(191,null)})),comments:Ne(new t),contextmenu:Ne(new g(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Ne(new g(21,"copyWithSyntaxHighlighting",!0,{description:u.localize(192,null)})),cursorBlinking:Ne(new r(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],l,{description:u.localize(193,null)})),cursorSmoothCaretAnimation:Ne(new g(23,"cursorSmoothCaretAnimation",!1,{description:u.localize(194,null)})),cursorStyle:Ne(new r(24,"cursorStyle",h.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],R,{description:u.localize(195,null)})),cursorSurroundingLines:Ne(new f(25,"cursorSurroundingLines",0,0,1073741824,{description:u.localize(196,null)})),cursorSurroundingLinesStyle:Ne(new d(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[u.localize(197,null),u.localize(198,null)],description:u.localize(199,null)})),cursorWidth:Ne(new f(27,"cursorWidth",0,0,1073741824,{markdownDescription:u.localize(200,null)})),disableLayerHinting:Ne(new g(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ne(new g(29,"disableMonospaceOptimizations",!1)),domReadOnly:Ne(new g(30,"domReadOnly",!1)),dragAndDrop:Ne(new g(31,"dragAndDrop",!0,{description:u.localize(201,null)})),emptySelectionClipboard:Ne(new O),enableDropIntoEditor:Ne(new g(32,"enableDropIntoEditor",!0)),extraEditorClassName:Ne(new m(34,"extraEditorClassName","")),fastScrollSensitivity:Ne(new a(35,"fastScrollSensitivity",5,Z=>Z<=0?5:Z,{markdownDescription:u.localize(202,null)})),find:Ne(new k),fixedOverflowWidgets:Ne(new g(37,"fixedOverflowWidgets",!1)),folding:Ne(new g(38,"folding",!0,{description:u.localize(203,null)})),foldingStrategy:Ne(new d(39,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[u.localize(204,null),u.localize(205,null)],description:u.localize(206,null)})),foldingHighlight:Ne(new g(40,"foldingHighlight",!0,{description:u.localize(207,null)})),foldingImportsByDefault:Ne(new g(41,"foldingImportsByDefault",!1,{description:u.localize(208,null)})),foldingMaximumRegions:Ne(new f(42,"foldingMaximumRegions",5e3,10,65e3,{description:u.localize(209,null)})),unfoldOnClickAfterEndOfLine:Ne(new g(43,"unfoldOnClickAfterEndOfLine",!1,{description:u.localize(210,null)})),fontFamily:Ne(new m(44,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:u.localize(211,null)})),fontInfo:Ne(new F),fontLigatures2:Ne(new U),fontSize:Ne(new $),fontWeight:Ne(new ee),formatOnPaste:Ne(new g(49,"formatOnPaste",!1,{description:u.localize(212,null)})),formatOnType:Ne(new g(50,"formatOnType",!1,{description:u.localize(213,null)})),glyphMargin:Ne(new g(51,"glyphMargin",!0,{description:u.localize(214,null)})),gotoLocation:Ne(new B),hideCursorInOverviewRuler:Ne(new g(53,"hideCursorInOverviewRuler",!1,{description:u.localize(215,null)})),hover:Ne(new z),inDiffEditor:Ne(new g(55,"inDiffEditor",!1)),letterSpacing:Ne(new a(57,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Z=>a.clamp(Z,-5,20),{description:u.localize(216,null)})),lightbulb:Ne(new j),lineDecorationsWidth:Ne(new b(59,"lineDecorationsWidth",10)),lineHeight:Ne(new Y),lineNumbers:Ne(new Pe),lineNumbersMinChars:Ne(new f(62,"lineNumbersMinChars",5,1,300)),linkedEditing:Ne(new g(63,"linkedEditing",!1,{description:u.localize(217,null)})),links:Ne(new g(64,"links",!0,{description:u.localize(218,null)})),matchBrackets:Ne(new d(65,"matchBrackets","always",["always","near","never"],{description:u.localize(219,null)})),minimap:Ne(new le),mouseStyle:Ne(new d(67,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ne(new a(68,"mouseWheelScrollSensitivity",1,Z=>Z===0?1:Z,{markdownDescription:u.localize(220,null)})),mouseWheelZoom:Ne(new g(69,"mouseWheelZoom",!1,{markdownDescription:u.localize(221,null)})),multiCursorMergeOverlapping:Ne(new g(70,"multiCursorMergeOverlapping",!0,{description:u.localize(222,null)})),multiCursorModifier:Ne(new r(71,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ue,{markdownEnumDescriptions:[u.localize(223,null),u.localize(224,null)],markdownDescription:u.localize(225,null)})),multiCursorPaste:Ne(new d(72,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[u.localize(226,null),u.localize(227,null)],markdownDescription:u.localize(228,null)})),occurrencesHighlight:Ne(new g(73,"occurrencesHighlight",!0,{description:u.localize(229,null)})),overviewRulerBorder:Ne(new g(74,"overviewRulerBorder",!0,{description:u.localize(230,null)})),overviewRulerLanes:Ne(new f(75,"overviewRulerLanes",3,0,3)),padding:Ne(new K),parameterHints:Ne(new ge),peekWidgetDefaultFocus:Ne(new d(78,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[u.localize(231,null),u.localize(232,null)],description:u.localize(233,null)})),definitionLinkOpensInPeek:Ne(new g(79,"definitionLinkOpensInPeek",!1,{description:u.localize(234,null)})),quickSuggestions:Ne(new Te),quickSuggestionsDelay:Ne(new f(81,"quickSuggestionsDelay",10,0,1073741824,{description:u.localize(235,null)})),readOnly:Ne(new g(82,"readOnly",!1)),renameOnType:Ne(new g(83,"renameOnType",!1,{description:u.localize(236,null),markdownDeprecationMessage:u.localize(237,null)})),renderControlCharacters:Ne(new g(84,"renderControlCharacters",!0,{description:u.localize(238,null),restricted:!0})),renderFinalNewline:Ne(new g(85,"renderFinalNewline",!0,{description:u.localize(239,null)})),renderLineHighlight:Ne(new d(86,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",u.localize(240,null)],description:u.localize(241,null)})),renderLineHighlightOnlyWhenFocus:Ne(new g(87,"renderLineHighlightOnlyWhenFocus",!1,{description:u.localize(242,null)})),renderValidationDecorations:Ne(new d(88,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ne(new d(89,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",u.localize(243,null),u.localize(244,null),u.localize(245,null),""],description:u.localize(246,null)})),revealHorizontalRightPadding:Ne(new f(90,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Ne(new g(91,"roundedSelection",!0,{description:u.localize(247,null)})),rulers:Ne(new ve),scrollbar:Ne(new ae),scrollBeyondLastColumn:Ne(new f(94,"scrollBeyondLastColumn",4,0,1073741824,{description:u.localize(248,null)})),scrollBeyondLastLine:Ne(new g(95,"scrollBeyondLastLine",!0,{description:u.localize(249,null)})),scrollPredominantAxis:Ne(new g(96,"scrollPredominantAxis",!0,{description:u.localize(250,null)})),selectionClipboard:Ne(new g(97,"selectionClipboard",!0,{description:u.localize(251,null),included:n.isLinux})),selectionHighlight:Ne(new g(98,"selectionHighlight",!0,{description:u.localize(252,null)})),selectOnLineNumbers:Ne(new g(99,"selectOnLineNumbers",!0)),showFoldingControls:Ne(new d(100,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[u.localize(253,null),u.localize(254,null)],description:u.localize(255,null)})),showUnused:Ne(new g(101,"showUnused",!0,{description:u.localize(256,null)})),showDeprecated:Ne(new g(127,"showDeprecated",!0,{description:u.localize(257,null)})),inlayHints:Ne(new ne),snippetSuggestions:Ne(new d(102,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[u.localize(258,null),u.localize(259,null),u.localize(260,null),u.localize(261,null)],description:u.localize(262,null)})),smartSelect:Ne(new X),smoothScrolling:Ne(new g(104,"smoothScrolling",!1,{description:u.localize(263,null)})),stopRenderingLineAfter:Ne(new f(106,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ne(new G),inlineSuggest:Ne(new te),suggestFontSize:Ne(new f(108,"suggestFontSize",0,0,1e3,{markdownDescription:u.localize(264,null)})),suggestLineHeight:Ne(new f(109,"suggestLineHeight",0,0,1e3,{markdownDescription:u.localize(265,null)})),suggestOnTriggerCharacters:Ne(new g(110,"suggestOnTriggerCharacters",!0,{description:u.localize(266,null)})),suggestSelection:Ne(new d(111,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[u.localize(267,null),u.localize(268,null),u.localize(269,null)],description:u.localize(270,null)})),tabCompletion:Ne(new d(112,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[u.localize(271,null),u.localize(272,null),u.localize(273,null)],description:u.localize(274,null)})),tabIndex:Ne(new f(113,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ne(new he),unusualLineTerminators:Ne(new d(115,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[u.localize(275,null),u.localize(276,null),u.localize(277,null)],description:u.localize(278,null)})),useShadowDOM:Ne(new g(116,"useShadowDOM",!0)),useTabStops:Ne(new g(117,"useTabStops",!0,{description:u.localize(279,null)})),wordSeparators:Ne(new m(118,"wordSeparators",y.USUAL_WORD_SEPARATORS,{description:u.localize(280,null)})),wordWrap:Ne(new d(119,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[u.localize(281,null),u.localize(282,null),u.localize(283,null),u.localize(284,null)],description:u.localize(285,null)})),wordWrapBreakAfterCharacters:Ne(new m(120,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ne(new m(121,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ne(new f(122,"wordWrapColumn",80,1,1073741824,{markdownDescription:u.localize(286,null)})),wordWrapOverride1:Ne(new d(123,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ne(new d(124,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Ne(new r(125,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],se,{enumDescriptions:[u.localize(287,null),u.localize(288,null),u.localize(289,null),u.localize(290,null)],description:u.localize(291,null)})),wrappingStrategy:Ne(new d(126,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[u.localize(292,null),u.localize(293,null)],description:u.localize(294,null)})),editorClassName:Ne(new N),pixelRatio:Ne(new ye),tabFocusMode:Ne(new de),layoutInfo:Ne(new V),wrappingInfo:Ne(new De)}}),define(Ie[164],ke([19,20]),function(Q,e){return Q.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ie[165],ke([19,20]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ie[166],ke([19,20]),function(Q,e){return Q.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ie[167],ke([19,20]),function(Q,e){return Q.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Ie[168],ke([19,20]),function(Q,e){return Q.create("vs/platform/files/common/files",e)}),define(Ie[169],ke([19,20]),function(Q,e){return Q.create("vs/platform/markers/common/markers",e)}),define(Ie[170],ke([19,20]),function(Q,e){return Q.create("vs/platform/workspace/common/workspace",e)}),define(Ie[171],ke([19,20]),function(Q,e){return Q.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ie[172],ke([19,20]),function(Q,e){return Q.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ie[173],ke([19,20]),function(Q,e){return Q.create("vs/workbench/api/common/extHostProgress",e)}),define(Ie[174],ke([19,20]),function(Q,e){return Q.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ie[175],ke([19,20]),function(Q,e){return Q.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ie[176],ke([19,20]),function(Q,e){return Q.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ie[177],ke([19,20]),function(Q,e){return Q.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ie[178],ke([19,20]),function(Q,e){return Q.create("vs/workbench/api/node/extHostDebugService",e)}),define(Ie[179],ke([19,20]),function(Q,e){return Q.create("vs/workbench/api/node/extHostTunnelService",e)}),define(Ie[180],ke([19,20]),function(Q,e){return Q.create("vs/workbench/common/editor",e)}),define(Ie[181],ke([19,20]),function(Q,e){return Q.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ie[182],ke([19,20]),function(Q,e){return Q.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ie[183],ke([19,20]),function(Q,e){return Q.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(Ie[184],ke([19,20]),function(Q,e){return Q.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ie[185],ke([19,20]),function(Q,e){return Q.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ie[186],ke([19,20]),function(Q,e){return Q.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ie[187],ke([19,20]),function(Q,e){return Q.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ie[188],ke([19,20]),function(Q,e){return Q.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ie[189],ke([1,0]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionSource=e.TextEditorSelectionRevealType=e.EditorOpenSource=e.EditorResolution=e.EditorActivation=void 0;var u;(function(C){C[C.ACTIVATE=1]="ACTIVATE",C[C.RESTORE=2]="RESTORE",C[C.PRESERVE=3]="PRESERVE"})(u=e.EditorActivation||(e.EditorActivation={}));var n;(function(C){C[C.PICK=0]="PICK",C[C.DISABLED=1]="DISABLED",C[C.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(n=e.EditorResolution||(e.EditorResolution={}));var y;(function(C){C[C.API=0]="API",C[C.USER=1]="USER"})(y=e.EditorOpenSource||(e.EditorOpenSource={}));var A;(function(C){C[C.Center=0]="Center",C[C.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",C[C.NearTop=2]="NearTop",C[C.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(A=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}));var D;(function(C){C.PROGRAMMATIC="api",C.NAVIGATION="code.navigation",C.JUMP="code.jump"})(D=e.TextEditorSelectionSource||(e.TextEditorSelectionSource={}))}),define(Ie[190],ke([1,0,22,41,166,303]),function(Q,e,u,n,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,C=/^-(\d{4})(\d{2})(\d{2})$/;function S(g){return g=g.trim(),g==="*"||D.test(g)}e.isValidVersionStr=S;function P(g){if(!S(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const v=g.match(D);return v?{hasCaret:v[1]==="^",hasGreaterEquals:v[1]===">=",majorBase:v[2]==="x"?0:parseInt(v[2],10),majorMustEqual:v[2]!=="x",minorBase:v[4]==="x"?0:parseInt(v[4],10),minorMustEqual:v[4]!=="x",patchBase:v[6]==="x"?0:parseInt(v[6],10),patchMustEqual:v[6]!=="x",preRelease:v[8]||null}:null}e.parseVersion=P;function L(g){if(!g)return null;const v=g.majorBase,f=g.majorMustEqual,a=g.minorBase;let m=g.minorMustEqual;const o=g.patchBase;let d=g.patchMustEqual;g.hasCaret&&(v===0||(m=!1),d=!1);let r=0;if(g.preRelease){const s=C.exec(g.preRelease);if(s){const[,i,t,c]=s;r=Date.UTC(Number(i),Number(t)-1,Number(c))}}return{majorBase:v,majorMustEqual:f,minorBase:a,minorMustEqual:m,patchBase:o,patchMustEqual:d,isMinimum:g.hasGreaterEquals,notBefore:r}}e.normalizeVersion=L;function I(g,v,f){let a;typeof g=="string"?a=L(P(g)):a=g;let m;v instanceof Date?m=v.getTime():typeof v=="string"&&(m=new Date(v).getTime());let o;if(typeof f=="string"?o=L(P(f)):o=f,!a||!o)return!1;const d=a.majorBase,r=a.minorBase,s=a.patchBase;let i=o.majorBase,t=o.minorBase,c=o.patchBase;const l=o.notBefore;let h=o.majorMustEqual,E=o.minorMustEqual,R=o.patchMustEqual;return o.isMinimum?d>i?!0:d<i?!1:r>t?!0:r<t||m&&m<l?!1:s>=c:(d===1&&i===0&&(!h||!E||!R)&&(i=1,t=0,c=0,h=!0,E=!1,R=!1),d<i?!1:d>i?!h:r<t?!1:r>t?!E:s<c?!1:s>c?!R:!(m&&m<l))}e.isValidVersion=I;function _(g,v,f,a,m){const o=[];if(typeof a.publisher!="undefined"&&typeof a.publisher!="string")return o.push([n.default.Error,y.localize(0,null)]),o;if(typeof a.name!="string")return o.push([n.default.Error,y.localize(1,null,"name")]),o;if(typeof a.version!="string")return o.push([n.default.Error,y.localize(2,null,"version")]),o;if(!a.engines)return o.push([n.default.Error,y.localize(3,null,"engines")]),o;if(typeof a.engines.vscode!="string")return o.push([n.default.Error,y.localize(4,null,"engines.vscode")]),o;if(typeof a.extensionDependencies!="undefined"&&!p(a.extensionDependencies))return o.push([n.default.Error,y.localize(5,null,"extensionDependencies")]),o;if(typeof a.activationEvents!="undefined"){if(!p(a.activationEvents))return o.push([n.default.Error,y.localize(6,null,"activationEvents")]),o;if(typeof a.main=="undefined"&&typeof a.browser=="undefined")return o.push([n.default.Error,y.localize(7,null,"activationEvents","main")]),o}if(typeof a.extensionKind!="undefined"&&typeof a.main=="undefined"&&o.push([n.default.Warning,y.localize(8,null,"extensionKind")]),typeof a.main!="undefined"){if(typeof a.main!="string")return o.push([n.default.Error,y.localize(9,null,"main")]),o;{const s=(0,u.joinPath)(f,a.main);(0,u.isEqualOrParent)(s,f)||o.push([n.default.Warning,y.localize(10,null,s.path,f.path)])}if(typeof a.activationEvents=="undefined")return o.push([n.default.Error,y.localize(11,null,"activationEvents","main")]),o}if(typeof a.browser!="undefined"){if(typeof a.browser!="string")return o.push([n.default.Error,y.localize(12,null,"browser")]),o;{const s=(0,u.joinPath)(f,a.browser);(0,u.isEqualOrParent)(s,f)||o.push([n.default.Warning,y.localize(13,null,s.path,f.path)])}if(typeof a.activationEvents=="undefined")return o.push([n.default.Error,y.localize(14,null,"activationEvents","browser")]),o}if(!A.valid(a.version))return o.push([n.default.Error,y.localize(15,null)]),o;const d=[];if(!T(g,v,a,m,d))for(const s of d)o.push([n.default.Error,s]);return o}e.validateExtensionManifest=_;function T(g,v,f,a,m){return a||typeof f.main=="undefined"&&typeof f.browser=="undefined"?!0:b(g,v,f.engines.vscode,m)}e.isValidExtensionVersion=T;function w(g,v,f){return g==="*"||b(v,f,g)}e.isEngineValid=w;function b(g,v,f,a=[]){const m=L(P(f));if(!m)return a.push(y.localize(16,null,f)),!1;if(m.majorBase===0){if(!m.majorMustEqual||!m.minorMustEqual)return a.push(y.localize(17,null,f)),!1}else if(!m.majorMustEqual)return a.push(y.localize(18,null,f)),!1;return I(g,v,m)?!0:(a.push(y.localize(19,null,g,f)),!1)}function p(g){if(!Array.isArray(g))return!1;for(let v=0,f=g.length;v<f;v++)if(typeof g[v]!="string")return!1;return!0}}),define(Ie[115],ke([1,0]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class u{constructor(y,A=[],D=!1){this.ctor=y,this.staticArguments=A,this.supportsDelayedInstantiation=D}}e.SyncDescriptor=u}),define(Ie[82],ke([1,0,115]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const n=[];function y(D,C,S){C instanceof u.SyncDescriptor||(C=new u.SyncDescriptor(C,[],S)),n.push([D,C])}e.registerSingleton=y;function A(){return n}e.getSingletonServiceDescriptors=A}),define(Ie[191],ke([1,0]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class u{constructor(A){this.incoming=new Map,this.outgoing=new Map,this.data=A}}e.Node=u;class n{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(const D of this._nodes.values())D.outgoing.size===0&&A.push(D);return A}insertEdge(A,D){const C=this.lookupOrInsertNode(A),S=this.lookupOrInsertNode(D);C.outgoing.set(this._hashFn(D),S),S.incoming.set(this._hashFn(A),C)}removeNode(A){const D=this._hashFn(A);this._nodes.delete(D);for(const C of this._nodes.values())C.outgoing.delete(D),C.incoming.delete(D)}lookupOrInsertNode(A){const D=this._hashFn(A);let C=this._nodes.get(D);return C||(C=new u(A),this._nodes.set(D,C)),C}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){const A=[];for(const[D,C]of this._nodes)A.push(`${D}, (incoming)[${[...C.incoming.keys()].join(", ")}], (outgoing)[${[...C.outgoing.keys()].join(",")}]`);return A.join(`
`)}findCycleSlow(){for(const[A,D]of this._nodes){const C=new Set([A]),S=this._findCycle(D,C);if(S)return S}}_findCycle(A,D){for(const[C,S]of A.outgoing){if(D.has(C))return[...D,C].join(" -> ");D.add(C);const P=this._findCycle(S,D);if(P)return P;D.delete(C)}}}e.Graph=n}),define(Ie[4],ke([1,0]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var u;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function C(S){return S[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=C})(u=e._util||(e._util={})),e.IInstantiationService=y("instantiationService");function n(D,C,S){C[u.DI_TARGET]===C?C[u.DI_DEPENDENCIES].push({id:D,index:S}):(C[u.DI_DEPENDENCIES]=[{id:D,index:S}],C[u.DI_TARGET]=C)}function y(D){if(u.serviceIds.has(D))return u.serviceIds.get(D);const C=function(S,P,L){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");n(C,S,L)};return C.toString=()=>D,u.serviceIds.set(D,C),C}e.createDecorator=y;function A(D){return D}e.refineServiceDecorator=A}),define(Ie[83],ke([1,0,10,2,4]),function(Q,e,u,n,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,y.createDecorator)("configurationService");function A(g){return g&&typeof g=="object"&&(!g.overrideIdentifier||typeof g.overrideIdentifier=="string")&&(!g.resource||g.resource instanceof n.URI)}e.isConfigurationOverrides=A;function D(g){return g&&typeof g=="object"&&(!g.overrideIdentifiers||u.isArray(g.overrideIdentifiers))&&!g.overrideIdentifier&&(!g.resource||g.resource instanceof n.URI)}e.isConfigurationUpdateOverrides=D;var C;(function(g){g[g.USER=1]="USER",g[g.USER_LOCAL=2]="USER_LOCAL",g[g.USER_REMOTE=3]="USER_REMOTE",g[g.WORKSPACE=4]="WORKSPACE",g[g.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",g[g.DEFAULT=6]="DEFAULT",g[g.MEMORY=7]="MEMORY"})(C=e.ConfigurationTarget||(e.ConfigurationTarget={}));function S(g){switch(g){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=S;function P(g,v){const f=Object.create(null);for(const a in g)L(f,a,g[a],v);return f}e.toValuesTree=P;function L(g,v,f,a){const m=v.split("."),o=m.pop();let d=g;for(let r=0;r<m.length;r++){const s=m[r];let i=d[s];switch(typeof i){case"undefined":i=d[s]=Object.create(null);break;case"object":break;default:a(`Ignoring ${v} as ${m.slice(0,r+1).join(".")} is ${JSON.stringify(i)}`);return}d=i}if(typeof d=="object"&&d!==null)try{d[o]=f}catch{a(`Ignoring ${v} as ${m.join(".")} is ${JSON.stringify(d)}`)}else a(`Ignoring ${v} as ${m.join(".")} is ${JSON.stringify(d)}`)}e.addToValueTree=L;function I(g,v){const f=v.split(".");_(g,f)}e.removeFromValueTree=I;function _(g,v){const f=v.shift();if(v.length===0){delete g[f];return}if(Object.keys(g).indexOf(f)!==-1){const a=g[f];typeof a=="object"&&!Array.isArray(a)&&(_(a,v),Object.keys(a).length===0&&delete g[f])}}function T(g,v,f){function a(d,r){let s=d;for(const i of r){if(typeof s!="object"||s===null)return;s=s[i]}return s}const m=v.split("."),o=a(g,m);return typeof o=="undefined"?f:o}e.getConfigurationValue=T;function w(g,v,f){Object.keys(v).forEach(a=>{a!=="__proto__"&&(a in g?u.isObject(g[a])&&u.isObject(v[a])?w(g[a],v[a],f):f&&(g[a]=v[a]):g[a]=v[a])})}e.merge=w;function b(g,v,f){const a=g.inspect(v),m=g.inspect(f);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof m.userValue!="undefined"||typeof m.workspaceValue!="undefined"||typeof m.workspaceFolderValue!="undefined"?m.value:a.defaultValue}e.getMigratedSettingValue=b;function p(g){return g.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=p}),define(Ie[51],ke([1,0,13,8,4]),function(Q,e,u,n,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const A=new Map;A.set("false",!1),A.set("true",!0),A.set("isMac",u.isMacintosh),A.set("isLinux",u.isLinux),A.set("isWindows",u.isWindows),A.set("isWeb",u.isWeb),A.set("isMacNative",u.isMacintosh&&!u.isWeb),A.set("isEdge",u.isEdge),A.set("isFirefox",u.isFirefox),A.set("isChrome",u.isChrome),A.set("isSafari",u.isSafari);const D=Object.prototype.hasOwnProperty;var C;(function(O){O[O.False=0]="False",O[O.True=1]="True",O[O.Defined=2]="Defined",O[O.Not=3]="Not",O[O.Equals=4]="Equals",O[O.NotEquals=5]="NotEquals",O[O.And=6]="And",O[O.Regex=7]="Regex",O[O.NotRegex=8]="NotRegex",O[O.Or=9]="Or",O[O.In=10]="In",O[O.NotIn=11]="NotIn",O[O.Greater=12]="Greater",O[O.GreaterEquals=13]="GreaterEquals",O[O.Smaller=14]="Smaller",O[O.SmallerEquals=15]="SmallerEquals"})(C=e.ContextKeyExprType||(e.ContextKeyExprType={}));class S{static false(){return I.INSTANCE}static true(){return _.INSTANCE}static has(k){return T.create(k)}static equals(k,U){return w.create(k,U)}static notEquals(k,U){return g.create(k,U)}static regex(k,U){return r.create(k,U)}static in(k,U){return b.create(k,U)}static not(k){return v.create(k)}static and(...k){return t.create(k,null)}static or(...k){return c.create(k,null,!0)}static greater(k,U){return a.create(k,U)}static greaterEquals(k,U){return m.create(k,U)}static smaller(k,U){return o.create(k,U)}static smallerEquals(k,U){return d.create(k,U)}static deserialize(k,U=!1){if(!!k)return this._deserializeOrExpression(k,U)}static _deserializeOrExpression(k,U){const F=k.split("||");return c.create(F.map($=>this._deserializeAndExpression($,U)),null,!0)}static _deserializeAndExpression(k,U){const F=k.split("&&");return t.create(F.map($=>this._deserializeOne($,U)),null)}static _deserializeOne(k,U){if(k=k.trim(),k.indexOf("!=")>=0){const F=k.split("!=");return g.create(F[0].trim(),this._deserializeValue(F[1],U))}if(k.indexOf("==")>=0){const F=k.split("==");return w.create(F[0].trim(),this._deserializeValue(F[1],U))}if(k.indexOf("=~")>=0){const F=k.split("=~");return r.create(F[0].trim(),this._deserializeRegexValue(F[1],U))}if(k.indexOf(" in ")>=0){const F=k.split(" in ");return b.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(k)){const F=k.split(">=");return m.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(k)){const F=k.split(">");return a.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(k)){const F=k.split("<=");return d.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(k)){const F=k.split("<");return o.create(F[0].trim(),F[1].trim())}return/^\!\s*/.test(k)?v.create(k.substr(1).trim()):T.create(k)}static _deserializeValue(k,U){if(k=k.trim(),k==="true")return!0;if(k==="false")return!1;const F=/^'([^']*)'$/.exec(k);return F?F[1].trim():k}static _deserializeRegexValue(k,U){if((0,n.isFalsyOrWhitespace)(k)){if(U)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const F=k.indexOf("/"),$=k.lastIndexOf("/");if(F===$||F<0){if(U)throw new Error(`bad regexp-value '${k}', missing /-enclosure`);return console.warn(`bad regexp-value '${k}', missing /-enclosure`),null}const ee=k.slice(F+1,$),B=k[$+1]==="i"?"i":"";try{return new RegExp(ee,B)}catch(z){if(U)throw new Error(`bad regexp-value '${k}', parse error: ${z}`);return console.warn(`bad regexp-value '${k}', parse error: ${z}`),null}}}e.ContextKeyExpr=S;function P(O,k){const U=O?O.substituteConstants():void 0,F=k?k.substituteConstants():void 0;return!U&&!F?!0:!U||!F?!1:U.equals(F)}e.expressionsAreEqualWithConstantSubstitution=P;function L(O,k){return O.cmp(k)}class I{constructor(){this.type=0}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!1}serialize(){return"false"}keys(){return[]}map(k){return this}negate(){return _.INSTANCE}}e.ContextKeyFalseExpr=I,I.INSTANCE=new I;class _{constructor(){this.type=1}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!0}serialize(){return"true"}keys(){return[]}map(k){return this}negate(){return I.INSTANCE}}e.ContextKeyTrueExpr=_,_.INSTANCE=new _;class T{constructor(k,U){this.key=k,this.negated=U,this.type=2}static create(k,U=null){const F=A.get(k);return typeof F=="boolean"?F?_.INSTANCE:I.INSTANCE:new T(k,U)}cmp(k){return k.type!==this.type?this.type-k.type:h(this.key,k.key)}equals(k){return k.type===this.type?this.key===k.key:!1}substituteConstants(){const k=A.get(this.key);return typeof k=="boolean"?k?_.INSTANCE:I.INSTANCE:this}evaluate(k){return!!k.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(k){return k.mapDefined(this.key)}negate(){return this.negated||(this.negated=v.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=T;class w{constructor(k,U,F){this.key=k,this.value=U,this.negated=F,this.type=4}static create(k,U,F=null){if(typeof U=="boolean")return U?T.create(k,F):v.create(k,F);const $=A.get(k);return typeof $=="boolean"?U===($?"true":"false")?_.INSTANCE:I.INSTANCE:new w(k,U,F)}cmp(k){return k.type!==this.type?this.type-k.type:E(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){const k=A.get(this.key);if(typeof k=="boolean"){const U=k?"true":"false";return this.value===U?_.INSTANCE:I.INSTANCE}return this}evaluate(k){return k.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(k){return k.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=g.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=w;class b{constructor(k,U){this.key=k,this.valueKey=U,this.type=10,this.negated=null}static create(k,U){return new b(k,U)}cmp(k){return k.type!==this.type?this.type-k.type:E(this.key,this.valueKey,k.key,k.valueKey)}equals(k){return k.type===this.type?this.key===k.key&&this.valueKey===k.valueKey:!1}substituteConstants(){return this}evaluate(k){const U=k.getValue(this.valueKey),F=k.getValue(this.key);return Array.isArray(U)?U.includes(F):typeof F=="string"&&typeof U=="object"&&U!==null?D.call(U,F):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(k){return k.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=p.create(this)),this.negated}}e.ContextKeyInExpr=b;class p{constructor(k){this._actual=k,this.type=11}static create(k){return new p(k)}cmp(k){return k.type!==this.type?this.type-k.type:this._actual.cmp(k._actual)}equals(k){return k.type===this.type?this._actual.equals(k._actual):!1}substituteConstants(){return this}evaluate(k){return!this._actual.evaluate(k)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(k){return new p(this._actual.map(k))}negate(){return this._actual}}e.ContextKeyNotInExpr=p;class g{constructor(k,U,F){this.key=k,this.value=U,this.negated=F,this.type=5}static create(k,U,F=null){if(typeof U=="boolean")return U?v.create(k,F):T.create(k,F);const $=A.get(k);return typeof $=="boolean"?U===($?"true":"false")?I.INSTANCE:_.INSTANCE:new g(k,U,F)}cmp(k){return k.type!==this.type?this.type-k.type:E(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){const k=A.get(this.key);if(typeof k=="boolean"){const U=k?"true":"false";return this.value===U?I.INSTANCE:_.INSTANCE}return this}evaluate(k){return k.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(k){return k.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=w.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=g;class v{constructor(k,U){this.key=k,this.negated=U,this.type=3}static create(k,U=null){const F=A.get(k);return typeof F=="boolean"?F?I.INSTANCE:_.INSTANCE:new v(k,U)}cmp(k){return k.type!==this.type?this.type-k.type:h(this.key,k.key)}equals(k){return k.type===this.type?this.key===k.key:!1}substituteConstants(){const k=A.get(this.key);return typeof k=="boolean"?k?I.INSTANCE:_.INSTANCE:this}evaluate(k){return!k.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(k){return k.mapNot(this.key)}negate(){return this.negated||(this.negated=T.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=v;function f(O,k){if(typeof O=="string"){const U=parseFloat(O);isNaN(U)||(O=U)}return typeof O=="string"||typeof O=="number"?k(O):I.INSTANCE}class a{constructor(k,U,F){this.key=k,this.value=U,this.negated=F,this.type=12}static create(k,U,F=null){return f(U,$=>new a(k,$,F))}cmp(k){return k.type!==this.type?this.type-k.type:E(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(k){return k.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=d.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=a;class m{constructor(k,U,F){this.key=k,this.value=U,this.negated=F,this.type=13}static create(k,U,F=null){return f(U,$=>new m(k,$,F))}cmp(k){return k.type!==this.type?this.type-k.type:E(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(k){return k.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=m;class o{constructor(k,U,F){this.key=k,this.value=U,this.negated=F,this.type=14}static create(k,U,F=null){return f(U,$=>new o(k,$,F))}cmp(k){return k.type!==this.type?this.type-k.type:E(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(k){return k.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=m.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=o;class d{constructor(k,U,F){this.key=k,this.value=U,this.negated=F,this.type=15}static create(k,U,F=null){return f(U,$=>new d(k,$,F))}cmp(k){return k.type!==this.type?this.type-k.type:E(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(k){return k.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=d;class r{constructor(k,U){this.key=k,this.regexp=U,this.type=7,this.negated=null}static create(k,U){return new r(k,U)}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.key<k.key)return-1;if(this.key>k.key)return 1;const U=this.regexp?this.regexp.source:"",F=k.regexp?k.regexp.source:"";return U<F?-1:U>F?1:0}equals(k){if(k.type===this.type){const U=this.regexp?this.regexp.source:"",F=k.regexp?k.regexp.source:"";return this.key===k.key&&U===F}return!1}substituteConstants(){return this}evaluate(k){const U=k.getValue(this.key);return this.regexp?this.regexp.test(U):!1}serialize(){const k=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${k}`}keys(){return[this.key]}map(k){return k.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=s.create(this)),this.negated}}e.ContextKeyRegexExpr=r;class s{constructor(k){this._actual=k,this.type=8}static create(k){return new s(k)}cmp(k){return k.type!==this.type?this.type-k.type:this._actual.cmp(k._actual)}equals(k){return k.type===this.type?this._actual.equals(k._actual):!1}substituteConstants(){return this}evaluate(k){return!this._actual.evaluate(k)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(k){return new s(this._actual.map(k))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;function i(O){let k=null;for(let U=0,F=O.length;U<F;U++){const $=O[U].substituteConstants();if(O[U]!==$&&k===null){k=[];for(let ee=0;ee<U;ee++)k[ee]=O[ee]}k!==null&&(k[U]=$)}return k===null?O:k}class t{constructor(k,U){this.expr=k,this.negated=U,this.type=6}static create(k,U){return t._normalizeArr(k,U)}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let U=0,F=this.expr.length;U<F;U++){const $=L(this.expr[U],k.expr[U]);if($!==0)return $}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let U=0,F=this.expr.length;U<F;U++)if(!this.expr[U].equals(k.expr[U]))return!1;return!0}return!1}substituteConstants(){const k=i(this.expr);return k===this.expr?this:t.create(k,this.negated)}evaluate(k){for(let U=0,F=this.expr.length;U<F;U++)if(!this.expr[U].evaluate(k))return!1;return!0}static _normalizeArr(k,U){const F=[];let $=!1;for(const ee of k)if(!!ee){if(ee.type===1){$=!0;continue}if(ee.type===0)return I.INSTANCE;if(ee.type===6){F.push(...ee.expr);continue}F.push(ee)}if(F.length===0&&$)return _.INSTANCE;if(F.length!==0){if(F.length===1)return F[0];F.sort(L);for(let ee=1;ee<F.length;ee++)F[ee-1].equals(F[ee])&&(F.splice(ee,1),ee--);if(F.length===1)return F[0];for(;F.length>1;){const ee=F[F.length-1];if(ee.type!==9)break;F.pop();const B=F.pop(),z=F.length===0,q=c.create(ee.expr.map(V=>t.create([V,B],null)),null,z);q&&(F.push(q),F.sort(L))}return F.length===1?F[0]:new t(F,U)}}serialize(){return this.expr.map(k=>k.serialize()).join(" && ")}keys(){const k=[];for(const U of this.expr)k.push(...U.keys());return k}map(k){return new t(this.expr.map(U=>U.map(k)),null)}negate(){if(!this.negated){const k=[];for(const U of this.expr)k.push(U.negate());this.negated=c.create(k,this,!0)}return this.negated}}class c{constructor(k,U){this.expr=k,this.negated=U,this.type=9}static create(k,U,F){return c._normalizeArr(k,U,F)}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let U=0,F=this.expr.length;U<F;U++){const $=L(this.expr[U],k.expr[U]);if($!==0)return $}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let U=0,F=this.expr.length;U<F;U++)if(!this.expr[U].equals(k.expr[U]))return!1;return!0}return!1}substituteConstants(){const k=i(this.expr);return k===this.expr?this:c.create(k,this.negated,!1)}evaluate(k){for(let U=0,F=this.expr.length;U<F;U++)if(this.expr[U].evaluate(k))return!0;return!1}static _normalizeArr(k,U,F){let $=[],ee=!1;if(k){for(let B=0,z=k.length;B<z;B++){const q=k[B];if(!!q){if(q.type===0){ee=!0;continue}if(q.type===1)return _.INSTANCE;if(q.type===9){$=$.concat(q.expr);continue}$.push(q)}}if($.length===0&&ee)return I.INSTANCE;$.sort(L)}if($.length!==0){if($.length===1)return $[0];for(let B=1;B<$.length;B++)$[B-1].equals($[B])&&($.splice(B,1),B--);if($.length===1)return $[0];if(F){for(let B=0;B<$.length;B++)for(let z=B+1;z<$.length;z++)R($[B],$[z])&&($.splice(z,1),z--);if($.length===1)return $[0]}return new c($,U)}}serialize(){return this.expr.map(k=>k.serialize()).join(" || ")}keys(){const k=[];for(const U of this.expr)k.push(...U.keys());return k}map(k){return new c(this.expr.map(U=>U.map(k)),null)}negate(){if(!this.negated){const k=[];for(const U of this.expr)k.push(U.negate());for(;k.length>1;){const U=k.shift(),F=k.shift(),$=[];for(const B of N(U))for(const z of N(F))$.push(t.create([B,z],null));const ee=k.length===0;k.unshift(c.create($,null,ee))}this.negated=k[0]}return this.negated}}class l extends T{constructor(k,U,F){super(k,null);this._defaultValue=U,typeof F=="object"?l._info.push({...F,key:k}):F!==!0&&l._info.push({key:k,description:F,type:U!=null?typeof U:void 0})}static all(){return l._info.values()}bindTo(k){return k.createKey(this.key,this._defaultValue)}getValue(k){return k.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(k){return w.create(this.key,k)}notEqualsTo(k){return g.create(this.key,k)}}e.RawContextKey=l,l._info=[],e.IContextKeyService=(0,y.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function h(O,k){return O<k?-1:O>k?1:0}function E(O,k,U,F){return O<U?-1:O>U?1:k<F?-1:k>F?1:0}function R(O,k){if(k.type===6&&O.type!==9&&O.type!==6){for(const $ of k.expr)if(O.equals($))return!0}const U=O.negate(),F=N(U).concat(N(k));F.sort(L);for(let $=0;$<F.length;$++){const B=F[$].negate();for(let z=$+1;z<F.length;z++){const q=F[z];if(B.equals(q))return!0}}return!1}e.implies=R;function N(O){return O.type===9?O.expr:[O]}}),define(Ie[192],ke([1,0,4]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,u.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,u.refineServiceDecorator)(e.IEnvironmentService)}),define(Ie[84],ke([1,0,165,4]),function(Q,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IServerExtensionManagementService=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function y(g){switch(g){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=y;function A(g){switch(g){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=A;function D(g,v){switch(g){case 3:return v==="x64"?"win32-x64":v==="ia32"?"win32-ia32":v==="arm64"?"win32-arm64":"unknown";case 2:return v==="x64"?"linux-x64":v==="arm64"?"linux-arm64":v==="arm"?"linux-armhf":"unknown";case"alpine":return v==="x64"?"alpine-x64":v==="arm64"?"alpine-arm64":"unknown";case 1:return v==="x64"?"darwin-x64":v==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=D;function C(g,v){return v==="web"&&!g.includes("web")}e.isNotWebExtensionInWebTargetPlatform=C;function S(g,v,f){return C(v,f)?!1:g==="undefined"||g==="universal"?!0:g==="unknown"?!1:g===f?!0:P(f).includes(g)}e.isTargetPlatformCompatible=S;function P(g){switch(g){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=P;function L(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}e.isIExtensionIdentifier=L;var I;(function(g){g[g.NoneOrRelevance=0]="NoneOrRelevance",g[g.LastUpdatedDate=1]="LastUpdatedDate",g[g.Title=2]="Title",g[g.PublisherName=3]="PublisherName",g[g.InstallCount=4]="InstallCount",g[g.PublishedDate=10]="PublishedDate",g[g.AverageRating=6]="AverageRating",g[g.WeightedRating=12]="WeightedRating"})(I=e.SortBy||(e.SortBy={}));var _;(function(g){g[g.Default=0]="Default",g[g.Ascending=1]="Ascending",g[g.Descending=2]="Descending"})(_=e.SortOrder||(e.SortOrder={}));var T;(function(g){g.Install="install",g.Uninstall="uninstall"})(T=e.StatisticType||(e.StatisticType={}));var w;(function(g){g[g.None=1]="None",g[g.Install=2]="Install",g[g.Update=3]="Update",g[g.Migrate=4]="Migrate"})(w=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,n.createDecorator)("extensionGalleryService");var b;(function(g){g.Unsupported="Unsupported",g.Deprecated="Deprecated",g.Malicious="Malicious",g.Incompatible="Incompatible",g.IncompatiblePreRelease="IncompatiblePreRelease",g.IncompatibleTargetPlatform="IncompatibleTargetPlatform",g.ReleaseVersionNotFound="ReleaseVersionNotFound",g.Invalid="Invalid",g.Download="Download",g.Extract="Extract",g.Delete="Delete",g.Rename="Rename",g.CorruptZip="CorruptZip",g.IncompleteZip="IncompleteZip",g.Internal="Internal"})(b=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class p extends Error{constructor(v,f){super(v);this.code=f,this.name=f}}e.ExtensionManagementError=p,e.IExtensionManagementService=(0,n.createDecorator)("extensionManagementService"),e.IServerExtensionManagementService=(0,n.refineServiceDecorator)(e.IExtensionManagementService),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,n.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,n.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,u.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,u.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,n.createDecorator)("IExtensionManagementCLIService")}),define(Ie[193],ke([1,0,4]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,u.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,u.createDecorator)("externalTerminal")}),define(Ie[194],ke([1,0,42,11,9,13,102,29,113,167,193]),function(Q,e,u,n,y,A,D,C,S,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const I=P.localize(0,null);class _{async getDefaultTerminalForPlatforms(){return{windows:T.getDefaultTerminalWindows(),linux:await b.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class T extends _{openTerminal(a,m){return this.spawnTerminal(u,a,S.getWindowsShell(),m)}spawnTerminal(a,m,o,d){const r=m.windowsExec||T.getDefaultTerminalWindows();d&&d[1]===":"&&(d=d[0].toUpperCase()+d.substr(1));const s=y.basename(r).toLowerCase();if(s==="cmder"||s==="cmder.exe")return a.spawn(r,d?[d]:void 0),Promise.resolve(void 0);const i=["/c","start","/wait"];return r.indexOf(" ")>=0&&i.push('""'),i.push(r),(s==="wt"||s==="wt.exe")&&i.push("-d ."),new Promise((t,c)=>{const l=p(process),h=a.spawn(o,i,{cwd:d,env:l});h.on("error",c),h.on("exit",()=>t())})}runInTerminal(a,m,o,d,r){const s="windowsExec"in r&&r.windowsExec?r.windowsExec:T.getDefaultTerminalWindows();return new Promise((i,t)=>{const c=`"${m} - ${I}"`,l=`""${o.join('" "')}" & pause"`,h=["/c","start",c,"/wait",s,"/c",l],E=Object.assign({},p(process),d);Object.keys(E).filter(O=>E[O]===null).forEach(O=>delete E[O]);const R={cwd:m,env:E,windowsVerbatimArguments:!0};u.spawn(T.CMD,h,R).on("error",O=>{t(g(O))}),i(void 0)})}static getDefaultTerminalWindows(){if(!T._DEFAULT_TERMINAL_WINDOWS){const a=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");T._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${a?"Sysnative":"System32"}\\cmd.exe`}return T._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=T,T.CMD="cmd.exe";class w extends _{openTerminal(a,m){return this.spawnTerminal(u,a,m)}runInTerminal(a,m,o,d,r){const s=r.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((i,t)=>{if(s===L.DEFAULT_TERMINAL_OSX||s==="iTerm.app"){const c=s===L.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",h=[n.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${c}.scpt`,Q).fsPath,"-t",a||I,"-w",m];for(const N of o)h.push("-a"),h.push(N);if(d){const N=Object.assign({},p(process),d);for(const O in N){const k=N[O];k===null?(h.push("-u"),h.push(O)):(h.push("-e"),h.push(`${O}=${k}`))}}let E="";const R=u.spawn(w.OSASCRIPT,h);R.on("error",N=>{t(g(N))}),R.stderr.on("data",N=>{E+=N.toString()}),R.on("exit",N=>{if(N===0)i(void 0);else if(E){const O=E.split(`
`,1);t(new Error(O[0]))}else t(new Error(P.localize(1,null,c,N)))})}else t(new Error(P.localize(2,null,s)))})}spawnTerminal(a,m,o){const d=m.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((r,s)=>{const i=["-a",d];o&&i.push(o);const t=p(process),c=a.spawn("/usr/bin/open",i,{cwd:o,env:t});c.on("error",s),c.on("exit",()=>r())})}}e.MacExternalTerminalService=w,w.OSASCRIPT="/usr/bin/osascript";class b extends _{openTerminal(a,m){return this.spawnTerminal(u,a,m)}runInTerminal(a,m,o,d,r){const s=r.linuxExec?Promise.resolve(r.linuxExec):b.getDefaultTerminalLinuxReady();return new Promise((i,t)=>{const c=[];s.then(l=>{l.indexOf("gnome-terminal")>=0?c.push("-x"):c.push("-e"),c.push("bash"),c.push("-c");const h=`${v(o)}; echo; read -p "${b.WAIT_MESSAGE}" -n1;`;c.push(`''${h}''`);const E=Object.assign({},p(process),d);Object.keys(E).filter(k=>E[k]===null).forEach(k=>delete E[k]);const R={cwd:m,env:E};let N="";const O=u.spawn(l,c,R);O.on("error",k=>{t(g(k))}),O.stderr.on("data",k=>{N+=k.toString()}),O.on("exit",k=>{if(k===0)i(void 0);else if(N){const U=N.split(`
`,1);t(new Error(U[0]))}else t(new Error(P.localize(4,null,l,k)))})})})}static async getDefaultTerminalLinuxReady(){if(!b._DEFAULT_TERMINAL_LINUX_READY)if(!A.isLinux)b._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const a=await C.Promises.exists("/etc/debian_version");b._DEFAULT_TERMINAL_LINUX_READY=new Promise(m=>{a?m("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?m("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?m("konsole"):process.env.COLORTERM?m(process.env.COLORTERM):process.env.TERM?m(process.env.TERM):m("xterm")})}return b._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(a,m,o){const d=m.linuxExec?Promise.resolve(m.linuxExec):b.getDefaultTerminalLinuxReady();return new Promise((r,s)=>{d.then(i=>{const t=p(process),c=a.spawn(i,[],{cwd:o,env:t});c.on("error",s),c.on("exit",()=>r())})})}}e.LinuxExternalTerminalService=b,b.WAIT_MESSAGE=P.localize(3,null);function p(f){const a={...f.env};return(0,D.sanitizeProcessEnvironment)(a),a}function g(f){return"errno"in f&&f.errno==="ENOENT"&&"path"in f&&typeof f.path=="string"?new Error(P.localize(5,null,f.path)):f}function v(f){let a="";for(const m of f)m.indexOf(" ")>=0?a+='"'+m+'"':a+=m,a+=" ";return a}}),define(Ie[43],ke([1,0,25,9,8,10,2,168,4]),function(Q,e,u,n,y,A,D,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function P(B){return B.create===!0}e.isFileOpenForWriteOptions=P;var L;(function(B){B[B.Unknown=0]="Unknown",B[B.File=1]="File",B[B.Directory=2]="Directory",B[B.SymbolicLink=64]="SymbolicLink"})(L=e.FileType||(e.FileType={}));var I;(function(B){B[B.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var _;(function(B){B[B.FileReadWrite=2]="FileReadWrite",B[B.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",B[B.FileReadStream=16]="FileReadStream",B[B.FileFolderCopy=8]="FileFolderCopy",B[B.PathCaseSensitive=1024]="PathCaseSensitive",B[B.Readonly=2048]="Readonly",B[B.Trash=4096]="Trash",B[B.FileWriteUnlock=8192]="FileWriteUnlock",B[B.FileAtomicRead=16384]="FileAtomicRead",B[B.FileClone=32768]="FileClone"})(_=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function T(B){return!!(B.capabilities&2)}e.hasReadWriteCapability=T;function w(B){return!!(B.capabilities&8)}e.hasFileFolderCopyCapability=w;function b(B){return!!(B.capabilities&32768)}e.hasFileCloneCapability=b;function p(B){return!!(B.capabilities&4)}e.hasOpenReadWriteCloseCapability=p;function g(B){return!!(B.capabilities&16)}e.hasFileReadStreamCapability=g;function v(B){return T(B)?!!(B.capabilities&16384):!1}e.hasFileAtomicReadCapability=v;var f;(function(B){B.FileExists="EntryExists",B.FileNotFound="EntryNotFound",B.FileNotADirectory="EntryNotADirectory",B.FileIsADirectory="EntryIsADirectory",B.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",B.FileTooLarge="EntryTooLarge",B.FileWriteLocked="EntryWriteLocked",B.NoPermissions="NoPermissions",B.Unavailable="Unavailable",B.Unknown="Unknown"})(f=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class a extends Error{constructor(z,q){super(z);this.code=q}}e.FileSystemProviderError=a;function m(B,z){const q=new a(B.toString(),z);return d(q,z),q}e.createFileSystemProviderError=m;function o(B){return B||m((0,C.localize)(0,null),f.Unknown)}e.ensureFileSystemProviderError=o;function d(B,z){return B.name=z?`${z} (FileSystemError)`:"FileSystemError",B}e.markAsFileSystemProviderError=d;function r(B){if(!B)return f.Unknown;if(B instanceof a)return B.code;const z=/^(.+) \(FileSystemError\)$/.exec(B.name);if(!z)return f.Unknown;switch(z[1]){case f.FileExists:return f.FileExists;case f.FileIsADirectory:return f.FileIsADirectory;case f.FileNotADirectory:return f.FileNotADirectory;case f.FileNotFound:return f.FileNotFound;case f.FileExceedsMemoryLimit:return f.FileExceedsMemoryLimit;case f.FileTooLarge:return f.FileTooLarge;case f.FileWriteLocked:return f.FileWriteLocked;case f.NoPermissions:return f.NoPermissions;case f.Unavailable:return f.Unavailable}return f.Unknown}e.toFileSystemProviderErrorCode=r;function s(B){if(B instanceof E)return B.fileOperationResult;switch(r(B)){case f.FileNotFound:return 1;case f.FileIsADirectory:return 0;case f.FileNotADirectory:return 10;case f.FileWriteLocked:return 5;case f.NoPermissions:return 6;case f.FileExists:return 4;case f.FileExceedsMemoryLimit:return 9;case f.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var i;(function(B){B[B.CREATE=0]="CREATE",B[B.DELETE=1]="DELETE",B[B.MOVE=2]="MOVE",B[B.COPY=3]="COPY",B[B.WRITE=4]="WRITE"})(i=e.FileOperation||(e.FileOperation={}));class t{constructor(z,q,V){this.resource=z,this.operation=q,this.target=V}isOperation(z){return this.operation===z}}e.FileOperationEvent=t;var c;(function(B){B[B.UPDATED=0]="UPDATED",B[B.ADDED=1]="ADDED",B[B.DELETED=2]="DELETED"})(c=e.FileChangeType||(e.FileChangeType={}));class l{constructor(z,q){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=z;const V=new Map;for(const j of z){const ne=V.get(j.type);switch(ne?ne.push([j.resource,j]):V.set(j.type,[[j.resource,j]]),j.type){case 1:this.rawAdded.push(j.resource);break;case 0:this.rawUpdated.push(j.resource);break;case 2:this.rawDeleted.push(j.resource);break}}for(const[j,ne]of V)switch(j){case 1:this.added=u.TernarySearchTree.forUris(()=>q),this.added.fill(ne);break;case 0:this.updated=u.TernarySearchTree.forUris(()=>q),this.updated.fill(ne);break;case 2:this.deleted=u.TernarySearchTree.forUris(()=>q),this.deleted.fill(ne);break}}contains(z,...q){return this.doContains(z,{includeChildren:!1},...q)}affects(z,...q){return this.doContains(z,{includeChildren:!0},...q)}doContains(z,q,...V){if(!z)return!1;const j=V.length>0;return!!((!j||V.includes(1))&&(this.added?.get(z)||q.includeChildren&&this.added?.findSuperstr(z))||(!j||V.includes(0))&&(this.updated?.get(z)||q.includeChildren&&this.updated?.findSuperstr(z))||(!j||V.includes(2))&&(this.deleted?.findSubstr(z)||q.includeChildren&&this.deleted?.findSuperstr(z)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=l;function h(B,z,q){return!B||!z||B===z||z.length>B.length?!1:(z.charAt(z.length-1)!==n.sep&&(z+=n.sep),q?(0,y.startsWithIgnoreCase)(B,z):B.indexOf(z)===0)}e.isParent=h;class E extends Error{constructor(z,q,V){super(z);this.fileOperationResult=q,this.options=V}}e.FileOperationError=E;class R extends E{constructor(z,q,V){super(z,2,V);this.stat=q}}e.NotModifiedSinceFileOperationError=R;var N;(function(B){B[B.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",B[B.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",B[B.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",B[B.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",B[B.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",B[B.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",B[B.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",B[B.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",B[B.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",B[B.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",B[B.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",B[B.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(N=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var O;(function(B){B[B.FILE=0]="FILE",B[B.FOLDER=1]="FOLDER",B[B.ROOT_FOLDER=2]="ROOT_FOLDER"})(O=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function k(B){if(!(typeof B.size!="number"||typeof B.mtime!="number"))return B.mtime.toString(29)+B.size.toString(31)}e.etag=k;async function U(B,z){if(!z.hasProvider(D.URI.from({scheme:B.scheme})))return new Promise(q=>{const V=z.onDidChangeFileSystemProviderRegistrations(j=>{j.scheme===B.scheme&&j.added&&(V.dispose(),q())})})}e.whenProviderRegistered=U,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class F{static formatSize(z){return(0,A.isNumber)(z)||(z=0),z<F.KB?(0,C.localize)(1,null,z.toFixed(0)):z<F.MB?(0,C.localize)(2,null,(z/F.KB).toFixed(2)):z<F.GB?(0,C.localize)(3,null,(z/F.MB).toFixed(2)):z<F.TB?(0,C.localize)(4,null,(z/F.GB).toFixed(2)):(0,C.localize)(5,null,(z/F.TB).toFixed(2))}}e.ByteSize=F,F.KB=1024,F.MB=F.KB*F.KB,F.GB=F.MB*F.KB,F.TB=F.GB*F.KB;var $;(function(B){B[B.IA32=0]="IA32",B[B.OTHER=1]="OTHER"})($=e.Arch||(e.Arch={}));function ee(B){return{maxFileSize:B===0?300*F.MB:16*F.GB,maxHeapSize:B===0?700*F.MB:2*700*F.MB}}e.getPlatformLimits=ee}),define(Ie[85],ke([1,0]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class u{constructor(...y){this._entries=new Map;for(const[A,D]of y)this.set(A,D)}set(y,A){const D=this._entries.get(y);return this._entries.set(y,A),D}has(y){return this._entries.has(y)}get(y){return this._entries.get(y)}}e.ServiceCollection=u}),define(Ie[195],ke([1,0,18,12,115,191,4,85]),function(Q,e,u,n,y,A,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const S=!1;class P extends Error{constructor(w){super("cyclic dependency between services");this.message=w.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${w.toString()}`}}class L{constructor(w=new C.ServiceCollection,b=!1,p){this._activeInstantiations=new Set,this._services=w,this._strict=b,this._parent=p,this._services.set(D.IInstantiationService,this)}createChild(w){return new L(w,this._strict,this)}invokeFunction(w,...b){const p=_.traceInvocation(w);let g=!1;try{return w({get:f=>{if(g)throw(0,n.illegalState)("service accessor is only valid during the invocation of its target method");const a=this._getOrCreateServiceInstance(f,p);if(!a)throw new Error(`[invokeFunction] unknown service '${f}'`);return a}},...b)}finally{g=!0,p.stop()}}createInstance(w,...b){let p,g;return w instanceof y.SyncDescriptor?(p=_.traceCreation(w.ctor),g=this._createInstance(w.ctor,w.staticArguments.concat(b),p)):(p=_.traceCreation(w),g=this._createInstance(w,b,p)),p.stop(),g}_createInstance(w,b=[],p){const g=D._util.getServiceDependencies(w).sort((a,m)=>a.index-m.index),v=[];for(const a of g){const m=this._getOrCreateServiceInstance(a.id,p);m||this._throwIfStrict(`[createInstance] ${w.name} depends on UNKNOWN service ${a.id}.`,!1),v.push(m)}const f=g.length>0?g[0].index:b.length;if(b.length!==f){console.trace(`[createInstance] First service dependency of ${w.name} at position ${f+1} conflicts with ${b.length} static arguments`);const a=f-b.length;a>0?b=b.concat(new Array(a)):b=b.slice(0,f)}return new w(...[...b,...v])}_setServiceInstance(w,b){if(this._services.get(w)instanceof y.SyncDescriptor)this._services.set(w,b);else if(this._parent)this._parent._setServiceInstance(w,b);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(w){const b=this._services.get(w);return!b&&this._parent?this._parent._getServiceInstanceOrDescriptor(w):b}_getOrCreateServiceInstance(w,b){const p=this._getServiceInstanceOrDescriptor(w);return p instanceof y.SyncDescriptor?this._safeCreateAndCacheServiceInstance(w,p,b.branch(w,!0)):(b.branch(w,!1),p)}_safeCreateAndCacheServiceInstance(w,b,p){if(this._activeInstantiations.has(w))throw new Error(`illegal state - RECURSIVELY instantiating service '${w}'`);this._activeInstantiations.add(w);try{return this._createAndCacheServiceInstance(w,b,p)}finally{this._activeInstantiations.delete(w)}}_createAndCacheServiceInstance(w,b,p){const g=new A.Graph(a=>a.id.toString());let v=0;const f=[{id:w,desc:b,_trace:p}];for(;f.length;){const a=f.pop();if(g.lookupOrInsertNode(a),v++>1e3)throw new P(g);for(const m of D._util.getServiceDependencies(a.desc.ctor)){const o=this._getServiceInstanceOrDescriptor(m.id);if(o||this._throwIfStrict(`[createInstance] ${w} depends on ${m.id} which is NOT registered.`,!0),o instanceof y.SyncDescriptor){const d={id:m.id,desc:o,_trace:a._trace.branch(m.id,!0)};g.insertEdge(a,d),f.push(d)}}}for(;;){const a=g.roots();if(a.length===0){if(!g.isEmpty())throw new P(g);break}for(const{data:m}of a){if(this._getServiceInstanceOrDescriptor(m.id)instanceof y.SyncDescriptor){const d=this._createServiceInstanceWithOwner(m.id,m.desc.ctor,m.desc.staticArguments,m.desc.supportsDelayedInstantiation,m._trace);this._setServiceInstance(m.id,d)}g.removeNode(m)}}return this._getServiceInstanceOrDescriptor(w)}_createServiceInstanceWithOwner(w,b,p=[],g,v){if(this._services.get(w)instanceof y.SyncDescriptor)return this._createServiceInstance(b,p,g,v);if(this._parent)return this._parent._createServiceInstanceWithOwner(w,b,p,g,v);throw new Error(`illegalState - creating UNKNOWN service instance ${b.name}`)}_createServiceInstance(w,b=[],p,g){if(p){const v=new u.IdleValue(()=>this._createInstance(w,b,g));return new Proxy(Object.create(null),{get(f,a){if(a in f)return f[a];const m=v.value;let o=m[a];return typeof o!="function"||(o=o.bind(m),f[a]=o),o},set(f,a,m){return v.value[a]=m,!0}})}else return this._createInstance(w,b,g)}_throwIfStrict(w,b){if(b&&console.warn(b),this._strict)throw new Error(w)}}e.InstantiationService=L;var I;(function(T){T[T.Creation=0]="Creation",T[T.Invocation=1]="Invocation",T[T.Branch=2]="Branch"})(I||(I={}));class _{constructor(w,b){this.type=w,this.name=b,this._start=Date.now(),this._dep=[]}static traceInvocation(w){return S?new _(1,w.name||w.toString().substring(0,42).replace(/\n/g,"")):_._None}static traceCreation(w){return S?new _(0,w.name):_._None}branch(w,b){const p=new _(2,w.toString());return this._dep.push([w,b,p]),p}stop(){const w=Date.now()-this._start;_._totals+=w;let b=!1;function p(v,f){const a=[],m=new Array(v+1).join("	");for(const[o,d,r]of f._dep)if(d&&r){b=!0,a.push(`${m}CREATES -> ${o}`);const s=p(v+1,r);s&&a.push(s)}else a.push(`${m}uses -> ${o}`);return a.join(`
`)}const g=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${w.toFixed(2)}ms (grand total ${_._totals.toFixed(2)}ms)`];(w>2||b)&&console.log(g.join(`
`))}}e.Trace=_,_._None=new class extends _{constructor(){super(-1,null)}stop(){}branch(){return this}},_._totals=0}),define(Ie[14],ke([1,0,49,3,6,13,4]),function(Q,e,u,n,y,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,D.createDecorator)("logService"),e.ILoggerService=(0,D.createDecorator)("loggerService");function C(){return new Date().toISOString()}var S;(function(d){d[d.Trace=0]="Trace",d[d.Debug=1]="Debug",d[d.Info=2]="Info",d[d.Warning=3]="Warning",d[d.Error=4]="Error",d[d.Critical=5]="Critical",d[d.Off=6]="Off"})(S=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=S.Info;function P(d,r,s){switch(r){case S.Trace:d.trace(s);break;case S.Debug:d.debug(s);break;case S.Info:d.info(s);break;case S.Warning:d.warn(s);break;case S.Error:d.error(s);break;case S.Critical:d.critical(s);break;default:throw new Error("Invalid log level")}}e.log=P;function L(d){let r="";for(let s=0;s<d.length;s++){let i=d[s];if(typeof i=="object")try{i=JSON.stringify(i)}catch{}r+=(s>0?" ":"")+i}return r}e.format=L;class I extends y.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new n.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(r){this.level!==r&&(this.level=r,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=I;class _ extends I{constructor(r){super();this.logAlways=r}checkLogLevel(r){return this.logAlways||this.getLevel()<=r}trace(r,...s){this.checkLogLevel(S.Trace)&&this.log(S.Trace,L([r,...s]))}debug(r,...s){this.checkLogLevel(S.Debug)&&this.log(S.Debug,L([r,...s]))}info(r,...s){this.checkLogLevel(S.Info)&&this.log(S.Info,L([r,...s]))}warn(r,...s){this.checkLogLevel(S.Warning)&&this.log(S.Warning,L([r,...s]))}error(r,...s){if(this.checkLogLevel(S.Error))if(r instanceof Error){const i=Array.prototype.slice.call(arguments);i[0]=r.stack,this.log(S.Error,L(i))}else this.log(S.Error,L([r,...s]))}critical(r,...s){this.checkLogLevel(S.Critical)&&this.log(S.Critical,L([r,...s]))}flush(){}}e.AbstractMessageLogger=_;class T extends I{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r),this.useColors=!A.isWindows}trace(r,...s){this.getLevel()<=S.Trace&&(this.useColors?console.log(`[90m[main ${C()}][0m`,r,...s):console.log(`[main ${C()}]`,r,...s))}debug(r,...s){this.getLevel()<=S.Debug&&(this.useColors?console.log(`[90m[main ${C()}][0m`,r,...s):console.log(`[main ${C()}]`,r,...s))}info(r,...s){this.getLevel()<=S.Info&&(this.useColors?console.log(`[90m[main ${C()}][0m`,r,...s):console.log(`[main ${C()}]`,r,...s))}warn(r,...s){this.getLevel()<=S.Warning&&(this.useColors?console.warn(`[93m[main ${C()}][0m`,r,...s):console.warn(`[main ${C()}]`,r,...s))}error(r,...s){this.getLevel()<=S.Error&&(this.useColors?console.error(`[91m[main ${C()}][0m`,r,...s):console.error(`[main ${C()}]`,r,...s))}critical(r,...s){this.getLevel()<=S.Critical&&(this.useColors?console.error(`[90m[main ${C()}][0m`,r,...s):console.error(`[main ${C()}]`,r,...s))}dispose(){}flush(){}}e.ConsoleMainLogger=T;class w extends I{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r)}trace(r,...s){this.getLevel()<=S.Trace&&console.log("%cTRACE","color: #888",r,...s)}debug(r,...s){this.getLevel()<=S.Debug&&console.log("%cDEBUG","background: #eee; color: #888",r,...s)}info(r,...s){this.getLevel()<=S.Info&&console.log("%c INFO","color: #33f",r,...s)}warn(r,...s){this.getLevel()<=S.Warning&&console.log("%c WARN","color: #993",r,...s)}error(r,...s){this.getLevel()<=S.Error&&console.log("%c  ERR","color: #f33",r,...s)}critical(r,...s){this.getLevel()<=S.Critical&&console.log("%cCRITI","background: #f33; color: white",r,...s)}dispose(){}flush(){}}e.ConsoleLogger=w;class b extends I{constructor(r,s=e.DEFAULT_LOG_LEVEL){super();this.adapter=r,this.setLevel(s)}trace(r,...s){this.getLevel()<=S.Trace&&this.adapter.log(S.Trace,[this.extractMessage(r),...s])}debug(r,...s){this.getLevel()<=S.Debug&&this.adapter.log(S.Debug,[this.extractMessage(r),...s])}info(r,...s){this.getLevel()<=S.Info&&this.adapter.log(S.Info,[this.extractMessage(r),...s])}warn(r,...s){this.getLevel()<=S.Warning&&this.adapter.log(S.Warning,[this.extractMessage(r),...s])}error(r,...s){this.getLevel()<=S.Error&&this.adapter.log(S.Error,[this.extractMessage(r),...s])}critical(r,...s){this.getLevel()<=S.Critical&&this.adapter.log(S.Critical,[this.extractMessage(r),...s])}extractMessage(r){return typeof r=="string"?r:(0,u.toErrorMessage)(r,this.getLevel()<=S.Trace)}dispose(){}flush(){}}e.AdapterLogger=b;class p extends I{constructor(r){super();this.logServices=r,r.length&&this.setLevel(r[0].getLevel())}setLevel(r){for(const s of this.logServices)s.setLevel(r);super.setLevel(r)}trace(r,...s){for(const i of this.logServices)i.trace(r,...s)}debug(r,...s){for(const i of this.logServices)i.debug(r,...s)}info(r,...s){for(const i of this.logServices)i.info(r,...s)}warn(r,...s){for(const i of this.logServices)i.warn(r,...s)}error(r,...s){for(const i of this.logServices)i.error(r,...s)}critical(r,...s){for(const i of this.logServices)i.critical(r,...s)}flush(){for(const r of this.logServices)r.flush()}dispose(){for(const r of this.logServices)r.dispose()}}e.MultiplexLogService=p;class g extends y.Disposable{constructor(r){super();this.logger=r,this._register(r)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(r){this.logger.setLevel(r)}getLevel(){return this.logger.getLevel()}trace(r,...s){this.logger.trace(r,...s)}debug(r,...s){this.logger.debug(r,...s)}info(r,...s){this.logger.info(r,...s)}warn(r,...s){this.logger.warn(r,...s)}error(r,...s){this.logger.error(r,...s)}critical(r,...s){this.logger.critical(r,...s)}flush(){this.logger.flush()}}e.LogService=g;class v extends y.Disposable{constructor(r,s){super();this.logLevel=r,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(s(i=>{this.logLevel=i,this.logLevelChangeableLoggers.forEach(t=>t.setLevel(i))}))}getLogger(r){return this.loggers.get(r.toString())}createLogger(r,s){let i=this.loggers.get(r.toString());return i||(i=this.doCreateLogger(r,s?.always?S.Trace:this.logLevel,s),this.loggers.set(r.toString(),i),s?.always||this.logLevelChangeableLoggers.push(i)),i}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(r=>r.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=v;class f{constructor(){this.onDidChangeLogLevel=new n.Emitter().event}setLevel(r){}getLevel(){return S.Info}trace(r,...s){}debug(r,...s){}info(r,...s){}warn(r,...s){}error(r,...s){}critical(r,...s){}dispose(){}flush(){}}e.NullLogService=f;function a(d){if(d.verbose)return S.Trace;if(typeof d.logLevel=="string"){const r=m(d.logLevel.toLowerCase());if(r!==void 0)return r}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=a;function m(d){switch(d){case"trace":return S.Trace;case"debug":return S.Debug;case"info":return S.Info;case"warn":return S.Warning;case"error":return S.Error;case"critical":return S.Critical;case"off":return S.Off}}e.parseLogLevel=m;function o(d){switch(d){case S.Trace:return"trace";case S.Debug:return"debug";case S.Info:return"info";case S.Warning:return"warn";case S.Error:return"error";case S.Critical:return"critical";case S.Off:return"off"}}e.LogLevelToString=o}),define(Ie[196],ke([1,0,43,14]),function(Q,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function y(C,S,P,L,I){try{const _=await new Promise((w,b)=>{Q(["spdlog"],w,b)});_.setFlushOn(n.LogLevel.Trace);const T=await _.createAsyncRotatingLogger(C,S,P,L);return I&&T.clearFormatters(),T}catch(_){console.error(_)}return null}function A(C,S,P){switch(S){case n.LogLevel.Trace:C.trace(P);break;case n.LogLevel.Debug:C.debug(P);break;case n.LogLevel.Info:C.info(P);break;case n.LogLevel.Warning:C.warn(P);break;case n.LogLevel.Error:C.error(P);break;case n.LogLevel.Critical:C.critical(P);break;default:throw new Error("Invalid log level")}}class D extends n.AbstractMessageLogger{constructor(S,P,L,I,_){super();this.buffer=[],this.setLevel(_),this._loggerCreationPromise=this._createSpdLogLogger(S,P,L,I),this._register(this.onDidChangeLogLevel(T=>{this._logger?.setLevel(T)}))}async _createSpdLogLogger(S,P,L,I){const _=L?6:1,T=30/_*u.ByteSize.MB,w=await y(S,P,T,_,I);if(w){this._logger=w,this._logger.setLevel(this.getLevel());for(const{level:b,message:p}of this.buffer)A(this._logger,b,p);this.buffer=[]}}log(S,P){this._logger?A(this._logger,S,P):this.getLevel()<=S&&this.buffer.push({level:S,message:P})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=D}),define(Ie[116],ke([1,0,41,169,4]),function(Q,e,u,n,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(A=e.MarkerTag||(e.MarkerTag={}));var D;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(D=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function P(w,b){return b-w}S.compare=P;const L=Object.create(null);L[S.Error]=(0,n.localize)(0,null),L[S.Warning]=(0,n.localize)(1,null),L[S.Info]=(0,n.localize)(2,null);function I(w){return L[w]||""}S.toString=I;function _(w){switch(w){case u.default.Error:return S.Error;case u.default.Warning:return S.Warning;case u.default.Info:return S.Info;case u.default.Ignore:return S.Hint}}S.fromSeverity=_;function T(w){switch(w){case S.Error:return u.default.Error;case S.Warning:return u.default.Warning;case S.Info:return u.default.Info;case S.Hint:return u.default.Ignore}}S.toSeverity=T}(D=e.MarkerSeverity||(e.MarkerSeverity={}));var C;(function(S){const P="";function L(_){return I(_,!0)}S.makeKey=L;function I(_,T){const w=[P];return _.source?w.push(_.source.replace("\xA6","\\\xA6")):w.push(P),_.code?typeof _.code=="string"?w.push(_.code.replace("\xA6","\\\xA6")):w.push(_.code.value.replace("\xA6","\\\xA6")):w.push(P),_.severity!==void 0&&_.severity!==null?w.push(D.toString(_.severity)):w.push(P),_.message&&T?w.push(_.message.replace("\xA6","\\\xA6")):w.push(P),_.startLineNumber!==void 0&&_.startLineNumber!==null?w.push(_.startLineNumber.toString()):w.push(P),_.startColumn!==void 0&&_.startColumn!==null?w.push(_.startColumn.toString()):w.push(P),_.endLineNumber!==void 0&&_.endLineNumber!==null?w.push(_.endLineNumber.toString()):w.push(P),_.endColumn!==void 0&&_.endColumn!==null?w.push(_.endColumn.toString()):w.push(P),w.push(P),w.join("\xA6")}S.makeKeyOptionalMessage=I})(C=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,y.createDecorator)("markerService")}),define(Ie[197],ke([1,0,3,41,4]),function(Q,e,u,n,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=n.default,e.INotificationService=(0,y.createDecorator)("notificationService");var A;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.PROFILE=1]="PROFILE",P[P.APPLICATION=2]="APPLICATION"})(A=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var D;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(D=e.NotificationsFilter||(e.NotificationsFilter={}));class C{constructor(){this.progress=new S,this.onDidClose=u.Event.None,this.onDidChangeVisibility=u.Event.None}updateSeverity(L){}updateMessage(L){}updateActions(L){}close(){}}e.NoOpNotification=C;class S{infinite(){}done(){}total(L){}worked(L){}}e.NoOpProgress=S}),define(Ie[117],ke([1,0,6,8,2,4]),function(Q,e,u,n,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,A.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return u.Disposable.None},registerValidator(){return u.Disposable.None},registerExternalUriResolver(){return u.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return u.Disposable.None},async open(){return!1},async resolveExternalUri(L){return{resolved:L,dispose(){}}}});function D(L,I){return y.URI.isUri(L)?(0,n.equalsIgnoreCase)(L.scheme,I):(0,n.startsWithIgnoreCase)(L,I+":")}e.matchesScheme=D;function C(L,...I){return I.some(_=>D(L,_))}e.matchesSomeScheme=C;function S(L,I){return L.with({fragment:`${I.startLineNumber},${I.startColumn}${I.endLineNumber?`-${I.endLineNumber}${I.endColumn?`,${I.endColumn}`:""}`:""}`})}e.withSelection=S;function P(L){let I;const _=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(L.fragment);return _&&(I={startLineNumber:parseInt(_[1]),startColumn:_[2]?parseInt(_[2]):1,endLineNumber:_[4]?parseInt(_[4]):void 0,endColumn:_[4]?_[5]?parseInt(_[5]):1:void 0},L=L.with({fragment:""})),{selection:I,uri:L}}e.extractSelection=P}),define(Ie[198],ke([1,0,11,13,40,22]),function(Q,e,u,n,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let D;if(typeof n.globals.vscode!="undefined"&&typeof n.globals.vscode.context!="undefined"){const C=n.globals.vscode.context.configuration();if(C)D=C.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Q?.__$__nodeRequire=="function"){const C=(0,A.dirname)(u.FileAccess.asFileUri("",Q));D=Q.__$__nodeRequire((0,A.joinPath)(C,"product.json").fsPath);const S=Q.__$__nodeRequire((0,A.joinPath)(C,"package.json").fsPath);y.env.VSCODE_DEV&&Object.assign(D,{nameShort:`${D.nameShort} Dev`,nameLong:`${D.nameLong} Dev`,dataFolderName:`${D.dataFolderName}-dev`,serverDataFolderName:D.serverDataFolderName?`${D.serverDataFolderName}-dev`:void 0}),Object.assign(D,{version:S.version})}else D={nameShort:"Code",nameLong:"Visual Studio Code",applicationName:"code",win32AppId:"{{F8A2A208-72B3-4D61-95FC-8A65D340689B}",win32x64AppId:"{{EA457B21-F73E-494C-ACAB-524FDE069978}",win32arm64AppId:"{{A5270FC5-65AD-483E-AC30-2C276B63D0AC}",win32UserAppId:"{{D628A17A-9713-46BF-8D57-E671B46A741E}",win32x64UserAppId:"{{771FD6B0-FA20-440A-A002-3B3BAC16DC50}",win32arm64UserAppId:"{{D9E514E7-1A56-452D-9337-2990C0DC4310}",win32NameVersion:"Microsoft Visual Studio Code",win32DirName:"Microsoft VS Code",win32SetupExeBasename:"VSCodeSetup",win32AppUserModelId:"Microsoft.VisualStudioCode",win32ShellNameShort:"Code",win32MutexName:"vscode",win32RegValueName:"VSCode",darwinCredits:"resources/darwin/Credits.rtf",darwinBundleIdentifier:"com.microsoft.VSCode",darwinExecutable:"VSCode",linuxIconName:"com.visualstudio.code",licenseFileName:"LICENSE.rtf",licenseName:"Multiple, see https://code.visualstudio.com/license",serverLicense:["*","* Visual Studio Code Server","*","* By using the software, you agree to","* the Visual Studio Code Server License Terms (https://aka.ms/vscode-server-license) and","* the Microsoft Privacy Statement (https://privacy.microsoft.com/en-US/privacystatement).","*"],serverLicensePrompt:"Do you accept the terms in the License Agreement (Y/n)?",serverApplicationName:"code-server",urlProtocol:"vscode",dataFolderName:".vscode",serverDataFolderName:".vscode-server",downloadUrl:"https://code.visualstudio.com",updateUrl:"https://update.code.visualstudio.com",webEndpointUrl:"https://main.vscode-cdn.net",webEndpointUrlTemplate:"https://{{uuid}}.vscode-cdn.net/{{quality}}/{{commit}}",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/{{quality}}/{{commit}}/out/vs/workbench/contrib/webview/browser/pre/",quality:"stable",extensionsGallery:{nlsBaseUrl:"https://www.vscode-unpkg.net/_lp/",serviceUrl:"https://marketplace.visualstudio.com/_apis/public/gallery",cacheUrl:"https://vscode.blob.core.windows.net/gallery/index",itemUrl:"https://marketplace.visualstudio.com/items",publisherUrl:"https://marketplace.visualstudio.com/publishers",resourceUrlTemplate:"https://{publisher}.vscode-unpkg.net/{publisher}/{name}/{version}/{path}",controlUrl:"https://az764295.vo.msecnd.net/extensions/marketplace.json",recommendationsUrl:"https://az764295.vo.msecnd.net/extensions/workspaceRecommendations.json.gz"},extensionTips:{"ms-dotnettools.csharp":"{**/*.cs,**/project.json,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln,**/appsettings.json}","firefox-devtools.vscode-firefox-debug":"{**/*.ts,**/*.tsx,**/*.js,**/*.jsx,**/*.es6,**/.babelrc}","ms-edgedevtools.vscode-edge-devtools":"{**/*.ts,**/*.tsx,**/*.js,**/*.css,**/*.html}","golang.Go":"**/*.go","ms-vscode.PowerShell":"{**/*.ps1,**/*.psd1,**/*.psm1,**/*.ps.config,**/*.ps1.config}","Ionide.Ionide-fsharp":"{**/*.fsx,**/*.fsi,**/*.fs,**/*.ml,**/*.mli}","dbaeumer.vscode-eslint":"{**/*.js,**/*.jsx,**/*.es6,**/.eslintrc.*,**/.eslintrc,**/.babelrc,**/jsconfig.json}","ms-vscode.vscode-typescript-tslint-plugin":"{**/tslint.json}","bmewburn.vscode-intelephense-client":"{**/*.php,**/php.ini}","xdebug.php-debug":"{**/*.php,**/php.ini}","rust-lang.rust-analyzer":"{**/*.rs,**/*.rslib}","ms-vscode.cpptools-extension-pack":"{**/*.c,**/*.cpp,**/*.cc,**/.cxx,**/*.hh,**/*.hpp,**/*.hxx,**/*.h}","DavidAnson.vscode-markdownlint":"{**/*.md}","ms-azuretools.vscode-docker":"{**/dockerfile,**/Dockerfile,**/docker-compose.yml,**/docker-compose.*.yml,**/*.cs,**/project.json,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln,**/appsettings.json,**/*.py,**/*.ipynb,**/*.js,**/*.ts,**/package.json}","EditorConfig.EditorConfig":"{**/.editorconfig}","HookyQR.beautify":"{**/.jsbeautifyrc}","donjayamanne.githistory":"{**/.gitignore,**/.git}","felipecaputo.git-project-manager":"{**/.gitignore,**/.git}","eamodio.gitlens":"{**/.gitignore,**/.git}","rebornix.Ruby":"{**/*.rb,**/*.erb,**/*.reek,**/.fasterer.yml,**/ruby-lint.yml,**/.rubocop.yml}","DotJoshJohnson.xml":"{**/*.xml}","stylelint.vscode-stylelint":"{**/.stylelintrc,**/stylelint.config.js}","eg2.vscode-npm-script":"{**/package.json}","ms-mssql.mssql":"{**/*.sql}","mtxr.sqltools":"{**/*.sql}","usqlextpublisher.usql-vscode-ext":"{**/*.usql}","ms-vscode.sublime-keybindings":"{**/.sublime-project,**/.sublime-workspace}","k--kato.intellij-idea-keybindings":"{**/.idea}","christian-kohler.npm-intellisense":"{**/package.json}","vue.volar":"{**/*.vue}","ms-python.python":"{**/*.py,**/*.ipynb}","ms-toolsai.jupyter":"{**/*.ipynb}","cake-build.cake-vscode":"{**/build.cake}","Angular.ng-template":"{**/.angular-cli.json,**/angular.json,**/*.ng.html,**/*.ng,**/*.ngml}","vscjava.vscode-maven":"**/pom.xml","ms-azuretools.vscode-azureterraform":"**/*.tf","HashiCorp.terraform":"**/*.tf","vsciot-vscode.vscode-arduino":"**/*.ino","ms-kubernetes-tools.vscode-kubernetes-tools":"{**/Chart.yaml}","GoogleCloudTools.cloudcode":"{**/skaffold.yaml}","Oracle.oracledevtools":"{**/*.sql}","ms-vscode.vscode-github-issue-notebooks":"{**/*.github-issues}","REditorSupport.r":"**/*.r"},extensionImportantTips:{"ms-dotnettools.csharp":{name:"C#",languages:["csharp"],pattern:"{**/*.cs,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln}"},"ms-python.python":{name:"Python",languages:["python"],pattern:"{**/*.py}"},"ms-toolsai.jupyter":{name:"Jupyter",pattern:"{**/*.ipynb}"},"golang.Go":{name:"Go",languages:["go"],pattern:"**/*.go"},"vscjava.vscode-java-pack":{name:"Java",languages:["java"],pattern:"{**/*.java}",isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]},"ms-vscode.PowerShell":{name:"PowerShell",languages:["powershell"],pattern:"{**/*.ps1,**/*.psd1,**/*.psm1}"},"ms-vscode.cpptools-extension-pack":{name:"C/C++",languages:["c","cpp"],pattern:"{**/*.c,**/*.cpp,**/*.cc,**/.cxx,**/*.hh,**/*.hpp,**/*.hxx,**/*.h}"},"ms-azuretools.vscode-docker":{name:"Docker",languages:["dockerfile"],pattern:"{**/dockerfile,**/Dockerfile,**/docker-compose.yml,**/docker-compose.*.yml}"},"vue.volar":{name:"Vetur",languages:["vue"],pattern:"{**/*.vue}"},"ms-vscode.makefile-tools":{name:"Makefile Tools",languages:["makefile"],pattern:"{**/makefile,**/Makefile}"},"ms-vscode.cmake-tools":{name:"CMake Tools",pattern:"{**/CMakeLists.txt}"},"ms-azure-devops.azure-pipelines":{name:"Azure Pipelines",pattern:"{**/azure-pipelines.yaml}"},"msazurermtools.azurerm-vscode-tools":{name:"Azure Resource Manager",pattern:"{**/azuredeploy.json}"},"ms-vscode-remote.remote-containers":{name:"Remote - Containers",pattern:"{**/devcontainer.json}"},"ms-azuretools.vscode-bicep":{name:"Bicep",pattern:"{**/*.bicep}"},"svelte.svelte-vscode":{name:"Svelte",pattern:"{**/*.svelte}"},"ms-vscode.vscode-github-issue-notebooks":{name:"GitHub Issue Notebooks",pattern:"{**/*.github-issues}"},"ms-playwright.playwright":{name:"Playwright",pattern:"{**/*playwright*.config.ts,**/*playwright*.config.js,**/*playwright*.config.mjs}"},"REditorSupport.r":{name:"R",languages:["r"],pattern:"{**/*.r}"}},keymapExtensionTips:["vscodevim.vim","ms-vscode.sublime-keybindings","ms-vscode.atom-keybindings","ms-vscode.brackets-keybindings","ms-vscode.vs-keybindings","ms-vscode.notepadplusplus-keybindings","k--kato.intellij-idea-keybindings","lfs.vscode-emacs-friendly","alphabotsec.vscode-eclipse-keybindings","alefragnani.delphi-keybindings"],languageExtensionTips:["ms-python.python","ms-vscode.cpptools-extension-pack","ms-dotnettools.csharp","ms-toolsai.jupyter","vscjava.vscode-java-pack","ecmel.vscode-html-css","vue.volar","bmewburn.vscode-intelephense-client","dsznajder.es7-react-js-snippets","golang.go","ms-vscode.powershell","dart-code.dart-code","rust-lang.rust-analyzer","rebornix.ruby"],configBasedExtensionTips:{git:{configPath:".git/config",configName:"Git",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",remotes:["github.com"]},"eamodio.gitlens":{name:"GitLens"}}},devContainer:{configPath:".devcontainer/devcontainer.json",configName:"Dev Container",recommendations:{"ms-vscode-remote.remote-containers":{name:"Remote - Containers",important:!0}}},maven:{configPath:"pom.xml",configName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]},"Pivotal.vscode-boot-dev-pack":{name:"Spring Boot Extension Pack",isExtensionPack:!0}}},gradle:{configPath:"build.gradle",configName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}}},"github-pull-request":{configPath:".vscode/.github-pull-request.rec",configName:"GitHub",configScheme:"vscode-vfs",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",important:!0}}}},exeBasedExtensionTips:{az:{friendlyName:"Azure CLI",windowsPath:"%ProgramFiles(x86)%\\Microsoft SDKs\\Azure\\CLI2\\wbin\\az.cmd",recommendations:{"ms-vscode.azurecli":{name:"Azure CLI Tools"}}},heroku:{friendlyName:"Heroku CLI",windowsPath:"%ProgramFiles%\\Heroku\\bin\\heroku.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"pkosta2005.heroku-command":{name:"heroku-cli"}}},mongo:{friendlyName:"Mongo",windowsPath:"%ProgramFiles%\\MongoDB\\Server\\3.6\\bin\\mongod.exe",recommendations:{"ms-azuretools.vscode-cosmosdb":{name:"Azure Databases"}}},serverless:{friendlyName:"Serverless framework",windowsPath:"%APPDATA%\\npm\\serverless.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},func:{friendlyName:"Azure Function SDK",windowsPath:"%APPDATA%\\npm\\func.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},mysql:{friendlyName:"MySQL",windowsPath:"%ProgramFiles%\\MySQL\\MySQL Server 8.0\\bin\\mysqld.exe",recommendations:{"mtxr.sqltools":{name:"SQLTools"}}},postgres:{friendlyName:"PostgreSQL",windowsPath:"%ProgramFiles%\\PostgreSQL\\11\\bin\\psql.exe",recommendations:{"ms-ossdata.vscode-postgresql":{name:"PostgreSQL"},"mtxr.sqltools":{name:"SQLTools"}}},sqlcmd:{friendlyName:"SQL CLI",recommendations:{"ms-mssql.mssql":{name:"SQL Server (mssql)"}}},now:{friendlyName:"Now CLI",windowsPath:"%APPDATA%\\npm\\now.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"ms-azuretools.vscode-docker":{name:"Docker"}}},docker:{friendlyName:"Docker",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\docker.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker",important:!0},"ms-vscode-remote.remote-containers":{name:"Remote - Containers",important:!0},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},kubectl:{friendlyName:"Kubernetes",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\kubectl.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"ms-vscode-remote.remote-containers":{name:"Remote - Containers"}}},ng:{friendlyName:"Angular CLI",windowsPath:"%APPDATA%\\npmexit\\ng.cmd",recommendations:{"johnpapa.Angular2":{name:"Angular Snippets"}}},"create-react-app":{friendlyName:"Create React App",windowsPath:"%APPDATA%\\npm\\create-react-app.cmd",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},"react-native":{friendlyName:"React Native",windowsPath:"%APPDATA%\\npm\\react-native-cli",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},p4:{friendlyName:"Perforce",recommendations:{"slevesque.perforce":{name:"Perforce for VS Code"}}},hg:{friendlyName:"Mercurial",recommendations:{"mrcrowl.hg":{name:"Hg"}}},git:{friendlyName:"Git",windowsPath:"%ProgramFiles%\\Git\\git-bash.exe",recommendations:{"eamodio.gitlens":{name:"GitLens"}}},svn:{friendlyName:"Subversion",windowsPath:"%ProgramFiles%\\TortoiseSVN\\bin\\TortoiseProc.exe",recommendations:{"johnstoncode.svn-scm":{name:"SVN"}}},subl:{friendlyName:"Sublime",windowsPath:"%ProgramFiles%\\Sublime Text3\\sublime_text.exe",recommendations:{"ms-vscode.sublime-keybindings":{name:"Sublime Text Keymap and Settings Importer"}}},atom:{friendlyName:"Atom",windowsPath:"%USERPROFILE%\\AppData\\Local\\atom\\bin\\atom.cmd",recommendations:{"ms-vscode.atom-keybindings":{name:"Atom Keymap"}}},brackets:{friendlyName:"Brackets",windowsPath:"%ProgramFiles(x86)%\\Brackets\\Brackets.exe",recommendations:{"ms-vscode.brackets-keybindings":{name:"Brackets Keymap"}}},notepadplusplus:{friendlyName:"Notepad++",windowsPath:"%ProgramFiles%\\Notepad++\\Notepad++.exe",recommendations:{"ms-vscode.notepadplusplus-keybindings":{name:"Notepad++ keymap"}}},vi:{friendlyName:"VIM",windowsPath:"%ProgramFiles(x86)%\\Vim\\vim80\\gvim.exe",recommendations:{"vscodevim.vim":{name:"Vim"}}},mvn:{friendlyName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}}},gradle:{friendlyName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}}},"Microsoft Edge":{friendlyName:"Microsoft Edge",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Dev":{friendlyName:"Microsoft Edge Dev",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Dev\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Beta":{friendlyName:"Microsoft Edge Beta",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Beta\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Canary":{friendlyName:"Microsoft Edge Canary",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge SxS\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Mozilla Firefox (x86)":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles(x86)%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition (x86)":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles(x86)%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},cordova:{friendlyName:"Cordova",windowsPath:"%APPDATA%\\npm\\cordova",recommendations:{"msjsdiag.cordova-tools":{name:"Cordova Tools"}}},gcloud:{friendlyName:"Google GCloud CLI",windowsPath:"%ProgramFiles(x86)%\\Google\\Cloud SDK\\google-cloud-sdk\\bin\\gcloud.cmd",recommendations:{"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},skaffold:{friendlyName:"Skaffold Code to Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},minikube:{friendlyName:"MiniKube Local Kubernetes Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"ms-vscode-remote.remote-containers":{name:"Remote - Containers"}}},podman:{friendlyName:"Podman",recommendations:{"ms-vscode-remote.remote-containers":{name:"Remote - Containers"}}},wsl:{friendlyName:"Windows Subsystem for Linux (WSL)",windowsPath:"%WINDIR%\\system32\\lxss\\LxssManager.dll",important:!0,recommendations:{"ms-vscode-remote.remote-wsl":{name:"Remote - WSL",important:!0}}}},webExtensionTips:["tyriar.luna-paint","codespaces-contrib.codeswing","ms-vscode.vscode-github-issue-notebooks","esbenp.prettier-vscode","hediet.vscode-drawio"],remoteExtensionTips:{wsl:{friendlyName:"Remote - WSL",extensionId:"ms-vscode-remote.remote-wsl"},"ssh-remote":{friendlyName:"Remote - SSH",extensionId:"ms-vscode-remote.remote-ssh"},"dev-container":{friendlyName:"Remote - Containers",extensionId:"ms-vscode-remote.remote-containers"},"attached-container":{friendlyName:"Remote - Containers",extensionId:"ms-vscode-remote.remote-containers"},vsonline:{friendlyName:"Visual Studio Online",extensionId:"ms-vsonline.vsonline"}},extensionKeywords:{md:["Markdown"],js:["JavaScript"],jsx:["JavaScript"],es6:["JavaScript"],html:["Html"],ts:["TypeScript"],tsx:["TypeScript"],css:["CSS"],scss:["SASS"],txt:["Text"],php:["PHP"],php3:["PHP"],php4:["PHP"],ph3:["PHP"],ph4:["PHP"],xml:["XML"],py:["Python"],pyc:["Python"],pyd:["Python"],pyo:["Python"],pyw:["Python"],pyz:["Python"],java:["Java"],class:["Java"],jar:["Java"],c:["c","objective c","objective-c"],m:["objective c","objective-c"],mm:["objective c","objective-c"],cpp:["cpp","c plus plus","c","c++"],cc:["cpp","c plus plus","c","c++"],cxx:["cpp","c plus plus","c++"],hh:["cpp","c plus plus","c++"],hpp:["cpp","c++"],h:["cpp","c plus plus","c++","c","objective c","objective-c"],sql:["sql"],sh:["bash"],bash:["bash"],zsh:["bash","zshell"],cs:["c#","csharp"],csproj:["c#","csharp"],sln:["c#","csharp"],go:["go"],sty:["latex"],tex:["latex"],ps:["powershell"],ps1:["powershell"],rs:["rust"],rslib:["rust"],hs:["haskell"],lhs:["haskell"],scm:["scheme"],ss:["scheme"],clj:["clojure"],cljs:["clojure"],cljc:["clojure"],edn:["clojure"],erl:["erlang"],hrl:["erlang"],scala:["scala"],sc:["scala"],pl:["perl"],pm:["perl"],t:["perl"],pod:["perl"],groovy:["groovy"],swift:["swift"],rb:["ruby"],rbw:["ruby"],jl:["julia"],f:["fortran"],for:["fortran"],f90:["fortran"],f95:["fortran"],coffee:["CoffeeScript"],litcoffee:["CoffeeScript"],yaml:["yaml"],yml:["yaml"],dart:["dart"],json:["json"]},extensionAllowedBadgeProviders:["api.bintray.com","api.travis-ci.com","api.travis-ci.org","app.fossa.io","badge.buildkite.com","badge.fury.io","badge.waffle.io","badgen.net","badges.frapsoft.com","badges.gitter.im","badges.greenkeeper.io","cdn.travis-ci.com","cdn.travis-ci.org","ci.appveyor.com","circleci.com","cla.opensource.microsoft.com","codacy.com","codeclimate.com","codecov.io","coveralls.io","david-dm.org","deepscan.io","dev.azure.com","docs.rs","flat.badgen.net","gemnasium.com","githost.io","gitlab.com","godoc.org","goreportcard.com","img.shields.io","isitmaintained.com","marketplace.visualstudio.com","nodesecurity.io","opencollective.com","snyk.io","travis-ci.com","travis-ci.org","visualstudio.com","vsmarketplacebadge.apphb.com","www.bithound.io","www.versioneye.com"],extensionAllowedBadgeProvidersRegex:["^https:\\/\\/github\\.com\\/[^/]+\\/[^/]+\\/(actions\\/)?workflows\\/.*badge\\.svg"],crashReporter:{productName:"VSCode",companyName:"Microsoft"},appCenter:{"win32-ia32":"appcenter://code?aid=f4289815-a66e-4ad9-b74f-d8e5bc093e41","win32-x64":"appcenter://code?aid=a4e3233c-699c-46ec-b4f4-9c2a77254662","win32-arm64":"appcenter://code?aid=3712d786-7cc8-4f11-8b08-cc12eab6d4f7","linux-x64":"appcenter://code?aid=fba07a4d-84bd-4fc8-a125-9640fc8ce171",darwin:"appcenter://code?aid=860d6632-f65b-490b-85a8-3e72944f7774","darwin-arm64":"appcenter://code?aid=be71415d-3893-4ae5-b453-e537b9668a10","darwin-universal":"appcenter://code?aid=de75e3cc-e22f-4f42-a03f-1409c21d8af8"},enableTelemetry:!0,aiConfig:{asimovKey:"AIF-444c3af9-8e69-4462-ab49-4191e6ad1916",ariaKey:"5bbf946d11a54f6783919c455abaddaf-fd62977b-c92d-4714-a45d-649d06980372-7168"},msftInternalDomains:["redmond.corp.microsoft.com","northamerica.corp.microsoft.com","fareast.corp.microsoft.com","ntdev.corp.microsoft.com","wingroup.corp.microsoft.com","southpacific.corp.microsoft.com","wingroup.windeploy.ntdev.microsoft.com","ddnet.microsoft.com","europe.corp.microsoft.com"],sendASmile:{reportIssueUrl:"https://go.microsoft.com/fwlink/?LinkId=534872",requestFeatureUrl:"https://go.microsoft.com/fwlink/?LinkID=533482"},documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",releaseNotesUrl:"https://go.microsoft.com/fwlink/?LinkID=533483#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",twitterUrl:"https://go.microsoft.com/fwlink/?LinkID=533687",requestFeatureUrl:"https://go.microsoft.com/fwlink/?LinkID=533482",reportIssueUrl:"https://github.com/Microsoft/vscode/issues/new",reportMarketplaceIssueUrl:"https://github.com/microsoft/vsmarketplace/issues/new",licenseUrl:"https://go.microsoft.com/fwlink/?LinkID=533485",privacyStatementUrl:"https://go.microsoft.com/fwlink/?LinkId=786907",showTelemetryOptOut:!0,npsSurveyUrl:"https://aka.ms/vscode-nps",cesSurveyUrl:"https://aka.ms/new-to-vscode-feedback",checksumFailMoreInfoUrl:"https://go.microsoft.com/fwlink/?LinkId=828886",electronRepository:"Microsoft/vscode-electron-prebuilt",settingsSearchUrl:"https://bingsettingssearch.trafficmanager.net/api/Search",surveys:[{surveyId:"cpp.1",surveyUrl:"https://www.research.net/r/VBVV6C6",languageId:"cpp",editCount:10,userProbability:.15},{surveyId:"java.2",surveyUrl:"https://www.research.net/r/vscodejava",languageId:"java",editCount:10,userProbability:.3},{surveyId:"javascript.1",surveyUrl:"https://www.research.net/r/vscode-js",languageId:"javascript",editCount:10,userProbability:.05},{surveyId:"typescript.1",surveyUrl:"https://www.research.net/r/vscode-ts",languageId:"typescript",editCount:10,userProbability:.05}],extensionEnabledApiProposals:{"ms-vscode.vscode-selfhost-test-provider":["testObserver"],"VisualStudioExptTeam.vscodeintellicode-completions":["inlineCompletionsNew","inlineCompletionsAdditions"],"ms-vsliveshare.vsliveshare":["contribMenuBarHome","diffCommand","documentFiltersExclusive","fileSearchProvider","findTextInFiles","notebookCellExecutionState","notebookContentProvider","notebookEditor","notebookEditorEdit","notebookLiveShare","notebookWorkspaceEdit","terminalDimensions","terminalDataWriteEvent","textSearchProvider"],"ms-vscode.js-debug":["portsAttributes","findTextInFiles","workspaceTrust","resolvers"],"ms-toolsai.vscode-ai-remote":["resolvers","notebookEditor"],"ms-python.python":["quickPickSortByLabel","testObserver","notebookEditor"],"ms-dotnettools.dotnet-interactive-vscode":["notebookCellExecutionState","notebookControllerKind","notebookDebugOptions","notebookEditor","notebookLiveShare","notebookMessaging","notebookMime","notebookWorkspaceEdit"],"GitHub.codespaces":["contribMenuBarHome","contribRemoteHelp","contribViewsRemote","notebookEditor","resolvers","terminalDataWriteEvent","treeViewReveal"],"ms-vscode.azure-repos":["extensionRuntime","fileSearchProvider","textSearchProvider"],"ms-vscode.remote-repositories":["contribEditSessions","contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","documentFiltersExclusive","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","scmSelectedProvider","scmValidation","textSearchProvider","timeline","notebookEditor"],"ms-vscode.remote-server":["resolvers"],"ms-vscode-remote.remote-wsl":["resolvers","contribViewsRemote","telemetry"],"ms-vscode-remote.remote-ssh":["resolvers","terminalDataWriteEvent","contribViewsRemote","telemetry"],"ms-vscode-remote.remote-containers":["resolvers","workspaceTrust","terminalDimensions","contribViewsRemote"],"ms-vscode.js-debug-nightly":["portsAttributes","findTextInFiles","workspaceTrust","resolvers"],"ms-vscode.lsif-browser":["documentFiltersExclusive"],"GitHub.vscode-pull-request-github":["tokenInformation","commentsResolvedState"],"GitHub.copilot":["inlineCompletionsNew","inlineCompletionsAdditions"],"GitHub.copilot-nightly":["inlineCompletionsNew","inlineCompletionsAdditions"],"GitHub.remotehub":["contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","documentFiltersExclusive","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","scmSelectedProvider","scmValidation","textSearchProvider","timeline","notebookEditor"],"GitHub.remotehub-insiders":["contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","documentFiltersExclusive","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","scmSelectedProvider","scmValidation","textSearchProvider","timeline","notebookEditor"],"ms-python.gather":["notebookEditor","notebookCellExecutionState"],"ms-python.vscode-pylance":["notebookEditor","notebookCellExecutionState"],"ms-toolsai.jupyter":["notebookControllerKind","notebookDebugOptions","notebookDeprecated","notebookEditor","notebookWorkspaceEdit","notebookMessaging","notebookMime","notebookCellExecutionState","portsAttributes","quickPickSortByLabel","notebookKernelSource"],"ms-toolsai.vscode-jupyter-powertoys":["notebookEditor","notebookEditorEdit","notebookWorkspaceEdit"],"dbaeumer.vscode-eslint":["notebookEditor","notebookCellExecutionState"],"ms-vscode.azure-sphere-tools-ui":["resolvers"],"ms-azuretools.vscode-azureappservice":["terminalDataWriteEvent"],"ms-vscode.anycode":["extensionsAny"],"ms-vscode.cpptools":["terminalDataWriteEvent"]},tasConfig:{endpoint:"https://default.exp-tas.com/vscode/ab",telemetryEventName:"query-expfeature",featuresTelemetryPropertyName:"VSCode.ABExp.Features",assignmentContextTelemetryPropertyName:"abexp.assignmentcontext"},experimentsUrl:"https://vscodeexperiments.azureedge.net/experiments/vscode-experiments.json",extensionKind:{"Shan.code-settings-sync":["ui"],"shalldie.background":["ui"],"techer.open-in-browser":["ui"],"CoenraadS.bracket-pair-colorizer-2":["ui"],"CoenraadS.bracket-pair-colorizer":["ui","workspace"],"hiro-sun.vscode-emacs":["ui","workspace"],"hnw.vscode-auto-open-markdown-preview":["ui","workspace"],"wayou.vscode-todo-highlight":["ui","workspace"],"aaron-bond.better-comments":["ui","workspace"],"vscodevim.vim":["ui"],"ollyhayes.colmak-vim":["ui"]},extensionPointExtensionKind:{typescriptServerPlugins:["workspace"]},extensionSyncedKeys:{"ritwickdey.liveserver":["liveServer.setup.version"]},extensionVirtualWorkspacesSupport:{"esbenp.prettier-vscode":{default:!1},"msjsdiag.debugger-for-chrome":{default:!1},"redhat.java":{default:!1},"HookyQR.beautify":{default:!1},"ritwickdey.LiveServer":{default:!1},"VisualStudioExptTeam.vscodeintellicode":{default:!1},"octref.vetur":{default:!1},"formulahendry.code-runner":{default:!1},"xdebug.php-debug":{default:!1},"ms-mssql.mssql":{default:!1},"christian-kohler.path-intellisense":{default:!1},"eg2.tslint":{default:!1},"eg2.vscode-npm-script":{default:!1},"donjayamanne.githistory":{default:!1},"Zignd.html-css-class-completion":{default:!1},"christian-kohler.npm-intellisense":{default:!1},"EditorConfig.EditorConfig":{default:!1},"austin.code-gnu-global":{default:!1},"johnpapa.Angular2":{default:!1},"ms-vscode.vscode-typescript-tslint-plugin":{default:!1},"DotJoshJohnson.xml":{default:!1},"techer.open-in-browser":{default:!1},"tht13.python":{default:!1},"bmewburn.vscode-intelephense-client":{default:!1},"Angular.ng-template":{default:!1},"xdebug.php-pack":{default:!1},"dbaeumer.jshint":{default:!1},"yzhang.markdown-all-in-one":{default:!1},"Dart-Code.flutter":{default:!1},"streetsidesoftware.code-spell-checker":{default:!1},"rebornix.Ruby":{default:!1},"ms-vscode.sublime-keybindings":{default:!1},"mitaki28.vscode-clang":{default:!1},"steoates.autoimport":{default:!1},"donjayamanne.python-extension-pack":{default:!1},"shd101wyy.markdown-preview-enhanced":{default:!1},"mikestead.dotenv":{default:!1},"pranaygp.vscode-css-peek":{default:!1},"ikappas.phpcs":{default:!1},"platformio.platformio-ide":{default:!1},"jchannon.csharpextensions":{default:!1},"gruntfuggly.todo-tree":{default:!1}},linkProtectionTrustedDomains:["https://*.visualstudio.com","https://*.microsoft.com","https://aka.ms","https://*.gallerycdn.vsassets.io","https://github.com/microsoft/","https://github.com/MicrosoftDocs/","https://login.microsoftonline.com"],auth:{loginUrl:"https://login.microsoftonline.com/common/oauth2/authorize",tokenUrl:"https://login.microsoftonline.com/common/oauth2/token",redirectUrl:"https://vscode-redirect.azurewebsites.net/",clientId:"aebc6443-996d-45c2-90f0-388ff96faa56"},"configurationSync.store":{url:"https://vscode-sync.trafficmanager.net/",stableUrl:"https://vscode-sync.trafficmanager.net/",insidersUrl:"https://vscode-sync-insiders.trafficmanager.net/",canSwitch:!1,authenticationProviders:{microsoft:{scopes:["openid","profile","email","offline_access"]},github:{scopes:["user:email"]}}},"sessionSync.store":{url:"https://vscode-sync.trafficmanager.net/",authenticationProviders:{microsoft:{scopes:["openid","profile","email","offline_access"]},github:{scopes:["user:email"]}}},builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.0.18",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.69.0",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.2",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode-remote.remote-wsl-recommender",version:"0.0.15",repo:"https://github.com/microsoft/vscode-remote-wsl-recommender",metadata:{id:"cb296d3c-017a-4dee-83af-ebb5a5a16e9a",publisherId:{publisherId:"ac9410a2-0d75-40ec-90de-b59bb705801d",publisherName:"ms-vscode-remote",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"},platforms:["win32"],clientOnly:!0}],version:"1.69.1",commit:"b06ae3b2d2dbfe28bca3134cc6be65935cdfea6a",date:"2022-07-12T08:08:34.173Z"},Object.keys(D).length===0&&Object.assign(D,{version:"1.67.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=D}),define(Ie[199],ke([1,0,4]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,u.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var $e=this&&this.__param||function(Q,e){return function(u,n){e(u,n,Q)}};define(Ie[118],ke([1,0,18,21,6,4]),function(Q,e,u,n,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,A.createDecorator)("progressService");var D;(function(L){L[L.Explorer=1]="Explorer",L[L.Scm=3]="Scm",L[L.Extensions=5]="Extensions",L[L.Window=10]="Window",L[L.Notification=15]="Notification",L[L.Dialog=20]="Dialog"})(D=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class C{constructor(I){this.callback=I}get value(){return this._value}report(I){this._value=I,this.callback(this._value)}}e.Progress=C,C.None=Object.freeze({report(){}});let S=class extends y.Disposable{constructor(I,_){super();this.deferred=new u.DeferredPromise,_.withProgress(I,T=>(this.reporter=T,this.lastStep&&T.report(this.lastStep),this.deferred.p)),this._register((0,y.toDisposable)(()=>this.deferred.complete()))}report(I){this.reporter?this.reporter.report(I):this.lastStep=I}};S=Ge([$e(1,e.IProgressService)],S),e.UnmanagedProgress=S;class P extends y.Disposable{constructor(I){super();this.progressIndicator=I,this.currentOperationId=0,this.currentOperationDisposables=this._register(new y.DisposableStore)}start(I){this.stop();const _=++this.currentOperationId,T=new n.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{_===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},I),this.currentOperationDisposables.add((0,y.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,y.toDisposable)(()=>T.cancel())),this.currentOperationDisposables.add((0,y.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:_,token:T.token,stop:()=>this.doStop(_),isCurrent:()=>this.currentOperationId===_}}stop(){this.doStop(this.currentOperationId)}doStop(I){this.currentOperationId===I&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=P,e.IEditorProgressService=(0,A.createDecorator)("editorProgressService")}),define(Ie[44],ke([1,0,56,10]),function(Q,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class y{constructor(){this.data=new Map}add(D,C){u.ok(n.isString(D)),u.ok(n.isObject(C)),u.ok(!this.data.has(D),"There is already an extension with this id"),this.data.set(D,C)}knows(D){return this.data.has(D)}as(D){return this.data.get(D)||null}}e.Registry=new y}),define(Ie[119],ke([1,0,3,44]),function(Q,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function y(C){return C.length>0&&C.charAt(C.length-1)==="#"?C.substring(0,C.length-1):C}class A{constructor(){this._onDidChangeSchema=new u.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(S,P){this.schemasById[y(S)]=P,this._onDidChangeSchema.fire(S)}notifySchemaChanged(S){this._onDidChangeSchema.fire(S)}getSchemaContributions(){return{schemas:this.schemasById}}}const D=new A;n.Registry.add(e.Extensions.JSONContribution,D)}),define(Ie[120],ke([1,0,16,3,10,164,83,119,44]),function(Q,e,u,n,y,A,D,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var P;(function(m){m.Multiline="multilineText",m.Singleline="singlelineText"})(P=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var L;(function(m){m[m.APPLICATION=1]="APPLICATION",m[m.MACHINE=2]="MACHINE",m[m.WINDOW=3]="WINDOW",m[m.RESOURCE=4]="RESOURCE",m[m.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",m[m.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(L=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const I=S.Registry.as(C.Extensions.JSONContribution);class _{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new n.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new n.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(o,d=!0){this.registerConfigurations([o],d)}registerConfigurations(o,d=!0){const r=this.doRegisterConfigurations(o,d);I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}deregisterConfigurations(o){const d=this.doDeregisterConfigurations(o);I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:d})}updateConfigurations({add:o,remove:d}){const r=[];r.push(...this.doDeregisterConfigurations(d)),r.push(...this.doRegisterConfigurations(o,!1)),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,u.distinct)(r)})}registerDefaultConfigurations(o){const d=[],r=[];for(const{overrides:s,source:i}of o)for(const t in s)if(d.push(t),e.OVERRIDE_PROPERTY_REGEX.test(t)){const c=this.configurationDefaultsOverrides.get(t),l=c?.valuesSources??new Map;if(i)for(const N of Object.keys(s[t]))l.set(N,i);const h={...c?.value||{},...s[t]};this.configurationDefaultsOverrides.set(t,{source:i,value:h,valuesSources:l});const E=(0,D.getLanguageTagSettingPlainKey)(t),R={type:"object",default:h,description:A.localize(1,null,E),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:h,source:y.isString(i)?void 0:i,defaultValueSource:i};r.push(...b(t)),this.configurationProperties[t]=R,this.defaultLanguageConfigurationOverridesNode.properties[t]=R}else{this.configurationDefaultsOverrides.set(t,{value:s[t],source:i});const c=this.configurationProperties[t];c&&(this.updatePropertyDefaultValue(t,c),this.updateSchema(t,c))}this.registerOverrideIdentifiers(r),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:d,defaultsOverrides:!0})}deregisterDefaultConfigurations(o){const d=[];for(const{overrides:r,source:s}of o)for(const i in r){const t=this.configurationDefaultsOverrides.get(i),c=y.isString(s)?s:s?.id,l=y.isString(t?.source)?t?.source:t?.source?.id;if(c===l)if(d.push(i),this.configurationDefaultsOverrides.delete(i),e.OVERRIDE_PROPERTY_REGEX.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const h=this.configurationProperties[i];h&&(this.updatePropertyDefaultValue(i,h),this.updateSchema(i,h))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:d,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...o){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(o){for(const d of o)this.overrideIdentifiers.add(d);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(o,d){const r=[];return o.forEach(s=>{r.push(...this.validateAndRegisterProperties(s,d,s.extensionInfo,s.restrictedProperties)),this.configurationContributors.push(s),this.registerJSONConfiguration(s)}),r}doDeregisterConfigurations(o){const d=[],r=s=>{if(s.properties)for(const i in s.properties){d.push(i);const t=this.configurationProperties[i];t?.policy?.name&&this.policyConfigurations.delete(t.policy.name),delete this.configurationProperties[i],this.removeFromSchema(i,s.properties[i])}s.allOf?.forEach(i=>r(i))};for(const s of o){r(s);const i=this.configurationContributors.indexOf(s);i!==-1&&this.configurationContributors.splice(i,1)}return d}validateAndRegisterProperties(o,d=!0,r,s,i=3){i=y.isUndefinedOrNull(o.scope)?i:o.scope;const t=[],c=o.properties;if(c)for(const h in c){const E=c[h];if(d&&f(h,E)){delete c[h];continue}if(E.source=r,E.defaultDefaultValue=c[h].default,this.updatePropertyDefaultValue(h,E),e.OVERRIDE_PROPERTY_REGEX.test(h)?E.scope=void 0:(E.scope=y.isUndefinedOrNull(E.scope)?i:E.scope,E.restricted=y.isUndefinedOrNull(E.restricted)?!!s?.includes(h):E.restricted),c[h].hasOwnProperty("included")&&!c[h].included){this.excludedConfigurationProperties[h]=c[h],delete c[h];continue}else this.configurationProperties[h]=c[h],c[h].policy?.name&&this.policyConfigurations.set(c[h].policy.name,h);!c[h].deprecationMessage&&c[h].markdownDeprecationMessage&&(c[h].deprecationMessage=c[h].markdownDeprecationMessage),t.push(h)}const l=o.allOf;if(l)for(const h of l)t.push(...this.validateAndRegisterProperties(h,d,r,s,i));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(o){const d=r=>{const s=r.properties;if(s)for(const t in s)this.updateSchema(t,s[t]);r.allOf?.forEach(d)};d(o)}updateSchema(o,d){switch(e.allSettings.properties[o]=d,d.scope){case 1:e.applicationSettings.properties[o]=d;break;case 2:e.machineSettings.properties[o]=d;break;case 6:e.machineOverridableSettings.properties[o]=d;break;case 3:e.windowSettings.properties[o]=d;break;case 4:e.resourceSettings.properties[o]=d;break;case 5:e.resourceSettings.properties[o]=d,this.resourceLanguageSettingsSchema.properties[o]=d;break}}removeFromSchema(o,d){switch(delete e.allSettings.properties[o],d.scope){case 1:delete e.applicationSettings.properties[o];break;case 2:delete e.machineSettings.properties[o];break;case 6:delete e.machineOverridableSettings.properties[o];break;case 3:delete e.windowSettings.properties[o];break;case 4:case 5:delete e.resourceSettings.properties[o],delete this.resourceLanguageSettingsSchema.properties[o];break}}updateOverridePropertyPatternKey(){for(const o of this.overrideIdentifiers.values()){const d=`[${o}]`,r={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(d,r),e.allSettings.properties[d]=r,e.applicationSettings.properties[d]=r,e.machineSettings.properties[d]=r,e.machineOverridableSettings.properties[d]=r,e.windowSettings.properties[d]=r,e.resourceSettings.properties[d]=r}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const o={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(o,d){const r=this.configurationDefaultsOverrides.get(o);let s=r?.value,i=r?.source;y.isUndefined(s)&&(s=d.defaultDefaultValue,i=void 0),y.isUndefined(s)&&(s=g(d.type)),d.default=s,d.defaultValueSource=i}}const T="\\[([^\\]]+)\\]",w=new RegExp(T,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${T})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function b(m){const o=[];if(e.OVERRIDE_PROPERTY_REGEX.test(m)){let d=w.exec(m);for(;d?.length;){const r=d[1].trim();r&&o.push(r),d=w.exec(m)}}return(0,u.distinct)(o)}e.overrideIdentifiersFromKey=b;function p(m){return m.reduce((o,d)=>`${o}[${d}]`,"")}e.keyFromOverrideIdentifiers=p;function g(m){switch(Array.isArray(m)?m[0]:m){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=g;const v=new _;S.Registry.add(e.Extensions.Configuration,v);function f(m,o){return m.trim()?e.OVERRIDE_PROPERTY_REGEX.test(m)?A.localize(7,null,m):v.getConfigurationProperties()[m]!==void 0?A.localize(8,null,m):o.policy?.name&&v.getPolicyConfigurations().get(o.policy?.name)!==void 0?A.localize(9,null,m,o.policy?.name,v.getPolicyConfigurations().get(o.policy?.name)):null:A.localize(6,null)}e.validateProperty=f;function a(){const m=[],o=v.getConfigurationProperties();for(const d of Object.keys(o))m.push([d,o[d].scope]);return m.push(["launch",4]),m.push(["task",4]),m}e.getScopes=a}),define(Ie[200],ke([1,0,16,3,143,6,25,24,10,2,83,120,44]),function(Q,e,u,n,y,A,D,C,S,P,L,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class T{constructor(d={},r=[],s=[]){this._contents=d,this._keys=r,this._overrides=s,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(d){return d?(0,L.getConfigurationValue)(this.contents,d):this.contents}getOverrideValue(d,r){const s=this.getContentsForOverrideIdentifer(r);return s?d?(0,L.getConfigurationValue)(s,d):s:void 0}getKeysForOverrideIdentifier(d){const r=[];for(const s of this.overrides)s.identifiers.includes(d)&&r.push(...s.keys);return u.distinct(r)}getAllOverrideIdentifiers(){const d=[];for(const r of this.overrides)d.push(...r.identifiers);return u.distinct(d)}override(d){let r=this.overrideConfigurations.get(d);return r||(r=this.createOverrideConfigurationModel(d),this.overrideConfigurations.set(d,r)),r}merge(...d){const r=C.deepClone(this.contents),s=C.deepClone(this.overrides),i=[...this.keys];for(const t of d)if(!t.isEmpty()){this.mergeContents(r,t.contents);for(const c of t.overrides){const[l]=s.filter(h=>u.equals(h.identifiers,c.identifiers));l?(this.mergeContents(l.contents,c.contents),l.keys.push(...c.keys),l.keys=u.distinct(l.keys)):s.push(C.deepClone(c))}for(const c of t.keys)i.indexOf(c)===-1&&i.push(c)}return new T(r,i,s)}freeze(){return this.frozen=!0,this}clone(){return new T(C.deepClone(this.contents),[...this.keys],C.deepClone(this.overrides))}createOverrideConfigurationModel(d){const r=this.getContentsForOverrideIdentifer(d);if(!r||typeof r!="object"||!Object.keys(r).length)return this;const s={};for(const i of u.distinct([...Object.keys(this.contents),...Object.keys(r)])){let t=this.contents[i];const c=r[i];c&&(typeof t=="object"&&typeof c=="object"?(t=C.deepClone(t),this.mergeContents(t,c)):t=c),s[i]=t}return new T(s,this.keys,this.overrides)}mergeContents(d,r){for(const s of Object.keys(r)){if(s in d&&S.isObject(d[s])&&S.isObject(r[s])){this.mergeContents(d[s],r[s]);continue}d[s]=C.deepClone(r[s])}}checkAndFreeze(d){return this.frozen&&!Object.isFrozen(d)?C.deepFreeze(d):d}getContentsForOverrideIdentifer(d){let r=null,s=null;const i=t=>{t&&(s?this.mergeContents(s,t):s=C.deepClone(t))};for(const t of this.overrides)u.equals(t.identifiers,[d])?r=t.contents:t.identifiers.includes(d)&&i(t.contents);return i(r),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(d,r){this.addKey(d),(0,L.addToValueTree)(this.contents,d,r,s=>{throw new Error(s)})}removeValue(d){this.removeKey(d)&&(0,L.removeFromValueTree)(this.contents,d)}addKey(d){let r=this.keys.length;for(let s=0;s<r;s++)d.indexOf(this.keys[s])===0&&(r=s);this.keys.splice(r,1,d)}removeKey(d){const r=this.keys.indexOf(d);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=T;class w{constructor(d){this._name=d,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new T}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(d,r){if(!S.isUndefinedOrNull(d)){const s=this.doParseContent(d);this.parseRaw(s,r)}}reparse(d){this._raw&&this.parseRaw(this._raw,d)}parseRaw(d,r){this._raw=d;const{contents:s,keys:i,overrides:t,restricted:c}=this.doParseRaw(d,r);this._configurationModel=new T(s,i,t),this._restrictedConfigurations=c||[]}doParseContent(d){let r={},s=null,i=[];const t=[],c=[];function l(E){Array.isArray(i)?i.push(E):s!==null&&(i[s]=E)}const h={onObjectBegin:()=>{const E={};l(E),t.push(i),i=E,s=null},onObjectProperty:E=>{s=E},onObjectEnd:()=>{i=t.pop()},onArrayBegin:()=>{const E=[];l(E),t.push(i),i=E,s=null},onArrayEnd:()=>{i=t.pop()},onLiteralValue:l,onError:(E,R,N)=>{c.push({error:E,offset:R,length:N})}};if(d)try{y.visit(d,h),r=i[0]||{}}catch(E){console.error(`Error while parsing settings file ${this._name}: ${E}`),this._parseErrors=[E]}return r}doParseRaw(d,r){const s=_.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),i=this.filter(d,s,!0,r);d=i.raw;const t=(0,L.toValuesTree)(d,h=>console.error(`Conflict in settings file ${this._name}: ${h}`)),c=Object.keys(d),l=this.toOverrides(d,h=>console.error(`Conflict in settings file ${this._name}: ${h}`));return{contents:t,keys:c,overrides:l,restricted:i.restricted}}filter(d,r,s,i){if(!i?.scopes&&!i?.skipRestricted)return{raw:d,restricted:[]};const t={},c=[];for(const l in d)if(I.OVERRIDE_PROPERTY_REGEX.test(l)&&s){const h=this.filter(d[l],r,!1,i);t[l]=h.raw,c.push(...h.restricted)}else{const h=r[l],E=h?typeof h.scope!="undefined"?h.scope:3:void 0;h?.restricted&&c.push(l),(E===void 0||i.scopes===void 0||i.scopes.includes(E))&&(i.skipRestricted&&h?.restricted||(t[l]=d[l]))}return{raw:t,restricted:c}}toOverrides(d,r){const s=[];for(const i of Object.keys(d))if(I.OVERRIDE_PROPERTY_REGEX.test(i)){const t={};for(const c in d[i])t[c]=d[i][c];s.push({identifiers:(0,I.overrideIdentifiersFromKey)(i),keys:Object.keys(t),contents:(0,L.toValuesTree)(t,r)})}return s}}e.ConfigurationModelParser=w;class b extends A.Disposable{constructor(d,r,s,i){super();this.userSettingsResource=d,this.scopes=r,this.fileService=i,this._onDidChange=this._register(new n.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new w(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(n.Event.any(n.Event.filter(this.fileService.onDidFilesChange,t=>t.contains(this.userSettingsResource)),n.Event.filter(this.fileService.onDidRunOperation,t=>(t.isOperation(0)||t.isOperation(3)||t.isOperation(1)||t.isOperation(4))&&s.isEqual(t.resource,d)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const d=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(d.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new T}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=b;class p{constructor(d,r,s,i,t=new T,c=new T,l=new D.ResourceMap,h=new T,E=new D.ResourceMap,R=!0){this._defaultConfiguration=d,this._policyConfiguration=r,this._applicationConfiguration=s,this._localUserConfiguration=i,this._remoteUserConfiguration=t,this._workspaceConfiguration=c,this._folderConfigurations=l,this._memoryConfiguration=h,this._memoryConfigurationByResource=E,this._freeze=R,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new D.ResourceMap,this._userConfiguration=null}getValue(d,r,s){return this.getConsolidatedConfigurationModel(d,r,s).getValue(d)}updateValue(d,r,s={}){let i;s.resource?(i=this._memoryConfigurationByResource.get(s.resource),i||(i=new T,this._memoryConfigurationByResource.set(s.resource,i))):i=this._memoryConfiguration,r===void 0?i.removeValue(d):i.setValue(d,r),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(d,r,s){const i=this.getConsolidatedConfigurationModel(d,r,s),t=this.getFolderConfigurationModelForResource(r.resource,s),c=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,l=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(d):this._defaultConfiguration.freeze().getValue(d),h=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(d),E=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().getValue(d),R=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(d):this.userConfiguration.freeze().getValue(d),N=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(d):this.localUserConfiguration.freeze().getValue(d),O=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(d):this.remoteUserConfiguration.freeze().getValue(d),k=s?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(d):this._workspaceConfiguration.freeze().getValue(d):void 0,U=t?r.overrideIdentifier?t.freeze().override(r.overrideIdentifier).getValue(d):t.freeze().getValue(d):void 0,F=r.overrideIdentifier?c.override(r.overrideIdentifier).getValue(d):c.getValue(d),$=i.getValue(d),ee=u.distinct(i.overrides.map(B=>B.identifiers).flat()).filter(B=>i.getOverrideValue(d,B)!==void 0);return{defaultValue:l,policyValue:h,applicationValue:E,userValue:R,userLocalValue:N,userRemoteValue:O,workspaceValue:k,workspaceFolderValue:U,memoryValue:F,value:$,default:l!==void 0?{value:this._defaultConfiguration.freeze().getValue(d),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(d,r.overrideIdentifier):void 0}:void 0,policy:h!==void 0?{value:h}:void 0,application:E!==void 0?{value:E,override:r.overrideIdentifier?this.applicationConfiguration.freeze().getOverrideValue(d,r.overrideIdentifier):void 0}:void 0,user:R!==void 0?{value:this.userConfiguration.freeze().getValue(d),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(d,r.overrideIdentifier):void 0}:void 0,userLocal:N!==void 0?{value:this.localUserConfiguration.freeze().getValue(d),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(d,r.overrideIdentifier):void 0}:void 0,userRemote:O!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(d),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(d,r.overrideIdentifier):void 0}:void 0,workspace:k!==void 0?{value:this._workspaceConfiguration.freeze().getValue(d),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(d,r.overrideIdentifier):void 0}:void 0,workspaceFolder:U!==void 0?{value:t?.freeze().getValue(d),override:r.overrideIdentifier?t?.freeze().getOverrideValue(d,r.overrideIdentifier):void 0}:void 0,memory:F!==void 0?{value:c.getValue(d),override:r.overrideIdentifier?c.getOverrideValue(d,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:ee.length?ee:void 0}}keys(d){const r=this.getFolderConfigurationModelForResource(void 0,d);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(d){this._defaultConfiguration=d,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(d){this._policyConfiguration=d}updateApplicationConfiguration(d){this._applicationConfiguration=d,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(d){this._localUserConfiguration=d,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(d){this._remoteUserConfiguration=d,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(d){this._workspaceConfiguration=d,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(d,r){this._folderConfigurations.set(d,r),this._foldersConsolidatedConfigurations.delete(d)}deleteFolderConfiguration(d){this.folderConfigurations.delete(d),this._foldersConsolidatedConfigurations.delete(d)}compareAndUpdateDefaultConfiguration(d,r){const s=[];if(!r){const{added:i,updated:t,removed:c}=a(this._defaultConfiguration,d);r=[...i,...t,...c]}for(const i of r)for(const t of(0,I.overrideIdentifiersFromKey)(i)){const c=this._defaultConfiguration.getKeysForOverrideIdentifier(t),l=d.getKeysForOverrideIdentifier(t),h=[...l.filter(E=>c.indexOf(E)===-1),...c.filter(E=>l.indexOf(E)===-1),...c.filter(E=>!C.equals(this._defaultConfiguration.override(t).getValue(E),d.override(t).getValue(E)))];s.push([t,h])}return this.updateDefaultConfiguration(d),{keys:r,overrides:s}}compareAndUpdatePolicyConfiguration(d){const{added:r,updated:s,removed:i}=a(this._policyConfiguration,d),t=[...r,...s,...i];return t.length&&this.updatePolicyConfiguration(d),{keys:t,overrides:[]}}compareAndUpdateApplicationConfiguration(d){const{added:r,updated:s,removed:i,overrides:t}=a(this.applicationConfiguration,d),c=[...r,...s,...i];return c.length&&this.updateApplicationConfiguration(d),{keys:c,overrides:t}}compareAndUpdateLocalUserConfiguration(d){const{added:r,updated:s,removed:i,overrides:t}=a(this.localUserConfiguration,d),c=[...r,...s,...i];return c.length&&this.updateLocalUserConfiguration(d),{keys:c,overrides:t}}compareAndUpdateRemoteUserConfiguration(d){const{added:r,updated:s,removed:i,overrides:t}=a(this.remoteUserConfiguration,d),c=[...r,...s,...i];return c.length&&this.updateRemoteUserConfiguration(d),{keys:c,overrides:t}}compareAndUpdateWorkspaceConfiguration(d){const{added:r,updated:s,removed:i,overrides:t}=a(this.workspaceConfiguration,d),c=[...r,...s,...i];return c.length&&this.updateWorkspaceConfiguration(d),{keys:c,overrides:t}}compareAndUpdateFolderConfiguration(d,r){const s=this.folderConfigurations.get(d),{added:i,updated:t,removed:c,overrides:l}=a(s,r),h=[...i,...t,...c];return(h.length||!s)&&this.updateFolderConfiguration(d,r),{keys:h,overrides:l}}compareAndDeleteFolderConfiguration(d){const r=this.folderConfigurations.get(d);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(d);const{added:s,updated:i,removed:t,overrides:c}=a(r,void 0);return{keys:[...s,...i,...t],overrides:c}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(d,r,s){let i=this.getConsolidatedConfigurationModelForResource(r,s);return r.overrideIdentifier&&(i=i.override(r.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(d)!==void 0&&(i=i.merge(this._policyConfiguration)),i}getConsolidatedConfigurationModelForResource({resource:d},r){let s=this.getWorkspaceConsolidatedConfiguration();if(r&&d){const i=r.getFolder(d);i&&(s=this.getFolderConsolidatedConfiguration(i.uri)||s);const t=this._memoryConfigurationByResource.get(d);t&&(s=s.merge(t))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(d){let r=this._foldersConsolidatedConfigurations.get(d);if(!r){const s=this.getWorkspaceConsolidatedConfiguration(),i=this._folderConfigurations.get(d);i?(r=s.merge(i),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(d,r)):r=s}return r}getFolderConfigurationModelForResource(d,r){if(r&&d){const s=r.getFolder(d);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((d,r)=>{const{contents:s,overrides:i,keys:t}=this._folderConfigurations.get(r);return d.push([r,{contents:s,overrides:i,keys:t}]),d},[])}}allKeys(){const d=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>d.add(r)),this.userConfiguration.freeze().keys.forEach(r=>d.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>d.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(s=>d.add(s))),[...d.values()]}allOverrideIdentifiers(){const d=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(r=>d.add(r)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(r=>d.add(r)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(r=>d.add(r)),this._folderConfigurations.forEach(r=>r.freeze().getAllOverrideIdentifiers().forEach(s=>d.add(s))),[...d.values()]}getAllKeysForOverrideIdentifier(d){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(d).forEach(s=>r.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(d).forEach(s=>r.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(d).forEach(s=>r.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(d).forEach(i=>r.add(i))),[...r.values()]}static parse(d){const r=this.parseConfigurationModel(d.defaults),s=this.parseConfigurationModel(d.policy),i=this.parseConfigurationModel(d.application),t=this.parseConfigurationModel(d.user),c=this.parseConfigurationModel(d.workspace),l=d.folders.reduce((h,E)=>(h.set(P.URI.revive(E[0]),this.parseConfigurationModel(E[1])),h),new D.ResourceMap);return new p(r,s,i,t,new T,c,l,new T,new D.ResourceMap,!1)}static parseConfigurationModel(d){return new T(d.contents,d.keys,d.overrides).freeze()}}e.Configuration=p;function g(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const d=new Set,r=new Map;for(const i of o)i.keys.forEach(t=>d.add(t)),i.overrides.forEach(([t,c])=>{const l=(0,D.getOrSet)(r,t,new Set);c.forEach(h=>l.add(h))});const s=[];return r.forEach((i,t)=>s.push([t,[...i.values()]])),{keys:[...d.values()],overrides:s}}e.mergeChanges=g;class v{constructor(d,r,s,i){this.change=d,this.previous=r,this.currentConfiguraiton=s,this.currentWorkspace=i,this._previousConfiguration=void 0;const t=new Set;d.keys.forEach(l=>t.add(l)),d.overrides.forEach(([,l])=>l.forEach(h=>t.add(h))),this.affectedKeys=[...t.values()];const c=new T;this.affectedKeys.forEach(l=>c.setValue(l,{})),this.affectedKeysTree=c.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=p.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(d,r){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,d)){if(r){const s=this.previousConfiguration?this.previousConfiguration.getValue(d,r,this.previous?.workspace):void 0,i=this.currentConfiguraiton.getValue(d,r,this.currentWorkspace);return!C.equals(s,i)}return!0}return!1}doesAffectedKeysTreeContains(d,r){let s=(0,L.toValuesTree)({[r]:!0},()=>{}),i;for(;typeof s=="object"&&(i=Object.keys(s)[0]);){if(d=d[i],!d)return!1;s=s[i]}return!0}}e.ConfigurationChangeEvent=v;class f extends v{constructor(d,r,s,i){super({keys:d.allKeys(),overrides:[]},void 0,d,r);this.source=s,this.sourceConfig=i}}e.AllKeysConfigurationChangeEvent=f;function a(o,d){const{added:r,removed:s,updated:i}=m(d,o),t=[],c=o?.getAllOverrideIdentifiers()||[],l=d?.getAllOverrideIdentifiers()||[];if(d){const h=l.filter(E=>!c.includes(E));for(const E of h)t.push([E,d.getKeysForOverrideIdentifier(E)])}if(o){const h=c.filter(E=>!l.includes(E));for(const E of h)t.push([E,o.getKeysForOverrideIdentifier(E)])}if(d&&o){for(const h of c)if(l.includes(h)){const E=m({contents:o.getOverrideValue(void 0,h)||{},keys:o.getKeysForOverrideIdentifier(h)},{contents:d.getOverrideValue(void 0,h)||{},keys:d.getKeysForOverrideIdentifier(h)});t.push([h,[...E.added,...E.removed,...E.updated]])}}return{added:r,removed:s,updated:i,overrides:t}}function m(o,d){const r=o?d?o.keys.filter(t=>d.keys.indexOf(t)===-1):[...o.keys]:[],s=d?o?d.keys.filter(t=>o.keys.indexOf(t)===-1):[...d.keys]:[],i=[];if(o&&d){for(const t of d.keys)if(o.keys.indexOf(t)!==-1){const c=(0,L.getConfigurationValue)(d.contents,t),l=(0,L.getConfigurationValue)(o.contents,t);C.equals(c,l)||i.push(t)}}return{added:r,removed:s,updated:i}}}),define(Ie[121],ke([1,0,12,4]),function(Q,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,n.createDecorator)("remoteAuthorityResolverService");var y;(function(D){D.Unknown="Unknown",D.NotAvailable="NotAvailable",D.TemporarilyNotAvailable="TemporarilyNotAvailable",D.NoResolverFound="NoResolverFound"})(y=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class A extends u.ErrorNoTelemetry{constructor(C,S=y.Unknown,P){super(C);this._message=C,this._code=S,this._detail=P,this.isHandled=S===y.NotAvailable&&P===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,A.prototype)}static isTemporarilyNotAvailable(C){return C instanceof A&&C._code===y.TemporarilyNotAvailable}static isNoResolverFound(C){return C instanceof A&&C._code===y.NoResolverFound}static isHandled(C){return C instanceof A&&C.isHandled}}e.RemoteAuthorityResolverError=A}),define(Ie[122],ke([1,0,11]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function n(P){return P.scheme===u.Schemas.vscodeRemote?P.authority:void 0}e.getRemoteAuthority=n;function y(P){if(!P)return;const L=P.indexOf("+");return L<0?P:P.substr(0,L)}e.getRemoteName=y;function A(P){return`/${P.quality??"oss"}-${P.commit??"dev"}`}e.getRemoteServerRootPath=A;function D(P){const{host:L,port:I}=S(P);if(typeof I=="undefined")throw new Error("Remote authority doesn't contain a port!");return{host:L,port:I}}e.parseAuthorityWithPort=D;function C(P,L){let{host:I,port:_}=S(P);return typeof _=="undefined"&&(_=L),{host:I,port:_}}e.parseAuthorityWithOptionalPort=C;function S(P){const L=P.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(L)return{host:L[1],port:parseInt(L[2],10)};const I=P.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const _=P.match(/(.*):(\d+)$/);return _?{host:_[1],port:parseInt(_[2],10)}:{host:P,port:void 0}}}),define(Ie[28],ke([1,0,8,4,122]),function(Q,e,u,n,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}e.getWorkspaceSupportTypeMessage=A;function D(w){return w&&typeof w=="object"&&typeof w.id=="string"&&(!w.uuid||typeof w.uuid=="string")}e.isIExtensionIdentifier=D,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var C;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(C=e.ExtensionType||(e.ExtensionType={}));var S;(function(w){w.WIN32_X64="win32-x64",w.WIN32_IA32="win32-ia32",w.WIN32_ARM64="win32-arm64",w.LINUX_X64="linux-x64",w.LINUX_ARM64="linux-arm64",w.LINUX_ARMHF="linux-armhf",w.ALPINE_X64="alpine-x64",w.ALPINE_ARM64="alpine-arm64",w.DARWIN_X64="darwin-x64",w.DARWIN_ARM64="darwin-arm64",w.WEB="web",w.UNIVERSAL="universal",w.UNKNOWN="unknown",w.UNDEFINED="undefined"})(S=e.TargetPlatform||(e.TargetPlatform={}));class P{constructor(b){this.value=b,this._lower=b.toLowerCase()}static equals(b,p){if(typeof b=="undefined"||b===null)return typeof p=="undefined"||p===null;if(typeof p=="undefined"||p===null)return!1;if(typeof b=="string"||typeof p=="string"){const g=typeof b=="string"?b:b.value,v=typeof p=="string"?p:p.value;return u.equalsIgnoreCase(g,v)}return b._lower===p._lower}static toKey(b){return typeof b=="string"?b.toLowerCase():b._lower}}e.ExtensionIdentifier=P;function L(w){return I(w)}e.isApplicationScopedExtension=L;function I(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}e.isLanguagePackExtension=I;function _(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=_;function T(w,b){if(b){const p=`onResolveRemoteAuthority:${(0,y.getRemoteName)(b)}`;return w.activationEvents?.indexOf(p)!==-1}return!1}e.isResolverExtension=T,e.IBuiltinExtensionsScannerService=(0,n.createDecorator)("IBuiltinExtensionsScannerService")}),define(Ie[201],ke([1,0,8,84,28,13,2,12,40]),function(Q,e,u,n,y,A,D,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function P(r,s){return r.uuid&&s.uuid?r.uuid===s.uuid:r.id===s.id?!0:(0,u.compareIgnoreCase)(r.id,s.id)===0}e.areSameExtensions=P;const L=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class I{constructor(s,i,t="undefined"){this.version=i,this.targetPlatform=t,this.id=s.id}static create(s){const i=s.manifest?s.manifest.version:s.version,t=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new I(s.identifier,i,t)}static parse(s){const i=L.exec(s);return i&&i[1]&&i[2]?new I({id:i[1]},i[2],i[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof I?P(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.ExtensionKey=I;const _=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function T(r){const s=_.exec(r);return s&&s[1]?[b(s[1]),s[2]]:[b(r),void 0]}e.getIdAndVersion=T;function w(r,s){return`${r}.${s}`}e.getExtensionId=w;function b(r){return r.toLocaleLowerCase()}e.adoptToGalleryExtensionId=b;function p(r,s){return b(w(r,s))}e.getGalleryExtensionId=p;function g(r,s){const i=[],t=c=>{for(const l of i)if(l.some(h=>P(s(h),s(c))))return l;return null};for(const c of r){const l=t(c);l?l.push(c):i.push([c])}return i}e.groupByExtension=g;function v(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=v;function f(r){return{id:r.identifier.id,name:r.name,galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),...r.telemetryData}}e.getGalleryExtensionTelemetryData=f,e.BetterMergeId=new y.ExtensionIdentifier("pprice.better-merge");function a(r){const s=new Set;if(r.malicious)for(const i of r.malicious)s.add(i.id);return s}e.getMaliciousExtensionsSet=a;function m(r,s){const i=[],t=s.manifest.extensionDependencies?.slice(0)??[];for(;t.length;){const c=t.shift();if(c&&i.every(l=>!P(l.identifier,{id:c}))){const l=r.filter(h=>P(h.identifier,{id:c}));l.length===1&&(i.push(l[0]),t.push(...l[0].manifest.extensionDependencies?.slice(0)??[]))}}return i}e.getExtensionDependencies=m;async function o(r,s){if(!A.isLinux)return!1;let i;try{i=(await r.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{i=(await r.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){s.debug("Error while getting the os-release file.",(0,C.getErrorMessage)(c))}}return!!i&&(i.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=o;async function d(r,s){const i=await o(r,s),t=(0,n.getTargetPlatform)(i?"alpine":A.platform,S.arch);return s.debug("ComputeTargetPlatform:",t),t}e.computeTargetPlatform=d}),define(Ie[202],ke([1,0]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class u{constructor(){this.validators=new Map}vsda(){return new Promise((y,A)=>Q(["vsda"],y,A))}async createNewMessage(y){try{const A=await this.vsda(),D=new A.validator;if(D){const C=String(u._nextId++);return this.validators.set(C,D),{id:C,data:D.createNewMessage(y)}}}catch{}return{id:"",data:y}}async validate(y,A){if(!y.id)return!0;const D=this.validators.get(y.id);if(!D)return!1;this.validators.delete(y.id);try{return D.validate(A)==="ok"}catch{return!1}}async sign(y){try{const A=await this.vsda(),D=new A.signer;if(D)return D.sign(y)}catch{}return y}}e.SignService=u,u._nextId=1}),define(Ie[203],ke([1,0]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class u{constructor(y){this._callback=y,this._terminalBufferMap=new Map}dispose(){for(const y of this._terminalBufferMap.values())y.dispose()}startBuffering(y,A,D=5){const C=A(S=>{const P=typeof S=="string"?S:S.data;let L=this._terminalBufferMap.get(y);if(L){L.data.push(P);return}const I=setTimeout(()=>this.flushBuffer(y),D);L={data:[P],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(y),C.dispose()}},this._terminalBufferMap.set(y,L)});return C}stopBuffering(y){const A=this._terminalBufferMap.get(y);A&&A.dispose()}flushBuffer(y){const A=this._terminalBufferMap.get(y);A&&(this._terminalBufferMap.delete(y),this._callback(y,A.data.join("")))}}e.TerminalDataBufferer=u}),define(Ie[204],ke([1,0]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var u;(function(A){A.DARK="dark",A.LIGHT="light",A.HIGH_CONTRAST_DARK="hcDark",A.HIGH_CONTRAST_LIGHT="hcLight"})(u=e.ColorScheme||(e.ColorScheme={}));function n(A){return A===u.HIGH_CONTRAST_DARK||A===u.HIGH_CONTRAST_LIGHT}e.isHighContrast=n;function y(A){return A===u.DARK||A===u.HIGH_CONTRAST_DARK}e.isDark=y}),define(Ie[86],ke([1,0,77,3,6,4,44,204]),function(Q,e,u,n,y,A,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,A.createDecorator)("themeService");var S;(function(p){function g(v){return v&&typeof v=="object"&&typeof v.id=="string"}p.isThemeColor=g})(S=e.ThemeColor||(e.ThemeColor={}));function P(p){return{id:p}}e.themeColorFromId=P;var L;(function(p){function g(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color=="undefined"||S.isThemeColor(s.color))}p.isThemeIcon=g;const v=new RegExp(`^\\$\\((${u.CSSIcon.iconNameExpression}(?:${u.CSSIcon.iconModifierExpression})?)\\)$`);function f(s){const i=v.exec(s);if(!i)return;const[,t]=i;return{id:t}}p.fromString=f;function a(s){return{id:s}}p.fromId=a;function m(s,i){let t=s.id;const c=t.lastIndexOf("~");return c!==-1&&(t=t.substring(0,c)),i&&(t=`${t}~${i}`),{id:t}}p.modify=m;function o(s){const i=s.id.lastIndexOf("~");if(i!==-1)return s.id.substring(i+1)}p.getModifier=o;function d(s,i){return s.id===i.id&&s.color?.id===i.color?.id}p.isEqual=d;function r(s,i){return{id:s.id,color:i?P(i):void 0}}p.asThemeIcon=r,p.asClassNameArray=u.CSSIcon.asClassNameArray,p.asClassName=u.CSSIcon.asClassName,p.asCSSSelector=u.CSSIcon.asCSSSelector})(L=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=u.Codicon.file,e.FolderThemeIcon=u.Codicon.folder;function I(p){switch(p){case C.ColorScheme.DARK:return"vs-dark";case C.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case C.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=I,e.Extensions={ThemingContribution:"base.contributions.theming"};class _{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new n.Emitter}onColorThemeChange(g){return this.themingParticipants.push(g),this.onThemingParticipantAddedEmitter.fire(g),(0,y.toDisposable)(()=>{const v=this.themingParticipants.indexOf(g);this.themingParticipants.splice(v,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const T=new _;D.Registry.add(e.Extensions.ThemingContribution,T);function w(p){return T.onColorThemeChange(p)}e.registerThemingParticipant=w;class b extends y.Disposable{constructor(g){super();this.themeService=g,this.theme=g.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(v=>this.onThemeChange(v)))}onThemeChange(g){this.theme=g,this.updateStyles()}updateStyles(){}getColor(g,v){let f=this.theme.getColor(g);return f&&v&&(f=v(f,this.theme)),f?f.toString():null}}e.Themable=b}),define(Ie[123],ke([1,0,3,13,4,14]),function(Q,e,u,n,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,y.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,y.createDecorator)("sharedTunnelsService");var D;(function(b){b.Http="http",b.Https="https"})(D=e.TunnelProtocol||(e.TunnelProtocol={}));var C;(function(b){b.ConstantPrivate="constantPrivate",b.Private="private",b.Public="public"})(C=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var S;(function(b){b[b.Notify=1]="Notify",b[b.OpenBrowser=2]="OpenBrowser",b[b.OpenPreview=3]="OpenPreview",b[b.Silent=4]="Silent",b[b.Ignore=5]="Ignore",b[b.OpenBrowserOnce=6]="OpenBrowserOnce"})(S=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function P(b){if(b.scheme!=="http"&&b.scheme!=="https")return;const p=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(b.authority);if(!!p)return{address:p[1],port:+p[2]}}e.extractLocalHostUriMetaDataForPortMapping=P,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function L(b){return e.LOCALHOST_ADDRESSES.indexOf(b)>=0}e.isLocalhost=L,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function I(b){return e.ALL_INTERFACES_ADDRESSES.indexOf(b)>=0}e.isAllInterfaces=I;function _(b,p){return p?p!==1&&b<1024:!n.isWindows&&b<1024}e.isPortPrivileged=_;class T{constructor(p,g,v){this.remoteAddress=p,this.localAddress=g,this._dispose=v,this._onDispose=new u.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=T;let w=class{constructor(p){this.logService=p,this._onTunnelOpened=new u.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new u.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new u.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(p){return this._tunnelProvider=p,p?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(p){this._canElevate=p.elevation,this._privacyOptions=p.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const p=[],g=Array.from(this._tunnels.values());for(const v of g){const f=Array.from(v.values());for(const a of f){const m=await a.value;m&&p.push(m)}}return p}async dispose(){for(const p of this._tunnels.values()){for(const{value:g}of p.values())await g.then(v=>v?.dispose());p.clear()}this._tunnels.clear()}openTunnel(p,g,v,f,a=!1,m,o){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${g}:${v} on local port ${f}.`),!p)return;if(g||(g="localhost"),this._tunnelProvider&&this._factoryInProgress.has(v)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const d=this.retainOrCreateTunnel(p,g,v,f,a,m,o);return d?d.then(r=>{if(!r){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(g,v);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.makeTunnel(r);return(r.tunnelRemoteHost!==g||r.tunnelRemotePort!==v)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(s),s}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),d)}makeTunnel(p){return{tunnelRemotePort:p.tunnelRemotePort,tunnelRemoteHost:p.tunnelRemoteHost,tunnelLocalPort:p.tunnelLocalPort,localAddress:p.localAddress,privacy:p.privacy,protocol:p.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${p.tunnelRemoteHost}:${p.tunnelRemotePort} `);const g=this._tunnels.get(p.tunnelRemoteHost);if(g){const v=g.get(p.tunnelRemotePort);v&&(v.refcount--,await this.tryDisposeTunnel(p.tunnelRemoteHost,p.tunnelRemotePort,v))}}}}async tryDisposeTunnel(p,g,v){if(v.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${p}:${g}.`);const f=v.value.then(async a=>{a&&(await a.dispose(!0),this._onTunnelClosed.fire({host:a.tunnelRemoteHost,port:a.tunnelRemotePort}))});return this._tunnels.has(p)&&this._tunnels.get(p).delete(g),f}}async closeTunnel(p,g){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${p}:${g} `);const v=this._tunnels.get(p);if(v&&v.has(g)){const f=v.get(g);f.refcount=0,await this.tryDisposeTunnel(p,g,f)}}addTunnelToMap(p,g,v){this._tunnels.has(p)||this._tunnels.set(p,new Map),this._tunnels.get(p).set(g,{refcount:1,value:v})}async removeEmptyTunnelFromMap(p,g){const v=this._tunnels.get(p);v&&(await v.get(g)||v.delete(g),v.size===0&&this._tunnels.delete(p))}getTunnelFromMap(p,g){const v=[p];L(p)?(v.push(...e.LOCALHOST_ADDRESSES),v.push(...e.ALL_INTERFACES_ADDRESSES)):I(p)&&v.push(...e.ALL_INTERFACES_ADDRESSES);const f=v.map(a=>this._tunnels.get(a));for(const a of f){const m=a?.get(g);if(m)return m}}canTunnel(p){return!!P(p)}createWithProvider(p,g,v,f,a,m,o){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${g}:${v} on local port ${f}.`);const d=v;this._factoryInProgress.add(d);const s={elevationRequired:a?_(f===void 0?v:f):!1},i={remoteAddress:{host:g,port:v},localAddressPort:f,privacy:m,public:m?m!==C.Private:void 0,protocol:o},t=p.forwardPort(i,s);return t?(this.addTunnelToMap(g,v,t),t.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(d)})):this._factoryInProgress.delete(d),t}};w=Ge([$e(0,A.ILogService)],w),e.AbstractTunnelService=w}),define(Ie[205],ke([1,0,11]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function n(S){return S.scheme!==u.Schemas.file&&S.scheme!==u.Schemas.vscodeRemote}e.isVirtualResource=n;function y(S){if(S.folders.length)return S.folders.every(P=>n(P.uri))?S.folders[0].uri:void 0;if(S.configuration&&n(S.configuration))return S.configuration}e.getVirtualWorkspaceLocation=y;function A(S){return y(S)?.scheme}e.getVirtualWorkspaceScheme=A;function D(S){return y(S)?.authority}e.getVirtualWorkspaceAuthority=D;function C(S){return y(S)!==void 0}e.isVirtualWorkspace=C}),define(Ie[45],ke([1,0,170,9,25,22,2,4,11]),function(Q,e,u,n,y,A,D,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,C.createDecorator)("contextService");function P(r){const s=r;return typeof s?.id=="string"&&D.URI.isUri(s.uri)}e.isSingleFolderWorkspaceIdentifier=P;function L(r){if(r.configuration)return{id:r.id,configPath:r.configuration};if(r.folders.length===1)return{id:r.id,uri:r.folders[0].uri}}e.toWorkspaceIdentifier=L;function I(r){const s=r;return typeof s?.id=="string"&&D.URI.isUri(s.configPath)}e.isWorkspaceIdentifier=I;function _(r){const s=r;if(s?.uri)return{id:s.id,uri:D.URI.revive(s.uri)};const i=r;if(i?.configPath)return{id:i.id,configPath:D.URI.revive(i.configPath)};if(r?.id)return{id:r.id}}e.reviveIdentifier=_;var T;(function(r){r[r.EMPTY=1]="EMPTY",r[r.FOLDER=2]="FOLDER",r[r.WORKSPACE=3]="WORKSPACE"})(T=e.WorkbenchState||(e.WorkbenchState={}));function w(r){const s=r;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}e.isWorkspace=w;function b(r){const s=r;return!!(s&&typeof s=="object"&&D.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}e.isWorkspaceFolder=b;class p{constructor(s,i,t,c,l){this._id=s,this._transient=t,this._configuration=c,this._ignorePathCasing=l,this._foldersMap=y.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=i}update(s){this._id=s.id,this._configuration=s.configuration,this._transient=s.transient,this._ignorePathCasing=s._ignorePathCasing,this.folders=s.folders}get folders(){return this._folders}set folders(s){this._folders=s,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(s){this._configuration=s}getFolder(s){return s&&this._foldersMap.findSubstr(s)||null}updateFoldersMap(){this._foldersMap=y.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const s of this.folders)this._foldersMap.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=p;class g{constructor(s,i){this.raw=i,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,A.joinPath)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=g;function v(r){return new g({uri:r,index:0,name:(0,A.basenameOrAuthority)(r)},{uri:r.toString()})}e.toWorkspaceFolder=v,e.WORKSPACE_EXTENSION="code-workspace";const f=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,u.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function a(r,s){return A.extUriBiasedIgnorePathCase.isEqualOrParent(r,s.untitledWorkspacesHome)}e.isUntitledWorkspace=a;function m(r){let s;return D.URI.isUri(r)?s=r:s=r.configuration,s?.scheme===S.Schemas.tmp}e.isTemporaryWorkspace=m;function o(r,s){return!a(r,s)&&!m(r)}e.isSavedWorkspace=o;function d(r){return(typeof r=="string"?(0,n.extname)(r):(0,A.extname)(r))===f}e.hasWorkspaceFileExtension=d}),define(Ie[87],ke([1,0]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class u{constructor(y){this.id=y,this._data=new Map,this._idPool=1}add(y){const A=this._idPool++;return this._data.set(A,y),this.logDebugInfo(),A}get(y,A){return this._data.has(y)?this._data.get(y)[A]:void 0}delete(y){this._data.delete(y),this.logDebugInfo()}logDebugInfo(){!u.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=u,u.enableDebugLogging=!1}),define(Ie[46],ke([1,0,11,22,4]),function(Q,e,u,n,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class A{constructor(){this._systemSchemes=new Set(Object.keys(u.Schemas)),this._providerInfo=new Map,this.extUri=new n.ExtUri(C=>{const S=this._providerInfo.get(C.scheme);return!(S===void 0||S&1024)})}$acceptProviderInfos(C,S){S===null?this._providerInfo.delete(C.scheme):this._providerInfo.set(C.scheme,S)}isFreeScheme(C){return!this._providerInfo.has(C)&&!this._systemSchemes.has(C)}getCapabilities(C){return this._providerInfo.get(C)}}e.ExtHostFileSystemInfo=A,e.IExtHostFileSystemInfo=(0,y.createDecorator)("IExtHostFileSystemInfo")}),define(Ie[26],ke([1,0,4]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,u.createDecorator)("IExtHostInitDataService")}),define(Ie[206],ke([1,0,18]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class n{constructor(D,C,S){this._deferredPromises=new Map,this._id=D,this._shared=C,this._storage=S,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(P=>(this._value=P,this)),this._storageListener=this._storage.onDidChangeStorage(P=>{P.shared===this._shared&&P.key===this._id&&(this._value=P.value)}),this._scheduler=new u.RunOnceScheduler(()=>{const P=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const L of P.values())L.complete()}catch(L){for(const I of P.values())I.error(L)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,D])=>D!==void 0).map(([D])=>D)}get whenReady(){return this._init}get(D,C){let S=this._value[D];return typeof S=="undefined"&&(S=C),S}update(D,C){this._value[D]=C;const S=this._deferredPromises.get(D);if(S!==void 0)return S.p;const P=new u.DeferredPromise;return this._deferredPromises.set(D,P),this._scheduler.isScheduled()||this._scheduler.schedule(),P.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=n;class y extends n{constructor(D,C){super(D.identifier.value,!0,C);this._extension=D}setKeysForSync(D){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},D)}}e.ExtensionGlobalMemento=y}),define(Ie[207],ke([1,0,3,2]),function(Q,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class y{constructor(D){this._notebooksAndEditors=D,this._onDidSaveNotebookDocument=new u.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new u.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(D,C,S,P){const I=this._notebooksAndEditors.getNotebookDocument(n.URI.revive(D)).acceptModelChanged(C.value,S,P);this._onDidChangeNotebookDocument.fire(I)}$acceptDirtyStateChanged(D,C){this._notebooksAndEditors.getNotebookDocument(n.URI.revive(D)).acceptDirty(C)}$acceptModelSaved(D){const C=this._notebooksAndEditors.getNotebookDocument(n.URI.revive(D));this._onDidSaveNotebookDocument.fire(C.apiNotebook)}}e.ExtHostNotebookDocuments=y}),define(Ie[17],ke([1,0,4]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,u.createDecorator)("IExtHostRpcService");class n{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.dispose=A.dispose.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.ExtHostRpcService=n});var tt=this&&this.__classPrivateFieldSet||function(Q,e,u,n,y){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!y:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?y.call(Q,u):y?y.value=u:e.set(Q,u),u},Me=this&&this.__classPrivateFieldGet||function(Q,e,u,n){if(u==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!n:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?n:u==="a"?n.call(Q):n?n.value:e.get(Q)};define(Ie[208],ke([1,0,28,3]),function(Q,e,u,n){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class A{constructor(C,S){y.set(this,void 0),this._onDidChange=new n.Emitter,this.onDidChange=this._onDidChange.event,this._id=u.ExtensionIdentifier.toKey(C.identifier),tt(this,y,S,"f"),Me(this,y,"f").onDidChangePassword(P=>{P.extensionId===this._id&&this._onDidChange.fire({key:P.key})})}get(C){return Me(this,y,"f").get(this._id,C)}store(C,S){return Me(this,y,"f").store(this._id,C,S)}delete(C){return Me(this,y,"f").delete(this._id,C)}}e.ExtensionSecrets=A,y=new WeakMap}),define(Ie[124],ke([1,0,4,3]),function(Q,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class y{constructor(){this._onDidChangeTelemetryEnabled=new n.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=new n.Emitter,this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}$initializeTelemetryLevel(D,C){this._level=D,this._productConfig=C||{usage:!0,error:!0}}$onDidChangeTelemetryLevel(D){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=D,this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails())}}e.ExtHostTelemetry=y,e.IExtHostTelemetry=(0,u.createDecorator)("IExtHostTelemetry")}),define(Ie[52],ke([1,0,4,123,3,17]),function(Q,e,u,n,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var D;(function(S){function P(I){return{remoteAddress:I.remoteAddress,localAddress:I.localAddress,public:!!I.public,privacy:I.privacy??(I.public?n.TunnelPrivacyId.Public:n.TunnelPrivacyId.Private),protocol:I.protocol}}S.fromApiTunnel=P;function L(I){return{remoteAddress:{host:I.tunnelRemoteHost,port:I.tunnelRemotePort},localAddress:I.localAddress,public:I.privacy!==n.TunnelPrivacyId.ConstantPrivate&&I.privacy!==n.TunnelPrivacyId.ConstantPrivate,privacy:I.privacy,protocol:I.protocol}}S.fromServiceTunnel=L})(D=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,u.createDecorator)("IExtHostTunnelService");let C=class{constructor(P){this.onDidChangeTunnels=new y.Emitter().event}async $applyCandidateFilter(P){return P}async openTunnel(P,L){}async getTunnels(){return[]}async setTunnelFactory(P){return{dispose:()=>{}}}registerPortsAttributesProvider(P,L){return{dispose:()=>{}}}async $providePortAttributes(P,L,I,_,T){return[]}async $forwardPort(P,L){}async $closeTunnel(P){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};C=Ge([$e(0,A.IExtHostRpcService)],C),e.ExtHostTunnelService=C});var tt=this&&this.__classPrivateFieldSet||function(Q,e,u,n,y){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!y:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?y.call(Q,u):y?y.value=u:e.set(Q,u),u},Me=this&&this.__classPrivateFieldGet||function(Q,e,u,n){if(u==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!n:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?n:u==="a"?n.call(Q):n?n.value:e.get(Q)};define(Ie[7],ke([1,0,16,12,106,25,101,8,10,2,34,43,121]),function(Q,e,u,n,y,A,D,C,S,P,L,I,_){"use strict";var T,w,b,p,g,v,f,a,m,o,d,r,s,i,t,c,l,h,E,R,N,O;Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKindNew=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionsNew=e.InlineSuggestionNew=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function k(x){function W(){return Reflect.construct(x,arguments,this.constructor)}return Object.defineProperty(W,"name",Object.getOwnPropertyDescriptor(x,"name")),Object.setPrototypeOf(W,x),Object.setPrototypeOf(W.prototype,x.prototype),W}let U=v=class{constructor(W){T.set(this,void 0),tt(this,T,W,"f")}static from(...W){let ce=W;return new v(function(){if(ce){for(const Le of ce)Le&&typeof Le.dispose=="function"&&Le.dispose();ce=void 0}})}dispose(){typeof Me(this,T,"f")=="function"&&(Me(this,T,"f").call(this),tt(this,T,void 0,"f"))}};T=new WeakMap,U=v=Ge([k],U),e.Disposable=U;let F=f=class{constructor(W,ce){if(W<0)throw(0,n.illegalArgument)("line must be non-negative");if(ce<0)throw(0,n.illegalArgument)("character must be non-negative");this._line=W,this._character=ce}static Min(...W){if(W.length===0)throw new TypeError;let ce=W[0];for(let Le=1;Le<W.length;Le++){const Qe=W[Le];Qe.isBefore(ce)&&(ce=Qe)}return ce}static Max(...W){if(W.length===0)throw new TypeError;let ce=W[0];for(let Le=1;Le<W.length;Le++){const Qe=W[Le];Qe.isAfter(ce)&&(ce=Qe)}return ce}static isPosition(W){if(!W)return!1;if(W instanceof f)return!0;const{line:ce,character:Le}=W;return typeof ce=="number"&&typeof Le=="number"}static of(W){if(W instanceof f)return W;if(this.isPosition(W))return new f(W.line,W.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}isBefore(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<W._character}isBeforeOrEqual(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<=W._character}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this._line===W._line&&this._character===W._character}compareTo(W){return this._line<W._line?-1:this._line>W.line?1:this._character<W._character?-1:this._character>W._character?1:0}translate(W,ce=0){if(W===null||ce===null)throw(0,n.illegalArgument)();let Le;return typeof W=="undefined"?Le=0:typeof W=="number"?Le=W:(Le=typeof W.lineDelta=="number"?W.lineDelta:0,ce=typeof W.characterDelta=="number"?W.characterDelta:0),Le===0&&ce===0?this:new f(this.line+Le,this.character+ce)}with(W,ce=this.character){if(W===null||ce===null)throw(0,n.illegalArgument)();let Le;return typeof W=="undefined"?Le=this.line:typeof W=="number"?Le=W:(Le=typeof W.line=="number"?W.line:this.line,ce=typeof W.character=="number"?W.character:this.character),Le===this.line&&ce===this.character?this:new f(Le,ce)}toJSON(){return{line:this.line,character:this.character}}};F=f=Ge([k],F),e.Position=F;let $=a=class{constructor(W,ce,Le,Qe){let rt,lt;if(typeof W=="number"&&typeof ce=="number"&&typeof Le=="number"&&typeof Qe=="number"?(rt=new F(W,ce),lt=new F(Le,Qe)):F.isPosition(W)&&F.isPosition(ce)&&(rt=F.of(W),lt=F.of(ce)),!rt||!lt)throw new Error("Invalid arguments");rt.isBefore(lt)?(this._start=rt,this._end=lt):(this._start=lt,this._end=rt)}static isRange(W){return W instanceof a?!0:W?F.isPosition(W.start)&&F.isPosition(W.end):!1}static of(W){if(W instanceof a)return W;if(this.isRange(W))return new a(W.start,W.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}contains(W){return a.isRange(W)?this.contains(W.start)&&this.contains(W.end):F.isPosition(W)?!(F.of(W).isBefore(this._start)||this._end.isBefore(W)):!1}isEqual(W){return this._start.isEqual(W._start)&&this._end.isEqual(W._end)}intersection(W){const ce=F.Max(W.start,this._start),Le=F.Min(W.end,this._end);if(!ce.isAfter(Le))return new a(ce,Le)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const ce=F.Min(W.start,this._start),Le=F.Max(W.end,this.end);return new a(ce,Le)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(W,ce=this.end){if(W===null||ce===null)throw(0,n.illegalArgument)();let Le;return W?F.isPosition(W)?Le=W:(Le=W.start||this.start,ce=W.end||this.end):Le=this.start,Le.isEqual(this._start)&&ce.isEqual(this.end)?this:new a(Le,ce)}toJSON(){return[this.start,this.end]}};$=a=Ge([k],$),e.Range=$;let ee=m=class extends ${constructor(W,ce,Le,Qe){let rt,lt;if(typeof W=="number"&&typeof ce=="number"&&typeof Le=="number"&&typeof Qe=="number"?(rt=new F(W,ce),lt=new F(Le,Qe)):F.isPosition(W)&&F.isPosition(ce)&&(rt=F.of(W),lt=F.of(ce)),!rt||!lt)throw new Error("Invalid arguments");super(rt,lt);this._anchor=rt,this._active=lt}static isSelection(W){return W instanceof m?!0:W?$.isRange(W)&&F.isPosition(W.anchor)&&F.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};ee=m=Ge([k],ee),e.Selection=ee;class B{constructor(W,ce,Le){if(typeof W!="string"||W.length===0)throw(0,n.illegalArgument)("host");if(typeof ce!="number"||ce===0||Math.round(ce)!==ce)throw(0,n.illegalArgument)("port");if(typeof Le!="undefined"&&(typeof Le!="string"||Le.length===0||!/^[0-9A-Za-z\-]+$/.test(Le)))throw(0,n.illegalArgument)("connectionToken");this.host=W,this.port=Math.round(ce),this.connectionToken=Le}}e.ResolvedAuthority=B;class z extends Error{constructor(W,ce=_.RemoteAuthorityResolverErrorCode.Unknown,Le){super(W);this._message=W,this._code=ce,this._detail=Le,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,z.prototype)}static NotAvailable(W,ce){return new z(W,_.RemoteAuthorityResolverErrorCode.NotAvailable,ce)}static TemporarilyNotAvailable(W){return new z(W,_.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=z;var q;(function(x){x[x.LF=1]="LF",x[x.CRLF=2]="CRLF"})(q=e.EndOfLine||(e.EndOfLine={}));var V;(function(x){x[x.Replace=1]="Replace",x[x.Append=2]="Append",x[x.Prepend=3]="Prepend"})(V=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let j=o=class{constructor(W,ce){this._range=W,this._newText=ce}static isTextEdit(W){return W instanceof o?!0:W?$.isRange(W)&&typeof W.newText=="string":!1}static replace(W,ce){return new o(W,ce)}static insert(W,ce){return o.replace(new $(W,W),ce)}static delete(W){return o.replace(W,"")}static setEndOfLine(W){const ce=new o(new $(new F(0,0),new F(0,0)),"");return ce.newEol=W,ce}get range(){return this._range}set range(W){if(W&&!$.isRange(W))throw(0,n.illegalArgument)("range");this._range=W}get newText(){return this._newText||""}set newText(W){if(W&&typeof W!="string")throw(0,n.illegalArgument)("newText");this._newText=W}get newEol(){return this._newEol}set newEol(W){if(W&&typeof W!="number")throw(0,n.illegalArgument)("newEol");this._newEol=W}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};j=o=Ge([k],j),e.TextEdit=j;let ne=d=class{constructor(W,ce){this.range=W,this.newCells=ce}static isNotebookCellEdit(W){return W instanceof d?!0:W?zt.isNotebookRange(W)&&Array.isArray(W.newCells):!1}static replaceCells(W,ce){return new d(W,ce)}static insertCells(W,ce){return new d(new zt(W,W),ce)}static deleteCells(W){return new d(W,[])}static updateCellMetadata(W,ce){const Le=new d(new zt(W,W),[]);return Le.newCellMetadata=ce,Le}static updateNotebookMetadata(W){const ce=new d(new zt(0,0),[]);return ce.newNotebookMetadata=W,ce}};ne=d=Ge([k],ne),e.NotebookEdit=ne;var Y;(function(x){x[x.File=1]="File",x[x.Text=2]="Text",x[x.Cell=3]="Cell",x[x.CellReplace=5]="CellReplace"})(Y=e.FileEditType||(e.FileEditType={}));let le=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(W,ce,Le,Qe){this._edits.push({_type:1,from:W,to:ce,options:Le,metadata:Qe})}createFile(W,ce,Le){this._edits.push({_type:1,from:void 0,to:W,options:ce,metadata:Le})}deleteFile(W,ce,Le){this._edits.push({_type:1,from:W,to:void 0,options:ce,metadata:Le})}replaceNotebookMetadata(W,ce,Le){this._edits.push({_type:3,metadata:Le,uri:W,edit:{editType:5,metadata:ce},notebookMetadata:ce})}replaceNotebookCells(W,ce,Le,Qe,rt){let lt,ut,Ct=[],Lt;if(zt.isNotebookRange(ce)&&jt.isNotebookCellDataArray(Le)&&!jt.isNotebookCellDataArray(Qe)?(lt=ce.start,ut=ce.end,Ct=Le,Lt=Qe):typeof ce=="number"&&typeof Le=="number"&&jt.isNotebookCellDataArray(Qe)&&(lt=ce,ut=Le,Ct=Qe,Lt=rt),lt===void 0||ut===void 0)throw new Error("Invalid arguments");(lt!==ut||Ct.length>0)&&this._edits.push({_type:5,uri:W,index:lt,count:ut-lt,cells:Ct,metadata:Lt})}replaceNotebookCellMetadata(W,ce,Le,Qe){this._edits.push({_type:3,metadata:Qe,uri:W,edit:{editType:8,index:ce,metadata:Le}})}replace(W,ce,Le,Qe){this._edits.push({_type:2,uri:W,edit:new j(ce,Le),metadata:Qe})}insert(W,ce,Le,Qe){this.replace(W,new $(ce,ce),Le,Qe)}delete(W,ce,Le){this.replace(W,ce,"",Le)}has(W){return this._edits.some(ce=>ce._type===2&&ce.uri.toString()===W.toString())}set(W,ce){if(ce)for(const Le of ce)Le&&(ne.isNotebookCellEdit(Le)?Le.newCellMetadata?this.replaceNotebookCellMetadata(W,Le.range.start,Le.newCellMetadata):Le.newNotebookMetadata?this.replaceNotebookMetadata(W,Le.newNotebookMetadata):this.replaceNotebookCells(W,Le.range,Le.newCells):this._edits.push({_type:2,uri:W,edit:Le}));else{for(let Le=0;Le<this._edits.length;Le++){const Qe=this._edits[Le];Qe._type===2&&Qe.uri.toString()===W.toString()&&(this._edits[Le]=void 0)}(0,u.coalesceInPlace)(this._edits)}}get(W){const ce=[];for(const Le of this._edits)Le._type===2&&Le.uri.toString()===W.toString()&&ce.push(Le.edit);return ce}entries(){const W=new A.ResourceMap;for(const ce of this._edits)if(ce._type===2){let Le=W.get(ce.uri);Le||(Le=[ce.uri,[]],W.set(ce.uri,Le)),Le[1].push(ce.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};le=Ge([k],le),e.WorkspaceEdit=le;let ue=r=class{constructor(W){this._tabstop=1,this.value=W||""}static isSnippetString(W){return W instanceof r?!0:W?typeof W.value=="string":!1}static _escape(W){return W.replace(/\$|}|\\/g,"\\$&")}appendText(W){return this.value+=r._escape(W),this}appendTabstop(W=this._tabstop++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,ce=this._tabstop++){if(typeof W=="function"){const Le=new r;Le._tabstop=this._tabstop,W(Le),this._tabstop=Le._tabstop,W=Le.value}else W=r._escape(W);return this.value+="${",this.value+=ce,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,ce=this._tabstop++){const Le=W.map(Qe=>Qe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ce,this.value+="|",this.value+=Le,this.value+="|}",this}appendVariable(W,ce){if(typeof ce=="function"){const Le=new r;Le._tabstop=this._tabstop,ce(Le),this._tabstop=Le._tabstop,ce=Le.value}else typeof ce=="string"&&(ce=ce.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,ce&&(this.value+=":",this.value+=ce),this.value+="}",this}};ue=r=Ge([k],ue),e.SnippetString=ue;var K;(function(x){x[x.Unnecessary=1]="Unnecessary",x[x.Deprecated=2]="Deprecated"})(K=e.DiagnosticTag||(e.DiagnosticTag={}));var ge;(function(x){x[x.Hint=3]="Hint",x[x.Information=2]="Information",x[x.Warning=1]="Warning",x[x.Error=0]="Error"})(ge=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ye=s=class{constructor(W,ce){if(this.uri=W,ce)if($.isRange(ce))this.range=$.of(ce);else if(F.isPosition(ce))this.range=new $(ce,ce);else throw new Error("Illegal argument")}static isLocation(W){return W instanceof s?!0:W?$.isRange(W.range)&&P.URI.isUri(W.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};ye=s=Ge([k],ye),e.Location=ye;let Te=class{constructor(W,ce){this.location=W,this.message=ce}static is(W){return W?typeof W.message=="string"&&W.location&&$.isRange(W.location.range)&&P.URI.isUri(W.location.uri):!1}static isEqual(W,ce){return W===ce?!0:!W||!ce?!1:W.message===ce.message&&W.location.range.isEqual(ce.location.range)&&W.location.uri.toString()===ce.location.uri.toString()}};Te=Ge([k],Te),e.DiagnosticRelatedInformation=Te;let pe=class{constructor(W,ce,Le=ge.Error){if(!$.isRange(W))throw new TypeError("range must be set");if(!ce)throw new TypeError("message must be set");this.range=W,this.message=ce,this.severity=Le}toJSON(){return{severity:ge[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,ce){return W===ce?!0:!W||!ce?!1:W.message===ce.message&&W.severity===ce.severity&&W.code===ce.code&&W.severity===ce.severity&&W.source===ce.source&&W.range.isEqual(ce.range)&&(0,u.equals)(W.tags,ce.tags)&&(0,u.equals)(W.relatedInformation,ce.relatedInformation,Te.isEqual)}};pe=Ge([k],pe),e.Diagnostic=pe;let Pe=class{constructor(W,ce){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:this.contents=[W],this.range=ce}};Pe=Ge([k],Pe),e.Hover=Pe;var fe;(function(x){x[x.Text=0]="Text",x[x.Read=1]="Read",x[x.Write=2]="Write"})(fe=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let ve=class{constructor(W,ce=fe.Text){this.range=W,this.kind=ce}toJSON(){return{range:this.range,kind:fe[this.kind]}}};ve=Ge([k],ve),e.DocumentHighlight=ve;var _e;(function(x){x[x.File=0]="File",x[x.Module=1]="Module",x[x.Namespace=2]="Namespace",x[x.Package=3]="Package",x[x.Class=4]="Class",x[x.Method=5]="Method",x[x.Property=6]="Property",x[x.Field=7]="Field",x[x.Constructor=8]="Constructor",x[x.Enum=9]="Enum",x[x.Interface=10]="Interface",x[x.Function=11]="Function",x[x.Variable=12]="Variable",x[x.Constant=13]="Constant",x[x.String=14]="String",x[x.Number=15]="Number",x[x.Boolean=16]="Boolean",x[x.Array=17]="Array",x[x.Object=18]="Object",x[x.Key=19]="Key",x[x.Null=20]="Null",x[x.EnumMember=21]="EnumMember",x[x.Struct=22]="Struct",x[x.Event=23]="Event",x[x.Operator=24]="Operator",x[x.TypeParameter=25]="TypeParameter"})(_e=e.SymbolKind||(e.SymbolKind={}));var ae;(function(x){x[x.Deprecated=1]="Deprecated"})(ae=e.SymbolTag||(e.SymbolTag={}));let he=i=class{constructor(W,ce,Le,Qe,rt){this.name=W,this.kind=ce,this.containerName=rt,typeof Le=="string"&&(this.containerName=Le),Qe instanceof ye?this.location=Qe:Le instanceof $&&(this.location=new ye(Qe,Le)),i.validate(this)}static validate(W){if(!W.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:_e[this.kind],location:this.location,containerName:this.containerName}}};he=i=Ge([k],he),e.SymbolInformation=he;let te=t=class{constructor(W,ce,Le,Qe,rt){this.name=W,this.detail=ce,this.kind=Le,this.range=Qe,this.selectionRange=rt,this.children=[],t.validate(this)}static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children?.forEach(t.validate)}};te=t=Ge([k],te),e.DocumentSymbol=te;var ie;(function(x){x[x.Invoke=1]="Invoke",x[x.Automatic=2]="Automatic"})(ie=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let M=class{constructor(W,ce){this.title=W,this.kind=ce}};M=Ge([k],M),e.CodeAction=M;let H=c=class{constructor(W){this.value=W}append(W){return new c(this.value?this.value+c.sep+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+c.sep)}};H.sep=".",H=c=Ge([k],H),e.CodeActionKind=H,H.Empty=new H(""),H.QuickFix=H.Empty.append("quickfix"),H.Refactor=H.Empty.append("refactor"),H.RefactorExtract=H.Refactor.append("extract"),H.RefactorInline=H.Refactor.append("inline"),H.RefactorRewrite=H.Refactor.append("rewrite"),H.Source=H.Empty.append("source"),H.SourceOrganizeImports=H.Source.append("organizeImports"),H.SourceFixAll=H.Source.append("fixAll");let G=class{constructor(W,ce){if(this.range=W,this.parent=ce,ce&&!ce.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};G=Ge([k],G),e.SelectionRange=G;class X{constructor(W,ce,Le,Qe,rt,lt){this.kind=W,this.name=ce,this.detail=Le,this.uri=Qe,this.range=rt,this.selectionRange=lt}}e.CallHierarchyItem=X;class de{constructor(W,ce){this.fromRanges=ce,this.from=W}}e.CallHierarchyIncomingCall=de;class be{constructor(W,ce){this.fromRanges=ce,this.to=W}}e.CallHierarchyOutgoingCall=be;var se;(function(x){x[x.Information=0]="Information",x[x.Warning=1]="Warning",x[x.Error=2]="Error"})(se=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let De=class{constructor(W,ce){this.range=W,this.command=ce}get isResolved(){return!!this.command}};De=Ge([k],De),e.CodeLens=De;let Ce=l=class{constructor(W,ce=!1){w.set(this,void 0),tt(this,w,new y.MarkdownString(W,{supportThemeIcons:ce}),"f")}static isMarkdownString(W){return W instanceof l?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}get value(){return Me(this,w,"f").value}set value(W){Me(this,w,"f").value=W}get isTrusted(){return Me(this,w,"f").isTrusted}set isTrusted(W){Me(this,w,"f").isTrusted=W}get supportThemeIcons(){return Me(this,w,"f").supportThemeIcons}set supportThemeIcons(W){Me(this,w,"f").supportThemeIcons=W}get supportHtml(){return Me(this,w,"f").supportHtml}set supportHtml(W){Me(this,w,"f").supportHtml=W}get baseUri(){return Me(this,w,"f").baseUri}set baseUri(W){Me(this,w,"f").baseUri=W}appendText(W){return Me(this,w,"f").appendText(W),this}appendMarkdown(W){return Me(this,w,"f").appendMarkdown(W),this}appendCodeblock(W,ce){return Me(this,w,"f").appendCodeblock(ce??"",W),this}};w=new WeakMap,Ce=l=Ge([k],Ce),e.MarkdownString=Ce;let ze=class{constructor(W,ce){this.label=W,this.documentation=ce}};ze=Ge([k],ze),e.ParameterInformation=ze;let Ke=class{constructor(W,ce){this.label=W,this.documentation=ce,this.parameters=[]}};Ke=Ge([k],Ke),e.SignatureInformation=Ke;let Ne=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Ne=Ge([k],Ne),e.SignatureHelp=Ne;var Ye;(function(x){x[x.Invoke=1]="Invoke",x[x.TriggerCharacter=2]="TriggerCharacter",x[x.ContentChange=3]="ContentChange"})(Ye=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Z;(function(x){x[x.Type=1]="Type",x[x.Parameter=2]="Parameter"})(Z=e.InlayHintKind||(e.InlayHintKind={}));let re=class{constructor(W){this.value=W}};re=Ge([k],re),e.InlayHintLabelPart=re;let Se=class{constructor(W,ce,Le){this.position=W,this.label=ce,this.kind=Le}};Se=Ge([k],Se),e.InlayHint=Se;var We;(function(x){x[x.Invoke=0]="Invoke",x[x.TriggerCharacter=1]="TriggerCharacter",x[x.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(We=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var oe;(function(x){x[x.Text=0]="Text",x[x.Method=1]="Method",x[x.Function=2]="Function",x[x.Constructor=3]="Constructor",x[x.Field=4]="Field",x[x.Variable=5]="Variable",x[x.Class=6]="Class",x[x.Interface=7]="Interface",x[x.Module=8]="Module",x[x.Property=9]="Property",x[x.Unit=10]="Unit",x[x.Value=11]="Value",x[x.Enum=12]="Enum",x[x.Keyword=13]="Keyword",x[x.Snippet=14]="Snippet",x[x.Color=15]="Color",x[x.File=16]="File",x[x.Reference=17]="Reference",x[x.Folder=18]="Folder",x[x.EnumMember=19]="EnumMember",x[x.Constant=20]="Constant",x[x.Struct=21]="Struct",x[x.Event=22]="Event",x[x.Operator=23]="Operator",x[x.TypeParameter=24]="TypeParameter",x[x.User=25]="User",x[x.Issue=26]="Issue"})(oe=e.CompletionItemKind||(e.CompletionItemKind={}));var Re;(function(x){x[x.Deprecated=1]="Deprecated"})(Re=e.CompletionItemTag||(e.CompletionItemTag={}));let Be=class{constructor(W,ce){this.label=W,this.kind=ce}toJSON(){return{label:this.label,kind:this.kind&&oe[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Be=Ge([k],Be),e.CompletionItem=Be;let qe=class{constructor(W=[],ce=!1){this.items=W,this.isIncomplete=ce}};qe=Ge([k],qe),e.CompletionList=qe;let je=class{constructor(W,ce,Le){this.insertText=W,this.range=ce,this.command=Le}};je=Ge([k],je),e.InlineSuggestion=je;let Ve=class{constructor(W){this.commands=void 0,this.items=W}};Ve=Ge([k],Ve),e.InlineSuggestionList=Ve;let nt=class{constructor(W,ce,Le){this.insertText=W,this.range=ce,this.command=Le}};nt=Ge([k],nt),e.InlineSuggestionNew=nt;let ot=class{constructor(W,ce){this.items=W,this.commands=ce}};ot=Ge([k],ot),e.InlineSuggestionsNew=ot;var st;(function(x){x[x.Active=-1]="Active",x[x.Beside=-2]="Beside",x[x.One=1]="One",x[x.Two=2]="Two",x[x.Three=3]="Three",x[x.Four=4]="Four",x[x.Five=5]="Five",x[x.Six=6]="Six",x[x.Seven=7]="Seven",x[x.Eight=8]="Eight",x[x.Nine=9]="Nine"})(st=e.ViewColumn||(e.ViewColumn={}));var it;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(it=e.StatusBarAlignment||(e.StatusBarAlignment={}));var at;(function(x){x[x.Off=0]="Off",x[x.On=1]="On",x[x.Relative=2]="Relative"})(at=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var wt;(function(x){x[x.Manual=1]="Manual",x[x.AfterDelay=2]="AfterDelay",x[x.FocusOut=3]="FocusOut"})(wt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Tt;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(Tt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var _t;(function(x){x[x.Keyboard=1]="Keyboard",x[x.Mouse=2]="Mouse",x[x.Command=3]="Command"})(_t=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ft;(function(x){x[x.Undo=1]="Undo",x[x.Redo=2]="Redo"})(ft=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var It;(function(x){x[x.OpenOpen=0]="OpenOpen",x[x.ClosedClosed=1]="ClosedClosed",x[x.OpenClosed=2]="OpenClosed",x[x.ClosedOpen=3]="ClosedOpen"})(It=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(x){function W(ce){switch(ce){case"keyboard":return x.Keyboard;case"mouse":return x.Mouse;case"api":return x.Command}}x.fromValue=W}(_t=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ft=class{constructor(W,ce){if(ce&&!P.URI.isUri(ce))throw(0,n.illegalArgument)("target");if(!$.isRange(W)||W.isEmpty)throw(0,n.illegalArgument)("range");this.range=W,this.target=ce}};Ft=Ge([k],Ft),e.DocumentLink=Ft;let At=class{constructor(W,ce,Le,Qe){this.red=W,this.green=ce,this.blue=Le,this.alpha=Qe}};At=Ge([k],At),e.Color=At;let Xe=class{constructor(W,ce){if(ce&&!(ce instanceof At))throw(0,n.illegalArgument)("color");if(!$.isRange(W)||W.isEmpty)throw(0,n.illegalArgument)("range");this.range=W,this.color=ce}};Xe=Ge([k],Xe),e.ColorInformation=Xe;let Rt=class{constructor(W){if(!W||typeof W!="string")throw(0,n.illegalArgument)("label");this.label=W}};Rt=Ge([k],Rt),e.ColorPresentation=Rt;var Mt;(function(x){x[x.RGB=0]="RGB",x[x.HEX=1]="HEX",x[x.HSL=2]="HSL"})(Mt=e.ColorFormat||(e.ColorFormat={}));var Ot;(function(x){x[x.Error=0]="Error",x[x.Warning=1]="Warning",x[x.Information=2]="Information"})(Ot=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class mt{constructor(W,ce,Le){if(this.startIndex=W,this.length=ce,this.tooltip=Le,typeof W!="number"||W<0)throw(0,n.illegalArgument)("startIndex");if(typeof ce!="number"||ce<1)throw(0,n.illegalArgument)("length");if(Le!==void 0&&typeof Le!="string")throw(0,n.illegalArgument)("tooltip")}}e.TerminalLink=mt;var Dt;(function(x){x[x.Panel=1]="Panel",x[x.Editor=2]="Editor"})(Dt=e.TerminalLocation||(e.TerminalLocation={}));class Ae{constructor(W){if(this.options=W,typeof W!="object")throw(0,n.illegalArgument)("options")}}e.TerminalProfile=Ae;var Oe;(function(x){x[x.Always=1]="Always",x[x.Silent=2]="Silent",x[x.Never=3]="Never"})(Oe=e.TaskRevealKind||(e.TaskRevealKind={}));var Ee;(function(x){x[x.Shared=1]="Shared",x[x.Dedicated=2]="Dedicated",x[x.New=3]="New"})(Ee=e.TaskPanelKind||(e.TaskPanelKind={}));let J=h=class{constructor(W,ce){if(this.label=ce,typeof W!="string"||typeof ce!="string")throw(0,n.illegalArgument)("name");this._id=W}static from(W){switch(W){case"clean":return h.Clean;case"build":return h.Build;case"rebuild":return h.Rebuild;case"test":return h.Test;default:return}}get id(){return this._id}};J.Clean=new h("clean","Clean"),J.Build=new h("build","Build"),J.Rebuild=new h("rebuild","Rebuild"),J.Test=new h("test","Test"),J=h=Ge([k],J),e.TaskGroup=J;function Fe(x){let W="";for(let ce=0;ce<x.length;ce++)W+=x[ce].replace(/,/g,",,")+",";return W}let xe=class{constructor(W,ce,Le){if(typeof W!="string")throw(0,n.illegalArgument)("process");this._args=[],this._process=W,ce!==void 0&&(Array.isArray(ce)?(this._args=ce,this._options=Le):this._options=ce)}get process(){return this._process}set process(W){if(typeof W!="string")throw(0,n.illegalArgument)("process");this._process=W}get args(){return this._args}set args(W){Array.isArray(W)||(W=[]),this._args=W}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("process"),this._process!==void 0&&W.push(this._process),this._args&&this._args.length>0)for(const ce of this._args)W.push(ce);return Fe(W)}};xe=Ge([k],xe),e.ProcessExecution=xe;let Je=class{constructor(W,ce,Le){if(this._args=[],Array.isArray(ce)){if(!W)throw(0,n.illegalArgument)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,n.illegalArgument)("command");this._command=W,this._args=ce,this._options=Le}else{if(typeof W!="string")throw(0,n.illegalArgument)("commandLine");this._commandLine=W,this._options=ce}}get commandLine(){return this._commandLine}set commandLine(W){if(typeof W!="string")throw(0,n.illegalArgument)("commandLine");this._commandLine=W}get command(){return this._command?this._command:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,n.illegalArgument)("command");this._command=W}get args(){return this._args}set args(W){this._args=W||[]}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("shell"),this._commandLine!==void 0&&W.push(this._commandLine),this._command!==void 0&&W.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const ce of this._args)W.push(typeof ce=="string"?ce:ce.value);return Fe(W)}};Je=Ge([k],Je),e.ShellExecution=Je;var et;(function(x){x[x.Escape=1]="Escape",x[x.Strong=2]="Strong",x[x.Weak=3]="Weak"})(et=e.ShellQuoting||(e.ShellQuoting={}));var Ze;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace"})(Ze=e.TaskScope||(e.TaskScope={}));class gt{constructor(W){this._callback=W}computeId(){return"customExecution"+(0,L.generateUuid)()}set callback(W){this._callback=W}get callback(){return this._callback}}e.CustomExecution=gt;let pt=E=class{constructor(W,ce,Le,Qe,rt,lt){this.__deprecated=!1,this._definition=this.definition=W;let ut;typeof ce=="string"?(this._name=this.name=ce,this._source=this.source=Le,this.execution=Qe,ut=rt,this.__deprecated=!0):ce===Ze.Global||ce===Ze.Workspace?(this.target=ce,this._name=this.name=Le,this._source=this.source=Qe,this.execution=rt,ut=lt):(this.target=ce,this._name=this.name=Le,this._source=this.source=Qe,this.execution=rt,ut=lt),typeof ut=="string"?(this._problemMatchers=[ut],this._hasDefinedMatchers=!0):Array.isArray(ut)?(this._problemMatchers=ut,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(W){this.__id=W}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof xe?this._definition={type:E.ProcessType,id:this._execution.computeId()}:this._execution instanceof Je?this._definition={type:E.ShellType,id:this._execution.computeId()}:this._execution instanceof gt?this._definition={type:E.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:E.EmptyType,id:(0,L.generateUuid)()}}get definition(){return this._definition}set definition(W){if(W==null)throw(0,n.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=W}get scope(){return this._scope}set target(W){this.clear(),this._scope=W}get name(){return this._name}set name(W){if(typeof W!="string")throw(0,n.illegalArgument)("name");this.clear(),this._name=W}get execution(){return this._execution}set execution(W){W===null&&(W=void 0),this.clear(),this._execution=W;const ce=this._definition.type;(E.EmptyType===ce||E.ProcessType===ce||E.ShellType===ce||E.ExtensionCallbackType===ce)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(W){if(Array.isArray(W))this.clear(),this._problemMatchers=W,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.clear(),this._isBackground=W}get source(){return this._source}set source(W){if(typeof W!="string"||W.length===0)throw(0,n.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=W}get group(){return this._group}set group(W){W===null&&(W=void 0),this.clear(),this._group=W}get detail(){return this._detail}set detail(W){W===null&&(W=void 0),this._detail=W}get presentationOptions(){return this._presentationOptions}set presentationOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._presentationOptions=W}get runOptions(){return this._runOptions}set runOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._runOptions=W}};pt.ExtensionCallbackType="customExecution",pt.ProcessType="process",pt.ShellType="shell",pt.EmptyType="$empty",pt=E=Ge([k],pt),e.Task=pt;var yt;(function(x){x[x.SourceControl=1]="SourceControl",x[x.Window=10]="Window",x[x.Notification=15]="Notification"})(yt=e.ProgressLocation||(e.ProgressLocation={}));let vt=class{constructor(W,ce=ht.None){this.collapsibleState=ce,P.URI.isUri(W)?this.resourceUri=W:this.label=W}};vt=Ge([k],vt),e.TreeItem=vt;var ht;(function(x){x[x.None=0]="None",x[x.Collapsed=1]="Collapsed",x[x.Expanded=2]="Expanded"})(ht=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Kt=class{constructor(W){this.value=W}async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}};Kt=Ge([k],Kt),e.DataTransferItem=Kt;let Xt=class{constructor(W){b.set(this,new Map);for(const[ce,Le]of W??[]){const Qe=Me(this,b,"f").get(ce);Qe?Qe.push(Le):Me(this,b,"f").set(ce,[Le])}}get(W){return Me(this,b,"f").get(W)?.[0]}set(W,ce){Me(this,b,"f").set(W,[ce])}forEach(W,ce){for(const[Le,Qe]of Me(this,b,"f"))for(const rt of Qe)W.call(ce,rt,Le,this)}*[(b=new WeakMap,Symbol.iterator)](){for(const[W,ce]of Me(this,b,"f"))for(const Le of ce)yield[W,Le]}};Xt=Ge([k],Xt),e.DataTransfer=Xt;let Et=class{constructor(W){this.insertText=W}};Et=Ge([k],Et),e.DocumentDropEdit=Et;let rn=class{constructor(W){this.insertText=W}};rn=Ge([k],rn),e.DocumentPasteEdit=rn;let Ut=class{constructor(W,ce){this.id=W,this.color=ce}};Ut=Ge([k],Ut),e.ThemeIcon=Ut,Ut.File=new Ut("file"),Ut.Folder=new Ut("folder");let sn=class{constructor(W){this.id=W}};sn=Ge([k],sn),e.ThemeColor=sn;var kn;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace",x[x.WorkspaceFolder=3]="WorkspaceFolder"})(kn=e.ConfigurationTarget||(e.ConfigurationTarget={}));let kt=class{constructor(W,ce){if(typeof W!="string"&&(!W||!P.URI.isUri(W)&&!P.URI.isUri(W.uri)))throw(0,n.illegalArgument)("base");if(typeof ce!="string")throw(0,n.illegalArgument)("pattern");typeof W=="string"?this.baseUri=P.URI.file(W):P.URI.isUri(W)?this.baseUri=W:this.baseUri=W.uri,this.pattern=ce}get base(){return this._base}set base(W){this._base=W,this._baseUri=P.URI.file(W)}get baseUri(){return this._baseUri}set baseUri(W){this._baseUri=W,this._base=W.fsPath}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};kt=Ge([k],kt),e.RelativePattern=kt;let xt=class{constructor(W,ce,Le,Qe){this.enabled=typeof W=="boolean"?W:!0,typeof ce=="string"&&(this.condition=ce),typeof Le=="string"&&(this.hitCondition=Le),typeof Qe=="string"&&(this.logMessage=Qe)}get id(){return this._id||(this._id=(0,L.generateUuid)()),this._id}};xt=Ge([k],xt),e.Breakpoint=xt;let fn=class extends xt{constructor(W,ce,Le,Qe,rt){super(ce,Le,Qe,rt);if(W===null)throw(0,n.illegalArgument)("location");this.location=W}};fn=Ge([k],fn),e.SourceBreakpoint=fn;let Qt=class extends xt{constructor(W,ce,Le,Qe,rt){super(ce,Le,Qe,rt);this.functionName=W}};Qt=Ge([k],Qt),e.FunctionBreakpoint=Qt;let Yt=class extends xt{constructor(W,ce,Le,Qe,rt,lt,ut){super(Qe,rt,lt,ut);if(!ce)throw(0,n.illegalArgument)("dataId");this.label=W,this.dataId=ce,this.canPersist=Le}};Yt=Ge([k],Yt),e.DataBreakpoint=Yt;let dt=class{constructor(W,ce,Le){this.command=W,this.args=ce||[],this.options=Le}};dt=Ge([k],dt),e.DebugAdapterExecutable=dt;let mn=class{constructor(W,ce){this.port=W,this.host=ce}};mn=Ge([k],mn),e.DebugAdapterServer=mn;let Bt=class{constructor(W){this.path=W}};Bt=Ge([k],Bt),e.DebugAdapterNamedPipeServer=Bt;let Vt=class{constructor(W){this.implementation=W}};Vt=Ge([k],Vt),e.DebugAdapterInlineImplementation=Vt;let on=class{constructor(W,ce){this.range=W,this.expression=ce}};on=Ge([k],on),e.EvaluatableExpression=on;var Pn;(function(x){x[x.Invoke=0]="Invoke",x[x.Automatic=1]="Automatic"})(Pn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var _n;(function(x){x[x.Invoke=0]="Invoke",x[x.Automatic=1]="Automatic"})(_n=e.InlineCompletionTriggerKindNew||(e.InlineCompletionTriggerKindNew={}));let gn=class{constructor(W,ce){this.range=W,this.text=ce}};gn=Ge([k],gn),e.InlineValueText=gn;let an=class{constructor(W,ce,Le=!0){this.range=W,this.variableName=ce,this.caseSensitiveLookup=Le}};an=Ge([k],an),e.InlineValueVariableLookup=an;let Jt=class{constructor(W,ce){this.range=W,this.expression=ce}};Jt=Ge([k],Jt),e.InlineValueEvaluatableExpression=Jt;let pn=class{constructor(W,ce){this.frameId=W,this.stoppedLocation=ce}};pn=Ge([k],pn),e.InlineValueContext=pn;var vn;(function(x){x[x.Changed=1]="Changed",x[x.Created=2]="Created",x[x.Deleted=3]="Deleted"})(vn=e.FileChangeType||(e.FileChangeType={}));let Zt=R=class extends Error{constructor(W,ce=I.FileSystemProviderErrorCode.Unknown,Le){super(P.URI.isUri(W)?W.toString(!0):W);this.code=Le?.name??"Unknown",(0,I.markAsFileSystemProviderError)(this,ce),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,R.prototype),typeof Error.captureStackTrace=="function"&&typeof Le=="function"&&Error.captureStackTrace(this,Le)}static FileExists(W){return new R(W,I.FileSystemProviderErrorCode.FileExists,R.FileExists)}static FileNotFound(W){return new R(W,I.FileSystemProviderErrorCode.FileNotFound,R.FileNotFound)}static FileNotADirectory(W){return new R(W,I.FileSystemProviderErrorCode.FileNotADirectory,R.FileNotADirectory)}static FileIsADirectory(W){return new R(W,I.FileSystemProviderErrorCode.FileIsADirectory,R.FileIsADirectory)}static NoPermissions(W){return new R(W,I.FileSystemProviderErrorCode.NoPermissions,R.NoPermissions)}static Unavailable(W){return new R(W,I.FileSystemProviderErrorCode.Unavailable,R.Unavailable)}};Zt=R=Ge([k],Zt),e.FileSystemError=Zt;let bn=class{constructor(W,ce,Le){this.start=W,this.end=ce,this.kind=Le}};bn=Ge([k],bn),e.FoldingRange=bn;var Tn;(function(x){x[x.Comment=1]="Comment",x[x.Imports=2]="Imports",x[x.Region=3]="Region"})(Tn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var en;(function(x){x[x.Collapsed=0]="Collapsed",x[x.Expanded=1]="Expanded"})(en=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var An;(function(x){x[x.Editing=0]="Editing",x[x.Preview=1]="Preview"})(An=e.CommentMode||(e.CommentMode={}));var Rn;(function(x){x[x.Unresolved=0]="Unresolved",x[x.Resolved=1]="Resolved"})(Rn=e.CommentThreadState||(e.CommentThreadState={}));class Ln{constructor(W,ce=[]){this.tokenTypes=W,this.tokenModifiers=ce}}e.SemanticTokensLegend=Ln;function On(x){return typeof x=="undefined"||(0,S.isStringArray)(x)}class tn{constructor(W){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,W){this._hasLegend=!0;for(let ce=0,Le=W.tokenTypes.length;ce<Le;ce++)this._tokenTypeStrToInt.set(W.tokenTypes[ce],ce);for(let ce=0,Le=W.tokenModifiers.length;ce<Le;ce++)this._tokenModifierStrToInt.set(W.tokenModifiers[ce],ce)}}push(W,ce,Le,Qe,rt){if(typeof W=="number"&&typeof ce=="number"&&typeof Le=="number"&&typeof Qe=="number"&&(typeof rt=="number"||typeof rt=="undefined"))return typeof rt=="undefined"&&(rt=0),this._pushEncoded(W,ce,Le,Qe,rt);if($.isRange(W)&&typeof ce=="string"&&On(Le))return this._push(W,ce,Le);throw(0,n.illegalArgument)()}_push(W,ce,Le){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ce))throw new Error("`tokenType` is not in the provided legend");const Qe=W.start.line,rt=W.start.character,lt=W.end.character-W.start.character,ut=this._tokenTypeStrToInt.get(ce);let Ct=0;if(Le)for(const Lt of Le){if(!this._tokenModifierStrToInt.has(Lt))throw new Error("`tokenModifier` is not in the provided legend");const Wt=this._tokenModifierStrToInt.get(Lt);Ct|=1<<Wt>>>0}this._pushEncoded(Qe,rt,lt,ut,Ct)}_pushEncoded(W,ce,Le,Qe,rt){if(this._dataIsSortedAndDeltaEncoded&&(W<this._prevLine||W===this._prevLine&&ce<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Ct=this._data.length/5|0;let Lt=0,Wt=0;for(let $t=0;$t<Ct;$t++){let qt=this._data[5*$t],En=this._data[5*$t+1];qt===0?(qt=Lt,En+=Wt):qt+=Lt,this._data[5*$t]=qt,this._data[5*$t+1]=En,Lt=qt,Wt=En}}let lt=W,ut=ce;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(lt-=this._prevLine,lt===0&&(ut-=this._prevChar)),this._data[this._dataLen++]=lt,this._data[this._dataLen++]=ut,this._data[this._dataLen++]=Le,this._data[this._dataLen++]=Qe,this._data[this._dataLen++]=rt,this._prevLine=W,this._prevChar=ce}static _sortAndDeltaEncode(W){const ce=[],Le=W.length/5|0;for(let ut=0;ut<Le;ut++)ce[ut]=ut;ce.sort((ut,Ct)=>{const Lt=W[5*ut],Wt=W[5*Ct];if(Lt===Wt){const $t=W[5*ut+1],qt=W[5*Ct+1];return $t-qt}return Lt-Wt});const Qe=new Uint32Array(W.length);let rt=0,lt=0;for(let ut=0;ut<Le;ut++){const Ct=5*ce[ut],Lt=W[Ct+0],Wt=W[Ct+1],$t=W[Ct+2],qt=W[Ct+3],En=W[Ct+4],Xn=Lt-rt,gi=Xn===0?Wt-lt:Wt,Sn=5*ut;Qe[Sn+0]=Xn,Qe[Sn+1]=gi,Qe[Sn+2]=$t,Qe[Sn+3]=qt,Qe[Sn+4]=En,rt=Lt,lt=Wt}return Qe}build(W){return this._dataIsSortedAndDeltaEncoded?new cn(new Uint32Array(this._data),W):new cn(tn._sortAndDeltaEncode(this._data),W)}}e.SemanticTokensBuilder=tn;class cn{constructor(W,ce){this.resultId=ce,this.data=W}}e.SemanticTokens=cn;class yn{constructor(W,ce,Le){this.start=W,this.deleteCount=ce,this.data=Le}}e.SemanticTokensEdit=yn;class He{constructor(W,ce){this.resultId=ce,this.edits=W}}e.SemanticTokensEdits=He;var Ht;(function(x){x[x.Separate=0]="Separate",x[x.MergeWithParent=1]="MergeWithParent"})(Ht=e.DebugConsoleMode||(e.DebugConsoleMode={}));let nn=class{constructor(){}};nn.Back={iconPath:new Ut("arrow-left")},nn=Ge([k],nn),e.QuickInputButtons=nn;var bt;(function(x){x[x.Separator=-1]="Separator",x[x.Default=0]="Default"})(bt=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Nn;(function(x){x[x.Info=1]="Info",x[x.Warning=2]="Warning",x[x.Error=3]="Error"})(Nn=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var Fn;(function(x){x[x.UI=1]="UI",x[x.Workspace=2]="Workspace"})(Fn=e.ExtensionKind||(e.ExtensionKind={}));class Cn{constructor(W,ce,Le){this.badge=W,this.tooltip=ce,this.color=Le}static validate(W){if(W.badge){let ce=(0,C.nextCharLength)(W.badge,0);if(ce<W.badge.length&&(ce+=(0,C.nextCharLength)(W.badge,ce)),W.badge.length>ce)throw new Error("The 'badge'-property must be undefined or a short character")}if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=Cn;let wn=class{constructor(W){this.kind=W}};wn=Ge([k],wn),e.ColorTheme=wn;var ln;(function(x){x[x.Light=1]="Light",x[x.Dark=2]="Dark",x[x.HighContrast=3]="HighContrast",x[x.HighContrastLight=4]="HighContrastLight"})(ln=e.ColorThemeKind||(e.ColorThemeKind={}));class zt{constructor(W,ce){if(W<0)throw(0,n.illegalArgument)("start must be positive");if(ce<0)throw(0,n.illegalArgument)("end must be positive");W<=ce?(this._start=W,this._end=ce):(this._start=ce,this._end=W)}static isNotebookRange(W){return W instanceof zt?!0:W?typeof W.start=="number"&&typeof W.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(W){let ce=this._start,Le=this._end;return W.start!==void 0&&(ce=W.start),W.end!==void 0&&(Le=W.end),ce===this._start&&Le===this._end?this:new zt(ce,Le)}}e.NotebookRange=zt;class jt{constructor(W,ce,Le,Qe,rt,lt,ut){this.kind=W,this.value=ce,this.languageId=Le,this.mime=Qe,this.outputs=rt??[],this.metadata=lt,this.executionSummary=ut,jt.validate(this)}static validate(W){if(typeof W.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof W.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof W.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(W){return Array.isArray(W)&&W.every(ce=>jt.isNotebookCellData(ce))}static isNotebookCellData(W){return!0}}e.NotebookCellData=jt;class Mn{constructor(W){this.cells=W}}e.NotebookData=Mn;class Nt{constructor(W,ce){this.data=W,this.mime=ce;const Le=(0,D.normalizeMimeType)(ce,!0);if(!Le)throw new Error(`INVALID mime type: ${ce}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Le}static isNotebookCellOutputItem(W){return W instanceof Nt?!0:W?typeof W.mime=="string"&&W.data instanceof Uint8Array:!1}static error(W){const ce={name:W.name,message:W.message,stack:W.stack};return Nt.json(ce,"application/vnd.code.notebook.error")}static stdout(W){return Nt.text(W,"application/vnd.code.notebook.stdout")}static stderr(W){return Nt.text(W,"application/vnd.code.notebook.stderr")}static bytes(W,ce="application/octet-stream"){return new Nt(W,ce)}static text(W,ce=D.Mimes.text){const Le=Me(Nt,p,"f",g).encode(String(W));return new Nt(Le,ce)}static json(W,ce="text/x-json"){const Le=JSON.stringify(W,void 0,"	");return Nt.text(Le,ce)}}e.NotebookCellOutputItem=Nt,p=Nt,g={value:new TextEncoder};class un{constructor(W,ce,Le){this.items=un.ensureUniqueMimeTypes(W,!0),typeof ce=="string"?(this.id=ce,this.metadata=Le):(this.id=(0,L.generateUuid)(),this.metadata=ce??Le)}static isNotebookCellOutput(W){return W instanceof un?!0:!W||typeof W!="object"?!1:typeof W.id=="string"&&(0,S.isArray)(W.items)}static ensureUniqueMimeTypes(W,ce=!1){const Le=new Set,Qe=new Set;for(let rt=0;rt<W.length;rt++){const lt=W[rt],ut=(0,D.normalizeMimeType)(lt.mime);if(!Le.has(ut)){Le.add(ut);continue}Qe.add(rt),ce&&console.warn(`DUPLICATED mime type '${lt.mime}' will be dropped`)}return Qe.size===0?W:W.filter((rt,lt)=>!Qe.has(lt))}}e.NotebookCellOutput=un;var Un;(function(x){x[x.Markup=1]="Markup",x[x.Code=2]="Code"})(Un=e.NotebookCellKind||(e.NotebookCellKind={}));var Bn;(function(x){x[x.Idle=1]="Idle",x[x.Pending=2]="Pending",x[x.Executing=3]="Executing"})(Bn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var zn;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(zn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Wn;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(Wn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class me{constructor(W,ce){this.text=W,this.alignment=ce}}e.NotebookCellStatusBarItem=me;var we;(function(x){x[x.Default=1]="Default",x[x.Preferred=2]="Preferred"})(we=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Ue{constructor(W,ce=[]){this.uri=W,this.provides=(0,u.asArray)(ce)}}e.NotebookRendererScript=Ue;let ct=class{constructor(W,ce){this.label=W,this.timestamp=ce}};ct=Ge([k],ct),e.TimelineItem=ct;var St;(function(x){x[x.Production=1]="Production",x[x.Development=2]="Development",x[x.Test=3]="Test"})(St=e.ExtensionMode||(e.ExtensionMode={}));var Pt;(function(x){x[x.Node=1]="Node",x[x.Webworker=2]="Webworker"})(Pt=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Zn;(function(x){x[x.Other=0]="Other",x[x.Comment=1]="Comment",x[x.String=2]="String",x[x.RegEx=3]="RegEx"})(Zn=e.StandardTokenType||(e.StandardTokenType={}));class ei{constructor(W,ce){this.ranges=W,this.wordPattern=ce}}e.LinkedEditingRanges=ei;class ti{constructor(W,ce){this._port=W,this._autoForwardAction=ce}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=ti;var ni;(function(x){x[x.Queued=1]="Queued",x[x.Running=2]="Running",x[x.Passed=3]="Passed",x[x.Failed=4]="Failed",x[x.Skipped=5]="Skipped",x[x.Errored=6]="Errored"})(ni=e.TestResultState||(e.TestResultState={}));var ii;(function(x){x[x.Run=1]="Run",x[x.Debug=2]="Debug",x[x.Coverage=3]="Coverage"})(ii=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Hn=class{constructor(W=void 0,ce=void 0,Le=void 0){this.include=W,this.exclude=ce,this.profile=Le}};Hn=Ge([k],Hn),e.TestRunRequest=Hn;let $n=N=class{constructor(W){this.message=W}static diff(W,ce,Le){const Qe=new N(W);return Qe.expectedOutput=ce,Qe.actualOutput=Le,Qe}};$n=N=Ge([k],$n),e.TestMessage=$n;let xn=class{constructor(W){this.id=W}};xn=Ge([k],xn),e.TestTag=xn;let dn=class{constructor(W,ce){this.covered=W,this.total=ce}};dn=Ge([k],dn),e.CoveredCount=dn;let Vn=O=class{constructor(W,ce,Le,Qe){this.uri=W,this.statementCoverage=ce,this.branchCoverage=Le,this.functionCoverage=Qe}static fromDetails(W,ce){const Le=new dn(0,0),Qe=new dn(0,0),rt=new dn(0,0);for(const ut of ce)if("branches"in ut){Le.total+=1,Le.covered+=ut.executionCount>0?1:0;for(const Ct of ut.branches)Qe.total+=1,Qe.covered+=Ct.executionCount>0?1:0}else rt.total+=1,rt.covered+=ut.executionCount>0?1:0;const lt=new O(W,Le,Qe.total>0?Qe:void 0,rt.total>0?rt:void 0);return lt.detailedCoverage=ce,lt}};Vn=O=Ge([k],Vn),e.FileCoverage=Vn;let jn=class{constructor(W,ce,Le=[]){this.executionCount=W,this.location=ce,this.branches=Le}};jn=Ge([k],jn),e.StatementCoverage=jn;let qn=class{constructor(W,ce){this.executionCount=W,this.location=ce}};qn=Ge([k],qn),e.BranchCoverage=qn;let Gn=class{constructor(W,ce){this.executionCount=W,this.location=ce}};Gn=Ge([k],Gn),e.FunctionCoverage=Gn;var ri;(function(x){x[x.None=0]="None",x[x.Option=1]="Option",x[x.Default=2]="Default",x[x.Preferred=3]="Preferred"})(ri=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var si;(function(x){x[x.Untrusted=0]="Untrusted",x[x.Trusted=1]="Trusted",x[x.Unspecified=2]="Unspecified"})(si=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var oi;(function(x){x[x.Notify=1]="Notify",x[x.OpenBrowser=2]="OpenBrowser",x[x.OpenPreview=3]="OpenPreview",x[x.Silent=4]="Silent",x[x.Ignore=5]="Ignore",x[x.OpenBrowserOnce=6]="OpenBrowserOnce"})(oi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class ai{constructor(W,ce,Le,Qe,rt,lt){this.kind=W,this.name=ce,this.detail=Le,this.uri=Qe,this.range=rt,this.selectionRange=lt}}e.TypeHierarchyItem=ai;class ci{constructor(W){this.uri=W}}e.TextTabInput=ci;class li{constructor(W,ce){this.original=W,this.modified=ce}}e.TextDiffTabInput=li;class ui{constructor(W,ce){this.uri=W,this.viewType=ce}}e.CustomEditorTabInput=ui;class di{constructor(W){this.viewType=W}}e.WebviewEditorTabInput=di;class hi{constructor(W,ce){this.uri=W,this.notebookType=ce}}e.NotebookEditorTabInput=hi;class fi{constructor(W,ce,Le){this.original=W,this.modified=ce,this.notebookType=Le}}e.NotebookDiffEditorTabInput=fi;class mi{constructor(){}}e.TerminalEditorTabInput=mi}),define(Ie[125],ke([1,0,56,11,8,159,99,7,16]),function(Q,e,u,n,y,A,D,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const P=new Map;function L(w,b){b?P.set(w,b):P.delete(w)}e.setWordDefinitionFor=L;function I(w){return P.get(w)}e.getWordDefinitionFor=I;class _ extends A.MirrorTextModel{constructor(b,p,g,v,f,a,m,o){super(p,g,v,f);this._proxy=b,this._languageId=a,this._isDirty=m,this.notebook=o,this._isDisposed=!1}dispose(){(0,u.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(b){return(0,S.equals)(this._lines,b)}get document(){if(!this._document){const b=this;this._document={get uri(){return b._uri},get fileName(){return b._uri.fsPath},get isUntitled(){return b._uri.scheme===n.Schemas.untitled},get languageId(){return b._languageId},get version(){return b._versionId},get isClosed(){return b._isDisposed},get isDirty(){return b._isDirty},save(){return b._save()},getText(p){return p?b._getTextInRange(p):b.getText()},get eol(){return b._eol===`
`?C.EndOfLine.LF:C.EndOfLine.CRLF},get lineCount(){return b._lines.length},lineAt(p){return b._lineAt(p)},offsetAt(p){return b._offsetAt(p)},positionAt(p){return b._positionAt(p)},validateRange(p){return b._validateRange(p)},validatePosition(p){return b._validatePosition(p)},getWordRangeAtPosition(p,g){return b._getWordRangeAtPosition(p,g)}}}return Object.freeze(this._document)}_acceptLanguageId(b){(0,u.ok)(!this._isDisposed),this._languageId=b}_acceptIsDirty(b){(0,u.ok)(!this._isDisposed),this._isDirty=b}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(b){const p=this._validateRange(b);if(p.isEmpty)return"";if(p.isSingleLine)return this._lines[p.start.line].substring(p.start.character,p.end.character);const g=this._eol,v=p.start.line,f=p.end.line,a=[];a.push(this._lines[v].substring(p.start.character));for(let m=v+1;m<f;m++)a.push(this._lines[m]);return a.push(this._lines[f].substring(0,p.end.character)),a.join(g)}_lineAt(b){let p;if(b instanceof C.Position?p=b.line:typeof b=="number"&&(p=b),typeof p!="number"||p<0||p>=this._lines.length||Math.floor(p)!==p)throw new Error("Illegal value for `line`");return new T(p,this._lines[p],p===this._lines.length-1)}_offsetAt(b){return b=this._validatePosition(b),this._ensureLineStarts(),this._lineStarts.getPrefixSum(b.line-1)+b.character}_positionAt(b){b=Math.floor(b),b=Math.max(0,b),this._ensureLineStarts();const p=this._lineStarts.getIndexOf(b),g=this._lines[p.index].length;return new C.Position(p.index,Math.min(p.remainder,g))}_validateRange(b){if(!(b instanceof C.Range))throw new Error("Invalid argument");const p=this._validatePosition(b.start),g=this._validatePosition(b.end);return p===b.start&&g===b.end?b:new C.Range(p.line,p.character,g.line,g.character)}_validatePosition(b){if(!(b instanceof C.Position))throw new Error("Invalid argument");if(this._lines.length===0)return b.with(0,0);let{line:p,character:g}=b,v=!1;if(p<0)p=0,g=0,v=!0;else if(p>=this._lines.length)p=this._lines.length-1,g=this._lines[p].length,v=!0;else{const f=this._lines[p].length;g<0?(g=0,v=!0):g>f&&(g=f,v=!0)}return v?new C.Position(p,g):b}_getWordRangeAtPosition(b,p){const g=this._validatePosition(b);if(!p)p=I(this._languageId);else if((0,y.regExpLeadsToEndlessLoop)(p))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${p.source}' because it matches the empty string.`);const v=(0,D.getWordAtText)(g.character+1,(0,D.ensureValidWordDefinition)(p),this._lines[g.line],0);if(v)return new C.Range(g.line,v.startColumn-1,g.line,v.endColumn-1)}}e.ExtHostDocumentData=_;class T{constructor(b,p,g){this._line=b,this._text=p,this._isLastLine=g}get lineNumber(){return this._line}get text(){return this._text}get range(){return new C.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new C.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=T}),define(Ie[209],ke([1,0,7,17,3]),function(Q,e,u,n,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let A=class{constructor(C){this._actual=new u.ColorTheme(u.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new y.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(C){let S;switch(C){case"light":S=u.ColorThemeKind.Light;break;case"hcDark":S=u.ColorThemeKind.HighContrast;break;case"hcLight":S=u.ColorThemeKind.HighContrastLight;break;default:S=u.ColorThemeKind.Dark}this._actual=new u.ColorTheme(S),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};A=Ge([$e(0,n.IExtHostRpcService)],A),e.ExtHostTheming=A}),define(Ie[65],ke([1,0,4]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,u.createDecorator)("IURITransformerService");class n{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=D=>D,this.transformOutgoing=D=>D,this.transformOutgoingURI=D=>D,this.transformOutgoingScheme=D=>D)}}e.URITransformerService=n}),define(Ie[210],ke([1,0,23]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class n{constructor(){this.buffers=[]}add(S){let P=this.buffers.indexOf(S);return P<0&&(P=this.buffers.length,this.buffers.push(S)),P}}function y(C,S){if(S.serializeBuffersForPostMessage){const P=new n,L=(T,w)=>{if(w instanceof ArrayBuffer){const b=P.add(w);return{$$vscode_array_buffer_reference$$:!0,index:b}}else if(ArrayBuffer.isView(w)){const b=A(w);if(b){const p=P.add(w.buffer);return{$$vscode_array_buffer_reference$$:!0,index:p,view:{type:b,byteLength:w.byteLength,byteOffset:w.byteOffset}}}}return w},I=JSON.stringify(C,L),_=P.buffers.map(T=>{const w=new Uint8Array(T);return u.VSBuffer.wrap(w)});return{message:I,buffers:_}}else return{message:JSON.stringify(C),buffers:[]}}e.serializeWebviewMessage=y;function A(C){switch(C.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function D(C,S){const P=S.map(_=>{const T=new ArrayBuffer(_.byteLength);return new Uint8Array(T).set(_.buffer),T}),L=S.length?(_,T)=>{if(T&&typeof T=="object"&&T.$$vscode_array_buffer_reference$$){const w=T,{index:b}=w,p=P[b];if(w.view)switch(w.view.type){case 1:return new Int8Array(p,w.view.byteOffset,w.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(p,w.view.byteOffset,w.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(p,w.view.byteOffset,w.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(p,w.view.byteOffset,w.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(p,w.view.byteOffset,w.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(p,w.view.byteOffset,w.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(p,w.view.byteOffset,w.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(p,w.view.byteOffset,w.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(p,w.view.byteOffset,w.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(p,w.view.byteOffset,w.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(p,w.view.byteOffset,w.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return p}return T}:void 0;return{message:JSON.parse(C,L),arrayBuffers:P}}e.deserializeWebviewMessage=D}),define(Ie[211],ke([1,0,108]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function n(A){return{transformIncoming:D=>D.scheme==="vscode-remote"?{scheme:"file",path:D.path,query:D.query,fragment:D.fragment}:D.scheme==="file"?{scheme:"vscode-local",path:D.path,query:D.query,fragment:D.fragment}:D,transformOutgoing:D=>D.scheme==="file"?{scheme:"vscode-remote",authority:A,path:D.path,query:D.query,fragment:D.fragment}:D.scheme==="vscode-local"?{scheme:"file",path:D.path,query:D.query,fragment:D.fragment}:D,transformOutgoingScheme:D=>D==="file"?"vscode-remote":D==="vscode-local"?"file":D}}function y(A){return new u.URITransformer(n(A))}e.createURITransformer=y}),define(Ie[212],ke([1,0,180,10,2,6,4,44,43,16,11]),function(Q,e,u,n,y,A,D,C,S,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,u.localize)(0,null),providerDisplayName:(0,u.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var I;(function(B){B[B.PROGRAMMATIC=1]="PROGRAMMATIC",B[B.USER=2]="USER",B[B.EDIT=3]="EDIT",B[B.NAVIGATION=4]="NAVIGATION",B[B.JUMP=5]="JUMP"})(I=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var _;(function(B){B[B.IDENTICAL=1]="IDENTICAL",B[B.SIMILAR=2]="SIMILAR",B[B.DIFFERENT=3]="DIFFERENT"})(_=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function T(B){const z=B;return!!z&&typeof z.getSelection=="function"&&!!z.onDidChangeSelection}e.isEditorPaneWithSelection=T;function w(B,z,q){for(const V of q.visibleEditorPanes)if(V.group.id===z&&B.matches(V.input))return V.getViewState()}e.findViewStateForEditor=w;function b(B){if(r(B))return!1;const z=B;return y.URI.isUri(z?.resource)}e.isResourceEditorInput=b;function p(B){if(r(B))return!1;const z=B;return z?.original!==void 0&&z.modified!==void 0}e.isResourceDiffEditorInput=p;function g(B){if(r(B)||p(B))return!1;const z=B;return z?.primary!==void 0&&z.secondary!==void 0}e.isResourceSideBySideEditorInput=g;function v(B){if(r(B))return!1;const z=B;return z?z.resource===void 0||z.resource.scheme===L.Schemas.untitled||z.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=v;var f;(function(B){B[B.SHORT=0]="SHORT",B[B.MEDIUM=1]="MEDIUM",B[B.LONG=2]="LONG"})(f=e.Verbosity||(e.Verbosity={}));var a;(function(B){B[B.EXPLICIT=1]="EXPLICIT",B[B.AUTO=2]="AUTO",B[B.FOCUS_CHANGE=3]="FOCUS_CHANGE",B[B.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(a=e.SaveReason||(e.SaveReason={}));class m{constructor(){this.mapIdToSaveSource=new Map}registerSource(z,q){let V=this.mapIdToSaveSource.get(z);return V||(V={source:z,label:q},this.mapIdToSaveSource.set(z,V)),V.source}getSourceLabel(z){return this.mapIdToSaveSource.get(z)?.label??z}}e.SaveSourceRegistry=new m;var o;(function(B){B[B.None=0]="None",B[B.Readonly=2]="Readonly",B[B.Untitled=4]="Untitled",B[B.Singleton=8]="Singleton",B[B.RequiresTrust=16]="RequiresTrust",B[B.CanSplitInGroup=32]="CanSplitInGroup",B[B.ForceDescription=64]="ForceDescription",B[B.CanDropIntoEditor=128]="CanDropIntoEditor"})(o=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class d extends A.Disposable{}e.AbstractEditorInput=d;function r(B){return B instanceof d}e.isEditorInput=r;function s(B){const z=B;return y.URI.isUri(z?.preferredResource)}function i(B){const z=B;return r(z?.primary)&&r(z?.secondary)}e.isSideBySideEditorInput=i;function t(B){const z=B;return r(z?.modified)&&r(z?.original)}e.isDiffEditorInput=t;function c(B){return r(B?.editor)}e.isEditorInputWithOptions=c;function l(B){const z=B;return c(B)&&z?.group!==void 0}e.isEditorInputWithOptionsAndGroup=l;function h(B){const z=B;return typeof z?.groupId=="number"&&r(z.editor)}e.isEditorIdentifier=h;var E;(function(B){B[B.UNKNOWN=0]="UNKNOWN",B[B.REPLACE=1]="REPLACE",B[B.MOVE=2]="MOVE",B[B.UNPIN=3]="UNPIN"})(E=e.EditorCloseContext||(e.EditorCloseContext={}));var R;(function(B){B[B.GROUP_ACTIVE=0]="GROUP_ACTIVE",B[B.GROUP_INDEX=1]="GROUP_INDEX",B[B.GROUP_LOCKED=2]="GROUP_LOCKED",B[B.EDITOR_OPEN=3]="EDITOR_OPEN",B[B.EDITOR_CLOSE=4]="EDITOR_CLOSE",B[B.EDITOR_MOVE=5]="EDITOR_MOVE",B[B.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",B[B.EDITOR_LABEL=7]="EDITOR_LABEL",B[B.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",B[B.EDITOR_PIN=9]="EDITOR_PIN",B[B.EDITOR_STICKY=10]="EDITOR_STICKY",B[B.EDITOR_DIRTY=11]="EDITOR_DIRTY",B[B.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(R=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var N;(function(B){B[B.PRIMARY=1]="PRIMARY",B[B.SECONDARY=2]="SECONDARY",B[B.BOTH=3]="BOTH",B[B.ANY=4]="ANY"})(N=e.SideBySideEditor||(e.SideBySideEditor={}));class O{getOriginalUri(z,q){if(!z)return;if(q?.supportSideBySide){const{primary:j,secondary:ne}=this.getSideEditors(z);if(j&&ne){if(q?.supportSideBySide===N.BOTH)return{primary:this.getOriginalUri(j,{filterByScheme:q.filterByScheme}),secondary:this.getOriginalUri(ne,{filterByScheme:q.filterByScheme})};if(q?.supportSideBySide===N.ANY)return this.getOriginalUri(j,{filterByScheme:q.filterByScheme})??this.getOriginalUri(ne,{filterByScheme:q.filterByScheme});z=q.supportSideBySide===N.PRIMARY?j:ne}}if(p(z)||g(z))return;const V=s(z)?z.preferredResource:z.resource;return!V||!q||!q.filterByScheme?V:this.filterUri(V,q.filterByScheme)}getSideEditors(z){return i(z)||g(z)?{primary:z.primary,secondary:z.secondary}:t(z)||p(z)?{primary:z.modified,secondary:z.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(z,q){if(!z)return;if(q?.supportSideBySide){const{primary:j,secondary:ne}=this.getSideEditors(z);if(j&&ne){if(q?.supportSideBySide===N.BOTH)return{primary:this.getCanonicalUri(j,{filterByScheme:q.filterByScheme}),secondary:this.getCanonicalUri(ne,{filterByScheme:q.filterByScheme})};if(q?.supportSideBySide===N.ANY)return this.getCanonicalUri(j,{filterByScheme:q.filterByScheme})??this.getCanonicalUri(ne,{filterByScheme:q.filterByScheme});z=q.supportSideBySide===N.PRIMARY?j:ne}}if(p(z)||g(z))return;const V=z.resource;return!V||!q||!q.filterByScheme?V:this.filterUri(V,q.filterByScheme)}filterUri(z,q){if(Array.isArray(q)){if(q.some(V=>z.scheme===V))return z}else if(q===z.scheme)return z}}e.EditorResourceAccessor=new O;var k;(function(B){B[B.LEFT=0]="LEFT",B[B.RIGHT=1]="RIGHT"})(k=e.CloseDirection||(e.CloseDirection={}));class U{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(z){const q=this.instantiationService=z.get(D.IInstantiationService);for(const[V,j]of this.editorSerializerConstructors)this.createEditorSerializer(V,j,q);this.editorSerializerConstructors.clear()}createEditorSerializer(z,q,V){const j=V.createInstance(q);this.editorSerializerInstances.set(z,j)}registerFileEditorFactory(z){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=z}getFileEditorFactory(){return(0,n.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(z,q){if(this.editorSerializerConstructors.has(z)||this.editorSerializerInstances.has(z))throw new Error(`A editor serializer with type ID '${z}' was already registered.`);return this.instantiationService?this.createEditorSerializer(z,q,this.instantiationService):this.editorSerializerConstructors.set(z,q),(0,A.toDisposable)(()=>{this.editorSerializerConstructors.delete(z),this.editorSerializerInstances.delete(z)})}getEditorSerializer(z){return this.editorSerializerInstances.get(typeof z=="string"?z:z.typeId)}}C.Registry.add(e.EditorExtensions.EditorFactory,new U);async function F(B,z){if(!B||!B.length)return[];const q=await Promise.all(B.map(async V=>{const j=y.URI.revive(V.fileUri);if(!j||!await z.canHandleResource(j))return;let Y=V.exists,le=V.type;if(typeof Y!="boolean"||typeof le!="number")try{le=(await z.stat(j)).isDirectory?S.FileType.Directory:S.FileType.Unknown,Y=!0}catch{Y=!1}if(!Y&&V.openOnlyIfExists||le===S.FileType.Directory)return;const ue={...V.options,pinned:!0};let K;return Y?K={resource:j,options:ue}:K={resource:j,options:ue,forceUntitled:!0},K}));return(0,P.coalesce)(q)}e.pathsToEditors=F;var $;(function(B){B[B.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",B[B.SEQUENTIAL=1]="SEQUENTIAL"})($=e.EditorsOrder||(e.EditorsOrder={}));function ee(B){const z=B;if(!z)return!1;const q=z;if(q.modified)return ee(q.modified);const V=z;return!!(V.contributionsState&&V.viewState&&Array.isArray(V.cursorState))}e.isTextEditorViewState=ee}),define(Ie[88],ke([1,0,11,2]),function(Q,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function y(C,S){return C.scheme===u.Schemas.http||C.scheme===u.Schemas.https?C:(S&&S.authority&&S.isRemote&&C.scheme===u.Schemas.file&&(C=n.URI.from({scheme:u.Schemas.vscodeRemote,authority:S.authority,path:C.path})),n.URI.from({scheme:u.Schemas.https,authority:`${C.scheme}+${A(C.authority)}.${e.webviewRootResourceAuthority}`,path:C.path,fragment:C.fragment,query:C.query}))}e.asWebviewUri=y;function A(C){return C.replace(/./g,S=>{const P=S.charCodeAt(0);return P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57?S:"-"+P.toString(16).padStart(4,"0")})}function D(C){return C.replace(/-([0-9a-f]{4})/g,(S,P)=>String.fromCharCode(parseInt(P,16)))}e.decodeAuthority=D}),define(Ie[213],ke([1,0,3,6,88]),function(Q,e,u,n,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class A{constructor(C,S,P){this._proxy=C,this._editors=S,this._remoteInfo=P,this._handlePool=0,this._disposables=new n.DisposableStore,this._insets=new Map,this._disposables.add(S.onDidChangeVisibleTextEditors(()=>{const L=S.getVisibleTextEditors();for(const I of this._insets.values())L.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this._insets.forEach(C=>C.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(C,S,P,L,I){let _;for(const f of this._editors.getVisibleTextEditors(!0))if(f.value===C){_=f;break}if(!_)throw new Error("not a visible editor");const T=this,w=this._handlePool++,b=new u.Emitter,p=new u.Emitter,g=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(f){return(0,y.asWebviewUri)(f,T._remoteInfo)}get cspSource(){return y.webviewGenericCspSource}set options(f){this._options=f,T._proxy.$setOptions(w,f)}get options(){return this._options}set html(f){this._html=f,T._proxy.$setHtml(w,f)}get html(){return this._html}get onDidReceiveMessage(){return b.event}postMessage(f){return T._proxy.$postMessage(w,f)}},v=new class{constructor(){this.editor=C,this.line=S,this.height=P,this.webview=g,this.onDidDispose=p.event}dispose(){T._insets.has(w)&&(T._insets.delete(w),T._proxy.$disposeEditorInset(w),p.fire(),p.dispose(),b.dispose())}};return this._proxy.$createEditorInset(w,_.id,_.value.document.uri,S+1,P,L||{},I.identifier,I.extensionLocation),this._insets.set(w,{editor:C,inset:v,onDidReceiveMessage:b}),v}$onDidDispose(C){const S=this._insets.get(C);S&&S.inset.dispose()}$onDidReceiveMessage(C,S){this._insets.get(C)?.onDidReceiveMessage.fire(S)}}e.ExtHostEditorInsets=A}),define(Ie[126],ke([1,0,3,18,181]),function(Q,e,u,n,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class A{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new u.Emitter,this._onExit=new u.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(C){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=C}onEvent(C){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=C}onRequest(C){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=C}sendResponse(C){C.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${C.command}`)):this.internalSend("response",C)}sendRequest(C,S,P,L){const I={command:C};if(S&&Object.keys(S).length>0&&(I.arguments=S),this.internalSend("request",I),typeof L=="number"){const _=setTimeout(()=>{clearTimeout(_);const T=this.pendingRequests.get(I.seq);if(T){this.pendingRequests.delete(I.seq);const w={type:"response",seq:0,request_seq:I.seq,success:!1,command:C,message:(0,y.localize)(0,null,L,C)};T(w)}},L)}return P&&this.pendingRequests.set(I.seq,P),I.seq}acceptMessage(C){this.messageCallback?this.messageCallback(C):(this.queue.push(C),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(C,S){return C.type!=="event"||S.type!=="event"}async processQueue(){let C;for(;this.queue.length;){if((!C||this.needsTaskBoundaryBetween(this.queue[0],C))&&await(0,n.timeout)(0),C=this.queue.shift(),!C)return;switch(C.type){case"event":this.eventCallback?.(C);break;case"request":this.requestCallback?.(C);break;case"response":{const S=C,P=this.pendingRequests.get(S.request_seq);P&&(this.pendingRequests.delete(S.request_seq),P(S));break}}}}internalSend(C,S){S.type=C,S.seq=this.sequence++,this.sendMessage(S)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const C=new Map;this.pendingRequests.forEach((S,P)=>C.set(P,S)),await(0,n.timeout)(500),C.forEach((S,P)=>{S({type:"response",seq:0,request_seq:P,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(P)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=A}),define(Ie[214],ke([1,0,182,51,4]),function(Q,e,u,n,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerUiMessage=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ACCESS_TYPE=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.DEBUG_SERVICE_ID=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.DEBUG_SERVICE_ID="debugService",e.CONTEXT_DEBUG_TYPE=new n.RawContextKey("debugType",void 0,{type:"string",description:u.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new n.RawContextKey("debugConfigurationType",void 0,{type:"string",description:u.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new n.RawContextKey("debugState","inactive",{type:"string",description:u.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new n.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:u.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new n.RawContextKey("inDebugMode",!1,{type:"boolean",description:u.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new n.RawContextKey("inDebugRepl",!1,{type:"boolean",description:u.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new n.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:u.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new n.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:u.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new n.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:u.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new n.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:u.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new n.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:u.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new n.RawContextKey("variablesFocused",!0,{type:"boolean",description:u.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new n.RawContextKey("expressionSelected",!1,{type:"boolean",description:u.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new n.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:u.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new n.RawContextKey("callStackItemType",void 0,{type:"string",description:u.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new n.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:u.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new n.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:u.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new n.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:u.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new n.RawContextKey("watchItemType",void 0,{type:"string",description:u.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new n.RawContextKey("canViewMemory",void 0,{type:"boolean",description:u.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new n.RawContextKey("breakpointItemType",void 0,{type:"string",description:u.localize(20,null)}),e.CONTEXT_BREAKPOINT_ACCESS_TYPE=new n.RawContextKey("breakpointAccessType",void 0,{type:"string",description:u.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new n.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:u.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new n.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:u.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new n.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:u.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new n.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:u.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new n.RawContextKey("stepBackSupported",!1,{type:"boolean",description:u.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new n.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:u.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new n.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:u.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new n.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:u.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new n.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:u.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new n.RawContextKey("breakpointsExist",!1,{type:"boolean",description:u.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new n.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:u.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new n.RawContextKey("debugExtensionAvailable",!1,{type:"boolean",description:u.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new n.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:u.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new n.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:u.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new n.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:u.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new n.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:u.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new n.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:u.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new n.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:u.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new n.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:u.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new n.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:u.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new n.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:u.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new n.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:u.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new n.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:u.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new n.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:u.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new n.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:u.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new n.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:u.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new n.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:u.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new n.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:u.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new n.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:u.localize(50,null)});const A=_=>u.localize(51,null,_);e.debuggerDisabledMessage=A,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:u.localize(52,null)};var D;(function(_){_[_.Inactive=0]="Inactive",_[_.Initializing=1]="Initializing",_[_.Stopped=2]="Stopped",_[_.Running=3]="Running"})(D=e.State||(e.State={}));function C(_){switch(_){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=C;var S;(function(_){_[_.Valid=0]="Valid",_[_.Unreadable=1]="Unreadable",_[_.Error=2]="Error"})(S=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var P;(function(_){_[_.Initial=1]="Initial",_[_.Dynamic=2]="Dynamic"})(P=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var L;(function(_){_.UnverifiedBreakpoints="unverifiedBreakpoints"})(L=e.DebuggerUiMessage||(e.DebuggerUiMessage={})),e.IDebugService=(0,y.createDecorator)(e.DEBUG_SERVICE_ID);var I;(function(_){_[_.CONDITION=0]="CONDITION",_[_.HIT_COUNT=1]="HIT_COUNT",_[_.LOG_MESSAGE=2]="LOG_MESSAGE"})(I=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(Ie[215],ke([1,0,8,2,9,24,11]),function(Q,e,u,n,y,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const C=/{([^}]+)}/g;function S(r,s,i){return r.replace(C,function(t,c){return s&&c.length>0&&c[0]!=="_"?t:i&&i.hasOwnProperty(c)?i[c]:t})}e.formatPII=S;function P(r){const s={};for(const i of Object.keys(r))i.startsWith("!")||(s[i]=r[i]);return s}e.filterExceptionsFromTelemetry=P;function L(r){return r.configuration.request==="attach"&&!I(r)&&(!r.parentSession||L(r.parentSession))}e.isSessionAttach=L;function I(r){let s=r.configuration.type;if(!!s)return s==="vslsShare"&&(s=r.configuration.adapterProxy.configuration.type),(0,u.equalsIgnoreCase)(s,"extensionhost")||(0,u.equalsIgnoreCase)(s,"pwa-extensionhost")?r:r.parentSession?I(r.parentSession):void 0}e.getExtensionHostDebugSession=I;function _(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=_;function T(r,s,i){let t,c=0;const l=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let h=null;for(;h=l.exec(r);){const E=h.index+1,R=E+h[0].length;if(E<=s&&R>=i){t=h[0],c=E;break}}if(t){const E=/\w+/g;let R=null;for(;(R=E.exec(t))&&!(R.index+1+c+R[0].length>=i););R&&(t=t.substring(0,E.lastIndex))}return t?{start:c,end:c+t.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=T;const w=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function b(r){return!!(r&&r.match(w))}e.isUri=b;function p(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(b(r.path))return n.URI.parse(r.path);if((0,y.isAbsolute)(r.path))return n.URI.file(r.path)}return r.path}function g(r){if(typeof r.path=="object"){const s=n.URI.revive(r.path);if(s)return s.scheme===D.Schemas.file?s.fsPath:s.toString()}return r.path}function v(r,s){const i=s?p:g,t=(0,A.deepClone)(r);return a(t,(c,l)=>{c&&l&&(l.path=i(l))}),t}e.convertToDAPaths=v;function f(r,s){const i=s?p:g,t=(0,A.deepClone)(r);return a(t,(c,l)=>{!c&&l&&(l.path=i(l))}),t}e.convertToVSCPaths=f;function a(r,s){switch(r.type){case"event":{const i=r;switch(i.event){case"output":s(!1,i.body.source);break;case"loadedSource":s(!1,i.body.source);break;case"breakpoint":s(!1,i.body.breakpoint.source);break;default:break}break}case"request":{const i=r;switch(i.command){case"setBreakpoints":s(!0,i.arguments.source);break;case"breakpointLocations":s(!0,i.arguments.source);break;case"source":s(!0,i.arguments.source);break;case"gotoTargets":s(!0,i.arguments.source);break;case"launchVSCode":i.arguments.args.forEach(t=>s(!1,t));break;default:break}break}case"response":{const i=r;if(i.success&&i.body)switch(i.command){case"stackTrace":i.body.stackFrames.forEach(t=>s(!1,t.source));break;case"loadedSources":i.body.sources.forEach(t=>s(!1,t));break;case"scopes":i.body.scopes.forEach(t=>s(!1,t.source));break;case"setFunctionBreakpoints":i.body.breakpoints.forEach(t=>s(!1,t.source));break;case"setBreakpoints":i.body.breakpoints.forEach(t=>s(!1,t.source));break;case"disassemble":i.body?.instructions.forEach(c=>s(!1,c.location));break;default:break}break}}}function m(r){return r.filter(s=>!s.presentation?.hidden).sort((s,i)=>s.presentation?i.presentation?s.presentation.group?i.presentation.group?s.presentation.group!==i.presentation.group?s.presentation.group.localeCompare(i.presentation.group):o(s.presentation.order,i.presentation.order):-1:i.presentation.group?1:o(s.presentation.order,i.presentation.order):-1:i.presentation?1:0)}e.getVisibleAndSorted=m;function o(r,s){return typeof r!="number"?typeof s!="number"?0:1:typeof s!="number"?-1:r-s}async function d(r,s){const i=r.getValue("debug.saveBeforeStart",{overrideIdentifier:s.activeTextEditorLanguageId});if(i!=="none"&&(await s.saveAll(),i==="allEditorsInActiveGroup")){const t=s.activeEditorPane;t&&t.input.resource?.scheme===D.Schemas.untitled&&await s.save({editor:t.input,groupId:t.group.id})}await r.reloadConfiguration()}e.saveAllBeforeDebugStart=d}),define(Ie[216],ke([1,0,29,42,183,127,9,8,24,13,84,126]),function(Q,e,u,n,y,A,D,C,S,P,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class _ extends I.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(v,f){this.outputStream=f,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,v.on("data",a=>this.handleData(a))}sendMessage(v){if(this.outputStream){const f=JSON.stringify(v);this.outputStream.write(`Content-Length: ${Buffer.byteLength(f,"utf8")}${_.TWO_CRLF}${f}`,"utf8")}}handleData(v){for(this.rawData=Buffer.concat([this.rawData,v]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const f=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,f.length>0)try{this.acceptMessage(JSON.parse(f))}catch(a){this._onError.fire(new Error((a.message||a)+`
`+f))}continue}}else{const f=this.rawData.indexOf(_.TWO_CRLF);if(f!==-1){const m=this.rawData.toString("utf8",0,f).split(_.HEADER_LINESEPARATOR);for(const o of m){const d=o.split(_.HEADER_FIELDSEPARATOR);d[0]==="Content-Length"&&(this.contentLength=Number(d[1]))}this.rawData=this.rawData.slice(f+_.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=_,_.TWO_CRLF=`\r
\r
`,_.HEADER_LINESEPARATOR=/\r?\n/,_.HEADER_FIELDSEPARATOR=/: */;class T extends _{startSession(){return new Promise((v,f)=>{let a=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),v(),a=!0}),this.socket.on("close",()=>{a?this._onError.fire(new Error("connection closed")):f(new Error("connection closed"))}),this.socket.on("error",m=>{a?this._onError.fire(m):f(m)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=T;class w extends T{constructor(v){super();this.adapterServer=v}createConnection(v){return A.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",v)}}e.SocketDebugAdapter=w;class b extends T{constructor(v){super();this.adapterServer=v}createConnection(v){return A.createConnection(this.adapterServer.path,v)}}e.NamedPipeDebugAdapter=b;class p extends _{constructor(v,f,a){super();this.adapterExecutable=v,this.debugType=f,this.outputService=a}async startSession(){const v=this.adapterExecutable.command,f=this.adapterExecutable.args,a=this.adapterExecutable.options||{};try{if(v)if(D.isAbsolute(v)){if(!await u.Promises.exists(v))throw new Error(y.localize(0,null,v))}else v.indexOf("/")<0&&v.indexOf("\\")<0;else throw new Error(y.localize(1,null,this.debugType));let m=process.env;if(a.env&&Object.keys(a.env).length>0&&(m=S.mixin(S.deepClone(process.env),a.env)),v==="node")if(Array.isArray(f)&&f.length>0){const d=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,r={env:m,execArgv:d?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};a.cwd&&(r.cwd=a.cwd);const s=n.fork(f[0],f.slice(1),r);if(!s.pid)throw new Error(y.localize(2,null,f[0]));this.serverProcess=s}else throw new Error(y.localize(3,null));else{const d={env:m};a.cwd&&(d.cwd=a.cwd),this.serverProcess=n.spawn(v,f,d)}this.serverProcess.on("error",d=>{this._onError.fire(d)}),this.serverProcess.on("exit",(d,r)=>{this._onExit.fire(d)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",d=>{this._onError.fire(d)}),this.serverProcess.stdin.on("error",d=>{this._onError.fire(d)});const o=this.outputService;if(o){const d=r=>r.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",r=>{o.getChannel(L.ExtensionsChannelId)?.append(d(r))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(m){this._onError.fire(m)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),P.isWindows?new Promise((v,f)=>{const a=n.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(m,o,d){if(m)return f(m)});a.on("exit",v),a.on("error",f)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(v,f){if(!v)return;const a=Object.create(null);v.runtime&&(v.runtime.indexOf("./")===0?a.runtime=D.join(f,v.runtime):a.runtime=v.runtime),v.runtimeArgs&&(a.runtimeArgs=v.runtimeArgs),v.program&&(D.isAbsolute(v.program)?a.program=v.program:a.program=D.join(f,v.program)),v.args&&(a.args=v.args);const m=v;return m.win&&(a.win=p.extract(m.win,f)),m.winx86&&(a.winx86=p.extract(m.winx86,f)),m.windows&&(a.windows=p.extract(m.windows,f)),m.osx&&(a.osx=p.extract(m.osx,f)),m.linux&&(a.linux=p.extract(m.linux,f)),a}static platformAdapterExecutable(v,f){let a=Object.create(null);f=f.toLowerCase();for(const i of v)if(i.contributes){const t=i.contributes.debuggers;t&&t.length>0&&t.filter(c=>typeof c.type=="string"&&C.equalsIgnoreCase(c.type,f)).forEach(c=>{const l=p.extract(c,i.extensionLocation.fsPath);a=S.mixin(a,l,i.isBuiltin)})}let m;P.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?m=a.winx86||a.win||a.windows:P.isWindows?m=a.win||a.windows:P.isMacintosh?m=a.osx:P.isLinux&&(m=a.linux),m=m||a;const o=m.program||a.program,d=m.args||a.args,r=m.runtime||a.runtime,s=m.runtimeArgs||a.runtimeArgs;if(r)return{type:"executable",command:r,args:(s||[]).concat(typeof o=="string"?[o]:[]).concat(d||[])};if(o)return{type:"executable",command:o,args:d||[]}}}e.ExecutableDebugAdapter=p}),define(Ie[217],ke([1,0,42,30,13]),function(Q,e,u,n,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function A(P,L){return new Promise((I,_)=>{let T="";const w=u.spawn(P,L);w.pid&&w.stdout.on("data",b=>{T+=b.toString()}),w.on("error",b=>{_(b)}),w.on("close",b=>{I(T)})})}async function D(P){if(P)if(y.isWindows){const L=await new Promise((I,_)=>{Q(["windows-process-tree"],I,_)});return new Promise(I=>{L.getProcessTree(P,_=>{I(!!_&&_.children.length>0)})})}else return A("/usr/bin/pgrep",["-lP",String(P)]).then(L=>{const I=L.trim();return!(I.length===0||I.indexOf(" tmux")>=0)},L=>!0);return Promise.resolve(!0)}e.hasChildProcesses=D;var C;(function(P){P[P.cmd=0]="cmd",P[P.powershell=1]="powershell",P[P.bash=2]="bash"})(C||(C={}));function S(P,L,I,_){P=P.trim().toLowerCase();let T;P.indexOf("powershell")>=0||P.indexOf("pwsh")>=0?T=1:P.indexOf("cmd.exe")>=0?T=0:P.indexOf("bash")>=0?T=2:y.isWindows?T=0:T=2;let w,b=" ";switch(T){case 1:if(w=p=>(p=p.replace(/\'/g,"''"),p.length>0&&p.charAt(p.length-1)==="\\"?`'${p}\\'`:`'${p}'`),I){const p=(0,n.getDriveLetter)(I);p&&(b+=`${p}:; `),b+=`cd ${w(I)}; `}if(_)for(const p in _){const g=_[p];g===null?b+=`Remove-Item env:${p}; `:b+=`\${env:${p}}='${g}'; `}if(L.length>0){const p=w(L.shift());b+=p[0]==="'"?`& ${p} `:`${p} `;for(const g of L)b+=g==="<"||g===">"?g:w(g),b+=" "}break;case 0:if(w=p=>(p=p.replace(/\"/g,'""'),p=p.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(g=>p.includes(g))||p.length===0?`"${p}"`:p),I){const p=(0,n.getDriveLetter)(I);p&&(b+=`${p}: && `),b+=`cd ${w(I)} && `}if(_){b+='cmd /C "';for(const p in _){let g=_[p];g===null?b+=`set "${p}=" && `:(g=g.replace(/[&^|<>]/g,v=>`^${v}`),b+=`set "${p}=${g}" && `)}}for(const p of L)b+=p==="<"||p===">"?p:w(p),b+=" ";_&&(b+='"');break;case 2:{w=g=>(g=g.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),g.length===0?'""':g);const p=g=>/[^\w@%\/+=,.:^-]/.test(g)?`'${g.replace(/'/g,"'\\''")}'`:g;if(I&&(b+=`cd ${w(I)} ; `),_){b+="/usr/bin/env";for(const g in _){const v=_[g];v===null?b+=` -u ${p(g)}`:b+=` ${p(`${g}=${v}`)}`}b+=" "}for(const g of L)b+=g==="<"||g===">"?g:w(g),b+=" ";break}}return b}e.prepareCommand=S}),define(Ie[128],ke([1,0,36,59,101,11,9,13,51]),function(Q,e,u,n,y,A,D,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var P;(function(i){i[i.Markup=1]="Markup",i[i.Code=2]="Code"})(P=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",y.Mimes.latex,y.Mimes.markdown,"image/png","image/jpeg",y.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[y.Mimes.latex,y.Mimes.markdown,"application/json",y.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var L;(function(i){i[i.Running=1]="Running",i[i.Idle=2]="Idle"})(L=e.NotebookRunState||(e.NotebookRunState={}));var I;(function(i){i[i.Unconfirmed=1]="Unconfirmed",i[i.Pending=2]="Pending",i[i.Executing=3]="Executing"})(I=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var _;(function(i){i[i.WithHardKernelDependency=0]="WithHardKernelDependency",i[i.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",i[i.Pure=2]="Pure",i[i.Never=3]="Never"})(_=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var T;(function(i){i.Always="always",i.Never="never",i.Optional="optional"})(T=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var w;(function(i){i[i.ModelChange=1]="ModelChange",i[i.Move=2]="Move",i[i.ChangeCellLanguage=5]="ChangeCellLanguage",i[i.Initialize=6]="Initialize",i[i.ChangeCellMetadata=7]="ChangeCellMetadata",i[i.Output=8]="Output",i[i.OutputItem=9]="OutputItem",i[i.ChangeCellContent=10]="ChangeCellContent",i[i.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",i[i.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",i[i.ChangeCellMime=13]="ChangeCellMime",i[i.Unknown=100]="Unknown"})(w=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var b;(function(i){i[i.Handle=0]="Handle",i[i.Index=1]="Index"})(b=e.SelectionStateType||(e.SelectionStateType={}));var p;(function(i){i[i.Replace=1]="Replace",i[i.Output=2]="Output",i[i.Metadata=3]="Metadata",i[i.CellLanguage=4]="CellLanguage",i[i.DocumentMetadata=5]="DocumentMetadata",i[i.Move=6]="Move",i[i.OutputItems=7]="OutputItems",i[i.PartialMetadata=8]="PartialMetadata",i[i.PartialInternalMetadata=9]="PartialInternalMetadata"})(p=e.CellEditType||(e.CellEditType={}));var g;(function(i){i.scheme=A.Schemas.vscodeNotebookCell;const t=/^ch(\d{7,})/;function c(O,k){return O.with({scheme:i.scheme,fragment:`ch${k.toString().padStart(7,"0")}${O.scheme!==A.Schemas.file?O.scheme:""}`})}i.generate=c;function l(O){if(O.scheme!==i.scheme)return;const k=t.exec(O.fragment);return k?{handle:Number(k[1]),notebook:O.with({scheme:O.fragment.substring(k[0].length)||A.Schemas.file,fragment:null})}:void 0}i.parse=l;function h(O,k){return O.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${k??""},${O.scheme!==A.Schemas.file?O.scheme:""}`})}i.generateCellOutputUri=h;function E(O){if(O.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const k=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(O.fragment);if(!k)return;const U=k[1]&&k[1]!==""?k[1]:void 0,F=k[2];return{outputId:U,notebook:O.with({scheme:F||A.Schemas.file,fragment:null})}}i.parseCellOutputUri=E;function R(O,k,U){return O.with({scheme:U,fragment:`ch${k.toString().padStart(7,"0")}${O.scheme!==A.Schemas.file?O.scheme:""}`})}i.generateCellUri=R;function N(O,k){if(O.scheme!==k)return;const U=t.exec(O.fragment);return U?{handle:Number(U[1]),notebook:O.with({scheme:O.fragment.substring(U[0].length)||A.Schemas.file,fragment:null})}:void 0}i.parseCellUri=N})(g=e.CellUri||(e.CellUri={}));const v=i=>C.isWindows?i.replace(/\//g,"\\"):i;class f{constructor(t=[],c=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=c,this.order=[...new Set(t)].map(l=>({pattern:l,matches:u.parse(v(l))}))}sort(t){const c=new Map(n.Iterable.map(t,h=>[h,v(h)]));let l=[];for(const{matches:h}of this.order)for(const[E,R]of c)if(h(R)){l.push(E),c.delete(E);break}return c.size&&(l=l.concat([...c.keys()].sort((h,E)=>this.defaultOrder.indexOf(h)-this.defaultOrder.indexOf(E)))),l}prioritize(t,c){const l=this.findIndex(t);if(l===-1){this.order.unshift({pattern:t,matches:u.parse(v(t))});return}const h=new Set(c.map(R=>this.findIndex(R,l)));h.delete(-1);const E=Array.from(h).sort();this.order.splice(l+1,0,...E.map(R=>this.order[R]));for(let R=E.length-1;R>=0;R--)this.order.splice(E[R],1)}toArray(){return this.order.map(t=>t.pattern)}findIndex(t,c=this.order.length){const l=v(t);for(let h=0;h<c;h++)if(this.order[h].matches(l))return h;return-1}}e.MimeTypeDisplayOrder=f;function a(i,t,c,l=(h,E)=>h===E){const h=[];function E(O,k,U){if(k===0&&U.length===0)return;const F=h[h.length-1];F&&F.start+F.deleteCount===O?(F.deleteCount+=k,F.toInsert.push(...U)):h.push({start:O,deleteCount:k,toInsert:U})}let R=0,N=0;for(;;){if(R===i.length){E(R,0,t.slice(N));break}if(N===t.length){E(R,i.length-R,[]);break}const O=i[R],k=t[N];if(l(O,k)){R+=1,N+=1;continue}c(k)?(E(R,1,[]),R+=1):(E(R,0,[k]),N+=1)}return h}e.diff=a,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new S.RawContextKey("notebookEditorCursorAtBoundary","none");var m;(function(i){i.default="default",i.option="option"})(m=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function o(i){const t=i;return!!((typeof t.include=="string"||u.isRelativePattern(t.include))&&(typeof t.exclude=="string"||u.isRelativePattern(t.exclude)))}e.isDocumentExcludePattern=o;function d(i,t,c){if(Array.isArray(i.viewType)&&i.viewType.indexOf(t)>=0||i.viewType===t)return!0;if(i.filenamePattern){const l=o(i.filenamePattern)?i.filenamePattern.include:i.filenamePattern,h=o(i.filenamePattern)?i.filenamePattern.exclude:void 0;if(u.match(l,(0,D.basename)(c.fsPath).toLowerCase()))return!(h&&u.match(h,(0,D.basename)(c.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=d,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily",interactiveWindowAlwaysScrollOnNewCell:"interactiveWindow.alwaysScrollOnNewCell"};var r;(function(i){i[i.Left=1]="Left",i[i.Right=2]="Right"})(r=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class s{static create(t){return`${s._prefix}${t}`}static parse(t){if(t.startsWith(s._prefix))return t.substring(s._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=s,s._prefix="notebook/"}),define(Ie[218],ke([1,0,4]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var n;(function(y){y[y.Output=1]="Output",y[y.OutputItems=2]="OutputItems",y[y.ExecutionState=3]="ExecutionState"})(n=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,u.createDecorator)("INotebookExecutionService")}),define(Ie[219],ke([1,0]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function u(D){return[...D.entries()]}e.serializeEnvironmentVariableCollection=u;function n(D){return new Map(D)}e.deserializeEnvironmentVariableCollection=n;function y(D){return Array.from(D.entries()).map(C=>[C[0],u(C[1].map)])}e.serializeEnvironmentVariableCollections=y;function A(D){return new Map(D.map(C=>[C[0],{map:n(C[1])}]))}e.deserializeEnvironmentVariableCollections=A}),define(Ie[66],ke([1,0]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var u;(function(A){A.Delimiter="\0"})(u=e.TestIdPathParts||(e.TestIdPathParts={}));var n;(function(A){A[A.IsSame=0]="IsSame",A[A.Disconnected=1]="Disconnected",A[A.IsChild=2]="IsChild",A[A.IsParent=3]="IsParent"})(n=e.TestPosition||(e.TestPosition={}));class y{constructor(D,C=D.length){if(this.path=D,this.viewEnd=C,D.length===0||C<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(D,C,S=D.parent){if(D.id===C)return new y([C]);const P=[D.id];for(let L=S;L&&L.id!==C;L=L.parent)P.push(L.id);return P.push(C),new y(P.reverse())}static isRoot(D){return!D.includes("\0")}static root(D){const C=D.indexOf("\0");return C===-1?D:D.slice(0,C)}static fromString(D){return new y(D.split("\0"))}static join(D,C){return new y([...D.path,C])}static joinToString(D,C){return D.toString()+"\0"+C}static compare(D,C){return D===C?0:C.startsWith(D+"\0")?2:D.startsWith(C+"\0")?3:1}get parentId(){return this.viewEnd>1?new y(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let D=1;D<=this.viewEnd;D++)yield new y(this.path,D)}compare(D){if(typeof D=="string")return y.compare(this.toString(),D);for(let C=0;C<D.viewEnd&&C<this.viewEnd;C++)if(D.path[C]!==this.path[C])return 1;return D.viewEnd>this.viewEnd?2:D.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let D=1;D<this.viewEnd;D++)this.stringifed+="\0",this.stringifed+=this.path[D]}return this.stringifed}}e.TestId=y}),define(Ie[67],ke([1,0,2,35]),function(Q,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var y;(function(i){i[i.Unset=0]="Unset",i[i.Queued=1]="Queued",i[i.Running=2]="Running",i[i.Passed=3]="Passed",i[i.Failed=4]="Failed",i[i.Skipped=5]="Skipped",i[i.Errored=6]="Errored"})(y=e.TestResultState||(e.TestResultState={}));var A;(function(i){i[i.Run=2]="Run",i[i.Debug=4]="Debug",i[i.Coverage=8]="Coverage",i[i.HasNonDefaultProfile=16]="HasNonDefaultProfile",i[i.HasConfigurable=32]="HasConfigurable"})(A=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var D;(function(i){i.serialize=t=>({range:t.range.toJSON(),uri:t.uri.toJSON()}),i.deserialize=t=>({range:n.Range.lift(t.range),uri:u.URI.revive(t.uri)})})(D=e.IRichLocation||(e.IRichLocation={}));var C;(function(i){i[i.Error=0]="Error",i[i.Output=1]="Output"})(C=e.TestMessageType||(e.TestMessageType={}));var S;(function(i){i.serialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&D.serialize(t.location)}),i.deserialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&D.deserialize(t.location)})})(S=e.ITestErrorMessage||(e.ITestErrorMessage={}));var P;(function(i){i.serialize=t=>({message:t.message,type:1,offset:t.offset,location:t.location&&D.serialize(t.location)}),i.deserialize=t=>({message:t.message,type:1,offset:t.offset,location:t.location&&D.deserialize(t.location)})})(P=e.ITestOutputMessage||(e.ITestOutputMessage={}));var L;(function(i){i.serialize=t=>t.type===0?S.serialize(t):P.serialize(t),i.deserialize=t=>t.type===0?S.deserialize(t):P.deserialize(t)})(L=e.ITestMessage||(e.ITestMessage={}));var I;(function(i){i.serialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(L.serialize)}),i.deserialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(L.deserialize)})})(I=e.ITestTaskState||(e.ITestTaskState={}));const _="\0",T=(i,t)=>i+_+t;e.namespaceTestTag=T;const w=i=>{const t=i.indexOf(_);return{ctrlId:i.slice(0,t),tagId:i.slice(t+1)}};e.denamespaceTestTag=w;var b;(function(i){i.serialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?.toJSON(),range:t.range?.toJSON()||null,description:t.description,error:t.error,sortText:t.sortText}),i.deserialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?u.URI.revive(t.uri):void 0,range:t.range?n.Range.lift(t.range):null,description:t.description,error:t.error,sortText:t.sortText})})(b=e.ITestItem||(e.ITestItem={}));var p;(function(i){i[i.NotExpandable=0]="NotExpandable",i[i.Expandable=1]="Expandable",i[i.BusyExpanding=2]="BusyExpanding",i[i.Expanded=3]="Expanded"})(p=e.TestItemExpandState||(e.TestItemExpandState={}));var g;(function(i){i.serialize=t=>({controllerId:t.controllerId,expand:t.expand,parent:t.parent,item:b.serialize(t.item)}),i.deserialize=t=>({controllerId:t.controllerId,expand:t.expand,parent:t.parent,item:b.deserialize(t.item)})})(g=e.InternalTestItem||(e.InternalTestItem={}));var v;(function(i){i.serialize=t=>{let c;return t.item&&(c={},t.item.label!==void 0&&(c.label=t.item.label),t.item.tags!==void 0&&(c.tags=t.item.tags),t.item.busy!==void 0&&(c.busy=t.item.busy),t.item.uri!==void 0&&(c.uri=t.item.uri?.toJSON()),t.item.range!==void 0&&(c.range=t.item.range?.toJSON()),t.item.description!==void 0&&(c.description=t.item.description),t.item.error!==void 0&&(c.error=t.item.error),t.item.sortText!==void 0&&(c.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:c}},i.deserialize=t=>{let c;return t.item&&(c={},t.item.label!==void 0&&(c.label=t.item.label),t.item.tags!==void 0&&(c.tags=t.item.tags),t.item.busy!==void 0&&(c.busy=t.item.busy),t.item.range!==void 0&&(c.range=t.item.range?n.Range.lift(t.item.range):null),t.item.description!==void 0&&(c.description=t.item.description),t.item.error!==void 0&&(c.error=t.item.error),t.item.sortText!==void 0&&(c.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:c}}})(v=e.ITestItemUpdate||(e.ITestItemUpdate={}));const f=(i,t)=>{t.expand!==void 0&&(i.expand=t.expand),t.item!==void 0&&(i.item=i.item?Object.assign(i.item,t.item):t.item)};e.applyTestItemUpdate=f;var a;(function(i){i.serialize=(t,c)=>({...g.serialize(t),children:c,ownComputedState:t.ownComputedState,computedState:t.computedState,tasks:t.tasks.map(I.serialize)})})(a=e.TestResultItem||(e.TestResultItem={}));var m;(function(i){i[i.Function=0]="Function",i[i.Statement=1]="Statement"})(m=e.DetailType||(e.DetailType={}));var o;(function(i){i[i.Add=0]="Add",i[i.Update=1]="Update",i[i.Remove=2]="Remove",i[i.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",i[i.Retire=4]="Retire",i[i.AddTag=5]="AddTag",i[i.RemoveTag=6]="RemoveTag"})(o=e.TestDiffOpType||(e.TestDiffOpType={}));var d;(function(i){i.deserialize=t=>t.op===0?{op:t.op,item:g.deserialize(t.item)}:t.op===1?{op:t.op,item:v.deserialize(t.item)}:t,i.serialize=t=>t.op===0?{op:t.op,item:g.serialize(t.item)}:t.op===1?{op:t.op,item:v.serialize(t.item)}:t})(d=e.TestsDiffOp||(e.TestsDiffOp={}));class r{add(t){}update(t){}remove(t,c){}complete(){}}e.IncrementalChangeCollector=r;class s{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(t){const c=this.createChangeCollector();for(const l of t)switch(l.op){case 0:{const h=g.deserialize(l.item);if(h.parent){if(this.items.has(h.parent)){const E=this.items.get(h.parent);E.children.add(h.item.extId);const R=this.createItem(h,E);this.items.set(h.item.extId,R),c.add(R)}}else{const E=this.createItem(h);this.roots.add(E),this.items.set(h.item.extId,E),c.add(E)}h.expand===2&&this.busyControllerCount++;break}case 1:{const h=v.deserialize(l.item),E=this.items.get(h.extId);if(!E)break;h.expand!==void 0&&(E.expand===2&&this.busyControllerCount--,h.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(E,h),c.update(E);break}case 2:{const h=this.items.get(l.itemId);if(!h)break;h.parent?this.items.get(h.parent).children.delete(h.item.extId):this.roots.delete(h);const E=[[l.itemId]];for(;E.length;)for(const R of E.pop()){const N=this.items.get(R);N&&(E.push(N.children),this.items.delete(R),c.remove(N,N!==h),N.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(l.itemId);break;case 3:this.updatePendingRoots(l.amount);break;case 5:this._tags.set(l.tag.id,l.tag);break;case 6:this._tags.delete(l.id);break}c.complete()}retireTest(t){}updatePendingRoots(t){this.pendingRootCount+=t}createChangeCollector(){return new r}}e.AbstractIncrementalTestCollection=s}),define(Ie[89],ke([1,0,18,3,6,10,67,66]),function(Q,e,u,n,y,A,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var S;(function(g){g[g.Upsert=0]="Upsert",g[g.SetTags=1]="SetTags",g[g.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",g[g.RemoveChild=3]="RemoveChild",g[g.SetProp=4]="SetProp",g[g.Bulk=5]="Bulk"})(S=e.TestItemEventOp||(e.TestItemEventOp={}));const P=(g,v)=>g===v,L={range:(g,v)=>g===v?!0:!g||!v?!1:g.equalsRange(v),busy:P,label:P,description:P,error:P,tags:(g,v)=>!(g.length!==v.length||g.some(f=>!v.includes(f)))},I=(g,v)=>{let f;for(const[a,m]of Object.entries(L))m(g[a],v[a])||(f?f[a]=v[a]:f={[a]:v[a]});return f};class _ extends y.Disposable{constructor(v){super();this.options=v,this.debounceSendDiff=this._register(new u.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new n.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}get root(){return this.options.root}set resolveHandler(v){this._resolveHandler=v;for(const f of this.tree.values())this.updateExpandability(f)}collectDiff(){const v=this.diff;return this.diff=[],v}pushDiff(v){const f=this.diff[this.diff.length-1];if(f&&v.op===1){if(f.op===1&&f.item.extId===v.item.extId){(0,D.applyTestItemUpdate)(f.item,v.item);return}if(f.op===0&&f.item.item.extId===v.item.extId){(0,D.applyTestItemUpdate)(f.item,v.item);return}}this.diff.push(v),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(v,f){const a=this.tree.get(v);if(!!a){if((a.expandLevels===void 0||f>a.expandLevels)&&(a.expandLevels=f),a.expand===1){const m=this.resolveChildren(a);return m.isOpen()?this.expandChildren(a,f-1):m.wait().then(()=>this.expandChildren(a,f-1))}else if(a.expand===3)return a.resolveBarrier?.isOpen()===!1?a.resolveBarrier.wait().then(()=>this.expandChildren(a,f-1)):this.expandChildren(a,f-1)}}dispose(){for(const v of this.tree.values())this.options.getApiFor(v.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(v,f){switch(f.op){case 3:this.removeItem(C.TestId.joinToString(v.fullId,f.id));break;case 0:this.upsertItem(f.item,v);break;case 5:for(const a of f.ops)this.onTestItemEvent(v,a);break;case 1:this.diffTagRefs(f.new,f.old,v.fullId.toString());break;case 2:this.updateExpandability(v);break;case 4:this.pushDiff({op:1,item:{extId:v.fullId.toString(),item:f.update}});break;default:(0,A.assertNever)(f)}}upsertItem(v,f){const a=C.TestId.fromExtHostTestItem(v,this.root.id,f?.actual),m=this.options.getApiFor(v);m.parent&&m.parent!==f?.actual&&this.options.getChildren(m.parent).delete(v.id);let o=this.tree.get(a.toString());if(!o){o={fullId:a,actual:v,parent:f?a.parentId:null,expandLevels:f?.expandLevels?f.expandLevels-1:void 0,expand:0},v.tags.forEach(this.incrementTagRefs,this),this.tree.set(o.fullId.toString(),o),this.setItemParent(v,f),this.pushDiff({op:0,item:{parent:o.parent&&o.parent.toString(),controllerId:this.options.controllerId,expand:o.expand,item:this.options.toITestItem(v)}}),this.connectItemAndChildren(v,o,f);return}if(o.actual===v){this.connectItem(v,o,f);return}const d=this.options.getChildren(o.actual),r=o.actual,s=I(this.options.toITestItem(r),this.options.toITestItem(v));this.options.getApiFor(r).listener=void 0,o.actual=v,o.expand=0,s&&(s.hasOwnProperty("tags")&&(this.diffTagRefs(v.tags,r.tags,a.toString()),delete s.tags),this.onTestItemEvent(o,{op:4,update:s})),this.connectItemAndChildren(v,o,f);for(const[i,t]of d)this.options.getChildren(v).get(t.id)||this.removeItem(C.TestId.joinToString(a,t.id))}diffTagRefs(v,f,a){const m=new Set(f.map(o=>o.id));for(const o of v)m.delete(o.id)||this.incrementTagRefs(o);this.pushDiff({op:1,item:{extId:a,item:{tags:v.map(o=>(0,D.namespaceTestTag)(this.options.controllerId,o.id))}}}),m.forEach(this.decrementTagRefs,this)}incrementTagRefs(v){const f=this.tags.get(v.id);f?f.refCount++:(this.tags.set(v.id,{refCount:1}),this.pushDiff({op:5,tag:{id:(0,D.namespaceTestTag)(this.options.controllerId,v.id)}}))}decrementTagRefs(v){const f=this.tags.get(v);f&&!--f.refCount&&(this.tags.delete(v),this.pushDiff({op:6,id:(0,D.namespaceTestTag)(this.options.controllerId,v)}))}setItemParent(v,f){this.options.getApiFor(v).parent=f&&f.actual!==this.root?f.actual:void 0}connectItem(v,f,a){this.setItemParent(v,a);const m=this.options.getApiFor(v);m.parent=a?.actual,m.listener=o=>this.onTestItemEvent(f,o),this.updateExpandability(f)}connectItemAndChildren(v,f,a){this.connectItem(v,f,a);for(const[m,o]of this.options.getChildren(v))this.upsertItem(o,f)}updateExpandability(v){let f;this._resolveHandler?v.resolveBarrier?f=v.resolveBarrier.isOpen()?3:2:f=v.actual.canResolveChildren?1:0:f=0,f!==v.expand&&(v.expand=f,this.pushDiff({op:1,item:{extId:v.fullId.toString(),expand:f}}),f===1&&v.expandLevels!==void 0&&this.resolveChildren(v))}expandChildren(v,f){if(f<0)return;const a=[];for(const[m,o]of this.options.getChildren(v.actual)){const d=this.expand(C.TestId.joinToString(v.fullId,o.id),f);(0,u.isThenable)(d)&&a.push(d)}if(a.length)return Promise.all(a).then(()=>{})}resolveChildren(v){if(v.resolveBarrier)return v.resolveBarrier;if(!this._resolveHandler){const o=new u.Barrier;return o.open(),o}v.expand=2,this.pushExpandStateUpdate(v);const f=v.resolveBarrier=new u.Barrier,a=o=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,o)};let m;try{m=this._resolveHandler(v.actual===this.root?void 0:v.actual)}catch(o){a(o)}return(0,u.isThenable)(m)?m.catch(a).then(()=>{f.open(),this.updateExpandability(v)}):(f.open(),this.updateExpandability(v)),v.resolveBarrier}pushExpandStateUpdate(v){this.pushDiff({op:1,item:{extId:v.fullId.toString(),expand:v.expand}})}removeItem(v){const f=this.tree.get(v);if(!f)throw new Error("attempting to remove non-existent child");this.pushDiff({op:2,itemId:v});const a=[f];for(;a.length;){const m=a.pop();if(!!m){this.options.getApiFor(m.actual).listener=void 0;for(const o of m.actual.tags)this.decrementTagRefs(o.id);this.tree.delete(m.fullId.toString());for(const[o,d]of this.options.getChildren(m.actual))a.push(this.tree.get(C.TestId.joinToString(m.fullId,d.id)))}}}flushDiff(){const v=this.collectDiff();v.length&&this.diffOpEmitter.fire(v)}}e.TestItemCollection=_;class T extends Error{constructor(v){super(`Attempted to insert a duplicate test item ID ${v}`)}}e.DuplicateTestItemError=T;class w extends Error{constructor(v){super(`TestItem with ID "${v}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=w;class b extends Error{constructor(v,f,a){super(`TestItem with ID "${v}" is from controller "${f}" and cannot be added as a child of an item from controller "${a}".`)}}e.MixedTestItemController=b;const p=(g,v,f)=>{let a=new Map;return{get size(){return a.size},forEach(m,o){for(const d of a.values())m.call(o,d,this)},[Symbol.iterator](){return a.entries()},replace(m){const o=new Map,d=new Set(a.keys()),r={op:5,ops:[]};for(const s of m){if(!(s instanceof f))throw new w(s.id);const i=v(s).controllerId;if(i!==g.controllerId)throw new b(s.id,i,g.controllerId);if(o.has(s.id))throw new T(s.id);o.set(s.id,s),d.delete(s.id),r.ops.push({op:0,item:s})}for(const s of d.keys())r.ops.push({op:3,id:s});g.listener?.(r),a=o},add(m){if(!(m instanceof f))throw new w(m.id);a.set(m.id,m),g.listener?.({op:0,item:m})},delete(m){a.delete(m)&&g.listener?.({op:3,id:m})},get(m){return a.get(m)},toJSON(){return Array.from(a.values())}}};e.createTestItemChildren=p}),define(Ie[129],ke([1,0,89]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const n=new WeakMap,y=(D,C)=>{const S={controllerId:C};return n.set(D,S),S};e.createPrivateApiFor=y;const A=D=>{const C=n.get(D);if(!C)throw new u.InvalidTestItemError(D?.id||"<unknown>");return C};e.getPrivateApiFor=A}),define(Ie[220],ke([1,0,9,40,10,24,13,107,186,8]),function(Q,e,u,n,y,A,D,C,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class L{constructor(_,T,w,b){this._contributedVariables=new Map,this._context=_,this._labelService=T,this._userHomePromise=w,b&&(this._envVariablesPromise=b.then(p=>this.prepareEnv(p)))}prepareEnv(_){if(D.isWindows){const T=Object.create(null);return Object.keys(_).forEach(w=>{T[w.toLowerCase()]=_[w]}),T}return _}resolveWithEnvironment(_,T,w){return this.recursiveResolve({env:this.prepareEnv(_),userHome:void 0},T?T.uri:void 0,w)}async resolveAsync(_,T){const w={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(w,_?_.uri:void 0,T)}async resolveAnyBase(_,T,w,b){const p=A.deepClone(T);D.isWindows&&p.windows?Object.keys(p.windows).forEach(v=>p[v]=p.windows[v]):D.isMacintosh&&p.osx?Object.keys(p.osx).forEach(v=>p[v]=p.osx[v]):D.isLinux&&p.linux&&Object.keys(p.linux).forEach(v=>p[v]=p.linux[v]),delete p.windows,delete p.osx,delete p.linux;const g={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(g,_?_.uri:void 0,p,w,b)}async resolveAnyAsync(_,T,w){return this.resolveAnyBase(_,T,w)}async resolveAnyMap(_,T,w){const b=new Map;return{newConfig:await this.resolveAnyBase(_,T,w,b),resolvedVariables:b}}resolveWithInteractionReplace(_,T,w,b){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(_,T,w,b){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(_,T){if(this._contributedVariables.has(_))throw new Error("Variable "+_+" is contributed twice.");this._contributedVariables.set(_,T)}async recursiveResolve(_,T,w,b,p){if(y.isString(w))return this.resolveString(_,T,w,b,p);if(y.isArray(w))return Promise.all(w.map(g=>this.recursiveResolve(_,T,g,b,p)));if(y.isObject(w)){const g=Object.create(null),v=await Promise.all(Object.keys(w).map(async f=>[await this.resolveString(_,T,f,b,p),await this.recursiveResolve(_,T,w[f],b,p)]));for(const[f,a]of v)g[f]=a;return g}return w}resolveString(_,T,w,b,p){return(0,P.replaceAsync)(w,L.VARIABLE_REGEXP,async(g,v)=>{if(v.includes(L.VARIABLE_LHS))return g;let f=await this.evaluateSingleVariable(_,g,v,T,b);return p?.set(v,f),f!==g&&y.isString(f)&&f.match(L.VARIABLE_REGEXP)&&(f=await this.resolveString(_,T,f,b,p)),f})}fsPath(_){return this._labelService?this._labelService.getUriLabel(_,{noPrefix:!0}):_.fsPath}async evaluateSingleVariable(_,T,w,b,p){let g;const v=w.split(":");v.length>1&&(w=v[0],g=v[1]);const f=()=>{const o=this._context.getFilePath();if(o)return o;throw new Error((0,S.localize)(0,null,T))},a=()=>{const o=f();if(this._context.getWorkspaceFolderPathForFile){const d=this._context.getWorkspaceFolderPathForFile();if(d)return d}throw new Error((0,S.localize)(1,null,T,u.basename(o)))},m=()=>{if(g){const o=this._context.getFolderUri(g);if(o)return o;throw new Error((0,S.localize)(2,null,T,g))}if(b)return b;throw this._context.getWorkspaceFolderCount()>1?new Error((0,S.localize)(3,null,T)):new Error((0,S.localize)(4,null,T))};switch(w){case"env":if(g){if(_.env){const o=_.env[D.isWindows?g.toLowerCase():g];if(y.isString(o))return o}return""}throw new Error((0,S.localize)(5,null,T));case"config":if(g){const o=this._context.getConfigurationValue(b,g);if(y.isUndefinedOrNull(o))throw new Error((0,S.localize)(6,null,T,g));if(y.isObject(o))throw new Error((0,S.localize)(7,null,T,g));return o}throw new Error((0,S.localize)(8,null,T));case"command":return this.resolveFromMap(T,g,p,"command");case"input":return this.resolveFromMap(T,g,p,"input");case"extensionInstallFolder":if(g){const o=await this._context.getExtension(g);if(!o)throw new Error((0,S.localize)(9,null,T,g));return this.fsPath(o.extensionLocation)}throw new Error((0,S.localize)(10,null,T));default:switch(w){case"workspaceRoot":case"workspaceFolder":return(0,C.normalizeDriveLetter)(this.fsPath(m()));case"cwd":return b||g?(0,C.normalizeDriveLetter)(this.fsPath(m())):n.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return u.basename(this.fsPath(m()));case"userHome":{if(_.userHome)return _.userHome;throw new Error((0,S.localize)(11,null,T))}case"lineNumber":{const o=this._context.getLineNumber();if(o)return o;throw new Error((0,S.localize)(12,null,T))}case"selectedText":{const o=this._context.getSelectedText();if(o)return o;throw new Error((0,S.localize)(13,null,T))}case"file":return f();case"fileWorkspaceFolder":return a();case"relativeFile":return b||g?u.relative(this.fsPath(m()),f()):f();case"relativeFileDirname":{const o=u.dirname(f());if(b||g){const d=u.relative(this.fsPath(m()),o);return d.length===0?".":d}return o}case"fileDirname":return u.dirname(f());case"fileExtname":return u.extname(f());case"fileBasename":return u.basename(f());case"fileBasenameNoExtension":{const o=u.basename(f());return o.slice(0,o.length-u.extname(o).length)}case"fileDirnameBasename":return u.basename(u.dirname(f()));case"execPath":{const o=this._context.getExecPath();return o||T}case"execInstallFolder":{const o=this._context.getAppRoot();return o||T}case"pathSeparator":return u.sep;default:try{const o=g?`${w}:${g}`:w;return this.resolveFromMap(T,o,p,void 0)}catch{return T}}}}resolveFromMap(_,T,w,b){if(T&&w){const p=b===void 0?w[T]:w[b+":"+T];if(typeof p=="string")return p;throw new Error((0,S.localize)(14,null,_))}return _}}e.AbstractVariableResolverService=L,L.VARIABLE_LHS="${",L.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Ie[130],ke([1,0,4,212]),function(Q,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,u.createDecorator)("editorGroupsService");var y;(function(w){w[w.UP=0]="UP",w[w.DOWN=1]="DOWN",w[w.LEFT=2]="LEFT",w[w.RIGHT=3]="RIGHT"})(y=e.GroupDirection||(e.GroupDirection={}));var A;(function(w){w[w.HORIZONTAL=0]="HORIZONTAL",w[w.VERTICAL=1]="VERTICAL"})(A=e.GroupOrientation||(e.GroupOrientation={}));var D;(function(w){w[w.FIRST=0]="FIRST",w[w.LAST=1]="LAST",w[w.NEXT=2]="NEXT",w[w.PREVIOUS=3]="PREVIOUS"})(D=e.GroupLocation||(e.GroupLocation={}));var C;(function(w){w[w.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",w[w.EVEN=1]="EVEN",w[w.TOGGLE=2]="TOGGLE"})(C=e.GroupsArrangement||(e.GroupsArrangement={}));var S;(function(w){w[w.COPY_EDITORS=0]="COPY_EDITORS",w[w.MOVE_EDITORS=1]="MOVE_EDITORS"})(S=e.MergeGroupMode||(e.MergeGroupMode={}));function P(w){const b=w;return(0,n.isEditorInput)(b?.editor)&&(0,n.isEditorInput)(b?.replacement)}e.isEditorReplacement=P;var L;(function(w){w[w.CREATION_TIME=0]="CREATION_TIME",w[w.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",w[w.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(L=e.GroupsOrder||(e.GroupsOrder={}));var I;(function(w){w[w.NEW_EDITOR=1]="NEW_EDITOR",w[w.MOVE_EDITOR=2]="MOVE_EDITOR",w[w.COPY_EDITOR=3]="COPY_EDITOR"})(I=e.OpenEditorContext||(e.OpenEditorContext={}));function _(w){const b=w;return!!b&&typeof b.id=="number"&&Array.isArray(b.editors)}e.isEditorGroup=_;function T(w){return w.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=T}),define(Ie[221],ke([1,0,4,130]),function(Q,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,u.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function y(A){const D=A;return typeof A=="number"||(0,n.isEditorGroup)(D)}e.isPreferredGroup=y}),define(Ie[15],ke([1,0,16,23,106,25,144,61,24,10,2,35,64,189,116,129,128,66,67,221,7,58]),function(Q,e,u,n,y,A,D,C,S,P,L,I,_,T,w,b,p,g,v,f,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var o;(function(Ae){function Oe(J){const{selectionStartLineNumber:Fe,selectionStartColumn:xe,positionLineNumber:Je,positionColumn:et}=J,Ze=new a.Position(Fe-1,xe-1),gt=new a.Position(Je-1,et-1);return new a.Selection(Ze,gt)}Ae.to=Oe;function Ee(J){const{anchor:Fe,active:xe}=J;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:xe.line+1,positionColumn:xe.character+1}}Ae.from=Ee})(o=e.Selection||(e.Selection={}));var d;(function(Ae){function Oe(J){if(!J)return;const{start:Fe,end:xe}=J;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:xe.line+1,endColumn:xe.character+1}}Ae.from=Oe;function Ee(J){if(!J)return;const{startLineNumber:Fe,startColumn:xe,endLineNumber:Je,endColumn:et}=J;return new a.Range(Fe-1,xe-1,Je-1,et-1)}Ae.to=Ee})(d=e.Range||(e.Range={}));var r;(function(Ae){function Oe(Ee){switch(Ee){case 1:return a.StandardTokenType.Comment;case 0:return a.StandardTokenType.Other;case 3:return a.StandardTokenType.RegEx;case 2:return a.StandardTokenType.String}}Ae.to=Oe})(r=e.TokenType||(e.TokenType={}));var s;(function(Ae){function Oe(J){return new a.Position(J.lineNumber-1,J.column-1)}Ae.to=Oe;function Ee(J){return{lineNumber:J.line+1,column:J.character+1}}Ae.from=Ee})(s=e.Position||(e.Position={}));var i;(function(Ae){function Oe(Fe,xe){return(0,u.coalesce)((0,u.asArray)(Fe).map(Je=>Ee(Je,xe)))}Ae.from=Oe;function Ee(Fe,xe){if(typeof Fe=="string")return{$serialized:!0,language:Fe};if(Fe)return{$serialized:!0,language:Fe.language,scheme:J(Fe.scheme,xe),pattern:oe.from(Fe.pattern)??void 0,exclusive:Fe.exclusive,notebookType:Fe.notebookType}}function J(Fe,xe){return xe&&typeof Fe=="string"?xe.transformOutgoingScheme(Fe):Fe}})(i=e.DocumentSelector||(e.DocumentSelector={}));var t;(function(Ae){function Oe(J){switch(J){case a.DiagnosticTag.Unnecessary:return 1;case a.DiagnosticTag.Deprecated:return 2}}Ae.from=Oe;function Ee(J){switch(J){case 1:return a.DiagnosticTag.Unnecessary;case 2:return a.DiagnosticTag.Deprecated;default:return}}Ae.to=Ee})(t=e.DiagnosticTag||(e.DiagnosticTag={}));var c;(function(Ae){function Oe(J){let Fe;return J.code&&((0,P.isString)(J.code)||(0,P.isNumber)(J.code)?Fe=String(J.code):Fe={value:String(J.code.value),target:J.code.target}),{...d.from(J.range),message:J.message,source:J.source,code:Fe,severity:h.from(J.severity),relatedInformation:J.relatedInformation&&J.relatedInformation.map(l.from),tags:Array.isArray(J.tags)?(0,u.coalesce)(J.tags.map(t.from)):void 0}}Ae.from=Oe;function Ee(J){const Fe=new a.Diagnostic(d.to(J),J.message,h.to(J.severity));return Fe.source=J.source,Fe.code=(0,P.isString)(J.code)?J.code:J.code?.value,Fe.relatedInformation=J.relatedInformation&&J.relatedInformation.map(l.to),Fe.tags=J.tags&&(0,u.coalesce)(J.tags.map(t.to)),Fe}Ae.to=Ee})(c=e.Diagnostic||(e.Diagnostic={}));var l;(function(Ae){function Oe(J){return{...d.from(J.location.range),message:J.message,resource:J.location.uri}}Ae.from=Oe;function Ee(J){return new a.DiagnosticRelatedInformation(new a.Location(J.resource,d.to(J)),J.message)}Ae.to=Ee})(l=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var h;(function(Ae){function Oe(J){switch(J){case a.DiagnosticSeverity.Error:return w.MarkerSeverity.Error;case a.DiagnosticSeverity.Warning:return w.MarkerSeverity.Warning;case a.DiagnosticSeverity.Information:return w.MarkerSeverity.Info;case a.DiagnosticSeverity.Hint:return w.MarkerSeverity.Hint}return w.MarkerSeverity.Error}Ae.from=Oe;function Ee(J){switch(J){case w.MarkerSeverity.Info:return a.DiagnosticSeverity.Information;case w.MarkerSeverity.Warning:return a.DiagnosticSeverity.Warning;case w.MarkerSeverity.Error:return a.DiagnosticSeverity.Error;case w.MarkerSeverity.Hint:return a.DiagnosticSeverity.Hint;default:return a.DiagnosticSeverity.Error}}Ae.to=Ee})(h=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var E;(function(Ae){function Oe(J){return typeof J=="number"&&J>=a.ViewColumn.One?J-1:J===a.ViewColumn.Beside?f.SIDE_GROUP:f.ACTIVE_GROUP}Ae.from=Oe;function Ee(J){if(typeof J=="number"&&J>=0)return J+1;throw new Error("invalid 'EditorGroupColumn'")}Ae.to=Ee})(E=e.ViewColumn||(e.ViewColumn={}));function R(Ae){return typeof Ae.range!="undefined"}function N(Ae){return Ae.length===0?!0:!!R(Ae[0])}e.isDecorationOptionsArr=N;var O;(function(Ae){function Oe(et){return et.map(Ae.from)}Ae.fromMany=Oe;function Ee(et){return et&&typeof et=="object"&&typeof et.language=="string"&&typeof et.value=="string"}function J(et){let Ze;if(Ee(et)){const{language:vt,value:ht}=et;Ze={value:"```"+vt+`
`+ht+"\n```\n"}}else a.MarkdownString.isMarkdownString(et)?Ze={value:et.value,isTrusted:et.isTrusted,supportThemeIcons:et.supportThemeIcons,supportHtml:et.supportHtml,baseUri:et.baseUri}:typeof et=="string"?Ze={value:et}:Ze={value:""};const gt=Object.create(null);Ze.uris=gt;const pt=vt=>{try{let ht=L.URI.parse(vt,!0);ht=ht.with({query:Fe(ht.query,gt)}),gt[vt]=ht}catch{}return""},yt=new D.marked.Renderer;return yt.link=pt,yt.image=vt=>typeof vt=="string"?pt(y.parseHrefAndDimensions(vt).href):"",(0,D.marked)(Ze.value,{renderer:yt}),Ze}Ae.from=J;function Fe(et,Ze){if(!et)return et;let gt;try{gt=(0,C.parse)(et)}catch{}if(!gt)return et;let pt=!1;return gt=(0,S.cloneAndChange)(gt,yt=>{if(L.URI.isUri(yt)){const vt=`__uri_${Math.random().toString(16).slice(2,8)}`;return Ze[vt]=yt,pt=!0,vt}else return}),pt?JSON.stringify(gt):et}function xe(et){const Ze=new a.MarkdownString(et.value,et.supportThemeIcons);return Ze.isTrusted=et.isTrusted,Ze.supportHtml=et.supportHtml,Ze.baseUri=et.baseUri?L.URI.from(et.baseUri):void 0,Ze}Ae.to=xe;function Je(et){if(!!et)return typeof et=="string"?et:Ae.from(et)}Ae.fromStrict=Je})(O=e.MarkdownString||(e.MarkdownString={}));function k(Ae){return N(Ae)?Ae.map(Oe=>({range:d.from(Oe.range),hoverMessage:Array.isArray(Oe.hoverMessage)?O.fromMany(Oe.hoverMessage):Oe.hoverMessage?O.from(Oe.hoverMessage):void 0,renderOptions:Oe.renderOptions})):Ae.map(Oe=>({range:d.from(Oe)}))}e.fromRangeOrRangeWithMessage=k;function U(Ae){return typeof Ae=="undefined"?Ae:typeof Ae=="string"?L.URI.file(Ae):Ae}e.pathOrURIToURI=U;var F;(function(Ae){function Oe(Ee){return typeof Ee=="undefined"?Ee:{contentText:Ee.contentText,contentIconPath:Ee.contentIconPath?U(Ee.contentIconPath):void 0,border:Ee.border,borderColor:Ee.borderColor,fontStyle:Ee.fontStyle,fontWeight:Ee.fontWeight,textDecoration:Ee.textDecoration,color:Ee.color,backgroundColor:Ee.backgroundColor,margin:Ee.margin,width:Ee.width,height:Ee.height}}Ae.from=Oe})(F=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var $;(function(Ae){function Oe(Ee){return typeof Ee=="undefined"?Ee:{backgroundColor:Ee.backgroundColor,outline:Ee.outline,outlineColor:Ee.outlineColor,outlineStyle:Ee.outlineStyle,outlineWidth:Ee.outlineWidth,border:Ee.border,borderColor:Ee.borderColor,borderRadius:Ee.borderRadius,borderSpacing:Ee.borderSpacing,borderStyle:Ee.borderStyle,borderWidth:Ee.borderWidth,fontStyle:Ee.fontStyle,fontWeight:Ee.fontWeight,textDecoration:Ee.textDecoration,cursor:Ee.cursor,color:Ee.color,opacity:Ee.opacity,letterSpacing:Ee.letterSpacing,gutterIconPath:Ee.gutterIconPath?U(Ee.gutterIconPath):void 0,gutterIconSize:Ee.gutterIconSize,overviewRulerColor:Ee.overviewRulerColor,before:Ee.before?F.from(Ee.before):void 0,after:Ee.after?F.from(Ee.after):void 0}}Ae.from=Oe})($=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var ee;(function(Ae){function Oe(Ee){if(typeof Ee=="undefined")return Ee;switch(Ee){case a.DecorationRangeBehavior.OpenOpen:return 0;case a.DecorationRangeBehavior.ClosedClosed:return 1;case a.DecorationRangeBehavior.OpenClosed:return 2;case a.DecorationRangeBehavior.ClosedOpen:return 3}}Ae.from=Oe})(ee=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var B;(function(Ae){function Oe(Ee){return{isWholeLine:Ee.isWholeLine,rangeBehavior:Ee.rangeBehavior?ee.from(Ee.rangeBehavior):void 0,overviewRulerLane:Ee.overviewRulerLane,light:Ee.light?$.from(Ee.light):void 0,dark:Ee.dark?$.from(Ee.dark):void 0,backgroundColor:Ee.backgroundColor,outline:Ee.outline,outlineColor:Ee.outlineColor,outlineStyle:Ee.outlineStyle,outlineWidth:Ee.outlineWidth,border:Ee.border,borderColor:Ee.borderColor,borderRadius:Ee.borderRadius,borderSpacing:Ee.borderSpacing,borderStyle:Ee.borderStyle,borderWidth:Ee.borderWidth,fontStyle:Ee.fontStyle,fontWeight:Ee.fontWeight,textDecoration:Ee.textDecoration,cursor:Ee.cursor,color:Ee.color,opacity:Ee.opacity,letterSpacing:Ee.letterSpacing,gutterIconPath:Ee.gutterIconPath?U(Ee.gutterIconPath):void 0,gutterIconSize:Ee.gutterIconSize,overviewRulerColor:Ee.overviewRulerColor,before:Ee.before?F.from(Ee.before):void 0,after:Ee.after?F.from(Ee.after):void 0}}Ae.from=Oe})(B=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var z;(function(Ae){function Oe(J){return{text:J.newText,eol:J.newEol&&Ye.from(J.newEol),range:d.from(J.range)}}Ae.from=Oe;function Ee(J){const Fe=new a.TextEdit(d.to(J.range),J.text);return Fe.newEol=typeof J.eol=="undefined"?void 0:Ye.to(J.eol),Fe}Ae.to=Ee})(z=e.TextEdit||(e.TextEdit={}));var q;(function(Ae){function Oe(J,Fe,xe){const Je={edits:[]};if(J instanceof a.WorkspaceEdit){const et=new A.ResourceSet;for(const Ze of J._allEntries())Ze._type===1&&L.URI.isUri(Ze.to)&&Ze.from===void 0&&et.add(Ze.to);for(const Ze of J._allEntries())if(Ze._type===1)Je.edits.push({_type:1,oldUri:Ze.from,newUri:Ze.to,options:Ze.options,metadata:Ze.metadata});else if(Ze._type===2){const gt={_type:2,resource:Ze.uri,edit:z.from(Ze.edit),modelVersionId:et.has(Ze.uri)?void 0:Fe?.getTextDocumentVersion(Ze.uri),metadata:Ze.metadata};xe&&Ze.edit.newText2 instanceof a.SnippetString&&(gt.edit.insertAsSnippet=!0,gt.edit.text=Ze.edit.newText2.value),Je.edits.push(gt)}else Ze._type===3?Je.edits.push({_type:3,metadata:Ze.metadata,resource:Ze.uri,edit:Ze.edit,notebookMetadata:Ze.notebookMetadata,notebookVersionId:Fe?.getNotebookDocumentVersion(Ze.uri)}):Ze._type===5&&Je.edits.push({_type:3,metadata:Ze.metadata,resource:Ze.uri,notebookVersionId:Fe?.getNotebookDocumentVersion(Ze.uri),edit:{editType:1,index:Ze.index,count:Ze.count,cells:Ze.cells.map(ot.from)}})}return Je}Ae.from=Oe;function Ee(J){const Fe=new a.WorkspaceEdit;for(const xe of J.edits)xe.edit?Fe.replace(L.URI.revive(xe.resource),d.to(xe.edit.range),xe.edit.text):Fe.renameFile(L.URI.revive(xe.oldUri),L.URI.revive(xe.newUri),xe.options);return Fe}Ae.to=Ee})(q=e.WorkspaceEdit||(e.WorkspaceEdit={}));var V;(function(Ae){const Oe=Object.create(null);Oe[a.SymbolKind.File]=0,Oe[a.SymbolKind.Module]=1,Oe[a.SymbolKind.Namespace]=2,Oe[a.SymbolKind.Package]=3,Oe[a.SymbolKind.Class]=4,Oe[a.SymbolKind.Method]=5,Oe[a.SymbolKind.Property]=6,Oe[a.SymbolKind.Field]=7,Oe[a.SymbolKind.Constructor]=8,Oe[a.SymbolKind.Enum]=9,Oe[a.SymbolKind.Interface]=10,Oe[a.SymbolKind.Function]=11,Oe[a.SymbolKind.Variable]=12,Oe[a.SymbolKind.Constant]=13,Oe[a.SymbolKind.String]=14,Oe[a.SymbolKind.Number]=15,Oe[a.SymbolKind.Boolean]=16,Oe[a.SymbolKind.Array]=17,Oe[a.SymbolKind.Object]=18,Oe[a.SymbolKind.Key]=19,Oe[a.SymbolKind.Null]=20,Oe[a.SymbolKind.EnumMember]=21,Oe[a.SymbolKind.Struct]=22,Oe[a.SymbolKind.Event]=23,Oe[a.SymbolKind.Operator]=24,Oe[a.SymbolKind.TypeParameter]=25;function Ee(Fe){return typeof Oe[Fe]=="number"?Oe[Fe]:6}Ae.from=Ee;function J(Fe){for(const xe in Oe)if(Oe[xe]===Fe)return Number(xe);return a.SymbolKind.Property}Ae.to=J})(V=e.SymbolKind||(e.SymbolKind={}));var j;(function(Ae){function Oe(J){switch(J){case a.SymbolTag.Deprecated:return 1}}Ae.from=Oe;function Ee(J){switch(J){case 1:return a.SymbolTag.Deprecated}}Ae.to=Ee})(j=e.SymbolTag||(e.SymbolTag={}));var ne;(function(Ae){function Oe(J){return{name:J.name,kind:V.from(J.kind),tags:J.tags&&J.tags.map(j.from),containerName:J.containerName,location:ge.from(J.location)}}Ae.from=Oe;function Ee(J){const Fe=new a.SymbolInformation(J.name,V.to(J.kind),J.containerName,ge.to(J.location));return Fe.tags=J.tags&&J.tags.map(j.to),Fe}Ae.to=Ee})(ne=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var Y;(function(Ae){function Oe(J){const Fe={name:J.name||"!!MISSING: name!!",detail:J.detail,range:d.from(J.range),selectionRange:d.from(J.selectionRange),kind:V.from(J.kind),tags:J.tags?.map(j.from)??[]};return J.children&&(Fe.children=J.children.map(Oe)),Fe}Ae.from=Oe;function Ee(J){const Fe=new a.DocumentSymbol(J.name,J.detail,V.to(J.kind),d.to(J.range),d.to(J.selectionRange));return(0,u.isNonEmptyArray)(J.tags)&&(Fe.tags=J.tags.map(j.to)),J.children&&(Fe.children=J.children.map(Ee)),Fe}Ae.to=Ee})(Y=e.DocumentSymbol||(e.DocumentSymbol={}));var le;(function(Ae){function Oe(J){const Fe=new a.CallHierarchyItem(V.to(J.kind),J.name,J.detail||"",L.URI.revive(J.uri),d.to(J.range),d.to(J.selectionRange));return Fe._sessionId=J._sessionId,Fe._itemId=J._itemId,Fe}Ae.to=Oe;function Ee(J,Fe,xe){if(Fe=Fe??J._sessionId,xe=xe??J._itemId,Fe===void 0||xe===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:xe,name:J.name,detail:J.detail,kind:V.from(J.kind),uri:J.uri,range:d.from(J.range),selectionRange:d.from(J.selectionRange),tags:J.tags?.map(j.from)}}Ae.from=Ee})(le=e.CallHierarchyItem||(e.CallHierarchyItem={}));var ue;(function(Ae){function Oe(Ee){return new a.CallHierarchyIncomingCall(le.to(Ee.from),Ee.fromRanges.map(J=>d.to(J)))}Ae.to=Oe})(ue=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var K;(function(Ae){function Oe(Ee){return new a.CallHierarchyOutgoingCall(le.to(Ee.to),Ee.fromRanges.map(J=>d.to(J)))}Ae.to=Oe})(K=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var ge;(function(Ae){function Oe(J){return{range:J.range&&d.from(J.range),uri:J.uri}}Ae.from=Oe;function Ee(J){return new a.Location(L.URI.revive(J.uri),d.to(J.range))}Ae.to=Ee})(ge=e.location||(e.location={}));var ye;(function(Ae){function Oe(J){const Fe=J,xe=J;return{originSelectionRange:Fe.originSelectionRange?d.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:xe.uri,range:d.from(Fe.targetRange?Fe.targetRange:xe.range),targetSelectionRange:Fe.targetSelectionRange?d.from(Fe.targetSelectionRange):void 0}}Ae.from=Oe;function Ee(J){return{targetUri:L.URI.revive(J.uri),targetRange:d.to(J.range),targetSelectionRange:J.targetSelectionRange?d.to(J.targetSelectionRange):void 0,originSelectionRange:J.originSelectionRange?d.to(J.originSelectionRange):void 0}}Ae.to=Ee})(ye=e.DefinitionLink||(e.DefinitionLink={}));var Te;(function(Ae){function Oe(J){return{range:d.from(J.range),contents:O.fromMany(J.contents)}}Ae.from=Oe;function Ee(J){return new a.Hover(J.contents.map(O.to),d.to(J.range))}Ae.to=Ee})(Te=e.Hover||(e.Hover={}));var pe;(function(Ae){function Oe(J){return{range:d.from(J.range),expression:J.expression}}Ae.from=Oe;function Ee(J){return new a.EvaluatableExpression(d.to(J.range),J.expression)}Ae.to=Ee})(pe=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Pe;(function(Ae){function Oe(J){if(J instanceof a.InlineValueText)return{type:"text",range:d.from(J.range),text:J.text};if(J instanceof a.InlineValueVariableLookup)return{type:"variable",range:d.from(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};if(J instanceof a.InlineValueEvaluatableExpression)return{type:"expression",range:d.from(J.range),expression:J.expression};throw new Error("Unknown 'InlineValue' type")}Ae.from=Oe;function Ee(J){switch(J.type){case"text":return{range:d.to(J.range),text:J.text};case"variable":return{range:d.to(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};case"expression":return{range:d.to(J.range),expression:J.expression}}}Ae.to=Ee})(Pe=e.InlineValue||(e.InlineValue={}));var fe;(function(Ae){function Oe(J){return{frameId:J.frameId,stoppedLocation:d.from(J.stoppedLocation)}}Ae.from=Oe;function Ee(J){return new a.InlineValueContext(J.frameId,d.to(J.stoppedLocation))}Ae.to=Ee})(fe=e.InlineValueContext||(e.InlineValueContext={}));var ve;(function(Ae){function Oe(J){return{range:d.from(J.range),kind:J.kind}}Ae.from=Oe;function Ee(J){return new a.DocumentHighlight(d.to(J.range),J.kind)}Ae.to=Ee})(ve=e.DocumentHighlight||(e.DocumentHighlight={}));var _e;(function(Ae){function Oe(Ee){switch(Ee){case 1:return a.CompletionTriggerKind.TriggerCharacter;case 2:return a.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return a.CompletionTriggerKind.Invoke}}Ae.to=Oe})(_e=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ae;(function(Ae){function Oe(Ee){return{triggerKind:_e.to(Ee.triggerKind),triggerCharacter:Ee.triggerCharacter}}Ae.to=Oe})(ae=e.CompletionContext||(e.CompletionContext={}));var he;(function(Ae){function Oe(J){switch(J){case a.CompletionItemTag.Deprecated:return 1}}Ae.from=Oe;function Ee(J){switch(J){case 1:return a.CompletionItemTag.Deprecated}}Ae.to=Ee})(he=e.CompletionItemTag||(e.CompletionItemTag={}));var te;(function(Ae){const Oe=new Map([[a.CompletionItemKind.Method,0],[a.CompletionItemKind.Function,1],[a.CompletionItemKind.Constructor,2],[a.CompletionItemKind.Field,3],[a.CompletionItemKind.Variable,4],[a.CompletionItemKind.Class,5],[a.CompletionItemKind.Interface,7],[a.CompletionItemKind.Struct,6],[a.CompletionItemKind.Module,8],[a.CompletionItemKind.Property,9],[a.CompletionItemKind.Unit,12],[a.CompletionItemKind.Value,13],[a.CompletionItemKind.Constant,14],[a.CompletionItemKind.Enum,15],[a.CompletionItemKind.EnumMember,16],[a.CompletionItemKind.Keyword,17],[a.CompletionItemKind.Snippet,27],[a.CompletionItemKind.Text,18],[a.CompletionItemKind.Color,19],[a.CompletionItemKind.File,20],[a.CompletionItemKind.Reference,21],[a.CompletionItemKind.Folder,23],[a.CompletionItemKind.Event,10],[a.CompletionItemKind.Operator,11],[a.CompletionItemKind.TypeParameter,24],[a.CompletionItemKind.Issue,26],[a.CompletionItemKind.User,25]]);function Ee(xe){return Oe.get(xe)??9}Ae.from=Ee;const J=new Map([[0,a.CompletionItemKind.Method],[1,a.CompletionItemKind.Function],[2,a.CompletionItemKind.Constructor],[3,a.CompletionItemKind.Field],[4,a.CompletionItemKind.Variable],[5,a.CompletionItemKind.Class],[7,a.CompletionItemKind.Interface],[6,a.CompletionItemKind.Struct],[8,a.CompletionItemKind.Module],[9,a.CompletionItemKind.Property],[12,a.CompletionItemKind.Unit],[13,a.CompletionItemKind.Value],[14,a.CompletionItemKind.Constant],[15,a.CompletionItemKind.Enum],[16,a.CompletionItemKind.EnumMember],[17,a.CompletionItemKind.Keyword],[27,a.CompletionItemKind.Snippet],[18,a.CompletionItemKind.Text],[19,a.CompletionItemKind.Color],[20,a.CompletionItemKind.File],[21,a.CompletionItemKind.Reference],[23,a.CompletionItemKind.Folder],[10,a.CompletionItemKind.Event],[11,a.CompletionItemKind.Operator],[24,a.CompletionItemKind.TypeParameter],[25,a.CompletionItemKind.User],[26,a.CompletionItemKind.Issue]]);function Fe(xe){return J.get(xe)??a.CompletionItemKind.Property}Ae.to=Fe})(te=e.CompletionItemKind||(e.CompletionItemKind={}));var ie;(function(Ae){function Oe(Ee,J){const Fe=new a.CompletionItem(Ee.label);return Fe.insertText=Ee.insertText,Fe.kind=te.to(Ee.kind),Fe.tags=Ee.tags?.map(he.to),Fe.detail=Ee.detail,Fe.documentation=y.isMarkdownString(Ee.documentation)?O.to(Ee.documentation):Ee.documentation,Fe.sortText=Ee.sortText,Fe.filterText=Ee.filterText,Fe.preselect=Ee.preselect,Fe.commitCharacters=Ee.commitCharacters,I.Range.isIRange(Ee.range)?Fe.range=d.to(Ee.range):typeof Ee.range=="object"&&(Fe.range={inserting:d.to(Ee.range.insert),replacing:d.to(Ee.range.replace)}),Fe.keepWhitespace=typeof Ee.insertTextRules=="undefined"?!1:Boolean(Ee.insertTextRules&1),typeof Ee.insertTextRules!="undefined"&&Ee.insertTextRules&4?Fe.insertText=new a.SnippetString(Ee.insertText):(Fe.insertText=Ee.insertText,Fe.textEdit=Fe.range instanceof a.Range?new a.TextEdit(Fe.range,Fe.insertText):void 0),Ee.additionalTextEdits&&Ee.additionalTextEdits.length>0&&(Fe.additionalTextEdits=Ee.additionalTextEdits.map(xe=>z.to(xe))),Fe.command=J&&Ee.command?J.fromInternal(Ee.command):void 0,Fe}Ae.to=Oe})(ie=e.CompletionItem||(e.CompletionItem={}));var M;(function(Ae){function Oe(J){return{label:J.label,documentation:O.fromStrict(J.documentation)}}Ae.from=Oe;function Ee(J){return{label:J.label,documentation:y.isMarkdownString(J.documentation)?O.to(J.documentation):J.documentation}}Ae.to=Ee})(M=e.ParameterInformation||(e.ParameterInformation={}));var H;(function(Ae){function Oe(J){return{label:J.label,documentation:O.fromStrict(J.documentation),parameters:Array.isArray(J.parameters)?J.parameters.map(M.from):[],activeParameter:J.activeParameter}}Ae.from=Oe;function Ee(J){return{label:J.label,documentation:y.isMarkdownString(J.documentation)?O.to(J.documentation):J.documentation,parameters:Array.isArray(J.parameters)?J.parameters.map(M.to):[],activeParameter:J.activeParameter}}Ae.to=Ee})(H=e.SignatureInformation||(e.SignatureInformation={}));var G;(function(Ae){function Oe(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(H.from):[]}}Ae.from=Oe;function Ee(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(H.to):[]}}Ae.to=Ee})(G=e.SignatureHelp||(e.SignatureHelp={}));var X;(function(Ae){function Oe(Ee,J){const Fe=new a.InlayHint(s.to(J.position),typeof J.label=="string"?J.label:J.label.map(de.to.bind(void 0,Ee)),J.kind&&be.to(J.kind));return Fe.textEdits=J.textEdits&&J.textEdits.map(z.to),Fe.tooltip=y.isMarkdownString(J.tooltip)?O.to(J.tooltip):J.tooltip,Fe.paddingLeft=J.paddingLeft,Fe.paddingRight=J.paddingRight,Fe}Ae.to=Oe})(X=e.InlayHint||(e.InlayHint={}));var de;(function(Ae){function Oe(Ee,J){const Fe=new a.InlayHintLabelPart(J.label);return Fe.tooltip=y.isMarkdownString(J.tooltip)?O.to(J.tooltip):J.tooltip,_.Command.is(J.command)&&(Fe.command=Ee.fromInternal(J.command)),J.location&&(Fe.location=ge.to(J.location)),Fe}Ae.to=Oe})(de=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var be;(function(Ae){function Oe(J){return J}Ae.from=Oe;function Ee(J){return J}Ae.to=Ee})(be=e.InlayHintKind||(e.InlayHintKind={}));var se;(function(Ae){function Oe(J){return{range:d.from(J.range),url:J.target,tooltip:J.tooltip}}Ae.from=Oe;function Ee(J){let Fe;if(J.url)try{Fe=typeof J.url=="string"?L.URI.parse(J.url,!0):L.URI.revive(J.url)}catch{}return new a.DocumentLink(d.to(J.range),Fe)}Ae.to=Ee})(se=e.DocumentLink||(e.DocumentLink={}));var De;(function(Ae){function Oe(J){const Fe=new a.ColorPresentation(J.label);return J.textEdit&&(Fe.textEdit=z.to(J.textEdit)),J.additionalTextEdits&&(Fe.additionalTextEdits=J.additionalTextEdits.map(xe=>z.to(xe))),Fe}Ae.to=Oe;function Ee(J){return{label:J.label,textEdit:J.textEdit?z.from(J.textEdit):void 0,additionalTextEdits:J.additionalTextEdits?J.additionalTextEdits.map(Fe=>z.from(Fe)):void 0}}Ae.from=Ee})(De=e.ColorPresentation||(e.ColorPresentation={}));var Ce;(function(Ae){function Oe(J){return new a.Color(J[0],J[1],J[2],J[3])}Ae.to=Oe;function Ee(J){return[J.red,J.green,J.blue,J.alpha]}Ae.from=Ee})(Ce=e.Color||(e.Color={}));var ze;(function(Ae){function Oe(J){return{range:d.from(J.range)}}Ae.from=Oe;function Ee(J){return new a.SelectionRange(d.to(J.range))}Ae.to=Ee})(ze=e.SelectionRange||(e.SelectionRange={}));var Ke;(function(Ae){function Oe(Ee){switch(Ee){case 2:return a.TextDocumentSaveReason.AfterDelay;case 1:return a.TextDocumentSaveReason.Manual;case 3:case 4:return a.TextDocumentSaveReason.FocusOut}}Ae.to=Oe})(Ke=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ne;(function(Ae){function Oe(J){switch(J){case a.TextEditorLineNumbersStyle.Off:return 0;case a.TextEditorLineNumbersStyle.Relative:return 2;case a.TextEditorLineNumbersStyle.On:default:return 1}}Ae.from=Oe;function Ee(J){switch(J){case 0:return a.TextEditorLineNumbersStyle.Off;case 2:return a.TextEditorLineNumbersStyle.Relative;case 1:default:return a.TextEditorLineNumbersStyle.On}}Ae.to=Ee})(Ne=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ye;(function(Ae){function Oe(J){if(J===a.EndOfLine.CRLF)return 1;if(J===a.EndOfLine.LF)return 0}Ae.from=Oe;function Ee(J){if(J===1)return a.EndOfLine.CRLF;if(J===0)return a.EndOfLine.LF}Ae.to=Ee})(Ye=e.EndOfLine||(e.EndOfLine={}));var Z;(function(Ae){function Oe(Ee){if(typeof Ee=="object")return Ee.viewId;switch(Ee){case a.ProgressLocation.SourceControl:return 3;case a.ProgressLocation.Window:return 10;case a.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ae.from=Oe})(Z=e.ProgressLocation||(e.ProgressLocation={}));var re;(function(Ae){function Oe(Ee){const J={start:Ee.start+1,end:Ee.end+1};return Ee.kind&&(J.kind=Se.from(Ee.kind)),J}Ae.from=Oe})(re=e.FoldingRange||(e.FoldingRange={}));var Se;(function(Ae){function Oe(Ee){if(Ee)switch(Ee){case a.FoldingRangeKind.Comment:return _.FoldingRangeKind.Comment;case a.FoldingRangeKind.Imports:return _.FoldingRangeKind.Imports;case a.FoldingRangeKind.Region:return _.FoldingRangeKind.Region}}Ae.from=Oe})(Se=e.FoldingRangeKind||(e.FoldingRangeKind={}));var We;(function(Ae){function Oe(Ee){if(Ee)return{pinned:typeof Ee.preview=="boolean"?!Ee.preview:void 0,inactive:Ee.background,preserveFocus:Ee.preserveFocus,selection:typeof Ee.selection=="object"?d.from(Ee.selection):void 0,override:typeof Ee.override=="boolean"?T.EditorResolution.DISABLED:void 0}}Ae.from=Oe})(We=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var oe;(function(Ae){function Oe(xe){return xe instanceof a.RelativePattern?xe.toJSON():typeof xe=="string"?xe:Ee(xe)||J(xe)?new a.RelativePattern(xe.baseUri??xe.base,xe.pattern).toJSON():xe}Ae.from=Oe;function Ee(xe){const Je=xe;return Je?L.URI.isUri(Je.baseUri)&&typeof Je.pattern=="string":!1}function J(xe){const Je=xe;return Je?typeof Je.base=="string"&&typeof Je.pattern=="string":!1}function Fe(xe){return typeof xe=="string"?xe:new a.RelativePattern(L.URI.revive(xe.baseUri),xe.pattern)}Ae.to=Fe})(oe=e.GlobPattern||(e.GlobPattern={}));var Re;(function(Ae){function Oe(Ee){if(Ee){if(Array.isArray(Ee))return Ee.map(Oe);if(typeof Ee=="string")return Ee;{const J=Ee;return{language:J.language,scheme:J.scheme,pattern:oe.from(J.pattern),exclusive:J.exclusive,notebookType:J.notebookType}}}else return}Ae.from=Oe})(Re=e.LanguageSelector||(e.LanguageSelector={}));var Be;(function(Ae){function Oe(J){return{start:J.start,end:J.end}}Ae.from=Oe;function Ee(J){return new a.NotebookRange(J.start,J.end)}Ae.to=Ee})(Be=e.NotebookRange||(e.NotebookRange={}));var qe;(function(Ae){function Oe(J){return{timing:typeof J.runStartTime=="number"&&typeof J.runEndTime=="number"?{startTime:J.runStartTime,endTime:J.runEndTime}:void 0,executionOrder:J.executionOrder,success:J.lastRunSuccess}}Ae.to=Oe;function Ee(J){return{lastRunSuccess:J.success,runStartTime:J.timing?.startTime,runEndTime:J.timing?.endTime,executionOrder:J.executionOrder}}Ae.from=Ee})(qe=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var je;(function(Ae){function Oe(Ee){if(Ee===p.NotebookCellExecutionState.Executing)return a.NotebookCellExecutionState.Executing;if(Ee===p.NotebookCellExecutionState.Pending)return a.NotebookCellExecutionState.Pending;if(Ee===p.NotebookCellExecutionState.Unconfirmed)return a.NotebookCellExecutionState.Pending;throw new Error(`Unknown state: ${Ee}`)}Ae.to=Oe})(je=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ve;(function(Ae){function Oe(J){switch(J){case a.NotebookCellKind.Markup:return p.CellKind.Markup;case a.NotebookCellKind.Code:default:return p.CellKind.Code}}Ae.from=Oe;function Ee(J){switch(J){case p.CellKind.Markup:return a.NotebookCellKind.Markup;case p.CellKind.Code:default:return a.NotebookCellKind.Code}}Ae.to=Ee})(Ve=e.NotebookCellKind||(e.NotebookCellKind={}));var nt;(function(Ae){function Oe(J){const Fe={metadata:J.metadata??Object.create(null),cells:[]};for(const xe of J.cells)a.NotebookCellData.validate(xe),Fe.cells.push(ot.from(xe));return Fe}Ae.from=Oe;function Ee(J){const Fe=new a.NotebookData(J.cells.map(ot.to));return(0,P.isEmptyObject)(J.metadata)||(Fe.metadata=J.metadata),Fe}Ae.to=Ee})(nt=e.NotebookData||(e.NotebookData={}));var ot;(function(Ae){function Oe(J){return{cellKind:Ve.from(J.kind),language:J.languageId,mime:J.mime,source:J.value,metadata:J.metadata,internalMetadata:qe.from(J.executionSummary??{}),outputs:J.outputs?J.outputs.map(it.from):[]}}Ae.from=Oe;function Ee(J){return new a.NotebookCellData(Ve.to(J.cellKind),J.source,J.language,J.mime,J.outputs?J.outputs.map(it.to):void 0,J.metadata,J.internalMetadata?qe.to(J.internalMetadata):void 0)}Ae.to=Ee})(ot=e.NotebookCellData||(e.NotebookCellData={}));var st;(function(Ae){function Oe(J){return{mime:J.mime,valueBytes:n.VSBuffer.wrap(J.data)}}Ae.from=Oe;function Ee(J){return new a.NotebookCellOutputItem(J.valueBytes.buffer,J.mime)}Ae.to=Ee})(st=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var it;(function(Ae){function Oe(J){return{outputId:J.id,items:J.items.map(st.from),metadata:J.metadata}}Ae.from=Oe;function Ee(J){const Fe=J.items.map(st.to);return new a.NotebookCellOutput(Fe,J.outputId,J.metadata)}Ae.to=Ee})(it=e.NotebookCellOutput||(e.NotebookCellOutput={}));var at;(function(Ae){function Oe(Fe){return J(Fe)?{include:(0,P.withNullAsUndefined)(oe.from(Fe.include)),exclude:(0,P.withNullAsUndefined)(oe.from(Fe.exclude))}:(0,P.withNullAsUndefined)(oe.from(Fe))}Ae.from=Oe;function Ee(Fe){return J(Fe)?{include:oe.to(Fe.include),exclude:oe.to(Fe.exclude)}:oe.to(Fe)}Ae.to=Ee;function J(Fe){const xe=Fe;return xe?!(0,P.isUndefinedOrNull)(xe.include)&&!(0,P.isUndefinedOrNull)(xe.exclude):!1}})(at=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var wt;(function(Ae){function Oe(Ee,J,Fe){const xe=typeof Ee.command=="string"?{title:"",command:Ee.command}:Ee.command;return{alignment:Ee.alignment===a.NotebookCellStatusBarAlignment.Left?1:2,command:J.toInternal(xe,Fe),text:Ee.text,tooltip:Ee.tooltip,accessibilityInformation:Ee.accessibilityInformation,priority:Ee.priority}}Ae.from=Oe})(wt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Tt;(function(Ae){function Oe(Ee){return{transientOutputs:Ee?.transientOutputs??!1,transientCellMetadata:Ee?.transientCellMetadata??{},transientDocumentMetadata:Ee?.transientDocumentMetadata??{}}}Ae.from=Oe})(Tt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var _t;(function(Ae){function Oe(J){return{uri:J.uri,provides:J.provides}}Ae.from=Oe;function Ee(J){return new a.NotebookRendererScript(L.URI.revive(J.uri),J.provides)}Ae.to=Ee})(_t=e.NotebookRendererScript||(e.NotebookRendererScript={}));var ft;(function(Ae){function Oe(J){return{message:O.fromStrict(J.message)||"",type:0,expected:J.expectedOutput,actual:J.actualOutput,location:J.location&&{range:d.from(J.location.range),uri:J.location.uri}}}Ae.from=Oe;function Ee(J){const Fe=new a.TestMessage(typeof J.message=="string"?J.message:O.to(J.message));return Fe.actualOutput=J.actual,Fe.expectedOutput=J.expected,Fe.location=J.location?ge.to(J.location):void 0,Fe}Ae.to=Ee})(ft=e.TestMessage||(e.TestMessage={}));var It;(function(Ae){Ae.namespace=v.namespaceTestTag,Ae.denamespace=v.denamespaceTestTag})(It=e.TestTag||(e.TestTag={}));var Ft;(function(Ae){function Oe(J){const Fe=(0,b.getPrivateApiFor)(J).controllerId;return{extId:g.TestId.fromExtHostTestItem(J,Fe).toString(),label:J.label,uri:L.URI.revive(J.uri),busy:!1,tags:J.tags.map(xe=>It.namespace(Fe,xe.id)),range:I.Range.lift(d.from(J.range)),description:J.description||null,sortText:J.sortText||null,error:J.error&&O.fromStrict(J.error)||null}}Ae.from=Oe;function Ee(J){return{parent:void 0,error:void 0,id:g.TestId.fromString(J.extId).localId,label:J.label,uri:L.URI.revive(J.uri),tags:(J.tags||[]).map(Fe=>{const{tagId:xe}=It.denamespace(Fe);return new a.TestTag(xe)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:d.to(J.range||void 0),canResolveChildren:!1,busy:!1,description:J.description||void 0,sortText:J.sortText||void 0}}Ae.toPlain=Ee})(Ft=e.TestItem||(e.TestItem={})),function(Ae){function Oe(J){return{id:J.id}}Ae.from=Oe;function Ee(J){return new a.TestTag(J.id)}Ae.to=Ee}(It=e.TestTag||(e.TestTag={}));var At;(function(Ae){const Oe=(J,Fe)=>{const xe={...Ft.toPlain(J.item),parent:void 0,taskStates:J.tasks.map(Je=>({state:Je.state,duration:Je.duration,messages:Je.messages.filter(et=>et.type===0).map(ft.to)})),children:J.children.map(Je=>Fe.get(Je)).filter(P.isDefined).map(Je=>Oe(Je,Fe))};for(const Je of xe.children)Je.parent=xe;return xe};function Ee(J){const Fe=[],xe=new Map;for(const Je of J.items)xe.set(Je.item.extId,Je),J.request.targets.some(et=>et.controllerId===Je.controllerId&&et.testIds.includes(Je.item.extId))&&Fe.push(Je);return{completedAt:J.completedAt,results:Fe.map(Je=>Oe(Je,xe))}}Ae.to=Ee})(At=e.TestResults||(e.TestResults={}));var Xe;(function(Ae){function Oe(xe){return{covered:xe.covered,total:xe.covered}}function Ee(xe){return"line"in xe?s.from(xe):d.from(xe)}function J(xe){return"branches"in xe?{count:xe.executionCount,location:Ee(xe.location),type:1,branches:xe.branches.length?xe.branches.map(Je=>({count:Je.executionCount,location:Je.location&&Ee(Je.location)})):void 0}:{type:0,count:xe.executionCount,location:Ee(xe.location)}}Ae.fromDetailed=J;function Fe(xe){return{uri:xe.uri,statement:Oe(xe.statementCoverage),branch:xe.branchCoverage&&Oe(xe.branchCoverage),function:xe.functionCoverage&&Oe(xe.functionCoverage),details:xe.detailedCoverage?.map(J)}}Ae.fromFile=Fe})(Xe=e.TestCoverage||(e.TestCoverage={}));var Rt;(function(Ae){function Oe(Ee){switch(Ee){case 1:return a.CodeActionTriggerKind.Invoke;case 2:return a.CodeActionTriggerKind.Automatic}}Ae.to=Oe})(Rt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Mt;(function(Ae){function Oe(J){const Fe=new a.TypeHierarchyItem(V.to(J.kind),J.name,J.detail||"",L.URI.revive(J.uri),d.to(J.range),d.to(J.selectionRange));return Fe._sessionId=J._sessionId,Fe._itemId=J._itemId,Fe}Ae.to=Oe;function Ee(J,Fe,xe){if(Fe=Fe??J._sessionId,xe=xe??J._itemId,Fe===void 0||xe===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:xe,kind:V.from(J.kind),name:J.name,detail:J.detail??"",uri:J.uri,range:d.from(J.range),selectionRange:d.from(J.selectionRange),tags:J.tags?.map(j.from)}}Ae.from=Ee})(Mt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Ot;(function(Ae){function Oe(Ee){if(!!Ee)return{value:Ee.value,tooltip:Ee.tooltip}}Ae.from=Oe})(Ot=e.ViewBadge||(e.ViewBadge={}));var mt;(function(Ae){function Oe(Ee,J){const Fe=Ee.fileData;return Fe?new class extends a.DataTransferItem{asFile(){return{name:Fe.name,uri:L.URI.revive(Fe.uri),data:(0,m.once)(()=>J())}}}(""):new a.DataTransferItem(Ee.asString)}Ae.toDataTransferItem=Oe})(mt=e.DataTransferItem||(e.DataTransferItem={}));var Dt;(function(Ae){function Oe(J,Fe){const xe=J.items.map(([Je,et],Ze)=>[Je,mt.toDataTransferItem(et,()=>Fe(Ze))]);return new a.DataTransfer(xe)}Ae.toDataTransfer=Oe;async function Ee(J){const Fe={items:[]},xe=[];return J.forEach((Je,et)=>{xe.push((async()=>{const Ze=await Je.asString(),gt=Je.asFile();Fe.items.push([et,{asString:Ze,fileData:gt?{name:gt.name,uri:gt.uri}:void 0}])})())}),await Promise.all(xe),Fe}Ae.toDataTransferDTO=Ee})(Dt=e.DataTransfer||(e.DataTransfer={}))}),define(Ie[222],ke([1,0,2,12,7,15,80]),function(Q,e,u,n,y,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class C{constructor(P,L,I,_={timeout:1500,errors:3}){this._logService=P,this._documents=L,this._mainThreadBulkEdits=I,this._thresholds=_,this._callbacks=new D.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(P){return(L,I,_)=>{const w={dispose:this._callbacks.push([L,I,P])};return Array.isArray(_)&&_.push(w),w}}async $participateInSave(P,L){const I=u.URI.revive(P);let _=!1;const T=setTimeout(()=>_=!0,this._thresholds.timeout),w=[];try{for(const b of[...this._callbacks]){if(_)break;const p=this._documents.getDocument(I),g=await this._deliverEventAsyncAndBlameBadListeners(b,{document:p,reason:A.TextDocumentSaveReason.to(L)});w.push(g)}}finally{clearTimeout(T)}return w}_deliverEventAsyncAndBlameBadListeners([P,L,I],_){const T=this._badListeners.get(P);return typeof T=="number"&&T>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(I,P,L,_).then(()=>!0,w=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this._logService.error(w),!(w instanceof Error)||w.message!=="concurrent_edits"){const b=this._badListeners.get(P);this._badListeners.set(P,b?b+1:1),typeof b=="number"&&b>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(P,L,I,_){const T=[],w=Date.now(),{document:b,reason:p}=_,{version:g}=b,v=Object.freeze({document:b,reason:p,waitUntil(f){if(Object.isFrozen(T))throw(0,n.illegalState)("waitUntil can not be called async");T.push(Promise.resolve(f))}});try{L.apply(I,[v])}catch(f){return Promise.reject(f)}return Object.freeze(T),new Promise((f,a)=>{const m=setTimeout(()=>a(new Error("timeout")),this._thresholds.timeout);return Promise.all(T).then(o=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' finished after ${Date.now()-w}ms`),clearTimeout(m),f(o)}).catch(o=>{clearTimeout(m),a(o)})}).then(f=>{const a={edits:[]};for(const m of f)if(Array.isArray(m)&&m.every(o=>o instanceof y.TextEdit))for(const{newText:o,newEol:d,range:r}of m)a.edits.push({_type:2,resource:b.uri,edit:{range:r&&A.Range.from(r),text:o,eol:d&&A.EndOfLine.from(d)}});if(a.edits.length!==0)return g===b.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(a):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=C}),define(Ie[223],ke([1,0,11,2,15,7,128]),function(Q,e,u,n,y,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class C{constructor(I,_,T,w){this.start=I,this.deletedCount=_,this.deletedItems=T,this.items=w}asApiEvent(){return{range:new A.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(I=>I.apiCell),removedCells:this.deletedItems}}}class S{constructor(I,_,T){this.notebook=I,this._extHostDocument=_,this._cellData=T,this.handle=T.handle,this.uri=n.URI.revive(T.uri),this.cellKind=T.cellKind,this._outputs=T.outputs.map(y.NotebookCellOutput.to),this._internalMetadata=T.internalMetadata??{},this._metadata=Object.freeze(T.metadata??{}),this._previousResult=Object.freeze(y.NotebookCellExecutionSummary.to(T.internalMetadata??{}))}static asModelAddData(I,_){return{EOL:_.eol,lines:_.source,languageId:_.language,uri:_.uri,isDirty:!1,versionId:1,notebook:I}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const I=this,_=this._extHostDocument.getDocument(this.uri);if(!_)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const T={get index(){return I.notebook.getCellIndex(I)},notebook:I.notebook.apiNotebook,kind:y.NotebookCellKind.to(this._cellData.cellKind),document:_.document,get mime(){return I._mime},set mime(w){I._mime=w},get outputs(){return I._outputs.slice(0)},get metadata(){return I._metadata},get executionSummary(){return I._previousResult}};this._apiCell=Object.freeze(T)}return this._apiCell}setOutputs(I){this._outputs=I.map(y.NotebookCellOutput.to)}setOutputItems(I,_,T){const w=T.map(y.NotebookCellOutputItem.to),b=this._outputs.find(p=>p.id===I);b&&(_||(b.items.length=0),b.items.push(...w))}setMetadata(I){this._metadata=Object.freeze(I)}setInternalMetadata(I){this._internalMetadata=I,this._previousResult=Object.freeze(y.NotebookCellExecutionSummary.to(I))}setMime(I){}}e.ExtHostCell=S;class P{constructor(I,_,T,w,b){this._proxy=I,this._textDocumentsAndEditors=_,this._textDocuments=T,this.uri=w,this.handle=P._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=b.viewType,this._metadata=Object.freeze(b.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,b.cells]],!0,void 0),this._versionId=b.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const I=this,_={get uri(){return I.uri},get version(){return I._versionId},get notebookType(){return I._notebookType},get isDirty(){return I._isDirty},get isUntitled(){return I.uri.scheme===u.Schemas.untitled},get isClosed(){return I._disposed},get metadata(){return I._metadata},get cellCount(){return I._cells.length},cellAt(T){return T=I._validateIndex(T),I._cells[T].apiCell},getCells(T){return(T?I._getCells(T):I._cells).map(b=>b.apiCell)},save(){return I._save()}};this._notebook=Object.freeze(_)}return this._notebook}updateBackup(I){this._backup?.delete(),this._backup=I}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(I){I.metadata&&(this._metadata=Object.freeze({...this._metadata,...I.metadata}))}acceptDirty(I){this._isDirty=I}acceptModelChanged(I,_,T){this._versionId=I.versionId,this._isDirty=_,this.acceptDocumentPropertiesChanged({metadata:T});const w={notebook:this.apiNotebook,metadata:T,cellChanges:[],contentChanges:[]},b=[];for(const g of I.rawEvents)g.kind===D.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(g.changes,!1,w.contentChanges):g.kind===D.NotebookCellsChangeType.Move?this._moveCell(g.index,g.newIdx,w.contentChanges):g.kind===D.NotebookCellsChangeType.Output?(this._setCellOutputs(g.index,g.outputs),b.push({cell:this._cells[g.index].apiCell,outputs:this._cells[g.index].apiCell.outputs})):g.kind===D.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(g.index,g.outputId,g.append,g.outputItems),b.push({cell:this._cells[g.index].apiCell,outputs:this._cells[g.index].apiCell.outputs})):g.kind===D.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(g.index,g.language),b.push({cell:this._cells[g.index].apiCell,document:this._cells[g.index].apiCell.document})):g.kind===D.NotebookCellsChangeType.ChangeCellContent?b.push({cell:this._cells[g.index].apiCell,document:this._cells[g.index].apiCell.document}):g.kind===D.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(g.index,g.mime):g.kind===D.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(g.index,g.metadata),b.push({cell:this._cells[g.index].apiCell,metadata:this._cells[g.index].apiCell.metadata})):g.kind===D.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(g.index,g.internalMetadata),b.push({cell:this._cells[g.index].apiCell,executionSummary:this._cells[g.index].apiCell.executionSummary}));const p=new Map;for(let g=0;g<b.length;g++){const v=b[g],f=p.get(v.cell);if(f===void 0){const a=w.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...v});p.set(v.cell,a-1)}else w.cellChanges[f]={...w.cellChanges[f],...v}}return Object.freeze(w),Object.freeze(w.cellChanges),Object.freeze(w.contentChanges),w}_validateIndex(I){return I=I|0,I<0?0:I>=this._cells.length?this._cells.length-1:I}_validateRange(I){let _=I.start|0,T=I.end|0;return _<0&&(_=0),T>this._cells.length&&(T=this._cells.length),I.with({start:_,end:T})}_getCells(I){I=this._validateRange(I);const _=[];for(let T=I.start;T<I.end;T++)_.push(this._cells[T]);return _}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(I,_,T){if(this._disposed)return;const w=[],b=[],p=[];if(I.reverse().forEach(g=>{const f=g[2].map(o=>{const d=new S(this,this._textDocumentsAndEditors,o);return _||b.push(S.asModelAddData(this.apiNotebook,o)),d}),a=new C(g[0],g[1],[],f),m=this._cells.splice(g[0],g[1],...f);for(const o of m)p.push(o.uri),a.deletedItems.push(o.apiCell);w.push(a)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:b,removedDocuments:p}),T)for(const g of w)T.push(g.asApiEvent())}_moveCell(I,_,T){const w=this._cells.splice(I,1);this._cells.splice(_,0,...w);const b=[new C(I,1,w.map(p=>p.apiCell),[]),new C(_,0,[],w)];for(const p of b)T.push(p.asApiEvent())}_setCellOutputs(I,_){this._cells[I].setOutputs(_)}_setCellOutputItems(I,_,T,w){this._cells[I].setOutputItems(_,T,w)}_changeCellLanguage(I,_){const T=this._cells[I];T.apiCell.document.languageId!==_&&this._textDocuments.$acceptModelLanguageChanged(T.uri,_)}_changeCellMime(I,_){const T=this._cells[I];T.apiCell.mime=_}_changeCellMetadata(I,_){this._cells[I].setMetadata(_)}_changeCellInternalMetadata(I,_){this._cells[I].setInternalMetadata(_)}getCellFromApiCell(I){return this._cells.find(_=>_.apiCell===I)}getCellFromIndex(I){return this._cells[I]}getCell(I){return this._cells.find(_=>_.handle===I)}getCellIndex(I){return this._cells.indexOf(I)}}e.ExtHostNotebookDocument=P,P._handlePool=0}),define(Ie[131],ke([1,0,7,15,12]),function(Q,e,u,n,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class A{constructor(S){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=S}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(S){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:S})}replaceCellMetadata(S,P){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:S,metadata:P})}replaceCells(S,P,L){this._throwIfFinalized(),!(S===P&&L.length===0)&&this._collectedEdits.push({editType:1,index:S,count:P-S,cells:L.map(n.NotebookCellData.from)})}}class D{constructor(S,P,L,I,_,T){this.id=S,this._proxy=P,this.notebookData=L,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=_,this._visibleRanges=I,this._viewColumn=T}get apiEditor(){if(!this._editor){const S=this;this._editor={get document(){return S.notebookData.apiNotebook},get notebook(){return S.notebookData.apiNotebook},get selection(){return S._selections[0]},set selection(P){this.selections=[P]},get selections(){return S._selections},set selections(P){if(!Array.isArray(P)||!P.every(u.NotebookRange.isNotebookRange))throw(0,y.illegalArgument)("selections");S._selections=P,S._trySetSelections(P)},get visibleRanges(){return S._visibleRanges},revealRange(P,L){S._proxy.$tryRevealRange(S.id,n.NotebookRange.from(P),L??u.NotebookEditorRevealType.Default)},get viewColumn(){return S._viewColumn},edit(P){const L=new A(this.document.version);return P(L),S._applyEdit(L.finalize())}},D.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(S){this._visible=S}_acceptVisibleRanges(S){this._visibleRanges=S}_acceptSelections(S){this._selections=S}_trySetSelections(S){this._proxy.$trySetSelections(this.id,S.map(n.NotebookRange.from))}_acceptViewColumn(S){this._viewColumn=S}_applyEdit(S){if(S.cellEdits.length===0)return Promise.resolve(!0);const P=[];let L=-1;for(let I=0;I<S.cellEdits.length;I++){if(L<0){P.push(S.cellEdits[I]),L++;continue}const T=P[L],w=S.cellEdits[I];if(T.editType===1&&w.editType===1&&T.index===w.index){T.cells.push(...S.cellEdits[I].cells),T.count+=S.cellEdits[I].count;continue}P.push(S.cellEdits[I]),L++}return this._proxy.$tryApplyEdits(this.id,S.documentVersionId,P)}}e.ExtHostNotebookEditor=D,D.apiEditorsToExtHost=new WeakMap}),define(Ie[224],ke([1,0,3,14,15]),function(Q,e,u,n,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let A=class{constructor(C,S){this._logService=C,this._notebooksAndEditors=S,this._onDidChangeNotebookEditorSelection=new u.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new u.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(C,S){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",C,S);const P=this._notebooksAndEditors.getEditorById(C);S.visibleRanges&&P._acceptVisibleRanges(S.visibleRanges.ranges.map(y.NotebookRange.to)),S.selections&&P._acceptSelections(S.selections.selections.map(y.NotebookRange.to)),S.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:P.apiEditor,visibleRanges:P.apiEditor.visibleRanges}),S.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:P.apiEditor,selections:P.apiEditor.selections}))}$acceptEditorViewColumns(C){for(const S in C)this._notebooksAndEditors.getEditorById(S)._acceptViewColumn(y.ViewColumn.to(C[S]))}};A=Ge([$e(0,n.ILogService)],A),e.ExtHostNotebookEditors=A}),define(Ie[225],ke([1,0,15,118,173,21,57,12]),function(Q,e,u,n,y,A,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class S{constructor(_){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=_}async withProgress(_,T,w){const b=this._handles++,{title:p,location:g,cancellable:v}=T,f={label:(0,y.localize)(0,null,_.displayName||_.name),id:_.identifier.value};return this._proxy.$startProgress(b,{location:u.ProgressLocation.from(g),title:p,source:f,cancellable:v},_.isUnderDevelopment?void 0:_.identifier.value).catch(C.onUnexpectedExternalError),this._withProgress(b,w,!!v)}_withProgress(_,T,w){let b;w&&(b=new A.CancellationTokenSource,this._mapHandleToCancellationSource.set(_,b));const p=v=>{this._proxy.$progressEnd(v),this._mapHandleToCancellationSource.delete(v),b&&b.dispose()};let g;try{g=T(new L(this._proxy,_),w&&b?b.token:A.CancellationToken.None)}catch(v){throw p(_),v}return g.then(v=>p(_),v=>p(_)),g}$acceptProgressCanceled(_){const T=this._mapHandleToCancellationSource.get(_);T&&(T.cancel(),this._mapHandleToCancellationSource.delete(_))}}e.ExtHostProgress=S;function P(I,_){return I.message=_.message,typeof _.increment=="number"&&(typeof I.increment=="number"?I.increment+=_.increment:I.increment=_.increment),I}class L extends n.Progress{constructor(_,T){super(w=>this.throttledReport(w));this._proxy=_,this._handle=T}throttledReport(_){this._proxy.$progressReport(this._handle,_)}}Ge([(0,D.throttle)(100,(I,_)=>P(I,_),()=>Object.create(null))],L.prototype,"throttledReport",null)}),define(Ie[132],ke([1,0,35,129,66,89,67,15,2]),function(Q,e,u,n,y,A,D,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const P=(f,a,m,o)=>{let d=a;return{enumerable:!0,configurable:!1,get(){return d},set(r){if(!m(d,r)){const s=d;d=r,f.listener?.(o(r,s))}}}},L=(f,a)=>f===a,I={range:(f,a)=>f===a?!0:!f||!a?!1:f.isEqual(a),label:L,description:L,sortText:L,busy:L,error:L,canResolveChildren:L,tags:(f,a)=>!(f.length!==a.length||f.some(m=>!a.find(o=>m.id===o.id)))},_=f=>a=>({op:4,update:f(a)}),T=(f,a)=>({range:P(f,void 0,I.range,_(m=>({range:u.Range.lift(C.Range.from(m))}))),label:P(f,a,I.label,_(m=>({label:m}))),description:P(f,void 0,I.description,_(m=>({description:m}))),sortText:P(f,void 0,I.sortText,_(m=>({sortText:m}))),canResolveChildren:P(f,!1,I.canResolveChildren,m=>({op:2,state:m})),busy:P(f,!1,I.busy,_(m=>({busy:m}))),error:P(f,void 0,I.error,_(m=>({error:C.MarkdownString.fromStrict(m)||null}))),tags:P(f,[],I.tags,(m,o)=>({op:1,new:m.map(C.TestTag.from),old:o.map(C.TestTag.from)}))}),w=f=>{const a=y.TestId.fromString(f.extId),m=new p(a.controllerId,a.localId,f.label,S.URI.revive(f.uri)||void 0);return m.range=C.Range.to(f.range||void 0),m.description=f.description||void 0,m.sortText=f.sortText||void 0,m.tags=f.tags.map(o=>C.TestTag.to({id:(0,D.denamespaceTestTag)(o).tagId})),m},b=f=>{let a;for(const m of f.tests){const o=w(m.item);(0,n.getPrivateApiFor)(o).parent=a,a=o}return a};e.toItemFromContext=b;class p{constructor(a,m,o,d){if(m.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(m)} symbol`);const r=(0,n.createPrivateApiFor)(this,a);Object.defineProperties(this,{id:{value:m,enumerable:!0,writable:!1},uri:{value:d,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof g?void 0:r.parent}},children:{value:(0,A.createTestItemChildren)(r,n.getPrivateApiFor,p),enumerable:!0,writable:!1},...T(r,o)})}}e.TestItemImpl=p;class g extends p{constructor(a,m){super(a,a,m,void 0)}}e.TestItemRootImpl=g;class v extends A.TestItemCollection{constructor(a,m){super({controllerId:a,getApiFor:n.getPrivateApiFor,getChildren:o=>o.children,root:new g(a,m),toITestItem:C.TestItem.from})}}e.ExtHostTestItemCollection=v}),define(Ie[133],ke([1,0,56,12,93,15,7]),function(Q,e,u,n,y,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class C{constructor(_,T,w){const b=C._Keys.nextId();_.$registerTextEditorDecorationType(T.identifier,b,A.DecorationRenderOptions.from(w)),this.value=Object.freeze({key:b,dispose(){_.$removeTextEditorDecorationType(b)}})}}e.TextEditorDecorationType=C,C._Keys=new y.IdGenerator("TextEditorDecorationType");class S{constructor(_,T){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=_,this._documentVersionId=_.version,this._undoStopBefore=T.undoStopBefore,this._undoStopAfter=T.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(_,T){this._throwIfFinalized();let w=null;if(_ instanceof D.Position)w=new D.Range(_,_);else if(_ instanceof D.Range)w=_;else throw new Error("Unrecognized location");this._pushEdit(w,T,!1)}insert(_,T){this._throwIfFinalized(),this._pushEdit(new D.Range(_,_),T,!0)}delete(_){this._throwIfFinalized();let T=null;if(_ instanceof D.Range)T=_;else throw new Error("Unrecognized location");this._pushEdit(T,null,!0)}_pushEdit(_,T,w){const b=this._document.validateRange(_);this._collectedEdits.push({range:b,text:T,forceMoveMarkers:w})}setEndOfLine(_){if(this._throwIfFinalized(),_!==D.EndOfLine.LF&&_!==D.EndOfLine.CRLF)throw(0,n.illegalArgument)("endOfLine");this._setEndOfLine=_}}e.TextEditorEdit=S;class P{constructor(_,T,w,b){this._proxy=_,this._id=T,this._accept(w),this._logService=b;const p=this;this.value={get tabSize(){return p._tabSize},set tabSize(g){p._setTabSize(g)},get insertSpaces(){return p._insertSpaces},set insertSpaces(g){p._setInsertSpaces(g)},get cursorStyle(){return p._cursorStyle},set cursorStyle(g){p._setCursorStyle(g)},get lineNumbers(){return p._lineNumbers},set lineNumbers(g){p._setLineNumbers(g)}}}_accept(_){this._tabSize=_.tabSize,this._insertSpaces=_.insertSpaces,this._cursorStyle=_.cursorStyle,this._lineNumbers=A.TextEditorLineNumbersStyle.to(_.lineNumbers)}_validateTabSize(_){if(_==="auto")return"auto";if(typeof _=="number"){const T=Math.floor(_);return T>0?T:null}if(typeof _=="string"){const T=parseInt(_,10);return isNaN(T)?null:T>0?T:null}return null}_setTabSize(_){const T=this._validateTabSize(_);if(T!==null){if(typeof T=="number"){if(this._tabSize===T)return;this._tabSize=T}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:T}))}}_validateInsertSpaces(_){return _==="auto"?"auto":_==="false"?!1:Boolean(_)}_setInsertSpaces(_){const T=this._validateInsertSpaces(_);if(typeof T=="boolean"){if(this._insertSpaces===T)return;this._insertSpaces=T}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:T}))}_setCursorStyle(_){this._cursorStyle!==_&&(this._cursorStyle=_,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:_})))}_setLineNumbers(_){this._lineNumbers!==_&&(this._lineNumbers=_,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:A.TextEditorLineNumbersStyle.from(_)})))}assign(_){const T={};let w=!1;if(typeof _.tabSize!="undefined"){const b=this._validateTabSize(_.tabSize);b==="auto"?(w=!0,T.tabSize=b):typeof b=="number"&&this._tabSize!==b&&(this._tabSize=b,w=!0,T.tabSize=b)}if(typeof _.insertSpaces!="undefined"){const b=this._validateInsertSpaces(_.insertSpaces);b==="auto"?(w=!0,T.insertSpaces=b):this._insertSpaces!==b&&(this._insertSpaces=b,w=!0,T.insertSpaces=b)}typeof _.cursorStyle!="undefined"&&this._cursorStyle!==_.cursorStyle&&(this._cursorStyle=_.cursorStyle,w=!0,T.cursorStyle=_.cursorStyle),typeof _.lineNumbers!="undefined"&&this._lineNumbers!==_.lineNumbers&&(this._lineNumbers=_.lineNumbers,w=!0,T.lineNumbers=A.TextEditorLineNumbersStyle.from(_.lineNumbers)),w&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,T))}_warnOnError(_,T){T.catch(w=>{this._logService.warn(`ExtHostTextEditorOptions '${_}' failed:'`),this._logService.warn(w)})}}e.ExtHostTextEditorOptions=P;class L{constructor(_,T,w,b,p,g,v,f){this.id=_,this._proxy=T,this._logService=w,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=p,this._options=new P(this._proxy,this.id,g,w),this._visibleRanges=v,this._viewColumn=f;const a=this;this.value=Object.freeze({get document(){return b.getValue()},set document(m){throw(0,n.readonly)("document")},get selection(){return a._selections&&a._selections[0]},set selection(m){if(!(m instanceof D.Selection))throw(0,n.illegalArgument)("selection");a._selections=[m],a._trySetSelection()},get selections(){return a._selections},set selections(m){if(!Array.isArray(m)||m.some(o=>!(o instanceof D.Selection)))throw(0,n.illegalArgument)("selections");a._selections=m,a._trySetSelection()},get visibleRanges(){return a._visibleRanges},set visibleRanges(m){throw(0,n.readonly)("visibleRanges")},get options(){return a._options.value},set options(m){a._disposed||a._options.assign(m)},get viewColumn(){return a._viewColumn},set viewColumn(m){throw(0,n.readonly)("viewColumn")},edit(m,o={undoStopBefore:!0,undoStopAfter:!0}){if(a._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const d=new S(b.getValue(),o);return m(d),a._applyEdit(d)},insertSnippet(m,o,d={undoStopBefore:!0,undoStopAfter:!0}){if(a._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!o||Array.isArray(o)&&o.length===0)r=a._selections.map(s=>A.Range.from(s));else if(o instanceof D.Position){const{lineNumber:s,column:i}=A.Position.from(o);r=[{startLineNumber:s,startColumn:i,endLineNumber:s,endColumn:i}]}else if(o instanceof D.Range)r=[A.Range.from(o)];else{r=[];for(const s of o)if(s instanceof D.Range)r.push(A.Range.from(s));else{const{lineNumber:i,column:t}=A.Position.from(s);r.push({startLineNumber:i,startColumn:t,endLineNumber:i,endColumn:t})}}return T.$tryInsertSnippet(_,b.getValue().version,m.value,r,d)},setDecorations(m,o){const d=o.length===0;d&&!a._hasDecorationsForKey.has(m.key)||(d?a._hasDecorationsForKey.delete(m.key):a._hasDecorationsForKey.add(m.key),a._runOnProxy(()=>{if(A.isDecorationOptionsArr(o))return T.$trySetDecorations(_,m.key,A.fromRangeOrRangeWithMessage(o));{const r=new Array(4*o.length);for(let s=0,i=o.length;s<i;s++){const t=o[s];r[4*s]=t.start.line+1,r[4*s+1]=t.start.character+1,r[4*s+2]=t.end.line+1,r[4*s+3]=t.end.character+1}return T.$trySetDecorationsFast(_,m.key,r)}}))},revealRange(m,o){a._runOnProxy(()=>T.$tryRevealRange(_,A.Range.from(m),o||D.TextEditorRevealType.Default))},show(m){T.$tryShowEditor(_,A.ViewColumn.from(m))},hide(){T.$tryHideEditor(_)}})}dispose(){(0,u.ok)(!this._disposed),this._disposed=!0}_acceptOptions(_){(0,u.ok)(!this._disposed),this._options._accept(_)}_acceptVisibleRanges(_){(0,u.ok)(!this._disposed),this._visibleRanges=_}_acceptViewColumn(_){(0,u.ok)(!this._disposed),this._viewColumn=_}_acceptSelections(_){(0,u.ok)(!this._disposed),this._selections=_}async _trySetSelection(){const _=this._selections.map(A.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,_)),this.value}_applyEdit(_){const T=_.finalize();if(T.edits.length===0&&!T.setEndOfLine)return Promise.resolve(!0);const w=T.edits.map(p=>p.range);w.sort((p,g)=>p.end.line===g.end.line?p.end.character===g.end.character?p.start.line===g.start.line?p.start.character-g.start.character:p.start.line-g.start.line:p.end.character-g.end.character:p.end.line-g.end.line);for(let p=0,g=w.length-1;p<g;p++){const v=w[p].end;if(w[p+1].start.isBefore(v))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const b=T.edits.map(p=>({range:A.Range.from(p.range),text:p.text,forceMoveMarkers:p.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,T.documentVersionId,b,{setEndOfLine:typeof T.setEndOfLine=="number"?A.EndOfLine.from(T.setEndOfLine):void 0,undoStopBefore:T.undoStopBefore,undoStopAfter:T.undoStopAfter})}_runOnProxy(_){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):_().then(()=>this,T=>(T instanceof Error&&T.name==="DISPOSED"||this._logService.warn(T),null))}}e.ExtHostTextEditor=L}),define(Ie[226],ke([1,0,4,192]),function(Q,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,u.refineServiceDecorator)(n.IEnvironmentService)}),define(Ie[227],ke([1,0,28,3,9]),function(Q,e,u,n,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class A{constructor(I){this.removedDueToLooping=I}}e.DeltaExtensionsResult=A;class D{constructor(I){this._onDidChange=new n.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=I,this._initialize()}_initialize(){this._extensionDescriptions.sort(S),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const I of this._extensionDescriptions){if(this._extensionsMap.has(u.ExtensionIdentifier.toKey(I.identifier))){console.error("Extension `"+I.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(u.ExtensionIdentifier.toKey(I.identifier),I),this._extensionsArr.push(I),Array.isArray(I.activationEvents))for(let _ of I.activationEvents)_==="onUri"&&(_=`onUri:${u.ExtensionIdentifier.toKey(I.identifier)}`),this._activationMap.has(_)||this._activationMap.set(_,[]),this._activationMap.get(_).push(I)}}set(I){this._extensionDescriptions=I,this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(I,_){this._extensionDescriptions=P(this._extensionDescriptions,_),this._extensionDescriptions=this._extensionDescriptions.concat(I);const T=D._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=P(this._extensionDescriptions,T.map(w=>w.identifier)),this._initialize(),this._onDidChange.fire(void 0),new A(T)}static _findLoopingExtensions(I){const _=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(g){this._nodesSet.has(g)||(this._nodesSet.add(g),this._nodesArr.push(g))}addArc(g,v){this.addNode(g),this.addNode(v),this._arcs.has(g)?this._arcs.get(g).push(v):this._arcs.set(g,[v])}getArcs(g){return this._arcs.has(g)?this._arcs.get(g):[]}hasOnlyGoodArcs(g,v){const f=_.getArcs(g);for(let a=0;a<f.length;a++)if(!v.has(f[a]))return!1;return!0}getNodes(){return this._nodesArr}},T=new Map;for(const g of I){const v=u.ExtensionIdentifier.toKey(g.identifier);if(T.set(v,g),g.extensionDependencies)for(const f of g.extensionDependencies){const a=u.ExtensionIdentifier.toKey(f);_.addArc(v,a)}}const w=new Set;_.getNodes().filter(g=>_.getArcs(g).length===0).forEach(g=>w.add(g));const b=_.getNodes().filter(g=>!w.has(g));let p;do{p=!1;for(let g=0;g<b.length;g++){const v=b[g];_.hasOnlyGoodArcs(v,w)&&(b.splice(g,1),g--,w.add(v),p=!0)}}while(p);return b.map(g=>T.get(g))}containsActivationEvent(I){return this._activationMap.has(I)}containsExtension(I){return this._extensionsMap.has(u.ExtensionIdentifier.toKey(I))}getExtensionDescriptionsForActivationEvent(I){const _=this._activationMap.get(I);return _?_.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(I){const _=this._extensionsMap.get(u.ExtensionIdentifier.toKey(I));return _||void 0}getExtensionDescriptionByUUID(I){for(const _ of this._extensionsArr)if(_.uuid===I)return _}getExtensionDescriptionByIdOrUUID(I,_){return this.getExtensionDescription(I)??(_?this.getExtensionDescriptionByUUID(_):void 0)}}e.ExtensionDescriptionRegistry=D;var C;(function(L){L[L.Builtin=0]="Builtin",L[L.User=1]="User",L[L.Dev=2]="Dev"})(C||(C={}));function S(L,I){const _=L.isBuiltin?0:L.isUnderDevelopment?2:1,T=I.isBuiltin?0:I.isUnderDevelopment?2:1;if(_!==T)return _-T;const w=y.posix.basename(L.extensionLocation.path),b=y.posix.basename(I.extensionLocation.path);return w<b?-1:w>b?1:0}function P(L,I){const _=new Set;return I.forEach(T=>_.add(u.ExtensionIdentifier.toKey(T))),L.filter(T=>!_.has(u.ExtensionIdentifier.toKey(T.identifier)))}}),define(Ie[228],ke([1,0]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var u;(function(L){L[L.IPC=1]="IPC",L[L.Socket=2]="Socket",L[L.MessagePort=3]="MessagePort"})(u=e.ExtHostConnectionType||(e.ExtHostConnectionType={}));class n{constructor(I){this.pipeName=I,this.type=1}serialize(I){I[n.ENV_KEY]=this.pipeName}}e.IPCExtHostConnection=n,n.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class y{constructor(){this.type=2}serialize(I){I[y.ENV_KEY]="1"}}e.SocketExtHostConnection=y,y.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class A{constructor(){this.type=3}serialize(I){I[A.ENV_KEY]="1"}}e.MessagePortExtHostConnection=A,A.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function D(L){delete L[n.ENV_KEY],delete L[y.ENV_KEY],delete L[A.ENV_KEY]}function C(L,I){D(I),L.serialize(I)}e.writeExtHostConnection=C;function S(L){if(L[n.ENV_KEY])return P(L,new n(L[n.ENV_KEY]));if(L[y.ENV_KEY])return P(L,new y);if(L[A.ENV_KEY])return P(L,new A);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=S;function P(L,I){return D(L),I}}),define(Ie[134],ke([1,0,23]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var n;(function(P){P[P.Desktop=1]="Desktop",P[P.Web=2]="Web"})(n=e.UIKind||(e.UIKind={}));var y;(function(P){P[P.VersionMismatch=55]="VersionMismatch",P[P.UnexpectedError=81]="UnexpectedError"})(y=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var A;(function(P){P[P.Initialized=0]="Initialized",P[P.Ready=1]="Ready",P[P.Terminate=2]="Terminate"})(A=e.MessageType||(e.MessageType={}));function D(P){const L=u.VSBuffer.alloc(1);switch(P){case 0:L.writeUInt8(1,0);break;case 1:L.writeUInt8(2,0);break;case 2:L.writeUInt8(3,0);break}return L}e.createMessageOfType=D;function C(P,L){if(P.byteLength!==1)return!1;switch(P.readUInt8(0)){case 1:return L===0;case 2:return L===1;case 3:return L===2;default:return!1}}e.isMessageOfType=C;var S;(function(P){P.Start="START_NATIVE_LOG",P.End="END_NATIVE_LOG"})(S=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(Ie[27],ke([1,0,3,2,4,28,201]),function(Q,e,u,n,y,A,D){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new A.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:n.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,y.createDecorator)("extensionService");class S{constructor(t){this.affinity=t,this.kind=1}equals(t){return this.kind===t.kind&&this.affinity===t.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=S;class P{constructor(){this.kind=2,this.affinity=0}equals(t){return this.kind===t.kind}asString(){return"LocalWebWorker"}}e.LocalWebWorkerRunningLocation=P;class L{constructor(){this.kind=3,this.affinity=0}equals(t){return this.kind===t.kind}asString(){return"Remote"}}e.RemoteRunningLocation=L;class I{constructor(t){this.dependency=t}}e.MissingExtensionDependency=I;var _;(function(i){i[i.LocalProcess=1]="LocalProcess",i[i.LocalWebWorker=2]="LocalWebWorker",i[i.Remote=3]="Remote"})(_=e.ExtensionHostKind||(e.ExtensionHostKind={}));function T(i){if(i===null)return"None";switch(i){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=T;class w{constructor(){this._allExtensions=[],this._myExtensions=[]}toDelta(){return{toRemove:[],toAdd:this._allExtensions,myToRemove:[],myToAdd:this._myExtensions}}set(t,c){const l=[],h=[],E=[],R=[],N=g(this._allExtensions),O=g(t),k=(ee,B)=>ee.extensionLocation.toString()===B.extensionLocation.toString()||ee.isBuiltin===B.isBuiltin||ee.isUserBuiltin===B.isUserBuiltin||ee.isUnderDevelopment===B.isUnderDevelopment;for(const ee of this._allExtensions){const B=O.get(A.ExtensionIdentifier.toKey(ee.identifier));if(!B){l.push(ee.identifier),N.delete(A.ExtensionIdentifier.toKey(ee.identifier));continue}if(!k(ee,B)){l.push(ee.identifier),N.delete(A.ExtensionIdentifier.toKey(ee.identifier));continue}}for(const ee of t){const B=N.get(A.ExtensionIdentifier.toKey(ee.identifier));if(!B){h.push(ee);continue}if(!k(B,ee)){l.push(B.identifier),N.delete(A.ExtensionIdentifier.toKey(B.identifier));continue}}const U=p(this._myExtensions),F=p(c);for(const ee of this._myExtensions)F.has(A.ExtensionIdentifier.toKey(ee))||E.push(ee);for(const ee of c)U.has(A.ExtensionIdentifier.toKey(ee))||R.push(ee);const $={toRemove:l,toAdd:h,myToRemove:E,myToAdd:R};return this.delta($),$}delta(t){const{toRemove:c,toAdd:l,myToRemove:h,myToAdd:E}=t,R=p(c),N=p(h);for(let O=0;O<this._allExtensions.length;O++)R.has(A.ExtensionIdentifier.toKey(this._allExtensions[O].identifier))&&(this._allExtensions.splice(O,1),O--);for(let O=0;O<this._myExtensions.length;O++)N.has(A.ExtensionIdentifier.toKey(this._myExtensions[O]))&&(this._myExtensions.splice(O,1),O--);for(const O of l)this._allExtensions.push(O);for(const O of E)this._myExtensions.push(O)}containsExtension(t){for(const c of this._myExtensions)if(A.ExtensionIdentifier.equals(c,t))return!0;return!1}}e.ExtensionHostExtensions=w;class b{constructor(t){if(this[C]="ExtensionIdentifierSet",this._map=new Map,this._toKey=A.ExtensionIdentifier.toKey,t)for(const c of t)this.add(c)}get size(){return this._map.size}add(t){return this._map.set(this._toKey(t),t),this}clear(){this._map.clear()}delete(t){return this._map.delete(this._toKey(t))}has(t){return this._map.has(this._toKey(t))}forEach(t,c){this._map.forEach(l=>t.call(c,l,l,this))}*entries(){for(const[t,c]of this._map)yield[c,c]}keys(){return this._map.values()}values(){return this._map.values()}[(C=Symbol.toStringTag,Symbol.iterator)](){return this._map.values()}}e.ExtensionIdentifierSet=b;function p(i){const t=new Set;for(const c of i)t.add(A.ExtensionIdentifier.toKey(c));return t}e.extensionIdentifiersArrayToSet=p;function g(i){const t=new Map;for(const c of i)t.set(A.ExtensionIdentifier.toKey(c.identifier),c);return t}function v(i,t){return i.enabledApiProposals?i.enabledApiProposals.includes(t):!1}e.isProposedApiEnabled=v;function f(i,t){if(!v(i,t))throw new Error(`Extension '${i.identifier.value}' CANNOT use API proposal: ${t}.
Its package.json#enabledApiProposals-property declares: ${i.enabledApiProposals?.join(", ")??"[]"} but NOT ${t}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${i.identifier.value}`)}e.checkProposedApiEnabled=f;class a{constructor(t,c,l,h){this.codeLoadingTime=t,this.activateCallTime=c,this.activateResolvedTime=l,this.activationReason=h}}e.ActivationTimes=a;class m{constructor(t,c){this.description=t,this.value=c}}e.ExtensionPointContribution=m,e.ExtensionHostLogFileName="exthost";var o;(function(i){i[i.Normal=0]="Normal",i[i.Immediate=1]="Immediate"})(o=e.ActivationKind||(e.ActivationKind={}));function d(i){return{type:i.isBuiltin?0:1,isBuiltin:i.isBuiltin||i.isUserBuiltin,identifier:{id:(0,D.getGalleryExtensionId)(i.publisher,i.name),uuid:i.uuid},manifest:i,location:i.extensionLocation,targetPlatform:i.targetPlatform,validations:[],isValid:!0}}e.toExtension=d;function r(i,t){return{identifier:new A.ExtensionIdentifier((0,D.getExtensionId)(i.manifest.publisher,i.manifest.name)),isBuiltin:i.type===0,isUserBuiltin:i.type===1&&i.isBuiltin,isUnderDevelopment:!!t,extensionLocation:i.location,...i.manifest,uuid:i.identifier.uuid,targetPlatform:i.targetPlatform}}e.toExtensionDescription=r;class s{constructor(){this.onDidRegisterExtensions=u.Event.None,this.onDidChangeExtensionsStatus=u.Event.None,this.onDidChangeExtensions=u.Event.None,this.onWillActivateByEvent=u.Event.None,this.onDidChangeResponsiveChange=u.Event.None}activateByEvent(t){return Promise.resolve(void 0)}activationEventIsDone(t){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(t){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(t,c){return Promise.resolve(0)}getInspectPorts(t,c){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(t){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(t,c){return Promise.resolve()}}e.NullExtensionService=s}),define(Ie[229],ke([1,0,12,28,27,14,18]),function(Q,e,u,n,y,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class C{constructor(p,g,v,f){this.startup=p,this.codeLoadingTime=g,this.activateCallTime=v,this.activateResolvedTime=f}}e.ExtensionActivationTimes=C,C.NONE=new C(!1,-1,-1,-1);class S{constructor(p){this._startup=p,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(p,g){return p===-1||g===-1?-1:g-p}build(){return new C(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=S;class P{constructor(p,g,v,f,a,m){this.activationFailed=p,this.activationFailedError=g,this.activationTimes=v,this.module=f,this.exports=a,this.subscriptions=m}}e.ActivatedExtension=P;class L extends P{constructor(p){super(!1,null,p,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=L;class I extends P{constructor(){super(!1,null,C.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=I;class _ extends P{constructor(p){super(!0,p,C.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=_;let T=class{constructor(p,g,v,f,a){this._logService=a,this._registry=p,this._resolvedExtensionsSet=new Set,g.forEach(m=>this._resolvedExtensionsSet.add(n.ExtensionIdentifier.toKey(m))),this._externalExtensionsMap=new Map,v.forEach(m=>this._externalExtensionsMap.set(n.ExtensionIdentifier.toKey(m),m)),this._host=f,this._operations=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[p,g]of this._operations)g.dispose()}isActivated(p){const g=this._operations.get(n.ExtensionIdentifier.toKey(p));return Boolean(g&&g.value)}getActivatedExtension(p){const g=this._operations.get(n.ExtensionIdentifier.toKey(p));if(!g||!g.value)throw new Error(`Extension '${p.value}' is not known or not activated`);return g.value}async activateByEvent(p,g){if(this._alreadyActivatedEvents[p])return;const v=this._registry.getExtensionDescriptionsForActivationEvent(p);await this._activateExtensions(v.map(f=>({id:f.identifier,reason:{startup:g,extensionId:f.identifier,activationEvent:p}}))),this._alreadyActivatedEvents[p]=!0}activateById(p,g){const v=this._registry.getExtensionDescription(p);if(!v)throw new Error(`Extension '${p}' is not known`);return this._activateExtensions([{id:v.identifier,reason:g}])}async _activateExtensions(p){const g=p.filter(v=>!this.isActivated(v.id)).map(v=>this._handleActivationRequest(v));await Promise.all(g.map(v=>v.wait()))}_handleActivationRequest(p){if(this._operations.has(n.ExtensionIdentifier.toKey(p.id)))return this._operations.get(n.ExtensionIdentifier.toKey(p.id));if(this._externalExtensionsMap.has(n.ExtensionIdentifier.toKey(p.id)))return this._createAndSaveOperation(p,null,[],null);const g=this._registry.getExtensionDescription(p.id);if(!g){const a=new Error(`Cannot activate unknown extension '${p.id.value}'`),m=this._createAndSaveOperation(p,null,[],new _(a));return this._host.onExtensionActivationError(p.id,a,new y.MissingExtensionDependency(p.id.value)),m}const v=[],f=typeof g.extensionDependencies=="undefined"?[]:g.extensionDependencies;for(const a of f){if(this._resolvedExtensionsSet.has(n.ExtensionIdentifier.toKey(a)))continue;const m=this._operations.get(n.ExtensionIdentifier.toKey(a));if(m){v.push(m);continue}if(this._externalExtensionsMap.has(n.ExtensionIdentifier.toKey(a))){v.push(this._handleActivationRequest({id:this._externalExtensionsMap.get(n.ExtensionIdentifier.toKey(a)),reason:p.reason}));continue}const o=this._registry.getExtensionDescription(a);if(o){if(!o.main&&!o.browser)continue;v.push(this._handleActivationRequest({id:o.identifier,reason:p.reason}));continue}const d=g.displayName||g.identifier.value,r=new Error(`Cannot activate the '${d}' extension because it depends on unknown extension '${a}'`),s=this._createAndSaveOperation(p,g.displayName,[],new _(r));return this._host.onExtensionActivationError(g.identifier,r,new y.MissingExtensionDependency(a)),s}return this._createAndSaveOperation(p,g.displayName,v,null)}_createAndSaveOperation(p,g,v,f){const a=new w(p.id,g,p.reason,v,f,this._host,this._logService);return this._operations.set(n.ExtensionIdentifier.toKey(p.id),a),a}};T=Ge([$e(4,A.ILogService)],T),e.ExtensionsActivator=T;let w=class{constructor(p,g,v,f,a,m,o){this._id=p,this._displayName=g,this._reason=v,this._deps=f,this._value=a,this._host=m,this._logService=o,this._barrier=new D.Barrier,this._isDisposed=!1,this._initialize()}get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let p=0;p<this._deps.length;p++){const g=this._deps[p];if(g.value&&!g.value.activationFailed){this._deps.splice(p,1),p--;continue}if(g.value&&g.value.activationFailed){const v=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${g.friendlyName}' failed to activate`);v.detail=g.value.activationFailedError,this._value=new _(v),this._host.onExtensionActivationError(this._id,v,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(p=>p.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(p){const g=new Error;if(p&&p.name&&(g.name=p.name),p&&p.message?g.message=`Activating extension '${this._id.value}' failed: ${p.message}.`:g.message=`Activating extension '${this._id.value}' failed: ${p}.`,p&&p.stack&&(g.stack=p.stack),this._value=new _(g),this._isDisposed&&u.isCancellationError(p))return;this._host.onExtensionActivationError(this._id,g,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(p)}}};w=Ge([$e(6,A.ILogService)],w)}),define(Ie[230],ke([1,0,14,26,27]),function(Q,e,u,n,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let A=class extends u.LogService{constructor(C,S){super(C.createLogger(S.logFile,{name:y.ExtensionHostLogFileName}))}};A=Ge([$e(0,u.ILoggerService),$e(1,n.IExtHostInitDataService)],A),e.ExtHostLogService=A}),define(Ie[231],ke([1,0]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",badges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.badges.d.ts",commentsResolvedState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsResolvedState.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorToolbar:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorToolbar.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineCompletionsNew:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsNew.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookContentProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookContentProvider.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDebugOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDebugOptions.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookEditor.d.ts",notebookEditorEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookEditorEdit.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookWorkspaceEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookWorkspaceEdit.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",snippetWorkspaceEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.snippetWorkspaceEdit.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalNameChangeEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalNameChangeEvent.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textEditorDrop:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textEditorDrop.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ie[232],ke([1,0,187,12,41,84,119,44,28,231,199]),function(Q,e,u,n,y,A,D,C,S,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const I=C.Registry.as(D.Extensions.JSONContribution);class _{constructor(a,m,o){this._messageHandler=a,this._extension=m,this._extensionPointId=o}_msg(a,m){this._messageHandler({type:a,message:m,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(a){this._msg(y.default.Error,a)}warn(a){this._msg(y.default.Warning,a)}info(a){this._msg(y.default.Info,a)}}e.ExtensionMessageCollector=_;class T{constructor(a,m){this.added=a,this.removed=m}static _toSet(a){const m=new Set;for(let o=0,d=a.length;o<d;o++)m.add(S.ExtensionIdentifier.toKey(a[o].description.identifier));return m}static compute(a,m){if(!a||!a.length)return new T(m,[]);if(!m||!m.length)return new T([],a);const o=this._toSet(a),d=this._toSet(m),r=m.filter(i=>!o.has(S.ExtensionIdentifier.toKey(i.description.identifier))),s=a.filter(i=>!d.has(S.ExtensionIdentifier.toKey(i.description.identifier)));return new T(r,s)}}e.ExtensionPointUserDelta=T;class w{constructor(a,m){this.name=a,this.defaultExtensionKind=m,this._handler=null,this._users=null,this._delta=null}setHandler(a){if(this._handler!==null)throw new Error("Handler already set!");this._handler=a,this._handle()}acceptUsers(a){this._delta=T.compute(this._users,a),this._users=a,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(a){(0,n.onUnexpectedError)(a)}}}e.ExtensionPoint=w;const b={type:"string",enum:["ui","workspace"],enumDescriptions:[u.localize(0,null),u.localize(1,null)]},p="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:u.localize(2,null),properties:{vscode:{type:"string",description:u.localize(3,null),default:"^1.22.0"}}},publisher:{description:u.localize(4,null),type:"string"},displayName:{description:u.localize(5,null),type:"string"},categories:{description:u.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:S.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:u.localize(7,null)}]}},galleryBanner:{type:"object",description:u.localize(8,null),properties:{color:{description:u.localize(9,null),type:"string"},theme:{description:u.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:u.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:u.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:u.localize(13,null)},enabledApiProposals:{markdownDescription:u.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(P.allApiProposals),markdownEnumDescriptions:Object.values(P.allApiProposals)}},activationEvents:{description:u.localize(15,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:u.localize(16,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:u.localize(17,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:u.localize(18,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:u.localize(19,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:u.localize(20,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:u.localize(21,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:u.localize(22,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:u.localize(23,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:u.localize(24,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:u.localize(25,null),body:"onStartupFinished"},{label:"onTaskType",description:u.localize(26,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:u.localize(27,null),body:"onFileSystem:${1:scheme}"},{label:"onSearch",description:u.localize(28,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:u.localize(29,null)},{label:"onIdentity",body:"onIdentity:${8:identity}",description:u.localize(30,null)},{label:"onUri",body:"onUri",description:u.localize(31,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:u.localize(32,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:u.localize(33,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:u.localize(34,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:u.localize(35,null)},{label:"onRenderer",description:u.localize(36,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:u.localize(37,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:u.localize(38,null)},{label:"*",description:u.localize(39,null),body:"*"}]}},badges:{type:"array",description:u.localize(40,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:u.localize(41,null)},href:{type:"string",description:u.localize(42,null)},description:{type:"string",description:u.localize(43,null)}}}},markdown:{type:"string",description:u.localize(44,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:u.localize(45,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:u.localize(46,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:u.localize(47,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:u.localize(48,null),type:"array",items:b,default:["workspace"],defaultSnippets:[{body:["ui"],description:u.localize(49,null)},{body:["workspace"],description:u.localize(50,null)},{body:["ui","workspace"],description:u.localize(51,null)},{body:["workspace","ui"],description:u.localize(52,null)},{body:[],description:u.localize(53,null)}]},capabilities:{description:u.localize(54,null),type:"object",properties:{virtualWorkspaces:{description:u.localize(55,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:u.localize(56,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[u.localize(57,null),u.localize(58,null),u.localize(59,null)]},description:{type:"string",markdownDescription:u.localize(60,null)}}},untrustedWorkspaces:{description:u.localize(61,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:u.localize(62,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[u.localize(63,null),u.localize(64,null),u.localize(65,null)]},restrictedConfigurations:{description:u.localize(66,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:u.localize(67,null)}}}}},sponsor:{description:u.localize(68,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:u.localize(69,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:u.localize(70,null),type:"string"},"vscode:uninstall":{description:u.localize(71,null),type:"string"}}},icon:{type:"string",description:u.localize(72,null)}}};class g{constructor(){this._extensionPoints=new Map}registerExtensionPoint(a){if(this._extensionPoints.has(a.extensionPoint))throw new Error("Duplicate extension point: "+a.extensionPoint);const m=new w(a.extensionPoint,a.defaultExtensionKind);return this._extensionPoints.set(a.extensionPoint,m),e.schema.properties.contributes.properties[a.extensionPoint]=a.jsonSchema,I.registerSchema(p,e.schema),m}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=g;const v={ExtensionsRegistry:"ExtensionsRegistry"};C.Registry.add(v.ExtensionsRegistry,new g),e.ExtensionsRegistry=C.Registry.as(v.ExtensionsRegistry),I.registerSchema(p,e.schema),I.registerSchema(L.productSchemaId,{properties:{extensionEnabledApiProposals:{description:u.localize(73,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(P.allApiProposals),markdownEnumDescriptions:Object.values(P.allApiProposals)}}]}}}})}),define(Ie[233],ke([1,0,184,10,24,232,51,3]),function(Q,e,u,n,y,A,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=e.TaskDefinitionRegistryImpl=void 0;const S={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:u.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:u.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:u.localize(2,null),default:""}}};var P;(function(_){function T(w,b,p){if(!w)return;const g=n.isString(w.type)?w.type:void 0;if(!g||g.length===0){p.error(u.localize(3,null));return}const v=[];if(Array.isArray(w.required))for(const f of w.required)n.isString(f)&&v.push(f);return{extensionId:b.value,taskType:g,required:v,properties:w.properties?y.deepClone(w.properties):{},when:w.when?D.ContextKeyExpr.deserialize(w.when):void 0}}_.from=T})(P||(P={}));const L=A.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:u.localize(4,null),type:"array",items:S}});class I{constructor(){this._onDefinitionsChanged=new C.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((T,w)=>{L.setHandler((b,p)=>{this._schema=void 0;try{for(const g of p.removed){const v=g.value;for(const f of v)this.taskTypes&&f.type&&this.taskTypes[f.type]&&delete this.taskTypes[f.type]}for(const g of p.added){const v=g.value;for(const f of v){const a=P.from(f,g.description.identifier,g.collector);a&&(this.taskTypes[a.taskType]=a)}}(p.removed.length>0||p.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}T(void 0)})})}onReady(){return this.readyPromise}get(T){return this.taskTypes[T]}all(){return Object.keys(this.taskTypes).map(T=>this.taskTypes[T])}getJsonSchema(){if(this._schema===void 0){const T=[];for(const w of this.all()){const b={type:"object",additionalProperties:!1};w.required.length>0&&(b.required=w.required.slice(0)),w.properties!==void 0?b.properties=y.deepClone(w.properties):b.properties=Object.create(null),b.properties.type={type:"string",enum:[w.taskType]},T.push(b)}this._schema={oneOf:T}}return this._schema}}e.TaskDefinitionRegistryImpl=I,e.TaskDefinitionRegistry=new I}),define(Ie[234],ke([1,0,185,10,22,24,51,233]),function(Q,e,u,n,y,A,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new D.RawContextKey("taskRunning",!1,u.localize(0,null)),e.TASKS_CATEGORY={value:u.localize(1,null),original:"Tasks"};var S;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(S=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(U){function F($){if(!$)return U.Strong;switch($.toLowerCase()){case"escape":return U.Escape;case"strong":return U.Strong;case"weak":return U.Weak;default:return U.Strong}}U.from=F}(S=e.ShellQuoting||(e.ShellQuoting={}));var P;(function(U){U.defaults={cwd:"${workspaceFolder}"}})(P=e.CommandOptions||(e.CommandOptions={}));var L;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(L=e.RevealKind||(e.RevealKind={})),function(U){function F($){switch($.toLowerCase()){case"always":return U.Always;case"silent":return U.Silent;case"never":return U.Never;default:return U.Always}}U.fromString=F}(L=e.RevealKind||(e.RevealKind={}));var I;(function(U){U[U.Never=1]="Never",U[U.OnProblem=2]="OnProblem",U[U.Always=3]="Always"})(I=e.RevealProblemKind||(e.RevealProblemKind={})),function(U){function F($){switch($.toLowerCase()){case"always":return U.Always;case"never":return U.Never;case"onproblem":return U.OnProblem;default:return U.OnProblem}}U.fromString=F}(I=e.RevealProblemKind||(e.RevealProblemKind={}));var _;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(_=e.PanelKind||(e.PanelKind={})),function(U){function F($){switch($.toLowerCase()){case"shared":return U.Shared;case"dedicated":return U.Dedicated;case"new":return U.New;default:return U.Shared}}U.fromString=F}(_=e.PanelKind||(e.PanelKind={}));var T;(function(U){U.defaults={echo:!0,reveal:L.Always,revealProblems:I.Never,focus:!1,panel:_.Shared,showReuseMessage:!0,clear:!1}})(T=e.PresentationOptions||(e.PresentationOptions={}));var w;(function(U){U[U.Shell=1]="Shell",U[U.Process=2]="Process",U[U.CustomExecution=3]="CustomExecution"})(w=e.RuntimeType||(e.RuntimeType={})),function(U){function F(ee){switch(ee.toLowerCase()){case"shell":return U.Shell;case"process":return U.Process;case"customExecution":return U.CustomExecution;default:return U.Process}}U.fromString=F;function $(ee){switch(ee){case U.Shell:return"shell";case U.Process:return"process";case U.CustomExecution:return"customExecution";default:return"process"}}U.toString=$}(w=e.RuntimeType||(e.RuntimeType={}));var b;(function(U){function F($){return n.isString($)?$:$.value}U.value=F})(b=e.CommandString||(e.CommandString={}));var p;(function(U){U.Clean={_id:"clean",isDefault:!1},U.Build={_id:"build",isDefault:!1},U.Rebuild={_id:"rebuild",isDefault:!1},U.Test={_id:"test",isDefault:!1};function F(ee){return ee===U.Clean._id||ee===U.Build._id||ee===U.Rebuild._id||ee===U.Test._id}U.is=F;function $(ee){if(ee!==void 0)return n.isString(ee)?F(ee)?{_id:ee,isDefault:!1}:void 0:ee}U.from=$})(p=e.TaskGroup||(e.TaskGroup={}));var g;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.Folder=3]="Folder"})(g=e.TaskScope||(e.TaskScope={}));var v;(function(U){U.Workspace="workspace",U.Extension="extension",U.InMemory="inMemory",U.WorkspaceFile="workspaceFile",U.User="user";function F($){switch($){case U.User:return 1;case U.WorkspaceFile:return 4;default:return 5}}U.toConfigurationTarget=F})(v=e.TaskSourceKind||(e.TaskSourceKind={}));var f;(function(U){U.parallel="parallel",U.sequence="sequence"})(f=e.DependsOrder||(e.DependsOrder={}));var a;(function(U){U[U.default=1]="default",U[U.folderOpen=2]="folderOpen"})(a=e.RunOnOptions||(e.RunOnOptions={}));var m;(function(U){U.defaults={reevaluateOnRerun:!0,runOn:a.default,instanceLimit:1}})(m=e.RunOptions||(e.RunOptions={}));class o{constructor(F,$,ee,B,z,q){this._label="",this._id=F,$&&(this._label=$),ee&&(this.type=ee),this.runOptions=B,this.configurationProperties=z,this._source=q}getDefinition(F){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const F={folder:this.getFolderId(),id:this._id};return JSON.stringify(F)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(F,$=!1){if(F===void 0)return!1;if(n.isString(F))return F===this._label||F===this.configurationProperties.identifier||$&&F===this._id;const ee=this.getDefinition(!0);return ee!==void 0&&ee._key===F._key}getQualifiedLabel(){const F=this.getWorkspaceFolder();return F?`${this._label} (${F.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(F){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),F&&(this._taskLoadMessages=this._taskLoadMessages.concat(F))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=o;class d extends o{constructor(F,$,ee,B,z,q,V,j){super(F,ee,void 0,V,j,$);this.command={},this._source=$,this.hasDefinedMatchers=q,z&&(this.command=z)}clone(){return new d(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(F=!1){if(F&&this._source.customizes!==void 0)return this._source.customizes;{let $;switch(this.command?this.command.runtime:void 0){case w.Shell:$="shell";break;case w.Process:$="process";break;case w.CustomExecution:$="customExecution";break;case void 0:$="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:$,_key:this._id,id:this._id}}}static is(F){return F instanceof d}getMapKey(){const F=this._source.config.workspaceFolder;return F?`${F.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===v.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const F=this.getFolderId();if(!F)return;let $=this.configurationProperties.identifier;this._source.kind!==v.Workspace&&($+=this._source.kind);const ee={type:e.CUSTOMIZED_TASK_TYPE,folder:F,id:$};return JSON.stringify(ee)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?y.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(F){return new d(F._id,F._source,F._label,F.type,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.CustomTask=d;class r extends o{constructor(F,$,ee,B,z,q,V){super(F,ee,B,q,V,$);this._source=$,this.configures=z}static is(F){return F instanceof r}fromObject(F){return F}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?y.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===v.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const F=this.getFolderId();if(!F)return;let $=this.configurationProperties.identifier;this._source.kind!==v.Workspace&&($+=this._source.kind);const ee={type:e.CUSTOMIZED_TASK_TYPE,folder:F,id:$};return JSON.stringify(ee)}}e.ConfiguringTask=r;class s extends o{constructor(F,$,ee,B,z,q,V,j,ne){super(F,ee,B,j,ne,$);this.defines=z,this.hasDefinedMatchers=V,this.command=q,this.icon=ne.icon}clone(){return new s(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(F){return F instanceof s}getMapKey(){const F=this._source.workspaceFolder;return F?`${this._source.scope.toString()}|${F.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const F={type:"contributed",scope:this._source.scope,id:this._id};return F.folder=this.getFolderId(),JSON.stringify(F)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(F){return new s(F._id,F._source,F._label,F.type,F.defines,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.ContributedTask=s;class i extends o{constructor(F,$,ee,B,z,q){super(F,ee,B,z,q,$);this._source=$}clone(){return new i(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(F){return F instanceof i}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(F){return new i(F._id,F._source,F._label,F.type,F.runOptions,F.configurationProperties)}}e.InMemoryTask=i;var t;(function(U){U[U.Process=1]="Process",U[U.Terminal=2]="Terminal"})(t=e.ExecutionEngine||(e.ExecutionEngine={})),function(U){U._default=U.Terminal}(t=e.ExecutionEngine||(e.ExecutionEngine={}));var c;(function(U){U[U.V0_1_0=1]="V0_1_0",U[U.V2_0_0=2]="V2_0_0"})(c=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class l{constructor(F){this._order=new Map;for(let $=0;$<F.length;$++)this._order.set(F[$].uri.toString(),$)}compare(F,$){const ee=F.getWorkspaceFolder(),B=$.getWorkspaceFolder();if(ee&&B){let z=this._order.get(ee.uri.toString());z=z===void 0?0:z+1;let q=this._order.get(B.uri.toString());return q=q===void 0?0:q+1,z===q?F._label.localeCompare($._label):z-q}else return!ee&&B?-1:ee&&!B?1:0}}e.TaskSorter=l;var h;(function(U){U.DependsOnStarted="dependsOnStarted",U.AcquiredInput="acquiredInput",U.Start="start",U.ProcessStarted="processStarted",U.Active="active",U.Inactive="inactive",U.Changed="changed",U.Terminated="terminated",U.ProcessEnded="processEnded",U.End="end"})(h=e.TaskEventKind||(e.TaskEventKind={}));var E;(function(U){U.SingleRun="singleRun",U.Background="background"})(E=e.TaskRunType||(e.TaskRunType={}));var R;(function(U){U[U.System=0]="System",U[U.User=1]="User",U[U.FolderOpen=2]="FolderOpen",U[U.ConfigurationChange=3]="ConfigurationChange"})(R=e.TaskRunSource||(e.TaskRunSource={}));var N;(function(U){function F($,ee,B,z){if(ee){const q={kind:$,taskId:ee._id,taskName:ee.configurationProperties.name,runType:ee.configurationProperties.isBackground?"background":"singleRun",group:ee.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:void 0,__task:ee};return $==="start"?(q.terminalId=B,q.resolvedVariables=z):$==="processStarted"?q.processId=B:$==="processEnded"&&(q.exitCode=B),Object.freeze(q)}else return Object.freeze({kind:"changed"})}U.create=F})(N=e.TaskEvent||(e.TaskEvent={}));var O;(function(U){function F(ee){const B=Object.keys(ee).sort();let z="";for(const q of B){let V=ee[q];V instanceof Object?V=F(V):typeof V=="string"&&(V=V.replace(/,/g,",,")),z+=q+","+V+","}return z}function $(ee){const z={_key:F(ee),type:ee.taskType};return Object.assign(z,ee),z}U.create=$})(O=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var k;(function(U){function F($,ee){const B=C.TaskDefinitionRegistry.get($.type);if(B===void 0){const j=A.deepClone($);return delete j._key,O.create(j)}const z=Object.create(null);z.type=B.taskType;const q=new Set;B.required.forEach(j=>q.add(j));const V=B.properties;for(const j of Object.keys(V)){const ne=$[j];if(ne!=null)z[j]=ne;else if(q.has(j)){const Y=V[j];if(Y.default!==void 0)z[j]=A.deepClone(Y.default);else switch(Y.type){case"boolean":z[j]=!1;break;case"number":case"integer":z[j]=0;break;case"string":z[j]="";break;default:ee.error(u.localize(2,null,JSON.stringify($,void 0,0),j));return}}}return O.create(z)}U.createTaskIdentifier=F})(k=e.TaskDefinition||(e.TaskDefinition={}))}),define(Ie[235],ke([1,0,12]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class n{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((D,C)=>{this._actualOk=D,this._actualErr=C,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(D){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=D,this._actual&&this._actualOk(D))}resolveErr(D){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=D,this._actual?this._actualErr(D):(0,u.onUnexpectedError)(D))}then(D,C){return this._ensureActual().then(D,C)}catch(D){return this._ensureActual().then(void 0,D)}finally(D){return this._ensureActual().finally(D)}}e.LazyPromise=n;class y extends n{constructor(){super();this._hasErr=!0,this._err=new u.CancellationError}}e.CanceledLazyPromise=y}),define(Ie[53],ke([1,0]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class u{constructor(S){this._proxyIdentifierBrand=void 0,this.sid=S,this.nid=++u.count}}e.ProxyIdentifier=u,u.count=0;const n=[];function y(C){const S=new u(C);return n[S.nid]=S,S}e.createProxyIdentifier=y;function A(C){return n[C].sid}e.getStringIdentifierForProxy=A;class D{constructor(S){this.value=S}}e.SerializableObjectWithBuffers=D}),define(Ie[5],ke([1,0,61,2,53]),function(Q,e,u,n,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var A;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(A=e.TextEditorRevealType||(e.TextEditorRevealType={}));var D;(function(f){f[f.UnknownInput=0]="UnknownInput",f[f.TextInput=1]="TextInput",f[f.TextDiffInput=2]="TextDiffInput",f[f.NotebookInput=3]="NotebookInput",f[f.NotebookDiffInput=4]="NotebookDiffInput",f[f.CustomEditorInput=5]="CustomEditorInput",f[f.WebviewEditorInput=6]="WebviewEditorInput",f[f.TerminalEditorInput=7]="TerminalEditorInput"})(D=e.TabInputKind||(e.TabInputKind={}));var C;(function(f){f[f.TAB_OPEN=0]="TAB_OPEN",f[f.TAB_CLOSE=1]="TAB_CLOSE",f[f.TAB_UPDATE=2]="TAB_UPDATE",f[f.TAB_MOVE=3]="TAB_MOVE"})(C=e.TabModelOperationKind||(e.TabModelOperationKind={}));var S;(function(f){f[f.Editable=0]="Editable",f[f.SupportsHotExit=1]="SupportsHotExit"})(S=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var P;(function(f){f[f.Int8Array=1]="Int8Array",f[f.Uint8Array=2]="Uint8Array",f[f.Uint8ClampedArray=3]="Uint8ClampedArray",f[f.Int16Array=4]="Int16Array",f[f.Uint16Array=5]="Uint16Array",f[f.Int32Array=6]="Int32Array",f[f.Uint32Array=7]="Uint32Array",f[f.Float32Array=8]="Float32Array",f[f.Float64Array=9]="Float64Array",f[f.BigInt64Array=10]="BigInt64Array",f[f.BigUint64Array=11]="BigUint64Array"})(P=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var L;(function(f){f[f.Text=1]="Text",f[f.Error=2]="Error",f[f.Rich=3]="Rich"})(L=e.CellOutputKind||(e.CellOutputKind={}));var I;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(I=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var _;(function(f){f[f.None=0]="None",f[f.Process=1]="Process",f[f.Output=2]="Output"})(_=e.CandidatePortSource||(e.CandidatePortSource={}));class T{static mixin(a){return a._id=T._n++,a}}e.IdObject=T,T._n=0;var w;(function(f){f.label="a",f.kind="b",f.detail="c",f.documentation="d",f.sortText="e",f.filterText="f",f.preselect="g",f.insertText="h",f.insertTextRules="i",f.range="j",f.commitCharacters="k",f.additionalTextEdits="l",f.command="m",f.kindModifier="n"})(w=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var b;(function(f){f.defaultRanges="a",f.completions="b",f.isIncomplete="c",f.duration="d"})(b=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var p;(function(f){f[f.File=1]="File",f[f.Text=2]="Text",f[f.Cell=3]="Cell"})(p=e.WorkspaceEditType||(e.WorkspaceEditType={}));function g(f){if(f&&f.edits)for(const a of f.edits)typeof a.resource=="object"?a.resource=n.URI.revive(a.resource):(a.newUri=n.URI.revive(a.newUri),a.oldUri=n.URI.revive(a.oldUri)),a.metadata&&a.metadata.iconPath&&(a.metadata=(0,u.revive)(a.metadata));return f}e.reviveWorkspaceEditDto=g;var v;(function(f){f[f.Workspace=0]="Workspace",f[f.TextDocument=1]="TextDocument"})(v=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,y.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,y.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,y.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,y.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,y.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,y.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,y.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,y.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,y.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,y.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,y.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,y.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,y.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,y.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,y.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,y.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,y.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,y.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,y.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,y.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,y.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,y.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,y.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,y.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,y.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,y.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,y.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,y.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,y.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,y.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,y.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,y.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,y.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,y.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,y.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,y.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,y.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,y.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,y.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,y.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,y.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,y.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,y.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,y.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,y.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,y.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,y.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,y.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,y.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,y.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,y.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,y.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,y.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,y.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,y.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,y.createProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,y.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,y.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,y.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,y.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,y.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,y.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,y.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,y.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,y.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,y.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,y.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,y.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,y.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,y.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,y.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,y.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,y.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,y.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,y.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,y.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,y.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,y.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,y.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,y.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,y.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,y.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,y.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,y.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,y.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,y.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,y.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,y.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,y.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,y.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,y.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,y.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,y.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,y.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,y.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,y.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,y.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,y.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,y.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,y.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,y.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,y.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,y.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,y.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,y.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,y.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,y.createProxyIdentifier)("ExtHostTelemetry")}}),define(Ie[90],ke([1,0,5,3,4]),function(Q,e,u,n,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class A{constructor(C){this._onDidChangePassword=new n.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=C.getProxy(u.MainContext.MainThreadSecretState)}async $onDidChangePassword(C){this._onDidChangePassword.fire(C)}get(C,S){return this._proxy.$getPassword(C,S)}store(C,S,P){return this._proxy.$setPassword(C,S,P)}delete(C,S){return this._proxy.$deletePassword(C,S)}}e.ExtHostSecretState=A,e.IExtHostSecretState=(0,y.createDecorator)("IExtHostSecretState")}),define(Ie[68],ke([1,0,4,14,5,17]),function(Q,e,u,n,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,u.createDecorator)("IExtHostApiDeprecationService");let D=class{constructor(S,P){this._extHostLogService=P,this._reportedUsages=new Set,this._telemetryShape=S.getProxy(y.MainContext.MainThreadTelemetry)}report(S,P,L){const I=this.getUsageKey(S,P);this._reportedUsages.has(I)||(this._reportedUsages.add(I),P.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${S}' is deprecated. ${L}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:P.identifier.value,apiId:S}))}getUsageKey(S,P){return`${S}-${P.identifier.value}`}};D=Ge([$e(0,A.IExtHostRpcService),$e(1,n.ILogService)],D),e.ExtHostApiDeprecationService=D,e.NullApiDeprecationService=Object.freeze(new class{report(C,S,P){}})}),define(Ie[236],ke([1,0,3,5,7,28]),function(Q,e,u,n,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class D{constructor(S){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new u.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=S.getProxy(n.MainContext.MainThreadAuthentication)}$setProviders(S){return this._providers=S,Promise.resolve()}async getSession(S,P,L,I={}){const _=A.ExtensionIdentifier.toKey(S.identifier),T=this._inFlightRequests.get(_)||[],w=[...L].sort().join(" ");let b=T.find(p=>p.providerId===P&&p.scopes===w);if(b)return b.result;{const p=this._getSession(S,_,P,L,I);b={providerId:P,scopes:w,result:p},T.push(b),this._inFlightRequests.set(_,T);try{await p}finally{const g=T.findIndex(v=>v.providerId===P&&v.scopes===w);g>-1&&(T.splice(g),this._inFlightRequests.set(_,T))}return p}}async _getSession(S,P,L,I,_={}){await this._proxy.$ensureProvider(L);const T=S.displayName||S.name;return this._proxy.$getSession(L,I,P,T,_)}async removeSession(S,P){const L=this._authenticationProviders.get(S);return L?L.provider.removeSession(P):this._proxy.$removeSession(S,P)}registerAuthenticationProvider(S,P,L,I){if(this._authenticationProviders.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this._authenticationProviders.set(S,{label:P,provider:L,options:I??{supportsMultipleAccounts:!1}}),this._providers.find(T=>T.id===S)||this._providers.push({id:S,label:P});const _=L.onDidChangeSessions(T=>{this._proxy.$sendDidChangeSessions(S,{added:T.added??[],changed:T.changed??[],removed:T.removed??[]})});return this._proxy.$registerAuthenticationProvider(S,P,I?.supportsMultipleAccounts??!1),new y.Disposable(()=>{_.dispose(),this._authenticationProviders.delete(S);const T=this._providers.findIndex(w=>w.id===S);T>-1&&this._providers.splice(T),this._proxy.$unregisterAuthenticationProvider(S)})}$createSession(S,P){const L=this._authenticationProviders.get(S);if(L)return Promise.resolve(L.provider.createSession(P));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,P){const L=this._authenticationProviders.get(S);if(L)return Promise.resolve(L.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,P){const L=this._authenticationProviders.get(S);if(L)return Promise.resolve(L.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,P){return this._onDidChangeSessions.fire({provider:{id:S,label:P}}),Promise.resolve()}}e.ExtHostAuthentication=D}),define(Ie[237],ke([1,0,5,17,15,27]),function(Q,e,u,n,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let D=class{constructor(S,P){this._proxy=S.getProxy(u.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:L=>P.getDocument(L)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(S,P){const L=(0,A.isProposedApiEnabled)(P,"snippetWorkspaceEdit"),I=y.WorkspaceEdit.from(S,this._versionInformationProvider,L);return this._proxy.$tryApplyWorkspaceEdit(I)}};D=Ge([$e(0,n.IExtHostRpcService)],D),e.ExtHostBulkEdits=D}),define(Ie[238],ke([1,0,5]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class n{constructor(A){const D=A.getProxy(u.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return D.$readText()},writeText(C){return D.$writeText(C)}})}}e.ExtHostClipboard=n});var tt=this&&this.__classPrivateFieldSet||function(Q,e,u,n,y){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!y:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?y.call(Q,u):y?y.value=u:e.set(Q,u),u},Me=this&&this.__classPrivateFieldGet||function(Q,e,u,n){if(u==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!n:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?n:u==="a"?n.call(Q):n?n.value:e.get(Q)};define(Ie[37],ke([1,0,10,7,15,24,5,16,14,61,35,48,2,6,4,17,132,23,53,49]),function(Q,e,u,n,y,A,D,C,S,P,L,I,_,T,w,b,p,g,v,f){"use strict";var a,m;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let o=class{constructor(c,l){a.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,m.set(this,void 0),tt(this,a,c.getProxy(D.MainContext.MainThreadCommands),"f"),this._logService=l,tt(this,m,c.getProxy(D.MainContext.MainThreadTelemetry),"f"),this.converter=new d(this,h=>{const E=this._apiCommands.get(h);return E?.result===s.Void?E:void 0},l),this._argumentProcessors=[{processArgument(h){return(0,P.revive)(h)}},{processArgument(h){return(0,A.cloneAndChange)(h,function(E){if(L.Range.isIRange(E))return y.Range.to(E);if(I.Position.isIPosition(E))return y.Position.to(E);if(L.Range.isIRange(E.range)&&_.URI.isUri(E.uri))return y.location.to(E);if(E instanceof g.VSBuffer)return E.buffer.buffer;if(!Array.isArray(E))return E})}}]}registerArgumentProcessor(c){this._argumentProcessors.push(c)}registerApiCommand(c){const l=this.registerCommand(!1,c.id,async(...h)=>{const E=c.args.map((N,O)=>{if(!N.validate(h[O]))throw new Error(`Invalid argument '${N.name}' when running '${c.id}', received: ${h[O]}`);return N.convert(h[O])}),R=await this.executeCommand(c.internalId,...E);return c.result.convert(R,h,this.converter)},void 0,{description:c.description,args:c.args,returns:c.result.description});return this._apiCommands.set(c.id,c),new n.Disposable(()=>{l.dispose(),this._apiCommands.delete(c.id)})}registerCommand(c,l,h,E,R,N){if(this._logService.trace("ExtHostCommands#registerCommand",l),!l.trim().length)throw new Error("invalid id");if(this._commands.has(l))throw new Error(`command '${l}' already exists`);return this._commands.set(l,{callback:h,thisArg:E,description:R,extension:N}),c&&Me(this,a,"f").$registerCommand(l),new n.Disposable(()=>{this._commands.delete(l)&&c&&Me(this,a,"f").$unregisterCommand(l)})}executeCommand(c,...l){return this._logService.trace("ExtHostCommands#executeCommand",c),this._doExecuteCommand(c,l,!0)}async _doExecuteCommand(c,l,h){if(this._commands.has(c))return Me(this,a,"f").$fireCommandActivationEvent(c),this._executeContributedCommand(c,l,!1);{let E=!1;const R=(0,A.cloneAndChange)(l,function(N){if(N instanceof n.Position)return y.Position.from(N);if(N instanceof n.Range)return y.Range.from(N);if(N instanceof n.Location)return y.location.from(N);if(n.NotebookRange.isNotebookRange(N))return y.NotebookRange.from(N);if(N instanceof ArrayBuffer)return E=!0,g.VSBuffer.wrap(new Uint8Array(N));if(N instanceof Uint8Array)return E=!0,g.VSBuffer.wrap(N);if(N instanceof g.VSBuffer)return E=!0,N;if(!Array.isArray(N))return N});try{const N=await Me(this,a,"f").$executeCommand(c,E?new v.SerializableObjectWithBuffers(R):R,h);return(0,P.revive)(N)}catch(N){if(N instanceof Error&&N.message==="$executeCommand:retry")return this._doExecuteCommand(c,l,!1);throw N}}}async _executeContributedCommand(c,l,h){const E=this._commands.get(c);if(!E)throw new Error("Unknown command");this._reportTelemetry(E,c);const{callback:R,thisArg:N,description:O}=E;if(O)for(let k=0;k<O.args.length;k++)try{(0,u.validateConstraint)(l[k],O.args[k].constraint)}catch{throw new Error(`Running the contributed command: '${c}' failed. Illegal argument '${O.args[k].name}' - ${O.args[k].description}`)}try{return await R.apply(N,l)}catch(k){if(c===this.converter.delegatingCommandId){const U=this.converter.getActualCommand(...l);U&&(c=U.command)}throw this._logService.error(k,c,E.extension?.identifier),h?new class extends Error{constructor(){super((0,f.toErrorMessage)(k));this.id=c,this.source=E.extension?.displayName??E.extension?.name}}:k}}_reportTelemetry(c,l){!c.extension||c.extension.isBuiltin||Me(this,m,"f").$publicLog2("Extension:ActionExecuted",{extensionId:c.extension.identifier.value,id:l})}$executeContributedCommand(c,...l){return this._logService.trace("ExtHostCommands#$executeContributedCommand",c),this._commands.has(c)?(l=l.map(h=>this._argumentProcessors.reduce((E,R)=>R.processArgument(E),h)),this._executeContributedCommand(c,l,!0)):Promise.reject(new Error(`Contributed command '${c}' does not exist.`))}getCommands(c=!1){return this._logService.trace("ExtHostCommands#getCommands",c),Me(this,a,"f").$getCommands().then(l=>(c&&(l=l.filter(h=>h[0]!=="_")),l))}$getContributedCommandHandlerDescriptions(){const c=Object.create(null);for(const[l,h]of this._commands){const{description:E}=h;E&&(c[l]=E)}return Promise.resolve(c)}};a=new WeakMap,m=new WeakMap,o=Ge([$e(0,b.IExtHostRpcService),$e(1,S.ILogService)],o),e.ExtHostCommands=o,e.IExtHostCommands=(0,w.createDecorator)("IExtHostCommands");class d{constructor(c,l,h){this._commands=c,this._lookupApiCommand=l,this._logService=h,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(c,l){if(!c)return;const h={$ident:void 0,id:c.command,title:c.title,tooltip:c.tooltip};if(!c.command)return h;const E=this._lookupApiCommand(c.command);if(E)h.id=E.internalId,h.arguments=E.args.map((R,N)=>R.convert(c.arguments&&c.arguments[N]));else if((0,C.isNonEmptyArray)(c.arguments)){const R=++this._cachIdPool;this._cache.set(R,c),l.add((0,T.toDisposable)(()=>{this._cache.delete(R),this._logService.trace("CommandsConverter#DISPOSE",R)})),h.$ident=R,h.id=this.delegatingCommandId,h.arguments=[R],this._logService.trace("CommandsConverter#CREATE",c.command,R)}return h}fromInternal(c){return typeof c.$ident=="number"?this._cache.get(c.$ident):{command:c.id,title:c.title,arguments:c.arguments}}getActualCommand(...c){return this._cache.get(c[0])}_executeConvertedCommand(...c){const l=this.getActualCommand(...c);return this._logService.trace("CommandsConverter#EXECUTE",c[0],l?l.command:"MISSING"),l?this._commands.executeCommand(l.command,...l.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=d;class r{constructor(c,l,h,E){this.name=c,this.description=l,this.validate=h,this.convert=E}optional(){return new r(this.name,`(optional) ${this.description}`,c=>c==null||this.validate(c),c=>c===void 0?void 0:c===null?null:this.convert(c))}with(c,l){return new r(c??this.name,l??this.description,this.validate,this.convert)}}e.ApiCommandArgument=r,r.Uri=new r("uri","Uri of a text document",t=>_.URI.isUri(t),t=>t),r.Position=new r("position","A position in a text document",t=>n.Position.isPosition(t),y.Position.from),r.Range=new r("range","A range in a text document",t=>n.Range.isRange(t),y.Range.from),r.Selection=new r("selection","A selection in a text document",t=>n.Selection.isSelection(t),y.Selection.from),r.Number=new r("number","",t=>typeof t=="number",t=>t),r.String=new r("string","",t=>typeof t=="string",t=>t),r.CallHierarchyItem=new r("item","A call hierarchy item",t=>t instanceof n.CallHierarchyItem,y.CallHierarchyItem.from),r.TypeHierarchyItem=new r("item","A type hierarchy item",t=>t instanceof n.TypeHierarchyItem,y.TypeHierarchyItem.from),r.TestItem=new r("testItem","A VS Code TestItem",t=>t instanceof p.TestItemImpl,y.TestItem.from);class s{constructor(c,l){this.description=c,this.convert=l}}e.ApiCommandResult=s,s.Void=new s("no result",t=>t);class i{constructor(c,l,h,E,R){this.id=c,this.internalId=l,this.description=h,this.args=E,this.result=R}}e.ApiCommand=i}),define(Ie[239],ke([1,0,2,15,7,64,37,16,112,117,11]),function(Q,e,u,n,y,A,D,C,S,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const I=[new D.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",T(n.DocumentHighlight.to))),new D.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(b,p)=>{if((0,C.isFalsyOrEmpty)(b))return;class g extends y.SymbolInformation{static to(f){const a=new g(f.name,n.SymbolKind.to(f.kind),f.containerName||"",new y.Location(p[0],n.Range.to(f.range)));return a.detail=f.detail,a.range=a.location.range,a.selectionRange=n.Range.to(f.selectionRange),a.children=f.children?f.children.map(g.to):[],a}}return b.map(g.to)})),new D.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("options","Formatting options",b=>!0,b=>b)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(n.TextEdit.to))),new D.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range,new D.ApiCommandArgument("options","Formatting options",b=>!0,b=>b)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(n.TextEdit.to))),new D.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,new D.ApiCommandArgument("ch","Trigger character",b=>typeof b=="string",b=>b),new D.ApiCommandArgument("options","Formatting options",b=>!0,b=>b)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(n.TextEdit.to))),new D.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new D.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new D.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new D.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new D.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location-instances.",T(n.location.to))),new D.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Hover-instances.",T(n.Hover.to))),new D.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("position","A position in a text document",b=>Array.isArray(b)&&b.every(p=>y.Position.isPosition(p)),b=>b.map(n.Position.from))],new D.ApiCommandResult("A promise that resolves to an array of ranges.",b=>b.map(p=>{let g;for(const v of p.reverse())g=new y.SelectionRange(n.Range.to(v),g);return g}))),new D.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[D.ApiCommandArgument.String.with("query","Search string")],new D.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",b=>b.map(n.WorkspaceSymbol.to))),new D.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A CallHierarchyItem or undefined",b=>b.map(n.CallHierarchyItem.to))),new D.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[D.ApiCommandArgument.CallHierarchyItem],new D.ApiCommandResult("A CallHierarchyItem or undefined",b=>b.map(n.CallHierarchyIncomingCall.to))),new D.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[D.ApiCommandArgument.CallHierarchyItem],new D.ApiCommandResult("A CallHierarchyItem or undefined",b=>b.map(n.CallHierarchyOutgoingCall.to))),new D.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to a range and placeholder text.",b=>{if(!!b)return{range:n.Range.to(b.range),placeholder:b.text}})),new D.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("newName","The new symbol name")],new D.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",b=>{if(!!b){if(b.rejectReason)throw new Error(b.rejectReason);return n.WorkspaceEdit.to(b)}})),new D.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new D.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",b=>b.map(n.DocumentLink.to))),new D.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",b=>{if(!!b)return new y.SemanticTokensLegend(b.tokenTypes,b.tokenModifiers)})),new D.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokens.",b=>{if(!b)return;const p=(0,S.decodeSemanticTokensDto)(b);if(p.type==="full")return new y.SemanticTokens(p.data,void 0)})),new D.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range.optional()],new D.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",b=>{if(!!b)return new y.SemanticTokensLegend(b.tokenTypes,b.tokenModifiers)})),new D.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to SemanticTokens.",b=>{if(!b)return;const p=(0,S.decodeSemanticTokensDto)(b);if(p.type==="full")return new y.SemanticTokens(p.data,void 0)})),new D.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),D.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new D.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(b,p,g)=>{if(!b)return new y.CompletionList([]);const v=b.suggestions.map(f=>n.CompletionItem.to(f,g));return new y.CompletionList(v,b.incomplete)})),new D.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new D.ApiCommandResult("A promise that resolves to SignatureHelp.",b=>{if(b)return n.SignatureHelp.to(b)})),new D.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new D.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(b,p,g)=>T(v=>new y.CodeLens(n.Range.to(v.range),v.command&&g.fromInternal(v.command)))(b))),new D.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",b=>y.Range.isRange(b),b=>y.Selection.isSelection(b)?n.Selection.from(b):n.Range.from(b)),D.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),D.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new D.ApiCommandResult("A promise that resolves to an array of Command-instances.",(b,p,g)=>T(v=>{if(v._isSynthetic){if(!v.command)throw new Error("Synthetic code actions must have a command");return g.fromInternal(v.command)}else{const f=new y.CodeAction(v.title,v.kind?new y.CodeActionKind(v.kind):void 0);return v.edit&&(f.edit=n.WorkspaceEdit.to(v.edit)),v.command&&(f.command=g.fromInternal(v.command)),f.isPreferred=v.isPreferred,f}})(b))),new D.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",b=>b?b.map(p=>new y.ColorInformation(n.Range.to(p.range),n.Color.to(p.color))):[])),new D.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new D.ApiCommandArgument("color","The color to show and insert",b=>b instanceof y.Color,n.Color.from),new D.ApiCommandArgument("context","Context object with uri and range",b=>!0,b=>({uri:b.uri,range:n.Range.from(b.range)}))],new D.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",b=>b?b.map(n.ColorPresentation.to):[])),new D.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to an array of Inlay objects",(b,p,g)=>b.map(n.InlayHint.to.bind(void 0,g)))),new D.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new D.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",T(b=>({viewType:b.viewType,displayName:b.displayName,options:{transientOutputs:b.options.transientOutputs,transientCellMetadata:b.options.transientCellMetadata,transientDocumentMetadata:b.options.transientDocumentMetadata},filenamePattern:b.filenamePattern.map(p=>n.NotebookExclusiveDocumentPattern.to(p))})))),new D.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to an array of InlineValue objects",b=>b.map(n.InlineValue.to))),new D.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new D.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",b=>u.URI.isUri(b)||typeof b=="string"&&(0,P.matchesSomeScheme)(b,L.Schemas.http,L.Schemas.https),b=>b),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",b=>b===void 0||typeof b=="number"||typeof b=="object",b=>b&&(typeof b=="number"?[n.ViewColumn.from(b),void 0]:[n.ViewColumn.from(b.viewColumn),n.TextEditorOpenOptions.from(b)])).optional(),D.ApiCommandArgument.String.with("label","").optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[D.ApiCommandArgument.Uri.with("resource","Resource to open"),D.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",b=>b===void 0||typeof b=="number"||typeof b=="object",b=>b&&(typeof b=="number"?[n.ViewColumn.from(b),void 0]:[n.ViewColumn.from(b.viewColumn),n.TextEditorOpenOptions.from(b)])).optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[D.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),D.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),D.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",b=>b===void 0||typeof b=="object",b=>b&&[n.ViewColumn.from(b.viewColumn),n.TextEditorOpenOptions.from(b)]).optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A TypeHierarchyItem or undefined",b=>b.map(n.TypeHierarchyItem.to))),new D.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[D.ApiCommandArgument.TypeHierarchyItem],new D.ApiCommandResult("A TypeHierarchyItem or undefined",b=>b.map(n.TypeHierarchyItem.to))),new D.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[D.ApiCommandArgument.TypeHierarchyItem],new D.ApiCommandResult("A TypeHierarchyItem or undefined",b=>b.map(n.TypeHierarchyItem.to))),new D.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[D.ApiCommandArgument.TestItem],D.ApiCommandResult.Void),new D.ApiCommand("vscode.experimental.editSession.continue","_workbench.experimental.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[D.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],D.ApiCommandResult.Void)];class _{static register(p){I.forEach(p.registerApiCommand,p)}}e.ExtHostApiCommands=_;function T(b){return p=>{if(Array.isArray(p))return p.map(b)}}function w(b){if(!Array.isArray(b))return;const p=[];for(const g of b)A.isLocationLink(g)?p.push(n.DefinitionLink.to(g)):p.push(n.location.to(g));return p}}),define(Ie[240],ke([1,0,18,57,3,6,2,64,28,15,7,27,5]),function(Q,e,u,n,y,A,D,C,S,P,L,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function T(w,b,p){const g=w.getProxy(_.MainContext.MainThreadComments);class v{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,b.registerArgumentProcessor({processArgument:t=>{if(t&&t.$mid===6){const c=this._commentControllers.get(t.handle);return c?c.value:t}else if(t&&t.$mid===7){const c=this._commentControllers.get(t.commentControlHandle);if(!c)return t;const l=c.getCommentThread(t.commentThreadHandle);return l?l.value:t}else if(t&&t.$mid===8){const c=this._commentControllers.get(t.thread.commentControlHandle);if(!c)return t;const l=c.getCommentThread(t.thread.commentThreadHandle);return l?{thread:l.value,text:t.text}:t}else if(t&&t.$mid===9){const c=this._commentControllers.get(t.thread.commentControlHandle);if(!c)return t;const l=c.getCommentThread(t.thread.commentThreadHandle);if(!l)return t;const h=t.commentUniqueId,E=l.getCommentByUniqueId(h);return E||t}else if(t&&t.$mid===10){const c=this._commentControllers.get(t.thread.commentControlHandle);if(!c)return t;const l=c.getCommentThread(t.thread.commentThreadHandle);if(!l)return t;const h=t.text,E=t.commentUniqueId,R=l.getCommentByUniqueId(E);return R?(R.body=h,R):t}return t}})}createCommentController(t,c,l){const h=v.handlePool++,E=new a(t,h,c,l);this._commentControllers.set(E.handle,E);const R=this._commentControllersByExtension.get(S.ExtensionIdentifier.toKey(t.identifier))||[];return R.push(E),this._commentControllersByExtension.set(S.ExtensionIdentifier.toKey(t.identifier),R),E.value}$createCommentThreadTemplate(t,c,l){const h=this._commentControllers.get(t);!h||h.$createCommentThreadTemplate(c,l)}async $updateCommentThreadTemplate(t,c,l){const h=this._commentControllers.get(t);!h||h.$updateCommentThreadTemplate(c,l)}$deleteCommentThread(t,c){this._commentControllers.get(t)?.$deleteCommentThread(c)}$provideCommentingRanges(t,c,l){const h=this._commentControllers.get(t);if(!h||!h.commentingRangeProvider)return Promise.resolve(void 0);const E=p.getDocument(D.URI.revive(c));return(0,u.asPromise)(()=>h.commentingRangeProvider.provideCommentingRanges(E,l)).then(R=>R?R.map(N=>P.Range.from(N)):void 0)}$toggleReaction(t,c,l,h,E){const R=this._commentControllers.get(t);return!R||!R.reactionHandler?Promise.resolve(void 0):(0,u.asPromise)(()=>{const N=R.getCommentThread(c);if(N){const O=N.getCommentByUniqueId(h.uniqueIdInThread);if(R!==void 0&&O&&R.reactionHandler)return R.reactionHandler(O,d(E))}return Promise.resolve(void 0)})}dispose(){}}v.handlePool=0;class f{constructor(t,c,l,h,E,R,N,O){this._commentControllerHandle=c,this._id=l,this._uri=h,this._range=E,this._comments=R,this.extensionDescription=N,this._isTemplate=O,this.handle=f._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new y.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputDisposables.value=new A.DisposableStore,this._id===void 0&&(this._id=`${t}.${this.handle}`),g.$createCommentThread(c,this.handle,this._id,this._uri,P.Range.from(this._range),N.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=R,this._localDisposables.push({dispose:()=>{g.$deleteCommentThread(c,this.handle)}});const k=this;this.value={get uri(){return k.uri},get range(){return k.range},set range(U){k.range=U},get comments(){return k.comments},set comments(U){k.comments=U},get collapsibleState(){return k.collapsibleState},set collapsibleState(U){k.collapsibleState=U},get canReply(){return k.canReply},set canReply(U){k.canReply=U},get contextValue(){return k.contextValue},set contextValue(U){k.contextValue=U},get label(){return k.label},set label(U){k.label=U},get state(){return k.state},set state(U){k.state=U},dispose:()=>{k.dispose()}}}set threadId(t){this._id=t}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(t){t.isEqual(this._range)||(this._range=t,this.modifications.range=t,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(t){this._canReply!==t&&(this._canReply=t,this.modifications.canReply=t,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(t){this._label=t,this.modifications.label=t,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(t){this._contextValue=t,this.modifications.contextValue=t,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(t){this._comments=t,this.modifications.comments=t,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(t){this._collapseState=t,this.modifications.collapsibleState=t,this._onDidUpdateCommentThread.fire()}get state(){return(0,I.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state}set state(t){(0,I.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state=t,this.modifications.state=t,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new A.DisposableStore);const t=l=>Object.prototype.hasOwnProperty.call(this.modifications,l),c={};t("range")&&(c.range=P.Range.from(this._range)),t("label")&&(c.label=this.label),t("contextValue")&&(c.contextValue=this.contextValue??null),t("comments")&&(c.comments=this._comments.map(l=>m(this,l,this._commentsMap))),t("collapsibleState")&&(c.collapseState=r(this._collapseState)),t("canReply")&&(c.canReply=this.canReply),t("state")&&(c.state=s(this._state)),t("isTemplate")&&(c.isTemplate=this._isTemplate),this.modifications={},g.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,c)}getCommentByUniqueId(t){for(const c of this._commentsMap){const l=c[0],h=c[1];if(t===h)return l}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(t=>t.dispose())}}f._handlePool=0,Ge([(0,n.debounce)(100)],f.prototype,"eventuallyUpdateCommentThread",null);class a{constructor(t,c,l,h){this._extension=t,this._handle=c,this._id=l,this._label=h,this._threads=new Map,g.$registerCommentController(this.handle,l,h);const E=this;this.value=Object.freeze({id:E.id,label:E.label,get options(){return E.options},set options(R){E.options=R},get commentingRangeProvider(){return E.commentingRangeProvider},set commentingRangeProvider(R){E.commentingRangeProvider=R},get reactionHandler(){return E.reactionHandler},set reactionHandler(R){E.reactionHandler=R},createCommentThread(R,N,O){return E.createCommentThread(R,N,O).value},dispose:()=>{E.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{g.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(t){this._commentingRangeProvider=t,g.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(t){this._reactionHandler=t,g.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!t})}get options(){return this._options}set options(t){this._options=t,g.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(t,c,l,h){if(typeof t=="string"){const E=new f(this.id,this.handle,t,c,l,h,this._extension,!1);return this._threads.set(E.handle,E),E}else{const E=new f(this.id,this.handle,void 0,t,c,l,this._extension,!1);return this._threads.set(E.handle,E),E}}$createCommentThreadTemplate(t,c){const l=new f(this.id,this.handle,void 0,D.URI.revive(t),P.Range.to(c),[],this._extension,!0);return l.collapsibleState=C.CommentThreadCollapsibleState.Expanded,this._threads.set(l.handle,l),l}$updateCommentThreadTemplate(t,c){const l=this._threads.get(t);l&&(l.range=P.Range.to(c))}$deleteCommentThread(t){const c=this._threads.get(t);c&&c.dispose(),this._threads.delete(t)}getCommentThread(t){return this._threads.get(t)}dispose(){this._threads.forEach(t=>{t.dispose()}),this._localDisposables.forEach(t=>t.dispose())}}function m(i,t,c){let l=c.get(t);l||(l=++i.commentHandle,c.set(t,l));const h=t.author&&t.author.iconPath?t.author.iconPath.toString():void 0;return{mode:t.mode,contextValue:t.contextValue,uniqueIdInThread:l,body:typeof t.body=="string"?t.body:P.MarkdownString.from(t.body),userName:t.author.name,userIconPath:h,label:t.label,commentReactions:t.reactions?t.reactions.map(E=>o(E)):void 0,timestamp:t.timestamp?.toJSON()}}function o(i){return{label:i.label,iconPath:i.iconPath?P.pathOrURIToURI(i.iconPath):void 0,count:i.count,hasReacted:i.authorHasReacted}}function d(i){return{label:i.label||"",count:i.count||0,iconPath:i.iconPath?D.URI.revive(i.iconPath):"",authorHasReacted:i.hasReacted||!1}}function r(i){if(i!==void 0)switch(i){case L.CommentThreadCollapsibleState.Expanded:return C.CommentThreadCollapsibleState.Expanded;case L.CommentThreadCollapsibleState.Collapsed:return C.CommentThreadCollapsibleState.Collapsed}return C.CommentThreadCollapsibleState.Collapsed}function s(i){if(i!==void 0)switch(i){case L.CommentThreadState.Unresolved:return C.CommentThreadState.Unresolved;case L.CommentThreadState.Resolved:return C.CommentThreadState.Resolved}return C.CommentThreadState.Unresolved}return new v}e.createExtHostComments=T}),define(Ie[241],ke([1,0,24,5,26,17]),function(Q,e,u,n,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let D=class{constructor(L,I){this._mainThreadConsole=L.getProxy(n.MainContext.MainThreadConsole),this._includeStack=I.consoleForward.includeStack,this._logNative=I.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(L,I){const _=this,T=console[L];Object.defineProperty(console,L,{set:()=>{},get:()=>function(){_._handleConsoleCall(L,I,T,arguments)}})}_handleConsoleCall(L,I,_,T){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:I,arguments:S(T,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(L,_,T)}};D=Ge([$e(0,A.IExtHostRpcService),$e(1,y.IExtHostInitDataService)],D),e.AbstractExtHostConsoleForwarder=D;const C=1e5;function S(P,L){const I=[];if(P.length)for(let _=0;_<P.length;_++){let T=P[_];if(typeof T=="undefined")T="undefined";else if(T instanceof Error){const w=T;w.stack?T=w.stack:T=w.toString()}I.push(T)}if(L){const _=new Error().stack;_&&I.push({__$stack:_.split(`
`).slice(3).join(`
`)})}try{const _=(0,u.safeStringify)(I);return _.length>C?"Output omitted for a large object that exceeds the limits":_}catch(_){return`Output omitted for an object that cannot be inspected ('${_.toString()}')`}}}),define(Ie[135],ke([1,0,2,5,7,4,17,14,16,8,9]),function(Q,e,u,n,y,A,D,C,S,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let I=class Dn{constructor(T,w){this._logService=w,this._provider=new Map,this._proxy=T.getProxy(n.MainContext.MainThreadDecorations)}registerFileDecorationProvider(T,w){const b=Dn._handlePool++;this._provider.set(b,{provider:T,extensionId:w}),this._proxy.$registerDecorationProvider(b,w.value);const p=T.onDidChangeFileDecorations&&T.onDidChangeFileDecorations(g=>{if(!g){this._proxy.$onDidChange(b,null);return}const v=(0,S.asArray)(g);if(v.length<=Dn._maxEventSize){this._proxy.$onDidChange(b,v);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",w.value,v.length);const f=v.map(o=>({uri:o,rank:(0,P.count)(o.path,"/")})),a=(0,S.groupBy)(f,(o,d)=>o.rank-d.rank||(0,P.compare)(o.uri.path,d.uri.path)),m=[];e:for(const o of a){let d;for(const r of o){const s=(0,L.dirname)(r.uri.path);if(d!==s&&(d=s,m.push(r.uri)>=Dn._maxEventSize))break e}}this._proxy.$onDidChange(b,m)});return new y.Disposable(()=>{p?.dispose(),this._proxy.$unregisterDecorationProvider(b),this._provider.delete(b)})}async $provideDecorations(T,w,b){if(!this._provider.has(T))return Object.create(null);const p=Object.create(null),{provider:g,extensionId:v}=this._provider.get(T);return await Promise.all(w.map(async f=>{try{const{uri:a,id:m}=f,o=await Promise.resolve(g.provideFileDecoration(u.URI.revive(a),b));if(!o)return;try{y.FileDecoration.validate(o),p[m]=[o.propagate,o.tooltip,o.badge,o.color]}catch(d){this._logService.warn(`INVALID decoration from extension '${v.value}': ${d}`)}}catch(a){this._logService.error(a)}})),p}};I._handlePool=0,I._maxEventSize=250,I=Ge([$e(0,D.IExtHostRpcService),$e(1,C.ILogService)],I),e.ExtHostDecorations=I,e.IExtHostDecorations=(0,A.createDecorator)("IExtHostDecorations")});var tt=this&&this.__classPrivateFieldSet||function(Q,e,u,n,y){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!y:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?y.call(Q,u):y?y.value=u:e.set(Q,u),u},Me=this&&this.__classPrivateFieldGet||function(Q,e,u,n){if(u==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!n:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?n:u==="a"?n.call(Q):n?n.value:e.get(Q)};define(Ie[242],ke([1,0,171,116,2,5,7,15,3,14,25,46]),function(Q,e,u,n,y,A,D,C,S,P,L,I){"use strict";var _,T,w;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class b{constructor(v,f,a,m,o,d){this._name=v,this._owner=f,this._maxDiagnosticsPerFile=a,_.set(this,void 0),T.set(this,void 0),w.set(this,void 0),this._isDisposed=!1,tt(this,w,new L.ResourceMap(r=>m.getComparisonKey(r)),"f"),tt(this,_,o,"f"),tt(this,T,d,"f")}dispose(){this._isDisposed||(Me(this,T,"f").fire([...Me(this,w,"f").keys()]),Me(this,_,"f")?.$clear(this._owner),Me(this,w,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(v,f){if(!v){this.clear();return}this._checkDisposed();let a=[];if(y.URI.isUri(v)){if(!f){this.delete(v);return}Me(this,w,"f").set(v,f.slice()),a=[v]}else if(Array.isArray(v)){a=[];let o;v=[...v].sort(b._compareIndexedTuplesByUri);for(const d of v){const[r,s]=d;if((!o||r.toString()!==o.toString())&&(o&&Me(this,w,"f").get(o).length===0&&Me(this,w,"f").delete(o),o=r,a.push(r),Me(this,w,"f").set(r,[])),s)Me(this,w,"f").get(r)?.push(...s);else{const i=Me(this,w,"f").get(r);i&&(i.length=0)}}}if(Me(this,T,"f").fire(a),!Me(this,_,"f"))return;const m=[];for(const o of a){let d=[];const r=Me(this,w,"f").get(o);if(r)if(r.length>this._maxDiagnosticsPerFile){d=[];const s=[D.DiagnosticSeverity.Error,D.DiagnosticSeverity.Warning,D.DiagnosticSeverity.Information,D.DiagnosticSeverity.Hint];e:for(let i=0;i<4;i++)for(const t of r)if(t.severity===s[i]&&d.push(C.Diagnostic.from(t))===this._maxDiagnosticsPerFile)break e;d.push({severity:n.MarkerSeverity.Info,message:(0,u.localize)(0,null,r.length-this._maxDiagnosticsPerFile),startLineNumber:d[d.length-1].startLineNumber,startColumn:d[d.length-1].startColumn,endLineNumber:d[d.length-1].endLineNumber,endColumn:d[d.length-1].endColumn})}else d=r.map(s=>C.Diagnostic.from(s));m.push([o,d])}Me(this,_,"f").$changeMany(this._owner,m)}delete(v){this._checkDisposed(),Me(this,T,"f").fire([v]),Me(this,w,"f").delete(v),Me(this,_,"f")?.$changeMany(this._owner,[[v,void 0]])}clear(){this._checkDisposed(),Me(this,T,"f").fire([...Me(this,w,"f").keys()]),Me(this,w,"f").clear(),Me(this,_,"f")?.$clear(this._owner)}forEach(v,f){this._checkDisposed();for(const[a,m]of this)v.call(f,a,m,this)}*[(_=new WeakMap,T=new WeakMap,w=new WeakMap,Symbol.iterator)](){this._checkDisposed();for(const v of Me(this,w,"f").keys())yield[v,this.get(v)]}get(v){this._checkDisposed();const f=Me(this,w,"f").get(v);return Array.isArray(f)?Object.freeze(f.slice(0)):[]}has(v){return this._checkDisposed(),Array.isArray(Me(this,w,"f").get(v))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(v,f){return v[0].toString()<f[0].toString()?-1:v[0].toString()>f[0].toString()?1:0}}e.DiagnosticCollection=b;let p=class hn{constructor(v,f,a){this._logService=f,this._fileSystemInfoService=a,this._collections=new Map,this._onDidChangeDiagnostics=new S.DebounceEmitter({merge:m=>m.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this._onDidChangeDiagnostics.event,hn._mapper),this._proxy=v.getProxy(A.MainContext.MainThreadDiagnostics)}static _mapper(v){const f=new L.ResourceMap;for(const a of v)f.set(a,a);return{uris:Object.freeze(Array.from(f.values()))}}createDiagnosticCollection(v,f){const{_collections:a,_proxy:m,_onDidChangeDiagnostics:o,_logService:d,_fileSystemInfoService:r}=this,s=new class{$changeMany(c,l){m.$changeMany(c,l),d.trace("[DiagnosticCollection] change many (extension, owner, uris)",v.value,c,l.length===0?"CLEARING":l)}$clear(c){m.$clear(c),d.trace("[DiagnosticCollection] remove all (extension, owner)",v.value,c)}dispose(){m.dispose()}};let i;if(!f)f="_generated_diagnostic_collection_name_#"+hn._idPool++,i=f;else if(!a.has(f))i=f;else{this._logService.warn(`DiagnosticCollection with name '${f}' does already exist.`);do i=f+hn._idPool++;while(a.has(i))}return new class extends b{constructor(){super(f,i,hn._maxDiagnosticsPerFile,r.extUri,s,o);a.set(i,this)}dispose(){super.dispose(),a.delete(i)}}}getDiagnostics(v){if(v)return this._getDiagnostics(v);{const f=new Map,a=[];for(const m of this._collections.values())m.forEach((o,d)=>{let r=f.get(o.toString());typeof r=="undefined"&&(r=a.length,f.set(o.toString(),r),a.push([o,[]])),a[r][1]=a[r][1].concat(...d)});return a}}_getDiagnostics(v){let f=[];for(const a of this._collections.values())a.has(v)&&(f=f.concat(a.get(v)));return f}$acceptMarkersChange(v){if(!this._mirrorCollection){const f="_generated_mirror",a=new b(f,f,hn._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(f,a),this._mirrorCollection=a}for(const[f,a]of v)this._mirrorCollection.set(y.URI.revive(f),a.map(C.Diagnostic.to))}};p._idPool=0,p._maxDiagnosticsPerFile=1e3,p=Ge([$e(1,P.ILogService),$e(2,I.IExtHostFileSystemInfo)],p),e.ExtHostDiagnostics=p}),define(Ie[243],ke([1,0,2,5]),function(Q,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class y{constructor(D){this._proxy=D.getProxy(n.MainContext.MainThreadDialogs)}showOpenDialog(D){return this._proxy.$showOpenDialog(D).then(C=>C?C.map(S=>u.URI.revive(S)):void 0)}showSaveDialog(D){return this._proxy.$showSaveDialog(D).then(C=>C?u.URI.revive(C):void 0)}}e.ExtHostDialogs=y}),define(Ie[244],ke([1,0,12,2,7,5,11,21,8]),function(Q,e,u,n,y,A,D,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class P{constructor(I,_,T){this._documentsAndEditors=_,this._logService=T,this._documentContentProviders=new Map,this._proxy=I.getProxy(A.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,_){if(Object.keys(D.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const T=P._handlePool++;this._documentContentProviders.set(T,_),this._proxy.$registerTextContentProvider(T,I);let w;return typeof _.onDidChange=="function"&&(w=_.onDidChange(b=>{if(b.scheme!==I){this._logService.warn(`Provider for scheme '${I}' is firing event for schema '${b.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(b)&&this.$provideTextDocumentContent(T,b).then(p=>{if(!p&&typeof p!="string")return;const g=this._documentsAndEditors.getDocument(b);if(!g)return;const v=(0,S.splitLines)(p);if(!g.equalLines(v))return this._proxy.$onVirtualDocumentChange(b,p)},u.onUnexpectedError)})),new y.Disposable(()=>{this._documentContentProviders.delete(T)&&this._proxy.$unregisterTextContentProvider(T),w&&(w.dispose(),w=void 0)})}$provideTextDocumentContent(I,_){const T=this._documentContentProviders.get(I);return T?Promise.resolve(T.provideTextDocumentContent(n.URI.revive(_),C.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${_.scheme}`))}}e.ExtHostDocumentContentProvider=P,P._handlePool=0}),define(Ie[245],ke([1,0,3,6,2,5,125,15,10,24,7]),function(Q,e,u,n,y,A,D,C,S,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class I{constructor(T,w){this._onDidAddDocument=new u.Emitter,this._onDidRemoveDocument=new u.Emitter,this._onDidChangeDocument=new u.Emitter,this._onDidSaveDocument=new u.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new n.DisposableStore,this._documentLoader=new Map,this._proxy=T.getProxy(A.MainContext.MainThreadDocuments),this._documentsAndEditors=w,this._documentsAndEditors.onDidRemoveDocuments(b=>{for(const p of b)this._onDidRemoveDocument.fire(p.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(b=>{for(const p of b)this._onDidAddDocument.fire(p.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(T){if(!T)return;const w=this._documentsAndEditors.getDocument(T);if(w)return w}getDocument(T){const w=this.getDocumentData(T);if(!w?.document)throw new Error(`Unable to retrieve document from URI '${T}'`);return w.document}ensureDocumentData(T){const w=this._documentsAndEditors.getDocument(T);if(w)return Promise.resolve(w);let b=this._documentLoader.get(T.toString());return b||(b=this._proxy.$tryOpenDocument(T).then(p=>{this._documentLoader.delete(T.toString());const g=y.URI.revive(p);return(0,S.assertIsDefined)(this._documentsAndEditors.getDocument(g))},p=>(this._documentLoader.delete(T.toString()),Promise.reject(p))),this._documentLoader.set(T.toString(),b)),b}createDocumentData(T){return this._proxy.$tryCreateDocument(T).then(w=>y.URI.revive(w))}$acceptModelLanguageChanged(T,w){const b=y.URI.revive(T),p=this._documentsAndEditors.getDocument(b);if(!p)throw new Error("unknown document");this._onDidRemoveDocument.fire(p.document),p._acceptLanguageId(w),this._onDidAddDocument.fire(p.document)}$acceptModelSaved(T){const w=y.URI.revive(T),b=this._documentsAndEditors.getDocument(w);if(!b)throw new Error("unknown document");this.$acceptDirtyStateChanged(T,!1),this._onDidSaveDocument.fire(b.document)}$acceptDirtyStateChanged(T,w){const b=y.URI.revive(T),p=this._documentsAndEditors.getDocument(b);if(!p)throw new Error("unknown document");p._acceptIsDirty(w),this._onDidChangeDocument.fire({document:p.document,contentChanges:[],reason:void 0})}$acceptModelChanged(T,w,b){const p=y.URI.revive(T),g=this._documentsAndEditors.getDocument(p);if(!g)throw new Error("unknown document");g._acceptIsDirty(b),g.onEvents(w);let v;w.isUndoing?v=L.TextDocumentChangeReason.Undo:w.isRedoing&&(v=L.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,P.deepFreeze)({document:g.document,contentChanges:w.changes.map(f=>({range:C.Range.to(f.range),rangeOffset:f.rangeOffset,rangeLength:f.rangeLength,text:f.text})),reason:v}))}setWordDefinitionFor(T,w){(0,D.setWordDefinitionFor)(T,w)}}e.ExtHostDocuments=I}),define(Ie[54],ke([1,0,56,3,6,2,4,5,125,17,133,15,14,25,11,59,79]),function(Q,e,u,n,y,A,D,C,S,P,L,I,_,T,w,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class g{constructor(a){this.value=a,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let v=class{constructor(a,m){this._extHostRpc=a,this._logService=m,this._activeEditorId=null,this._editors=new Map,this._documents=new T.ResourceMap,this._onDidAddDocuments=new n.Emitter,this._onDidRemoveDocuments=new n.Emitter,this._onDidChangeVisibleTextEditors=new n.Emitter,this._onDidChangeActiveTextEditor=new n.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(a){this.acceptDocumentsAndEditorsDelta(a)}acceptDocumentsAndEditorsDelta(a){const m=[],o=[],d=[];if(a.removedDocuments)for(const r of a.removedDocuments){const s=A.URI.revive(r),i=this._documents.get(s);i?.unref()&&(this._documents.delete(s),m.push(i.value))}if(a.addedDocuments)for(const r of a.addedDocuments){const s=A.URI.revive(r.uri);let i=this._documents.get(s);if(i&&s.scheme!==w.Schemas.vscodeNotebookCell&&s.scheme!==w.Schemas.vscodeInteractiveInput)throw new Error(`document '${s} already exists!'`);i||(i=new g(new S.ExtHostDocumentData(this._extHostRpc.getProxy(C.MainContext.MainThreadDocuments),s,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty,r.notebook)),this._documents.set(s,i),o.push(i.value)),i.ref()}if(a.removedEditors)for(const r of a.removedEditors){const s=this._editors.get(r);this._editors.delete(r),s&&d.push(s)}if(a.addedEditors)for(const r of a.addedEditors){const s=A.URI.revive(r.documentUri);u.ok(this._documents.has(s),`document '${s}' does not exist`),u.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const i=this._documents.get(s).value,t=new L.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(C.MainContext.MainThreadTextEditors),this._logService,new p.Lazy(()=>i.document),r.selections.map(I.Selection.to),r.options,r.visibleRanges.map(c=>I.Range.to(c)),typeof r.editorPosition=="number"?I.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,t)}a.newActiveEditor!==void 0&&(u.ok(a.newActiveEditor===null||this._editors.has(a.newActiveEditor),`active editor '${a.newActiveEditor}' does not exist`),this._activeEditorId=a.newActiveEditor),(0,y.dispose)(m),(0,y.dispose)(d),a.removedDocuments&&this._onDidRemoveDocuments.fire(m),a.addedDocuments&&this._onDidAddDocuments.fire(o),(a.removedEditors||a.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),a.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(a){return this._documents.get(a)?.value}allDocuments(){return b.Iterable.map(this._documents.values(),a=>a.value)}getEditor(a){return this._editors.get(a)}activeEditor(a){if(!this._activeEditorId)return;const m=this._editors.get(this._activeEditorId);return a?m:m?.value}allEditors(){return[...this._editors.values()]}};v=Ge([$e(0,P.IExtHostRpcService),$e(1,_.ILogService)],v),e.ExtHostDocumentsAndEditors=v,e.IExtHostDocumentsAndEditors=(0,D.createDecorator)("IExtHostDocumentsAndEditors")}),define(Ie[55],ke([1,0,15,5,2,3,4,7,17,10,78]),function(Q,e,u,n,y,A,D,C,S,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,D.createDecorator)("IExtHostEditorTabs");class I{constructor(p,g,v){this._activeTabIdGetter=v,this._parentGroup=g,this.acceptDtoUpdate(p)}get apiObject(){if(!this._apiObject){const p=this,g={get isActive(){return p._dto.id===p._activeTabIdGetter()},get label(){return p._dto.label},get input(){return p._input},get isDirty(){return p._dto.isDirty},get isPinned(){return p._dto.isPinned},get isPreview(){return p._dto.isPreview},get group(){return p._parentGroup.apiObject}};this._apiObject=Object.freeze(g)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(p){this._dto=p,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new C.TextTabInput(y.URI.revive(this._dto.input.uri));case 2:return new C.TextDiffTabInput(y.URI.revive(this._dto.input.original),y.URI.revive(this._dto.input.modified));case 5:return new C.CustomEditorTabInput(y.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 6:return new C.WebviewEditorTabInput(this._dto.input.viewType);case 3:return new C.NotebookEditorTabInput(y.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 4:return new C.NotebookDiffEditorTabInput(y.URI.revive(this._dto.input.original),y.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 7:return new C.TerminalEditorTabInput;default:return}}}class _{constructor(p,g,v){this._tabs=[],this._activeTabId="",this._dto=p,this._activeGroupIdGetter=v;for(const f of p.tabs)f.isActive&&(this._activeTabId=f.id),this._tabs.push(new I(f,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const p=this,g={get isActive(){return p._dto.groupId===p._activeGroupIdGetter()},get viewColumn(){return u.ViewColumn.to(p._dto.viewColumn)},get activeTab(){return p._tabs.find(v=>v.tabId===p._activeTabId)?.apiObject},get tabs(){return Object.freeze(p._tabs.map(v=>v.apiObject))}};this._apiObject=Object.freeze(g)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(p){this._dto=p}acceptTabOperation(p){if(p.kind===0){const v=new I(p.tabDto,this,()=>this.activeTabId());return this._tabs.splice(p.index,0,v),p.tabDto.isActive&&(this._activeTabId=v.tabId),v}else if(p.kind===1){const v=this._tabs.splice(p.index,1)[0];if(!v)throw new Error(`Tab close updated received for index ${p.index} which does not exist`);return v.tabId===this._activeTabId&&(this._activeTabId=""),v}else if(p.kind===3){if(p.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const v=this._tabs.splice(p.oldIndex,1)[0];if(!v)throw new Error(`Tab move updated received for index ${p.oldIndex} which does not exist`);return this._tabs.splice(p.index,0,v),v}const g=this._tabs.find(v=>v.tabId===p.tabDto.id);if(!g)throw new Error("INVALID tab");return p.tabDto.isActive?this._activeTabId=p.tabDto.id:this._activeTabId===p.tabDto.id&&!p.tabDto.isActive&&(this._activeTabId=""),g.acceptDtoUpdate(p.tabDto),g}activeTabId(){return this._activeTabId}}let T=class{constructor(p){this._onDidChangeTabs=new A.Emitter,this._onDidChangeTabGroups=new A.Emitter,this._extHostTabGroups=[],this._proxy=p.getProxy(n.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const p=this,g={onDidChangeTabGroups:p._onDidChangeTabGroups.event,onDidChangeTabs:p._onDidChangeTabs.event,get all(){return Object.freeze(p._extHostTabGroups.map(v=>v.apiObject))},get activeTabGroup(){const v=p._activeGroupId;return(0,P.assertIsDefined)(p._extHostTabGroups.find(a=>a.groupId===v)?.apiObject)},close:async(v,f)=>{const a=Array.isArray(v)?v:[v];return a.length?w(a[0])?this._closeGroups(a,f):this._closeTabs(a,f):!0}};this._apiObject=Object.freeze(g)}return this._apiObject}$acceptEditorTabModel(p){const g=new Set(this._extHostTabGroups.map(r=>r.groupId)),v=new Set(p.map(r=>r.groupId)),f=(0,L.diffSets)(g,v),a=this._extHostTabGroups.filter(r=>f.removed.includes(r.groupId)).map(r=>r.apiObject),m=[],o=[];this._extHostTabGroups=p.map(r=>{const s=new _(r,this._proxy,()=>this._activeGroupId);return f.added.includes(s.groupId)?m.push(s.apiObject):o.push(s.apiObject),s});const d=(0,P.assertIsDefined)(p.find(r=>r.isActive===!0)?.groupId);d!==void 0&&this._activeGroupId!==d&&(this._activeGroupId=d),this._onDidChangeTabGroups.fire(Object.freeze({opened:m,closed:a,changed:o}))}$acceptTabGroupUpdate(p){const g=this._extHostTabGroups.find(v=>v.groupId===p.groupId);if(!g)throw new Error("Update Group IPC call received before group creation.");g.acceptGroupDtoUpdate(p),p.isActive&&(this._activeGroupId=p.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[g.apiObject],opened:[],closed:[]}))}$acceptTabOperation(p){const g=this._extHostTabGroups.find(f=>f.groupId===p.groupId);if(!g)throw new Error("Update Tabs IPC call received before group creation.");const v=g.acceptTabOperation(p);switch(p.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[v.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[v.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[v.apiObject]}));return}}_findExtHostTabFromApi(p){for(const g of this._extHostTabGroups)for(const v of g.tabs)if(v.apiObject===p)return v}_findExtHostTabGroupFromApi(p){return this._extHostTabGroups.find(g=>g.apiObject===p)}async _closeTabs(p,g){const v=[];for(const f of p){const a=this._findExtHostTabFromApi(f);if(!a)throw new Error("Tab close: Invalid tab not found!");v.push(a.tabId)}return this._proxy.$closeTab(v,g)}async _closeGroups(p,g){const v=[];for(const f of p){const a=this._findExtHostTabGroupFromApi(f);if(!a)throw new Error("Group close: Invalid group not found!");v.push(a.groupId)}return this._proxy.$closeGroup(v,g)}};T=Ge([$e(0,S.IExtHostRpcService)],T),e.ExtHostEditorTabs=T;function w(b){return b.tabs!==void 0}}),define(Ie[246],ke([1,0,2,5,6,7,15,150,8,23,27]),function(Q,e,u,n,y,A,D,C,S,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class I{constructor(){this._schemes=[]}add(w){this._stateMachine=void 0,this._schemes.push(w)}delete(w){const b=this._schemes.indexOf(w);b>=0&&(this._schemes.splice(b,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const w=this._schemes.sort(),b=[];let p,g,v=14,f=14;for(const a of w){let m=p?(0,S.commonPrefixLength)(p,a):0;for(m===0?g=1:g=f;m<a.length;m++)m+1===a.length?(v=f,f=9):f+=1,b.push([g,a.toUpperCase().charCodeAt(m),f]),b.push([g,a.toLowerCase().charCodeAt(m),f]),g=f;p=a,f=v}b.push([9,58,10]),b.push([10,47,12]),this._stateMachine=new C.StateMachine(b)}}provideDocumentLinks(w){this._initStateMachine();const b=[],p=C.LinkComputer.computeLinks({getLineContent(g){return w.lineAt(g-1).text},getLineCount(){return w.lineCount}},this._stateMachine);for(const g of p){const v=D.DocumentLink.to(g);v.target&&b.push(v)}return b}}class _{constructor(w,b){this._extHostLanguageFeatures=b,this._linkProvider=new I,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=w.getProxy(n.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(w,b,p,g={}){if(this._registeredSchemes.has(b))throw new Error(`a provider for the scheme '${b}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(w,"*",this._linkProvider));const v=this._handlePool++;this._linkProvider.add(b),this._registeredSchemes.add(b),this._fsProvider.set(v,p);let f=2;g.isCaseSensitive&&(f+=1024),g.isReadonly&&(f+=2048),typeof p.copy=="function"&&(f+=8),typeof p.open=="function"&&typeof p.close=="function"&&typeof p.read=="function"&&typeof p.write=="function"&&((0,L.checkProposedApiEnabled)(w,"fsChunks"),f+=4),this._proxy.$registerFileSystemProvider(v,b,f).catch(m=>{console.error(`FAILED to register filesystem provider of ${w.identifier.value}-extension for the scheme ${b}`),console.error(m)});const a=p.onDidChangeFile(m=>{const o=[];for(const d of m){const{uri:r,type:s}=d;if(r.scheme!==b)continue;let i;switch(s){case A.FileChangeType.Changed:i=0;break;case A.FileChangeType.Created:i=1;break;case A.FileChangeType.Deleted:i=2;break;default:throw new Error("Unknown FileChangeType")}o.push({resource:r,type:i})}this._proxy.$onFileSystemChange(v,o)});return(0,y.toDisposable)(()=>{a.dispose(),this._linkProvider.delete(b),this._registeredSchemes.delete(b),this._fsProvider.delete(v),this._proxy.$unregisterProvider(v)})}static _asIStat(w){const{type:b,ctime:p,mtime:g,size:v,permissions:f}=w;return{type:b,ctime:p,mtime:g,size:v,permissions:f}}$stat(w,b){return Promise.resolve(this._getFsProvider(w).stat(u.URI.revive(b))).then(p=>_._asIStat(p))}$readdir(w,b){return Promise.resolve(this._getFsProvider(w).readDirectory(u.URI.revive(b)))}$readFile(w,b){return Promise.resolve(this._getFsProvider(w).readFile(u.URI.revive(b))).then(p=>P.VSBuffer.wrap(p))}$writeFile(w,b,p,g){return Promise.resolve(this._getFsProvider(w).writeFile(u.URI.revive(b),p.buffer,g))}$delete(w,b,p){return Promise.resolve(this._getFsProvider(w).delete(u.URI.revive(b),p))}$rename(w,b,p,g){return Promise.resolve(this._getFsProvider(w).rename(u.URI.revive(b),u.URI.revive(p),g))}$copy(w,b,p,g){const v=this._getFsProvider(w);if(!v.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(v.copy(u.URI.revive(b),u.URI.revive(p),g))}$mkdir(w,b){return Promise.resolve(this._getFsProvider(w).createDirectory(u.URI.revive(b)))}$watch(w,b,p,g){const v=this._getFsProvider(w).watch(u.URI.revive(p),g);this._watches.set(b,v)}$unwatch(w,b){const p=this._watches.get(b);p&&(p.dispose(),this._watches.delete(b))}$open(w,b,p){const g=this._getFsProvider(w);if(!g.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(g.open(u.URI.revive(b),p))}$close(w,b){const p=this._getFsProvider(w);if(!p.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(p.close(b))}$read(w,b,p,g){const v=this._getFsProvider(w);if(!v.read)throw new Error('FileSystemProvider does not implement "read"');const f=P.VSBuffer.alloc(g);return Promise.resolve(v.read(b,p,f.buffer,0,g)).then(a=>f.slice(0,a))}$write(w,b,p,g){const v=this._getFsProvider(w);if(!v.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(v.write(b,p,g.buffer,0,g.byteLength))}_getFsProvider(w){const b=this._fsProvider.get(w);if(!b){const p=new Error;throw p.name="ENOPRO",p.message="no provider",p}return b}}e.ExtHostFileSystem=_}),define(Ie[69],ke([1,0,5,43,7,23,4,17,46,6]),function(Q,e,u,n,y,A,D,C,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let L=class Gt{constructor(_,T){this._fileSystemProvider=new Map,this._proxy=_.getProxy(u.MainContext.MainThreadFileSystem);const w=this;this.value=Object.freeze({async stat(b){try{const p=w._fileSystemProvider.get(b.scheme);if(!p)return await w._proxy.$stat(b);await w._proxy.$ensureActivation(b.scheme);const g=await p.stat(b);return{type:g.type,ctime:g.ctime,mtime:g.mtime,size:g.size,permissions:g.permissions}}catch(p){Gt._handleError(p)}},async readDirectory(b){try{const p=w._fileSystemProvider.get(b.scheme);return p?(await w._proxy.$ensureActivation(b.scheme),(await p.readDirectory(b)).slice()):await w._proxy.$readdir(b)}catch(p){return Gt._handleError(p)}},async createDirectory(b){try{return await w._proxy.$mkdir(b)}catch(p){return Gt._handleError(p)}},async readFile(b){try{const p=w._fileSystemProvider.get(b.scheme);return p?(await w._proxy.$ensureActivation(b.scheme),(await p.readFile(b)).slice()):(await w._proxy.$readFile(b)).buffer}catch(p){return Gt._handleError(p)}},async writeFile(b,p){try{return await w._proxy.$writeFile(b,A.VSBuffer.wrap(p))}catch(g){return Gt._handleError(g)}},async delete(b,p){try{const g=w._fileSystemProvider.get(b.scheme);return g?(await w._proxy.$ensureActivation(b.scheme),await g.delete(b,{recursive:!1,...p})):await w._proxy.$delete(b,{recursive:!1,useTrash:!1,...p})}catch(g){return Gt._handleError(g)}},async rename(b,p,g){try{return await w._proxy.$rename(b,p,{overwrite:!1,...g})}catch(v){return Gt._handleError(v)}},async copy(b,p,g){try{return await w._proxy.$copy(b,p,{overwrite:!1,...g})}catch(v){return Gt._handleError(v)}},isWritableFileSystem(b){const p=T.getCapabilities(b);if(typeof p=="number")return!(p&2048)}})}static _handleError(_){if(_ instanceof y.FileSystemError)throw _;if(!(_ instanceof Error))throw new y.FileSystemError(String(_));if(_.name==="ENOPRO")throw y.FileSystemError.Unavailable(_.message);switch(_.name){case n.FileSystemProviderErrorCode.FileExists:throw y.FileSystemError.FileExists(_.message);case n.FileSystemProviderErrorCode.FileNotFound:throw y.FileSystemError.FileNotFound(_.message);case n.FileSystemProviderErrorCode.FileNotADirectory:throw y.FileSystemError.FileNotADirectory(_.message);case n.FileSystemProviderErrorCode.FileIsADirectory:throw y.FileSystemError.FileIsADirectory(_.message);case n.FileSystemProviderErrorCode.NoPermissions:throw y.FileSystemError.NoPermissions(_.message);case n.FileSystemProviderErrorCode.Unavailable:throw y.FileSystemError.Unavailable(_.message);default:throw new y.FileSystemError(_.message,_.name)}}addFileSystemProvider(_,T){return this._fileSystemProvider.set(_,T),(0,P.toDisposable)(()=>this._fileSystemProvider.delete(_))}};L=Ge([$e(0,C.IExtHostRpcService),$e(1,S.IExtHostFileSystemInfo)],L),e.ExtHostConsumerFileSystem=L,e.IExtHostConsumerFileSystem=(0,D.createDecorator)("IExtHostConsumerFileSystem")}),define(Ie[247],ke([1,0,3,36,2,5,15,7]),function(Q,e,u,n,y,A,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class S{constructor(I,_,T,w,b,p,g,v){this._onDidCreate=new u.Emitter,this._onDidChange=new u.Emitter,this._onDidDelete=new u.Emitter;const f=this.ensureWatching(I,T,b);this._config=0,p&&(this._config+=1),g&&(this._config+=2),v&&(this._config+=4);const a=(0,n.parse)(b),m=typeof b=="string",o=w(d=>{if(!p)for(const r of d.created){const s=y.URI.revive(r);a(s.fsPath)&&(!m||_.getWorkspaceFolder(s))&&this._onDidCreate.fire(s)}if(!g)for(const r of d.changed){const s=y.URI.revive(r);a(s.fsPath)&&(!m||_.getWorkspaceFolder(s))&&this._onDidChange.fire(s)}if(!v)for(const r of d.deleted){const s=y.URI.revive(r);a(s.fsPath)&&(!m||_.getWorkspaceFolder(s))&&this._onDidDelete.fire(s)}});this._disposable=C.Disposable.from(f,this._onDidCreate,this._onDidChange,this._onDidDelete,o)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}ensureWatching(I,_,T){const w=C.Disposable.from();if(typeof T=="string")return w;const b=I.getProxy(A.MainContext.MainThreadFileSystem);let p=!1;(T.pattern.includes(n.GLOBSTAR)||T.pattern.includes(n.GLOB_SPLIT))&&(p=!0);const g=Math.random();return b.$watch(_.identifier.value,g,T.baseUri,{recursive:p,excludes:[]}),C.Disposable.from({dispose:()=>b.$unwatch(g)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class P{constructor(I,_,T){this._mainContext=I,this._logService=_,this._extHostDocumentsAndEditors=T,this._onFileSystemEvent=new u.Emitter,this._onDidRenameFile=new u.Emitter,this._onDidCreateFile=new u.Emitter,this._onDidDeleteFile=new u.Emitter,this._onWillRenameFile=new u.AsyncEmitter,this._onWillCreateFile=new u.AsyncEmitter,this._onWillDeleteFile=new u.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(I,_,T,w,b,p){return new S(this._mainContext,I,_,this._onFileSystemEvent.event,D.GlobPattern.from(T),w,b,p)}$onFileEvent(I){this._onFileSystemEvent.fire(I)}$onDidRunFileOperation(I,_){switch(I){case 2:this._onDidRenameFile.fire(Object.freeze({files:_.map(T=>({oldUri:y.URI.revive(T.source),newUri:y.URI.revive(T.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:_.map(T=>y.URI.revive(T.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:_.map(T=>y.URI.revive(T.target))}));break;default:}}getOnWillRenameFileEvent(I){return this._createWillExecuteEvent(I,this._onWillRenameFile)}getOnWillCreateFileEvent(I){return this._createWillExecuteEvent(I,this._onWillCreateFile)}getOnWillDeleteFileEvent(I){return this._createWillExecuteEvent(I,this._onWillDeleteFile)}_createWillExecuteEvent(I,_){return(T,w,b)=>{const p=function(v){T.call(w,v)};return p.extension=I,_.event(p,void 0,b)}}async $onWillRunFileOperation(I,_,T,w){switch(I){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:_.map(b=>({oldUri:y.URI.revive(b.source),newUri:y.URI.revive(b.target)}))},T,w);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:_.map(b=>y.URI.revive(b.target))},T,w);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:_.map(b=>y.URI.revive(b.target))},T,w)}}async _fireWillEvent(I,_,T,w){const b=new Set,p=[];if(await I.fireAsync(_,w,async(v,f)=>{const a=Date.now(),m=await Promise.resolve(v);m instanceof C.WorkspaceEdit&&(p.push(m),b.add(f.extension.displayName??f.extension.identifier.value)),Date.now()-a>T&&this._logService.warn("SLOW file-participant",f.extension.identifier)}),w.isCancellationRequested||p.length===0)return;const g={edits:[]};for(const v of p){const{edits:f}=D.WorkspaceEdit.from(v,{getTextDocumentVersion:a=>this._extHostDocumentsAndEditors.getDocument(a)?.version,getNotebookDocumentVersion:()=>{}});g.edits=g.edits.concat(f)}return{edit:g,extensionNames:Array.from(b)}}}e.ExtHostFileSystemEventService=P}),define(Ie[248],ke([1,0,2,37]),function(Q,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class y{constructor(D,C,S,P,L){this._extHostNotebooks=C,this._textDocumentsAndEditors=S,this._commands=P;const I=new n.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new n.ApiCommandArgument("showOptions","Show Options",_=>!0,_=>_),new n.ApiCommandArgument("resource","Interactive resource Uri",_=>!0,_=>_),new n.ApiCommandArgument("controllerId","Notebook controller Id",_=>!0,_=>_),new n.ApiCommandArgument("title","Interactive editor title",_=>!0,_=>_)],new n.ApiCommandResult("Notebook and input URI",_=>{if(L.debug("[ExtHostInteractive] open iw with notebook editor id",_.notebookEditorId),_.notebookEditorId!==void 0){const T=this._extHostNotebooks.getEditorById(_.notebookEditorId);return L.debug("[ExtHostInteractive] notebook editor found",T.id),{notebookUri:u.URI.revive(_.notebookUri),inputUri:u.URI.revive(_.inputUri),notebookEditor:T.apiEditor}}return L.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",_.notebookUri,_.inputUri),{notebookUri:u.URI.revive(_.notebookUri),inputUri:u.URI.revive(_.inputUri)}}));this._commands.registerApiCommand(I)}$willAddInteractiveDocument(D,C,S,P){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:C,lines:[""],languageId:S,uri:D,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(u.URI.revive(P))?.apiNotebook}]})}$willRemoveInteractiveDocument(D,C){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[D]})}}e.ExtHostInteractive=y}),define(Ie[249],ke([1,0,6,5]),function(Q,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class y{constructor(D){this._handlePool=0,this._proxy=D.getProxy(n.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(D){const C=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(C,D),(0,u.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(C)})}}e.ExtHostLabelService=y}),define(Ie[250],ke([1,0,2,24,15,7,64,5,8,35,16,10,146,21,6,112,93,87,50,12,18,27]),function(Q,e,u,n,y,A,D,C,S,P,L,I,_,T,w,b,p,g,v,f,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class o{constructor(M,H){this._documents=M,this._provider=H}async provideDocumentSymbols(M,H){const G=this._documents.getDocument(M),X=await this._provider.provideDocumentSymbols(G,H);if(!(0,L.isFalsyOrEmpty)(X))return X[0]instanceof A.DocumentSymbol?X.map(y.DocumentSymbol.from):o._asDocumentSymbolTree(X)}static _asDocumentSymbolTree(M){M=M.slice(0).sort((X,de)=>{let be=X.location.range.start.compareTo(de.location.range.start);return be===0&&(be=de.location.range.end.compareTo(X.location.range.end)),be});const H=[],G=[];for(const X of M){const de={name:X.name||"!!MISSING: name!!",kind:y.SymbolKind.from(X.kind),tags:X.tags?.map(y.SymbolTag.from)||[],detail:"",containerName:X.containerName,range:y.Range.from(X.location.range),selectionRange:y.Range.from(X.location.range),children:[]};for(;;){if(G.length===0){G.push(de),H.push(de);break}const be=G[G.length-1];if(P.Range.containsRange(be.range,de.range)&&!P.Range.equalsRange(be.range,de.range)){be.children?.push(de),G.push(de);break}G.pop()}}return H}}class d{constructor(M,H,G){this._documents=M,this._commands=H,this._provider=G,this._cache=new g.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(M,H){const G=this._documents.getDocument(M),X=await this._provider.provideCodeLenses(G,H);if(!X||H.isCancellationRequested)return;const de=this._cache.add(X),be=new w.DisposableStore;this._disposables.set(de,be);const se={cacheId:de,lenses:[]};for(let De=0;De<X.length;De++)se.lenses.push({cacheId:[de,De],range:y.Range.from(X[De].range),command:this._commands.toInternal(X[De].command,be)});return se}async resolveCodeLens(M,H){const G=M.cacheId&&this._cache.get(...M.cacheId);if(!G)return;let X;if(typeof this._provider.resolveCodeLens!="function"||G.isResolved?X=G:X=await this._provider.resolveCodeLens(G,H),X||(X=G),H.isCancellationRequested)return;const de=M.cacheId&&this._disposables.get(M.cacheId[0]);if(!!de)return M.command=this._commands.toInternal(X.command??d._badCmd,de),M}releaseCodeLenses(M){this._disposables.get(M)?.dispose(),this._disposables.delete(M),this._cache.delete(M)}}d._badCmd={command:"missing",title:"!!MISSING: command!!"};function r(ie){return Array.isArray(ie)?ie.map(y.DefinitionLink.from):ie?[y.DefinitionLink.from(ie)]:[]}class s{constructor(M,H){this._documents=M,this._provider=H}async provideDefinition(M,H,G){const X=this._documents.getDocument(M),de=y.Position.to(H),be=await this._provider.provideDefinition(X,de,G);return r(be)}}class i{constructor(M,H){this._documents=M,this._provider=H}async provideDeclaration(M,H,G){const X=this._documents.getDocument(M),de=y.Position.to(H),be=await this._provider.provideDeclaration(X,de,G);return r(be)}}class t{constructor(M,H){this._documents=M,this._provider=H}async provideImplementation(M,H,G){const X=this._documents.getDocument(M),de=y.Position.to(H),be=await this._provider.provideImplementation(X,de,G);return r(be)}}class c{constructor(M,H){this._documents=M,this._provider=H}async provideTypeDefinition(M,H,G){const X=this._documents.getDocument(M),de=y.Position.to(H),be=await this._provider.provideTypeDefinition(X,de,G);return r(be)}}class l{constructor(M,H){this._documents=M,this._provider=H}async provideHover(M,H,G){const X=this._documents.getDocument(M),de=y.Position.to(H),be=await this._provider.provideHover(X,de,G);if(!(!be||(0,L.isFalsyOrEmpty)(be.contents)))return be.range||(be.range=X.getWordRangeAtPosition(de)),be.range||(be.range=new A.Range(de,de)),y.Hover.from(be)}}class h{constructor(M,H){this._documents=M,this._provider=H}async provideEvaluatableExpression(M,H,G){const X=this._documents.getDocument(M),de=y.Position.to(H),be=await this._provider.provideEvaluatableExpression(X,de,G);if(be)return y.EvaluatableExpression.from(be)}}class E{constructor(M,H){this._documents=M,this._provider=H}async provideInlineValues(M,H,G,X){const de=this._documents.getDocument(M),be=await this._provider.provideInlineValues(de,y.Range.to(H),y.InlineValueContext.to(G),X);if(Array.isArray(be))return be.map(se=>y.InlineValue.from(se))}}class R{constructor(M,H){this._documents=M,this._provider=H}async provideDocumentHighlights(M,H,G){const X=this._documents.getDocument(M),de=y.Position.to(H),be=await this._provider.provideDocumentHighlights(X,de,G);if(Array.isArray(be))return be.map(y.DocumentHighlight.from)}}class N{constructor(M,H){this._documents=M,this._provider=H}async provideLinkedEditingRanges(M,H,G){const X=this._documents.getDocument(M),de=y.Position.to(H),be=await this._provider.provideLinkedEditingRanges(X,de,G);if(be&&Array.isArray(be.ranges))return{ranges:(0,L.coalesce)(be.ranges.map(y.Range.from)),wordPattern:be.wordPattern}}}class O{constructor(M,H){this._documents=M,this._provider=H}async provideReferences(M,H,G,X){const de=this._documents.getDocument(M),be=y.Position.to(H),se=await this._provider.provideReferences(de,be,G,X);if(Array.isArray(se))return se.map(y.location.from)}}class k{constructor(M,H,G,X,de,be,se){this._documents=M,this._commands=H,this._diagnostics=G,this._provider=X,this._logService=de,this._extension=be,this._apiDeprecation=se,this._cache=new g.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(M,H,G,X){const de=this._documents.getDocument(M),be=_.Selection.isISelection(H)?y.Selection.to(H):y.Range.to(H),se=[];for(const Ye of this._diagnostics.getDiagnostics(M))if(be.intersection(Ye.range)&&se.push(Ye)>k._maxCodeActionsPerFile)break;const De={diagnostics:se,only:G.only?new A.CodeActionKind(G.only):void 0,triggerKind:y.CodeActionTriggerKind.to(G.trigger)},Ce=await this._provider.provideCodeActions(de,be,De,X);if(!(0,L.isNonEmptyArray)(Ce)||X.isCancellationRequested)return;const ze=this._cache.add(Ce),Ke=new w.DisposableStore;this._disposables.set(ze,Ke);const Ne=[];for(let Ye=0;Ye<Ce.length;Ye++){const Z=Ce[Ye];!Z||(k._isCommand(Z)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Ne.push({_isSynthetic:!0,title:Z.title,command:this._commands.toInternal(Z,Ke)})):(De.only&&(Z.kind?De.only.contains(Z.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${De.only.value} 'requested but returned code action is of kind '${Z.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${De.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ne.push({cacheId:[ze,Ye],title:Z.title,command:Z.command&&this._commands.toInternal(Z.command,Ke),diagnostics:Z.diagnostics&&Z.diagnostics.map(y.Diagnostic.from),edit:Z.edit&&y.WorkspaceEdit.from(Z.edit),kind:Z.kind&&Z.kind.value,isPreferred:Z.isPreferred,disabled:Z.disabled?.reason})))}return{cacheId:ze,actions:Ne}}async resolveCodeAction(M,H){const[G,X]=M,de=this._cache.get(G,X);if(!de||k._isCommand(de)||!this._provider.resolveCodeAction)return;const be=await this._provider.resolveCodeAction(de,H)??de;return be?.edit?y.WorkspaceEdit.from(be.edit):void 0}releaseCodeActions(M){this._disposables.get(M)?.dispose(),this._disposables.delete(M),this._cache.delete(M)}static _isCommand(M){return typeof M.command=="string"&&typeof M.title=="string"}}k._maxCodeActionsPerFile=1e3;class U{constructor(M,H,G,X){this._proxy=M,this._documents=H,this._provider=G,this._handle=X}async prepareDocumentPaste(M,H,G,X){if(!this._provider.prepareDocumentPaste)return;const de=this._documents.getDocument(M),be=H.map(De=>y.Range.to(De)),se=y.DataTransfer.toDataTransfer(G,()=>{throw new f.NotImplementedError});return await this._provider.prepareDocumentPaste(de,be,se,X),y.DataTransfer.toDataTransferDTO(se)}async providePasteEdits(M,H,G,X,de){const be=this._documents.getDocument(H),se=G.map(ze=>y.Range.to(ze)),De=y.DataTransfer.toDataTransfer(X,async ze=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,M,ze)).buffer),Ce=await this._provider.provideDocumentPasteEdits(be,se,De,de);if(!!Ce)return{insertText:typeof Ce.insertText=="string"?Ce.insertText:{snippet:Ce.insertText.value},additionalEdit:Ce.additionalEdit?y.WorkspaceEdit.from(Ce.additionalEdit):void 0}}}class F{constructor(M,H){this._documents=M,this._provider=H}async provideDocumentFormattingEdits(M,H,G){const X=this._documents.getDocument(M),de=await this._provider.provideDocumentFormattingEdits(X,H,G);if(Array.isArray(de))return de.map(y.TextEdit.from)}}class ${constructor(M,H){this._documents=M,this._provider=H}async provideDocumentRangeFormattingEdits(M,H,G,X){const de=this._documents.getDocument(M),be=y.Range.to(H),se=await this._provider.provideDocumentRangeFormattingEdits(de,be,G,X);if(Array.isArray(se))return se.map(y.TextEdit.from)}}class ee{constructor(M,H){this._documents=M,this._provider=H,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(M,H,G,X,de){const be=this._documents.getDocument(M),se=y.Position.to(H),De=await this._provider.provideOnTypeFormattingEdits(be,se,G,X,de);if(Array.isArray(De))return De.map(y.TextEdit.from)}}class B{constructor(M,H){this._provider=M,this._logService=H,this._cache=new g.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(M,H){const G=await this._provider.provideWorkspaceSymbols(M,H);if(!(0,L.isNonEmptyArray)(G))return{symbols:[]};const X=this._cache.add(G),de={cacheId:X,symbols:[]};for(let be=0;be<G.length;be++){const se=G[be];if(!se||!se.name){this._logService.warn("INVALID SymbolInformation",se);continue}de.symbols.push({...y.WorkspaceSymbol.from(se),cacheId:[X,be]})}return de}async resolveWorkspaceSymbol(M,H){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!M.cacheId)return M;const G=this._cache.get(...M.cacheId);if(G){const X=await this._provider.resolveWorkspaceSymbol(G,H);return X&&(0,n.mixin)(M,y.WorkspaceSymbol.from(X),!0)}}releaseWorkspaceSymbols(M){this._cache.delete(M)}}class z{constructor(M,H,G){this._documents=M,this._provider=H,this._logService=G}static supportsResolving(M){return typeof M.prepareRename=="function"}async provideRenameEdits(M,H,G,X){const de=this._documents.getDocument(M),be=y.Position.to(H);try{const se=await this._provider.provideRenameEdits(de,be,G,X);return se?y.WorkspaceEdit.from(se):void 0}catch(se){const De=z._asMessage(se);return De?{rejectReason:De,edits:void 0}:Promise.reject(se)}}async resolveRenameLocation(M,H,G){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const X=this._documents.getDocument(M),de=y.Position.to(H);try{const be=await this._provider.prepareRename(X,de,G);let se,De;if(A.Range.isRange(be)?(se=be,De=X.getText(be)):(0,I.isObject)(be)&&(se=be.range,De=be.placeholder),!se||!De)return;if(se.start.line>de.line||se.end.line<de.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:y.Range.from(se),text:De}}catch(be){const se=z._asMessage(be);return se?{rejectReason:se,range:void 0,text:void 0}:Promise.reject(be)}}static _asMessage(M){return typeof M=="string"?M:M instanceof Error&&typeof M.message=="string"?M.message:void 0}}class q{constructor(M,H){this.resultId=M,this.tokens=H}}class V{constructor(M,H){this._documents=M,this._provider=H,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(M,H,G){const X=this._documents.getDocument(M),de=H!==0?this._previousResults.get(H):null;let be=typeof de?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(X,de.resultId,G):await this._provider.provideDocumentSemanticTokens(X,G);return de&&this._previousResults.delete(H),be?(be=V._fixProvidedSemanticTokens(be),this._send(V._convertToEdits(de,be),be)):null}async releaseDocumentSemanticColoring(M){this._previousResults.delete(M)}static _fixProvidedSemanticTokens(M){return V._isSemanticTokens(M)?V._isCorrectSemanticTokens(M)?M:new A.SemanticTokens(new Uint32Array(M.data),M.resultId):V._isSemanticTokensEdits(M)?V._isCorrectSemanticTokensEdits(M)?M:new A.SemanticTokensEdits(M.edits.map(H=>new A.SemanticTokensEdit(H.start,H.deleteCount,H.data?new Uint32Array(H.data):H.data)),M.resultId):M}static _isSemanticTokens(M){return M&&!!M.data}static _isCorrectSemanticTokens(M){return M.data instanceof Uint32Array}static _isSemanticTokensEdits(M){return M&&Array.isArray(M.edits)}static _isCorrectSemanticTokensEdits(M){for(const H of M.edits)if(!(H.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(M,H){if(!V._isSemanticTokens(H)||!M||!M.tokens)return H;const G=M.tokens,X=G.length,de=H.data,be=de.length;let se=0;const De=Math.min(X,be);for(;se<De&&G[se]===de[se];)se++;if(se===X&&se===be)return new A.SemanticTokensEdits([],H.resultId);let Ce=0;const ze=De-se;for(;Ce<ze&&G[X-Ce-1]===de[be-Ce-1];)Ce++;return new A.SemanticTokensEdits([{start:se,deleteCount:X-se-Ce,data:de.subarray(se,be-Ce)}],H.resultId)}_send(M,H){if(V._isSemanticTokens(M)){const G=this._nextResultId++;return this._previousResults.set(G,new q(M.resultId,M.data)),(0,b.encodeSemanticTokensDto)({id:G,type:"full",data:M.data})}if(V._isSemanticTokensEdits(M)){const G=this._nextResultId++;return V._isSemanticTokens(H)?this._previousResults.set(G,new q(H.resultId,H.data)):this._previousResults.set(G,new q(M.resultId)),(0,b.encodeSemanticTokensDto)({id:G,type:"delta",deltas:(M.edits||[]).map(X=>({start:X.start,deleteCount:X.deleteCount,data:X.data}))})}return null}}e.DocumentSemanticTokensAdapter=V;class j{constructor(M,H){this._documents=M,this._provider=H}async provideDocumentRangeSemanticTokens(M,H,G){const X=this._documents.getDocument(M),de=await this._provider.provideDocumentRangeSemanticTokens(X,y.Range.to(H),G);return de?this._send(de):null}_send(M){return(0,b.encodeSemanticTokensDto)({id:0,type:"full",data:M.data})}}e.DocumentRangeSemanticTokensAdapter=j;class ne{constructor(M,H,G,X,de){this._documents=M,this._commands=H,this._provider=G,this._apiDeprecation=X,this._extension=de,this._cache=new g.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(M){return typeof M.resolveCompletionItem=="function"}async provideCompletionItems(M,H,G,X){const de=this._documents.getDocument(M),be=y.Position.to(H),se=de.getWordRangeAtPosition(be)||new A.Range(be,be),De=se.with({end:be}),Ce=new v.StopWatch(!0),ze=await this._provider.provideCompletionItems(de,be,X,y.CompletionContext.to(G));if(!ze||X.isCancellationRequested)return;const Ke=Array.isArray(ze)?new A.CompletionList(ze):ze,Ne=ne.supportsResolving(this._provider)?this._cache.add(Ke.items):this._cache.add([]),Ye=new w.DisposableStore;this._disposables.set(Ne,Ye);const Z=[],re={x:Ne,b:Z,a:{replace:y.Range.from(se),insert:y.Range.from(De)},c:Ke.isIncomplete||void 0,d:Ce.elapsed()};for(let Se=0;Se<Ke.items.length;Se++){const We=Ke.items[Se],oe=this._convertCompletionItem(We,[Ne,Se],De,se);Z.push(oe)}return re}async resolveCompletionItem(M,H){if(typeof this._provider.resolveCompletionItem!="function")return;const G=this._cache.get(...M);if(!G)return;const X=await this._provider.resolveCompletionItem(G,H);if(!!X)return this._convertCompletionItem(X,M)}releaseCompletionItems(M){this._disposables.get(M)?.dispose(),this._disposables.delete(M),this._cache.delete(M)}_convertCompletionItem(M,H,G,X){const de=this._disposables.get(H[0]);if(!de)throw Error("DisposableStore is missing...");const be={x:H,a:M.label,b:M.kind!==void 0?y.CompletionItemKind.from(M.kind):void 0,n:M.tags&&M.tags.map(y.CompletionItemTag.from),c:M.detail,d:typeof M.documentation=="undefined"?void 0:y.MarkdownString.fromStrict(M.documentation),e:M.sortText!==M.label?M.sortText:void 0,f:M.filterText!==M.label?M.filterText:void 0,g:M.preselect||void 0,i:M.keepWhitespace?1:0,k:M.commitCharacters,l:M.additionalTextEdits&&M.additionalTextEdits.map(y.TextEdit.from),m:this._commands.toInternal(M.command,de)};M.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),be.h=M.textEdit.newText):typeof M.insertText=="string"?be.h=M.insertText:M.insertText instanceof A.SnippetString&&(be.h=M.insertText.value,be.i|=4);let se;return M.textEdit?se=M.textEdit.range:M.range&&(se=M.range),A.Range.isRange(se)?be.j=y.Range.from(se):se&&(!G?.isEqual(se.inserting)||!X?.isEqual(se.replacing))&&(be.j={insert:y.Range.from(se.inserting),replace:y.Range.from(se.replacing)}),be}}class Y{async provideInlineCompletions(M,H,G,X){}disposeCompletions(M){}handleDidShowCompletionItem(M,H){}}class le extends Y{constructor(M,H,G,X){super();this._extension=M,this._documents=H,this._provider=G,this._commands=X,this._references=new K,this._isAdditionsProposedApiEnabled=(0,m.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[D.InlineCompletionTriggerKind.Automatic]:A.InlineCompletionTriggerKind.Automatic,[D.InlineCompletionTriggerKind.Explicit]:A.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,m.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&typeof this._provider.handleDidShowCompletionItem=="function"}async provideInlineCompletions(M,H,G,X){const de=this._documents.getDocument(M),be=y.Position.to(H),se=await this._provider.provideInlineCompletionItems(de,be,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:y.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[G.triggerKind]},X);if(!se||X.isCancellationRequested)return;const De=(0,I.isArray)(se)?se:se.items,Ce=this._isAdditionsProposedApiEnabled?(0,I.isArray)(se)?[]:se.commands||[]:[];let ze;return{pid:this._references.createReferenceId({dispose(){ze&&ze.dispose()},items:De}),items:De.map((Ne,Ye)=>{let Z;Ne.command&&(ze||(ze=new w.DisposableStore),Z=this._commands.toInternal(Ne.command,ze));const re=Ne.insertText;return{insertText:typeof re=="string"?re:{snippet:re.value},filterText:Ne.filterText,range:Ne.range?y.Range.from(Ne.range):void 0,command:Z,idx:Ye,completeBracketPairs:this._isAdditionsProposedApiEnabled?Ne.completeBracketPairs:!1}}),commands:Ce.map(Ne=>(ze||(ze=new w.DisposableStore),this._commands.toInternal(Ne,ze)))}}disposeCompletions(M){this._references.disposeReferenceId(M)?.dispose()}handleDidShowCompletionItem(M,H){const G=this._references.get(M)?.items[H];G&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(G)}}class ue extends Y{constructor(M,H,G,X){super();this.extension=M,this._documents=H,this._provider=G,this._commands=X,this._references=new K,this.isAdditionProposedApiEnabled=(0,m.isProposedApiEnabled)(this.extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[D.InlineCompletionTriggerKind.Automatic]:A.InlineCompletionTriggerKindNew.Automatic,[D.InlineCompletionTriggerKind.Explicit]:A.InlineCompletionTriggerKindNew.Invoke}}async provideInlineCompletions(M,H,G,X){const de=this._documents.getDocument(M),be=y.Position.to(H),se=await this._provider.provideInlineCompletionItems(de,be,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:y.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[G.triggerKind]},X);if(!se||X.isCancellationRequested)return;const De=(0,I.isArray)(se)?se:se.items,Ce=(0,I.isArray)(se)?[]:se.commands||[];let ze;return{pid:this._references.createReferenceId({dispose(){ze&&ze.dispose()},items:De}),items:De.map((Ne,Ye)=>{let Z;Ne.command&&(ze||(ze=new w.DisposableStore),Z=this._commands.toInternal(Ne.command,ze));const re=Ne.insertText;return{insertText:typeof re=="string"?re:{snippet:re.value},filterText:Ne.filterText,range:Ne.range?y.Range.from(Ne.range):void 0,command:Z,idx:Ye,completeBracketPairs:this.isAdditionProposedApiEnabled?Ne.completeBracketPairs:!1}}),commands:Ce.map(Ne=>(ze||(ze=new w.DisposableStore),this._commands.toInternal(Ne,ze)))}}disposeCompletions(M){this._references.disposeReferenceId(M)?.dispose()}handleDidShowCompletionItem(M,H){const G=this._references.get(M)?.items[H];G&&this._provider.handleDidShowCompletionItem&&this.isAdditionProposedApiEnabled&&this._provider.handleDidShowCompletionItem(G)}}class K{constructor(){this._references=new Map,this._idPool=1}createReferenceId(M){const H=this._idPool++;return this._references.set(H,M),H}disposeReferenceId(M){const H=this._references.get(M);return this._references.delete(M),H}get(M){return this._references.get(M)}}class ge{constructor(M,H){this._documents=M,this._provider=H,this._cache=new g.Cache("SignatureHelp")}async provideSignatureHelp(M,H,G,X){const de=this._documents.getDocument(M),be=y.Position.to(H),se=this.reviveContext(G),De=await this._provider.provideSignatureHelp(de,be,X,se);if(De){const Ce=this._cache.add([De]);return{...y.SignatureHelp.from(De),id:Ce}}}reviveContext(M){let H;if(M.activeSignatureHelp){const G=y.SignatureHelp.to(M.activeSignatureHelp),X=this._cache.get(M.activeSignatureHelp.id,0);X?(H=X,H.activeSignature=G.activeSignature,H.activeParameter=G.activeParameter):H=G}return{...M,activeSignatureHelp:H}}releaseSignatureHelp(M){this._cache.delete(M)}}class ye{constructor(M,H,G,X,de){this._documents=M,this._commands=H,this._provider=G,this._logService=X,this._extension=de,this._cache=new g.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(M,H,G){const X=this._documents.getDocument(M),de=y.Range.to(H),be=await this._provider.provideInlayHints(X,de,G);if(!Array.isArray(be)||be.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${H}`);return}if(G.isCancellationRequested)return;const se=this._cache.add(be);this._disposables.set(se,new w.DisposableStore);const De={hints:[],cacheId:se};for(let Ce=0;Ce<be.length;Ce++)this._isValidInlayHint(be[Ce],de)&&De.hints.push(this._convertInlayHint(be[Ce],[se,Ce]));return this._logService.trace(`[InlayHints] ${De.hints.length} inlay hints from '${this._extension.identifier.value}' for ${H}`),De}async resolveInlayHint(M,H){if(typeof this._provider.resolveInlayHint!="function")return;const G=this._cache.get(...M);if(!G)return;const X=await this._provider.resolveInlayHint(G,H);if(!!X&&!!this._isValidInlayHint(X))return this._convertInlayHint(X,M)}releaseHints(M){this._disposables.get(M)?.dispose(),this._disposables.delete(M),this._cache.delete(M)}_isValidInlayHint(M,H){return M.label.length===0||Array.isArray(M.label)&&M.label.every(G=>G.value.length===0)?(console.log("INVALID inlay hint, empty label",M),!1):!(H&&!H.contains(M.position))}_convertInlayHint(M,H){const G=this._disposables.get(H[0]);if(!G)throw Error("DisposableStore is missing...");const X={label:"",cacheId:H,tooltip:y.MarkdownString.fromStrict(M.tooltip),position:y.Position.from(M.position),textEdits:M.textEdits&&M.textEdits.map(y.TextEdit.from),kind:M.kind&&y.InlayHintKind.from(M.kind),paddingLeft:M.paddingLeft,paddingRight:M.paddingRight};return typeof M.label=="string"?X.label=M.label:X.label=M.label.map(de=>{const be={label:de.value};return be.tooltip=y.MarkdownString.fromStrict(de.tooltip),A.Location.isLocation(de.location)&&(be.location=y.location.from(de.location)),de.command&&(be.command=this._commands.toInternal(de.command,G)),be}),X}}class Te{constructor(M,H){this._documents=M,this._provider=H,this._cache=new g.Cache("DocumentLink")}async provideLinks(M,H){const G=this._documents.getDocument(M),X=await this._provider.provideDocumentLinks(G,H);if(!(!Array.isArray(X)||X.length===0)&&!H.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:X.filter(Te._validateLink).map(y.DocumentLink.from)};{const de=this._cache.add(X),be={links:[],cacheId:de};for(let se=0;se<X.length;se++){if(!Te._validateLink(X[se]))continue;const De=y.DocumentLink.from(X[se]);De.cacheId=[de,se],be.links.push(De)}return be}}}static _validateLink(M){return M.target&&M.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(M,H){if(typeof this._provider.resolveDocumentLink!="function")return;const G=this._cache.get(...M);if(!G)return;const X=await this._provider.resolveDocumentLink(G,H);if(!(!X||!Te._validateLink(X)))return y.DocumentLink.from(X)}releaseLinks(M){this._cache.delete(M)}}class pe{constructor(M,H){this._documents=M,this._provider=H}async provideColors(M,H){const G=this._documents.getDocument(M),X=await this._provider.provideDocumentColors(G,H);return Array.isArray(X)?X.map(be=>({color:y.Color.from(be.color),range:y.Range.from(be.range)})):[]}async provideColorPresentations(M,H,G){const X=this._documents.getDocument(M),de=y.Range.to(H.range),be=y.Color.to(H.color),se=await this._provider.provideColorPresentations(be,{document:X,range:de},G);if(!!Array.isArray(se))return se.map(y.ColorPresentation.from)}}class Pe{constructor(M,H){this._documents=M,this._provider=H}async provideFoldingRanges(M,H,G){const X=this._documents.getDocument(M),de=await this._provider.provideFoldingRanges(X,H,G);if(!!Array.isArray(de))return de.map(y.FoldingRange.from)}}class fe{constructor(M,H,G){this._documents=M,this._provider=H,this._logService=G}async provideSelectionRanges(M,H,G){const X=this._documents.getDocument(M),de=H.map(y.Position.to),be=await this._provider.provideSelectionRanges(X,de,G);if(!(0,L.isNonEmptyArray)(be))return[];if(be.length!==de.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const se=[];for(let De=0;De<de.length;De++){const Ce=[];se.push(Ce);let ze=de[De],Ke=be[De];for(;;){if(!Ke.range.contains(ze))throw new Error("INVALID selection range, must contain the previous range");if(Ce.push(y.SelectionRange.from(Ke)),!Ke.parent)break;ze=Ke.range,Ke=Ke.parent}}return se}}class ve{constructor(M,H){this._documents=M,this._provider=H,this._idPool=new p.IdGenerator(""),this._cache=new Map}async prepareSession(M,H,G){const X=this._documents.getDocument(M),de=y.Position.to(H),be=await this._provider.prepareCallHierarchy(X,de,G);if(!be)return;const se=this._idPool.nextId();return this._cache.set(se,new Map),Array.isArray(be)?be.map(De=>this._cacheAndConvertItem(se,De)):[this._cacheAndConvertItem(se,be)]}async provideCallsTo(M,H,G){const X=this._itemFromCache(M,H);if(!X)throw new Error("missing call hierarchy item");const de=await this._provider.provideCallHierarchyIncomingCalls(X,G);if(!!de)return de.map(be=>({from:this._cacheAndConvertItem(M,be.from),fromRanges:be.fromRanges.map(se=>y.Range.from(se))}))}async provideCallsFrom(M,H,G){const X=this._itemFromCache(M,H);if(!X)throw new Error("missing call hierarchy item");const de=await this._provider.provideCallHierarchyOutgoingCalls(X,G);if(!!de)return de.map(be=>({to:this._cacheAndConvertItem(M,be.to),fromRanges:be.fromRanges.map(se=>y.Range.from(se))}))}releaseSession(M){this._cache.delete(M)}_cacheAndConvertItem(M,H){const G=this._cache.get(M),X=y.CallHierarchyItem.from(H,M,G.size.toString(36));return G.set(X._itemId,H),X}_itemFromCache(M,H){return this._cache.get(M)?.get(H)}}class _e{constructor(M,H){this._documents=M,this._provider=H,this._idPool=new p.IdGenerator(""),this._cache=new Map}async prepareSession(M,H,G){const X=this._documents.getDocument(M),de=y.Position.to(H),be=await this._provider.prepareTypeHierarchy(X,de,G);if(!be)return;const se=this._idPool.nextId();return this._cache.set(se,new Map),Array.isArray(be)?be.map(De=>this._cacheAndConvertItem(se,De)):[this._cacheAndConvertItem(se,be)]}async provideSupertypes(M,H,G){const X=this._itemFromCache(M,H);if(!X)throw new Error("missing type hierarchy item");const de=await this._provider.provideTypeHierarchySupertypes(X,G);if(!!de)return de.map(be=>this._cacheAndConvertItem(M,be))}async provideSubtypes(M,H,G){const X=this._itemFromCache(M,H);if(!X)throw new Error("missing type hierarchy item");const de=await this._provider.provideTypeHierarchySubtypes(X,G);if(!!de)return de.map(be=>this._cacheAndConvertItem(M,be))}releaseSession(M){this._cache.delete(M)}_cacheAndConvertItem(M,H){const G=this._cache.get(M),X=y.TypeHierarchyItem.from(H,M,G.size.toString(36));return G.set(X._itemId,H),X}_itemFromCache(M,H){return this._cache.get(M)?.get(H)}}class ae{constructor(M,H,G,X){this._proxy=M,this._documents=H,this._provider=G,this._handle=X}async provideDocumentOnDropEdits(M,H,G,X,de){const be=this._documents.getDocument(H),se=y.Position.to(G),De=y.DataTransfer.toDataTransfer(X,async ze=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,M,ze)).buffer),Ce=await this._provider.provideDocumentOnDropEdits(be,se,De,de);if(!!Ce)return{insertText:typeof Ce.insertText=="string"?Ce.insertText:{snippet:Ce.insertText.value},additionalEdit:Ce.additionalEdit?y.WorkspaceEdit.from(Ce.additionalEdit):void 0}}}class he{constructor(M,H){this.adapter=M,this.extension=H}}class te{constructor(M,H,G,X,de,be,se){this._adapter=new Map,this._uriTransformer=H,this._proxy=M.getProxy(C.MainContext.MainThreadLanguageFeatures),this._documents=G,this._commands=X,this._diagnostics=de,this._logService=be,this._apiDeprecation=se}_transformDocumentSelector(M){return y.DocumentSelector.from(M,this._uriTransformer)}_createDisposable(M){return new A.Disposable(()=>{this._adapter.delete(M),this._proxy.$unregister(M)})}_nextHandle(){return te._handlePool++}async _withAdapter(M,H,G,X,de,be=!1){const se=this._adapter.get(M);if(!se||!(se.adapter instanceof H))return X;const De=Date.now();be||this._logService.trace(`[${se.extension.identifier.value}] INVOKE provider '${G.toString().replace(/[\r\n]/g,"")}'`);const Ce=G(se.adapter,se.extension);return Promise.resolve(Ce).catch(ze=>{(0,f.isCancellationError)(ze)||(this._logService.error(`[${se.extension.identifier.value}] provider FAILED`),this._logService.error(ze))}).finally(()=>{be||this._logService.trace(`[${se.extension.identifier.value}] provider DONE after ${Date.now()-De}ms`)}),T.CancellationToken.isCancellationToken(de)?(0,a.raceCancellationError)(Ce,de):Ce}_addNewAdapter(M,H){const G=this._nextHandle();return this._adapter.set(G,new he(M,H)),G}static _extLabel(M){return M.displayName||M.name}registerDocumentSymbolProvider(M,H,G,X){const de=this._addNewAdapter(new o(this._documents,G),M),be=X&&X.label||te._extLabel(M);return this._proxy.$registerDocumentSymbolProvider(de,this._transformDocumentSelector(H),be),this._createDisposable(de)}$provideDocumentSymbols(M,H,G){return this._withAdapter(M,o,X=>X.provideDocumentSymbols(u.URI.revive(H),G),void 0,G)}registerCodeLensProvider(M,H,G){const X=this._nextHandle(),de=typeof G.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(X,new he(new d(this._documents,this._commands.converter,G),M)),this._proxy.$registerCodeLensSupport(X,this._transformDocumentSelector(H),de);let be=this._createDisposable(X);if(de!==void 0){const se=G.onDidChangeCodeLenses(De=>this._proxy.$emitCodeLensEvent(de));be=A.Disposable.from(be,se)}return be}$provideCodeLenses(M,H,G){return this._withAdapter(M,d,X=>X.provideCodeLenses(u.URI.revive(H),G),void 0,G)}$resolveCodeLens(M,H,G){return this._withAdapter(M,d,X=>X.resolveCodeLens(H,G),void 0,void 0)}$releaseCodeLenses(M,H){this._withAdapter(M,d,G=>Promise.resolve(G.releaseCodeLenses(H)),void 0,void 0)}registerDefinitionProvider(M,H,G){const X=this._addNewAdapter(new s(this._documents,G),M);return this._proxy.$registerDefinitionSupport(X,this._transformDocumentSelector(H)),this._createDisposable(X)}$provideDefinition(M,H,G,X){return this._withAdapter(M,s,de=>de.provideDefinition(u.URI.revive(H),G,X),[],X)}registerDeclarationProvider(M,H,G){const X=this._addNewAdapter(new i(this._documents,G),M);return this._proxy.$registerDeclarationSupport(X,this._transformDocumentSelector(H)),this._createDisposable(X)}$provideDeclaration(M,H,G,X){return this._withAdapter(M,i,de=>de.provideDeclaration(u.URI.revive(H),G,X),[],X)}registerImplementationProvider(M,H,G){const X=this._addNewAdapter(new t(this._documents,G),M);return this._proxy.$registerImplementationSupport(X,this._transformDocumentSelector(H)),this._createDisposable(X)}$provideImplementation(M,H,G,X){return this._withAdapter(M,t,de=>de.provideImplementation(u.URI.revive(H),G,X),[],X)}registerTypeDefinitionProvider(M,H,G){const X=this._addNewAdapter(new c(this._documents,G),M);return this._proxy.$registerTypeDefinitionSupport(X,this._transformDocumentSelector(H)),this._createDisposable(X)}$provideTypeDefinition(M,H,G,X){return this._withAdapter(M,c,de=>de.provideTypeDefinition(u.URI.revive(H),G,X),[],X)}registerHoverProvider(M,H,G,X){const de=this._addNewAdapter(new l(this._documents,G),M);return this._proxy.$registerHoverProvider(de,this._transformDocumentSelector(H)),this._createDisposable(de)}$provideHover(M,H,G,X){return this._withAdapter(M,l,de=>de.provideHover(u.URI.revive(H),G,X),void 0,X)}registerEvaluatableExpressionProvider(M,H,G,X){const de=this._addNewAdapter(new h(this._documents,G),M);return this._proxy.$registerEvaluatableExpressionProvider(de,this._transformDocumentSelector(H)),this._createDisposable(de)}$provideEvaluatableExpression(M,H,G,X){return this._withAdapter(M,h,de=>de.provideEvaluatableExpression(u.URI.revive(H),G,X),void 0,X)}registerInlineValuesProvider(M,H,G,X){const de=typeof G.onDidChangeInlineValues=="function"?this._nextHandle():void 0,be=this._addNewAdapter(new E(this._documents,G),M);this._proxy.$registerInlineValuesProvider(be,this._transformDocumentSelector(H),de);let se=this._createDisposable(be);if(de!==void 0){const De=G.onDidChangeInlineValues(Ce=>this._proxy.$emitInlineValuesEvent(de));se=A.Disposable.from(se,De)}return se}$provideInlineValues(M,H,G,X,de){return this._withAdapter(M,E,be=>be.provideInlineValues(u.URI.revive(H),G,X,de),void 0,de)}registerDocumentHighlightProvider(M,H,G){const X=this._addNewAdapter(new R(this._documents,G),M);return this._proxy.$registerDocumentHighlightProvider(X,this._transformDocumentSelector(H)),this._createDisposable(X)}$provideDocumentHighlights(M,H,G,X){return this._withAdapter(M,R,de=>de.provideDocumentHighlights(u.URI.revive(H),G,X),void 0,X)}registerLinkedEditingRangeProvider(M,H,G){const X=this._addNewAdapter(new N(this._documents,G),M);return this._proxy.$registerLinkedEditingRangeProvider(X,this._transformDocumentSelector(H)),this._createDisposable(X)}$provideLinkedEditingRanges(M,H,G,X){return this._withAdapter(M,N,async de=>{const be=await de.provideLinkedEditingRanges(u.URI.revive(H),G,X);if(be)return{ranges:be.ranges,wordPattern:be.wordPattern?te._serializeRegExp(be.wordPattern):void 0}},void 0,X)}registerReferenceProvider(M,H,G){const X=this._addNewAdapter(new O(this._documents,G),M);return this._proxy.$registerReferenceSupport(X,this._transformDocumentSelector(H)),this._createDisposable(X)}$provideReferences(M,H,G,X,de){return this._withAdapter(M,O,be=>be.provideReferences(u.URI.revive(H),G,X,de),void 0,de)}registerCodeActionProvider(M,H,G,X){const de=new w.DisposableStore,be=this._addNewAdapter(new k(this._documents,this._commands.converter,this._diagnostics,G,this._logService,M,this._apiDeprecation),M);return this._proxy.$registerQuickFixSupport(be,this._transformDocumentSelector(H),{providedKinds:X?.providedCodeActionKinds?.map(se=>se.value),documentation:X?.documentation?.map(se=>({kind:se.kind.value,command:this._commands.converter.toInternal(se.command,de)}))},te._extLabel(M),Boolean(G.resolveCodeAction)),de.add(this._createDisposable(be)),de}$provideCodeActions(M,H,G,X,de){return this._withAdapter(M,k,be=>be.provideCodeActions(u.URI.revive(H),G,X,de),void 0,de)}$resolveCodeAction(M,H,G){return this._withAdapter(M,k,X=>X.resolveCodeAction(H,G),void 0,void 0)}$releaseCodeActions(M,H){this._withAdapter(M,k,G=>Promise.resolve(G.releaseCodeActions(H)),void 0,void 0)}registerDocumentFormattingEditProvider(M,H,G){const X=this._addNewAdapter(new F(this._documents,G),M);return this._proxy.$registerDocumentFormattingSupport(X,this._transformDocumentSelector(H),M.identifier,M.displayName||M.name),this._createDisposable(X)}$provideDocumentFormattingEdits(M,H,G,X){return this._withAdapter(M,F,de=>de.provideDocumentFormattingEdits(u.URI.revive(H),G,X),void 0,X)}registerDocumentRangeFormattingEditProvider(M,H,G){const X=this._addNewAdapter(new $(this._documents,G),M);return this._proxy.$registerRangeFormattingSupport(X,this._transformDocumentSelector(H),M.identifier,M.displayName||M.name),this._createDisposable(X)}$provideDocumentRangeFormattingEdits(M,H,G,X,de){return this._withAdapter(M,$,be=>be.provideDocumentRangeFormattingEdits(u.URI.revive(H),G,X,de),void 0,de)}registerOnTypeFormattingEditProvider(M,H,G,X){const de=this._addNewAdapter(new ee(this._documents,G),M);return this._proxy.$registerOnTypeFormattingSupport(de,this._transformDocumentSelector(H),X,M.identifier),this._createDisposable(de)}$provideOnTypeFormattingEdits(M,H,G,X,de,be){return this._withAdapter(M,ee,se=>se.provideOnTypeFormattingEdits(u.URI.revive(H),G,X,de,be),void 0,be)}registerWorkspaceSymbolProvider(M,H){const G=this._addNewAdapter(new B(H,this._logService),M);return this._proxy.$registerNavigateTypeSupport(G,typeof H.resolveWorkspaceSymbol=="function"),this._createDisposable(G)}$provideWorkspaceSymbols(M,H,G){return this._withAdapter(M,B,X=>X.provideWorkspaceSymbols(H,G),{symbols:[]},G)}$resolveWorkspaceSymbol(M,H,G){return this._withAdapter(M,B,X=>X.resolveWorkspaceSymbol(H,G),void 0,void 0)}$releaseWorkspaceSymbols(M,H){this._withAdapter(M,B,G=>G.releaseWorkspaceSymbols(H),void 0,void 0)}registerRenameProvider(M,H,G){const X=this._addNewAdapter(new z(this._documents,G,this._logService),M);return this._proxy.$registerRenameSupport(X,this._transformDocumentSelector(H),z.supportsResolving(G)),this._createDisposable(X)}$provideRenameEdits(M,H,G,X,de){return this._withAdapter(M,z,be=>be.provideRenameEdits(u.URI.revive(H),G,X,de),void 0,de)}$resolveRenameLocation(M,H,G,X){return this._withAdapter(M,z,de=>de.resolveRenameLocation(u.URI.revive(H),G,X),void 0,X)}registerDocumentSemanticTokensProvider(M,H,G,X){const de=this._addNewAdapter(new V(this._documents,G),M),be=typeof G.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(de,this._transformDocumentSelector(H),X,be);let se=this._createDisposable(de);if(be){const De=G.onDidChangeSemanticTokens(Ce=>this._proxy.$emitDocumentSemanticTokensEvent(be));se=A.Disposable.from(se,De)}return se}$provideDocumentSemanticTokens(M,H,G,X){return this._withAdapter(M,V,de=>de.provideDocumentSemanticTokens(u.URI.revive(H),G,X),null,X)}$releaseDocumentSemanticTokens(M,H){this._withAdapter(M,V,G=>G.releaseDocumentSemanticColoring(H),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(M,H,G,X){const de=this._addNewAdapter(new j(this._documents,G),M);return this._proxy.$registerDocumentRangeSemanticTokensProvider(de,this._transformDocumentSelector(H),X),this._createDisposable(de)}$provideDocumentRangeSemanticTokens(M,H,G,X){return this._withAdapter(M,j,de=>de.provideDocumentRangeSemanticTokens(u.URI.revive(H),G,X),null,X)}registerCompletionItemProvider(M,H,G,X){const de=this._addNewAdapter(new ne(this._documents,this._commands.converter,G,this._apiDeprecation,M),M);return this._proxy.$registerCompletionsProvider(de,this._transformDocumentSelector(H),X,ne.supportsResolving(G),`${M.identifier.value}(${X.join("")})`),this._createDisposable(de)}$provideCompletionItems(M,H,G,X,de){return this._withAdapter(M,ne,be=>be.provideCompletionItems(u.URI.revive(H),G,X,de),void 0,de)}$resolveCompletionItem(M,H,G){return this._withAdapter(M,ne,X=>X.resolveCompletionItem(H,G),void 0,G)}$releaseCompletionItems(M,H){this._withAdapter(M,ne,G=>G.releaseCompletionItems(H),void 0,void 0)}registerInlineCompletionsProvider(M,H,G){const X=new le(M,this._documents,G,this._commands.converter),de=this._addNewAdapter(X,M);return this._proxy.$registerInlineCompletionsSupport(de,this._transformDocumentSelector(H),X.supportsHandleDidShowCompletionItem),this._createDisposable(de)}registerInlineCompletionsProviderNew(M,H,G){const X=this._addNewAdapter(new ue(M,this._documents,G,this._commands.converter),M);return this._proxy.$registerInlineCompletionsSupport(X,this._transformDocumentSelector(H),!0),this._createDisposable(X)}$provideInlineCompletions(M,H,G,X,de){return this._withAdapter(M,Y,be=>be.provideInlineCompletions(u.URI.revive(H),G,X,de),void 0,de)}$handleInlineCompletionDidShow(M,H,G){this._withAdapter(M,Y,async X=>{X.handleDidShowCompletionItem(H,G)},void 0,void 0)}$freeInlineCompletionsList(M,H){this._withAdapter(M,Y,async G=>{G.disposeCompletions(H)},void 0,void 0)}registerSignatureHelpProvider(M,H,G,X){const de=Array.isArray(X)?{triggerCharacters:X,retriggerCharacters:[]}:X,be=this._addNewAdapter(new ge(this._documents,G),M);return this._proxy.$registerSignatureHelpProvider(be,this._transformDocumentSelector(H),de),this._createDisposable(be)}$provideSignatureHelp(M,H,G,X,de){return this._withAdapter(M,ge,be=>be.provideSignatureHelp(u.URI.revive(H),G,X,de),void 0,de)}$releaseSignatureHelp(M,H){this._withAdapter(M,ge,G=>G.releaseSignatureHelp(H),void 0,void 0)}registerInlayHintsProvider(M,H,G){const X=typeof G.onDidChangeInlayHints=="function"?this._nextHandle():void 0,de=this._addNewAdapter(new ye(this._documents,this._commands.converter,G,this._logService,M),M);this._proxy.$registerInlayHintsProvider(de,this._transformDocumentSelector(H),typeof G.resolveInlayHint=="function",X,te._extLabel(M));let be=this._createDisposable(de);if(X!==void 0){const se=G.onDidChangeInlayHints(De=>this._proxy.$emitInlayHintsEvent(X));be=A.Disposable.from(be,se)}return be}$provideInlayHints(M,H,G,X){return this._withAdapter(M,ye,de=>de.provideInlayHints(u.URI.revive(H),G,X),void 0,X)}$resolveInlayHint(M,H,G){return this._withAdapter(M,ye,X=>X.resolveInlayHint(H,G),void 0,G)}$releaseInlayHints(M,H){this._withAdapter(M,ye,G=>G.releaseHints(H),void 0,void 0)}registerDocumentLinkProvider(M,H,G){const X=this._addNewAdapter(new Te(this._documents,G),M);return this._proxy.$registerDocumentLinkProvider(X,this._transformDocumentSelector(H),typeof G.resolveDocumentLink=="function"),this._createDisposable(X)}$provideDocumentLinks(M,H,G){return this._withAdapter(M,Te,X=>X.provideLinks(u.URI.revive(H),G),void 0,G,H.scheme==="output")}$resolveDocumentLink(M,H,G){return this._withAdapter(M,Te,X=>X.resolveLink(H,G),void 0,void 0,!0)}$releaseDocumentLinks(M,H){this._withAdapter(M,Te,G=>G.releaseLinks(H),void 0,void 0,!0)}registerColorProvider(M,H,G){const X=this._addNewAdapter(new pe(this._documents,G),M);return this._proxy.$registerDocumentColorProvider(X,this._transformDocumentSelector(H)),this._createDisposable(X)}$provideDocumentColors(M,H,G){return this._withAdapter(M,pe,X=>X.provideColors(u.URI.revive(H),G),[],G)}$provideColorPresentations(M,H,G,X){return this._withAdapter(M,pe,de=>de.provideColorPresentations(u.URI.revive(H),G,X),void 0,X)}registerFoldingRangeProvider(M,H,G){const X=this._nextHandle(),de=typeof G.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(X,new he(new Pe(this._documents,G),M)),this._proxy.$registerFoldingRangeProvider(X,this._transformDocumentSelector(H),de);let be=this._createDisposable(X);if(de!==void 0){const se=G.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(de));be=A.Disposable.from(be,se)}return be}$provideFoldingRanges(M,H,G,X){return this._withAdapter(M,Pe,de=>de.provideFoldingRanges(u.URI.revive(H),G,X),void 0,X)}registerSelectionRangeProvider(M,H,G){const X=this._addNewAdapter(new fe(this._documents,G,this._logService),M);return this._proxy.$registerSelectionRangeProvider(X,this._transformDocumentSelector(H)),this._createDisposable(X)}$provideSelectionRanges(M,H,G,X){return this._withAdapter(M,fe,de=>de.provideSelectionRanges(u.URI.revive(H),G,X),[],X)}registerCallHierarchyProvider(M,H,G){const X=this._addNewAdapter(new ve(this._documents,G),M);return this._proxy.$registerCallHierarchyProvider(X,this._transformDocumentSelector(H)),this._createDisposable(X)}$prepareCallHierarchy(M,H,G,X){return this._withAdapter(M,ve,de=>Promise.resolve(de.prepareSession(u.URI.revive(H),G,X)),void 0,X)}$provideCallHierarchyIncomingCalls(M,H,G,X){return this._withAdapter(M,ve,de=>de.provideCallsTo(H,G,X),void 0,X)}$provideCallHierarchyOutgoingCalls(M,H,G,X){return this._withAdapter(M,ve,de=>de.provideCallsFrom(H,G,X),void 0,X)}$releaseCallHierarchy(M,H){this._withAdapter(M,ve,G=>Promise.resolve(G.releaseSession(H)),void 0,void 0)}registerTypeHierarchyProvider(M,H,G){const X=this._addNewAdapter(new _e(this._documents,G),M);return this._proxy.$registerTypeHierarchyProvider(X,this._transformDocumentSelector(H)),this._createDisposable(X)}$prepareTypeHierarchy(M,H,G,X){return this._withAdapter(M,_e,de=>Promise.resolve(de.prepareSession(u.URI.revive(H),G,X)),void 0,X)}$provideTypeHierarchySupertypes(M,H,G,X){return this._withAdapter(M,_e,de=>de.provideSupertypes(H,G,X),void 0,X)}$provideTypeHierarchySubtypes(M,H,G,X){return this._withAdapter(M,_e,de=>de.provideSubtypes(H,G,X),void 0,X)}$releaseTypeHierarchy(M,H){this._withAdapter(M,_e,G=>Promise.resolve(G.releaseSession(H)),void 0,void 0)}registerDocumentOnDropEditProvider(M,H,G){const X=this._nextHandle();return this._adapter.set(X,new he(new ae(this._proxy,this._documents,G,X),M)),this._proxy.$registerDocumentOnDropEditProvider(X,this._transformDocumentSelector(H)),this._createDisposable(X)}$provideDocumentOnDropEdits(M,H,G,X,de,be){return this._withAdapter(M,ae,se=>Promise.resolve(se.provideDocumentOnDropEdits(H,u.URI.revive(G),X,de,be)),void 0,void 0)}registerDocumentPasteEditProvider(M,H,G,X){const de=this._nextHandle();return this._adapter.set(de,new he(new U(this._proxy,this._documents,G,de),M)),this._proxy.$registerPasteEditProvider(de,this._transformDocumentSelector(H),!!G.prepareDocumentPaste,X.pasteMimeTypes),this._createDisposable(de)}$prepareDocumentPaste(M,H,G,X,de){return this._withAdapter(M,U,be=>be.prepareDocumentPaste(u.URI.revive(H),G,X,de),void 0,de)}$providePasteEdits(M,H,G,X,de){return this._withAdapter(M,U,be=>be.providePasteEdits(0,u.URI.revive(H),G,X,de),void 0,de)}static _serializeRegExp(M){return{pattern:M.source,flags:(0,S.regExpFlags)(M)}}static _serializeIndentationRule(M){return{decreaseIndentPattern:te._serializeRegExp(M.decreaseIndentPattern),increaseIndentPattern:te._serializeRegExp(M.increaseIndentPattern),indentNextLinePattern:M.indentNextLinePattern?te._serializeRegExp(M.indentNextLinePattern):void 0,unIndentedLinePattern:M.unIndentedLinePattern?te._serializeRegExp(M.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(M){return{beforeText:te._serializeRegExp(M.beforeText),afterText:M.afterText?te._serializeRegExp(M.afterText):void 0,previousLineText:M.previousLineText?te._serializeRegExp(M.previousLineText):void 0,action:M.action}}static _serializeOnEnterRules(M){return M.map(te._serializeOnEnterRule)}setLanguageConfiguration(M,H,G){const{wordPattern:X}=G;if(X&&(0,S.regExpLeadsToEndlessLoop)(X))throw new Error(`Invalid language configuration: wordPattern '${X}' is not allowed to match the empty string.`);X?this._documents.setWordDefinitionFor(H,X):this._documents.setWordDefinitionFor(H,void 0),G.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",M,"Do not use."),G.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",M,"Do not use.");const de=this._nextHandle(),be={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?te._serializeRegExp(G.wordPattern):void 0,indentationRules:G.indentationRules?te._serializeIndentationRule(G.indentationRules):void 0,onEnterRules:G.onEnterRules?te._serializeOnEnterRules(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport};return this._proxy.$setLanguageConfiguration(de,H,be),this._createDisposable(de)}$setWordDefinitions(M){for(const H of M)this._documents.setWordDefinitionFor(H.languageId,new RegExp(H.regexSource,H.regexFlags))}}e.ExtHostLanguageFeatures=te,te._handlePool=0}),define(Ie[251],ke([1,0,5,15,7,41,18,6]),function(Q,e,u,n,y,A,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class S{constructor(L,I,_,T){this._documents=I,this._commands=_,this._uriTransformer=T,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=L.getProxy(u.MainContext.MainThreadLanguages)}$acceptLanguageIds(L){this._languageIds=L}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(L,I){await this._proxy.$changeLanguage(L,I);const _=this._documents.getDocumentData(L);if(!_)throw new Error(`document '${L.toString()}' NOT found`);return _.document}async tokenAtPosition(L,I){const _=L.version,T=n.Position.from(I),w=await this._proxy.$tokensAtPosition(L.uri,T),b={type:y.StandardTokenType.Other,range:L.getWordRangeAtPosition(I)??new y.Range(I.line,I.character,I.line,I.character)};if(!w)return b;const p={range:n.Range.to(w.range),type:n.TokenType.to(w.type)};return!p.range.contains(I)||_!==L.version?b:p}createLanguageStatusItem(L,I,_){const T=this._handlePool++,w=this._proxy,b=this._ids,p=`${L.identifier.value}/${I}`;if(b.has(p))throw new Error(`LanguageStatusItem with id '${I}' ALREADY exists`);b.add(p);const g={selector:_,id:I,name:L.displayName??L.name,severity:y.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let v;const f=new C.DisposableStore,a=()=>{v?.dispose(),v=(0,D.disposableTimeout)(()=>{f.clear(),this._proxy.$setLanguageStatus(T,{id:p,name:g.name??L.displayName??L.name,source:L.displayName??L.name,selector:n.DocumentSelector.from(g.selector,this._uriTransformer),label:g.text,detail:g.detail??"",severity:g.severity===y.LanguageStatusSeverity.Error?A.default.Error:g.severity===y.LanguageStatusSeverity.Warning?A.default.Warning:A.default.Info,command:g.command&&this._commands.toInternal(g.command,f),accessibilityInfo:g.accessibilityInformation,busy:g.busy})},0)},m={dispose(){f.dispose(),v?.dispose(),w.$removeLanguageStatus(T),b.delete(p)},get id(){return g.id},get name(){return g.name},set name(o){g.name=o,a()},get selector(){return g.selector},set selector(o){g.selector=o,a()},get text(){return g.text},set text(o){g.text=o,a()},get detail(){return g.detail},set detail(o){g.detail=o,a()},get severity(){return g.severity},set severity(o){g.severity=o,a()},get accessibilityInformation(){return g.accessibilityInformation},set accessibilityInformation(o){g.accessibilityInformation=o,a()},get command(){return g.command},set command(o){g.command=o,a()},get busy(){return g.busy},set busy(o){g.busy=o,a()}};return a(),m}}e.ExtHostLanguages=S}),define(Ie[136],ke([1,0,14,5,26,17,3]),function(Q,e,u,n,y,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let C=class extends u.AbstractLoggerService{constructor(L,I){const _=new D.Emitter;super(I.logLevel,_.event);this._proxy=L.getProxy(n.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(_)}$setLevel(L){this._onDidChangeLogLevel.fire(L)}doCreateLogger(L,I,_){return new S(this._proxy,L,I,_)}};C=Ge([$e(0,A.IExtHostRpcService),$e(1,y.IExtHostInitDataService)],C),e.ExtHostLoggerService=C;class S extends u.AbstractMessageLogger{constructor(L,I,_,T){super(T?.always);this.proxy=L,this.file=I,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(_),this.proxy.$createLogger(I,T).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(L,I){const _=[[L,I]];this.isLoggerCreated?this.doLog(_):this.buffer.push(..._)}doLog(L){this.proxy.$log(this.file,L)}}}),define(Ie[252],ke([1,0,5,14,27]),function(Q,e,u,n,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function A(C){return C&&C.title}let D=class{constructor(S,P){this._logService=P,this._proxy=S.getProxy(u.MainContext.MainThreadMessageService)}showMessage(S,P,L,I,_){const T={source:{identifier:S.identifier,label:S.displayName||S.name}};let w;typeof I=="string"||A(I)?w=[I,..._]:(T.modal=I?.modal,T.useCustom=I?.useCustom,T.detail=I?.detail,w=_),T.useCustom&&(0,y.checkProposedApiEnabled)(S,"resolvers");const b=[];for(let p=0;p<w.length;p++){const g=w[p];if(typeof g=="string")b.push({title:g,handle:p,isCloseAffordance:!1});else if(typeof g=="object"){const{title:v,isCloseAffordance:f}=g;b.push({title:v,isCloseAffordance:!!f,handle:p})}else this._logService.warn("Invalid message item:",g)}return this._proxy.$showMessage(P,L,T,b).then(p=>{if(typeof p=="number")return w[p]})}};D=Ge([$e(1,n.ILogService)],D),e.ExtHostMessageService=D}),define(Ie[253],ke([1,0,23,3,60,6,25,8,10,2,87,5,37,15,7,53,223,131]),function(Q,e,u,n,y,A,D,C,S,P,L,I,_,T,w,b,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class v{constructor(a,m,o,d,r){this._textDocumentsAndEditors=o,this._textDocuments=d,this._extensionStoragePaths=r,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new D.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new n.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new n.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new n.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new n.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new L.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=a.getProxy(I.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=a.getProxy(I.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=a.getProxy(I.MainContext.MainThreadNotebookEditors),this._commandsConverter=m.converter,m.registerArgumentProcessor({processArgument:s=>{if(s&&s.$mid===12){const i=s.notebookEditor?.notebookUri,t=s.cell.handle,l=this._documents.get(i)?.getCell(t);if(l)return l.apiCell}return s}}),v._registerApiCommands(m)}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(a=>a.apiEditor)}getEditorById(a){const m=this._editors.get(a);if(!m)throw new Error(`unknown text editor: ${a}. known editors: ${[...this._editors.keys()]} `);return m}getIdByEditor(a){for(const[m,o]of this._editors)if(o.apiEditor===a)return m}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(a,m){const o=this._documents.get(a);if(!o&&!m)throw new Error(`NO notebook document for '${a}'`);return o}_getProviderData(a){const m=this._notebookContentProviders.get(a);if(!m)throw new Error(`NO provider for '${a}'`);return m}registerNotebookContentProvider(a,m,o,d,r){if((0,C.isFalsyOrWhitespace)(m))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(m))throw new Error(`Notebook provider for '${m}' already registered`);this._notebookContentProviders.set(m,{extension:a,provider:o});let s;return o.onDidChangeNotebookContentOptions&&(s=o.onDidChangeNotebookContentOptions(()=>{const i=T.NotebookDocumentContentOptions.from(o.options);this._notebookProxy.$updateNotebookProviderOptions(m,i)})),this._notebookProxy.$registerNotebookProvider({id:a.identifier,location:a.extensionLocation},m,T.NotebookDocumentContentOptions.from(d),v._convertNotebookRegistrationData(a,r)),new w.Disposable(()=>{s?.dispose(),this._notebookContentProviders.delete(m),this._notebookProxy.$unregisterNotebookProvider(m)})}static _convertNotebookRegistrationData(a,m){if(!m)return;const o=m.filenamePattern.map(d=>T.NotebookExclusiveDocumentPattern.from(d)).filter(d=>d!==void 0);if(m.filenamePattern&&!o){console.warn(`Notebook content provider view options file name pattern is invalid ${m.filenamePattern}`);return}return{extension:a.identifier,providerDisplayName:a.displayName||a.name,displayName:m.displayName,filenamePattern:o,exclusive:m.exclusive||!1}}registerNotebookCellStatusBarItemProvider(a,m,o){const d=v._notebookStatusBarItemProviderHandlePool++,r=typeof o.onDidChangeCellStatusBarItems=="function"?v._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(d,o),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(d,r,m);let s;return r!==void 0&&(s=o.onDidChangeCellStatusBarItems(i=>this._notebookProxy.$emitCellStatusBarEvent(r))),new w.Disposable(()=>{this._notebookStatusBarItemProviders.delete(d),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(d,r),s&&s.dispose()})}async createNotebookDocument(a){const m=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:a.viewType,content:a.content&&T.NotebookData.from(a.content)});return P.URI.revive(m)}async openNotebookDocument(a){const m=this._documents.get(a);if(m)return m.apiNotebook;const o=await this._notebookDocumentsProxy.$tryOpenNotebook(a),d=this._documents.get(P.URI.revive(o));return(0,S.assertIsDefined)(d?.apiNotebook)}async showNotebookDocument(a,m){P.URI.isUri(a)&&(a=await this.openNotebookDocument(a));let o;typeof m=="object"?o={position:T.ViewColumn.from(m.viewColumn),preserveFocus:m.preserveFocus,selections:m.selections&&m.selections.map(T.NotebookRange.from),pinned:typeof m.preview=="boolean"?!m.preview:void 0}:o={preserveFocus:!1};const d=await this._notebookEditorsProxy.$tryShowNotebookDocument(a.uri,a.notebookType,o),r=d&&this._editors.get(d)?.apiEditor;if(r)return r;throw d?new Error(`Could NOT open editor for "${a.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${a.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(a,m,o,d){const r=this._notebookStatusBarItemProviders.get(a),s=P.URI.revive(m),i=this._documents.get(s);if(!i||!r)return;const t=i.getCellFromIndex(o);if(!t)return;const c=await r.provideCellStatusBarItems(t.apiCell,d);if(!c)return;const l=new A.DisposableStore,h=this._statusBarCache.add([l]),R=(Array.isArray(c)?c:[c]).map(N=>T.NotebookStatusBarItem.from(N,this._commandsConverter,l));return{cacheId:h,items:R}}$releaseNotebookCellStatusBarItems(a){this._statusBarCache.delete(a)}registerNotebookSerializer(a,m,o,d,r){if((0,C.isFalsyOrWhitespace)(m))throw new Error("viewType cannot be empty or just whitespace");const s=this._handlePool++;return this._notebookSerializer.set(s,o),this._notebookProxy.$registerNotebookSerializer(s,{id:a.identifier,location:a.extensionLocation},m,T.NotebookDocumentContentOptions.from(d),v._convertNotebookRegistrationData(a,r)),(0,A.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(s)})}async $dataToNotebook(a,m,o){const d=this._notebookSerializer.get(a);if(!d)throw new Error("NO serializer found");const r=await d.deserializeNotebook(m.buffer,o);return new b.SerializableObjectWithBuffers(T.NotebookData.from(r))}async $notebookToData(a,m,o){const d=this._notebookSerializer.get(a);if(!d)throw new Error("NO serializer found");const r=await d.serializeNotebook(T.NotebookData.to(m.value),o);return u.VSBuffer.wrap(r)}async $openNotebook(a,m,o,d,r){const{provider:s}=this._getProviderData(a),i=await s.openNotebook(P.URI.revive(m),{backupId:o,untitledDocumentData:d?.buffer},r);return new b.SerializableObjectWithBuffers({metadata:i.metadata??Object.create(null),cells:i.cells.map(T.NotebookCellData.from)})}async $saveNotebook(a,m,o){const d=this.getNotebookDocument(P.URI.revive(m)),{provider:r}=this._getProviderData(a);return await r.saveNotebook(d.apiNotebook,o),!0}async $saveNotebookAs(a,m,o,d){const r=this.getNotebookDocument(P.URI.revive(m)),{provider:s}=this._getProviderData(a);return await s.saveNotebookAs(P.URI.revive(o),r.apiNotebook,d),!0}async $backupNotebook(a,m,o){const d=this.getNotebookDocument(P.URI.revive(m)),r=this._getProviderData(a),s=this._extensionStoragePaths.workspaceValue(r.extension)??this._extensionStoragePaths.globalValue(r.extension),i=String((0,y.hash)([d.uri.toString(),this._backupIdPool++])),t=P.URI.joinPath(s,i),c=await r.provider.backupNotebook(d.apiNotebook,{destination:t},o);return d.updateBackup(c),c.id}_createExtHostEditor(a,m,o){if(this._editors.has(m))throw new Error(`editor with id ALREADY EXSIST: ${m}`);const d=new g.ExtHostNotebookEditor(m,this._notebookEditorsProxy,a,o.visibleRanges.map(T.NotebookRange.to),o.selections.map(T.NotebookRange.to),typeof o.viewColumn=="number"?T.ViewColumn.to(o.viewColumn):void 0);this._editors.set(m,d)}$acceptDocumentAndEditorsDelta(a){if(a.value.removedDocuments)for(const o of a.value.removedDocuments){const d=P.URI.revive(o),r=this._documents.get(d);r&&(r.dispose(),this._documents.delete(d),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:r.apiNotebook.getCells().map(s=>s.document.uri)}),this._onDidCloseNotebookDocument.fire(r.apiNotebook));for(const s of this._editors.values())s.notebookData.uri.toString()===d.toString()&&this._editors.delete(s.id)}if(a.value.addedDocuments){const o=[];for(const d of a.value.addedDocuments){const r=P.URI.revive(d.uri);if(this._documents.has(r))throw new Error(`adding EXISTING notebook ${r} `);const s=new p.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,r,d);o.push(...d.cells.map(i=>p.ExtHostCell.asModelAddData(s.apiNotebook,i))),this._documents.get(r)?.dispose(),this._documents.set(r,s),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:o}),this._onDidOpenNotebookDocument.fire(s.apiNotebook)}}if(a.value.addedEditors)for(const o of a.value.addedEditors){if(this._editors.has(o.id))return;const d=P.URI.revive(o.documentUri),r=this._documents.get(d);r&&this._createExtHostEditor(r,o.id,o)}const m=[];if(a.value.removedEditors)for(const o of a.value.removedEditors){const d=this._editors.get(o);d&&(this._editors.delete(o),this._activeNotebookEditor?.id===d.id&&(this._activeNotebookEditor=void 0),m.push(d))}if(a.value.visibleEditors){this._visibleNotebookEditors=a.value.visibleEditors.map(d=>this._editors.get(d)).filter(d=>!!d);const o=new Set;this._visibleNotebookEditors.forEach(d=>o.add(d.id));for(const d of this._editors.values()){const r=o.has(d.id);d._acceptVisibility(r)}this._visibleNotebookEditors=[...this._editors.values()].map(d=>d).filter(d=>d.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}a.value.newActiveEditor===null?this._activeNotebookEditor=void 0:a.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(a.value.newActiveEditor)),a.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(a){const m=_.ApiCommandArgument.String.with("notebookType","A notebook type"),o=new _.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[m,new _.ApiCommandArgument("data","Bytes to convert to data",r=>r instanceof Uint8Array,r=>u.VSBuffer.wrap(r))],new _.ApiCommandResult("Notebook Data",r=>T.NotebookData.to(r.value))),d=new _.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[m,new _.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",r=>!0,r=>new b.SerializableObjectWithBuffers(T.NotebookData.from(r)))],new _.ApiCommandResult("Bytes",r=>r.buffer));a.registerApiCommand(o),a.registerApiCommand(d)}}e.ExtHostNotebookController=v,v._notebookStatusBarItemProviderHandlePool=0}),define(Ie[254],ke([1,0,16,18,21,3,6,25,2,28,14,5,37,15,7,88,218,27,53]),function(Q,e,u,n,y,A,D,C,S,P,L,I,_,T,w,b,p,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let f=class{constructor(s,i,t,c,l){this._initData=i,this._extHostNotebook=t,this._commands=c,this._logService=l,this._activeExecutions=new C.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new A.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=s.getProxy(I.MainContext.MainThreadNotebookKernels);const h=new _.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new _.ApiCommandArgument("options","Select kernel options",E=>!0,E=>{if(E&&"notebookEditor"in E&&"id"in E){const R=this._extHostNotebook.getIdByEditor(E.notebookEditor);return{id:E.id,extension:E.extension,notebookEditorId:R}}else if(E&&"notebookEditor"in E){const R=this._extHostNotebook.getIdByEditor(E.notebookEditor);if(R===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${E.notebookEditor.document.uri.toString()}`);return{notebookEditorId:R}}return E})],_.ApiCommandResult.Void);this._commands.registerApiCommand(h)}createNotebookController(s,i,t,c,l,h){for(const ne of this._kernelData.values())if(ne.controller.id===i&&P.ExtensionIdentifier.equals(s.identifier,ne.extensionId))throw new Error(`notebook controller with id '${i}' ALREADY exist`);const E=this._handlePool++,R=this;this._logService.trace(`NotebookController[${E}], CREATED by ${s.identifier.value}, ${i}`);const N=()=>console.warn(`NO execute handler from notebook controller '${$.id}' of extension: '${s.identifier}'`);let O=!1;const k=new D.DisposableStore,U=new A.Emitter,F=new A.Emitter,$={id:d(s.identifier,i),notebookType:t,extensionId:s.identifier,extensionLocation:s.extensionLocation,label:c||s.identifier.value,preloads:h?h.map(T.NotebookRendererScript.from):[]};let ee=l??N,B;this._proxy.$addKernel(E,$).catch(ne=>{console.log(ne),O=!0});let z=0;const q=()=>{if(O)return;const ne=++z;Promise.resolve().then(()=>{ne===z&&this._proxy.$updateKernel(E,$)})},V=new C.ResourceMap,j={get id(){return i},get notebookType(){return $.notebookType},onDidChangeSelectedNotebooks:U.event,get label(){return $.label},set label(ne){$.label=ne??s.displayName??s.name,q()},get detail(){return $.detail??""},set detail(ne){$.detail=ne,q()},get description(){return $.description??""},set description(ne){$.description=ne,q()},get kind(){return(0,g.checkProposedApiEnabled)(s,"notebookControllerKind"),$.kind??""},set kind(ne){(0,g.checkProposedApiEnabled)(s,"notebookControllerKind"),$.kind=ne,q()},get supportedLanguages(){return $.supportedLanguages},set supportedLanguages(ne){$.supportedLanguages=ne,q()},get supportsExecutionOrder(){return $.supportsExecutionOrder??!1},set supportsExecutionOrder(ne){$.supportsExecutionOrder=ne,q()},get rendererScripts(){return $.preloads?$.preloads.map(T.NotebookRendererScript.to):[]},get executeHandler(){return ee},set executeHandler(ne){ee=ne??N},get interruptHandler(){return B},set interruptHandler(ne){B=ne,$.supportsInterrupt=Boolean(ne),q()},createNotebookCellExecution(ne){if(O)throw new Error("notebook controller is DISPOSED");if(!V.has(ne.notebook.uri))throw R._logService.trace(`NotebookController[${E}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(V.keys()).map(Y=>Y.toString())),new Error(`notebook controller is NOT associated to notebook: ${ne.notebook.uri.toString()}`);return R._createNotebookCellExecution(ne,d(s.identifier,this.id))},dispose:()=>{O||(this._logService.trace(`NotebookController[${E}], DISPOSED`),O=!0,this._kernelData.delete(E),k.dispose(),U.dispose(),F.dispose(),this._proxy.$removeKernel(E))},updateNotebookAffinity(ne,Y){R._proxy.$updateNotebookPriority(E,ne.uri,Y)},onDidReceiveMessage:F.event,postMessage(ne,Y){return(0,g.checkProposedApiEnabled)(s,"notebookMessaging"),R._proxy.$postMessage(E,Y&&R._extHostNotebook.getIdByEditor(Y),ne)},asWebviewUri(ne){return(0,g.checkProposedApiEnabled)(s,"notebookMessaging"),(0,b.asWebviewUri)(ne,R._initData.remote)}};return this._kernelData.set(E,{extensionId:s.identifier,controller:j,onDidReceiveMessage:F,onDidChangeSelection:U,associatedNotebooks:V}),j}getIdByController(s){for(const[i,t]of this._kernelData)if(t.controller===s)return d(t.extensionId,s.id);return null}$acceptNotebookAssociation(s,i,t){const c=this._kernelData.get(s);if(c){const l=this._extHostNotebook.getNotebookDocument(S.URI.revive(i));t?c.associatedNotebooks.set(l.uri,!0):c.associatedNotebooks.delete(l.uri),this._logService.trace(`NotebookController[${s}] ASSOCIATE notebook`,l.uri.toString(),t),c.onDidChangeSelection.fire({selected:t,notebook:l.apiNotebook})}}async $executeCells(s,i,t){const c=this._kernelData.get(s);if(!c)return;const l=this._extHostNotebook.getNotebookDocument(S.URI.revive(i)),h=[];for(const E of t){const R=l.getCell(E);R&&h.push(R.apiCell)}try{this._logService.trace(`NotebookController[${s}] EXECUTE cells`,l.uri.toString(),h.length),await c.controller.executeHandler.call(c.controller,h,l.apiNotebook,c.controller)}catch(E){this._logService.error(`NotebookController[${s}] execute cells FAILED`,E),console.error(E)}}async $cancelCells(s,i,t){const c=this._kernelData.get(s);if(!c)return;const l=this._extHostNotebook.getNotebookDocument(S.URI.revive(i));if(c.controller.interruptHandler)await c.controller.interruptHandler.call(c.controller,l.apiNotebook);else for(const h of t){const E=l.getCell(h);E&&this._activeExecutions.get(E.uri)?.cancel()}}$acceptKernelMessageFromRenderer(s,i,t){const c=this._kernelData.get(s);if(!c)return;const l=this._extHostNotebook.getEditorById(i);c.onDidReceiveMessage.fire(Object.freeze({editor:l.apiEditor,message:t}))}$cellExecutionChanged(s,i,t){const l=this._extHostNotebook.getNotebookDocument(S.URI.revive(s)).getCell(i);l&&this._onDidChangeCellExecutionState.fire({cell:l.apiCell,state:t?T.NotebookCellExecutionState.to(t):w.NotebookCellExecutionState.Idle})}_createNotebookCellExecution(s,i){if(s.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const c=this._extHostNotebook.getNotebookDocument(s.notebook.uri).getCellFromApiCell(s);if(!c)throw new Error("invalid cell");if(this._activeExecutions.has(c.uri))throw new Error(`duplicate execution for ${c.uri}`);const l=new m(i,c,this._proxy);this._activeExecutions.set(c.uri,l);const h=l.onDidChangeState(()=>{l.state===a.Resolved&&(l.dispose(),h.dispose(),this._activeExecutions.delete(c.uri))});return l.asApiObject()}};f=Ge([$e(4,L.ILogService)],f),e.ExtHostNotebookKernels=f;var a;(function(r){r[r.Init=0]="Init",r[r.Started=1]="Started",r[r.Resolved=2]="Resolved"})(a||(a={}));class m extends D.Disposable{constructor(s,i,t){super();this._cell=i,this._proxy=t,this._handle=m.HANDLE++,this._onDidChangeState=new A.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=a.Init,this._tokenSource=this._register(new y.CancellationTokenSource),this._collector=new o(10,c=>this.update(c)),this._executionOrder=i.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,s,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(s){await this._collector.addItem(s)}async update(s){const i=Array.isArray(s)?s:[s];return this._proxy.$updateExecution(this._handle,new v.SerializableObjectWithBuffers(i))}verifyStateForOutput(){if(this._state===a.Init)throw new Error("Must call start before modifying cell output");if(this._state===a.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(s){let i=this._cell;if(s&&(i=this._cell.notebook.getCellFromApiCell(s)),!i)throw new Error("INVALID cell");return i.handle}validateAndConvertOutputs(s){return s.map(i=>{const t=w.NotebookCellOutput.ensureUniqueMimeTypes(i.items,!0);return t===i.items?T.NotebookCellOutput.from(i):T.NotebookCellOutput.from({items:t,id:i.id,metadata:i.metadata})})}async updateOutputs(s,i,t){const c=this.cellIndexToHandle(i),l=this.validateAndConvertOutputs((0,u.asArray)(s));return this.updateSoon({editType:p.CellExecutionUpdateType.Output,cellHandle:c,append:t,outputs:l})}async updateOutputItems(s,i,t){return s=w.NotebookCellOutput.ensureUniqueMimeTypes((0,u.asArray)(s),!0),this.updateSoon({editType:p.CellExecutionUpdateType.OutputItems,items:s.map(T.NotebookCellOutputItem.from),outputId:i.id,append:t})}asApiObject(){const s=this;return Object.freeze({get token(){return s._tokenSource.token},get cell(){return s._cell.apiCell},get executionOrder(){return s._executionOrder},set executionOrder(t){s._executionOrder=t,s.update([{editType:p.CellExecutionUpdateType.ExecutionState,executionOrder:s._executionOrder}])},start(t){if(s._state===a.Resolved||s._state===a.Started)throw new Error("Cannot call start again");s._state=a.Started,s._onDidChangeState.fire(),s.update({editType:p.CellExecutionUpdateType.ExecutionState,runStartTime:t})},end(t,c){if(s._state===a.Resolved)throw new Error("Cannot call resolve twice");s._state=a.Resolved,s._onDidChangeState.fire(),s._collector.flush(),s._proxy.$completeExecution(s._handle,new v.SerializableObjectWithBuffers({runEndTime:c,lastRunSuccess:t}))},clearOutput(t){return s.verifyStateForOutput(),s.updateOutputs([],t,!1)},appendOutput(t,c){return s.verifyStateForOutput(),s.updateOutputs(t,c,!0)},replaceOutput(t,c){return s.verifyStateForOutput(),s.updateOutputs(t,c,!1)},appendOutputItems(t,c){return s.verifyStateForOutput(),s.updateOutputItems(t,c,!0)},replaceOutputItems(t,c){return s.verifyStateForOutput(),s.updateOutputItems(t,c,!1)}})}}m.HANDLE=0;class o{constructor(s,i){this.delay=s,this.callback=i,this.batch=[],this.startedTimer=Date.now()}addItem(s){return this.batch.push(s),this.currentDeferred||(this.currentDeferred=new n.DeferredPromise,this.startedTimer=Date.now(),(0,n.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const s=this.currentDeferred;this.currentDeferred=void 0;const i=this.batch;return this.batch=[],this.callback(i).finally(()=>s.complete())}}function d(r,s){return`${r.value}/${s}`}e.createKernelId=d}),define(Ie[255],ke([1,0,3,5,131]),function(Q,e,u,n,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class A{constructor(C,S){this._extHostNotebook=S,this._rendererMessageEmitters=new Map,this.proxy=C.getProxy(n.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(C,S,P){const L=this._extHostNotebook.getEditorById(C);this._rendererMessageEmitters.get(S)?.fire({editor:L.apiEditor,message:P})}createRendererMessaging(C,S){if(!C.contributes?.notebookRenderer?.some(L=>L.id===S))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${S})`);return{onDidReceiveMessage:(L,I,_)=>this.getOrCreateEmitterFor(S).event(L,I,_),postMessage:(L,I)=>{y.ExtHostNotebookEditor.apiEditorsToExtHost.has(L)&&([L,I]=[I,L]);const _=I&&y.ExtHostNotebookEditor.apiEditorsToExtHost.get(I);return this.proxy.$postMessage(_?.id,S,L)}}}getOrCreateEmitterFor(C){let S=this._rendererMessageEmitters.get(C);return S||(S=new u.Emitter({onLastListenerRemove:()=>{S?.dispose(),this._rendererMessageEmitters.delete(C)}}),this._rendererMessageEmitters.set(C,S),S)}}e.ExtHostNotebookRenderers=A}),define(Ie[256],ke([1,0,21,3,6,5,2,7,12,16,41,86]),function(Q,e,u,n,y,A,D,C,S,P,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function _(T,w,b){const p=T.getProxy(A.MainContext.MainThreadQuickOpen);class g{constructor(i,t){this._sessions=new Map,this._instances=0,this._workspace=i,this._commands=t}showQuickPick(i,t,c=u.CancellationToken.None){this._onDidSelectItem=void 0;const l=Promise.resolve(i),h=++this._instances,E=p.$show(h,{title:t?.title,placeHolder:t?.placeHolder,matchOnDescription:t?.matchOnDescription,matchOnDetail:t?.matchOnDetail,ignoreFocusLost:t?.ignoreFocusOut,canPickMany:t?.canPickMany},c),R={},N=E.then(()=>R);return Promise.race([N,l]).then(O=>{if(O!==R)return l.then(k=>{const U=[];for(let F=0;F<k.length;F++){const $=k[F];typeof $=="string"?U.push({label:$,handle:F}):$.kind===C.QuickPickItemKind.Separator?U.push({type:"separator",label:$.label}):U.push({label:$.label,description:$.description,detail:$.detail,picked:$.picked,alwaysShow:$.alwaysShow,handle:F})}return t&&typeof t.onDidSelectItem=="function"&&(this._onDidSelectItem=F=>{t.onDidSelectItem(k[F])}),p.$setItems(h,U),E.then(F=>{if(typeof F=="number")return k[F];if(Array.isArray(F))return F.map($=>k[$])})})}).then(void 0,O=>{if(!(0,S.isCancellationError)(O))return p.$setError(h,O),Promise.reject(O)})}$onItemSelected(i){this._onDidSelectItem?.(i)}showInput(i,t=u.CancellationToken.None){return this._validateInput=i?.validateInput,p.$input(i,typeof this._validateInput=="function",t).then(void 0,c=>{if(!(0,S.isCancellationError)(c))return Promise.reject(c)})}async $validateInput(i){if(!this._validateInput)return;const t=await this._validateInput(i);if(!t||typeof t=="string")return t;let c;switch(t.severity){case C.InputBoxValidationSeverity.Info:c=L.default.Info;break;case C.InputBoxValidationSeverity.Warning:c=L.default.Warning;break;case C.InputBoxValidationSeverity.Error:c=L.default.Error;break;default:c=t.message?L.default.Error:L.default.Ignore;break}return{content:t.message,severity:c}}async showWorkspaceFolderPick(i,t=u.CancellationToken.None){const c=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[i]);if(!c)return;const l=await this._workspace.getWorkspaceFolders2();if(!!l)return l.find(h=>h.uri.toString()===c.uri.toString())}createQuickPick(i){const t=new d(i,()=>this._sessions.delete(t._id));return this._sessions.set(t._id,t),t}createInputBox(i){const t=new r(i,()=>this._sessions.delete(t._id));return this._sessions.set(t._id,t),t}$onDidChangeValue(i,t){this._sessions.get(i)?._fireDidChangeValue(t)}$onDidAccept(i){const t=this._sessions.get(i);t&&t._fireDidAccept()}$onDidChangeActive(i,t){const c=this._sessions.get(i);c instanceof d&&c._fireDidChangeActive(t)}$onDidChangeSelection(i,t){const c=this._sessions.get(i);c instanceof d&&c._fireDidChangeSelection(t)}$onDidTriggerButton(i,t){this._sessions.get(i)?._fireDidTriggerButton(t)}$onDidTriggerItemButton(i,t,c){const l=this._sessions.get(i);l instanceof d&&l._fireDidTriggerItemButton(t,c)}$onDidHide(i){const t=this._sessions.get(i);t&&t._fireDidHide()}}class v{constructor(i,t){this._extensionId=i,this._onDidDispose=t,this._id=d._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new n.Emitter,this._onDidChangeValueEmitter=new n.Emitter,this._onDidTriggerButtonEmitter=new n.Emitter,this._onDidHideEmitter=new n.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(i){this._title=i,this.update({title:i})}get step(){return this._steps}set step(i){this._steps=i,this.update({step:i})}get totalSteps(){return this._totalSteps}set totalSteps(i){this._totalSteps=i,this.update({totalSteps:i})}get enabled(){return this._enabled}set enabled(i){this._enabled=i,this.update({enabled:i})}get busy(){return this._busy}set busy(i){this._busy=i,this.update({busy:i})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(i){this._ignoreFocusOut=i,this.update({ignoreFocusOut:i})}get value(){return this._value}set value(i){this._value=i,this.update({value:i})}get placeholder(){return this._placeholder}set placeholder(i){this._placeholder=i,this.update({placeholder:i})}get buttons(){return this._buttons}set buttons(i){this._buttons=i.slice(),this._handlesToButtons.clear(),i.forEach((t,c)=>{const l=t===C.QuickInputButtons.Back?-1:c;this._handlesToButtons.set(l,t)}),this.update({buttons:i.map((t,c)=>({...o(t),tooltip:t.tooltip,handle:t===C.QuickInputButtons.Back?-1:c}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(i){this._value=i,this._onDidChangeValueEmitter.fire(i)}_fireDidTriggerButton(i){const t=this._handlesToButtons.get(i);t&&this._onDidTriggerButtonEmitter.fire(t)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,y.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),p.$dispose(this._id))}update(i){if(!this._disposed){for(const t of Object.keys(i)){const c=i[t];this._pendingUpdate[t]=c===void 0?null:c}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){p.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}v._nextId=1;function f(s){if(s instanceof C.ThemeIcon)return{id:s.id};const i=m(s),t=a(s);return{dark:typeof i=="string"?D.URI.file(i):i,light:typeof t=="string"?D.URI.file(t):t}}function a(s){return typeof s=="object"&&"light"in s?s.light:s}function m(s){return typeof s=="object"&&"dark"in s?s.dark:s}function o(s){const i=f(s.iconPath);let t,c;return"id"in i?c=I.ThemeIcon.asClassName(i):t=i,{iconPath:t,iconClass:c}}class d extends v{constructor(i,t){super(i.identifier,t);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new n.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new n.Emitter,this._onDidTriggerItemButtonEmitter=new n.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(i){this._items=i.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),i.forEach((c,l)=>{this._handlesToItems.set(l,c),this._itemsToHandles.set(c,l)});const t=[];for(let c=0;c<i.length;c++){const l=i[c];l.kind===C.QuickPickItemKind.Separator?t.push({type:"separator",label:l.label}):t.push({handle:c,label:l.label,description:l.description,detail:l.detail,picked:l.picked,alwaysShow:l.alwaysShow,buttons:l.buttons?.map((h,E)=>({...o(h),tooltip:h.tooltip,handle:E}))})}this.update({items:t})}get canSelectMany(){return this._canSelectMany}set canSelectMany(i){this._canSelectMany=i,this.update({canSelectMany:i})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(i){this._matchOnDescription=i,this.update({matchOnDescription:i})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(i){this._matchOnDetail=i,this.update({matchOnDetail:i})}get sortByLabel(){return this._sortByLabel}set sortByLabel(i){this._sortByLabel=i,this.update({sortByLabel:i})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(i){this._keepScrollPosition=i,this.update({keepScrollPosition:i})}get activeItems(){return this._activeItems}set activeItems(i){this._activeItems=i.filter(t=>this._itemsToHandles.has(t)),this.update({activeItems:this._activeItems.map(t=>this._itemsToHandles.get(t))})}get selectedItems(){return this._selectedItems}set selectedItems(i){this._selectedItems=i.filter(t=>this._itemsToHandles.has(t)),this.update({selectedItems:this._selectedItems.map(t=>this._itemsToHandles.get(t))})}_fireDidChangeActive(i){const t=(0,P.coalesce)(i.map(c=>this._handlesToItems.get(c)));this._activeItems=t,this._onDidChangeActiveEmitter.fire(t)}_fireDidChangeSelection(i){const t=(0,P.coalesce)(i.map(c=>this._handlesToItems.get(c)));this._selectedItems=t,this._onDidChangeSelectionEmitter.fire(t)}_fireDidTriggerItemButton(i,t){const c=this._handlesToItems.get(i);if(!c||!c.buttons||!c.buttons.length)return;const l=c.buttons[t];l&&this._onDidTriggerItemButtonEmitter.fire({button:l,item:c})}}class r extends v{constructor(i,t){super(i.identifier,t);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(i){this._password=i,this.update({password:i})}get prompt(){return this._prompt}set prompt(i){this._prompt=i,this.update({prompt:i})}get validationMessage(){return this._validationMessage}set validationMessage(i){this._validationMessage=i,i?typeof i=="string"?this.update({validationMessage:i,severity:L.default.Error}):this.update({validationMessage:i.message,severity:i.severity??L.default.Error}):this.update({validationMessage:void 0,severity:L.default.Ignore})}}return new g(w,b)}e.createExtHostQuickOpen=_});var tt=this&&this.__classPrivateFieldSet||function(Q,e,u,n,y){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!y:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?y.call(Q,u):y?y.value=u:e.set(Q,u),u},Me=this&&this.__classPrivateFieldGet||function(Q,e,u,n){if(u==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!n:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?n:u==="a"?n.call(Q):n?n.value:e.get(Q)};define(Ie[257],ke([1,0,2,3,57,6,18,5,16,104,14,28,86,15,27]),function(Q,e,u,n,y,A,D,C,S,P,L,I,_,T,w){"use strict";var b,p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function g(l){if(l)return typeof l.iconPath=="string"?u.URI.file(l.iconPath):u.URI.isUri(l.iconPath)||_.ThemeIcon.isThemeIcon(l.iconPath)?l.iconPath:void 0}function v(l,h){if(!l.iconPath&&!h.iconPath)return 0;if(l.iconPath){if(!h.iconPath)return 1}else return-1;const E=typeof l.iconPath=="string"?l.iconPath:u.URI.isUri(l.iconPath)?l.iconPath.fsPath:l.iconPath.id,R=typeof h.iconPath=="string"?h.iconPath:u.URI.isUri(h.iconPath)?h.iconPath.fsPath:h.iconPath.id;return(0,P.comparePaths)(E,R)}function f(l,h){let E=0;if(l.strikeThrough!==h.strikeThrough)return l.strikeThrough?1:-1;if(l.faded!==h.faded)return l.faded?1:-1;if(l.tooltip!==h.tooltip)return(l.tooltip||"").localeCompare(h.tooltip||"");if(E=v(l,h),E!==0)return E;if(l.light&&h.light)E=v(l.light,h.light);else{if(l.light)return 1;if(h.light)return-1}if(E!==0)return E;if(l.dark&&h.dark)E=v(l.dark,h.dark);else{if(l.dark)return 1;if(h.dark)return-1}return E}function a(l,h){if(l.command!==h.command)return l.command<h.command?-1:1;if(l.title!==h.title)return l.title<h.title?-1:1;if(l.tooltip!==h.tooltip){if(l.tooltip!==void 0&&h.tooltip!==void 0)return l.tooltip<h.tooltip?-1:1;if(l.tooltip!==void 0)return 1;if(h.tooltip!==void 0)return-1}if(l.arguments===h.arguments)return 0;if(l.arguments)if(h.arguments){if(l.arguments.length!==h.arguments.length)return l.arguments.length-h.arguments.length}else return 1;else return-1;for(let E=0;E<l.arguments.length;E++){const R=l.arguments[E],N=h.arguments[E];if(R!==N)return R<N?-1:1}return 0}function m(l,h){let E=(0,P.comparePaths)(l.resourceUri.fsPath,h.resourceUri.fsPath,!0);if(E!==0)return E;if(l.command&&h.command)E=a(l.command,h.command);else{if(l.command)return 1;if(h.command)return-1}if(E!==0)return E;if(l.decorations&&h.decorations)E=f(l.decorations,h.decorations);else{if(l.decorations)return 1;if(h.decorations)return-1}return E}function o(l,h){for(let E=0;E<l.length;E++)if(l[E]!==h[E])return!1;return!0}function d(l,h){return l.command===h.command&&l.title===h.title&&l.tooltip===h.tooltip&&(l.arguments&&h.arguments?o(l.arguments,h.arguments):l.arguments===h.arguments)}function r(l,h){return(0,S.equals)(l,h,d)}class s{constructor(h,E,R){this._extension=h,this._sourceControlHandle=R,b.set(this,void 0),this._value="",this._onDidChange=new n.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,tt(this,b,E,"f")}get value(){return this._value}set value(h){h=h??"",Me(this,b,"f").$setInputBoxValue(this._sourceControlHandle,h),this.updateValue(h)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(h){Me(this,b,"f").$setInputBoxPlaceholder(this._sourceControlHandle,h),this._placeholder=h}get validateInput(){return(0,w.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(h){if((0,w.checkProposedApiEnabled)(this._extension,"scmValidation"),h&&typeof h!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=h,Me(this,b,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!h)}get enabled(){return this._enabled}set enabled(h){h=!!h,this._enabled!==h&&(this._enabled=h,Me(this,b,"f").$setInputBoxEnablement(this._sourceControlHandle,h))}get visible(){return this._visible}set visible(h){h=!!h,this._visible!==h&&(this._visible=h,Me(this,b,"f").$setInputBoxVisibility(this._sourceControlHandle,h))}showValidationMessage(h,E){(0,w.checkProposedApiEnabled)(this._extension,"scmValidation"),Me(this,b,"f").$showValidationMessage(this._sourceControlHandle,h,E)}$onInputBoxValueChange(h){this.updateValue(h)}updateValue(h){this._value=h,this._onDidChange.fire(h)}}e.ExtHostSCMInputBox=s,b=new WeakMap;class i{constructor(h,E,R,N,O){this._proxy=h,this._commands=E,this._sourceControlHandle=R,this._id=N,this._label=O,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new n.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new n.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=i._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(h){this._label=h,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,h)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(h){this._hideWhenEmpty=h,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(h){this._resourceStates=[...h],this._onDidUpdateResourceStates.fire()}getResourceState(h){return this._resourceStatesMap.get(h)}$executeResourceCommand(h,E){const R=this._resourceStatesCommandsMap.get(h);return R?(0,D.asPromise)(()=>this._commands.executeCommand(R.command,...R.arguments||[],E)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const h=[...this._resourceStates].sort(m),R=(0,S.sortedDiff)(this._resourceSnapshot,h,m).map(k=>{const U=k.toInsert.map(F=>{const $=this._resourceHandlePool++;this._resourceStatesMap.set($,F);const ee=F.resourceUri;let B;if(F.command)if(F.command.command==="vscode.open"||F.command.command==="vscode.diff"){const ge=new A.DisposableStore;B=this._commands.converter.toInternal(F.command,ge),this._resourceStatesDisposablesMap.set($,ge)}else this._resourceStatesCommandsMap.set($,F.command);const z=g(F.decorations),q=F.decorations&&g(F.decorations.light)||z,V=F.decorations&&g(F.decorations.dark)||z,j=[q,V],ne=F.decorations&&F.decorations.tooltip||"",Y=F.decorations&&!!F.decorations.strikeThrough,le=F.decorations&&!!F.decorations.faded,ue=F.contextValue||"";return{rawResource:[$,ee,j,ne,Y,le,ue,B],handle:$}});return{start:k.start,deleteCount:k.deleteCount,toInsert:U}}),N=R.map(({start:k,deleteCount:U,toInsert:F})=>[k,U,F.map($=>$.rawResource)]),O=R.reverse();for(const{start:k,deleteCount:U,toInsert:F}of O){const $=F.map(B=>B.handle),ee=this._handlesSnapshot.splice(k,U,...$);for(const B of ee)this._resourceStatesMap.delete(B),this._resourceStatesCommandsMap.delete(B),this._resourceStatesDisposablesMap.get(B)?.dispose(),this._resourceStatesDisposablesMap.delete(B)}return this._resourceSnapshot=h,N}dispose(){this._disposed=!0,this._onDidDispose.fire()}}i._handlePool=0;class t{constructor(h,E,R,N,O,k){this._extension=h,this._commands=R,this._id=N,this._label=O,this._rootUri=k,p.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new A.MutableDisposable,this._statusBarDisposables=new A.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new n.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=t._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,tt(this,p,E,"f"),this._inputBox=new s(h,Me(this,p,"f"),this.handle),Me(this,p,"f").$registerSourceControl(this.handle,N,O,k)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(h){this._count!==h&&(this._count=h,Me(this,p,"f").$updateSourceControl(this.handle,{count:h}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(h){this._quickDiffProvider=h,Me(this,p,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!h})}get commitTemplate(){return this._commitTemplate}set commitTemplate(h){h!==this._commitTemplate&&(this._commitTemplate=h,Me(this,p,"f").$updateSourceControl(this.handle,{commitTemplate:h}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(h){this._acceptInputDisposables.value=new A.DisposableStore,this._acceptInputCommand=h;const E=this._commands.converter.toInternal(h,this._acceptInputDisposables.value);Me(this,p,"f").$updateSourceControl(this.handle,{acceptInputCommand:E})}get actionButton(){return(0,w.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(h){(0,w.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new A.DisposableStore,this._actionButton=h;const E=h!==void 0?{command:this._commands.converter.toInternal(h.command,this._actionButtonDisposables.value),secondaryCommands:h.secondaryCommands?.map(R=>R.map(N=>this._commands.converter.toInternal(N,this._actionButtonDisposables.value))),description:h.description,enabled:h.enabled}:void 0;Me(this,p,"f").$updateSourceControl(this.handle,{actionButton:E??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(h){if(this._statusBarCommands&&h&&r(this._statusBarCommands,h))return;this._statusBarDisposables.value=new A.DisposableStore,this._statusBarCommands=h;const E=(h||[]).map(R=>this._commands.converter.toInternal(R,this._statusBarDisposables.value));Me(this,p,"f").$updateSourceControl(this.handle,{statusBarCommands:E})}get selected(){return this._selected}createResourceGroup(h,E){const R=new i(Me(this,p,"f"),this._commands,this.handle,h,E),N=n.Event.once(R.onDidDispose)(()=>this.createdResourceGroups.delete(R));return this.createdResourceGroups.set(R,N),this.eventuallyAddResourceGroups(),R}eventuallyAddResourceGroups(){const h=[],E=[];for(const[R,N]of this.createdResourceGroups){N.dispose();const O=R.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(R),this.eventuallyUpdateResourceStates()});n.Event.once(R.onDidDispose)(()=>{this.updatedResourceGroups.delete(R),O.dispose(),this._groups.delete(R.handle),Me(this,p,"f").$unregisterGroup(this.handle,R.handle)}),h.push([R.handle,R.id,R.label,R.features]);const k=R._takeResourceStateSnapshot();k.length>0&&E.push([R.handle,k]),this._groups.set(R.handle,R)}Me(this,p,"f").$registerGroups(this.handle,h,E),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const h=[];this.updatedResourceGroups.forEach(E=>{const R=E._takeResourceStateSnapshot();R.length!==0&&h.push([E.handle,R])}),h.length>0&&Me(this,p,"f").$spliceResourceStates(this.handle,h),this.updatedResourceGroups.clear()}getResourceGroup(h){return this._groups.get(h)}setSelectionState(h){this._selected=h,this._onDidChangeSelection.fire(h)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(h=>h.dispose()),Me(this,p,"f").$unregisterSourceControl(this.handle)}}p=new WeakMap,t._handlePool=0,Ge([(0,y.debounce)(100)],t.prototype,"eventuallyAddResourceGroups",null),Ge([(0,y.debounce)(100)],t.prototype,"eventuallyUpdateResourceStates",null);let c=class Qn{constructor(h,E,R){this._commands=E,this.logService=R,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new n.Emitter,this._proxy=h.getProxy(C.MainContext.MainThreadSCM),this._telemetry=h.getProxy(C.MainContext.MainThreadTelemetry),E.registerArgumentProcessor({processArgument:N=>{if(N&&N.$mid===3){const O=this._sourceControls.get(N.sourceControlHandle);if(!O)return N;const k=O.getResourceGroup(N.groupHandle);return k?k.getResourceState(N.handle):N}else if(N&&N.$mid===4){const O=this._sourceControls.get(N.sourceControlHandle);return O?O.getResourceGroup(N.groupHandle):N}else if(N&&N.$mid===5){const O=this._sourceControls.get(N.handle);return O||N}return N}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(h,E,R,N){this.logService.trace("ExtHostSCM#createSourceControl",h.identifier.value,E,R,N),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:h.identifier.value});const O=Qn._handlePool++,k=new t(h,this._proxy,this._commands,E,R,N);this._sourceControls.set(O,k);const U=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(h.identifier))||[];return U.push(k),this._sourceControlsByExtension.set(I.ExtensionIdentifier.toKey(h.identifier),U),k}getLastInputBox(h){this.logService.trace("ExtHostSCM#getLastInputBox",h.identifier.value);const E=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(h.identifier)),R=E&&E[E.length-1];return R&&R.inputBox}$provideOriginalResource(h,E,R){const N=u.URI.revive(E);this.logService.trace("ExtHostSCM#$provideOriginalResource",h,N.toString());const O=this._sourceControls.get(h);return!O||!O.quickDiffProvider||!O.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,D.asPromise)(()=>O.quickDiffProvider.provideOriginalResource(N,R)).then(k=>k||null)}$onInputBoxValueChange(h,E){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",h);const R=this._sourceControls.get(h);return R&&R.inputBox.$onInputBoxValueChange(E),Promise.resolve(void 0)}$executeResourceCommand(h,E,R,N){this.logService.trace("ExtHostSCM#$executeResourceCommand",h,E,R);const O=this._sourceControls.get(h);if(!O)return Promise.resolve(void 0);const k=O.getResourceGroup(E);return k?k.$executeResourceCommand(R,N):Promise.resolve(void 0)}$validateInput(h,E,R){this.logService.trace("ExtHostSCM#$validateInput",h);const N=this._sourceControls.get(h);return!N||!N.inputBox.validateInput?Promise.resolve(void 0):(0,D.asPromise)(()=>N.inputBox.validateInput(E,R)).then(O=>{if(!O)return Promise.resolve(void 0);const k=T.MarkdownString.fromStrict(O.message);return k?Promise.resolve([k,O.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(h){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",h),h!==void 0&&this._sourceControls.get(h)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=h,Promise.resolve(void 0)}};c._handlePool=0,c=Ge([$e(2,L.ILogService)],c),e.ExtHostSCM=c});var tt=this&&this.__classPrivateFieldSet||function(Q,e,u,n,y){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!y:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?y.call(Q,u):y?y.value=u:e.set(Q,u),u},Me=this&&this.__classPrivateFieldGet||function(Q,e,u,n){if(u==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!n:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?n:u==="a"?n.call(Q):n?n.value:e.get(Q)};define(Ie[258],ke([1,0,7,5,174,6,15,10]),function(Q,e,u,n,y,A,D,C){"use strict";var S,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class L{constructor(w,b,p,g,v=u.StatusBarAlignment.Left,f){S.set(this,void 0),P.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new A.DisposableStore,tt(this,S,w,"f"),tt(this,P,b,"f"),this._entryId=L.ID_GEN++,this._extension=p,this._id=g,this._alignment=v,this._priority=this.validatePriority(f)}validatePriority(w){if(!!(0,C.isNumber)(w))return w===Number.POSITIVE_INFINITY?Number.MAX_VALUE:w===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:w}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(w){this._text=w,this.update()}set name(w){this._name=w,this.update()}set tooltip(w){this._tooltip=w,this.update()}set color(w){this._color=w,this.update()}set backgroundColor(w){w&&!L.ALLOWED_BACKGROUND_COLORS.has(w.id)&&(w=void 0),this._backgroundColor=w,this.update()}set command(w){this._command?.fromApi!==w&&(this._internalCommandRegistration.clear(),typeof w=="string"?this._command={fromApi:w,internal:Me(this,P,"f").toInternal({title:"",command:w},this._internalCommandRegistration)}:w?this._command={fromApi:w,internal:Me(this,P,"f").toInternal(w,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(w){this._accessibilityInformation=w,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Me(this,S,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let w;this._extension?this._id?w=`${this._extension.identifier.value}.${this._id}`:w=this._extension.identifier.value:w=this._id;let b;this._name?b=this._name:b=(0,y.localize)(0,null,this._extension.displayName||this._extension.name);let p=this._color;this._backgroundColor&&(p=L.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const g=D.MarkdownString.fromStrict(this._tooltip);Me(this,S,"f").$setEntry(this._entryId,w,b,this._text,g,this._command?.internal,p,this._backgroundColor,this._alignment===u.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=L,S=new WeakMap,P=new WeakMap,L.ID_GEN=0,L.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new u.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new u.ThemeColor("statusBarItem.warningForeground")]]);class I{constructor(w){this._messages=[],this._item=w.createStatusBarEntry(void 0,"status.extensionMessage",u.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,y.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(w){const b={message:w};return this._messages.unshift(b),this._update(),new u.Disposable(()=>{const p=this._messages.indexOf(b);p>=0&&(this._messages.splice(p,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class _{constructor(w,b){this._proxy=w.getProxy(n.MainContext.MainThreadStatusBar),this._commands=b,this._statusMessage=new I(this)}createStatusBarEntry(w,b,p,g){return new L(this._proxy,this._commands,w,b,p,g)}setStatusBarMessage(w,b){const p=this._statusMessage.setMessage(w);let g;return typeof b=="number"?g=setTimeout(()=>p.dispose(),b):typeof b!="undefined"&&b.then(()=>p.dispose(),()=>p.dispose()),new u.Disposable(()=>{p.dispose(),clearTimeout(g)})}}e.ExtHostStatusBar=_}),define(Ie[91],ke([1,0,5,3,4]),function(Q,e,u,n,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class A{constructor(C){this._onDidChangeStorage=new n.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=C.getProxy(u.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(C,S){this._proxy.$registerExtensionStorageKeysToSync(C,S)}initializeExtensionStorage(C,S,P){return this._proxy.$initializeExtensionStorage(C,S).then(L=>L||P)}setValue(C,S,P){return this._proxy.$setValue(C,S,P)}$acceptValue(C,S,P){this._onDidChangeStorage.fire({shared:C,key:S,value:P})}}e.ExtHostStorage=A,e.IExtHostStorage=(0,y.createDecorator)("IExtHostStorage")}),define(Ie[70],ke([1,0,4,26,14,69,2]),function(Q,e,u,n,y,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,u.createDecorator)("IExtensionStoragePaths");let C=class{constructor(P,L,I){this._logService=L,this._extHostFileSystem=I,this._workspace=P.workspace??void 0,this._environment=P.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(_=>this._value=_)}async _getWorkspaceStorageURI(P){return D.URI.joinPath(this._environment.workspaceStorageHome,P)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const P=this._workspace.id,L=await this._getWorkspaceStorageURI(P);try{return await this._extHostFileSystem.value.stat(L),this._logService.trace("[ExtHostStorage] storage dir already exists",L),L}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",L),await this._extHostFileSystem.value.createDirectory(L),await this._extHostFileSystem.value.writeFile(D.URI.joinPath(L,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:D.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),L}catch(I){this._logService.error("[ExtHostStorage]",I);return}}workspaceValue(P){if(this._value)return D.URI.joinPath(this._value,P.identifier.value)}globalValue(P){return D.URI.joinPath(this._environment.globalStorageHome,P.identifier.value.toLowerCase())}onWillDeactivateAll(){}};C=Ge([$e(0,n.IExtHostInitDataService),$e(1,y.ILogService),$e(2,A.IExtHostConsumerFileSystem)],C),e.ExtensionStoragePaths=C}),define(Ie[38],ke([1,0,3,5,4,2,17,6,7,175,12,219,21,34,203,86,10,18]),function(Q,e,u,n,y,A,D,C,S,P,L,I,_,T,w,b,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,y.createDecorator)("IExtHostTerminalService");class v{constructor(t,c,l,h){this._proxy=t,this._id=c,this._creationOptions=l,this._name=h,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(R=>this._pidPromiseComplete=R);const E=this;this.value={get name(){return E._name||""},get processId(){return E._pidPromise},get creationOptions(){return E._creationOptions},get exitStatus(){return E._exitStatus},get state(){return E._state},sendText(R,N=!0){E._checkDisposed(),E._proxy.$sendText(E._id,R,N)},show(R){E._checkDisposed(),E._proxy.$show(E._id,R)},hide(){E._checkDisposed(),E._proxy.$hide(E._id)},dispose(){E._disposed||(E._disposed=!0,E._proxy.$dispose(E._id))},get dimensions(){if(!(E._cols===void 0||E._rows===void 0))return{columns:E._cols,rows:E._rows}}}}async create(t,c){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:t.name,shellPath:(0,p.withNullAsUndefined)(t.shellPath),shellArgs:(0,p.withNullAsUndefined)(t.shellArgs),cwd:(0,p.withNullAsUndefined)(t.cwd),env:(0,p.withNullAsUndefined)(t.env),icon:(0,p.withNullAsUndefined)(r(t.iconPath)),color:b.ThemeColor.isThemeColor(t.color)?t.color.id:void 0,initialText:(0,p.withNullAsUndefined)(t.message),strictEnv:(0,p.withNullAsUndefined)(t.strictEnv),hideFromUser:(0,p.withNullAsUndefined)(t.hideFromUser),isFeatureTerminal:(0,p.withNullAsUndefined)(c?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,p.withNullAsUndefined)(c?.useShellEnvironment),location:c?.location||this._serializeParentTerminal(t.location,c?.resolvedExtHostIdentifier),isTransient:(0,p.withNullAsUndefined)(t.isTransient)})}async createExtensionTerminal(t,c,l,h){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:l,color:b.ThemeColor.isThemeColor(h)?h.id:void 0,location:this._serializeParentTerminal(t,c),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(t,c){return typeof t=="object"?"parentTerminal"in t&&t.parentTerminal&&c?{parentTerminal:c}:"viewColumn"in t?{viewColumn:t.viewColumn,preserveFocus:t.preserveFocus}:void 0:t}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,c){return t===this._cols&&c===this._rows||t===0||c===0?!1:(this._cols=t,this._rows=c,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(c=>{c!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=v;class f{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new u.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new u.Emitter,this._onDidChangeProperty=new u.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new u.Emitter,this.onProcessExit=this._onProcessExit.event}get onProcessReady(){return this._onProcessReady.event}refreshProperty(t){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${t}`)}updateProperty(t,c){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${t}, value: ${c}`)}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput?.(t)}resize(t,c){this._pty.setDimensions?.({columns:t,rows:c})}async processBinary(t){}acknowledgeDataEvent(t){}async setUnicodeVersion(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(c=>this._onProcessData.fire(c)),this._pty.onDidClose?.((c=void 0)=>{this._onProcessExit.fire(c===void 0?void 0:c)}),this._pty.onDidOverrideDimensions?.(c=>{c&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:c.columns,rows:c.rows}})}),this._pty.onDidChangeName?.(c=>{this._onDidChangeProperty.fire({type:"title",value:c})}),this._pty.open(t||void 0),t&&this._pty.setDimensions?.(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=f;let a=1,m=class extends C.Disposable{constructor(t,c){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new u.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new u.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new u.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new u.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new u.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=c.getProxy(n.MainContext.MainThreadTerminalService),this._bufferer=new w.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new u.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[l,h]of this._terminalProcesses)h.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(t){return(t?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(t){return(t?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(t,c){const l=new v(this._proxy,(0,T.generateUuid)(),t,t.name),h=new f(t.pty);return l.createExtensionTerminal(t.location,this._serializeParentTerminal(t,c).resolvedExtHostIdentifier,r(t.iconPath),s(t.color)).then(E=>{const R=this._setupExtHostProcessListeners(E,h);this._terminalProcessDisposables[E]=R}),this._terminals.push(l),l.value}_serializeParentTerminal(t,c){if(c=c||{},t.location&&typeof t.location=="object"&&"parentTerminal"in t.location){const l=t.location.parentTerminal;if(l){const h=this._terminals.find(E=>E.value===l);h&&(c.resolvedExtHostIdentifier=h._id)}}else t.location&&typeof t.location!="object"?c.location=t.location:c.location&&typeof c.location=="object"&&"splitActiveTerminal"in c.location&&(c.location={splitActiveTerminal:!0});return c}attachPtyToTerminal(t,c){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const h=new f(c),E=this._setupExtHostProcessListeners(t,h);this._terminalProcessDisposables[t]=E}async $acceptActiveTerminalChanged(t){const c=this._activeTerminal;if(t===null){this._activeTerminal=void 0,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const l=this._getTerminalById(t);l&&(this._activeTerminal=l,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,c){const l=this._getTerminalById(t);l&&this._onDidWriteTerminalData.fire({terminal:l.value,data:c})}async $acceptTerminalDimensions(t,c,l){const h=this._getTerminalById(t);h&&h.setDimensions(c,l)&&this._onDidChangeTerminalDimensions.fire({terminal:h.value,dimensions:h.value.dimensions})}async $acceptTerminalMaximumDimensions(t,c,l){this._terminalProcesses.get(t)?.resize(c,l)}async $acceptTerminalTitleChange(t,c){const l=this._getTerminalById(t);l&&(l.name=c)}async $acceptTerminalClosed(t,c){const l=this._getTerminalObjectIndexById(this._terminals,t);if(l!==null){const h=this._terminals.splice(l,1)[0];h.setExitCode(c),this._onDidCloseTerminal.fire(h.value)}}$acceptTerminalOpened(t,c,l,h){if(c){const N=this._getTerminalObjectIndexById(this._terminals,c);if(N!==null){this._terminals[N]._id=t,this._onDidOpenTerminal.fire(this.terminals[N]),this._terminals[N].isOpen=!0;return}}const E={name:h.name,shellPath:h.executable,shellArgs:h.args,cwd:typeof h.cwd=="string"?h.cwd:A.URI.revive(h.cwd),env:h.env,hideFromUser:h.hideFromUser},R=new v(this._proxy,t,E,l);this._terminals.push(R),this._onDidOpenTerminal.fire(R.value),R.isOpen=!0}async $acceptTerminalProcessId(t,c){this._getTerminalById(t)?._setProcessId(c)}async $startExtensionTerminal(t,c){const l=this._getTerminalById(t);if(!l)return{message:(0,P.localize)(0,null,t)};l.isOpen||await new Promise(E=>{const R=this.onDidOpenTerminal(async N=>{N===l.value&&(R.dispose(),E())})});const h=this._terminalProcesses.get(t);h?h.startSendingEvents(c):this._extensionTerminalAwaitingStart[t]={initialDimensions:c}}_setupExtHostProcessListeners(t,c){const l=new C.DisposableStore;l.add(c.onProcessReady(E=>this._proxy.$sendProcessReady(t,E.pid,E.cwd))),l.add(c.onDidChangeProperty(E=>this._proxy.$sendProcessProperty(t,E))),this._bufferer.startBuffering(t,c.onProcessData),l.add(c.onProcessExit(E=>this._onProcessExit(t,E))),this._terminalProcesses.set(t,c);const h=this._extensionTerminalAwaitingStart[t];return h&&c instanceof f&&(c.startSendingEvents(h.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),l}$acceptProcessAckDataEvent(t,c){this._terminalProcesses.get(t)?.acknowledgeDataEvent(c)}$acceptProcessInput(t,c){this._terminalProcesses.get(t)?.input(c)}$acceptTerminalInteraction(t){const c=this._getTerminalById(t);c?.setInteractedWith()&&this._onDidChangeTerminalState.fire(c.value)}$acceptProcessResize(t,c,l){try{this._terminalProcesses.get(t)?.resize(c,l)}catch(h){if(h.code!=="EPIPE"&&h.code!=="ERR_IPC_CHANNEL_CLOSED")throw h}}$acceptProcessShutdown(t,c){this._terminalProcesses.get(t)?.shutdown(c)}$acceptProcessRequestInitialCwd(t){this._terminalProcesses.get(t)?.getInitialCwd().then(c=>this._proxy.$sendProcessProperty(t,{type:"initialCwd",value:c}))}$acceptProcessRequestCwd(t){this._terminalProcesses.get(t)?.getCwd().then(c=>this._proxy.$sendProcessProperty(t,{type:"cwd",value:c}))}$acceptProcessRequestLatency(t){return Promise.resolve(t)}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new S.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(t,c,l){if(this._profileProviders.has(c))throw new Error(`Terminal profile provider "${c}" already registered`);return this._profileProviders.set(c,l),this._proxy.$registerProfileProvider(c,t.identifier.value),new S.Disposable(()=>{this._profileProviders.delete(c),this._proxy.$unregisterProfileProvider(c)})}async $createContributedProfileTerminal(t,c){const l=new _.CancellationTokenSource().token;let h=await this._profileProviders.get(t)?.provideTerminalProfile(l);if(!l.isCancellationRequested){if(h&&!("options"in h)&&(h={options:h}),!h||!("options"in h))throw new Error(`No terminal profile options provided for id "${t}"`);if("pty"in h.options){this.createExtensionTerminal(h.options,c);return}this.createTerminalFromOptions(h.options,c)}}async $provideLinks(t,c){const l=this._getTerminalById(t);if(!l)return[];this._terminalLinkCache.delete(t),this._terminalLinkCancellationSource.get(t)?.dispose(!0);const E=new _.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,E);const R=[],N={terminal:l.value,line:c},O=[];for(const F of this._linkProviders)O.push(g.Promises.withAsyncBody(async $=>{E.token.onCancellationRequested(()=>$({provider:F,links:[]}));const ee=await F.provideTerminalLinks(N,E.token)||[];E.token.isCancellationRequested||$({provider:F,links:ee})}));const k=await Promise.all(O);if(E.token.isCancellationRequested)return[];const U=new Map;for(const F of k)F&&F.links.length>0&&R.push(...F.links.map($=>{const ee={id:a++,startIndex:$.startIndex,length:$.length,label:$.tooltip};return U.set(ee.id,{provider:F.provider,link:$}),ee}));return this._terminalLinkCache.set(t,U),R}$activateLink(t,c){const l=this._terminalLinkCache.get(t)?.get(c);!l||l.provider.handleTerminalLink(l.link)}_onProcessExit(t,c){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const l=this._terminalProcessDisposables[t];l&&(l.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,c)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,c){const l=this._getTerminalObjectIndexById(t,c);return l!==null?t[l]:null}_getTerminalObjectIndexById(t,c){let l=null;return t.some((h,E)=>h._id===c?(l=E,!0):!1),l}getEnvironmentVariableCollection(t){let c=this._environmentVariableCollections.get(t.identifier.value);return c||(c=new o,this._setEnvironmentVariableCollection(t.identifier.value,c)),c}_syncEnvironmentVariableCollection(t,c){const l=(0,I.serializeEnvironmentVariableCollection)(c.map);this._proxy.$setEnvironmentVariableCollection(t,c.persistent,l.length===0?void 0:l)}$initEnvironmentVariableCollections(t){t.forEach(c=>{const l=c[0],h=new o(c[1]);this._setEnvironmentVariableCollection(l,h)})}$acceptDefaultProfile(t,c){this._defaultProfile=t,this._defaultAutomationProfile=c}_setEnvironmentVariableCollection(t,c){this._environmentVariableCollections.set(t,c),c.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,c)})}};m=Ge([$e(1,D.IExtHostRpcService)],m),e.BaseExtHostTerminalService=m;class o{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new u.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,c){this._setIfDiffers(t,{value:c,type:S.EnvironmentVariableMutatorType.Replace})}append(t,c){this._setIfDiffers(t,{value:c,type:S.EnvironmentVariableMutatorType.Append})}prepend(t,c){this._setIfDiffers(t,{value:c,type:S.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,c){const l=this.map.get(t);(!l||l.value!==c.value||l.type!==c.type)&&(this.map.set(t,c),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,c){this.map.forEach((l,h)=>t.call(c,h,l,this))}[Symbol.iterator](){return this.map.entries()}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=o;let d=class extends m{constructor(t){super(!1,t)}createTerminal(t,c,l){throw new L.NotSupportedError}createTerminalFromOptions(t,c){throw new L.NotSupportedError}};d=Ge([$e(0,D.IExtHostRpcService)],d),e.WorkerExtHostTerminalService=d;function r(i){if(!(!i||typeof i=="string"))return"id"in i?{id:i.id,color:i.color}:i}function s(i){return b.ThemeColor.isThemeColor(i)?i:void 0}});var tt=this&&this.__classPrivateFieldSet||function(Q,e,u,n,y){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!y:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?y.call(Q,u):y?y.value=u:e.set(Q,u),u},Me=this&&this.__classPrivateFieldGet||function(Q,e,u,n){if(u==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!n:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?n:u==="a"?n.call(Q):n?n.value:e.get(Q)};define(Ie[259],ke([1,0,16,23,21,3,58,60,6,24,10,34,5,17,132,15,7,66,89,67]),function(Q,e,u,n,y,A,D,C,S,P,L,I,_,T,w,b,p,g,v,f){"use strict";var a,m;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let o=class{constructor(O,k){this.resultsChangedEmitter=new A.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=O.getProxy(_.MainContext.MainThreadTesting),this.observer=new h(this.proxy),this.runTracker=new r(this.proxy),k.registerArgumentProcessor({processArgument:U=>U?.$mid===13?(0,w.toItemFromContext)(U):U})}createTestController(O,k,U){if(this.controllers.has(O))throw new Error(`Attempt to insert a duplicate controller with ID "${O}"`);const F=new S.DisposableStore,$=F.add(new w.ExtHostTestItemCollection(O,k));$.root.label=k;const ee=new Map,B=this.proxy,z={items:$.root.children,get label(){return k},set label(V){k=V,$.root.label=V,B.$updateController(O,{label:k})},get refreshHandler(){return U},set refreshHandler(V){U=V,B.$updateController(O,{canRefresh:!!V})},get id(){return O},createRunProfile:(V,j,ne,Y,le)=>{let ue=(0,C.hash)(V);for(;ee.has(ue);)ue++;return new E(this.proxy,ee,O,ue,V,j,ne,Y,le)},createTestItem(V,j,ne){return new w.TestItemImpl(O,V,j,ne)},createTestRun:(V,j,ne=!0)=>this.runTracker.createTestRun(O,$,V,j,ne),set resolveHandler(V){$.resolveHandler=V},get resolveHandler(){return $.resolveHandler},dispose:()=>{F.dispose()}};B.$registerTestController(O,k,!!U),F.add((0,S.toDisposable)(()=>B.$unregisterTestController(O)));const q={controller:z,collection:$,profiles:ee};return this.controllers.set(O,q),F.add((0,S.toDisposable)(()=>this.controllers.delete(O))),F.add($.onDidGenerateDiff(V=>B.$publishDiff(O,V.map(f.TestsDiffOp.serialize)))),z}createTestObserver(){return this.observer.checkout()}async runTests(O,k=y.CancellationToken.None){const U=s(O);if(!U)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const F=this.controllers.get(U.controllerId);if(!F)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:O.include?.map($=>g.TestId.fromExtHostTestItem($,F.collection.root.id).toString())??[F.collection.root.id],profileGroup:R[U.kind],profileId:U.profileId,controllerId:U.controllerId}],exclude:O.exclude?.map($=>$.id)},k)}$provideFileCoverage(O,k,U){return(0,u.mapFind)(this.runTracker.trackers,$=>$.id===O?$.getCoverage(k):void 0)?.provideFileCoverage(U)??Promise.resolve([])}$resolveFileCoverage(O,k,U,F){return(0,u.mapFind)(this.runTracker.trackers,ee=>ee.id===O?ee.getCoverage(k):void 0)?.resolveFileCoverage(U,F)??Promise.resolve([])}$configureRunProfile(O,k){this.controllers.get(O)?.profiles.get(k)?.configureHandler?.()}async $refreshTests(O,k){await this.controllers.get(O)?.controller.refreshHandler?.(k)}$publishTestResults(O){this.results=Object.freeze(O.map(k=>(0,P.deepFreeze)(b.TestResults.to(k))).concat(this.results).sort((k,U)=>U.completedAt-k.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(O,k){const U=this.controllers.get(g.TestId.fromString(O).controllerId)?.collection;U&&(await U.expand(O,k<0?1/0:k),U.flushDiff())}$acceptDiff(O){this.observer.applyDiff(O.map(f.TestsDiffOp.deserialize))}async $runControllerTests(O,k){const U=this.controllers.get(O.controllerId);if(!U)return;const{collection:F,profiles:$}=U,ee=$.get(O.profileId);if(!ee)return;const B=O.testIds.map(j=>F.tree.get(j)).filter(L.isDefined),z=O.excludeExtIds.map(j=>U.collection.tree.get(j)).filter(L.isDefined).filter(j=>B.some(ne=>ne.fullId.compare(j.fullId)===2));if(!B.length)return;const q=new p.TestRunRequest(B.some(j=>j.actual instanceof w.TestItemRootImpl)?void 0:B.map(j=>j.actual),z.map(j=>j.actual),ee),V=this.runTracker.prepareForMainThreadTestRun(q,i.fromInternal(O,U.collection),k);try{await ee.runHandler(q,k)}finally{V.isRunning&&!k.isCancellationRequested&&await A.Event.toPromise(V.onEnd),V.dispose()}}$cancelExtensionTestRun(O){O===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(O)}};o=Ge([$e(0,T.IExtHostRpcService)],o),e.ExtHostTesting=o;class d extends S.Disposable{constructor(O,k,U){super();this.dto=O,this.proxy=k,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new A.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new y.CancellationTokenSource(U)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:F}of this.tasks.values())F.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(O){return this.tasks.get(O)?.coverage}createRun(O){const k=this.dto.id,U=this.dto.controllerId,F=(0,I.generateUuid)(),$=new t(this.proxy,k,F),ee=V=>(j,...ne)=>{if(z){console.warn(`Setting the state of test "${j.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(j)||(this.ensureTestIsKnown(j),V(j,...ne))},B=(V,j)=>{const ne=j instanceof Array?j.map(b.TestMessage.from):[b.TestMessage.from(j)];if(V.uri&&V.range){const Y={range:b.Range.from(V.range),uri:V.uri};for(const le of ne)le.location=le.location||Y}this.proxy.$appendTestMessagesInRun(k,F,g.TestId.fromExtHostTestItem(V,U).toString(),ne)};let z=!1;const q={isPersisted:this.dto.isPersisted,token:this.cts.token,name:O,get coverageProvider(){return $.coverageProvider},set coverageProvider(V){$.coverageProvider=V},enqueued:ee(V=>{this.proxy.$updateTestStateInRun(k,F,g.TestId.fromExtHostTestItem(V,U).toString(),1)}),skipped:ee(V=>{this.proxy.$updateTestStateInRun(k,F,g.TestId.fromExtHostTestItem(V,U).toString(),5)}),started:ee(V=>{this.proxy.$updateTestStateInRun(k,F,g.TestId.fromExtHostTestItem(V,U).toString(),2)}),errored:ee((V,j,ne)=>{B(V,j),this.proxy.$updateTestStateInRun(k,F,g.TestId.fromExtHostTestItem(V,U).toString(),6,ne)}),failed:ee((V,j,ne)=>{B(V,j),this.proxy.$updateTestStateInRun(k,F,g.TestId.fromExtHostTestItem(V,U).toString(),4,ne)}),passed:ee((V,j)=>{this.proxy.$updateTestStateInRun(k,F,g.TestId.fromExtHostTestItem(V,this.dto.controllerId).toString(),3,j)}),appendOutput:(V,j,ne)=>{z||(ne&&(this.dto.isIncluded(ne)?this.ensureTestIsKnown(ne):ne=void 0),this.proxy.$appendOutputToRun(k,F,n.VSBuffer.fromString(V),j&&b.location.from(j),ne&&g.TestId.fromExtHostTestItem(ne,U).toString()))},end:()=>{z||(z=!0,this.proxy.$finishedTestRunTask(k,F),this.tasks.delete(F),this.isRunning||this.dispose())}};return this.tasks.set(F,{run:q,coverage:$}),this.proxy.$startedTestRunTask(k,{id:F,name:O,running:!0}),q}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(O){if(!(O instanceof w.TestItemImpl))throw new v.InvalidTestItemError(O.id);if(this.sharedTestIds.has(g.TestId.fromExtHostTestItem(O,this.dto.controllerId).toString()))return;const k=[],U=this.dto.colllection.root;for(;;){const F=b.TestItem.from(O);if(k.unshift(F),this.sharedTestIds.has(F.extId)||(this.sharedTestIds.add(F.extId),O===U))break;O=O.parent||U}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,k)}}class r{constructor(O){this.proxy=O,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(O,k,U){return this.getTracker(O,k,U)}cancelRunById(O){for(const k of this.tracked.values())if(k.id===O){k.dispose();return}}cancelAllRuns(){for(const O of this.tracked.values())O.dispose()}createTestRun(O,k,U,F,$){const ee=this.tracked.get(U);if(ee)return ee.createRun(F);const B=i.fromPublic(O,k,U,$),z=s(U);this.proxy.$startedExtensionTestRun({controllerId:O,profile:z&&{group:R[z.kind],id:z.profileId},exclude:U.exclude?.map(V=>g.TestId.fromExtHostTestItem(V,k.root.id).toString())??[],id:B.id,include:U.include?.map(V=>g.TestId.fromExtHostTestItem(V,k.root.id).toString())??[k.root.id],persist:$});const q=this.getTracker(U,B);return q.onEnd(()=>this.proxy.$finishedExtensionTestRun(B.id)),q.createRun(F)}getTracker(O,k,U){const F=new d(k,this.proxy,U);return this.tracked.set(O,F),F.onEnd(()=>this.tracked.delete(O)),F}}e.TestRunCoordinator=r;const s=N=>{if(!!N.profile){if(!(N.profile instanceof E))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return N.profile}};class i{constructor(O,k,U,F,$,ee){this.controllerId=O,this.id=k,this.isPersisted=$,this.colllection=ee,this.includePrefix=U.map(B=>B+"\0"),this.excludePrefix=F.map(B=>B+"\0")}static fromPublic(O,k,U,F){return new i(O,(0,I.generateUuid)(),U.include?.map($=>g.TestId.fromExtHostTestItem($,O).toString())??[O],U.exclude?.map($=>g.TestId.fromExtHostTestItem($,O).toString())??[],F,k)}static fromInternal(O,k){return new i(O.controllerId,O.runId,O.testIds,O.excludeExtIds,!0,k)}isIncluded(O){const k=g.TestId.fromExtHostTestItem(O,this.controllerId).toString()+"\0";for(const U of this.excludePrefix)if(k===U||k.startsWith(U))return!1;for(const U of this.includePrefix)if(k===U||k.startsWith(U))return!0;return!1}}e.TestRunDto=i;class t{constructor(O,k,U){this.proxy=O,this.runId=k,this.taskId=U}set coverageProvider(O){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!O||(this._coverageProvider=O,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(O){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(O))());try{return(await this.fileCoverage)?.map(b.TestCoverage.fromFile)??[]}catch(k){throw this.fileCoverage=void 0,k}}async resolveFileCoverage(O,k){const U=await this.fileCoverage;let F=U?.[O];return!this._coverageProvider||!U||!F?[]:(F.detailedCoverage||(F=U[O]=await this._coverageProvider.resolveFileCoverage?.(F,k)??F),F.detailedCoverage?.map(b.TestCoverage.fromDetailed)??[])}}class c extends f.IncrementalChangeCollector{constructor(O){super();this.emitter=O,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(O){this.added.add(O)}update(O){Object.assign(O.revived,b.TestItem.toPlain(O.item)),this.added.has(O)||this.updated.add(O)}remove(O){if(this.added.has(O)){this.added.delete(O);return}if(this.updated.delete(O),O.parent&&this.alreadyRemoved.has(O.parent)){this.alreadyRemoved.add(O.item.extId);return}this.removed.add(O)}getChangeEvent(){const{added:O,updated:k,removed:U}=this;return{get added(){return[...O].map(F=>F.revived)},get updated(){return[...k].map(F=>F.revived)},get removed(){return[...U].map(F=>F.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class l extends f.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new A.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(O){return this.items.get(O)}getMirroredTestDataByReference(O){return this.items.get(O.id)}createItem(O,k){return{...O,revived:b.TestItem.toPlain(O.item),depth:k?k.depth+1:0,children:new Set}}createChangeCollector(){return new c(this.changeEmitter)}}e.MirroredTestCollection=l;class h{constructor(O){this.proxy=O}checkout(){this.current||(this.current=this.createObserverData());const O=this.current;return O.observers++,{onDidChangeTest:O.tests.onDidChangeTests,get tests(){return[...O.tests.rootTests].map(k=>k.revived)},dispose:(0,D.once)(()=>{--O.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(O){return this.current?.tests.getMirroredTestDataByReference(O)}applyDiff(O){this.current?.tests.apply(O)}createObserverData(){const O=new l;return this.proxy.$subscribeToDiffs(),{observers:0,tests:O}}}class E{constructor(O,k,U,F,$,ee,B,z=!1,q=void 0){this.controllerId=U,this.profileId=F,this._label=$,this.kind=ee,this.runHandler=B,this._isDefault=z,this._tag=q,a.set(this,void 0),m.set(this,void 0),tt(this,a,O,"f"),tt(this,m,k,"f"),k.set(F,this);const V=R[ee];if(typeof V!="number")throw new Error(`Unknown TestRunProfile.group ${ee}`);Me(this,a,"f").$publishTestRunProfile({profileId:F,controllerId:U,tag:q?b.TestTag.namespace(this.controllerId,q.id):null,label:$,group:V,isDefault:z,hasConfigurationHandler:!1})}get label(){return this._label}set label(O){O!==this._label&&(this._label=O,Me(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:O}))}get isDefault(){return this._isDefault}set isDefault(O){O!==this._isDefault&&(this._isDefault=O,Me(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:O}))}get tag(){return this._tag}set tag(O){O?.id!==this._tag?.id&&(this._tag=O,Me(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:O?b.TestTag.namespace(this.controllerId,O.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(O){O!==this._configureHandler&&(this._configureHandler=O,Me(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!O}))}dispose(){Me(this,m,"f")?.delete(this.profileId)&&(tt(this,m,void 0,"f"),Me(this,a,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=E,a=new WeakMap,m=new WeakMap;const R={[p.TestRunProfileKind.Coverage]:8,[p.TestRunProfileKind.Debug]:4,[p.TestRunProfileKind.Run]:2}}),define(Ie[260],ke([1,0,16,3,5,133,15,7]),function(Q,e,u,n,y,A,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(L,I){this._extHostDocumentsAndEditors=I,this._onDidChangeTextEditorSelection=new n.Emitter,this._onDidChangeTextEditorOptions=new n.Emitter,this._onDidChangeTextEditorVisibleRanges=new n.Emitter,this._onDidChangeTextEditorViewColumn=new n.Emitter,this._onDidChangeActiveTextEditor=new n.Emitter,this._onDidChangeVisibleTextEditors=new n.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=L.getProxy(y.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(_=>this._onDidChangeVisibleTextEditors.fire(_)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(_=>this._onDidChangeActiveTextEditor.fire(_))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(L){const I=this._extHostDocumentsAndEditors.allEditors();return L?I:I.map(_=>_.value)}async showTextDocument(L,I,_){let T;typeof I=="number"?T={position:D.ViewColumn.from(I),preserveFocus:_}:typeof I=="object"?T={position:D.ViewColumn.from(I.viewColumn),preserveFocus:I.preserveFocus,selection:typeof I.selection=="object"?D.Range.from(I.selection):void 0,pinned:typeof I.preview=="boolean"?!I.preview:void 0}:T={preserveFocus:!1};const w=await this._proxy.$tryShowTextDocument(L.uri,T),b=w&&this._extHostDocumentsAndEditors.getEditor(w);if(b)return b.value;throw w?new Error(`Could NOT open editor for "${L.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${L.uri.toString()}".`)}createTextEditorDecorationType(L,I){return new A.TextEditorDecorationType(this._proxy,L,I).value}$acceptEditorPropertiesChanged(L,I){const _=this._extHostDocumentsAndEditors.getEditor(L);if(!_)throw new Error("unknown text editor");if(I.options&&_._acceptOptions(I.options),I.selections){const T=I.selections.selections.map(D.Selection.to);_._acceptSelections(T)}if(I.visibleRanges){const T=u.coalesce(I.visibleRanges.map(D.Range.to));_._acceptVisibleRanges(T)}if(I.options&&this._onDidChangeTextEditorOptions.fire({textEditor:_.value,options:{...I.options,lineNumbers:D.TextEditorLineNumbersStyle.to(I.options.lineNumbers)}}),I.selections){const T=C.TextEditorSelectionChangeKind.fromValue(I.selections.source),w=I.selections.selections.map(D.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:_.value,selections:w,kind:T})}if(I.visibleRanges){const T=u.coalesce(I.visibleRanges.map(D.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:_.value,visibleRanges:T})}}$acceptEditorPositionData(L){for(const I in L){const _=this._extHostDocumentsAndEditors.getEditor(I);if(!_)throw new Error("Unknown text editor");const T=D.ViewColumn.to(L[I]);_.value.viewColumn!==T&&(_._acceptViewColumn(T),this._onDidChangeTextEditorViewColumn.fire({textEditor:_.value,viewColumn:T}))}}getDiffInformation(L){return Promise.resolve(this._proxy.$getDiffInformation(L))}}e.ExtHostEditors=S}),define(Ie[261],ke([1,0,2,4,5,6,7,15,10]),function(Q,e,u,n,y,A,D,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,n.createDecorator)("IExtHostTimeline");class P{constructor(_,T){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=_.getProxy(y.MainContext.MainThreadTimeline),T.registerArgumentProcessor({processArgument:w=>{if(w&&w.$mid===11){const b=w.uri===void 0?void 0:u.URI.revive(w.uri);return this._itemsBySourceAndUriMap.get(w.source)?.get(L(b))?.get(w.handle)}return w}})}async $getTimeline(_,T,w,b){return this._providers.get(_)?.provideTimeline(u.URI.revive(T),w,b)}registerTimelineProvider(_,T,w,b){const p=new A.DisposableStore,g=this.convertTimelineItem(T.id,b,p).bind(this);let v;T.onDidChange&&(v=T.onDidChange(a=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...a,id:T.id}),this));const f=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...T,scheme:_,onDidChange:void 0,async provideTimeline(a,m,o){m?.resetCache&&(p.clear(),f.get(T.id)?.clear());const d=await T.provideTimeline(a,m,o);if(d==null)return;const r=g(a,m);return{...d,source:T.id,items:d.items.map(r)}},dispose(){for(const a of f.values())a.get(T.id)?.clear();v?.dispose(),p.dispose()}})}convertTimelineItem(_,T,w){return(b,p)=>{let g;if(p?.cacheResults){let v=this._itemsBySourceAndUriMap.get(_);v===void 0&&(v=new Map,this._itemsBySourceAndUriMap.set(_,v));const f=L(b);g=v.get(f),g===void 0&&(g=new Map,v.set(f,g))}return v=>{const{iconPath:f,...a}=v,m=`${_}|${v.id??v.timestamp}`;g?.set(m,v);let o,d,r;v.iconPath&&(f instanceof D.ThemeIcon?r={id:f.id,color:f.color}:u.URI.isUri(f)?(o=f,d=f):{light:o,dark:d}=f);let s;return D.MarkdownString.isMarkdownString(a.tooltip)?s=C.MarkdownString.from(a.tooltip):(0,S.isString)(a.tooltip)?s=a.tooltip:D.MarkdownString.isMarkdownString(a.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),s=C.MarkdownString.from(a.detail)):(0,S.isString)(a.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),s=a.detail),{...a,id:a.id??void 0,handle:m,source:_,command:v.command?T.toInternal(v.command,w):void 0,icon:o,iconDark:d,themeIcon:r,tooltip:s,accessibilityInformation:v.accessibilityInformation}}}}registerTimelineProviderCore(_){if(this._providers.get(_.id))throw new Error(`Timeline Provider ${_.id} already exists.`);return this._proxy.$registerTimelineProvider({id:_.id,label:_.label,scheme:_.scheme}),this._providers.set(_.id,_),(0,A.toDisposable)(()=>{for(const w of this._itemsBySourceAndUriMap.values())w.get(_.id)?.clear();this._providers.delete(_.id),this._proxy.$unregisterTimelineProvider(_.id),_.dispose()})}}e.ExtHostTimeline=P;function L(I){return I?.toString()}}),define(Ie[262],ke([1,0,6,11,2,5]),function(Q,e,u,n,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class D{constructor(S){this._openers=new Map,this._proxy=S.getProxy(A.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,P,L,I){if(this._openers.has(P))throw new Error(`Opener with id '${P}' already registered`);const _=I.schemes.find(T=>!D.supportedSchemes.has(T));if(_)throw new Error(`Scheme '${_}' is not supported. Only http and https are currently supported.`);return this._openers.set(P,L),this._proxy.$registerUriOpener(P,I.schemes,S,I.label),(0,u.toDisposable)(()=>{this._openers.delete(P),this._proxy.$unregisterUriOpener(P)})}async $canOpenUri(S,P,L){const I=this._openers.get(S);if(!I)throw new Error(`Unknown opener with id: ${S}`);const _=y.URI.revive(P);return I.canOpenExternalUri(_,L)}async $openUri(S,P,L){const I=this._openers.get(S);if(!I)throw new Error(`Unknown opener id: '${S}'`);return I.openExternalUri(y.URI.revive(P.resolvedUri),{sourceUri:y.URI.revive(P.sourceUri)},L)}}e.ExtHostUriOpeners=D,D.supportedSchemes=new Set([n.Schemas.http,n.Schemas.https])}),define(Ie[263],ke([1,0,5,2,6,12,28]),function(Q,e,u,n,y,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class C{constructor(P){this.handles=new Set,this.handlers=new Map,this._proxy=P.getProxy(u.MainContext.MainThreadUrls)}registerUriHandler(P,L){if(this.handles.has(D.ExtensionIdentifier.toKey(P)))throw new Error(`Protocol handler already registered for extension ${P}`);const I=C.HandlePool++;return this.handles.add(D.ExtensionIdentifier.toKey(P)),this.handlers.set(I,L),this._proxy.$registerUriHandler(I,P),(0,y.toDisposable)(()=>{this.handles.delete(D.ExtensionIdentifier.toKey(P)),this.handlers.delete(I),this._proxy.$unregisterUriHandler(I)})}$handleExternalUri(P,L){const I=this.handlers.get(P);if(!I)return Promise.resolve(void 0);try{I.handleUri(n.URI.revive(L))}catch(_){(0,A.onUnexpectedError)(_)}return Promise.resolve(void 0)}async createAppUri(P){return n.URI.revive(await this._proxy.$createAppUri(P))}}e.ExtHostUrls=C,C.HandlePool=0});var tt=this&&this.__classPrivateFieldSet||function(Q,e,u,n,y){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!y:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?y.call(Q,u):y?y.value=u:e.set(Q,u),u},Me=this&&this.__classPrivateFieldGet||function(Q,e,u,n){if(u==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!n:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?n:u==="a"?n.call(Q):n?n.value:e.get(Q)};define(Ie[71],ke([1,0,3,11,2,190,210,88,5]),function(Q,e,u,n,y,A,D,C,S){"use strict";var P,L,I,_,T,w,b,p,g,v,f,a;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class m{constructor(l,h,E,R,N,O,k){P.set(this,void 0),L.set(this,void 0),I.set(this,void 0),_.set(this,void 0),T.set(this,void 0),w.set(this,void 0),b.set(this,""),p.set(this,void 0),g.set(this,!1),v.set(this,!1),f.set(this,!1),this._onMessageEmitter=new u.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,a.set(this,new u.Emitter),this._onDidDispose=Me(this,a,"f").event,tt(this,P,l,"f"),tt(this,L,h,"f"),tt(this,p,E,"f"),tt(this,_,R,"f"),tt(this,T,N,"f"),tt(this,w,O,"f"),tt(this,f,o(O),"f"),tt(this,I,k,"f")}dispose(){tt(this,g,!0,"f"),Me(this,a,"f").fire(),Me(this,a,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(l){return tt(this,v,!0,"f"),(0,C.asWebviewUri)(l,Me(this,_,"f"))}get cspSource(){const l=Me(this,w,"f").extensionLocation;if(l.scheme===n.Schemas.https||l.scheme===n.Schemas.http){let h=l.toString();return h.endsWith("/")||(h+="/"),h+" "+C.webviewGenericCspSource}return C.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Me(this,b,"f")}set html(l){this.assertNotDisposed(),Me(this,b,"f")!==l&&(tt(this,b,l,"f"),!Me(this,v,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(l)&&(tt(this,v,!0,"f"),Me(this,I,"f").report("Webview vscode-resource: uris",Me(this,w,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Me(this,L,"f").$setHtml(Me(this,P,"f"),l))}get options(){return this.assertNotDisposed(),Me(this,p,"f")}set options(l){this.assertNotDisposed(),Me(this,L,"f").$setOptions(Me(this,P,"f"),s(Me(this,w,"f"),Me(this,T,"f"),l)),tt(this,p,l,"f")}async postMessage(l){if(Me(this,g,"f"))return!1;const h=(0,D.serializeWebviewMessage)(l,{serializeBuffersForPostMessage:Me(this,f,"f")});return Me(this,L,"f").$postMessage(Me(this,P,"f"),h.message,...h.buffers)}assertNotDisposed(){if(Me(this,g,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=m,P=new WeakMap,L=new WeakMap,I=new WeakMap,_=new WeakMap,T=new WeakMap,w=new WeakMap,b=new WeakMap,p=new WeakMap,g=new WeakMap,v=new WeakMap,f=new WeakMap,a=new WeakMap;function o(c){try{const l=(0,A.normalizeVersion)((0,A.parseVersion)(c.engines.vscode));return!!l&&l.majorBase>=1&&l.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=o;class d{constructor(l,h,E,R,N){this.remoteInfo=h,this.workspace=E,this._logService=R,this._deprecationService=N,this._webviews=new Map,this._webviewProxy=l.getProxy(S.MainContext.MainThreadWebviews)}$onMessage(l,h,E){const R=this.getWebview(l);if(R){const{message:N}=(0,D.deserializeWebviewMessage)(h,E.value);R._onMessageEmitter.fire(N)}}$onMissingCsp(l,h){this._logService.warn(`${h} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(l,h,E){const R=new m(l,this._webviewProxy,i(h),this.remoteInfo,this.workspace,E,this._deprecationService);return this._webviews.set(l,R),R._onDidDispose(()=>{this._webviews.delete(l)}),R}deleteWebview(l){this._webviews.delete(l)}getWebview(l){return this._webviews.get(l)}}e.ExtHostWebviews=d;function r(c){return{id:c.identifier,location:c.extensionLocation}}e.toExtensionData=r;function s(c,l,h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,enableForms:h.enableForms,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots||t(c,l)}}e.serializeWebviewOptions=s;function i(c){return{enableCommandUris:c.enableCommandUris,enableScripts:c.enableScripts,enableForms:c.enableForms,portMapping:c.portMapping,localResourceRoots:c.localResourceRoots?.map(l=>y.URI.from(l))}}e.reviveOptions=i;function t(c,l){return[...(l?.getWorkspaceFolders()||[]).map(h=>h.uri),c.extensionLocation]}}),define(Ie[264],ke([1,0,21,60,6,11,22,2,15,71,87,5,7]),function(Q,e,u,n,y,A,D,C,S,P,L,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class T{constructor(o,d){this.document=o,this._storagePath=d,this._backupCounter=1,this._edits=new L.Cache("custom documents")}addEdit(o){return this._edits.add([o])}async undo(o,d){await this.getEdit(o).undo(),d||this.disposeBackup()}async redo(o,d){await this.getEdit(o).redo(),d||this.disposeBackup()}disposeEdits(o){for(const d of o)this._edits.delete(d)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const o=a(this.document.uri)+this._backupCounter++;return(0,D.joinPath)(this._storagePath,o)}updateBackup(o){this._backup?.delete(),this._backup=o}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(o){const d=this._edits.get(o,0);if(!d)throw new Error("No edit found");return d}}class w{constructor(){this._documents=new Map}get(o,d){return this._documents.get(this.key(o,d))}add(o,d,r){const s=this.key(o,d.uri);if(this._documents.has(s))throw new Error(`Document already exists for viewType:${o} resource:${d.uri}`);const i=new T(d,r);return this._documents.set(s,i),i}delete(o,d){const r=this.key(o,d.uri);this._documents.delete(r)}key(o,d){return`${o}@@@${d}`}}var b;(function(m){m[m.Text=0]="Text",m[m.Custom=1]="Custom"})(b||(b={}));class p{constructor(){this._providers=new Map}addTextProvider(o,d,r){return this.add(0,o,d,r)}addCustomProvider(o,d,r){return this.add(1,o,d,r)}get(o){return this._providers.get(o)}add(o,d,r,s){if(this._providers.has(d))throw new Error(`Provider for viewType:${d} already registered`);return this._providers.set(d,{type:o,extension:r,provider:s}),new _.Disposable(()=>this._providers.delete(d))}}class g{constructor(o,d,r,s,i){this._extHostDocuments=d,this._extensionStoragePaths=r,this._extHostWebview=s,this._extHostWebviewPanels=i,this._editorProviders=new p,this._documents=new w,this._proxy=o.getProxy(I.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(o,d,r,s){const i=new y.DisposableStore;return v(r)?(i.add(this._editorProviders.addTextProvider(d,o,r)),this._proxy.$registerTextEditorProvider((0,P.toExtensionData)(o),d,s.webviewOptions||{},{supportsMove:!!r.moveCustomTextEditor},(0,P.shouldSerializeBuffersForPostMessage)(o))):(i.add(this._editorProviders.addCustomProvider(d,o,r)),this.supportEditing(r)&&i.add(r.onDidChangeCustomDocument(t=>{const c=this.getCustomDocumentEntry(d,t.document.uri);if(f(t)){const l=c.addEdit(t);this._proxy.$onDidEdit(t.document.uri,d,l,t.label)}else this._proxy.$onContentChange(t.document.uri,d)})),this._proxy.$registerCustomEditorProvider((0,P.toExtensionData)(o),d,s.webviewOptions||{},!!s.supportsMultipleEditorsPerDocument,(0,P.shouldSerializeBuffersForPostMessage)(o))),_.Disposable.from(i,new _.Disposable(()=>{this._proxy.$unregisterEditorProvider(d)}))}async $createCustomDocument(o,d,r,s,i){const t=this._editorProviders.get(d);if(!t)throw new Error(`No provider found for '${d}'`);if(t.type!==1)throw new Error(`Invalid provide type for '${d}'`);const c=C.URI.revive(o),l=await t.provider.openCustomDocument(c,{backupId:r,untitledDocumentData:s?.buffer},i);let h;return this.supportEditing(t.provider)&&this._extensionStoragePaths&&(h=this._extensionStoragePaths.workspaceValue(t.extension)??this._extensionStoragePaths.globalValue(t.extension)),this._documents.add(d,l,h),{editable:this.supportEditing(t.provider)}}async $disposeCustomDocument(o,d){const r=this._editorProviders.get(d);if(!r)throw new Error(`No provider found for '${d}'`);if(r.type!==1)throw new Error(`Invalid provider type for '${d}'`);const s=C.URI.revive(o),{document:i}=this.getCustomDocumentEntry(d,s);this._documents.delete(d,i),i.dispose()}async $resolveWebviewEditor(o,d,r,s,i,t){const c=this._editorProviders.get(r);if(!c)throw new Error(`No provider found for '${r}'`);const l=S.ViewColumn.to(i),h=this._extHostWebview.createNewWebview(d,s.webviewOptions,c.extension),E=this._extHostWebviewPanels.createNewWebviewPanel(d,r,s.title,l,s.panelOptions,h,!0),R=C.URI.revive(o);switch(c.type){case 1:{const{document:N}=this.getCustomDocumentEntry(r,R);return c.provider.resolveCustomEditor(N,E,t)}case 0:{const N=this._extHostDocuments.getDocument(R);return c.provider.resolveCustomTextEditor(N,E,t)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(o,d,r){this.getCustomDocumentEntry(d,o).disposeEdits(r)}async $onMoveCustomEditor(o,d,r){const s=this._editorProviders.get(r);if(!s)throw new Error(`No provider found for '${r}'`);if(!s.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${r}'`);const i=this._extHostWebviewPanels.getWebviewPanel(o);if(!i)throw new Error("No webview found");const t=C.URI.revive(d),c=this._extHostDocuments.getDocument(t);await s.provider.moveCustomTextEditor(c,i,u.CancellationToken.None)}async $undo(o,d,r,s){return this.getCustomDocumentEntry(d,o).undo(r,s)}async $redo(o,d,r,s){return this.getCustomDocumentEntry(d,o).redo(r,s)}async $revert(o,d,r){const s=this.getCustomDocumentEntry(d,o);await this.getCustomEditorProvider(d).revertCustomDocument(s.document,r),s.disposeBackup()}async $onSave(o,d,r){const s=this.getCustomDocumentEntry(d,o);await this.getCustomEditorProvider(d).saveCustomDocument(s.document,r),s.disposeBackup()}async $onSaveAs(o,d,r,s){const i=this.getCustomDocumentEntry(d,o);return this.getCustomEditorProvider(d).saveCustomDocumentAs(i.document,C.URI.revive(r),s)}async $backup(o,d,r){const s=this.getCustomDocumentEntry(d,o),t=await this.getCustomEditorProvider(d).backupCustomDocument(s.document,{destination:s.getNewBackupUri()},r);return s.updateBackup(t),t.id}getCustomDocumentEntry(o,d){const r=this._documents.get(o,C.URI.revive(d));if(!r)throw new Error("No custom document found");return r}getCustomEditorProvider(o){const r=this._editorProviders.get(o)?.provider;if(!r||!this.supportEditing(r))throw new Error("Custom document is not editable");return r}supportEditing(o){return!!o.onDidChangeCustomDocument}}e.ExtHostCustomEditors=g;function v(m){return typeof m.resolveCustomTextEditor=="function"}function f(m){return typeof m.undo=="function"&&typeof m.redo=="function"}function a(m){const o=m.scheme===A.Schemas.file||m.scheme===A.Schemas.untitled?m.fsPath:m.toString();return(0,n.hash)(o)+""}});var tt=this&&this.__classPrivateFieldSet||function(Q,e,u,n,y){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!y:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?y.call(Q,u):y?y.value=u:e.set(Q,u),u},Me=this&&this.__classPrivateFieldGet||function(Q,e,u,n){if(u==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!n:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?n:u==="a"?n.call(Q):n?n.value:e.get(Q)};define(Ie[265],ke([1,0,3,6,2,34,15,71,5,7]),function(Q,e,u,n,y,A,D,C,S,P){"use strict";var L,I,_,T,w,b,p,g,v,f,a,m,o;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class d extends n.Disposable{constructor(t,c,l,h){super();L.set(this,void 0),I.set(this,void 0),_.set(this,void 0),T.set(this,void 0),w.set(this,void 0),b.set(this,void 0),p.set(this,void 0),g.set(this,void 0),v.set(this,!0),f.set(this,void 0),a.set(this,!1),m.set(this,this._register(new u.Emitter)),this.onDidDispose=Me(this,m,"f").event,o.set(this,this._register(new u.Emitter)),this.onDidChangeViewState=Me(this,o,"f").event,tt(this,L,t,"f"),tt(this,I,c,"f"),tt(this,T,l,"f"),tt(this,_,h.viewType,"f"),tt(this,w,h.panelOptions,"f"),tt(this,g,h.viewColumn,"f"),tt(this,b,h.title,"f"),tt(this,f,h.active,"f")}dispose(){Me(this,a,"f")||(tt(this,a,!0,"f"),Me(this,m,"f").fire(),Me(this,I,"f").$disposeWebview(Me(this,L,"f")),Me(this,T,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Me(this,T,"f")}get viewType(){return this.assertNotDisposed(),Me(this,_,"f")}get title(){return this.assertNotDisposed(),Me(this,b,"f")}set title(t){this.assertNotDisposed(),Me(this,b,"f")!==t&&(tt(this,b,t,"f"),Me(this,I,"f").$setTitle(Me(this,L,"f"),t))}get iconPath(){return this.assertNotDisposed(),Me(this,p,"f")}set iconPath(t){this.assertNotDisposed(),Me(this,p,"f")!==t&&(tt(this,p,t,"f"),Me(this,I,"f").$setIconPath(Me(this,L,"f"),y.URI.isUri(t)?{light:t,dark:t}:t))}get options(){return Me(this,w,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Me(this,g,"f")=="number"&&Me(this,g,"f")<0))return Me(this,g,"f")}get active(){return this.assertNotDisposed(),Me(this,f,"f")}get visible(){return this.assertNotDisposed(),Me(this,v,"f")}_updateViewState(t){Me(this,a,"f")||(this.active!==t.active||this.visible!==t.visible||this.viewColumn!==t.viewColumn)&&(tt(this,f,t.active,"f"),tt(this,v,t.visible,"f"),tt(this,g,t.viewColumn,"f"),Me(this,o,"f").fire({webviewPanel:this}))}reveal(t,c){this.assertNotDisposed(),Me(this,I,"f").$reveal(Me(this,L,"f"),{viewColumn:typeof t=="undefined"?void 0:D.ViewColumn.from(t),preserveFocus:!!c})}assertNotDisposed(){if(Me(this,a,"f"))throw new Error("Webview is disposed")}}L=new WeakMap,I=new WeakMap,_=new WeakMap,T=new WeakMap,w=new WeakMap,b=new WeakMap,p=new WeakMap,g=new WeakMap,v=new WeakMap,f=new WeakMap,a=new WeakMap,m=new WeakMap,o=new WeakMap;class r{constructor(t,c,l){this.webviews=c,this.workspace=l,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=t.getProxy(S.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,A.generateUuid)()}createWebviewPanel(t,c,l,h,E={}){const R=typeof h=="object"?h.viewColumn:h,N={viewColumn:D.ViewColumn.from(R),preserveFocus:typeof h=="object"&&!!h.preserveFocus},O=(0,C.shouldSerializeBuffersForPostMessage)(t),k=r.newHandle();this._proxy.$createWebviewPanel((0,C.toExtensionData)(t),k,c,{title:l,panelOptions:s(E),webviewOptions:(0,C.serializeWebviewOptions)(t,this.workspace,E),serializeBuffersForPostMessage:O},N);const U=this.webviews.createNewWebview(k,E,t);return this.createNewWebviewPanel(k,c,l,R,E,U,!0)}$onDidChangeWebviewPanelViewStates(t){const c=Object.keys(t);c.sort((l,h)=>{const E=t[l],R=t[h];return E.active?1:R.active?-1:+E.visible-+R.visible});for(const l of c){const h=this.getWebviewPanel(l);if(!h)continue;const E=t[l];h._updateViewState({active:E.active,visible:E.visible,viewColumn:D.ViewColumn.to(E.position)})}}async $onDidDisposeWebviewPanel(t){this.getWebviewPanel(t)?.dispose(),this._webviewPanels.delete(t),this.webviews.deleteWebview(t)}registerWebviewPanelSerializer(t,c,l){if(this._serializers.has(c))throw new Error(`Serializer for '${c}' already registered`);return this._serializers.set(c,{serializer:l,extension:t}),this._proxy.$registerSerializer(c,{serializeBuffersForPostMessage:(0,C.shouldSerializeBuffersForPostMessage)(t)}),new P.Disposable(()=>{this._serializers.delete(c),this._proxy.$unregisterSerializer(c)})}async $deserializeWebviewPanel(t,c,l,h){const E=this._serializers.get(c);if(!E)throw new Error(`No serializer found for '${c}'`);const{serializer:R,extension:N}=E,O=this.webviews.createNewWebview(t,l.webviewOptions,N),k=this.createNewWebviewPanel(t,c,l.title,h,l.panelOptions,O,l.active);await R.deserializeWebviewPanel(k,l.state)}createNewWebviewPanel(t,c,l,h,E,R,N){const O=new d(t,this._proxy,R,{viewType:c,title:l,viewColumn:h,panelOptions:E,active:N});return this._webviewPanels.set(t,O),O}getWebviewPanel(t){return this._webviewPanels.get(t)}}e.ExtHostWebviewPanels=r;function s(i){return{enableFindWidget:i.enableFindWidget,retainContextWhenHidden:i.retainContextWhenHidden}}});var tt=this&&this.__classPrivateFieldSet||function(Q,e,u,n,y){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!y:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?y.call(Q,u):y?y.value=u:e.set(Q,u),u},Me=this&&this.__classPrivateFieldGet||function(Q,e,u,n){if(u==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!n:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?n:u==="a"?n.call(Q):n?n.value:e.get(Q)};define(Ie[266],ke([1,0,3,6,71,27,15,5,7]),function(Q,e,u,n,y,A,D,C,S){"use strict";var P,L,I,_,T,w,b,p,g,v,f,a;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class m extends n.Disposable{constructor(r,s,i,t,c,l,h){super();P.set(this,void 0),L.set(this,void 0),I.set(this,void 0),_.set(this,void 0),T.set(this,void 0),w.set(this,!1),b.set(this,void 0),p.set(this,void 0),g.set(this,void 0),v.set(this,void 0),f.set(this,this._register(new u.Emitter)),this.onDidChangeVisibility=Me(this,f,"f").event,a.set(this,this._register(new u.Emitter)),this.onDidDispose=Me(this,a,"f").event,tt(this,I,i,"f"),tt(this,p,t,"f"),tt(this,P,r,"f"),tt(this,L,s,"f"),tt(this,_,c,"f"),tt(this,T,l,"f"),tt(this,b,h,"f")}dispose(){Me(this,w,"f")||(tt(this,w,!0,"f"),Me(this,a,"f").fire(),Me(this,_,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Me(this,p,"f")}set title(r){this.assertNotDisposed(),Me(this,p,"f")!==r&&(tt(this,p,r,"f"),Me(this,L,"f").$setWebviewViewTitle(Me(this,P,"f"),r))}get description(){return this.assertNotDisposed(),Me(this,g,"f")}set description(r){this.assertNotDisposed(),Me(this,g,"f")!==r&&(tt(this,g,r,"f"),Me(this,L,"f").$setWebviewViewDescription(Me(this,P,"f"),r))}get visible(){return Me(this,b,"f")}get webview(){return Me(this,_,"f")}get viewType(){return Me(this,I,"f")}_setVisible(r){r===Me(this,b,"f")||Me(this,w,"f")||(tt(this,b,r,"f"),Me(this,f,"f").fire())}get badge(){return this.assertNotDisposed(),(0,A.checkProposedApiEnabled)(Me(this,T,"f"),"badges"),Me(this,v,"f")}set badge(r){this.assertNotDisposed(),(0,A.checkProposedApiEnabled)(Me(this,T,"f"),"badges"),!(r?.value===Me(this,v,"f")?.value&&r?.tooltip===Me(this,v,"f")?.tooltip)&&(tt(this,v,D.ViewBadge.from(r),"f"),Me(this,L,"f").$setWebviewViewBadge(Me(this,P,"f"),r))}show(r){this.assertNotDisposed(),Me(this,L,"f").$show(Me(this,P,"f"),!!r)}assertNotDisposed(){if(Me(this,w,"f"))throw new Error("Webview is disposed")}}P=new WeakMap,L=new WeakMap,I=new WeakMap,_=new WeakMap,T=new WeakMap,w=new WeakMap,b=new WeakMap,p=new WeakMap,g=new WeakMap,v=new WeakMap,f=new WeakMap,a=new WeakMap;class o{constructor(r,s){this._extHostWebview=s,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=r.getProxy(C.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(r,s,i,t){if(this._viewProviders.has(s))throw new Error(`View provider for '${s}' already registered`);return this._viewProviders.set(s,{provider:i,extension:r}),this._proxy.$registerWebviewViewProvider((0,y.toExtensionData)(r),s,{retainContextWhenHidden:t?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,y.shouldSerializeBuffersForPostMessage)(r)}),new S.Disposable(()=>{this._viewProviders.delete(s),this._proxy.$unregisterWebviewViewProvider(s)})}async $resolveWebviewView(r,s,i,t,c){const l=this._viewProviders.get(s);if(!l)throw new Error(`No view provider found for '${s}'`);const{provider:h,extension:E}=l,R=this._extHostWebview.createNewWebview(r,{},E),N=new m(r,this._proxy,s,i,R,E,!0);this._webviewViews.set(r,N),await h.resolveWebviewView(N,{state:t},c)}async $onDidChangeWebviewViewVisibility(r,s){this.getWebviewView(r)._setVisible(s)}async $disposeWebviewView(r){const s=this.getWebviewView(r);this._webviewViews.delete(r),s.dispose(),this._extHostWebview.deleteWebview(r)}getWebviewView(r){const s=this._webviewViews.get(r);if(!s)throw new Error("No webview found");return s}}e.ExtHostWebviewViews=o}),define(Ie[137],ke([1,0,3,5,2,11,8,4,17]),function(Q,e,u,n,y,A,D,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let P=class Yn{constructor(I){this._onDidChangeWindowState=new u.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Yn.InitialState,this._proxy=I.getProxy(n.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(_=>this.$onDidChangeWindowFocus(_))}get state(){return this._state}$onDidChangeWindowFocus(I){I!==this._state.focused&&(this._state={...this._state,focused:I},this._onDidChangeWindowState.fire(this._state))}openUri(I,_){let T;if(typeof I=="string"){T=I;try{I=y.URI.parse(I)}catch{return Promise.reject(`Invalid uri - '${I}'`)}}return(0,D.isFalsyOrWhitespace)(I.scheme)?Promise.reject("Invalid scheme - cannot be empty"):I.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${I.scheme}'`):this._proxy.$openUri(I,T,_)}async asExternalUri(I,_){if((0,D.isFalsyOrWhitespace)(I.scheme))return Promise.reject("Invalid scheme - cannot be empty");const T=await this._proxy.$asExternalUri(I,_);return y.URI.from(T)}};P.InitialState={focused:!0},P=Ge([$e(0,S.IExtHostRpcService)],P),e.ExtHostWindow=P,e.IExtHostWindow=(0,C.createDecorator)("IExtHostWindow")}),define(Ie[267],ke([1,0,241,26,17]),function(Q,e,u,n,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;const A=1024*1024;let D=class extends u.AbstractExtHostConsoleForwarder{constructor(S,P){super(S,P);this._isMakingConsoleCall=!1,this._wrapStream("stderr","error"),this._wrapStream("stdout","log")}_nativeConsoleLogMessage(S,P,L){const I=S==="error"||S==="warn"?process.stderr:process.stdout;this._isMakingConsoleCall=!0,I.write(`
START_NATIVE_LOG
`),P.apply(console,L),I.write(`
END_NATIVE_LOG
`),this._isMakingConsoleCall=!1}_wrapStream(S,P){const L=process[S],I=L.write;let _="";Object.defineProperty(L,"write",{set:()=>{},get:()=>(T,w,b)=>{if(!this._isMakingConsoleCall){_+=T.toString(w);const p=_.length>A?_.length:_.lastIndexOf(`
`);p!==-1&&(console[P](_.slice(0,p)),_=_.slice(p+1))}I.call(L,T,w,b)}})}};D=Ge([$e(0,y.IExtHostRpcService),$e(1,n.IExtHostInitDataService)],D),e.ExtHostConsoleForwarder=D}),define(Ie[268],ke([1,0,9,63,34,37,6,5,2,17]),function(Q,e,u,n,y,A,D,C,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let L=class extends D.Disposable{constructor(_,T){super();const w=_.getProxy(C.MainContext.MainThreadDownloadService);T.registerCommand(!1,"_workbench.downloadResource",async b=>{const p=S.URI.file((0,u.join)((0,n.tmpdir)(),(0,y.generateUuid)()));return await w.$download(b,p),p})}};L=Ge([$e(0,P.IExtHostRpcService),$e(1,A.IExtHostCommands)],L),e.ExtHostDownloadService=L}),define(Ie[269],ke([1,0,136,11,196,34]),function(Q,e,u,n,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class D extends u.ExtHostLoggerService{doCreateLogger(S,P,L){return S.scheme===n.Schemas.file?new y.SpdLogLogger(L?.name||(0,A.generateUuid)(),S.fsPath,!L?.donotRotate,!!L?.donotUseFormatters,P):super.doCreateLogger(S,P,L)}}e.ExtHostLoggerService=D}),define(Ie[270],ke([1,0,62,9,2,70,6,11,18,29]),function(Q,e,u,n,y,A,D,C,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class L extends A.ExtensionStoragePaths{constructor(){super(...arguments);this._workspaceStorageLock=null}async _getWorkspaceStorageURI(o){const d=await super._getWorkspaceStorageURI(o);if(d.scheme!==C.Schemas.file)return d;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${d.fsPath}.`),d;const r=d.fsPath;let s=0;do{let i;s===0?i=r:i=/[/\\]$/.test(r)?`${r.substr(0,r.length-1)}-${s}`:`${r}-${s}`,await I(i);const t=n.join(i,"vscode.lock"),c=await b(this._logService,t,!1);if(c)return this._workspaceStorageLock=c,process.on("exit",()=>{c.dispose()}),y.URI.file(i);s++}while(s<10);return d}onWillDeactivateAll(){this._workspaceStorageLock?.setWillRelease(6e3)}}e.ExtensionStoragePaths=L;async function I(m){try{await P.Promises.stat(m);return}catch{}try{await P.Promises.mkdir(m,{recursive:!0})}catch{}}const _=1e3,T=10*60*1e3;class w extends D.Disposable{constructor(o,d){super();this.logService=o,this.filename=d,this._timer=this._register(new S.IntervalTimer),this._timer.cancelAndSet(async()=>{const r=await p(o,d);(!r||r.pid!==process.pid)&&(o.info(`Lock '${d}': The lock was lost unexpectedly.`),this._timer.cancel());try{await P.Promises.utimes(d,new Date,new Date)}catch(s){o.error(s),o.info(`Lock '${d}': Could not update mtime.`)}},_)}dispose(){super.dispose();try{u.unlinkSync(this.filename)}catch{}}async setWillRelease(o){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${o} ms.`);try{const d={pid:process.pid,willReleaseAt:Date.now()+o};await P.Promises.writeFile(this.filename,JSON.stringify(d),{flag:"w"})}catch(d){this.logService.error(d)}}}async function b(m,o,d){try{const s={pid:process.pid,willReleaseAt:0};await P.Promises.writeFile(o,JSON.stringify(s),{flag:"wx"})}catch(s){m.error(s)}const r=await p(m,o);return!r||r.pid!==process.pid?d?(m.info(`Lock '${o}': Could not acquire lock, giving up.`),null):(m.info(`Lock '${o}': Could not acquire lock, checking if the file is stale.`),f(m,o)):(m.info(`Lock '${o}': Lock acquired.`),new w(m,o))}async function p(m,o){let d;try{d=await P.Promises.readFile(o)}catch(r){return m.error(r),null}try{return JSON.parse(String(d))}catch(r){return m.error(r),null}}async function g(m,o){let d;try{d=await P.Promises.stat(o)}catch(r){return m.error(r),0}return d.mtime.getTime()}function v(m){try{return process.kill(m,0),!0}catch{return!1}}async function f(m,o){const d=await p(m,o);if(!d)return m.info(`Lock '${o}': Could not read pid of lock holder.`),a(m,o);if(d.willReleaseAt){let c=d.willReleaseAt-Date.now();if(c<5e3){for(c>0?m.info(`Lock '${o}': The lockfile is scheduled to be released in ${c} ms.`):m.info(`Lock '${o}': The lockfile is scheduled to have been released.`);c>0;){if(await(0,S.timeout)(Math.min(100,c)),await g(m,o)===0)return a(m,o);c=d.willReleaseAt-Date.now()}return a(m,o)}}if(!v(d.pid))return m.info(`Lock '${o}': The pid ${d.pid} appears to be gone.`),a(m,o);const r=await g(m,o),s=Date.now()-r;if(s<=T)return m.info(`Lock '${o}': The lock does not look stale, elapsed: ${s} ms, giving up.`),null;m.info(`Lock '${o}': The lock looks stale, waiting for 2s.`),await(0,S.timeout)(2e3);const i=await g(m,o),t=Date.now()-i;return t<=T?(m.info(`Lock '${o}': The lock does not look stale, elapsed: ${t} ms, giving up.`),null):(m.info(`Lock '${o}': The lock looks stale even after waiting for 2s.`),a(m,o))}async function a(m,o){m.info(`Lock '${o}': Deleting a stale lock.`);try{await P.Promises.unlink(o)}catch{}return b(m,o,!0)}}),define(Ie[271],ke([1,0,34,17,38]),function(Q,e,u,n,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let A=class extends y.BaseExtHostTerminalService{constructor(C){super(!0,C)}createTerminal(C,S,P){return this.createTerminalFromOptions({name:C,shellPath:S,shellArgs:P})}createTerminalFromOptions(C,S){const P=new y.ExtHostTerminal(this._proxy,(0,u.generateUuid)(),C,C.name);return this._terminals.push(P),P.create(C,this._serializeParentTerminal(C,S)),P.value}};A=Ge([$e(0,n.IExtHostRpcService)],A),e.ExtHostTerminalService=A}),define(Ie[272],ke([1,0,5,17,179,6,26,2,42,22,29,7,13,52,3,123,94,14]),function(Q,e,u,n,y,A,D,C,S,P,L,I,_,T,w,b,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class v extends b.DisposableTunnel{}function f(c){const l=c.trim().split(`
`),h=[];return l.forEach(R=>{const N=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(R);N&&N.length>=3&&h.push({pid:parseInt(N[1],10),socket:parseInt(N[2],10)})}),h.reduce((R,N)=>(R[N.socket]=N,R),{})}e.getSockets=f;function a(...c){const l=[].concat(...c.map(o));return[...new Map(l.filter(h=>h.st==="0A").map(h=>{const E=h.local_address.split(":");return{socket:parseInt(h.inode,10),ip:m(E[0]),port:parseInt(E[1],16)}}).map(h=>[h.ip+":"+h.port,h])).values()]}e.loadListeningPorts=a;function m(c){let l="";if(c.length===8)for(let h=c.length-2;h>=0;h-=2)l+=parseInt(c.substr(h,2),16),h!==0&&(l+=".");else for(let h=c.length-4;h>=0;h-=4)l+=parseInt(c.substr(h,4),16).toString(16),h!==0&&(l+=":");return l}e.parseIpAddress=m;function o(c){const l=c.trim().split(`
`),h=l.shift().trim().split(/\s+/).filter(R=>R!=="rx_queue"&&R!=="tm->when");return l.map(R=>R.trim().split(/\s+/).reduce((N,O,k)=>(N[h[k]||k]=O,N),{}))}e.loadConnectionTable=o;function d(c){return!!c.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||c.indexOf("out/server-main.js")!==-1||c.indexOf("_productName=VSCode")!==-1}function r(c){const l=c.trim().split(`
`),h=[];return l.forEach(E=>{const R=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(E);R&&R.length>=4&&h.push({pid:parseInt(R[1],10),ppid:parseInt(R[2]),cmd:R[3]})}),h}e.getRootProcesses=r;async function s(c,l,h){const E=h.reduce((N,O)=>(N[O.pid]=O,N),{}),R=[];return c.forEach(({socket:N,ip:O,port:k})=>{const U=l[N]?l[N].pid:void 0,F=U?E[U]?.cmd:void 0;U&&F&&!d(F)&&R.push({host:O,port:k,detail:F,pid:U})}),R}e.findPorts=s;function i(c,l,h){const E=new Map,R=r(l);for(const N of c){const O=h.get(N.port);if(O){E.set(N.port,O);continue}const k=R.find(U=>U.cmd.includes(`${N.port}`));if(k){let U=k,F;do F=R.find($=>$.ppid===U.pid),F&&(U=F);while(F);E.set(N.port,{host:N.ip,port:N.port,pid:U.pid,detail:U.cmd,ppid:U.ppid})}else E.set(N.port,{host:N.ip,port:N.port,ppid:Number.MAX_VALUE})}return E}e.tryFindRootPorts=i;let t=class extends A.Disposable{constructor(l,h,E){super();this.logService=E,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new w.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=l.getProxy(u.MainContext.MainThreadTunnelService),_.isLinux&&h.remote.isRemote&&h.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(l,h){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${l.identifier.value} called openTunnel API for ${h.remoteAddress.host}:${h.remoteAddress.port}.`);const E=await this._proxy.$openTunnel(h,l.displayName);if(E){const R=new v(E.remoteAddress,E.localAddress,()=>this._proxy.$closeTunnel(E.remoteAddress));return this._register(R),R}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(l){return Math.max(l*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(l,h){const E=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(E,{selector:l,provider:h}),this._proxy.$registerPortsAttributesProvider(l,E),new I.Disposable(()=>{this._portAttributesProviders.delete(E),this._proxy.$unregisterPortsAttributesProvider(E)})}async $providePortAttributes(l,h,E,R,N){const O=[];for(const U of l){const F=this._portAttributesProviders.get(U);if(!F)return[];O.push(...await Promise.all(h.map(async $=>F.provider.providePortAttributes($,E,R,N))))}const k=O.filter(U=>!!U);return k.length>0?k.map(U=>({autoForwardAction:U.autoForwardAction,port:U.port})):[]}async $registerCandidateFinder(l){if(l&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=l;const h=new p.MovingAverage;let E;for(;this._candidateFindingEnabled;){const R=new Date().getTime(),N=(await this.findCandidatePorts()).filter(k=>(0,b.isLocalhost)(k.host)||(0,b.isAllInterfaces)(k.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${N.map(k=>k.port).join(", ")}`);const O=new Date().getTime()-R;h.update(O),(!E||JSON.stringify(E)!==JSON.stringify(N))&&(E=N,await this._proxy.$onFoundNewCandidates(E)),await new Promise(k=>setTimeout(()=>k(),this.calculateDelay(h.value)))}}async setTunnelFactory(l){if(l){if(l.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(l.candidatePortSource),l.showCandidatePort&&(this._showCandidatePort=l.showCandidatePort,this._proxy.$setCandidateFilter()),l.tunnelFactory){this._forwardPortProvider=l.tunnelFactory;let h=l.tunnelFeatures?.privacyOptions??[];l.tunnelFeatures?.public&&h.length===0&&(h=[{id:"private",label:y.localize(0,null),themeIcon:"lock"},{id:"public",label:y.localize(1,null),themeIcon:"eye"}]);const E=l.tunnelFeatures?{elevation:!!l.tunnelFeatures?.elevation,public:!!l.tunnelFeatures?.public,privacyOptions:h}:void 0;this._proxy.$setTunnelProvider(E)}}else this._forwardPortProvider=void 0;return(0,A.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(l,h){if(this._extensionTunnels.has(l.host)){const E=this._extensionTunnels.get(l.host);E.has(l.port)&&(h&&E.get(l.port).disposeListener.dispose(),await E.get(l.port).tunnel.dispose(),E.delete(l.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(l,h){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const E=this._forwardPortProvider(l,h);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),E!==void 0){const R=await E;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(l.remoteAddress.host)||this._extensionTunnels.set(l.remoteAddress.host,new Map);const N=this._register(R.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(R.remoteAddress))));return this._extensionTunnels.get(l.remoteAddress.host).set(l.remoteAddress.port,{tunnel:R,disposeListener:N}),T.TunnelDtoConverter.fromApiTunnel(R)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(l){const h=await Promise.all(l.map(R=>this._showCandidatePort(R.host,R.port,R.detail??""))),E=l.filter((R,N)=>h[N]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${l.map(R=>R.port).join(", ")} to ${E.map(R=>R.port).join(", ")}`),E}async findCandidatePorts(){let l="",h="";try{l=await L.Promises.readFile("/proc/net/tcp","utf8"),h=await L.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const E=a(l,h),R=await new Promise(B=>{(0,S.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(z,q,V)=>{B(q)})}),N=f(R),O=await L.Promises.readdir("/proc"),k=[];for(const B of O)try{const z=Number(B),q=P.joinPath(C.URI.file("/proc"),B);if((await L.Promises.stat(q.fsPath)).isDirectory()&&!isNaN(z)){const j=await L.Promises.readlink(P.joinPath(q,"cwd").fsPath),ne=await L.Promises.readFile(P.joinPath(q,"cmdline").fsPath,"utf8");k.push({pid:z,cwd:j,cmd:ne})}}catch{}const U=[],F=E.filter(B=>{const z=N[B.socket];return z||U.push(B),z}),$=s(F,N,k);let ee;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${U.length}`),U.length>0){const B=await new Promise(z=>{(0,S.exec)("ps -F -A -l | grep root",(q,V,j)=>{z(V)})});this._foundRootPorts=i(U,B,this._foundRootPorts),ee=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${ee.join(", ")}`)}return $.then(B=>ee?B.concat(ee):B)}};t=Ge([$e(0,n.IExtHostRpcService),$e(1,D.IExtHostInitDataService),$e(2,g.ILogService)],t),e.ExtHostTunnelService=t}),define(Ie[273],ke([1,0,18,23,21,12,3,6,108,235,53]),function(Q,e,u,n,y,A,D,C,S,P,L){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function _(E,R){try{return JSON.stringify(E,R)}catch{return"null"}}const T="$$ref$$",w={[T]:-1};class b{constructor(R,N){this.jsonString=R,this.referencedBuffers=N}}function p(E,R=null,N=!1){const O=[];return{jsonString:(N?_:JSON.stringify)(E,(U,F)=>{if(typeof F=="undefined")return w;if(typeof F=="object"){if(F instanceof n.VSBuffer){const $=O.push(F)-1;return{[T]:$}}if(R)return R(U,F)}return F}),referencedBuffers:O}}e.stringifyJsonWithBufferRefs=p;function g(E,R,N){return JSON.parse(E,(O,k)=>{if(k){const U=k[T];if(typeof U=="number")return R[U];if(N&&k.$mid===1)return N.transformIncoming(k)}return k})}e.parseJsonAndRestoreBufferRefs=g;function v(E,R){return JSON.stringify(E,R)}function f(E){return E?(R,N)=>N&&N.$mid===1?E.transformOutgoing(N):N:null}var a;(function(E){E[E.LocalSide=0]="LocalSide",E[E.OtherSide=1]="OtherSide"})(a=e.RequestInitiator||(e.RequestInitiator={}));var m;(function(E){E[E.Responsive=0]="Responsive",E[E.Unresponsive=1]="Unresponsive"})(m=e.ResponsiveState||(e.ResponsiveState={}));const o=()=>{},d=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class s extends C.Disposable{constructor(R,N=null,O=null){super();this[I]=!0,this._onDidChangeResponsiveState=this._register(new D.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=R,this._logger=N,this._uriTransformer=O,this._uriReplacer=f(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let k=0,U=L.ProxyIdentifier.count;k<U;k++)this._locals[k]=null,this._proxies[k]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new u.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(k=>this._receiveOneMessage(k))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(R=>{this._pendingRPCReplies[R].resolveErr(A.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(R){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+s.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(R){this._unresponsiveTime=Date.now()+s.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(R){this._responsiveState!==R&&(this._responsiveState=R,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(R){return this._uriTransformer?(0,S.transformIncomingURIs)(R,this._uriTransformer):R}getProxy(R){const{nid:N,sid:O}=R;return this._proxies[N]||(this._proxies[N]=this._createProxy(N,O)),this._proxies[N]}_createProxy(R,N){const O={get:(k,U)=>(typeof U=="string"&&!k[U]&&U.charCodeAt(0)===36&&(k[U]=(...F)=>this._remoteCall(R,U,F)),U===r?N:k[U])};return new Proxy(Object.create(null),O)}set(R,N){return this._locals[R.nid]=N,N}assertRegistered(R){for(let N=0,O=R.length;N<O;N++){const k=R[N];if(!this._locals[k.nid])throw new Error(`Missing proxy instance ${k.sid}`)}}_receiveOneMessage(R){if(this._isDisposed)return;const N=R.byteLength,O=i.read(R,0),k=O.readUInt8(),U=O.readUInt32();switch(k){case 1:case 2:{let{rpcId:F,method:$,args:ee}=c.deserializeRequestJSONArgs(O);this._uriTransformer&&(ee=(0,S.transformIncomingURIs)(ee,this._uriTransformer)),this._receiveRequest(N,U,F,$,ee,k===2);break}case 3:case 4:{let{rpcId:F,method:$,args:ee}=c.deserializeRequestMixedArgs(O);this._uriTransformer&&(ee=(0,S.transformIncomingURIs)(ee,this._uriTransformer)),this._receiveRequest(N,U,F,$,ee,k===4);break}case 5:{this._logger?.logIncoming(N,U,0,"ack"),this._onDidReceiveAcknowledge(U);break}case 6:{this._receiveCancel(N,U);break}case 7:{this._receiveReply(N,U,void 0);break}case 9:{let F=c.deserializeReplyOKJSON(O);this._uriTransformer&&(F=(0,S.transformIncomingURIs)(F,this._uriTransformer)),this._receiveReply(N,U,F);break}case 10:{const F=c.deserializeReplyOKJSONWithBuffers(O,this._uriTransformer);this._receiveReply(N,U,F);break}case 8:{const F=c.deserializeReplyOKVSBuffer(O);this._receiveReply(N,U,F);break}case 11:{let F=c.deserializeReplyErrError(O);this._uriTransformer&&(F=(0,S.transformIncomingURIs)(F,this._uriTransformer)),this._receiveReplyErr(N,U,F);break}case 12:{this._receiveReplyErr(N,U,void 0);break}default:console.error("received unexpected message"),console.error(R)}}_receiveRequest(R,N,O,k,U,F){this._logger?.logIncoming(R,N,1,`receiveRequest ${(0,L.getStringIdentifierForProxy)(O)}.${k}(`,U);const $=String(N);let ee,B;if(F){const q=new y.CancellationTokenSource;U.push(q.token),ee=this._invokeHandler(O,k,U),B=()=>q.cancel()}else ee=this._invokeHandler(O,k,U),B=o;this._cancelInvokedHandlers[$]=B;const z=c.serializeAcknowledged(N);this._logger?.logOutgoing(z.byteLength,N,1,"ack"),this._protocol.send(z),ee.then(q=>{delete this._cancelInvokedHandlers[$];const V=c.serializeReplyOK(N,q,this._uriReplacer);this._logger?.logOutgoing(V.byteLength,N,1,"reply:",q),this._protocol.send(V)},q=>{delete this._cancelInvokedHandlers[$];const V=c.serializeReplyErr(N,q);this._logger?.logOutgoing(V.byteLength,N,1,"replyErr:",q),this._protocol.send(V)})}_receiveCancel(R,N){this._logger?.logIncoming(R,N,1,"receiveCancel");const O=String(N);this._cancelInvokedHandlers[O]?.()}_receiveReply(R,N,O){this._logger?.logIncoming(R,N,0,"receiveReply:",O);const k=String(N);if(!this._pendingRPCReplies.hasOwnProperty(k))return;const U=this._pendingRPCReplies[k];delete this._pendingRPCReplies[k],U.resolveOk(O)}_receiveReplyErr(R,N,O){this._logger?.logIncoming(R,N,0,"receiveReplyErr:",O);const k=String(N);if(!this._pendingRPCReplies.hasOwnProperty(k))return;const U=this._pendingRPCReplies[k];delete this._pendingRPCReplies[k];let F;O&&(O.$isError?(F=new Error,F.name=O.name,F.message=O.message,F.stack=O.stack):F=O),U.resolveErr(F)}_invokeHandler(R,N,O){try{return Promise.resolve(this._doInvokeHandler(R,N,O))}catch(k){return Promise.reject(k)}}_doInvokeHandler(R,N,O){const k=this._locals[R];if(!k)throw new Error("Unknown actor "+(0,L.getStringIdentifierForProxy)(R));const U=k[N];if(typeof U!="function")throw new Error("Unknown method "+N+" on actor "+(0,L.getStringIdentifierForProxy)(R));return U.apply(k,O)}_remoteCall(R,N,O){if(this._isDisposed)return new P.CanceledLazyPromise;let k=null;if(O.length>0&&y.CancellationToken.isCancellationToken(O[O.length-1])&&(k=O.pop()),k&&k.isCancellationRequested)return Promise.reject(A.canceled());const U=c.serializeRequestArguments(O,this._uriReplacer),F=++this._lastMessageId,$=String(F),ee=new P.LazyPromise;k&&k.onCancellationRequested(()=>{const z=c.serializeCancel(F);this._logger?.logOutgoing(z.byteLength,F,0,"cancel"),this._protocol.send(c.serializeCancel(F))}),this._pendingRPCReplies[$]=ee,this._onWillSendRequest(F);const B=c.serializeRequest(F,R,N,U,!!k);return this._logger?.logOutgoing(B.byteLength,F,0,`request: ${(0,L.getStringIdentifierForProxy)(R)}.${N}(`,O),this._protocol.send(B),ee}}e.RPCProtocol=s,I=d,s.UNRESPONSIVE_TIME=3*1e3;class i{constructor(R,N){this._buff=R,this._offset=N}static alloc(R,N,O){const k=new i(n.VSBuffer.alloc(O+1+4),0);return k.writeUInt8(R),k.writeUInt32(N),k}static read(R,N){return new i(R,N)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(R){this._buff.writeUInt8(R,this._offset),this._offset+=1}readUInt8(){const R=this._buff.readUInt8(this._offset);return this._offset+=1,R}writeUInt32(R){this._buff.writeUInt32BE(R,this._offset),this._offset+=4}readUInt32(){const R=this._buff.readUInt32BE(this._offset);return this._offset+=4,R}static sizeShortString(R){return 1+R.byteLength}writeShortString(R){this._buff.writeUInt8(R.byteLength,this._offset),this._offset+=1,this._buff.set(R,this._offset),this._offset+=R.byteLength}readShortString(){const R=this._buff.readUInt8(this._offset);this._offset+=1;const O=this._buff.slice(this._offset,this._offset+R).toString();return this._offset+=R,O}static sizeLongString(R){return 4+R.byteLength}writeLongString(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}readLongString(){const R=this._buff.readUInt32BE(this._offset);this._offset+=4;const O=this._buff.slice(this._offset,this._offset+R).toString();return this._offset+=R,O}writeBuffer(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}static sizeVSBuffer(R){return 4+R.byteLength}writeVSBuffer(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}readVSBuffer(){const R=this._buff.readUInt32BE(this._offset);this._offset+=4;const N=this._buff.slice(this._offset,this._offset+R);return this._offset+=R,N}static sizeMixedArray(R){let N=0;N+=1;for(let O=0,k=R.length;O<k;O++){const U=R[O];switch(N+=1,U.type){case 1:N+=this.sizeLongString(U.value);break;case 2:N+=this.sizeVSBuffer(U.value);break;case 3:N+=this.sizeUInt32,N+=this.sizeLongString(U.value);for(let F=0;F<U.buffers.length;++F)N+=this.sizeVSBuffer(U.buffers[F]);break;case 4:break}}return N}writeMixedArray(R){this._buff.writeUInt8(R.length,this._offset),this._offset+=1;for(let N=0,O=R.length;N<O;N++){const k=R[N];switch(k.type){case 1:this.writeUInt8(1),this.writeLongString(k.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(k.value);break;case 3:this.writeUInt8(3),this.writeUInt32(k.buffers.length),this.writeLongString(k.value);for(let U=0;U<k.buffers.length;++U)this.writeBuffer(k.buffers[U]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const R=this._buff.readUInt8(this._offset);this._offset+=1;const N=new Array(R);for(let O=0;O<R;O++)switch(this.readUInt8()){case 1:N[O]=this.readLongString();break;case 2:N[O]=this.readVSBuffer();break;case 3:{const U=this.readUInt32(),F=this.readLongString(),$=[];for(let ee=0;ee<U;++ee)$.push(this.readVSBuffer());N[O]=new L.SerializableObjectWithBuffers(g(F,$,null));break}case 4:N[O]=void 0;break}return N}}i.sizeUInt32=4;var t;(function(E){E[E.Simple=0]="Simple",E[E.Mixed=1]="Mixed"})(t||(t={}));class c{static _useMixedArgSerialization(R){for(let N=0,O=R.length;N<O;N++)if(R[N]instanceof n.VSBuffer||R[N]instanceof L.SerializableObjectWithBuffers||typeof R[N]=="undefined")return!0;return!1}static serializeRequestArguments(R,N){if(this._useMixedArgSerialization(R)){const O=[];for(let k=0,U=R.length;k<U;k++){const F=R[k];if(F instanceof n.VSBuffer)O[k]={type:2,value:F};else if(typeof F=="undefined")O[k]={type:4};else if(F instanceof L.SerializableObjectWithBuffers){const{jsonString:$,referencedBuffers:ee}=p(F.value,N);O[k]={type:3,value:n.VSBuffer.fromString($),buffers:ee}}else O[k]={type:1,value:n.VSBuffer.fromString(v(F,N))}}return{type:1,args:O}}return{type:0,args:v(R,N)}}static serializeRequest(R,N,O,k,U){switch(k.type){case 0:return this._requestJSONArgs(R,N,O,k.args,U);case 1:return this._requestMixedArgs(R,N,O,k.args,U)}}static _requestJSONArgs(R,N,O,k,U){const F=n.VSBuffer.fromString(O),$=n.VSBuffer.fromString(k);let ee=0;ee+=i.sizeUInt8(),ee+=i.sizeShortString(F),ee+=i.sizeLongString($);const B=i.alloc(U?2:1,R,ee);return B.writeUInt8(N),B.writeShortString(F),B.writeLongString($),B.buffer}static deserializeRequestJSONArgs(R){const N=R.readUInt8(),O=R.readShortString(),k=R.readLongString();return{rpcId:N,method:O,args:JSON.parse(k)}}static _requestMixedArgs(R,N,O,k,U){const F=n.VSBuffer.fromString(O);let $=0;$+=i.sizeUInt8(),$+=i.sizeShortString(F),$+=i.sizeMixedArray(k);const ee=i.alloc(U?4:3,R,$);return ee.writeUInt8(N),ee.writeShortString(F),ee.writeMixedArray(k),ee.buffer}static deserializeRequestMixedArgs(R){const N=R.readUInt8(),O=R.readShortString(),k=R.readMixedArray(),U=new Array(k.length);for(let F=0,$=k.length;F<$;F++){const ee=k[F];typeof ee=="string"?U[F]=JSON.parse(ee):U[F]=ee}return{rpcId:N,method:O,args:U}}static serializeAcknowledged(R){return i.alloc(5,R,0).buffer}static serializeCancel(R){return i.alloc(6,R,0).buffer}static serializeReplyOK(R,N,O){if(typeof N=="undefined")return this._serializeReplyOKEmpty(R);if(N instanceof n.VSBuffer)return this._serializeReplyOKVSBuffer(R,N);if(N instanceof L.SerializableObjectWithBuffers){const{jsonString:k,referencedBuffers:U}=p(N.value,O,!0);return this._serializeReplyOKJSONWithBuffers(R,k,U)}else return this._serializeReplyOKJSON(R,_(N,O))}static _serializeReplyOKEmpty(R){return i.alloc(7,R,0).buffer}static _serializeReplyOKVSBuffer(R,N){let O=0;O+=i.sizeVSBuffer(N);const k=i.alloc(8,R,O);return k.writeVSBuffer(N),k.buffer}static deserializeReplyOKVSBuffer(R){return R.readVSBuffer()}static _serializeReplyOKJSON(R,N){const O=n.VSBuffer.fromString(N);let k=0;k+=i.sizeLongString(O);const U=i.alloc(9,R,k);return U.writeLongString(O),U.buffer}static _serializeReplyOKJSONWithBuffers(R,N,O){const k=n.VSBuffer.fromString(N);let U=0;U+=i.sizeUInt32,U+=i.sizeLongString(k);for(const $ of O)U+=i.sizeVSBuffer($);const F=i.alloc(10,R,U);F.writeUInt32(O.length),F.writeLongString(k);for(const $ of O)F.writeBuffer($);return F.buffer}static deserializeReplyOKJSON(R){const N=R.readLongString();return JSON.parse(N)}static deserializeReplyOKJSONWithBuffers(R,N){const O=R.readUInt32(),k=R.readLongString(),U=[];for(let F=0;F<O;++F)U.push(R.readVSBuffer());return new L.SerializableObjectWithBuffers(g(k,U,N))}static serializeReplyErr(R,N){const O=N?_(A.transformErrorForSerialization(N),null):void 0;if(typeof O!="string")return this._serializeReplyErrEmpty(R);const k=n.VSBuffer.fromString(O);let U=0;U+=i.sizeLongString(k);const F=i.alloc(11,R,U);return F.writeLongString(k),F.buffer}static deserializeReplyErrError(R){const N=R.readLongString();return JSON.parse(N)}static _serializeReplyErrEmpty(R){return i.alloc(12,R,0).buffer}}var l;(function(E){E[E.RequestJSONArgs=1]="RequestJSONArgs",E[E.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",E[E.RequestMixedArgs=3]="RequestMixedArgs",E[E.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",E[E.Acknowledged=5]="Acknowledged",E[E.Cancel=6]="Cancel",E[E.ReplyOKEmpty=7]="ReplyOKEmpty",E[E.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",E[E.ReplyOKJSON=9]="ReplyOKJSON",E[E.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",E[E.ReplyErrError=11]="ReplyErrError",E[E.ReplyErrEmpty=12]="ReplyErrEmpty"})(l||(l={}));var h;(function(E){E[E.String=1]="String",E[E.VSBuffer=2]="VSBuffer",E[E.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",E[E.Undefined=4]="Undefined"})(h||(h={}))}),define(Ie[274],ke([1,0,3,44,51,4,43,12,18]),function(Q,e,u,n,y,A,D,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new y.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new y.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new y.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,A.createDecorator)(e.OUTPUT_SERVICE_ID);var P;(function(T){T[T.Append=1]="Append",T[T.Replace=2]="Replace",T[T.Clear=3]="Clear"})(P=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class L{constructor(){this.channels=new Map,this._onDidRegisterChannel=new u.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new u.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(w){this.channels.has(w.id)||(this.channels.set(w.id,w),this._onDidRegisterChannel.fire(w.id))}getChannels(){const w=[];return this.channels.forEach(b=>w.push(b)),w}getChannel(w){return this.channels.get(w)}removeChannel(w){this.channels.delete(w),this._onDidRemoveChannel.fire(w)}}n.Registry.add(e.Extensions.OutputChannels,new L);function I(T,w,b,p,g){return(0,S.createCancelablePromise)(async v=>{await(0,D.whenProviderRegistered)(b,p);const f=n.Registry.as(e.Extensions.OutputChannels);try{await _(b,1,p,g,v),f.registerChannel({id:T,label:w,file:b,log:!0})}catch(a){(0,C.isCancellationError)(a)||g.error("Error while registering log channel",b.toString(),(0,C.getErrorMessage)(a))}})}e.registerLogChannel=I;async function _(T,w,b,p,g){if(!await b.exists(T)){if(g.isCancellationRequested)throw new C.CancellationError;if(w>10)throw new Error("Timed out while waiting for file to be created");p.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",T.toString()),await(0,S.timeout)(1e3,g),await _(T,w+1,b,p,g)}}}),define(Ie[138],ke([1,0,5,6,4,17,14,274,69,26,46,153,23,10]),function(Q,e,u,n,y,A,D,C,S,P,L,I,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class w extends n.Disposable{constructor(g,v,f,a){super();this.id=g,this.name=v,this.logger=f,this.proxy=a,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(g){this.append(g+`
`)}append(g){this.write(g),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,C.OutputChannelUpdateMode.Append))}clear(){const g=this.offset;this.logger.flush(),this.proxy.$update(this.id,C.OutputChannelUpdateMode.Clear,g)}replace(g){const v=this.offset;this.write(g),this.proxy.$update(this.id,C.OutputChannelUpdateMode.Replace,v),this.visible&&this.logger.flush()}show(g,v){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof g=="boolean"?g:v))}hide(){this.proxy.$close(this.id)}write(g){this.offset+=_.VSBuffer.fromString(g).byteLength,this.logger.info(g)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=w;let b=class{constructor(g,v,f,a,m){this.extHostFileSystem=f,this.extHostFileSystemInfo=a,this.loggerService=m,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=g.getProxy(u.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(v.logsLocation,`output_logging_${(0,I.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(g){this.visibleChannelId=g;for(const[v,f]of this.channels)f.visible=v===this.visibleChannelId}createOutputChannel(g,v,f){if(g=g.trim(),!g)throw new Error("illegal argument `name`. must not be falsy");if((0,T.isString)(v)&&!v.trim())throw new Error("illegal argument `languageId`. must not be empty");const a=this.doCreateOutputChannel(g,v,f);return a.then(m=>{this.channels.set(m.id,m),m.visible=m.id===this.visibleChannelId}),this.createExtHostOutputChannel(g,a)}async doCreateOutputChannel(g,v,f){const a=await this.createOutputDirectory(),m=this.extHostFileSystemInfo.extUri.joinPath(a,`${this.namePool++}-${g.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),o=this.loggerService.createLogger(m,{always:!0,donotRotate:!0,donotUseFormatters:!0}),d=await this.proxy.$register(g,!1,m,v,f.identifier.value);return new w(d,g,o,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(g,v){let f=!1;const a=()=>{if(f)throw new Error("Channel has been closed")};return{get name(){return g},append(m){a(),v.then(o=>o.append(m))},appendLine(m){a(),v.then(o=>o.appendLine(m))},clear(){a(),v.then(m=>m.clear())},replace(m){a(),v.then(o=>o.replace(m))},show(m,o){a(),v.then(d=>d.show(m,o))},hide(){a(),v.then(m=>m.hide())},dispose(){f=!0,v.then(m=>m.dispose())}}}};b=Ge([$e(0,A.IExtHostRpcService),$e(1,P.IExtHostInitDataService),$e(2,S.IExtHostConsumerFileSystem),$e(3,L.IExtHostFileSystemInfo),$e(4,D.ILoggerService)],b),e.ExtHostOutputService=b,e.IExtHostOutputService=(0,y.createDecorator)("IExtHostOutputService")}),define(Ie[275],ke([1,0,4]),function(Q,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,u.createDecorator)("remoteAgentService")}),define(Ie[276],ke([1,0,30,11,9,13,22,2,4,205,45,226,275]),function(Q,e,u,n,y,A,D,C,S,P,L,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,S.createDecorator)("pathService");let T=class Jn{constructor(b,p,g,v){this.localUserHome=b,this.remoteAgentService=p,this.environmentService=g,this.contextService=v,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||A.OS)(),this.resolveUserHome=(async()=>{const f=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=f?.userHome??b})()}hasValidBasename(b,p,g){return typeof p=="string"||typeof p=="undefined"?this.resolveOS.then(v=>this.doHasValidBasename(b,v,p)):this.doHasValidBasename(b,p,g)}doHasValidBasename(b,p,g){return b.scheme===n.Schemas.file||b.scheme===n.Schemas.vscodeRemote?(0,u.isValidBasename)(g??(0,D.basename)(b),p===1):!0}get defaultUriScheme(){return Jn.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(b,p){if(b.remoteAuthority)return n.Schemas.vscodeRemote;const g=(0,P.getVirtualWorkspaceScheme)(p.getWorkspace());if(g)return g;const v=p.getWorkspace().folders[0];if(v)return v.uri.scheme;const f=p.getWorkspace().configuration;return f?f.scheme:n.Schemas.file}userHome(b){return b?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(b=>b===1?y.win32:y.posix)}async fileURI(b){let p="";if(await this.resolveOS===1&&(b=b.replace(/\\/g,"/")),b[0]==="/"&&b[1]==="/"){const v=b.indexOf("/",2);v===-1?(p=b.substring(2),b="/"):(p=b.substring(2,v),b=b.substring(v)||"/")}return C.URI.from({scheme:n.Schemas.file,authority:p,path:b,query:"",fragment:""})}};T=Ge([$e(1,_.IRemoteAgentService),$e(2,I.IWorkbenchEnvironmentService),$e(3,L.IWorkspaceContextService)],T),e.AbstractPathService=T}),define(Ie[72],ke([1,0]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class u{constructor(D,C){this.line=D,this.character=C}isBefore(D){return!1}isBeforeOrEqual(D){return!1}isAfter(D){return!1}isAfterOrEqual(D){return!1}isEqual(D){return!1}compareTo(D){return 0}translate(D,C){return new u(0,0)}with(D){return new u(0,0)}}e.Position=u;class n{constructor(D,C,S,P){this.isEmpty=!1,this.isSingleLine=!1,this.start=new u(D,C),this.end=new u(S,P)}contains(D){return!1}isEqual(D){return!1}intersection(D){}union(D){return new n(0,0,0,0)}with(D){return new n(0,0,0,0)}}e.Range=n;var y;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})(y=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Ie[31],ke([1,0,16,36,24,30,8,4,9,12,72,18]),function(Q,e,u,n,y,A,D,C,S,P,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return L.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const _="\u27EA ",T=" characters skipped \u27EB",w=(_.length+T.length+5)*2;e.ISearchService=(0,C.createDecorator)("searchService");var b;(function(j){j[j.file=0]="file",j[j.text=1]="text"})(b=e.SearchProviderType||(e.SearchProviderType={}));var p;(function(j){j[j.File=1]="File",j[j.Text=2]="Text"})(p=e.QueryType||(e.QueryType={}));function g(j){return!!j.preview}e.resultIsMatch=g;function v(j){return!!j.resource}e.isFileMatch=v;function f(j){return!!j.message}e.isProgressMessage=f;var a;(function(j){j[j.Normal=0]="Normal",j[j.NewSearchStarted=1]="NewSearchStarted"})(a=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class m{constructor(ne){this.resource=ne,this.results=[]}}e.FileMatch=m;class o{constructor(ne,Y,le){this.ranges=Y;const ue=Array.isArray(Y)?Y:[Y];if(le&&le.matchLines===1&&d(ue)){ne=(0,D.getNLines)(ne,le.matchLines);let K="",ge=0,ye=0;const Te=Math.floor(le.charsPerLine/5),pe=[];for(const Pe of ue){const fe=Math.max(Pe.startColumn-Te,0),ve=Pe.startColumn+le.charsPerLine;if(fe>ye+Te+w){const _e=_+(fe-ye)+T;K+=_e+ne.slice(fe,ve),ge+=fe-(ye+_e.length)}else K+=ne.slice(ye,ve);pe.push(new s(0,Pe.startColumn-ge,Pe.endColumn-ge)),ye=ve}this.preview={text:K,matches:Array.isArray(this.ranges)?pe:pe[0]}}else{const K=Array.isArray(Y)?Y[0].startLineNumber:Y.startLineNumber;this.preview={text:ne,matches:(0,u.mapArrayOrNot)(Y,ge=>new r(ge.startLineNumber-K,ge.startColumn,ge.endLineNumber-K,ge.endColumn))}}}}e.TextSearchMatch=o;function d(j){const ne=j[0].startLineNumber;for(const Y of j)if(Y.startLineNumber!==ne||Y.endLineNumber!==ne)return!1;return!0}class r{constructor(ne,Y,le,ue){this.startLineNumber=ne,this.startColumn=Y,this.endLineNumber=le,this.endColumn=ue}}e.SearchRange=r;class s extends r{constructor(ne,Y,le){super(ne,Y,ne,le)}}e.OneLineRange=s;var i;(function(j){j.Default="default",j.FileNames="fileNames",j.Type="type",j.Modified="modified",j.CountDescending="countDescending",j.CountAscending="countAscending"})(i=e.SearchSortOrder||(e.SearchSortOrder={}));function t(j,ne=!0){const Y=j&&j.files&&j.files.exclude,le=ne&&j&&j.search&&j.search.exclude;if(!Y&&!le)return;if(!Y||!le)return Y||le;let ue=Object.create(null);return ue=y.mixin(ue,y.deepClone(Y)),ue=y.mixin(ue,y.deepClone(le),!0),ue}e.getExcludes=t;function c(j,ne){return j.excludePattern&&n.match(j.excludePattern,ne)?!1:j.includePattern||j.usingSearchPaths?j.includePattern&&n.match(j.includePattern,ne)?!0:j.usingSearchPaths?!!j.folderQueries&&j.folderQueries.some(Y=>{const le=Y.folder.fsPath;if(A.isEqualOrParent(ne,le)){const ue=S.relative(le,ne);return!Y.includePattern||!!n.match(Y.includePattern,ue)}else return!1}):!1:!0}e.pathIncludedInQuery=c;var l;(function(j){j[j.unknownEncoding=1]="unknownEncoding",j[j.regexParseError=2]="regexParseError",j[j.globParseError=3]="globParseError",j[j.invalidLiteral=4]="invalidLiteral",j[j.rgProcessError=5]="rgProcessError",j[j.other=6]="other",j[j.canceled=7]="canceled"})(l=e.SearchErrorCode||(e.SearchErrorCode={}));class h extends Error{constructor(ne,Y){super(ne);this.code=Y}}e.SearchError=h;function E(j){const ne=j.message;if((0,P.isCancellationError)(j))return new h(ne,l.canceled);try{const Y=JSON.parse(ne);return new h(Y.message,Y.code)}catch{return new h(ne,l.other)}}e.deserializeSearchError=E;function R(j){const ne={message:j.message,code:j.code};return new Error(JSON.stringify(ne))}e.serializeSearchError=R;function N(j){return j.type==="error"?!0:j.type==="success"}e.isSerializedSearchComplete=N;function O(j){return j.type==="success"}e.isSerializedSearchSuccess=O;function k(j){return!!j.path}e.isSerializedFileMatch=k;function U(j,ne){const Y=j.searchPath?j.searchPath:j.relativePath;return(0,D.fuzzyContains)(Y,ne)}e.isFilePatternMatch=U;class F{constructor(ne){this.path=ne,this.results=[]}addMatch(ne){this.results.push(ne)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=F;function $(j,ne){const Y={...j||{},...ne||{}};return Object.keys(Y).filter(le=>{const ue=Y[le];return typeof ue=="boolean"&&ue})}e.resolvePatternsForProvider=$;class ee{constructor(ne,Y){this._parsedIncludeExpression=null,this._excludeExpression={...ne.excludePattern||{},...Y.excludePattern||{}},this._parsedExcludeExpression=n.parse(this._excludeExpression);let le=ne.includePattern;Y.includePattern&&(le?le={...le,...Y.includePattern}:le=Y.includePattern),le&&(this._parsedIncludeExpression=n.parse(le))}matchesExcludesSync(ne,Y,le){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ne,Y,le))}includedInQuerySync(ne,Y,le){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ne,Y,le)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(ne,Y,le))}includedInQuery(ne,Y,le){const ue=this._parsedExcludeExpression(ne,Y,le),K=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(ne,Y,le):!0;return(0,I.isThenable)(ue)?ue.then(ge=>ge?!1:K()):K()}hasSiblingExcludeClauses(){return B(this._excludeExpression)}}e.QueryGlobTester=ee;function B(j){for(const ne in j)if(typeof j[ne]!="boolean")return!0;return!1}function z(j){if(!j)return;let ne;return Y=>(ne||(ne=(j()||Promise.resolve([])).then(le=>le?V(le):{})),ne.then(le=>!!le[Y]))}e.hasSiblingPromiseFn=z;function q(j){if(!j)return;let ne;return Y=>{if(!ne){const le=j();ne=le?V(le):{}}return!!ne[Y]}}e.hasSiblingFn=q;function V(j){const ne={};for(const Y of j)ne[Y]=!0;return ne}}),define(Ie[32],ke([1,0,16,18,21,3,25,11,94,22,8,10,2,177,4,14,197,45,46,26,17,15,7,31,5]),function(Q,e,u,n,y,A,D,C,S,P,L,I,_,T,w,b,p,g,v,f,a,m,o,d,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function s(N,O,k){return new P.ExtUri(U=>l(U,k)).isEqual(N,O)}function i(N,O,k){return s(N.uri,O.uri,k)?0:(0,L.compare)(N.uri.toString(),O.uri.toString())}function t(N,O,k){return N.index!==O.index?N.index<O.index?-1:1:s(N.uri,O.uri,k)?(0,L.compare)(N.name,O.name):(0,L.compare)(N.uri.toString(),O.uri.toString())}function c(N,O,k,U){const F=N.slice(0).sort((ee,B)=>k(ee,B,U)),$=O.slice(0).sort((ee,B)=>k(ee,B,U));return(0,u.delta)(F,$,(ee,B)=>k(ee,B,U))}function l(N,O){const k=O.getCapabilities(N.scheme);return!(k&&k&1024)}class h extends g.Workspace{constructor(O,k,U,F,$,ee,B){super(O,U.map(z=>new g.WorkspaceFolder(z)),F,$,B);this._name=k,this._isUntitled=ee,this._workspaceFolders=[],this._structure=D.TernarySearchTree.forUris(B),U.forEach(z=>{this._workspaceFolders.push(z),this._structure.set(z.uri,z)})}static toExtHostWorkspace(O,k,U,F){if(!O)return{workspace:null,added:[],removed:[]};const{id:$,name:ee,folders:B,configuration:z,transient:q,isUntitled:V}=O,j=[],ne=k;k?B.forEach((K,ge)=>{const ye=_.URI.revive(K.uri),Te=h._findFolder(U||k,ye,F);Te?(Te.name=K.name,Te.index=K.index,j.push(Te)):j.push({uri:ye,name:K.name,index:ge})}):j.push(...B.map(({uri:K,name:ge,index:ye})=>({uri:_.URI.revive(K),name:ge,index:ye}))),j.sort((K,ge)=>K.index<ge.index?-1:1);const Y=new h($,ee,j,!!q,z?_.URI.revive(z):null,!!V,K=>l(K,F)),{added:le,removed:ue}=c(ne?ne.workspaceFolders:[],Y.workspaceFolders,i,F);return{workspace:Y,added:le,removed:ue}}static _findFolder(O,k,U){for(let F=0;F<O.folders.length;F++){const $=O.workspaceFolders[F];if(s($.uri,k,U))return $}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(O,k){return k&&this._structure.get(O)&&(O=(0,P.dirname)(O)),this._structure.findSubstr(O)}resolveWorkspaceFolder(O){return this._structure.get(O)}}let E=class{constructor(O,k,U,F){this._onDidChangeWorkspace=new A.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new A.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=F,this._extHostFileSystemInfo=U,this._requestIdProvider=new S.Counter,this._barrier=new n.Barrier,this._proxy=O.getProxy(r.MainContext.MainThreadWorkspace),this._messageService=O.getProxy(r.MainContext.MainThreadMessageService);const $=k.workspace;this._confirmedWorkspace=$?new h($.id,$.name,[],!!$.transient,$.configuration?_.URI.revive($.configuration):null,!!$.isUntitled,ee=>l(ee,U)):void 0}$initializeWorkspace(O,k){this._trusted=k,this.$acceptWorkspaceData(O),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?_.URI.from({scheme:C.Schemas.untitled,path:(0,P.basename)((0,P.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(O,k,U,...F){const $=[];if(Array.isArray(F)&&F.forEach(V=>{_.URI.isUri(V.uri)&&!$.some(j=>s(j.uri,V.uri,this._extHostFileSystemInfo))&&$.push({uri:V.uri,name:V.name||(0,P.basenameOrAuthority)(V.uri)})}),this._unconfirmedWorkspace||[k,U].some(V=>typeof V!="number"||V<0)||U===0&&$.length===0)return!1;const ee=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(k+U>ee.length)return!1;const B=ee.slice(0);B.splice(k,U,...$.map(V=>({uri:V.uri,name:V.name||(0,P.basenameOrAuthority)(V.uri),index:void 0})));for(let V=0;V<B.length;V++){const j=B[V];if(B.some((ne,Y)=>Y!==V&&s(j.uri,ne.uri,this._extHostFileSystemInfo)))return!1}B.forEach((V,j)=>V.index=j);const{added:z,removed:q}=c(ee,B,t,this._extHostFileSystemInfo);if(z.length===0&&q.length===0)return!1;if(this._proxy){const V=O.displayName||O.name;this._proxy.$updateWorkspaceFolders(V,k,U,$).then(void 0,j=>{this._unconfirmedWorkspace=void 0;const ne={source:{identifier:O.identifier,label:O.displayName||O.name}};this._messageService.$showMessage(p.Severity.Error,(0,T.localize)(0,null,V,j.toString()),ne,[])})}return this.trySetWorkspaceFolders(B),!0}getWorkspaceFolder(O,k){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(O,k)}async getWorkspaceFolder2(O,k){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(O,k)}async resolveWorkspaceFolder(O){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(O)}getPath(){if(!this._actualWorkspace)return;const{folders:O}=this._actualWorkspace;if(O.length!==0)return O[0].uri.fsPath}getRelativePath(O,k){let U,F="";if(typeof O=="string"?(U=_.URI.file(O),F=O):typeof O!="undefined"&&(U=O,F=O.fsPath),!U)return F;const $=this.getWorkspaceFolder(U,!0);if(!$)return F;typeof k=="undefined"&&this._actualWorkspace&&(k=this._actualWorkspace.folders.length>1);let ee=(0,P.relativePath)($.uri,U);return k&&$.name&&(ee=`${$.name}/${ee}`),ee}trySetWorkspaceFolders(O){this._actualWorkspace&&(this._unconfirmedWorkspace=h.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:O,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(O){const{workspace:k,added:U,removed:F}=h.toExtHostWorkspace(O,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=k||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:U,removed:F}))}findFiles(O,k,U,F,$=y.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${F.value}, entryPoint: findFiles`);let ee;if(k===null?ee=!1:k&&(typeof k=="string"?ee=k:ee=k.pattern),$&&$.isCancellationRequested)return Promise.resolve([]);const{includePattern:B,folder:z}=R(m.GlobPattern.from(O));return this._proxy.$startFileSearch((0,I.withUndefinedAsNull)(B),(0,I.withUndefinedAsNull)(z),(0,I.withUndefinedAsNull)(ee),(0,I.withUndefinedAsNull)(U),$).then(q=>Array.isArray(q)?q.map(V=>_.URI.revive(V)):[])}async findTextInFiles(O,k,U,F,$=y.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${F.value}, entryPoint: findTextInFiles`);const ee=this._requestIdProvider.getNext(),B=typeof k.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:k.previewOptions,{includePattern:z,folder:q}=R(m.GlobPattern.from(k.include)),V=typeof k.exclude=="string"?k.exclude:k.exclude?k.exclude.pattern:void 0,j={ignoreSymlinks:typeof k.followSymlinks=="boolean"?!k.followSymlinks:void 0,disregardIgnoreFiles:typeof k.useIgnoreFiles=="boolean"?!k.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof k.useGlobalIgnoreFiles=="boolean"?!k.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof k.useParentIgnoreFiles=="boolean"?!k.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof k.useDefaultExcludes=="boolean"?!k.useDefaultExcludes:!0,fileEncoding:k.encoding,maxResults:k.maxResults,previewOptions:B,afterContext:k.afterContext,beforeContext:k.beforeContext,includePattern:z,excludePattern:V},ne=!1;if(this._activeSearchCallbacks[ee]=Y=>{if(ne)return;const le=_.URI.revive(Y.resource);Y.results.forEach(ue=>{(0,d.resultIsMatch)(ue)?U({uri:le,preview:{text:ue.preview.text,matches:(0,u.mapArrayOrNot)(ue.preview.matches,K=>new o.Range(K.startLineNumber,K.startColumn,K.endLineNumber,K.endColumn))},ranges:(0,u.mapArrayOrNot)(ue.ranges,K=>new o.Range(K.startLineNumber,K.startColumn,K.endLineNumber,K.endColumn))}):U({uri:le,text:ue.text,lineNumber:ue.lineNumber})})},$.isCancellationRequested)return{};try{const Y=await this._proxy.$startTextSearch(O,(0,I.withUndefinedAsNull)(q),j,ee,$);return delete this._activeSearchCallbacks[ee],Y||{}}catch(Y){throw delete this._activeSearchCallbacks[ee],Y}}$handleTextSearchResult(O,k){this._activeSearchCallbacks[k]?.(O)}saveAll(O){return this._proxy.$saveAll(O)}resolveProxy(O){return this._proxy.$resolveProxy(O)}get trusted(){return this._trusted}requestWorkspaceTrust(O){return this._proxy.$requestWorkspaceTrust(O)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};E=Ge([$e(0,a.IExtHostRpcService),$e(1,f.IExtHostInitDataService),$e(2,v.IExtHostFileSystemInfo),$e(3,b.ILogService)],E),e.ExtHostWorkspace=E,e.IExtHostWorkspace=(0,w.createDecorator)("IExtHostWorkspace");function R(N){let O,k;return N&&(typeof N=="string"?O=N:(O=N.pattern,k=_.URI.revive(N.baseUri))),{includePattern:O,folder:k}}}),define(Ie[33],ke([1,0,24,3,32,5,7,200,120,10,18,4,17,14,2]),function(Q,e,u,n,y,A,D,C,S,P,L,I,_,T,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function b(d,r){if(r){const s=r.split(".");let i=d;for(let t=0;i&&t<s.length;t++)i=i[s[t]];return i}}function p(d){return d instanceof w.URI}function g(d){return d&&d.uri instanceof w.URI&&d.languageId&&typeof d.languageId=="string"}function v(d){return d&&!d.uri&&d.languageId&&typeof d.languageId=="string"}function f(d){return d&&d.uri instanceof w.URI&&(!d.name||typeof d.name=="string")&&(!d.index||typeof d.index=="number")}function a(d){if(p(d))return{resource:d};if(g(d))return{resource:d.uri,overrideIdentifier:d.languageId};if(v(d))return{overrideIdentifier:d.languageId};if(f(d))return{resource:d.uri};if(d===null)return{resource:null}}let m=class{constructor(r,s,i){this._proxy=r.getProxy(A.MainContext.MainThreadConfiguration),this._extHostWorkspace=s,this._logService=i,this._barrier=new L.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new o(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,s){this.getConfigProvider().then(i=>i.$acceptConfigurationChanged(r,s))}};m=Ge([$e(0,_.IExtHostRpcService),$e(1,y.IExtHostWorkspace),$e(2,T.ILogService)],m),e.ExtHostConfiguration=m;class o{constructor(r,s,i,t){this._onDidChangeConfiguration=new n.Emitter,this._proxy=r,this._logService=t,this._extHostWorkspace=s,this._configuration=C.Configuration.parse(i),this._configurationScopes=this._toMap(i.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,s){const i={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=C.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(s,i))}getConfiguration(r,s,i){const t=a(s)||{},c=this._toReadonlyValue(r?b(this._configuration.getValue(void 0,t,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,t,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,t,i?.identifier);function l(E){if(E==null)return null;if(typeof E=="boolean")return E?1:4;switch(E){case D.ConfigurationTarget.Global:return 1;case D.ConfigurationTarget.Workspace:return 4;case D.ConfigurationTarget.WorkspaceFolder:return 5}}const h={has(E){return typeof b(c,E)!="undefined"},get:(E,R)=>{this._validateConfigurationAccess(r?`${r}.${E}`:E,t,i?.identifier);let N=b(c,E);if(typeof N=="undefined")N=R;else{let O;const k=(U,F)=>{let $;const ee=()=>{O=O||(0,u.deepClone)(c),$=$||b(O,F)};return(0,P.isObject)(U)?new Proxy(U,{get:(B,z)=>{if(typeof z=="string"&&z.toLowerCase()==="tojson")return ee(),()=>$;if(O)return $=$||b(O,F),$[z];const q=B[z];return typeof z=="string"?k(q,`${F}.${z}`):q},set:(B,z,q)=>(ee(),$&&($[z]=q),!0),deleteProperty:(B,z)=>(ee(),$&&delete $[z],!0),defineProperty:(B,z,q)=>(ee(),$&&Object.defineProperty($,z,q),!0)}):U};N=k(N,E)}return N},update:(E,R,N,O)=>{E=r?`${r}.${E}`:E;const k=l(N);return R!==void 0?this._proxy.$updateConfigurationOption(k,E,R,t,O):this._proxy.$removeConfigurationOption(k,E,t,O)},inspect:E=>{E=r?`${r}.${E}`:E;const R=(0,u.deepClone)(this._configuration.inspect(E,t,this._extHostWorkspace.workspace));if(R)return{key:E,defaultValue:R.policy?.value??R.default?.value,globalValue:R.user?.value??R.application?.value,workspaceValue:R.workspace?.value,workspaceFolderValue:R.workspaceFolder?.value,defaultLanguageValue:R.default?.override,globalLanguageValue:R.user?.override??R.application?.override,workspaceLanguageValue:R.workspace?.override,workspaceFolderLanguageValue:R.workspaceFolder?.override,languageIds:R.overrideIdentifiers}}};return typeof c=="object"&&(0,u.mixin)(h,c,!1),Object.freeze(h)}_toReadonlyValue(r){const s=i=>(0,P.isObject)(i)?new Proxy(i,{get:(t,c)=>s(t[c]),set:(t,c,l)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(c)}' of object`)},deleteProperty:(t,c)=>{throw new Error(`TypeError: Cannot delete read only property '${String(c)}' of object`)},defineProperty:(t,c)=>{throw new Error(`TypeError: Cannot define property '${String(c)}' for a readonly object`)},setPrototypeOf:t=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):i;return s(r)}_validateConfigurationAccess(r,s,i){const t=S.OVERRIDE_PROPERTY_REGEX.test(r)?4:this._configurationScopes.get(r),c=i?`[${i.value}] `:"";if(t===4){typeof s?.resource=="undefined"&&this._logService.warn(`${c}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(t===3){s?.resource&&this._logService.warn(`${c}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,s){const i=new C.ConfigurationChangeEvent(r,s,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(t,c)=>i.affectsConfiguration(t,a(c))})}_toMap(r){return r.reduce((s,i)=>(s.set(i[0],i[1]),s),new Map)}}e.ExtHostConfigProvider=o,e.IExtHostConfiguration=(0,I.createDecorator)("IExtHostConfiguration")});var tt=this&&this.__classPrivateFieldSet||function(Q,e,u,n,y){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!y:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?y.call(Q,u):y?y.value=u:e.set(Q,u),u},Me=this&&this.__classPrivateFieldGet||function(Q,e,u,n){if(u==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!n:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?n:u==="a"?n.call(Q):n?n.value:e.get(Q)};define(Ie[73],ke([1,0,2,18,3,5,7,32,54,33,21,38,17,26,4,11,13,14,68,234,12]),function(Q,e,u,n,y,A,D,C,S,P,L,I,_,T,w,b,p,g,v,f,a){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var o;(function(F){function $(B){if(B!=null)return B}F.from=$;function ee(B){if(B!=null)return B}F.to=ee})(o=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var d;(function(F){function $(B){if(B!=null)return B}F.from=$;function ee(B){if(B!=null)return B}F.to=ee})(d=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var r;(function(F){function $(B){if(B!=null)return B}F.from=$;function ee(B){if(B!=null)return B}F.to=ee})(r=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var s;(function(F){function $(z){if(z){const q=z;return q&&!!q.process}else return!1}F.is=$;function ee(z){if(z==null)return;const q={process:z.process,args:z.args};return z.options&&(q.options=r.from(z.options)),q}F.from=ee;function B(z){if(z!=null)return new D.ProcessExecution(z.process,z.args,z.options)}F.to=B})(s=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var i;(function(F){function $(B){if(B!=null)return B}F.from=$;function ee(B){if(B!=null)return B}F.to=ee})(i=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var t;(function(F){function $(z){if(z){const q=z;return q&&(!!q.commandLine||!!q.command)}else return!1}F.is=$;function ee(z){if(z==null)return;const q={};return z.commandLine!==void 0?q.commandLine=z.commandLine:(q.command=z.command,q.args=z.args),z.options&&(q.options=i.from(z.options)),q}F.from=ee;function B(z){if(!(z==null||z.command===void 0&&z.commandLine===void 0))return z.commandLine?new D.ShellExecution(z.commandLine,z.options):new D.ShellExecution(z.command,z.args?z.args:[],z.options)}F.to=B})(t=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var c;(function(F){function $(z){if(z){const q=z;return q&&q.customExecution==="customExecution"}else return!1}F.is=$;function ee(z){return{customExecution:"customExecution"}}F.from=ee;function B(z,q){return q.get(z)}F.to=B})(c=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var l;(function(F){function $(ee,B){let z;return ee.scope!==void 0&&typeof ee.scope!="number"?z=ee.scope.uri:ee.scope!==void 0&&typeof ee.scope=="number"&&(ee.scope===D.TaskScope.Workspace&&B&&B.workspaceFile?z=B.workspaceFile:z=f.USER_TASKS_GROUP_KEY),{id:ee._id,workspaceFolder:z}}F.from=$})(l=e.TaskHandleDTO||(e.TaskHandleDTO={}));var h;(function(F){function $(ee){if(ee!=null)return{_id:ee.id,isDefault:ee.isDefault}}F.from=$})(h=e.TaskGroupDTO||(e.TaskGroupDTO={}));var E;(function(F){function $(z,q){if(z==null)return[];const V=[];for(const j of z){const ne=ee(j,q);ne&&V.push(ne)}return V}F.fromMany=$;function ee(z,q){if(z==null)return;let V;z.execution instanceof D.ProcessExecution?V=s.from(z.execution):z.execution instanceof D.ShellExecution?V=t.from(z.execution):z.execution&&z.execution instanceof D.CustomExecution&&(V=c.from(z.execution));const j=o.from(z.definition);let ne;return z.scope?typeof z.scope=="number"?ne=z.scope:ne=z.scope.uri:ne=D.TaskScope.Workspace,!j||!ne?void 0:{_id:z._id,definition:j,name:z.name,source:{extensionId:q.identifier.value,label:z.source,scope:ne},execution:V,isBackground:z.isBackground,group:h.from(z.group),presentationOptions:d.from(z.presentationOptions),problemMatchers:z.problemMatchers,hasDefinedMatchers:z.hasDefinedMatchers,runOptions:z.runOptions?z.runOptions:{reevaluateOnRerun:!0},detail:z.detail}}F.from=ee;async function B(z,q,V){if(z==null)return;let j;s.is(z.execution)?j=s.to(z.execution):t.is(z.execution)?j=t.to(z.execution):c.is(z.execution)&&(j=c.to(z._id,V));const ne=o.to(z.definition);let Y;if(z.source&&(z.source.scope!==void 0?typeof z.source.scope=="number"?Y=z.source.scope:Y=await q.resolveWorkspaceFolder(u.URI.revive(z.source.scope)):Y=D.TaskScope.Workspace),!ne||!Y)return;const le=new D.Task(ne,Y,z.name,z.source.label,j,z.problemMatchers);return z.isBackground!==void 0&&(le.isBackground=z.isBackground),z.group!==void 0&&(le.group=D.TaskGroup.from(z.group._id),le.group&&z.group.isDefault&&(le.group=new D.TaskGroup(le.group.id,le.group.label),z.group.isDefault===!0&&(le.group.isDefault=z.group.isDefault))),z.presentationOptions&&(le.presentationOptions=d.to(z.presentationOptions)),z._id&&(le._id=z._id),z.detail&&(le.detail=z.detail),le}F.to=B})(E=e.TaskDTO||(e.TaskDTO={}));var R;(function(F){function $(B){return B}F.from=$;function ee(B){if(!!B)return Object.assign(Object.create(null),B)}F.to=ee})(R=e.TaskFilterDTO||(e.TaskFilterDTO={}));class N{constructor($,ee,B){this._id=ee,this._task=B,m.set(this,void 0),tt(this,m,$,"f")}get task(){return this._task}terminate(){Me(this,m,"f").terminateTask(this)}fireDidStartProcess($){}fireDidEndProcess($){}}m=new WeakMap;var O;(function(F){function $(ee){return{id:ee._id,task:void 0}}F.from=$})(O=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let k=class{constructor($,ee,B,z,q,V,j,ne){this._onDidExecuteTask=new y.Emitter,this._onDidTerminateTask=new y.Emitter,this._onDidTaskProcessStarted=new y.Emitter,this._onDidTaskProcessEnded=new y.Emitter,this._proxy=$.getProxy(A.MainContext.MainThreadTask),this._workspaceProvider=B,this._editorService=z,this._configurationService=q,this._terminalService=V,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=j,this._deprecationService=ne,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider($,ee,B){if(!B)return new D.Disposable(()=>{});const z=this.nextHandle();return this._handlers.set(z,{type:ee,provider:B,extension:$}),this._proxy.$registerTaskProvider(z,ee),new D.Disposable(()=>{this._handlers.delete(z),this._proxy.$unregisterTaskProvider(z)})}registerTaskSystem($,ee){this._proxy.$registerTaskSystem($,ee)}fetchTasks($){return this._proxy.$fetchTasks(R.from($)).then(async ee=>{const B=[];for(const z of ee){const q=await E.to(z,this._workspaceProvider,this._providedCustomExecutions2);q&&B.push(q)}return B})}get taskExecutions(){const $=[];return this._taskExecutions.forEach(ee=>$.push(ee)),$}terminateTask($){if(!($ instanceof N))throw new Error("No valid task execution provided");return this._proxy.$terminateTask($._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask($,ee,B){const z=this._providedCustomExecutions2.get($.id);z&&(this._activeCustomExecutions2.set($.id,z),this._terminalService.attachPtyToTerminal(ee,await z.callback(B))),this._lastStartedTask=$.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution($)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask($){const ee=await this.getTaskExecution($);this._taskExecutionPromises.delete($.id),this._taskExecutions.delete($.id),this.customExecutionComplete($),this._onDidTerminateTask.fire({execution:ee})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess($){const ee=await this.getTaskExecution($.id);this._onDidTaskProcessStarted.fire({execution:ee,processId:$.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess($){const ee=await this.getTaskExecution($.id);this._onDidTaskProcessEnded.fire({execution:ee,exitCode:$.exitCode})}$provideTasks($,ee){const B=this._handlers.get($);if(!B)return Promise.reject(new Error("no handler found"));const z=[],q=(0,n.asPromise)(()=>B.provider.provideTasks(L.CancellationToken.None)).then(V=>this.provideTasksInternal(ee,z,B,V));return new Promise(V=>{q.then(j=>{Promise.all(z).then(()=>{V(j)})})})}async $resolveTask($,ee){const B=this._handlers.get($);if(!B)return Promise.reject(new Error("no handler found"));if(ee.definition.type!==B.type)throw new Error(`Unexpected: Task of type [${ee.definition.type}] cannot be resolved by provider of type [${B.type}].`);const z=await E.to(ee,this._workspaceProvider,this._providedCustomExecutions2);if(!z)throw new Error("Unexpected: Task cannot be resolved.");const q=await B.provider.resolveTask(z,L.CancellationToken.None);if(!q)return;this.checkDeprecation(q,B);const V=E.from(q,B.extension);if(!V)throw new Error("Unexpected: Task cannot be resolved.");if(q.definition!==z.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return c.is(V.execution)&&await this.addCustomExecution(V,q,!0),await this.resolveTaskInternal(V)}nextHandle(){return this._handleCounter++}async addCustomExecution($,ee,B){const z=await this._proxy.$createTaskId($);!B&&!this._providedCustomExecutions2.has(z)&&(this._notProvidedCustomExecutions.add(z),this._activeCustomExecutions2.set(z,ee.execution)),this._providedCustomExecutions2.set(z,ee.execution)}async getTaskExecution($,ee){if(typeof $=="string"){const q=this._taskExecutionPromises.get($);if(!q)throw new Error("Unexpected: The specified task is missing an execution");return q}const B=this._taskExecutionPromises.get($.id);if(B)return B;const z=new Promise((q,V)=>{function j(ne,Y,le){le?q(new N(ne,Y.id,le)):V("Unexpected: Task does not exist.")}ee?j(this,$,ee):E.to($.task,this._workspaceProvider,this._providedCustomExecutions2).then(ne=>j(this,$,ne))});return this._taskExecutionPromises.set($.id,z),z.then(q=>(this._taskExecutions.set($.id,q),q),q=>Promise.reject(q))}checkDeprecation($,ee){$._deprecated&&this._deprecationService.report("Task.constructor",ee.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete($){this._activeCustomExecutions2.get($.id)&&this._activeCustomExecutions2.delete($.id),this._notProvidedCustomExecutions.has($.id)&&this._lastStartedTask!==$.id&&(this._providedCustomExecutions2.delete($.id),this._notProvidedCustomExecutions.delete($.id));const B=this._notProvidedCustomExecutions.values();let z=B.next();for(;!z.done;)!this._activeCustomExecutions2.has(z.value)&&this._lastStartedTask!==z.value&&(this._providedCustomExecutions2.delete(z.value),this._notProvidedCustomExecutions.delete(z.value)),z=B.next()}};k=Ge([$e(0,_.IExtHostRpcService),$e(1,T.IExtHostInitDataService),$e(2,C.IExtHostWorkspace),$e(3,S.IExtHostDocumentsAndEditors),$e(4,P.IExtHostConfiguration),$e(5,I.IExtHostTerminalService),$e(6,g.ILogService),$e(7,v.IExtHostApiDeprecationService)],k),e.ExtHostTaskBase=k;let U=class extends k{constructor($,ee,B,z,q,V,j,ne){super($,ee,B,z,q,V,j,ne);this.registerTaskSystem(b.Schemas.vscodeRemote,{scheme:b.Schemas.vscodeRemote,authority:"",platform:p.PlatformToString(0)})}async executeTask($,ee){if(!ee.execution)throw new Error("Tasks to execute must include an execution");const B=E.from(ee,$);if(B===void 0)throw new Error("Task is not valid");if(c.is(B.execution))await this.addCustomExecution(B,ee,!1);else throw new a.NotSupportedError;const z=await this.getTaskExecution(await this._proxy.$getTaskExecution(B),ee);return this._proxy.$executeTask(B).catch(q=>{throw new Error(q)}),z}provideTasksInternal($,ee,B,z){const q=[];if(z)for(const V of z){this.checkDeprecation(V,B),(!V.definition||!$[V.definition.type])&&this._logService.warn(`The task [${V.source}, ${V.name}] uses an undefined task type. The task will be ignored in the future.`);const j=E.from(V,B.extension);j&&c.is(j.execution)?(q.push(j),ee.push(this.addCustomExecution(j,V,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:q,extension:B.extension}}async resolveTaskInternal($){if(c.is($.execution))return $;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables($,ee){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable($,ee,B){}};U=Ge([$e(0,_.IExtHostRpcService),$e(1,T.IExtHostInitDataService),$e(2,C.IExtHostWorkspace),$e(3,S.IExtHostDocumentsAndEditors),$e(4,P.IExtHostConfiguration),$e(5,I.IExtHostTerminalService),$e(6,g.ILogService),$e(7,v.IExtHostApiDeprecationService)],U),e.WorkerExtHostTask=U,e.IExtHostTask=(0,w.createDecorator)("IExtHostTask")}),define(Ie[277],ke([1,0,9,21,49,36,22,50,31]),function(Q,e,u,n,y,A,D,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class P{constructor(_,T,w){this.config=_,this.provider=T,this.sessionToken=w,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=_.filePattern,this.includePattern=_.includePattern&&A.parse(_.includePattern),this.maxResults=_.maxResults||void 0,this.exists=_.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=_.excludePattern&&A.parse(_.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(_=>_.cancel()),this.activeCancellationTokens=new Set}search(_){const T=this.config.folderQueries||[];return new Promise((w,b)=>{const p=g=>{this.resultCount++,_(g)};if(this.isCanceled)return w({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(g=>{const v=g.toString(),f=u.basename(v);this.globalExcludePattern&&this.globalExcludePattern(v,f)||this.matchFile(p,{base:g,basename:f})}),Promise.all(T.map(g=>this.searchInFolder(g,p))).then(g=>{w({limitHit:this.isLimitHit,stats:g[0]||void 0})},g=>{b(new Error((0,y.toErrorMessage)(g)))})})}async searchInFolder(_,T){const w=new n.CancellationTokenSource,b=this.getSearchOptionsForFolder(_),p=this.initDirectoryTree(),g=new S.QueryGlobTester(this.config,_),v=!g.hasSiblingExcludeClauses();let f;try{this.activeCancellationTokens.add(w),f=C.StopWatch.create();const a=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},b,w.token),m=f.elapsed(),o=C.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(a&&a.forEach(d=>{const r=u.posix.relative(_.folder.path,d.path);if(v){const s=u.basename(d.path);this.matchFile(T,{base:_.folder,relativePath:r,basename:s});return}this.addDirectoryEntries(p,_.folder,r,T)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(p,g,T),{providerTime:m,postProcessTime:o.elapsed()})}finally{w.dispose(),this.activeCancellationTokens.delete(w)}}getSearchOptionsForFolder(_){const T=(0,S.resolvePatternsForProvider)(this.config.includePattern,_.includePattern),w=(0,S.resolvePatternsForProvider)(this.config.excludePattern,_.excludePattern);return{folder:_.folder,excludes:w,includes:T,useIgnoreFiles:!_.disregardIgnoreFiles,useGlobalIgnoreFiles:!_.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!_.disregardParentIgnoreFiles,followSymlinks:!_.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const _={rootEntries:[],pathToEntries:Object.create(null)};return _.pathToEntries["."]=_.rootEntries,_}addDirectoryEntries({pathToEntries:_},T,w,b){if(w===this.filePattern){const g=u.basename(this.filePattern);this.matchFile(b,{base:T,relativePath:this.filePattern,basename:g})}function p(g){const v=u.basename(g),f=u.dirname(g);let a=_[f];a||(a=_[f]=[],p(f)),a.push({base:T,relativePath:g,basename:v})}p(w)}matchDirectoryTree({rootEntries:_,pathToEntries:T},w,b){const p=this,g=this.filePattern;function v(f){const a=(0,S.hasSiblingFn)(()=>f.map(m=>m.basename));for(let m=0,o=f.length;m<o;m++){const d=f[m],{relativePath:r,basename:s}=d;if(w.matchesExcludesSync(r,s,g!==s?a:void 0))continue;const i=T[r];if(i)v(i);else{if(r===g)continue;p.matchFile(b,d)}if(p.isLimitHit)break}}v(_)}matchFile(_,T){(!this.includePattern||T.relativePath&&this.includePattern(T.relativePath,T.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||_(T))}}class L{constructor(){this.sessions=new Map}fileSearch(_,T,w,b){const p=this.getSessionTokenSource(_.cacheKey),g=new P(_,T,p&&p.token);let v=0;const f=a=>{v+=a.length,w(a.map(m=>this.rawMatchToSearchItem(m)))};return this.doSearch(g,L.BATCH_SIZE,f,b).then(a=>({limitHit:a.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:v,detailStats:a.stats}}))}clearCache(_){const T=this.getSessionTokenSource(_);T&&T.cancel()}getSessionTokenSource(_){if(!!_)return this.sessions.has(_)||this.sessions.set(_,new n.CancellationTokenSource),this.sessions.get(_)}rawMatchToSearchItem(_){return _.relativePath?{resource:D.joinPath(_.base,_.relativePath)}:{resource:_.base}}doSearch(_,T,w,b){b.onCancellationRequested(()=>{_.cancel()});const p=v=>{v&&(g.push(v),T>0&&g.length>=T&&(w(g),g=[]))};let g=[];return _.search(p).then(v=>(g.length&&w(g),v),v=>(g.length&&w(g),Promise.reject(v)))}}e.FileSearchManager=L,L.BATCH_SIZE=512}),define(Ie[278],ke([1,0,16,78,36,107,25,11,9,22,8,10,2,160,188,83,14,45,130,276,31]),function(Q,e,u,n,y,A,D,C,S,P,L,I,_,T,w,b,p,g,v,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let m=class{constructor(h,E,R,N,O){this.configurationService=h,this.workspaceContextService=E,this.editorGroupsService=R,this.logService=N,this.pathService=O}text(h,E,R={}){h=this.getContentPattern(h,R);const N=this.configurationService.getValue(),O=E&&E.some(U=>!this.configurationService.getValue({resource:U}).search.useRipgrep);return{...this.commonQuery(E?.map(g.toWorkspaceFolder),R),type:2,contentPattern:h,previewOptions:R.previewOptions,maxFileSize:R.maxFileSize,usePCRE2:N.search.usePCRE2||O||!1,beforeContext:R.beforeContext,afterContext:R.afterContext,userDisabledExcludesAndIgnoreFiles:R.disregardExcludeSettings&&R.disregardIgnoreFiles}}getContentPattern(h,E){const R=this.configurationService.getValue();h.isRegExp&&(h.pattern=h.pattern.replace(/\r?\n/g,"\\n"));const N={...h,wordSeparators:R.editor.wordSeparators};return this.isCaseSensitive(h,E)&&(N.isCaseSensitive=!0),this.isMultiline(h)&&(N.isMultiline=!0),N}file(h,E={}){return{...this.commonQuery(h,E),type:1,filePattern:E.filePattern?E.filePattern.trim():E.filePattern,exists:E.exists,sortByScore:E.sortByScore,cacheKey:E.cacheKey}}handleIncludeExclude(h,E){return h?(h=Array.isArray(h)?h.map(i):i(h),E?this.parseSearchPaths(h):{pattern:d(...Array.isArray(h)?h:[h])}):{}}commonQuery(h=[],E={}){const R=this.handleIncludeExclude(E.includePattern,E.expandPatterns),N=this.handleIncludeExclude(E.excludePattern,E.expandPatterns),O=h.length>1,k=(R.searchPaths&&R.searchPaths.length?R.searchPaths.map($=>this.getFolderQueryForSearchPath($,E,N)):h.map($=>this.getFolderQueryForRoot($,E,N,O))).filter($=>!!$),U={_reason:E._reason,folderQueries:k,usingSearchPaths:!!(R.searchPaths&&R.searchPaths.length),extraFileResources:E.extraFileResources,excludePattern:N.pattern,includePattern:R.pattern,onlyOpenEditors:E.onlyOpenEditors,maxResults:E.maxResults};if(E.onlyOpenEditors){const $=u.coalesce(u.flatten(this.editorGroupsService.groups.map(z=>z.editors.map(q=>q.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify($));const ee=$.filter(z=>(0,a.pathIncludedInQuery)(U,z.fsPath)),B=this.commonQueryFromFileList(ee);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(B)),{...U,...B}}const F=E.extraFileResources&&E.extraFileResources.filter($=>(0,a.pathIncludedInQuery)(U,$.fsPath));return U.extraFileResources=F&&F.length?F:void 0,U}commonQueryFromFileList(h){const E=[],R=new D.ResourceMap,N={};let O=!1;return h.forEach(k=>{if(k.scheme===C.Schemas.walkThrough)return;if((0,P.isAbsolutePath)(k)){const F=this.workspaceContextService.getWorkspaceFolder(k)?.uri??k.with({path:S.dirname(k.fsPath)});let $=R.get(F);$||(O=!0,$={folder:F,includePattern:{}},E.push($),R.set(F,$));const ee=S.relative(F.fsPath,k.fsPath);(0,I.assertIsDefined)($.includePattern)[ee.replace(/\\/g,"/")]=!0}else k.fsPath&&(O=!0,N[k.fsPath]=!0)}),{folderQueries:E,includePattern:N,usingSearchPaths:!0,excludePattern:O?void 0:{"**/*":!0}}}isCaseSensitive(h,E){if(E.isSmartCase){if(h.isRegExp){if(L.containsUppercaseCharacter(h.pattern,!0))return!0}else if(L.containsUppercaseCharacter(h.pattern))return!0}return!!h.isCaseSensitive}isMultiline(h){return h.isMultiline||h.isRegExp&&(0,T.isMultilineRegexSource)(h.pattern)||h.pattern.indexOf(`
`)>=0?!0:!!h.isMultiline}parseSearchPaths(h){const E=B=>S.isAbsolute(B)||/^\.\.?([\/\\]|$)/.test(B),N=(Array.isArray(h)?h:r(h)).map(B=>{const z=this.pathService.resolvedUserHome;return z?(0,A.untildify)(B,z.scheme===C.Schemas.file?z.fsPath:z.path):B}),O=n.groupBy(N,B=>E(B)?"searchPaths":"exprSegments"),k=(O.exprSegments||[]).map(B=>L.rtrim(B,"/")).map(B=>L.rtrim(B,"\\")).map(B=>(B[0]==="."&&(B="*"+B),s(B))),U={},F=this.expandSearchPathPatterns(O.searchPaths||[]);F&&F.length&&(U.searchPaths=F);const $=u.flatten(k),ee=d(...$);return ee&&(U.pattern=ee),U}getExcludesForFolder(h,E){return E.disregardExcludeSettings?void 0:(0,a.getExcludes)(h,!E.disregardSearchExcludeSettings)}expandSearchPathPatterns(h){if(!h||!h.length)return[];const E=u.flatten(h.map(N=>{let{pathPortion:O,globPortion:k}=o(N);k&&(k=t(k));const U=this.expandOneSearchPath(O);return u.flatten(U.map(F=>this.resolveOneSearchPathPattern(F,k)))})),R=new Map;return E.forEach(N=>{const O=N.searchPath.toString(),k=R.get(O);k?N.pattern&&(k.pattern=k.pattern||{},k.pattern[N.pattern]=!0):R.set(O,{searchPath:N.searchPath,pattern:N.pattern?d(N.pattern):void 0})}),Array.from(R.values())}expandOneSearchPath(h){if(S.isAbsolute(h)){const E=this.workspaceContextService.getWorkspace().folders;return E[0]&&E[0].uri.scheme!==C.Schemas.file?[{searchPath:E[0].uri.with({path:h})}]:[{searchPath:_.URI.file(S.normalize(h))}]}if(this.workspaceContextService.getWorkbenchState()===2){const E=this.workspaceContextService.getWorkspace().folders[0].uri;if(h=i(h),h.startsWith("../")||h===".."){const N=S.posix.resolve(E.path,h);return[{searchPath:E.with({path:N})}]}const R=t(h);return[{searchPath:E,pattern:R}]}else{if(h==="./"||h===".\\")return[];{const E=h.replace(/^\.[\/\\]/,""),N=this.workspaceContextService.getWorkspace().folders.map(O=>{const k=E.match(new RegExp(`^${L.escapeRegExpCharacters(O.name)}(?:/(.*)|$)`));return k?{match:k,folder:O}:null}).filter(I.isDefined);if(N.length)return N.map(O=>{const k=O.match[1];return{searchPath:O.folder.uri,pattern:k&&t(k)}});{const O=h.match(/\.[\/\\](.+)[\/\\]?/),k=O?O[1]:h,U=w.localize(0,null,k);throw new Error(U)}}}}resolveOneSearchPathPattern(h,E){const R=h.pattern&&E?`${h.pattern}/${E}`:h.pattern||E,N=[{searchPath:h.searchPath,pattern:R}];return R&&!R.endsWith("**")&&N.push({searchPath:h.searchPath,pattern:R+"/**"}),N}getFolderQueryForSearchPath(h,E,R){const N=this.getFolderQueryForRoot((0,g.toWorkspaceFolder)(h.searchPath),E,R,!1);return N?{...N,includePattern:h.pattern}:null}getFolderQueryForRoot(h,E,R,N){let O;const k=_.URI.isUri(h)?h:h.uri;if(R.searchPaths){const B=R.searchPaths.filter(z=>(0,P.isEqual)(z.searchPath,k))[0];if(B&&!B.pattern)return null;B&&(O=B.pattern)}const U=this.configurationService.getValue({resource:k}),$={...this.getExcludesForFolder(U,E)||{},...O||{}},ee=_.URI.isUri(h)?(0,P.basename)(h):h.name;return{folder:k,folderName:N?ee:void 0,excludePattern:Object.keys($).length>0?$:void 0,fileEncoding:U.files&&U.files.encoding,disregardIgnoreFiles:typeof E.disregardIgnoreFiles=="boolean"?E.disregardIgnoreFiles:!U.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof E.disregardGlobalIgnoreFiles=="boolean"?E.disregardGlobalIgnoreFiles:!U.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof E.disregardParentIgnoreFiles=="boolean"?E.disregardParentIgnoreFiles:!U.search.useParentIgnoreFiles,ignoreSymlinks:typeof E.ignoreSymlinks=="boolean"?E.ignoreSymlinks:!U.search.followSymlinks}}};m=Ge([$e(0,b.IConfigurationService),$e(1,g.IWorkspaceContextService),$e(2,v.IEditorGroupsService),$e(3,p.ILogService),$e(4,f.IPathService)],m),e.QueryBuilder=m;function o(l){const h=l.match(/[\*\{\}\(\)\[\]\?]/);if(h){const E=h.index,R=l.substr(0,E).match(/[/|\\][^/\\]*$/);if(R){let N=l.substr(0,R.index);return N.match(/[/\\]/)||(N+="/"),{pathPortion:N,globPortion:l.substr((R.index||0)+1)}}}return{pathPortion:l}}function d(...l){return l.length?l.reduce((h,E)=>(h[E]=!0,h),Object.create(null)):void 0}function r(l){return y.splitGlobAware(l,",").map(h=>h.trim()).filter(h=>!!h.length)}function s(l){return[`**/${l}/**`,`**/${l}`].map(E=>E.replace(/\*\*\/\*\*/g,"**"))}function i(l){return l.replace(/\\/g,"/")}function t(l){return i(l).replace(/^\.\//,"").replace(/\/+$/g,"")}function c(l,h){l=u.distinct(l,N=>N.toString());const E=[],R=h.getWorkspace();return l&&l.forEach(N=>{let O;if(h.getWorkbenchState()===2)O=(0,P.relativePath)(R.folders[0].uri,N),O&&O!=="."&&(O="./"+O);else{const k=h.getWorkspaceFolder(N);if(k){const U=k.name;if(R.folders.filter($=>$.name===U).length===1){const $=(0,P.relativePath)(k.uri,N);$===""?O=`./${k.name}`:O=`./${k.name}/${$}`}else O=N.fsPath}}O&&E.push(O)}),E}e.resolveResourcesForSearchIncludes=c}),define(Ie[279],ke([1,0,22,2,21,12,4,278,31,45]),function(Q,e,u,n,y,A,D,C,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const L=7e3;function I(b,p){const g=p.activationEvents;if(!g)return Promise.resolve(void 0);const v=[],f=[];for(const s of g)if(/^workspaceContains:/.test(s)){const i=s.substr("workspaceContains:".length);i.indexOf("*")>=0||i.indexOf("?")>=0||b.forceUsingSearch?f.push(i):v.push(i)}if(v.length===0&&f.length===0)return Promise.resolve(void 0);let a;const m=new Promise((s,i)=>{a=s}),o=s=>a({activationEvent:s}),d=Promise.all(v.map(s=>_(b,s,o))).then(()=>{}),r=T(b,p.identifier,f,o);return Promise.all([d,r]).then(()=>{a(void 0)}),m}e.checkActivateWorkspaceContainsExtension=I;async function _(b,p,g){for(const v of b.folders)if(await b.exists(u.joinPath(n.URI.revive(v),p))){g(`workspaceContains:${p}`);return}}async function T(b,p,g,v){if(g.length===0)return Promise.resolve(void 0);const f=new y.CancellationTokenSource,a=b.checkExists(b.folders,g,f.token),m=setTimeout(async()=>{f.cancel(),b.logService.info(`Not activating extension '${p.value}': Timed out while searching for 'workspaceContains' pattern ${g.join(",")}`)},L);let o=!1;try{o=await a}catch(d){A.isCancellationError(d)||A.onUnexpectedError(d)}f.dispose(),clearTimeout(m),o&&v(`workspaceContains:${g.join(",")}`)}function w(b,p,g,v){const f=b.get(D.IInstantiationService),a=b.get(S.ISearchService),o=f.createInstance(C.QueryBuilder).file(p.map(d=>(0,P.toWorkspaceFolder)(n.URI.revive(d))),{_reason:"checkExists",includePattern:g,exists:!0});return a.fileSearch(o,v).then(d=>!!d.limitHit,d=>A.isCancellationError(d)?!1:Promise.reject(d))}e.checkGlobFileExists=w});var tt=this&&this.__classPrivateFieldSet||function(Q,e,u,n,y){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!y:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?y.call(Q,u):y?y.value=u:e.set(Q,u),u},Me=this&&this.__classPrivateFieldGet||function(Q,e,u,n){if(u==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!n:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?n:u==="a"?n.call(Q):n?n.value:e.get(Q)};define(Ie[39],ke([1,0,172,9,74,22,18,6,25,2,14,5,33,229,91,32,27,227,12,28,23,206,7,121,4,26,70,17,85,52,38,3,279,90,208,11]),function(Q,e,u,n,y,A,D,C,S,P,L,I,_,T,w,b,p,g,v,f,a,m,o,d,r,s,i,t,c,l,h,E,R,N,O,k){"use strict";var U,F,$;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let ee=class In extends C.Disposable{constructor(Y,le,ue,K,ge,ye,Te,pe,Pe,fe){super();this._onDidChangeRemoteConnectionData=this._register(new E.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=le,this._extHostContext=ue,this._initData=Te,this._extHostWorkspace=K,this._extHostConfiguration=ge,this._logService=ye,this._extHostTunnelService=Pe,this._extHostTerminalService=fe,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(I.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(I.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(I.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new D.Barrier,this._readyToStartExtensionHost=new D.Barrier,this._readyToRunExtensions=new D.Barrier,this._eagerExtensionsActivated=new D.Barrier,this._globalRegistry=new g.ExtensionDescriptionRegistry(this._initData.allExtensions);const ve=(0,p.extensionIdentifiersArrayToSet)(this._initData.myExtensions);this._myRegistry=new g.ExtensionDescriptionRegistry(q(this._globalRegistry,ve)),this._storage=new w.ExtHostStorage(this._extHostContext),this._secretState=new N.ExtHostSecretState(this._extHostContext),this._storagePath=pe,this._instaService=Y.createChild(new c.ServiceCollection([w.IExtHostStorage,this._storage],[N.IExtHostSecretState,this._secretState]));let _e=[],ae=[];this._initData.remote.isRemote&&(_e=this._initData.allExtensions.filter(te=>!te.main&&!te.browser).map(te=>te.identifier),ae=this._initData.allExtensions.filter(te=>!ve.has(f.ExtensionIdentifier.toKey(te.identifier.value))).filter(te=>(te.main||te.browser)&&te.api==="none").map(te=>te.identifier));const he=(0,p.extensionIdentifiersArrayToSet)(ae);this._activator=this._register(new T.ExtensionsActivator(this._myRegistry,_e,ae,{onExtensionActivationError:(te,ie,M)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(te,v.transformErrorForSerialization(ie),M)},actualActivateExtension:async(te,ie)=>{if(he.has(f.ExtensionIdentifier.toKey(te)))return await this._mainThreadExtensionsProxy.$activateExtension(te,ie),new T.HostExtension;const M=this._myRegistry.getExtensionDescription(te);return this._activateExtension(M,ie)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),y.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(Y){v.onUnexpectedError(Y)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let Y=[];try{Y=this._myRegistry.getAllExtensionDescriptions().map(ge=>ge.identifier).filter(ge=>this.isActivated(ge)).map(ge=>this._deactivate(ge))}catch{}await Promise.all(Y)}terminate(Y,le=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${Y}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),v.setUnexpectedErrorHandler(K=>{this._logService.error(K)}),this._extHostContext.dispose();const ue=this._deactivateAll();Promise.race([(0,D.timeout)(5e3),ue]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${le}`):this._logService.info(`Extension host exiting with code ${le}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(le)})}isActivated(Y){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(Y):!1}async getExtension(Y){const le=await this._mainThreadExtensionsProxy.$getExtension(Y);return le&&{...le,identifier:new f.ExtensionIdentifier(le.identifier.value),extensionLocation:P.URI.revive(le.extensionLocation)}}_activateByEvent(Y,le){return this._activator.activateByEvent(Y,le)}_activateById(Y,le){return this._activator.activateById(Y,le)}activateByIdWithErrors(Y,le){return this._activateById(Y,le).then(()=>{const ue=this._activator.getActivatedExtension(Y);if(ue.activationFailed)return Promise.reject(ue.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(Y=>this._myRegistry)}getExtensionExports(Y){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(Y).exports:null}async _realPathExtensionUri(Y){if(Y.scheme!==k.Schemas.file)return Y;const le=await this._hostUtils.realpath(Y.fsPath);return P.URI.file(le)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(Y=>new j(Y))),this._extensionPathIndex}async _createExtensionPathIndex(Y){const le=S.TernarySearchTree.forUris(ue=>A.extUriBiasedIgnorePathCase.ignorePathCasing(ue));return await Promise.all(Y.map(async ue=>{if(this._getEntryPoint(ue)){const K=await this._realPathExtensionUri(ue.extensionLocation);le.set(K,ue)}})),le}_deactivate(Y){let le=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(Y))return le;const ue=this._activator.getActivatedExtension(Y);if(!ue)return le;try{typeof ue.module.deactivate=="function"&&(le=Promise.resolve(ue.module.deactivate()).then(void 0,K=>(this._logService.error(K),Promise.resolve(void 0))))}catch(K){this._logService.error(`An error occurred when deactivating the extension '${Y.value}':`),this._logService.error(K)}try{(0,C.dispose)(ue.subscriptions)}catch(K){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${Y.value}':`),this._logService.error(K)}return le}async _activateExtension(Y,le){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(Y.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(Y.identifier),this._doActivateExtension(Y,le).then(ue=>{const K=ue.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(Y.identifier,K.codeLoadingTime,K.activateCallTime,K.activateResolvedTime,le),this._logExtensionActivationTimes(Y,le,"success",K),ue},ue=>{throw this._logExtensionActivationTimes(Y,le,"failure"),ue})}_logExtensionActivationTimes(Y,le,ue,K){const ge=B(Y,le);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...ge,...K||{},outcome:ue})}_doActivateExtension(Y,le){const ue=B(Y,le);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",ue);const K=this._getEntryPoint(Y);if(!K)return Promise.resolve(new T.EmptyExtension(T.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${Y.identifier.value}, startup: ${le.startup}, activationEvent: '${le.activationEvent}'${Y.identifier.value!==le.extensionId.value?`, root cause: ${le.extensionId.value}`:""}`),this._logService.flush();const ge=new T.ExtensionActivationTimesBuilder(le.startup);return Promise.all([this._loadCommonJSModule(Y.identifier,(0,A.joinPath)(Y.extensionLocation,K),ge),this._loadExtensionContext(Y)]).then(ye=>(y.mark(`code/extHost/willActivateExtension/${Y.identifier.value}`),In._callActivate(this._logService,Y.identifier,ye[0],ye[1],ge))).then(ye=>(y.mark(`code/extHost/didActivateExtension/${Y.identifier.value}`),ye))}_loadExtensionContext(Y){const le=new m.ExtensionGlobalMemento(Y,this._storage),ue=new m.ExtensionMemento(Y.identifier.value,!1,this._storage),K=new O.ExtensionSecrets(Y,this._secretState),ge=Y.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?o.ExtensionMode.Test:o.ExtensionMode.Development:o.ExtensionMode.Production,ye=this._initData.remote.isRemote?o.ExtensionKind.Workspace:o.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${Y.identifier.value}`),Promise.all([le.whenReady,ue.whenReady,this._storagePath.whenReady]).then(()=>{const Te=this;let pe,Pe;const fe=(0,p.isProposedApiEnabled)(Y,"ipc")?this._initData.messagePorts?.get(f.ExtensionIdentifier.toKey(Y.identifier)):void 0;return Object.freeze({globalState:le,workspaceState:ue,secrets:K,subscriptions:[],get extensionUri(){return Y.extensionLocation},get extensionPath(){return Y.extensionLocation.fsPath},asAbsolutePath(ve){return n.join(Y.extensionLocation.fsPath,ve)},get storagePath(){return Te._storagePath.workspaceValue(Y)?.fsPath},get globalStoragePath(){return Te._storagePath.globalValue(Y).fsPath},get logPath(){return n.join(Te._initData.logsLocation.fsPath,Y.identifier.value)},get logUri(){return P.URI.joinPath(Te._initData.logsLocation,Y.identifier.value)},get storageUri(){return Te._storagePath.workspaceValue(Y)},get globalStorageUri(){return Te._storagePath.globalValue(Y)},get extensionMode(){return ge},get extension(){return pe===void 0&&(pe=new z(Te,Y.identifier,Y,ye,!1)),pe},get extensionRuntime(){return(0,p.checkProposedApiEnabled)(Y,"extensionRuntime"),Te.extensionRuntime},get environmentVariableCollection(){return Te._extHostTerminalService.getEnvironmentVariableCollection(Y)},get messagePassingProtocol(){if(!Pe){if(!fe)return;const ve=E.Event.buffer(E.Event.fromDOMEventEmitter(fe,"message",_e=>_e.data));fe.start(),Pe={onDidReceiveMessage:ve,postMessage:fe.postMessage.bind(fe)}}return Pe}})})}static _callActivate(Y,le,ue,K,ge){return ue=ue||{activate:void 0,deactivate:void 0},this._callActivateOptional(Y,le,ue,K,ge).then(ye=>new T.ActivatedExtension(!1,null,ge.build(),ue,ye,K.subscriptions))}static _callActivateOptional(Y,le,ue,K,ge){if(typeof ue.activate=="function")try{ge.activateCallStart(),Y.trace(`ExtensionService#_callActivateOptional ${le.value}`);const ye=typeof global=="object"?global:self,Te=ue.activate.apply(ye,[K]);return ge.activateCallStop(),ge.activateResolveStart(),Promise.resolve(Te).then(pe=>(ge.activateResolveStop(),pe))}catch(ye){return Promise.reject(ye)}else return Promise.resolve(ue)}_activateOneStartupFinished(Y,le){this._activateById(Y.identifier,{startup:!1,extensionId:Y.identifier,activationEvent:le}).then(void 0,ue=>{this._logService.error(ue)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(y.getMarks());for(const Y of this._myRegistry.getAllExtensionDescriptions())if(Y.activationEvents)for(const le of Y.activationEvents)le==="onStartupFinished"&&this._activateOneStartupFinished(Y,le)}_handleEagerExtensions(){const Y=this._activateByEvent("*",!0).then(void 0,ge=>{this._logService.error(ge)});this._register(this._extHostWorkspace.onDidChangeWorkspace(ge=>this._handleWorkspaceContainsEagerExtensions(ge.added)));const le=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],ue=this._handleWorkspaceContainsEagerExtensions(le),K=Promise.all([Y,ue]).then(()=>{});return Promise.race([K,(0,D.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),K}_handleWorkspaceContainsEagerExtensions(Y){return Y.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(le=>this._handleWorkspaceContainsEagerExtension(Y,le))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(Y,le){if(this.isActivated(le.identifier))return;const ue=!this._initData.remote.isRemote&&!!this._initData.remote.authority,K={logService:this._logService,folders:Y.map(ye=>ye.uri),forceUsingSearch:ue,exists:ye=>this._hostUtils.exists(ye.fsPath),checkExists:(ye,Te,pe)=>this._mainThreadWorkspaceProxy.$checkExists(ye,Te,pe)},ge=await(0,R.checkActivateWorkspaceContainsExtension)(K,le);if(!!ge)return this._activateById(le.identifier,{startup:!0,extensionId:le.identifier,activationEvent:ge.activationEvent}).then(void 0,ye=>this._logService.error(ye))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(Y){throw console.error(Y),Y}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:Y,extensionTestsLocationURI:le}=this._initData.environment;if(!Y||!le)throw new Error(u.localize(0,null));const ue=await this._loadCommonJSModule(null,le,new T.ExtensionActivationTimesBuilder(!1));if(!ue||typeof ue.run!="function")throw new Error(u.localize(1,null,le.toString()));return new Promise((K,ge)=>{const ye=(Pe,fe)=>{Pe?ge(Pe):K(typeof fe=="number"&&fe>0?1:0)},Te=(0,A.originalFSPath)(le),pe=ue.run(Te,ye);pe&&pe.then&&pe.then(()=>{K(0)}).catch(Pe=>{ge(Pe instanceof Error&&Pe.stack?Pe.stack:String(Pe))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(Y,le){return this._resolvers[Y]=le,(0,C.toDisposable)(()=>{delete this._resolvers[Y]})}async _activateAndGetResolver(Y){const le=Y.indexOf("+");if(le===-1)throw new Error("Not an authority that can be resolved!");const ue=Y.substr(0,le);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${ue}`,!1),{authorityPrefix:ue,resolver:this._resolvers[ue]}}async $resolveAuthority(Y,le){this._logService.info(`$resolveAuthority invoked for authority (${V(Y)})`);const{authorityPrefix:ue,resolver:K}=await this._activateAndGetResolver(Y);if(!K)return{type:"error",error:{code:d.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${ue}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(K)),y.mark(`code/extHost/willResolveAuthority/${ue}`);const ge=await K.resolve(Y,{resolveAttempt:le});y.mark(`code/extHost/didResolveAuthorityOK/${ue}`);const ye={authority:Y,host:ge.host,port:ge.port,connectionToken:ge.connectionToken},Te={extensionHostEnv:ge.extensionHostEnv,isTrusted:ge.isTrusted,authenticationSession:ge.authenticationSessionForInitializingExtensions?{id:ge.authenticationSessionForInitializingExtensions.id,providerId:ge.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:ye,options:Te,tunnelInformation:{environmentTunnels:ge.environmentTunnels,features:ge.tunnelFeatures}}}}catch(ge){if(y.mark(`code/extHost/didResolveAuthorityError/${ue}`),ge instanceof o.RemoteAuthorityResolverError)return{type:"error",error:{code:ge._code,message:ge._message,detail:ge._detail}};throw ge}}async $getCanonicalURI(Y,le){this._logService.info(`$getCanonicalURI invoked for authority (${V(Y)})`);const{resolver:ue}=await this._activateAndGetResolver(Y);if(!ue)return null;const K=P.URI.revive(le);if(typeof ue.getCanonicalURI=="undefined")return K;const ge=await(0,D.asPromise)(()=>ue.getCanonicalURI(K));return ge||K}static _applyExtensionsDelta(Y,le,ue){const K=new g.ExtensionDescriptionRegistry(Y.getAllExtensionDescriptions());K.deltaExtensions(ue.toAdd,ue.toRemove);const ge=(0,p.extensionIdentifiersArrayToSet)(le.getAllExtensionDescriptions().map(Te=>Te.identifier));for(const Te of ue.myToRemove)ge.delete(f.ExtensionIdentifier.toKey(Te));for(const Te of ue.myToAdd)ge.add(f.ExtensionIdentifier.toKey(Te));const ye=q(K,ge);return{globalRegistry:K,myExtensions:ye}}$startExtensionHost(Y){Y.toAdd.forEach(K=>K.extensionLocation=P.URI.revive(K.extensionLocation));const{globalRegistry:le,myExtensions:ue}=In._applyExtensionsDelta(this._globalRegistry,this._myRegistry,Y);return this._globalRegistry.set(le.getAllExtensionDescriptions()),this._myRegistry.set(ue),this._startExtensionHost()}$activateByEvent(Y,le){return le===1?this._activateByEvent(Y,!1):this._readyToRunExtensions.wait().then(ue=>this._activateByEvent(Y,!1))}async $activate(Y,le){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(Y)?(await this._activateById(Y,le),!0):!1}async $deltaExtensions(Y){Y.toAdd.forEach(ye=>ye.extensionLocation=P.URI.revive(ye.extensionLocation));const{globalRegistry:le,myExtensions:ue}=In._applyExtensionsDelta(this._globalRegistry,this._myRegistry,Y),K=await this._createExtensionPathIndex(ue);return(await this.getExtensionPathIndex()).setSearchTree(K),this._globalRegistry.set(le.getAllExtensionDescriptions()),this._myRegistry.set(ue),Promise.resolve(void 0)}async $test_latency(Y){return Y}async $test_up(Y){return Y.byteLength}async $test_down(Y){const le=a.VSBuffer.alloc(Y),ue=Math.random()%256;for(let K=0;K<Y;K++)le.writeUInt8(ue,K);return le}async $updateRemoteConnectionData(Y){this._remoteConnectionData=Y,this._onDidChangeRemoteConnectionData.fire()}};ee=Ge([$e(0,r.IInstantiationService),$e(1,e.IHostUtils),$e(2,t.IExtHostRpcService),$e(3,b.IExtHostWorkspace),$e(4,_.IExtHostConfiguration),$e(5,L.ILogService),$e(6,s.IExtHostInitDataService),$e(7,i.IExtensionStoragePaths),$e(8,l.IExtHostTunnelService),$e(9,h.IExtHostTerminalService)],ee),e.AbstractExtHostExtensionService=ee;function B(ne,Y){return{id:ne.identifier.value,name:ne.name,extensionVersion:ne.version,publisherDisplayName:ne.publisher,activationEvents:ne.activationEvents?ne.activationEvents.join(","):null,isBuiltin:ne.isBuiltin,reason:Y.activationEvent,reasonId:Y.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class z{constructor(Y,le,ue,K,ge){U.set(this,void 0),F.set(this,void 0),$.set(this,void 0),tt(this,U,Y,"f"),tt(this,F,le,"f"),tt(this,$,ue.identifier,"f"),this.id=ue.identifier.value,this.extensionUri=ue.extensionLocation,this.extensionPath=n.normalize((0,A.originalFSPath)(ue.extensionLocation)),this.packageJSON=ue,this.extensionKind=K,this.isFromDifferentExtensionHost=ge}get isActive(){return Me(this,U,"f").isActivated(Me(this,$,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Me(this,U,"f").getExtensionExports(Me(this,$,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Me(this,U,"f").activateByIdWithErrors(Me(this,$,"f"),{startup:!1,extensionId:Me(this,F,"f"),activationEvent:"api"}),this.exports}}e.Extension=z,U=new WeakMap,F=new WeakMap,$=new WeakMap;function q(ne,Y){return ne.getAllExtensionDescriptions().filter(le=>Y.has(f.ExtensionIdentifier.toKey(le.identifier)))}function V(ne){const Y=ne.indexOf("+");return Y===-1?ne:ne.substring(0,Y)}class j{constructor(Y){this._searchTree=Y}setSearchTree(Y){this._searchTree=Y}findSubstr(Y){return this._searchTree.findSubstr(Y)}forEach(Y){return this._searchTree.forEach(Y)}}e.ExtensionPaths=j}),define(Ie[280],ke([1,0,74,2,5,33,27,28,17,26,4,39,40,14,8]),function(Q,e,u,n,y,A,D,C,S,P,L,I,_,T,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let b=class{constructor(m,o,d,r,s,i,t){this._apiFactory=m,this._extensionRegistry=o,this._instaService=d,this._extHostConfiguration=r,this._extHostExtensionService=s,this._initData=i,this._logService=t,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),u.mark("code/extHost/willWaitForConfig");const m=await this._extHostConfiguration.getConfigProvider();u.mark("code/extHost/didWaitForConfig");const o=await this._extHostExtensionService.getExtensionPathIndex();this.register(new g(this._apiFactory,o,this._extensionRegistry,m,this._logService)),this.register(this._instaService.createInstance(v,o)),this.register(this._instaService.createInstance(p)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(f,o,this._initData.environment.appUriScheme))}register(m){if("nodeModuleName"in m)if(Array.isArray(m.nodeModuleName))for(const o of m.nodeModuleName)this._factories.set(o,m);else this._factories.set(m.nodeModuleName,m);typeof m.alternativeModuleName=="function"&&this._alternatives.push(o=>m.alternativeModuleName(o))}};b=Ge([$e(2,L.IInstantiationService),$e(3,A.IExtHostConfiguration),$e(4,I.IExtHostExtensionService),$e(5,P.IExtHostInitDataService),$e(6,T.ILogService)],b),e.RequireInterceptor=b;let p=class Kn{constructor(m){if(m.environment.appRoot&&Kn.aliased.size){const o=(0,w.escapeRegExpCharacters)(this.forceForwardSlashes(m.environment.appRoot.fsPath)),d="[a-z0-9_.-]",r=`@${d}+\\/${d}+|${d}+`,s="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${o}/${s}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(m){if(!this.re)return;const o=this.re.exec(this.forceForwardSlashes(m));if(!o)return;const[,d,r,s]=o,i=Kn.aliased.get(r);if(i!==void 0)return console.warn(`${r} as been renamed to ${i}, please update your imports`),d+i+s}forceForwardSlashes(m){return m.replace(/\\/g,"/")}};p.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),p=Ge([$e(0,P.IExtHostInitDataService)],p);class g{constructor(m,o,d,r,s){this._apiFactory=m,this._extensionPaths=o,this._extensionRegistry=d,this._configProvider=r,this._logService=s,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(m,o){const d=this._extensionPaths.findSubstr(o);if(d){let r=this._extApiImpl.get(C.ExtensionIdentifier.toKey(d.identifier));return r||(r=this._apiFactory(d,this._extensionRegistry,this._configProvider),this._extApiImpl.set(C.ExtensionIdentifier.toKey(d.identifier),r)),r}if(!this._defaultApiImpl){let r="";this._extensionPaths.forEach((s,i)=>r+=`	${i} -> ${s.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${o}. These are the extension path mappings: 
${r}`),this._defaultApiImpl=this._apiFactory(D.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let v=class{constructor(m,o,d){this._extensionPaths=m,this.nodeModuleName="keytar",this._mainThreadTelemetry=o.getProxy(y.MainContext.MainThreadTelemetry);const{environment:r}=d,s=o.getProxy(y.MainContext.MainThreadKeytar);if(r.appRoot){let i=r.appRoot.fsPath;_.platform==="win32"&&(i=i.replace(/\\/g,"/")),i[i.length-1]==="/"&&(i=i.substr(0,i.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${i}/node_modules.asar/keytar`),this.alternativeNames.add(`${i}/node_modules/keytar`)}this._impl={getPassword:(i,t)=>s.$getPassword(i,t),setPassword:(i,t,c)=>s.$setPassword(i,t,c),deletePassword:(i,t)=>s.$deletePassword(i,t),findPassword:i=>s.$findPassword(i),findCredentials(i){return s.$findCredentials(i)}}}load(m,o){const d=this._extensionPaths.findSubstr(o);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:d?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(m){const o=m.length;if(o<=7||!this.alternativeNames)return;const d=o-7;if((m.charAt(d)==="/"||m.charAt(d)==="\\")&&m.endsWith("keytar")&&(m=m.replace(/\\/g,"/"),this.alternativeNames.has(m)))return"keytar"}};v=Ge([$e(1,S.IExtHostRpcService),$e(2,P.IExtHostInitDataService)],v);let f=class{constructor(m,o,d){this._extensionPaths=m,this._appUriScheme=o,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=d.getProxy(y.MainContext.MainThreadTelemetry);const r=d.getProxy(y.MainContext.MainThreadWindow);this._impl=(s,i)=>{const t=n.URI.parse(s);return i?this.callOriginal(s,i):t.scheme==="http"||t.scheme==="https"?r.$openUri(t,s,{allowTunneling:!0}):t.scheme==="mailto"||t.scheme===this._appUriScheme?r.$openUri(t,s,{}):this.callOriginal(s,i)}}load(m,o,d){const r=this._extensionPaths.findSubstr(o);return r&&(this._extensionId=r.identifier.value,this.sendShimmingTelemetry()),this._original=d(m),this._impl}callOriginal(m,o){return this.sendNoForwardTelemetry(),this._original(m,o)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};f=Ge([$e(2,S.IExtHostRpcService)],f)}),define(Ie[47],ke([1,0,79,6,9,40,4,54,55,39,7,32,220,33]),function(Q,e,u,n,y,A,D,C,S,P,L,I,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,D.createDecorator)("IExtHostVariableResolverProvider");class w extends _.AbstractVariableResolverService{constructor(g,v,f,a,m,o,d){function r(){if(f){const s=f.activeEditor();if(s)return s.document.uri;const i=a.tabGroups.all.find(t=>t.isActive)?.activeTab;if(i!==void 0){if(i.input instanceof L.TextDiffTabInput||i.input instanceof L.NotebookDiffEditorTabInput)return i.input.modified;if(i.input instanceof L.TextTabInput||i.input instanceof L.NotebookEditorTabInput||i.input instanceof L.CustomEditorTabInput)return i.input.uri}}}super({getFolderUri:s=>{const i=o.folders.filter(t=>t.name===s);if(i&&i.length>0)return i[0].uri},getWorkspaceFolderCount:()=>o.folders.length,getConfigurationValue:(s,i)=>m.getConfiguration(void 0,s).get(i),getAppRoot:()=>A.cwd(),getExecPath:()=>A.env.VSCODE_EXEC_PATH,getFilePath:()=>{const s=r();if(s)return y.normalize(s.fsPath)},getWorkspaceFolderPathForFile:()=>{if(v){const s=r();if(s){const i=v.getWorkspaceFolder(s);if(i)return y.normalize(i.uri.fsPath)}}},getSelectedText:()=>{if(f){const s=f.activeEditor();if(s&&!s.selection.isEmpty)return s.document.getText(s.selection)}},getLineNumber:()=>{if(f){const s=f.activeEditor();if(s)return String(s.selection.end.line+1)}},getExtension:s=>g.getExtension(s)},void 0,d?Promise.resolve(d):void 0,Promise.resolve(A.env))}}let b=class extends n.Disposable{constructor(g,v,f,a,m){super();this.extensionService=g,this.workspaceService=v,this.editorService=f,this.configurationService=a,this.editorTabs=m,this._resolver=new u.Lazy(async()=>{const o=await this.configurationService.getConfigProvider(),r={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async s=>{r.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new w(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,o,r,this.homeDir())})}getResolver(){return this._resolver.getValue()}homeDir(){}};b=Ge([$e(0,P.IExtHostExtensionService),$e(1,I.IExtHostWorkspace),$e(2,C.IExtHostDocumentsAndEditors),$e(3,T.IExtHostConfiguration),$e(4,S.IExtHostEditorTabs)],b),e.ExtHostVariableResolverProviderService=b}),define(Ie[75],ke([1,0,18,3,10,2,4,5,55,39,17,7,32,126,215,33,47]),function(Q,e,u,n,y,A,D,C,S,P,L,I,_,T,w,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,D.createDecorator)("IExtHostDebugService");let g=class{constructor(r,s,i,t,c,l){this._workspaceService=s,this._extensionService=i,this._configurationService=t,this._editorTabs=c,this._variableResolver=l,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new n.Emitter,this._onDidTerminateDebugSession=new n.Emitter,this._onDidChangeActiveDebugSession=new n.Emitter,this._onDidReceiveDebugSessionCustomEvent=new n.Emitter,this._debugServiceProxy=r.getProxy(C.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new n.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new f(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(h=>{h.onDidChange(E=>{this.registerAllDebugTypes(h)}),this.registerAllDebugTypes(h)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(r,s){const i=r;if(typeof i.sourceReference=="number"&&i.sourceReference>0){let t=`debug:${encodeURIComponent(i.path||"")}`,c="?";return s&&(t+=`${c}session=${encodeURIComponent(s.id)}`,c="&"),t+=`${c}ref=${i.sourceReference}`,A.URI.parse(t)}else{if(i.path)return A.URI.file(i.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(r){const s=[];for(const i of r.getAllExtensionDescriptions())if(i.contributes){const t=i.contributes.debuggers;if(t&&t.length>0)for(const c of t)(0,w.isDebuggerMainContribution)(c)&&s.push(c.type)}this._debugServiceProxy.$registerDebugTypes(s)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const r=[];return this._breakpoints.forEach(s=>r.push(s)),r}addBreakpoints(r){this.startBreakpoints();const s=r.filter(c=>{const l=c.id;return this._breakpoints.has(l)?!1:(this._breakpoints.set(l,c),!0)});this.fireBreakpointChanges(s,[],[]);const i=[],t=new Map;for(const c of s)if(c instanceof I.SourceBreakpoint){let l=t.get(c.location.uri.toString());l||(l={type:"sourceMulti",uri:c.location.uri,lines:[]},t.set(c.location.uri.toString(),l),i.push(l)),l.lines.push({id:c.id,enabled:c.enabled,condition:c.condition,hitCondition:c.hitCondition,logMessage:c.logMessage,line:c.location.range.start.line,character:c.location.range.start.character})}else c instanceof I.FunctionBreakpoint&&i.push({type:"function",id:c.id,enabled:c.enabled,hitCondition:c.hitCondition,logMessage:c.logMessage,condition:c.condition,functionName:c.functionName});return this._debugServiceProxy.$registerBreakpoints(i)}removeBreakpoints(r){this.startBreakpoints();const s=r.filter(l=>this._breakpoints.delete(l.id));this.fireBreakpointChanges([],s,[]);const i=s.filter(l=>l instanceof I.SourceBreakpoint).map(l=>l.id),t=s.filter(l=>l instanceof I.FunctionBreakpoint).map(l=>l.id),c=s.filter(l=>l instanceof I.DataBreakpoint).map(l=>l.id);return this._debugServiceProxy.$unregisterBreakpoints(i,t,c)}startDebugging(r,s,i){return this._debugServiceProxy.$startDebugging(r?r.uri:void 0,s,{parentSessionID:i.parentSession?i.parentSession.id:void 0,lifecycleManagedByParent:i.lifecycleManagedByParent,repl:i.consoleMode===I.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:i.noDebug,compact:i.compact,debugUI:i.debugUI,suppressSaveBeforeStart:i.suppressSaveBeforeStart})}stopDebugging(r){return this._debugServiceProxy.$stopDebugging(r?r.id:void 0)}registerDebugConfigurationProvider(r,s,i){if(!s)return new I.Disposable(()=>{});const t=this._configProviderHandleCounter++;return this._configProviders.push({type:r,handle:t,provider:s}),this._debugServiceProxy.$registerDebugConfigurationProvider(r,i,!!s.provideDebugConfigurations,!!s.resolveDebugConfiguration,!!s.resolveDebugConfigurationWithSubstitutedVariables,t),new I.Disposable(()=>{this._configProviders=this._configProviders.filter(c=>c.provider!==s),this._debugServiceProxy.$unregisterDebugConfigurationProvider(t)})}registerDebugAdapterDescriptorFactory(r,s,i){if(!i)return new I.Disposable(()=>{});if(!this.definesDebugType(r,s))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${s}' debugger.`);if(this.getAdapterDescriptorFactoryByType(s))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const t=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:s,handle:t,factory:i}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(s,t),new I.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(c=>c.factory!==i),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(t)})}registerDebugAdapterTrackerFactory(r,s){if(!s)return new I.Disposable(()=>{});const i=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:r,handle:i,factory:s}),new I.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(t=>t.factory!==s)})}async $runInTerminal(r,s){return Promise.resolve(void 0)}async $substituteVariables(r,s){let i;const t=await this.getFolder(r);return t&&(i={uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(i,s)}createDebugAdapter(r,s){if(r.type==="implementation")return new m(r.implementation)}createSignService(){}async $startDASession(r,s){const i=this,t=await this.getSession(s);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(t.type),t).then(c=>{if(!c)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${t.type}' (extension might have failed to activate)`);const l=this.convertToDto(c),h=this.createDebugAdapter(l,t);if(!h)throw new Error(`Couldn't create a debug adapter for type '${t.type}'.`);const E=h;return this._debugAdapters.set(r,E),this.getDebugAdapterTrackers(t).then(R=>(R&&this._debugAdaptersTrackers.set(r,R),E.onMessage(async N=>{if(N.type==="request"&&N.command==="handshake"){const O=N,k={type:"response",seq:0,command:O.command,request_seq:O.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const U=await this._signService.sign(O.arguments.value);k.body={signature:U},E.sendResponse(k)}else throw new Error("no signer")}catch(U){k.success=!1,k.message=U.message,E.sendResponse(k)}}else R&&R.onDidSendMessage&&R.onDidSendMessage(N),N=(0,w.convertToVSCPaths)(N,!0),i._debugServiceProxy.$acceptDAMessage(r,N)}),E.onError(N=>{R&&R.onError&&R.onError(N),this._debugServiceProxy.$acceptDAError(r,N.name,N.message,N.stack)}),E.onExit(N=>{R&&R.onExit&&R.onExit((0,y.withNullAsUndefined)(N),void 0),this._debugServiceProxy.$acceptDAExit(r,(0,y.withNullAsUndefined)(N),void 0)}),R&&R.onWillStartSession&&R.onWillStartSession(),E.startSession()))})}$sendDAMessage(r,s){s=(0,w.convertToDAPaths)(s,!1);const i=this._debugAdaptersTrackers.get(r);i&&i.onWillReceiveMessage&&i.onWillReceiveMessage(s),this._debugAdapters.get(r)?.sendMessage(s)}$stopDASession(r){const s=this._debugAdaptersTrackers.get(r);this._debugAdaptersTrackers.delete(r),s&&s.onWillStopSession&&s.onWillStopSession();const i=this._debugAdapters.get(r);return this._debugAdapters.delete(r),i?i.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(r){const s=[],i=[],t=[];if(r.added)for(const c of r.added){const l=c.id;if(l&&!this._breakpoints.has(l)){let h;if(c.type==="function")h=new I.FunctionBreakpoint(c.functionName,c.enabled,c.condition,c.hitCondition,c.logMessage);else if(c.type==="data")h=new I.DataBreakpoint(c.label,c.dataId,c.canPersist,c.enabled,c.hitCondition,c.condition,c.logMessage);else{const E=A.URI.revive(c.uri);h=new I.SourceBreakpoint(new I.Location(E,new I.Position(c.line,c.character)),c.enabled,c.condition,c.hitCondition,c.logMessage)}h._id=l,this._breakpoints.set(l,h),s.push(h)}}if(r.removed)for(const c of r.removed){const l=this._breakpoints.get(c);l&&(this._breakpoints.delete(c),i.push(l))}if(r.changed){for(const c of r.changed)if(c.id){const l=this._breakpoints.get(c.id);if(l){if(l instanceof I.FunctionBreakpoint&&c.type==="function"){const h=l;h.enabled=c.enabled,h.condition=c.condition,h.hitCondition=c.hitCondition,h.logMessage=c.logMessage,h.functionName=c.functionName}else if(l instanceof I.SourceBreakpoint&&c.type==="source"){const h=l;h.enabled=c.enabled,h.condition=c.condition,h.hitCondition=c.hitCondition,h.logMessage=c.logMessage,h.location=new I.Location(A.URI.revive(c.uri),new I.Position(c.line,c.character))}t.push(l)}}}this.fireBreakpointChanges(s,i,t)}$provideDebugConfigurations(r,s,i){return(0,u.asPromise)(async()=>{const t=this.getConfigProviderByHandle(r);if(!t)throw new Error("no DebugConfigurationProvider found");if(!t.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const c=await this.getFolder(s);return t.provideDebugConfigurations(c,i)}).then(t=>{if(!t)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return t})}$resolveDebugConfiguration(r,s,i,t){return(0,u.asPromise)(async()=>{const c=this.getConfigProviderByHandle(r);if(!c)throw new Error("no DebugConfigurationProvider found");if(!c.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const l=await this.getFolder(s);return c.resolveDebugConfiguration(l,i,t)})}$resolveDebugConfigurationWithSubstitutedVariables(r,s,i,t){return(0,u.asPromise)(async()=>{const c=this.getConfigProviderByHandle(r);if(!c)throw new Error("no DebugConfigurationProvider found");if(!c.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const l=await this.getFolder(s);return c.resolveDebugConfigurationWithSubstitutedVariables(l,i,t)})}async $provideDebugAdapter(r,s){const i=this.getAdapterDescriptorFactoryByHandle(r);if(!i)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const t=await this.getSession(s);return this.getAdapterDescriptor(i,t).then(c=>{if(!c)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${t.type}'`);return this.convertToDto(c)})}async $acceptDebugSessionStarted(r){const s=await this.getSession(r);this._onDidStartDebugSession.fire(s)}async $acceptDebugSessionTerminated(r){const s=await this.getSession(r);s&&(this._onDidTerminateDebugSession.fire(s),this._debugSessions.delete(s.id))}async $acceptDebugSessionActiveChanged(r){this._activeDebugSession=r?await this.getSession(r):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(r,s){(await this.getSession(r))?._acceptNameChanged(s)}async $acceptDebugSessionCustomEvent(r,s){const t={session:await this.getSession(r),event:s.event,body:s.body};this._onDidReceiveDebugSessionCustomEvent.fire(t)}convertToDto(r){if(r instanceof I.DebugAdapterExecutable)return{type:"executable",command:r.command,args:r.args,options:r.options};if(r instanceof I.DebugAdapterServer)return{type:"server",port:r.port,host:r.host};if(r instanceof I.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:r.path};if(r instanceof I.DebugAdapterInlineImplementation)return{type:"implementation",implementation:r.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(r){const s=this._adapterFactories.filter(i=>i.type===r);if(s.length>0)return s[0].factory}getAdapterDescriptorFactoryByHandle(r){const s=this._adapterFactories.filter(i=>i.handle===r);if(s.length>0)return s[0].factory}getConfigProviderByHandle(r){const s=this._configProviders.filter(i=>i.handle===r);if(s.length>0)return s[0].provider}definesDebugType(r,s){if(r.contributes){const i=r.contributes.debuggers;if(i&&i.length>0){for(const t of i)if(t.label&&t.type&&t.type===s)return!0}}return!1}getDebugAdapterTrackers(r){const i=r.configuration.type,t=this._trackerFactories.filter(c=>c.type===i||c.type==="*").map(c=>(0,u.asPromise)(()=>c.factory.createDebugAdapterTracker(r)).then(l=>l,l=>null));return Promise.race([Promise.all(t).then(c=>{const l=c.filter(h=>!!h);if(l.length>0)return new a(l)}),new Promise((c,l)=>{const h=setTimeout(()=>{clearTimeout(h),l(new Error("timeout"))},1e3)})]).catch(c=>{})}async getAdapterDescriptor(r,s){const i=s.configuration.debugServer;if(typeof i=="number")return Promise.resolve(new I.DebugAdapterServer(i));if(r){const c=await this._extensionService.getExtensionRegistry();return(0,u.asPromise)(()=>r.createDebugAdapterDescriptor(s,this.daExecutableFromPackage(s,c))).then(l=>{if(l)return l})}const t=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(s,t))}daExecutableFromPackage(r,s){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(r,s,i){(r.length>0||s.length>0||i.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:r,removed:s,changed:i}))}async getSession(r){if(r)if(typeof r=="string"){const s=this._debugSessions.get(r);if(s)return s}else{let s=this._debugSessions.get(r.id);if(!s){const i=await this.getFolder(r.folderUri),t=r.parent?this._debugSessions.get(r.parent):void 0;s=new v(this._debugServiceProxy,r.id,r.type,r.name,i,r.configuration,t),this._debugSessions.set(s.id,s),this._debugServiceProxy.$sessionCached(s.id)}return s}throw new Error("cannot find session")}getFolder(r){if(r){const s=A.URI.revive(r);return this._workspaceService.resolveWorkspaceFolder(s)}return Promise.resolve(void 0)}};g=Ge([$e(0,L.IExtHostRpcService),$e(1,_.IExtHostWorkspace),$e(2,P.IExtHostExtensionService),$e(3,b.IExtHostConfiguration),$e(4,S.IExtHostEditorTabs),$e(5,p.IExtHostVariableResolverProvider)],g),e.ExtHostDebugServiceBase=g;class v{constructor(r,s,i,t,c,l,h){this._debugServiceProxy=r,this._id=s,this._type=i,this._name=t,this._workspaceFolder=c,this._configuration=l,this._parentSession=h}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(r){this._name=r,this._debugServiceProxy.$setDebugSessionName(this._id,r)}get parentSession(){return this._parentSession}_acceptNameChanged(r){this._name=r}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(r,s){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,r,s)}getDebugProtocolBreakpoint(r){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,r.id)}}e.ExtHostDebugSession=v;class f{constructor(r){this.value=Object.freeze({append(s){r.$appendDebugConsole(s)},appendLine(s){this.append(s+`
`)}})}}e.ExtHostDebugConsole=f;class a{constructor(r){this.trackers=r}onWillStartSession(){this.trackers.forEach(r=>r.onWillStartSession?r.onWillStartSession():void 0)}onWillReceiveMessage(r){this.trackers.forEach(s=>s.onWillReceiveMessage?s.onWillReceiveMessage(r):void 0)}onDidSendMessage(r){this.trackers.forEach(s=>s.onDidSendMessage?s.onDidSendMessage(r):void 0)}onWillStopSession(){this.trackers.forEach(r=>r.onWillStopSession?r.onWillStopSession():void 0)}onError(r){this.trackers.forEach(s=>s.onError?s.onError(r):void 0)}onExit(r,s){this.trackers.forEach(i=>i.onExit?i.onExit(r,s):void 0)}}class m extends T.AbstractDebugAdapter{constructor(r){super();this.implementation=r,r.onDidSendMessage(s=>{this.acceptMessage(s)})}startSession(){return Promise.resolve(void 0)}sendMessage(r){this.implementation.handleMessage(r)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let o=class extends g{constructor(r,s,i,t,c,l){super(r,s,i,t,c,l)}};o=Ge([$e(0,L.IExtHostRpcService),$e(1,_.IExtHostWorkspace),$e(2,P.IExtHostExtensionService),$e(3,b.IExtHostConfiguration),$e(4,S.IExtHostEditorTabs),$e(5,p.IExtHostVariableResolverProvider)],o),e.WorkerExtHostDebugService=o}),define(Ie[281],ke([1,0,12,74,2,5,273,14,82,85,26,195,17,65,39]),function(Q,e,u,n,y,A,D,C,S,P,L,I,_,T,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class b{constructor(g,v,f,a,m){this._hostUtils=f,this._rpcProtocol=new D.RPCProtocol(g,null,a),v=b._transform(v,this._rpcProtocol);const o=new P.ServiceCollection(...(0,S.getSingletonServiceDescriptors)());o.set(L.IExtHostInitDataService,{_serviceBrand:void 0,...v,messagePorts:m}),o.set(_.IExtHostRpcService,new _.ExtHostRpcService(this._rpcProtocol)),o.set(T.IURITransformerService,new T.URITransformerService(a)),o.set(w.IHostUtils,f);const d=new I.InstantiationService(o,!0);this._logService=d.invokeFunction(t=>t.get(C.ILogService)),n.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",v),this._extensionService=d.invokeFunction(t=>t.get(w.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const r=new WeakMap;this._extensionService.getExtensionPathIndex().then(t=>{Error.prepareStackTrace=(c,l)=>{let h="",E,R;for(const N of l)h+=`
	at ${N.toString()}`,R=N.getFileName(),!E&&R&&(E=t.findSubstr(y.URI.file(R)));return r.set(c,E),`${c.name||"Error"}: ${c.message||""}${h}`}});const s=this._rpcProtocol.getProxy(A.MainContext.MainThreadExtensionService),i=this._rpcProtocol.getProxy(A.MainContext.MainThreadErrors);u.setUnexpectedErrorHandler(t=>{const c=u.transformErrorForSerialization(t),l=r.get(t);l?s.$onExtensionRuntimeError(l.identifier,c):i.$onUnexpectedError(c)})}async asBrowserUri(g){const v=this._rpcProtocol.getProxy(A.MainContext.MainThreadExtensionService);return y.URI.revive(await v.$asBrowserUri(g))}terminate(g){this._extensionService.terminate(g)}static _transform(g,v){g.allExtensions.forEach(a=>a.extensionLocation=y.URI.revive(v.transformIncomingURIs(a.extensionLocation))),g.environment.appRoot=y.URI.revive(v.transformIncomingURIs(g.environment.appRoot));const f=g.environment.extensionDevelopmentLocationURI;return f&&(g.environment.extensionDevelopmentLocationURI=f.map(a=>y.URI.revive(v.transformIncomingURIs(a)))),g.environment.extensionTestsLocationURI=y.URI.revive(v.transformIncomingURIs(g.environment.extensionTestsLocationURI)),g.environment.globalStorageHome=y.URI.revive(v.transformIncomingURIs(g.environment.globalStorageHome)),g.environment.workspaceStorageHome=y.URI.revive(v.transformIncomingURIs(g.environment.workspaceStorageHome)),g.logsLocation=y.URI.revive(v.transformIncomingURIs(g.logsLocation)),g.logFile=y.URI.revive(v.transformIncomingURIs(g.logFile)),g.workspace=v.transformIncomingURIs(g.workspace),g}}e.ExtensionHostMain=b}),define(Ie[282],ke([1,0,18,13,178,194,202,75,55,39,17,38,7,47,32,216,217,33]),function(Q,e,u,n,y,A,D,C,S,P,L,I,_,T,w,b,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.runInExternalTerminal=e.ExtHostDebugService=void 0;let v=class extends C.ExtHostDebugServiceBase{constructor(d,r,s,i,t,c,l){super(d,r,s,i,c,l);this._terminalService=t,this._integratedTerminalInstances=new m}createDebugAdapter(d,r){switch(d.type){case"server":return new b.SocketDebugAdapter(d);case"pipeServer":return new b.NamedPipeDebugAdapter(d);case"executable":return new b.ExecutableDebugAdapter(d,r.type)}return super.createDebugAdapter(d,r)}daExecutableFromPackage(d,r){const s=b.ExecutableDebugAdapter.platformAdapterExecutable(r.getAllExtensionDescriptions(),d.type);if(s)return new _.DebugAdapterExecutable(s.command,s.args,s.options)}createSignService(){return new D.SignService}async $runInTerminal(d,r){if(d.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(U=>{this._integratedTerminalInstances.onTerminalClosed(U)}));const s=await this._configurationService.getConfigProvider(),i=this._terminalService.getDefaultShell(!0),t=this._terminalService.getDefaultShellArgs(!0),c=d.title||y.localize(0,null),l=JSON.stringify({shell:i,shellArgs:t});let h=await this._integratedTerminalInstances.checkout(l,c),E,R=!1;if(h)E=d.cwd;else{const U={shellPath:i,shellArgs:t,cwd:d.cwd,name:c,iconPath:new _.ThemeIcon("debug")};R=!0,h=this._terminalService.createTerminalFromOptions(U,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(h,l)}h.show(!0);const N=await h.processId;R?await new Promise(U=>setTimeout(U,1e3)):s.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(i.indexOf("powershell")>=0||i.indexOf("pwsh")>=0||i.indexOf("cmd.exe")>=0?h.sendText("cls"):i.indexOf("bash")>=0?h.sendText("clear"):n.isWindows?h.sendText("cls"):h.sendText("clear"));const O=(0,p.prepareCommand)(i,d.args,E,d.env);h.sendText(O);const k=this.onDidTerminateDebugSession(U=>{U.id===r&&(this._integratedTerminalInstances.free(h),k.dispose())});return N}else if(d.kind==="external")return a(d,await this._configurationService.getConfigProvider());return super.$runInTerminal(d,r)}};v=Ge([$e(0,L.IExtHostRpcService),$e(1,w.IExtHostWorkspace),$e(2,P.IExtHostExtensionService),$e(3,g.IExtHostConfiguration),$e(4,I.IExtHostTerminalService),$e(5,S.IExtHostEditorTabs),$e(6,T.IExtHostVariableResolverProvider)],v),e.ExtHostDebugService=v;let f;function a(o,d){if(!f)if(n.isWindows)f=new A.WindowsExternalTerminalService;else if(n.isMacintosh)f=new A.MacExternalTerminalService;else if(n.isLinux)f=new A.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const r=d.getConfiguration("terminal");return f.runInTerminal(o.title,o.cwd,o.args,o.env||{},r.external||{})}e.runInExternalTerminal=a;class m{constructor(){this._terminalInstances=new Map}async checkout(d,r){const i=[...this._terminalInstances.entries()].map(([t,c])=>(0,u.createCancelablePromise)(async l=>{if(t.name!==r||c.lastUsedAt!==-1&&await(0,p.hasChildProcesses)(await t.processId))return null;const h=Date.now();return c.lastUsedAt+m.minUseDelay>h||l.isCancellationRequested||c.config!==d?null:(c.lastUsedAt=h,t)}));return await(0,u.firstParallel)(i,t=>!!t)}insert(d,r){this._terminalInstances.set(d,{lastUsedAt:Date.now(),config:r})}free(d){const r=this._terminalInstances.get(d);r&&(r.lastUsedAt=-1)}onTerminalClosed(d){this._terminalInstances.delete(d)}}m.minUseDelay=1e3}),define(Ie[283],ke([1,0,9,2,113,32,54,33,45,38,17,26,73,11,14,68,22,63,47]),function(Q,e,u,n,y,A,D,C,S,P,L,I,_,T,w,b,p,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let f=class extends _.ExtHostTaskBase{constructor(m,o,d,r,s,i,t,c,l){super(m,o,d,r,s,i,t,c);this.workspaceService=d,this.variableResolver=l,o.remote.isRemote&&o.remote.authority?this.registerTaskSystem(T.Schemas.vscodeRemote,{scheme:T.Schemas.vscodeRemote,authority:o.remote.authority,platform:process.platform}):this.registerTaskSystem(T.Schemas.file,{scheme:T.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(m,o){const d=o;if(!o.execution&&d._id===void 0)throw new Error("Tasks to execute must include an execution");if(d._id!==void 0){const r=_.TaskHandleDTO.from(d,this.workspaceService),s=await this._proxy.$getTaskExecution(r);if(s.task===void 0)throw new Error("Task from execution DTO is undefined");const i=await this.getTaskExecution(s,o);return this._proxy.$executeTask(r).catch(()=>{}),i}else{const r=_.TaskDTO.from(o,m);if(r===void 0)return Promise.reject(new Error("Task is not valid"));_.CustomExecutionDTO.is(r.execution)&&await this.addCustomExecution(r,o,!1);const s=await this.getTaskExecution(await this._proxy.$getTaskExecution(r),o);return this._proxy.$executeTask(r).catch(()=>{}),s}}provideTasksInternal(m,o,d,r){const s=[];if(r)for(const i of r){this.checkDeprecation(i,d),(!i.definition||!m[i.definition.type])&&this._logService.warn(`The task [${i.source}, ${i.name}] uses an undefined task type. The task will be ignored in the future.`);const t=_.TaskDTO.from(i,d.extension);t&&(s.push(t),_.CustomExecutionDTO.is(t.execution)&&o.push(this.addCustomExecution(t,i,!0)))}return{tasks:s,extension:d.extension}}async resolveTaskInternal(m){return m}async getAFolder(m){let o=m&&m.length>0?m[0]:void 0;if(!o){const d=n.URI.file((0,g.homedir)());o=new S.WorkspaceFolder({uri:d,name:p.basename(d),index:0})}return{uri:o.uri,name:o.name,index:o.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(m,o){const d=n.URI.revive(m),r={process:void 0,variables:Object.create(null)},s=await this._workspaceProvider.resolveWorkspaceFolder(d),i=await this._workspaceProvider.getWorkspaceFolders2()??[],t=await this.variableResolver.getResolver(),c=s?{uri:s.uri,name:s.name,index:s.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(i);for(const l of o.variables)r.variables[l]=await t.resolveAsync(c,l);if(o.process!==void 0){let l;if(o.process.path!==void 0){l=o.process.path.split(u.delimiter);for(let h=0;h<l.length;h++)l[h]=await t.resolveAsync(c,l[h])}r.process=await y.win32.findExecutable(await t.resolveAsync(c,o.process.name),o.process.cwd!==void 0?await t.resolveAsync(c,o.process.cwd):void 0,l)}return r}async $jsonTasksSupported(){return!0}async $findExecutable(m,o,d){return y.win32.findExecutable(m,o,d)}};f=Ge([$e(0,L.IExtHostRpcService),$e(1,I.IExtHostInitDataService),$e(2,A.IExtHostWorkspace),$e(3,D.IExtHostDocumentsAndEditors),$e(4,C.IExtHostConfiguration),$e(5,P.IExtHostTerminalService),$e(6,w.ILogService),$e(7,b.IExtHostApiDeprecationService),$e(8,v.IExtHostVariableResolverProvider)],f),e.ExtHostTask=f}),define(Ie[284],ke([1,0,63,47]),function(Q,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class y extends n.ExtHostVariableResolverProviderService{homeDir(){return(0,u.homedir)()}}e.NodeExtHostVariableResolverProviderService=y}),define(Ie[139],ke([1,0,16,18,21,49,11,9,22,10,2,31]),function(Q,e,u,n,y,A,D,C,S,P,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class _{constructor(f,a,m,o){this.query=f,this.provider=a,this.fileUtils=m,this.processType=o,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(f,a){const m=this.query.folderQueries||[],o=new y.CancellationTokenSource;return a.onCancellationRequested(()=>o.cancel()),new Promise((d,r)=>{this.collector=new w(f);let s=!1;const i=(t,c)=>{if(!s&&!this.isLimitHit){const l=this.resultSize(t);p(t)&&typeof this.query.maxResults=="number"&&this.resultCount+l>this.query.maxResults&&(this.isLimitHit=!0,s=!0,o.cancel(),t=this.trimResultToSize(t,this.query.maxResults-this.resultCount));const h=this.resultSize(t);this.resultCount+=h,(h>0||!p(t))&&this.collector.add(t,c)}};Promise.all(m.map((t,c)=>this.searchInFolder(t,l=>i(l,c),o.token))).then(t=>{o.dispose(),this.collector.flush();const c=t.some(l=>!!l&&!!l.limitHit);d({limitHit:this.isLimitHit||c,messages:(0,u.flatten)(t.map(l=>l?.message?(0,P.isArray)(l.message)?l.message:[l.message]:[])),stats:{type:this.processType}})},t=>{o.dispose();const c=(0,A.toErrorMessage)(t);r(new Error(c))})})}resultSize(f){return p(f)?Array.isArray(f.ranges)?f.ranges.length:1:0}trimResultToSize(f,a){const m=Array.isArray(f.ranges)?f.ranges:[f.ranges],o=Array.isArray(f.preview.matches)?f.preview.matches:[f.preview.matches];return{ranges:m.slice(0,a),preview:{matches:o.slice(0,a),text:f.preview.text},uri:f.uri}}async searchInFolder(f,a,m){const o=new I.QueryGlobTester(this.query,f),d=[],r={report:t=>{if(!this.validateProviderResult(t))return;const c=f.folder.scheme===D.Schemas.file?(0,I.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(S.dirname(t.uri))):void 0,l=S.relativePath(f.folder,t.uri);if(l){const h=o.includedInQuery(l,C.basename(l),c);(0,n.isThenable)(h)?d.push(h.then(E=>{E&&a(t)})):h&&a(t)}}},s=this.getSearchOptionsForFolder(f),i=await this.provider.provideTextSearchResults(T(this.query.contentPattern),s,r,m);return d.length&&await Promise.all(d),i}validateProviderResult(f){if(p(f)){if(Array.isArray(f.ranges)){if(!Array.isArray(f.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(f.preview.matches.length!==f.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(f.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(f){const a=(0,I.resolvePatternsForProvider)(this.query.includePattern,f.includePattern),m=(0,I.resolvePatternsForProvider)(this.query.excludePattern,f.excludePattern),o={folder:L.URI.from(f.folder),excludes:m,includes:a,useIgnoreFiles:!f.disregardIgnoreFiles,useGlobalIgnoreFiles:!f.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!f.disregardParentIgnoreFiles,followSymlinks:!f.ignoreSymlinks,encoding:f.fileEncoding&&this.fileUtils.toCanonicalName(f.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return o.usePCRE2=this.query.usePCRE2,o}}e.TextSearchManager=_;function T(v){return{isCaseSensitive:v.isCaseSensitive||!1,isRegExp:v.isRegExp||!1,isWordMatch:v.isWordMatch||!1,isMultiline:v.isMultiline||!1,pattern:v.pattern}}class w{constructor(f){this._onResult=f,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new g(512,a=>this.sendItems(a))}add(f,a){this._currentFileMatch&&(this._currentFolderIdx!==a||!S.isEqual(this._currentUri,f.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=a,this._currentFileMatch={resource:f.uri,results:[]}),this._currentFileMatch.results.push(b(f))}pushToCollector(){const f=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,f)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(f){this._onResult(f)}}e.TextSearchResultsCollector=w;function b(v){return p(v)?{preview:{matches:(0,u.mapArrayOrNot)(v.preview.matches,f=>({startLineNumber:f.start.line,startColumn:f.start.character,endLineNumber:f.end.line,endColumn:f.end.character})),text:v.preview.text},ranges:(0,u.mapArrayOrNot)(v.ranges,f=>({startLineNumber:f.start.line,startColumn:f.start.character,endLineNumber:f.end.line,endColumn:f.end.character}))}:{text:v.text,lineNumber:v.lineNumber}}function p(v){return!!v.preview}e.extensionResultIsMatch=p;class g{constructor(f,a){this.maxBatchSize=f,this.cb=a,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(f,a){!f||this.addItemToBatch(f,a)}addItems(f,a){!f||this.addItemsToBatch(f,a)}addItemToBatch(f,a){this.batch.push(f),this.batchSize+=a,this.onUpdate()}addItemsToBatch(f,a){this.batch=this.batch.concat(f),this.batchSize+=a,this.onUpdate()}onUpdate(){this.totalNumberCompleted<g.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},g.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=g,g.TIMEOUT=4e3,g.START_BATCH_AFTER_COUNT=50}),define(Ie[76],ke([1,0,6,5,4,277,17,65,14,2,139]),function(Q,e,u,n,y,A,D,C,S,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,y.createDecorator)("IExtHostSearch");let I=class{constructor(b,p,g){this.extHostRpc=b,this._uriTransformer=p,this._logService=g,this._proxy=this.extHostRpc.getProxy(n.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new A.FileSearchManager}_transformScheme(b){return this._uriTransformer.transformOutgoingScheme(b)}registerTextSearchProvider(b,p){if(this._textSearchUsedSchemes.has(b))throw new Error(`a text search provider for the scheme '${b}' is already registered`);this._textSearchUsedSchemes.add(b);const g=this._handlePool++;return this._textSearchProvider.set(g,p),this._proxy.$registerTextSearchProvider(g,this._transformScheme(b)),(0,u.toDisposable)(()=>{this._textSearchUsedSchemes.delete(b),this._textSearchProvider.delete(g),this._proxy.$unregisterProvider(g)})}registerFileSearchProvider(b,p){if(this._fileSearchUsedSchemes.has(b))throw new Error(`a file search provider for the scheme '${b}' is already registered`);this._fileSearchUsedSchemes.add(b);const g=this._handlePool++;return this._fileSearchProvider.set(g,p),this._proxy.$registerFileSearchProvider(g,this._transformScheme(b)),(0,u.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(b),this._fileSearchProvider.delete(g),this._proxy.$unregisterProvider(g)})}$provideFileSearchResults(b,p,g,v){const f=_(g),a=this._fileSearchProvider.get(b);if(a)return this._fileSearchManager.fileSearch(f,a,m=>{this._proxy.$handleFileMatch(b,p,m.map(o=>o.resource))},v);throw new Error("unknown provider: "+b)}$clearCache(b){return this._fileSearchManager.clearCache(b),Promise.resolve(void 0)}$provideTextSearchResults(b,p,g,v){const f=this._textSearchProvider.get(b);if(!f||!f.provideTextSearchResults)throw new Error(`Unknown provider ${b}`);const a=_(g);return this.createTextSearchManager(a,f).search(o=>this._proxy.$handleTextMatch(b,p,o),v)}$enableExtensionHostSearch(){}createTextSearchManager(b,p){return new L.TextSearchManager(b,p,{readdir:g=>Promise.resolve([]),toCanonicalName:g=>g},"textSearchProvider")}};I=Ge([$e(0,D.IExtHostRpcService),$e(1,C.IURITransformerService),$e(2,S.ILogService)],I),e.ExtHostSearch=I;function _(w){return{...w,folderQueries:w.folderQueries&&w.folderQueries.map(T),extraFileResources:w.extraFileResources&&w.extraFileResources.map(b=>P.URI.revive(b))}}e.reviveQuery=_;function T(w){return{...w,folder:P.URI.revive(w.folder)}}}),define(Ie[285],ke([1,0,82,138,32,135,33,37,54,38,73,75,76,91,52,68,137,69,46,90,124,55,136,14,230,47]),function(Q,e,u,n,y,A,D,C,S,P,L,I,_,T,w,b,p,g,v,f,a,m,o,d,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,u.registerSingleton)(d.ILoggerService,o.ExtHostLoggerService),(0,u.registerSingleton)(d.ILogService,r.ExtHostLogService),(0,u.registerSingleton)(b.IExtHostApiDeprecationService,b.ExtHostApiDeprecationService),(0,u.registerSingleton)(C.IExtHostCommands,C.ExtHostCommands),(0,u.registerSingleton)(D.IExtHostConfiguration,D.ExtHostConfiguration),(0,u.registerSingleton)(g.IExtHostConsumerFileSystem,g.ExtHostConsumerFileSystem),(0,u.registerSingleton)(I.IExtHostDebugService,I.WorkerExtHostDebugService),(0,u.registerSingleton)(A.IExtHostDecorations,A.ExtHostDecorations),(0,u.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors),(0,u.registerSingleton)(v.IExtHostFileSystemInfo,v.ExtHostFileSystemInfo),(0,u.registerSingleton)(n.IExtHostOutputService,n.ExtHostOutputService),(0,u.registerSingleton)(_.IExtHostSearch,_.ExtHostSearch),(0,u.registerSingleton)(T.IExtHostStorage,T.ExtHostStorage),(0,u.registerSingleton)(L.IExtHostTask,L.WorkerExtHostTask),(0,u.registerSingleton)(P.IExtHostTerminalService,P.WorkerExtHostTerminalService),(0,u.registerSingleton)(w.IExtHostTunnelService,w.ExtHostTunnelService),(0,u.registerSingleton)(p.IExtHostWindow,p.ExtHostWindow),(0,u.registerSingleton)(y.IExtHostWorkspace,y.ExtHostWorkspace),(0,u.registerSingleton)(f.IExtHostSecretState,f.ExtHostSecretState),(0,u.registerSingleton)(a.IExtHostTelemetry,a.ExtHostTelemetry),(0,u.registerSingleton)(m.IExtHostEditorTabs,m.ExtHostEditorTabs),(0,u.registerSingleton)(s.IExtHostVariableResolverProvider,s.ExtHostVariableResolverProviderService)}),define(Ie[92],ke([1,0,16,14,31,72]),function(Q,e,u,n,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function D(I){return I.startsWith("**")||I.startsWith("/")?I:`/${I}`}e.anchorGlob=D;function C(I,_,T,w){const b=(0,u.mapArrayOrNot)(T,S),p=new y.TextSearchMatch(_,b,w),g=p.preview.matches;return{ranges:(0,u.mapArrayOrNot)(b,P),uri:I,preview:{text:p.preview.text,matches:(0,u.mapArrayOrNot)(g,P)}}}e.createTextSearchResult=C;function S(I){return new y.SearchRange(I.start.line,I.start.character,I.end.line,I.end.character)}function P(I){return new A.Range(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn)}let L=class{constructor(_,T){this.prefix=_,this.logService=T}appendLine(_){this.logService.debug(`${this.prefix}#search`,_)}};L=Ge([$e(1,n.ILogService)],L),e.OutputChannel=L}),define(Ie[286],ke([1,0,42,9,81,30,13,8,92,287]),function(Q,e,u,n,y,A,D,C,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const L=P.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function I(f,a,m,o){const d=_(f,a,m,o),r=a.folder.fsPath;return{cmd:u.spawn(L,d.args,{cwd:r}),rgDiskPath:L,siblingClauses:d.siblingClauses,rgArgs:d,cwd:r}}e.spawnRipgrepCmd=I;function _(f,a,m,o){const d=["--files","--hidden","--case-sensitive"];w([a],m,!1).forEach(s=>{const i=(0,S.anchorGlob)(s);if(d.push("-g",i),D.isMacintosh){const t=(0,y.normalizeNFD)(i);t!==i&&d.push("-g",t)}});const r=T([a],o,void 0,!1);return r.globArgs.forEach(s=>{const i=`!${(0,S.anchorGlob)(s)}`;if(d.push("-g",i),D.isMacintosh){const t=(0,y.normalizeNFD)(i);t!==i&&d.push("-g",t)}}),a.disregardIgnoreFiles!==!1?d.push("--no-ignore"):a.disregardParentIgnoreFiles!==!1&&d.push("--no-ignore-parent"),a.ignoreSymlinks||d.push("--follow"),f.exists&&d.push("--quiet"),d.push("--no-config"),a.disregardGlobalIgnoreFiles&&d.push("--no-ignore-global"),{args:d,siblingClauses:r.siblingClauses}}function T(f,a,m,o=!0){const d=[];let r={};return f.forEach(s=>{const i=Object.assign({},s.excludePattern||{},a||{}),t=b(i,o?s.folder.fsPath:void 0,m);d.push(...t.globArgs),t.siblingClauses&&(r=Object.assign(r,t.siblingClauses))}),{globArgs:d,siblingClauses:r}}e.foldersToRgExcludeGlobs=T;function w(f,a,m=!0){const o=[];return f.forEach(d=>{const r=Object.assign({},a||{},d.includePattern||{}),s=b(r,m?d.folder.fsPath:void 0);o.push(...s.globArgs)}),o}e.foldersToIncludeGlobs=w;function b(f,a,m){const o=[],d={};return Object.keys(f).forEach(r=>{if(m&&m.has(r)||!r)return;const s=f[r];r=g(a?p(a,r):r),r.startsWith("\\\\")?r="\\\\"+r.substr(2).replace(/\\/g,"/"):r=r.replace(/\\/g,"/"),typeof s=="boolean"&&s?(r.startsWith("\\\\")&&(r+="**"),o.push(v(r))):s&&s.when&&(d[r]=s)}),{globArgs:o,siblingClauses:d}}function p(f,a){return n.isAbsolute(a)?a:n.join(f,a)}e.getAbsoluteGlob=p;function g(f){return f=C.rtrim(f,"\\"),C.rtrim(f,"/")}function v(f){return A.getRoot(f).toLowerCase()==="c:/"?f.replace(/^c:[/\\]/i,"/"):f}e.fixDriveC=v}),define(Ie[288],ke([1,0,42,62,9,97,16,49,36,81,30,13,50,8,10,29,31,286,105]),function(Q,e,u,n,y,A,D,C,S,P,L,I,_,T,w,b,p,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const f=new Set;process.on("exit",()=>{f.forEach(r=>r())});class a{constructor(s){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=s,this.filePattern=s.filePattern||"",this.includePattern=s.includePattern&&S.parse(s.includePattern),this.maxResults=s.maxResults||null,this.exists=!!s.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,v.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=s.excludePattern&&S.parse(s.excludePattern),this.folderExcludePatterns=new Map,s.folderQueries.forEach(i=>{const t=Object.assign({},i.excludePattern||{},this.config.excludePattern||{}),c=i.folder.fsPath;s.folderQueries.map(l=>l.folder.fsPath).filter(l=>l!==c).forEach(l=>{(0,L.isEqualOrParent)(l,c)&&(t[y.relative(c,l)]=!0)}),this.folderExcludePatterns.set(c,new o(t,c))})}cancel(){this.isCanceled=!0,f.forEach(s=>s())}walk(s,i,t,c,l){if(this.fileWalkSW=_.StopWatch.create(!1),this.isCanceled)return l(null,this.isLimitHit);i.forEach(h=>{const E=y.basename(h.fsPath);this.globalExcludePattern&&this.globalExcludePattern(h.fsPath,E)||this.matchFile(t,{relativePath:h.fsPath,searchPath:void 0})}),this.cmdSW=_.StopWatch.create(!1),this.parallel(s,(h,E)=>{this.call(this.cmdTraversal,this,h,t,c,R=>{if(R){const N=(0,C.toErrorMessage)(R);console.error(N),this.errors.push(N),E(R,void 0)}else E(null,void 0)})},(h,E)=>{this.fileWalkSW.stop();const R=h?D.coalesce(h)[0]:null;l(R,this.isLimitHit)})}parallel(s,i,t){const c=new Array(s.length),l=new Array(s.length);let h=!1,E=0;if(s.length===0)return t(null,[]);s.forEach((R,N)=>{i(R,(O,k)=>{if(O?(h=!0,c[N]=null,l[N]=O):(c[N]=k,l[N]=null),++E===s.length)return t(h?l:null,c)})})}call(s,i,...t){try{s.apply(i,t)}catch(c){t[t.length-1](c)}}cmdTraversal(s,i,t,c){const l=s.folder.fsPath,h=I.isMacintosh,E=()=>U&&U.kill();f.add(E);let R=B=>{f.delete(E),R=()=>{},c(B)},N="";const O=this.initDirectoryTree(),k=(0,g.spawnRipgrepCmd)(this.config,s,this.config.includePattern,this.folderExcludePatterns.get(s.folder.fsPath).expression),U=k.cmd,F=!Object.keys(k.siblingClauses).length,$=k.rgArgs.args.map(B=>B.match(/^-/)?B:`'${B}'`).join(" ");let ee=`${k.rgDiskPath} ${$}
 - cwd: ${k.cwd}`;k.rgArgs.siblingClauses&&(ee+=`
 - Sibling clauses: ${JSON.stringify(k.rgArgs.siblingClauses)}`),t({message:ee}),this.cmdResultCount=0,this.collectStdout(U,"utf8",t,(B,z,q)=>{if(B){R(B);return}if(this.isLimitHit){R();return}const j=(N+(h?P.normalizeNFC(z||""):z)).split(`
`);if(q){const ne=j.length;j[ne-1]=j[ne-1].trim(),j[ne-1]||j.pop()}else N=j.pop()||"";if(j.length&&j[0].indexOf(`
`)!==-1){R(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=j.length,F){for(const ne of j)if(this.matchFile(i,{base:l,relativePath:ne,searchPath:this.getSearchPath(s,ne)}),this.isLimitHit){E();break}(q||this.isLimitHit)&&R();return}this.addDirectoryEntries(s,O,l,j,i),q&&(this.matchDirectoryTree(O,l,i),R())})}spawnFindCmd(s){const i=this.folderExcludePatterns.get(s.folder.fsPath),t=i.getBasenameTerms(),c=i.getPathTerms(),l=["-L","."];if(t.length||c.length){l.push("-not","(","(");for(const h of t)l.push("-name",h),l.push("-o");for(const h of c)l.push("-path",h),l.push("-o");l.pop(),l.push(")","-prune",")")}return l.push("-type","f"),u.spawn("find",l,{cwd:s.folder.fsPath})}readStdout(s,i,t){let c="";this.collectStdout(s,i,()=>{},(l,h,E)=>{if(l){t(l);return}c+=h,E&&t(null,c)})}collectStdout(s,i,t,c){let l=(R,N,O)=>{(R||O)&&(l=()=>{},this.cmdSW&&this.cmdSW.stop()),c(R,N,O)},h=!1;s.stdout?(this.forwardData(s.stdout,i,l),s.stdout.once("data",()=>h=!0)):t({message:"stdout is null"});let E;s.stderr?E=this.collectData(s.stderr):t({message:"stderr is null"}),s.on("error",R=>{l(R)}),s.on("close",R=>{let N;!h&&(N=this.decodeData(E,i))&&d(N)?l(new Error(`command failed with error code ${R}: ${this.decodeData(E,i)}`)):(this.exists&&R===0&&(this.isLimitHit=!0),l(null,"",!0))})}forwardData(s,i,t){const c=new A.StringDecoder(i);return s.on("data",l=>{t(null,c.write(l))}),c}collectData(s){const i=[];return s.on("data",t=>{i.push(t)}),i}decodeData(s,i){const t=new A.StringDecoder(i);return s.map(c=>t.write(c)).join("")}initDirectoryTree(){const s={rootEntries:[],pathToEntries:Object.create(null)};return s.pathToEntries["."]=s.rootEntries,s}addDirectoryEntries(s,{pathToEntries:i},t,c,l){c.indexOf(this.filePattern)!==-1&&this.matchFile(l,{base:t,relativePath:this.filePattern,searchPath:this.getSearchPath(s,this.filePattern)});const h=E=>{const R=y.basename(E),N=y.dirname(E);let O=i[N];O||(O=i[N]=[],h(N)),O.push({base:t,relativePath:E,basename:R,searchPath:this.getSearchPath(s,E)})};c.forEach(h)}matchDirectoryTree({rootEntries:s,pathToEntries:i},t,c){const l=this,h=this.folderExcludePatterns.get(t),E=this.filePattern;function R(N){l.directoriesWalked++;const O=(0,p.hasSiblingFn)(()=>N.map(k=>k.basename));for(let k=0,U=N.length;k<U;k++){const F=N[k],{relativePath:$,basename:ee}=F;if(h.test($,ee,E!==ee?O:void 0))continue;const B=i[$];if(B)R(B);else{if(l.filesWalked++,$===E)continue;l.matchFile(c,F)}if(l.isLimitHit)break}}R(s)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(s,i,t,c,l){const h=s.folder,E=(0,p.hasSiblingFn)(()=>t);this.parallel(t,(R,N)=>{if(this.isCanceled||this.isLimitHit)return N(null);const O=i?[i,R].join(y.sep):R;if(this.folderExcludePatterns.get(s.folder.fsPath).test(O,R,this.config.filePattern!==R?E:void 0))return N(null);const k=[h.fsPath,O].join(y.sep);n.lstat(k,(U,F)=>{if(U||this.isCanceled||this.isLimitHit)return N(null);this.statLinkIfNeeded(k,F,($,ee)=>$||this.isCanceled||this.isLimitHit?N(null):ee.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(k,F,(B,z)=>B||this.isCanceled||this.isLimitHit||(z=z||"",this.walkedPaths[z])?N(null):(this.walkedPaths[z]=!0,b.Promises.readdir(k).then(q=>{if(this.isCanceled||this.isLimitHit)return N(null);this.doWalk(s,O,q,c,V=>N(V||null))},q=>{N(null)})))):(this.filesWalked++,O===this.filePattern||this.maxFilesize&&w.isNumber(ee.size)&&ee.size>this.maxFilesize||this.matchFile(c,{base:h.fsPath,relativePath:O,searchPath:this.getSearchPath(s,O)}),N(null,void 0)))})},R=>{const N=R&&D.coalesce(R);return l(N&&N.length>0?N[0]:void 0)})}matchFile(s,i){this.isFileMatch(i)&&(!this.includePattern||this.includePattern(i.relativePath,y.basename(i.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||s(i))}isFileMatch(s){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,p.isFilePatternMatch)(s,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(s,i,t){return i.isSymbolicLink()?n.stat(s,t):t(null,i)}realPathIfNeeded(s,i,t){return i.isSymbolicLink()?n.realpath(s,(c,l)=>c?t(c):t(null,l)):t(null,s)}getSearchPath(s,i){return s.folderName?y.join(s.folderName,i):i}}e.FileWalker=a;class m{constructor(s){this.folderQueries=s.folderQueries,this.extraFiles=s.extraFileResources||[],this.walker=new a(s)}search(s,i,t){this.walker.walk(this.folderQueries,this.extraFiles,s,i,(c,l)=>{t(c,{limitHit:l,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=m;class o{constructor(s,i){this.expression=s,this.root=i,this.init(s)}init(s){let i,t;Object.keys(s).filter(c=>s[c]).forEach(c=>{y.isAbsolute(c)?(i=i||S.getEmptyExpression(),i[c]=s[c]):(t=t||S.getEmptyExpression(),t[c]=s[c])}),this.absoluteParsedExpr=i&&S.parse(i,{trimForExclusions:!0}),this.relativeParsedExpr=t&&S.parse(t,{trimForExclusions:!0})}test(s,i,t){return this.relativeParsedExpr&&this.relativeParsedExpr(s,i,t)||this.absoluteParsedExpr&&this.absoluteParsedExpr(y.join(this.root,s),i,t)}getBasenameTerms(){const s=[];return this.absoluteParsedExpr&&s.push(...S.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&s.push(...S.getBasenameTerms(this.relativeParsedExpr)),s}getPathTerms(){const s=[];return this.absoluteParsedExpr&&s.push(...S.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&s.push(...S.getPathTerms(this.relativeParsedExpr)),s}}function d(r){const s=r.trim().split(`
`),i=s[0].trim();if(i.startsWith("Error parsing regex"))return i;if(i.startsWith("regex parse error"))return T.uppercaseFirstLetter(s[s.length-1].trim());if(i.startsWith("error parsing glob")||i.startsWith("unsupported encoding"))return i.charAt(0).toUpperCase()+i.substr(1);if(i==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(i.startsWith("Literal "))return i}e.rgErrorMsgForDisplay=d}),define(Ie[289],ke([1,0,95,23]),function(Q,e,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function y(r){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(s=>s===r)}e.isUTFEncoding=y,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const A=512,D=512,C=512*8,S=512*128;var P;(function(r){r[r.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(P=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class L extends Error{constructor(s,i){super(s);this.decodeStreamErrorKind=i}}e.DecodeStreamError=L;class I{constructor(s){this.iconvLiteDecoder=s}static async create(s){let i;if(s!==e.UTF8)i=(await new Promise((c,l)=>{Q(["@vscode/iconv-lite-umd"],c,l)})).getDecoder(b(s));else{const t=new TextDecoder;i={write(c){return t.decode(c,{stream:!0})},end(){return t.decode()}}}return new I(i)}write(s){return this.iconvLiteDecoder.write(s)}end(){return this.iconvLiteDecoder.end()}}function _(r,s){const i=s.minBytesRequiredForDetection??s.guessEncoding?C:D;return new Promise((t,c)=>{const l=(0,u.newWriteableStream)(k=>k.join("")),h=[];let E=0,R,N;const O=async()=>{try{const k=await d({buffer:n.VSBuffer.concat(h),bytesRead:E},s.guessEncoding);if(k.seemsBinary&&s.acceptTextOnly)throw new L("Stream is binary but only text is accepted for decoding",1);k.encoding=await s.overwriteEncoding(k.encoding),R=await I.create(k.encoding);const U=R.write(n.VSBuffer.concat(h).buffer);l.write(U),h.length=0,E=0,t({stream:l,detected:k})}catch(k){N?.dispose(),l.destroy(),c(k)}};N=(0,u.listenStream)(r,{onData:async k=>{R?l.write(R.write(k.buffer)):(h.push(k),E+=k.byteLength,E>=i&&(r.pause(),await O(),setTimeout(()=>r.resume())))},onError:k=>l.error(k),onEnd:async()=>{R||await O(),l.end(R?.end())}})})}e.toDecodeStream=_;async function T(r,s,i){const c=(await new Promise((E,R)=>{Q(["@vscode/iconv-lite-umd"],E,R)})).getEncoder(b(s),i);let l=!1,h=!1;return{read(){if(h)return null;const E=r.read();if(typeof E!="string"){if(h=!0,!l&&i?.addBOM)switch(s){case e.UTF8:case e.UTF8_with_bom:return n.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return n.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return n.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const R=c.end();return R&&R.length>0?(l=!0,n.VSBuffer.wrap(R)):null}return l=!0,n.VSBuffer.wrap(c.write(E))}}}e.toEncodeReadable=T;async function w(r){return(await new Promise((i,t)=>{Q(["@vscode/iconv-lite-umd"],i,t)})).encodingExists(b(r))}e.encodingExists=w;function b(r){return r===e.UTF8_with_bom||r===null?e.UTF8:r}e.toNodeEncoding=b;function p(r,s){if(!r||s<e.UTF16be_BOM.length)return null;const i=r.readUInt8(0),t=r.readUInt8(1);if(i===e.UTF16be_BOM[0]&&t===e.UTF16be_BOM[1])return e.UTF16be;if(i===e.UTF16le_BOM[0]&&t===e.UTF16le_BOM[1])return e.UTF16le;if(s<e.UTF8_BOM.length)return null;const c=r.readUInt8(2);return i===e.UTF8_BOM[0]&&t===e.UTF8_BOM[1]&&c===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=p;const g=["ascii","utf-16","utf-32"];async function v(r){const s=await new Promise((h,E)=>{Q(["jschardet"],h,E)}),i=r.slice(0,S),t=m(i.buffer),c=s.detect(t);if(!c||!c.encoding)return null;const l=c.encoding.toLowerCase();return 0<=g.indexOf(l)?null:a(c.encoding)}const f={ibm866:"cp866",big5:"cp950"};function a(r){const s=r.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return f[s]||s}function m(r){let s="";for(let i=0;i<r.length;i++)s+=String.fromCharCode(r[i]);return s}function o(r){switch(r){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const s=r.match(/windows(\d+)/);return s?"windows-"+s[1]:r}}}e.toCanonicalName=o;function d({buffer:r,bytesRead:s},i){let t=p(r,s),c=!1;if(t!==e.UTF16be&&t!==e.UTF16le&&r){let l=!0,h=!0,E=!1;for(let R=0;R<s&&R<A;R++){const N=R%2==1,O=r.readUInt8(R)===0;if(O&&(E=!0),l&&(N&&!O||!N&&O)&&(l=!1),h&&(N&&O||!N&&!O)&&(h=!1),O&&!l&&!h)break}E&&(l?t=e.UTF16le:h?t=e.UTF16be:c=!0)}return i&&!c&&!t&&r?v(r.slice(0,s)).then(l=>({seemsBinary:!1,encoding:l})):{seemsBinary:c,encoding:t}}e.detectEncodingFromBuffer=d,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(Ie[140],ke([1,0,289,29,139]),function(Q,e,u,n,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class A extends y.TextSearchManager{constructor(C,S,P=n,L="searchProcess"){super(C,S,{readdir:I=>P.Promises.readdir(I.fsPath),toCanonicalName:I=>(0,u.toCanonicalName)(I)},L)}}e.NativeTextSearchManager=A}),define(Ie[290],ke([1,0]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class u{constructor(){this._dragOperations=new Map,this._renderedElements=new Map}removeDragOperationTransfer(y){if(y&&this._dragOperations.has(y)){const A=this._dragOperations.get(y);return this._dragOperations.delete(y),A}}addDragOperationTransfer(y,A){this._dragOperations.set(y,A)}getRenderedTreeElement(y){if(this._renderedElements.has(y))return this._renderedElements.get(y)}addRenderedTreeItemElement(y,A){this._renderedElements.set(y,A)}removeRenderedTreeItemElement(y){this._renderedElements.has(y)&&this._renderedElements.delete(y)}}e.TreeviewsService=u}),define(Ie[291],ke([1,0,176,7,22,2,3,6,18,7,10,16,15,21,290,27]),function(Q,e,u,n,y,A,D,C,S,P,L,I,_,T,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function p(f,a){if((0,L.isString)(f))return{label:f};if(f&&typeof f=="object"&&typeof f.label=="string"){let m;return Array.isArray(f.highlights)&&(m=f.highlights.filter(o=>o.length===2&&typeof o[0]=="number"&&typeof o[1]=="number"),m=m.length?m:void 0),{label:f.label,highlights:m}}}class g{constructor(a,m,o){this._proxy=a,this.commands=m,this.logService=o,this.treeViews=new Map,this.treeDragAndDropService=new w.TreeviewsService;function d(r){return r&&r.$treeViewId&&r.$treeItemHandle}m.registerArgumentProcessor({processArgument:r=>d(r)?this.convertArgument(r):Array.isArray(r)&&r.length>0?r.map(s=>d(s)?this.convertArgument(s):s):r})}registerTreeDataProvider(a,m,o){const d=this.createTreeView(a,{treeDataProvider:m},o);return{dispose:()=>d.dispose()}}createTreeView(a,m,o){if(!m||!m.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const d=m.dragAndDropController?.dropMimeTypes??[],r=m.dragAndDropController?.dragMimeTypes??[],s=!!m.dragAndDropController?.handleDrag,i=!!m.dragAndDropController?.handleDrop,t=this._proxy.$registerTreeViewDataProvider(a,{showCollapseAll:!!m.showCollapseAll,canSelectMany:!!m.canSelectMany,dropMimeTypes:d,dragMimeTypes:r,hasHandleDrag:s,hasHandleDrop:i}),c=this.createExtHostTreeView(a,m,o);return{get onDidCollapseElement(){return c.onDidCollapseElement},get onDidExpandElement(){return c.onDidExpandElement},get selection(){return c.selectedElements},get onDidChangeSelection(){return c.onDidChangeSelection},get visible(){return c.visible},get onDidChangeVisibility(){return c.onDidChangeVisibility},get message(){return c.message},set message(l){c.message=l},get title(){return c.title},set title(l){c.title=l},get description(){return c.description},set description(l){c.description=l},get badge(){return(0,b.checkProposedApiEnabled)(o,"badges"),c.badge},set badge(l){(0,b.checkProposedApiEnabled)(o,"badges"),c.badge=l},reveal:(l,h)=>c.reveal(l,h),dispose:async()=>{await t,this.treeViews.delete(a),c.dispose()}}}$getChildren(a,m){const o=this.treeViews.get(a);return o?o.getChildren(m):Promise.reject(new Error((0,u.localize)(0,null,a)))}async $handleDrop(a,m,o,d,r,s,i,t){const c=this.treeViews.get(a);if(!c)return Promise.reject(new Error((0,u.localize)(1,null,a)));const l=_.DataTransfer.toDataTransfer(o,async h=>(await this._proxy.$resolveDropFileData(a,m,h)).buffer);return i===a&&t&&await this.addAdditionalTransferItems(l,c,t,r,s),c.onDrop(l,d,r)}async addAdditionalTransferItems(a,m,o,d,r){const s=this.treeDragAndDropService.removeDragOperationTransfer(r);if(s)(await s)?.forEach((i,t)=>{i&&a.set(t,i)});else if(r&&m.handleDrag){const i=m.handleDrag(o,a,d);this.treeDragAndDropService.addDragOperationTransfer(r,i),await i}return a}async $handleDrag(a,m,o,d){const r=this.treeViews.get(a);if(!r)return Promise.reject(new Error((0,u.localize)(2,null,a)));const s=await this.addAdditionalTransferItems(new n.DataTransfer,r,m,d,o);if(!!s)return _.DataTransfer.toDataTransferDTO(s)}async $hasResolve(a){const m=this.treeViews.get(a);if(!m)throw new Error((0,u.localize)(3,null,a));return m.hasResolve}$resolve(a,m,o){const d=this.treeViews.get(a);if(!d)throw new Error((0,u.localize)(4,null,a));return d.resolveTreeItem(m,o)}$setExpanded(a,m,o){const d=this.treeViews.get(a);if(!d)throw new Error((0,u.localize)(5,null,a));d.setExpanded(m,o)}$setSelection(a,m){const o=this.treeViews.get(a);if(!o)throw new Error((0,u.localize)(6,null,a));o.setSelection(m)}$setVisible(a,m){const o=this.treeViews.get(a);if(!o)throw new Error((0,u.localize)(7,null,a));o.setVisible(m)}createExtHostTreeView(a,m,o){const d=new v(a,m,this._proxy,this.commands.converter,this.logService,o);return this.treeViews.set(a,d),d}convertArgument(a){const m=this.treeViews.get(a.$treeViewId);return m?m.getExtensionElement(a.$treeItemHandle):null}}e.ExtHostTreeViews=g;class v extends C.Disposable{constructor(a,m,o,d,r,s){super();if(this.viewId=a,this.proxy=o,this.commands=d,this.logService=r,this.extension=s,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new D.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new D.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new D.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new D.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new D.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new T.CancellationTokenSource,s.contributes&&s.contributes.views)for(const c in s.contributes.views)for(const l of s.contributes.views[c])l.id===a&&(this._title=l.name);this.dataProvider=m.treeDataProvider,this.dndController=m.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(c=>this._onDidChangeData.fire({message:!1,element:c})));let i,t;this._register(D.Event.debounce(this._onDidChangeData.event,(c,l)=>(c||(c={message:!1,elements:[]}),l.element!==!1&&(i||(i=new Promise(h=>t=h),this.refreshPromise=this.refreshPromise.then(()=>i)),Array.isArray(l.element)?c.elements.push(...l.element):c.elements.push(l.element)),l.message&&(c.message=!0),c),200,!0)(({message:c,elements:l})=>{l.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const h=t;return i=null,this.refresh(l).then(()=>h())})),c&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(a=>this.getExtensionElement(a)).filter(a=>!(0,L.isUndefinedOrNull)(a))}async getChildren(a){const m=a?this.getExtensionElement(a):void 0;if(a&&!m)return this.logService.error(`No tree item with id '${a}' found.`),Promise.resolve([]);let o=this.getChildrenNodes(a);return o||(o=await this.fetchChildrenNodes(m)),o?o.map(d=>d.item):void 0}getExtensionElement(a){return this.elements.get(a)}reveal(a,m){m=m||{select:!0,focus:!1};const o=(0,L.isUndefinedOrNull)(m.select)?!0:m.select,d=(0,L.isUndefinedOrNull)(m.focus)?!1:m.focus,r=(0,L.isUndefinedOrNull)(m.expand)?!1:m.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):a?this.refreshPromise.then(()=>this.resolveUnknownParentChain(a)).then(s=>this.resolveTreeNode(a,s[s.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:s.map(t=>t.item)},{select:o,focus:d,expand:r})),s=>this.logService.error(s)):this.proxy.$reveal(this.viewId,void 0,{select:o,focus:d,expand:r})}get message(){return this._message}set message(a){this._message=a,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(a){this._title=a,this.proxy.$setTitle(this.viewId,a,this._description)}get description(){return this._description}set description(a){this._description=a,this.proxy.$setTitle(this.viewId,this._title,a)}get badge(){return this._badge}set badge(a){this._badge?.value===a?.value&&this._badge?.tooltip===a?.tooltip||(this._badge=_.ViewBadge.from(a),this.proxy.$setBadge(this.viewId,a))}setExpanded(a,m){const o=this.getExtensionElement(a);o&&(m?this._onDidExpandElement.fire(Object.freeze({element:o})):this._onDidCollapseElement.fire(Object.freeze({element:o})))}setSelection(a){(0,I.equals)(this._selectedHandles,a)||(this._selectedHandles=a,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(a){a!==this._visible&&(this._visible=a,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async handleDrag(a,m,o){const d=[];for(const r of a){const s=this.getExtensionElement(r);s&&d.push(s)}if(!(!this.dndController?.handleDrag||d.length===0))return await this.dndController.handleDrag(d,m,o),m}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(a,m,o){const d=m?this.getExtensionElement(m):void 0;if(!(!d&&m||!this.dndController?.handleDrop))return(0,S.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(d,a,o):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(a,m){if(!this.dataProvider.resolveTreeItem)return;const o=this.elements.get(a);if(o){const d=this.nodes.get(o);if(d){const r=await this.dataProvider.resolveTreeItem(d.extensionItem,o,m)??d.extensionItem;return d.item.tooltip=this.getTooltip(r.tooltip),d.item.command=this.getCommand(d.disposableStore,r.command),d.item}}}resolveUnknownParentChain(a){return this.resolveParent(a).then(m=>m?this.resolveUnknownParentChain(m).then(o=>this.resolveTreeNode(m,o[o.length-1]).then(d=>(o.push(d),o))):Promise.resolve([]))}resolveParent(a){const m=this.nodes.get(a);return m?Promise.resolve(m.parent?this.elements.get(m.parent.item.handle):void 0):(0,S.asPromise)(()=>this.dataProvider.getParent(a))}resolveTreeNode(a,m){const o=this.nodes.get(a);return o?Promise.resolve(o):(0,S.asPromise)(()=>this.dataProvider.getTreeItem(a)).then(d=>this.createHandle(a,d,m,!0)).then(d=>this.getChildren(m?m.item.handle:void 0).then(()=>{const r=this.getExtensionElement(d);if(r){const s=this.nodes.get(r);if(s)return Promise.resolve(s)}throw new Error(`Cannot resolve tree item for element ${d}`)}))}getChildrenNodes(a){if(a){let m;if(typeof a=="string"){const o=this.getExtensionElement(a);m=o?this.nodes.get(o):void 0}else m=a;return m&&m.children||void 0}return this.roots}async fetchChildrenNodes(a){this.clearChildren(a);const m=new T.CancellationTokenSource(this._refreshCancellationSource.token);try{const o=a?this.nodes.get(a):void 0,d=await this.dataProvider.getChildren(a);if(m.token.isCancellationRequested)return;const r=await Promise.all((0,I.coalesce)(d||[]).map(async s=>{const i=await this.dataProvider.getTreeItem(s);return i&&!m.token.isCancellationRequested?this.createAndRegisterTreeNode(s,i,o):null}));return m.token.isCancellationRequested?void 0:(0,I.coalesce)(r)}finally{m.dispose()}}refresh(a){if(a.some(o=>!o))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new T.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const o=this.getHandlesToRefresh(a);if(o.length)return this.refreshHandles(o)}return Promise.resolve(void 0)}getHandlesToRefresh(a){const m=new Set,o=a.map(r=>this.nodes.get(r));for(const r of o)if(r&&!m.has(r.item.handle)){let s=r;for(;s&&s.parent&&o.findIndex(i=>s&&s.parent&&i&&i.item.handle===s.parent.item.handle)===-1;){const i=this.elements.get(s.parent.item.handle);s=i?this.nodes.get(i):void 0}s&&!s.parent&&m.add(r.item.handle)}const d=[];return m.forEach(r=>{const s=this.elements.get(r);if(s){const i=this.nodes.get(s);i&&(!i.parent||!m.has(i.parent.item.handle))&&d.push(r)}}),d}refreshHandles(a){const m={};return Promise.all(a.map(o=>this.refreshNode(o).then(d=>{d&&(m[o]=d.item)}))).then(()=>Object.keys(m).length?this.proxy.$refresh(this.viewId,m):void 0)}refreshNode(a){const m=this.getExtensionElement(a);if(m){const o=this.nodes.get(m);if(o)return this.clearChildren(m),(0,S.asPromise)(()=>this.dataProvider.getTreeItem(m)).then(d=>{if(d){const r=this.createTreeNode(m,d,o.parent);return this.updateNodeCache(m,r,o,o.parent),o.dispose(),r}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(a,m,o){const d=this.createTreeNode(a,m,o);if(m.id&&this.elements.has(d.item.handle))throw new Error((0,u.localize)(8,null,m.id));return this.addNodeToCache(a,d),this.addNodeToParentCache(d,o),d}getTooltip(a){return P.MarkdownString.isMarkdownString(a)?_.MarkdownString.from(a):a}getCommand(a,m){return m?this.commands.toInternal(m,a):void 0}createTreeNode(a,m,o){const d=new C.DisposableStore,r=this.createHandle(a,m,o),s=this.getLightIconPath(m);return{item:{handle:r,parentHandle:o?o.item.handle:void 0,label:p(m.label,this.extension),description:m.description,resourceUri:m.resourceUri,tooltip:this.getTooltip(m.tooltip),command:this.getCommand(d,m.command),contextValue:m.contextValue,icon:s,iconDark:this.getDarkIconPath(m)||s,themeIcon:this.getThemeIcon(m),collapsibleState:(0,L.isUndefinedOrNull)(m.collapsibleState)?P.TreeItemCollapsibleState.None:m.collapsibleState,accessibilityInformation:m.accessibilityInformation},extensionItem:m,parent:o,children:void 0,disposableStore:d,dispose(){d.dispose()}}}getThemeIcon(a){return a.iconPath instanceof P.ThemeIcon?a.iconPath:void 0}createHandle(a,{id:m,label:o,resourceUri:d},r,s){if(m)return`${v.ID_HANDLE_PREFIX}/${m}`;const i=p(o,this.extension),t=r?r.item.handle:v.LABEL_HANDLE_PREFIX;let c=i?i.label:d?(0,y.basename)(d):"";c=c.indexOf("/")!==-1?c.replace("/","//"):c;const l=this.nodes.has(a)?this.nodes.get(a).item.handle:void 0,h=this.getChildrenNodes(r)||[];let E,R=0;do{if(E=`${t}/${R}:${c}`,s||!this.elements.has(E)||l===E)break;R++}while(R<=h.length);return E}getLightIconPath(a){if(a.iconPath&&!(a.iconPath instanceof P.ThemeIcon))return typeof a.iconPath=="string"||A.URI.isUri(a.iconPath)?this.getIconPath(a.iconPath):this.getIconPath(a.iconPath.light)}getDarkIconPath(a){if(a.iconPath&&!(a.iconPath instanceof P.ThemeIcon)&&a.iconPath.dark)return this.getIconPath(a.iconPath.dark)}getIconPath(a){return A.URI.isUri(a)?a:A.URI.file(a)}addNodeToCache(a,m){this.elements.set(m.item.handle,a),this.nodes.set(a,m)}updateNodeCache(a,m,o,d){this.elements.delete(m.item.handle),this.nodes.delete(a),m.item.handle!==o.item.handle&&this.elements.delete(o.item.handle),this.addNodeToCache(a,m);const r=this.getChildrenNodes(d)||[],s=r.filter(i=>i.item.handle===o.item.handle)[0];s&&r.splice(r.indexOf(s),1,m)}addNodeToParentCache(a,m){m?(m.children||(m.children=[]),m.children.push(a)):(this.roots||(this.roots=[]),this.roots.push(a))}clearChildren(a){if(a){const m=this.nodes.get(a);if(m){if(m.children)for(const o of m.children){const d=this.elements.get(o.item.handle);d&&this.clear(d)}m.children=void 0}}else this.clearAll()}clear(a){const m=this.nodes.get(a);if(m){if(m.children)for(const o of m.children){const d=this.elements.get(o.item.handle);d&&this.clear(d)}this.nodes.delete(a),this.elements.delete(m.item.handle),m.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(a=>a.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}v.LABEL_HANDLE_PREFIX="0",v.ID_HANDLE_PREFIX="1"}),define(Ie[292],ke([1,0,21,12,3,41,2,114,100,149,158,43,5,134,239,238,37,240,33,242,243,244,222,245,54,39,246,247,250,251,252,138,225,256,257,258,91,38,260,291,15,7,263,71,137,32,213,249,122,135,73,75,76,14,65,17,26,253,209,52,68,236,261,70,69,266,264,265,237,46,259,262,90,55,124,254,72,255,11,117,224,207,248,6,27,214,8]),function(Q,e,u,n,y,A,D,C,S,P,L,I,_,T,w,b,p,g,v,f,a,m,o,d,r,s,i,t,c,l,h,E,R,N,O,k,U,F,$,ee,B,z,q,V,j,ne,Y,le,ue,K,ge,ye,Te,pe,Pe,fe,ve,_e,ae,he,te,ie,M,H,G,X,de,be,se,De,Ce,ze,Ke,Ne,Ye,Z,re,Se,We,oe,Re,Be,qe,je,Ve,nt,ot){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function st(it){const at=it.get(ve.IExtHostInitDataService),wt=it.get(De.IExtHostFileSystemInfo),Tt=it.get(G.IExtHostConsumerFileSystem),_t=it.get(s.IExtHostExtensionService),ft=it.get(ne.IExtHostWorkspace),It=it.get(Ye.IExtHostTelemetry),Ft=it.get(v.IExtHostConfiguration),At=it.get(Pe.IURITransformerService),Xe=it.get(fe.IExtHostRpcService),Rt=it.get(U.IExtHostStorage),Mt=it.get(H.IExtensionStoragePaths),Ot=it.get(pe.ILoggerService),mt=it.get(pe.ILogService),Dt=it.get(he.IExtHostTunnelService),Ae=it.get(te.IExtHostApiDeprecationService),Oe=it.get(j.IExtHostWindow),Ee=it.get(Ke.IExtHostSecretState),J=it.get(Ne.IExtHostEditorTabs);Xe.set(_.ExtHostContext.ExtHostFileSystemInfo,wt),Xe.set(_.ExtHostContext.ExtHostLogLevelServiceShape,Ot),Xe.set(_.ExtHostContext.ExtHostWorkspace,ft),Xe.set(_.ExtHostContext.ExtHostConfiguration,Ft),Xe.set(_.ExtHostContext.ExtHostExtensionService,_t),Xe.set(_.ExtHostContext.ExtHostStorage,Rt),Xe.set(_.ExtHostContext.ExtHostTunnelService,Dt),Xe.set(_.ExtHostContext.ExtHostWindow,Oe),Xe.set(_.ExtHostContext.ExtHostSecretState,Ee),Xe.set(_.ExtHostContext.ExtHostTelemetry,It),Xe.set(_.ExtHostContext.ExtHostEditorTabs,J);const Fe=Xe.set(_.ExtHostContext.ExtHostDecorations,it.get(K.IExtHostDecorations)),xe=Xe.set(_.ExtHostContext.ExtHostDocumentsAndEditors,it.get(r.IExtHostDocumentsAndEditors)),Je=Xe.set(_.ExtHostContext.ExtHostCommands,it.get(p.IExtHostCommands)),et=Xe.set(_.ExtHostContext.ExtHostTerminalService,it.get(F.IExtHostTerminalService)),Ze=Xe.set(_.ExtHostContext.ExtHostDebugService,it.get(ye.IExtHostDebugService)),gt=Xe.set(_.ExtHostContext.ExtHostSearch,it.get(Te.IExtHostSearch)),pt=Xe.set(_.ExtHostContext.ExtHostTask,it.get(ge.IExtHostTask)),yt=Xe.set(_.ExtHostContext.ExtHostOutputService,it.get(E.IExtHostOutputService)),vt=Xe.set(_.ExtHostContext.ExtHostUrls,new q.ExtHostUrls(Xe)),ht=Xe.set(_.ExtHostContext.ExtHostDocuments,new d.ExtHostDocuments(Xe,xe)),Kt=Xe.set(_.ExtHostContext.ExtHostDocumentContentProviders,new m.ExtHostDocumentContentProvider(Xe,xe,mt)),Xt=Xe.set(_.ExtHostContext.ExtHostDocumentSaveParticipant,new o.ExtHostDocumentSaveParticipant(mt,ht,Xe.getProxy(_.MainContext.MainThreadBulkEdits))),Et=Xe.set(_.ExtHostContext.ExtHostNotebook,new _e.ExtHostNotebookController(Xe,Je,xe,ht,Mt)),rn=Xe.set(_.ExtHostContext.ExtHostNotebookDocuments,new Be.ExtHostNotebookDocuments(Et)),Ut=Xe.set(_.ExtHostContext.ExtHostNotebookEditors,new Re.ExtHostNotebookEditors(mt,Et)),sn=Xe.set(_.ExtHostContext.ExtHostNotebookKernels,new Z.ExtHostNotebookKernels(Xe,at,Et,Je,mt)),kn=Xe.set(_.ExtHostContext.ExtHostNotebookRenderers,new Se.ExtHostNotebookRenderers(Xe,Et)),kt=Xe.set(_.ExtHostContext.ExtHostEditors,new $.ExtHostEditors(Xe,xe)),xt=Xe.set(_.ExtHostContext.ExtHostTreeViews,new ee.ExtHostTreeViews(Xe.getProxy(_.MainContext.MainThreadTreeViews),Je,mt)),fn=Xe.set(_.ExtHostContext.ExtHostEditorInsets,new Y.ExtHostEditorInsets(Xe.getProxy(_.MainContext.MainThreadEditorInsets),kt,at.remote)),Qt=Xe.set(_.ExtHostContext.ExtHostDiagnostics,new f.ExtHostDiagnostics(Xe,mt,wt)),Yt=Xe.set(_.ExtHostContext.ExtHostLanguages,new l.ExtHostLanguages(Xe,ht,Je.converter,At)),dt=Xe.set(_.ExtHostContext.ExtHostLanguageFeatures,new c.ExtHostLanguageFeatures(Xe,At,ht,Je,Qt,mt,Ae)),mn=Xe.set(_.ExtHostContext.ExtHostFileSystem,new i.ExtHostFileSystem(Xe,dt)),Bt=Xe.set(_.ExtHostContext.ExtHostFileSystemEventService,new t.ExtHostFileSystemEventService(Xe,mt,xe)),Vt=Xe.set(_.ExtHostContext.ExtHostQuickOpen,(0,N.createExtHostQuickOpen)(Xe,ft,Je)),on=Xe.set(_.ExtHostContext.ExtHostSCM,new O.ExtHostSCM(Xe,Je,mt)),Pn=Xe.set(_.ExtHostContext.ExtHostComments,(0,g.createExtHostComments)(Xe,Je,ht)),_n=Xe.set(_.ExtHostContext.ExtHostProgress,new R.ExtHostProgress(Xe.getProxy(_.MainContext.MainThreadProgress))),gn=Xe.set(_.ExtHostContext.ExtHosLabelService,new le.ExtHostLabelService(Xe)),an=Xe.set(_.ExtHostContext.ExtHostTheming,new ae.ExtHostTheming(Xe)),Jt=Xe.set(_.ExtHostContext.ExtHostAuthentication,new ie.ExtHostAuthentication(Xe)),pn=Xe.set(_.ExtHostContext.ExtHostTimeline,new M.ExtHostTimeline(Xe,Je)),vn=Xe.set(_.ExtHostContext.ExtHostWebviews,new V.ExtHostWebviews(Xe,at.remote,ft,mt,Ae)),Zt=Xe.set(_.ExtHostContext.ExtHostWebviewPanels,new be.ExtHostWebviewPanels(Xe,vn,ft)),bn=Xe.set(_.ExtHostContext.ExtHostCustomEditors,new de.ExtHostCustomEditors(Xe,ht,Mt,vn,Zt)),Tn=Xe.set(_.ExtHostContext.ExtHostWebviewViews,new X.ExtHostWebviewViews(Xe,vn)),en=Xe.set(_.ExtHostContext.ExtHostTesting,new Ce.ExtHostTesting(Xe,Je)),An=Xe.set(_.ExtHostContext.ExtHostUriOpeners,new ze.ExtHostUriOpeners(Xe));Xe.set(_.ExtHostContext.ExtHostInteractive,new qe.ExtHostInteractive(Xe,Et,xe,Je,mt));const Rn=Object.values(_.ExtHostContext);Xe.assertRegistered(Rn);const Ln=new se.ExtHostBulkEdits(Xe,xe),On=new b.ExtHostClipboard(Xe),tn=new h.ExtHostMessageService(Xe,mt),cn=new a.ExtHostDialogs(Xe),yn=new k.ExtHostStatusBar(Xe,Je.converter);return w.ExtHostApiCommands.register(Je),function(He,Ht,nn){const bt=function(){let me=!He.isUnderDevelopment;function we(){me||(mt.info(`Extension '${He.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),me=!0)}return function Ue(ct){if(Array.isArray(ct))ct.forEach(Ue);else if(typeof ct=="string")we();else{const St=ct;typeof St.scheme=="undefined"&&we(),typeof St.exclusive=="boolean"&&(0,Ve.checkProposedApiEnabled)(He,"documentFiltersExclusive")}return ct}}(),Nn={getSession(me,we,Ue){return Jt.getSession(He,me,we,Ue)},async hasSession(me,we){return(0,Ve.checkProposedApiEnabled)(He,"authSession"),!!await Jt.getSession(He,me,we,{silent:!0})},get onDidChangeSessions(){return Jt.onDidChangeSessions},registerAuthenticationProvider(me,we,Ue,ct){return Jt.registerAuthenticationProvider(me,we,Ue,ct)}},Fn={registerCommand(me,we,Ue){return Je.registerCommand(!0,me,we,Ue,void 0,He)},registerTextEditorCommand(me,we,Ue){return Je.registerCommand(!0,me,(...ct)=>{const St=kt.getActiveTextEditor();if(!St){mt.warn("Cannot execute "+me+" because there is no active text editor.");return}return St.edit(Pt=>{we.apply(Ue,[St,Pt,...ct])}).then(Pt=>{Pt||mt.warn("Edits from command "+me+" were not applied.")},Pt=>{mt.warn("An error occurred while running command "+me,Pt)})},void 0,void 0,He)},registerDiffInformationCommand:(me,we,Ue)=>((0,Ve.checkProposedApiEnabled)(He,"diffCommand"),Je.registerCommand(!0,me,async(...ct)=>{const St=xe.activeEditor(!0);if(!St){mt.warn("Cannot execute "+me+" because there is no active text editor.");return}const Pt=await kt.getDiffInformation(St.id);we.apply(Ue,[Pt,...ct])},void 0,void 0,He)),executeCommand(me,...we){return Je.executeCommand(me,...we)},getCommands(me=!1){return Je.getCommands(me)}},Cn={get machineId(){return at.telemetryInfo.machineId},get sessionId(){return at.telemetryInfo.sessionId},get language(){return at.environment.appLanguage},get appName(){return at.environment.appName},get appRoot(){return at.environment.appRoot?.fsPath??""},get appHost(){return at.environment.appHost},get uriScheme(){return at.environment.appUriScheme},get clipboard(){return On.value},get shell(){return et.getDefaultShell(!1)},get isTelemetryEnabled(){return It.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return It.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ve.checkProposedApiEnabled)(He,"telemetry"),It.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ve.checkProposedApiEnabled)(He,"telemetry"),It.onDidChangeTelemetryConfiguration},get isNewAppInstall(){const me=Date.now()-new Date(at.telemetryInfo.firstSessionDate).getTime();return isNaN(me)?!1:me<1e3*60*60*24},openExternal(me,we){return Oe.openUri(me,{allowTunneling:!!at.remote.authority,allowContributedOpeners:we?.allowContributedOpeners})},async asExternalUri(me){if(me.scheme===at.environment.appUriScheme)return vt.createAppUri(me);try{return await Oe.asExternalUri(me,{allowTunneling:!!at.remote.authority})}catch(we){if((0,oe.matchesScheme)(me,We.Schemas.http)||(0,oe.matchesScheme)(me,We.Schemas.https))return me;throw we}},get remoteName(){return(0,ue.getRemoteName)(at.remote.authority)},get remoteAuthority(){return(0,Ve.checkProposedApiEnabled)(He,"resolvers"),at.remote.authority},get uiKind(){return at.uiKind}};at.environment.extensionTestsLocationURI||Object.freeze(Cn);const wn={createTestController(me,we,Ue){return en.createTestController(me,we,Ue)},createTestObserver(){return(0,Ve.checkProposedApiEnabled)(He,"testObserver"),en.createTestObserver()},runTests(me){return(0,Ve.checkProposedApiEnabled)(He,"testObserver"),en.runTests(me)},get onDidChangeTestResults(){return(0,Ve.checkProposedApiEnabled)(He,"testObserver"),en.onResultsChanged},get testResults(){return(0,Ve.checkProposedApiEnabled)(He,"testObserver"),en.results}},ln=at.remote.isRemote?z.ExtensionKind.Workspace:z.ExtensionKind.UI,zt={getExtension(me,we){(0,ot.equalsIgnoreCase)(me,"ms-vscode.references-view")&&(Ae.report("The extension 'ms-vscode.references-view' has been renamed.",He,"Use 'vscode.references-view' instead."),me="vscode.references-view"),(0,Ve.isProposedApiEnabled)(He,"extensionsAny")||(we=!1);const Ue=Ht.mine.getExtensionDescription(me);if(Ue)return new s.Extension(_t,He.identifier,Ue,ln,!1);if(we){const ct=Ht.all.getExtensionDescription(me);if(ct)return new s.Extension(_t,He.identifier,ct,ln,!0)}},get all(){const me=[];for(const we of Ht.mine.getAllExtensionDescriptions())me.push(new s.Extension(_t,He.identifier,we,ln,!1));return me},get allAcrossExtensionHosts(){(0,Ve.checkProposedApiEnabled)(He,"extensionsAny");const me=new Ve.ExtensionIdentifierSet(Ht.mine.getAllExtensionDescriptions().map(Ue=>Ue.identifier)),we=[];for(const Ue of Ht.all.getAllExtensionDescriptions()){const ct=!me.has(Ue.identifier);we.push(new s.Extension(_t,He.identifier,Ue,ln,ct))}return we},get onDidChange(){return(0,Ve.isProposedApiEnabled)(He,"extensionsAny")?y.Event.any(Ht.mine.onDidChange,Ht.all.onDidChange):Ht.mine.onDidChange}},jt={createDiagnosticCollection(me){return Qt.createDiagnosticCollection(He.identifier,me)},get onDidChangeDiagnostics(){return Qt.onDidChangeDiagnostics},getDiagnostics:me=>Qt.getDiagnostics(me),getLanguages(){return Yt.getLanguages()},setTextDocumentLanguage(me,we){return Yt.changeLanguage(me.uri,we)},match(me,we){const Ue=ht.getDocumentData(we.uri)?.notebook;return(0,L.score)(B.LanguageSelector.from(me),we.uri,we.languageId,!0,Ue?.uri,Ue?.notebookType)},registerCodeActionsProvider(me,we,Ue){return dt.registerCodeActionProvider(He,bt(me),we,Ue)},registerDocumentPasteEditProvider(me,we,Ue){return(0,Ve.checkProposedApiEnabled)(He,"documentPaste"),dt.registerDocumentPasteEditProvider(He,bt(me),we,Ue)},registerCodeLensProvider(me,we){return dt.registerCodeLensProvider(He,bt(me),we)},registerDefinitionProvider(me,we){return dt.registerDefinitionProvider(He,bt(me),we)},registerDeclarationProvider(me,we){return dt.registerDeclarationProvider(He,bt(me),we)},registerImplementationProvider(me,we){return dt.registerImplementationProvider(He,bt(me),we)},registerTypeDefinitionProvider(me,we){return dt.registerTypeDefinitionProvider(He,bt(me),we)},registerHoverProvider(me,we){return dt.registerHoverProvider(He,bt(me),we,He.identifier)},registerEvaluatableExpressionProvider(me,we){return dt.registerEvaluatableExpressionProvider(He,bt(me),we,He.identifier)},registerInlineValuesProvider(me,we){return dt.registerInlineValuesProvider(He,bt(me),we,He.identifier)},registerDocumentHighlightProvider(me,we){return dt.registerDocumentHighlightProvider(He,bt(me),we)},registerLinkedEditingRangeProvider(me,we){return dt.registerLinkedEditingRangeProvider(He,bt(me),we)},registerReferenceProvider(me,we){return dt.registerReferenceProvider(He,bt(me),we)},registerRenameProvider(me,we){return dt.registerRenameProvider(He,bt(me),we)},registerDocumentSymbolProvider(me,we,Ue){return dt.registerDocumentSymbolProvider(He,bt(me),we,Ue)},registerWorkspaceSymbolProvider(me){return dt.registerWorkspaceSymbolProvider(He,me)},registerDocumentFormattingEditProvider(me,we){return dt.registerDocumentFormattingEditProvider(He,bt(me),we)},registerDocumentRangeFormattingEditProvider(me,we){return dt.registerDocumentRangeFormattingEditProvider(He,bt(me),we)},registerOnTypeFormattingEditProvider(me,we,Ue,...ct){return dt.registerOnTypeFormattingEditProvider(He,bt(me),we,[Ue].concat(ct))},registerDocumentSemanticTokensProvider(me,we,Ue){return dt.registerDocumentSemanticTokensProvider(He,bt(me),we,Ue)},registerDocumentRangeSemanticTokensProvider(me,we,Ue){return dt.registerDocumentRangeSemanticTokensProvider(He,bt(me),we,Ue)},registerSignatureHelpProvider(me,we,Ue,...ct){return typeof Ue=="object"?dt.registerSignatureHelpProvider(He,bt(me),we,Ue):dt.registerSignatureHelpProvider(He,bt(me),we,typeof Ue=="undefined"?[]:[Ue,...ct])},registerCompletionItemProvider(me,we,...Ue){return dt.registerCompletionItemProvider(He,bt(me),we,Ue)},registerInlineCompletionItemProvider(me,we){return we.handleDidShowCompletionItem&&(0,Ve.checkProposedApiEnabled)(He,"inlineCompletionsAdditions"),dt.registerInlineCompletionsProvider(He,bt(me),we)},registerInlineCompletionItemProviderNew(me,we){if((0,Ve.checkProposedApiEnabled)(He,"inlineCompletionsNew"),we.handleDidShowCompletionItem&&!(0,Ve.isProposedApiEnabled)(He,"inlineCompletionsAdditions"))throw new Error(`When the method "handleDidShowCompletionItem" is implemented on a provider, the usage of the proposed api 'inlineCompletionsAdditions' must be declared!`);return dt.registerInlineCompletionsProviderNew(He,bt(me),we)},registerDocumentLinkProvider(me,we){return dt.registerDocumentLinkProvider(He,bt(me),we)},registerColorProvider(me,we){return dt.registerColorProvider(He,bt(me),we)},registerFoldingRangeProvider(me,we){return dt.registerFoldingRangeProvider(He,bt(me),we)},registerSelectionRangeProvider(me,we){return dt.registerSelectionRangeProvider(He,me,we)},registerCallHierarchyProvider(me,we){return dt.registerCallHierarchyProvider(He,me,we)},registerTypeHierarchyProvider(me,we){return dt.registerTypeHierarchyProvider(He,me,we)},setLanguageConfiguration:(me,we)=>dt.setLanguageConfiguration(He,me,we),getTokenInformationAtPosition(me,we){return(0,Ve.checkProposedApiEnabled)(He,"tokenInformation"),Yt.tokenAtPosition(me,we)},registerInlayHintsProvider(me,we){return dt.registerInlayHintsProvider(He,me,we)},createLanguageStatusItem(me,we){return Yt.createLanguageStatusItem(He,me,we)},registerDocumentOnDropEditProvider(me,we){return(0,Ve.checkProposedApiEnabled)(He,"textEditorDrop"),dt.registerDocumentOnDropEditProvider(He,me,we)}},Mn={get activeTextEditor(){return kt.getActiveTextEditor()},get visibleTextEditors(){return kt.getVisibleTextEditors()},get activeTerminal(){return et.activeTerminal},get terminals(){return et.terminals},async showTextDocument(me,we,Ue){const ct=await(D.URI.isUri(me)?Promise.resolve(Nt.openTextDocument(me)):Promise.resolve(me));return kt.showTextDocument(ct,we,Ue)},createTextEditorDecorationType(me){return kt.createTextEditorDecorationType(He,me)},onDidChangeActiveTextEditor(me,we,Ue){return kt.onDidChangeActiveTextEditor(me,we,Ue)},onDidChangeVisibleTextEditors(me,we,Ue){return kt.onDidChangeVisibleTextEditors(me,we,Ue)},onDidChangeTextEditorSelection(me,we,Ue){return kt.onDidChangeTextEditorSelection(me,we,Ue)},onDidChangeTextEditorOptions(me,we,Ue){return kt.onDidChangeTextEditorOptions(me,we,Ue)},onDidChangeTextEditorVisibleRanges(me,we,Ue){return kt.onDidChangeTextEditorVisibleRanges(me,we,Ue)},onDidChangeTextEditorViewColumn(me,we,Ue){return kt.onDidChangeTextEditorViewColumn(me,we,Ue)},onDidCloseTerminal(me,we,Ue){return et.onDidCloseTerminal(me,we,Ue)},onDidOpenTerminal(me,we,Ue){return et.onDidOpenTerminal(me,we,Ue)},onDidChangeActiveTerminal(me,we,Ue){return et.onDidChangeActiveTerminal(me,we,Ue)},onDidChangeTerminalDimensions(me,we,Ue){return(0,Ve.checkProposedApiEnabled)(He,"terminalDimensions"),et.onDidChangeTerminalDimensions(me,we,Ue)},onDidChangeTerminalState(me,we,Ue){return et.onDidChangeTerminalState(me,we,Ue)},onDidWriteTerminalData(me,we,Ue){return(0,Ve.checkProposedApiEnabled)(He,"terminalDataWriteEvent"),et.onDidWriteTerminalData(me,we,Ue)},get state(){return Oe.state},onDidChangeWindowState(me,we,Ue){return Oe.onDidChangeWindowState(me,we,Ue)},showInformationMessage(me,...we){return tn.showMessage(He,A.default.Info,me,we[0],we.slice(1))},showWarningMessage(me,...we){return tn.showMessage(He,A.default.Warning,me,we[0],we.slice(1))},showErrorMessage(me,...we){return tn.showMessage(He,A.default.Error,me,we[0],we.slice(1))},showQuickPick(me,we,Ue){return Vt.showQuickPick(me,we,Ue)},showWorkspaceFolderPick(me){return Vt.showWorkspaceFolderPick(me)},showInputBox(me,we){return Vt.showInput(me,we)},showOpenDialog(me){return cn.showOpenDialog(me)},showSaveDialog(me){return cn.showSaveDialog(me)},createStatusBarItem(me,we,Ue){let ct,St,Pt;return typeof me=="string"?(ct=me,St=we,Pt=Ue):(St=me,Pt=we),yn.createStatusBarEntry(He,ct,St,Pt)},setStatusBarMessage(me,we){return yn.setStatusBarMessage(me,we)},withScmProgress(me){return Ae.report("window.withScmProgress",He,"Use 'withProgress' instead."),_n.withProgress(He,{location:z.ProgressLocation.SourceControl},(we,Ue)=>me({report(ct){}}))},withProgress(me,we){return _n.withProgress(He,me,we)},createOutputChannel(me,we){return yt.createOutputChannel(me,we,He)},createWebviewPanel(me,we,Ue,ct){return Zt.createWebviewPanel(He,me,we,Ue,ct)},createWebviewTextEditorInset(me,we,Ue,ct){return(0,Ve.checkProposedApiEnabled)(He,"editorInsets"),fn.createWebviewEditorInset(me,we,Ue,ct,He)},createTerminal(me,we,Ue){return typeof me=="object"?"pty"in me?et.createExtensionTerminal(me):et.createTerminalFromOptions(me):et.createTerminal(me,we,Ue)},registerTerminalLinkProvider(me){return et.registerLinkProvider(me)},registerTerminalProfileProvider(me,we){return et.registerProfileProvider(He,me,we)},registerTreeDataProvider(me,we){return xt.registerTreeDataProvider(me,we,He)},createTreeView(me,we){return xt.createTreeView(me,we,He)},registerWebviewPanelSerializer:(me,we)=>Zt.registerWebviewPanelSerializer(He,me,we),registerCustomEditorProvider:(me,we,Ue={})=>bn.registerCustomEditorProvider(He,me,we,Ue),registerFileDecorationProvider(me){return Fe.registerFileDecorationProvider(me,He.identifier)},registerUriHandler(me){return vt.registerUriHandler(He.identifier,me)},createQuickPick(){return Vt.createQuickPick(He)},createInputBox(){return Vt.createInputBox(He)},get activeColorTheme(){return an.activeColorTheme},onDidChangeActiveColorTheme(me,we,Ue){return an.onDidChangeActiveColorTheme(me,we,Ue)},registerWebviewViewProvider(me,we,Ue){return Tn.registerWebviewViewProvider(He,me,we,Ue?.webviewOptions)},get activeNotebookEditor(){return Et.activeNotebookEditor},onDidChangeActiveNotebookEditor(me,we,Ue){return Et.onDidChangeActiveNotebookEditor(me,we,Ue)},get visibleNotebookEditors(){return Et.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return Et.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(me,we,Ue){return Ut.onDidChangeNotebookEditorSelection(me,we,Ue)},onDidChangeNotebookEditorVisibleRanges(me,we,Ue){return Ut.onDidChangeNotebookEditorVisibleRanges(me,we,Ue)},showNotebookDocument(me,we){return D.URI.isUri(me)&&Ae.report("window.showNotebookDocument(uri)",He,"Please use 'window.openNotebookDocument' and 'window.showTextDocument'"),Et.showNotebookDocument(me,we)},registerExternalUriOpener(me,we,Ue){return(0,Ve.checkProposedApiEnabled)(He,"externalUriOpener"),An.registerExternalUriOpener(He.identifier,me,we,Ue)},get tabGroups(){return J.tabGroups}},Nt={get rootPath(){return Ae.report("workspace.rootPath",He,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(me){throw n.readonly()},getWorkspaceFolder(me){return ft.getWorkspaceFolder(me)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(me){throw n.readonly()},get workspaceFile(){return ft.workspaceFile},set workspaceFile(me){throw n.readonly()},updateWorkspaceFolders:(me,we,...Ue)=>ft.updateWorkspaceFolders(He,me,we||0,...Ue),onDidChangeWorkspaceFolders:function(me,we,Ue){return ft.onDidChangeWorkspace(me,we,Ue)},asRelativePath:(me,we)=>ft.getRelativePath(me,we),findFiles:(me,we,Ue,ct)=>ft.findFiles(me,we,Ue,He.identifier,ct),findTextInFiles:(me,we,Ue,ct)=>{(0,Ve.checkProposedApiEnabled)(He,"findTextInFiles");let St,Pt;return typeof we=="object"?(St=we,Pt=Ue):(St={},Pt=we,ct=Ue),ft.findTextInFiles(me,St||{},Pt,He.identifier,ct)},saveAll:me=>ft.saveAll(me),applyEdit(me){return Ln.applyWorkspaceEdit(me,He)},createFileSystemWatcher:(me,we,Ue,ct)=>Bt.createFileSystemWatcher(ft,He,me,we,Ue,ct),get textDocuments(){return ht.getAllDocumentData().map(me=>me.document)},set textDocuments(me){throw n.readonly()},openTextDocument(me){let we;const Ue=me;if(typeof me=="string")we=Promise.resolve(D.URI.file(me));else if(D.URI.isUri(me))we=Promise.resolve(me);else if(!Ue||typeof Ue=="object")we=ht.createDocumentData(Ue);else throw new Error("illegal argument - uriOrFileNameOrOptions");return we.then(ct=>ht.ensureDocumentData(ct).then(St=>St.document))},onDidOpenTextDocument:(me,we,Ue)=>ht.onDidAddDocument(me,we,Ue),onDidCloseTextDocument:(me,we,Ue)=>ht.onDidRemoveDocument(me,we,Ue),onDidChangeTextDocument:(me,we,Ue)=>ht.onDidChangeDocument(me,we,Ue),onDidSaveTextDocument:(me,we,Ue)=>ht.onDidSaveDocument(me,we,Ue),onWillSaveTextDocument:(me,we,Ue)=>Xt.getOnWillSaveTextDocumentEvent(He)(me,we,Ue),get notebookDocuments(){return Et.notebookDocuments.map(me=>me.apiNotebook)},async openNotebookDocument(me,we){let Ue;if(D.URI.isUri(me))Ue=me,await Et.openNotebookDocument(me);else if(typeof me=="string")Ue=D.URI.revive(await Et.createNotebookDocument({viewType:me,content:we}));else throw new Error("Invalid arguments");return Et.getNotebookDocument(Ue).apiNotebook},onDidSaveNotebookDocument(me,we,Ue){return rn.onDidSaveNotebookDocument(me,we,Ue)},onDidChangeNotebookDocument(me,we,Ue){return rn.onDidChangeNotebookDocument(me,we,Ue)},get onDidOpenNotebookDocument(){return Et.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Et.onDidCloseNotebookDocument},registerNotebookSerializer(me,we,Ue,ct){return Et.registerNotebookSerializer(He,me,we,Ue,(0,Ve.isProposedApiEnabled)(He,"notebookLiveShare")?ct:void 0)},registerNotebookContentProvider:(me,we,Ue,ct)=>((0,Ve.checkProposedApiEnabled)(He,"notebookContentProvider"),Ae.report("workspace.registerNotebookContentProvider",He,"The notebookContentProvider API is not on track for finalization and will be removed."),Et.registerNotebookContentProvider(He,me,we,Ue,(0,Ve.isProposedApiEnabled)(He,"notebookLiveShare")?ct:void 0)),onDidChangeConfiguration:(me,we,Ue)=>nn.onDidChangeConfiguration(me,we,Ue),getConfiguration(me,we){return we=arguments.length===1?void 0:we,nn.getConfiguration(me,we,He)},registerTextDocumentContentProvider(me,we){return Kt.registerTextDocumentContentProvider(me,we)},registerTaskProvider:(me,we)=>(Ae.report("window.registerTaskProvider",He,"Use the corresponding function on the 'tasks' namespace instead"),pt.registerTaskProvider(He,me,we)),registerFileSystemProvider(me,we,Ue){return(0,je.combinedDisposable)(mn.registerFileSystemProvider(He,me,we,Ue),Tt.addFileSystemProvider(me,we))},get fs(){return Tt.value},registerFileSearchProvider:(me,we)=>((0,Ve.checkProposedApiEnabled)(He,"fileSearchProvider"),gt.registerFileSearchProvider(me,we)),registerTextSearchProvider:(me,we)=>((0,Ve.checkProposedApiEnabled)(He,"textSearchProvider"),gt.registerTextSearchProvider(me,we)),registerRemoteAuthorityResolver:(me,we)=>((0,Ve.checkProposedApiEnabled)(He,"resolvers"),_t.registerRemoteAuthorityResolver(me,we)),registerResourceLabelFormatter:me=>((0,Ve.checkProposedApiEnabled)(He,"resolvers"),gn.$registerResourceLabelFormatter(me)),onDidCreateFiles:(me,we,Ue)=>Bt.onDidCreateFile(me,we,Ue),onDidDeleteFiles:(me,we,Ue)=>Bt.onDidDeleteFile(me,we,Ue),onDidRenameFiles:(me,we,Ue)=>Bt.onDidRenameFile(me,we,Ue),onWillCreateFiles:(me,we,Ue)=>Bt.getOnWillCreateFileEvent(He)(me,we,Ue),onWillDeleteFiles:(me,we,Ue)=>Bt.getOnWillDeleteFileEvent(He)(me,we,Ue),onWillRenameFiles:(me,we,Ue)=>Bt.getOnWillRenameFileEvent(He)(me,we,Ue),openTunnel:me=>((0,Ve.checkProposedApiEnabled)(He,"resolvers"),Dt.openTunnel(He,me).then(we=>{if(!we)throw new Error("cannot open tunnel");return we})),get tunnels(){return(0,Ve.checkProposedApiEnabled)(He,"resolvers"),Dt.getTunnels()},onDidChangeTunnels:(me,we,Ue)=>((0,Ve.checkProposedApiEnabled)(He,"resolvers"),Dt.onDidChangeTunnels(me,we,Ue)),registerPortAttributesProvider:(me,we)=>((0,Ve.checkProposedApiEnabled)(He,"portsAttributes"),Dt.registerPortsAttributesProvider(me,we)),registerTimelineProvider:(me,we)=>((0,Ve.checkProposedApiEnabled)(He,"timeline"),pn.registerTimelineProvider(me,we,He.identifier,Je.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:me=>((0,Ve.checkProposedApiEnabled)(He,"workspaceTrust"),ft.requestWorkspaceTrust(me)),onDidGrantWorkspaceTrust:(me,we,Ue)=>ft.onDidGrantWorkspaceTrust(me,we,Ue)},un={get inputBox(){return Ae.report("scm.inputBox",He,"Use 'SourceControl.inputBox' instead"),on.getLastInputBox(He)},createSourceControl(me,we,Ue){return on.createSourceControl(He,me,we,Ue)}},Un={createCommentController(me,we){return Pn.createCommentController(He,me,we)}},Bn={get activeDebugSession(){return Ze.activeDebugSession},get activeDebugConsole(){return Ze.activeDebugConsole},get breakpoints(){return Ze.breakpoints},onDidStartDebugSession(me,we,Ue){return Ze.onDidStartDebugSession(me,we,Ue)},onDidTerminateDebugSession(me,we,Ue){return Ze.onDidTerminateDebugSession(me,we,Ue)},onDidChangeActiveDebugSession(me,we,Ue){return Ze.onDidChangeActiveDebugSession(me,we,Ue)},onDidReceiveDebugSessionCustomEvent(me,we,Ue){return Ze.onDidReceiveDebugSessionCustomEvent(me,we,Ue)},onDidChangeBreakpoints(me,we,Ue){return Ze.onDidChangeBreakpoints(me,we,Ue)},registerDebugConfigurationProvider(me,we,Ue){return Ze.registerDebugConfigurationProvider(me,we,Ue||nt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(me,we){return Ze.registerDebugAdapterDescriptorFactory(He,me,we)},registerDebugAdapterTrackerFactory(me,we){return Ze.registerDebugAdapterTrackerFactory(me,we)},startDebugging(me,we,Ue){return!Ue||typeof Ue=="object"&&"configuration"in Ue?Ze.startDebugging(me,we,{parentSession:Ue}):Ze.startDebugging(me,we,Ue||{})},stopDebugging(me){return Ze.stopDebugging(me)},addBreakpoints(me){return Ze.addBreakpoints(me)},removeBreakpoints(me){return Ze.removeBreakpoints(me)},asDebugSourceUri(me,we){return Ze.asDebugSourceUri(me,we)}},zn={registerTaskProvider:(me,we)=>pt.registerTaskProvider(He,me,we),fetchTasks:me=>pt.fetchTasks(me),executeTask:me=>pt.executeTask(He,me),get taskExecutions(){return pt.taskExecutions},onDidStartTask:(me,we,Ue)=>pt.onDidStartTask(me,we,Ue),onDidEndTask:(me,we,Ue)=>pt.onDidEndTask(me,we,Ue),onDidStartTaskProcess:(me,we,Ue)=>pt.onDidStartTaskProcess(me,we,Ue),onDidEndTaskProcess:(me,we,Ue)=>pt.onDidEndTaskProcess(me,we,Ue)},Wn={createNotebookController(me,we,Ue,ct,St){return sn.createNotebookController(He,me,we,Ue,ct,(0,Ve.isProposedApiEnabled)(He,"notebookMessaging")?St:void 0)},registerNotebookCellStatusBarItemProvider:(me,we)=>Et.registerNotebookCellStatusBarItemProvider(He,me,we),createRendererMessaging(me){return kn.createRendererMessaging(He,me)},onDidChangeNotebookCellExecutionState(me,we,Ue){return(0,Ve.checkProposedApiEnabled)(He,"notebookCellExecutionState"),sn.onDidChangeNotebookCellExecutionState(me,we,Ue)}};return{version:at.version,authentication:Nn,commands:Fn,comments:Un,debug:Bn,env:Cn,extensions:zt,languages:jt,notebooks:Wn,scm:un,tasks:zn,tests:wn,window:Mn,workspace:Nt,Breakpoint:z.Breakpoint,CallHierarchyIncomingCall:z.CallHierarchyIncomingCall,CallHierarchyItem:z.CallHierarchyItem,CallHierarchyOutgoingCall:z.CallHierarchyOutgoingCall,CancellationError:n.CancellationError,CancellationTokenSource:u.CancellationTokenSource,CandidatePortSource:_.CandidatePortSource,CodeAction:z.CodeAction,CodeActionKind:z.CodeActionKind,CodeActionTriggerKind:z.CodeActionTriggerKind,CodeLens:z.CodeLens,Color:z.Color,ColorInformation:z.ColorInformation,ColorPresentation:z.ColorPresentation,ColorThemeKind:z.ColorThemeKind,CommentMode:z.CommentMode,CommentThreadCollapsibleState:z.CommentThreadCollapsibleState,CommentThreadState:z.CommentThreadState,CompletionItem:z.CompletionItem,CompletionItemKind:z.CompletionItemKind,CompletionItemTag:z.CompletionItemTag,CompletionList:z.CompletionList,CompletionTriggerKind:z.CompletionTriggerKind,ConfigurationTarget:z.ConfigurationTarget,CustomExecution:z.CustomExecution,DebugAdapterExecutable:z.DebugAdapterExecutable,DebugAdapterInlineImplementation:z.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:z.DebugAdapterNamedPipeServer,DebugAdapterServer:z.DebugAdapterServer,DebugConfigurationProviderTriggerKind:nt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:z.DebugConsoleMode,DecorationRangeBehavior:z.DecorationRangeBehavior,Diagnostic:z.Diagnostic,DiagnosticRelatedInformation:z.DiagnosticRelatedInformation,DiagnosticSeverity:z.DiagnosticSeverity,DiagnosticTag:z.DiagnosticTag,Disposable:z.Disposable,DocumentHighlight:z.DocumentHighlight,DocumentHighlightKind:z.DocumentHighlightKind,DocumentLink:z.DocumentLink,DocumentSymbol:z.DocumentSymbol,EndOfLine:z.EndOfLine,EnvironmentVariableMutatorType:z.EnvironmentVariableMutatorType,EvaluatableExpression:z.EvaluatableExpression,InlineValueText:z.InlineValueText,InlineValueVariableLookup:z.InlineValueVariableLookup,InlineValueEvaluatableExpression:z.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:z.InlineCompletionTriggerKind,InlineCompletionTriggerKindNew:z.InlineCompletionTriggerKindNew,EventEmitter:y.Emitter,ExtensionKind:z.ExtensionKind,ExtensionMode:z.ExtensionMode,ExternalUriOpenerPriority:z.ExternalUriOpenerPriority,FileChangeType:z.FileChangeType,FileDecoration:z.FileDecoration,FileSystemError:z.FileSystemError,FileType:I.FileType,FilePermission:I.FilePermission,FoldingRange:z.FoldingRange,FoldingRangeKind:z.FoldingRangeKind,FunctionBreakpoint:z.FunctionBreakpoint,InlineCompletionItem:z.InlineSuggestion,InlineCompletionItemNew:z.InlineSuggestionNew,InlineCompletionList:z.InlineSuggestionList,InlineCompletionListNew:z.InlineSuggestionsNew,Hover:z.Hover,IndentAction:P.IndentAction,Location:z.Location,MarkdownString:z.MarkdownString,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:z.ParameterInformation,PortAutoForwardAction:z.PortAutoForwardAction,Position:z.Position,ProcessExecution:z.ProcessExecution,ProgressLocation:z.ProgressLocation,QuickInputButtons:z.QuickInputButtons,Range:z.Range,RelativePattern:z.RelativePattern,Selection:z.Selection,SelectionRange:z.SelectionRange,SemanticTokens:z.SemanticTokens,SemanticTokensBuilder:z.SemanticTokensBuilder,SemanticTokensEdit:z.SemanticTokensEdit,SemanticTokensEdits:z.SemanticTokensEdits,SemanticTokensLegend:z.SemanticTokensLegend,ShellExecution:z.ShellExecution,ShellQuoting:z.ShellQuoting,SignatureHelp:z.SignatureHelp,SignatureHelpTriggerKind:z.SignatureHelpTriggerKind,SignatureInformation:z.SignatureInformation,SnippetString:z.SnippetString,SourceBreakpoint:z.SourceBreakpoint,StandardTokenType:z.StandardTokenType,StatusBarAlignment:z.StatusBarAlignment,SymbolInformation:z.SymbolInformation,SymbolKind:z.SymbolKind,SymbolTag:z.SymbolTag,Task:z.Task,TaskGroup:z.TaskGroup,TaskPanelKind:z.TaskPanelKind,TaskRevealKind:z.TaskRevealKind,TaskScope:z.TaskScope,TerminalLink:z.TerminalLink,TerminalLocation:z.TerminalLocation,TerminalProfile:z.TerminalProfile,TextDocumentSaveReason:z.TextDocumentSaveReason,TextEdit:z.TextEdit,TextEditorCursorStyle:C.TextEditorCursorStyle,TextEditorLineNumbersStyle:z.TextEditorLineNumbersStyle,TextEditorRevealType:z.TextEditorRevealType,TextEditorSelectionChangeKind:z.TextEditorSelectionChangeKind,TextDocumentChangeReason:z.TextDocumentChangeReason,ThemeColor:z.ThemeColor,ThemeIcon:z.ThemeIcon,TreeItem:z.TreeItem,TreeItemCollapsibleState:z.TreeItemCollapsibleState,TypeHierarchyItem:z.TypeHierarchyItem,UIKind:T.UIKind,Uri:D.URI,ViewColumn:z.ViewColumn,WorkspaceEdit:z.WorkspaceEdit,DocumentDropEdit:z.DocumentDropEdit,DocumentPasteEdit:z.DocumentPasteEdit,InlayHint:z.InlayHint,InlayHintLabelPart:z.InlayHintLabelPart,InlayHintKind:z.InlayHintKind,RemoteAuthorityResolverError:z.RemoteAuthorityResolverError,ResolvedAuthority:z.ResolvedAuthority,SourceControlInputBoxValidationType:z.SourceControlInputBoxValidationType,ExtensionRuntime:z.ExtensionRuntime,TimelineItem:z.TimelineItem,NotebookRange:z.NotebookRange,NotebookCellKind:z.NotebookCellKind,NotebookCellExecutionState:z.NotebookCellExecutionState,NotebookCellData:z.NotebookCellData,NotebookData:z.NotebookData,NotebookRendererScript:z.NotebookRendererScript,NotebookCellStatusBarAlignment:z.NotebookCellStatusBarAlignment,NotebookEditorRevealType:z.NotebookEditorRevealType,NotebookCellOutput:z.NotebookCellOutput,NotebookCellOutputItem:z.NotebookCellOutputItem,NotebookCellStatusBarItem:z.NotebookCellStatusBarItem,NotebookControllerAffinity:z.NotebookControllerAffinity,NotebookEdit:z.NotebookEdit,PortAttributes:z.PortAttributes,LinkedEditingRanges:z.LinkedEditingRanges,TestResultState:z.TestResultState,TestRunRequest:z.TestRunRequest,TestMessage:z.TestMessage,TestTag:z.TestTag,TestRunProfileKind:z.TestRunProfileKind,TextSearchCompleteMessageType:re.TextSearchCompleteMessageType,DataTransfer:z.DataTransfer,DataTransferItem:z.DataTransferItem,CoveredCount:z.CoveredCount,FileCoverage:z.FileCoverage,StatementCoverage:z.StatementCoverage,BranchCoverage:z.BranchCoverage,FunctionCoverage:z.FunctionCoverage,WorkspaceTrustState:z.WorkspaceTrustState,LanguageStatusSeverity:z.LanguageStatusSeverity,QuickPickItemKind:z.QuickPickItemKind,InputBoxValidationSeverity:z.InputBoxValidationSeverity,TabInputText:z.TextTabInput,TabInputTextDiff:z.TextDiffTabInput,TabInputCustom:z.CustomEditorTabInput,TabInputNotebook:z.NotebookEditorTabInput,TabInputNotebookDiff:z.NotebookDiffEditorTabInput,TabInputWebview:z.WebviewEditorTabInput,TabInputTerminal:z.TerminalEditorTabInput}}}e.createApiFactoryAndRegisterActors=st}),define(Ie[293],ke([1,0,294,304,305,2,306]),function(Q,e,u,n,y,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function C(I,_,T,w,b,p){const g=p.environment.useHostProxy,v=typeof g=="boolean"?g:!p.remote.isRemote,f=(0,D.createProxyResolver)({resolveProxy:m=>I.resolveProxy(m),getHttpProxySetting:()=>_.getConfiguration("http").get("proxy"),log:(m,o,...d)=>{switch(m){case D.LogLevel.Trace:w.trace(o,...d);break;case D.LogLevel.Debug:w.debug(o,...d);break;case D.LogLevel.Info:w.info(o,...d);break;case D.LogLevel.Warning:w.warn(o,...d);break;case D.LogLevel.Error:w.error(o,...d);break;case D.LogLevel.Critical:w.critical(o,...d);break;case D.LogLevel.Off:break;default:r(m,o,d);break}function r(s,i,...t){w.error("Unknown log level",s),w.error(i,...t)}},getLogLevel:()=>w.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:v,env:process.env}),a=S(_,f);return L(T,a)}e.connectProxyResolver=C;function S(I,_){const T={config:I.getConfiguration("http").get("proxySupport")||"off"};I.onDidChangeConfiguration(b=>{T.config=I.getConfiguration("http").get("proxySupport")||"off"});const w={config:!!I.getConfiguration("http").get("systemCertificates")};return I.onDidChangeConfiguration(b=>{w.config=!!I.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},u,(0,D.createHttpPatch)(u,_,{config:"off"},w,!0)),on:Object.assign({},u,(0,D.createHttpPatch)(u,_,{config:"on"},w,!0)),override:Object.assign({},u,(0,D.createHttpPatch)(u,_,{config:"override"},w,!0)),onRequest:Object.assign({},u,(0,D.createHttpPatch)(u,_,T,w,!0)),default:Object.assign(u,(0,D.createHttpPatch)(u,_,T,w,!1))},https:{off:Object.assign({},n,(0,D.createHttpPatch)(n,_,{config:"off"},w,!0)),on:Object.assign({},n,(0,D.createHttpPatch)(n,_,{config:"on"},w,!0)),override:Object.assign({},n,(0,D.createHttpPatch)(n,_,{config:"override"},w,!0)),onRequest:Object.assign({},n,(0,D.createHttpPatch)(n,_,T,w,!0)),default:Object.assign(n,(0,D.createHttpPatch)(n,_,T,w,!1))},tls:Object.assign(y,(0,D.createTlsPatch)(y))}}const P=new Map;function L(I,_){return I.getExtensionPathIndex().then(T=>{const w=Q.__$__nodeRequire("module"),b=w._load;w._load=function(g,v,f){if(g==="tls")return _.tls;if(g!=="http"&&g!=="https")return b.apply(this,arguments);const a=_[g],m=T.findSubstr(A.URI.file(v.filename));let o=P.get(m);if(o||P.set(m,o={}),!o[g]){const d=a.default;o[g]={...d}}return o[g]}})}}),define(Ie[141],ke([1,0,42,307,97,16,78,36,9,8,2,31,72,308,287,92]),function(Q,e,u,n,y,A,D,C,S,P,L,I,_,T,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const p=w.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class g{constructor(h){this.outputChannel=h}provideTextSearchResults(h,E,R,N){return this.outputChannel.appendLine(`provideTextSearchResults ${h.pattern}, ${JSON.stringify({...E,folder:E.folder.toString()})}`),new Promise((O,k)=>{N.onCancellationRequested(()=>V());const U=d(h,E),F=E.folder.fsPath,$=U.map(ue=>ue.match(/^-/)?ue:`'${ue}'`).join(" ");this.outputChannel.appendLine(`${p} ${$}
 - cwd: ${F}`);let ee=u.spawn(p,U,{cwd:F});ee.on("error",ue=>{console.error(ue),this.outputChannel.appendLine("Error: "+(ue&&ue.message)),k((0,I.serializeSearchError)(new I.SearchError(ue&&ue.message,I.SearchErrorCode.rgProcessError)))});let B=!1;const z=new a(E.maxResults,F,E.previewOptions);z.on("result",ue=>{B=!0,ne="",R.report(ue)});let q=!1;const V=()=>{q=!0,ee&&ee.kill(),z&&z.cancel()};let j=!1;z.on("hitLimit",()=>{j=!0,V()});let ne="";ee.stdout.on("data",ue=>{z.handleData(ue),B||(ne+=ue)});let Y=!1;ee.stdout.once("data",()=>Y=!0);let le="";ee.stderr.on("data",ue=>{const K=ue.toString();this.outputChannel.appendLine(K),le+=K}),ee.on("close",()=>{if(this.outputChannel.appendLine(Y?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(B?"Got result from parser":"No result from parser"),ne&&this.outputChannel.appendLine(`Got data without result: ${ne}`),this.outputChannel.appendLine(""),q)O({limitHit:j});else{z.flush(),ee=null;let ue;le&&!Y&&(ue=v(le))?k((0,I.serializeSearchError)(new I.SearchError(ue.message,ue.code))):O({limitHit:j})}})})}}e.RipgrepTextSearchEngine=g;function v(l){const h=l.split(`
`),E=h[0].trim();if(h.some(N=>N.startsWith("regex parse error")))return new I.SearchError(f(h),I.SearchErrorCode.regexParseError);const R=E.match(/grep config error: unknown encoding: (.*)/);if(R)return new I.SearchError(`Unknown encoding: ${R[1]}`,I.SearchErrorCode.unknownEncoding);if(E.startsWith("error parsing glob"))return new I.SearchError(E.charAt(0).toUpperCase()+E.substr(1),I.SearchErrorCode.globParseError);if(E.startsWith("the literal"))return new I.SearchError(E.charAt(0).toUpperCase()+E.substr(1),I.SearchErrorCode.invalidLiteral);if(E.startsWith("PCRE2: error compiling pattern"))return new I.SearchError(E,I.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=v;function f(l){const h=["Regex parse error"],E=l.filter(R=>R.startsWith("PCRE2:"));if(E.length>=1){const R=E[0].replace("PCRE2:","");if(R.indexOf(":")!==-1&&R.split(":").length>=2){const N=R.split(":")[1];h.push(":"+N)}}return h.join("")}e.buildRegexParseError=f;class a extends n.EventEmitter{constructor(h,E,R){super();this.maxResults=h,this.rootFolder=E,this.previewOptions=R,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new y.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(h,E){return super.on(h,E),this}handleData(h){if(this.isDone)return;const E=typeof h=="string"?h:this.stringDecoder.write(h);this.handleDecodedData(E)}handleDecodedData(h){let E=h.indexOf(`
`);const R=this.remainder+h;if(E>=0)E+=this.remainder.length;else{this.remainder=R;return}let N=0;for(;E>=0;)this.handleLine(R.substring(N,E).trim()),N=E+1,E=R.indexOf(`
`,N);this.remainder=R.substring(N)}handleLine(h){if(this.isDone||!h)return;let E;try{E=JSON.parse(h)}catch{throw new Error(`malformed line from rg: ${h}`)}if(E.type==="match"){const R=m(E.data.path),N=L.URI.file(S.join(this.rootFolder,R)),O=this.createTextSearchMatch(E.data,N);this.onResult(O),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(E.type==="context"){const R=m(E.data.path),N=L.URI.file(S.join(this.rootFolder,R));this.createTextSearchContext(E.data,N).forEach(k=>this.onResult(k))}}createTextSearchMatch(h,E){const R=h.line_number-1,N=m(h.lines),O=Buffer.from(N);let k=0,U=0,F=R;h.submatches.length===0&&h.submatches.push(N.length?{start:0,end:1,match:{text:N[0]}}:{start:0,end:0,match:{text:""}});const $=(0,A.coalesce)(h.submatches.map((ee,B)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const z=m(ee.match),q=O.slice(k,ee.start).toString().length,V=U+q,j=o(z),ne=F,Y=j.numLines+ne,le=j.numLines>0?j.lastLineLength:j.lastLineLength+V;return k=ee.end,U=le,F=Y,new _.Range(ne,V,Y,le)}));return(0,b.createTextSearchResult)(E,N,$,this.previewOptions)}createTextSearchContext(h,E){const R=m(h.lines),N=h.line_number;return R.replace(/\r?\n$/,"").split(`
`).map((O,k)=>({text:O,uri:E,lineNumber:N+k}))}onResult(h){this.emit("result",h)}}e.RipgrepParser=a;function m(l){return l.bytes?Buffer.from(l.bytes,"base64").toString():l.text}function o(l){const h=/\n/g;let E=0,R=-1,N;for(;N=h.exec(l);)E++,R=N.index;const O=R>=0?l.length-R-1:l.length;return{numLines:E,lastLineLength:O}}function d(l,h){const E=["--hidden"];E.push(l.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:R,otherIncludes:N}=(0,D.groupBy)(h.includes,k=>k.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(N&&N.length){const k=new Set;N.forEach(U=>{k.add(U)}),E.push("-g","!*"),k.forEach(U=>{r(U).map(b.anchorGlob).forEach(F=>{E.push("-g",F)})})}R&&R.length&&R.forEach(k=>{E.push("-g",k)}),h.excludes.map(b.anchorGlob).forEach(k=>E.push("-g",`!${k}`)),h.maxFileSize&&E.push("--max-filesize",h.maxFileSize+""),h.useIgnoreFiles?h.useParentIgnoreFiles||E.push("--no-ignore-parent"):E.push("--no-ignore"),h.followSymlinks&&E.push("--follow"),h.encoding&&h.encoding!=="utf8"&&E.push("--encoding",h.encoding),l.pattern==="--"&&(l.isRegExp=!0,l.pattern="\\-\\-"),l.isMultiline&&!l.isRegExp&&(l.pattern=(0,P.escapeRegExpCharacters)(l.pattern),l.isRegExp=!0),h.usePCRE2&&E.push("--pcre2"),E.push("--crlf"),l.isRegExp&&(l.pattern=s(l.pattern),E.push("--engine","auto"));let O;if(l.isWordMatch){const U=(0,P.createRegExp)(l.pattern,!!l.isRegExp,{wholeWord:l.isWordMatch}).source.replace(/\\\//g,"/");E.push("--regexp",U)}else if(l.isRegExp){let k=t(l.pattern);k=c(k),E.push("--regexp",k)}else O=l.pattern,E.push("--fixed-strings");return E.push("--no-config"),h.useGlobalIgnoreFiles||E.push("--no-ignore-global"),E.push("--json"),l.isMultiline&&E.push("--multiline"),h.beforeContext&&E.push("--before-context",h.beforeContext+""),h.afterContext&&E.push("--after-context",h.afterContext+""),E.push("--"),O&&E.push(O),E.push("."),E}function r(l){const h=(0,C.splitGlobAware)(l,"/");return h.map((E,R)=>h.slice(0,R+1).join("/"))}e.spreadGlobComponents=r;function s(l){const h=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;l.match(h);)l=l.replace(h,"$1\\x{$2}");const E=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;l.match(E);)l=l.replace(E,"$1\\x{$2}");return l}e.unicodeEscapesToPCRE2=s;const i=l=>l.type==="Assertion"&&l.kind==="lookbehind";function t(l){let h;try{h=new T.RegExpParser().parsePattern(l)}catch{return l}let E="",R=0;const N=(U,F,$)=>{E+=l.slice(R,U)+$,R=F},O=[];return new T.RegExpVisitor({onCharacterEnter(U){if(U.raw!=="\\n")return;const F=O[0];if(!F)N(U.start,U.end,"\\r?\\n");else if(!O.some(i))if(F.type==="CharacterClass")if(F.negate){const $=l.slice(F.start+2,U.start)+l.slice(U.end,F.end-1);F.parent?.type==="Quantifier"?N(F.start,F.end,$?`[^${$}]`:"."):N(F.start,F.end,"(?!\\r?\\n"+($?`|[${$}]`:"")+")")}else{const $=l.slice(F.start+1,U.start)+l.slice(U.end,F.end-1);N(F.start,F.end,$===""?"\\r?\\n":`(?:[${$}]|\\r?\\n)`)}else F.type==="Quantifier"&&N(U.start,U.end,"(?:\\r?\\n)")},onQuantifierEnter(U){O.unshift(U)},onQuantifierLeave(){O.shift()},onCharacterClassRangeEnter(U){O.unshift(U)},onCharacterClassRangeLeave(){O.shift()},onCharacterClassEnter(U){O.unshift(U)},onCharacterClassLeave(){O.shift()},onAssertionEnter(U){i(U)&&O.push(U)},onAssertionLeave(U){O[0]===U&&O.shift()}}).visit(h),E+=l.slice(R),E}e.fixRegexNewline=t;function c(l){return l.replace(/\n/g,"\\r?\\n")}e.fixNewline=c}),define(Ie[295],ke([1,0,21,141,118,11]),function(Q,e,u,n,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class D{constructor(P){this.outputChannel=P,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(P,L,I,_){const T=new n.RipgrepTextSearchEngine(this.outputChannel);if(L.folder.scheme===A.Schemas.vscodeUserData){const w={...L,folder:L.folder.with({scheme:A.Schemas.file})},b=new y.Progress(p=>I.report({...p,uri:p.uri.with({scheme:L.folder.scheme})}));return this.withToken(_,p=>T.provideTextSearchResults(P,w,b,p))}else return this.withToken(_,w=>T.provideTextSearchResults(P,L,I,w))}async withToken(P,L){const I=C(P);this.inProgress.add(I);const _=await L(I.token);return this.inProgress.delete(I),_}dispose(){this.inProgress.forEach(P=>P.cancel())}}e.RipgrepSearchProvider=D;function C(S){const P=new u.CancellationTokenSource;return S.onCancellationRequested(()=>P.cancel()),P}}),define(Ie[296],ke([1,0,29,141,140]),function(Q,e,u,n,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class A{constructor(S){this.query=S}search(S,P,L){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const I={appendLine(T){L({message:T})}},_=new y.NativeTextSearchManager(this.query,new n.RipgrepTextSearchEngine(I),u);return new Promise((T,w)=>_.search(b=>{P(b.map(D))},S).then(b=>T({limitHit:b.limitHit,type:"success",stats:b.stats}),w))}}e.TextSearchEngineAdapter=A;function D(C){return{path:C.resource&&C.resource.fsPath,results:C.results,numMatches:(C.results||[]).reduce((S,P)=>{if(P.ranges){const L=P;return S+(Array.isArray(L.ranges)?L.ranges.length:1)}else return S+1},0)}}}),define(Ie[297],ke([1,0,16,18,12,3,105,9,50,2,43,31,288,296]),function(Q,e,u,n,y,A,D,C,S,P,L,I,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class w{constructor(a="searchProcess"){this.processType=a,this.caches=Object.create(null)}fileSearch(a){let m;const o=g(a),d=new A.Emitter({onFirstListenerDidAdd:()=>{m=(0,n.createCancelablePromise)(r=>this.doFileSearchWithEngine(_.Engine,o,s=>d.fire(s),r)),m.then(r=>d.fire(r),r=>d.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onLastListenerRemove:()=>{m.cancel()}});return d.event}textSearch(a){let m;const o=g(a),d=new A.Emitter({onFirstListenerDidAdd:()=>{m=(0,n.createCancelablePromise)(r=>this.ripgrepTextSearch(o,s=>d.fire(s),r)),m.then(r=>d.fire(r),r=>d.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onLastListenerRemove:()=>{m.cancel()}});return d.event}ripgrepTextSearch(a,m,o){return a.maxFileSize=(0,L.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new T.TextSearchEngineAdapter(a).search(o,m,m)}doFileSearch(a,m,o){return this.doFileSearchWithEngine(_.Engine,a,m,o)}doFileSearchWithEngine(a,m,o,d,r=w.BATCH_SIZE){let s=0;const i=c=>{Array.isArray(c)?(s+=c.length,o(c.map(l=>this.rawMatchToSearchItem(l)))):c.relativePath?(s++,o(this.rawMatchToSearchItem(c))):o(c)};if(m.sortByScore){let c=this.trySortedSearchFromCache(m,i,d);if(!c){const l=m.maxResults?Object.assign({},m,{maxResults:null}):m,h=new a(l);c=this.doSortedSearch(h,m,o,i,d)}return new Promise((l,h)=>{c.then(([E,R])=>{const N=R.map(O=>this.rawMatchToSearchItem(O));this.sendProgress(N,o,r),l(E)},h)})}const t=new a(m);return this.doSearch(t,i,r,d).then(c=>({limitHit:c.limitHit,type:"success",stats:{detailStats:c.stats,type:this.processType,fromCache:!1,resultCount:s,sortingTime:void 0}}))}rawMatchToSearchItem(a){return{path:a.base?(0,C.join)(a.base,a.relativePath):a.relativePath}}doSortedSearch(a,m,o,d,r){const s=new A.Emitter;let i=(0,n.createCancelablePromise)(c=>{let l=[];const h=E=>{Array.isArray(E)?l=E:(d(E),s.fire(E))};return this.doSearch(a,h,-1,c).then(E=>[E,l])}),t;if(m.cacheKey){t=this.getOrCreateCache(m.cacheKey);const c={promise:i,event:s.event,resolved:!1};t.resultsToSearchCache[m.filePattern||""]=c,i.then(()=>{c.resolved=!0},l=>{delete t.resultsToSearchCache[m.filePattern||""]}),i=this.preventCancellation(i)}return i.then(([c,l])=>{const h=t?t.scorerCache:Object.create(null),E=(typeof m.maxResults!="number"||m.maxResults>0)&&S.StopWatch.create(!1);return this.sortResults(m,l,h,r).then(R=>{const N=E?E.elapsed():-1;return[{type:"success",stats:{detailStats:c.stats,sortingTime:N,fromCache:!1,type:this.processType,workspaceFolderCount:m.folderQueries.length,resultCount:R.length},messages:c.messages,limitHit:c.limitHit||typeof m.maxResults=="number"&&l.length>m.maxResults},R]})})}getOrCreateCache(a){const m=this.caches[a];return m||(this.caches[a]=new b)}trySortedSearchFromCache(a,m,o){const d=a.cacheKey&&this.caches[a.cacheKey];if(!d)return;const r=this.getResultsFromCache(d,a.filePattern||"",m,o);if(r)return r.then(([s,i,t])=>{const c=S.StopWatch.create(!1);return this.sortResults(a,i,d.scorerCache,o).then(l=>{const h=c.elapsed(),E={fromCache:!0,detailStats:t,type:this.processType,resultCount:i.length,sortingTime:h};return[{type:"success",limitHit:s.limitHit||typeof a.maxResults=="number"&&i.length>a.maxResults,stats:E},l]})})}sortResults(a,m,o,d){const r=(0,D.prepareQuery)(a.filePattern||""),s=(t,c)=>(0,D.compareItemsByFuzzyScore)(t,c,r,!0,p,o),i=typeof a.maxResults=="number"?a.maxResults:Number.MAX_VALUE;return u.topAsync(m,s,i,1e4,d)}sendProgress(a,m,o){if(o&&o>0)for(let d=0;d<a.length;d+=o)m(a.slice(d,d+o));else m(a)}getResultsFromCache(a,m,o,d){const r=S.StopWatch.create(!1),s=m.indexOf(C.sep)>=0;let i;for(const h in a.resultsToSearchCache)if(m.startsWith(h)){if(s&&h.indexOf(C.sep)<0&&h!=="")continue;const E=a.resultsToSearchCache[h];i={promise:this.preventCancellation(E.promise),event:E.event,resolved:E.resolved};break}if(!i)return null;const t=r.elapsed(),c=S.StopWatch.create(!1),l=i.event(o);return d&&d.onCancellationRequested(()=>{l.dispose()}),i.promise.then(([h,E])=>{if(d&&d.isCancellationRequested)throw(0,y.canceled)();const R=[],N=(0,D.prepareQuery)(m).normalizedLowercase;for(const O of E)!(0,I.isFilePatternMatch)(O,N)||R.push(O);return[h,R,{cacheWasResolved:i.resolved,cacheLookupTime:t,cacheFilterTime:c.elapsed(),cacheEntryCount:E.length}]})}doSearch(a,m,o,d){return new Promise((r,s)=>{let i=[];d?.onCancellationRequested(()=>a.cancel()),a.search(t=>{t&&(o?(i.push(t),o>0&&i.length>=o&&(m(i),i=[])):m(t))},t=>{m(t)},(t,c)=>{i.length&&m(i),t?s(t):r(c)})})}clearCache(a){return delete this.caches[a],Promise.resolve(void 0)}preventCancellation(a){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(m,o){return a.then(m,o)}catch(m){return this.then(void 0,m)}finally(m){return a.finally(m)}}}}e.SearchService=w,w.BATCH_SIZE=512;class b{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const p=new class{getItemLabel(f){return(0,C.basename)(f.relativePath)}getItemDescription(f){return(0,C.dirname)(f.relativePath)}getItemPath(f){return f.relativePath}};function g(f){return{...f,folderQueries:f.folderQueries&&f.folderQueries.map(v),extraFileResources:f.extraFileResources&&f.extraFileResources.map(a=>P.URI.revive(a))}}function v(f){return{...f,folder:P.URI.revive(f.folder)}}}),define(Ie[298],ke([1,0,6,11,2,29,14,26,17,76,65,31,297,295,92,140]),function(Q,e,u,n,y,A,D,C,S,P,L,I,_,T,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let p=class extends P.ExtHostSearch{constructor(v,f,a,m){super(v,a,m);this._pfs=A,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const o=new w.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(n.Schemas.vscodeUserData,new T.RipgrepSearchProvider(o)),f.remote.isRemote&&f.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const v=new w.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(n.Schemas.file,new T.RipgrepSearchProvider(v)),this.registerInternalFileSearchProvider(n.Schemas.file,new _.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(v,f){const a=this._handlePool++;return this._internalFileSearchProvider=f,this._internalFileSearchHandle=a,this._proxy.$registerFileSearchProvider(a,this._transformScheme(v)),(0,u.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(a)})}$provideFileSearchResults(v,f,a,m){const o=(0,P.reviveQuery)(a);return v===this._internalFileSearchHandle?this.doInternalFileSearch(v,f,o,m):super.$provideFileSearchResults(v,f,a,m)}doInternalFileSearch(v,f,a,m){const o=d=>{if((0,I.isSerializedFileMatch)(d)&&(d=[d]),Array.isArray(d)){this._proxy.$handleFileMatch(v,f,d.map(r=>y.URI.file(r.path)));return}d.message&&this._logService.debug("ExtHostSearch",d.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(a,o,m)}$clearCache(v){return this._internalFileSearchProvider?.clearCache(v),super.$clearCache(v)}createTextSearchManager(v,f){return new b.NativeTextSearchManager(v,f,void 0,"textSearchProvider")}};p=Ge([$e(0,S.IExtHostRpcService),$e(1,C.IExtHostInitDataService),$e(2,L.IURITransformerService),$e(3,D.ILogService)],p),e.NativeExtHostSearch=p}),define(Ie[142],ke([1,0,309,127,63,23,12,3,6,9,13,34,110,111,310]),function(Q,e,u,n,y,A,D,C,S,P,L,I,_,T,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class b{constructor(E,R=""){this.debugLabel=R,this.socket=E,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=N=>{if(this.traceSocketEvent("error",{code:N?.code,message:N?.message}),N){if(N.code==="EPIPE")return;(0,D.onUnexpectedError)(N)}},this.socket.on("error",this._errorListener)}traceSocketEvent(E,R){T.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,E,R)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(E){const R=N=>{this.traceSocketEvent("read",N),E(A.VSBuffer.wrap(N))};return this.socket.on("data",R),{dispose:()=>this.socket.off("data",R)}}onClose(E){const R=N=>{this.traceSocketEvent("close",{hadError:N}),E({type:0,hadError:N,error:void 0})};return this.socket.on("close",R),{dispose:()=>this.socket.off("close",R)}}onEnd(E){const R=()=>{this.traceSocketEvent("nodeEndReceived"),E()};return this.socket.on("end",R),{dispose:()=>this.socket.off("end",R)}}write(E){if(!this.socket.destroyed)try{this.traceSocketEvent("write",E),this.socket.write(E.buffer,R=>{if(R){if(R.code==="EPIPE")return;(0,D.onUnexpectedError)(R)}})}catch(R){if(R.code==="EPIPE")return;(0,D.onUnexpectedError)(R)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((E,R)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),E();return}const N=()=>{this.socket.off("close",N),this.socket.off("end",N),this.socket.off("error",N),this.socket.off("timeout",N),this.socket.off("drain",N),this.traceSocketEvent("nodeDrainEnd"),E()};this.socket.on("close",N),this.socket.on("end",N),this.socket.on("error",N),this.socket.on("timeout",N),this.socket.on("drain",N)})}}e.NodeSocket=b;var p;(function(h){h[h.MinHeaderByteSize=2]="MinHeaderByteSize"})(p||(p={}));var g;(function(h){h[h.PeekHeader=1]="PeekHeader",h[h.ReadHeader=2]="ReadHeader",h[h.ReadBody=3]="ReadBody",h[h.Fin=4]="Fin"})(g||(g={}));class v extends S.Disposable{constructor(E,R,N,O){super();this._onData=this._register(new C.Emitter),this._onClose=this._register(new C.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=E,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:R,inflateBytesLength:N?.byteLength||0,recordInflateBytes:O}),this._flowManager=this._register(new f(this,R,N,O,this._onData,(k,U)=>this._write(k,U))),this._register(this._flowManager.onError(k=>{console.error(k),(0,D.onUnexpectedError)(k),this._onClose.fire({type:0,hadError:!0,error:k})})),this._incomingData=new T.ChunkStream,this._register(this.socket.onData(k=>this._acceptChunk(k))),this._register(this.socket.onClose(k=>this._onClose.fire(k)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(E,R){this.socket.traceSocketEvent(E,R)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(E){return this._onData.event(E)}onClose(E){return this._onClose.event(E)}onEnd(E){return this.socket.onEnd(E)}write(E){this._flowManager.writeMessage(E)}_write(E,R){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",E);let N=2;E.byteLength<126?N+=0:E.byteLength<2**16?N+=2:N+=8;const O=A.VSBuffer.alloc(N);if(R?O.writeUInt8(194,0):O.writeUInt8(130,0),E.byteLength<126)O.writeUInt8(E.byteLength,1);else if(E.byteLength<2**16){O.writeUInt8(126,1);let k=1;O.writeUInt8(E.byteLength>>>8&255,++k),O.writeUInt8(E.byteLength>>>0&255,++k)}else{O.writeUInt8(127,1);let k=1;O.writeUInt8(0,++k),O.writeUInt8(0,++k),O.writeUInt8(0,++k),O.writeUInt8(0,++k),O.writeUInt8(E.byteLength>>>24&255,++k),O.writeUInt8(E.byteLength>>>16&255,++k),O.writeUInt8(E.byteLength>>>8&255,++k),O.writeUInt8(E.byteLength>>>0&255,++k)}this.socket.write(A.VSBuffer.concat([O,E]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(E){if(E.byteLength!==0){for(this._incomingData.acceptChunk(E);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const R=this._incomingData.peek(this._state.readLen),N=R.readUInt8(0),O=(N&128)>>>7,k=(N&64)>>>6,U=R.readUInt8(1),F=(U&128)>>>7,$=U&127;this._state.state=2,this._state.readLen=2+(F?4:0)+($===126?2:0)+($===127?8:0),this._state.fin=O,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(k)),this._state.firstFrameOfMessage=Boolean(O),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const R=this._incomingData.read(this._state.readLen),N=R.readUInt8(1),O=(N&128)>>>7;let k=N&127,U=1;k===126?k=R.readUInt8(++U)*2**8+R.readUInt8(++U):k===127&&(k=R.readUInt8(++U)*0+R.readUInt8(++U)*0+R.readUInt8(++U)*0+R.readUInt8(++U)*0+R.readUInt8(++U)*2**24+R.readUInt8(++U)*2**16+R.readUInt8(++U)*2**8+R.readUInt8(++U));let F=0;O&&(F=R.readUInt8(++U)*2**24+R.readUInt8(++U)*2**16+R.readUInt8(++U)*2**8+R.readUInt8(++U)),this._state.state=3,this._state.readLen=k,this._state.mask=F,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const R=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",R),o(R,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",R),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(R,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await C.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=v;class f extends S.Disposable{constructor(E,R,N,O,k,U){super();this._tracer=E,this._onData=k,this._writeFn=U,this._onError=this._register(new C.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new C.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,R?(this._zlibInflateStream=this._register(new a(this._tracer,O,N,{windowBits:15})),this._zlibDeflateStream=this._register(new m(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(F=>this._onError.fire(F))),this._register(this._zlibDeflateStream.onError(F=>this._onError.fire(F)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:A.VSBuffer.alloc(0)}writeMessage(E){this._writeQueue.push(E),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const E=this._writeQueue.shift();if(this._zlibDeflateStream){const R=await this._deflateMessage(this._zlibDeflateStream,E);this._writeFn(R,!0)}else this._writeFn(E,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(E,R){return new Promise((N,O)=>{E.write(R),E.flush(k=>N(k))})}acceptFrame(E,R,N){this._readQueue.push({data:E,isCompressed:R,isLastFrameOfMessage:N}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const E=this._readQueue.shift();if(this._zlibInflateStream&&E.isCompressed){const R=await this._inflateFrame(this._zlibInflateStream,E.data,E.isLastFrameOfMessage);this._onData.fire(R)}else this._onData.fire(E.data)}this._isProcessingReadQueue=!1}}_inflateFrame(E,R,N){return new Promise((O,k)=>{E.write(R),N&&E.write(A.VSBuffer.fromByteArray([0,0,255,255])),E.flush(U=>O(U))})}}class a extends S.Disposable{constructor(E,R,N,O){super();this._tracer=E,this._recordInflateBytes=R,this._onError=this._register(new C.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=w.createInflateRaw(O),this._zlibInflate.on("error",k=>{this._tracer.traceSocketEvent("zlibInflateError",{message:k?.message,code:k?.code}),this._onError.fire(k)}),this._zlibInflate.on("data",k=>{this._tracer.traceSocketEvent("zlibInflateData",k),this._pendingInflateData.push(A.VSBuffer.wrap(k))}),N&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",N.buffer),this._zlibInflate.write(N.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?A.VSBuffer.concat(this._recordedInflateBytes):A.VSBuffer.alloc(0)}write(E){this._recordInflateBytes&&this._recordedInflateBytes.push(E.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",E),this._zlibInflate.write(E.buffer)}flush(E){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const R=A.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,E(R)})}}class m extends S.Disposable{constructor(E,R){super();this._tracer=E,this._onError=this._register(new C.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=w.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",N=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:N?.message,code:N?.code}),this._onError.fire(N)}),this._zlibDeflate.on("data",N=>{this._tracer.traceSocketEvent("zlibDeflateData",N),this._pendingDeflateData.push(A.VSBuffer.wrap(N))})}write(E){this._tracer.traceSocketEvent("zlibDeflateWrite",E.buffer),this._zlibDeflate.write(E.buffer)}flush(E){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let R=A.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,R=R.slice(0,R.byteLength-4),E(R)})}}function o(h,E){if(E===0)return;const R=h.byteLength>>>2;for(let $=0;$<R;$++){const ee=h.readUInt32BE($*4);h.writeUInt32BE(ee^E,$*4)}const N=R*4,O=h.byteLength-N,k=E>>>24&255,U=E>>>16&255,F=E>>>8&255;O>=1&&h.writeUInt8(h.readUInt8(N)^k,N),O>=2&&h.writeUInt8(h.readUInt8(N+1)^U,N+1),O>=3&&h.writeUInt8(h.readUInt8(N+2)^F,N+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const d={[2]:107,[1]:103};function r(){const h=(0,I.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${h}-sock`;let E;return e.XDG_RUNTIME_DIR?E=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${h}.sock`):E=(0,P.join)((0,y.tmpdir)(),`vscode-ipc-${h}.sock`),i(E),E}e.createRandomIPCHandle=r;function s(h,E,R){const N=(0,u.createHash)("md5").update(h).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${N}-${R}-${E}-sock`;let O;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?O=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-${N.substr(0,8)}-${R}-${E}.sock`):O=(0,P.join)(h,`${R}-${E}.sock`),i(O),O}e.createStaticIPCHandle=s;function i(h){const E=d[L.platform];typeof E=="number"&&h.length>=E&&console.warn(`WARNING: IPC handle "${h}" is longer than ${E} chars, try a shorter --user-data-dir`)}class t extends _.IPCServer{constructor(E){super(t.toClientConnectionEvent(E));this.server=E}static toClientConnectionEvent(E){const R=C.Event.fromNodeEventEmitter(E,"connection");return C.Event.map(R,N=>({protocol:new T.Protocol(new b(N,"ipc-server-connection")),onDidClientDisconnect:C.Event.once(C.Event.fromNodeEventEmitter(N,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=t;function c(h){return new Promise((E,R)=>{const N=(0,n.createServer)();N.on("error",R),N.listen(h,()=>{N.removeListener("error",R),E(new t(N))})})}e.serve=c;function l(h,E){return new Promise((R,N)=>{const O=(0,n.createConnection)(h,()=>{O.removeListener("error",N),R(T.Client.fromSocket(new b(O,`ipc-client${E}`),E))});O.once("error",N)})}e.connect=l}),define(Ie[299],ke([1,0,142,294,62,37,2,14,45]),function(Q,e,u,n,y,A,D,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class P{constructor(_,T,w){this._commands=_,this.logService=T,this._ipcHandlePath=w,this._server=n.createServer((b,p)=>this.onRequest(b,p)),this.setup().catch(b=>(T.error(b),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",_=>this.logService.error(_))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(_,T){const w=(p,g)=>{T.writeHead(p,{"content-type":"application/json"}),T.end(JSON.stringify(g||null),v=>v&&this.logService.error(v))},b=[];_.setEncoding("utf8"),_.on("data",p=>b.push(p)),_.on("end",async()=>{try{const p=JSON.parse(b.join(""));let g;switch(p.type){case"open":g=await this.open(p);break;case"openExternal":g=await this.openExternal(p);break;case"status":g=await this.getStatus(p);break;case"extensionManagement":g=await this.manageExtensions(p);break;default:w(404,`Unknown message type: ${p.type}`);break}w(200,g)}catch(p){const g=p instanceof Error?p.message:JSON.stringify(p);w(500,g),this.logService.error("Error while processing pipe request",p)}})}async open(_){const{fileURIs:T,folderURIs:w,forceNewWindow:b,diffMode:p,addMode:g,forceReuseWindow:v,gotoLineMode:f,waitMarkerFilePath:a,remoteAuthority:m}=_,o=[];if(Array.isArray(w))for(const i of w)try{o.push({folderUri:D.URI.parse(i)})}catch{}if(Array.isArray(T))for(const i of T)try{(0,S.hasWorkspaceFileExtension)(i)?o.push({workspaceUri:D.URI.parse(i)}):o.push({fileUri:D.URI.parse(i)})}catch{}const d=a?D.URI.file(a):void 0,s={forceNewWindow:b,diffMode:p,addMode:g,gotoLineMode:f,forceReuseWindow:v,preferNewWindow:!v&&!d&&!g,waitMarkerFileURI:d,remoteAuthority:m};return this._commands.executeCommand("_remoteCLI.windowOpen",o,s),""}async openExternal(_){for(const T of _.uris){const w=D.URI.parse(T),b=w.scheme==="file"?w:T;await this._commands.executeCommand("_remoteCLI.openExternal",b)}}async manageExtensions(_){const T=b=>b?.map(p=>/\.vsix$/i.test(p)?D.URI.parse(p):p),w={list:_.list,install:T(_.install),uninstall:T(_.uninstall),force:_.force};return await this._commands.executeCommand("_remoteCLI.manageExtensions",w)}async getStatus(_){return await this._commands.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&y.existsSync(this._ipcHandlePath)&&y.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=P;let L=class extends P{constructor(_,T){super(_,T,(0,u.createRandomIPCHandle)())}};L=Ge([$e(0,A.IExtHostCommands),$e(1,C.ILogService)],L),e.CLIServer=L}),define(Ie[300],ke([1,0,74,292,280,293,39,268,2,11,7,299,109,267]),function(Q,e,u,n,y,A,D,C,S,P,L,I,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class w extends y.RequireInterceptor{_installInterceptor(){const g=this,v=Q.__$__nodeRequire("module"),f=v._load;v._load=function(d,r,s){return d=m(d),g._factories.has(d)?g._factories.get(d).load(d,S.URI.file((0,_.realpathSync)(r.filename)),i=>f.apply(this,[i,r,s])):f.apply(this,arguments)};const a=v._resolveLookupPaths;v._resolveLookupPaths=(o,d)=>a.call(this,m(o),d);const m=o=>{for(const d of g._alternatives){const r=d(o);if(r){o=r;break}}return o}}}class b extends D.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=L.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(T.ExtHostConsoleForwarder);const g=this._instaService.invokeFunction(n.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(C.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const a=this._instaService.createInstance(I.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=a.ipcHandlePath}await this._instaService.createInstance(w,g,{mine:this._myRegistry,all:this._globalRegistry}).install(),u.mark("code/extHost/didInitAPI");const f=await this._extHostConfiguration.getConfigProvider();await(0,A.connectProxyResolver)(this._extHostWorkspace,f,this,this._logService,this._mainThreadTelemetryProxy,this._initData),u.mark("code/extHost/didInitProxyResolver")}_getEntryPoint(g){return g.main}_loadCommonJSModule(g,v,f){if(v.scheme!==P.Schemas.file)throw new Error(`Cannot load URI: '${v}', must be of file-scheme`);let a=null;f.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${v.toString(!0)}`),this._logService.flush();try{g&&u.mark(`code/extHost/willLoadExtensionCode/${g.value}`),a=Q.__$__nodeRequire(v.fsPath)}catch(m){return Promise.reject(m)}finally{g&&u.mark(`code/extHost/didLoadExtensionCode/${g.value}`),f.codeLoadingStop()}return Promise.resolve(a)}async $setRemoteEnvironment(g){if(!!this._initData.remote.isRemote)for(const v in g){const f=g[v];f===null?delete process.env[v]:process.env[v]=f}}}e.ExtHostExtensionService=b}),define(Ie[301],ke([1,0,82,271,283,282,298,300,272,75,39,76,73,38,52,70,270,269,14,284,47]),function(Q,e,u,n,y,A,D,C,S,P,L,I,_,T,w,b,p,g,v,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,u.registerSingleton)(L.IExtHostExtensionService,C.ExtHostExtensionService),(0,u.registerSingleton)(v.ILoggerService,g.ExtHostLoggerService),(0,u.registerSingleton)(b.IExtensionStoragePaths,p.ExtensionStoragePaths),(0,u.registerSingleton)(P.IExtHostDebugService,A.ExtHostDebugService),(0,u.registerSingleton)(I.IExtHostSearch,D.NativeExtHostSearch),(0,u.registerSingleton)(_.IExtHostTask,y.ExtHostTask),(0,u.registerSingleton)(T.IExtHostTerminalService,n.ExtHostTerminalService),(0,u.registerSingleton)(w.IExtHostTunnelService,S.ExtHostTunnelService),(0,u.registerSingleton)(a.IExtHostVariableResolverProvider,f.NodeExtHostVariableResolverProviderService)}),define(Ie[311],ke([1,0,127,312,74,12,111,142,198,134,281,23,29,109,18,114,211,228,285,301]),function(Q,e,u,n,y,A,D,C,S,P,L,I,_,T,w,b,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let t=0;t<process.execArgv.length;t++)process.execArgv[t]==="--inspect-port=0"&&(process.execArgv.splice(t,1),t--)}();const v=n(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const i=Q.__$__nodeRequire("module"),t=i._load;i._load=function(c){if(c==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return t.apply(this,arguments)}})();const f=process.exit.bind(process);function a(i){process.exit=function(t){if(i)f(t);else{const c=new Error("An extension called process.exit() and this was prevented.");console.warn(c.stack)}},process.crash=function(){const t=new Error("An extension called process.crash() and this was prevented.");console.warn(t.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let m=function(i){f()};function o(){const i=(0,g.readExtHostConnection)(process.env);if(i.type===3)return new Promise((t,c)=>{const l=h=>{const E=h[0],R=new D.BufferedEmitter;E.on("message",N=>R.fire(I.VSBuffer.wrap(N.data))),E.on("close",()=>{m("renderer closed the MessagePort")}),E.start(),t({onMessage:R.event,send:N=>E.postMessage(N.buffer)})};if(global.vscodePorts){const h=global.vscodePorts;delete global.vscodePorts,l(h)}else global.vscodePortsCallback=l});if(i.type===2)return new Promise((t,c)=>{let l=null;const h=setTimeout(()=>{m("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),E=108e5,R=3e5,N=new w.ProcessTimeRunOnceScheduler(()=>m("renderer disconnected for too long (1)"),E),O=new w.ProcessTimeRunOnceScheduler(()=>m("renderer disconnected for too long (2)"),R);process.on("message",(U,F)=>{if(U&&U.type==="VSCODE_EXTHOST_IPC_SOCKET"){F.setNoDelay(!0);const $=I.VSBuffer.wrap(Buffer.from(U.initialDataChunk,"base64"));let ee;if(U.skipWebSocketFrames)ee=new C.NodeSocket(F,"extHost-socket");else{const B=I.VSBuffer.wrap(Buffer.from(U.inflateBytes,"base64"));ee=new C.WebSocketNodeSocket(new C.NodeSocket(F,"extHost-socket"),U.permessageDeflate,B,!1)}l?(N.cancel(),O.cancel(),l.beginAcceptReconnection(ee,$),l.endAcceptReconnection(),l.sendResume()):(clearTimeout(h),l=new D.PersistentProtocol(ee,$),l.sendResume(),l.onDidDispose(()=>m("renderer disconnected")),t(l),l.onSocketClose(()=>{N.schedule()}))}if(U&&U.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(O.isScheduled())return;N.isScheduled()&&O.schedule()}});const k={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(k)});{const t=i.pipeName;return new Promise((c,l)=>{const h=u.createConnection(t,()=>{h.removeListener("error",l);const E=new D.PersistentProtocol(new C.NodeSocket(h,"extHost-renderer"));E.sendResume(),c(E)});h.once("error",l),h.on("close",()=>{m("renderer closed the socket")})})}}async function d(){const i=await o();return new class{constructor(){this._onMessage=new D.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,i.onMessage(t=>{(0,P.isMessageOfType)(t,2)?(this._terminating=!0,m("received terminate message from renderer")):this._onMessage.fire(t)})}send(t){this._terminating||i.send(t)}async drain(){if(i.drain)return i.drain()}}}function r(i){return new Promise(t=>{const c=i.onMessage(l=>{c.dispose();const h=JSON.parse(l.toString()),E=h.commit,R=S.default.commit;E&&R&&E!==R&&f(55);let N=0;setInterval(function(){try{process.kill(h.parentPid,0),N=0}catch(k){k&&k.code==="EPERM"?(N++,N>=3&&m(`parent process ${h.parentPid} does not exist anymore (3 x EPERM): ${k.message} (code: ${k.code}) (errno: ${k.errno})`)):m(`parent process ${h.parentPid} does not exist anymore: ${k.message} (code: ${k.code}) (errno: ${k.errno})`)}},1e3);let O;try{O=Q.__$__nodeRequire("native-watchdog"),O.start(h.parentPid)}catch(k){(0,A.onUnexpectedError)(k)}i.send((0,P.createMessageOfType)(0)),t({protocol:i,initData:h})});i.send((0,P.createMessageOfType)(1))})}async function s(){const i=[];process.on("unhandledRejection",(N,O)=>{i.push(O),setTimeout(()=>{const k=i.indexOf(O);k>=0&&O.catch(U=>{i.splice(k,1),(0,A.isCancellationError)(U)||(console.warn(`rejected promise not handled within 1 second: ${U}`),U&&U.stack&&console.warn(`stack trace: ${U.stack}`),N&&(0,A.onUnexpectedError)(N))})},1e3)}),process.on("rejectionHandled",N=>{const O=i.indexOf(N);O>=0&&i.splice(O,1)}),process.on("uncaughtException",function(N){(0,A.onUnexpectedError)(N)}),y.mark("code/extHost/willConnectToRenderer");const t=await d();y.mark("code/extHost/didConnectToRenderer");const c=await r(t);y.mark("code/extHost/didWaitForInitData");const{initData:l}=c;a(!!l.environment.extensionTestsLocationURI),l.environment.useHostProxy=v.useHostProxy!==void 0?v.useHostProxy!=="false":void 0,l.environment.skipWorkspaceStorageLock=(0,b.boolean)(v.skipWorkspaceStorageLock,!1);const h=new class{constructor(){this.pid=process.pid}exit(O){f(O)}exists(O){return _.Promises.exists(O)}realpath(O){return(0,T.realpath)(O)}};let E=null;l.remote.authority&&v.transformURIs&&(E=(0,p.createURITransformer)(l.remote.authority));const R=new L.ExtensionHostMain(c.protocol,l,h,E);m=N=>R.terminate(N)}e.startExtensionHostProcess=s,s().catch(i=>console.log(i))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/b06ae3b2d2dbfe28bca3134cc6be65935cdfea6a/core/vs/workbench/api/node/extensionHostProcess.js.map
